/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs


/* Copy the first part of user declarations.  */
#line 1 "gram.y" /* yacc.c:339  */


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 2003-2020, PgPool Global Development Group
 * Portions Copyright (c) 1996-2020, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  src/backend/parser/gram.y
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET constraint_exclusion TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */

#include "pool_parser.h"
#include "utils/elog.h"
#include "utils/palloc.h"
#include <ctype.h>
#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "nodes.h"
#include "keywords.h"
#include "gramparse.h"
#include "makefuncs.h"
#include "pool_string.h"
#include "parser.h"
#include "pg_class.h"
#include "pg_trigger.h"

/* This is a configuration parameter since PostgreSQL 9.5.
 * We set this false in pgpool-II. This is default in PostgreSQL.
 */
static bool operator_precedence_warning = false;

/*
 * Definition taken from
 * postgreSQL source code file: src/include/commands/trigger.h
 */
#define TRIGGER_FIRES_ON_ORIGIN                         'O'
#define TRIGGER_FIRES_ALWAYS                            'A'
#define TRIGGER_FIRES_ON_REPLICA                        'R'
#define TRIGGER_DISABLED                                'D'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/catalog/pg_class.h
 */

#define           REPLICA_IDENTITY_DEFAULT      'd'
#define           REPLICA_IDENTITY_NOTHING      'n'
#define           REPLICA_IDENTITY_FULL         'f'
#define           REPLICA_IDENTITY_INDEX        'i'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/catalog/pg_attribute.h
 */
#define		  ATTRIBUTE_IDENTITY_ALWAYS	'a'
#define		  ATTRIBUTE_IDENTITY_BY_DEFAULT 'd'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/utils/xml.h
 */
typedef enum
{
	XML_STANDALONE_YES,
	XML_STANDALONE_NO,
	XML_STANDALONE_NO_VALUE,
	XML_STANDALONE_OMITTED
} XmlStandaloneType;

/*
 * Location tracking support --- simpler than bison's default, since we only
 * want to track the start position not the end position of each nonterminal.
 */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if ((N) > 0) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (-1); \
	} while (0)

/*
 * The above macro assigns -1 (unknown) as the parse location of any
 * nonterminal that was reduced from an empty rule, or whose leftmost
 * component was reduced from an empty rule.  This is problematic
 * for nonterminals defined like
 *		OptFooList: / * EMPTY * / { ... } | OptFooList Foo { ... } ;
 * because we'll set -1 as the location during the first reduction and then
 * copy it during each subsequent reduction, leaving us with -1 for the
 * location even when the list is not empty.  To fix that, do this in the
 * action for the nonempty rule(s):
 *		if (@$ < 0) @$ = @2;
 * (Although we have many nonterminals that follow this pattern, we only
 * bother with fixing @$ like this when the nonterminal's parse location
 * is actually referenced in some rule.)
 *
 * A cleaner answer would be to make YYLLOC_DEFAULT scan all the Rhs
 * locations until it's found one that's not -1.  Then we'd get a correct
 * location for any nonterminal that isn't entirely empty.  But this way
 * would add overhead to every rule reduction, and so far there's not been
 * a compelling reason to pay that overhead.
 */

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	ObjectType	objtype;
	List	   *objs;
} PrivTarget;

/* Private struct for the result of import_qualification production */
typedef struct ImportQual
{
	ImportForeignSchemaType type;
	List	   *table_names;
} ImportQual;

/* Private struct for the result of opt_select_limit production */
typedef struct SelectLimit
{
	Node *limitOffset;
	Node *limitCount;
	LimitOption limitOption;
} SelectLimit;

/* ConstraintAttributeSpec yields an integer bitmask of these flags: */
#define CAS_NOT_DEFERRABLE			0x01
#define CAS_DEFERRABLE				0x02
#define CAS_INITIALLY_IMMEDIATE		0x04
#define CAS_INITIALLY_DEFERRED		0x08
#define CAS_NOT_VALID				0x10
#define CAS_NO_INHERIT				0x20


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static RawStmt *makeRawStmt(Node *stmt, int stmt_location);
static void updateRawStmtEnd(RawStmt *rs, int end_location);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeStringConst(char *str, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Value *v, int location);
static Node *makeBoolAConst(bool state, int location);
static RoleSpec *makeRoleSpec(RoleSpecType type, int location);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static List *extractAggrArgTypes(List *aggrargs);
static List *makeOrderedSetArgs(List *directargs, List *orderedargs,
								core_yyscan_t yyscanner);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								SelectLimit *limitClause,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Value *v);
static Node *makeAndExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeOrExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeNotExpr(Node *expr, int location);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod,
								  int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);
static RangeVar *makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner);
static void SplitColQualList(List *qualList,
							 List **constraintList, CollateClause **collClause,
							 core_yyscan_t yyscanner);
static void processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner);
static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);


#line 309 "gram.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_BASE_YY_Y_TAB_H_INCLUDED
# define YY_BASE_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int base_yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    IDENT = 258,
    UIDENT = 259,
    FCONST = 260,
    SCONST = 261,
    USCONST = 262,
    BCONST = 263,
    XCONST = 264,
    Op = 265,
    ICONST = 266,
    PARAM = 267,
    TYPECAST = 268,
    DOT_DOT = 269,
    COLON_EQUALS = 270,
    EQUALS_GREATER = 271,
    LESS_EQUALS = 272,
    GREATER_EQUALS = 273,
    NOT_EQUALS = 274,
    ABORT_P = 275,
    ABSOLUTE_P = 276,
    ACCESS = 277,
    ACTION = 278,
    ADD_P = 279,
    ADMIN = 280,
    AFTER = 281,
    AGGREGATE = 282,
    ALL = 283,
    ALSO = 284,
    ALTER = 285,
    ALWAYS = 286,
    ANALYSE = 287,
    ANALYZE = 288,
    AND = 289,
    ANY = 290,
    ARRAY = 291,
    AS = 292,
    ASC = 293,
    ASSERTION = 294,
    ASSIGNMENT = 295,
    ASYMMETRIC = 296,
    AT = 297,
    ATTACH = 298,
    ATTRIBUTE = 299,
    AUTHORIZATION = 300,
    BACKWARD = 301,
    BEFORE = 302,
    BEGIN_P = 303,
    BETWEEN = 304,
    BIGINT = 305,
    BINARY = 306,
    BIT = 307,
    BOOLEAN_P = 308,
    BOTH = 309,
    BY = 310,
    CACHE = 311,
    CALL = 312,
    CALLED = 313,
    CASCADE = 314,
    CASCADED = 315,
    CASE = 316,
    CAST = 317,
    CATALOG_P = 318,
    CHAIN = 319,
    CHAR_P = 320,
    CHARACTER = 321,
    CHARACTERISTICS = 322,
    CHECK = 323,
    CHECKPOINT = 324,
    CLASS = 325,
    CLOSE = 326,
    CLUSTER = 327,
    COALESCE = 328,
    COLLATE = 329,
    COLLATION = 330,
    COLUMN = 331,
    COLUMNS = 332,
    COMMENT = 333,
    COMMENTS = 334,
    COMMIT = 335,
    COMMITTED = 336,
    CONCURRENTLY = 337,
    CONFIGURATION = 338,
    CONFLICT = 339,
    CONNECTION = 340,
    CONSTRAINT = 341,
    CONSTRAINTS = 342,
    CONTENT_P = 343,
    CONTINUE_P = 344,
    CONVERSION_P = 345,
    COPY = 346,
    COST = 347,
    CREATE = 348,
    CROSS = 349,
    CSV = 350,
    CUBE = 351,
    CURRENT_P = 352,
    CURRENT_CATALOG = 353,
    CURRENT_DATE = 354,
    CURRENT_ROLE = 355,
    CURRENT_SCHEMA = 356,
    CURRENT_TIME = 357,
    CURRENT_TIMESTAMP = 358,
    CURRENT_USER = 359,
    CURSOR = 360,
    CYCLE = 361,
    DATA_P = 362,
    DATABASE = 363,
    DAY_P = 364,
    DEALLOCATE = 365,
    DEC = 366,
    DECIMAL_P = 367,
    DECLARE = 368,
    DEFAULT = 369,
    DEFAULTS = 370,
    DEFERRABLE = 371,
    DEFERRED = 372,
    DEFINER = 373,
    DELETE_P = 374,
    DELIMITER = 375,
    DELIMITERS = 376,
    DEPENDS = 377,
    DESC = 378,
    DETACH = 379,
    DICTIONARY = 380,
    DISABLE_P = 381,
    DISCARD = 382,
    DISTINCT = 383,
    DO = 384,
    DOCUMENT_P = 385,
    DOMAIN_P = 386,
    DOUBLE_P = 387,
    DROP = 388,
    EACH = 389,
    ELSE = 390,
    ENABLE_P = 391,
    ENCODING = 392,
    ENCRYPTED = 393,
    END_P = 394,
    ENUM_P = 395,
    ESCAPE = 396,
    EVENT = 397,
    EXCEPT = 398,
    EXCLUDE = 399,
    EXCLUDING = 400,
    EXCLUSIVE = 401,
    EXECUTE = 402,
    EXISTS = 403,
    EXPLAIN = 404,
    EXPRESSION = 405,
    EXTENSION = 406,
    EXTERNAL = 407,
    EXTRACT = 408,
    FALSE_P = 409,
    FAMILY = 410,
    FETCH = 411,
    FILTER = 412,
    FIRST_P = 413,
    FLOAT_P = 414,
    FOLLOWING = 415,
    FOR = 416,
    FORCE = 417,
    FOREIGN = 418,
    FORWARD = 419,
    FREEZE = 420,
    FROM = 421,
    FULL = 422,
    FUNCTION = 423,
    FUNCTIONS = 424,
    GENERATED = 425,
    GLOBAL = 426,
    GRANT = 427,
    GRANTED = 428,
    GREATEST = 429,
    GROUP_P = 430,
    GROUPING = 431,
    GROUPS = 432,
    HANDLER = 433,
    HAVING = 434,
    HEADER_P = 435,
    HOLD = 436,
    HOUR_P = 437,
    IDENTITY_P = 438,
    IF_P = 439,
    ILIKE = 440,
    IMMEDIATE = 441,
    IMMUTABLE = 442,
    IMPLICIT_P = 443,
    IMPORT_P = 444,
    IN_P = 445,
    INCLUDE = 446,
    INCLUDING = 447,
    INCREMENT = 448,
    INDEX = 449,
    INDEXES = 450,
    INHERIT = 451,
    INHERITS = 452,
    INITIALLY = 453,
    INLINE_P = 454,
    INNER_P = 455,
    INOUT = 456,
    INPUT_P = 457,
    INSENSITIVE = 458,
    INSERT = 459,
    INSTEAD = 460,
    INT_P = 461,
    INTEGER = 462,
    INTERSECT = 463,
    INTERVAL = 464,
    INTO = 465,
    INVOKER = 466,
    IS = 467,
    ISNULL = 468,
    ISOLATION = 469,
    JOIN = 470,
    KEY = 471,
    LABEL = 472,
    LANGUAGE = 473,
    LARGE_P = 474,
    LAST_P = 475,
    LATERAL_P = 476,
    LEADING = 477,
    LEAKPROOF = 478,
    LEAST = 479,
    LEFT = 480,
    LEVEL = 481,
    LIKE = 482,
    LIMIT = 483,
    LISTEN = 484,
    LOAD = 485,
    LOCAL = 486,
    LOCALTIME = 487,
    LOCALTIMESTAMP = 488,
    LOCATION = 489,
    LOCK_P = 490,
    LOCKED = 491,
    LOGGED = 492,
    MAPPING = 493,
    MATCH = 494,
    MATERIALIZED = 495,
    MAXVALUE = 496,
    METHOD = 497,
    MINUTE_P = 498,
    MINVALUE = 499,
    MODE = 500,
    MONTH_P = 501,
    MOVE = 502,
    NAME_P = 503,
    NAMES = 504,
    NATIONAL = 505,
    NATURAL = 506,
    NCHAR = 507,
    NEW = 508,
    NEXT = 509,
    NFC = 510,
    NFD = 511,
    NFKC = 512,
    NFKD = 513,
    NO = 514,
    NONE = 515,
    NORMALIZE = 516,
    NORMALIZED = 517,
    NOT = 518,
    NOTHING = 519,
    NOTIFY = 520,
    NOTNULL = 521,
    NOWAIT = 522,
    NULL_P = 523,
    NULLIF = 524,
    NULLS_P = 525,
    NUMERIC = 526,
    OBJECT_P = 527,
    OF = 528,
    OFF = 529,
    OFFSET = 530,
    OIDS = 531,
    OLD = 532,
    ON = 533,
    ONLY = 534,
    OPERATOR = 535,
    OPTION = 536,
    OPTIONS = 537,
    OR = 538,
    ORDER = 539,
    ORDINALITY = 540,
    OTHERS = 541,
    OUT_P = 542,
    OUTER_P = 543,
    OVER = 544,
    OVERLAPS = 545,
    OVERLAY = 546,
    OVERRIDING = 547,
    OWNED = 548,
    OWNER = 549,
    PARALLEL = 550,
    PARSER = 551,
    PARTIAL = 552,
    PARTITION = 553,
    PASSING = 554,
    PASSWORD = 555,
    PGPOOL = 556,
    PLACING = 557,
    PLANS = 558,
    POLICY = 559,
    POSITION = 560,
    PRECEDING = 561,
    PRECISION = 562,
    PRESERVE = 563,
    PREPARE = 564,
    PREPARED = 565,
    PRIMARY = 566,
    PRIOR = 567,
    PRIVILEGES = 568,
    PROCEDURAL = 569,
    PROCEDURE = 570,
    PROCEDURES = 571,
    PROGRAM = 572,
    PUBLICATION = 573,
    QUOTE = 574,
    RANGE = 575,
    READ = 576,
    REAL = 577,
    REASSIGN = 578,
    RECHECK = 579,
    RECURSIVE = 580,
    REF = 581,
    REFERENCES = 582,
    REFERENCING = 583,
    REFRESH = 584,
    REINDEX = 585,
    RELATIVE_P = 586,
    RELEASE = 587,
    RENAME = 588,
    REPEATABLE = 589,
    REPLACE = 590,
    REPLICA = 591,
    RESET = 592,
    RESTART = 593,
    RESTRICT = 594,
    RETURNING = 595,
    RETURNS = 596,
    REVOKE = 597,
    RIGHT = 598,
    ROLE = 599,
    ROLLBACK = 600,
    ROLLUP = 601,
    ROUTINE = 602,
    ROUTINES = 603,
    ROW = 604,
    ROWS = 605,
    RULE = 606,
    SAVEPOINT = 607,
    SCHEMA = 608,
    SCHEMAS = 609,
    SCROLL = 610,
    SEARCH = 611,
    SECOND_P = 612,
    SECURITY = 613,
    SELECT = 614,
    SEQUENCE = 615,
    SEQUENCES = 616,
    SERIALIZABLE = 617,
    SERVER = 618,
    SESSION = 619,
    SESSION_USER = 620,
    SET = 621,
    SETS = 622,
    SETOF = 623,
    SHARE = 624,
    SHOW = 625,
    SIMILAR = 626,
    SIMPLE = 627,
    SKIP = 628,
    SMALLINT = 629,
    SNAPSHOT = 630,
    SOME = 631,
    SQL_P = 632,
    STABLE = 633,
    STANDALONE_P = 634,
    START = 635,
    STATEMENT = 636,
    STATISTICS = 637,
    STDIN = 638,
    STDOUT = 639,
    STORAGE = 640,
    STORED = 641,
    STRICT_P = 642,
    STRIP_P = 643,
    SUBSCRIPTION = 644,
    SUBSTRING = 645,
    SUPPORT = 646,
    SYMMETRIC = 647,
    SYSID = 648,
    SYSTEM_P = 649,
    TABLE = 650,
    TABLES = 651,
    TABLESAMPLE = 652,
    TABLESPACE = 653,
    TEMP = 654,
    TEMPLATE = 655,
    TEMPORARY = 656,
    TEXT_P = 657,
    THEN = 658,
    TIES = 659,
    TIME = 660,
    TIMESTAMP = 661,
    TO = 662,
    TRAILING = 663,
    TRANSACTION = 664,
    TRANSFORM = 665,
    TREAT = 666,
    TRIGGER = 667,
    TRIM = 668,
    TRUE_P = 669,
    TRUNCATE = 670,
    TRUSTED = 671,
    TYPE_P = 672,
    TYPES_P = 673,
    UESCAPE = 674,
    UNBOUNDED = 675,
    UNCOMMITTED = 676,
    UNENCRYPTED = 677,
    UNION = 678,
    UNIQUE = 679,
    UNKNOWN = 680,
    UNLISTEN = 681,
    UNLOGGED = 682,
    UNTIL = 683,
    UPDATE = 684,
    USER = 685,
    USING = 686,
    VACUUM = 687,
    VALID = 688,
    VALIDATE = 689,
    VALIDATOR = 690,
    VALUE_P = 691,
    VALUES = 692,
    VARCHAR = 693,
    VARIADIC = 694,
    VARYING = 695,
    VERBOSE = 696,
    VERSION_P = 697,
    VIEW = 698,
    VIEWS = 699,
    VOLATILE = 700,
    WHEN = 701,
    WHERE = 702,
    WHITESPACE_P = 703,
    WINDOW = 704,
    WITH = 705,
    WITHIN = 706,
    WITHOUT = 707,
    WORK = 708,
    WRAPPER = 709,
    WRITE = 710,
    XML_P = 711,
    XMLATTRIBUTES = 712,
    XMLCONCAT = 713,
    XMLELEMENT = 714,
    XMLEXISTS = 715,
    XMLFOREST = 716,
    XMLNAMESPACES = 717,
    XMLPARSE = 718,
    XMLPI = 719,
    XMLROOT = 720,
    XMLSERIALIZE = 721,
    XMLTABLE = 722,
    YEAR_P = 723,
    YES_P = 724,
    ZONE = 725,
    NOT_LA = 726,
    NULLS_LA = 727,
    WITH_LA = 728,
    POSTFIXOP = 729,
    UMINUS = 730
  };
#endif
/* Tokens.  */
#define IDENT 258
#define UIDENT 259
#define FCONST 260
#define SCONST 261
#define USCONST 262
#define BCONST 263
#define XCONST 264
#define Op 265
#define ICONST 266
#define PARAM 267
#define TYPECAST 268
#define DOT_DOT 269
#define COLON_EQUALS 270
#define EQUALS_GREATER 271
#define LESS_EQUALS 272
#define GREATER_EQUALS 273
#define NOT_EQUALS 274
#define ABORT_P 275
#define ABSOLUTE_P 276
#define ACCESS 277
#define ACTION 278
#define ADD_P 279
#define ADMIN 280
#define AFTER 281
#define AGGREGATE 282
#define ALL 283
#define ALSO 284
#define ALTER 285
#define ALWAYS 286
#define ANALYSE 287
#define ANALYZE 288
#define AND 289
#define ANY 290
#define ARRAY 291
#define AS 292
#define ASC 293
#define ASSERTION 294
#define ASSIGNMENT 295
#define ASYMMETRIC 296
#define AT 297
#define ATTACH 298
#define ATTRIBUTE 299
#define AUTHORIZATION 300
#define BACKWARD 301
#define BEFORE 302
#define BEGIN_P 303
#define BETWEEN 304
#define BIGINT 305
#define BINARY 306
#define BIT 307
#define BOOLEAN_P 308
#define BOTH 309
#define BY 310
#define CACHE 311
#define CALL 312
#define CALLED 313
#define CASCADE 314
#define CASCADED 315
#define CASE 316
#define CAST 317
#define CATALOG_P 318
#define CHAIN 319
#define CHAR_P 320
#define CHARACTER 321
#define CHARACTERISTICS 322
#define CHECK 323
#define CHECKPOINT 324
#define CLASS 325
#define CLOSE 326
#define CLUSTER 327
#define COALESCE 328
#define COLLATE 329
#define COLLATION 330
#define COLUMN 331
#define COLUMNS 332
#define COMMENT 333
#define COMMENTS 334
#define COMMIT 335
#define COMMITTED 336
#define CONCURRENTLY 337
#define CONFIGURATION 338
#define CONFLICT 339
#define CONNECTION 340
#define CONSTRAINT 341
#define CONSTRAINTS 342
#define CONTENT_P 343
#define CONTINUE_P 344
#define CONVERSION_P 345
#define COPY 346
#define COST 347
#define CREATE 348
#define CROSS 349
#define CSV 350
#define CUBE 351
#define CURRENT_P 352
#define CURRENT_CATALOG 353
#define CURRENT_DATE 354
#define CURRENT_ROLE 355
#define CURRENT_SCHEMA 356
#define CURRENT_TIME 357
#define CURRENT_TIMESTAMP 358
#define CURRENT_USER 359
#define CURSOR 360
#define CYCLE 361
#define DATA_P 362
#define DATABASE 363
#define DAY_P 364
#define DEALLOCATE 365
#define DEC 366
#define DECIMAL_P 367
#define DECLARE 368
#define DEFAULT 369
#define DEFAULTS 370
#define DEFERRABLE 371
#define DEFERRED 372
#define DEFINER 373
#define DELETE_P 374
#define DELIMITER 375
#define DELIMITERS 376
#define DEPENDS 377
#define DESC 378
#define DETACH 379
#define DICTIONARY 380
#define DISABLE_P 381
#define DISCARD 382
#define DISTINCT 383
#define DO 384
#define DOCUMENT_P 385
#define DOMAIN_P 386
#define DOUBLE_P 387
#define DROP 388
#define EACH 389
#define ELSE 390
#define ENABLE_P 391
#define ENCODING 392
#define ENCRYPTED 393
#define END_P 394
#define ENUM_P 395
#define ESCAPE 396
#define EVENT 397
#define EXCEPT 398
#define EXCLUDE 399
#define EXCLUDING 400
#define EXCLUSIVE 401
#define EXECUTE 402
#define EXISTS 403
#define EXPLAIN 404
#define EXPRESSION 405
#define EXTENSION 406
#define EXTERNAL 407
#define EXTRACT 408
#define FALSE_P 409
#define FAMILY 410
#define FETCH 411
#define FILTER 412
#define FIRST_P 413
#define FLOAT_P 414
#define FOLLOWING 415
#define FOR 416
#define FORCE 417
#define FOREIGN 418
#define FORWARD 419
#define FREEZE 420
#define FROM 421
#define FULL 422
#define FUNCTION 423
#define FUNCTIONS 424
#define GENERATED 425
#define GLOBAL 426
#define GRANT 427
#define GRANTED 428
#define GREATEST 429
#define GROUP_P 430
#define GROUPING 431
#define GROUPS 432
#define HANDLER 433
#define HAVING 434
#define HEADER_P 435
#define HOLD 436
#define HOUR_P 437
#define IDENTITY_P 438
#define IF_P 439
#define ILIKE 440
#define IMMEDIATE 441
#define IMMUTABLE 442
#define IMPLICIT_P 443
#define IMPORT_P 444
#define IN_P 445
#define INCLUDE 446
#define INCLUDING 447
#define INCREMENT 448
#define INDEX 449
#define INDEXES 450
#define INHERIT 451
#define INHERITS 452
#define INITIALLY 453
#define INLINE_P 454
#define INNER_P 455
#define INOUT 456
#define INPUT_P 457
#define INSENSITIVE 458
#define INSERT 459
#define INSTEAD 460
#define INT_P 461
#define INTEGER 462
#define INTERSECT 463
#define INTERVAL 464
#define INTO 465
#define INVOKER 466
#define IS 467
#define ISNULL 468
#define ISOLATION 469
#define JOIN 470
#define KEY 471
#define LABEL 472
#define LANGUAGE 473
#define LARGE_P 474
#define LAST_P 475
#define LATERAL_P 476
#define LEADING 477
#define LEAKPROOF 478
#define LEAST 479
#define LEFT 480
#define LEVEL 481
#define LIKE 482
#define LIMIT 483
#define LISTEN 484
#define LOAD 485
#define LOCAL 486
#define LOCALTIME 487
#define LOCALTIMESTAMP 488
#define LOCATION 489
#define LOCK_P 490
#define LOCKED 491
#define LOGGED 492
#define MAPPING 493
#define MATCH 494
#define MATERIALIZED 495
#define MAXVALUE 496
#define METHOD 497
#define MINUTE_P 498
#define MINVALUE 499
#define MODE 500
#define MONTH_P 501
#define MOVE 502
#define NAME_P 503
#define NAMES 504
#define NATIONAL 505
#define NATURAL 506
#define NCHAR 507
#define NEW 508
#define NEXT 509
#define NFC 510
#define NFD 511
#define NFKC 512
#define NFKD 513
#define NO 514
#define NONE 515
#define NORMALIZE 516
#define NORMALIZED 517
#define NOT 518
#define NOTHING 519
#define NOTIFY 520
#define NOTNULL 521
#define NOWAIT 522
#define NULL_P 523
#define NULLIF 524
#define NULLS_P 525
#define NUMERIC 526
#define OBJECT_P 527
#define OF 528
#define OFF 529
#define OFFSET 530
#define OIDS 531
#define OLD 532
#define ON 533
#define ONLY 534
#define OPERATOR 535
#define OPTION 536
#define OPTIONS 537
#define OR 538
#define ORDER 539
#define ORDINALITY 540
#define OTHERS 541
#define OUT_P 542
#define OUTER_P 543
#define OVER 544
#define OVERLAPS 545
#define OVERLAY 546
#define OVERRIDING 547
#define OWNED 548
#define OWNER 549
#define PARALLEL 550
#define PARSER 551
#define PARTIAL 552
#define PARTITION 553
#define PASSING 554
#define PASSWORD 555
#define PGPOOL 556
#define PLACING 557
#define PLANS 558
#define POLICY 559
#define POSITION 560
#define PRECEDING 561
#define PRECISION 562
#define PRESERVE 563
#define PREPARE 564
#define PREPARED 565
#define PRIMARY 566
#define PRIOR 567
#define PRIVILEGES 568
#define PROCEDURAL 569
#define PROCEDURE 570
#define PROCEDURES 571
#define PROGRAM 572
#define PUBLICATION 573
#define QUOTE 574
#define RANGE 575
#define READ 576
#define REAL 577
#define REASSIGN 578
#define RECHECK 579
#define RECURSIVE 580
#define REF 581
#define REFERENCES 582
#define REFERENCING 583
#define REFRESH 584
#define REINDEX 585
#define RELATIVE_P 586
#define RELEASE 587
#define RENAME 588
#define REPEATABLE 589
#define REPLACE 590
#define REPLICA 591
#define RESET 592
#define RESTART 593
#define RESTRICT 594
#define RETURNING 595
#define RETURNS 596
#define REVOKE 597
#define RIGHT 598
#define ROLE 599
#define ROLLBACK 600
#define ROLLUP 601
#define ROUTINE 602
#define ROUTINES 603
#define ROW 604
#define ROWS 605
#define RULE 606
#define SAVEPOINT 607
#define SCHEMA 608
#define SCHEMAS 609
#define SCROLL 610
#define SEARCH 611
#define SECOND_P 612
#define SECURITY 613
#define SELECT 614
#define SEQUENCE 615
#define SEQUENCES 616
#define SERIALIZABLE 617
#define SERVER 618
#define SESSION 619
#define SESSION_USER 620
#define SET 621
#define SETS 622
#define SETOF 623
#define SHARE 624
#define SHOW 625
#define SIMILAR 626
#define SIMPLE 627
#define SKIP 628
#define SMALLINT 629
#define SNAPSHOT 630
#define SOME 631
#define SQL_P 632
#define STABLE 633
#define STANDALONE_P 634
#define START 635
#define STATEMENT 636
#define STATISTICS 637
#define STDIN 638
#define STDOUT 639
#define STORAGE 640
#define STORED 641
#define STRICT_P 642
#define STRIP_P 643
#define SUBSCRIPTION 644
#define SUBSTRING 645
#define SUPPORT 646
#define SYMMETRIC 647
#define SYSID 648
#define SYSTEM_P 649
#define TABLE 650
#define TABLES 651
#define TABLESAMPLE 652
#define TABLESPACE 653
#define TEMP 654
#define TEMPLATE 655
#define TEMPORARY 656
#define TEXT_P 657
#define THEN 658
#define TIES 659
#define TIME 660
#define TIMESTAMP 661
#define TO 662
#define TRAILING 663
#define TRANSACTION 664
#define TRANSFORM 665
#define TREAT 666
#define TRIGGER 667
#define TRIM 668
#define TRUE_P 669
#define TRUNCATE 670
#define TRUSTED 671
#define TYPE_P 672
#define TYPES_P 673
#define UESCAPE 674
#define UNBOUNDED 675
#define UNCOMMITTED 676
#define UNENCRYPTED 677
#define UNION 678
#define UNIQUE 679
#define UNKNOWN 680
#define UNLISTEN 681
#define UNLOGGED 682
#define UNTIL 683
#define UPDATE 684
#define USER 685
#define USING 686
#define VACUUM 687
#define VALID 688
#define VALIDATE 689
#define VALIDATOR 690
#define VALUE_P 691
#define VALUES 692
#define VARCHAR 693
#define VARIADIC 694
#define VARYING 695
#define VERBOSE 696
#define VERSION_P 697
#define VIEW 698
#define VIEWS 699
#define VOLATILE 700
#define WHEN 701
#define WHERE 702
#define WHITESPACE_P 703
#define WINDOW 704
#define WITH 705
#define WITHIN 706
#define WITHOUT 707
#define WORK 708
#define WRAPPER 709
#define WRITE 710
#define XML_P 711
#define XMLATTRIBUTES 712
#define XMLCONCAT 713
#define XMLELEMENT 714
#define XMLEXISTS 715
#define XMLFOREST 716
#define XMLNAMESPACES 717
#define XMLPARSE 718
#define XMLPI 719
#define XMLROOT 720
#define XMLSERIALIZE 721
#define XMLTABLE 722
#define YEAR_P 723
#define YES_P 724
#define ZONE 725
#define NOT_LA 726
#define NULLS_LA 727
#define WITH_LA 728
#define POSTFIXOP 729
#define UMINUS 730

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 247 "gram.y" /* yacc.c:355  */

	core_YYSTYPE		core_yystype;
	/* these fields must match core_YYSTYPE: */
	int					ival;
	char				*str;
	const char			*keyword;

	char				chr;
	bool				boolean;
	JoinType			jtype;
	DropBehavior		dbehavior;
	OnCommitAction		oncommit;
	List				*list;
	Node				*node;
	Value				*value;
	ObjectType			objtype;
	TypeName			*typnam;
	FunctionParameter   *fun_param;
	FunctionParameterMode fun_param_mode;
	ObjectWithArgs		*objwithargs;
	DefElem				*defelt;
	SortBy				*sortby;
	WindowDef			*windef;
	JoinExpr			*jexpr;
	IndexElem			*ielem;
	Alias				*alias;
	RangeVar			*range;
	IntoClause			*into;
	WithClause			*with;
	InferClause			*infer;
	OnConflictClause	*onconflict;
	A_Indices			*aind;
	ResTarget			*target;
	struct PrivTarget	*privtarget;
	AccessPriv			*accesspriv;
	struct ImportQual	*importqual;
	InsertStmt			*istmt;
	VariableSetStmt		*vsetstmt;
	PartitionElem		*partelem;
	PartitionSpec		*partspec;
	PartitionBoundSpec	*partboundspec;
	RoleSpec			*rolespec;
	struct SelectLimit	*selectlimit;

#line 1344 "gram.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int base_yyparse (core_yyscan_t yyscanner);

#endif /* !YY_BASE_YY_Y_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 1374 "gram.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  841
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   105180

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  493
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  673
/* YYNRULES -- Number of rules.  */
#define YYNRULES  2764
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  5567

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   730

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   482,     2,     2,
     487,   488,   480,   478,   491,   479,   489,   481,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   492,   490,
     474,   476,   475,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   485,     2,   486,   483,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   477,
     484
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   841,   841,   857,   869,   879,   880,   881,   882,   883,
     884,   885,   886,   887,   888,   889,   890,   891,   892,   893,
     894,   895,   896,   897,   898,   899,   900,   901,   902,   903,
     904,   905,   906,   907,   908,   909,   910,   911,   912,   913,
     914,   915,   916,   917,   918,   919,   920,   921,   922,   923,
     924,   925,   926,   927,   928,   929,   930,   931,   932,   933,
     934,   935,   936,   937,   938,   939,   940,   941,   942,   943,
     944,   945,   946,   947,   948,   949,   950,   951,   952,   953,
     954,   955,   956,   957,   958,   959,   960,   961,   962,   963,
     964,   965,   966,   967,   968,   969,   970,   971,   972,   973,
     974,   975,   976,   977,   978,   979,   980,   981,   982,   983,
     984,   985,   986,   987,   988,   989,   990,   991,   992,   993,
     994,   995,   996,   997,   998,   999,  1000,  1001,  1002,  1003,
    1005,  1014,  1029,  1040,  1041,  1042,  1051,  1052,  1056,  1057,
    1061,  1066,  1070,  1080,  1088,  1092,  1096,  1101,  1105,  1153,
    1155,  1159,  1163,  1167,  1171,  1185,  1203,  1211,  1222,  1223,
    1227,  1235,  1243,  1251,  1272,  1279,  1286,  1293,  1300,  1307,
    1324,  1342,  1353,  1354,  1365,  1375,  1385,  1400,  1418,  1419,
    1423,  1430,  1438,  1439,  1440,  1441,  1442,  1443,  1457,  1464,
    1470,  1476,  1485,  1493,  1501,  1505,  1513,  1521,  1528,  1538,
    1539,  1547,  1558,  1566,  1574,  1585,  1593,  1601,  1608,  1617,
    1627,  1628,  1632,  1633,  1636,  1638,  1642,  1643,  1644,  1645,
    1649,  1650,  1651,  1657,  1669,  1673,  1677,  1692,  1699,  1700,
    1701,  1705,  1706,  1707,  1711,  1712,  1716,  1717,  1726,  1727,
    1734,  1741,  1751,  1758,  1768,  1769,  1774,  1775,  1781,  1787,
    1793,  1799,  1805,  1811,  1817,  1827,  1837,  1838,  1842,  1843,
    1851,  1866,  1872,  1878,  1884,  1890,  1909,  1918,  1927,  1936,
    1945,  1956,  1967,  1976,  1985,  1994,  2005,  2016,  2025,  2034,
    2043,  2052,  2061,  2070,  2081,  2095,  2096,  2101,  2114,  2130,
    2146,  2155,  2164,  2173,  2182,  2191,  2199,  2207,  2215,  2224,
    2233,  2249,  2258,  2267,  2276,  2293,  2302,  2311,  2320,  2330,
    2343,  2358,  2367,  2376,  2391,  2399,  2409,  2419,  2426,  2434,
    2442,  2449,  2456,  2464,  2472,  2480,  2487,  2494,  2502,  2509,
    2516,  2524,  2532,  2540,  2548,  2556,  2564,  2574,  2581,  2589,
    2597,  2605,  2613,  2621,  2628,  2635,  2642,  2648,  2658,  2659,
    2663,  2664,  2665,  2669,  2677,  2681,  2682,  2686,  2693,  2700,
    2707,  2717,  2720,  2721,  2725,  2726,  2731,  2735,  2739,  2744,
    2751,  2753,  2758,  2762,  2766,  2777,  2785,  2838,  2851,  2865,
    2877,  2884,  2888,  2902,  2915,  2916,  2921,  2930,  2940,  2950,
    2976,  2982,  3015,  3050,  3072,  3073,  3077,  3078,  3087,  3088,
    3089,  3092,  3093,  3098,  3099,  3103,  3107,  3111,  3115,  3119,
    3123,  3127,  3131,  3135,  3139,  3143,  3147,  3151,  3160,  3164,
    3168,  3172,  3176,  3177,  3182,  3186,  3193,  3200,  3201,  3202,
    3203,  3204,  3208,  3212,  3220,  3231,  3250,  3269,  3289,  3309,
    3329,  3362,  3363,  3364,  3365,  3366,  3373,  3380,  3381,  3385,
    3386,  3390,  3391,  3395,  3399,  3406,  3410,  3417,  3418,  3419,
    3423,  3424,  3427,  3448,  3466,  3487,  3488,  3492,  3499,  3500,
    3501,  3532,  3539,  3546,  3557,  3568,  3580,  3591,  3600,  3623,
    3641,  3642,  3661,  3668,  3675,  3682,  3693,  3703,  3704,  3705,
    3709,  3710,  3711,  3712,  3713,  3714,  3715,  3716,  3717,  3726,
    3733,  3737,  3750,  3766,  3781,  3797,  3812,  3831,  3852,  3853,
    3857,  3858,  3862,  3863,  3866,  3872,  3873,  3876,  3880,  3888,
    3893,  3899,  3900,  3904,  3909,  3916,  3917,  3927,  3929,  3931,
    3933,  3936,  3939,  3942,  3946,  3947,  3948,  3949,  3950,  3953,
    3954,  3958,  3959,  3962,  3974,  3975,  3978,  3989,  4000,  4014,
    4015,  4020,  4021,  4022,  4025,  4026,  4027,  4028,  4031,  4032,
    4035,  4036,  4039,  4057,  4069,  4093,  4101,  4122,  4135,  4151,
    4167,  4168,  4169,  4181,  4194,  4210,  4224,  4225,  4237,  4257,
    4267,  4280,  4288,  4299,  4300,  4303,  4304,  4307,  4308,  4311,
    4315,  4319,  4323,  4327,  4331,  4335,  4339,  4343,  4347,  4351,
    4356,  4360,  4364,  4370,  4371,  4375,  4376,  4377,  4382,  4385,
    4386,  4398,  4413,  4428,  4429,  4437,  4438,  4442,  4443,  4447,
    4448,  4452,  4453,  4457,  4467,  4480,  4481,  4491,  4502,  4503,
    4516,  4523,  4540,  4548,  4559,  4562,  4566,  4570,  4574,  4581,
    4593,  4603,  4606,  4610,  4623,  4632,  4641,  4650,  4659,  4668,
    4677,  4686,  4695,  4704,  4713,  4722,  4731,  4740,  4749,  4758,
    4767,  4776,  4785,  4794,  4803,  4812,  4821,  4830,  4839,  4848,
    4857,  4866,  4884,  4895,  4896,  4897,  4898,  4902,  4903,  4907,
    4908,  4918,  4926,  4938,  4939,  4943,  4947,  4955,  4959,  4963,
    4970,  4974,  4979,  4984,  4991,  4998,  5003,  5013,  5025,  5040,
    5041,  5046,  5047,  5051,  5052,  5062,  5071,  5079,  5096,  5116,
    5136,  5157,  5188,  5197,  5218,  5233,  5234,  5238,  5246,  5261,
    5270,  5282,  5283,  5295,  5303,  5320,  5344,  5361,  5375,  5376,
    5380,  5381,  5385,  5386,  5390,  5391,  5395,  5409,  5413,  5414,
    5418,  5419,  5420,  5421,  5422,  5432,  5443,  5444,  5455,  5476,
    5502,  5503,  5504,  5508,  5510,  5532,  5534,  5536,  5538,  5540,
    5545,  5546,  5550,  5551,  5555,  5566,  5567,  5571,  5580,  5584,
    5588,  5593,  5603,  5604,  5608,  5609,  5613,  5614,  5618,  5619,
    5623,  5624,  5625,  5629,  5633,  5634,  5635,  5639,  5640,  5645,
    5646,  5673,  5674,  5675,  5676,  5677,  5678,  5691,  5701,  5715,
    5717,  5722,  5727,  5729,  5734,  5744,  5745,  5746,  5747,  5758,
    5777,  5788,  5800,  5810,  5820,  5831,  5840,  5847,  5854,  5863,
    5872,  5881,  5890,  5899,  5909,  5918,  5930,  5933,  5934,  5937,
    5941,  5948,  5949,  5950,  5951,  5952,  5953,  5956,  5959,  5960,
    5968,  5975,  5976,  5979,  5981,  5992,  6003,  6014,  6025,  6038,
    6039,  6055,  6070,  6071,  6075,  6087,  6097,  6105,  6114,  6123,
    6124,  6127,  6128,  6131,  6132,  6133,  6136,  6150,  6155,  6165,
    6174,  6186,  6187,  6191,  6199,  6211,  6221,  6234,  6244,  6266,
    6276,  6294,  6304,  6314,  6324,  6334,  6344,  6354,  6364,  6374,
    6384,  6394,  6404,  6418,  6419,  6420,  6421,  6422,  6423,  6424,
    6425,  6426,  6427,  6428,  6429,  6430,  6435,  6436,  6437,  6438,
    6439,  6440,  6441,  6446,  6447,  6448,  6452,  6453,  6456,  6457,
    6460,  6462,  6467,  6468,  6479,  6490,  6491,  6492,  6526,  6534,
    6542,  6550,  6558,  6566,  6574,  6582,  6590,  6603,  6611,  6619,
    6627,  6635,  6643,  6651,  6659,  6667,  6675,  6687,  6688,  6689,
    6690,  6691,  6692,  6693,  6694,  6695,  6696,  6697,  6698,  6699,
    6700,  6705,  6706,  6707,  6708,  6709,  6710,  6711,  6712,  6713,
    6714,  6715,  6716,  6720,  6721,  6735,  6745,  6755,  6765,  6775,
    6785,  6795,  6805,  6815,  6827,  6828,  6833,  6834,  6835,  6836,
    6837,  6838,  6843,  6844,  6845,  6846,  6847,  6848,  6849,  6850,
    6853,  6854,  6864,  6870,  6878,  6886,  6894,  6902,  6910,  6918,
    6926,  6934,  6942,  6950,  6958,  6966,  6974,  6982,  6990,  6998,
    7008,  7009,  7012,  7013,  7023,  7039,  7053,  7079,  7081,  7083,
    7085,  7092,  7101,  7102,  7105,  7112,  7119,  7126,  7140,  7148,
    7156,  7164,  7172,  7180,  7188,  7196,  7204,  7212,  7220,  7228,
    7236,  7244,  7252,  7260,  7268,  7276,  7284,  7292,  7304,  7305,
    7309,  7310,  7315,  7316,  7326,  7339,  7349,  7361,  7362,  7365,
    7366,  7376,  7386,  7387,  7391,  7395,  7399,  7410,  7423,  7437,
    7454,  7455,  7456,  7457,  7458,  7459,  7471,  7501,  7534,  7535,
    7539,  7540,  7544,  7545,  7549,  7550,  7553,  7554,  7559,  7571,
    7590,  7595,  7600,  7607,  7608,  7611,  7612,  7615,  7616,  7619,
    7620,  7623,  7624,  7625,  7628,  7629,  7630,  7646,  7658,  7671,
    7683,  7698,  7699,  7702,  7703,  7707,  7708,  7712,  7713,  7718,
    7730,  7737,  7744,  7759,  7760,  7764,  7765,  7780,  7789,  7798,
    7807,  7816,  7828,  7829,  7830,  7831,  7832,  7838,  7842,  7857,
    7858,  7864,  7874,  7878,  7883,  7891,  7932,  7936,  7940,  7944,
    7952,  7953,  7957,  7967,  7968,  7974,  7975,  7982,  7986,  7990,
    7994,  7998,  8002,  8006,  8010,  8014,  8018,  8022,  8026,  8030,
    8034,  8038,  8042,  8047,  8054,  8058,  8062,  8066,  8070,  8076,
    8077,  8084,  8085,  8089,  8090,  8093,  8105,  8109,  8124,  8132,
    8140,  8152,  8153,  8158,  8159,  8176,  8186,  8196,  8206,  8216,
    8226,  8239,  8249,  8262,  8272,  8285,  8293,  8295,  8297,  8302,
    8304,  8309,  8310,  8315,  8333,  8342,  8343,  8347,  8351,  8363,
    8374,  8385,  8398,  8399,  8400,  8404,  8416,  8417,  8427,  8439,
    8443,  8447,  8451,  8458,  8478,  8488,  8498,  8508,  8520,  8521,
    8524,  8525,  8526,  8529,  8530,  8533,  8543,  8552,  8569,  8578,
    8587,  8596,  8605,  8614,  8623,  8632,  8641,  8650,  8659,  8668,
    8677,  8687,  8697,  8706,  8715,  8724,  8733,  8742,  8751,  8761,
    8771,  8781,  8791,  8801,  8811,  8821,  8831,  8841,  8851,  8861,
    8871,  8882,  8893,  8904,  8915,  8926,  8937,  8947,  8957,  8968,
    8979,  8989,  8999,  9007,  9016,  9025,  9034,  9043,  9052,  9061,
    9070,  9079,  9088,  9102,  9103,  9106,  9107,  9117,  9126,  9135,
    9144,  9154,  9163,  9174,  9175,  9185,  9194,  9203,  9212,  9221,
    9230,  9239,  9248,  9257,  9266,  9275,  9284,  9293,  9302,  9311,
    9320,  9329,  9338,  9347,  9356,  9365,  9374,  9383,  9392,  9401,
    9410,  9419,  9437,  9446,  9447,  9450,  9452,  9458,  9459,  9460,
    9461,  9462,  9474,  9489,  9497,  9505,  9513,  9521,  9529,  9537,
    9545,  9553,  9561,  9569,  9577,  9585,  9593,  9601,  9609,  9617,
    9625,  9633,  9641,  9649,  9657,  9665,  9673,  9691,  9710,  9711,
    9715,  9719,  9739,  9746,  9754,  9762,  9779,  9792,  9796,  9803,
    9812,  9821,  9830,  9839,  9849,  9859,  9877,  9885,  9901,  9918,
    9919,  9920,  9925,  9931,  9940,  9941,  9942,  9943,  9944,  9948,
    9949,  9952,  9953,  9954,  9955,  9959,  9960,  9961,  9973,  9983,
    9984,  9987,  9996, 10002, 10021, 10029, 10036, 10043, 10051, 10059,
   10067, 10074, 10081, 10088, 10095, 10102, 10109, 10116, 10125, 10126,
   10127, 10131, 10134, 10137, 10140, 10143, 10150, 10152, 10154, 10159,
   10161, 10165, 10166, 10167, 10179, 10192, 10205, 10223, 10244, 10245,
   10246, 10247, 10257, 10273, 10283, 10284, 10288, 10289, 10293, 10297,
   10301, 10319, 10320, 10321, 10322, 10323, 10324, 10325, 10332, 10333,
   10344, 10351, 10358, 10369, 10386, 10394, 10402, 10410, 10421, 10425,
   10436, 10448, 10465, 10471, 10487, 10500, 10509, 10517, 10525, 10534,
   10545, 10556, 10566, 10567, 10578, 10588, 10599, 10610, 10621, 10632,
   10641, 10653, 10654, 10668, 10691, 10701, 10712, 10725, 10726, 10738,
   10758, 10768, 10779, 10790, 10794, 10801, 10802, 10806, 10813, 10814,
   10818, 10819, 10820, 10824, 10825, 10829, 10830, 10833, 10834, 10837,
   10838, 10842, 10843, 10847, 10854, 10856, 10861, 10862, 10875, 10882,
   10892, 10899, 10909, 10910, 10911, 10912, 10913, 10914, 10915, 10916,
   10917, 10921, 10925, 10932, 10939, 10940, 10944, 10945, 10946, 10956,
   10966, 10967, 10971, 10972, 10973, 10974, 10984, 10991, 11008, 11027,
   11028, 11038, 11044, 11050, 11056, 11072, 11090, 11094, 11102, 11108,
   11115, 11121, 11128, 11137, 11138, 11142, 11144, 11149, 11160, 11170,
   11180, 11186, 11195, 11204, 11210, 11211, 11222, 11236, 11237, 11248,
   11259, 11260, 11263, 11264, 11265, 11266, 11267, 11268, 11269, 11270,
   11273, 11274, 11278, 11279, 11280, 11291, 11308, 11309, 11313, 11318,
   11342, 11353, 11354, 11364, 11375, 11378, 11379, 11380, 11381, 11382,
   11385, 11386, 11387, 11435, 11436, 11440, 11441, 11456, 11457, 11464,
   11472, 11480, 11488, 11496, 11504, 11515, 11516, 11543, 11557, 11572,
   11573, 11592, 11596, 11600, 11617, 11624, 11631, 11641, 11642, 11645,
   11658, 11659, 11660, 11664, 11665, 11669, 11681, 11689, 11694, 11699,
   11704, 11709, 11717, 11725, 11730, 11735, 11742, 11743, 11747, 11748,
   11749, 11756, 11757, 11761, 11762, 11766, 11767, 11771, 11775, 11776,
   11779, 11788, 11801, 11806, 11811, 11815, 11826, 11827, 11831, 11839,
   11855, 11863, 11871, 11879, 11890, 11893, 11898, 11899, 11907, 11927,
   11928, 11930, 11935, 11936, 11940, 11941, 11944, 11945, 11970, 11971,
   11975, 11976, 11980, 11981, 11982, 11983, 11984, 11988, 12001, 12008,
   12015, 12022, 12023, 12027, 12028, 12032, 12033, 12037, 12038, 12042,
   12053, 12054, 12055, 12056, 12060, 12061, 12071, 12077, 12095, 12096,
   12100, 12101, 12107, 12112, 12120, 12127, 12135, 12141, 12148, 12183,
   12208, 12212, 12238, 12242, 12254, 12267, 12281, 12292, 12307, 12313,
   12318, 12324, 12331, 12332, 12340, 12344, 12348, 12354, 12361, 12366,
   12367, 12368, 12369, 12373, 12374, 12386, 12387, 12392, 12399, 12406,
   12413, 12424, 12425, 12438, 12442, 12449, 12462, 12475, 12476, 12491,
   12501, 12513, 12518, 12519, 12522, 12523, 12526, 12527, 12532, 12533,
   12538, 12539, 12547, 12552, 12553, 12557, 12561, 12567, 12591, 12601,
   12614, 12615, 12619, 12633, 12690, 12704, 12706, 12711, 12713, 12715,
   12717, 12722, 12724, 12729, 12737, 12757, 12762, 12769, 12774, 12780,
   12785, 12794, 12796, 12799, 12803, 12804, 12805, 12806, 12807, 12808,
   12813, 12833, 12834, 12835, 12836, 12847, 12853, 12861, 12862, 12868,
   12873, 12878, 12883, 12888, 12893, 12898, 12903, 12909, 12915, 12921,
   12928, 12950, 12959, 12963, 12971, 12975, 12983, 12995, 13016, 13020,
   13026, 13030, 13043, 13051, 13061, 13063, 13065, 13067, 13069, 13071,
   13076, 13077, 13084, 13093, 13101, 13110, 13121, 13129, 13130, 13131,
   13135, 13137, 13139, 13141, 13143, 13145, 13147, 13152, 13157, 13163,
   13171, 13176, 13183, 13190, 13194, 13198, 13234, 13235, 13237, 13245,
   13260, 13262, 13264, 13266, 13268, 13270, 13272, 13274, 13276, 13278,
   13280, 13282, 13284, 13286, 13289, 13291, 13293, 13296, 13298, 13300,
   13302, 13305, 13310, 13318, 13323, 13331, 13336, 13344, 13349, 13358,
   13366, 13374, 13382, 13400, 13408, 13416, 13424, 13432, 13448, 13456,
   13464, 13472, 13480, 13488, 13496, 13500, 13504, 13508, 13512, 13520,
   13528, 13536, 13544, 13564, 13586, 13597, 13604, 13620, 13625, 13631,
   13635, 13639, 13643, 13647, 13672, 13674, 13676, 13678, 13680, 13682,
   13684, 13686, 13688, 13690, 13692, 13694, 13696, 13698, 13700, 13702,
   13704, 13706, 13708, 13710, 13714, 13718, 13722, 13726, 13731, 13747,
   13748, 13749, 13764, 13798, 13800, 13802, 13813, 13837, 13848, 13859,
   13866, 13876, 13886, 13895, 13899, 13905, 13912, 13919, 13929, 13936,
   13964, 13999, 14010, 14011, 14018, 14024, 14028, 14032, 14036, 14040,
   14044, 14048, 14052, 14056, 14060, 14064, 14068, 14072, 14076, 14080,
   14084, 14086, 14090, 14094, 14098, 14107, 14112, 14119, 14134, 14141,
   14145, 14149, 14153, 14157, 14164, 14172, 14180, 14184, 14188, 14192,
   14196, 14200, 14206, 14210, 14219, 14223, 14227, 14232, 14246, 14248,
   14252, 14254, 14256, 14259, 14262, 14265, 14266, 14269, 14277, 14287,
   14288, 14291, 14292, 14293, 14298, 14302, 14306, 14310, 14317, 14318,
   14326, 14327, 14331, 14332, 14340, 14341, 14345, 14346, 14351, 14359,
   14361, 14375, 14378, 14405, 14406, 14409, 14410, 14418, 14425, 14432,
   14440, 14449, 14466, 14511, 14519, 14527, 14535, 14543, 14554, 14555,
   14556, 14557, 14558, 14572, 14573, 14574, 14577, 14578, 14581, 14584,
   14585, 14586, 14589, 14590, 14593, 14594, 14595, 14596, 14597, 14598,
   14599, 14600, 14601, 14602, 14603, 14604, 14607, 14609, 14614, 14616,
   14621, 14623, 14625, 14627, 14629, 14631, 14643, 14647, 14654, 14658,
   14664, 14668, 14677, 14688, 14689, 14692, 14696, 14700, 14706, 14707,
   14712, 14716, 14723, 14724, 14725, 14726, 14727, 14728, 14729, 14730,
   14734, 14735, 14736, 14737, 14747, 14751, 14758, 14765, 14766, 14782,
   14786, 14791, 14795, 14810, 14815, 14819, 14822, 14825, 14826, 14827,
   14830, 14837, 14847, 14861, 14862, 14866, 14877, 14878, 14881, 14882,
   14885, 14889, 14896, 14900, 14904, 14912, 14923, 14924, 14928, 14929,
   14933, 14934, 14937, 14938, 14948, 14949, 14953, 14954, 14957, 14973,
   14981, 14989, 15011, 15012, 15023, 15027, 15054, 15056, 15061, 15064,
   15067, 15069, 15071, 15073, 15083, 15085, 15096, 15100, 15104, 15108,
   15112, 15121, 15128, 15160, 15164, 15170, 15177, 15181, 15185, 15191,
   15192, 15194, 15195, 15196, 15200, 15233, 15260, 15264, 15270, 15272,
   15289, 15290, 15291, 15296, 15297, 15298, 15303, 15304, 15305, 15306,
   15312, 15313, 15314, 15315, 15316, 15336, 15337, 15338, 15339, 15340,
   15341, 15342, 15343, 15344, 15345, 15346, 15347, 15348, 15349, 15350,
   15351, 15352, 15353, 15354, 15355, 15356, 15357, 15358, 15359, 15360,
   15361, 15362, 15363, 15364, 15365, 15366, 15367, 15368, 15369, 15370,
   15371, 15372, 15373, 15374, 15375, 15376, 15377, 15378, 15379, 15380,
   15381, 15382, 15383, 15384, 15385, 15386, 15387, 15388, 15389, 15390,
   15391, 15392, 15393, 15394, 15395, 15396, 15397, 15398, 15399, 15400,
   15401, 15402, 15403, 15404, 15405, 15406, 15407, 15408, 15409, 15410,
   15411, 15412, 15413, 15414, 15415, 15416, 15417, 15418, 15419, 15420,
   15421, 15422, 15423, 15424, 15425, 15426, 15427, 15428, 15429, 15430,
   15431, 15432, 15433, 15434, 15435, 15436, 15437, 15438, 15439, 15440,
   15441, 15442, 15443, 15444, 15445, 15446, 15447, 15448, 15449, 15450,
   15451, 15452, 15453, 15454, 15455, 15456, 15457, 15458, 15459, 15460,
   15461, 15462, 15463, 15464, 15465, 15466, 15467, 15468, 15469, 15470,
   15471, 15472, 15473, 15474, 15475, 15476, 15477, 15478, 15479, 15480,
   15481, 15482, 15483, 15484, 15485, 15486, 15487, 15488, 15489, 15490,
   15491, 15492, 15493, 15494, 15495, 15496, 15497, 15498, 15499, 15500,
   15501, 15502, 15503, 15504, 15505, 15506, 15507, 15508, 15509, 15510,
   15511, 15512, 15513, 15514, 15515, 15516, 15517, 15518, 15519, 15520,
   15521, 15522, 15523, 15524, 15525, 15526, 15527, 15528, 15529, 15530,
   15531, 15532, 15533, 15534, 15535, 15536, 15537, 15538, 15539, 15540,
   15541, 15542, 15543, 15544, 15545, 15546, 15547, 15548, 15549, 15550,
   15551, 15552, 15553, 15554, 15555, 15556, 15557, 15558, 15559, 15560,
   15561, 15562, 15563, 15564, 15565, 15566, 15567, 15568, 15569, 15570,
   15571, 15572, 15573, 15574, 15575, 15576, 15577, 15578, 15579, 15580,
   15581, 15582, 15583, 15584, 15585, 15586, 15587, 15588, 15589, 15590,
   15591, 15592, 15593, 15594, 15595, 15596, 15597, 15598, 15599, 15600,
   15601, 15602, 15603, 15604, 15605, 15606, 15607, 15608, 15609, 15610,
   15611, 15612, 15613, 15614, 15615, 15616, 15617, 15618, 15619, 15620,
   15621, 15622, 15623, 15624, 15625, 15626, 15627, 15628, 15629, 15630,
   15631, 15632, 15633, 15634, 15648, 15649, 15650, 15651, 15652, 15653,
   15654, 15655, 15656, 15657, 15658, 15659, 15660, 15661, 15662, 15663,
   15664, 15665, 15666, 15667, 15668, 15669, 15670, 15671, 15672, 15673,
   15674, 15675, 15676, 15677, 15678, 15679, 15680, 15681, 15682, 15683,
   15684, 15685, 15686, 15687, 15688, 15689, 15690, 15691, 15692, 15693,
   15694, 15695, 15696, 15697, 15698, 15712, 15713, 15714, 15715, 15716,
   15717, 15718, 15719, 15720, 15721, 15722, 15723, 15724, 15725, 15726,
   15727, 15728, 15729, 15730, 15731, 15732, 15733, 15734, 15744, 15745,
   15746, 15747, 15748, 15749, 15750, 15751, 15752, 15753, 15754, 15755,
   15756, 15757, 15758, 15759, 15760, 15761, 15762, 15763, 15764, 15765,
   15766, 15767, 15768, 15769, 15770, 15771, 15772, 15773, 15774, 15775,
   15776, 15777, 15778, 15779, 15780, 15781, 15782, 15783, 15784, 15785,
   15786, 15787, 15788, 15789, 15790, 15791, 15792, 15793, 15794, 15795,
   15796, 15797, 15798, 15799, 15800, 15801, 15802, 15803, 15804, 15805,
   15806, 15807, 15808, 15809, 15810, 15811, 15812, 15813, 15814, 15815,
   15816, 15817, 15818, 15819, 15820
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "UIDENT", "FCONST", "SCONST",
  "USCONST", "BCONST", "XCONST", "Op", "ICONST", "PARAM", "TYPECAST",
  "DOT_DOT", "COLON_EQUALS", "EQUALS_GREATER", "LESS_EQUALS",
  "GREATER_EQUALS", "NOT_EQUALS", "ABORT_P", "ABSOLUTE_P", "ACCESS",
  "ACTION", "ADD_P", "ADMIN", "AFTER", "AGGREGATE", "ALL", "ALSO", "ALTER",
  "ALWAYS", "ANALYSE", "ANALYZE", "AND", "ANY", "ARRAY", "AS", "ASC",
  "ASSERTION", "ASSIGNMENT", "ASYMMETRIC", "AT", "ATTACH", "ATTRIBUTE",
  "AUTHORIZATION", "BACKWARD", "BEFORE", "BEGIN_P", "BETWEEN", "BIGINT",
  "BINARY", "BIT", "BOOLEAN_P", "BOTH", "BY", "CACHE", "CALL", "CALLED",
  "CASCADE", "CASCADED", "CASE", "CAST", "CATALOG_P", "CHAIN", "CHAR_P",
  "CHARACTER", "CHARACTERISTICS", "CHECK", "CHECKPOINT", "CLASS", "CLOSE",
  "CLUSTER", "COALESCE", "COLLATE", "COLLATION", "COLUMN", "COLUMNS",
  "COMMENT", "COMMENTS", "COMMIT", "COMMITTED", "CONCURRENTLY",
  "CONFIGURATION", "CONFLICT", "CONNECTION", "CONSTRAINT", "CONSTRAINTS",
  "CONTENT_P", "CONTINUE_P", "CONVERSION_P", "COPY", "COST", "CREATE",
  "CROSS", "CSV", "CUBE", "CURRENT_P", "CURRENT_CATALOG", "CURRENT_DATE",
  "CURRENT_ROLE", "CURRENT_SCHEMA", "CURRENT_TIME", "CURRENT_TIMESTAMP",
  "CURRENT_USER", "CURSOR", "CYCLE", "DATA_P", "DATABASE", "DAY_P",
  "DEALLOCATE", "DEC", "DECIMAL_P", "DECLARE", "DEFAULT", "DEFAULTS",
  "DEFERRABLE", "DEFERRED", "DEFINER", "DELETE_P", "DELIMITER",
  "DELIMITERS", "DEPENDS", "DESC", "DETACH", "DICTIONARY", "DISABLE_P",
  "DISCARD", "DISTINCT", "DO", "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P",
  "DROP", "EACH", "ELSE", "ENABLE_P", "ENCODING", "ENCRYPTED", "END_P",
  "ENUM_P", "ESCAPE", "EVENT", "EXCEPT", "EXCLUDE", "EXCLUDING",
  "EXCLUSIVE", "EXECUTE", "EXISTS", "EXPLAIN", "EXPRESSION", "EXTENSION",
  "EXTERNAL", "EXTRACT", "FALSE_P", "FAMILY", "FETCH", "FILTER", "FIRST_P",
  "FLOAT_P", "FOLLOWING", "FOR", "FORCE", "FOREIGN", "FORWARD", "FREEZE",
  "FROM", "FULL", "FUNCTION", "FUNCTIONS", "GENERATED", "GLOBAL", "GRANT",
  "GRANTED", "GREATEST", "GROUP_P", "GROUPING", "GROUPS", "HANDLER",
  "HAVING", "HEADER_P", "HOLD", "HOUR_P", "IDENTITY_P", "IF_P", "ILIKE",
  "IMMEDIATE", "IMMUTABLE", "IMPLICIT_P", "IMPORT_P", "IN_P", "INCLUDE",
  "INCLUDING", "INCREMENT", "INDEX", "INDEXES", "INHERIT", "INHERITS",
  "INITIALLY", "INLINE_P", "INNER_P", "INOUT", "INPUT_P", "INSENSITIVE",
  "INSERT", "INSTEAD", "INT_P", "INTEGER", "INTERSECT", "INTERVAL", "INTO",
  "INVOKER", "IS", "ISNULL", "ISOLATION", "JOIN", "KEY", "LABEL",
  "LANGUAGE", "LARGE_P", "LAST_P", "LATERAL_P", "LEADING", "LEAKPROOF",
  "LEAST", "LEFT", "LEVEL", "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL",
  "LOCALTIME", "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "LOCKED", "LOGGED",
  "MAPPING", "MATCH", "MATERIALIZED", "MAXVALUE", "METHOD", "MINUTE_P",
  "MINVALUE", "MODE", "MONTH_P", "MOVE", "NAME_P", "NAMES", "NATIONAL",
  "NATURAL", "NCHAR", "NEW", "NEXT", "NFC", "NFD", "NFKC", "NFKD", "NO",
  "NONE", "NORMALIZE", "NORMALIZED", "NOT", "NOTHING", "NOTIFY", "NOTNULL",
  "NOWAIT", "NULL_P", "NULLIF", "NULLS_P", "NUMERIC", "OBJECT_P", "OF",
  "OFF", "OFFSET", "OIDS", "OLD", "ON", "ONLY", "OPERATOR", "OPTION",
  "OPTIONS", "OR", "ORDER", "ORDINALITY", "OTHERS", "OUT_P", "OUTER_P",
  "OVER", "OVERLAPS", "OVERLAY", "OVERRIDING", "OWNED", "OWNER",
  "PARALLEL", "PARSER", "PARTIAL", "PARTITION", "PASSING", "PASSWORD",
  "PGPOOL", "PLACING", "PLANS", "POLICY", "POSITION", "PRECEDING",
  "PRECISION", "PRESERVE", "PREPARE", "PREPARED", "PRIMARY", "PRIOR",
  "PRIVILEGES", "PROCEDURAL", "PROCEDURE", "PROCEDURES", "PROGRAM",
  "PUBLICATION", "QUOTE", "RANGE", "READ", "REAL", "REASSIGN", "RECHECK",
  "RECURSIVE", "REF", "REFERENCES", "REFERENCING", "REFRESH", "REINDEX",
  "RELATIVE_P", "RELEASE", "RENAME", "REPEATABLE", "REPLACE", "REPLICA",
  "RESET", "RESTART", "RESTRICT", "RETURNING", "RETURNS", "REVOKE",
  "RIGHT", "ROLE", "ROLLBACK", "ROLLUP", "ROUTINE", "ROUTINES", "ROW",
  "ROWS", "RULE", "SAVEPOINT", "SCHEMA", "SCHEMAS", "SCROLL", "SEARCH",
  "SECOND_P", "SECURITY", "SELECT", "SEQUENCE", "SEQUENCES",
  "SERIALIZABLE", "SERVER", "SESSION", "SESSION_USER", "SET", "SETS",
  "SETOF", "SHARE", "SHOW", "SIMILAR", "SIMPLE", "SKIP", "SMALLINT",
  "SNAPSHOT", "SOME", "SQL_P", "STABLE", "STANDALONE_P", "START",
  "STATEMENT", "STATISTICS", "STDIN", "STDOUT", "STORAGE", "STORED",
  "STRICT_P", "STRIP_P", "SUBSCRIPTION", "SUBSTRING", "SUPPORT",
  "SYMMETRIC", "SYSID", "SYSTEM_P", "TABLE", "TABLES", "TABLESAMPLE",
  "TABLESPACE", "TEMP", "TEMPLATE", "TEMPORARY", "TEXT_P", "THEN", "TIES",
  "TIME", "TIMESTAMP", "TO", "TRAILING", "TRANSACTION", "TRANSFORM",
  "TREAT", "TRIGGER", "TRIM", "TRUE_P", "TRUNCATE", "TRUSTED", "TYPE_P",
  "TYPES_P", "UESCAPE", "UNBOUNDED", "UNCOMMITTED", "UNENCRYPTED", "UNION",
  "UNIQUE", "UNKNOWN", "UNLISTEN", "UNLOGGED", "UNTIL", "UPDATE", "USER",
  "USING", "VACUUM", "VALID", "VALIDATE", "VALIDATOR", "VALUE_P", "VALUES",
  "VARCHAR", "VARIADIC", "VARYING", "VERBOSE", "VERSION_P", "VIEW",
  "VIEWS", "VOLATILE", "WHEN", "WHERE", "WHITESPACE_P", "WINDOW", "WITH",
  "WITHIN", "WITHOUT", "WORK", "WRAPPER", "WRITE", "XML_P",
  "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT", "XMLEXISTS", "XMLFOREST",
  "XMLNAMESPACES", "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE",
  "XMLTABLE", "YEAR_P", "YES_P", "ZONE", "NOT_LA", "NULLS_LA", "WITH_LA",
  "'<'", "'>'", "'='", "POSTFIXOP", "'+'", "'-'", "'*'", "'/'", "'%'",
  "'^'", "UMINUS", "'['", "']'", "'('", "')'", "'.'", "';'", "','", "':'",
  "$accept", "stmtblock", "stmtmulti", "stmt", "CallStmt",
  "CreateRoleStmt", "opt_with", "OptRoleList", "AlterOptRoleList",
  "AlterOptRoleElem", "CreateOptRoleElem", "CreateUserStmt",
  "AlterRoleStmt", "opt_in_database", "AlterRoleSetStmt", "DropRoleStmt",
  "CreateGroupStmt", "AlterGroupStmt", "add_drop", "CreateSchemaStmt",
  "OptSchemaName", "OptSchemaEltList", "schema_stmt", "VariableSetStmt",
  "set_rest", "generic_set", "set_rest_more", "var_name", "var_list",
  "var_value", "iso_level", "opt_boolean_or_string", "zone_value",
  "opt_encoding", "NonReservedWord_or_Sconst", "VariableResetStmt",
  "reset_rest", "generic_reset", "SetResetClause",
  "FunctionSetResetClause", "VariableShowStmt", "ConstraintsSetStmt",
  "constraints_set_list", "constraints_set_mode", "CheckPointStmt",
  "DiscardStmt", "AlterTableStmt", "alter_table_cmds", "partition_cmd",
  "index_partition_cmd", "alter_table_cmd", "alter_column_default",
  "opt_drop_behavior", "opt_collate_clause", "alter_using",
  "replica_identity", "reloptions", "opt_reloptions", "reloption_list",
  "reloption_elem", "alter_identity_column_option_list",
  "alter_identity_column_option", "PartitionBoundSpec",
  "hash_partbound_elem", "hash_partbound", "AlterCompositeTypeStmt",
  "alter_type_cmds", "alter_type_cmd", "ClosePortalStmt", "CopyStmt",
  "copy_from", "opt_program", "copy_file_name", "copy_options",
  "copy_opt_list", "copy_opt_item", "opt_binary", "copy_delimiter",
  "opt_using", "copy_generic_opt_list", "copy_generic_opt_elem",
  "copy_generic_opt_arg", "copy_generic_opt_arg_list",
  "copy_generic_opt_arg_list_item", "CreateStmt", "OptTemp",
  "OptTableElementList", "OptTypedTableElementList", "TableElementList",
  "TypedTableElementList", "TableElement", "TypedTableElement",
  "columnDef", "columnOptions", "ColQualList", "ColConstraint",
  "ColConstraintElem", "generated_when", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "opt_no_inherit", "opt_column_list",
  "columnList", "columnElem", "opt_c_include", "key_match",
  "ExclusionConstraintList", "ExclusionConstraintElem",
  "ExclusionWhereClause", "key_actions", "key_update", "key_delete",
  "key_action", "OptInherit", "OptPartitionSpec", "PartitionSpec",
  "part_params", "part_elem", "table_access_method_clause", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptConsTableSpace", "ExistingIndex",
  "CreateStatsStmt", "AlterStatsStmt", "CreateAsStmt", "create_as_target",
  "opt_with_data", "CreateMatViewStmt", "create_mv_target", "OptNoLog",
  "RefreshMatViewStmt", "CreateSeqStmt", "AlterSeqStmt", "OptSeqOptList",
  "OptParenthesizedSeqOptList", "SeqOptList", "SeqOptElem", "opt_by",
  "NumericOnly", "NumericOnly_list", "CreatePLangStmt", "opt_trusted",
  "handler_name", "opt_inline_handler", "validator_clause",
  "opt_validator", "DropPLangStmt", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "AlterForeignServerStmt",
  "CreateForeignTableStmt", "AlterForeignTableStmt",
  "ImportForeignSchemaStmt", "import_qualification_type",
  "import_qualification", "CreateUserMappingStmt", "auth_ident",
  "DropUserMappingStmt", "AlterUserMappingStmt", "CreatePolicyStmt",
  "AlterPolicyStmt", "RowSecurityOptionalExpr",
  "RowSecurityOptionalWithCheck", "RowSecurityDefaultToRole",
  "RowSecurityOptionalToRole", "RowSecurityDefaultPermissive",
  "RowSecurityDefaultForCmd", "row_security_cmd", "CreateAmStmt",
  "am_type", "CreateTrigStmt", "TriggerActionTime", "TriggerEvents",
  "TriggerOneEvent", "TriggerReferencing", "TriggerTransitions",
  "TriggerTransition", "TransitionOldOrNew", "TransitionRowOrTable",
  "TransitionRelName", "TriggerForSpec", "TriggerForOptEach",
  "TriggerForType", "TriggerWhen", "FUNCTION_or_PROCEDURE",
  "TriggerFuncArgs", "TriggerFuncArg", "OptConstrFromTable",
  "ConstraintAttributeSpec", "ConstraintAttributeElem",
  "CreateEventTrigStmt", "event_trigger_when_list",
  "event_trigger_when_item", "event_trigger_value_list",
  "AlterEventTrigStmt", "enable_trigger", "CreateAssertionStmt",
  "DefineStmt", "definition", "def_list", "def_elem", "def_arg",
  "old_aggr_definition", "old_aggr_list", "old_aggr_elem",
  "opt_enum_val_list", "enum_val_list", "AlterEnumStmt",
  "opt_if_not_exists", "CreateOpClassStmt", "opclass_item_list",
  "opclass_item", "opt_default", "opt_opfamily", "opclass_purpose",
  "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "drop_type_any_name", "drop_type_name", "drop_type_name_on_any_name",
  "any_name_list", "any_name", "attrs", "type_name_list", "TruncateStmt",
  "opt_restart_seqs", "CommentStmt", "comment_type_any_name",
  "comment_type_name", "comment_text", "SecLabelStmt", "opt_provider",
  "security_label_type_any_name", "security_label_type_name",
  "security_label", "FetchStmt", "fetch_args", "from_in", "opt_from_in",
  "GrantStmt", "RevokeStmt", "privileges", "privilege_list", "privilege",
  "privilege_target", "grantee_list", "grantee", "opt_grant_grant_option",
  "GrantRoleStmt", "RevokeRoleStmt", "opt_grant_admin_option",
  "opt_granted_by", "AlterDefaultPrivilegesStmt", "DefACLOptionList",
  "DefACLOption", "DefACLAction", "defacl_privilege_target", "IndexStmt",
  "opt_unique", "opt_concurrently", "opt_index_name",
  "access_method_clause", "index_params", "index_elem_options",
  "index_elem", "opt_include", "index_including_params", "opt_collate",
  "opt_class", "opt_asc_desc", "opt_nulls_order", "CreateFunctionStmt",
  "opt_or_replace", "func_args", "func_args_list",
  "function_with_argtypes_list", "function_with_argtypes",
  "func_args_with_defaults", "func_args_with_defaults_list", "func_arg",
  "arg_class", "param_name", "func_return", "func_type",
  "func_arg_with_default", "aggr_arg", "aggr_args", "aggr_args_list",
  "aggregate_with_argtypes", "aggregate_with_argtypes_list",
  "createfunc_opt_list", "common_func_opt_item", "createfunc_opt_item",
  "func_as", "transform_type_list", "opt_definition", "table_func_column",
  "table_func_column_list", "AlterFunctionStmt", "alterfunc_opt_list",
  "opt_restrict", "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt",
  "oper_argtypes", "any_operator", "operator_with_argtypes_list",
  "operator_with_argtypes", "DoStmt", "dostmt_opt_list", "dostmt_opt_item",
  "CreateCastStmt", "cast_context", "DropCastStmt", "opt_if_exists",
  "CreateTransformStmt", "transform_element_list", "DropTransformStmt",
  "ReindexStmt", "reindex_target_type", "reindex_target_multitable",
  "reindex_option_list", "reindex_option_elem", "AlterTblSpcStmt",
  "RenameStmt", "opt_column", "opt_set_data", "AlterObjectDependsStmt",
  "opt_no", "AlterObjectSchemaStmt", "AlterOperatorStmt",
  "operator_def_list", "operator_def_elem", "operator_def_arg",
  "AlterTypeStmt", "AlterOwnerStmt", "CreatePublicationStmt",
  "opt_publication_for_tables", "publication_for_tables",
  "AlterPublicationStmt", "CreateSubscriptionStmt",
  "publication_name_list", "publication_name_item",
  "AlterSubscriptionStmt", "DropSubscriptionStmt", "RuleStmt",
  "RuleActionList", "RuleActionMulti", "RuleActionStmt",
  "RuleActionStmtOrEmpty", "event", "opt_instead", "NotifyStmt",
  "notify_payload", "ListenStmt", "UnlistenStmt", "TransactionStmt",
  "opt_transaction", "transaction_mode_item", "transaction_mode_list",
  "transaction_mode_list_or_empty", "opt_transaction_chain", "ViewStmt",
  "opt_check_option", "LoadStmt", "CreatedbStmt", "createdb_opt_list",
  "createdb_opt_items", "createdb_opt_item", "createdb_opt_name",
  "opt_equal", "AlterDatabaseStmt", "AlterDatabaseSetStmt", "DropdbStmt",
  "drop_option_list", "drop_option", "AlterCollationStmt",
  "AlterSystemStmt", "CreateDomainStmt", "AlterDomainStmt", "opt_as",
  "AlterTSDictionaryStmt", "AlterTSConfigurationStmt", "any_with",
  "CreateConversionStmt", "ClusterStmt", "cluster_index_specification",
  "VacuumStmt", "AnalyzeStmt", "vac_analyze_option_list",
  "analyze_keyword", "vac_analyze_option_elem", "vac_analyze_option_name",
  "vac_analyze_option_arg", "opt_analyze", "opt_verbose", "opt_full",
  "opt_freeze", "opt_name_list", "vacuum_relation", "vacuum_relation_list",
  "opt_vacuum_relation_list", "ExplainStmt", "ExplainableStmt",
  "explain_option_list", "explain_option_elem", "explain_option_name",
  "explain_option_arg", "PrepareStmt", "prep_type_clause",
  "PreparableStmt", "ExecuteStmt", "execute_param_clause",
  "DeallocateStmt", "InsertStmt", "insert_target", "insert_rest",
  "override_kind", "insert_column_list", "insert_column_item",
  "opt_on_conflict", "opt_conf_expr", "returning_clause", "DeleteStmt",
  "using_clause", "LockStmt", "opt_lock", "lock_type", "opt_nowait",
  "opt_nowait_or_skip", "UpdateStmt", "set_clause_list", "set_clause",
  "set_target", "set_target_list", "DeclareCursorStmt", "cursor_name",
  "cursor_options", "opt_hold", "SelectStmt", "select_with_parens",
  "select_no_parens", "select_clause", "simple_select", "with_clause",
  "cte_list", "common_table_expr", "opt_materialized", "opt_with_clause",
  "into_clause", "OptTempTableName", "opt_table", "all_or_distinct",
  "distinct_clause", "opt_all_clause", "opt_sort_clause", "sort_clause",
  "sortby_list", "sortby", "select_limit", "opt_select_limit",
  "limit_clause", "offset_clause", "select_limit_value",
  "select_offset_value", "select_fetch_first_value", "I_or_F_const",
  "row_or_rows", "first_or_next", "group_clause", "group_by_list",
  "group_by_item", "empty_grouping_set", "rollup_clause", "cube_clause",
  "grouping_sets_clause", "having_clause", "for_locking_clause",
  "opt_for_locking_clause", "for_locking_items", "for_locking_item",
  "for_locking_strength", "locked_rels_list", "values_clause",
  "from_clause", "from_list", "table_ref", "joined_table", "alias_clause",
  "opt_alias_clause", "func_alias_clause", "join_type", "join_outer",
  "join_qual", "relation_expr", "relation_expr_list",
  "relation_expr_opt_alias", "tablesample_clause", "opt_repeatable_clause",
  "func_table", "rowsfrom_item", "rowsfrom_list", "opt_col_def_list",
  "opt_ordinality", "where_clause", "where_or_current_clause",
  "OptTableFuncElementList", "TableFuncElementList", "TableFuncElement",
  "xmltable", "xmltable_column_list", "xmltable_column_el",
  "xmltable_column_option_list", "xmltable_column_option_el",
  "xml_namespace_list", "xml_namespace_el", "Typename", "opt_array_bounds",
  "SimpleTypename", "ConstTypename", "GenericType", "opt_type_modifiers",
  "Numeric", "opt_float", "Bit", "ConstBit", "BitWithLength",
  "BitWithoutLength", "Character", "ConstCharacter", "CharacterWithLength",
  "CharacterWithoutLength", "character", "opt_varying", "ConstDatetime",
  "ConstInterval", "opt_timezone", "opt_interval", "interval_second",
  "a_expr", "b_expr", "c_expr", "func_application", "func_expr",
  "func_expr_windowless", "func_expr_common_subexpr", "xml_root_version",
  "opt_xml_root_standalone", "xml_attributes", "xml_attribute_list",
  "xml_attribute_el", "document_or_content", "xml_whitespace_option",
  "xmlexists_argument", "xml_passing_mech", "within_group_clause",
  "filter_clause", "window_clause", "window_definition_list",
  "window_definition", "over_clause", "window_specification",
  "opt_existing_window_name", "opt_partition_clause", "opt_frame_clause",
  "frame_extent", "frame_bound", "opt_window_exclusion_clause", "row",
  "explicit_row", "implicit_row", "sub_type", "all_Op", "MathOp",
  "qual_Op", "qual_all_Op", "subquery_Op", "expr_list", "func_arg_list",
  "func_arg_expr", "type_list", "array_expr", "array_expr_list",
  "extract_list", "extract_arg", "unicode_normal_form", "overlay_list",
  "overlay_placing", "position_list", "substr_list", "substr_from",
  "substr_for", "trim_list", "in_expr", "case_expr", "when_clause_list",
  "when_clause", "case_default", "case_arg", "columnref", "indirection_el",
  "opt_slice_bound", "indirection", "opt_indirection", "opt_asymmetric",
  "opt_target_list", "target_list", "target_el", "qualified_name_list",
  "qualified_name", "name_list", "name", "database_name", "access_method",
  "attr_name", "index_name", "file_name", "func_name", "AexprConst",
  "Iconst", "Sconst", "SignedIconst", "RoleId", "RoleSpec", "role_list",
  "ColId", "type_function_name", "NonReservedWord", "ColLabel",
  "unreserved_keyword", "col_name_keyword", "type_func_name_keyword",
  "reserved_keyword", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,    60,    62,    61,   729,    43,    45,
      42,    47,    37,    94,   730,    91,    93,    40,    41,    46,
      59,    44,    58
};
# endif

#define YYPACT_NINF -4929

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-4929)))

#define YYTABLE_NINF -2671

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-2671)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const int yypact[] =
{
    8129,  1224, 17004, -4929, -4929,  1224, 62730, -4929, 70686,   536,
     717,  1211,   175, 16290, 71154, 79110,   622,   352,  8615,  1224,
   79110,  1407, 53837, 67878,   841, 79110,  1016,   806, 53837, 79110,
    1810, 79578,   989,  1193,   745, 80046, 71622, 66474,  1212, 79110,
    1410,   395, 80514, 72090,  1063, 72558,   806, 50103,   168,  1161,
   80982, 79110,  2141,  1747,  1316, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929,    23, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929,  2032, -4929,  1001,  2131,  1362,   829,  1433, -4929,
   -4929,  1819, 62730, 79110, 79110, 79110,  1562, 79110,  1531, 79110,
     238, 62730, 58518, 73026,  1684,  1559, 46323, 81450, -4929, 62730,
   79110, 56646, 62730, 79110, 79110, 81918, 79110, 82386, 79110,  1417,
   69282, 79110,  1620, 79110, 79110, 57114, 82854,  1825,  1495,   230,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929,  1563,  1668, -4929,   251, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, 79110, 16888,  1016,
    1819, -4929,  2141, 79110,  1832, 79110,  1598, 83322,  1714, 79110,
   -4929, 79110,  1734, 83790,   803,  1635, 58518,  1721, 46797,  1831,
   79110, 79110, 58518, 84258, 84726, 85194, 79110, 79110, -4929, -4929,
    1817, 79110, 79110, -4929,  1939, 58986,  1501,  1950,  2148,  2055,
     812, -4929, 73494, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, 61794,   352, -4929, -4929,  2015, 63198,  2085, -4929, -4929,
   85662,102440,  1871, -4929,   823, 63666, 59454,  2238,  1861, 47271,
    2274, -4929, 64134, -4929, 59922, 64602, -4929, -4929, -4929, -4929,
   -4929, 86130, -4929, 86598,  1984,  2085, -4929,102894, 60390, -4929,
    2133, 87066, 87534, 88002,  1819,  1896,  1243,  2012, 42089, -4929,
   -4929, -4929,   536, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929,   266,  1759,   258,   224,   261, -4929, -4929,   225,   229,
     235,   266,  2387,  2387, -4929, 79110, -4929, -4929,  1759,   724,
    1918,  1918,  1918,  2138,    40, -4929,  1918,  2056, -4929, -4929,
   -4929, -4929, 72558, -4929,  1952, 73962, 79110, 74430,  1016,  1978,
    2371,  2040, -4929, -4929, -4929, -4929, -4929,  2034,  2410,  2410,
   79110, -4929, -4929,  2408,  2027,  2296,  2026, -4929, -4929, -4929,
    2248,  2298,  2266,   129,  1016,   220, -4929,  2405, -4929,  2310,
   28775, 28775,  1016, 74898, 88470,   222, 61794,  1016, 75366,  2122,
     226,  2329, -4929, -4929, -4929,   848, -4929,  2572,  2155,  2415,
    2026,  1495, 43493, -4929,  2159,  1668, 72558, -4929, -4929, -4929,
   60858,  2482, 30695, 79110,  2162, -4929,  2194,  2162,  2182,  2243,
    1362, -4929,  8129, 60858, 79110,  1364,  1364,  2671,  1364,  1592,
    2050, -4929,  2153, -4929,  2583,  2528, 72558,  2258,  1022, -4929,
    1637,  2280,  1767,  2282,  1744,  2319, -4929, -4929,   244, 79110,
     418,  2307, 75834,  7313,  2291,  1668,  2312, -4929, -4929, -4929,
    2467,  1512, -4929, -4929, -4929, -4929,  2614,  2657,  6933,   276,
   76302, -4929, -4929, -4929, -4929, 79110, 79110, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929,  2351,  1314, -4929, -4929,
    2355,  2691,  2568,  8574,   978,  2658,  2523,  1477, 10283,  2586,
    1456,  2714, 11061,  1255,  2725,  1804,  1340, 73962, 79110,  2682,
    2731,  4596,  1488,   792,  2607,  1112,  2658,  2732,  2562,  1477,
    2766,  5615, 79110, -4929,  2694,  2810,   794, -4929,   330, -4929,
   23540, 30695, 49635, -4929,  1668,  2499,  2654,   873,  2696, 62730,
    2466, -4929, -4929, 79110, -4929, -4929,103348,  2553, -4929,   852,
   62730, -4929,  2679,  2526, 47745, 79110, 62730, -4929, -4929, 62730,
   79110, -4929, -4929, -4929, -4929, -4929, -4929, -4929,  2621,  2827,
   79110,103348, -4929,  2779, 79110, 79110, -4929, -4929,  2517, -4929,
   -4929, -4929, -4929,  1918, 79110,  2948,103348,  2754,   155, 79110,
      17,  2981, 79110,  2769,    17,  2587, 88938, -4929, -4929,    17,
   -4929, -4929, -4929, 79110, 79110,  2550,  1391,  2765,  2891,    17,
    2791,  3013,  3023,  2813,  2663,  2819,  2194,  3005,  2800,   874,
     908,   203,  1808,    17,  2656, 89406, 89874, 79110,  2659, 79110,
    2410, 62730, 62730, 62730, 79110,  2943, -4929,  2793, -4929, -4929,
    1448, -4929, -4929, -4929, -4929, -4929,  2957, -4929,   172,  2960,
    2623,  2963,  1607, -4929, -4929,  2676, -4929,  2676,  2676,  2630,
    2630,  2811,  2633,  2985, -4929, -4929, -4929,  2309,  2676,  2630,
   -4929,104256, -4929,   555,  1755, -4929,   243, -4929,  3098, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929,  2651, -4929,  1059,
    1740, -4929, -4929,  2686, -4929,  2988,   291, -4929,  2993, -4929,
    2653, 90342, -4929, 90810, 91278,  2997,   314, -4929, 58518,  2998,
     291,  2999,  2653,  3002,   291,  3004,   855,  3007, -4929,   942,
    2992,  3009,   243,  3011,  1874,  2653, 62262,  3012,   319, -4929,
    3014,   391, -4929,  3015,  2886, -4929, 30695, -4929,  2770, -4929,
    1161, -4929,   -10, -4929, 52899, -4929,  2012,  1759, -4929, 79110,
    1759, 79110,  1759, 79110,  1759, 79110,  1759, 79110, 79110, 79110,
    1759, -4929, -4929, -4929, 79110,  2680, 79110, 79110, -4929, -4929,
   -4929, 68346, 58518, 68814, -4929, 79110, -4929,   416,  1016, -4929,
   -4929, -4929,  1384, -4929,  2026, -4929,103348,  3129, 58518,  2410,
   -4929,  1623, -4929, -4929, 79110, 79110, -4929, -4929, -4929,  2944,
   79110,  3008,  3010, 68346, 58518, -4929, 91746, -4929, 61794,  2895,
    2685, -4929, -4929, -4929, -4929, -4929,  1806,  3169,   217,  3171,
   30695,  2692,   217,   217,  2693,  3017, -4929, -4929, -4929,   259,
    2697,  2700, -4929,   231,   231, -4929,  2701,  2703, -4929,   241,
    2705,  2707,  3175,  3177,   254,  2708,  2709,  2710,  2309,   217,
    2711, 30695, -4929,  2712,   231,  2715,  2718,  2719,  3195,  2720,
   -4929,  3202,  2723,   320,   326,  2726,  2727, -4929,  2701, -4929,
     265,  2729,  2733,  2734,  2736,  2739,  2741,  2743,  2744, 30695,
   30695, 30695, -4929, 27330,  1668,  1016, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929,   270,  4694, -4929,  2761, -4929, -4929,
    2929, -4929, -4929, 30695, -4929, -4929,   123, -4929,   277, -4929,
   -4929, -4929,  1668,  3022,  2746, -4929, -4929,   328,  2748, -4929,
    1826, -4929, -4929, -4929, -4929, -4929, -4929, 61326,  3197, -4929,
     349,  1016,   330,  1510,  3138, 51961, 52430, -4929, -4929,  3016,
   -4929, 79110, -4929, -4929,  1668,   149,  1788, -4929, -4929, 52899,
   -4929, -4929,   536, 15719,  1845,  2162, 79110, 79110,  3201, -4929,
   -4929, -4929,  1876, -4929,  2752, -4929,  2194, -4929, -4929,  1362,
    1362, 30695,  1362,   271,  1051, 29255, 31175,  3085,  2973,  1487,
    1378,  3088, -4929,  2977,  1592,  2050, 72558, 79110, 92214,  2885,
   30695, -4929,  3188,  2847,  2849,  2904, 51039, -4929,  2851,  2818,
    2854,  2911, 54774,  2777,  2863,  2864,  2919, -4929,  3046, -4929,
   -4929,  2868,  2939,  2874, 92682, -4929, -4929,  1159, -4929, -4929,
   -4929,  1159, -4929,  2803,  1491,  1080,   977,  2875,   252,   862,
    3205, -4929,  1381, -4929, -4929,  2934, -4929,  6513, 79110,  3140,
    7782,  3019,   276,  2937, -4929, -4929, -4929,  3077,  2898, 79110,
    2899,  3039,   276,   323, 93150, -4929, -4929, 79110, -4929, -4929,
   -4929, -4929,  4994,  3186, 26422, -4929,  1914,  2902,  2881,  2914,
   79110, 65538,   398,  3018,  3035,  1533,  2033,   840,  2965, 79110,
     304,  3042, 79110,  2831,  2910,  2913,  3139,  2836,  1439,  3238,
    2834, -4929, -4929, -4929,  3207, -4929,   471,  1222,  3033, -4929,
    3141,  3184,  8318,  2906,  2915,101078, -4929,  2926,    54, 48219,
   79110, 79110,  2941,  2947, 93618,  4994,  3225,  2949,  2955,  2951,
    2952,    43,  3247,  1503,  2959, -4929, -4929, -4929,  1503,  2961,
    2964, 94086,  4994,  3234, 79110,  2971,  2972, 79110,104256,   276,
   -4929,  3307,   276,   276,  1877,  3309,  2974,   346,  3119,  2163,
      17,  2834,  3222, -4929,  2976,  2978,   335, -4929,  3106, 79110,
    2984,  2986,  1599,  1016, -4929, -4929,  2987,  3052,  2989,   924,
   -4929, -4929,  2994, 72558,  3097,  3099,   304,   253,  2197,  2834,
   -4929,  2991,  3003,  2836,  2836, 79110, 79110, 79110, 79110, 79110,
     355,  3355,  3361,  3006,   364,   725,  2918, -4929,  1503, 57582,
    3020, -4929,  1503, 79110,   429,  2203,  2834,  1621,  1840, -4929,
   -4929, -4929,  1495, -4929, 30695, 30695, 30695,  2923, -4929,  2423,
   15719,   101, -4929,   292,  6667,  2920, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, 79110, -4929, 79110, -4929,  3194,103348,  3136,  3204,
   -4929,  2966, -4929,  3209,   276, -4929, 79110, 79110,  3210,  3145,
    3214,  3219,  3154,  1179,103348,  3156,  3223, -4929,  3224,  3227,
    3030,   181,  3024,  2953,  3406,  3296, 79110, 54774, -4929,  3420,
    1159, -4929,103348,  3170,  3299, -4929, 79110,  3187,    78, -4929,
    3335,  3021, -4929, -4929,   103, 79110,   214,  3001, -4929, -4929,
    3310, 58518,   356,  3312,  1016,  3025,  3313,  3179,  1016, 58518,
    3221, 79110, 79110, 79110, 79110, -4929, -4929,  3189,   808,   280,
   -4929, 57582,  3206, -4929, 79110,  3208,  3222,  3211,  3427,    86,
    1918, 94554,  3304, 95022,  2983,  2990,  2990,  3431,103348,  3255,
   -4929,  1894, -4929,  3121, -4929, 62730, -4929, -4929, 62730, -4929,
   -4929,103348, 79110,  2995, -4929,  2996, -4929, -4929, 30695, -4929,
   -4929, -4929,  2387, -4929,103348,  2676,  2676, -4929, -4929,  3442,
    3074,  3080,  2387, -4929,  2387, -4929,103348, -4929,  3032,  3036,
    2387,  3073,  3079,  3081, -4929,  3000,  3087,  2387, -4929, -4929,
    2073, -4929, -4929, 62730, 62730, -4929, 58518, 58518,  3347,   319,
    3348,  3069,  3350,  3071, 48219, 48219, -4929,   442, 62730, -4929,
   58518, 62730, -4929, 79110, -4929, 79110, -4929, -4929, -4929, -4929,
  103348,103348, -4929, 58518, 57582,  3356,  3357,   855, 79110, 79110,
   -4929, 79110, 79110, -4929, 79110, 79110,  1899, 95490,  2012, 60858,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, 79110, -4929,
   79110, -4929, 79110, -4929, 79110, -4929, 79110, -4929, -4929, -4929,
   79110, -4929, 79110,  1905, -4929, -4929,  1923,  1522, 79110, 79110,
     843, 62730, 79110,  3231, 62730, 62730, 79110, 79110, 79110, 79110,
   79110,  3100,  2748,  1385, -4929,   290,   810, 72558,  3242, -4929,
   -4929,  1960,  2141,  1025, 79110,  1095,  2034, -4929, -4929, -4929,
   -4929, 68814, 67878,  3352,   144, 79110, -4929, -4929,  6739, 30695,
    1668, 28290, -4929, -4929, 15719,  3076, 30695, 30695,  3026,  2387,
    2387, -4929,   959, 30695, 30695, 30695,  2387,  2387, 30695, 10215,
   30695, 48219, 30695, 35975, 24512, 30695, 30695, 27810, -4929, 30695,
    3272, 37409, 30695,  1510,  3275, 30695,  1510, 10215,  3515,  3515,
    2189,  7151,  3038,  1668, -4929,  2387,  1014, -4929,   299,103348,
   30695, 30695, 30695, 30695, 54774,  3135,   281, 79110, 30695,  3054,
    2830, -4929, 30695, -4929,  3055, 30695,  3147,   920, 30695, 30695,
   30695, 30695, 30695, 30695, 30695, 30695, 30695, -4929, 38813,   337,
    3370,  3390,    55,   574, 76770, 28775,  3382, 23540, -4929,   242,
    3382, -4929, -4929, -4929, 79110,  3197, -4929, -4929,  3149, -4929,
   -4929, -4929, -4929, -4929,   293, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929,  3065, -4929, -4929, -4929, -4929,  3065, -4929,  3082,
    3381,  3384,   855, 79110, 60858, -4929, -4929, -4929,  2470, -4929,
   30695, -4929,  1966,  1891, 79110, 79110, -4929,  3360, -4929,  3084,
   -4929, 12460,  3360, -4929, -4929, 36452,  3196,  3362,  3294, -4929,
   -4929, -4929,  3086, 15719, 31655, 31655, -4929,  2110, 15719,  2223,
   -4929, -4929, -4929, -4929, -4929, -4929,  1302, -4929, 79110,   167,
    3085,  1378,  3148,   944,  3539, 79110, -4929, 43961,  1970, -4929,
   58518, 79110, 79110,  3293, -4929,  3526, -4929,104256, -4929,  3095,
   -4929,103802, 99702, -4929, -4929,    95, -4929,   799, 58518, -4929,
   79110, 79110, -4929, 54774, 58518, 79110, 79110, -4929, 58518, 79110,
   79110, -4929, -4929, -4929, -4929, -4929, 53368,  1061, 67878,  3239,
   66942, -4929, -4929,  3109, 79110,  3153,  3371,  3377,    26, -4929,
   -4929, 95958, -4929,  3332, 58518, 79110, 79110, 30695,  3336, 79110,
   79110, -4929,   565,  3198,  3199, -4929, 79110,  3200,  3374, 62730,
    3116, 79110, 79110,103348,  3213,   853, 62730,  3190, 48693, 62730,
   62730, 79110, 79110, 79110, 79110,  3256,  3452,103348, 79110,  3400,
    1162, 72558,   445,  2350,  2834,  3363, -4929,  1292, -4929, 58518,
   -4929, 79110,  3354, -4929, -4929, -4929, 77238,  3589,  3260, -4929,
   -4929, -4929, 96426, -4929, -4929,  3358, -4929,  1989, -4929, 58518,
   58518, 79110,  8818, 96894,   598,  3375, -4929, -4929,103348, -4929,
   79110, 77706, 79110, 79110,  3411, 79110, 69750, 97362, 97830,   636,
    1539,  3414, 79110, 70218,  3415, -4929,  3295, 79110, -4929, -4929,
   55242, 58518, 79110,   216, 54774, -4929, -4929, 79110, -4929,   321,
   -4929, 79110,  3067,  3364, -4929, -4929,  3236,  3248, 79110,   450,
    2381,  2834,  3523, 79110, 79110,  3159,  1993, 58518, 79110, 54774,
   -4929,  3369,  1122, 58518, 79110, 77238, -4929,  3379, 72558, 72558,
   58518, 79110, 72558, -4929, 79110, 88470, -4929, 58518,   926, -4929,
   58518, 79110, 77238, -4929,  3383,  3320, 58518, 79110, 13753, -4929,
   -4929, -4929,   276, -4929, -4929, -4929, -4929, -4929, 79110, 79110,
     276, 79110, 79110,   276,  1261, -4929, 58518, 79110, -4929, -4929,
   -4929,  3289, 58518, 79110, 79110,   266, -4929, 58518,  3001, 79110,
   54774, -4929, 79110,  5911, 79110, 79110, 79110, 79110, 79110, 79110,
   58518, 79110, -4929, -4929,  1253,  1200,  1602,  1609,  1419, 79110,
    3475, 79110, 98298, 58518, 79110, 79110,  1016, 79110, 54774,  1601,
   -4929, -4929,  3297, -4929, 58518,   926, -4929,  8939, 79110, 79110,
   79110,  3257,  3258,   247,  3341, -4929, -4929, -4929,   644,   644,
    3385, -4929, 30695, 30695, 29735,  3183, -4929, -4929, 30695, -4929,
   -4929, -4929,   340,  3626, 98766,   340, -4929,   340,  3455,  3241,
    3243,   340, 79110,   340,   340, 79110, -4929, -4929, -4929, -4929,
    3457, 79110,   340,   340,   340,  3359, -4929, -4929,  3359,   721,
   30695,103348, 79110, -4929,  1999, -4929,  3203,   808, -4929, -4929,
   54774, 79110,   260,   872,  3529,  3405, 66006,  2578,  3519, 79110,
    3240, 79110,  3644,  3286, 72558,  2550, -4929,  2578, 79110, -4929,
    2106, 67878, -4929, -4929, -4929, -4929, -4929, -4929, -4929, 79110,
   -4929, -4929,  3528, 79110, 30695,  3376, -4929,  1016,  2550,  2550,
    2550,  2550, -4929, -4929, -4929, -4929,  3416,  1988, -4929,  3212,
    2550, 79110,  3330,  3548,  2578,  3215,  3550, -4929,  3222,  3552,
    1251, 79110,  3424, 66006,  3270,  3253,  3441,  3668,  1918,  1016,
    3443,  3433, -4929, 51500, -4929,  2550, 26876,  6577,  7426,  3434,
    3495, 61794,  3533,  3534,  3556, -4929,   172, -4929,  3681,  1607,
    3557, 30695,  2000,  3232,   243, -4929, -4929,  3237,  3036,  3251,
    3259,  3235,  3245, -4929,  2387,   211,  3249,  1373,   178,  3368,
    2387,  3480,  3250, -4929,   291, -4929,  2653, -4929, 79110, -4929,
   79110, 79110, 79110, 79110,   314, -4929, -4929,   291,  2653,   291,
     855, -4929,  3509,   243,  2653,  3365,  3570, 61794, -4929,   319,
   -4929,   391, -4929,  3462,   855, -4929,  3472,  1918, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929,  2021, -4929, 79110, -4929,
    3551,  3553,  3558,  3559,  3560,  3262,  3264,  3288, 79110,  3265,
    3262,   276,  3265,  3265,  3262,  2748,  2748,  3262,  3264, 58050,
    3721,  3574, -4929,  3351,  3274,  3591,   198, -4929,   210,    88,
    3514, -4929, -4929, -4929, -4929,103348, -4929, 58518,  3314,  2410,
    2410, -4929,   174,  3484,  3276, 58050,  3708,   855, -4929, 62730,
   -4929, -4929,103348,  3366,  3378, 62730,  3494,  3326, 62730, -4929,
   -4929, 62730, -4929, -4929, -4929, -4929, -4929,103348, -4929,  3554,
   79110, 79110,  2023, -4929, -4929,  1551, -4929,  1789, 30695,   446,
   -4929, 13828,  2031, 30695,  3282,  3283, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929,  3287,  3608, -4929,  2036,  2043,  2051,  3291,
    3292,  4831,  5540,  3298, 13910,  3300,  3290, 35975, 35975, 27330,
    1089, -4929, 35975,  3301,  3491,  2061, 12440,  3302,  3303, 14217,
   30215, 30695, 30215, 30215, 14139,  3302,  3306,  2067, 54774,  3485,
   14589,  2092, -4929, 30695, 54774,  5716, 30695, -4929, 30695,  3308,
   -4929, -4929,  6216,  6216,  6216, 10215, -4929,  3315, -4929, 35975,
   35975, -4929,  2894, 27330, -4929, -4929,  3617, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929,  3028, -4929,  3305, -4929, -4929,  3525,
    3575, 48219,  7541, 30695,   302, 30695,  3054, 30695,  3392,  6216,
    6216,  6216,   307,   307,   249,   249,   249,  1898,   574, -4929,
   -4929, -4929,  3316,  3321,  3322,  3501,  3323, 30695, -4929,  2185,
    2232, 79110,  2940,  3061,  3639, -4929, -4929, -4929, 39749,  3373,
     101,  3373, -4929,  1495,  2387,  1014, 52899, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, 79110, 15719, -4929, -4929,  3561,  3325,
   -4929, -4929, 30695, -4929, -4929,  1102,  3343,    87,   946,  1802,
    1802,  2110,  1064, -4929, -4929,  3393, -4929, 30695,  2315, -4929,
    2337, -4929, -4929, -4929, -4929,  2748, -4929,  3577, -4929, -4929,
   -4929, 39749,  3380,  3386,    67, 43025,  3543, -4929, 79110, -4929,
   79110,   379, -4929,  3349, -4929, -4929, -4929, -4929, -4929, -4929,
   99702,  1740, -4929,103802, -4929,103802, -4929,  1740,  3742, -4929,
   99702,  1828, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, 58518, 58518,  3546, 79110,  3545,
    3555, 30695,  1136, 79110,  3344,  3345,  1107,  3634, 79110, -4929,
    3682,   855, -4929, -4929,  3428, -4929, 15719, -4929, -4929, -4929,
   -4929, -4929, 58518, 79110, -4929, 61794, -4929, 79110, -4929,103348,
   -4929, -4929, -4929, 79110,  3387, 79110, -4929, 79110, 79110, 79110,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929,  1190,103348, -4929,
   -4929, 79110, 79110,   159,  3429,  3430, 79110, -4929,   800,  3106,
    9286, 79110, 79110, 79110,  3636, -4929, -4929, -4929, -4929,  3572,
   -4929,  3692, -4929, 99702, -4929,  2653,   668,  3437,  2834,  3582,
   -4929,  3700,  3567, -4929,  3486,  1113, -4929, -4929,  3492, -4929,
   -4929, -4929, -4929,  3705,   855,  3706,   855, 79110, 79110, 79110,
   79110,  3502, -4929, -4929, -4929, -4929,  3503,  3633, -4929, 54774,
   54774, 54774,  2116, -4929, -4929,  1016, -4929, -4929, -4929, -4929,
   -4929, -4929,  3669, -4929,  2118, -4929,    -4, -4929, -4929, -4929,
   -4929, -4929,  3711, 58518, 79110,  9597, 79110, 79110, 79110,  3586,
    1818, -4929,  1175,103348, -4929,101532, -4929, -4929,  2120, -4929,
    3389, 79110,  3459, 58518,  3438, -4929, -4929, -4929,  3717,  3388,
    3388, -4929, -4929,  3388, -4929, -4929, -4929,  3642,  3571, -4929,
     903,  3573, 58518,  3444, -4929, -4929, -4929, -4929,  3723,  3468,
   -4929, -4929,  3469,  2389,  2834,  3222, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929,  3496, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929,  1395, -4929, -4929,  1083,   433,  2438,  2834,
   -4929,   345, -4929,  3470, -4929,  3473, -4929, -4929, -4929,  3646,
    3647,  3652,  3487,  3493,  3538,  3497,  3505,  3540, -4929,  3506,
    3565,  3512,  3568,  3517,  3760,   855,103348,  3629,  1016,  3532,
    3761,   855, -4929,  3518, -4929,  3520, -4929,  2150,  3864, -4929,
   79110, -4929,   457,  2472,  2834, -4929,  3521, -4929, 58518, 79110,
   -4929, -4929, -4929, 30695,  3446,  3447,  3448, 15719, 15719, 30695,
   -4929, -4929, 15719,  3436, -4929, -4929, -4929,103348, 79110,  3718,
   -4929, -4929,   340, 79110, 79110, -4929,  3720, -4929, -4929,  3725,
   79110,  3726, -4929, -4929, -4929, -4929,   485,   485, -4929, -4929,
    3751,  7457,  3451,   296, -4929, 54774, 45368,  2030,  3075,   460,
      17, -4929, 61794, 79110, 61794, -4929,   872,  3567, 79110, 79110,
   79110,  3454,  3449, -4929, -4929, -4929, -4929, 58518,  1137, 58518,
    2387, -4929, -4929,  3527, -4929, 79110,  1918,  3940,  3786, -4929,
    3388, -4929,  3903,  3023,   356,  3614,  1680,  2663,  3843,  2194,
     396, 54774,  3253, -4929, -4929, -4929, -4929, 79110, 79110,   808,
    1016, -4929,  3463,  3461, -4929, 79110,  3792, 79110, 79110, 79110,
   79110,  3314,  3471, 79110,  3474,103348, 79110,  2088,  2836,  3919,
    3809,  2141,  3270,  3564,  3811, 72558,  3490,  2152, -4929, -4929,
   -4929,  2157,   150, -4929,  1016, 61794,100624,  3799, -4929,  7426,
   -4929, -4929,  7426,  1015, 79110,  3783, -4929, -4929,  2141, -4929,
  103348,  3476, -4929,  2166, -4929,  2188, -4929, -4929, -4929,  2387,
   -4929, -4929,  1576,  1576,  3481, -4929,  3489, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929,  3488, -4929, -4929, -4929,   319,  3541,
     855,  3562,   855, -4929, -4929, -4929, -4929, 79110, -4929, 79110,
   57582,   855, -4929, -4929, 79110, -4929,  3829, -4929, -4929,  3627,
    3628,  3630,  3631,  3638, 79110,  3262, -4929,  3498, 58518,  1396,
   -4929, -4929,  3715, -4929, -4929, 72558,  3635, -4929, -4929, -4929,
   -4929,  3846,  3851, -4929, -4929, -4929,   289, -4929, 79110, 79110,
   58518, 68346,   490, 58518, -4929,  3787,  3788, -4929, -4929,  3789,
     276, -4929,  3790,  3791,  3793, -4929,  3794,  3795, -4929, -4929,
   -4929,  3524, 15114, 30695, -4929,  3869,103348, -4929,  8256, -4929,
   -4929, -4929, 30695, -4929, -4929, -4929, -4929, -4929, -4929,  2174,
   30695, -4929, 30695,  3847, -4929, 24998,  3999,  3999,  3530,103348,
   35975, 35975, 35975, 35975,  1538,  2715, 35975, 35975, 35975, 35975,
   35975, 35975, 35975, 35975, 35975, 36932,   675, -4929,  3727, 30695,
   30695,  3861,  3847, -4929,103348,  3535,  3302,  3536,  3547, 30695,
   -4929, -4929,  2200, 37877,  3576, 54774, -4929, 30695, 13206,  2204,
    3594, 15244,  1668,  8555,  1016, 30695,  2339,  2649, 30695,  2206,
   30695,  3867, -4929, -4929, -4929, -4929,  3578, -4929, -4929,  3775,
  103348, -4929, 30695,  3579,  3977, 35975, 35975,  4102, -4929,  4331,
   30695, 27330, -4929,  3385,  3592, 44429, -4929, 25484,  3580,   806,
     806,   806,   806, -4929, 79110, 79110, 79110, 40217,  3872,  3583,
   39281, 78174,  3584,  2010, -4929, 78174, 78642, 78174, -4929,  3569,
   -4929,  1668, 30695,  3865,  3581,  3865,   330,  3585, -4929, -4929,
   -4929, -4929,  2141, -4929,  3587, -4929,  3343,  1330, -4929, -4929,
   -4929,  1082, -4929,  3637, -4929, -4929, -4929,  3584, 32135,  3703,
   -4929, -4929, -4929,  3609,  2214, -4929, -4929,  3960,  3703, -4929,
   -4929,  2216, 43961,  3380, 30695,  1668,  2222,  1895, -4929, -4929,
   99702, -4929,  3632,  2653,  2653,  1520,  3262,  3886,  1520,  8651,
   -4929, -4929, 40685, 79110, 79110, -4929, 79110,  2224,  1476, 79110,
   -4929, 79110, -4929, -4929, -4929, -4929,  4011, -4929, 79110, -4929,
   -4929,  3621,  3645, 79110, 79110, 79110, 79110,  3841, -4929, -4929,
    2282, -4929, -4929, 58518, 79110, -4929, -4929, -4929,   474,  2622,
    2834, -4929,  3654, -4929, -4929,  3875, 79110, -4929,  4008,  3680,
   79110,  3918, 79110,  3593, -4929,  1476,  3697,  3911,  1823,  2836,
     346,  5686, -4929,  1354, -4929, -4929,  3665, -4929, 79110, -4929,
   79110, -4929, -4929, -4929, -4929, -4929, -4929, -4929,  3732, -4929,
   -4929, -4929, -4929, 55242, -4929, -4929, 79110, -4929, 54774, 45368,
   54774, 79110, -4929,  1174,   476,  2724,  2834, -4929,  3676, -4929,
    3934,  3687,  3688,  3743,   199,   263,  3690,  3691,  3746,  3612,
    3613,  3615, -4929, 54774, 45849,  3771, 79110,  2653,  3619,  3657,
   79110,   266,  1016, -4929, -4929,  1016,  2653,  1016, 79110, 79110,
   79110, 79110,   266, 54774, -4929,  4054,  3712, 79110, 79110, 79110,
   79110, -4929,  3674, -4929, 79110, 79110,  3955,   931,  2007, 58518,
   79110, 79110, 58518, 79110, 79110, 79110, 79110, 79110, 79110, 79110,
    3844, -4929,  4045,  3978,  2139,  4023,  3716, 79110, -4929, 79110,
    1016, -4929,  3106, 79110, 79110, 79110, 79110, -4929, -4929, -4929,
   -4929, -4929,  3385, -4929,  3648,  3920,   340, -4929,  3925,  3926,
     340,   340,  3930,   340, -4929, -4929,    17, -4929,   171, 79110,
   -4929,  2171, 79110, -4929, -4929, -4929,  3587,   471,  1222, -4929,
   -4929, -4929, -4929, -4929, -4929, 79110,  3656, 79110, 79110, 35975,
   -4929,   437,  1260,   286, -4929,  3936, 79110,  3001, -4929, -4929,
   -4929,   935, 79110, -4929, -4929, -4929, -4929, -4929,    82,  3471,
   -4929,  3959, 66006,  2653, 58518, 58518,  2653, -4929,103348,  3672,
    3253, -4929,   256,  3753, 58518,   356,  1360, 99234,  3025,  3709,
    3890, 39749,  1395, -4929,  3673,  3842, -4929,  3683,  3686, -4929,
   -4929, 79110,  3567, 57582,  2230,  3222,  4135,    89,  1896, -4929,
   67410,  3880,  3471,  3959, -4929,  2836,  3897,  3901, -4929,  2141,
   79110,  3314,  3253,  1016, 79110,  3153, 45368, -4929,  4177, -4929,
   99702, 30695, 30695, -4929,  3693, -4929,  3694,  7426, -4929,  3765,
    3695, -4929, -4929, -4929, -4929, -4929,  3776,  3698, 79110, -4929,
    3699,  3557, -4929,  3557, -4929,  3702, -4929, -4929, -4929, -4929,
   -4929, -4929, 79110, -4929, 79110, -4929,   855, -4929,  3826, -4929,
     855, 79110, 79110, 79110, 79110, 79110, 79110,  3262,   276, -4929,
    4019, 58050, -4929, -4929,  2255, 79110, -4929, -4929, -4929,  4085,
   -4929, -4929,   144,  4027, -4929, -4929,   905,   905,   905,  3983,
     905,   905,   905,   905,   905, -4929, 30695, 15719, -4929,  3710,
   -4929, 15719,  3713,  9034, 15719,  3861, -4929,  2262, 30695, -4929,
    1424,  1424,  1424,  5281,  4030, -4929,   998,  3719,  1424,  1424,
    1424,   417,   417,   267,   267,   267,  3999,   675, 15719, 15719,
   -4929, -4929,  3714, -4929, -4929, -4929,  3302, -4929, 32615,   658,
    4142, 37409, -4929, -4929, -4929,  3752,  3757,  3722, -4929, 30695,
   33095,  3724,104256,  3917, -4929,  1773, 30695, 30695,  3549, -4929,
   11358, 30695,103348, -4929,  2263,  3549,   468, 30695,  4074,  5137,
   30695, 30695,  5201,  9130,  3730, 30695,100156, -4929, -4929, -4929,
    2267, 30695, 79110, 79110, 79110, 79110, -4929, -4929, -4929, 78174,
   78642, 78174,  3733, 38345, 25953,  2010,  3731, 79110, -4929, -4929,
    3734, 39749,  3994,  3923, -4929, 39749,  3923,  1262,  3923,  3997,
    3816, 44897, -4929, -4929,  3735, -4929,  3929, -4929,  1914, 15719,
    4170,  4048,  1016,  4048,  1016,  3741, 48219, -4929, -4929, -4929,
   -4929,  3827, -4929,  3957, 15719, 28775, -4929,  2141,  1435, 79110,
    1668,   104, -4929,  3756, 79110, -4929,  3703, 15719, -4929,  3817,
    2271, -4929, -4929, -4929, -4929, -4929, -4929, -4929,  3828, 67878,
    4067, -4929, 30695,  2272, -4929,  3798,  4162,   156,  2284,  2285,
    1476, -4929,  4046, -4929,  1537,  4043,   462, -4929,   855, -4929,
  103348, -4929, 79110, 79110, -4929, -4929, -4929, -4929, 79110,  2777,
   -4929, -4929, 79110, 79110, 79110, 79110, -4929, -4929, 58518, 79110,
   -4929, 79110, -4929, 54774,  3075,   266,   437,  4056,  4057,  3974,
   -4929,   276, -4929,   437,  3976,   266, 79110, -4929, -4929,  2664,
   -4929,103348,   855,   855, -4929, -4929, -4929, -4929, -4929,  3769,
   -4929,  4194,  3852, 79110, 79110, 79110, 79110, 79110, 58518, 79110,
   79110,  2387,  2387,103348,  3764, -4929,  2387,  2387,  3767, -4929,
   58518, 79110, 79110, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929,  3845, -4929, 30695,  4183, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   58518, 79110,  3849, -4929,  3855, -4929,   781, -4929, -4929, 79110,
   79110, 79110, 79110,  4111, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929,  4115, 79110, -4929, -4929,  1016,
    1016,103348,   855,   855, -4929, -4929, -4929,  3860, -4929, -4929,
    3781,  4058,   340, -4929,   340,   340, -4929, -4929,   340, -4929,
    3784, -4929,    17,  4151, -4929,  1476,  1425,  4105, -4929,  4108,
   30695, -4929,  1046,  5281, -4929,  4161,  4239, -4929, -4929, -4929,
   -4929,  3001,  1918,  3848, -4929, -4929, 62730,  1427, -4929,  4087,
     260,  4005, 66006,   345,   324,  3796,  3921, -4929,  2653,  2653,
    3854, 79110,  4245, -4929, -4929, -4929, -4929, -4929, -4929, 58518,
    3438, -4929,  4025,   811,  4127, 79110, 30695,  3584, -4929,  1777,
    4132, -4929,  1016, -4929, -4929,  3931,  3253, -4929,  1460, 79110,
    4024, 66006,  3314,  2297, -4929, -4929, -4929,  3850,  4241,  3270,
   -4929,   345,  3880, -4929, -4929,  4218,  3904,  3856,  4268, -4929,
    3904,  4143,  4033,  3825, -4929,  3490, -4929, -4929, 15719, 15719,
    1016,104710,  7426,103348,  4153, 79110,   754,  4116,   855,  2301,
   -4929, -4929,   855,   855, -4929, 79110, -4929,  3262,  3262,  3262,
    3262,  3262, -4929,  4036, -4929, -4929,  4109, -4929,   855, 58050,
   -4929, -4929, -4929, -4929, -4929,   905, -4929, -4929, -4929, -4929,
   -4929, 15719, -4929, -4929, -4929, -4929, -4929,  9196, 35975,  4152,
   -4929,  3834,103348, -4929,  3835,  2302,  2318, -4929, -4929,   658,
   -4929,  4142, -4929, -4929, -4929,  9734,  3889, 15719,  3947,  3839,
    3840,  3549,  3549, 11358,  2338, -4929,  3549, 30695, 30695,  3549,
    3549, 30695, -4929, -4929, 10036,  4035, -4929, -4929, 10069, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, 55710,  3853,  3485, 78174,
    3858, 79110,  2010, 39749, -4929, -4929,  2048, -4929, 39749,  4120,
   -4929, 39749, 62730, -4929, 79110,  3859, 79110, -4929, 33575, 30695,
    3882, -4929,  3882, -4929, -4929,  3862, -4929, 79110,  2746, -4929,
      67, -4929, -4929,  4250, 40685,  4208, 30695, -4929, -4929, -4929,
   -4929, 58050,  4060, 58050,  1476, 10116,  4046, 40685, 49167, 79110,
   -4929, 79110, -4929,  4012,  4046,  3866,  3001, -4929, -4929, -4929,
   -4929, -4929, -4929,  3863, -4929, -4929, -4929, -4929,  3935, -4929,
   -4929,   947,  3242, -4929,  2340, -4929, -4929,  4306,  4199,  4201,
   -4929, -4929, -4929, -4929, -4929, -4929,  4045, -4929, -4929, 45368,
   58518, 79110, -4929,  3945, -4929, -4929, -4929, -4929, -4929, -4929,
   42557, 48219, -4929,   199,  3870,  3871,   263, -4929, -4929, -4929,
   79110, 10349,  3873,   963,  3242, 79110, 79110,  3874,  3876,  3877,
    1797,  1350,  1782,  3262,  4195, 79110, -4929, -4929, -4929,  4045,
   -4929, -4929, 79110, -4929,   340, -4929, -4929, -4929, -4929, 54774,
   -4929,  2747,  3784,  1016, 62730,  4322,  4322, 79110, -4929, 10455,
    4094, -4929, -4929,   135,  3848,  4126,  4172, -4929,  3881, 79110,
     935,  3884, 79110,  3879,  4006,   282,   282, 79110, 79110, 79110,
    2344,  2141,  2653,  3657,   356,  4224, 66006,  4267,  3567,   400,
   -4929, -4929,  1777, -4929,   614,  4242,  3932, -4929, 79110,  4338,
   79110,  3314,  3471, 79110,  3891, -4929, -4929, 67410,  4095,  3075,
   79110,  2088,  3880,  3270,  1235, 79110, -4929,   332, -4929,  2141,
   -4929, 79110, 72558, 40685, -4929,103802, -4929,  2352, -4929, -4929,
    3964,  3373,  4007,  4009,  3895, 79110,   886, -4929, -4929, -4929,
   -4929, -4929, -4929, 79110, -4929,   490, -4929, -4929,  5358, 35975,
  103348,  2362, 30695, -4929, 30695, -4929, -4929, -4929, -4929,   790,
   -4929, -4929, -4929,  3549,  3549,  3549, -4929,  4332,  3385, -4929,
   -4929,  2367,  4351, 35015,  4312, -4929, 79110,  2378, -4929, 30695,
    3905, -4929, -4929, 39749,  2048,  3906,  2386, 79110,  2392,103348,
    3907,    49,  3908, 24026,  3899, -4929, -4929, -4929, -4929, -4929,
   15719, 15719, 79110, -4929, -4929, -4929, -4929,  3961, 79110,  2398,
   -4929,   672, 15719,  1396,  1520,   490,  4162,  3001, -4929,  3909,
   -4929, -4929,  2836,   401, 79110,  3001, 79110,  3848, -4929, 79110,
    3993, -4929, -4929, 54774,  4215, -4929, -4929,  3968, -4929,  1033,
    3242, 79110,103348, -4929,   117,  4240, -4929,103348,103348, -4929,
   -4929, -4929, 30695,  4002, -4929, -4929, -4929, 30695, 30695, 65070,
   -4929, -4929, 79110, 79110, 79110, 79110, 79110, -4929,   855, -4929,
   -4929,  2406, -4929, 41621, -4929, -4929,  2981,  1016,  2981,  1469,
   -4929, -4929,  2981,  2981, -4929,  3373, -4929,  4322,   369, -4929,
   -4929, -4929,  1974,  4144,  3915, 30695, -4929,  1139,  4129,  4010,
    3922, -4929, 62730,  4403,  3471,  3959, 79110, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,  2422,  3567,
    4256,  3253,  3856, -4929, 79110,  3958, -4929, 39749, -4929, -4929,
   -4929,  2981, -4929,  1482,  3927,  4269,  3567,  2141,  1896, -4929,
    3880,  3471,  3959, -4929, -4929,  3928,  3901,  3270,  2088,  4068,
   -4929,  4069, -4929,  4349,  4141,  4355,  3314, -4929,  3153,  2427,
   -4929,  7426,104710,103348,  4295,  3975,  3979, -4929, -4929,  3992,
   79110, -4929, -4929,  3567, -4929,  5358,  2428, -4929,  2440,  2446,
    3995, -4929, 30695,   209,  3569, 55710,  3941, -4929, 35975,  2457,
   -4929,  5187, 79110,  2458, -4929, 15719, 79110, -4929, -4929, 30695,
   -4929,  2459, -4929, 30695,  3943, 30695, -4929, 33575,  3942, -4929,
    4395,  2141, -4929,  3373, 40685, -4929,  4071, -4929,  4272, -4929,
   -4929,  3848, 48219,   401,  3343,  1918,  3848,  2464, -4929, -4929,
   79110, -4929,  3915, 30695, -4929,  4041, -4929, -4929,  2479,  1449,
    4110,  4110,  2485,  2490, 10690, 79110,  2498,  2502, -4929,  2507,
    2387,  3264,  1782,  3264, -4929,  3262, -4929, -4929, 54774, -4929,
   56178, -4929, -4929, -4929,  1016, -4929,  1016,  4173, 79110, 50571,
    1016,  1016, -4929, -4929, -4929, -4929,  4308,  4244, -4929,  3222,
   -4929, 10992, -4929, -4929, -4929,   389, -4929,  4165,  4166, 79110,
   -4929,  3962, -4929,  2513,   345,  4082,  3567, -4929, -4929, 79110,
    4409,  4410, -4929,   831, 79110,  3584, 79110, -4929, -4929, -4929,
   30695,   935, -4929,  3856,  3314,  3270,   345,  3880,  3075, 41153,
    3904,  2088,  3901, -4929, -4929,  4171, -4929,  4180, -4929,  3966,
    4260,  7426, -4929, -4929,  1140,  4286,  4294, -4929, -4929, -4929,
   -4929, -4929, -4929, -4929,  3302, 34055, 34055, 34055,  3980, -4929,
   -4929, 79110,  5281,  3973, 35015, 54774,  2515, -4929,101986, -4929,
    2521,  2522, -4929,  2537, 33575,  2538, -4929, 79110,  3982, -4929,
   -4929, -4929, 43961, 58050,  4020,  3986,  3343, -4929,  4126, -4929,
   -4929,  1476,  3242, -4929, 15719, 79110, 62730,  4415, -4929, -4929,
   -4929, -4929, -4929, -4929, -4929,  3242,  4064, -4929, -4929, 65070,
   -4929, 79110, -4929, -4929,  2539, -4929, -4929, -4929, 79110,  3673,
   -4929,  3673, -4929, -4929,  4133, -4929,  2183,  4089,  1041,  1041,
    4357, -4929,  4049, -4929, -4929,  3996, -4929,  4475,  4122, 79110,
   -4929, -4929,   199,  2141, 66006,  3567, -4929, -4929, 11340, 62730,
   -4929, -4929,  2088,  3880,  3270, 30695,  2543, -4929,  4162,   156,
   -4929,  3901,  3904, -4929, -4929, 40685,  4000,  3253, -4929, -4929,
    1665, 62730, 62730, 35495,  4134,  1116, 13283,  4342, -4929,  4342,
    4342, -4929,  2548, 37409, -4929, -4929, -4929, 79110,  4203,   322,
   -4929,  4155, -4929,  2554, -4929, -4929, -4929,    11,   490,  4004,
   -4929, -4929, -4929,  4129,  1476, -4929,  3242, -4929, 79110, -4929,
    4013, -4929, -4929, -4929, 56178,  3673,  3932, -4929, -4929, -4929,
    4469, -4929,   828, -4929, -4929, -4929, -4929, 79110,  3567,  3764,
    3856, -4929, -4929,  4014,  3901,  3270,  2088, 11727, -4929, 41153,
   79110, 79110,  3904, -4929,  2559, 40685,  3904, -4929,  1935, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929,  4015,  4017,  4461, -4929,
   -4929, -4929, -4929, -4929,  1093, -4929, -4929, -4929, -4929,  3485,
   -4929, -4929, 35975, 35975,  4229, -4929,   322, -4929,  4018, -4929,
   -4929, -4929, -4929, 30695,  1476, -4929, -4929, -4929, 30695, -4929,
    4362, -4929, -4929, -4929,  3567, -4929, -4929, 54306,  3904,  2088,
    3901,  4162, -4929, -4929, -4929, -4929, -4929,  4260, -4929,  2560,
    3373,  2170, -4929, -4929,  2210,  2243,  4091,  4336, 34535,  4163,
   -4929,  4231, -4929,  4433,  5281,  5281, -4929, -4929, 30695, 11911,
    1476,  2574,   935, -4929, -4929,  2579, -4929, -4929, -4929, -4929,
   -4929,  3901,  3904, 79110,  3253, -4929, 40685, -4929, -4929,  1935,
    4138,  4146, -4929, -4929, -4929, 79110, 12397, -4929, -4929, 62730,
   -4929, 54306,  3904, -4929, -4929,  3904, -4929, -4929,  4070,  4076,
    2584, -4929,  4031, -4929, -4929,  3373,  4361,  4363, -4929, 54306,
   -4929, 62730, 62730,  2590, -4929, -4929, -4929
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
    1684,  1450,   626,  1536,  1535,  1450,     0,   260,     0,  1546,
       0,  1450,   419,  1122,     0,     0,     0,     0,   626,  1450,
       0,  1684,     0,     0,     0,     0,     0,  1697,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1450,     0,
       0,  1704,     0,     0,     0,     0,  1697,     0,  1548,     0,
       0,     0,     0,     0,     2,     4,    39,    74,    75,    32,
      31,    93,    57,    18,    65,   127,   126,   128,    44,    40,
      82,    27,    29,    41,    45,    67,    69,    34,    47,    58,
     105,    66,    25,    64,    88,    70,    91,    52,    12,    13,
      53,    14,    54,    15,    55,    16,   101,    76,    94,    37,
      63,    24,    46,    72,    73,     5,    48,    80,    11,    59,
      60,    62,    85,    86,    87,   110,    89,   122,    43,   119,
      98,    99,   116,   100,   117,     9,   102,    56,    17,   113,
     112,   114,    83,    49,    84,    71,    92,   111,    28,   115,
      19,    20,    22,    23,    21,    61,    30,    68,    33,    90,
     118,   108,   104,   123,   121,   129,   106,    77,     7,     8,
      95,     6,    26,    51,    10,    36,    35,    50,    42,   125,
      38,  1546,    97,   109,    96,    78,   103,    81,   107,   124,
      79,   120,  1654,  1653,  1706,  1657,  1683,     0,  1669,  1449,
    1448,  1463,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   625,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1460,  2300,
    2315,  2316,  2317,  2318,  2319,  2320,  2321,  2322,  2323,  2324,
    2325,  2326,  2327,  2328,  2329,  2330,  2665,  2331,  2332,  2333,
    2614,  2615,  2666,  2616,  2617,  2334,  2335,  2336,  2337,  2338,
    2339,  2340,  2341,  2618,  2619,  2342,  2343,  2344,  2345,  2346,
    2620,  2667,  2347,  2348,  2349,  2350,  2351,  2668,  2352,  2353,
    2354,  2355,  2356,  2357,  2358,  2359,  2360,  2669,  2361,  2362,
    2363,  2670,  2364,  2365,  2366,  2367,  2368,  2369,  2621,  2622,
    2370,  2371,  2372,  2373,  2374,  2375,  2376,  2377,  2378,  2379,
    2380,  2381,  2382,  2383,  2384,  2385,  2386,  2387,  2388,  2389,
    2390,  2391,  2392,  2393,  2394,  2395,  2396,  2623,  2397,  2398,
    2399,  2400,  2624,  2401,  2402,  2403,  2625,  2404,  2405,  2406,
    2671,  2672,  2407,  2408,  2409,  2410,  2411,  2626,  2627,  2412,
    2413,  2414,  2415,  2416,  2417,  2418,  2673,  2419,  2420,  2421,
    2422,  2423,  2424,  2425,  2426,  2427,  2428,  2429,  2430,  2674,
    2628,  2431,  2432,  2433,  2434,  2629,  2630,  2631,  2435,  2675,
    2676,  2436,  2677,  2437,  2438,  2439,  2440,  2441,  2442,  2632,
    2678,  2443,  2679,  2444,  2445,  2446,  2447,  2448,  2449,  2450,
    2451,  2452,  2453,  2454,  2455,  2456,  2457,  2458,  2459,  2460,
    2461,  2462,  2633,  2680,  2634,  2463,  2464,  2465,  2466,  2467,
    2468,  2469,  2635,  2636,  2470,  2471,  2472,  2681,  2473,  2637,
    2474,  2638,  2475,  2476,  2477,  2478,  2479,  2480,  2481,  2482,
    2483,  2484,  2639,  2682,  2485,  2683,  2640,  2486,  2487,  2488,
    2489,  2490,  2491,  2492,  2493,  2494,  2495,  2496,  2641,  2497,
    2642,  2500,  2498,  2499,  2501,  2502,  2503,  2504,  2505,  2506,
    2507,  2508,  2509,  2510,  2643,  2511,  2512,  2513,  2514,  2515,
    2516,  2517,  2518,  2519,  2520,  2521,  2522,  2523,  2524,  2525,
    2526,  2527,  2528,  2684,  2529,  2530,  2531,  2532,  2533,  2644,
    2534,  2535,  2536,  2537,  2538,  2539,  2540,  2541,  2542,  2543,
    2544,  2545,  2546,  2547,  2548,  2549,  2645,  2550,  2551,  2685,
    2552,  2553,  2646,  2554,  2555,  2556,  2557,  2558,  2559,  2560,
    2561,  2562,  2563,  2564,  2565,  2566,  2567,  2647,  2568,  2569,
    2570,  2571,  2686,  2572,  2573,  2574,  2575,  2576,  2577,  2648,
    2649,  2578,  2579,  2650,  2580,  2651,  2581,  2582,  2583,  2584,
    2585,  2586,  2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,
    2595,  2596,  2597,  2598,  2652,  2653,  2599,  2687,  2600,  2601,
    2602,  2603,  2604,  2605,  2606,  2607,  2608,  2609,  2610,  2654,
    2655,  2656,  2657,  2658,  2659,  2660,  2661,  2662,  2663,  2664,
    2611,  2612,  2613,   131,     0,     0,  2274,  2301,  2302,  2305,
    2300,   391,   390,  1644,  2268,  2301,  1545,  1525,   626,     0,
    1463,   418,  1684,     0,     0,     0,     0,     0,     0,     0,
     859,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   179,     0,     0,     0,     0,   442,   441,
       0,     0,     0,  1088,   447,     0,     0,     0,     0,     0,
     614,  1593,  2498,  1591,  1645,   261,   264,   265,   262,   263,
    2290,     0,  1224,  1225,  1227,     0,     0,  1237,   899,   900,
       0,     0,     0,   908,     0,     0,     0,   897,     0,     0,
       0,   913,     0,   910,     0,     0,   914,   911,   894,   912,
     901,     0,   893,     0,     0,  1237,   915,     0,     0,   895,
       0,     0,     0,     0,  1463,  1590,   448,  1684,     0,  1567,
    1568,  1569,  1546,  1558,  1570,  1563,  1565,  1564,  1566,  1562,
    2289,  2316,  1023,  1023,  1023,  1023,  1020,  1021,  1023,  1023,
    1023,  2518,     0,     0,  1002,     0,  1004,  2291,  1023,  1028,
     511,   511,   511,     0,  1027,  1032,   511,     0,  1431,  1472,
    2273,  1696,     0,  1003,  1430,     0,     0,     0,  2578,  1581,
       0,     0,  1252,  1248,  1250,  1251,  1249,     0,  1091,  1091,
    2536,  1442,   243,  2547,  2648,  2578,   242,   236,   238,   210,
    2320,     0,     0,  1027,     0,  1463,  1440,   985,  1703,  1701,
       0,  2255,  2340,  2355,  2446,   233,  2529,  2537,  2547,  2648,
    2578,  2610,   189,   199,   194,     0,   254,  2547,  2648,  2578,
     250,  1460,     0,  1670,  1807,  2264,     0,  1433,  1432,  1547,
       0,  1550,     0,  2513,  1674,  1677,  1552,  1675,  1666,     0,
       0,     1,  1684,     0,  1557,  1700,  1700,     0,  1700,     0,
    1658,  1666,  1661,  1665,     0,     0,     0,     0,     0,  1434,
       0,     0,     0,   918,     0,  1475,  2269,  1073,     0,     0,
       0,     0,     0,  1324,     0,  1131,  1130,  2306,  2296,  2297,
       0,  2294,  2295,  2307,  2308,  2309,     0,  2418,  1324,     0,
       0,  2162,  2173,  2174,  2175,  2344,  2401,  2170,  2171,  2172,
    2164,  2165,  2166,  2167,  2168,  2169,     0,     0,  1219,  2163,
       0,  2418,     0,  1324,     0,   158,     0,   135,  1324,     0,
       0,  2418,     0,     0,  2418,     0,     0,     0,     0,     0,
    2418,     0,     0,     0,     0,     0,   158,  2451,     0,   135,
    2418,     0,     0,  1454,     0,     0,     0,  1456,  1459,  1435,
       0,  2247,     0,  2248,  2275,  1528,     0,  2264,     0,     0,
       0,   954,   947,     0,   955,   962,     0,     0,   964,     0,
       0,   948,     0,     0,     0,     0,     0,   967,   968,     0,
       0,   969,   949,   970,   950,   971,   951,   972,     0,     0,
       0,     0,   952,     0,     0,     0,  1446,  1437,     0,  1583,
    1585,  1584,  1582,   511,     0,     0,     0,  2418,     0,     0,
     135,  1513,     0,  2418,   135,     0,     0,   446,   445,   135,
    2294,   444,   443,  2344,  2401,     0,  1121,     0,  1389,   135,
    2418,     0,   181,  2418,   700,  2418,  1552,     0,   629,     0,
       0,   814,  2451,   135,     0,     0,     0,     0,     0,     0,
    1091,     0,     0,     0,     0,     0,   613,   626,  1594,  1592,
       0,  1228,   235,   234,  1226,   906,  2418,  1163,   352,     0,
       0,  2418,  1494,  2303,  1882,  1911,  1889,  1911,  1911,  1878,
    1878,  2384,  1891,  2418,  1879,  1880,  1916,     0,  1911,  1878,
    1883,     0,  1881,  1919,  1919,  1906,   352,   922,  1863,  1864,
    1865,  1866,  1892,  1893,  1867,  1898,  1899,  1903,  1868,  1933,
    1878,  2304,   907,     0,   898,  2418,   352,  1127,  2418,  2298,
     168,     0,   896,  2344,  2401,  2418,   352,  1221,     0,  2418,
     352,  2418,   164,  2418,   352,  2418,   352,  2418,   630,     0,
       0,  2418,   352,  2418,  2451,   166,     0,  2418,   352,   916,
    2418,   352,  2266,  2418,     0,  1438,     0,  1586,     0,  1560,
    2652,  1575,     0,  1571,  1578,  1574,  1684,  1023,  1022,     0,
    1023,     0,  1023,     0,  1023,     0,  1023,     0,     0,     0,
    1023,  2292,  2293,  1005,     0,  1029,     0,     0,  1036,  1035,
    1034,     0,     0,     0,  1037,     0,  1811,  1621,     0,  1428,
     237,   188,     0,   249,   248,  1445,     0,     0,     0,  1091,
    1255,     0,  1253,  1090,     0,     0,  1441,   241,   239,     0,
       0,     0,     0,     0,     0,  1447,     0,  1439,     0,     0,
       0,  2277,  2279,  2280,  2176,  2250,     0,  2615,  2616,  2617,
    2239,     0,  2618,  2619,  2620,  2667,  2068,  2055,  2064,  2069,
    2056,  2058,  2065,  2621,  2622,  2003,  2623,  2624,  2287,  2625,
    2626,  2627,  2629,  2630,  2631,  2632,  2060,  2062,  2633,  2634,
    2636,     0,  2288,  2637,  2638,  2480,  2640,  2641,  2643,  2644,
    2066,  2646,  2647,  2648,  2649,  2650,  2651,  2286,     0,  2067,
    2653,  2655,  2656,  2657,  2658,  2660,  2661,  2662,  2663,     0,
       0,     0,  2261,     0,  2035,     0,  1871,  1872,  1894,  1895,
    1873,  1900,  1901,  1874,     0,  2260,  1936,  2121,  2034,  2051,
       0,  2040,  2041,     0,  2033,  2029,  1686,  2256,     0,  2030,
    2276,  2278,  2240,  1686,  2254,   202,   256,     0,   257,  2262,
    2547,   190,   232,   204,   231,   205,   203,     0,  2342,   191,
       0,     0,   192,     0,     0,     0,     0,   253,   251,     0,
    1436,     0,  1809,  1808,  2265,   927,     0,  1539,  1533,  1542,
    1538,  1549,  1546,  2186,     0,  1676,     0,     0,     0,  1656,
    1655,     3,     0,  1554,  1556,  1531,  1552,  1698,  1699,     0,
       0,     0,     0,     0,     0,     0,     0,  1756,  1714,  1715,
    1717,  1753,  1757,  1765,     0,  1662,     0,     0,  1813,     0,
       0,  1461,     0,     0,     0,     0,     0,  1162,     0,     0,
       0,     0,     0,   919,     0,     0,     0,  1481,     0,  1483,
    1484,  1485,     0,     0,     0,  1486,  1487,  1475,   245,  1493,
    1491,  1474,  1476,  1489,     0,     0,     0,     0,     0,     0,
       0,  1505,     0,   172,   173,     0,   642,   626,     0,  2418,
       0,     0,     0,     0,  1170,  1177,  1323,     0,     0,     0,
       0,     0,     0,     0,     0,  1171,  1169,     0,  1172,   247,
    1182,  1201,  1204,     0,     0,  1129,  1132,     0,     0,     0,
       0,     0,  1314,     0,     0,     0,  1314,     0,     0,     0,
    1323,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     272,   274,   285,   347,     0,   605,     0,     0,     0,   608,
       0,  2418,  1324,     0,     0,     0,  1223,     0,     0,     0,
       0,     0,     0,     0,     0,  1204,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   133,   134,   139,     0,     0,
       0,     0,  1204,     0,     0,     0,     0,     0,     0,     0,
     591,   604,     0,     0,     0,     0,     0,   601,     0,     0,
     135,   277,   581,   587,     0,     0,     0,   707,   706,     0,
       0,     0,     0,     0,  1405,  1404,     0,     0,     0,     0,
    1503,  1502,     0,     0,     0,     0,     0,  1314,     0,   266,
     268,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   383,   384,     0,     0,
       0,   139,     0,     0,  1314,     0,   279,     0,     0,  1455,
    1452,  1453,     0,  1458,     0,     0,     0,     0,  2043,     0,
    2190,  1706,  2188,  1147,  2246,     0,  2310,  2688,  2689,  2690,
    2691,  2692,  2693,  2694,  2695,  2696,  2697,  2698,  2699,  2700,
    2701,  2702,  2703,  2704,  2705,  2706,  2707,  2708,  2709,  2710,
    2711,  2712,  2713,  2714,  2715,  2716,  2717,  2718,  2719,  2720,
    2721,  2722,  2723,  2724,  2725,  2726,  2727,  2728,  2729,  2730,
    2731,  2732,  2733,  2734,  2735,  2736,  2737,  2738,  2739,  2740,
    2741,  2742,  2743,  2744,  2745,  2746,  2747,  2748,  2749,  2750,
    2751,  2752,  2753,  2754,  2755,  2756,  2757,  2758,  2759,  2760,
    2761,  2762,  2763,  2764,  2243,  2242,  2271,  2311,  2312,  2313,
    2314,  2249,     0,  1524,     0,   961,     0,     0,     0,     0,
     963,     0,   956,     0,     0,   953,  2344,  2401,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   966,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   822,     0,
    1475,  1512,     0,     0,     0,   635,     0,  2418,     0,   137,
     860,     0,   812,   447,     0,     0,     0,  1194,  1388,   137,
       0,     0,   175,     0,     0,   704,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   751,   750,     0,     0,     0,
     813,     0,     0,   137,     0,  2418,   584,  2418,     0,   511,
     511,     0,     0,  1093,     0,     0,     0,     0,     0,     0,
    1648,  1650,  1649,     0,  1647,     0,   350,   351,     0,  1211,
    1236,     0,     0,     0,  1910,  1897,  1905,  1904,     0,  1887,
    1886,  1885,     0,  1884,     0,  1911,  1911,  1909,  1888,  1863,
       0,     0,     0,  1915,     0,  1913,     0,   889,  1859,  1855,
       0,  1922,  1923,  1924,  1921,  1934,  1920,     0,  1869,  1925,
    1878,  1875,   909,     0,     0,  1205,     0,     0,  2418,   352,
    2418,     0,  2418,     0,     0,     0,  1213,   352,     0,  1207,
       0,     0,  1209,     0,  1406,     0,   905,   903,   902,   904,
       0,     0,   887,     0,     0,     0,  2418,   352,     0,     0,
     882,     0,     0,   884,     0,     0,     0,     0,  1684,     0,
     221,   222,   220,  1576,   223,  1577,  1573,  1559,     0,  1013,
       0,  1017,     0,  1008,     0,  1014,     0,  1009,  1006,  1007,
       0,  1012,     0,     0,   512,   514,     0,     0,  2367,  2383,
       0,  2407,  2439,  2440,  2504,  2532,  2537,  2543,     0,  2572,
    2583,     0,  1038,  1068,  1033,   718,     0,     0,  1631,  1429,
    2193,     0,  1684,     0,     0,     0,     0,  1244,  1245,   240,
     211,     0,     0,     0,  1070,  2536,  1444,   984,   626,     0,
    2031,     0,  2038,  2039,  2238,     0,     0,     0,     0,     0,
       0,  2037,  2201,     0,     0,     0,     0,     0,     0,  1959,
       0,     0,     0,  2218,     0,  2224,     0,     0,  1996,     0,
       0,     0,     0,     0,     0,     0,     0,  1960,  1940,  1941,
    2035,  2186,     0,  2036,  2283,     0,  1933,  2259,  2176,     0,
    2173,  2174,  2175,     0,     0,     0,  2253,     0,  2184,     0,
       0,  1974,  2182,  1976,     0,     0,     0,     0,  2170,  2171,
    2172,  2164,  2165,  2166,  2167,  2168,  2169,  2180,  1956,     0,
       0,  2123,     0,  1955,     0,     0,  1769,     0,  2281,  2241,
    1769,   258,   259,   255,     0,     0,   207,   206,     0,   225,
     229,   230,   201,   228,     0,   224,   209,  2110,  2109,   208,
     200,   197,   195,   212,   214,   215,   198,   196,   252,     0,
       0,     0,   352,  1557,     0,  1540,  1541,  1537,  1544,  1766,
       0,  1678,     0,  1682,  1557,     0,  1553,  1673,  1672,  1707,
    1708,  1113,  1671,  1736,  1737,     0,     0,     0,     0,  1762,
    1760,  1727,  1718,  1726,     0,     0,  1724,     0,  1728,  1936,
    1755,  1660,  1712,  1713,  1716,  1659,     0,  1758,     0,  1634,
    1756,  1717,  1618,     0,  1596,     0,  1814,     0,     0,  1462,
       0,     0,     0,  1142,  1144,     0,  1143,     0,  1146,     0,
    1155,     0,     0,  1141,  1160,     0,  1149,  1147,     0,  1501,
       0,     0,   920,     0,     0,     0,     0,  1482,     0,     0,
    2572,   244,  1485,  1490,  1477,  1488,     0,     0,     0,     0,
       0,  1072,  1071,     0,     0,  1095,     0,     0,     0,  1508,
     500,     0,   349,     0,     0,     0,     0,     0,     0,     0,
       0,   808,   805,     0,     0,   804,     0,   640,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     680,     0,  1314,     0,   712,     0,  1179,     0,  1178,     0,
    1183,     0,     0,  1180,  1175,  1176,  2537,  2547,  2578,   246,
    1181,  1203,     0,  1202,  1198,     0,  1124,     0,  1125,     0,
       0,     0,     0,     0,  2393,  2418,   290,   312,     0,  1313,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   334,     0,     0,   337,   336,
       0,     0,     0,     0,     0,   341,   320,     0,   321,     0,
     340,     0,     0,     0,   606,   607,     0,     0,     0,  1314,
       0,   281,     0,     0,     0,     0,     0,     0,     0,     0,
    1220,     0,   735,     0,     0,  2537,  1199,     0,     0,     0,
       0,     0,     0,  1392,     0,     0,   161,     0,   156,   160,
       0,     0,  2537,  1200,     0,     0,     0,     0,     0,   589,
     590,   603,     0,   594,   595,   592,   596,   597,     0,     0,
       0,     0,     0,     0,     0,   588,     0,     0,   702,   701,
     705,     0,     0,     0,     0,     0,  1401,     0,  1194,     0,
       0,  1400,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1257,  1256,     0,     0,     0,     0,  1324,     0,
     850,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     163,   722,     0,   721,     0,   157,   162,     0,     0,     0,
       0,     0,     0,     0,     0,   219,  1451,  1457,  1706,  1706,
    1706,  2049,     0,     0,     0,     0,  1705,  2244,  2247,  1527,
    2272,  1526,     0,     0,     0,     0,   965,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   957,   958,   959,   960,
       0,     0,     0,     0,     0,   397,   394,   395,   397,     0,
       0,     0,     0,   824,     0,   827,   830,     0,  1473,   466,
       0,     0,   632,   680,     0,     0,   450,   170,     0,     0,
       0,     0,   737,     0,     0,     0,  1387,   132,   179,   181,
     448,     0,   180,   182,   184,   185,   186,   183,   187,     0,
     699,   703,     0,     0,     0,     0,   628,     0,     0,     0,
       0,     0,   752,   756,   755,   759,   757,     0,   753,     0,
       0,  1834,     0,     0,   155,     0,     0,   579,   583,     0,
       0,     0,     0,   450,   550,   363,  2418,     0,   511,     0,
    2418,     0,  1092,     0,   811,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1646,   352,  1164,     0,  1495,
       0,     0,     0,     0,   352,  1908,  1907,  1860,  1856,     0,
       0,     0,     0,   923,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1876,   352,  1128,   169,  2299,     0,   891,
       0,     0,     0,     0,   352,  1222,   879,   352,   165,   352,
     352,   631,     0,   352,   167,     0,     0,     0,   623,   352,
     917,   352,  2267,     0,   352,  1589,  2418,   511,  1561,  1572,
    1010,  1019,  1018,  1016,  1015,  1011,     0,  1030,     0,   510,
       0,     0,     0,     0,     0,  1046,  1047,     0,     0,  1043,
    1048,     0,  1044,  1045,  1050,  1040,  1039,  1051,  1052,     0,
       0,  1070,   716,     0,     0,     0,     0,  1628,     0,  1626,
       0,  1812,  1630,  1619,  1580,     0,  1579,     0,   572,  1091,
    1091,  1254,     0,     0,  1027,     0,     0,   352,  1443,     0,
     986,   992,     0,     0,     0,     0,     0,     0,     0,   995,
     996,     0,   997,   988,   998,   989,   999,     0,   990,     0,
       0,     0,     0,  2251,  2197,     0,  2198,     0,     0,  2237,
    2233,     0,     0,     0,     0,     0,  2202,  2205,  2206,  2207,
    2204,  2208,  2203,     0,     0,  2209,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2644,     0,     0,     0,
       0,  2004,     0,     0,  2157,     0,  2186,  2223,     0,     0,
       0,     0,     0,     0,  2186,  2229,     0,     0,     0,     0,
    2108,     0,  2105,     0,     0,     0,     0,  2250,     0,     0,
    2284,  1937,  1951,  1952,  1953,  1957,  2258,     0,  2252,     0,
       0,  1938,  1965,     0,  2230,  1992,     0,  1997,  1980,  2210,
    2211,  2212,  2213,  1999,     0,  1973,     0,  1978,  1982,     0,
    1961,     0,  1958,     0,  2253,  2185,     0,  2183,     0,  1948,
    1949,  1950,  1942,  1943,  1944,  1945,  1946,  1947,  1954,  2161,
    2159,  2160,     0,     0,     0,  2131,     0,     0,  1977,  2410,
    2446,     0,  1697,  1697,  1697,  1685,  1695,  2257,     0,  1829,
    1706,  1829,  2263,     0,     0,  1933,     0,  1810,   925,   926,
     924,  1530,  1534,  1543,  1557,  2187,  1551,  1680,     0,     0,
    1532,  1555,     0,  1111,  1112,     0,  1116,  2644,  2534,     0,
       0,     0,     0,  1729,  1763,     0,  1754,     0,  2277,  1730,
    2276,  1731,  1734,  1735,  1725,  1764,  1632,     0,  1759,  1664,
    1663,     0,  1832,     0,     0,     0,  1610,  1598,     0,  1815,
       0,  1769,  1636,     0,  2250,  1767,  1363,  1258,  1325,  1145,
       0,  1878,  1156,     0,  1140,     0,  1139,  1878,     0,  1157,
       0,  1878,  1364,  1259,  1326,   921,  1365,  1260,  1327,  1366,
    1261,  1492,  1480,  1479,  1478,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   789,
    2418,   352,  1506,  1367,     0,  1262,   348,  1507,  1328,  1511,
     807,   806,     0,     0,  1329,     0,   641,     0,   645,     0,
     647,   648,   649,     0,     0,     0,   650,     0,  2344,  2401,
     652,   655,   656,   657,   664,   669,   659,     0,     0,   671,
     665,     0,     0,     0,     0,     0,     0,   677,   682,     0,
       0,     0,     0,     0,     0,  1173,  1174,  1368,  1265,     0,
    1330,     0,  1123,     0,  1266,   171,     0,     0,   273,  2418,
     292,     0,   684,   789,     0,  1316,   289,   318,     0,   333,
     328,   329,   327,  2418,   352,  2418,   352,     0,     0,     0,
       0,     0,   330,   325,   326,   322,     0,     0,   335,  2319,
    2385,  2548,     0,   688,   690,     0,   695,   338,  1286,   359,
     358,   357,     0,   342,     0,   364,   367,   339,   319,   317,
     314,   286,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2270,     0,     0,  1215,     0,  1371,  1331,     0,  1353,
       0,     0,     0,     0,   729,  1374,  1272,  1334,     0,  1393,
    1395,  1385,  1273,  1394,   159,  1303,   148,     0,     0,   144,
       0,     0,     0,     0,   138,  1375,  1274,  1335,     0,     0,
    1376,  1275,     0,     0,   278,   582,   593,   598,  1280,   602,
     599,  1343,   600,  1383,  1276,     0,  1379,  1306,  1338,   565,
    1386,  1402,  1277,  1194,  1397,  1399,     0,  1314,     0,   267,
     269,     0,   288,     0,  1278,     0,  1336,  1378,  1305,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1514,     0,
       0,     0,     0,     0,     0,   352,     0,     0,     0,  1316,
    2418,   352,  1377,     0,  1311,     0,  1351,     0,     0,   385,
       0,  1304,  1314,     0,   280,  1282,     0,  1345,     0,     0,
     217,   216,   218,     0,     0,     0,     0,  2191,  2192,     0,
    2189,  2044,  2246,     0,   974,   932,   973,     0,  2383,     0,
     931,   933,     0,     0,     0,   934,     0,   938,   939,     0,
       0,     0,   930,   928,   929,   396,     0,     0,   746,   747,
       0,     0,     0,     0,   826,     0,     0,     0,  1504,     0,
     135,   639,     0,     0,     0,   634,   679,   684,     0,     0,
       0,     0,   449,   453,   457,   458,   459,     0,     0,     0,
       0,   149,   136,     0,   868,     0,   511,     0,   739,  1391,
    1390,  1193,     0,   181,   174,     0,     0,   700,     0,  1552,
       0,     0,   363,   821,   819,   818,   820,     0,     0,     0,
     842,   817,     0,  1833,  1835,     0,     0,     0,     0,     0,
       0,   572,   452,     0,     0,   514,     0,   553,     0,     0,
       0,     0,   550,     0,     0,     0,  2303,     0,   838,   810,
    1134,     0,  1152,  1135,     0,     0,     0,     0,  1187,  1119,
    1188,  1165,  1120,     0,     0,   611,  1651,  1652,     0,  1212,
       0,     0,  1500,     0,  1498,     0,  1877,  1890,   890,     0,
    1918,  1917,  1919,  1919,     0,  1861,     0,  1902,  1927,  1928,
    1929,  1930,  1931,  1932,     0,  1926,  1870,  1206,   352,     0,
     352,     0,   352,  1214,  1208,  1210,  1407,     0,   888,     0,
       0,   352,   881,   883,     0,   885,     0,  1031,   513,     0,
       0,     0,     0,     0,     0,  1042,   609,  1049,     0,  1063,
    1058,  1060,     0,  1064,   715,     0,     0,  1629,  1622,  1624,
    1623,     0,     0,  1620,  2194,   880,     0,   578,     0,     0,
       0,     0,   352,     0,  1065,     0,     0,   993,   987,     0,
       0,   991,     0,     0,     0,   994,     0,     0,  1702,  2195,
    2196,     0,     0,     0,  2234,     0,     0,  2083,     0,  2057,
    2059,  2071,     0,  2084,  2042,  2085,  2061,  2063,  2072,     0,
       0,  2177,     0,     0,  2074,     0,  2006,  2007,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2022,  2021,  2075,  2156,     0,
       0,  2221,  2222,  2076,     0,     0,  2228,     0,     0,     0,
    2081,  2086,     0,     0,     0,     0,  2092,     0,  2113,     0,
       0,     0,  2032,  2187,     0,     0,     0,     0,     0,     0,
       0,     0,  1998,  1981,  2001,  1975,     0,  1979,  1983,     0,
       0,  2000,     0,     0,  1969,     0,     0,  1967,  1993,  1963,
       0,     0,  1994,     0,     0,     0,  2050,     0,     0,  1697,
    1697,  1697,  1697,  1694,     0,     0,     0,     0,  2534,  2664,
       0,  1793,  1768,  1770,  1780,  1793,  1798,  1793,  2052,  1827,
    2053,  2264,     0,  1739,     0,  1739,   193,     0,   226,   213,
    1529,  1681,  1684,  1709,     0,  2178,  1116,     0,  1711,  1733,
    1732,     0,  1722,     0,  1761,  1719,  1633,  1617,     0,  1615,
    1602,  1604,  1603,     0,     0,  1605,  2250,     0,  1615,  1597,
    1641,     0,     0,  1832,     0,  1640,     0,  1878,  1137,  1138,
       0,  1161,     0,  1075,  1076,     0,  1074,     0,     0,     0,
     499,  1094,     0,     0,     0,   789,     0,     0,   503,     0,
    1509,     0,  1384,  1302,   643,   644,     0,   658,     0,   667,
     666,     0,     0,     0,     0,     0,     0,     0,   651,   673,
     615,   674,   676,     0,     0,   675,   678,   681,  1314,     0,
     713,  1288,     0,  1349,  1167,     0,     0,  1126,     0,     0,
       0,     0,     0,     0,   466,   313,     0,     0,     0,     0,
     372,     0,   294,   305,   370,   311,     0,   344,     0,   316,
       0,   309,   331,   323,   332,   324,   343,   345,     0,   692,
     693,   691,   687,     0,   694,   696,     0,   361,     0,     0,
       0,     0,  1370,     0,  1314,     0,   282,  1284,     0,  1347,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1352,     0,     0,     0,     0,   734,     0,   731,
       0,     0,     0,   141,   140,     0,   147,     0,     0,     0,
       0,     0,     0,     0,  1403,     0,     0,     0,     0,     0,
       0,   379,     0,   287,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   386,   354,     0,   845,     0,     0,     0,   388,     0,
       0,  1362,     0,     0,     0,     0,     0,  1369,  1267,  2047,
    2048,  2045,  1706,  2245,     0,     0,     0,   945,     0,     0,
       0,     0,     0,     0,   399,   400,   135,   398,   421,     0,
     789,     0,     0,   823,   828,   836,  2480,  2164,  2165,   834,
     829,   831,   833,   835,   832,     0,     0,     0,     0,     0,
     482,     0,     0,     0,   472,     0,     0,  1194,   465,   468,
     469,     0,     0,   635,   638,   636,   637,   672,     0,   452,
     489,   540,     0,   151,     0,     0,   152,   150,     0,     0,
     363,   736,     0,   733,     0,   177,   448,     0,   704,     0,
       0,     0,  1194,   627,   758,   761,   754,     0,   841,   843,
     815,     0,   684,     0,     0,   584,     0,   511,  1590,   567,
       0,   542,   452,   540,   549,     0,     0,   557,   362,     0,
       0,   572,   363,     0,     0,  1095,     0,   837,     0,  1133,
       0,     0,     0,  1184,  1189,  1185,     0,     0,  1148,     0,
    1186,  1166,  1423,  1424,  1421,  1422,     0,     0,     0,  1643,
       0,     0,  1496,     0,  1896,     0,  1914,  1912,  1857,  1862,
    1935,   892,     0,   875,     0,   877,   352,   723,     0,   624,
     352,     0,     0,     0,     0,     0,     0,  1041,     0,  1061,
       0,     0,  1024,  1067,     0,     0,  1627,  1625,   570,     0,
    1246,  1247,  1070,     0,  1025,  1069,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2199,     0,  2236,  2232,     0,
    2054,  2200,     0,     0,  2216,  2215,  2157,     0,     0,  2005,
    2017,  2018,  2019,  2217,     0,  2027,     0,     0,  2014,  2015,
    2016,  2008,  2009,  2010,  2011,  2012,  2013,  2020,  2226,  2225,
    2219,  2220,     0,  2078,  2079,  2080,  2227,  2087,     0,  2334,
    2114,     0,  2091,  2107,  2106,     0,     0,     0,  2094,     0,
       0,  2103,     0,  2158,  2285,  1939,     0,     0,  1966,  2231,
    1984,     0,     0,  2002,     0,  1962,  2177,     0,     0,     0,
       0,     0,  1971,     0,     0,     0,  2134,  2129,  2130,  2154,
       0,     0,     0,     0,     0,     0,  1688,  1687,  1693,  1793,
    1798,  1793,     0,     0,  1666,     0,  1780,     0,  1792,  1778,
    1791,     0,     0,  1804,  1802,     0,  1804,     0,  1804,     0,
    1772,     0,  1794,  1774,  1791,  1776,     0,  1819,  2265,  1828,
       0,  1752,  2044,  1752,     0,     0,     0,  1710,  1114,  1115,
    1720,     0,  1723,  2363,  1830,     0,  1616,     0,     0,     0,
    1607,  1613,  1595,     0,     0,  1637,  1615,  1638,  1158,     0,
       0,  1150,  1081,  1082,  1085,  1083,  1080,  1084,     0,     0,
       0,   789,     0,     0,   521,     0,  1108,  1108,     0,     0,
     505,   562,   516,   792,     0,     0,     0,   790,   352,  1263,
       0,   668,     0,     0,   663,   661,   660,   662,     0,   616,
    1382,  1264,     0,     0,     0,     0,  1168,  1317,     0,     0,
    1287,     0,   291,     0,   462,     0,     0,   297,   306,     0,
     302,     0,  1315,     0,     0,     0,     0,   301,   374,     0,
     371,     0,   352,   352,   346,   689,   360,   365,   366,   369,
    1322,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   869,   852,     0,     0,   870,   871,
       0,     0,     0,  1217,  1218,  1216,  1354,  1355,  1360,  1357,
    1356,  1359,  1361,  1358,     0,  1270,     0,     0,   727,  1318,
     145,   142,   143,   146,  1319,  1300,  1281,  1344,   566,  1398,
       0,     0,     0,  1279,     0,  1337,     0,  1296,  1290,     0,
       0,     0,     0,     0,  1381,  1310,  1342,  1380,  1308,  1340,
    1307,  1339,  1309,  1341,  1301,     0,     0,  1837,   849,     0,
       0,     0,   352,   352,   848,   725,  1283,     0,  1346,  1292,
       0,     0,     0,   935,     0,     0,   937,   940,     0,   942,
     404,   422,   135,     0,   745,   809,     0,     0,   825,   788,
       0,   470,     0,   476,   480,     0,     0,   484,   485,   483,
     471,  1194,   511,   561,   778,   779,     0,     0,   799,     0,
     633,     0,   450,     0,   486,     0,     0,   454,   154,   153,
       0,     0,     0,   740,   744,   742,   741,   743,   738,     0,
     729,   181,  2418,     0,     0,     0,     0,   563,  1396,     0,
     771,   816,     0,  1836,   719,     0,   363,   580,     0,     0,
       0,   450,   572,     0,   455,   460,   461,   466,     0,   550,
     541,     0,   542,   551,   552,     0,   559,  1471,     0,   573,
     559,     0,     0,     0,   840,     0,   839,  1136,  1153,  1154,
       0,     0,  1117,     0,     0,     0,     0,   618,   352,     0,
    1499,  1858,   352,   352,  1243,     0,   886,  1055,  1056,  1057,
    1054,  1053,   610,     0,  1059,   717,     0,   571,   352,     0,
    1001,   979,  1000,   978,   980,     0,   982,   983,   977,   975,
     976,  2235,  2070,  2073,  2082,  2214,  2156,  2187,     0,     0,
    2028,     0,     0,  2077,  2654,     0,     0,  2118,  2119,     0,
    2115,  2116,  2111,  2112,  2093,     0,  2469,  2098,     0,     0,
       0,  1990,  1988,  1985,     0,  1986,  1970,     0,     0,  1968,
    1964,     0,  1995,  2120,     0,  2136,  2133,  2153,  2187,  1692,
    1691,  1690,  1689,  1779,  1775,  1777,     0,  2659,     0,  1782,
    1789,     0,  1771,     0,  1803,  1799,     0,  1800,     0,     0,
    1801,     0,     0,  1773,     0,  1789,     0,  1826,     0,     0,
    2125,  2282,  2125,   227,  1679,     0,  1721,     0,  1614,  1599,
       0,  1600,  1606,     0,     0,     0,     0,  1642,  1635,  1151,
    1159,     0,     0,     0,   501,     0,   516,     0,     0,     0,
    1101,  1110,  1100,     0,   516,     0,  1194,   794,   793,   796,
     791,   795,  1510,     0,   653,   654,   670,  1289,     0,  1350,
    1298,     0,  1631,   293,     0,   685,   300,     0,     0,     0,
     295,   373,   375,   296,   299,   303,   354,   315,   308,     0,
       0,     0,  1285,     0,  1348,  1294,  1321,  1372,  1268,  1332,
       0,     0,   858,     0,     0,     0,     0,  1373,  1269,  1333,
       0,     0,     0,     0,  1631,     0,     0,     0,     0,     0,
       0,     0,     0,  1519,     0,     0,   353,   847,   846,   354,
     387,  1312,     0,  2046,     0,   936,   943,   944,   941,     0,
     393,   401,   404,     0,     0,  1234,  1234,     0,   789,     0,
       0,   467,   481,     0,   561,   520,     0,   473,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   732,   731,   176,     0,   450,     0,   684,     0,
     765,   766,   760,   762,     0,   773,   777,   844,     0,     0,
       0,   572,   452,     0,     0,  1587,   451,     0,     0,   463,
       0,   553,   542,   550,     0,     0,   569,     0,  1464,     0,
     575,     0,     0,     0,  1190,     0,  1196,     0,  1147,  1191,
       0,  1829,     0,     0,     0,     0,   622,  1235,  1497,   876,
     878,   724,  1062,     0,  1066,   352,   981,  2158,  2023,     0,
       0,     0,     0,  2088,     0,  2089,  2117,  2095,  2099,     0,
    2096,  2097,  1987,  1991,  1989,  1972,  2122,     0,  1706,  2155,
    1822,     0,  1825,     0,     0,  1781,     0,     0,  1783,     0,
       0,  1785,  1787,     0,     0,     0,     0,     0,     0,  2268,
    2362,  2627,  2531,     0,  1738,  1740,  1743,  1745,  1744,  1746,
    1742,  1751,     0,  1668,  1667,  2179,  1831,     0,     0,     0,
    1096,     0,  1639,  1063,     0,   352,  1108,  1194,   522,  2480,
     523,  1107,  1109,  1113,     0,  1194,     0,   561,   646,     0,
       0,   275,   683,     0,     0,   298,   307,   356,   368,     0,
    1631,     0,     0,   856,   865,   865,   853,     0,     0,   872,
    1271,   728,     0,     0,   270,  1297,  1291,     0,     0,     0,
    1521,  1522,     0,     0,     0,     0,     0,  1320,   352,  1293,
     946,     0,   424,   431,   405,   409,  1513,     0,  1513,     0,
     406,   410,  1513,  1513,   403,  1829,   420,  1234,     0,  1231,
    1230,   787,     0,   509,   586,     0,   474,     0,   531,     0,
       0,   800,     0,     0,   452,   540,     0,   498,   490,   491,
     492,   494,   493,   495,   496,   497,   488,   487,     0,   684,
     862,   363,  1471,   726,     0,     0,   697,     0,   763,   768,
     767,  1513,   772,     0,     0,     0,   684,     0,  1590,   568,
     542,   452,   540,   456,   466,     0,   557,   550,   553,     0,
     554,     0,   558,     0,     0,     0,   572,  1523,  1095,     0,
    1195,     0,     0,     0,     0,     0,     0,  1238,   617,     0,
       0,   621,   612,   684,  1026,  2024,     0,  2025,     0,     0,
    2101,  2100,     0,  2140,  1827,     0,     0,  1821,     0,     0,
    1851,     0,     0,     0,  1790,  1806,     0,  1786,  1784,     0,
    1795,     0,  1797,     0,     0,     0,  1747,     0,  2124,  2126,
       0,     0,  1612,  1829,     0,  1609,     0,  1077,     0,  1078,
    1102,   561,     0,  1113,  1116,   511,   561,     0,   789,  1299,
       0,   686,   586,     0,   310,     0,   283,  1295,     0,     0,
     867,   867,     0,     0,     0,     0,     0,     0,   381,     0,
       0,  1515,     0,  1516,  1517,  1520,   389,   402,     0,   429,
       0,   427,   426,   428,     0,   417,     0,     0,     0,     0,
       0,     0,   392,  1229,  1233,  1232,     0,     0,   475,     0,
     477,     0,   517,   518,   519,     0,   479,   527,   528,     0,
     797,     0,   802,     0,     0,     0,   684,   539,   708,     0,
       0,     0,  1465,     0,     0,   564,     0,   774,   775,   770,
       0,     0,   720,  1471,   572,   550,     0,   542,   464,     0,
     559,   553,   557,   555,   556,     0,  1468,     0,   574,     0,
    1104,  1118,  1197,  1192,  1427,     0,     0,   620,   619,   714,
    2026,  2104,  2090,  2102,  2135,     0,     0,     0,     0,  1820,
    1823,     0,  1854,     0,     0,     0,     0,  1840,     0,  1788,
       0,     0,  1796,     0,     0,     0,  1741,     0,     0,  1601,
    1611,  1097,     0,     0,   526,     0,  1116,  1098,   520,   789,
     515,   502,  1631,   304,   355,     0,     0,     0,   863,   866,
     854,   855,   874,   873,   730,  1631,     0,   377,   376,     0,
     380,     0,   425,   434,     0,   432,   407,   412,     0,   416,
     414,   413,   408,   411,     0,   508,     0,     0,     0,     0,
       0,   529,     0,   530,   560,     0,   801,     0,     0,     0,
     710,   861,     0,     0,   450,   684,   764,   769,     0,     0,
    1466,  1588,   553,   542,   550,     0,     0,   544,  1108,  1108,
     437,   557,   559,  1469,  1470,     0,     0,   363,  1426,  1425,
    1684,     0,     0,  2614,  2363,  2586,     0,  2152,  2141,  2152,
    2152,  2132,     0,     0,  1852,  1853,  1838,     0,     0,  1842,
    1805,  1818,  1749,     0,  1748,  2127,  2128,  1829,   352,     0,
     789,   524,  1099,   531,   504,   276,  1631,   857,     0,   271,
       0,   382,  1518,   430,     0,   415,   777,   585,   478,   536,
       0,   535,     0,   533,   532,   798,   803,     0,   684,   851,
    1471,   698,   776,     0,   557,   550,   553,     0,   543,     0,
    1110,  1110,   559,   435,     0,     0,   559,  1409,  1684,  1408,
    1410,  1418,  1415,  1417,  1416,  1414,  1241,  1242,     0,  2145,
    2144,  2143,  2147,  2146,     0,  2139,  2137,  2138,  1824,     0,
    1841,  1844,     0,     0,     0,  1850,  1843,  1845,     0,  1816,
    1750,  1608,  1079,     0,   506,   789,   284,   864,     0,   433,
       0,   534,   538,   537,   684,   709,  1467,   782,   559,   553,
     557,  1108,   545,  1109,   547,   546,   439,  1104,  1105,     0,
    1829,     0,  1419,  1413,  1666,  1653,     0,     0,     0,     0,
    2149,     0,  2150,     0,  1847,  1848,  1849,  1846,     0,     0,
     507,     0,     0,   711,   784,     0,   780,   783,   785,   786,
     438,   557,   559,  1110,   363,  1103,     0,  1086,  1411,  1684,
       0,     0,  2142,  2148,  2151,     0,     0,   525,   378,     0,
     748,     0,   559,   436,   548,   559,  1106,  1412,     0,     0,
       0,  1817,     0,   781,   440,  1829,     0,     0,  1839,   782,
    1087,     0,     0,     0,  1239,  1240,   749
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -4929, -4929, -4929,  3696, -4929, -4929,  -890, -1319,  2909, -1935,
   -4929, -4929, -4929,  1305, -4929, -4929, -4929, -4929,  3651, -4929,
    1996, -2440, -4929, -4929,   133,  -372, -1318,   138,  3180,  1639,
   -4929, -1156, -4929, -4929,  -574,   107, -4929,  -367,   716, -4929,
   -4929, -4929, -4929, -4929, -4929, -4929, -4929,  -509,  2114, -4929,
    2198,  1464,  3165, -3299, -4929, -4929, -1467, -3256, -4929,   763,
   -4929,   791, -4260,  -744, -4929, -4929, -4929,  2097, -4929, -4929,
   -4929,  2039,  1264,  -183, -4929, -4929, -4929, -4929, -4929, -4929,
    -586, -4929, -4929,  -831,   148,    42, -2472, -3810, -4929, -4929,
     632,  -232, -1441, -4929, -3631, -4929,   158, -2770, -4929, -4929,
   -4929,  -200, -1413,  1575, -4929,  -730, -1148,  1890, -2672,  -699,
   -4929,   -73, -4929,  -807,  -600,  -598,  -723, -3846, -4348, -4929,
   -4929,  -832, -3228, -4567, -4809, -4345, -4256,  1593, -4929, -4929,
     151, -3154, -3265,   152,   608, -4929,   154,   161, -4929,   626,
    -530,  -915, -1562, -4929,  -483, -4929, -4929, -4929, -2973, -4929,
   -4929, -4929, -4929,    73, -4929, -4929, -4929, -4929,   671, -4929,
   -4929, -4929, -4929, -4929, -4929, -2717,  2072,  2075, -4929, -3022,
   -4929,  -871, -4929,   826, -2995,  1496, -4929, -4929,  1263,  3678,
     655, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -1737, -4929,
   -4929, -4929, -4929,   165,  -169, -4929, -4929, -4929, -4929, -4929,
   -4929, -4929,   163, -4929,  2090,  1265, -4929, -4929,  -173, -4929,
   -4929, -4929, -4929, -4929, -4929,  -779, -4558,  -943,  -922, -4929,
   -3002, -4929, -4929, -4929,  -141, -4929, -4929, -4929, -4929, -4929,
    -923, -4929,  1326, -3638, -4929, -4929,   634, -4929, -4929, -4929,
   -4929, -4929,  -698,   -80,  2845, -4929,  -304,  -499, -4929, -4929,
   -4929,   -72, -4929, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -1096,  9144,  -817,  -584, -4929, -4929, -4929, -4929, -4929, -2197,
   -4929, -4929, -4929, -4929, -3749, -4929,  4605,  1834,   960,   164,
   -4929,   -35,    57,  3445, -1158, -2678,   594,  -267, -4929, -4929,
   -4929, -2592, -4929, -4929, -4929, -4929, -3571,   166, -4929,  -687,
   -4929, -3860, -4598, -4061, -3603,  -850, -4929, -4928, -4454, -4542,
   -3556, -4929, -4929, -4929, -4929,  -552,  -167,  2814, -4929, -1431,
    2452,  -935, -4929, -2122,   657,  1678,  2826, -2762,  -136,  2816,
   -2538,  -674, -3289, -4929, -4929, -2313,  -400, -4929, -4929,  1372,
    -117, -4929, -4929, -4929, -4929,  -633,  2760,  -205, -4929, -4929,
    3985, -4929, -4382, -4929,  3950, -4929, -4929, -4929, -4929,  2673,
    2674, -4929,  2677, -4929, -4929, -1430,  1431, -4929,  -780, -4929,
   -4929,  2217,   859, -4929, -4929, -4929, -4929, -4929, -4929, -4929,
   -4929,  1325,   844, -4929, -4929, -4929, -4929, -4929,  -681,  -859,
   -4929, -4929,   184, -4929, -4929, -4929, -4929,  2383,  -897,  -733,
    3857,  -231,   185, -4688, -4929, -4929, -1121, -4929,  3233, -4929,
   -4929, -4929, -4929, -4929,   661,   660, -4929, -4929, -4929, -4929,
   -2749, -4929, -4929, -4418, -4929, -4929, -4929, -4929, -4929,  3832,
      93,  2552, -4929, -4929, -4929,   -50, -4929, -4929,  -974,  2542,
   -4929, -1966, -4929,  -605, -4929,  2750, -4929, -4929, -4929, -4929,
   -1898,   190, -3853, -4929,    12, -4929, -4929,    50, -4929,   472,
   -4929, -4929, -3467,    14, -4929, -4929, -4929, -4929, -4455, -4929,
      16,  -580,  1012, -2839, -4929,   196,   157, -4929, -4929,     9,
     353,   -49,   -39,   -26,     6,    99,  3317, -4929, -4929,  3353,
   -4929,    18,  1860, -4929, -4929,  -808,  -149, -4929,  1776,  -642,
    2514,  3311,  3318, -4929,  1762,  2545, -1962, -1998, -4929,  1056,
    -562,  -401, -4929, -4929, -4929, -4929,   505,  -641,  2529, -4929,
    3324, -4929, -4929, -4929, -1959, -2854, -3465,  1081, -3504, -3384,
     543,   528, -1454,  -168,   -41,  -754,  3331, -4929, -4929,  1091,
    -366, -4929, -4929,  -360, -2808,  1045, -4929, -4404, -2338,  1104,
    -816,  -644, -4929,  -729, -4929,  -518,  9111,  2871, -1063, -4929,
   -4929, -1004, 14156, -4929, -4929, -4929, 14958, 15789, -4929, -4929,
   16399, 16791, -4929,  -825, 17389, 14128, -1033, -1897,   -29, 13334,
   -1768,  2872,    53, -4929, -3560, -2453, -4929, -4929, -4929,  -102,
    1177,   465, -4929, -4463, -3828, -4929, -4929,   124, -4929,  -510,
   -4929,  -508, -4929, -4929, -4929, -2500, -4033, -2594,  2666, -4929,
   -4929, -4929,  -182, -4929, 18023, -2789, -4929,  1882, -1334, -1548,
   -3480, -1906, -4929, -4929, -4929, -2640, -4929, -4929, -4929, -4929,
   -1468, -3332,  -356,  1893, -4929, -4929,  1992, -4929, -4929, -4929,
    -911,  2276,  -777, -2675,  1901, -4929,  -788,  2667,  -785, 11523,
    -543,  9276,  -550, -2273, -1251, -1665, -4929,  2004, -4929,  5383,
    6602,    35,  -143,   683,  -516,    -6, 13259,  -660,  -824,  4302,
   12528, 10075, -3180
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    53,    54,    55,    56,    57,  1547,  2527,  2378,  3321,
    3322,    58,    59,  1543,    60,    61,    62,    63,  1457,    64,
    1031,  1792,  2542,    65,  2211,   813,   814,   815,  2112,  2113,
    2466,  2114,  2102,  1343,  1934,  1479,   787,   788,  1439,  1480,
      67,    68,  1337,  2093,    69,    70,    71,  1510,  1600,  1511,
    1512,  1451,  1839,  4377,  5124,  3113,  2340,  3369,  3114,  3115,
    3753,  3754,  3833,  5138,  5139,    72,  1616,  1617,    73,    74,
    2508,  3286,  3886,  4740,  4741,  4974,   623,  4402,  4403,  4961,
    4962,  5152,  5294,  5295,  2543,  1784,  3364,  3971,  3312,  4473,
    3313,  4474,  3314,  4475,  3298,  3918,  3919,  4416,  3920,  3315,
    4434,  5006,  3316,  2230,  5168,  2584,  1956,  1954,  4656,  4988,
    4233,  4234,  5380,  5176,  5177,  5178,  5403,  4436,  4479,  4480,
    5336,  5337,  3367,  3977,  4486,  4806,  4757,  2999,    76,    77,
     719,  1818,  3477,   720,  2587,   657,   721,  2544,    82,  2577,
    5170,  2578,  1573,  2392,  3899,  3457,    83,  1057,  3719,  4826,
    5061,  5062,    84,   227,    85,  1800,    86,    87,  2522,  3305,
      88,  2247,  3016,    89,    90,  3047,  3048,  3049,    91,  3744,
    4674,  1513,  3102,  3103,  3104,  3105,  3774,    92,  1795,  2551,
    2552,    93,    94,    95,    96,  2704,  2705,    97,  2452,    98,
      99,   100,   101,  3809,  4338,  4450,  3144,  3328,  3943,  4448,
     102,  3290,  2545,  1808,  2567,  2568,  4460,  4782,  4783,  4784,
    5021,  5326,  4786,  5023,  5199,  5025,  4426,  5515,  5516,  4748,
    3698,  4247,   104,  4427,  4428,  5183,   105,  2245,   106,   107,
    1768,  2514,  2515,  3900,  2594,  3377,  3378,  3957,  3958,   108,
    3228,   109,  4314,  4315,   658,  5190,  5130,  5280,   110,   111,
    4318,  4319,   112,   113,   114,   115,   116,   711,   712,   713,
    1148,  1149,  2971,  1096,   117,  2122,   118,   994,   995,  3265,
     119,  1229,  2750,  2751,  4531,   120,   744,  1168,  1169,  2546,
     122,   753,  2724,   755,  1971,  3459,  3460,  4042,   123,   124,
    2701,  2727,   125,  1444,  2221,  2222,  4228,  2547,   659,  1214,
    2591,  2994,  4899,  4650,  4900,  5347,  5489,  4651,  4913,  2916,
    3648,   127,   660,  1485,  2297,  1116,  1117,  2597,  3381,  2190,
    2191,  2192,  3997,  2193,  3383,  2194,  1417,  2195,  1067,  1068,
    3389,  3390,  3391,  3993,  4000,  2536,  4816,  4817,   128,  1482,
    2294,   129,   130,   131,  1526,   906,  1126,  1127,   132,   672,
     673,   133,  4979,   134,  1070,   135,  4824,   136,   137,   778,
     779,  1211,  1212,   138,   139,  2311,  3756,   140,  1483,   141,
     142,  3138,  3139,  4330,   143,   144,   145,  1787,  1788,   146,
     147,  3193,  3194,   148,   149,   150,  5429,  5491,  5492,  5493,
    4006,  5350,  5431,  1199,   152,   153,   154,   191,   947,   948,
     949,   859,  2548,  4808,   156,   157,  1440,  1441,  1442,  1443,
    2216,   158,   159,   160,  3403,  3404,   161,   162,   163,   164,
    1772,   165,   166,  4952,   167,   168,  1733,   169,   170,  1366,
    1367,  1368,  1369,  2127,  2904,   617,   831,  1372,  1378,  1383,
    1384,  1385,   172,   723,  1162,  1163,  1164,  1936,   173,  1207,
     998,   724,  1157,   175,   725,  2173,  2946,  3663,  3664,  3665,
    3668,  4635,  4206,   726,  2942,   178,  1978,  2710,  2713,  2938,
     727,  2951,  2952,  2953,  3671,   728,   746,  1060,  2604,   729,
    1304,   183,   184,   185,   840,   834,   835,  2909,   187,  2086,
    2885,   762,  1389,   800,   801,   849,  2476,  2139,  2140,  2164,
    2165,  1398,  1399,  2152,  2156,  2157,  2929,  2922,  2145,  4191,
    4884,  4885,  4886,  4887,  4888,  4889,  4620,  2160,  2161,  1401,
    1402,  1403,  2169,   188,  2889,  3622,  3623,  3624,  4168,  4169,
    4183,  4179,  4605,  4871,  3625,  1197,  1409,  4613,  5459,  3626,
    4860,  4861,  5077,  4187,  3633,  3659,  3352,  3353,  3354,  3627,
    5246,  5247,  5456,  5457,  5079,  5080,  2196,  1869,  1098,  1305,
    1099,  1881,  1306,  1853,  1101,  1307,  1308,  1309,  1104,  1310,
    1311,  1312,  1107,  1845,  1313,  1314,  1863,  1878,  1879,  1373,
    5081,  1316,  1317,  1318,  3629,  1319,  4121,  4569,  4555,  2811,
    2812,  2109,  4117,  3564,  4111,  2081,  2875,  4893,  5098,  5099,
    3606,  4147,  4585,  4858,  5238,  5357,  5358,  5445,  1320,  1321,
    1322,  2872,  2077,   909,  1323,  3902,  2079,  2805,  1641,  1642,
    1981,  2003,  2757,  2773,  2774,  2849,  2785,  3523,  2793,  2798,
    3551,  3552,  2806,  2835,  1324,  2759,  2760,  3505,  2005,  1325,
     953,  1645,   954,  2000,  2830,  1333,  1326,  1327,  1972,   824,
    4867,  1152,   865,  3130,  1725,   956,   759,  1328,  1329,  1330,
    1331,  1519,   880,  1119,  1120,   614,   606,   882,  3106,   615,
     608,   609,  1730
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     605,   907,   792,   839,   823,  1025,   186,  1572,  1933,   181,
    2405,  1063,   176,  1334,   177,  1639,   179,   756,  1338,   758,
    1188,  1189,  1190,   764,   908,  1889,  1194,   186,  1859,   781,
     789,   756,  2229,   796,   873,   850,   789,   789,  1953,   825,
    2335,   828,   913,  1731,  1404,   918,  1423,  3482,  1364,  1621,
    2306,  1633,  1577,  2298,  3311,   656,   860,   748,  1165,   603,
    3392,  1865,  1797,   748,   826,  1993,  2318,  2479,   916,  2964,
    2966,  3745,  1365,  3725,  2572,  1849,  1850,  1352,  2307,  1010,
     754,  3132,   938,  3635,  2716,  1858,  3953,  3657,  2470,  4235,
    4197,   710,  1215,   171,   793,  2756,  3969,  1061,  1486,  3334,
    4001,  3225,  1782,  4001,  3769,  3191,  3771,    66,  1514,  3463,
    4134,  3670,  1159,  4274,   722,  4472,  3904,  4230,  1810,  4433,
    1770,   844,  4182,  1142,  1775,  4493,  3646,  4482,  1726,  1779,
    1072,  2891,  4236,  1536,  4803,  4864,  2432,  2433,  1553,  1789,
    1130,  4298,  3572,  1134,  3982,  4810,  1063,   852,    75,  2820,
     837,    78,    79,  1813,    80,  4165,  2289,  2901,  2592,  2934,
     853,    81,  4481,   103,   121,   612,   126,  2428,  2910,  1151,
    1370,  2202,   664,  4764,   786,   812,  4652,  2655,  1132,   931,
    1364,   820,  1843,  1370,   151,   155,   605,   863,   863,   866,
     174,   863,  1145,  2931,  2459,   875,   180,   825,  3676,  1481,
     910,  4212,  4992,   875,  3589,  3966,   875,  1397,  1400,   825,
    4876,   863,  4878,  2125,   825,  5049,  2289,  4921,   863,  4100,
     825,  4802,   730, -1911, -2403, -2441,   621,  5210,   670, -2464,
    4649,  1836,  1345,  2289,  5036, -2501, -2303, -1878,  2120,  1481,
    1809,  4180,  2533,  4185,  1481, -2303, -2303, -1891, -2275,  1849,
    1850,  1865,  1846,  1847,   858,  2790,  3324, -2304, -2331,  4944,
   -1916, -2406,  2049,  1857,  3991, -2670, -2304, -2304,  1445,   730,
    1858, -1906,   730,  1761, -2670, -2670,   670,   730,  5129,  3675,
    3529,  1515,  4560,   670,  4443,  3927,  1170,   730,  3270,  1174,
    3271,  2055,  -423,  1880,  3275,  1224,  3277,  3278, -2274,   670,
    2468,  2469,  1836,  4954,  4955,  3282,  3283,  3284,  4533,  4534,
    4997,  4536,  4537,  4538,  4539,  4540,  2213,  2726,  4984,  3301,
    2049,  1766,  2828,  2057,  5192,  5452, -1919, -2162,  3250,  2309,
    3109,  3726, -1919,  2084, -2162,   829,  1342,  3721,  2235,  2426,
    3480,   670,   943,  2828,  3467,   871,   670,  2506,  4494,  2055,
    1836,  -135,  2099,   182,  1515,   670,  3469,  -135,   670,  2581,
     730,  4998,  4469,  1823,  4980,  2869, -1734,  4311,  3430,  4999,
    3432,  5114,  2870,  1836,   182,  4444,  2525,  1446,  1836,  2968,
    4431,  2057,  4633,  3110,  2582,   847,  5235,  4470, -2462,   997,
     736,   736,  5043,  3118,  1201,   736,  4048,  5000,  1200,  2439,
    5044,   736,  4419,  5342,  2876,   838,  1518,  2358,  2444,  5164,
    5420,  5421,  2136,  1571,   737,   737,  5094,  1846,  1847,   737,
    2569,  3421,  1599,   798,   736,   737,  3302,   736,  2530,  2143,
    3529,  4316,  1626,  2702,  2936,  3630,  5453,  3471,  2372,  2913,
     944,  2284,  1453,  3164,  1857,  2091,   943,  1192,   737,  2540,
    1836,   737,  5001,  1731,  5037,  1633,   908,  2997,  3632,  3831,
    4445,  3661,  3892,  2100,   616,  5002,  2326,  1545,  4414,  4765,
    2537,  5212,  3779,  5091,  2309,  5126,  2344,  5003,  1928,  4312,
    3111,  1929,   730,  1155,  2310,  3780,  1063,  2121,  3630,   945,
    1546,   670,  4415,  1019,  2574,  2389, -2181,  3662,  4986,  1029,
    2327,  1836,  3672, -2181,  1063,  2309,  3832,   908,  5308,  2309,
     843,  1837,  1043,  2998,  2092,  5330,  4766,  3472,  2703,  3827,
    3164,  2309,  1984,   799,  2914,  2144,  2309,  2043,  2541,  5236,
    1767,  1193,  5422,  2309,  2285,  1875,  2014, -1734,  1447,   851,
    2937,  2359,  2877,  4317,   944,  2888,  2531,   946,  4049,  1836,
    2309,  1454,  2309,  5523,  4420,  2089,  1591,  5165,  1086,  5237,
    1590,  1937,  3951,  5045,  1227,  2526,  5017,  3468,  1063,  4432,
     671,  5266,  1917,  2583,  3525,  1731,  4471,  1448,  4660,  3470,
    2101,  3503,  1837,  2969,  4313,  5454,  2970,  2049,  2507,  3726,
    5455,  4634,  2474,   945,  3722,  5163,  3010,  3119,  1726,  3904,
    2570,  1351,  4401,  2408,  1525,  5478,  1976,  3921,  3264,  2534,
    1449,   957,  1897,  3303,  2085,  4446,  2055,   825,  2373,   863,
    1193,   863,  4985,   866,  4333,   863,  3992,  1226,   186, -2462,
    1837,  1002,   910,   872,   999,  1887,  1000,  1032,  1001,   863,
    1977,   951,  1767,  5329,  5341,   952,   863,  3112,  2057,  2518,
     665,   946,  4574,  1837,  1997,   830,  4182,  1844,  1837,  2236,
    2427,  5118,   622,  1838,  5004,  1193,  2421,  5005,  3251,   839,
     605,  5522,  1166,  2829,   866, -2162,  1973,  2400,  1450,   875,
    2403,  1935,  5205,   910,  4442,  4447,   875,  1063,  3529,   875,
    1767,   993,  1983,  4240,  3595,  1063,  1063,  3415, -2462,  1639,
    1639,  1639,  3304,  1405, -1911,   863,  4602,  2410,  1994,  1063,
    4606, -2462,  5542,  2871, -2403, -2441,  4489, -2303,  1848, -2464,
    3691,  1196,  5476,   186,  5291, -2501,  4490,   951,  1852, -2275,
    1837,   952,  2076,  4846,  1866,  2467,   742,   743, -2304,   742,
     743, -1916,  2352,  4545,   742,   743, -2670,  5424, -2331,  4638,
    3544, -2406, -1906,  2890,  1516,  1517,   825,  2045,  1158,   789,
     789,   789,  2170,  2171,  2087,  5414,  1167,  2571,  1172,  1748,
    1176,  2445,  1860,  2097,  1216,  4593,  1180,  4595,  1860, -2274,
    2894,  1837,  1884,  1767,  1455,  1196,  4836,  2073,  2074,  2075,
    2076,  2440,   908,  1861,  1332,  1332,  1545,   825,   789,  1861,
    2446,   852,   789,  1743,  2676,  1895,  3904,  1862,  2293,  1750,
    1919,  1161,  1751,  1864,   853,  1408,   825,  5385,  5309,  1546,
     825,  1632,  2659,  1736,  -135,  -135,  1332,  1516,  1517,  1837,
    5389,  1460,  2706,  2475,  2132, -1878,  2458,  5362,   825,  1051,
    3828,  3678,  3052,  3679, -2181,  5110,  4799,  1456,   186,  5480,
     825,   181,  3051,   772,   176,  5264,   177,  3126,   179,  5334,
    5269,  2293,  3070,  2686,  3863,  5340,   825,  2103,  3884,  3885,
    3672,  2319,  2115,  2115,  2698,  1605,  2633,  3966,  2293,  4072,
    3824,  4262,  1922,  4303,   825,   881,  2126,  2130,  4405,   863,
     863,  2130,  2758,  3945,   917,  4661,  2360,  3541,  3542,  3543,
    3544,  3011,  1183,   786,  1202,  1204,  3922,  1977,   939,   670,
    1015,   670,  5521, -1878,  1836,  3288,  4404,  1606,  4220,  3127,
    4822,   789,   789,  3651,  5318,   666,  3260,  2563,   847,  3156,
    1113,  5466,  1375,  1887,  1805,   171,  5105,  1341,  3640,   773,
    4464,  1349,  5472,  2516,  1332,  1332,  5333,  4717,   854,    66,
    2687,  2274,  2975,   605,  5539,  1806,  2707,  1801,  2931,  1741,
    3024,  3738,  2766,  5019,   875,   670,  5484,  5485,   910,  2854,
     875,  4718,  1438,   875,  2289,   182,  2237,   616,  3042,  2276,
    1052,  4041,  5030,   667,  4557,  5415,  5503,  3087,   863,  2283,
      75,  4210,  3673,    78,    79,   618,    80,  5423,  3638,  1802,
    3878,  3879,  1537,    81,   757,   103,   121,  1860,   126,  5020,
     825,  3157,  2564,  2351,  1354,  4331,  2405,   863,   863,  3526,
    3527,   668,   670,   669,  3546,  1906,   151,   155,  1861,  2993,
    2615,  2616,   174,   855,  3739,  4507,  4862,  1185,   180,   825,
     825,   825,  1862,   863,  4235,   605,   605,   605,  3088,  5070,
    3042,  4928,  2071,  2072,  2073,  2074,  2075,  2076,  2943,  3043,
    2983,  3576,  3577,  2231,  3158,   786,  1202,  1907,  2767,  5544,
     182,   838,  4841,  1630,  4236,  3877,  2390,  5486,  2447,  2393,
    2394,  5490,  -679, -1878,  2581, -1095,  1411,  4236,  1607,  2753,
    2585,  2232,  4360,  3974,  4558,  4865,  5473,  4457,   774,  1234,
    5399,  5106,  3529,  4424,  4469,  2855,  3530,  3531,  3532,  2582,
    2856,  1538,   891,  1807,  3906,   863,  3289,   863,   863,   892,
     893,   894,  3159,  1871,  1859,  2238,  4549,  1053,  4550,  4470,
    1829,  3043,  1731,  5520,  4002,  3253,  1610,  3747,  4868,   775,
     776,  2768,  1611,  4872,   845,  5059,  4874,  2857,  2223,  5185,
    1332, -2272,  1639,  3539,  3540,  3541,  3542,  3543,  3544,  2708,
    3909,  4823,  1427,  1054,  3630,  3382,  2224,  3630,  1871,  5348,
    1803,  3813,   186,  4530,  3901,  5204,  2320,  5543,  1731,  2709,
    1955,  1955,  2695,  2696,  5184,   825,  5207,   756,  5219,  2321,
    5499,  2322,  1608,   851,  1837,   182,  1872,  5554,  1016,  3794,
    5555,   761,  2769,   772,  2223,  2770,  2688,  4795,   825,   846,
    4789,  1186,  2448,  4001,  1990,  2239,  3911,   825,  1114,  4003,
    1996,  5206,  1055,  2565,  2225, -1735,  3160,  2345,  1056,  4644,
    2826,  4719,   777,   730,  1332,  3046,  2944,  2566,  1908,  3630,
    2233,  1872,  2420,  2226,  1428,  1612,  3748,  1742,  3025,  1631,
    4425,  4801,  2323,  4236,   839,  1355,  2963,  1873,   856,  5071,
    1874,  2488,  2496,  2043,  3998,  1332,  4361,  2146,  5500,  1165,
    2614,  4551,  1539,  3713,  1804, -1878,  5440,  3209,  4675,  3533,
    2225,  1412,   770,  3210, -1878,   847,  1848, -1878,  1422,   773,
   -1878,  2858,  2609,  1332,  1332,  1332,  1429,  1332,  4776,  2226,
    5400,  3534,  1873,    41,  2497,  1874,  5172,  3046,  3795,  4750,
    2147,  1540,  3934,  4920,  3914,  3714,  2771,  1332,  5324,  1020,
    5438,  5060,  2128,  2668,  1356,  1020,  1939,  2653,  1941,  4943,
    1943,  2634,  1945,  5108,  1947,  1948,  1949,  1220,  1020,    45,
    3042,  1951,  1909,  3652,  1541,  5349,  2647,   908,  3161,  2649,
    2137,  2138,  5501,  2142,  5039,   825,  3162,  3915,   951,  3163,
    5066,  4200,   952,   853,   853,  1408,   853,  2395,  5040,  3535,
    2636,  1875,  2148,  3916,  4004,  4637,  3825,  4417,  2661,  1726,
    5401,    49,  3644,  2935,  2648,  1332,  3211,  4927,  2783,  1332,
    1332,  2227,  1387,  1430,    50,  1503, -1735,  2654,  3360,  5125,
     825,   825,  2176,  5208,  1332,  2985,  1613,  5402,  5087,  2689,
    3055,  1767,  2692,  2693,   635,  2685,  1875,    51,  2366,  2690,
    2149,  3043,  5441,  2694,   848,  1583,  2697,  2772,   789,  4173,
    4958,  2945,  2717,   771,  1234,  2383,  5173,  3529,  1887,     3,
       4, -2671, -2671, -2671,  4005,  1614,  4418,  2227,   774,  3826,
    3749,  3750,  5128,  2212,  1887,  3142,  3044,  5132,  5133,  4502,
    4528,  4759,  4174,  2280,  1370,  5532,  1584,  4301,   789,  3796,
    3917,   863,   821,  3175,   637,  2498,  1585,  4608,  1615,  3751,
    2150,  3935,  1876,  -577,   825,  2308,  3715,  4176,  4198,   775,
     776,  2986,  1388,   825,  3215,  3045,   863,  5502,  3630,  1830,
     716,  5261,  2396,  3056,  2228,  2397,  4677,  2241,  3797,  3904,
    3116,  5174,  3218,  4682,  3653,  4862,  1887,  2242,  2146,   182,
      15,   619,   794,   910,  1887,   825,  5029,  1876,   789,  3143,
    2269,   635,  4201,  3216,  1393,  3140,  1453,  1503,  2997,  1639,
    4302,  3798,  3428,  5041,  4236,   789,  1877,  3212,   825,  1574,
    4199,   825,  2423,  1831,    20,  3418,  1063,  1435,  5267,  1436,
    2228,  2147,   635,  3536,  3537,  3538,  3217,  3539,  3540,  3541,
    3542,  3543,  3544,   863,  4760,  5038,   897,   898,   899,  2499,
     900,   901,   902,   903,   904,   905,  3213,   825,  1575,  2002,
    3716,   637,  4243,  4744,  3694,  4065,  3195,  3046,  2107,   863,
     863,   863,   863,   825,  4423,  4178,  1395,  4790,  1527,  2011,
      41,   943,  3331,  2405,  3149,  3150,  3419,   825,  3153,  3214,
     189,   189,   637,  4463,  3140,  3238,  4745,   797,  1332,  1332,
    1332,  1611,  3737,   189,  1586,  3343,  3344,  3345,  3346,  4458,
    2108,  2028,   648,  1393,   649,  1454,    45,  3351,   832,  5338,
    1438,  1832,  2217,  1396,  4657,  1438,  2040,  3901,  3224,  2980,
    3254,  3255,  3256,  2218,   190,   190,  4084,  1542,  4085,  1587,
     654,  2149,  3379,  1588,  4244,  2243,  2336,   190,  1466,  4393,
    1528,  2219,  4329,  4396,  4397,  4953,  4399,  1767,    49,  4222,
    2645,  2680,  3750,  1171,  1173,  1175,  3299,  1576,  1177,  1178,
    1179,    50,  2607,  4028,  3535,  3260,  1589,  1833,  1184,   944,
    5382,  3872,   908,   908,  2244,  1395,  -448,  2635,  3630,  3401,
    4289,    41,  3630,  4658,    51,  1438,  2480,  4630,   825,  1438,
    1875,  2150,  5157,  5277,  1612,  4245,    33,  5158,    52,  4246,
     863,   863,   851,   851,  4195,   851,  4982,   841,  1393,  4512,
    1555,  4513,  3223,  1394,   927,  5191,  5016,    45,   945,   648,
     863,   649,  4080,  4081,  4082,  4083,    41,  3829,  4088,  4089,
    4090,  4091,  4092,  4093,  4094,  4095,  4096,  4097,  -158,   825,
    3330,  5218,  1601,   928,  3065,  4236,  2049,  1783,  5159,  1556,
     648,  1355,   649,  3068,    41,   863,   863,   863,   863,    49,
    4950,  4086,    45,  1834,  1432,  5278,   842,  3649,   825,  5211,
   -2294,  4087,  3864,   730,  -158,   825,   946,  2480,  1783,    41,
    1395,  1602,  5488,  4951,  3154,  1603,  1044,  4138,  4139,   605,
      45,  5197,   605,  2220,  -448,  2700,   866,  2337,  2681,   908,
      36,  1922,  1332,  -158,    49,  2535,  4040,  2057,   717,    52,
    3697,  4835,  5058,   858,  1604,    45,   745,    50,  3372,  5338,
    1356,  1045,   745,  5198,  3901,  4236,  2338,  1396,  4223,  2375,
    2682,  1347,    49,  1220,  4224,   867,  1887,   875,   875,  3174,
      51,  4225,  2314,  2683,  2315,    50,  3823,  4041,   910,   910,
    3089,  2339,   875,  2095,   718,   875,  1046,    49, -2671, -2671,
   -2671,  3978,  3539,  3540,  3541,  3542,  3543,  3544,    51,  3176,
      50,  2049,   863,   863,  3199,  2461,  4226,  3179,  2684,   863,
    3182,   825,    52,  5546,   857,   736,  2334,  1545,  5121,  5427,
      29,  1413,  4001,    51,   186,  3219,  2711,  2232,  4227,  5331,
    2055,  1063,  3221,   869,  1047,  2316,  1955,    52,  3244,   737,
    1546,  3090,  2414,   863,  2462,   875,   889,  2723,   875,   875,
    4763,   825,   825,  4903,   863,  4905,  4236,  2633,  3220,  1811,
    1414,   825,  2057,  4277,  4907,  3222,   933,  5332,   825,  4664,
    4665,  2415,  4915,  2395,  3562,   756,   756,  5188,   186,  2728,
    3569,  1002,  1812,  1332,   999,  1332,  1000,  1063,  1001,  4794,
    1332,  1332,   890,  1415,  5202,  1044,  4278,  1332,  1332,  1332,
     604,  4774,  1332,  5054,  1332,   910,  1332,  1332,  1332,  1332,
    1332,  1332,  1161,  1332,    41,  1332,  1332,  3395,  1860,  1332,
    4780,  4241,  3478,  3479,  1017,  1914,  1018,  3499,  1424,  2326,
    1045,  5229,  2130,   942,  1332,  1332,  1332,  1332,  2722,  1861,
     950,   863,  1332,  3030,  4781,  4075,  1332,  1545,  1915,  1332,
      45,  1418,  1332,  1332,  1332,  1332,  1332,  1332,  1332,  1332,
    1332,  2749,  1332,  2327,  1004,  3947,   908,  1425,   825,  1332,
    1546,  1332,  3634,  3441,  4101,  1006,  4279,  5228,   825,  3026,
    4243,  5426,  3031,  3032,  -135,  2670,  1419,  2671,  1580,  2672,
    1420,  2673,    49,  2674,  4172,   716,  5416,  2675,  4754,  2309,
    1426,  1985,  3791,  3018,  1986,    50,  5271,   825,  2396,  2317,
    1021,  2397,  1022,  1047,  1332,    15,  1009,  1938,   825,   825,
    1940,  2907,  1942,  1421,  1944,  5166,  1946,  1581,    51,  1332,
    1950,  4413,  4172,  3630,  3677,  3455,  1012,   765,  1332,  1332,
    3630,  3792,  5428,   951,  2908,  3630,  3064,   952,  3630,    20,
    3636,  2463,   825,  5195,  5320,  4379,  1026,  5162,  4362,  2949,
    1582,  2954,  4244,  1039,  2464, -1666,   766,  4173,  3727,  -576,
     767,  3630,  2947,  2987,  3793,  2990,  4380,  5479, -1666,  4288,
    1048,  4363,   628, -1666,  3630,  4735,   861,  4736,  4737,  3954,
      29,  4738,  2465,   866,  3755,   874, -1705,  1860,  3456,  3964,
    4174, -1705,   756,   874,   756,  4173,   874,  5154,  3593,  5156,
    1558,  2903,  1548,  5160,  5161,  4175,  4465,  1848,  1861,  1422,
    3050,  1332,  4950,  4245,  3155,  4176,  1063,  4246,  1049,  1559,
   -1666,  1618,  1864,   605,  1622,   863,   863,  4950,  4174,  1050,
     875,  2984,   910,   875,   875,  4951,   863,  1065,   863,  2376,
   -1666,  4177,   863,  4175,  2379,   825,  3348,  5384,  5545,  1069,
    4951,  3349,  5196,  4176, -1665,  3500,  2123,   635, -1705,  2124,
    3501,   182,  4280,  1112,  4287,  1535,   789, -1665,  1922,  1560,
    1552,  2001, -1665,    52,    41,  5260,   845,  2308,  4263,  4177,
   -1089,  4272,  2453,  5411,  1122,  3075,   825, -1666,  3905, -1706,
    3682,  3241,  3086,  3349, -1706,  1848, -1666,  2203,  1639,  4492,
    1121,   825,  1427,  4053,  1639, -1705,  4869,  1196,  1196,  1128,
      45,  1196, -1666,  2129,  2450,   182,  2130,   637,  2456, -1665,
    1139,    33,   825,  4917,  2602, -1666,  2603,  3131,  3131,  1234,
   -1666,  1146,  3529,  4178,  4304,  1063,  3530,  3531,  3532, -1665,
    3630,   846,   825,   825,  2134,  3950,   825,  2124,   866,   789,
    3893,    41,    49,  4126,  1855,  1856,  1561,  4219,  5464,  4016,
    4017, -1706,  1848,  1156,  2203,    50,  5475,  2665,   228,  3335,
    2130,  4178,   863,  2677,   620,   863,  2678, -1666,   730,   951,
    2336, -2275,   714,   952,  1428,  1187, -1665,    45,    51,  1195,
    3923,  2679,  2834,  2115,  2678, -1665,  1191, -1666,   825,   825,
    3630,   795,    52, -1420,  1562, -1420,  1208,  1563, -1706,  2839,
    2840,  2841,  2842,  3226,  2336,  3229,  3231,   847,  2472,  2473,
    2336,  3704,  2404,  1198,  3555,  3686,  3557,  3558,  2714,    49,
    3189,  2715,  5513,  1217,  2906, -1666,  1429,  1922,  2955,  2932,
    2933,  2130,    50,  5510, -1666,  1206,  1332,  1332,  1332,  3683,
    3684,  2516,  1332, -1666,  2539,  1210,  1565,  3062,   863,  4870,
    3063,  3134,  2556,  1209,  3135,    51,   863,  3294,  3406,   863,
    3295,  2130,  1213,  1196,  2453,   863,  5010,  1218,  2813,    52,
      41,  2816,     3,     4,  1332,   648,   863,   649,  4483,  3447,
    1219,  3498,  2678,  5221,  2130,  1220,  2402,  3195,   651,  3507,
    2308,  1567,  2130,  3131,  3513,   825,   182,  2130,   825,  1221,
     653,  3514,  3333,  1783,  2130,   756,    45,  4960,  3975,  3515,
    3976,  3730,  2130,  1568,  1223,  4238,  4239,   863,  1332,  3548,
    2429,  3534,  2130,  1430, -1665,  3561,  2460,  4476,  2130,  3382,
    1848,  2337,  2203,  1570,  3630,  3226,  1228,  3901,  3489,  5461,
    2637,  3492, -1729, -1729,  3493,   863,   848,  3365,    49,  1222,
    3566,  3156,  3336,  3567,  3609,  5378,  3610,  2336,  1230,  3361,
    2338,    50,  1350,  3485,  5111,  2337,  3940,  2453,  3420,  3422,
    3423,  2337,  5116,  3317,  3772,  1332,  3777,  3773,  3802,  3778,
    1353,  3803, -1666,  1431,    51,  2339,  3786,  1357,  2336,  3535,
    1432,  4406,  3630,  4407,  2338,  1358,  2336,  3807,    52,  1359,
    2338,  3611,   863,  3612,   863,  3131,   863,  3131,  3861,  1363,
    3987,  3803,  1063,  3988,  1063,  3989,  3816,  1371,  3990,  2339,
    2334,  3630,  1433,  1376,  4012,  2339,    36,  4013,  5528,  1234,
    5529,  2753,  3529,  3157, -1733, -1733,  3530,  3531,  3532,   908,
    1379,  5397,  1955,  2633,   951,  2336,  4014,  1379,   952,  2130,
     861,  1377,  5527,  4127,  2334,  1434, -1732, -1732,  4107,   874,
    2334,  4108,  4118,  5050,  4129,  4119,   874,  2130,  1379,   874,
   -1654,  1558,  4208,  3053,  4213,  4209,  1390,  4214,  1392,  2336,
    4218,  4044,  4242,  2970,  1374,  2678,  3158,  1435,  4466,  1436,
    1559,  2678,  4607,   605,  4610,  1063,  1391,  4288,  3924,   875,
    3926,  1380,   875,  3645,  3128,   875,  5359,  5360,  1407,  1633,
     839,  4113,  3821,  4525,   863,  1410,  1977,  5560,  2337,  1406,
    4546,  4575,  1332,  2130,  2715,  4587,  3630,  1332,  2130,  4640,
    4646,  1458,  2970,  4647,  2753,  5446,  5447,  1416,  3318,  1437,
    1560,  1422,  4653,  4654,  3159,  2678,  2678,  2338,  1484,  2337,
    4838,  1332,  1332,  1332,   839,  4796,  1332,  2337,  4797,  4828,
    4843,  3830,  4013,  4844,  1332,  1332,  1332,  1332,  4964, -2305,
    1487,  3933,  2339,  3936,  1489,  1490,  4845,  1332,  2338,  2130,
    1332,  3995,  1332,  3536,  3537,  3538,  2338,  3539,  3540,  3541,
    3542,  3543,  3544,  1332,  1332,  3865,  4852,  1332,  4922,  2715,
    4673,  4923,  5011,  2339,  4283,  2678,  2337,  2334,  1525,  1530,
    5051,  2339,  4965,  5052,  1529,   910,  1531,  1332,  1542,  1332,
    5067,  1332,  4794,  2715,  4188,  5074,  1544,  1561,  5075,  2336,
    4281,  3534,  1557,  2956,  1554,  2338,  5084,  4966,  2334,  1922,
    2337,  1332,  1592,  1579,  5090,   825,  2334,  3961,  3160,  1593,
    5092,  2972,  3631,  3961,  4967,  1609,  5103,  2976,  4968,  5104,
    2339,  2979,  3630,  1619,  5147,  1620,   839,  5148,   825,  2338,
    3614,  3615,  3616,  4259,  2048,  1562,  1332,  2049,  1563,  4969,
    5187,  4037,  4970,  2094,  1623,  5220,  5230,  3003,  5104,  2715,
    1628,  1332,  3319,  2404,  2339,  2334,  1629,  4971,  5231,  3535,
    1732,  3567,  1734,   182,  5232,  3631,  2055,  2130,  1735,  3666,
   -2573,  3628,  3669, -2671,  2954,  5243,  5249,  5252,  5244,  1922,
    3961,  1744,  5270,  1737,  3116,  2678,  4299,  1565,  2836,  2334,
    2837,  2336,  3057,   861,  4052,  1740,  3630,  5276,  2057,  1745,
    2715,  3320,  3630,  5282,   874,  4264,  2715,  1753,  5283,  3140,
     874,  2715,  1020,   874,  2838,  1332,  5286,  3131,  1754,  2130,
    5287,  4385,  1955,  2130,  3628,  5288,  4400,  1757,  5289,  3195,
    3161,  5316,  1567,  5366,  5317,  1760,  5367,  4059,  3162,  5370,
    5371,  3163,  1922,  2130,  3107,  4972,  1763,  1765,  1771,   863,
    2337,   863,   863,   863,  1568,  5372,  5374,  5393,  2130,  2130,
    5394,  5418,  1774, -2573,  5419,  3578,  5448,  1767,  1926,  3961,
    3136,  1776,  5460,  1785,  1570,  5097,  3145,  5487,  5525,  2338,
    5104,  5526,  1786,  3151,  1790,  1824,  1825,  1826,  1791,  4570,
    1020, -2575,  5538,  3165,  4390,  2130,  4973,  5540,  -178,  3170,
    5541,  5065,  5558,  3630,  2339,  5367,  1793,  4305,  5566, -2671,
    1794,  5541,  1796, -2573, -2671,  2839,  2840,  2841,  2842,  3183,
    1798,  1491,  2843,  2844,  1799,  3186, -2573,  1492,  2845,  1814,
    3190, -2573,  1821,  2846,  1828,  1835, -2573,   208,  1840,  2334,
    1841,  1842, -2573,  3207,  3645, -2573,  1844,  1848,  1851, -2573,
    1852, -2671,  2337,  3536,  3537,  3538,  3232,  3539,  3540,  3541,
    3542,  3543,  3544,  1854,  1868,   825,  1883,  1020,  1870,  1494,
    1882,  1886,  2040,  3906,  1887,  1894,  1898,  1900, -2573,  3907,
    1901,  2338,  1903,  1910, -2575,  1905,  3581,  1911,  3582,  1913,
    1918,  3908,  1921,  1924,  1925,  1927,  1982,  1952, -2573,  1991,
    1989,  1992,  1999,  1998,  2064, -1882,  2339, -1889,  2008,  2006,
    2007, -1879,  3583, -1880,  2009,  2042,  2040,  2010,    52,  3909,
    2012,  3910,  2013,  1495,  2014,  2015,  2016,  2017,  2018,  2020,
    1496, -1883,  2021,  1497, -2575,  2022,  2023,  2024, -1881,  2834,
    2025,  2334,  2080,  2026,  2027, -2573,  2029, -2575, -2573,  2082,
    2030,  2031, -2575,  2032, -2573,  3602,  2033, -2575,  2034,  1498,
    2035,  2036,  2084, -2575,  2098,  2110, -2575,  2085,  2133,  2094,
   -2575,  3621,  2118,  2135,  2847,  3911,  1394,  1332,  1396,  2166,
    2168,  2177,  2179,  1332,  2180,  2848,  2181,  2182,  2198,  1558,
    2199,  2200,   863,  1499,  2201, -2671,  2203,  3131,  3131, -2575,
    2204,  2205,  2206,  3912,  2207,  2208,   765,  1731,  1559,  2215,
   -2573,  2209,  2234,  2839,  2840,  2841,  2842,  2246,  2271, -2575,
    3584,  2240,  2178,  4770,  3621,  2277,  3585,  2275,   838,  2753,
    2278,  3586,   825,   825,   825,  2279,  2281,  2282,  2295,  2299,
    5242,  2300,  2301,  2313,  2324,  2328,  2312,  2331,  2330,   825,
    2332,  4328,  2333,  2334,  2341,  2342,  1596,  2346,  1560,  2343,
    1501,  2347,  2348,  2357,  3985,   761, -2575,  2353,  3913, -2575,
    1502,  1955,   825,  3914,  2368, -2575,  2354,  2367,  2363,  1503,
    2369,  1955,   825,   825,  2364,  2374,  2384,   825,  2370,  2371,
    3131,  1504,  2391, -2573,  2398, -2671,  2377,  2401,  2380,   825,
    2418,  2381,  2071,  2072,  2073,  2074,  2075,  2076,  2386,  2387,
    3981,  2399,  3461,  2406,  4476,  2407,  3915, -2573,  1503, -2573,
   -2573,  2412,  2422,  2413,  2417,  2424,  2419,  2425,  2430,  2441,
    3475, -2575,  3916,  1506,  1507,  2442,  2482,  4009,  3461,  2449,
    2431,  2471,  2478,  2443,  2484,  1561,  2485,  4628,  4438,  4439,
    2486,  2487,  2491,  2492,  1196, -2573,  2493,  2454, -2573, -2573,
   -2573,  2494,  2495,  1508,  2501,  2502,  2503,  2505,   863,  2504,
    2510,  2509,  3587,  2511,  2512,  5113,  2517,  2521,  2520,   630,
    2524,  2535,  2529,  3588,  4144,  2557,   761,  2554,  2538,   825,
    2549,  2553,  2562,  1562,  2580,  2589,  1563,  1576,  2599,  2573,
    2593,  2576,   825,  2601,  2579,   825,  2605,  2596,  2617,  2619,
    2627,  2404,  2610,  2611, -2575,  2620,  2628,  2630,  2629,  4517,
    4518,  4519,  4520,  4521,  2631,  2638,  2640,  1332,  2642,  3917,
    2641,  1509,  2643,  2691,  2656,  2657,  1332,  2699, -2575,  2712,
   -2575, -2575,  4742,  2763,  1332,  1565,  1332,  2624,  2725,  1332,
    2808,  2625,  2758,  2814,  1332,  1332,  1332,  1332,  2049,  2818,
    1332,  1332,  1332,  1332,  1332,  1332,  1332,  1332,  1332,  1332,
    2827,  2833,  2851,  1332,  1332,  2873, -2575,  2874,  2888, -2575,
   -2575, -2575,   839,  1332,  2853,  4522,  2896,  1332,  2893,  2048,
    1567,  1332,  2049,  4625,  2898,  2924,  4815,  2899,   846,  1332,
    2897,   839,  1332,  2926,  1332,  2912,  2948,  2927,  2925,  2941,
    2959,  2960,  1568,  2962,  2993,  2048,  1332,  2995,  2049,  1332,
    1332,  2055,  2988,  2996,  1332,  1332,  2991,  3645, -2671,  4148,
    3002,  1332,  1570,  3019,  3007,  3012,  3013,  3015,   825,   825,
     825,   605,  3037,  3038,  3631,  4170,  3017,  2055,  3041,  4170,
    4184,  4170,  3645,  2057, -2671,  3023,  1332,  4152,  4153,  4154,
    4155,  3054,  3059,  3027,  1347,  1351,  3061,  3078,  3071, -2591,
    3091,  3096,  3122,  3123,  3097,  3129,  3124,  3141,   186,  2057,
    3133,  1002,  1332,  3169,   999,  3185,  1000,  3148,  1001,  3227,
    3240,  3168,  3252,  3267,  3248,  3249,  2954,  3272,  1332,   847,
    3628,  3261,  3273,  3628,  3274,  3280,  3285,  3308,  3309,  3296,
    3323,  3327,  3329,  3325,  5504,  5505,  4237,  1955,  1955,  3347,
    2480,  3338,  4755,  3355,  3341,  3702,  3356,  3363,  3358,  3350,
    3359,  3366,  3357,  3368,  3370,  3371,  3374,   863,   863,   863,
     863,  3375,  3393,  3394,  3396,  3397,  3592,  3398,  3400,  3402,
    3407,  3410,  3409,  3412,   182,  1875,  3425,  3437,  3439,  3411,
    2612,  3440, -2591,  3413, -2671,  3446,  2308,  3417,  3426, -2671,
    3444,  3449,  3454,  3450,  2405,  3628,  3462,  2726,  3451,  3452,
    3453,   182,  4671,  1922,  4293,  1919,  1884,  3466,  3464,  3473,
   -2671,  3465,  3481,  3483,  3476, -2671,  3490,  1193,  5117,  3491,
    3509,  3510,  3495,  3488,  3512,  3511, -2671,  3525,  3487,  3516,
    3517, -2154, -2591,  3580,  3563,  3575,  3521,  3591,  3524,  3547,
    3605,  3553,  3590,  2130,  3560, -2591,  3574,  3680,  4681,  3600,
   -2591,  3641, -2671,  3601,  3645, -2591,  3782,  5151,  3603,  3604,
    3607, -2591,  3642,  3656, -2591,  3647,  4720,  4721, -2591,  4723,
    3632,  3667,  3654,  3660,  3685,  3674,  3687,  3658,  3696,  2064,
    3699,  3692,  3693,  3688,  4713,  3701,  3723,  3724,  3734,   861,
    3735,  3708,   861,  3736,  3740,  3741,  4340, -2591,  3742,  3743,
    3757,  4382,  3746,  3758,  3760,  2064,  5141,  4348,  5143,  3768,
    3766,  3767,  3781,  3776,  3790,  3804,  3806, -2591,  3810,  3808,
    3811,  3812,  3817,  3815,  3818,  3819,  3820,  3834,  3822,  1977,
    3835,  2752,  3850,  2755,  3836,  3837,   863,   874,   874,  2762,
    3838,  3841,  3853,  3844,  3839,  2776,  2777,  2778,  3855,   825,
    3840,   863,   874,  1332,  3842,   874,  2795,  2797,  2439,  3857,
     825,  2807,  3843,  3845, -2591,  4963,  4429, -2591,  3846,  3847,
   -2671,  3848,  3873, -2591,  3849,  3859,  2308,  3860,  3866,  3889,
    3876,  3867,  3880,  4772,  3869,  3870,  3871,  3881,  3883,  3891,
    3932,   825,  3931,  3941,  3938,  3631, -2671,  3942,  3944,  3946,
    3949,  3960,  3961,  3963,  2040,  3226,  3979,  3980,  3970,  3984,
    3999,  4008,  3973,  4011,  4477,   874,  3986,  4018,   874,   874,
    4159,  3983,  4022,  4164,   825,  4019,  4020,  4031,  2480, -2591,
    4032,  4033,  5008,  4034,  4035,  1332,  1332,  2048,  4487,  4038,
    2049,  4036,  4046,  4024,  5293,   182,  4043,  4047,  4045,  4056,
    4057,  4058,  4060,  4061,  3628,  4062,  4063,  4064,  4068,  2001,
    5299,  5301,  3529,  3550,   908,  4910,  3131, -2153,  3131,  2055,
   -2671,  4078,  3549,  4103,  4104,   825, -2671,  2071,  2072,  2073,
    2074,  2075,  2076,  4131,   761,  4105,  4120,  4133,  4162,  4145,
    4190,  4202,  4186,  4205,  4211,  4207, -2671,  4229,  4250,  4221,
    5073,  2057,  4252,  2071,  2072,  2073,  2074,  2075,  2076,  4258,
    1332,  4265, -2591,  4268,  4112,  4132,  4271,  4136,  4934,  4192,
    4163,  4151,  1332,  4194,  4196,  4171,  4253,  4266,  4269,  4275,
    4273,  4276,  4291,  4306,  1234,  4307, -2591,  3529, -2591, -2591,
    4294,  3530,  3531,  3532,  4308,  4309,  4310,  4320,  4321,  4322,
    4323,  4324,  1332,  4325,  4334,  1332,  4336,  4337,  4577,  4350,
    4351,  4356,  2048,  1332,  1332,  2049,  4359,  4815,  4137,  4376,
    1332,  1332,  4375,  2453, -2591,  1332,  4378, -2591, -2591, -2591,
    4282,  1332,  4392,  4381,  1332,  1332,  4391,  4394,  4395,  1332,
    4586,  4039,  4398,  4410,  2055,  1332,   825,   825,   825,   825,
    5395, -2671,  4421,  4170,  4184,  4170,  4435,  1332,  4170,  4441,
    4449,  4600, -2671,  4455,  2678,  3631,  4055, -2671,  4456,  3631,
    4459,  4461,  4468,  4484,  4929,  4615,  2057,  4462,  4478,  4485,
    4495,  4501,  4503,  4505,  4500,  4506,  4504,  4508,  4511,  4515,
     910,  4523,  4527,  4529,  4642,  4535,  4548,  4559,  4542,  1332,
    4562,  4543,  4553,  3666, -2671,  4563,  4552, -2155,  2954,  4603,
    4564,  4604,  4611,  4612,  4617,  4568,  4629,  4631,  4583,  4599,
    4596,  4601,  4616,   756,  3628,  4618,  1332,  4619,  3628,  4624,
    4627,  4626,  4636,  4643,  4639,  4641,  4649,  4655,  5293,  4659,
    4678,  4679,  4680,  4140,  4683,  4689,  3131,  3131,  4648,  4690,
    4691,  4712,  4710,   861,  5306,  4703,  4715,  2064,  4706,  4724,
     874,  1867,  4716,   874,   874,  2308,  4725,  4732,  2159,  4733,
    4734,  4739,  4743,  4746,  4747,  4752,  4753,  4761,  4762,  4756,
    4685,  1885,  4771,  4767,  4768,  4769,  3534, -2671,  4775,  5140,
    4777,  1896, -2671,  4785,  4788,  1899,  4800,  4793,  4804,  1902,
    4798,  1904,  4805,  1063,  3621,  4809,  4807,  1912,   607,  4811,
    4676,  4812,  4813,  1920,  4820,  4825,  1923,  4832,  4839,  4833,
    4684,  4840,  4842,  5083,  4963,  4848,  4849,  4850,  4851, -2671,
    1332,  4892,   182,  4857,  5083,  4873,  4898,  4901,  4904,  4914,
    4863,  2048,  4919,  4924,  2049,  4866,  4877,  4925, -2671,  4926,
    4895,  4918,  4931,  4916,  3535,   863,  4956,  4937,  4938,  4978,
    4942,  4947,  4420,  4948,  4949,  4987,  4989,  4995,  4990,  4996,
     863,  4993,  5014,  2055,  5015,  5027,  5022,  5034,  5024,  5032,
   -2671,  5053,  2064,  5057,  5055,  5268,  5056,  5072,  5076,  5082,
    5097,  5120,  5086,  5089,  5093,  5095,  5112,  5101,  5122,  5123,
    5135,  5129,  5169,  5167,  1332,  2057,  4260,  5175,  5179,  5182,
    5180,  5189,  5194,  5145,  5200,  5209,  5201,  5215,  5213,  5214,
     605,  5365,  5216,  5217,  5224,  5225,  2308,  5227,  5241,  5226,
    5254,  5233,  5258,  5257,  5279,  1955,  3340,  5262,  5263,  5275,
    5305,  5298,  5304,  5310,  5312,  5319,  5322,  5323, -2671,  5315,
    1332,  5346,  5343,  5345,  5351,  2071,  2072,  2073,  2074,  2075,
    2076,  5344,  5352,   863,  5363,  3365,   908,  5379,  5361,  4146,
    5388,  5390,  4141, -2671,  5381,  5398,  5308,  4791,  5309,  5265,
    5153,  5406,  5396,  5439,  5405,  5407,  5444,  5425,  5451,  5458,
    1063,  5463,  5471,  3405,   607,  5498,  4935,  5506,  5530,   825,
    5468,  5477,  5531,   607,   883,  5508,  5496,  3645,  5497,  5512,
    5535,   607,  5533,   883,   607,  5548, -2671,  5534,  5559,   908,
    5556, -2671,  4364,  5549,  3621,  4367,  5557,   883,  3621,  5561,
    2455,  5562,  1488,  4933,  3332,  3639,  2117,  3200,  1381,  3752,
    3121,  4297,  1332,  5250,  4290,  5391,  3239,  3287,  3536,  3537,
    3538,  3888,  3539,  3540,  3541,  3542,  3543,  3544, -2671,  4975,
     182,   182,  5292,  5469,  4437,  5033,  5007,  3690,  3448,  5383,
    4751,  1332,  1332, -2671,  4908,  1332,  5465,  4977,  5313,  5311,
    2071,  2072,  2073,  2074,  2075,  2076,  5404,  5482,  4488,  3695,
     605,  4467,  5273,  4170,  4430,  3306,  3770,  3631,  3307,  4295,
    3948,  1578,  3631,  4454,  5013,  3631,   605,  3297,  3226,  5018,
    4879,  2064,  1332,  1332,  3956,  4773,  5563,  5470,  4991,  5553,
    1491,  3894,  4496,  4936,  5409,  2528,  1492,  4451,  4237,  5140,
    1332,  5131,  5281,   763,  4939,  4524,  5107,  5524,  1974,  1594,
    2598,  4237,   910,   863,  2965,   863,  2453,  4497,  3681,  3628,
    2595,  2606,  5222,  5519,  2644,  1140,  3628,  1064,  2719,  2720,
    3856,  3628,  4326,  2721,  3628,  3237,  3952,  4349,  1494,  5430,
    5547,  3528,  4509,  4510,  2214,  1382,  2902,  2911,  1360,  2669,
    4897,  4632,  5377,  3556,  4215,  2940,  2090,  3628,  3643,  3655,
    2921,  4193,  5373,  2131,   875,   910,  5256,  2047,  4622,  2939,
    3628,  4166, -2671,  4594,  2048,  4609,  5088,  2049,  4160,  5240,
    2163,  2050,  2051,  2052,  5239,  3579,  2162,  5519,  4216,  5550,
    1595,  4161,  1495,  5450,  3461,  2167,  5364,  5507,  2053,  1496,
    2618,  2054,  1497,   861,  1063,  5519,  2055,  2172,   875,   874,
    5068,   825,   874,  2056,  4114,   874,  4894,  5375,  2878,  3598,
    5376,  3504,  2887,  4429,  3263,  3596,   825,     0,  1498,  3608,
       0,   825,     0,  3131,     0,     0,     0,     0,  2057,     0,
    2308,  5048,     0,     0,     0,     0,     0,     0,     0,     0,
    5012,     0,     0,     0,  4896,     0,     0,   825,     0,     0,
       0,  4477,  1499,     0,  5035,     0,     0,     0,     0,     0,
       0,     0, -2671,     0,     0,   863,   825,  4237,     0,  2071,
    2072,  2073,  2074,  2075,  2076,     0,     0,     0,  5046,     0,
       0,   182,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1332,   839,     0,  1332,     0,  1332,     0,
       0,  2048,     0,     0,  2049,     0,     0,     0,  2050,  2051,
    2052,     0,     0,     0,     0,  1596,     0,  1332,     0,  1501,
       0,     0,     0,  1332,     0,  2053,  3628,  3631,     0,  1502,
       0,  4879,     0,  2055,     0,     0,     0,  1332,  1503,  2058,
    2056,     0,     0,     0,  2059,     0,  5100,     0,     0,     0,
    1504,     0,   604,     0,     0,  2791,     0,     0,     0,     0,
       0,     0,     0,  2809,     0,  2057,  2060,  2061,   825,     0,
    1955,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2062,     0,     0,     0,     0,  3628,     0,     0,  1597,
     908,     0,  1506,  1507,     0,     0,  1332,     0,   883,     0,
       0,  1332,  1332,     0,   883,   604,   863,   863,   863,   863,
       0,     0,     0,     0,     0,     0,  3621,   883,     0,     0,
    2063,  3621,  1598,     0,  3621,     0,     0,     0,     0,     0,
       0,     0,     0,   883,  2064,     0,     0,  2065,   607,  1332,
       0,     0,     0,  1111,     0,     0,   605,   607,   883,     0,
       0,  4697,     0,     0,   607,     0,   883,   607,     0,     0,
       0,     0,     0,  4707,     0,     0,     0,     0,   825,  1111,
     883,  3631,     0,     0,     0,     0,  2058,  2923,     0,     0,
     883,  2059,     0,     0,     0,     0,     0,     0,     0,     0,
    1509,     0,     0,     0,     0,     0,  5203,     0,     0,     0,
       0,     0,     0,  2060,  2061,     0,     0,     0,     0,     0,
       0,     0,  1461,     0,  2639,     0,     0,     0,  2062,     0,
       0,     0,  2646,     0,     0,  2066,  1332,     0,     0,   605,
    3628,     0,  1332,     0,     0,     0,  5248,     0,     0,     0,
       0,     0,  2658,  1332,     0,     0,  1462,  1332,     0,  1332,
       0,  1332,     0,     0,     0,     0,     0,  2063,  4237,     0,
       0,     0,   607,   607,     0,     0,   910,     0,   883,  5387,
    5259,  2064,     0,     0,  2065,     0,     0,  1332,     0,     0,
       0,     0,     0,     0,   182,     0,     0,     0,  3628,     0,
       0,     0,   883,     0,   607,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   883,  1463,  1234,     0,     0,
    3529,     0,  1955,  1955,  3530,  3531,  3532,  3628,     0,     0,
       0,     0,   182,     0,     0,  2067,     0,     0,  2068,  2069,
    2070,  4578,  2071,  2072,  2073,  2074,  2075,  2076,     0,     0,
       0,  1464,     0,   863,  5436,  5437,     0,     0,     0,     0,
    5327,     0,     0,     0,  1332,     0,     0,  1234,     0,     0,
    3529,     0,  2066,  5339,  3530,  3531,  3532,     0,     0,     0,
       0,  2048,  3461,     0,  2049,     0,     0,  1465,     0,     0,
       0,     0,     0,     0,  5245,     0,  3621,     0,     0,  1332,
    1332,  1332,     0,     0,     0,  3226,  2040,     0,  1332,     0,
       0,     0,     0,  2055,     0,     0,     0,     0,  1332,     0,
   -2671,  5100,   607,   607,  1727,     0,  2954,  1467,     0,     0,
       0,   607,  3628,     0,     0,     0,     0,     0,  1111,     0,
     875,     0,   607,     0,     0,  2057,     0,     0,   607,     0,
       0,   607,     0,     0,     0,   863,     0,  2900,     0,  1469,
       0,  1234,  1955,  1111,  3529,  1432,     0,     0,  3530,  3531,
    3532,     0,  2067,     0,     0,  2068,  2069,  2070,  1111,  2071,
    2072,  2073,  2074,  2075,  2076,     0,     0,     0,  2308,  3518,
       0,     0,  3519,   605,  3461,     0,  3461,     0,     0,  1332,
       0,    36,  5410,  2291,     0,  1471,     0,     0,     0,  4237,
       0,     0,  4581,     0,  1472,   875,   875,  1332,     0,  3534,
       0,     0,  1473,   607,   607,   607,   186,  1332,     0,  5435,
    2292,  5248,  5432,     0,  5433,     0,  5434,     0,  1234,     0,
    3621,  3529,  1475,     0,     0,  3530,  3531,  3532,     0,  5495,
     182,  1476,   863,     0,     0,  1477, -2671,     0,     0,     0,
       0, -2671,     0,  1111,  5564,  5565,     0,     0,  3628,  3534,
       0,     0,     0,     0,     0,   747,     0,  4077,     0,     0,
       0,   747,     0,  5339,   863,   863,     0,  3535,     0,  4237,
       0,     0,     0,     0,     0,     0,     0,     0, -2671,     0,
     883,     0,     0,     0,   186,     0,     0,  5435,     0,  1478,
    5432,  4106,  5433,     0,  5434,     0,  1332,  1332,   883,     0,
       0,     0,     0,     0,   182,     0,     0,  1332,   607,     0,
       0,     0,  1332,     0,     0,     0,   883,  3535,     0,     0,
       0,     0,  3628,     0,     0,     0,     0,     0,  3628,     0,
       0,  2064,     0,     0,     0,     0,     0,     0,     0,  4150,
       0,     0,  1332,  3534,   883,     0,     0,     0,     0,     0,
       0,     0,  1332,     0,     0,     0,     0,     0,  1111,     0,
     883,     0,     0,     0,     0,     0,     0,   863,     0,     0,
    4237,     0,     0,     0,     0,     0,   883,     0,     0,  5248,
     883,     0,     0,   605,     0,   186,     0,     0,  5435,     0,
       0,  5432,   607,  5433,     0,  5434,     0,     0,     0,     0,
    2048,     0,     0,  2049,     0,   875,   875,  2050,  2051,  2052,
       0,  3535,     0,     0,     0,     0,     0,     0,     0,     0,
   -2671,     0, -2671,   607,  2053,     0,     0,     0,     0,  3628,
       0,     0,  2055,     0,     0,     0,     0,     0,     0,  2056,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   607,   607,   607,     0,   607,     0,     0,     0,     0,
       0,  3536,  3537,  3538,  2057,  3539,  3540,  3541,  3542,  3543,
    3544,   604,     0,     0,   604,   607,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3535,  1491,
       0,     0,     0,     0,     0,  1492,     0,     0,     0,   883,
       0,     0,     0,     0,     0,     0,     0,   883,   883,  2791,
    2791,  3536,  3537,  3538,  2791,  3539,  3540,  3541,  3542,  3543,
    3544,   883, -2671,     0,     0,     0,   182,     0,     0,  2071,
    2072,  2073,  2074,  2075,  2076,     0,     0,  1494,     0,     0,
       0,     0,     0,   607,     0,     0,   604,   607,   607,     0,
       0,  2791,  2791,   182,     0,     0,     0,     0,     0,     0,
       0,     0,   607,     0,     0,     0,     0,     0,  1111,     0,
       0,     0,     0,  1558,  1727,  2058,  2048,     0,     0,  2049,
    2059,     0,     0,  2050,  2051,  2052,     0,     0,     0,     0,
       0,  1495,  1559,     0,     0,     0,     0,     0,  1496,     0,
    2053,  1497,  2060,  2061,     0,  3536,  3537,  3538,  2055,  3539,
    3540,  3541,  3542,  3543,  3544,  2056,     0,  2062,     0,     0,
       0,  3399,     0,     0,     0,     0,     0,  1498,     0,  3408,
       0,  5494,     0,     0,     0,     0,  1111,     0,     0,     0,
    2057,     0,  1560,  4282,     0,     0,     0,     0,     0,  3427,
    2237,     0,     0,     0,     0,     0,  2063,     0,     0,  3433,
       0,  1499,  3434,     0,  3435,  3436,     0,     0,  3438,     0,
    2064,     0,     0,  2065,  3442,     0,  3443,  1111,     0,  3445,
       0,     0,  3536,  3537,  3538,     0,  3539,  3540,  3541,  3542,
    3543,  3544,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4283,     0,     0,     0,
    1111,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1596,     0,     0,     0,  1501,  1561,
       0,     0,   182,     0,     0,     0,     0,     0,  1502,     0,
       0,     0,  3484,     0,     0,     0,     0,  1503,     0,     0,
       0,  2058,     0,     0,     0,     0,  2059,     0,     0,  1504,
       0,  2066,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   883,     0,     0,     0,     0,     0,  1562,  2060,  2061,
    1563,     0,     0,     0,     0,  1491,   607,   607,   607,     0,
       0,  1492,     0,  2062,     0,  2404,  3461,     0,  1624,  4284,
       0,  1506,  1507,     0,  1594,   604,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1565,
       0,  1625,  2063,  1494,     0,     0,     0,     0,     0,     0,
    4556,     0,     0,     0,     0,     0,  2064,     0,     0,  2065,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2067,     0,     0,  2068,  2069,  2070,     0,  2071,  2072,
    2073,  2074,  2075,  2076,  1567,     0,     0,     0,     0,     0,
       0,  3520,     0,     0,     0,  1595,     0,  1495,     0,  1111,
       0,     0,     0,     0,  1496,     0,  1568,  1497,     0,  1509,
       0,     0,     0,     0,     0,     0,  1111,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1570,     0,  4285,  1727,
       0,  4286,     0,  1498,  1111,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2066,     0,     0,
       0,     0,     0,   883,     0,     0,     0,     0,     0,     0,
       0,   883,     0,     0,     0,     0,     0,  1499,     0,     0,
       0,     0,     0,   883,   747,     0,   747,     0,   747,     0,
       0,     0,     0,     0,   747,  1181,  1182,     0,     0,     0,
    1111,     0,     0,     0,     0,     0,     0,   607,     0,     0,
     607,     0,     0,  1111,     0,     0,     0,     0,     0,     0,
     607,     0,     0,     0,     0,     0,  1111,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3700,     0,  1111,     0,
    1596,     0,     0,  2334,  1501,   604,     0,     0,     0,   604,
       0,     0,     0,     0,  1502,   607,   607,  2067,   883,   883,
    2068,  2069,  2070,  1503,  2071,  2072,  2073,  2074,  2075,  2076,
     607,     0,   883,   607,     0,  1504,     0,  3570,     0,     0,
       0,     0,  1111,  1111,     0,   883,   883,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2048,     0,     0,  2049,
       0,   883,     0, -2671, -2671, -2671,     0,     0,     0,     0,
       0,     0,     0,     0,  3197,     0,     0,  1506,  1507,  3759,
       0,  3761,     0,     0,     0,     0,     0,     0,  2055,     0,
       0,     0,     0,   607,     0,  2056,   607,   607,     0,     0,
       0,     0,   747,     0,     0,     0,     0,  3198,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2057,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   607,     0,   607,     0,     0,     0,     0,   607,   607,
       0,     0,     0,     0,     0,   607,   607,   607,     0,     0,
     607,     0,   607,     0,   607,   607,   607,   607,   607,   607,
       0,   607,     0,   607,   607,     0,     0,   607,  4779,     0,
       0,     0,     0,     0,     0,  1509,     0,     0,     0,     0,
       0,  1111,   607,   607,   607,   607,  1727,     0,     0,     0,
     607,     0,     0,     0,   607,     0,     0,   607,     0,     0,
     607,   607,   607,   607,   607,   607,   607,   607,   607,     0,
     607,     0,     0,     0,     0,     0,     0,   607,     0,   607,
    3851,     0,     0,     0,     0,     0,  3858,     0,     0,     0,
       0,  2058,  2791,  2791,  2791,  2791,  2059,     0,  2791,  2791,
    2791,  2791,  2791,  2791,  2791,  2791,  2791,  2791,     0,     0,
       0,     0,     0,     0,     0,     0,   883,     0,     0,     0,
    4758,     0,   607,     0,     0,  4110,     0,     0,     0,     0,
       0,     0,     0,  2062,     0,     0,     0,   607,     0,     0,
       0,     0,     0,     0,     0,     0,   607,   607,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2791,  2791,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   883,     0,     0,     0,     0,     0,     0,  1111,
       0,     0,     0,  1111,  1111,     0,  2064,     0,     0,     0,
     883,     0,     0,     0,     0,  1727,   883,     0,     0,     0,
     883,     0,     0,     0,     0,     0,     0,     0,   883,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2248,   883,     0,     0,   607,
    2249,     0,     0,     0,     0,     0,     0,   747,     0,     0,
       0,   607,     0,     0,     0,  1111,     0,     0,   607,     0,
       0,   607,   607,     0,     0,     0,     0,     0,     0,  1111,
       0,     0,     0,     0,     0,  2250,     0,     0,     0,     0,
       0,   883,     0,     0,     0,     0,     0,  2066,  2251,     0,
       0,     0,     0,  4021,     0,  4023,     0,  4025,     0,     0,
     604,   883,   883,  2252,     0,     0,  4029,   604,     0,     0,
    1111,     0,   604,     0,  3384,   604,  4875,     0,     0,   674,
       0,     0,     0,     0,     0,     0,     0,     0,   760,     0,
       0,     0,  1727,   883,     0,  1461,  1727,     0,   604,     0,
       0,     0,     0,     0,  2253,     0,     0,  4054,     0,     0,
       0,   604,     0,     0,     0,  2254,     0,     0,     0,   883,
       0,  1727,     0,     0,     0,   883,     0,     0,     0,  1462,
       0,     0,   883,     0,     0,     0,  2255,  2048,     0,   883,
    2049,  2256,   883,     0,  2050,  2051,  2052,  2067,   883,     0,
   -2671, -2671, -2671,     0,  2071,  2072,  2073,  2074,  2075,  2076,
       0,  2053,     0,     0,   874,     0,     0,     0,   883,  2055,
       0,     0,     0,     0,   883,     0,  2056,     0,     0,   883,
       0,     0,  1727,     0,     0,     0,  5069,     0,     0,  1463,
       0,     0,   883,   747,     0,     0,     0,     0,   747,   747,
       0,  2057,     0,     0,     0,   883,     0,     0,   874,     0,
    1727,     0,   747,  2257,     0,     0,   883,     0,     0,     0,
       0,     0,     0,     0,  1464,  2042,  2729,     0,     0,     0,
       0,     0,     0,     0,   607,   607,   607,     0,     0,     0,
     607,  2791,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2258,     0,  3385,     0,     0,     0,     0,
    1465,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   607,  1111,     0,  2730,     0,   604,     0,     0,
       0,     0,  1727,     0,     0,     0,     0,   208,  2259,  5136,
    5137,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1467,     0,     0,     0,     0,   747,     0,  2731,     0,     0,
       0,     0,  2058,     0,     0,   747,   607,  2059,     0,     0,
    2260,     0,     0,     0,     0,     0,  2261,     0,     0,     0,
    2732,     0,  1469,  2262,     0,     0,  2263,   604,  1432,  2060,
    2061,  2733,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2062,  1111,     0,     0,  1111,  1181,
    1182,     0,  2734,   883,     0,     0,     0,  2735,  2264,     0,
       0,     0,     0,   607,    36,  2265,     0,     0,  3386,     0,
       0,     0,     0,  2266,     0,     0,     0,  1472,     0,     0,
    2267,     0,     0,  2063,     0,  1473,     0,     0,     0,     0,
       0,     0,   747,  2292,     0,   747,   747,  2064,     0,     0,
    2065,     0,     0,     0,  5234,  1475,  2268,  1491,  2736,   883,
       0,     0,     0,  1492,  1476,     0,     0,     0,  1477,     0,
       0,  5251,     0,     0,     0,  5253,  1493,  5255,     0,  2737,
       0,     0,     0,  4561,     0,     0,     0,  3387,     0,     0,
       0,     0,     0,     0,     0,     0,  5181,     0,     0,     0,
       0,   883,     0,     0,     0,  1494,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1111,     0,   883,
       0,   604,  1478,     0,     0,     0,  3388,   883,     0,     0,
       0,   607,     0,     0,  1111,  4598,     0,   607,  2066,     0,
     607,     0,     0,   607,     0,     0,     0,     0,     0,  1111,
       0,     0,     0,   208,  2738,     0,     0,  2739,     0,  1495,
     607,     0,     0,     0,     0,   607,  1496,     0,     0,  1497,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   604,
       0,     0,     0,  2740,     0,     0,  2741,     0,     0,   607,
     607,   607,  2742,     0,   607,  1498,     0,     0,     0,  2743,
       0,     0,   607,   607,   607,   607,     0,     0,   604,     0,
    1727,     0,     0,     0,     0,   607,  1727,     0,   607,     0,
     607,     0,     0,     0,     0,     0,     0,   747,  2744,  1499,
       0,   607,   607,     0,  2745,   607,     0,  2746,  2067,     0,
       0,  2068,  2069,  2070,     0,  2071,  2072,  2073,  2074,  2075,
    2076,     0,     0,  2477,     0,   607,  2747,   607,     0,   607,
       0,  2048,     0,     0,  2049,     0,     0,     0,  2050,  2051,
    2052,     0,     0,     0,     0,     0,     0,     0,     0,   607,
       0,     0,  2748,     0,     0,  2053,     0,     0,     0,     0,
     607,  4514,  1500,  2055,     0,  4516,  1501,     0,   883,     0,
    2056,     0,     0,     0,     0,     0,  1502,     0,     0,     0,
       0,     0,     0,   604,   607,  1503,     0,     0,     0,     0,
       0,   996,     0,     0,     0,  2057,     0,  1504,     0,   607,
       0,     0,     0,     0,     0,  2613,     0,     0,     0,     0,
       0,     0,     0,   607,     0,  2621,     0,  2622,     0,     0,
       0,     0,     0,  2626,     0,     0,     0,     0,     0,     0,
    2632,     0,  1111,     0,     0,  1111,  1505,  1111,     0,  1506,
    1507,     0,  1111,  1062,   674,     0,     0,     0,     0,     0,
     874,     0,     0,     0,     0,     0,     0,   883,   883,     0,
       0,     0,     0,   607,     0,     0,     0,     0,     0,  1508,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   883,     0,     0,   883,     0,     0,
       0,  1111,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5413,     0,     0,  2058,     0,     0,     0,
    1111,  2059,     0,     0,     0,     0,     0,     0,     0,   604,
    5511,     0,     0,     0,     0,   874,   874,     0,     0,     0,
       0,     0,     0,  2060,  2061,  1111,     0,  1509,     0,     0,
    1205,  1461,     0,     0,     0,     0,     0,     0,  2062,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2764,  2765,     0,     0,  1225,     0,     0,  2779,
    2780,  1727,  1727,  1727,  1335,  1462,     0,  1344,  1062,  1346,
       0,     0,     0,  4662,     0,     0,     0,  2063,     0,     0,
    2791,     0,     0,   604,     0,   883,     0,     0,  2819,   604,
       0,  2064,     0,     0,  2065,  1111,     0,  1111,     0,     0,
       0,     0,     0,     0,     0,   883,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4687,  4688,     0,
       0,     0,     0,  3384,   883,  1463,     0,  2048,     0,     0,
    2049,     0,     0,     0,  2050,  2051,  2052,     0,     0,     0,
       0,     0,     0,     0,  1461,     0,     0,     0,     0,     0,
       0,  2053,     0,     0,     0,     0,     0,     0,     0,  2055,
    1464,     0,     0,     0,     0,     0,  2056,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1462,     0,
       0,     0,  2066,     0,     0,     0,     0,     0,  1111,     0,
     604,  2057,     0,     0,     0,     0,  1465,  2930,  2930,     0,
       0,     0,     0,  5552,     0,     0,     0,  4730,  4731,     0,
     883,  2048,     0,     0,  2049,   607,     0,     0,  2050,  2051,
    2052,   607,     0,     0,     0,   874,   874,     0,     0,  1111,
       0,     0,  1466,     0,     0,  2053,  1467,     0,  1463,     0,
       0,     0,     0,  2055,     0,     0,     0,     0,     0,     0,
    2056,     0,     0,     0,     0,     0,     0,  1727,  1111,   747,
       0,     0,     0,     0,   883,     0,   883,  1468,  1469,     0,
       0,     0,     0,  1464,  1432,  2057,     0,     0,     0,   883,
       0,   883,  2067,     0,     0,  2068,  2069,  2070,     0,  2071,
    2072,  2073,  2074,  2075,  2076,     0,     0,     0,     0,  2817,
       0,     0,  2058,  1727,  3385,     0,  1470,  2059,     0,  1465,
      36,     0,     0,     0,  1471,     0,     0,     0,     0,     0,
       0,     0,     0,  1472,     0,     0,     0,  1111,     0,  2060,
    2061,  1473,     0,  4827,     0,     0,     0,  4829,  4830,  1474,
       0,     0,     0,     0,  2062,     0,     0,   883,  1111,  1467,
       0,  1475,     0,  4834,  3074,     0,     0,     0,     0,     0,
    1476,     0,  1111,     0,  1477,     0,     0,     0,     0,     0,
       0,  2791,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1469,     0,  2063,     0,     0,  2058,  1432,     0,     0,
       0,  2059,     0,     0,     0,  2791,     0,  2064,     0,     0,
    2065,     0,   883,     0,     0,     0,     0,     0,  1062,     0,
       0,     0,     0,  2060,  2061,     0,     0,     0,  1478,     0,
     883,     0,     0,    36,     0,     0,  1062,  1471,  2062,     0,
       0,     0,     0,     0,     0,   747,  1472,     0,     0,     0,
       0,     0,   883,   747,  1473,   883,   747,     0,     0,     0,
       0,     0,  2292,     0,     0,     0,     0,     0,   747,     0,
    1979,     0,     0,     0,  1475,   607,  1491,  2063,  1111,     0,
       0,     0,  1492,  1476,   607,     0,     0,  1477,     0,     0,
       0,  2064,   607,     0,   607,     0,     0,   607,  2066,     0,
    1062,  1111,   607,   607,   607,   607,  3387,     0,   607,   607,
     607,   607,   607,   607,   607,   607,   607,   607,     0,     0,
       0,   607,   607,     0,  1494,     0,  1111,     0,     0,     0,
       0,   607,     0,     0,     0,   607,     0,  1727,     0,   607,
       0,  1478,     0,     0,     0,  3388,     0,   607,     0,     0,
     607,     0,   607,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1111,     0,   607,     0,     0,   607,   607,     0,
       0,     0,   607,   607,     0,     0,     0,  2044,  1495,   607,
       0,     0,  2066,     0,     0,  1496,  2046,     0,  1497,   607,
       0,     0,   607,     0,     0,     0,     0,     0,  2067,     0,
    2088,  2068,  2069,  2070,   607,  2071,  2072,  2073,  2074,  2075,
    2076,     0,     0,     0,  1498,  3890,     0,     0,     0,  1062,
    2791,     0,  2105,  2106,     0,     0,     0,  1062,  1062,     0,
     607,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1062,     0,     0,     0,     0,   607,     0,  1499,     0,
       0,     0,  1111,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   607,     0,     0,     0,     0,     0,
    5064,     0,     0,     0,     0,     0,     0,  3414,  3416,     0,
       0,     0,  2067,  3424,     0,  2068,  2069,  2070,     0,  2071,
    2072,  2073,  2074,  2075,  2076,   883,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1596,     0,     0,     0,  1501,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1502,     0,     0,     0,     0,
       0,     0,     0,     0,  1503,     0,     0,     0,     0,     0,
    5109,     0,     0,     0,   747,  1727,  1504,     0,     0,     0,
    1727,  1111,  1727,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1727,  1111,     0,     0,     0,
       0,     0,     0,     0,     0,  2272,  2791,     0,  1506,  1507,
       0,     0,     0,  5146,     0,  1727,     0,     0,     0,  -130,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   883,     0,     0,   883,     0,     0,     0,  2273,     1,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     2,
       0,     3,     4,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     5,  2409,     0,
       0,     0,     0,     0,     0,  2416,     6,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     7,     0,
       8,     9,     0,     0,     0,     0,     0,    10,     0,    11,
       0,   607,     0,     0,     0,     0,  1509,     0,     0,     0,
      12,     0,    13,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5449,   883,   883,     0,    14,
    1111,     0,    15,     0,     0,     0,   883,     0,     0,     0,
       0,     0,     0,   607,     0,     0,    16,     0,    17,     0,
       0,     0,    18,     0,     0,   883,  2048,     0,    19,  2049,
       0,     0,     0,  2050,  2051,  2052,    20,  3637,    21,   747,
       0,     0,     0,     0,     0,    22,     0,     0,  1111,     0,
    2053,     0,  1111,   607,   607,     0,     0,     0,  2055,     0,
       0,    23,  3650,  3650,     0,  2056,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    24,     0,
       0,     0,     0,     0,  2791,  2791,     0,     0,     0,     0,
    2057,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1491,   883,     0,     0,     0,     0,  1492,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    25,    26,
       0,     0,     0,     0,    27,     0,     0,     0,   607,     0,
       0,     0,     0,     0,     0,     0,    28,     0,     0,     0,
     607,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1494,     0,     0,     0,    29,     0,  2550,     0,     0,     0,
    2555,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     607,     0,     0,   607,     0,     0,     0,     0,     0,     0,
       0,   607,   607,     0,  1111,     0,     0,     0,   607,   607,
      30,     0,     0,   607,  1111,     0,     0,     0,    31,   607,
       0,  2058,   607,   607,  1495,     0,  2059,   607,     0,     0,
       0,  1496,    32,   607,  1497,     0,     0,     0,    33,    34,
       0,    35,     0,     0,     0,   607,    36,     0,  2060,  2061,
       0,    37,     0,   607,    38,     0,     0,   607,     0,     0,
    1498,    39,     0,  2062,     0,     0,     0,    40,    41,     0,
       0,     0,     0,     0,     0,    42,     0,     0,     0,    43,
       0,     0,     0,     0,     0,     0,     0,   607,     0,    44,
       0,     0,     0,     0,  1499,     0,     0,     0,     0,     0,
       0,     0,  2063,     0,    45,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   607,     0,  2064,     0,     0,  2065,
       0,     0,     0,  5462,    46,     0,     0,     0,     0,     0,
       0,     0,  1111,     0,     0,    47,     0,     0,     0,     0,
       0,    48,     0,     0,     0,  2048,    49,     0,  2049,     0,
     883,     0,  2050,  2051,  2052,  1727,     0,  1500,     0,    50,
       0,  1501,     0,     0,     0,     0,     0,     0,     0,  2053,
       0,  1502,     0,  1111,     0,     0,     0,  2055,     0,     0,
    1503,     0,    51,     0,  2056,     0,     0,     0,     0,     0,
     883,     0,  1504,     0,  2775,  1111,    52,     0,     0,  -130,
       0,     0,   883,     0,     0,     0,     0,  2066,     0,  2057,
       0,     0,  1461,     0,     0,     0,     0,   675,   607,     0,
       0,     0,   676,     0,     0,     0,     0,     0,     0,     0,
       0,  2349,   883,     0,  1506,  1507,     0,     0,     0,     0,
       0,  2048,     0,     0,  2049,     0,  1462,     0,  2050,  2051,
    2052,     0,     0,     0,     0,     0,     0,   677,     0,   747,
       0,     0,     0,  1111,  2350,  2053,     0,     0,     0,     0,
     678,     0,     0,  2055,     0,     0,     0,     0,     0,     0,
    2056,     0,     0,  3937,     0,   679,  2895,     0,     0,     0,
       0,     0,   607,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   680,     0,  2057,  1463,  2067,   607,     0,
    2068,  2069,  2070,     0,  2071,  2072,  2073,  2074,  2075,  2076,
    2058,     0,     0,     0,  4070,  2059,   681,     0,     0,     0,
       0,   883,  1509,     0,     0,     0,     0,   682,   607,     0,
       0,  1464,     0,     0,     0,     0,   683,  2060,  2061,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   684,     0,
       0,     0,  2062,   685,     0,     0,     0,     0,     0,     0,
     686,     0,  4015,     0,     0,     0,     0,  1465,     0,     0,
       0,     0,     0,  1111,     0,  1111,     0,     0,     0,   687,
       0,     0,     0,     0,     0,     0,     0,     0,  1062,     0,
       0,  2063,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   883,     0,  1466,     0,  2064,  2058,  1467,  2065,     0,
       0,  2059,  1491,     0,     0,     0,     0,     0,  1492,     0,
     607,     0,     0,     0,  1111,   688,     0,     0,     0,     0,
       0,     0,     0,  2060,  2061,     0,     0,     0,  1532,  1469,
       0,     0,     0,   747,     0,  1432,     0,     0,  2062,   607,
     607,     0,     0,   607,     0,     0,     0,     0,  1346,     0,
    1494,     0,     0,     0,     0,   689,     0,     0,   607,     0,
       0,     0,     0,     0,     0,   607,     0,  1533,   690,     0,
     607,    36,     0,   607,   607,  1471,     0,  2063,     0,   691,
     607,   607,     0,     0,  1472,     0,  2066,     0,     0,   208,
     692,  2064,  1473,   693,  2065,     0,   607,     0,   607,     0,
    1534,     0,     0,   883,  1495,   883,     0,     0,     0,   607,
       0,  1496,  1475,     0,  1497,     0,     0,     0,     0,   694,
       0,  1476,   695,  1491,     0,  1477,   696,  1346,   697,  1492,
       0,     0,     0,     0,     0,   698,     0,     0,   699,     0,
    1498,     0,     0,     0,  1346,     0,     0,     0,     0,     0,
       0,  1111,   883,     0,     0,     0,     0,   700,     0,     0,
       0,     0,   607,     0,   701,     0,     0,     0,     0,     0,
     702,  1494,     0,   703,  1499,     0,     0,   704,     0,  1478,
       0,     0,  2066,     0,     0,   705,  2067,   706,     0,  2068,
    2069,  2070,   707,  2071,  2072,  2073,  2074,  2075,  2076,     0,
       0,  1727,     0,  4123,  2048,   708,   607,  2049,  3235,     0,
       0,  2050,  2051,  2052,     0,     0,     0,     0,   709,     0,
       0,     0,     0,     0,     0,  1495,     0,     0,  2053,     0,
       0,     0,  1496,     0,     0,  1497,  2055,  1596,     0,     0,
       0,  1501,     0,  2056,  3266,     0,     0,  3266,     0,  3266,
       0,  1502,     0,  3266,     0,  3266,  3266,     0,     0,     0,
    1503,  1498,     0,     0,  3266,  3266,  3266,     0,  2057,     0,
       0,     0,  1504,     0,     0,   607,     0,  1111,     0,     0,
       0,     0,  2067,     0,     0,  2068,  2069,  2070,     0,  2071,
    2072,  2073,  2074,  2075,  2076,  1499,     0,     0,     0,  4231,
    2048,   607,  1111,  2049,   607,     0,   607,  2050,  2051,  2052,
       0,  3067,     0,     0,  1506,  1507,     0,     0,     0,  3342,
       0,     0,   747,     0,  2053,   607,     0,     0,     0,     0,
       0,   607,  2055,     0,     0,   607,     0,     0,     0,  2056,
       0,  1111,     0,     0,  1508,   607,     0,   747,     0,     0,
       0,  3373,     0,     0,   747,     0,     0,     0,  1596,     0,
       0,     0,  1501,  1062,  2057,   747,  2048,     0,     0,  2049,
       0,     0,  1502,  2050,  2051,  2052,     0,     0,     0,  2058,
       0,  1503,     0,     0,  2059,  1727,     0,     0,     0,     0,
    2053,     0,     0,  1504,  1111,     0,     0,     0,  2055,  1111,
    1111,     0,     0,     0,   607,  2056,  2060,  2061,     0,   607,
     607,   883,  1509,     0,     0,     0,     0,     0,     0,  1062,
       0,  2062,     0,     0,     0,   883,     0,     0,     0,     0,
    2057,     0,  3242,     0,     0,  1506,  1507,     0,     0,     0,
    1181,  1182,     0,     0,   613,     0,     0,   607,     0,     0,
     663,   613,     0,     0,   607,     0,   715,     0,   613,     0,
    2063,     0,     0,     0,   613,  3243,     0,   769,     0,     0,
    1491,     0,     0,     0,  2064,  2058,  1492,  2065,     0,   607,
    2059,     0,     0,     0,     0,     0,   836,   836,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   862,   864,     0,
       0,   868,  2060,  2061,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1111,  1111,     0,  2062,  1494,     0,
       0,   925,     0,     0,     0,     0,     0,     0,   935,   747,
       0,     0,     0,  1509,   607,     0,     0,   607,     0,     0,
     607,  2058,     0,     0,     0,     0,  2059,     0,     0,     0,
       0,   607,     0,     0,     0,   607,  2063,   607,     0,   607,
       0,     0,     0,     0,     0,  2066,   607,     0,  2060,  2061,
    2064,     0,  1495,  2065,     0,     0,     0,     0,     0,  1496,
       0,   747,  1497,  2062,     0,   607,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1498,     0,
    1727,     0,   883,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2063,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   870,  2064,     0,     0,  2065,
       0,     0,  1499,   912,     0,     0,   914,     0,     0,   919,
     920,     0,   923,     0,   926,     0,     0,   932,  1062,   934,
       0,  2066,   607,     0,     0,  2067,     0,     0,  2068,  2069,
    2070,   607,  2071,  2072,  2073,  2074,  2075,  2076,     0,     0,
       0,     0,  4544,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   607,   607,   607,
       0,     0,     0,     0,     0,  1596,   607,  1727,     0,  1501,
    1111,     0,     0,     0,     0,     0,   607,     0,     0,  1502,
       0,     0,     0,     0,     0,   883,     0,  2066,  1503,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   607,     0,
    1504,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   883,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2067,     0,     0,  2068,  2069,  2070,     0,  2071,  2072,
    2073,  2074,  2075,  2076,     0,     0,     0,  1062,  4582,  3728,
       0,  1491,  1506,  1507,     0,     0,     0,  1492,     0,     0,
       0,   607,     0,     0,     0,     0,     0,   607,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   607,     0,     0,
       0,     0,  3729,   607,   607,   607,     0,     0,   747,     0,
       0,     0,     0,     0,   747,   607,     0,  2067,   747,  1494,
    2068,  2069,  2070,     0,  2071,  2072,  2073,  2074,  2075,  2076,
       0,     0,     0,     0,  4837,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4700,  4701,   883,     0,     0,  4704,
    4705,     0,     0,     0,     0,     0,     0,  3775,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1509,   607,     0,  1495,     0,     0,     0,   607,     0,     0,
    1496,     0,     0,  1497,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2048,     0,     0,  2049,     0,     0,
       0,  2050,  2051,  2052,   607,   607,     0,     0,     0,  1498,
       0,     0,  3814,     0,     0,   607,     0,     0,  2053,  1005,
     607,  1008,     0,     0,     0,  1011,  2055,     0,     0,  1727,
       0,     0,     0,  2056,     0,     0,     0,     0,     0,  1036,
       0,     0,  1097,  1499,     0,     0,  1041,     0,     0,     0,
     607,     0,     0,     0,     0,     0,     0,     0,  2057,     0,
     607,     0,     0,     0,     0,     0,     0,     0,  1097,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   607,     0,
    3854,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   607,     0,  1727,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1596,     0,     0,     0,
    1501,  1727,     0,   607,   607,     0,     0,     0,     0,     0,
    1502,     0,     0,     0,  3266,     0,     0,     0,     0,  1503,
       0,     0,     0,     0,     0,     0,     0,     0,  3887,  3887,
       0,  1504,     0,     0,     0,     0,     0,     0,  3903,     0,
       0,     0,     0,     0,  1062,     0,  1062,     0,     0,  1014,
       0,     0,     0,     0,     0,     0,  1027,  1028,     0,  2058,
    1034,     0,  1037,  1038,  2059,     0,     0,  1040,     0,     0,
    3784,     0,     0,  1506,  1507,     0,     0,     0,  1059,     0,
       0,     0,     0,     0,     0,     0,  2060,  2061,     0,     0,
       0,     0,  3959,     0,     0,     0,     0,     0,     0,     0,
       0,  2062,     0,  3785,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1136,     0,  1138,
       0,     0,     0,     0,     0,     0,  3994,  1062,     0,  1154,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2063,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2064,     0,     0,  2065,     0,     0,
       0,   613,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1509,     0,     0,     0,     0,     0,     0,     0,  1523,
    1524,     0,     0,     0,     0,     0,  2048,     0,     0,  2049,
       0,     0,     0,  2050,  2051,  2052,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2053,     0,   747,     0,     0,     0,     0,  1739,  2055,  2048,
       0,     0,  2049,     0,     0,  2056,  2050,  2051,  2052,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1756,  2053,     0,  2066,     0,     0,     0,   836,
    2057,  2055,     0,     0,     0,     0,     0,  1764,  2056,     0,
       0,     0,     0,     0,     0,     0,  2048,     0,     0,  2049,
       0,     0,     0,  2050,  2051,  2052,     0,     0,  1758,     0,
       0,     0,     0,  2057,     0,  1452,     0,     0,     0,     0,
    2053,     0,     0,     0,     0,     0,     0,     0,  2055,     0,
       0,     0,     0,     0,     0,  2056,     0,  1780,  1781,     0,
       0,     0,     0,     0,     0,     0,  4124,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2057,     0,     0,  1822,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2067,     0,     0,  2068,  2069,
    2070,     0,  2071,  2072,  2073,  2074,  2075,  2076,  1627,     0,
       0,  2058,  4847,     0,     0,  2048,  2059,     0,  2049,     0,
       0,     0,  2050,  2051,  2052,     0,     0,     0,     0,  1738,
       0,     0,     0,     0,     0,     0,     0,     0,  2060,  2061,
       0,  1749,     0,     0,  2058,     0,  1752,  2055,     0,  2059,
       0,     0,     0,  2062,  2056,     0,  1755,  1891,  1893,     0,
       0,  1759,     0,     0,     0,     0,   876,   885,     0,     0,
    1762,  2060,  2061,     0,   876,  1769,   885,   876,  1773,  2057,
       0,     0,     0,     0,     0,     0,  2062,     0,     0,     0,
     885,  2058,  2063,     0,     0,     0,  2059,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2064,  1980,     0,  2065,
       0,     0,     0,     0,     0,     0,     0,     0,  2060,  2061,
    1827,     0,     0,     0,     0,  2063,     0,     0,     0,     0,
       0,  1461,     0,  2062,     0,     0,   747,     0,     0,  2064,
       0,     0,  2065,     0,     0,     0,     0,     0,     0,  2048,
       0,     0,  2049,     0,     0,     0,  2050,  2051,  2052,     0,
       0,     0,     0,     0,     0,  1462,     0,     0,     0,     0,
       0,  3903,  2063,  2053,     0,     0,     0,     0,     0,     0,
       0,  2055,     0,     0,     0,     0,  2064,     0,  2056,  2065,
    2058,     0,     0,     0,     0,  2059,  4332,  2066,     0,     0,
       0,     0,     0,     0,  4341,     0,     0,  4342,     0,  4343,
       0,     0,     0,  2057,     0,     0,     0,  2060,  2061,     0,
       0,     0,     0,     0,     0,  1463,     0,     0,     0,     0,
    2066,     0,  2062,     0,     0,   613,     0,   613,     0,   613,
       0,   613,     0,   613,   613,   613,     0,     0,     0,     0,
     613,     0,  4384,     0,     0,  2048,     0,     0,  2049,     0,
    1464,  1975,  2050,  2051,  2052,     0,     0,     0,  3266,     0,
       0,  2063,  3266,  3266,     0,  3266,     0,  2066,     0,  2053,
       0,  1988,     0,     0,     0,  2064,     0,  2055,     0,     0,
       0,     0,     0,     0,  2056,     0,  1465,  2067,     0,     0,
    2068,  2069,  2070,     0,  2071,  2072,  2073,  2074,  2075,  2076,
       0,     0,     0,  5290,  4856,     0,     0,     0,     0,  2057,
       0,     0,     0,     0,  2058,     0,     0,     0,     0,  2059,
    2067,     0,  1466,  2068,  2069,  2070,  1467,  2071,  2072,  2073,
    2074,  2075,  2076,     0,     0,     0,     0,  4859,     0,     0,
       0,  2060,  2061,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2062,  1549,  1469,     0,
       0,     0,     0,     0,  1432,  4491,  2066,  2067,  3903,     0,
    2068,  2069,  2070,     0,  2071,  2072,  2073,  2074,  2075,  2076,
       0,     0,     0,     0,  4906,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2063,  1550,     0,     0,     0,
      36,  2290,     0,     0,  1471,     0,     0,     0,     0,  2064,
       0,     0,  2065,  1472,     0,     0,  2356,     0,     0,     0,
    2058,  1473,     0,     0,     0,  2059,  2329,     0,     0,  1551,
       0,     0,   836,     0,     0,     0,     0,     0,  4532,  4532,
    4532,  1475,  4532,  4532,  4532,  4532,  4532,  2060,  2061,     0,
    1476,     0,     0,     0,  1477,     0,     0,     0,     0,     0,
       0,     0,  2062,     0,     0,     0,  2067,     0,     0,  2068,
    2069,  2070,     0,  2071,  2072,  2073,  2074,  2075,  2076,     0,
    2048,     0,     0,  2049,     0,     0,     0,  2050,  2051,  2052,
       0,   885,     0,     0,     0,     0,     0,   885,     0,     0,
    2066,  2063,     0,  2411,  2053,     0,     0,     0,  1478,     0,
     885,     0,  2055,     0,  2270,  2064,     0,     0,  2065,  2056,
       0,     0,     0,     0,     0,     0,   885,     0,     0,  2434,
    2435,  2436,  2437,     0,     0,     0,     0,     0,     0,     0,
     876,   885,     0,     0,  2057,     0,     0,   876,     0,   885,
     876,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   885,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   885,  4621,     0,  4623,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2361,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2067,     0,     0,  2068,  2069,  2070,  2066,  2071,  2072,  2073,
    2074,  2075,  2076,     0,     0,     0,     0,  4941,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2483,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5517,     0,     0,     0,     0,  2500,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2058,     0,     0,     0,     0,
    2059,   885,     0,  2519,     0,     0,     0,     0,     0,     0,
    2489,  2490,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2060,  2061,     0,   885,     0,     0,     0,     0,
    2513,     0,     0,     0,     0,     0,     0,  2062,   885,     0,
       0,     0,     0,     0,  5517,     0,  2067,     0,     0,  2068,
    2069,  2070,     0,  2071,  2072,  2073,  2074,  2075,  2076,  2600,
       0,     0,  5517,  4983,     0,  2558,  2559,  2560,  2561,     0,
       0,     0,  2608,     0,     0,     0,  2063,     0,     0,     0,
       0,     0,     0,     0,     0,  1097,     0,     0,     0,     0,
    2064,     0,     0,  2065,     0,     0,     0,  2623,     0,     0,
       0,  4727,  4728,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3266,     0,  3266,  3266,     0,     0,
    3266,     0,  2048,     0,     0,  2049,     0,     0,     0,  2050,
    2051,  2052,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2652,  1097,     0,     0,     0,  2053,  1729,     0,     0,
       0,     0,     0,     0,  2055,     0,     0,     0,     0,     0,
       0,  2056,     0,     0,     0,   876,     0,     0,     0,     0,
       0,   876,  2523,     0,   876,     0,     0,     0,     0,     0,
       0,  2066,     0,  2660,  4787,     0,  2057,     0,     0,  2664,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1491,     0,     0,     0,     0,
       0,  1492,     0,     0,     0,     0,     0,     0,  1558,     0,
       0,     0,  4814,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1559,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1494,     0,     0,     0,  4532,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2821,  2067,     0,     0,  2068,  2069,  2070,  1560,  2071,  2072,
    2073,  2074,  2075,  2076,     0,     0,     0,  2058,  5284,  2650,
       0,  2651,  2059,     0,     0,     0,     0,  1495,     0,     0,
       0,     0,     0,     0,  1496,     0,     0,  1497,  2662,     0,
    2663,  2831,     0,   885,  2060,  2061,     0,     0,     0,     0,
       0,     0,     0,     0,   613,     0,   613,     0,   613,  2062,
     613,   885,   613,  1498,     0,     0,   613,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   885,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1561,     0,     0,  1499,  2063,     0,
       0,     0,     0,     0,     0,     0,     0,   885,     0,     0,
       0,     0,  2064,     0,     0,  2065,     0,     0,     0,     0,
       0,     0,     0,   885,     0,     0,     0,     0,     0,     0,
       0,  3903,     0,     0,     0,     0,     0,     0,     0,   885,
       0,     0,  1562,   885,     0,  1563,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1564,     0,     0,     0,  1501,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1502,     0,  3266,     0,     0,     0,
       0,     0,     0,  1503,     0,  4976,     0,     0,     0,     0,
    2048,     0,     0,  2049,  1565,  1504,     0,  2050,  2051,  2052,
       0,     0,     0,  2066,  3022,     0,     0,     0,  2048,     0,
       0,  2049,     0,     0,  2053,  2050,  2051,  2052,  3039,     0,
       0,     0,  2055,     0,     0,     0,     0,     0,     0,  2056,
       0,     0,     0,     0,  1566,  3020,  3021,  1506,  1507,  1567,
    2055,     0,     0,     0,     0,     0,  3034,  2056,  3036,     0,
       0,     0,  3040,     0,  2057,     0,     0,     0,     0,  3072,
       0,  1568,   885,     0,     0,     0,     0,  1569,     0,     0,
     885,   885,  2057,     0,     0,     0,     0,     0,     0,     0,
       0,  1570,     0,     0,   885,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2957,  2958,     0,
       0,     0,     0,  2067,     0,     0,  2068,  2069,  2070,     0,
    2071,  2072,  2073,  2074,  2075,  2076,  2973,  2974,     0,     0,
    5307,  2977,  2978,     0,     0,     0,  2981,     0,     0,     0,
       0,     0,     0,     0,     0,  1509,     0,  1729,     0,     0,
    2992,     0,     0,     0,     0,     0,     0,  3001,     0,     0,
       0,  3004,  3005,     0,     0,  3008,  3009,     0,     0,     0,
       0,     0,  3014,     0,     0,  2058,     0,     0,     0,     0,
    2059,     0,     0,     0,     0,     0,     0,  3033,     0,  3035,
       0,     0,  3177,  2058,     0,  3180,     0,     0,  2059,     0,
       0,     0,  2060,  2061,     0,     0,     0,  3058,     0,     0,
       0,     0,  3060,     0,     0,  1062,     0,  2062,     0,  5155,
   -2671, -2671,     0,     0,     0,     0,     0,  3066,     0,     0,
       0,     0,     0,     0,     0,  2062,  3073,     0,     0,  3077,
       0,  3079,  3082,  3084,     0,     0,     0,     0,  3092,  3095,
       0,     0,     0,     0,     0,     0,  2063,     0,  3108,     0,
       0,     0,     0,  3117,     0,     0,     0,  3120,     0,     0,
    2064,     0,  3292,  2065, -2671,     0,     0,     0,  3269,     0,
       0,     0,     0,     0,  3137,     0,  3276,     0,  2064,  3279,
    3146,  3147,     0,     0,     0,  3281,     0,  3152,     0,     0,
       0,     0,     0,     0,     0,     0,  3293,  3166,  3167,     0,
       0,     0,     0,  3171,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3178,     0,     0,  3181,     0,
       0,     0,     0,  3184,     0,     0,     0,     0,     0,  3187,
    3188,     0,     0,     0,   885,  3192,     0,  3339,  3196,     0,
       0,     0,  3203,  3204,  3205,  3206,     0,  3208,     0,     0,
       0,  2066,     0,     0,     0,     0,     0,     0,     0,     0,
    3233,  3234,     0,  3236,     0,  3362,   888,     0,     0,  2066,
       0,     0,     0,     0,  3245,  3246,  3247,  2048,   922,     0,
    2049,     0,     0,     0,  2050,  2051,  2052,     0,     0,   941,
       0,     0,  1062,     0,     0,     0,  5296,     0,  5297,     0,
       0,  2053,  5302,  5303,     0,     0,     0,     0,     0,  2055,
       0,     0,     0,     0,     0,     0,  2056,     0,     0,     0,
       0,     0,     0,     0,  3429,     0,  3431,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3300,     0,     0,
       0,  2057,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2067,     0,     0,  2068,  2069,  2070,     0,  2071,  2072,
    2073,  2074,  2075,  2076,     0,  3337,  3474,     0,  5412,  2067,
       0,     0,  2068,  2069,  2070,     0,  2071,  2072,  2073,  2074,
    2075,  2076,  1729,  3486,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3494,     0,
       0,     0,     0,     0,     0,     0,   885,     0,     0,     0,
       0,     0,     0,     0,   885,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   885,     0,     0,     0,
       0,     0,     0,     0,  3496,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2058,     0,     0,     0,     0,  2059,     0,     0,
       0,  2048,     0,     0,  2049,     0,     0,     0,  2050,  2051,
    2052,     0,     0,     0,     0,     0,     0,     0,     0,  2060,
    2061,     0,     0,     0,     0,  2053,     0,     0,     0,     0,
       0,     0,     0,  2055,  2062,     0,     0,     0,   876,   876,
    2056,   885,   885,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   876,     0,   885,   876,     0,     0,     0,
       0,     0,     0,     0,     0,  2057,     0,     0,   885,   885,
       0,     0,     0,  2063,     0,     0,  1062,     0,     0,     0,
       0,     0,     0,     0,   885,     0,     0,  2064,     0,     0,
    2065,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3497,     0,     0,
       0,     0,     0,     0,     0,     0,   876,     0,     0,   876,
     876,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5518,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2058,     0,  2066,     0,
       0,  2059,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2060,  2061,     0,     0,     0,     0,  1729,
    3706,     0,     0,     0,     0,     0,     0,     0,  2062,     0,
     955,     0,     0,  5518,     0,     0,  1003,     0,     0,  3717,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5518,     0,     0,     0,     0,     0,     0,     0,  3709,
       0,  3710,  3711,  3712,     0,     0,     0,  2063,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2064,     0,     0,  2065,     0,     0,     0,  2067,   885,
       0,  2068,  2069,  2070,     0,  2071,  2072,  2073,  2074,  2075,
    2076,     0,     0,     0,     0,  5481,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3799,     0,  3801,     0,     0,     0,
       0,     0,     0,     0,     0,   885,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   885,     0,     0,     0,     0,  1729,   885,
       0,     0,  2066,   885,     0,     0,     0,     0,     0,  3703,
       0,   885,     0,  3705,     0,     0,     0,     0,     0,  3707,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   885,
       0,     0,     0,     0,     0,     0,     0,  3718,  3720,     0,
       0,     0,  3720,     0,     0,     0,  1339,  3731,  3732,  3733,
       0,   876,     0,     0,   876,   876,     0,  3852,     0,     0,
       0,     0,     0,     0,     0,  1362,     0,     0,     0,     0,
       0,     0,     0,     0,   885,     0,     0,     0,     0,     0,
       0,     0,     0,  3762,  3763,  3764,  3765,  1386,     0,     0,
       0,     0,     0,     0,   885,   885,     0,     0,  3874,     0,
       0,     0,  2067,     0,     0,  2068,  2069,  2070,     0,  2071,
    2072,  2073,  2074,  2075,  2076,     0,     0,     0,     0,  5537,
    3783,     0,  3787,  3788,  3789,  1729,   885,  2048,     0,  1729,
    2049,     0,  3875,  1522,  2050,  2051,  2052,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2053,   885,     0,  1729,     0,     0,     0,   885,  2055,
       0,     0,     0,     0,     0,   885,  2056,     0,     0,     0,
    2048,     0,   885,  2049,     0,   885,     0,  2050,  2051,  2052,
       0,   885,     0,     0,     0,     0,     0,     0,     0,     0,
    2048,  2057,     0,  2049,  2053,     0,  3072,  2050,  2051,  2052,
       0,   885,  2055,     0,     0,     0,     0,   885,     0,  2056,
       0,     0,   885,     0,  2053,  1729,     0,     0,  2913,     0,
       0,     0,  2055,     0,     0,   885,     0,     0,     0,  2056,
       0,  4010,     0,     0,  2057,     0,  3862,     0,   885,     0,
       0,     0,     0,  1729,     0,  3868,     0,     0,     0,   885,
       0,     0,     0,     0,  2057,     0,     0,     0,     0,  1778,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3882,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1816,  1819,
    1820,     0,     0,     0,     0,     0,     0,     0,     0,  3925,
       0,     0,  2058,  2914,     0,     0,     0,  2059,  4030,     0,
       0,     0,     0,     0,     0,  1729,     0,     0,     0,     0,
       0,  3549,     0,     0,     0,     0,  3550,     0,     0,  2060,
    2061,     0,     0,     0,     0,     0,     0,  4069,     0,     0,
       0,     0,     0,     0,  2062,  2058,     0,     0,     0,     0,
    2059,  3962,     0,     0,     0,     0,  3968,     0,     0,     0,
    4079,     0,     0,     0,     0,  2058,     0,     0,     0,     0,
    2059,     0,  2060,  2061,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2063,     0,  4102,     0,  2062,     0,     0,
    4007,     0,  2060,  2061,     0,     0,   885,  2064,     0,     0,
    2065,     0,     0,     0,     0,     0,     0,  2062,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1980,     0,     0,     0,     0,  2063,     0,     0,     0,
       0,     0,     0,  4026,  1339,  4027,     0,     0,     0,     0,
    2064,     0,     0,  2065,     0,     0,  2063,     0,     0,     0,
     884,     0,   885,     0,     0,     0,     0,  1987,     0,   884,
    2064,     0,     0,  2065,     0,     0,  1339,     0,     0,     0,
       0,     0,     0,   884,     0,  4051,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2066,     0,
       0,     0,     0,     0,   885,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   885,     0,     0,     0,     0,     0,     0,     0,
     885,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     876,  2066,     0,   876,     0,     0,   876,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2066,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4254,  4255,  4256,
    4257,     0,     0,     0,     0,     0,     0,     0,  2067,     0,
       0,  2068,  2069,  2070,     0,  2071,  2072,  2073,  2074,  2075,
    2076,     0,     0,  1729,  2119,  5551,     0,     0,     0,  1729,
       0,  2915,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2067,     0,     0,  2068,  2069,  2070,     0,  2071,  2072,
    2073,  2074,  2075,  2076,     0,     0,     0,     0,     0,     0,
    2174,  2067,     0,     0,  2068,  2069,  2070,     0,  2071,  2072,
    2073,  2074,  2075,  2076,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   885,     0,     0,     0,  4248,     0,  4249,     0,     0,
       0,     0,     0,     0,  4251,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4261,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4267,  2302,     0,     0,  4270,     0,     0,     0,
       0,     0,  2325,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4292,     0,  4408,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4440,
       0,  4411,  4296,     0,  2362,     0,     0,  4300,     0,     0,
     885,   885,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2385,     0,     0,
    2388,     0,  4335,     0,     0,     0,  4339,   885,     0,     0,
     885,     0,     0,     0,  4344,  4345,  4346,  4347,     0,     0,
       0,     0,     0,  4352,  4353,  4354,  4355,     0,     0,     0,
    4357,  4358,     0,     0,     0,     0,  4365,  4366,     0,  4368,
    4369,  4370,  4371,  4372,  4373,  4374,     0,     0,     0,     0,
       0,     0,  2438,     0,     0,  4383,     0,     0,     0,  4386,
    4387,  4388,  4389,     0,     0,     0,  2457,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   884,  3720,     0,     0,     0,     0,
     884,     0,     0,     0,  1729,  1729,  1729,     0,     0,     0,
       0,     0,     0,   884,  4412,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   885,   884,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   884,     0,  2048,     0,   885,  2049,
       0,     0,   884,  2050,  2051,  2052,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   884,   885,     0,     0,
    2053,     0,     0,  1980,     0,     0,   884,     0,  2055,     0,
       0,     0,     0,     0,     0,  2056,     0,  2481,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2057,     0,     0,     0,  3720,     0,     0,     0,     0,     0,
       0,     0,     0,  2048,     0,     0,  2049,     0,     0,     0,
    2050,  2051,  2052,     0,     0,     0,     0,     0,  2532,     0,
       0,     0,     0,     0,     0,     0,     0,  2053,     0,     0,
       0,  4526,     0,   885,     0,  2055,     0,     0,     0,     0,
       0,     0,  2056,     0,   884,     0,     0,  2575,     0,     0,
       0,     0,     0,     0,  2588,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2057,   884,     0,
       0,  4663,     0,     0,     0,     0,     0,     0,     0,     0,
    1729,   884,     0,     0,     0,     0,     0,   885,     0,   885,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2058,   885,     0,   885,     0,  2059,     0,     0,     0,
       0,     0,  4686,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1729,     0,  2060,  2061,
       0,     0,     0,     0,  4702,     0,     0,     0,     0,     0,
       0,     0,     0,  2062,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5442,     0,     0,     0,     0,     0,     0,
    2667,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     885,     0,     0,     0,     0,     0,     0,     0,  2058,     0,
       0,     0,  2063,  2059,     0,     0,     0,     0,     0,     0,
    1728,     0,     0,     0,     0,     0,  2064,     0,     0,  2065,
    1339,  1339,  4729,     0,     0,  2060,  2061,     0,     0,     0,
       0,     0,     0,     0,     0,  4722,     0,  2718,     0,     0,
    2062,     0,     0,     0,  4115,   885,     0,     0,     0,     0,
    4726,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   885,  4666,     0,     0,     0,  4667,  4668,
    4669,  4670,     0,     0,     0,  4672,     0,     0,     0,  2063,
       0,     0,     0,     0,     0,   885,     0,     0,   885,     0,
       0,     0,     0,  2064,     0,     0,  2065,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2066,     0,  4692,
    4693,  4694,  4695,  4696,     0,  4698,  4699,     0,     0,  5443,
       0,     0,     0,     0,  4116,     0,     0,  4708,  4709,     0,
       0,     0,     0,     0,     0,     0,     0,  2886,     0,     0,
       0,     0,     0,  4792,  4819,     0,     0,  2892,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4714,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1729,     0,     0,     0,     0,     0,  1386,     0,     0,     0,
       0,     0,     0,     0,  2066,     0,   884,  1386,  1386,     0,
       0,     0,     0,  1980,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   884,     0,     0,  2067,     0,     0,
    2068,  2069,  2070,     0,  2071,  2072,  2073,  2074,  2075,  2076,
       0,  1339,   884,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     884,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4778,     0,     0,     0,     0,   884,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   884,     0,  2067,     0,   884,  2068,  2069,  2070,
       0,  2071,  2072,  2073,  2074,  2075,  2076,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1491,     0,     0,
       0,     0,     0,  1492,     0,     0,     0,     0,     0,     0,
    1558,  4831,     0,  4911,     0,  4912,     0,     0,   885,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1559,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1494,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3076,     0,     0,  2048,     0,
       0,  2049,     0,     0,     0,  2050,  2051,  2052,  1729,     0,
    3098,     0,     0,  1729,     0,  1729,     0,     0,     0,  1560,
       0,     0,  2053,     0,     0,  3506,     0,     0,     0,     0,
    2055,  3125,     0,     0,     0,   884,     0,  2056,  1729,  1495,
       0,     0,     0,   884,   884,     0,  1496,     0,     0,  1497,
       0,     0,     0,     0,     0,     0,     0,   884,  1729,     0,
       0,     0,  2057,   613,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   885,  1498,     0,   885,     0,     0,
    2048,     0,     0,  2049,     0,     0,     0,  2050,  2051,  2052,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1110,     0,     0,     0,  2053,     0,  1561,  3201,  3202,  1499,
    1728,  1980,  2055,     0,     0,  5047,     0,     0,     0,  2056,
       0,     0,     0,     0,     0,     0,  1110,  4930,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2057,     0,  4940,     0,     0,     0,
    3852,  4945,  4946,     0,  1562,     0,     0,  1563,     0,     0,
       0,  4957,     0,     0,     0,     0,     0,     0,  4959,   885,
     885,     0,  1564,  2058,     0,     0,  1501,     0,  2059,   885,
       0,     0,     0,     0,     0,     0,  1502,     0,     0,     0,
       0,     0,     0,     0,     0,  1503,     0,     0,   885,     0,
    2060,  2061,     0,  1980,  5009,     0,  1565,  1504,  1980,  1980,
       0,     0,     0,     0,  3326,  2062,     0,     0,     0,     0,
       0,     0,     0,     0,  5026,     0,  5028,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5042,     0,     0,     0,     0,  3172,     0,     0,  1506,
    1507,  1567,     0,     0,  2063,  2058,     0,  5142,     0,  5144,
    2059,  3720,     0,     0,     0,     0,     0,     0,  2064,  5063,
       0,  2065,     0,  1568,     0,     0,   885,     0,     0,  3173,
       0,     0,  2060,  2061,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1570,  1315,  1315,     0,  2062,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   884,     0,  2048,
       0,     0,  2049,     0,     0,     0,  2050,  2051,  2052,     0,
       0,     0,     0,     0,  5223,     0,     0,     0,     0,     0,
       0,     0,     0,  2053,  5102,     0,  2063,     0,     0,     0,
       0,  2055,     0,     0,     0,     0,     0,  1509,  2056,     0,
    2064,     0,     0,  2065,     0,  5119,     0,     0,     0,  2066,
       0,     0,     0,     0,     0,     0,     0,  5127,     0,  1643,
       0,     0,  3522,  2057,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1110,     0,  2048,     0,     0,
    2049,     0,     0,     0,  2050,  2051,  2052,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1110,  2053,     0,     0,  3554,     0,     0,     0,     0,  2055,
       0,     0,     0,     0,     0,  1110,  2056,     0,     0,     0,
       0,     0,  5186,     0,     0,     0,     0,     0,     0,     0,
       0,  2066,     0,     0,  1640,  1644,     0,     0,     0,     0,
       0,  2057,     0,     0,     0,  1728,     0,     0,     0,  2067,
       0,     0,  2068,  2069,  2070,  3559,  2071,  2072,  2073,  2074,
    2075,  2076,     0,     0,     0,     0,     0,     0,     0,   884,
       0,     0,     0,     0,  2058,     0,     0,   884,     0,  2059,
       0,     0,     0,  5321,     0,     0,  3720,     0,     0,   884,
       0,     0,     0,   885,     0,     0,     0,     0,  1729,     0,
    1110,  2060,  2061,     0,     0,     0,     0,     0,     0,  5369,
       0,     0,     0,     0,     0,     0,  2062,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2067,     0,   885,  2068,  2069,  2070,     0,  2071,  2072,
    2073,  2074,  2075,  2076,     0,   885,  5272,     0,     0,     0,
       0,     0,  2058,     0,  3613,  2063,     0,  2059,     0,     0,
       0,  5285,     0,     0,   884,   884,     0,     0,     0,  2064,
       0,     0,  2065,     0,     0,   885,     0,  1386,   884,  2060,
    2061,     0,     0,     0,     0,  5392,     0,     0,     0,     0,
       0,   884,   884,     0,  2062,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5314,     0,   884,     0,     0,
       0,     0,     0,     0,     0,  1110,     0,     0,     0,     0,
    5325,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2063,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2064,     0,     0,
    2065,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2066,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   885,     0,     0,     0,     0,     0,
       0,     0,  5467,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5386,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5483,  5483,     0,     0,     0,     0,
       0,     0,     0,     0,  2004,     0,     0,     0,     0,     0,
       0,     0,  1728,     0,     0,     0,     0,     0,  2066,     0,
       0,     0,     0,     0,     0,  5408,     0,     0,     0,  2048,
       0,     0,  2049,     0,   885,  2019,  2050,  2051,  2052,     0,
    2067,     0,     0,  2068,  2069,  2070,     0,  2071,  2072,  2073,
    2074,  2075,  2076,  2053,     0,     0,  3565,     0,     0,     0,
       0,  2055,     0,  2037,  2038,  2039,     0,  2041,  2056,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   884,     0,     0,     0,     0,  2083,     0,     0,
       0,     0,     0,  2057,  3805,     0,     0,  5483,     0,     0,
       0,     0,     0,     0,     0,  2197,     0,     0,     0,     0,
       0,     0,     0,  5474,     0,     0,     0,     0,  2067,     0,
       0,  2068,  2069,  2070,     0,  2071,  2072,  2073,  2074,  2075,
    2076,     0,     0,     0,     0,     0,     0,     0,   884,     0,
       0,     0,     0,     0,     0,     0,   885,     0,   885,     0,
       0,     0,     0,     0,     0,  2141,   884,     0,     0,  2153,
    2158,  1728,   884,     0,     0,     0,   884,     0,     0,     0,
       0,     0,     0,  2197,   884,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   884,     0,     0,   885,     0,     0,     0,     0,
       0,     0,     0,     0,  2058,   876,     0,     0,     0,  2059,
       0,     0,     0,     0,  1110,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2060,  2061,     0,     0,     0,     0,   884,     0,  1109,
       0,     0,     0,     0,  1729,     0,  2062,  1110,     0,   876,
       0,     0,     0,     0,     0,     0,     0,   884,   884,     0,
       0,  3928,  3929,  3930,     0,  1109,     0,  1100,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3939,     0,
       0,     0,     0,     0,     0,  2063,     0,     0,  1728,   884,
       0,     0,  1728,  1100,     0,     0,     0,     0,     0,  2064,
       0,  3955,  2065,     0,     0,     0,     0,     0,     0,     0,
       0,  3965,  3967,     0,     0,   884,  3972,  1728,     0,     0,
       0,   884,     0,  1643,  1643,  1643,     0,     0,   884,     0,
       0,     0,     0,     0,     0,   884,     0,     0,   884,     0,
       0,     0,     0,     0,   884,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   884,     0,     0,     0,     0,     0,
     884,     0,     0,     0,     0,   884,     0,     0,  1728,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   884,     0,
    2066,     0,     0,     0,     0,     0,     0,     0,  1640,  1640,
    1640,   884,     0,     0,     0,     0,  1728,     0,     0,     0,
       0,     0,   884,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1110,     0,  1729,     0,
       0,  4050,     0,     0,  1339,     0,     0,     0,     0,     0,
       0,     0,     0,  1110,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   885,     0,     0,     0,     0,     0,
       0,  1110,     0,     0,     0,     0,     0,     0,   885,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1728,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2067,     0,     0,  2068,  2069,  2070,     0,  2071,  2072,  2073,
    2074,  2075,  2076,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1110,     0,     0,
       0,     0,     0,     0,  1109,     0,     0,     0,     0,     0,
    1110,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1110,     0,     0,     0,     0,     0,  1109,
       0,     0,  1100,     0,  2048,  1110,     0,  2049,     0,   884,
       0,  2050,  2051,  2052,  1109,     0,     0,  4156,  4157,  4158,
       0,     0,     0,     0,     0,     0,     0,  1100,  2053,     0,
       0,     0,     0,     0,     0,     0,  2055,     0,     0,     0,
       0,     0,  1100,  2056,     0,     0,     0,     0,     0,  1110,
    1110,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   884,     0,     0,  2057,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1109,
       0,     0,     0,  1729,     0,   885,     0,   884,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   884,     0,  1100,     0,     0,
       0,     0,     0,   884,  2048,     0,     0,  2049,     0,     0,
       0,  2050,  2051,  2052,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2053,     0,
       0,  4122,     0,     0,     0,     0,  2055,     0,     0,     0,
       0,     0,     0,  2056,     0,     0,     0,     0,     0,  2058,
       0,     0,     0,     0,  2059,     0,     0,     0,  1110,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2057,     0,
    1729,     0,     0,     0,     0,     0,  2060,  2061,     0,     0,
       0,     0,     0,     0,  1109,     0,  1728,     0,   885,     0,
    2761,  2062,  1728,     0,     0,     0,  1643,     0,     0,     0,
       0,   876,  2781,     0,  2782,     0,  2784,     0,     0,  2796,
    2799,  2804,  1100,     0,   885,     0,  2810,     0,     0,  2815,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2063,     0,     0,     0,  2822,  2823,  2824,  2825,     0,     0,
       0,     0,  2832,     0,  2064,     0,  2850,  2065,     0,  2852,
       0,     0,  2859,  2860,  2861,  2862,  2863,  2864,  2865,  2866,
    2867,     0,  2868,     0,     0,     0,     0,     0,     0,  1315,
       0,  1640,     0,     0,   884,     0,   876,   876,  4409,  2058,
       0,     0,     0,     0,  2059,     0,     0,     0,     0,  4422,
       0,     0,     0,     0,     0,     0,  2961,     0,     0,     0,
    2197,  2967,     0,     0,     0,     0,  2060,  2061,     0,     0,
       0,     0,     0,     0,  2905,     0,     0,     0,     0,   885,
    4453,  2062,     0,     0,     0,     0,     0,     0,  2104,     0,
       0,     0,     0,     0,     0,  2066,     0,     0,  2038,  2039,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2588,     0,     0,     0,     0,     0,     0,
    2063,     0,  1110,   884,   884,     0,     0,  4066,     0,     0,
       0,     0,     0,     0,  2064,     0,  1110,  2065,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     884,     0,     0,   884,  1109,     0,     0,     0,     0,     0,
       0,     0,  1729,     0,  2667,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1110,     0,     0,
       0,  3006,  1100,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2067,     0,     0,  2068,  2069,
    2070,     0,  2071,  2072,  2073,  2074,  2075,  2076,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1109,     0,     0,  2066,  1729,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1728,  1728,  1728,
       0,     0,     0,     0,  1729,     0,   876,   876,     0,  1102,
    1100,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   884,     0,  1109,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1102,     0,     0,     0,     0,
       0,   884,     0,     0,     0,  4589,  4590,  4591,  4592,     0,
       0,  1100,     0,     0,     0,     0,  1109,     0,     0,     0,
     884,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1100,  2067,     0,     0,  2068,  2069,
    2070,     0,  2071,  2072,  2073,  2074,  2075,  2076,     0,  2048,
       0,     0,  2049,  1643,     0,     0,  2050,  2051,  2052,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2053,     0,     0,     0,     0,     0,     0,
       0,  2055,     0,     0,     0,     0,     0,     0,  2056,     0,
    1110,     0,     0,     0,     0,     0,   884,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2057,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3257,  3258,  1640,     0,
       0,     0,  3262,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1728,     0,     0,     0,     0,     0,     0,
     884,     0,   884,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3291,   884,     0,   884,     0,     0,
       0,     0,  2197,     0,     0,  2197,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1109,     0,     0,     0,  1728,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1109,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1100,     0,     0,     0,     0,     0,     0,
    1109,     0,     0,     0,  2058,     0,     0,     0,     0,  2059,
    1100,     0,     0,   884,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1102,     0,     0,     0,  1100,     0,
       0,  2060,  2061,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2062,     0,     0,  1102,
       0,     0,     0,     0,     0,     0,  1109,     0,     0,     0,
       0,     0,     0,     0,  1102,     0,     0,     0,   884,  1109,
       0,     0,     0,     0,  1110,     0,     0,     0,     0,     0,
       0,     0,  1109,     0,  1100,  2063,   884,     0,     0,     0,
       0,  1110,     0,     0,  1109,     0,     0,  1100,     0,  2064,
       0,     0,  2065,     0,     0,     0,  1110,     0,   884,     0,
    1100,   884,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1100,     0,     0,     0,     0,     0,  4821,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1109,  1109,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1102,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1100,  1100,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2066,     0,  3502,  1728,     0,     0,     0,  3508,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2041,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2804,     0,  2804,  2804,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3568,     0,     0,
    3571,     0,  3573,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1102,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1109,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3594,     0,  3597,
    2067,  3599,     0,  2068,  2069,  2070,     0,  2071,  2072,  2073,
    2074,  2075,  2076,     0,     0,  1100,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2197,
       0,     0,  2967,     0,  2967,     0,     0,     0,     0,  2197,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2141,     0,     0,     0,
       0,   884,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2158,     0,     0,     0,     0,     0,     0,     0,     0,
    4981,     0,     0,     0,     0,     0,     0,     0,  1110,     0,
       0,     0,     0,     0,     0,  4994,     0,     0,     0,     0,
    1339,     0,     0,     0,     0,     0,     0,  1110,     0,     0,
       0,  1728,     0,     0,     0,     0,  1728,     0,  1728,     0,
       0,     0,   624,     0,     0,  1109,  5031,     0,     0,  1109,
    1109,     0,  2197,     0,     0,  3689,     0,     0,     0,   625,
       0,  1728,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1100,     0,     0,     0,  1100,  1100,     0,
       0,  1728,   626,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   627,     0,   884,     0,     0,
     884,     0,     0,     0,  1102,     0,   628,     0,     0,     0,
    -860,  1109,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1110,     0,  1110,  1109,     0,     0,   629,     0,
       0,     0,     0,     0,   630,     0,     0,     0,     0,  1100,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   631,     0,  1100,     0,     0,     0,     0,     0,     0,
       0,     0,   632,     0,     0,     0,  1109,  5115,     0,     0,
       0,   633,  1102,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   634,     0,     0,     0,     0,     0,     0,
       0,   635,   884,   884,  1100,   636,     0,     0,     0,     0,
    1103,     0,   884,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1102, -1089,  1110,     0,     0,     0,     0,
       0,   884,     0,     0,     0,     0,  1103,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1643,     0,     0,     0,  1102,     0,  1643,     0,
       0,   637,     0,     0,     0,     0,  1110,     0,     0,     0,
    -577,     0,     0,     0,     0,     0,     0,  5193,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2967,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   884,
     638,     0,     0,   639,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1640,     0,     0,
       0,     0,     0,  1640,   640,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   641,     0,
       0,     0,     0,     0,     0,  -448,     0,     0,     0,     0,
       0,     0,     0,     0,  1110,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   642,     0,     0,     0,     0,  1109,
       0,     0,     0,   643,     0,  2967,     0,     0,     0,     0,
    -448,     0,     0,   644,     0,     0,     0,     0,     0,  1110,
       0,     0,     0,     0,     0,     0,     0,  1100,     0,     0,
       0,     0,   645,     0,     0,     0,     0,     0,     0,   646,
       0,     0,     0,     0,     0,  -448,     0,     0,   647,   648,
       0,   649,   650,     0,     0,  1102,     0,     0,     0,     0,
       0,     0,   651,     0,     0,     0,     0,   652,     0,     0,
       0,     0,  1102,     0,   653,     0,     0,   654,     0,     0,
     655,  1109,     0,     0,  1109,     0,     0,     0,     0,     0,
    1102,     0,     0,  -448,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1100,
       0,     0,  1100,     0,     0,  1103,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1110,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1103,     0,     0,     0,     0,     0,  1102,     0,  1110,     0,
       0,     0,     0,     0,     0,  1103,   884,     0,     0,  1102,
       0,  1728,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1102,  1110,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1102,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   884,  4067,     0,     0,
       0,     0,     0,  1109,     0,     0,  4071,     0,   884,  1110,
       0,     0,     0,     0,  4073,     0,  4074,     0,     0,     0,
    1109,     0,     0,     0,     0,     0,     0,     0,  1102,  1102,
       0,  1100,     0,     0,     0,  1109,     0,     0,   884,     0,
    1103,     0,     0,  4098,  4099,     0,     0,     0,  1100,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2810,     0,  1100,     0,     0,     0,     0,     0,  4125,
     958,     0,  4128,     0,  4130,   959,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4135,     0,     0,     0,
       0,     0,     0,     0,  4142,  4143,     0,     0,     0,  2197,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     960,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   961,   962,     0,  4189,     0,     0,     0,
       0,     0,     0,     0,   963,     0,     0,   884,   964,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4204,     0,     0,  1103,   965,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1102,  4217,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   966,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     967,   192,     0,     0,     0,     0,     0,     0,  2967,   968,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   969,     0,     0,     0,     0,   970,   884,     0,     0,
       0,     0,     0,  2967,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   193,
    1105,     0,   971,     0,     0,     0,     0,     0,  1109,     0,
       0,  1109,     0,  1109,   194,     0,     0,     0,  1109,     0,
       0,     0,     0,     0,     0,     0,  1105,   972,     0,     0,
       0,     0,   195,     0,     0,     0,  1100,     0,   196,  1100,
       0,  1100,     0,     0,     0,     0,  1100,     0,   973,     0,
       0,     0,     0,     0,     0,   197,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1102,   198,  1109,     0,  1102,
    1102,     0,     0,     0,     0,   199,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1109,   200,   974,   884,
       0,   884,   201,     0,     0,  1100,     0,     0,     0,   202,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1109,   975,     0,  1100,     0,     0,  1110,   203,     0,
       0,     0,   208,   976,     0,  1103,   977,     0,     0,     0,
       0,  1102,     0,     0,     0,     0,     0,     0,   884,  1100,
       0,     0,     0,   204,     0,  1102,     0,     0,     0,     0,
       0,     0,   978,     0,     0,   979,     0,     0,     0,   980,
       0,   981,     0,     0,   205,  2967,     0,     0,   982,  2197,
       0,   983,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1109,     0,  1109,     0,     0,  1102,  1728,     0,     0,
     984,     0,     0,  1103,     0,     0,     0,   985,     0,     0,
       0,     0,     0,   986,   206,     0,   987,     0,     0,  1100,
     988,  1100,     0,     0,     0,     0,     0,     0,   989,     0,
     990,     0,     0,     0,     0,   991,     0,     0,   207,     0,
       0,     0,     0,     0,  1103,     0,     0,     0,   208,   209,
       0,     0,   210,     0,     0,  4498,  4499,     0,     0,     0,
       0,   992,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1103,   211,     0,
       0,   212,     0,     0,  1109,   213,     0,   214,     0,     0,
       0,     0,     0,     0,   215,  1105,     0,   216,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1110,  1100,     0,     0,     0,   217,     0,     0,     0,
    1105,  1110,     0,   218,     0,  1109,     0,     0,   219,   220,
    4541,     0,   221,     0,     0,  1105,   222,     0,     0,     0,
       0,     0,  4547,     0,     0,     0,   223,     0,     0,     0,
       0,   224,     0,  1100,  1109,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   225,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   226,     0,     0,
       0,  1728,  1100,  4565,  4567,     0,     0,     0,     0,     0,
    4571,  4572,     0,     0,     0,  4573,     0,     0,     0,  1102,
       0,  4576,  1106,     0,  4579,  4580,     0,   884,     0,  4584,
       0,     0,     0,     0,     0,  4588,     0,     0,     0,     0,
    1105,   884,     0,  1109,     0,     0,     0,     0,  1106,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1110,
       0,     0,     0,     0,  1109,     0,     0,     0,     0,     0,
       0,  1100,     0,     0,     0,     0,  1103,     0,  1109,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1315,
       0,     0,  1100,  1103,     0,     0,     0,     0,     0,     0,
    1110,  1102,     0,     0,  1102,     0,  1100,     0,     0,     0,
       0,  1103,     0,     0,     0,     0,  4645,     0,     0,     0,
       0,     0,  1110,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1105,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1103,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1103,     0,     0,     0,  1109,     0,     0,     0,     0,     0,
    1110,     0,     0,  1103,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1103,     0,  1109,     0,     0,
       0,     0,  1100,     0,     0,     0,     0,     0,     0,     0,
    4711,     0,     0,  1102,     0,     0,  1728,     0,   884,     0,
       0,     0,  1109,     0,     0,  1100,     0,     0,     0,     0,
    1102,     0,     0,     0,     0,     0,     0,     0,     0,  1103,
    1103,     0,     0,     0,     0,  1102,     0,     0,     0,     0,
    1100,     0,     0,     0,     0,     0,     0,     0,  1109,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4749,     0,  1100,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1106,     0,     0,
    4818,     0,  1110,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1728,     0,     0,     0,     0,     0,     0,
       0,     0,  1106,     0,     0,     0,     0,     0,     0,     0,
       0,   884,     0,     0,     0,     0,     0,  1106,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1109,     0,
       0,  1110,     0,     0,     0,  1105,     0,   884,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1100,     0,  1103,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1106,  1105,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1109,     0,     0,
       0,  4853,  4854,     0,     0,  4855,     0,     0,  1102,     0,
       0,  1102,   884,  1102,  1105,     0,     0,     0,  1102,     0,
       0,     0,  1109,     0,     0,  1100,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2967,     0,
       0,     0,  4890,  4891,     0,     0,     0,  1105,     0,     0,
    1100,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4902,     0,     0,     0,     0,     0,  1103,  1102,     0,     0,
    1103,  1103,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1102,  1106,     0,     0,
       0,     0,     0,     0,     0,  1728,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1102,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1103,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1103,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1109,     0,     0,  1728,
    1108,     0,     0,     0,  2967,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1728,     0,     0,
       0,  1102,     0,  1102,  1100,     0,  1108,  1103,     0,  1110,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1109,     0,     0,     0,  1109,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1105,     0,  1110,     0,
       0,     0,  1100,     0,     0,     0,  1100,     0,     0,     0,
       0,     0,     0,  1105,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1105,     0,     0,     0,     0,  2810,     0,     0,     0,
       0,     0,     0,     0,  1102,     0,     0,     0,     0,     0,
       0,  1110,     0,     0,     0,     0,  1110,  1110,     0,     0,
       0,     0,     0,  5085,     0,     0,     0,  1106,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2041,     0,     0,
       0,     0,     0,     0,     0,  1102,     0,  1105,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1105,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1109,     0,     0,  1105,  1102,     0,     0,     0,     0,     0,
    1109,     0,     0,     0,     0,  1105,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1106,  5134,     0,  1100,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1100,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1103,     0,     0,     0,     0,     0,     0,     0,     0,  1105,
    1105,  4818,  1110,     0,     0,     0,  1106,     0,     0,  5171,
       0,     0,     0,  1102,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1102,     0,     0,     0,     0,  1106,
       0,     0,     0,     0,     0,  1108,     0,     0,  1102,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1109,     0,
    1108,     0,  1103,     0,     0,  1103,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1108,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1100,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1109,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4890,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1109,     0,     0,     0,     0,     0,  1100,  1105,     0,
       0,     0,     0,     0,     0,     0,     0,  5274,     0,     0,
       0,     0,     0,     0,  1102,     0,     0,     0,     0,  1100,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1108,     0,     0,     0,     0,     0,     0,  1102,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1103,     0,     0,  1110,     0,  1109,
       0,     0,  1102,     0,     0,     0,     0,     0,     0,     0,
       0,  1103,     0,     0,     0,     0,     0,     0,  1106,     0,
       0,     0,     0,     0,  5328,     0,  1103,  1100,     0,     0,
       0,     0,     0,     0,     0,  1106,     0,     0,  1102,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1106,     0,     0,     0,     0,     0,  5356,
    5356,  5356,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1105,     0,  4890,     0,
    1105,  1105,     0,     0,     0,  1108,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1106,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1109,  1106,     0,     0,     0,     0,     0,  1102,     0,
       0,     0,     0,     0,     0,  1106,     0,     0,     0,     0,
       0,     0,  1105,     0,     0,     0,     0,  1106,     0,  1100,
       0,     0,     0,     0,     0,     0,  1105,     0,     0,  5417,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1109,     0,     0,     0,     0,     0,     0,  5356,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1106,  1106,     0,     0,     0,     0,  1105,  1100,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1102,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1103,
       0,     0,  1103,     0,  1103,     0,     0,     0,     0,  1103,
       0,     0,  1102,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5509,     0,     0,
       0,     0,     0,     0,     0,  1108,     0,     0,  1103,     0,
       0,     0,     0,     0,     0,     0,     0,  1109,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1103,     0,     0,
       0,     0,  5356,     0,     0,     0,     0,     0,     0,     0,
    1106,     0,  5536,     0,     0,  1100,     0,     0,     0,     0,
       0,     0,  1103,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1108,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1102,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1105,     0,     0,     0,  1108,     0,     0,     0,     0,     0,
       0,     0,  1103,     0,  1103,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1109,  1102,     0,     0,  1108,  1102,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1109,     0,
       0,  1100,     0,     0,     0,     0,     0,     0,  1106,     0,
       0,     0,  1106,  1106,     0,     0,     0,     0,     0,     0,
       0,     0,  1105,     0,     0,  1105,  1100,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1109,     0,     0,
       0,     0,     0,     0,     0,  1103,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1100,     0,     0,     0,     0,
       0,     0,     0,     0,  1106,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1103,     0,  1106,     0,
    1109,     0,     0,     0,     0,  1109,  1109,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1102,     0,     0,     0,     0,  1103,     0,     0,  1100,     0,
    1102,     0,     0,  1100,  1100,     0,     0,     0,     0,  1106,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1105,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1108,     0,     0,     0,
       0,  1105,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1108,     0,     0,  1105,     0,     0,     0,
       0,     0,     0,     0,  1103,     0,     0,     0,     0,     0,
       0,  1108,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1103,     0,     0,     0,     0,
       0,  1109,     0,     0,     0,     0,     0,     0,     0,  1103,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1102,  1100,
       0,     0,     0,     0,     0,     0,     0,  1108,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1108,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1108,     0,     0,     0,     0,     0,  1102,
       0,     0,     0,     0,     0,  1108,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1102,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1103,     0,     0,     0,  1108,
    1108,     0,  1106,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1103,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2078,  1102,
       0,     0,     0,  1103,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1105,
       0,     0,  1105,     0,  1105,     0,     0,     0,     0,  1105,
       0,     0,     0,     0,     0,     0,  1109,     0,     0,  1103,
       0,     0,     0,     0,  1106,     0,     0,  1106,     0,     0,
       0,     0,     0,     0,     0,     0,  2078,     0,     0,     0,
       0,     0,     0,     0,  1100,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1105,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1105,  1108,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1102,  1105,     0,     0,     0,     0,     0,     0,  1103,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1106,     0,     0,     0,
    1102,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1106,     0,     0,     0,     0,     0,     0,
       0,     0,  1105,     0,  1105,     0,     0,     0,  1106,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1103,     0,
       0,     0,     0,     0,     0,     0,  1108,     0,     0,     0,
    1108,  1108,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1103,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1105,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1108,     0,     0,     0,     0,  1102,     0,     0,
       0,     0,     0,     0,     0,     0,  1108,     0,     0,     0,
       0,     0,     0,  2078,     0,     0,  1105,  2078,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1105,     0,  1108,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1103,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1106,     0,     0,  1106,     0,  1106,     0,     0,     0,
       0,  1106,     0,     0,  1105,     0,     0,     0,     0,     0,
       0,     0,     0,  1102,     0,  1103,     0,     0,     0,  1103,
       0,     0,     0,     0,     0,  1105,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1102,  1105,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1106,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1106,
       0,     0,     0,     0,     0,     0,     0,  1102,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1106,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1102,     0,     0,     0,     0,  1102,  1102,     0,     0,     0,
    1108,     0,     0,     0,     0,  1105,     0,     0,     0,     0,
       0,  1103,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1103,     0,     0,  1106,     0,  1106,     0,  1105,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1105,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1108,     0,     0,  1108,     0,     0,     0,  1105,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1102,     0,     0,     0,     0,     0,  1106,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2078,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1103,
       0,     0,  2078,     0,     0,     0,  2792,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1106,     0,
    2078,  2078,  2078,     0,  2078,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1105,
    1103,     0,     0,     0,     0,     0,     0,  1106,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1103,     0,  1108,     0,  2078,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1108,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1108,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1106,     0,     0,     0,
       0,     0,     0,     0,  2078,     0,     0,     0,     0,     0,
    1103,     0,     0,     0,     0,     0,  2078,  1106,  1105,     0,
       0,  2078,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1106,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1105,     0,     0,  1102,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1103,     0,     0,     0,     0,  1106,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1106,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1105,     0,     0,
       0,  1103,     0,     0,     0,  1106,     0,     0,     0,  1108,
       0,     0,  1108,     0,  1108,     0,     0,     0,     0,  1108,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1106,     0,     0,     0,  1105,     0,     0,     0,  1105,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1108,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1108,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1108,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1106,     0,     0,     0,     0,     0,     0,  1103,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1105,  1108,     0,  1108,     0,     0,     0,     0,     0,
       0,  1105,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1106,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1106,     0,     0,     0,     0,
       0,     0,     0,     0,  1103,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1108,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1103,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1105,
       0,     0,     0,     0,     0,     0,  1108,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1103,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1108,     0,     0,     0,     0,
    1105,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1105,     0,     0,     0,     0,     0,     0,     0,
       0,  1103,     0,     0,     0,     0,  1103,  1103,     0,  1106,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1108,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1108,     0,  1106,     0,     0,
    1105,  1106,     0,     0,  2078,     0,     0,     0,     0,  1108,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2078,  2078,     0,  2078,     0,     0,
    2792,  2792,     0,  3545,     0,  2792,     0,     0,     0,  2078,
       0,     0,  2078,     0,     0,     0,     0,  2078,     0,     0,
       0,     0,     0,  2078,     0,     0,     0,     0,  2078,     0,
       0,     0,  1103,     0,     0,  2078,  2078,  2078,  2078,     0,
       0,     0,  2792,  2792,     0,  2078,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2078,     0,  2078,     0,     0,     0,     0,
       0,     0,  2078,  2078,  2078,  2078,  2078,  2078,  2078,  2078,
    2078,  2078,     0,     0,     0,  1108,     0,     0,     0,     0,
       0,     0,  1105,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1106,     0,     0,     0,     0,  1108,     0,
       0,     0,     0,  1106,     0,     0,     0,     0,  2078,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1108,     0,     0,     0,     0,     0,     0,
       0,  1105,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1108,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2078,
       0,     0,     0,     0,     0,     0,     0,  1103,     0,     0,
       0,  1106,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1108,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1106,     0,     0,     0,     0,     0,  1105,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1106,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1108,     0,
       0,     0,  1106,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1108,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1105,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1105,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1105,     0,
    2078,  2078,     0,     0,     0,  2078,     0,     0,     0,     0,
       0,     0,     0,     0,  1106,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2078,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1108,     0,     0,
       0,  1105,     0,     0,     0,     0,  1105,  1105,     0,     0,
       0,     0,     0,  1106,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1108,     0,     0,     0,  1108,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1105,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1106,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1108,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1108,     0,     0,     0,  2078,     0,     0,     0,     0,
       0,  2078,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3545,
    3545,     0,     0,  2792,  2792,  2792,  2792,     0,     0,  2792,
    2792,  2792,  2792,  2792,  2792,  2792,  2792,  2792,  2792,  3545,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2078,     0,     0,  2078,     0,  2078,     0,     0,  3545,
    3545,     0,     0,     0,     0,     0,  1106,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2078,  2792,  2792,
    2078,     0,  2078,     0,     0,     0,     0,     0,     0,     0,
       0,  1106,     0,     0,     0,     0,     0,     0,     0,  1108,
       0,     0,     0,     0,     0,     0,     0,  1105,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1106,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1108,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1108,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2078,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1106,     0,     0,     0,     0,  1106,  1106,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1108,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1106,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1108,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2792,     0,     0,     0,     0,     0,     0,     0,
       0,  1108,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1106,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1108,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2078,     0,     0,     0,  2078,     0,  2078,  2078,     0,     0,
       0,     0,     0,  3545,  3545,  3545,  3545,     0,     0,     0,
       0,  3545,  3545,  3545,  3545,  3545,  3545,  3545,  3545,  3545,
    3545,  2078,  2078,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2078,     0,
       0,  2078,     0,  2078,     0,     0,     0,     0,  2078,     0,
       0,  3545,  3545,     0,     0,  2078,  2078,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1108,     0,     0,     0,     0,     0,
       0,     0,  2078,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2078,     0,  1108,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2078,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1108,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1108,     0,     0,     0,     0,  1108,  1108,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3545,     0,     0,     0,
       0,     0,  1108,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2078,  2078,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2078,     0,     0,     0,     0,     0,
    2078,  2792,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2078,     0,
    2078,     0,     0,     0,  2078,  2078,  2078,     0,     0,  2078,
       0,     0,  2078,  2078,     0,     0,     0,  2078,     0,     0,
       0,  2078,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1108,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2078,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2078,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2078,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3545,  2792,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2078,  2078,  2078,     0,
       0,     0,     0,     0,     0,     0,  2792,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2078,  2078,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2078,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3545,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2792,     0,     0,  3545,     0,     0,     0,  2078,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2078,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2078,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3545,     0,  2792,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2078,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2078,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2078,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2078,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2792,  2792,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3545,  3545,     0,
       0,     0,  2078,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   229,     0,  1231,   670,     0,  1232,  1233,
    1234,   730,  1235,     0,     0,     0,     0,     0,     0,  2078,
     230,   231,   232,   233,   234,   235,   236,   237,  1634,   238,
     239,   240,     0,     0,     0,     0,  1236,     0,     0,   241,
     242,     0,   243,   244,   245,   246,   247,   248,   249,   250,
    1237,   252,  1238,  1239,     0,   255,   256,   257,   258,   259,
     260,  1240,  1241,   261,   262,  1242,  1243,   265,     0,   266,
     267,   268,   269,  1244,     0,  1245,     0,   272,   273,   274,
     275,   276,   277,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,   287,   288,   289,   290,  1246,  1247,
    1248,  1249,  1250,  1251,  1252,   292,   293,   294,   295,   296,
     297,  1253,  1254,   300,  1255,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,  1635,     0,
     312,   313,  1081,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,  1256,   328,
     329,   330,   331,  1257,  1258,   333,     0,   334,   335,  1259,
     337,     0,   338,     0,   339,   340,     0,   341,   342,   343,
     344,   345,     0,   346,  1260,     0,  1261,   349,   350,     0,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,  1262,  1263,     0,  1264,
       0,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,     0,     0,   388,  1265,   390,   391,   392,     0,   393,
     394,   395,  1266,  1267,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
    1268,   413,  1269,   415,   416,   417,   418,   419,   420,   421,
     422,  1270,   424,  1271,   425,   426,   427,   428,  1272,  1273,
     430,  1274,   432,   433,   434,     0,   435,   436,     0,     0,
    1275,   438,   439,     0,     0,   440,   441,   442,   443,   444,
     445,  1276,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,  1277,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,  1278,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,   494,   495,   496,   497,   498,  1279,
     500,   501,   502,   503,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,   513,  1280,   514,   515,   516,   517,
     518,   519,   520,   521,  1281,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
    1282,   538,     0,   539,   540,     0,   541,   542,   543,   544,
     545,   546,   547,     0,   548,  1283,  1284,     0,     0,   551,
     552,  1285,   554,  1286,  1287,   556,   557,   558,   559,   560,
     561,   562,   563,     0,  1288,   564,   565,   566,   567,   568,
    1289,     0,   569,   570,   571,   572,   573,   574,  1290,  1636,
     576,   577,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   588,   589,  1291,  1292,
    1293,  1294,   594,  1295,  1296,  1297,  1298,   599,   600,   601,
     602,  1299,     0,     0,     0,     0,     0,     0,  1300,  1301,
    1637,     0,     0,     0,     0,     0,     0,  1303,  1638,   229,
       0,  1231,   670,     0,  1232,  1233,  1234,   730,  1235,     0,
       0,     0,     0,     0,     0,     0,   230,   231,   232,   233,
     234,   235,   236,   237,     0,   238,   239,   240,     0,     0,
       0,     0,  1236,     0,     0,   241,   242,     0,   243,   244,
     245,   246,   247,   248,   249,   250,  1237,   252,  1238,  1239,
       0,   255,   256,   257,   258,   259,   260,  1240,  1241,   261,
     262,  1242,  1243,   265,     0,   266,   267,   268,   269,  1244,
       0,  1245,     0,   272,   273,   274,   275,   276,   277,   278,
     279,   280,     0,   281,   282,   283,   284,   285,   286,     0,
     287,   288,   289,   290,  1246,  1247,  1248,  1249,  1250,  1251,
    1252,   292,   293,   294,   295,   296,   297,  1253,  1254,   300,
    1255,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,   313,  1081,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,  1256,   328,   329,   330,   331,  1257,
    1258,   333,     0,   334,   335,  1259,   337,     0,   338,     0,
     339,   340,     0,   341,   342,   343,   344,   345,     0,   346,
    1260,     0,  1261,   349,   350,     0,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,     0,   361,   362,   363,
     364,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,  1262,  1263,     0,  1264,     0,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,     0,     0,   388,
    1265,   390,   391,   392,     0,   393,   394,   395,  1266,  1267,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,  1268,   413,  1269,   415,
     416,   417,   418,   419,   420,   421,   422,  1270,   424,  1271,
     425,   426,   427,   428,  1272,  1273,   430,  1274,   432,   433,
     434,     0,   435,   436,     0,     0,  1275,   438,   439,     0,
       0,   440,   441,   442,   443,   444,   445,  1276,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   456,
     457,  1277,   459,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,  1278,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,   493,
     494,   495,   496,   497,   498,  1279,   500,   501,   502,   503,
     504,   505,   506,   507,   508,    41,   509,   510,   511,   512,
     513,  1280,   514,   515,   516,   517,   518,   519,   520,   521,
    1281,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,  1282,   538,     0,   539,
     540,    45,   541,   542,   543,   544,   545,   546,   547,     0,
     548,  1283,  1284,     0,     0,   551,   552,  1285,   554,  1286,
    1287,   556,   557,   558,   559,   560,   561,   562,   563,     0,
    1288,   564,   565,   566,   567,   568,  1289,     0,   569,   570,
     571,   572,   573,  1160,  1290,     0,   576,   577,   578,   579,
     580,   581,     0,     0,   582,     0,    50,   583,   584,   585,
     586,   587,   588,   589,  1291,  1292,  1293,  1294,   594,  1295,
    1296,  1297,  1298,   599,   600,   601,   602,  1299,     0,    51,
       0,     0,     0,     0,  1300,  1301,     0,     0,     0,     0,
       0,     0,     0,  1303,  5096,   229,     0,  1231,   670,     0,
    1232,  1233,  1234,   730,  1235,     0,     0,     0,     0,     0,
       0,     0,   230,   231,   232,   233,   234,   235,   236,   237,
       0,   238,   239,   240,     0,     0,     0,     0,  1236,     0,
       0,   241,   242,     0,   243,   244,   245,   246,   247,   248,
     249,   250,  1237,   252,  1238,  1239,     0,   255,   256,   257,
     258,   259,   260,  1240,  1241,   261,   262,  1242,  1243,   265,
       0,   266,   267,   268,   269,  1244,     0,  1245,     0,   272,
     273,   274,   275,   276,   277,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0,   287,   288,   289,   290,
    1246,  1247,  1248,  1249,  1250,  1251,  1252,   292,   293,   294,
     295,   296,   297,  1253,  1254,   300,  1255,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,  1081,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
    1256,   328,   329,   330,   331,  1257,  1258,   333,     0,   334,
     335,  1259,   337,     0,   338,     0,   339,   340,     0,   341,
     342,   343,   344,   345,     0,   346,  1260,     0,  1261,   349,
     350,     0,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,     0,   361,   362,   363,   364,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,  1262,  1263,
       0,  1264,     0,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,     0,     0,   388,  1265,   390,   391,   392,
       0,   393,   394,   395,  1266,  1267,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,  1268,   413,  1269,   415,   416,   417,   418,   419,
     420,   421,   422,  1270,   424,  1271,   425,   426,   427,   428,
    1272,  1273,   430,  1274,   432,   433,   434,     0,   435,   436,
       0,     0,  1275,   438,   439,     0,     0,   440,   441,   442,
     443,   444,   445,  1276,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,  1277,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,  1278,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,   494,   495,   496,   497,
     498,  1279,   500,   501,   502,   503,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,   513,  1280,   514,   515,
     516,   517,   518,   519,   520,   521,  1281,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,  1282,   538,     0,   539,   540,     0,   541,   542,
     543,   544,   545,   546,   547,     0,   548,  1283,  1284,     0,
       0,   551,   552,  1285,   554,  1286,  1287,   556,   557,   558,
     559,   560,   561,   562,   563,     0,  1288,   564,   565,   566,
     567,   568,  1289,     0,   569,   570,   571,   572,   573,   574,
    1290,     0,   576,   577,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,   589,
    1291,  1292,  1293,  1294,   594,  1295,  1296,  1297,  1298,   599,
     600,   601,   602,  1299,     0,     0,     0,     0,     0,     0,
    1300,  1301,     0,     0,     0,     0,     0,     0,     0,  1303,
    2794,   229,     0,  1231,   670,     0,  1232,  1233,  1234,   730,
    1235,     0,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   236,   237,     0,   238,   239,   240,
       0,     0,     0,     0,  1236,     0,     0,   241,   242,     0,
     243,   244,   245,   246,   247,   248,   249,   250,  1237,   252,
    1238,  1239,     0,   255,   256,   257,   258,   259,   260,  1240,
    1241,   261,   262,  1242,  1243,   265,     0,   266,   267,   268,
     269,  1244,     0,  1245,     0,   272,   273,   274,   275,   276,
     277,   278,   279,   280,     0,   281,   282,   283,   284,   285,
     286,     0,   287,   288,   289,   290,  1246,  1247,  1248,  1249,
    1250,  1251,  1252,   292,   293,   294,   295,   296,   297,  1253,
    1254,   300,  1255,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   309,   310,   311,     0,     0,   312,   313,
    1081,   315,   316,     0,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,  1256,   328,   329,   330,
     331,  1257,  1258,   333,     0,   334,   335,  1259,   337,     0,
     338,     0,   339,   340,     0,   341,   342,   343,   344,   345,
       0,   346,  1260,     0,  1261,   349,   350,     0,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,     0,   361,
     362,   363,   364,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,  1262,  1263,     0,  1264,     0,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,     0,
       0,   388,  1265,   390,   391,   392,     0,   393,   394,   395,
    1266,  1267,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,  1268,   413,
    1269,   415,   416,   417,   418,   419,   420,   421,   422,  1270,
     424,  1271,   425,   426,   427,   428,  1272,  1273,   430,  1274,
     432,   433,   434,     0,   435,   436,     0,     0,  1275,   438,
     439,     0,     0,   440,   441,   442,   443,   444,   445,  1276,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
       0,   456,   457,  1277,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
    1278,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,   494,   495,   496,   497,   498,  1279,   500,   501,
     502,   503,   504,   505,   506,   507,   508,     0,   509,   510,
     511,   512,   513,  1280,   514,   515,   516,   517,   518,   519,
     520,   521,  1281,   523,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,  1282,   538,
       0,   539,   540,     0,   541,   542,   543,   544,   545,   546,
     547,     0,   548,  1283,  1284,     0,     0,   551,   552,  1285,
     554,  1286,  1287,   556,   557,   558,   559,   560,   561,   562,
     563,     0,  1288,   564,   565,   566,   567,   568,  1289,     0,
     569,   570,   571,   572,   573,   574,  1290,     0,   576,   577,
     578,   579,   580,   581,     0,     0,   582,     0,     0,   583,
     584,   585,   586,   587,   588,   589,  1291,  1292,  1293,  1294,
     594,  1295,  1296,  1297,  1298,   599,   600,   601,   602,  1299,
       0,     0,     0,     0,     0,     0,  1300,  1301,     0,     0,
       0,     0,     0,     0,     0,  1303,  4076,   229,     0,  1231,
     670,     0,  1232,  1233,  1234,   730,  1235,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
    1236,     0,     0,   241,   242,     0,   243,   244,   245,   246,
     247,   248,   249,   250,  1237,   252,  1238,  1239,     0,   255,
     256,   257,   258,   259,   260,  1240,  1241,   261,   262,  1242,
    1243,   265,     0,   266,   267,   268,   269,  1244,     0,  1245,
       0,   272,   273,   274,   275,   276,   277,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,   287,   288,
     289,   290,  1246,  1247,  1248,  1249,  1250,  1251,  1252,   292,
     293,   294,   295,   296,   297,  1253,  1254,   300,  1255,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,  1081,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,  1256,   328,   329,   330,   331,  1257,  1258,   333,
       0,   334,   335,  1259,   337,     0,   338,     0,   339,   340,
       0,   341,   342,   343,   344,   345,     0,   346,  1260,     0,
    1261,   349,   350,     0,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
    1262,  1263,     0,  1264,     0,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,     0,     0,   388,  1265,   390,
     391,   392,     0,   393,   394,   395,  1266,  1267,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,  1268,   413,  1269,   415,   416,   417,
     418,   419,   420,   421,   422,  1270,   424,  1271,   425,   426,
     427,   428,  1272,  1273,   430,  1274,   432,   433,   434,     0,
     435,   436,     0,     0,  1275,   438,   439,     0,     0,   440,
     441,   442,   443,   444,   445,  1276,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,  1277,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,  1278,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,  1279,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,  1280,
     514,   515,   516,   517,   518,   519,   520,   521,  1281,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,  1282,   538,     0,   539,   540,     0,
     541,   542,   543,   544,   545,   546,   547,     0,   548,  1283,
    1284,     0,     0,   551,   552,  1285,   554,  1286,  1287,   556,
     557,   558,   559,   560,   561,   562,   563,     0,  1288,   564,
     565,   566,   567,   568,  1289,     0,   569,   570,   571,   572,
     573,   574,  1290,     0,   576,   577,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,  1291,  1292,  1293,  1294,   594,  1295,  1296,  1297,
    1298,   599,   600,   601,   602,  1299,   610,     0,     0,     0,
       0,     0,  1300,  1301,     0,     0,     0,     0,     0,     0,
       0,  1303,  4149,   230,   231,   232,   233,   234,   235,   236,
     237,     0,   238,   239,   240,     0,     0,     0,     0,     0,
    4167,     0,   241,   242,     0,   243,   244,   245,     0,   247,
     248,   249,   250,   251,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,     0,     0,     0,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
     281,   282,   283,   284,   285,   286,     0, -1793,   288,   289,
     290,     0,     0,     0,     0,     0,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   309,   310,
     311,     0,     0,   312,   313,   314,   315,   316,     0,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,     0,   333,     0,
     334,   335,   336,   337,     0,   338,     0,   339,     0,     0,
   -1793,   342,   343,   344,   345,     0,   346,   347,     0,   348,
     349,   350,     0,   351,   352,   353,   354,   355,     0,   357,
     358,   359,   360,     0,   361,   362,   363,   364,   365,   366,
     367,     0,   368, -1793,   370,   371,   372,   373,   374,   375,
     376,     0,   377,     0,   378,     0,     0,   381, -1793,   383,
     384,   385,   386,   387,     0,     0,   388,   389, -1793,   391,
       0,     0,   393,   394,   395,     0,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412, -1793,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,     0,
     428,     0,   429,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,     0,     0,   440,   441,
     442,     0,   444,     0,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   458,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492, -1793,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,     0,   509,   510,   511,   512,   513,     0,   514,
     515,   516,   517,   518,     0,   520,   521,   522,   523,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,     0,   539,   540,     0,   541,
       0,   543,   544,   545,   546,   547,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,   561,   562,   563,     0,     0,   564,   565,
     566,   567,   568,     0,     0,   569,   570,   571,   572,   573,
     574,   575,     0,   576,     0,   578,   579,   580,   581,     0,
       0,   582,     0,     0,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,     0,  1073,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1379,   230,   231,   232,   233,   234,   235,   236,   237,
       0,   238,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,     0,   243,   244,   245,   246,   247,   248,
     249,     0,  1074,   252,  1075,  1076,     0,   255,   256,   257,
     258,   259,   260,     0,     0,   261,   262,  1077,  1078,   265,
       0,   266,   267,   268,   269,     0,     0,   271,     0,   272,
     273,   274,   275,   276,   277,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0,   287,   288,   289,   290,
       0,     0,     0,   291,     0,     0,     0,   292,   293,   294,
     295,   296,   297,  1079,  1080,   300,     0,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,  1081,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
       0,   328,   329,   330,   331,     0,     0,   333,     0,   334,
     335,  1082,   337,     0,   338,     0,   339,   340,     0,   341,
     342,   343,   344,   345,     0,   346,     0,     0,     0,   349,
     350,     0,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,  2183,   361,   362,   363,   364,   365,   366,   367,
       0,   368,   369,  2184,   371,   372,   373,   374,  1084,  1085,
       0,  1086,     0,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,     0,     0,   388,     0,   390,   391,   392,
       0,   393,   394,   395,     0,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,  1087,   413,  1088,   415,   416,   417,   418,   419,
     420,   421,     0,     0,   424,     0,   425,   426,   427,   428,
       0,     0,   430,  1089,   432,   433,   434,     0,   435,   436,
       0,     0,   437,   438,   439,     0,     0,   440,   441,  2186,
     443,   444,   445,     0,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,     0,   459,     0,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,  1090,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,   494,   495,   496,   497,
     498,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,   513,     0,   514,   515,
    2187,   517,   518,   519,   520,   521,  1092,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,     0,   538,     0,   539,   540,     0,   541,   542,
     543,   544,   545,   546,   547,     0,   548,  1093,  1094,     0,
       0,   551,   552,     0,   554,     0,     0,   556,   557,   558,
     559,   560,   561,   562,   563,     0,     0,   564,   565,   566,
     567,   568,     0,     0,   569,   570,   571,   572,   573,     0,
    1095,  2188,   576,   577,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,  1073,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     600,   601,   602,     0,     0,     0,   230,   231,   232,   233,
     234,   235,   236,   237,     0,   238,   239,   240,     0,     0,
    2296,     0,     0,     0,     0,   241,   242,     0,   243,   244,
     245,   246,   247,   248,   249,     0,  1074,   252,  1075,  1076,
       0,   255,   256,   257,   258,   259,   260,     0,     0,   261,
     262,  1077,  1078,   265,     0,   266,   267,   268,   269,     0,
       0,   271,     0,   272,   273,   274,   275,   276,   277,   278,
     279,   280,     0,   281,   282,   283,   284,   285,   286,     0,
     287,   288,   289,   290,     0,     0,     0,   291,     0,     0,
       0,   292,   293,   294,   295,   296,   297,  1079,  1080,   300,
       0,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,   313,  1081,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,     0,   328,   329,   330,   331,     0,
       0,   333,     0,   334,   335,  1082,   337,     0,   338,     0,
     339,   340,     0,   341,   342,   343,   344,   345,     0,   346,
       0,     0,     0,   349,   350,     0,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,  2183,   361,   362,   363,
     364,   365,   366,   367,     0,   368,   369,  2184,   371,   372,
     373,   374,  1084,  1085,     0,  1086,     0,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,     0,     0,   388,
       0,   390,   391,   392,     0,   393,   394,   395,     0,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,  1087,   413,  1088,   415,
     416,   417,   418,   419,   420,   421,     0,     0,   424,     0,
     425,   426,   427,   428,     0,     0,   430,  1089,   432,   433,
     434,     0,   435,   436,     0,     0,   437,   438,   439,     0,
       0,   440,   441,  2186,   443,   444,   445,     0,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   456,
     457,     0,   459,     0,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,  1090,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,   493,
     494,   495,   496,   497,   498,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,     0,   509,   510,   511,   512,
     513,     0,   514,   515,  2187,   517,   518,   519,   520,   521,
    1092,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,     0,   538,     0,   539,
     540,     0,   541,   542,   543,   544,   545,   546,   547,     0,
     548,  1093,  1094,     0,     0,   551,   552,     0,   554,     0,
       0,   556,   557,   558,   559,   560,   561,   562,   563,     0,
       0,   564,   565,   566,   567,   568,     0,     0,   569,   570,
     571,   572,   573,     0,  1095,  2188,   576,   577,   578,   579,
     580,   581,     0,     0,   582,     0,     0,   583,   584,   585,
     586,   587,   588,   229,     0,  1231,   670,     0,  1232,  1233,
    1234,   730,  1235,     0,   600,   601,   602,     0,     0,     0,
     230,   231,   232,   233,   234,   235,   236,   237,     0,   238,
     239,   240,     0,     0,  3380,     0,  1236,     0,     0,   241,
     242,     0,   243,   244,   245,   246,   247,   248,   249,   250,
    1237,   252,  1238,  1239,     0,   255,   256,   257,   258,   259,
     260,  1240,  1241,   261,   262,  1242,  1243,   265,     0,   266,
     267,   268,   269,  1244,     0,  1245,     0,   272,   273,   274,
     275,   276,   277,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,   287,   288,   289,   290,  1246,  1247,
    1248,  1249,  1250,  1251,  1252,   292,   293,   294,   295,   296,
     297,  1253,  1254,   300,  1255,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,  1081,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,  1256,   328,
     329,   330,   331,  1257,  1258,   333,     0,   334,   335,  1259,
     337,     0,   338,     0,   339,   340,     0,   341,   342,   343,
     344,   345,     0,   346,  1260,     0,  1261,   349,   350,     0,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,  1262,  1263,     0,  1264,
       0,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,     0,     0,   388,  1265,   390,   391,   392,     0,   393,
     394,   395,  1266,  1267,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
    1268,   413,  1269,   415,   416,   417,   418,   419,   420,   421,
     422,  1270,   424,  1271,   425,   426,   427,   428,  1272,  1273,
     430,  1274,   432,   433,   434,     0,   435,   436,     0,     0,
    1275,   438,   439,     0,     0,   440,   441,   442,   443,   444,
     445,  1276,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,  1277,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,  1278,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,   494,   495,   496,   497,   498,  1279,
     500,   501,   502,   503,   504,   505,   506,   507,   508,    41,
     509,   510,   511,   512,   513,  1280,   514,   515,   516,   517,
     518,   519,   520,   521,  1281,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
    1282,   538,     0,   539,   540,    45,   541,   542,   543,   544,
     545,   546,   547,     0,   548,  1283,  1284,     0,     0,   551,
     552,  1285,   554,  1286,  1287,   556,   557,   558,   559,   560,
     561,   562,   563,     0,  1288,   564,   565,   566,   567,   568,
    1289,     0,   569,   570,   571,   572,   573,  1160,  1290,     0,
     576,   577,   578,   579,   580,   581,     0,     0,   582,     0,
      50,   583,   584,   585,   586,   587,   588,   589,  1291,  1292,
    1293,  1294,   594,  1295,  1296,  1297,  1298,   599,   600,   601,
     602,  1299,     0,    51,     0,     0,     0,     0,  1300,  1301,
       0,     0,     0,   229,     0,  1231,   670,  1303,  1232,  1233,
    1234,   730,  1235,     0,     0,     0,     0,     0,     0,     0,
     230,   231,   232,   233,   234,   235,   236,   237,     0,   238,
     239,   240,     0,     0,     0,     0,  1236,     0,     0,   241,
     242,     0,   243,   244,   245,   246,   247,   248,   249,   250,
    1237,   252,  1238,  1239,  2800,   255,   256,   257,   258,   259,
     260,  1240,  1241,   261,   262,  1242,  1243,   265,     0,   266,
     267,   268,   269,  1244,     0,  1245,     0,   272,   273,   274,
     275,   276,   277,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,   287,   288,   289,   290,  1246,  1247,
    1248,  1249,  1250,  1251,  1252,   292,   293,   294,   295,   296,
     297,  1253,  1254,   300,  1255,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,  1081,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,  1256,   328,
     329,   330,   331,  1257,  1258,   333,     0,   334,   335,  1259,
     337,     0,   338,     0,   339,   340,  2801,   341,   342,   343,
     344,   345,     0,   346,  1260,     0,  1261,   349,   350,     0,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,  1262,  1263,     0,  1264,
       0,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,     0,  2802,   388,  1265,   390,   391,   392,     0,   393,
     394,   395,  1266,  1267,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
    1268,   413,  1269,   415,   416,   417,   418,   419,   420,   421,
     422,  1270,   424,  1271,   425,   426,   427,   428,  1272,  1273,
     430,  1274,   432,   433,   434,     0,   435,   436,     0,     0,
    1275,   438,   439,     0,     0,   440,   441,   442,   443,   444,
     445,  1276,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,  1277,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,  1278,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,   494,   495,   496,   497,   498,  1279,
     500,   501,   502,   503,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,   513,  1280,   514,   515,   516,   517,
     518,   519,   520,   521,  1281,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
    1282,   538,     0,   539,   540,     0,   541,   542,   543,   544,
     545,   546,   547,     0,   548,  1283,  1284,     0,  2803,   551,
     552,  1285,   554,  1286,  1287,   556,   557,   558,   559,   560,
     561,   562,   563,     0,  1288,   564,   565,   566,   567,   568,
    1289,     0,   569,   570,   571,   572,   573,   574,  1290,     0,
     576,   577,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   588,   589,  1291,  1292,
    1293,  1294,   594,  1295,  1296,  1297,  1298,   599,   600,   601,
     602,  1299,     0,     0,     0,     0,     0,     0,  1300,  1301,
       0,     0,     0,   229,     0,  1231,   670,  1303,  1232,  1233,
    1234,   730,  1235,     0,     0,     0,     0,     0,     0,     0,
     230,   231,   232,   233,   234,   235,   236,   237,     0,   238,
     239,   240,     0,     0,     0,     0,  1236,     0,     0,   241,
     242,     0,   243,   244,   245,   246,   247,   248,   249,   250,
    1237,   252,  1238,  1239,     0,   255,   256,   257,   258,   259,
     260,  1240,  1241,   261,   262,  1242,  1243,   265,     0,   266,
     267,   268,   269,  1244,     0,  1245,     0,   272,   273,   274,
     275,   276,   277,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,   287,   288,   289,   290,  1246,  1247,
    1248,  1249,  1250,  1251,  1252,   292,   293,   294,   295,   296,
     297,  1253,  1254,   300,  1255,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,  1081,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,  1256,   328,
     329,   330,   331,  1257,  1258,   333,     0,   334,   335,  1259,
     337,     0,   338,     0,   339,   340,     0,   341,   342,   343,
     344,   345,     0,   346,  1260,     0,  1261,   349,   350,     0,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,  1262,  1263,     0,  1264,
       0,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,     0,     0,   388,  1265,   390,   391,   392,     0,   393,
     394,   395,  1266,  1267,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
    1268,   413,  1269,   415,   416,   417,   418,   419,   420,   421,
     422,  1270,   424,  1271,   425,   426,   427,   428,  1272,  1273,
     430,  1274,   432,   433,   434,     0,   435,   436,     0,     0,
    1275,   438,   439,     0,     0,   440,   441,   442,   443,   444,
     445,  1276,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,  1277,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,  1278,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,   494,   495,   496,   497,   498,  1279,
     500,   501,   502,   503,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,   513,  1280,   514,   515,   516,   517,
     518,   519,   520,   521,  1281,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
    1282,   538,     0,   539,   540,     0,   541,   542,   543,   544,
     545,   546,   547,     0,   548,  1283,  1284,     0,     0,   551,
     552,  1285,   554,  1286,  1287,   556,   557,   558,   559,   560,
     561,   562,   563,     0,  1288,   564,   565,   566,   567,   568,
    1289,     0,   569,   570,   571,   572,   573,   574,  1290,     0,
     576,   577,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   588,   589,  1291,  1292,
    1293,  1294,   594,  1295,  1296,  1297,  1298,   599,   600,   601,
     602,  1299,     0,     0,     0,     0,     0,     0,  1300,  1301,
       0,     0,     0,     0,     0,  2001,  2754,  1303,   229,     0,
    1231,   670,     0,  1232,  1233,  1234,   730,  1235,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,  1236,     0,     0,   241,   242,     0,   243,   244,   245,
     246,   247,   248,   249,   250,  1237,   252,  1238,  1239,     0,
     255,   256,   257,   258,   259,   260,  1240,  1241,   261,   262,
    1242,  1243,   265,     0,   266,   267,   268,   269,  1244,     0,
    1245,     0,   272,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,   287,
     288,   289,   290,  1246,  1247,  1248,  1249,  1250,  1251,  1252,
     292,   293,   294,   295,   296,   297,  1253,  1254,   300,  1255,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,  1081,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,  1256,   328,   329,   330,   331,  1257,  1258,
     333,     0,   334,   335,  1259,   337,     0,   338,     0,   339,
     340,     0,   341,   342,   343,   344,   345,     0,   346,  1260,
       0,  1261,   349,   350,     0,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,  1262,  1263,     0,  1264,     0,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,     0,     0,   388,  1265,
     390,   391,   392,     0,   393,   394,   395,  1266,  1267,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,  1268,   413,  1269,   415,   416,
     417,   418,   419,   420,   421,   422,  1270,   424,  1271,   425,
     426,   427,   428,  1272,  1273,   430,  1274,   432,   433,   434,
       0,   435,   436,     0,     0,  1275,   438,   439,     0,     0,
     440,   441,   442,   443,   444,   445,  1276,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
    1277,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,  1278,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,  1279,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
    1280,   514,   515,   516,   517,   518,   519,   520,   521,  1281,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,  1282,   538,     0,   539,   540,
       0,   541,   542,   543,   544,   545,   546,   547,     0,   548,
    1283,  1284,     0,     0,   551,   552,  1285,   554,  1286,  1287,
     556,   557,   558,   559,   560,   561,   562,   563,     0,  1288,
     564,   565,   566,   567,   568,  1289,     0,   569,   570,   571,
     572,   573,   574,  1290,     0,   576,   577,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,  1291,  1292,  1293,  1294,   594,  1295,  1296,
    1297,  1298,   599,   600,   601,   602,  1299,     0,     0,     0,
       0,     0,     0,  1300,  1301,  1302,     0,     0,   229,     0,
    1231,   670,  1303,  1232,  1233,  1234,   730,  1235,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,  2151,   238,   239,   240,     0,     0,     0,
       0,  1236,     0,     0,   241,   242,     0,   243,   244,   245,
     246,   247,   248,   249,   250,  1237,   252,  1238,  1239,     0,
     255,   256,   257,   258,   259,   260,  1240,  1241,   261,   262,
    1242,  1243,   265,     0,   266,   267,   268,   269,  1244,     0,
    1245,     0,   272,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,   287,
     288,   289,   290,  1246,  1247,  1248,  1249,  1250,  1251,  1252,
     292,   293,   294,   295,   296,   297,  1253,  1254,   300,  1255,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,  1081,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,  1256,   328,   329,   330,   331,  1257,  1258,
     333,     0,   334,   335,  1259,   337,     0,   338,     0,   339,
     340,     0,   341,   342,   343,   344,   345,     0,   346,  1260,
       0,  1261,   349,   350,     0,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,  1262,  1263,     0,  1264,     0,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,     0,     0,   388,  1265,
     390,   391,   392,     0,   393,   394,   395,  1266,  1267,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,  1268,   413,  1269,   415,   416,
     417,   418,   419,   420,   421,   422,  1270,   424,  1271,   425,
     426,   427,   428,  1272,  1273,   430,  1274,   432,   433,   434,
       0,   435,   436,     0,     0,  1275,   438,   439,     0,     0,
     440,   441,   442,   443,   444,   445,  1276,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
    1277,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,  1278,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,  1279,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
    1280,   514,   515,   516,   517,   518,   519,   520,   521,  1281,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,  1282,   538,     0,   539,   540,
       0,   541,   542,   543,   544,   545,   546,   547,     0,   548,
    1283,  1284,     0,     0,   551,   552,  1285,   554,  1286,  1287,
     556,   557,   558,   559,   560,   561,   562,   563,     0,  1288,
     564,   565,   566,   567,   568,  1289,     0,   569,   570,   571,
     572,   573,   574,  1290,     0,   576,   577,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,  1291,  1292,  1293,  1294,   594,  1295,  1296,
    1297,  1298,   599,   600,   601,   602,  1299,     0,     0,     0,
       0,     0,     0,  1300,  1301,     0,     0,     0,   229,     0,
    1231,   670,  1303,  1232,  1233,  1234,   730,  1235,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,  1236,     0,     0,   241,   242,     0,   243,   244,   245,
     246,   247,   248,   249,   250,  1237,   252,  1238,  1239,     0,
     255,   256,   257,   258,   259,   260,  1240,  1241,   261,   262,
    1242,  1243,   265,     0,   266,   267,   268,   269,  1244,     0,
    1245,     0,   272,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,   287,
     288,   289,   290,  1246,  1247,  1248,  1249,  1250,  1251,  1252,
     292,   293,   294,   295,   296,   297,  1253,  1254,   300,  1255,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,  1081,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,  1256,   328,   329,   330,   331,  1257,  1258,
     333,     0,   334,   335,  1259,   337,     0,   338,     0,   339,
     340,     0,   341,   342,   343,   344,   345,     0,   346,  1260,
       0,  1261,   349,   350,     0,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,  1262,  1263,     0,  1264,     0,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,     0,     0,   388,  1265,
     390,   391,   392,     0,   393,   394,   395,  1266,  1267,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,  1268,   413,  1269,   415,   416,
     417,   418,   419,   420,   421,   422,  1270,   424,  1271,   425,
     426,   427,   428,  1272,  1273,   430,  1274,   432,   433,   434,
       0,   435,   436,     0,     0,  1275,   438,   439,     0,     0,
     440,   441,   442,   443,   444,   445,  1276,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
    1277,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,  1278,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,  1279,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
    1280,   514,   515,   516,   517,   518,   519,   520,   521,  1281,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,  1282,   538,     0,   539,   540,
       0,   541,   542,   543,   544,   545,   546,   547,     0,   548,
    1283,  1284,     0,     0,   551,   552,  1285,   554,  1286,  1287,
     556,   557,   558,   559,   560,   561,   562,   563,     0,  1288,
     564,   565,   566,   567,   568,  1289,     0,   569,   570,   571,
     572,   573,   574,  1290,  3259,   576,   577,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,  1291,  1292,  1293,  1294,   594,  1295,  1296,
    1297,  1298,   599,   600,   601,   602,  1299,     0,     0,     0,
       0,     0,     0,  1300,  1301,     0,     0,     0,   229,     0,
    1231,   670,  1303,  1232,  1233,  1234,   730,  1235,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,  1236,     0,     0,   241,   242,     0,   243,   244,   245,
     246,   247,   248,   249,   250,  1237,   252,  1238,  1239,     0,
     255,   256,   257,   258,   259,   260,  1240,  1241,   261,   262,
    1242,  1243,   265,     0,   266,   267,   268,   269,  1244,     0,
    1245,     0,   272,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,   287,
     288,   289,   290,  1246,  1247,  1248,  1249,  1250,  1251,  1252,
     292,   293,   294,   295,   296,   297,  1253,  1254,   300,  1255,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,  1081,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,  1256,   328,   329,   330,   331,  1257,  1258,
     333,     0,   334,   335,  1259,   337,     0,   338,     0,   339,
     340,  2801,   341,   342,   343,   344,   345,     0,   346,  1260,
       0,  1261,   349,   350,     0,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,  1262,  1263,     0,  1264,     0,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,     0,     0,   388,  1265,
     390,   391,   392,     0,   393,   394,   395,  1266,  1267,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,  1268,   413,  1269,   415,   416,
     417,   418,   419,   420,   421,   422,  1270,   424,  1271,   425,
     426,   427,   428,  1272,  1273,   430,  1274,   432,   433,   434,
       0,   435,   436,     0,     0,  1275,   438,   439,     0,     0,
     440,   441,   442,   443,   444,   445,  1276,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
    1277,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,  1278,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,  1279,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
    1280,   514,   515,   516,   517,   518,   519,   520,   521,  1281,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,  1282,   538,     0,   539,   540,
       0,   541,   542,   543,   544,   545,   546,   547,     0,   548,
    1283,  1284,     0,     0,   551,   552,  1285,   554,  1286,  1287,
     556,   557,   558,   559,   560,   561,   562,   563,     0,  1288,
     564,   565,   566,   567,   568,  1289,     0,   569,   570,   571,
     572,   573,   574,  1290,     0,   576,   577,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,  1291,  1292,  1293,  1294,   594,  1295,  1296,
    1297,  1298,   599,   600,   601,   602,  1299,     0,     0,     0,
       0,     0,     0,  1300,  1301,     0,     0,     0,   229,     0,
    1231,   670,  1303,  1232,  1233,  1234,   730,  1235,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,  1236,     0,     0,   241,   242,     0,   243,   244,   245,
     246,   247,   248,   249,   250,  1237,   252,  1238,  1239,     0,
     255,   256,   257,   258,   259,   260,  1240,  1241,   261,   262,
    1242,  1243,   265,     0,   266,   267,   268,   269,  1244,     0,
    1245,     0,   272,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,   287,
     288,   289,   290,  1246,  1247,  1248,  1249,  1250,  1251,  1252,
     292,   293,   294,   295,   296,   297,  1253,  1254,   300,  1255,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,  1081,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,  1256,   328,   329,   330,   331,  1257,  1258,
     333,     0,   334,   335,  1259,   337,     0,   338,     0,   339,
     340,     0,   341,   342,   343,   344,   345,     0,   346,  1260,
       0,  1261,   349,   350,     0,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,  1262,  1263,     0,  1264,     0,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,     0,     0,   388,  1265,
     390,   391,   392,     0,   393,   394,   395,  1266,  1267,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,  1268,   413,  1269,   415,   416,
     417,   418,   419,   420,   421,   422,  1270,   424,  1271,   425,
     426,   427,   428,  1272,  1273,   430,  1274,   432,   433,   434,
       0,   435,   436,     0,     0,  1275,   438,   439,     0,     0,
     440,   441,   442,   443,   444,   445,  1276,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
    1277,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,  1278,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,  1279,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
    1280,   514,   515,   516,   517,   518,   519,   520,   521,  1281,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,  1282,   538,     0,   539,   540,
       0,   541,   542,   543,   544,   545,   546,   547,     0,   548,
    1283,  1284,     0,     0,   551,   552,  1285,   554,  1286,  1287,
     556,   557,   558,   559,   560,   561,   562,   563,     0,  1288,
     564,   565,   566,   567,   568,  1289,     0,   569,   570,   571,
     572,   573,   574,  1290,     0,   576,   577,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,  1291,  1292,  1293,  1294,   594,  1295,  1296,
    1297,  1298,   599,   600,   601,   602,  1299,     0,     0,     0,
       0,     0,     0,  1300,  1301,     0,     0,     0,   229,     0,
    1231,   670,  1303,  1232,  1233,  1234,   730,  1235,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,  1236,     0,     0,   241,   242,     0,   243,   244,   245,
     246,   247,   248,   249,   250,  1237,   252,  1238,  1239,     0,
     255,   256,   257,   258,   259,   260,  1240,  1241,   261,   262,
    1242,  1243,   265,     0,   266,   267,   268,   269,  1244,     0,
    1245,     0,   272,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,   287,
     288,   289,   290,  1246,  1247,  1248,  1249,  1250,  1251,  1252,
     292,   293,   294,   295,   296,   297,  1253,  1254,   300,  1255,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,  1081,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,  1256,   328,   329,   330,   331,  1257,  1258,
     333,     0,   334,   335,  1259,   337,     0,   338,     0,   339,
     340,     0,   341,   342,   343,   344,   345,     0,   346,  1260,
       0,  1261,   349,   350,     0,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,  1262,  1263,     0,  1264,     0,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,     0,     0,   388,  1265,
     390,   391,   392,     0,   393,   394,   395,  1266,  1267,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,  1268,   413,  1269,   415,   416,
     417,   418,   419,   420,   421,   422,  1270,   424,  1271,   425,
     426,   427,   428,  1272,  1273,   430,  1274,   432,   433,   434,
       0,   435,   436,     0,     0,  1275,   438,   439,     0,     0,
     440,   441,   442,   443,   444,   445,  1276,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
    1277,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,  1278,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,  1279,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
    1280,   514,   515,   516,   517,   518,   519,   520,   521,  1281,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,  1282,   538,     0,   539,   540,
       0,   541,   542,   543,   544,   545,   546,   547,     0,   548,
    1283,  1284,     0,     0,   551,   552,  1285,   554,  1286,  1287,
     556,   557,   558,   559,   560,   561,   562,   563,     0,  1288,
     564,   565,   566,   567,   568,  1289,     0,   569,   570,   571,
     572,   573,   574,  1290,     0,   576,   577,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,  1291,  1292,  1293,  1294,   594,  1295,  1296,
    1297,  1298,   599,   600,   601,   602,  1299,     0,     0,     0,
       0,     0,     0,  2154,  2155,     0,     0,     0,   229,     0,
    2928,   670,  1303,  1232,  1233,  1234,   730,  1235,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,  1236,     0,     0,   241,   242,     0,   243,   244,   245,
     246,   247,   248,   249,   250,  1237,   252,  1238,  1239,     0,
     255,   256,   257,   258,   259,   260,  1240,  1241,   261,   262,
    1242,  1243,   265,     0,   266,   267,   268,   269,  1244,     0,
    1245,     0,   272,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,   287,
     288,   289,   290,  1246,  1247,  1248,  1249,  1250,  1251,  1252,
     292,   293,   294,   295,   296,   297,  1253,  1254,   300,  1255,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,  1081,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,  1256,   328,   329,   330,   331,  1257,  1258,
     333,     0,   334,   335,  1259,   337,     0,   338,     0,   339,
     340,     0,   341,   342,   343,   344,   345,     0,   346,  1260,
       0,  1261,   349,   350,     0,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,  1262,  1263,     0,  1264,     0,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,     0,     0,   388,  1265,
     390,   391,   392,     0,   393,   394,   395,  1266,  1267,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,  1268,   413,  1269,   415,   416,
     417,   418,   419,   420,   421,   422,  1270,   424,  1271,   425,
     426,   427,   428,  1272,  1273,   430,  1274,   432,   433,   434,
       0,   435,   436,     0,     0,  1275,   438,   439,     0,     0,
     440,   441,   442,   443,   444,   445,  1276,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
    1277,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,  1278,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,  1279,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
    1280,   514,   515,   516,   517,   518,   519,   520,   521,  1281,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,  1282,   538,     0,   539,   540,
       0,   541,   542,   543,   544,   545,   546,   547,     0,   548,
    1283,  1284,     0,     0,   551,   552,  1285,   554,  1286,  1287,
     556,   557,   558,   559,   560,   561,   562,   563,     0,  1288,
     564,   565,   566,   567,   568,  1289,     0,   569,   570,   571,
     572,   573,   574,  1290,     0,   576,   577,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,  1291,  1292,  1293,  1294,   594,  1295,  1296,
    1297,  1298,   599,   600,   601,   602,  1299,     0,     0,     0,
       0,     0,     0,  1300,  1301,     0,     0,     0,   229,     0,
    1231,   670,  1303,  1232,  1233,  1234,   730,  1235,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,  1236,     0,     0,   241,   242,     0,   243,   244,   245,
     246,   247,   248,   249,   250,  1237,   252,  1238,  1239,     0,
     255,   256,   257,   258,   259,   260,  1240,  1241,   261,   262,
    1242,  1243,   265,     0,   266,   267,   268,   269,  1244,     0,
    1245,     0,   272,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,   287,
     288,   289,  4203,  1246,  1247,  1248,  1249,  1250,  1251,  1252,
     292,   293,   294,   295,   296,   297,  1253,  1254,   300,  1255,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,  1081,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,  1256,   328,   329,   330,   331,  1257,  1258,
     333,     0,   334,   335,  1259,   337,     0,   338,     0,   339,
     340,     0,   341,   342,   343,   344,   345,     0,   346,  1260,
       0,  1261,   349,   350,     0,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,  1262,  1263,     0,  1264,     0,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,     0,     0,   388,  1265,
     390,   391,   392,     0,   393,   394,   395,  1266,  1267,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,  1268,   413,  1269,   415,   416,
     417,   418,   419,   420,   421,   422,  1270,   424,  1271,   425,
     426,   427,   428,  1272,  1273,   430,  1274,   432,   433,   434,
       0,   435,   436,     0,     0,  1275,   438,   439,     0,     0,
     440,   441,   442,   443,   444,   445,  1276,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
    1277,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,  1278,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,  1279,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
    1280,   514,   515,   516,   517,   518,   519,   520,   521,  1281,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,  1282,   538,     0,   539,   540,
       0,   541,   542,   543,   544,   545,   546,   547,     0,   548,
    1283,  1284,     0,     0,   551,   552,  1285,   554,  1286,  1287,
     556,   557,   558,   559,   560,   561,   562,   563,     0,  1288,
     564,   565,   566,   567,   568,  1289,     0,   569,   570,   571,
     572,   573,   574,  1290,     0,   576,   577,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,  1291,  1292,  1293,  1294,   594,  1295,  1296,
    1297,  1298,   599,   600,   601,   602,  1299,     0,     0,     0,
       0,     0,     0,  1300,  1301,     0,     0,     0,   229,     0,
    1231,   670,  1303,  1232,  1233,  1234,   730,  1235,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,  1236,     0,     0,   241,   242,     0,   243,   244,   245,
     246,   247,   248,   249,   250,  1237,   252,  1238,  1239,     0,
     255,   256,   257,   258,   259,   260,  1240,  1241,   261,   262,
    1242,  1243,   265,     0,   266,   267,   268,   269,  1244,     0,
    1245,     0,   272,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,   287,
     288,   289,   290,  1246,  1247,  1248,  1249,  1250,  1251,  1252,
     292,   293,   294,   295,   296,   297,  1253,  1254,   300,  1255,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,  1081,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,  1256,   328,   329,   330,   331,  1257,  1258,
     333,     0,   334,   335,  1259,   337,     0,   338,     0,   339,
     340,     0,   341,   342,   343,   344,   345,     0,   346,  1260,
       0,  1261,   349,   350,     0,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,  1262,  1263,     0,  1264,     0,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,     0,     0,   388,  1265,
     390,   391,   392,     0,   393,   394,   395,  1266,  1267,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,  1268,   413,  1269,   415,   416,
     417,   418,   419,   420,   421,   422,  1270,   424,  1271,   425,
     426,   427,   428,  1272,  1273,   430,  1274,   432,   433,   434,
       0,   435,   436,     0,     0,  1275,   438,   439,     0,     0,
     440,   441,   442,   443,   444,   445,  1276,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
    1277,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,  1278,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,  1279,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
    1280,   514,   515,   516,   517,   518,   519,   520,   521,  1281,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,  1282,   538,     0,   539,   540,
       0,   541,   542,   543,   544,   545,   546,   547,     0,   548,
    1283,  1284,     0,     0,   551,   552,  1285,   554,  1286,  1287,
     556,   557,   558,   559,   560,   561,   562,   563,     0,  1288,
     564,   565,   566,   567,   568,  1289,     0,   569,   570,   571,
     572,   573,   574,  1290,     0,   576,   577,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,  4554,  1291,  1292,  1293,  1294,   594,  1295,  1296,
    1297,  1298,   599,   600,   601,   602,  1299,     0,     0,     0,
       0,     0,     0,  1300,  1301,     0,     0,     0,   229,     0,
    1231,   670,  1303,  1232,  1233,  1234,   730,  1235,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,  1236,     0,     0,   241,   242,     0,   243,   244,   245,
     246,   247,   248,   249,   250,  1237,   252,  1238,  1239,     0,
     255,   256,   257,   258,   259,   260,  1240,  1241,   261,   262,
    1242,  1243,   265,     0,   266,   267,   268,   269,  1244,     0,
    1245,     0,   272,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,   287,
     288,   289,   290,  1246,  1247,  1248,  1249,  1250,  1251,  1252,
     292,   293,   294,   295,   296,   297,  1253,  1254,   300,  1255,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,  1081,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,  1256,   328,   329,   330,   331,  1257,  1258,
     333,     0,   334,   335,  1259,   337,     0,   338,     0,   339,
     340,     0,   341,   342,   343,   344,   345,     0,   346,  1260,
       0,  1261,   349,   350,     0,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,  1262,  1263,     0,  1264,     0,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,     0,     0,   388,  1265,
     390,   391,   392,     0,   393,   394,   395,  1266,  1267,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,  1268,   413,  1269,   415,   416,
     417,   418,   419,   420,  4566,   422,  1270,   424,  1271,   425,
     426,   427,   428,  1272,  1273,   430,  1274,   432,   433,   434,
       0,   435,   436,     0,     0,  1275,   438,   439,     0,     0,
     440,   441,   442,   443,   444,   445,  1276,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
    1277,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,  1278,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,  1279,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
    1280,   514,   515,   516,   517,   518,   519,   520,   521,  1281,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,  1282,   538,     0,   539,   540,
       0,   541,   542,   543,   544,   545,   546,   547,     0,   548,
    1283,  1284,     0,     0,   551,   552,  1285,   554,  1286,  1287,
     556,   557,   558,   559,   560,   561,   562,   563,     0,  1288,
     564,   565,   566,   567,   568,  1289,     0,   569,   570,   571,
     572,   573,   574,  1290,     0,   576,   577,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,  1291,  1292,  1293,  1294,   594,  1295,  1296,
    1297,  1298,   599,   600,   601,   602,  1299,     0,     0,     0,
       0,     0,     0,  1300,  1301,     0,     0,     0,   229,     0,
    1231,   670,  1303,  1232,  1233,  1234,   730,  1235,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,  1236,     0,     0,   241,   242,     0,   243,   244,   245,
     246,   247,   248,   249,   250,  1237,   252,  1238,  1239,     0,
     255,   256,   257,   258,   259,   260,  1240,  1241,   261,   262,
    1242,  1243,   265,     0,   266,   267,   268,   269,  1244,     0,
    1245,     0,   272,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,   287,
     288,  4880,   290,  1246,  1247,  1248,  1249,  1250,  1251,  1252,
     292,   293,   294,   295,   296,   297,  1253,  1254,   300,  1255,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,  1081,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,  1256,   328,   329,   330,   331,  1257,  1258,
     333,     0,   334,   335,  1259,   337,     0,   338,     0,   339,
     340,     0,   341,   342,   343,   344,   345,     0,   346,  1260,
       0,  4881,   349,   350,     0,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,  1262,  1263,     0,  1264,     0,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,     0,     0,   388,  1265,
     390,   391,   392,     0,   393,   394,   395,  1266,  1267,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,  1268,   413,  1269,   415,   416,
     417,   418,   419,   420,   421,   422,  1270,   424,  1271,   425,
     426,   427,   428,  1272,  1273,   430,  1274,   432,   433,   434,
       0,   435,   436,     0,     0,  1275,   438,   439,     0,     0,
     440,   441,   442,   443,   444,   445,  1276,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
    1277,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,  1278,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,  4882,   497,   498,  1279,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
    1280,   514,   515,   516,   517,   518,   519,   520,   521,  1281,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,  1282,   538,     0,   539,   540,
       0,   541,   542,   543,   544,   545,   546,   547,     0,   548,
    1283,  1284,     0,     0,   551,   552,  1285,   554,  1286,  1287,
     556,   557,   558,   559,   560,   561,   562,   563,     0,  1288,
     564,   565,   566,   567,   568,  1289,     0,   569,   570,   571,
     572,   573,   574,  1290,     0,   576,   577,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,  1291,  1292,  1293,  1294,   594,  1295,  1296,
    1297,  1298,   599,   600,   601,   602,  1299,     0,     0,     0,
       0,     0,     0,  1300,  1301,     0,     0,     0,   229,     0,
    1231,   670,  4883,  1232,  1233,  1234,   730,  1235,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,  1236,     0,     0,   241,   242,     0,   243,   244,   245,
     246,   247,   248,   249,  5353,  1237,   252,  1238,  1239,     0,
     255,   256,   257,   258,   259,   260,  1240,  1241,   261,   262,
    1242,  1243,   265,     0,   266,   267,   268,   269,  1244,     0,
    1245,     0,   272,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,   287,
     288,   289,  5354,  1246,  1247,  1248,  1249,  1250,  1251,  1252,
     292,   293,   294,   295,   296,   297,  1253,  1254,   300,  1255,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,  1081,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,  1256,   328,   329,   330,   331,  1257,  1258,
     333,     0,   334,   335,  1259,   337,     0,   338,     0,   339,
     340,     0,   341,   342,   343,   344,   345,     0,   346,  1260,
       0,  1261,   349,   350,     0,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,  1262,  1263,     0,  1264,     0,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,     0,     0,   388,  1265,
     390,   391,   392,     0,   393,   394,   395,  1266,  1267,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,  1268,   413,  1269,   415,   416,
     417,   418,   419,   420,   421,   422,  1270,   424,  1271,   425,
     426,   427,   428,  1272,  1273,   430,  1274,   432,   433,   434,
       0,   435,   436,     0,     0,  1275,   438,   439,     0,     0,
     440,   441,   442,   443,   444,   445,  1276,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
    1277,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,  1278,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,  1279,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
    1280,   514,   515,   516,   517,   518,   519,   520,   521,  1281,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,  1282,   538,     0,   539,   540,
       0,   541,   542,   543,   544,   545,   546,   547,     0,   548,
    1283,  1284,     0,     0,   551,   552,  1285,   554,  1286,  1287,
     556,   557,   558,   559,   560,  5355,   562,   563,     0,  1288,
     564,   565,   566,   567,   568,  1289,     0,   569,   570,   571,
     572,   573,   574,  1290,     0,   576,   577,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,  1291,  1292,  1293,  1294,   594,  1295,  1296,
    1297,  1298,   599,   600,   601,   602,  1299,     0,     0,     0,
       0,     0,     0,  1300,  1301,     0,     0,     0,   229,     0,
    1231,   670,  1303,  1232,  1233,  1234,   730,  1235,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,  1236,     0,     0,   241,   242,     0,   243,   244,   245,
     246,   247,   248,   249,   250,  1237,   252,  1238,  1239,     0,
     255,   256,   257,   258,   259,   260,  1240,  1241,   261,   262,
    1242,  1243,   265,     0,   266,   267,   268,   269,  1244,     0,
    1245,     0,   272,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,   287,
     288,   289,  5354,  1246,  1247,  1248,  1249,  1250,  1251,  1252,
     292,   293,   294,   295,   296,   297,  1253,  1254,   300,  1255,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,  1081,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,  1256,   328,   329,   330,   331,  1257,  1258,
     333,     0,   334,   335,  1259,   337,     0,   338,     0,   339,
     340,     0,   341,   342,   343,   344,   345,     0,   346,  1260,
       0,  1261,   349,   350,     0,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,  1262,  1263,     0,  1264,     0,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,     0,     0,   388,  1265,
     390,   391,   392,     0,   393,   394,   395,  1266,  1267,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,  1268,   413,  1269,   415,   416,
     417,   418,   419,   420,   421,   422,  1270,   424,  1271,   425,
     426,   427,   428,  1272,  1273,   430,  1274,   432,   433,   434,
       0,   435,   436,     0,     0,  1275,   438,   439,     0,     0,
     440,   441,   442,   443,   444,   445,  1276,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
    1277,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,  1278,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,  1279,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
    1280,   514,   515,   516,   517,   518,   519,   520,   521,  1281,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,  1282,   538,     0,   539,   540,
       0,   541,   542,   543,   544,   545,   546,   547,     0,   548,
    1283,  1284,     0,     0,   551,   552,  1285,   554,  1286,  1287,
     556,   557,   558,   559,   560,  5355,   562,   563,     0,  1288,
     564,   565,   566,   567,   568,  1289,     0,   569,   570,   571,
     572,   573,   574,  1290,     0,   576,   577,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,  1291,  1292,  1293,  1294,   594,  1295,  1296,
    1297,  1298,   599,   600,   601,   602,  1299,     0,     0,     0,
       0,     0,     0,  1300,  1301,     0,     0,     0,   229,     0,
    1231,   670,  1303,  1232,  1233,  1234,   730,  1235,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,  1236,     0,     0,   241,   242,     0,   243,   244,   245,
     246,   247,   248,   249,   250,  1237,   252,  1238,  1239,     0,
     255,   256,   257,   258,   259,   260,  1240,  1241,   261,   262,
    1242,  1243,   265,     0,   266,   267,   268,   269,  1244,     0,
    1245,     0,   272,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,   287,
     288,   289,   290,  1246,  1247,  1248,  1249,  1250,  1251,  1252,
     292,   293,   294,   295,   296,   297,  1253,  1254,   300,  5078,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,  1081,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,  1256,   328,   329,   330,   331,  1257,  1258,
     333,     0,   334,   335,  1259,   337,     0,   338,     0,   339,
     340,     0,   341,   342,   343,   344,   345,     0,   346,  1260,
       0,  1261,   349,   350,     0,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,  1262,  1263,     0,  1264,     0,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,     0,     0,   388,  1265,
     390,   391,   392,     0,   393,   394,   395,  1266,  1267,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,  1268,   413,  1269,   415,   416,
     417,   418,   419,   420,   421,   422,  1270,   424,     0,   425,
     426,   427,   428,  1272,  1273,   430,  1274,   432,   433,   434,
       0,   435,   436,     0,     0,  1275,   438,   439,     0,     0,
     440,   441,   442,   443,   444,   445,  1276,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
    1277,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,  1278,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,  2786,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
    1280,   514,   515,   516,   517,   518,   519,   520,   521,  1281,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,  1282,   538,     0,   539,   540,
       0,   541,   542,   543,   544,   545,   546,   547,     0,   548,
    1283,  1284,     0,     0,   551,   552,  1285,   554,  1286,  1287,
     556,   557,   558,   559,   560,   561,   562,   563,     0,     0,
     564,   565,   566,   567,   568,  1289,     0,   569,   570,   571,
     572,   573,   574,  1290,     0,   576,   577,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,  1291,  1292,  1293,  1294,   594,  1295,  1296,
    1297,  1298,   599,   600,   601,   602,     0,     0,     0,     0,
       0,     0,     0,  2787,  2788,     0,     0,     0,   229,     0,
    1231,   670,  2789,  1232,  1233,  1234,   730,  1235,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,  1236,     0,     0,   241,   242,     0,   243,   244,   245,
     246,   247,   248,   249, -2671,  1237,   252,  1238,  1239,     0,
     255,   256,   257,   258,   259,   260,  1240,  1241,   261,   262,
    1242,  1243,   265,     0,   266,   267,   268,   269,  1244,     0,
    1245,     0,   272,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,   287,
     288,   289,  5354,  1246,  1247,  1248,  1249,  1250,  1251,  1252,
     292,   293,   294,   295,   296,   297,  1253,  1254,   300,  1255,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,  1081,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,  1256,   328,   329,   330,   331,  1257,  1258,
     333,     0,   334,   335,  1259,   337,     0,   338,     0,   339,
     340,     0,   341,   342,   343,   344,   345,     0,   346,  1260,
       0,  1261,   349,   350,     0,   351,   352,   353,   354,   355,
   -2671,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,  1262,  1263,     0,  1264,     0,   378,     0,     0,   381,
     382,   383,   384,   385,   386,   387,     0,     0,   388,  1265,
     390,   391, -2671,     0,   393,   394,   395,  1266,  1267,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,  1268,   413,  1269,   415,   416,
     417,   418,   419,   420,   421,   422,  1270,   424,  1271,   425,
     426,     0,   428,  1272,  1273,   430,  1274,   432,   433,   434,
       0,   435,   436,     0,     0,  1275,   438,   439,     0,     0,
     440,   441,   442,   443,   444,   445,  1276,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
    1277,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,  1278,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,  1279,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
    1280,   514,   515,   516,   517,   518, -2671,   520,   521,  1281,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,  1282,   538,     0,   539,   540,
       0,   541,   542,   543,   544,   545,   546,   547,     0,   548,
    1283,  1284,     0,     0,   551,   552,  1285,   554,  1286,  1287,
     556,   557,   558,   559,   560,  5355,   562,   563,     0,  1288,
     564,   565,   566,   567,   568,  1289,     0,   569,   570,   571,
     572,   573,   574,  1290,     0,   576,   577,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,  1291,  1292,  1293,  1294,   594,  1295,  1296,
    1297,  1298,   599,   600,   601,   602, -2671,     0,     0,     0,
       0,     0,     0,  1300,  1301,     0,     0,     0,   229,     0,
    1231,   670,  1303,  1232,  1233,  1234,   730,  1235,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,  1236,     0,     0,   241,   242,     0,   243,   244,   245,
     246,   247,   248,   249,   250,  1237,   252,  1238,  1239,     0,
     255,   256,   257,   258,   259,   260,  1240,  1241,   261,   262,
    1242,  1243,   265,     0,   266,   267,   268,   269,  1244,     0,
    1245,     0,   272,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,   287,
     288,   289,   290,  1246,  1247,  1248,  1249,  1250,  1251,  1252,
     292,   293,   294,   295,   296,   297,  1253,  1254,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,  1081,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,  1256,   328,   329,   330,   331,  1257,  1258,
     333,     0,   334,   335,  1259,   337,     0,   338,     0,   339,
     340,     0,   341,   342,   343,   344,   345,     0,   346,  1260,
       0,  1261,   349,   350,     0,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,  1262,  1263,     0,  1264,     0,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,     0,     0,   388,  1265,
     390,   391,   392,     0,   393,   394,   395,  1266,  1267,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,  1268,   413,  1269,   415,   416,
     417,   418,   419,   420,   421,   422,  1270,   424,     0,   425,
     426,   427,   428,  1272,  1273,   430,  1274,   432,   433,   434,
       0,   435,   436,     0,     0,  1275,   438,   439,     0,     0,
     440,   441,   442,   443,   444,   445,  1276,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
    1277,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,  1278,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,  2786,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
    1280,   514,   515,   516,   517,   518,   519,   520,   521,  1281,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,  1282,   538,     0,   539,   540,
       0,   541,   542,   543,   544,   545,   546,   547,     0,   548,
    1283,  1284,     0,     0,   551,   552,  1285,   554,  1286,  1287,
     556,   557,   558,   559,   560,   561,   562,   563,     0,     0,
     564,   565,   566,   567,   568,  1289,     0,   569,   570,   571,
     572,   573,   574,  1290,     0,   576,   577,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,  1291,  1292,  1293,  1294,   594,  1295,  1296,
    1297,  1298,   599,   600,   601,   602,     0,     0,     0,     0,
       0,     0,     0,  2787,  2788,   229,     0,  1231,   670,     0,
    1232,  1233,  2789,   730,  1235,     0,     0,     0,     0,     0,
       0,     0,   230,   231,   232,   233,   234,   235,   236,   237,
       0,   238,   239,   240,     0,     0,     0,     0,  1236,     0,
       0,   241,   242,     0,   243,   244,   245,   246,   247,   248,
     249,   250,  1237,   252,  1238,  1239,     0,   255,   256,   257,
     258,   259,   260,  1240,  1241,   261,   262,  1242,  1243,   265,
       0,   266,   267,   268,   269,  1244,     0,  1245,     0,   272,
     273,   274,   275,   276,   277,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0,   287,   288,   289,   290,
    1246,  1247,  1248,  1249,  1250,  1251,  1252,   292,   293,   294,
     295,   296,   297,  1253,  1254,   300,     0,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,  1081,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
    1256,   328,   329,   330,   331,  1257,  1258,   333,     0,   334,
     335,  1259,   337,     0,   338,     0,   339,   340,     0,   341,
     342,   343,   344,   345,     0,   346,  1260,     0,  1261,   349,
     350,     0,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,     0,   361,   362,   363,   364,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,  1262,  1263,
       0,  1264,     0,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,     0,     0,   388,  1265,   390,   391,   392,
       0,   393,   394,   395,  1266,  1267,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,  1268,   413,  1269,   415,   416,   417,   418,   419,
     420,   421,   422,  1270,   424,     0,   425,   426,   427,   428,
    1272,  1273,   430,  1274,   432,   433,   434,     0,   435,   436,
       0,     0,   437,   438,   439,     0,     0,   440,   441,   442,
     443,   444,   445,  1276,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,  1277,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,  1278,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,   494,   495,   496,   497,
     498,  2917,  2918,   501,   502,   503,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,   513,  1280,   514,   515,
     516,   517,   518,   519,   520,   521,  1281,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,  1282,   538,     0,   539,   540,     0,   541,   542,
     543,   544,   545,   546,   547,     0,   548,  1283,  1284,     0,
       0,   551,   552,  1285,   554,  1286,  1287,   556,   557,   558,
     559,   560,   561,   562,   563,     0,     0,   564,   565,   566,
     567,   568,  1289,     0,   569,   570,   571,   572,   573,   574,
    1290,     0,   576,   577,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,   589,
    1291,  1292,  1293,  1294,   594,  1295,  1296,  1297,  1298,   599,
     600,   601,   602,     0,     0,     0,     0,     0,     0,     0,
    2919,  2920,     0,     0,     0,   229,     0,  1231,   670,  2789,
    1232,  1233,  1234,   730,  1235,     0,     0,     0,     0,     0,
       0,     0,   230,   231,   232,   233,   234,   235,   236,   237,
       0,   238,   239,   240,     0,     0,     0,     0,  1236,     0,
       0,   241,   242,     0,   243,   244,   245,   246,   247,   248,
     249,   250,  1237,   252,  1238,  1239,     0,   255,   256,   257,
     258,   259,   260,  1240,  1241,   261,   262,  1242,  1243,   265,
       0,   266,   267,   268,   269,  1244,     0,  1245,     0,   272,
     273,   274,   275,   276,   277,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0,   287,   288,   289,   290,
    1246,  1247,  1248,  1249,  1250,  1251,  1252,   292,   293,   294,
     295,   296,   297,  1253,  1254,   300,     0,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,  1081,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
    1256,   328,   329,   330,   331,  1257,  1258,   333,     0,   334,
     335,  1259,   337,     0,   338,     0,   339,   340,     0,   341,
     342,   343,   344,   345,     0,   346,  1260,     0,  1261,   349,
     350,     0,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,     0,   361,   362,   363,   364,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,  1262,  1263,
       0,  1264,     0,   378,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,     0,   388,  1265,   390,   391,   392,
       0,   393,   394,   395,  1266,  1267,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,  1268,   413,  1269,   415,   416,   417,   418,   419,
     420,   421,   422,  1270,   424,     0,   425,   426,   427,   428,
    1272,  1273,   430,  1274,   432,   433,   434,     0,   435,   436,
       0,     0,  1275,   438,   439,     0,     0,   440,   441,   442,
     443,   444,   445,  1276,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,  1277,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,  1278,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,   494,   495,   496,   497,
     498,  2786,   500,   501,   502,   503,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,   513,  1280,   514,   515,
     516,   517,   518,   519,   520,   521,  1281,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,  1282,   538,     0,   539,   540,     0,   541,   542,
     543,   544,   545,   546,   547,     0,   548,  1283,  1284,     0,
       0,   551,   552,  1285,   554,  1286,  1287,   556,   557,   558,
     559,   560,   561,   562,   563,     0,     0,   564,   565,   566,
     567,   568,  1289,     0,   569,   570,   571,   572,   573,   574,
    1290,     0,   576,   577,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,   589,
    1291,  1292,  1293,  1294,   594,  1295,  1296,  1297,  1298,   599,
     600,   601,   602,     0,     0,     0,     0,     0,     0,     0,
    2787,  2788,   229,     0,  1231,   670,     0,  1232,  1233,  2789,
     730,  1235,     0,     0,     0,     0,     0,     0,     0,   230,
     231,   232,   233,   234,   235,   236,   237,     0,   238,   239,
     240,     0,     0,     0,     0,  1236,     0,     0,   241,   242,
       0,   243,   244,   245,   246,   247,   248,   249,   250,  1237,
     252,  1238,  1239,     0,   255,   256,   257,   258,   259,   260,
    1240,  1241,   261,   262,  1242,  1243,   265,     0,   266,   267,
     268,   269,  1244,     0,  1245,     0,   272,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,   287,   288,   289,   290,  1246,  1247,  1248,
    1249,  1250,  1251,  1252,   292,   293,   294,   295,   296,   297,
    1253,  1254,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,  1081,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,  1256,   328,   329,
     330,   331,  1257,  1258,   333,     0,   334,   335,  1259,   337,
       0,   338,     0,   339,   340,     0,   341,   342,   343,   344,
     345,     0,   346,  1260,     0,  1261,   349,   350,     0,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,  1262,  1263,     0,  1264,     0,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
       0,     0,   388,  1265,   390,   391,   392,     0,   393,   394,
     395,  1266,  1267,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,  1268,
     413,  1269,   415,   416,   417,   418,   419,   420,   421,   422,
    1270,   424,     0,   425,   426,   427,   428,  1272,  1273,   430,
    1274,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,     0,     0,   440,   441,   442,   443,   444,   445,
    1276,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,  1277,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,  1278,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,   494,   495,   496,   497,   498,  2786,   500,
     501,   502,   503,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,   513,  1280,   514,   515,   516,   517,   518,
     519,   520,   521,  1281,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,  1282,
     538,     0,   539,   540,     0,   541,   542,   543,   544,   545,
     546,   547,     0,   548,  1283,  1284,     0,     0,   551,   552,
    1285,   554,  1286,  1287,   556,   557,   558,   559,   560,   561,
     562,   563,     0,     0,   564,   565,   566,   567,   568,  1289,
       0,   569,   570,   571,   572,   573,   574,  1290,     0,   576,
     577,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   588,   589,  1291,  1292,  1293,
    1294,   594,  1295,  1296,  1297,  1298,   599,   600,   601,   602,
     229,     0,  1231,   670,     0,  1232,  1233,     0,   730,  1235,
       0,     0,     0,     0,     0,     0,  2789,   230,   231,   232,
     233,   234,   235,   236,   237,     0,   238,   239,   240,     0,
       0,     0,     0,  1236,     0,     0,   241,   242,     0,   243,
     244,   245,   246,   247,   248,   249,   250,  1237,   252,  1238,
    1239,     0,  4109,   256,   257,   258,   259,   260,  1240,  1241,
     261,   262,  1242,  1243,   265,     0,   266,   267,   268,   269,
    1244,     0,  1245,     0,   272,   273,   274,   275,   276,   277,
     278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
       0,   287,   288,   289,   290,  1246,  1247,  1248,  1249,  1250,
    1251,  1252,   292,   293,   294,   295,   296,   297,  1253,  1254,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   309,   310,   311,     0,     0,   312,   313,  1081,
     315,   316,     0,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,  1256,   328,   329,   330,   331,
    1257,  1258,   333,     0,   334,   335,  1259,   337,     0,   338,
       0,   339,   340,     0,   341,   342,   343,   344,   345,     0,
     346,  1260,     0,  1261,   349,   350,     0,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,     0,   361,   362,
     363,   364,   365,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,  1262,  1263,     0,  1264,     0,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,     0,     0,
     388,  1265,   390,   391,   392,     0,   393,   394,   395,  1266,
    1267,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,  1268,   413,  1269,
     415,   416,   417,   418,   419,   420,   421,   422,  1270,   424,
       0,   425,   426,   427,   428,  1272,  1273,   430,  1274,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
       0,     0,   440,   441,   442,   443,   444,   445,  1276,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     456,   457,  1277,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,  1278,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
     493,   494,   495,   496,   497,   498,  2786,   500,   501,   502,
     503,   504,   505,   506,   507,   508,     0,   509,   510,   511,
     512,   513,  1280,   514,   515,   516,   517,   518,   519,   520,
     521,  1281,   523,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,  1282,   538,     0,
     539,   540,     0,   541,   542,   543,   544,   545,   546,   547,
       0,   548,  1283,  1284,     0,     0,   551,   552,  1285,   554,
    1286,  1287,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,   565,   566,   567,   568,  1289,     0,   569,
     570,   571,   572,   573,   574,  1290,     0,   576,   577,   578,
     579,   580,   581,     0,     0,   582,     0,     0,   583,   584,
     585,   586,   587,   588,   589,  1291,  1292,  1293,  1294,   594,
    1295,  1296,  1297,  1298,   599,   600,   601,   602,   229,     0,
    1231,   670,     0,  1232,  1233,     0,   730,  1235,     0,     0,
       0,     0,     0,     0,  2789,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,  1236,     0,     0,   241,   242,     0,   243,   244,   245,
     246,   247,   248,   249,   250,  1237,   252,  1238,  1239,     0,
     255,   256,   257,   258,   259,   260,  1240,  1241,   261,   262,
    1242,  1243,   265,     0,   266,   267,   268,   269,  1244,     0,
    1245,     0,   272,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,   287,
     288,   289,   290,  1246,  1247,  1248,  1249,  1250,  1251,  1252,
     292,   293,   294,   295,   296,   297,  1253,  1254,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,  1081,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,  1256,   328,   329,   330,   331,  1257,  1258,
     333,     0,   334,   335,  1259,   337,     0,   338,     0,   339,
     340,     0,   341,   342,   343,   344,   345,     0,   346,  1260,
       0,  1261,   349,   350,     0,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,  1262,  1263,     0,  1264,     0,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,     0,     0,   388,  1265,
     390,   391,   392,     0,   393,   394,   395,  1266,  1267,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,  1268,   413,  1269,   415,   416,
     417,   418,   419,   420,   421,   422,  1270,   424,     0,   425,
     426,   427,   428,  1272,  1273,   430,  1274,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,     0,     0,
     440,   441,   442,   443,   444,   445,  1276,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
    1277,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,  1278,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,  2786,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
    1280,   514,   515,   516,   517,   518,   519,   520,   521,  1281,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,  1282,   538,     0,   539,   540,
       0,   541,   542,   543,   544,   545,   546,   547,     0,   548,
    1283,  1284,     0,     0,   551,   552,  1285,   554,  1286,  1287,
     556,   557,   558,   559,   560,   561,   562,   563,     0,     0,
     564,   565,   566,   567,   568,  1289,     0,   569,   570,   571,
     572,   573,   574,  1290,     0,   576,   577,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,  1291,  1292,  1293,  1294,  4597,  1295,  1296,
    1297,  1298,   599,   600,   601,   602,   229,     0,  1231,   670,
       0,  1232,  1233,  1234,   730,  1235,     0,     0,     0,     0,
       0,     0,  2789,   230,   231,   232,   233,   234,   235,   236,
     237,     0,   238,   239,   240,     0,     0,     0,     0,  1236,
       0,     0,   241,   242,     0,   243,   244,   245,   246,   247,
     248,   249,     0,  1237,   252,  1238,  1239,     0,   255,   256,
     257,   258,   259,   260,  1240,  1241,   261,   262,  1242,  1243,
     265,     0,   266,   267,   268,   269,  1244,     0,  1245,     0,
     272,   273,   274,   275,   276,   277,   278,   279,   280,     0,
     281,   282,   283,   284,   285,   286,     0,   287,   288,   289,
     290,  1246,  1247,  1248,  1249,  1250,  1251,  1252,   292,   293,
     294,   295,   296,   297,  1253,  1254,   300,  1255,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   309,   310,
     311,     0,     0,   312,   313,  1081,   315,   316,     0,   317,
     318,   319,     0,   320,     0,   322,     0,   323,   324,   325,
     326,  1256,   328,   329,   330,   331,  1257,  1258,   333,     0,
     334,   335,  1259,   337,     0,   338,     0,   339,   340,     0,
     341,   342,   343,   344,   345,     0,   346,  1260,     0,  1261,
     349,   350,     0,   351,   352,   353,   354,   355,     0,   357,
     358,   359,   360,     0,   361,   362,   363,   364,   365,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,  1262,
    1263,     0,  1264,     0,   378,     0,     0,   381,   382,   383,
     384,   385,   386,   387,     0,     0,   388,  1265,   390,   391,
       0,     0,   393,   394,   395,  1266,  1267,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,  1268,   413,  1269,   415,   416,   417,   418,
     419,   420,   421,   422,  1270,   424,  1271,   425,   426,     0,
     428,  1272,  1273,   430,  1274,   432,   433,   434,     0,   435,
     436,     0,     0,  1275,   438,   439,     0,     0,   440,   441,
     442,   443,   444,   445,  1276,   447,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   456,   457,  1277,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,  1278,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,   493,   494,   495,   496,
     497,   498,  1279,   500,   501,   502,   503,   504,   505,   506,
     507,   508,     0,   509,   510,   511,   512,   513,  1280,   514,
     515,   516,   517,   518,     0,   520,   521,  1281,   523,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,  1282,   538,     0,   539,   540,     0,   541,
     542,   543,   544,   545,   546,   547,     0,   548,  1283,  1284,
       0,     0,   551,   552,  1285,   554,  1286,  1287,   556,   557,
     558,   559,   560,   561,   562,   563,     0,  1288,   564,   565,
     566,   567,   568,  1289,     0,   569,   570,   571,   572,   573,
     574,  1290,     0,   576,   577,   578,   579,   580,   581,     0,
       0,   582,     0,     0,   583,   584,   585,   586,   587,   588,
     589,  1291,  1292,  1293,  1294,   594,  1295,  1296,  1297,  1298,
     599,   600,   601,   602,   229,     0,     0,     0,     0,     0,
       0,  1300,  1301,     0,     0,     0,     0,     0,     0,     0,
    1303,   230,   231,   232,   233,   234,   235,   236,   237,     0,
     238,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,     0,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,  1241,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,  1244,     0,  1245,     0,   272,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,     0,   287,   288,   289,   290,  1246,
    1247,  1248,  1249,  1250,  1251,  1252,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,   314,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,  1257,     0,   333,     0,   334,   335,
     336,   337,     0,   338,     0,   339,   340,     0,   341,   342,
     343,   344,   345,     0,   346,  1260,     0,   348,   349,   350,
       0,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,     0,   361,   362,   363,   364,   365,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,     0,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,  3617,     0,   388,  1265,   390,   391,   392,     0,
     393,   394,   395,  1266,  1267,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,  1270,   424,     0,   425,   426,   427,   428,     0,
    1273,   430,   431,   432,   433,   434,     0,   435,   436,     0,
     822,   437,   438,   439,     0,     0,   440,   441,   442,   443,
     444,   445,  1276,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,  1277,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,   494,   495,   496,   497,   498,
     499,  3618,   501,   502,   503,   504,   505,   506,   507,   508,
      41,   509,   510,   511,   512,   513,  1280,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,  1282,   538,     0,   539,   540,    45,   541,   542,   543,
     544,   545,   546,   547,     0,   548,   549,   550,     0,     0,
     551,   552,  1285,   554,  1286,     0,   556,   557,   558,   559,
     560,   561,   562,   563,     0,     0,   564,   565,   566,   567,
     568,  1289,     0,   569,   570,   571,   572,   573,  1160,   575,
       0,   576,   577,   578,   579,   580,   581,     0,     0,   582,
       0,    50,   583,   584,   585,   586,   587,   588,   589,  1291,
    1292,  1293,  1294,   594,  1295,  1296,  1297,  1298,  3619,   600,
     601,   602,   229,     0,    51,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3620,   230,
     231,   232,   233,   234,   235,   236,   237,     0,   238,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
       0,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,  1241,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,  1244,     0,  1245,     0,   272,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,   287,   288,   289,   290,  1246,  1247,  1248,
    1249,  1250,  1251,  1252,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,   314,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,  1257,     0,   333,     0,   334,   335,   336,   337,
       0,   338,     0,   339,   340,     0,   341,   342,   343,   344,
     345,     0,   346,  1260,     0,   348,   349,   350,     0,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,     0,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
    3617,     0,   388,  1265,   390,   391,   392,     0,   393,   394,
     395,  1266,  1267,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
    1270,   424,     0,   425,   426,   427,   428,     0,  1273,   430,
     431,   432,   433,   434,     0,   435,   436,     0,   822,   437,
     438,   439,     0,     0,   440,   441,   442,   443,   444,   445,
    1276,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,  1277,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,   494,   495,   496,   497,   498,   499,  3618,
     501,   502,   503,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,   513,  1280,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,  1282,
     538,     0,   539,   540,     0,   541,   542,   543,   544,   545,
     546,   547,     0,   548,   549,   550,     0,     0,   551,   552,
    1285,   554,  1286,     0,   556,   557,   558,   559,   560,   561,
     562,   563,     0,     0,   564,   565,   566,   567,   568,  1289,
       0,   569,   570,   571,   572,   573,   574,   575,     0,   576,
     577,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   588,   589,  1291,  1292,  1293,
    1294,   594,  1295,  1296,  1297,  1298,  3619,   600,   601,   602,
     229,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3620,   230,   231,   232,
     233,   234,   235,   236,   237,     0,   238,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,     0,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,  1241,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
    1244,     0,  1245,     0,   272,   273,   274,   275,   276,   277,
     278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
       0,   287,   288,   289,   290,  1246,  1247,  1248,  1249,  1250,
    1251,  1252,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   309,   310,   311,     0,     0,   312,   313,   314,
     315,   316,     0,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
    1257,     0,   333,     0,   334,   335,   336,   337,     0,   338,
       0,   339,   340,     0,   341,   342,   343,   344,   345,     0,
     346,  1260,     0,   348,   349,   350,     0,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,     0,   361,   362,
     363,   364,   365,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,     0,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,     0,     0,
     388,  1265,   390,   391,   392,     0,   393,   394,   395,  1266,
    1267,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,  1270,   424,
       0,   425,   426,   427,   428,     0,  1273,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
       0,     0,   440,   441,   442,   443,   444,   445,  1276,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     456,   457,  1277,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
     493,   494,   495,   496,   497,   498,   499,  3618,   501,   502,
     503,   504,   505,   506,   507,   508,     0,   509,   510,   511,
     512,   513,  1280,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,  1282,   538,     0,
     539,   540,     0,   541,   542,   543,   544,   545,   546,   547,
       0,   548,   549,   550,     0,     0,   551,   552,  1285,   554,
    1286,     0,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,   565,   566,   567,   568,  1289,     0,   569,
     570,   571,   572,   573,   574,   575,     0,   576,   577,   578,
     579,   580,   581,     0,     0,   582,     0,     0,   583,   584,
     585,   586,   587,   588,   589,  1291,  1292,  1293,  1294,   594,
    1295,  1296,  1297,  1298,  3619,   600,   601,   602,   229,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    52,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,     0,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,  1241,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,  1244,     0,
    1245,     0,   272,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,   287,
     288,   289,   290,  1246,  1247,  1248,  1249,  1250,  1251,  1252,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,   314,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,  1257,     0,
     333,     0,   334,   335,   336,   337,     0,   338,     0,   339,
     340,     0,   341,   342,   343,   344,   345,     0,   346,  1260,
       0,   348,   349,   350,     0,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,     0,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,     0,     0,   388,  1265,
     390,   391,   392,     0,   393,   394,   395,  1266,  1267,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,  1270,   424,     0,   425,
     426,   427,   428,     0,  1273,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,     0,     0,
     440,   441,   442,   443,   444,   445,  1276,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
    1277,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
    1280,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,  1282,   538,     0,   539,   540,
       0,   541,   542,   543,   544,   545,   546,   547,     0,   548,
     549,   550,     0,     0,   551,   552,  1285,   554,  1286,     0,
     556,   557,   558,   559,   560,   561,   562,   563,     0,     0,
     564,   565,   566,   567,   568,  1289,     0,   569,   570,   571,
     572,   573,   574,   575,     0,   576,   577,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,  1291,  1292,  1293,  1294,   594,  1295,  1296,
    1297,  1298,   599,   600,   601,   602,   229,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4232,   230,   231,   232,   233,   234,   235,   236,
     237,     0,   238,   239,   240,     0,     0,     0,     0,     0,
       0,     0,   241,   242,     0,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,  1241,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,  1244,     0,  1245,     0,
     272,   273,   274,   275,   276,   277,   278,   279,   280,     0,
     281,   282,   283,   284,   285,   286,     0,   287,   288,   289,
     290,  1246,  1247,  1248,  1249,  1250,  1251,  1252,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   309,   310,
     311,     0,     0,   312,   313,   314,   315,   316,     0,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,  1257,     0,   333,     0,
     334,   335,   336,   337,     0,   338,     0,   339,   340,     0,
     341,   342,   343,   344,   345,     0,   346,  1260,     0,   348,
     349,   350,     0,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,     0,   361,   362,   363,   364,   365,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,     0,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,     0,     0,   388,  1265,   390,   391,
     392,     0,   393,   394,   395,  1266,  1267,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,  1270,   424,     0,   425,   426,   427,
     428,     0,  1273,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,     0,     0,   440,   441,
     442,   443,   444,   445,  1276,   447,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   456,   457,  1277,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,     0,   509,   510,   511,   512,   513,  1280,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,  1282,   538,     0,   539,   540,     0,   541,
     542,   543,   544,   545,   546,   547,     0,   548,   549,   550,
       0,     0,   551,   552,  1285,   554,  1286,     0,   556,   557,
     558,   559,   560,   561,   562,   563,     0,     0,   564,   565,
     566,   567,   568,  1289,     0,   569,   570,   571,   572,   573,
     574,   575,     0,   576,   577,   578,   579,   580,   581,     0,
       0,   582,     0,     0,   583,   584,   585,   586,   587,   588,
     589,  1291,  1292,  1293,  1294,   594,  1295,  1296,  1297,  1298,
     599,   600,   601,   602,   877,     0,  1515,   670,     0,     0,
       0,     0,   730,     0,     0,     0,     0,     0,     0,     0,
    5335,   230,   231,   232,   233,   234,   235,   236,   237,     0,
     238,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,     0,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,     0,   271,     0,   272,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,     0,   287,   288,   289,   290,     0,
       0,     0,   291,     0,     0,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,   314,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,  1930,   333,     0,   334,   335,
     336,   337,     0,   338,     0,   339,   340,     0,   341,   342,
     343,   344,   345,     0,   346,   347,     0,   348,   349,   350,
       0,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,     0,   361,   362,   363,   364,   365,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,     0,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,     0,     0,   388,   389,   390,   391,   392,     0,
     393,   394,   395,     0,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,     0,
     429,   430,   431,   432,   433,   434,     0,   435,   436,  1931,
       0,   437,   438,   439,     0,     0,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   458,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
       0,   509,   510,   511,   512,   513,     0,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,     0,   539,   540,     0,   541,   542,   543,
     544,   545,   546,   547,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,  1932,   556,   557,   558,   559,
     560,   561,   562,   563,     0,     0,   564,   565,   566,   567,
     568,     0,     0,   569,   570,   571,   572,   573,   574,   575,
       0,   576,   577,   578,   579,   580,   581,     0,     0,   582,
       0,     0,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   877,     0,     0,     0,     0,     0,     0,  1516,
    1517,  5149,     0,     0,     0,     0,     0,     0,  5150,   230,
     231,   232,   233,   234,   235,   236,   237,     0,   238,   239,
     240,     3,     4,     0,     0,     0,     0,     0,   241,   242,
       0,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,     0,   271,     0,   272,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,   287,   288,   289,   290,     0,     0,     0,
     291,     0,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,   314,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,     0,   333,     0,   334,   335,   336,   337,
       0,   338,     0,   339,   340,     0,   341,   342,   343,   344,
     345,     0,   346,   347,     0,   348,   349,   350,     0,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,     0,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
       0,     0,   388,   389,   390,   391,   392,     0,   393,   394,
     395,     0,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,     0,   429,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,     0,     0,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   458,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,    41,   509,
     510,   511,   512,   513,     0,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,     0,   539,   540,    45,   541,   542,   543,   544,   545,
     546,   547,     0,   548,   549,   550,     0,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,   561,
     562,   563,     0,     0,   564,   565,   566,   567,   568,     0,
       0,   569,   570,   571,   572,   573,  1160,   575,     0,   576,
     577,   578,   579,   580,   581,     0,     0,   582,     0,    50,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     229,     0,    51,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    52,   230,   231,   232,
     233,   234,   235,   236,   237,     0,   238,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,     0,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,     0,   271,     0,   272,   273,   274,   275,   276,   277,
     278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
       0,   287,   288,   289,   290,     0,     0,     0,   291,     0,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   309,   310,   311,     0,     0,   312,   313,   314,
     315,   316,     0,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,     0,   333,     0,   334,   335,   336,   337,     0,   338,
       0,   339,   340,     0,   341,   342,   343,   344,   345,     0,
     346,   347,     0,   348,   349,   350,     0,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,     0,   361,   362,
     363,   364,   365,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,     0,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,     0,     0,
     388,   389,   390,   391,   392,     0,   393,   394,   395,     0,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,     0,   429,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
       0,     0,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   458,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,     0,   509,   510,   511,
     512,   513,     0,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,     0,
     539,   540,     0,   541,   542,   543,   544,   545,   546,   547,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,   565,   566,   567,   568,     0,     0,   569,
     570,   571,   572,   573,   574,   575,     0,   576,   577,   578,
     579,   580,   581,     0,     0,   582,     0,     0,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   610,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4932,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,     0,   243,   244,   245,
       0,   247,   248,   249,   250,   251,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,     0,
       0,     0,   272,   273,   274,   275,   276,     0,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,     0,
     288,   289,   290,     0,     0,     0,     0,     0,     0,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,   314,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,     0,
     333,     0,   334,   335,   336,   337,     0,   338,     0,   339,
       0,     0,     0,   342,   343,   344,   345,     0,   346,   347,
       0,   348,   349,   350,     0,   351,   352,   353,   354,   355,
       0,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,     0,   370,   371,   372,   373,
     374,   375,   376,     0,   377,     0,   378,     0,     0,   381,
       0,   383,   384,   385,   386,   387,     0,     0,   388,   389,
       0,   391,     0,     0,   393,   394,   395,     0,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,     0,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,     0,   428,     0,   429,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,     0,     0,
     440,   441,   442,     0,   444,     0,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     458,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,    41,   509,   510,   511,   512,   513,
       0,   514,   515,   516,   517,   518,     0,   520,   521,   522,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,     0,   539,   540,
      45,   541,     0,   543,   544,   545,   546,   547,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,   561,   562,   563,     0,     0,
     564,   565,   566,   567,   568,     0,     0,   569,   570,   571,
     572,   573,  1160,   575,     0,   576,     0,   578,   579,   580,
     581,     0,     0,   582,     0,    50,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   610,     0,    51,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    52,   230,   231,   232,   233,   234,   235,   236,
     237,     0,   238,   239,   240,     0,     0,     0,     0,     0,
       0,     0,   241,   242,     0,   243,   244,   245,     0,   247,
     248,   249,   250,   251,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,     0,     0,     0,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
     281,   282,   283,   284,   285,   286,     0,     0,   288,   289,
     290,     0,     0,     0,     0,     0,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   309,   310,
     311,     0,     0,   312,   313,   314,   315,   316,     0,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,     0,   333,     0,
     334,   335,   336,   337,     0,   338,     0,   339,     0,     0,
       0,   342,   343,   344,   345,     0,   346,   347,     0,   348,
     349,   350,     0,   351,   352,   353,   354,   355,     0,   357,
     358,   359,   360,     0,   361,   362,   363,   364,   365,   366,
     367,     0,   368,     0,   370,   371,   372,   373,   374,   375,
     376,     0,   377,     0,   378,     0,     0,   381,     0,   383,
     384,   385,   386,   387,     0,     0,   388,   389,     0,   391,
       0,     0,   393,   394,   395,     0,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,     0,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,     0,
     428,     0,   429,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,     0,     0,   440,   441,
     442,     0,   444,     0,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   458,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,     0,   509,   510,   511,   512,   513,     0,   514,
     515,   516,   517,   518,     0,   520,   521,   522,   523,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,     0,   539,   540,     0,   541,
       0,   543,   544,   545,   546,   547,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,   561,   562,   563,     0,     0,   564,   565,
     566,   567,   568,     0,     0,   569,   570,   571,   572,   573,
     574,   575,     0,   576,     0,   578,   579,   580,   581,     0,
       0,   582,     0,     0,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   610,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1361,   230,   231,   232,   233,   234,   235,   236,   237,     0,
     238,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,     0,   243,   244,   245,     0,   247,   248,   249,
     250,   251,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,     0,     0,     0,   272,   273,
     274,   275,   276,     0,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,     0,     0,   288,   289,   290,     0,
       0,     0,     0,     0,     0,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,   314,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,     0,   333,     0,   334,   335,
     336,   337,     0,   338,     0,   339,     0,     0,     0,   342,
     343,   344,   345,     0,   346,   347,     0,   348,   349,   350,
       0,   351,   352,   353,   354,   355,     0,   357,   358,   359,
     360,     0,   361,   362,   363,   364,   365,   366,   367,     0,
     368,     0,   370,   371,   372,   373,   374,   375,   376,     0,
     377,     0,   378,     0,     0,   381,     0,   383,   384,   385,
     386,   387,     0,     0,   388,   389,     0,   391,     0,     0,
     393,   394,   395,     0,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,     0,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,     0,   428,     0,
     429,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,     0,     0,   440,   441,   442,     0,
     444,     0,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   458,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
       0,   509,   510,   511,   512,   513,     0,   514,   515,   516,
     517,   518,     0,   520,   521,   522,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,     0,   539,   540,     0,   541,     0,   543,
     544,   545,   546,   547,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,   561,   562,   563,     0,     0,   564,   565,   566,   567,
     568,     0,     0,   569,   570,   571,   572,   573,   574,   575,
       0,   576,     0,   578,   579,   580,   581,     0,     0,   582,
       0,     0,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   610,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2950,   230,
     231,   232,   233,   234,   235,   236,   237,     0,   238,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
       0,   243,   244,   245,     0,   247,   248,   249,   250,   251,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,     0,     0,     0,   272,   273,   274,   275,
     276,     0,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,     0,   288,   289,   290,     0,     0,     0,
       0,     0,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,   314,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,     0,   333,     0,   334,   335,   336,   337,
       0,   338,     0,   339,     0,     0,     0,   342,   343,   344,
     345,     0,   346,   347,     0,   348,   349,   350,     0,   351,
     352,   353,   354,   355,     0,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,     0,
     370,   371,   372,   373,   374,   375,   376,     0,   377,     0,
     378,     0,     0,   381,     0,   383,   384,   385,   386,   387,
       0,     0,   388,   389,     0,   391,     0,     0,   393,   394,
     395,     0,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
       0,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,     0,   428,     0,   429,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,     0,     0,   440,   441,   442,     0,   444,     0,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   458,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,   513,     0,   514,   515,   516,   517,   518,
       0,   520,   521,   522,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,     0,   539,   540,     0,   541,     0,   543,   544,   545,
     546,   547,     0,   548,   549,   550,     0,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,   561,
     562,   563,     0,     0,   564,   565,   566,   567,   568,     0,
       0,   569,   570,   571,   572,   573,   574,   575,     0,   576,
       0,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     610,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4146,   230,   231,   232,
     233,   234,   235,   236,   237,     0,   238,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,     0,   243,
     244,   245,     0,   247,   248,   249,   250,   251,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,     0,     0,     0,   272,   273,   274,   275,   276,     0,
     278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
       0,     0,   288,   289,   290,     0,     0,     0,     0,     0,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   309,   310,   311,     0,     0,   312,   313,   314,
     315,   316,     0,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,     0,   333,     0,   334,   335,   336,   337,     0,   338,
       0,   339,     0,     0,     0,   342,   343,   344,   345,     0,
     346,   347,     0,   348,   349,   350,     0,   351,   352,   353,
     354,   355,     0,   357,   358,   359,   360,     0,   361,   362,
     363,   364,   365,   366,   367,     0,   368,     0,   370,   371,
     372,   373,   374,   375,   376,     0,   377,     0,   378,     0,
       0,   381,     0,   383,   384,   385,   386,   387,     0,     0,
     388,   389,     0,   391,     0,     0,   393,   394,   395,     0,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,     0,   428,     0,   429,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
       0,     0,   440,   441,   442,     0,   444,     0,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   458,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,     0,   509,   510,   511,
     512,   513,     0,   514,   515,   516,   517,   518,     0,   520,
     521,   522,   523,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,     0,
     539,   540,     0,   541,     0,   543,   544,   545,   546,   547,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,   565,   566,   567,   568,     0,     0,   569,
     570,   571,   572,   573,   574,   575,     0,   576,     0,   578,
     579,   580,   581,     0,     0,   582,     0,     0,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,     0,     0,
       0,  1073,     0,  1515,   670,     0,     0,     0,   891,   730,
       0,     0,     0,     0,  4614,   892,   893,   894,   230,   231,
     232,   233,   234,   235,   236,   237,  1647,   238,   239,   240,
    1648,  1649,  1650,  1651,  1652,  1653,  1654,   241,   242,  1655,
     243,   244,   245,   246,   247,   248,   249,     0,  1074,   252,
    1075,  1076,  1656,   255,   256,   257,   258,   259,   260,  1657,
    1658,   261,   262,  1077,  1078,   265,  1659,   266,   267,   268,
     269,     0,  1660,   271,  1661,   272,   273,   274,   275,   276,
     277,   278,   279,   280,  1662,   281,   282,   283,   284,   285,
     286,  1663,   287,   288,   289,   290,  1664,  1665,  1666,   291,
    1667,  1668,  1669,   292,   293,   294,   295,   296,   297,  1079,
    1080,   300,  1670,   301,  1671,   302,   303,   304,   305,   306,
     307,  1672,   308,   309,   310,   311,  1673,  1674,   312,   313,
    1081,   315,   316,  1675,   317,   318,   319,  1676,   320,   321,
     322,  1677,   323,   324,   325,   326,     0,   328,   329,   330,
     331,     0,  1678,   333,  1679,   334,   335,  1082,   337,  1680,
     338,  1681,   339,   340,  1682,   341,   342,   343,   344,   345,
    1683,   346,     0,  1684,     0,   349,   350,  1685,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,  1686,   361,
     362,   363,   364,   365,   366,   367,  1687,   368,   369,     0,
     371,   372,   373,   374,  1084,  1085,  1688,  1086,  1689,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,  1690,
    1691,   388,     0,   390,   391,   392,  1692,   393,   394,   395,
    1693,  1694,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,  1087,   413,
    1088,   415,   416,   417,   418,   419,   420,   421,  3895,     0,
     424,  1695,   425,   426,   427,   428,  1696,     0,   430,  1089,
     432,   433,   434,  1697,   435,   436,  1698,  1699,  3896,   438,
     439,  1700,  1701,   440,   441,     0,   443,   444,   445,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
    1702,   456,   457,     0,   459,     0,   461,   462,   463,  1703,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
    1090,   475,   476,   477,   478,  1704,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,  1705,   491,
     492,   493,   494,   495,   496,   497,   498,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,  1706,   509,   510,
     511,   512,   513,  1707,   514,   515,  2187,   517,   518,   519,
     520,   521,  1092,   523,  1708,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,     0,   538,
    1709,   539,   540,  1710,   541,   542,   543,   544,   545,   546,
     547,  1711,   548,  1093,  1094,  1712,  1713,   551,   552,     0,
     554,     0,  1714,   556,   557,   558,   559,   560,   561,   562,
     563,  1715,  1716,   564,   565,   566,   567,   568,  1717,  1718,
     569,   570,   571,   572,   573,     0,  1095,  1719,   576,   577,
     578,   579,   580,   581,  1720,  1721,   582,  1722,  1723,   583,
     584,   585,   586,   587,   588,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   600,   601,   602,     0,
       0,     0,   897,   898,   899,     0,  3897,  3898,   902,   903,
     904,   905,  1073,     0,  1515,   670,     0,     0,     0,   891,
     730,     0,     0,     0,     0,     0,   892,   893,   894,   230,
     231,   232,   233,   234,   235,   236,   237,  1647,   238,   239,
     240,  1648,  1649,  1650,  1651,  1652,  1653,  1654,   241,   242,
    1655,   243,   244,   245,   246,   247,   248,   249,     0,  1074,
     252,  1075,  1076,  1656,   255,   256,   257,   258,   259,   260,
    1657,  1658,   261,   262,  1077,  1078,   265,  1659,   266,   267,
     268,   269,     0,  1660,   271,  1661,   272,   273,   274,   275,
     276,   277,   278,   279,   280,  1662,   281,   282,   283,   284,
     285,   286,  1663,   287,   288,   289,   290,  1664,  1665,  1666,
     291,  1667,  1668,  1669,   292,   293,   294,   295,   296,   297,
    1079,  1080,   300,  1670,   301,  1671,   302,   303,   304,   305,
     306,   307,  1672,   308,   309,   310,   311,  1673,  1674,   312,
     313,  1081,   315,   316,  1675,   317,   318,   319,  1676,   320,
     321,   322,  1677,   323,   324,   325,   326,     0,   328,   329,
     330,   331,     0,  1678,   333,  1679,   334,   335,  1082,   337,
    1680,   338,  1681,   339,   340,  1682,   341,   342,   343,   344,
     345,  1683,   346,     0,  1684,     0,   349,   350,  1685,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,  1686,
     361,   362,   363,   364,   365,   366,   367,  1687,   368,   369,
       0,   371,   372,   373,   374,  1084,  1085,  1688,  1086,  1689,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
    1690,  1691,   388,     0,   390,   391,   392,  1692,   393,   394,
     395,  1693,  1694,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,  1087,
     413,  1088,   415,   416,   417,   418,   419,   420,   421,  4327,
       0,   424,  1695,   425,   426,   427,   428,  1696,     0,   430,
    1089,   432,   433,   434,  1697,   435,   436,  1698,  1699,  3896,
     438,   439,  1700,  1701,   440,   441,     0,   443,   444,   445,
       0,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,  1702,   456,   457,     0,   459,     0,   461,   462,   463,
    1703,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,  1090,   475,   476,   477,   478,  1704,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,  1705,
     491,   492,   493,   494,   495,   496,   497,   498,     0,   500,
     501,   502,   503,   504,   505,   506,   507,   508,  1706,   509,
     510,   511,   512,   513,  1707,   514,   515,  2187,   517,   518,
     519,   520,   521,  1092,   523,  1708,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,     0,
     538,  1709,   539,   540,  1710,   541,   542,   543,   544,   545,
     546,   547,  1711,   548,  1093,  1094,  1712,  1713,   551,   552,
       0,   554,     0,  1714,   556,   557,   558,   559,   560,   561,
     562,   563,  1715,  1716,   564,   565,   566,   567,   568,  1717,
    1718,   569,   570,   571,   572,   573,     0,  1095,  1719,   576,
     577,   578,   579,   580,   581,  1720,  1721,   582,  1722,  1723,
     583,   584,   585,   586,   587,   588,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   600,   601,   602,
       0,     0,     0,   897,   898,   899,   610,  3897,  3898,   902,
     903,   904,   905,   891,     0,     0,     0,     0,     0,     0,
     892,   893,   894,   230,   231,   232,   233,   234,   235,   236,
     237,     0,   238,   239,   240,     0,     0,     0,     0,     0,
       0,     0,   241,   242,     0,   243,   244,   245,     0,   247,
     248,   249,   250,   251,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,   263,   264,
     265,     0,   266,   895,   268,   269,   270,     0,     0,     0,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
     281,   282,   283,   284,   285,   286,     0,     0,   288,   289,
     290,     0,     0,     0,     0,     0,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   309,   310,
     311,     0,     0,   312,   313,   314,   315,   316,     0,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,     0,   896,     0,
     334,   335,   336,   337,     0,   338,     0,   339,     0,     0,
       0,   342,   343,   344,   345,     0,   346,   347,     0,   348,
     349,   350,     0,   351,   352,   353,   354,   355,     0,   357,
     358,   359,   360,     0,   361,   362,   363,   364,   365,   366,
     367,     0,   368,     0,   370,   371,   372,   373,   374,   375,
     376,     0,   377,     0,   378,     0,     0,   381,     0,   383,
     384,   385,   386,   387,     0,     0,   388,   389,     0,   391,
       0,     0,   393,   394,   395,     0,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,     0,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,     0,
     428,     0,   429,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,     0,     0,   440,   441,
     442,     0,   444,     0,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   458,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,     0,   509,   510,   511,   512,   513,     0,   514,
     515,   516,   517,   518,     0,   520,   521,   522,   523,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,     0,   539,   540,     0,   541,
       0,   543,   544,   545,   546,   547,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,   561,   562,   563,     0,     0,   564,   565,
     566,   567,   568,     0,     0,   569,   570,   571,   572,   573,
     574,   575,     0,   576,     0,   578,   579,   580,   581,     0,
       0,   582,     0,     0,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,     0,     0,     0,   897,   898,   899,
     610,   900,   901,   902,   903,   904,   905,   891,     0,     0,
       0,     0,     0,     0,   892,   893,   894,   230,   231,   232,
     233,   234,   235,   236,   237,     0,   238,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,     0,   243,
     244,   245,     0,   247,   248,   249,   250,   251,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,   263,   264,   265,     0,   266,  1023,   268,   269,
     270,     0,     0,     0,   272,   273,   274,   275,   276,     0,
     278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
       0,     0,   288,   289,   290,     0,     0,     0,     0,     0,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   309,   310,   311,     0,     0,   312,   313,   314,
     315,   316,     0,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,     0,  1024,     0,   334,   335,   336,   337,     0,   338,
       0,   339,     0,     0,     0,   342,   343,   344,   345,     0,
     346,   347,     0,   348,   349,   350,     0,   351,   352,   353,
     354,   355,     0,   357,   358,   359,   360,     0,   361,   362,
     363,   364,   365,   366,   367,     0,   368,     0,   370,   371,
     372,   373,   374,   375,   376,     0,   377,     0,   378,     0,
       0,   381,     0,   383,   384,   385,   386,   387,     0,     0,
     388,   389,     0,   391,     0,     0,   393,   394,   395,     0,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,     0,   428,     0,   429,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
       0,     0,   440,   441,   442,     0,   444,     0,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   458,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,     0,   509,   510,   511,
     512,   513,     0,   514,   515,   516,   517,   518,     0,   520,
     521,   522,   523,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,     0,
     539,   540,     0,   541,     0,   543,   544,   545,   546,   547,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,   565,   566,   567,   568,     0,     0,   569,
     570,   571,   572,   573,   574,   575,     0,   576,     0,   578,
     579,   580,   581,     0,     0,   582,     0,     0,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,     0,     0,
       0,   897,   898,   899,   610,   900,   901,   902,   903,   904,
     905,   891,     0,     0,     0,     0,     0,     0,   892,   893,
     894,   230,   231,   232,   233,   234,   235,   236,   237,     0,
     238,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,     0,   243,   244,   245,     0,   247,   248,   249,
     250,   251,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,   263,   264,   265,     0,
     266,  1123,   268,   269,   270,     0,     0,     0,   272,   273,
     274,   275,   276,     0,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,     0,     0,   288,   289,   290,     0,
       0,     0,     0,     0,     0,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,   314,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,     0,  1124,     0,   334,   335,
     336,   337,     0,   338,     0,   339,     0,     0,     0,   342,
     343,   344,   345,     0,   346,   347,     0,   348,   349,   350,
       0,   351,   352,   353,   354,  1125,     0,   357,   358,   359,
     360,     0,   361,   362,   363,   364,   365,   366,   367,     0,
     368,     0,   370,   371,   372,   373,   374,   375,   376,     0,
     377,     0,   378,     0,     0,   381,     0,   383,   384,   385,
     386,   387,     0,     0,   388,   389,     0,   391,     0,     0,
     393,   394,   395,     0,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,     0,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,     0,   428,     0,
     429,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,     0,     0,   440,   441,   442,     0,
     444,     0,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   458,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
       0,   509,   510,   511,   512,   513,     0,   514,   515,   516,
     517,   518,     0,   520,   521,   522,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,     0,   539,   540,     0,   541,     0,   543,
     544,   545,   546,   547,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,   561,   562,   563,     0,     0,   564,   565,   566,   567,
     568,     0,     0,   569,   570,   571,   572,   573,   574,   575,
       0,   576,     0,   578,   579,   580,   581,     0,     0,   582,
       0,     0,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,     0,     0,     0,   897,   898,   899,   610,   900,
     901,   902,   903,   904,   905,   891,     0,     0,     0,     0,
       0,     0,   892,   893,   894,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,     0,   243,   244,   245,
       0,   247,   248,   249,   250,   251,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
     263,   264,   265,     0,   266,  1746,   268,   269,   270,     0,
       0,     0,   272,   273,   274,   275,   276,     0,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,     0,
     288,   289,   290,     0,     0,     0,     0,     0,     0,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,   314,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,     0,
    1747,     0,   334,   335,   336,   337,     0,   338,     0,   339,
       0,     0,     0,   342,   343,   344,   345,     0,   346,   347,
       0,   348,   349,   350,     0,   351,   352,   353,   354,   355,
       0,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,     0,   370,   371,   372,   373,
     374,   375,   376,     0,   377,     0,   378,     0,     0,   381,
       0,   383,   384,   385,   386,   387,     0,     0,   388,   389,
       0,   391,     0,     0,   393,   394,   395,     0,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,     0,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,     0,   428,     0,   429,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,     0,     0,
     440,   441,   442,     0,   444,     0,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     458,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
       0,   514,   515,   516,   517,   518,     0,   520,   521,   522,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,     0,   539,   540,
       0,   541,     0,   543,   544,   545,   546,   547,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,   561,   562,   563,     0,     0,
     564,   565,   566,   567,   568,     0,     0,   569,   570,   571,
     572,   573,   574,   575,     0,   576,     0,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,     0,     0,     0,   897,
     898,   899,   610,   900,   901,   902,   903,   904,   905,   891,
       0,     0,     0,     0,     0,     0,   892,   893,   894,   230,
     231,   232,   233,   234,   235,   236,   237,     0,   238,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
       0,   243,   244,   245,     0,   247,   248,   249,   250,   251,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,     0,     0,     0,   272,   273,   274,   275,
     276,     0,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,     0,   288,   289,   290,     0,     0,     0,
       0,     0,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,   314,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,     0,   333,     0,   334,   335,   336,   337,
       0,   338,     0,   339,     0,     0,     0,   342,   343,   344,
     345,     0,   346,   347,     0,   348,   349,   350,     0,   351,
     352,   353,   354,   355,     0,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,     0,
     370,   371,   372,   373,   374,   375,   376,     0,   377,     0,
     378,     0,     0,   381,     0,   383,   384,   385,   386,   387,
       0,     0,   388,   389,     0,   391,     0,     0,   393,   394,
     395,     0,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
       0,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,     0,   428,     0,   429,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,     0,     0,   440,   441,   442,     0,   444,     0,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   458,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,   513,     0,   514,   515,   516,   517,   518,
       0,   520,   521,   522,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,     0,   539,   540,     0,   541,     0,   543,   544,   545,
     546,   547,     0,   548,   549,   550,     0,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,   561,
     562,   563,     0,     0,   564,   565,   566,   567,   568,     0,
       0,   569,   570,   571,   572,   573,   574,   575,     0,   576,
       0,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
       0,     0,     0,   897,   898,   899,   610,   900,   901,   902,
     903,   904,   905,   891,     0,     0,     0,     0,     0,     0,
     892,   893,   894,   230,   231,   232,   233,   234,   235,   236,
     237,     0,   238,   239,   240,     0,     0,     0,     0,     0,
       0,     0,   241,   242,     0,   243,   244,   245,     0,   247,
     248,   249,   250,   251,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,   263,   264,
     265,     0,   266,  3028,   268,   269,   270,     0,     0,     0,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
     281,   282,   283,   284,   285,   286,     0,     0,   288,   289,
     290,     0,     0,     0,     0,     0,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   309,   310,
     311,     0,     0,   312,   313,   314,   315,   316,     0,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,     0,  3029,     0,
     334,   335,   336,   337,     0,   338,     0,   339,     0,     0,
       0,   342,   343,   344,   345,     0,   346,   347,     0,   348,
     349,   350,     0,   351,   352,   353,   354,   355,     0,   357,
     358,   359,   360,     0,   361,   362,   363,   364,   365,   366,
     367,     0,   368,     0,   370,   371,   372,   373,   374,   375,
     376,     0,   377,     0,   378,     0,     0,   381,     0,   383,
     384,   385,   386,   387,     0,     0,   388,   389,     0,   391,
       0,     0,   393,   394,   395,     0,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,     0,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,     0,
     428,     0,   429,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,     0,     0,   440,   441,
     442,     0,   444,     0,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   458,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,     0,   509,   510,   511,   512,   513,     0,   514,
     515,   516,   517,   518,     0,   520,   521,   522,   523,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,     0,   539,   540,     0,   541,
       0,   543,   544,   545,   546,   547,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,   561,   562,   563,     0,     0,   564,   565,
     566,   567,   568,     0,     0,   569,   570,   571,   572,   573,
     574,   575,     0,   576,     0,   578,   579,   580,   581,     0,
       0,   582,     0,     0,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,     0,     0,     0,   897,   898,   899,
     610,   900,   901,   902,   903,   904,   905,   891,     0,     0,
       0,     0,     0,     0,   892,   893,   894,   230,   231,   232,
     233,   234,   235,   236,   237,     0,   238,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,     0,   243,
     244,   245,     0,   247,   248,   249,   250,   251,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,     0,     0,     0,   272,   273,   274,   275,   276,     0,
     278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
       0,     0,   288,   289,   290,     0,     0,     0,     0,     0,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   309,   310,   311,     0,     0,   312,   313,   314,
     315,   316,     0,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,     0,   333,     0,   334,   335,   336,   337,     0,   338,
       0,   339,     0,     0,     0,   342,   343,   344,   345,     0,
     346,   347,     0,   348,   349,   350,     0,   351,   352,   353,
     354,   355,     0,   357,   358,   359,   360,     0,   361,   362,
     363,   364,   365,   366,   367,     0,   368,     0,   370,   371,
     372,   373,   374,   375,   376,     0,   377,     0,   378,     0,
       0,   381,     0,   383,   384,   385,   386,   387,     0,     0,
     388,   389,     0,   391,     0,     0,   393,   394,   395,     0,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,     0,   428,     0,   429,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,  4909,   438,   439,
       0,     0,   440,   441,   442,     0,   444,     0,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   458,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,     0,   509,   510,   511,
     512,   513,     0,   514,   515,   516,   517,   518,     0,   520,
     521,   522,   523,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,     0,
     539,   540,     0,   541,     0,   543,   544,   545,   546,   547,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,   565,   566,   567,   568,     0,     0,   569,
     570,   571,   572,   573,   574,   575,     0,   576,     0,   578,
     579,   580,   581,     0,     0,   582,     0,     0,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,  1646,     0,
       0,   897,   898,   899,     0,   900,   901,   902,   903,   904,
     905,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,  1647,   238,   239,   240,  1648,  1649,  1650,
    1651,  1652,  1653,  1654,   241,   242,  1655,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,  1656,
     255,   256,   257,   258,   259,   260,  1657,  1658,   261,   262,
     263,   264,   265,  1659,   266,   267,   268,   269,   270,  1660,
     271,  1661,   272,   273,   274,   275,   276,   277,   278,   279,
     280,  1662,   281,   282,   283,   284,   285,   286,  1663,   287,
     288,   289,   290,  1664,  1665,  1666,   291,  1667,  1668,  1669,
     292,   293,   294,   295,   296,   297,   298,   299,   300,  1670,
     301,  1671,   302,   303,   304,   305,   306,   307,  1672,   308,
     309,   310,   311,  1673,  1674,   312,   313,   314,   315,   316,
    1675,   317,   318,   319,  1676,   320,   321,   322,  1677,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,  1678,
     333,  1679,   334,   335,   336,   337,  1680,   338,  1681,   339,
     340,  1682,   341,   342,   343,   344,   345,  1683,   346,   347,
    1684,   348,   349,   350,  1685,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,  1686,   361,   362,   363,   364,
     365,   366,   367,  1687,   368,   369,   370,   371,   372,   373,
     374,   375,   376,  1688,   377,  1689,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,  1690,  1691,   388,   389,
     390,   391,   392,  1692,   393,   394,   395,  1693,  1694,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,  1695,   425,
     426,   427,   428,  1696,   429,   430,   431,   432,   433,   434,
    1697,   435,   436,  1698,  1699,   437,   438,   439,  1700,  1701,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,  1702,   456,   457,
     458,   459,   460,   461,   462,   463,  1703,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,  1704,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,  1705,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,  1706,   509,   510,   511,   512,   513,
    1707,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,  1708,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,  1709,   539,   540,
    1710,   541,   542,   543,   544,   545,   546,   547,  1711,   548,
     549,   550,  1712,  1713,   551,   552,   553,   554,   555,  1714,
     556,   557,   558,   559,   560,   561,   562,   563,  1715,  1716,
     564,   565,   566,   567,   568,  1717,  1718,   569,   570,   571,
     572,   573,   574,   575,  1719,   576,   577,   578,   579,   580,
     581,  1720,  1721,   582,  1722,  1723,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   610,     0,     0,     0,
       0,     0,     0,     0,     0,  1724,     0,     0,     0,     0,
       0,     0,     0,   230,   231,   232,   233,   234,   235,   236,
     237,     0,   238,   239,   240,     0,     0,     0,     0,     0,
       0,     0,   241,   242,     0,   243,   244,   245,     0,   247,
     248,   249,   250,   251,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,     0,     0,     0,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
     281,   282,   283,   284,   285,   286,     0,     0,   288,   289,
     290,     0,     0,     0,     0,     0,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   309,   310,
     311,     0,     0,   312,   313,   314,   315,   316,     0,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,     0,   333,     0,
     334,   335,   336,   337,     0,   338,     0,   339,     0,     0,
       0,   342,   343,   344,   345,     0,   346,   347,     0,   348,
     349,   350,     0,   351,   352,   353,   354,   355,     0,   357,
     358,   359,   360,     0,   361,   362,   363,   364,   365,   366,
     367,     0,   368,     0,   370,   371,   372,   373,   374,   375,
     376,     0,   377,     0,   378,     0,     0,   381,     0,   383,
     384,   385,   386,   387,     0,     0,   388,   389,     0,   391,
       0,     0,   393,   394,   395,     0,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,     0,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,     0,
     428,     0,   429,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,     0,     0,   440,   441,
     442,     0,   444,     0,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   458,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,     0,   509,   510,   511,   512,   513,     0,   514,
     515,   516,   517,   518,     0,   520,   521,   522,   523,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,     0,   539,   540,     0,   541,
       0,   543,   544,   545,   546,   547,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,   561,   562,   563,     0,     0,   564,   565,
     566,   567,   568,     0,     0,   569,   570,   571,   572,   573,
     574,   575,     0,   576,     0,   578,   579,   580,   581,     0,
       0,   582,     0,     0,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   610,     0,     0,     0,     0,     0,
       0,     0,     0,   827,     0,     0,     0,     0,     0,     0,
       0,   230,   231,   232,   233,   234,   235,   236,   237,     0,
     238,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,     0,   243,   244,   245,     0,   247,   248,   249,
     250,   251,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,     0,     0,     0,   272,   273,
     274,   275,   276,     0,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,     0,     0,   288,   289,   290,     0,
       0,     0,     0,     0,     0,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,   314,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,     0,   333,     0,   334,   335,
     336,   337,     0,   338,     0,   339,     0,     0,     0,   342,
     343,   344,   345,     0,   346,   347,     0,   348,   349,   350,
       0,   351,   352,   353,   354,   355,     0,   357,   358,   359,
     360,     0,   361,   362,   363,   364,   365,   366,   367,     0,
     368,     0,   370,   371,   372,   373,   374,   375,   376,     0,
     377,     0,   378,     0,     0,   381,     0,   383,   384,   385,
     386,   387,     0,     0,   388,   389,     0,   391,     0,     0,
     393,   394,   395,     0,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,     0,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,     0,   428,     0,
     429,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,     0,     0,   440,   441,   442,     0,
     444,     0,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   458,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
       0,   509,   510,   511,   512,   513,     0,   514,   515,   516,
     517,   518,     0,   520,   521,   522,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,     0,   539,   540,     0,   541,     0,   543,
     544,   545,   546,   547,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,   561,   562,   563,     0,     0,   564,   565,   566,   567,
     568,     0,     0,   569,   570,   571,   572,   573,   574,   575,
       0,   576,     0,   578,   579,   580,   581,     0,     0,   582,
       0,     0,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,  1073,     0,     0,     0,     0,     0,     0,     0,
       0,  5300,     0,     0,     0,     0,     0,     0,     0,   230,
     231,   232,   233,   234,   235,   236,   237,     0,   238,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
       0,   243,   244,   245,   246,   247,   248,   249,     0,  1074,
     252,  1075,  1076,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,  1077,  1078,   265,     0,   266,   267,
     268,   269,     0,     0,   271,     0,   272,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,   287,   288,   289,   290,     0,     0,     0,
     291,     0,     0,     0,   292,   293,   294,   295,   296,   297,
    1079,  1080,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,  1081,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,     0,   328,   329,
     330,   331,     0,     0,   333,     0,   334,   335,  1082,   337,
       0,   338,     0,   339,   340,     0,   341,   342,   343,   344,
     345,     0,   346,     0,     0,     0,   349,   350,     0,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,  2183,
     361,   362,   363,   364,   365,   366,   367,     0,   368,   369,
    2184,   371,   372,   373,   374,  1084,  1085,     0,  1086,     0,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
       0,     0,   388,     0,   390,   391,   392,     0,   393,   394,
     395,     0,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,  1087,
     413,  1088,   415,   416,   417,   418,   419,   420,   421,     0,
       0,   424,     0,   425,   426,   427,   428,     0,     0,   430,
    1089,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,     0,  2185,   440,   441,  2186,   443,   444,   445,
       0,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,     0,   459,     0,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,  1090,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,   494,   495,   496,   497,   498,     0,   500,
     501,   502,   503,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,   513,     0,   514,   515,  2187,   517,   518,
     519,   520,   521,  1092,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,     0,
     538,     0,   539,   540,     0,   541,   542,   543,   544,   545,
     546,   547,     0,   548,  1093,  1094,     0,     0,   551,   552,
       0,   554,     0,     0,   556,   557,   558,   559,   560,   561,
     562,   563,     0,     0,   564,   565,   566,   567,   568,     0,
       0,   569,   570,   571,   572,   573,     0,  1095,  2188,   576,
     577,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   588,     0,     0,     0,     0,
       0,     0,     0,  3376,     0,     0,     0,   600,   601,   602,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2189,
     230,   231,   232,   233,   234,   235,   236,   237,     0,   238,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,     0,   243,   244,   245,   246,   247,   248,   249,     0,
    1074,   252,  1075,  1076,     0,   255,   256,   257,   258,   259,
     260,     0,     0,   261,   262,  1077,  1078,   265,     0,   266,
     267,   268,   269,     0,     0,   271,     0,   272,   273,   274,
     275,   276,   277,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,   287,   288,   289,   290,     0,     0,
       0,   291,     0,     0,     0,   292,   293,   294,   295,   296,
     297,  1079,  1080,   300,     0,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,  1081,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,     0,   328,
     329,   330,   331,     0,     0,   333,     0,   334,   335,  1082,
     337,     0,   338,     0,   339,   340,     0,   341,   342,   343,
     344,   345,     0,   346,     0,     0,     0,   349,   350,     0,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
    2183,   361,   362,   363,   364,   365,   366,   367,     0,   368,
     369,  2184,   371,   372,   373,   374,  1084,  1085,     0,  1086,
       0,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,     0,     0,   388,     0,   390,   391,   392,     0,   393,
     394,   395,     0,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
    1087,   413,  1088,   415,   416,   417,   418,   419,   420,   421,
       0,     0,   424,     0,   425,   426,   427,   428,     0,     0,
     430,  1089,   432,   433,   434,     0,   435,   436,     0,     0,
     437,   438,   439,     0,  2185,   440,   441,  2186,   443,   444,
     445,     0,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,     0,   459,     0,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,  1090,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,   494,   495,   496,   497,   498,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,   513,     0,   514,   515,  2187,   517,
     518,   519,   520,   521,  1092,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
       0,   538,     0,   539,   540,     0,   541,   542,   543,   544,
     545,   546,   547,     0,   548,  1093,  1094,     0,     0,   551,
     552,     0,   554,     0,     0,   556,   557,   558,   559,   560,
     561,   562,   563,     0,     0,   564,   565,   566,   567,   568,
       0,     0,   569,   570,   571,   572,   573,     0,  1095,  2188,
     576,   577,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   588,     0,     0,     0,
       0,     0,     0,     0,   877,     0,  1515,   670,   600,   601,
     602,     0,   730,     0,     0,     0,     0,     0,     0,     0,
    2189,   230,   231,   232,   233,   234,   235,   236,   237,     0,
     238,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,     0,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,     0,   271,     0,   272,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,     0,   287,   288,   289,   290,     0,
       0,     0,   291,     0,     0,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,  2111,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,   314,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,  1930,   333,     0,   334,   335,
     336,   337,     0,   338,     0,   339,   340,     0,   341,   342,
     343,   344,   345,     0,   346,   347,     0,   348,   349,   350,
       0,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,     0,   361,   362,   363,   364,   365,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,     0,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,     0,     0,   388,   389,   390,   391,   392,     0,
     393,   394,   395,     0,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,     0,
     429,   430,   431,   432,   433,   434,     0,   435,   436,  1931,
       0,   437,   438,   439,     0,     0,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   458,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
       0,   509,   510,   511,   512,   513,     0,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,     0,   539,   540,     0,   541,   542,   543,
     544,   545,   546,   547,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,  1932,   556,   557,   558,   559,
     560,   561,   562,   563,     0,     0,   564,   565,   566,   567,
     568,     0,     0,   569,   570,   571,   572,   573,   574,   575,
       0,   576,   577,   578,   579,   580,   581,     0,     0,   582,
       0,     0,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,     0,   877,     0,  1515,   670,     0,     0,  1516,
    1517,   730,     0,     0,     0,     0,     0,     0,     0,     0,
     230,   231,   232,   233,   234,   235,   236,   237,     0,   238,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,     0,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,   256,   257,   258,   259,
     260,     0,     0,   261,   262,   263,   264,   265,     0,   266,
     267,   268,   269,   270,     0,   271,     0,   272,   273,   274,
     275,   276,   277,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,   287,   288,   289,   290,     0,     0,
       0,   291,     0,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,  2116,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,   314,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,  1930,   333,     0,   334,   335,   336,
     337,     0,   338,     0,   339,   340,     0,   341,   342,   343,
     344,   345,     0,   346,   347,     0,   348,   349,   350,     0,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,     0,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,     0,     0,   388,   389,   390,   391,   392,     0,   393,
     394,   395,     0,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   427,   428,     0,   429,
     430,   431,   432,   433,   434,     0,   435,   436,  1931,     0,
     437,   438,   439,     0,     0,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,   458,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,   513,     0,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,     0,   539,   540,     0,   541,   542,   543,   544,
     545,   546,   547,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,  1932,   556,   557,   558,   559,   560,
     561,   562,   563,     0,     0,   564,   565,   566,   567,   568,
       0,     0,   569,   570,   571,   572,   573,   574,   575,     0,
     576,   577,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   877,     0,  1515,   670,     0,     0,  1516,  1517,
     730,     0,     0,     0,     0,     0,     0,     0,     0,   230,
     231,   232,   233,   234,   235,   236,   237,     0,   238,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
       0,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,     0,   271,     0,   272,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,   287,   288,   289,   290,     0,     0,     0,
     291,     0,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,   314,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,  1930,   333,     0,   334,   335,   336,   337,
       0,   338,     0,   339,   340,     0,   341,   342,   343,   344,
     345,     0,   346,   347,     0,   348,   349,   350,     0,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,     0,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
       0,     0,   388,   389,   390,   391,   392,     0,   393,   394,
     395,     0,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,     0,   429,   430,
     431,   432,   433,   434,     0,   435,   436,  1931,     0,   437,
     438,   439,     0,     0,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   458,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,   513,     0,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,     0,   539,   540,     0,   541,   542,   543,   544,   545,
     546,   547,     0,   548,   549,   550,     0,     0,   551,   552,
     553,   554,   555,  1932,   556,   557,   558,   559,   560,   561,
     562,   563,     0,     0,   564,   565,   566,   567,   568,     0,
       0,   569,   570,   571,   572,   573,   574,   575,     0,   576,
     577,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
       0,   877,     0,     0,   670,     0,     0,  1516,  1517,   730,
       0,     0,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   236,   237,     0,   238,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,     0,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,     0,   271,     0,   272,   273,   274,   275,   276,
     277,   278,   279,   280,     0,   281,   282,   283,   284,   285,
     286,     0,   287,   288,   289,   290,     0,     0,     0,   291,
       0,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,  2982,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   309,   310,   311,     0,     0,   312,   313,
     314,   315,   316,     0,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,  1930,   333,     0,   334,   335,   336,   337,     0,
     338,     0,   339,   340,     0,   341,   342,   343,   344,   345,
       0,   346,   347,     0,   348,   349,   350,     0,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,     0,   361,
     362,   363,   364,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,     0,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,     0,
       0,   388,   389,   390,   391,   392,     0,   393,   394,   395,
       0,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   427,   428,     0,   429,   430,   431,
     432,   433,   434,     0,   435,   436,  1931,     0,   437,   438,
     439,     0,     0,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
       0,   456,   457,   458,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,     0,   509,   510,
     511,   512,   513,     0,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
       0,   539,   540,     0,   541,   542,   543,   544,   545,   546,
     547,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,  1932,   556,   557,   558,   559,   560,   561,   562,
     563,     0,     0,   564,   565,   566,   567,   568,     0,     0,
     569,   570,   571,   572,   573,   574,   575,     0,   576,   577,
     578,   579,   580,   581,     0,     0,   582,     0,     0,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     610,     0,     0,     0,     0,     0,   742,   743,   730,     0,
       0,     0,     0,     0,     0,     0,     0,   230,   731,   232,
     233,   234,   235,   236,   237,   732,   238,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,     0,   243,
     244,   245,     0,   733,   248,   249,   250,   251,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,     0,     0,     0,   272,   273,   274,   275,   276,     0,
     278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
       0,     0,   288,   289,   290,     0,     0,     0,     0,     0,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   309,   310,   311,     0,     0,   312,   313,   314,
     315,   316,     0,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,     0,   333,     0,   334,   734,   336,   337,     0,   338,
       0,   735,     0,   736,     0,   342,   343,   344,   345,     0,
     346,   347,     0,   348,   349,   350,     0,   351,   352,   353,
     354,   355,     0,   357,   358,   359,   360,   737,   361,   362,
     363,   364,   365,   366,   367,     0,   368,     0,   370,   371,
     372,   373,   374,   375,   376,     0,   377,     0,   378,     0,
       0,   381,     0,   383,   384,   385,   386,   738,     0,     0,
     388,   389,     0,   391,     0,     0,   393,   394,   395,     0,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,     0,   414,
     415,   739,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,     0,   428,     0,   429,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
       0,     0,   440,   441,   442,     0,   444,     0,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   458,   459,   460,   461,   462,   463,     0,   740,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   741,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,     0,   509,   510,   511,
     512,   513,     0,   514,   515,   516,   517,   518,     0,   520,
     521,   522,   523,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,     0,
     539,   540,     0,   541,     0,   543,   544,   545,   546,   547,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,   565,   566,   567,   568,     0,     0,   569,
     570,   571,   572,   573,   574,   575,     0,   576,     0,   578,
     579,   580,   581,     0,     0,   582,     0,     0,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,     0,  1646,
       0,  5514,   670,     0,     0,   742,   743,   730,     0,     0,
       0,     0,     0,     0,     0,     0,   230,   231,   232,   233,
     234,   235,   236,   237,  1647,   238,   239,   240,  1648,  1649,
    1650,  1651,  1652,  1653,  1654,   241,   242,  1655,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
    1656,   255,   256,   257,   258,   259,   260,  1657,  1658,   261,
     262,   263,   264,   265,  1659,   266,   267,   268,   269,   270,
    1660,   271,  1661,   272,   273,   274,   275,   276,   277,   278,
     279,   280,  1662,   281,   282,   283,   284,   285,   286,  1663,
     287,   288,   289,   290,  1664,  1665,  1666,   291,  1667,  1668,
    1669,   292,   293,   294,   295,   296,   297,   298,   299,   300,
    1670,   301,  1671,   302,   303,   304,   305,   306,   307,  1672,
     308,   309,   310,   311,  1673,  1674,   312,   313,   314,   315,
     316,  1675,   317,   318,   319,  1676,   320,   321,   322,  1677,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
    1678,   333,  1679,   334,   335,   336,   337,  1680,   338,  1681,
     339,   340,  1682,   341,   342,   343,   344,   345,  1683,   346,
     347,  1684,   348,   349,   350,  1685,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,  1686,   361,   362,   363,
     364,   365,   366,   367,  1687,   368,   369,   370,   371,   372,
     373,   374,   375,   376,  1688,   377,  1689,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,  1690,  1691,   388,
     389,   390,   391,   392,  1692,   393,   394,   395,  1693,  1694,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,  1695,
     425,   426,   427,   428,  1696,   429,   430,   431,   432,   433,
     434,  1697,   435,   436,  1698,  1699,   437,   438,   439,  1700,
    1701,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,  1702,   456,
     457,   458,   459,   460,   461,   462,   463,  1703,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,  1704,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,  1705,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,  1706,   509,   510,   511,   512,
     513,  1707,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,  1708,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,  1709,   539,
     540,  1710,   541,   542,   543,   544,   545,   546,   547,  1711,
     548,   549,   550,  1712,  1713,   551,   552,   553,   554,   555,
    1714,   556,   557,   558,   559,   560,   561,   562,   563,  1715,
    1716,   564,   565,   566,   567,   568,  1717,  1718,   569,   570,
     571,   572,   573,   574,   575,  1719,   576,   577,   578,   579,
     580,   581,  1720,  1721,   582,  1722,  1723,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,  1646,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,  1647,   238,   239,   240,  1648,  1649,  1650,  1651,
    1652,  1653,  1654,   241,   242,  1655,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,  1656,   255,
     256,   257,   258,   259,   260,  1657,  1658,   261,   262,   263,
     264,   265,  1659,   266,   267,   268,   269,   270,  1660,   271,
    1661,   272,   273,   274,   275,   276,   277,   278,   279,   280,
    1662,   281,   282,   283,   284,   285,   286,  1663,   287,   288,
     289,   290,  1664,  1665,  1666,   291,  1667,  1668,  1669,   292,
     293,   294,   295,   296,   297,   298,   299,   300,  1670,   301,
    1671,   302,   303,   304,   305,   306,   307,  1672,   308,   309,
     310,   311,  1673,  1674,   312,   313,   314,   315,   316,  1675,
     317,   318,   319,  1676,   320,   321,   322,  1677,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,  1678,   333,
    1679,   334,   335,   336,   337,  1680,   338,  1681,   339,   340,
    1682,   341,   342,   343,   344,   345,  1683,   346,   347,  1684,
     348,   349,   350,  1685,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,  1686,   361,   362,   363,   364,   365,
     366,   367,  1687,   368,   369,   370,   371,   372,   373,   374,
     375,   376,  1688,   377,  1689,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,  1690,  1691,   388,   389,   390,
     391,   392,  1692,   393,   394,   395,  1693,  1694,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,  1695,   425,   426,
     427,   428,  1696,   429,   430,   431,   432,   433,   434,  1697,
     435,   436,  1698,  1699,   437,   438,   439,  1700,  1701,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,  1702,   456,   457,   458,
     459,   460,   461,   462,   463,  1703,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,  1704,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,  1705,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,  1706,   509,   510,   511,   512,   513,  1707,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
    1708,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,  1709,   539,   540,  1710,
     541,   542,   543,   544,   545,   546,   547,  1711,   548,   549,
     550,  1712,  1713,   551,   552,   553,   554,   555,  1714,   556,
     557,   558,   559,   560,   561,   562,   563,  1715,  1716,   564,
     565,   566,   567,   568,  1717,  1718,   569,   570,   571,   572,
     573,   574,   575,  1719,   576,   577,   578,   579,   580,   581,
    1720,  1721,   582,  1722,  1723,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,  1646,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   230,   231,   232,   233,  3099,   235,   236,   237,
    1647,   238,   239,   240,  1648,  1649,  1650,  1651,  1652,  1653,
    1654,   241,   242,  1655,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,  1656,   255,   256,   257,
     258,   259,   260,  1657,  1658,   261,   262,   263,   264,   265,
    1659,   266,   267,   268,   269,   270,  1660,   271,  1661,   272,
     273,   274,   275,   276,   277,   278,   279,   280,  1662,   281,
     282,   283,   284,   285,   286,  1663,   287,   288,   289,   290,
    1664,  1665,  1666,   291,  1667,  1668,  1669,   292,   293,   294,
     295,   296,   297,   298,   299,   300,  1670,   301,  1671,   302,
     303,   304,   305,   306,   307,  1672,   308,   309,   310,   311,
    1673,  1674,   312,   313,   314,  3100,   316,  1675,   317,   318,
     319,  1676,   320,   321,   322,  1677,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,  1678,   333,  1679,   334,
     335,   336,   337,  1680,   338,  1681,   339,   340,  1682,   341,
     342,   343,   344,   345,  1683,   346,   347,  1684,   348,   349,
     350,  1685,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,  1686,   361,   362,   363,   364,   365,   366,   367,
    1687,   368,   369,   370,   371,   372,   373,   374,   375,   376,
    1688,   377,  1689,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,  1690,  1691,   388,   389,   390,   391,   392,
    1692,   393,   394,   395,  1693,  1694,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,  1695,   425,   426,   427,   428,
    1696,   429,   430,   431,   432,   433,   434,  1697,   435,   436,
    1698,  1699,   437,   438,   439,  1700,  1701,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,  1702,   456,   457,   458,   459,   460,
     461,   462,   463,  1703,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,  1704,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,  1705,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,  1706,   509,   510,   511,   512,   513,  1707,  3101,   515,
     516,   517,   518,   519,   520,   521,   522,   523,  1708,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,  1709,   539,   540,  1710,   541,   542,
     543,   544,   545,   546,   547,  1711,   548,   549,   550,  1712,
    1713,   551,   552,   553,   554,   555,  1714,   556,   557,   558,
     559,   560,   561,   562,   563,  1715,  1716,   564,   565,   566,
     567,   568,  1717,  1718,   569,   570,   571,   572,   573,   574,
     575,  1719,   576,   577,   578,   579,   580,   581,  1720,  1721,
     582,  1722,  1723,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   229,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     230,   231,   232,   233,   234,   235,   236,   237,     0,   238,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,     0,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,   256,   257,   258,   259,
     260,     0,  1241,   261,   262,   263,   264,   265,     0,   266,
     267,   268,   269,  1244,     0,  1245,     0,   272,   273,   274,
     275,   276,   277,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,   287,   288,   289,   290,  1246,  1247,
    1248,  1249,  1250,  1251,  1252,   292,   293,   294,   295,   296,
     297,   298,   299,   300,     0,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,   314,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,  1257,     0,   333,     0,   334,   335,   336,
     337,     0,   338,     0,   339,   340,     0,   341,   342,   343,
     344,   345,     0,   346,  1260,     0,   348,   349,   350,     0,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,     0,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,     0,     0,   388,  1265,   390,   391,   392,     0,   393,
     394,   395,  1266,  1267,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,  1270,   424,     0,   425,   426,   427,   428,     0,  1273,
     430,   431,   432,   433,   434,     0,   435,   436,     0,     0,
     437,   438,   439,     0,     0,   440,   441,   442,   443,   444,
     445,  1276,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,  1277,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,   513,  1280,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
    1282,   538,     0,   539,   540,     0,   541,   542,   543,   544,
     545,   546,   547,     0,   548,   549,   550,     0,     0,   551,
     552,  1285,   554,  1286,     0,   556,   557,   558,   559,   560,
     561,   562,   563,     0,     0,   564,   565,   566,   567,   568,
    1289,     0,   569,   570,   571,   572,   573,   574,   575,     0,
     576,   577,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   588,   589,  1291,  1292,
    1293,  1294,   594,  1295,  1296,  1297,  1298,   599,   600,   601,
     602,   877,     0,     0,   670,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   236,   237,     0,   238,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,     0,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,     0,   271,     0,   272,   273,   274,   275,   276,
     277,   278,   279,   280,     0,   281,   282,   283,   284,   285,
     286,     0,   287,   288,   289,   290,     0,     0,     0,   291,
       0,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   309,   310,   311,     0,     0,   312,   313,
     314,   315,   316,     0,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,  1930,   333,     0,   334,   335,   336,   337,     0,
     338,     0,   339,   340,     0,   341,   342,   343,   344,   345,
       0,   346,   347,     0,   348,   349,   350,     0,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,     0,   361,
     362,   363,   364,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,     0,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,     0,
       0,   388,   389,   390,   391,   392,     0,   393,   394,   395,
       0,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   427,   428,     0,   429,   430,   431,
     432,   433,   434,     0,   435,   436,  1931,     0,   437,   438,
     439,     0,     0,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
       0,   456,   457,   458,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,     0,   509,   510,
     511,   512,   513,     0,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
       0,   539,   540,     0,   541,   542,   543,   544,   545,   546,
     547,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,  1932,   556,   557,   558,   559,   560,   561,   562,
     563,     0,     0,   564,   565,   566,   567,   568,     0,     0,
     569,   570,   571,   572,   573,   574,   575,     0,   576,   577,
     578,   579,   580,   581,     0,     0,   582,     0,     0,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   877,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   230,   231,   232,   233,
     234,   235,   236,   237,   915,   238,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,     0,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,   256,   257,   258,   259,   260,     0,     0,   261,
     262,   263,   264,   265,     0,   266,   267,   268,   269,   270,
       0,   271,     0,   272,   273,   274,   275,   276,   277,   278,
     279,   280,     0,   281,   282,   283,   284,   285,   286,     0,
     287,   288,   289,   290,     0,     0,     0,   291,     0,     0,
     878,   292,   293,   294,   295,   296,   297,   298,   299,   300,
       0,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,   313,   314,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
       0,   333,     0,   334,   335,   336,   337,     0,   338,     0,
     339,   340,     0,   341,   342,   343,   344,   345,     0,   346,
     347,     0,   348,   349,   350,     0,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,     0,   361,   362,   363,
     364,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,     0,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,     0,     0,   388,
     389,   390,   391,   392,     0,   393,   394,   395,     0,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   427,   428,     0,   429,   430,   431,   432,   433,
     434,     0,   435,   436,     0,     0,   437,   438,   439,     0,
       0,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   456,
     457,   458,   459,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,     0,   509,   510,   511,   512,
     513,   879,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,     0,   539,
     540,     0,   541,   542,   543,   544,   545,   546,   547,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,     0,
       0,   564,   565,   566,   567,   568,     0,     0,   569,   570,
     571,   572,   573,   574,   575,     0,   576,   577,   578,   579,
     580,   581,     0,     0,   582,     0,     0,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   877,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,   936,   238,   239,   240,     0,     0,     0,     0,
       0,     0,     0,   241,   242,     0,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,     0,   261,   262,   263,
     264,   265,     0,   266,   267,   268,   269,   270,     0,   271,
       0,   272,   273,   274,   275,   276,   277,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,   287,   288,
     289,   290,     0,     0,     0,   291,     0,     0,   878,   292,
     293,   294,   295,   296,   297,   298,   299,   300,     0,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,   314,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,     0,   333,
       0,   334,   335,   336,   337,     0,   338,     0,   339,   340,
       0,   341,   342,   343,   344,   345,     0,   346,   347,     0,
     348,   349,   350,     0,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,     0,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,     0,     0,   388,   389,   390,
     391,   392,     0,   393,   394,   395,     0,     0,   396,   397,
     398,   399,   937,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     427,   428,     0,   429,   430,   431,   432,   433,   434,     0,
     435,   436,     0,     0,   437,   438,   439,     0,     0,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,   458,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,   879,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,     0,   539,   540,     0,
     541,   542,   543,   544,   545,   546,   547,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,   561,   562,   563,     0,     0,   564,
     565,   566,   567,   568,     0,     0,   569,   570,   571,   572,
     573,   574,   575,     0,   576,   577,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   877,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   230,   231,   232,   233,   234,   235,   236,   237,
       0,   238,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,     0,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,     0,   261,   262,   263,   264,   265,
       0,   266,   267,   268,   269,   270,     0,   271,     0,   272,
     273,   274,   275,   276,   277,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0,   287,   288,   289,   290,
       0,     0,     0,   291,     0,     0,   878,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,   314,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,     0,   333,     0,   334,
     335,   336,   337,     0,   338,     0,   339,   340,     0,   341,
     342,   343,   344,   345,     0,   346,   347,     0,   348,   349,
     350,     0,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,     0,   361,   362,   363,   364,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,     0,     0,   388,   389,   390,   391,   392,
       0,   393,   394,   395,     0,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,   428,
       0,   429,   430,   431,   432,   433,   434,     0,   435,   436,
       0,     0,   437,   438,   439,     0,     0,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,   458,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,   513,   879,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,     0,   539,   540,     0,   541,   542,
     543,   544,   545,   546,   547,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,   561,   562,   563,     0,     0,   564,   565,   566,
     567,   568,  2451,     0,   569,   570,   571,   572,   573,   574,
     575,     0,   576,   577,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   877,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     230,   231,   232,   233,   234,   235,   236,   237,     0,   238,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,     0,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,   256,   257,   258,   259,
     260,     0,     0,   261,   262,   263,   264,   265,     0,   266,
     267,   268,   269,   270,     0,   271,     0,   272,   273,   274,
     275,   276,   277,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,   287,   288,   289,   290,     0,     0,
       0,   291,     0,     0,   878,   292,   293,   294,   295,   296,
     297,   298,   299,   300,     0,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,   314,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,     0,   333,     0,   334,   335,   336,
     337,     0,   338,     0,   339,   340,     0,   341,   342,   343,
     344,   345,     0,   346,   347,  3458,   348,   349,   350,     0,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,     0,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,     0,     0,   388,   389,   390,   391,   392,     0,   393,
     394,   395,     0,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   427,   428,     0,   429,
     430,   431,   432,   433,   434,     0,   435,   436,     0,     0,
     437,   438,   439,     0,     0,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,   458,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,   513,   879,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,     0,   539,   540,     0,   541,   542,   543,   544,
     545,   546,   547,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
     561,   562,   563,     0,     0,   564,   565,   566,   567,   568,
       0,     0,   569,   570,   571,   572,   573,   574,   575,     0,
     576,   577,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   877,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   236,   237,     0,   238,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,     0,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,     0,   271,     0,   272,   273,   274,   275,   276,
     277,   278,   279,   280,     0,   281,   282,   283,   284,   285,
     286,     0,   287,   288,   289,   290,     0,     0,     0,   291,
       0,     0,   878,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   309,   310,   311,     0,     0,   312,   313,
     314,   315,   316,     0,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,     0,   333,     0,   334,   335,   336,   337,     0,
     338,     0,   339,   340,     0,   341,   342,   343,   344,   345,
       0,   346,   347,     0,   348,   349,   350,     0,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,     0,   361,
     362,   363,   364,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,     0,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,     0,
       0,   388,   389,   390,   391,   392,     0,   393,   394,   395,
       0,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   427,   428,     0,   429,   430,   431,
     432,   433,   434,     0,   435,   436,     0,     0,   437,   438,
     439,     0,     0,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
       0,   456,   457,   458,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   879,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
       0,   539,   540,     0,   541,   542,   543,   544,   545,   546,
     547,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,   561,   562,
     563,     0,     0,   564,   565,   566,   567,   568,     0,     0,
     569,   570,   571,   572,   573,   574,   575,     0,   576,   577,
     578,   579,   580,   581,     0,     0,   582,     0,     0,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   877,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   230,   231,   232,   233,
     234,   235,   236,   237,     0,   238,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,     0,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,   256,   257,   258,   259,   260,     0,     0,   261,
     262,   263,   264,   265,     0,   266,   267,   268,   269,   270,
       0,   271,     0,   272,   273,   274,   275,   276,   277,   278,
     279,   280,     0,   281,   282,   283,   284,   285,   286,     0,
     287,   288,   289,   290,     0,     0,     0,   291,     0,     0,
     878,   292,   293,   294,   295,   296,   297,   298,   299,   300,
       0,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,   313,   314,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
       0,   333,     0,   334,   335,   336,   337,     0,   338,     0,
     339,   340,     0,   341,   342,   343,   344,   345,     0,   346,
     347,     0,   348,   349,   350,     0,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,     0,   361,   362,   363,
     364,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,     0,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,     0,     0,   388,
     389,   390,   391,   392,     0,   393,   394,   395,     0,     0,
     396,   397,   398,   399,  1042,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   427,   428,     0,   429,   430,   431,   432,   433,
     434,     0,   435,   436,     0,     0,   437,   438,   439,     0,
       0,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   456,
     457,   458,   459,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,     0,   509,   510,   511,   512,
     513,   879,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,     0,   539,
     540,     0,   541,   542,   543,   544,   545,   546,   547,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,     0,
       0,   564,   565,   566,   567,   568,     0,     0,   569,   570,
     571,   572,   573,   574,   575,     0,   576,   577,   578,   579,
     580,   581,     0,     0,   582,     0,     0,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   877,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
       0,     0,     0,   241,   242,     0,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,     0,   261,   262,   263,
     264,   265,     0,   266,   267,   268,   269,   270,     0,   271,
       0,   272,   273,   274,   275,   276,   277,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,   287,   288,
     289,   290,     0,     0,     0,   291,     0,     0,   878,   292,
     293,   294,   295,   296,   297,   298,   299,   300,     0,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,   314,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,     0,   333,
       0,   334,   335,   336,   337,     0,   338,     0,   339,   340,
       0,   341,   342,   343,   344,   345,     0,   346,   347,     0,
     348,   349,   350,     0,   351,   352,   353,   354,  1118,   356,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,     0,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,     0,     0,   388,   389,   390,
     391,   392,     0,   393,   394,   395,     0,     0,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     427,   428,     0,   429,   430,   431,   432,   433,   434,     0,
     435,   436,     0,     0,   437,   438,   439,     0,     0,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,   458,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,   879,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,     0,   539,   540,     0,
     541,   542,   543,   544,   545,   546,   547,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,   561,   562,   563,     0,     0,   564,
     565,   566,   567,   568,     0,     0,   569,   570,   571,   572,
     573,   574,   575,     0,   576,   577,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   877,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   230,   231,   232,   233,   234,   235,   236,   237,
       0,   238,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,     0,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,     0,   261,   262,   263,   264,   265,
       0,   266,   267,   268,   269,   270,     0,   271,     0,   272,
     273,   274,   275,   276,   277,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0,   287,   288,   289,   290,
       0,     0,     0,   291,     0,     0,   878,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,   314,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,     0,   333,     0,   334,
     335,   336,   337,     0,   338,     0,   339,   340,     0,   341,
     342,   343,   344,   345,     0,   346,   347,     0,   348,   349,
     350,     0,   351,   352,   353,   354,  1131,   356,   357,   358,
     359,   360,     0,   361,   362,   363,   364,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,     0,     0,   388,   389,   390,   391,   392,
       0,   393,   394,   395,     0,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,   428,
       0,   429,   430,   431,   432,   433,   434,     0,   435,   436,
       0,     0,   437,   438,   439,     0,     0,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,   458,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,   513,   879,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,     0,   539,   540,     0,   541,   542,
     543,   544,   545,   546,   547,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,   561,   562,   563,     0,     0,   564,   565,   566,
     567,   568,     0,     0,   569,   570,   571,   572,   573,   574,
     575,     0,   576,   577,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   877,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     230,   231,   232,   233,   234,   235,   236,   237,     0,   238,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,     0,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,   256,   257,   258,   259,
     260,     0,     0,   261,   262,   263,   264,   265,     0,   266,
     267,   268,   269,   270,     0,   271,     0,   272,   273,   274,
     275,   276,   277,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,   287,   288,   289,   290,     0,     0,
       0,   291,     0,     0,   878,   292,   293,   294,   295,   296,
     297,   298,   299,   300,     0,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,   314,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,     0,   333,     0,   334,   335,   336,
     337,     0,   338,     0,   339,   340,     0,   341,   342,   343,
     344,   345,     0,   346,   347,     0,   348,   349,   350,     0,
     351,   352,   353,   354,  1143,   356,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,     0,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,     0,     0,   388,   389,   390,   391,   392,     0,   393,
     394,   395,     0,     0,   396,   397,   398,   399,  1144,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   427,   428,     0,   429,
     430,   431,   432,   433,   434,     0,   435,   436,     0,     0,
     437,   438,   439,     0,     0,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,   458,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,   513,   879,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,     0,   539,   540,     0,   541,   542,   543,   544,
     545,   546,   547,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
     561,   562,   563,     0,     0,   564,   565,   566,   567,   568,
       0,     0,   569,   570,   571,   572,   573,   574,   575,     0,
     576,   577,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   877,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   236,   237,     0,   238,   239,   240,
       3,     4,     0,     0,     0,     0,     0,   241,   242,     0,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,     0,   271,     0,   272,   273,   274,   275,   276,
     277,   278,   279,   280,     0,   281,   282,   283,   284,   285,
     286,     0,   287,   288,   289,   290,     0,     0,     0,   291,
       0,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   309,   310,   311,     0,     0,   312,   313,
     314,   315,   316,     0,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,     0,   333,     0,   334,   335,   336,   337,     0,
     338,     0,   339,   340,     0,   341,   342,   343,   344,   345,
       0,   346,   347,     0,   348,   349,   350,     0,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,     0,   361,
     362,   363,   364,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,     0,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,     0,
       0,   388,   389,   390,   391,   392,     0,   393,   394,   395,
       0,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   427,   428,     0,   429,   430,   431,
     432,   433,   434,     0,   435,   436,     0,     0,   437,   438,
     439,     0,     0,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
       0,   456,   457,   458,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,     0,   509,   510,
     511,   512,   513,     0,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
       0,   539,   540,     0,   541,   542,   543,   544,   545,   546,
     547,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,   561,   562,
     563,     0,     0,   564,   565,   566,   567,   568,     0,     0,
     569,   570,   571,   572,   573,   574,   575,     0,   576,   577,
     578,   579,   580,   581,     0,     0,   582,     0,     0,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   877,
       0,     0,   670,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   230,   231,   232,   233,
     234,   235,   236,   237,     0,   238,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,     0,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,   256,   257,   258,   259,   260,     0,     0,   261,
     262,   263,   264,   265,     0,   266,   267,   268,   269,   270,
       0,   271,     0,   272,   273,   274,   275,   276,   277,   278,
     279,   280,     0,   281,   282,   283,   284,   285,   286,     0,
     287,   288,   289,   290,     0,     0,     0,   291,     0,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
    2096,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,   313,   314,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
       0,   333,     0,   334,   335,   336,   337,     0,   338,     0,
     339,   340,     0,   341,   342,   343,   344,   345,     0,   346,
     347,     0,   348,   349,   350,     0,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,     0,   361,   362,   363,
     364,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,     0,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,     0,     0,   388,
     389,   390,   391,   392,     0,   393,   394,   395,     0,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   427,   428,     0,   429,   430,   431,   432,   433,
     434,     0,   435,   436,     0,     0,   437,   438,   439,     0,
       0,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   456,
     457,   458,   459,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,     0,   509,   510,   511,   512,
     513,     0,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,     0,   539,
     540,     0,   541,   542,   543,   544,   545,   546,   547,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,     0,
       0,   564,   565,   566,   567,   568,     0,     0,   569,   570,
     571,   572,   573,   574,   575,     0,   576,   577,   578,   579,
     580,   581,     0,     0,   582,     0,     0,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   877,     0,     0,
     670,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
       0,     0,     0,   241,   242,     0,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,     0,   261,   262,   263,
     264,   265,     0,   266,   267,   268,   269,   270,     0,   271,
       0,   272,   273,   274,   275,   276,   277,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,   287,   288,
     289,   290,     0,     0,     0,   291,     0,     0,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,     0,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,   314,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,     0,   333,
       0,   334,   335,   336,   337,     0,   338,     0,   339,   340,
       0,   341,   342,   343,   344,   345,     0,   346,   347,     0,
     348,   349,   350,     0,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,     0,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,     0,     0,   388,   389,   390,
     391,   392,     0,   393,   394,   395,     0,     0,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     427,   428,     0,   429,   430,   431,   432,   433,   434,     0,
     435,   436,     0,     0,   437,   438,   439,     0,     0,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,   458,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,     0,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,     0,   539,   540,     0,
     541,   542,   543,   544,   545,   546,   547,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,   561,   562,   563,     0,     0,   564,
     565,   566,   567,   568,     0,     0,   569,   570,   571,   572,
     573,   574,   575,     0,   576,   577,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   877,     0,     0,   670,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   230,   231,   232,   233,   234,   235,   236,   237,
       0,   238,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,     0,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,     0,   261,   262,   263,   264,   265,
       0,   266,   267,   268,   269,   270,     0,   271,     0,   272,
     273,   274,   275,   276,   277,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0,   287,   288,   289,   290,
       0,     0,     0,   291,     0,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,   314,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,     0,   333,     0,   334,
     335,   336,   337,     0,   338,     0,   339,   340,     0,   341,
     342,   343,   344,   345,     0,   346,   347,     0,   348,   349,
     350,     0,   351,   352,   353,   354,  1916,   356,   357,   358,
     359,   360,     0,   361,   362,   363,   364,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,     0,     0,   388,   389,   390,   391,   392,
       0,   393,   394,   395,     0,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,   428,
       0,   429,   430,   431,   432,   433,   434,     0,   435,   436,
       0,     0,   437,   438,   439,     0,     0,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,   458,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,   513,     0,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,     0,   539,   540,     0,   541,   542,
     543,   544,   545,   546,   547,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,   561,   562,   563,     0,     0,   564,   565,   566,
     567,   568,     0,     0,   569,   570,   571,   572,   573,   574,
     575,     0,   576,   577,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   229,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     230,   231,   232,   233,   234,   235,   236,   237,     0,   238,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,     0,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,   256,   257,   258,   259,
     260,     0,     0,   261,   262,   263,   264,   265,     0,   266,
     267,   268,   269,   270,     0,   271,     0,   272,   273,   274,
     275,   276,   277,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,   287,   288,   289,   290,     0,     0,
       0,   291,     0,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,     0,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,   314,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,     0,   333,     0,   334,   335,   336,
     337,     0,   338,     0,   339,   340,     0,   341,   342,   343,
     344,   345,     0,   346,   347,     0,   348,   349,   350,     0,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,     0,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,     0,     0,   388,   389,   390,   391,   392,     0,   393,
     394,   395,     0,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   427,   428,     0,   429,
     430,   431,   432,   433,   434,     0,   435,   436,     0,     0,
     437,   438,   439,     0,     0,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,   458,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,   513,     0,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,     0,   539,   540,     0,   541,   542,   543,   544,
     545,   546,   547,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
     561,   562,   563,     0,     0,   564,   565,   566,   567,   568,
       0,     0,   569,   570,   571,   572,   573,   574,   575,     0,
     576,   577,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   229,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   236,   237,     0,   238,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,     0,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,     0,   271,     0,   272,   273,   274,   275,   276,
     277,   278,   279,   280,     0,   281,   282,   283,   284,   285,
     286,     0,   287,   288,   289,   290,     0,     0,     0,   291,
       0,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   309,   310,   311,     0,     0,   312,   313,
     314,   315,   316,     0,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,     0,   333,     0,   334,   335,   336,   337,     0,
     338,     0,   339,   340,     0,   341,   342,   343,   344,   345,
       0,   346,   347,     0,   348,   349,   350,     0,   351,   352,
     353,   354,  1066,   356,   357,   358,   359,   360,     0,   361,
     362,   363,   364,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,     0,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,     0,
       0,   388,   389,   390,   391,   392,     0,   393,   394,   395,
       0,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   427,   428,     0,   429,   430,   431,
     432,   433,   434,     0,   435,   436,     0,     0,   437,   438,
     439,     0,     0,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
       0,   456,   457,   458,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,     0,   509,   510,
     511,   512,   513,     0,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
       0,   539,   540,     0,   541,   542,   543,   544,   545,   546,
     547,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,   561,   562,
     563,     0,     0,   564,   565,   566,   567,   568,     0,     0,
     569,   570,   571,   572,   573,   574,   575,     0,   576,   577,
     578,   579,   580,   581,     0,     0,   582,     0,     0,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   229,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   230,   231,   232,   233,
     234,   235,   236,   237,     0,   238,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,     0,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,   256,   257,   258,   259,   260,     0,     0,   261,
     262,   263,   264,   265,     0,   266,   267,   268,   269,   270,
       0,   271,     0,   272,   273,   274,   275,   276,   277,   278,
     279,   280,     0,   281,   282,   283,   284,   285,   286,     0,
     287,   288,   289,   290,     0,     0,     0,   291,     0,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
       0,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,   313,   314,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
       0,   333,     0,   334,   335,   336,   337,     0,   338,     0,
     339,   340,     0,   341,   342,   343,   344,   345,     0,   346,
     347,     0,   348,   349,   350,     0,   351,   352,   353,   354,
    1115,   356,   357,   358,   359,   360,     0,   361,   362,   363,
     364,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,     0,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,     0,     0,   388,
     389,   390,   391,   392,     0,   393,   394,   395,     0,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   427,   428,     0,   429,   430,   431,   432,   433,
     434,     0,   435,   436,     0,     0,   437,   438,   439,     0,
       0,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   456,
     457,   458,   459,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,     0,   509,   510,   511,   512,
     513,     0,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,     0,   539,
     540,     0,   541,   542,   543,   544,   545,   546,   547,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,     0,
       0,   564,   565,   566,   567,   568,     0,     0,   569,   570,
     571,   572,   573,   574,   575,     0,   576,   577,   578,   579,
     580,   581,     0,     0,   582,     0,     0,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   229,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
       0,     0,     0,   241,   242,     0,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,     0,   261,   262,   263,
     264,   265,     0,   266,   267,   268,   269,   270,     0,   271,
       0,   272,   273,   274,   275,   276,   277,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,   287,   288,
     289,   290,     0,     0,     0,   291,     0,     0,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,     0,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,   314,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,     0,   333,
       0,   334,   335,   336,   337,     0,   338,     0,   339,   340,
       0,   341,   342,   343,   344,   345,     0,   346,   347,     0,
     348,   349,   350,     0,   351,   352,   353,   354,  1129,   356,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,     0,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,     0,     0,   388,   389,   390,
     391,   392,     0,   393,   394,   395,     0,     0,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     427,   428,     0,   429,   430,   431,   432,   433,   434,     0,
     435,   436,     0,     0,   437,   438,   439,     0,     0,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,   458,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,     0,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,     0,   539,   540,     0,
     541,   542,   543,   544,   545,   546,   547,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,   561,   562,   563,     0,     0,   564,
     565,   566,   567,   568,     0,     0,   569,   570,   571,   572,
     573,   574,   575,     0,   576,   577,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   229,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   230,   231,   232,   233,   234,   235,   236,   237,
       0,   238,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,     0,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,     0,   261,   262,   263,   264,   265,
       0,   266,   267,   268,   269,   270,     0,   271,     0,   272,
     273,   274,   275,   276,   277,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0,   287,   288,   289,   290,
       0,     0,     0,   291,     0,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,   314,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,     0,   333,     0,   334,
     335,   336,   337,     0,   338,     0,   339,   340,     0,   341,
     342,   343,   344,   345,     0,   346,   347,     0,   348,   349,
     350,     0,   351,   352,   353,   354,  1133,   356,   357,   358,
     359,   360,     0,   361,   362,   363,   364,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,     0,     0,   388,   389,   390,   391,   392,
       0,   393,   394,   395,     0,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,   428,
       0,   429,   430,   431,   432,   433,   434,     0,   435,   436,
       0,     0,   437,   438,   439,     0,     0,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,   458,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,   513,     0,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,     0,   539,   540,     0,   541,   542,
     543,   544,   545,   546,   547,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,   561,   562,   563,     0,     0,   564,   565,   566,
     567,   568,     0,     0,   569,   570,   571,   572,   573,   574,
     575,     0,   576,   577,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   877,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     230,   231,   232,   233,   234,   235,   236,   237,     0,   238,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,     0,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,   256,   257,   258,   259,
     260,     0,     0,   261,   262,   263,   264,   265,     0,   266,
     267,   268,   269,   270,     0,   271,     0,   272,   273,   274,
     275,   276,   277,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,   287,   288,   289,   290,     0,     0,
       0,   291,     0,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,     0,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,   314,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,     0,   333,     0,   334,   335,   336,
     337,     0,   338,     0,   339,   340,     0,   341,   342,   343,
     344,   345,     0,   346,   347,     0,   348,   349,   350,     0,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,     0,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,     0,     0,   388,   389,   390,   391,   392,     0,   393,
     394,   395,     0,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   427,   428,     0,   429,
     430,   431,   432,   433,   434,     0,   435,   436,     0,     0,
     437,   438,   439,     0,     0,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,   458,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,   513,     0,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,     0,   539,   540,     0,   541,   542,   543,   544,
     545,   546,   547,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
     561,   562,   563,     0,     0,   564,   565,   566,   567,   568,
       0,     0,   569,   570,   571,   572,   573,   574,   575,     0,
     576,   577,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   610,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   236,   237,     0,   238,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,     0,
     243,   244,   245,     0,   247,   248,   249,   250,   251,     0,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,   263,   264,   265,  2223,   266,   267,   268,
     269,   270,     0,     0,  2303,   272,   273,   274,   275,   276,
       0,   278,   279,   280,  2224,   281,   282,   283,   284,   285,
     286,     0,     0,   288,   289,   290,     0,     0,     0,     0,
       0,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   309,   310,   311,     0,     0,   312,   313,
     314,   315,   316,     0,   317,   318,   319,     0,   320,   321,
     322,     0,  2304,   324,   325,   326,   327,   328,   329,   330,
     331,   332,     0,   333,     0,   334,   335,   336,   337,     0,
     338,  2226,   339,     0,     0,     0,   342,   343,   344,   345,
       0,   346,   347,     0,   348,   349,   350,     0,   351,   352,
     353,   354,  2305,     0,   357,   358,   359,   360,     0,   361,
     362,   363,   364,   365,   366,   367,     0,   368,     0,   370,
     371,   372,   373,   374,   375,   376,     0,   377,     0,   378,
       0,     0,   381,     0,   383,   384,   385,   386,   387,     0,
       0,   388,   389,     0,   391,     0,     0,   393,   394,   395,
       0,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   428,     0,   429,   430,   431,
     432,   433,   434,     0,   435,   436,     0,     0,   437,   438,
     439,     0,     0,   440,   441,   442,     0,   444,     0,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
       0,   456,   457,   458,   459,   460,   461,   462,   463,  2227,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,     0,   509,   510,
     511,   512,   513,     0,   514,   515,   516,   517,   518,     0,
     520,   521,   522,   523,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
       0,   539,   540,     0,   541,     0,   543,   544,   545,   546,
     547,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,   561,   562,
     563,     0,  2228,   564,   565,   566,   567,   568,     0,     0,
     569,   570,   571,   572,   573,   574,   575,     0,   576,     0,
     578,   579,   580,   581,     0,     0,   582,     0,     0,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   610,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   230,   231,   232,   233,
     234,   235,   236,   237,     0,   238,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,     0,   243,   244,
     245,     0,   247,   248,   249,   250,   251,     0,   253,   254,
       0,   255,   256,   257,   258,   259,   260,     0,     0,   261,
     262,   263,   264,   265,  2223,   266,   267,   268,   269,   270,
       0,     0,     0,   272,   273,   274,   275,   276,     0,   278,
     279,   280,  2224,   281,   282,   283,   284,   285,   286,     0,
       0,   288,   289,   290,     0,     0,     0,     0,     0,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
       0,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,   313,   314,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
    2304,   324,   325,   326,   327,   328,   329,   330,   331,   332,
       0,   333,     0,   334,   335,   336,   337,     0,   338,  2226,
     339,     0,     0,     0,   342,   343,   344,   345,     0,   346,
     347,     0,   348,   349,   350,     0,   351,   352,   353,   354,
     355,     0,   357,   358,   359,   360,     0,   361,   362,   363,
     364,   365,   366,   367,     0,   368,     0,   370,   371,   372,
     373,   374,   375,   376,     0,   377,     0,   378,     0,     0,
     381,     0,   383,   384,   385,   386,   387,     0,     0,   388,
     389,     0,   391,  3310,     0,   393,   394,   395,     0,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   428,     0,   429,   430,   431,   432,   433,
     434,     0,   435,   436,     0,     0,   437,   438,   439,     0,
       0,   440,   441,   442,     0,   444,     0,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   456,
     457,   458,   459,   460,   461,   462,   463,  2227,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,     0,   509,   510,   511,   512,
     513,     0,   514,   515,   516,   517,   518,     0,   520,   521,
     522,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,     0,   539,
     540,     0,   541,     0,   543,   544,   545,   546,   547,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,     0,
    2228,   564,   565,   566,   567,   568,     0,     0,   569,   570,
     571,   572,   573,   574,   575,     0,   576,     0,   578,   579,
     580,   581,     0,     0,   582,     0,     0,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   610,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   790,
     236,   237,   749,   238,   239,   240,     0,     0,     0,     0,
       0,     0,     0,   241,   242,     0,   243,   244,   245,     0,
     247,   248,   249,   250,   251,     0,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,     0,   261,   262,   263,
     264,   265,     0,   266,   267,   268,   269,   270,     0,     0,
       0,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   750,     0,   288,
     289,   290,     0,     0,     0,     0,     0,     0,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,     0,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,   314,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,     0,   333,
       0,   334,   335,   336,   337,     0,   338,     0,   339,     0,
       0,     0,   342,   343,   344,   345,   791,   346,   347,     0,
     348,   349,   350,     0,   351,   352,   353,   354,   355,     0,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,     0,   370,   371,   372,   373,   374,
     375,   376,     0,   377,     0,   378,     0,     0,   381,     0,
     383,   384,   385,   386,   387,     0,     0,   388,   389,     0,
     391,     0,     0,   393,   394,   395,     0,     0,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   428,     0,   429,   430,   431,   432,   433,   434,     0,
     435,   436,     0,     0,   437,   438,   439,     0,     0,   440,
     441,   442,     0,   444,     0,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,   458,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   751,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   752,   509,   510,   511,   512,   513,     0,
     514,   515,   516,   517,   518,     0,   520,   521,   522,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,     0,   539,   540,     0,
     541,     0,   543,   544,   545,   546,   547,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,   561,   562,   563,     0,     0,   564,
     565,   566,   567,   568,     0,     0,   569,   570,   571,   572,
     573,   574,   575,     0,   576,     0,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   610,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   230,   231,   232,   233,   234,   235,   236,   237,
     749,   238,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,     0,   243,   244,   245,     0,   247,   248,
     249,   250,   251,     0,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,     0,   261,   262,   263,   264,   265,
       0,   266,   267,   268,   269,   270,     0,     0,     0,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   750,     0,   288,   289,   290,
       0,     0,     0,     0,     0,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,   314,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,     0,   333,     0,   334,
     335,   336,   337,     0,   338,     0,   339,     0,     0,     0,
     342,   343,   344,   345,  2989,   346,   347,     0,   348,   349,
     350,     0,   351,   352,   353,   354,   355,     0,   357,   358,
     359,   360,     0,   361,   362,   363,   364,   365,   366,   367,
       0,   368,     0,   370,   371,   372,   373,   374,   375,   376,
       0,   377,     0,   378,     0,     0,   381,     0,   383,   384,
     385,   386,   387,     0,     0,   388,   389,     0,   391,     0,
       0,   393,   394,   395,     0,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   428,
       0,   429,   430,   431,   432,   433,   434,     0,   435,   436,
       0,     0,   437,   438,   439,     0,     0,   440,   441,   442,
       0,   444,     0,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,   458,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   751,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   752,   509,   510,   511,   512,   513,     0,   514,   515,
     516,   517,   518,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,     0,   539,   540,     0,   541,     0,
     543,   544,   545,   546,   547,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,   561,   562,   563,     0,     0,   564,   565,   566,
     567,   568,     0,     0,   569,   570,   571,   572,   573,   574,
     575,     0,   576,     0,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   610,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     230,   231,   232,   233,   234,   235,   236,   237,     0,   238,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,     0,   243,   244,   245,     0,   247,   248,   249,   250,
     251,     0,   253,   254,     0,   255,   256,   257,   258,   259,
     260,     0,     0,   261,   262,   263,   264,   265,  2223,   266,
     267,   268,   269,   270,     0,     0,     0,   272,   273,   274,
     275,   276,     0,   278,   279,   280,  2224,   281,   282,   283,
     284,   285,   286,     0,     0,   288,   289,   290,     0,     0,
       0,     0,     0,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,     0,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,   314,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,  2304,   324,   325,   326,   327,   328,
     329,   330,   331,   332,     0,   333,     0,   334,   335,   336,
     337,     0,   338,  2226,   339,     0,     0,     0,   342,   343,
     344,   345,     0,   346,   347,     0,   348,   349,   350,     0,
     351,   352,   353,   354,   355,     0,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
       0,   370,   371,   372,   373,   374,   375,   376,     0,   377,
       0,   378,     0,     0,   381,     0,   383,   384,   385,   386,
     387,     0,     0,   388,   389,     0,   391,     0,     0,   393,
     394,   395,     0,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   428,     0,   429,
     430,   431,   432,   433,   434,     0,   435,   436,     0,     0,
     437,   438,   439,     0,     0,   440,   441,   442,     0,   444,
       0,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,   458,   459,   460,   461,   462,
     463,  2227,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,   513,     0,   514,   515,   516,   517,
     518,     0,   520,   521,   522,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,     0,   539,   540,     0,   541,     0,   543,   544,
     545,   546,   547,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
     561,   562,   563,     0,  2228,   564,   565,   566,   567,   568,
       0,     0,   569,   570,   571,   572,   573,   574,   575,     0,
     576,     0,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   610,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   236,   237,   749,   238,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,     0,
     243,   244,   245,     0,   247,   248,   249,   250,   251,     0,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,     0,     0,     0,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   750,     0,   288,   289,   290,     0,     0,     0,     0,
       0,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   309,   310,   311,     0,     0,   312,   313,
     314,   315,   316,     0,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,     0,   333,     0,   334,   335,   336,   337,     0,
     338,     0,   339,     0,     0,     0,   342,   343,   344,   345,
       0,   346,   347,     0,   348,   349,   350,     0,   351,   352,
     353,   354,   355,     0,   357,   358,   359,   360,     0,   361,
     362,   363,   364,   365,   366,   367,     0,   368,     0,   370,
     371,   372,   373,   374,   375,   376,     0,   377,     0,   378,
       0,     0,   381,     0,   383,   384,   385,   386,   387,     0,
       0,   388,   389,     0,   391,     0,     0,   393,   394,   395,
       0,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   428,     0,   429,   430,   431,
     432,   433,   434,     0,   435,   436,     0,     0,   437,   438,
     439,     0,     0,   440,   441,   442,     0,   444,     0,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
       0,   456,   457,   458,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   751,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   752,   509,   510,
     511,   512,   513,     0,   514,   515,   516,   517,   518,     0,
     520,   521,   522,   523,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
       0,   539,   540,     0,   541,     0,   543,   544,   545,   546,
     547,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,   561,   562,
     563,     0,     0,   564,   565,   566,   567,   568,     0,     0,
     569,   570,   571,   572,   573,   574,   575,     0,   576,     0,
     578,   579,   580,   581,     0,     0,   582,     0,     0,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   610,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   230,   231,   232,   233,
     234,   235,   236,   237,  1957,   238,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,     0,   243,   244,
     245,     0,   247,   248,   249,   250,   251,     0,   253,   254,
       0,   255,   256,   257,   258,   259,   260,     0,     0,   261,
     262,   263,   264,   265,     0,   266,   267,   268,   269,   270,
       0,     0,     0,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,   281,   282,   283,   284,   285,   286,     0,
       0,   288,   289,   290,     0,     0,     0,     0,     0,     0,
       0,   292,   293,   294,  1958,   296,   297,   298,   299,   300,
       0,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,  1959,   314,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
       0,   333,     0,   334,   335,   336,   337,     0,   338,  1960,
     339,     0,     0,     0,  1961,   343,   344,   345,     0,   346,
     347,     0,   348,   349,   350,     0,   351,   352,   353,   354,
     355,     0,   357,   358,   359,   360,     0,   361,   362,   363,
     364,   365,   366,   367,     0,   368,     0,   370,   371,   372,
     373,   374,   375,   376,     0,   377,     0,   378,     0,     0,
     381,     0,   383,   384,  1962,  1963,   387,     0,     0,   388,
     389,     0,   391,     0,     0,   393,   394,   395,     0,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   428,     0,   429,   430,   431,   432,   433,
     434,     0,   435,   436,     0,     0,   437,   438,   439,     0,
       0,   440,   441,   442,     0,   444,     0,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   456,
     457,   458,   459,   460,   461,   462,   463,     0,   464,   465,
     466,  1964,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,     0,
     494,   495,   496,  1965,   498,   499,   500,   501,   502,  1966,
     504,   505,   506,   507,   508,     0,  1967,   510,   511,   512,
     513,     0,   514,   515,   516,   517,   518,     0,   520,   521,
     522,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,     0,   539,
     540,  1968,   541,     0,  1969,   544,   545,   546,   547,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
       0,   556,   557,  1970,   559,   560,   561,   562,   563,     0,
       0,   564,   565,   566,   567,   568,     0,     0,   569,   570,
     571,   572,   573,   574,   575,     0,   576,     0,   578,   579,
     580,   581,     0,     0,   582,     0,     0,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   610,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
       0,     0,     0,   241,   242,     0,   243,   244,   245,     0,
     247,   248,   249,   250,   251,     0,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,     0,   261,   262,   263,
     264,   265,     0,   266,   267,   268,   269,   270,     0,     0,
       0,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   750,     0,   288,
     289,   290,     0,     0,     0,     0,     0,     0,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,     0,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,   314,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,     0,   333,
       0,   334,   335,   336,   337,     0,   338,     0,   339,     0,
       0,     0,   342,   343,   344,   345,     0,   346,   347,     0,
     348,   349,   350,     0,   351,   352,   353,   354,   355,     0,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,     0,   370,   371,   372,   373,   374,
     375,   376,     0,   377,     0,   378,     0,     0,   381,     0,
     383,   384,   385,   386,   387,     0,     0,   388,   389,     0,
     391,     0,     0,   393,   394,   395,     0,     0,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   428,     0,   429,   430,   431,   432,   433,   434,     0,
     435,   436,     0,     0,   437,   438,   439,     0,     0,   440,
     441,   442,     0,   444,     0,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,   458,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   751,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   752,   509,   510,   511,   512,   513,     0,
     514,   515,   516,   517,   518,     0,   520,   521,   522,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,     0,   539,   540,     0,
     541,     0,   543,   544,   545,   546,   547,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,   561,   562,   563,     0,     0,   564,
     565,   566,   567,   568,     0,     0,   569,   570,   571,   572,
     573,   574,   575,     0,   576,     0,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   610,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   230,   231,   232,   233,   234,   235,   236,   237,
     929,   238,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,     0,   243,   244,   245,     0,   247,   248,
     249,   250,   251,     0,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,     0,   261,   262,   263,   264,   265,
       0,   266,   267,   268,   269,   270,     0,     0,     0,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0,     0,   288,   289,   290,
       0,     0,     0,     0,     0,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,   314,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,     0,   333,     0,   334,
     335,   336,   337,     0,   338,     0,   339,     0,     0,     0,
     342,   343,   344,   345,     0,   346,   347,     0,   348,   349,
     350,     0,   351,   352,   353,   354,   930,     0,   357,   358,
     359,   360,     0,   361,   362,   363,   364,   365,   366,   367,
       0,   368,     0,   370,   371,   372,   373,   374,   375,   376,
       0,   377,     0,   378,     0,     0,   381,     0,   383,   384,
     385,   386,   387,     0,     0,   388,   389,     0,   391,     0,
       0,   393,   394,   395,     0,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   428,
       0,   429,   430,   431,   432,   433,   434,     0,   435,   436,
       0,   822,   437,   438,   439,     0,     0,   440,   441,   442,
       0,   444,     0,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,   458,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,   513,     0,   514,   515,
     516,   517,   518,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,     0,   539,   540,     0,   541,     0,
     543,   544,   545,   546,   547,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,   561,   562,   563,     0,     0,   564,   565,   566,
     567,   568,     0,     0,   569,   570,   571,   572,   573,   574,
     575,     0,   576,     0,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   610,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     230,   231,   232,   233,   234,   235,   236,   237,  3080,   238,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,     0,   243,   244,   245,     0,   247,   248,   249,   250,
     251,     0,   253,   254,     0,   255,   256,   257,   258,   259,
     260,     0,     0,   261,   262,   263,   264,   265,     0,   266,
     267,   268,   269,   270,     0,     0,     0,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,     0,   288,   289,   290,     0,     0,
       0,     0,     0,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,     0,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,   314,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,     0,   333,     0,   334,   335,   336,
     337,     0,   338,     0,   339,     0,     0,     0,   342,   343,
     344,   345,     0,   346,   347,     0,   348,   349,   350,     0,
     351,   352,   353,   354,   355,     0,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
       0,   370,   371,   372,   373,   374,   375,   376,     0,   377,
       0,   378,     0,     0,   381,     0,   383,   384,   385,   386,
     387,     0,     0,   388,   389,     0,   391,     0,     0,   393,
     394,   395,     0,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   428,     0,   429,
     430,   431,   432,   433,   434,     0,   435,   436,     0,     0,
     437,   438,   439,     0,     0,   440,   441,   442,     0,   444,
       0,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,   458,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,   513,     0,   514,   515,   516,   517,
     518,     0,   520,   521,   522,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,     0,   539,   540,     0,   541,     0,   543,   544,
     545,   546,   547,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
     561,   562,   563,     0,     0,   564,   565,   566,   567,   568,
    3081,     0,   569,   570,   571,   572,   573,   574,   575,     0,
     576,     0,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   610,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   236,   237,  3093,   238,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,     0,
     243,   244,   245,     0,   247,   248,   249,   250,   251,     0,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,     0,     0,     0,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,   281,   282,   283,   284,   285,
     286,     0,     0,   288,   289,   290,     0,     0,     0,     0,
       0,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   309,   310,   311,     0,     0,   312,   313,
     314,   315,   316,     0,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,     0,   333,     0,   334,   335,   336,   337,     0,
     338,     0,   339,     0,     0,     0,   342,   343,   344,   345,
       0,   346,   347,     0,   348,   349,   350,     0,   351,   352,
     353,   354,   355,     0,   357,   358,   359,   360,     0,   361,
     362,   363,   364,   365,   366,   367,     0,   368,     0,   370,
     371,   372,   373,   374,   375,   376,     0,   377,     0,   378,
       0,     0,   381,     0,   383,   384,   385,   386,   387,     0,
       0,   388,   389,     0,   391,     0,     0,   393,   394,   395,
       0,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   428,     0,   429,   430,   431,
     432,   433,   434,     0,   435,   436,     0,     0,   437,   438,
     439,     0,     0,   440,   441,   442,     0,   444,     0,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
       0,   456,   457,   458,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,     0,   509,   510,
     511,   512,   513,     0,   514,   515,   516,   517,   518,     0,
     520,   521,   522,   523,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
       0,   539,   540,     0,   541,     0,   543,   544,   545,   546,
     547,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,   561,   562,
     563,     0,     0,   564,   565,   566,   567,   568,  3094,     0,
     569,   570,   571,   572,   573,   574,   575,     0,   576,     0,
     578,   579,   580,   581,     0,     0,   582,     0,     0,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   610,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   230,   231,   232,   233,
     234,   235,   236,   237,   611,   238,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,     0,   243,   244,
     245,     0,   247,   248,   249,   250,   251,     0,   253,   254,
       0,   255,   256,   257,   258,   259,   260,     0,     0,   261,
     262,   263,   264,   265,     0,   266,   267,   268,   269,   270,
       0,     0,     0,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,   281,   282,   283,   284,   285,   286,     0,
       0,   288,   289,   290,     0,     0,     0,     0,     0,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
       0,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,   313,   314,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
       0,   333,     0,   334,   335,   336,   337,     0,   338,     0,
     339,     0,     0,     0,   342,   343,   344,   345,     0,   346,
     347,     0,   348,   349,   350,     0,   351,   352,   353,   354,
     355,     0,   357,   358,   359,   360,     0,   361,   362,   363,
     364,   365,   366,   367,     0,   368,     0,   370,   371,   372,
     373,   374,   375,   376,     0,   377,     0,   378,     0,     0,
     381,     0,   383,   384,   385,   386,   387,     0,     0,   388,
     389,     0,   391,     0,     0,   393,   394,   395,     0,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   428,     0,   429,   430,   431,   432,   433,
     434,     0,   435,   436,     0,     0,   437,   438,   439,     0,
       0,   440,   441,   442,     0,   444,     0,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   456,
     457,   458,   459,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,     0,   509,   510,   511,   512,
     513,     0,   514,   515,   516,   517,   518,     0,   520,   521,
     522,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,     0,   539,
     540,     0,   541,     0,   543,   544,   545,   546,   547,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,     0,
       0,   564,   565,   566,   567,   568,     0,     0,   569,   570,
     571,   572,   573,   574,   575,     0,   576,     0,   578,   579,
     580,   581,     0,     0,   582,     0,     0,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   610,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,   661,   238,   239,   240,     0,     0,     0,     0,
       0,     0,     0,   241,   242,     0,   243,   244,   245,     0,
     247,   248,   249,   250,   251,     0,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,     0,   261,   262,   263,
     264,   265,     0,   266,   267,   268,   269,   270,     0,     0,
       0,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,     0,   288,
     289,   290,     0,     0,     0,     0,     0,     0,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,     0,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,   314,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,     0,   333,
       0,   334,   335,   336,   337,     0,   338,     0,   339,     0,
       0,     0,   342,   343,   344,   345,     0,   346,   347,     0,
     348,   349,   350,     0,   351,   352,   353,   354,   355,     0,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,     0,   370,   371,   372,   373,   374,
     375,   376,     0,   377,     0,   378,     0,     0,   381,     0,
     383,   384,   385,   386,   387,     0,     0,   388,   389,     0,
     391,     0,     0,   393,   394,   395,     0,     0,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   428,     0,   429,   430,   431,   432,   433,   434,     0,
     435,   436,     0,     0,   437,   438,   439,     0,     0,   440,
     441,   442,     0,   444,     0,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,   458,
     459,   460,   461,   662,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,     0,
     514,   515,   516,   517,   518,     0,   520,   521,   522,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,     0,   539,   540,     0,
     541,     0,   543,   544,   545,   546,   547,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,   561,   562,   563,     0,     0,   564,
     565,   566,   567,   568,     0,     0,   569,   570,   571,   572,
     573,   574,   575,     0,   576,     0,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   610,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   230,   231,   232,   233,   234,   235,   236,   237,
     782,   238,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,     0,   243,   244,   245,     0,   247,   248,
     249,   250,   251,     0,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,     0,   261,   262,   263,   264,   265,
       0,   266,   267,   268,   269,   270,     0,     0,     0,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0,     0,   288,   289,   290,
       0,     0,     0,     0,     0,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,   314,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,     0,   333,     0,   334,
     335,   336,   337,     0,   338,     0,   339,     0,     0,     0,
     342,   343,   344,   345,     0,   346,   347,     0,   348,   349,
     350,     0,   351,   352,   353,   354,   355,     0,   357,   358,
     359,   360,     0,   361,   362,   363,   364,   365,   366,   367,
       0,   368,     0,   370,   371,   372,   373,   374,   375,   376,
       0,   377,     0,   378,     0,     0,   381,     0,   383,   384,
     385,   386,   387,     0,     0,   388,   389,     0,   391,     0,
       0,   393,   394,   395,     0,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   428,
       0,   429,   430,   431,   432,   433,   434,     0,   435,   436,
       0,     0,   437,   438,   439,     0,     0,   440,   441,   442,
       0,   444,     0,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,   458,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,   783,     0,   514,   515,
     516,   517,   518,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,     0,   539,   540,     0,   541,     0,
     543,   544,   545,   546,   547,     0,   548,   784,   550,     0,
       0,   785,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,   561,   562,   563,     0,     0,   564,   565,   566,
     567,   568,     0,     0,   569,   570,   571,   572,   573,   574,
     575,     0,   576,     0,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   610,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     230,   231,   232,   233,   234,   235,   236,   237,   816,   238,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,     0,   243,   244,   245,     0,   247,   248,   249,   250,
     251,     0,   253,   254,     0,   255,   256,   257,   258,   259,
     260,     0,     0,   261,   262,   263,   264,   265,     0,   266,
     267,   268,   269,   270,     0,     0,     0,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,     0,   288,   289,   290,     0,     0,
       0,     0,     0,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,     0,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,   314,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,     0,   333,     0,   334,   335,   336,
     337,     0,   338,     0,   339,     0,     0,     0,   342,   343,
     344,   345,     0,   346,   347,     0,   348,   349,   350,     0,
     351,   352,   353,   354,   355,     0,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
       0,   370,   371,   372,   373,   374,   375,   376,     0,   377,
       0,   378,     0,     0,   381,     0,   383,   384,   385,   386,
     387,     0,     0,   388,   389,     0,   391,     0,     0,   393,
     394,   395,     0,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   428,     0,   429,
     430,   431,   432,   433,   434,     0,   435,   436,     0,     0,
     437,   438,   439,     0,     0,   440,   441,   442,     0,   444,
       0,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,   458,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,   817,     0,   514,   515,   516,   517,
     518,     0,   520,   521,   522,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,     0,   539,   540,     0,   541,     0,   543,   544,
     545,   546,   547,     0,   548,   818,   550,     0,     0,   819,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
     561,   562,   563,     0,     0,   564,   565,   566,   567,   568,
       0,     0,   569,   570,   571,   572,   573,   574,   575,     0,
     576,     0,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   610,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   236,   237,     0,   238,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,     0,
     243,   244,   245,     0,   247,   248,   249,   250,   251,     0,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,     0,     0,     0,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,   281,   282,   283,   284,   285,
     286,     0,     0,   288,   289,   290,     0,     0,     0,     0,
       0,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   309,   310,   311,     0,     0,   312,   313,
     314,   315,   316,     0,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,     0,   333,     0,   334,   335,   336,   337,     0,
     338,     0,   339,     0,     0,     0,   342,   343,   344,   345,
       0,   346,   347,     0,   348,   349,   350,     0,   351,   352,
     353,   354,   355,     0,   357,   358,   359,   360,     0,   361,
     362,   363,   364,   365,   366,   367,     0,   368,     0,   370,
     371,   372,   373,   374,   375,   376,     0,   377,     0,   378,
       0,     0,   381,     0,   383,   384,   385,   386,   387,     0,
       0,   388,   389,     0,   391,     0,     0,   393,   394,   395,
       0,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   428,     0,   429,   430,   431,
     432,   433,   434,     0,   435,   436,     0,   822,   437,   438,
     439,     0,     0,   440,   441,   442,     0,   444,     0,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
       0,   456,   457,   458,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,     0,   509,   510,
     511,   512,   513,     0,   514,   515,   516,   517,   518,     0,
     520,   521,   522,   523,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
       0,   539,   540,     0,   541,     0,   543,   544,   545,   546,
     547,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,   561,   562,
     563,     0,     0,   564,   565,   566,   567,   568,     0,     0,
     569,   570,   571,   572,   573,   574,   575,     0,   576,     0,
     578,   579,   580,   581,     0,     0,   582,     0,     0,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   610,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   230,   231,   232,   233,
     234,   235,   236,   237,   886,   238,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,     0,   243,   244,
     245,     0,   247,   248,   249,   250,   251,     0,   253,   254,
       0,   255,   256,   257,   258,   259,   260,     0,     0,   261,
     262,   263,   264,   265,     0,   266,   267,   268,   269,   270,
       0,     0,     0,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,   281,   282,   283,   284,   285,   286,     0,
       0,   288,   289,   290,     0,     0,     0,     0,     0,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
       0,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,   313,   314,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
       0,   333,     0,   334,   335,   336,   337,     0,   338,     0,
     339,     0,     0,     0,   342,   343,   344,   345,     0,   346,
     347,     0,   348,   349,   350,     0,   351,   352,   353,   354,
     887,     0,   357,   358,   359,   360,     0,   361,   362,   363,
     364,   365,   366,   367,     0,   368,     0,   370,   371,   372,
     373,   374,   375,   376,     0,   377,     0,   378,     0,     0,
     381,     0,   383,   384,   385,   386,   387,     0,     0,   388,
     389,     0,   391,     0,     0,   393,   394,   395,     0,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   428,     0,   429,   430,   431,   432,   433,
     434,     0,   435,   436,     0,     0,   437,   438,   439,     0,
       0,   440,   441,   442,     0,   444,     0,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   456,
     457,   458,   459,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,     0,   509,   510,   511,   512,
     513,     0,   514,   515,   516,   517,   518,     0,   520,   521,
     522,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,     0,   539,
     540,     0,   541,     0,   543,   544,   545,   546,   547,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,     0,
       0,   564,   565,   566,   567,   568,     0,     0,   569,   570,
     571,   572,   573,   574,   575,     0,   576,     0,   578,   579,
     580,   581,     0,     0,   582,     0,     0,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   610,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,  1058,   238,   239,   240,     0,     0,     0,     0,
       0,     0,     0,   241,   242,     0,   243,   244,   245,     0,
     247,   248,   249,   250,   251,     0,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,     0,   261,   262,   263,
     264,   265,     0,   266,   267,   268,   269,   270,     0,     0,
       0,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,     0,   288,
     289,   290,     0,     0,     0,     0,     0,     0,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,     0,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,   314,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,     0,   333,
       0,   334,   335,   336,   337,     0,   338,     0,   339,     0,
       0,     0,   342,   343,   344,   345,     0,   346,   347,     0,
     348,   349,   350,     0,   351,   352,   353,   354,   355,     0,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,     0,   370,   371,   372,   373,   374,
     375,   376,     0,   377,     0,   378,     0,     0,   381,     0,
     383,   384,   385,   386,   387,     0,     0,   388,   389,     0,
     391,     0,     0,   393,   394,   395,     0,     0,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   428,     0,   429,   430,   431,   432,   433,   434,     0,
     435,   436,     0,     0,   437,   438,   439,     0,     0,   440,
     441,   442,     0,   444,     0,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,   458,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,     0,
     514,   515,   516,   517,   518,     0,   520,   521,   522,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,     0,   539,   540,     0,
     541,     0,   543,   544,   545,   546,   547,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,   561,   562,   563,     0,     0,   564,
     565,   566,   567,   568,     0,     0,   569,   570,   571,   572,
     573,   574,   575,     0,   576,     0,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   610,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   230,   231,   232,   233,   234,   235,   236,   237,
     782,   238,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,     0,   243,   244,   245,     0,   247,   248,
     249,   250,   251,     0,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,     0,   261,   262,   263,   264,   265,
       0,   266,   267,   268,   269,   270,     0,     0,     0,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0,     0,   288,   289,   290,
       0,     0,     0,     0,     0,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,   314,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,     0,   333,     0,   334,
     335,   336,   337,     0,   338,     0,   339,     0,     0,     0,
     342,   343,   344,   345,     0,   346,   347,     0,   348,   349,
     350,     0,   351,   352,   353,   354,   355,     0,   357,   358,
     359,   360,     0,   361,   362,   363,   364,   365,   366,   367,
       0,   368,     0,   370,   371,   372,   373,   374,   375,   376,
       0,   377,     0,   378,     0,     0,   381,     0,   383,   384,
     385,   386,   387,     0,     0,   388,   389,     0,   391,     0,
       0,   393,   394,   395,     0,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   428,
       0,   429,   430,   431,   432,   433,   434,     0,   435,   436,
       0,     0,   437,   438,   439,     0,     0,   440,   441,   442,
       0,   444,     0,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,   458,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,   513,     0,   514,   515,
     516,   517,   518,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,     0,   539,   540,     0,   541,     0,
     543,   544,   545,   546,   547,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,   561,   562,   563,     0,     0,   564,   565,   566,
     567,   568,     0,     0,   569,   570,   571,   572,   573,   574,
     575,     0,   576,     0,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   610,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     230,   231,   232,   233,   234,   235,   236,   237,  1203,   238,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,     0,   243,   244,   245,     0,   247,   248,   249,   250,
     251,     0,   253,   254,     0,   255,   256,   257,   258,   259,
     260,     0,     0,   261,   262,   263,   264,   265,     0,   266,
     267,   268,   269,   270,     0,     0,     0,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,     0,   288,   289,   290,     0,     0,
       0,     0,     0,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,     0,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,   314,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,     0,   333,     0,   334,   335,   336,
     337,     0,   338,     0,   339,     0,     0,     0,   342,   343,
     344,   345,     0,   346,   347,     0,   348,   349,   350,     0,
     351,   352,   353,   354,   355,     0,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
       0,   370,   371,   372,   373,   374,   375,   376,     0,   377,
       0,   378,     0,     0,   381,     0,   383,   384,   385,   386,
     387,     0,     0,   388,   389,     0,   391,     0,     0,   393,
     394,   395,     0,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   428,     0,   429,
     430,   431,   432,   433,   434,     0,   435,   436,     0,     0,
     437,   438,   439,     0,     0,   440,   441,   442,     0,   444,
       0,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,   458,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,   513,     0,   514,   515,   516,   517,
     518,     0,   520,   521,   522,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,     0,   539,   540,     0,   541,     0,   543,   544,
     545,   546,   547,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
     561,   562,   563,     0,     0,   564,   565,   566,   567,   568,
       0,     0,   569,   570,   571,   572,   573,   574,   575,     0,
     576,     0,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   610,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   236,   237,  1336,   238,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,     0,
     243,   244,   245,     0,   247,   248,   249,   250,   251,     0,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,     0,     0,     0,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,   281,   282,   283,   284,   285,
     286,     0,     0,   288,   289,   290,     0,     0,     0,     0,
       0,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   309,   310,   311,     0,     0,   312,   313,
     314,   315,   316,     0,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,     0,   333,     0,   334,   335,   336,   337,     0,
     338,     0,   339,     0,     0,     0,   342,   343,   344,   345,
       0,   346,   347,     0,   348,   349,   350,     0,   351,   352,
     353,   354,   355,     0,   357,   358,   359,   360,     0,   361,
     362,   363,   364,   365,   366,   367,     0,   368,     0,   370,
     371,   372,   373,   374,   375,   376,     0,   377,     0,   378,
       0,     0,   381,     0,   383,   384,   385,   386,   387,     0,
       0,   388,   389,     0,   391,     0,     0,   393,   394,   395,
       0,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   428,     0,   429,   430,   431,
     432,   433,   434,     0,   435,   436,     0,     0,   437,   438,
     439,     0,     0,   440,   441,   442,     0,   444,     0,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
       0,   456,   457,   458,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,     0,   509,   510,
     511,   512,   513,     0,   514,   515,   516,   517,   518,     0,
     520,   521,   522,   523,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
       0,   539,   540,     0,   541,     0,   543,   544,   545,   546,
     547,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,   561,   562,
     563,     0,     0,   564,   565,   566,   567,   568,     0,     0,
     569,   570,   571,   572,   573,   574,   575,     0,   576,     0,
     578,   579,   580,   581,     0,     0,   582,     0,     0,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   610,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   230,   231,   232,   233,
     234,   235,   236,   237,     0,   238,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,     0,   243,   244,
     245,  1347,   247,   248,   249,   250,   251,     0,   253,   254,
       0,   255,   256,   257,   258,   259,   260,     0,     0,   802,
     262,   263,   264,  1348,     0,   266,   267,   268,   269,   270,
       0,     0,     0,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,   281,   282,   283,   284,   285,   286,     0,
       0,   288,   289,   290,     0,     0,     0,     0,     0,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
       0,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,   313,   314,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
       0,   333,     0,   334,   335,   336,   337,     0,   338,     0,
     339,     0,     0,     0,   342,   343,   344,   345,     0,   346,
     347,     0,   348,   349,   350,     0,   351,   352,   353,   354,
     355,     0,   357,   358,   359,   360,     0,   361,   362,   363,
     364,   365,   366,   367,     0,   368,     0,   370,   371,   372,
     373,   374,   375,   376,     0,   377,     0,   378,     0,     0,
     381,     0,   383,   384,   385,   386,   387,     0,     0,   388,
     389,     0,   391,     0,     0,   393,   394,   395,     0,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   805,   412,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   428,     0,   429,   430,   431,   432,   433,
     434,     0,   435,   436,     0,     0,   437,   438,   439,     0,
       0,   440,   441,   442,     0,   444,     0,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   456,
     457,   458,   459,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,     0,
     806,   495,   496,   497,   498,   499,   500,   501,   502,   807,
     504,   505,   506,   507,   508,     0,   509,   510,   511,   512,
    1340,     0,   514,   515,   516,   517,   518,     0,   520,   521,
     522,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,     0,   539,
     540,     0,   541,     0,   543,   544,   545,   546,   547,     0,
     548,   809,   550,     0,     0,   810,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,     0,
       0,   564,   565,   566,   567,   568,     0,     0,   569,   570,
     571,   572,   573,   574,   575,     0,   576,     0,   578,   579,
     580,   581,     0,     0,   582,     0,     0,   583,   584,   585,
     586,   587,   811,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   610,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
       0,     0,     0,   241,   242,     0,   243,   244,   245,     0,
     247,   248,   249,   250,   251,     0,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,     0,   261,   262,   263,
     264,   265,     0,   266,   267,   268,   269,   270,     0,     0,
       0,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,     0,   288,
     289,   290,     0,     0,     0,     0,     0,     0,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,     0,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,   314,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,     0,   333,
       0,   334,   335,   336,   337,     0,   338,     0,   339,     0,
       0,     0,   342,   343,   344,   345,     0,   346,   347,     0,
     348,   349,   350,     0,   351,   352,   353,   354,  1459,     0,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,     0,   370,   371,   372,   373,   374,
     375,   376,     0,   377,     0,   378,     0,     0,   381,     0,
     383,   384,   385,   386,   387,     0,     0,   388,   389,     0,
     391,     0,     0,   393,   394,   395,     0,     0,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   428,     0,   429,   430,   431,   432,   433,   434,     0,
     435,   436,     0,   822,   437,   438,   439,     0,     0,   440,
     441,   442,     0,   444,     0,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,   458,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,     0,
     514,   515,   516,   517,   518,     0,   520,   521,   522,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,     0,   539,   540,     0,
     541,     0,   543,   544,   545,   546,   547,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,   561,   562,   563,     0,     0,   564,
     565,   566,   567,   568,     0,     0,   569,   570,   571,   572,
     573,   574,   575,     0,   576,     0,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   610,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   230,   231,   232,   233,   234,   235,   236,   237,
    1520,   238,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,     0,   243,   244,   245,     0,   247,   248,
     249,   250,   251,     0,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,     0,   261,   262,   263,   264,   265,
       0,   266,   267,   268,   269,   270,     0,     0,     0,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0,     0,   288,   289,   290,
       0,     0,     0,     0,     0,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,   314,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,     0,   333,     0,   334,
     335,   336,   337,     0,   338,     0,   339,     0,     0,     0,
     342,   343,   344,   345,     0,   346,   347,     0,   348,   349,
     350,     0,   351,   352,   353,   354,  1521,     0,   357,   358,
     359,   360,     0,   361,   362,   363,   364,   365,   366,   367,
       0,   368,     0,   370,   371,   372,   373,   374,   375,   376,
       0,   377,     0,   378,     0,     0,   381,     0,   383,   384,
     385,   386,   387,     0,     0,   388,   389,     0,   391,     0,
       0,   393,   394,   395,     0,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   428,
       0,   429,   430,   431,   432,   433,   434,     0,   435,   436,
       0,     0,   437,   438,   439,     0,     0,   440,   441,   442,
       0,   444,     0,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,   458,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,   513,     0,   514,   515,
     516,   517,   518,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,     0,   539,   540,     0,   541,     0,
     543,   544,   545,   546,   547,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,   561,   562,   563,     0,     0,   564,   565,   566,
     567,   568,     0,     0,   569,   570,   571,   572,   573,   574,
     575,     0,   576,     0,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   610,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     230,   231,   232,   233,   234,   235,   236,   237,     0,   238,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,     0,   243,   244,   245,     0,   247,   248,   249,   250,
     251,     0,   253,   254,     0,   255,   256,   257,   258,   259,
     260,     0,     0,   261,   262,   263,   264,   265,     0,   266,
     267,   268,   269,   270,     0,     0,     0,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,     0,   288,   289,   290,     0,     0,
       0,     0,     0,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,     0,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,   314,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,     0,   333,     0,   334,   335,   336,
     337,     0,   338,     0,   339,     0,     0,     0,   342,   343,
     344,  2879,     0,   346,   347,     0,   348,   349,   350,     0,
     351,   352,   353,   354,   355,     0,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
       0,   370,   371,   372,   373,   374,   375,   376,     0,   377,
       0,   378,     0,     0,   381,     0,   383,   384,   385,   386,
     387,     0,     0,   388,   389,     0,   391,     0,     0,   393,
     394,  2880,     0,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   428,     0,   429,
     430,   431,   432,   433,   434,     0,   435,   436,     0,     0,
     437,   438,   439,     0,     0,   440,   441,   442,     0,   444,
       0,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,   458,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,   513,     0,   514,   515,   516,   517,
     518,     0,   520,   521,   522,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,     0,   539,   540,  2881,   541,     0,   543,  2882,
     545,  2883,   547,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
     561,   562,   563,     0,     0,   564,   565,  2884,   567,   568,
       0,     0,   569,   570,   571,   572,   573,   574,   575,     0,
     576,     0,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   610,     0,     0,   670,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   236,   237,     0,   238,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,     0,
     243,   244,   245,     0,   247,   248,   249,   250,   251,     0,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,     0,     0,     0,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,   281,   282,   283,   284,   285,
     286,     0,     0,   288,   289,   290,     0,     0,     0,     0,
       0,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   309,   310,   311,     0,     0,   312,   313,
     314,   315,   316,     0,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,     0,   333,     0,   334,   335,   336,   337,     0,
     338,     0,   339,     0,     0,     0,   342,   343,   344,   345,
       0,   346,   347,     0,   348,   349,   350,     0,   351,   352,
     353,   354,   355,     0,   357,   358,   359,   360,     0,   361,
     362,   363,   364,   365,   366,   367,     0,   368,     0,   370,
     371,   372,   373,   374,   375,   376,     0,   377,     0,   378,
       0,     0,   381,     0,   383,   384,   385,   386,   387,     0,
       0,   388,   389,     0,   391,     0,     0,   393,   394,   395,
       0,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   428,     0,   429,   430,   431,
     432,   433,   434,     0,   435,   436,     0,     0,   437,   438,
     439,     0,     0,   440,   441,   442,     0,   444,     0,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
       0,   456,   457,   458,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,     0,   509,   510,
     511,   512,   513,     0,   514,   515,   516,   517,   518,     0,
     520,   521,   522,   523,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
       0,   539,   540,     0,   541,     0,   543,   544,   545,   546,
     547,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,   561,   562,
     563,     0,     0,   564,   565,   566,   567,   568,     0,     0,
     569,   570,   571,   572,   573,   574,   575,     0,   576,     0,
     578,   579,   580,   581,     0,     0,   582,     0,     0,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   610,
       0,     0,     0,     0,     0,     0,     0,   730,     0,     0,
       0,     0,     0,     0,     0,     0,   230,   231,   232,   233,
     234,   235,   236,   237,     0,   238,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,     0,   243,   244,
     245,     0,   247,   248,   249,   250,   251,     0,   253,   254,
       0,   255,   256,   257,   258,   259,   260,     0,     0,   261,
     262,   263,   264,   265,     0,   266,   267,   268,   269,   270,
       0,     0,     0,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,   281,   282,   283,   284,   285,   286,     0,
       0,   288,   289,   290,     0,     0,     0,     0,     0,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
       0,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,   313,   314,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
       0,   333,     0,   334,   335,   336,   337,     0,   338,     0,
     339,     0,     0,     0,   342,   343,   344,   345,     0,   346,
     347,     0,   348,   349,   350,     0,   351,   352,   353,   354,
     355,     0,   357,   358,   359,   360,     0,   361,   362,   363,
     364,   365,   366,   367,     0,   368,     0,   370,   371,   372,
     373,   374,   375,   376,     0,   377,     0,   378,     0,     0,
     381,     0,   383,   384,   385,   386,   387,     0,     0,   388,
     389,     0,   391,     0,     0,   393,   394,   395,     0,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   428,     0,   429,   430,   431,   432,   433,
     434,     0,   435,   436,     0,     0,   437,   438,   439,     0,
       0,   440,   441,   442,     0,   444,     0,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   456,
     457,   458,   459,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,     0,   509,   510,   511,   512,
     513,     0,   514,   515,   516,   517,   518,     0,   520,   521,
     522,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,     0,   539,
     540,     0,   541,     0,   543,   544,   545,   546,   547,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,     0,
       0,   564,   565,   566,   567,   568,     0,     0,   569,   570,
     571,   572,   573,   574,   575,     0,   576,     0,   578,   579,
     580,   581,     0,     0,   582,     0,     0,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   610,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
       0,  4167,     0,   241,   242,     0,   243,   244,   245,     0,
     247,   248,   249,   250,   251,     0,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,     0,   261,   262,   263,
     264,   265,     0,   266,   267,   268,   269,   270,     0,     0,
       0,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,     0,   288,
     289,   290,     0,     0,     0,     0,     0,     0,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,     0,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,   314,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,     0,   333,
       0,   334,   335,   336,   337,     0,   338,     0,   339,     0,
       0,     0,   342,   343,   344,   345,     0,   346,   347,     0,
     348,   349,   350,     0,   351,   352,   353,   354,   355,     0,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,     0,   370,   371,   372,   373,   374,
     375,   376,     0,   377,     0,   378,     0,     0,   381,     0,
     383,   384,   385,   386,   387,     0,     0,   388,   389,     0,
     391,     0,     0,   393,   394,   395,     0,     0,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   428,     0,   429,   430,   431,   432,   433,   434,     0,
     435,   436,     0,     0,   437,   438,   439,     0,     0,   440,
     441,   442,     0,   444,     0,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,   458,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,     0,
     514,   515,   516,   517,   518,     0,   520,   521,   522,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,     0,   539,   540,     0,
     541,     0,   543,   544,   545,   546,   547,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,   561,   562,   563,     0,     0,   564,
     565,   566,   567,   568,     0,     0,   569,   570,   571,   572,
     573,   574,   575,     0,   576,     0,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   610,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   230,   231,   232,   233,   234,   235,   236,   237,
       0,   238,   239,   240,     0,     0,     0,     0,     0,  4181,
       0,   241,   242,     0,   243,   244,   245,     0,   247,   248,
     249,   250,   251,     0,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,     0,   261,   262,   263,   264,   265,
       0,   266,   267,   268,   269,   270,     0,     0,     0,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0,     0,   288,   289,   290,
       0,     0,     0,     0,     0,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,   314,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,     0,   333,     0,   334,
     335,   336,   337,     0,   338,     0,   339,     0,     0,     0,
     342,   343,   344,   345,     0,   346,   347,     0,   348,   349,
     350,     0,   351,   352,   353,   354,   355,     0,   357,   358,
     359,   360,     0,   361,   362,   363,   364,   365,   366,   367,
       0,   368,     0,   370,   371,   372,   373,   374,   375,   376,
       0,   377,     0,   378,     0,     0,   381,     0,   383,   384,
     385,   386,   387,     0,     0,   388,   389,     0,   391,     0,
       0,   393,   394,   395,     0,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   428,
       0,   429,   430,   431,   432,   433,   434,     0,   435,   436,
       0,     0,   437,   438,   439,     0,     0,   440,   441,   442,
       0,   444,     0,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,   458,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,   513,     0,   514,   515,
     516,   517,   518,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,     0,   539,   540,     0,   541,     0,
     543,   544,   545,   546,   547,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,   561,   562,   563,     0,     0,   564,   565,   566,
     567,   568,     0,     0,   569,   570,   571,   572,   573,   574,
     575,     0,   576,     0,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   610,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     230,   231,   232,   233,   234,   235,   236,   237,     0,   238,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,     0,   243,   244,   245,     0,   247,   248,   249,   250,
     251,     0,   253,   254,     0,   255,   256,   257,   258,   259,
     260,     0,     0,   261,   262,   263,   264,   265,     0,   266,
     267,   268,   269,   270,     0,     0,     0,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,     0,   288,   289,   290,     0,     0,
       0,     0,     0,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,     0,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,   314,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,     0,   333,     0,   334,   335,   336,
     337,     0,   338,     0,   339,     0,     0,     0,   342,   343,
     344,   345,     0,   346,   347,     0,   348,   349,   350,     0,
     351,   352,   353,   354,   355,     0,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
       0,   370,   371,   372,   373,   374,   375,   376,     0,   377,
       0,   378,     0,     0,   381,     0,   383,   384,   385,   386,
     387,     0,     0,   388,   389,     0,   391,     0,     0,   393,
     394,   395,     0,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   428,     0,   429,
     430,   431,   432,   433,   434,     0,   435,   436,     0,     0,
     437,   438,   439,     0,     0,   440,   441,   442,     0,   444,
       0,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,   458,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,   513,     0,   514,   515,   516,   517,
     518,     0,   520,   521,   522,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,     0,   539,   540,     0,   541,     0,   543,   544,
     545,   546,   547,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
     561,   562,   563,     0,     0,   564,   565,   566,   567,   568,
       0,     0,   569,   570,   571,   572,   573,   574,   575,     0,
     576,     0,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   610,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   236,   237,     0,   238,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,     0,
     243,   244,   245,     0,   247,   248,   249,   250,   251,     0,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,     0,     0,     0,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,   281,   282,   283,   284,   285,
     286,     0,     0,   288,   289,   290,     0,     0,     0,     0,
       0,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   309,   310,   311,     0,     0,   312,   313,
     314,   315,   316,     0,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,     0,   333,     0,   334,   335,   336,   337,     0,
     338,     0,   339,     0,     0,     0,   342,   343,   344,   345,
       0,   346,   347,     0,   348,   349,   350,     0,   351,   352,
     353,   354,   355,     0,   357,   358,   359,   360,     0,   361,
     362,   363,   364,   365,   366,   367,     0,   368,     0,   370,
     371,   372,   373,   374,   375,   376,     0,   377,     0,   378,
       0,     0,   381,     0,   383,   384,   385,   386,   387,     0,
       0,   388,   389,     0,   391,     0,     0,   393,   394,   395,
       0,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   428,     0,   429,   430,   431,
     432,   433,   434,     0,   435,   436,     0,     0,   437,   438,
     439,     0,     0,   440,   441,   442,     0,   444,     0,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
       0,   456,   457,   458,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,     0,   509,   510,
     511,   512,   513,     0,   514,   515,   516,   517,   518,     0,
     520,   521,   522,   523,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
       0,   539,   540,     0,   541,     0,   543,   544,   545,   546,
     547,     0,   548,   549,   550,     0,     0,   768,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,   561,   562,
     563,     0,     0,   564,   565,   566,   567,   568,     0,     0,
     569,   570,   571,   572,   573,   574,   575,     0,   576,     0,
     578,   579,   580,   581,     0,     0,   582,     0,     0,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   610,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   230,   231,   232,   233,
     234,   235,   236,   237,     0,   238,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,     0,   243,   244,
     245,     0,   247,   248,   249,   250,   251,     0,   253,   254,
       0,   255,   256,   257,   258,   259,   260,     0,     0,   261,
     262,   263,   264,   265,     0,   266,   267,   268,   269,   270,
       0,     0,     0,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,   281,   282,   283,   284,   285,   286,     0,
       0,   288,   289,   290,     0,     0,     0,     0,     0,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
       0,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,   313,   314,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
       0,   333,     0,   334,   335,   336,   337,     0,   338,     0,
     339,     0,     0,     0,   342,   343,   344,   345,     0,   346,
     347,     0,   348,   349,   350,     0,   351,   352,   353,   354,
     355,     0,   357,   358,   359,   360,     0,   361,   362,   363,
     364,   365,   366,   367,     0,   368,     0,   370,   371,   372,
     373,   374,   375,   376,     0,   377,     0,   378,     0,     0,
     381,     0,   383,   384,   385,   386,   387,     0,     0,   388,
     389,     0,   391,     0,     0,   393,   394,   395,     0,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   428,     0,   429,   430,   431,   432,   433,
     434,     0,   435,   436,     0,     0,   437,   438,   439,     0,
       0,   440,   441,   442,     0,   444,     0,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   456,
     457,   458,   459,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   780,   503,
     504,   505,   506,   507,   508,     0,   509,   510,   511,   512,
     513,     0,   514,   515,   516,   517,   518,     0,   520,   521,
     522,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,     0,   539,
     540,     0,   541,     0,   543,   544,   545,   546,   547,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,     0,
       0,   564,   565,   566,   567,   568,     0,     0,   569,   570,
     571,   572,   573,   574,   575,     0,   576,     0,   578,   579,
     580,   581,     0,     0,   582,     0,     0,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   610,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
       0,     0,     0,   241,   242,     0,   243,   244,   245,     0,
     247,   248,   249,   250,   251,     0,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,     0,   802,   262,   263,
     264,   265,     0,   266,   267,   268,   269,   270,     0,     0,
       0,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,   803,   282,   283,   284,   285,   286,     0,     0,   288,
     289,   290,     0,     0,     0,     0,     0,     0,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,     0,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,   314,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,     0,   333,
       0,   334,   335,   336,   337,     0,   338,     0,   339,     0,
       0,     0,   342,   343,   344,   345,     0,   346,   347,     0,
     348,   349,   350,     0,   351,   352,   353,   354,   355,     0,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,     0,   370,   371,   372,   373,   374,
     375,   376,     0,   377,     0,   378,     0,     0,   381,     0,
     383,   384,   385,   386,   387,     0,     0,   388,   389,     0,
     391,     0,     0,   393,   394,   804,     0,     0,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   805,   412,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   428,     0,   429,   430,   431,   432,   433,   434,     0,
     435,   436,     0,     0,   437,   438,   439,     0,     0,   440,
     441,   442,     0,   444,     0,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,   458,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,     0,   806,   495,
     496,   497,   498,   499,   500,   501,   502,   807,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   808,     0,
     514,   515,   516,   517,   518,     0,   520,   521,   522,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,     0,   539,   540,     0,
     541,     0,   543,   544,   545,   546,   547,     0,   548,   809,
     550,     0,     0,   810,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,   561,   562,   563,     0,     0,   564,
     565,   566,   567,   568,     0,     0,   569,   570,   571,   572,
     573,   574,   575,     0,   576,     0,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     811,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   610,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   230,   231,   232,   233,   234,   235,   236,   237,
       0,   238,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,     0,   243,   244,   245,     0,   247,   248,
     249,   250,   251,     0,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,     0,   261,   262,   263,   264,   265,
       0,   266,   267,   268,   269,   270,     0,     0,     0,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0,     0,   288,   289,   290,
       0,     0,     0,     0,     0,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,   314,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,     0,   333,     0,   334,
     335,   336,   337,     0,   338,     0,   339,     0,     0,     0,
     342,   343,   344,   345,     0,   346,   347,     0,   348,   349,
     350,     0,   351,   352,   353,   354,   355,     0,   357,   358,
     359,   360,     0,   361,   362,   363,   364,   365,   366,   367,
       0,   368,     0,   370,   371,   372,   373,   374,   375,   376,
       0,   377,     0,   378,     0,     0,   381,     0,   383,   384,
     385,   386,   387,     0,     0,   388,   389,     0,   391,     0,
       0,   393,   394,   395,     0,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   428,
       0,   429,   430,   431,   432,   433,   434,     0,   435,   436,
       0,     0,   437,   438,   439,     0,     0,   440,   441,   442,
       0,   444,     0,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,   458,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   833,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,   513,     0,   514,   515,
     516,   517,   518,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,     0,   539,   540,     0,   541,     0,
     543,   544,   545,   546,   547,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,   561,   562,   563,     0,     0,   564,   565,   566,
     567,   568,     0,     0,   569,   570,   571,   572,   573,   574,
     575,     0,   576,     0,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   610,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     230,   231,   232,   233,   234,   235,   236,   237,     0,   238,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,     0,   243,   244,   245,     0,   247,   248,   249,   250,
     251,     0,   253,   254,     0,   255,   256,   257,   258,   259,
     260,     0,     0,   261,   262,   263,   264,   265,     0,   266,
     267,   268,   269,   270,     0,     0,     0,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,     0,   288,   289,   290,     0,     0,
       0,     0,     0,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,     0,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,   314,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,     0,   333,     0,   334,   335,   336,
     337,     0,   338,     0,   339,     0,     0,     0,   342,   343,
     344,   345,     0,   346,   347,     0,   348,   349,   350,     0,
     351,   352,   353,   354,   911,     0,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
       0,   370,   371,   372,   373,   374,   375,   376,     0,   377,
       0,   378,     0,     0,   381,     0,   383,   384,   385,   386,
     387,     0,     0,   388,   389,     0,   391,     0,     0,   393,
     394,   395,     0,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   428,     0,   429,
     430,   431,   432,   433,   434,     0,   435,   436,     0,     0,
     437,   438,   439,     0,     0,   440,   441,   442,     0,   444,
       0,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,   458,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,   513,     0,   514,   515,   516,   517,
     518,     0,   520,   521,   522,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,     0,   539,   540,     0,   541,     0,   543,   544,
     545,   546,   547,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
     561,   562,   563,     0,     0,   564,   565,   566,   567,   568,
       0,     0,   569,   570,   571,   572,   573,   574,   575,     0,
     576,     0,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   610,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   236,   237,     0,   238,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,     0,
     243,   244,   245,     0,   247,   248,   249,   250,   251,     0,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,     0,     0,     0,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,   281,   282,   283,   284,   285,
     286,     0,     0,   288,   289,   290,     0,     0,     0,     0,
       0,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   309,   310,   311,     0,     0,   312,   313,
     314,   315,   316,     0,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,     0,   333,     0,   334,   335,   336,   337,     0,
     338,     0,   339,     0,     0,     0,   342,   343,   344,   345,
       0,   346,   347,     0,   348,   349,   350,     0,   351,   352,
     353,   354,   921,     0,   357,   358,   359,   360,     0,   361,
     362,   363,   364,   365,   366,   367,     0,   368,     0,   370,
     371,   372,   373,   374,   375,   376,     0,   377,     0,   378,
       0,     0,   381,     0,   383,   384,   385,   386,   387,     0,
       0,   388,   389,     0,   391,     0,     0,   393,   394,   395,
       0,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   428,     0,   429,   430,   431,
     432,   433,   434,     0,   435,   436,     0,     0,   437,   438,
     439,     0,     0,   440,   441,   442,     0,   444,     0,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
       0,   456,   457,   458,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,     0,   509,   510,
     511,   512,   513,     0,   514,   515,   516,   517,   518,     0,
     520,   521,   522,   523,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
       0,   539,   540,     0,   541,     0,   543,   544,   545,   546,
     547,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,   561,   562,
     563,     0,     0,   564,   565,   566,   567,   568,     0,     0,
     569,   570,   571,   572,   573,   574,   575,     0,   576,     0,
     578,   579,   580,   581,     0,     0,   582,     0,     0,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   610,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   230,   231,   232,   233,
     234,   235,   236,   237,     0,   238,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,     0,   243,   244,
     245,     0,   247,   248,   249,   250,   251,     0,   253,   254,
       0,   255,   256,   257,   258,   259,   260,     0,     0,   261,
     262,   263,   264,   265,     0,   266,   267,   268,   269,   270,
       0,     0,     0,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,   281,   282,   283,   284,   285,   286,     0,
       0,   288,   289,   290,     0,     0,     0,     0,     0,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
       0,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,   313,   314,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
       0,   333,     0,   334,   335,   336,   337,     0,   338,     0,
     339,     0,     0,     0,   342,   343,   344,   345,     0,   346,
     347,     0,   348,   349,   350,     0,   351,   352,   353,   354,
     924,     0,   357,   358,   359,   360,     0,   361,   362,   363,
     364,   365,   366,   367,     0,   368,     0,   370,   371,   372,
     373,   374,   375,   376,     0,   377,     0,   378,     0,     0,
     381,     0,   383,   384,   385,   386,   387,     0,     0,   388,
     389,     0,   391,     0,     0,   393,   394,   395,     0,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   428,     0,   429,   430,   431,   432,   433,
     434,     0,   435,   436,     0,     0,   437,   438,   439,     0,
       0,   440,   441,   442,     0,   444,     0,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   456,
     457,   458,   459,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,     0,   509,   510,   511,   512,
     513,     0,   514,   515,   516,   517,   518,     0,   520,   521,
     522,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,     0,   539,
     540,     0,   541,     0,   543,   544,   545,   546,   547,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,     0,
       0,   564,   565,   566,   567,   568,     0,     0,   569,   570,
     571,   572,   573,   574,   575,     0,   576,     0,   578,   579,
     580,   581,     0,     0,   582,     0,     0,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   610,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
       0,     0,     0,   241,   242,     0,   243,   244,   245,     0,
     247,   248,   249,   250,   251,     0,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,     0,   261,   262,   263,
     264,   265,     0,   266,   267,   268,   269,   270,     0,     0,
       0,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,     0,   288,
     289,   290,     0,     0,     0,     0,     0,     0,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,     0,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,   314,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,     0,   333,
       0,   334,   335,   336,   337,     0,   338,     0,   339,     0,
       0,     0,   342,   343,   344,   345,     0,   346,   347,     0,
     348,   349,   350,     0,   351,   352,   353,   354,   940,     0,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,     0,   370,   371,   372,   373,   374,
     375,   376,     0,   377,     0,   378,     0,     0,   381,     0,
     383,   384,   385,   386,   387,     0,     0,   388,   389,     0,
     391,     0,     0,   393,   394,   395,     0,     0,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   428,     0,   429,   430,   431,   432,   433,   434,     0,
     435,   436,     0,     0,   437,   438,   439,     0,     0,   440,
     441,   442,     0,   444,     0,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,   458,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,     0,
     514,   515,   516,   517,   518,     0,   520,   521,   522,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,     0,   539,   540,     0,
     541,     0,   543,   544,   545,   546,   547,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,   561,   562,   563,     0,     0,   564,
     565,   566,   567,   568,     0,     0,   569,   570,   571,   572,
     573,   574,   575,     0,   576,     0,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   610,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   230,   231,   232,   233,   234,   235,   236,   237,
       0,   238,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,     0,   243,   244,   245,     0,   247,   248,
     249,   250,   251,     0,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,     0,   261,   262,   263,   264,   265,
       0,   266,   267,   268,   269,   270,     0,     0,     0,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0,     0,   288,   289,   290,
       0,     0,     0,     0,     0,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,   314,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,     0,   333,     0,   334,
     335,   336,   337,     0,   338,     0,   339,     0,     0,     0,
     342,   343,   344,   345,     0,   346,   347,     0,   348,   349,
     350,     0,   351,   352,   353,   354,  1007,     0,   357,   358,
     359,   360,     0,   361,   362,   363,   364,   365,   366,   367,
       0,   368,     0,   370,   371,   372,   373,   374,   375,   376,
       0,   377,     0,   378,     0,     0,   381,     0,   383,   384,
     385,   386,   387,     0,     0,   388,   389,     0,   391,     0,
       0,   393,   394,   395,     0,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   428,
       0,   429,   430,   431,   432,   433,   434,     0,   435,   436,
       0,     0,   437,   438,   439,     0,     0,   440,   441,   442,
       0,   444,     0,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,   458,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,   513,     0,   514,   515,
     516,   517,   518,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,     0,   539,   540,     0,   541,     0,
     543,   544,   545,   546,   547,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,   561,   562,   563,     0,     0,   564,   565,   566,
     567,   568,     0,     0,   569,   570,   571,   572,   573,   574,
     575,     0,   576,     0,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   610,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     230,   231,   232,   233,   234,   235,   236,   237,     0,   238,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,     0,   243,   244,   245,     0,   247,   248,   249,   250,
     251,     0,   253,   254,     0,   255,   256,   257,   258,   259,
     260,     0,     0,   261,   262,   263,   264,   265,     0,   266,
     267,   268,   269,   270,     0,     0,     0,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,     0,   288,   289,   290,     0,     0,
       0,     0,     0,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,     0,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,   314,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,     0,   333,     0,   334,   335,   336,
     337,     0,   338,     0,   339,     0,     0,     0,   342,   343,
     344,   345,     0,   346,   347,     0,   348,   349,   350,     0,
     351,   352,   353,   354,  1013,     0,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
       0,   370,   371,   372,   373,   374,   375,   376,     0,   377,
       0,   378,     0,     0,   381,     0,   383,   384,   385,   386,
     387,     0,     0,   388,   389,     0,   391,     0,     0,   393,
     394,   395,     0,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   428,     0,   429,
     430,   431,   432,   433,   434,     0,   435,   436,     0,     0,
     437,   438,   439,     0,     0,   440,   441,   442,     0,   444,
       0,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,   458,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,   513,     0,   514,   515,   516,   517,
     518,     0,   520,   521,   522,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,     0,   539,   540,     0,   541,     0,   543,   544,
     545,   546,   547,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
     561,   562,   563,     0,     0,   564,   565,   566,   567,   568,
       0,     0,   569,   570,   571,   572,   573,   574,   575,     0,
     576,     0,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   610,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   236,   237,     0,   238,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,     0,
     243,   244,   245,     0,   247,   248,   249,   250,   251,     0,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,     0,     0,     0,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,   281,   282,   283,   284,   285,
     286,     0,     0,   288,   289,   290,     0,     0,     0,     0,
       0,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   309,   310,   311,     0,     0,   312,   313,
     314,   315,   316,     0,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,     0,   333,     0,   334,   335,   336,   337,     0,
     338,     0,   339,     0,     0,     0,   342,   343,   344,   345,
       0,   346,   347,     0,   348,   349,   350,     0,   351,   352,
     353,   354,  1030,     0,   357,   358,   359,   360,     0,   361,
     362,   363,   364,   365,   366,   367,     0,   368,     0,   370,
     371,   372,   373,   374,   375,   376,     0,   377,     0,   378,
       0,     0,   381,     0,   383,   384,   385,   386,   387,     0,
       0,   388,   389,     0,   391,     0,     0,   393,   394,   395,
       0,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   428,     0,   429,   430,   431,
     432,   433,   434,     0,   435,   436,     0,     0,   437,   438,
     439,     0,     0,   440,   441,   442,     0,   444,     0,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
       0,   456,   457,   458,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,     0,   509,   510,
     511,   512,   513,     0,   514,   515,   516,   517,   518,     0,
     520,   521,   522,   523,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
       0,   539,   540,     0,   541,     0,   543,   544,   545,   546,
     547,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,   561,   562,
     563,     0,     0,   564,   565,   566,   567,   568,     0,     0,
     569,   570,   571,   572,   573,   574,   575,     0,   576,     0,
     578,   579,   580,   581,     0,     0,   582,     0,     0,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   610,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   230,   231,   232,   233,
     234,   235,   236,   237,     0,   238,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,     0,   243,   244,
     245,     0,   247,   248,   249,   250,   251,     0,   253,   254,
       0,   255,   256,   257,   258,   259,   260,     0,     0,   261,
     262,   263,   264,   265,     0,   266,   267,   268,   269,   270,
       0,     0,     0,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,   281,   282,   283,   284,   285,   286,     0,
       0,   288,   289,   290,     0,     0,     0,     0,     0,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
       0,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,   313,   314,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
       0,   333,     0,   334,   335,   336,   337,     0,   338,     0,
     339,     0,     0,     0,   342,   343,   344,   345,     0,   346,
     347,     0,   348,   349,   350,     0,   351,   352,   353,   354,
    1033,     0,   357,   358,   359,   360,     0,   361,   362,   363,
     364,   365,   366,   367,     0,   368,     0,   370,   371,   372,
     373,   374,   375,   376,     0,   377,     0,   378,     0,     0,
     381,     0,   383,   384,   385,   386,   387,     0,     0,   388,
     389,     0,   391,     0,     0,   393,   394,   395,     0,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   428,     0,   429,   430,   431,   432,   433,
     434,     0,   435,   436,     0,     0,   437,   438,   439,     0,
       0,   440,   441,   442,     0,   444,     0,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   456,
     457,   458,   459,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,     0,   509,   510,   511,   512,
     513,     0,   514,   515,   516,   517,   518,     0,   520,   521,
     522,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,     0,   539,
     540,     0,   541,     0,   543,   544,   545,   546,   547,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,     0,
       0,   564,   565,   566,   567,   568,     0,     0,   569,   570,
     571,   572,   573,   574,   575,     0,   576,     0,   578,   579,
     580,   581,     0,     0,   582,     0,     0,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   610,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
       0,     0,     0,   241,   242,     0,   243,   244,   245,     0,
     247,   248,   249,   250,   251,     0,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,     0,   261,   262,   263,
     264,   265,     0,   266,   267,   268,   269,   270,     0,     0,
       0,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,     0,   288,
     289,   290,     0,     0,     0,     0,     0,     0,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,     0,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,   314,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,     0,   333,
       0,   334,   335,   336,   337,     0,   338,     0,   339,     0,
       0,     0,   342,   343,   344,   345,     0,   346,   347,     0,
     348,   349,   350,     0,   351,   352,   353,   354,  1035,     0,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,     0,   370,   371,   372,   373,   374,
     375,   376,     0,   377,     0,   378,     0,     0,   381,     0,
     383,   384,   385,   386,   387,     0,     0,   388,   389,     0,
     391,     0,     0,   393,   394,   395,     0,     0,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   428,     0,   429,   430,   431,   432,   433,   434,     0,
     435,   436,     0,     0,   437,   438,   439,     0,     0,   440,
     441,   442,     0,   444,     0,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,   458,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,     0,
     514,   515,   516,   517,   518,     0,   520,   521,   522,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,     0,   539,   540,     0,
     541,     0,   543,   544,   545,   546,   547,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,   561,   562,   563,     0,     0,   564,
     565,   566,   567,   568,     0,     0,   569,   570,   571,   572,
     573,   574,   575,     0,   576,     0,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   610,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   230,   231,   232,   233,   234,   235,   236,   237,
       0,   238,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,     0,   243,   244,   245,     0,   247,   248,
     249,   250,   251,     0,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,     0,   261,   262,   263,   264,   265,
       0,   266,   267,   268,   269,   270,     0,     0,     0,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0,     0,   288,   289,   290,
       0,     0,     0,     0,     0,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,   314,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,     0,   333,     0,   334,
     335,   336,   337,     0,   338,     0,   339,     0,     0,     0,
     342,   343,   344,   345,     0,   346,   347,     0,   348,   349,
     350,     0,   351,   352,   353,   354,  1071,     0,   357,   358,
     359,   360,     0,   361,   362,   363,   364,   365,   366,   367,
       0,   368,     0,   370,   371,   372,   373,   374,   375,   376,
       0,   377,     0,   378,     0,     0,   381,     0,   383,   384,
     385,   386,   387,     0,     0,   388,   389,     0,   391,     0,
       0,   393,   394,   395,     0,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   428,
       0,   429,   430,   431,   432,   433,   434,     0,   435,   436,
       0,     0,   437,   438,   439,     0,     0,   440,   441,   442,
       0,   444,     0,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,   458,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,   513,     0,   514,   515,
     516,   517,   518,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,     0,   539,   540,     0,   541,     0,
     543,   544,   545,   546,   547,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,   561,   562,   563,     0,     0,   564,   565,   566,
     567,   568,     0,     0,   569,   570,   571,   572,   573,   574,
     575,     0,   576,     0,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   610,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     230,   231,   232,   233,   234,   235,   236,   237,     0,   238,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,     0,   243,   244,   245,     0,   247,   248,   249,   250,
     251,     0,   253,   254,     0,   255,   256,   257,   258,   259,
     260,     0,     0,   261,   262,   263,   264,   265,     0,   266,
     267,   268,   269,   270,     0,     0,     0,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,     0,   288,   289,   290,     0,     0,
       0,     0,     0,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,     0,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,   314,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,     0,   333,     0,   334,   335,   336,
     337,     0,   338,     0,   339,     0,     0,     0,   342,   343,
     344,   345,     0,   346,   347,     0,   348,   349,   350,     0,
     351,   352,   353,   354,  1135,     0,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
       0,   370,   371,   372,   373,   374,   375,   376,     0,   377,
       0,   378,     0,     0,   381,     0,   383,   384,   385,   386,
     387,     0,     0,   388,   389,     0,   391,     0,     0,   393,
     394,   395,     0,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   428,     0,   429,
     430,   431,   432,   433,   434,     0,   435,   436,     0,     0,
     437,   438,   439,     0,     0,   440,   441,   442,     0,   444,
       0,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,   458,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,   513,     0,   514,   515,   516,   517,
     518,     0,   520,   521,   522,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,     0,   539,   540,     0,   541,     0,   543,   544,
     545,   546,   547,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
     561,   562,   563,     0,     0,   564,   565,   566,   567,   568,
       0,     0,   569,   570,   571,   572,   573,   574,   575,     0,
     576,     0,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   610,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   236,   237,     0,   238,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,     0,
     243,   244,   245,     0,   247,   248,   249,   250,   251,     0,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,     0,     0,     0,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,   281,   282,   283,   284,   285,
     286,     0,     0,   288,   289,   290,     0,     0,     0,     0,
       0,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   309,   310,   311,     0,     0,   312,   313,
     314,   315,   316,     0,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,     0,   333,     0,   334,   335,   336,   337,     0,
     338,     0,   339,     0,     0,     0,   342,   343,   344,   345,
       0,   346,   347,     0,   348,   349,   350,     0,   351,   352,
     353,   354,  1137,     0,   357,   358,   359,   360,     0,   361,
     362,   363,   364,   365,   366,   367,     0,   368,     0,   370,
     371,   372,   373,   374,   375,   376,     0,   377,     0,   378,
       0,     0,   381,     0,   383,   384,   385,   386,   387,     0,
       0,   388,   389,     0,   391,     0,     0,   393,   394,   395,
       0,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   428,     0,   429,   430,   431,
     432,   433,   434,     0,   435,   436,     0,     0,   437,   438,
     439,     0,     0,   440,   441,   442,     0,   444,     0,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
       0,   456,   457,   458,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,     0,   509,   510,
     511,   512,   513,     0,   514,   515,   516,   517,   518,     0,
     520,   521,   522,   523,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
       0,   539,   540,     0,   541,     0,   543,   544,   545,   546,
     547,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,   561,   562,
     563,     0,     0,   564,   565,   566,   567,   568,     0,     0,
     569,   570,   571,   572,   573,   574,   575,     0,   576,     0,
     578,   579,   580,   581,     0,     0,   582,     0,     0,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   610,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   230,   231,   232,   233,
     234,   235,   236,   237,     0,   238,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,     0,   243,   244,
     245,     0,   247,   248,   249,   250,   251,     0,   253,   254,
       0,   255,   256,   257,   258,   259,   260,     0,     0,   261,
     262,   263,   264,   265,     0,   266,   267,   268,   269,   270,
       0,     0,     0,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,   281,   282,   283,   284,   285,   286,     0,
       0,   288,   289,   290,     0,     0,     0,     0,     0,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
       0,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,   313,   314,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
       0,   333,     0,   334,   335,   336,   337,     0,   338,     0,
     339,     0,     0,     0,   342,   343,   344,   345,     0,   346,
     347,     0,   348,   349,   350,     0,   351,   352,   353,   354,
    1147,     0,   357,   358,   359,   360,     0,   361,   362,   363,
     364,   365,   366,   367,     0,   368,     0,   370,   371,   372,
     373,   374,   375,   376,     0,   377,     0,   378,     0,     0,
     381,     0,   383,   384,   385,   386,   387,     0,     0,   388,
     389,     0,   391,     0,     0,   393,   394,   395,     0,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   428,     0,   429,   430,   431,   432,   433,
     434,     0,   435,   436,     0,     0,   437,   438,   439,     0,
       0,   440,   441,   442,     0,   444,     0,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   456,
     457,   458,   459,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,     0,   509,   510,   511,   512,
     513,     0,   514,   515,   516,   517,   518,     0,   520,   521,
     522,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,     0,   539,
     540,     0,   541,     0,   543,   544,   545,   546,   547,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,     0,
       0,   564,   565,   566,   567,   568,     0,     0,   569,   570,
     571,   572,   573,   574,   575,     0,   576,     0,   578,   579,
     580,   581,     0,     0,   582,     0,     0,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   610,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
       0,     0,     0,   241,   242,     0,   243,   244,   245,     0,
     247,   248,   249,   250,   251,     0,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,     0,   261,   262,   263,
     264,   265,     0,   266,   267,   268,   269,   270,     0,     0,
       0,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,     0,   288,
     289,   290,     0,     0,     0,     0,     0,     0,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,     0,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,   314,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,     0,   333,
       0,   334,   335,   336,   337,     0,   338,     0,   339,     0,
       0,     0,   342,   343,   344,   345,     0,   346,   347,     0,
     348,   349,   350,     0,   351,   352,   353,   354,  1150,     0,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,     0,   370,   371,   372,   373,   374,
     375,   376,     0,   377,     0,   378,     0,     0,   381,     0,
     383,   384,   385,   386,   387,     0,     0,   388,   389,     0,
     391,     0,     0,   393,   394,   395,     0,     0,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   428,     0,   429,   430,   431,   432,   433,   434,     0,
     435,   436,     0,     0,   437,   438,   439,     0,     0,   440,
     441,   442,     0,   444,     0,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,   458,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,     0,
     514,   515,   516,   517,   518,     0,   520,   521,   522,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,     0,   539,   540,     0,
     541,     0,   543,   544,   545,   546,   547,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,   561,   562,   563,     0,     0,   564,
     565,   566,   567,   568,     0,     0,   569,   570,   571,   572,
     573,   574,   575,     0,   576,     0,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   610,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   230,   231,   232,   233,   234,   235,   236,   237,
       0,   238,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,     0,   243,   244,   245,     0,   247,   248,
     249,   250,   251,     0,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,     0,   261,   262,   263,   264,   265,
       0,   266,   267,   268,   269,   270,     0,     0,     0,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0,     0,   288,   289,   290,
       0,     0,     0,     0,     0,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,   314,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,     0,   333,     0,   334,
     335,   336,   337,     0,   338,     0,   339,     0,     0,     0,
     342,   343,   344,   345,     0,   346,   347,     0,   348,   349,
     350,     0,   351,   352,   353,   354,  1153,     0,   357,   358,
     359,   360,     0,   361,   362,   363,   364,   365,   366,   367,
       0,   368,     0,   370,   371,   372,   373,   374,   375,   376,
       0,   377,     0,   378,     0,     0,   381,     0,   383,   384,
     385,   386,   387,     0,     0,   388,   389,     0,   391,     0,
       0,   393,   394,   395,     0,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   428,
       0,   429,   430,   431,   432,   433,   434,     0,   435,   436,
       0,     0,   437,   438,   439,     0,     0,   440,   441,   442,
       0,   444,     0,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,   458,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,   513,     0,   514,   515,
     516,   517,   518,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,     0,   539,   540,     0,   541,     0,
     543,   544,   545,   546,   547,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,   561,   562,   563,     0,     0,   564,   565,   566,
     567,   568,     0,     0,   569,   570,   571,   572,   573,   574,
     575,     0,   576,     0,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   610,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     230,   231,   232,   233,   234,   235,   236,   237,     0,   238,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,     0,   243,   244,   245,     0,   247,   248,   249,   250,
     251,     0,   253,   254,     0,   255,   256,   257,   258,   259,
     260,     0,     0,   802,   262,   263,   264,   265,     0,   266,
     267,   268,   269,   270,     0,     0,     0,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,     0,   288,   289,   290,     0,     0,
       0,     0,     0,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,     0,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,   314,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,     0,   333,     0,   334,   335,   336,
     337,     0,   338,     0,   339,     0,     0,     0,   342,   343,
     344,   345,     0,   346,   347,     0,   348,   349,   350,     0,
     351,   352,   353,   354,   355,     0,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
       0,   370,   371,   372,   373,   374,   375,   376,     0,   377,
       0,   378,     0,     0,   381,     0,   383,   384,   385,   386,
     387,     0,     0,   388,   389,     0,   391,     0,     0,   393,
     394,   395,     0,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   805,
     412,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   428,     0,   429,
     430,   431,   432,   433,   434,     0,   435,   436,     0,     0,
     437,   438,   439,     0,     0,   440,   441,   442,     0,   444,
       0,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,   458,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,     0,   806,   495,   496,   497,   498,   499,
     500,   501,   502,   807,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,  1340,     0,   514,   515,   516,   517,
     518,     0,   520,   521,   522,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,     0,   539,   540,     0,   541,     0,   543,   544,
     545,   546,   547,     0,   548,   809,   550,     0,     0,   810,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
     561,   562,   563,     0,     0,   564,   565,   566,   567,   568,
       0,     0,   569,   570,   571,   572,   573,   574,   575,     0,
     576,     0,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   811,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   610,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   236,   237,     0,   238,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,     0,
     243,   244,   245,     0,   247,   248,   249,   250,   251,     0,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,     0,     0,     0,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,   281,   282,   283,   284,   285,
     286,     0,     0,   288,   289,   290,     0,     0,     0,     0,
       0,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   309,   310,   311,     0,     0,   312,   313,
     314,   315,   316,     0,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,     0,   333,     0,   334,   335,   336,   337,     0,
     338,     0,   339,     0,     0,     0,   342,   343,   344,   345,
       0,   346,   347,     0,   348,   349,   350,     0,   351,   352,
     353,   354,  1777,     0,   357,   358,   359,   360,     0,   361,
     362,   363,   364,   365,   366,   367,     0,   368,     0,   370,
     371,   372,   373,   374,   375,   376,     0,   377,     0,   378,
       0,     0,   381,     0,   383,   384,   385,   386,   387,     0,
       0,   388,   389,     0,   391,     0,     0,   393,   394,   395,
       0,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   428,     0,   429,   430,   431,
     432,   433,   434,     0,   435,   436,     0,     0,   437,   438,
     439,     0,     0,   440,   441,   442,     0,   444,     0,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
       0,   456,   457,   458,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,     0,   509,   510,
     511,   512,   513,     0,   514,   515,   516,   517,   518,     0,
     520,   521,   522,   523,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
       0,   539,   540,     0,   541,     0,   543,   544,   545,   546,
     547,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,   561,   562,
     563,     0,     0,   564,   565,   566,   567,   568,     0,     0,
     569,   570,   571,   572,   573,   574,   575,     0,   576,     0,
     578,   579,   580,   581,     0,     0,   582,     0,     0,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   610,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   230,   231,   232,   233,
     234,   235,   236,   237,     0,   238,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,     0,   243,   244,
     245,     0,   247,   248,   249,   250,   251,     0,   253,   254,
       0,   255,   256,   257,   258,   259,   260,     0,     0,   261,
     262,   263,   264,   265,     0,   266,   267,   268,   269,   270,
       0,     0,     0,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,   281,   282,   283,   284,   285,   286,     0,
       0,   288,   289,   290,     0,     0,     0,     0,     0,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
       0,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,   313,   314,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
       0,   333,     0,   334,   335,   336,   337,     0,   338,     0,
     339,     0,     0,     0,   342,   343,   344,   345,     0,   346,
     347,     0,   348,   349,   350,     0,   351,   352,   353,   354,
    1815,     0,   357,   358,   359,   360,     0,   361,   362,   363,
     364,   365,   366,   367,     0,   368,     0,   370,   371,   372,
     373,   374,   375,   376,     0,   377,     0,   378,     0,     0,
     381,     0,   383,   384,   385,   386,   387,     0,     0,   388,
     389,     0,   391,     0,     0,   393,   394,   395,     0,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   428,     0,   429,   430,   431,   432,   433,
     434,     0,   435,   436,     0,     0,   437,   438,   439,     0,
       0,   440,   441,   442,     0,   444,     0,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   456,
     457,   458,   459,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,     0,   509,   510,   511,   512,
     513,     0,   514,   515,   516,   517,   518,     0,   520,   521,
     522,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,     0,   539,
     540,     0,   541,     0,   543,   544,   545,   546,   547,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,     0,
       0,   564,   565,   566,   567,   568,     0,     0,   569,   570,
     571,   572,   573,   574,   575,     0,   576,     0,   578,   579,
     580,   581,     0,     0,   582,     0,     0,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   610,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
       0,     0,     0,   241,   242,     0,   243,   244,   245,     0,
     247,   248,   249,   250,   251,     0,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,     0,   261,   262,   263,
     264,   265,     0,   266,   267,   268,   269,   270,     0,     0,
       0,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,     0,   288,
     289,   290,     0,     0,     0,     0,     0,     0,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,     0,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,   314,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,     0,   333,
       0,   334,   335,   336,   337,     0,   338,     0,   339,     0,
       0,     0,   342,   343,   344,   345,     0,   346,   347,     0,
     348,   349,   350,     0,   351,   352,   353,   354,  1817,     0,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,     0,   370,   371,   372,   373,   374,
     375,   376,     0,   377,     0,   378,     0,     0,   381,     0,
     383,   384,   385,   386,   387,     0,     0,   388,   389,     0,
     391,     0,     0,   393,   394,   395,     0,     0,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   428,     0,   429,   430,   431,   432,   433,   434,     0,
     435,   436,     0,     0,   437,   438,   439,     0,     0,   440,
     441,   442,     0,   444,     0,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,   458,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,     0,
     514,   515,   516,   517,   518,     0,   520,   521,   522,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,     0,   539,   540,     0,
     541,     0,   543,   544,   545,   546,   547,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,   561,   562,   563,     0,     0,   564,
     565,   566,   567,   568,     0,     0,   569,   570,   571,   572,
     573,   574,   575,     0,   576,     0,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   610,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   230,   231,   232,   233,   234,   235,   236,   237,
       0,   238,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,     0,   243,   244,   245,     0,   247,   248,
     249,   250,   251,     0,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,     0,   261,   262,   263,   264,   265,
       0,   266,   267,   268,   269,   270,     0,     0,     0,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0,     0,   288,   289,   290,
       0,     0,     0,     0,     0,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,   314,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,     0,   333,     0,   334,
     335,   336,   337,     0,   338,     0,   339,     0,     0,     0,
     342,   343,   344,   345,     0,   346,   347,     0,   348,   349,
     350,     0,   351,   352,   353,   354,  1888,     0,   357,   358,
     359,   360,     0,   361,   362,   363,   364,   365,   366,   367,
       0,   368,     0,   370,   371,   372,   373,   374,   375,   376,
       0,   377,     0,   378,     0,     0,   381,     0,   383,   384,
     385,   386,   387,     0,     0,   388,   389,     0,   391,     0,
       0,   393,   394,   395,     0,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   428,
       0,   429,   430,   431,   432,   433,   434,     0,   435,   436,
       0,     0,   437,   438,   439,     0,     0,   440,   441,   442,
       0,   444,     0,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,   458,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,   513,     0,   514,   515,
     516,   517,   518,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,     0,   539,   540,     0,   541,     0,
     543,   544,   545,   546,   547,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,   561,   562,   563,     0,     0,   564,   565,   566,
     567,   568,     0,     0,   569,   570,   571,   572,   573,   574,
     575,     0,   576,     0,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   610,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     230,   231,   232,   233,   234,   235,   236,   237,     0,   238,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,     0,   243,   244,   245,     0,   247,   248,   249,   250,
     251,     0,   253,   254,     0,   255,   256,   257,   258,   259,
     260,     0,     0,   261,   262,   263,   264,   265,     0,   266,
     267,   268,   269,   270,     0,     0,     0,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,     0,   288,   289,   290,     0,     0,
       0,     0,     0,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,     0,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,   314,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,     0,   333,     0,   334,   335,   336,
     337,     0,   338,     0,   339,     0,     0,     0,   342,   343,
     344,   345,     0,   346,   347,     0,   348,   349,   350,     0,
     351,   352,   353,   354,  1890,     0,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
       0,   370,   371,   372,   373,   374,   375,   376,     0,   377,
       0,   378,     0,     0,   381,     0,   383,   384,   385,   386,
     387,     0,     0,   388,   389,     0,   391,     0,     0,   393,
     394,   395,     0,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   428,     0,   429,
     430,   431,   432,   433,   434,     0,   435,   436,     0,     0,
     437,   438,   439,     0,     0,   440,   441,   442,     0,   444,
       0,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,   458,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,   513,     0,   514,   515,   516,   517,
     518,     0,   520,   521,   522,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,     0,   539,   540,     0,   541,     0,   543,   544,
     545,   546,   547,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
     561,   562,   563,     0,     0,   564,   565,   566,   567,   568,
       0,     0,   569,   570,   571,   572,   573,   574,   575,     0,
     576,     0,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   610,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   236,   237,     0,   238,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,     0,
     243,   244,   245,     0,   247,   248,   249,   250,   251,     0,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,     0,     0,     0,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,   281,   282,   283,   284,   285,
     286,     0,     0,   288,   289,   290,     0,     0,     0,     0,
       0,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   309,   310,   311,     0,     0,   312,   313,
     314,   315,   316,     0,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,     0,   333,     0,   334,   335,   336,   337,     0,
     338,     0,   339,     0,     0,     0,   342,   343,   344,   345,
       0,   346,   347,     0,   348,   349,   350,     0,   351,   352,
     353,   354,  1892,     0,   357,   358,   359,   360,     0,   361,
     362,   363,   364,   365,   366,   367,     0,   368,     0,   370,
     371,   372,   373,   374,   375,   376,     0,   377,     0,   378,
       0,     0,   381,     0,   383,   384,   385,   386,   387,     0,
       0,   388,   389,     0,   391,     0,     0,   393,   394,   395,
       0,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   428,     0,   429,   430,   431,
     432,   433,   434,     0,   435,   436,     0,     0,   437,   438,
     439,     0,     0,   440,   441,   442,     0,   444,     0,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
       0,   456,   457,   458,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,     0,   509,   510,
     511,   512,   513,     0,   514,   515,   516,   517,   518,     0,
     520,   521,   522,   523,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
       0,   539,   540,     0,   541,     0,   543,   544,   545,   546,
     547,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,   561,   562,
     563,     0,     0,   564,   565,   566,   567,   568,     0,     0,
     569,   570,   571,   572,   573,   574,   575,     0,   576,     0,
     578,   579,   580,   581,     0,     0,   582,     0,     0,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   610,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   230,   231,   232,   233,
     234,   235,   236,   237,     0,   238,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,     0,   243,   244,
     245,     0,   247,   248,   249,   250,   251,     0,   253,   254,
       0,   255,   256,   257,   258,   259,   260,     0,     0,   261,
     262,   263,   264,   265,     0,   266,   267,   268,   269,   270,
       0,     0,     0,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,   281,   282,   283,   284,   285,   286,     0,
       0,   288,   289,   290,     0,     0,     0,     0,     0,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
       0,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,   313,   314,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
       0,   333,     0,   334,   335,   336,   337,     0,   338,     0,
     339,     0,     0,     0,   342,   343,   344,   345,     0,   346,
     347,     0,   348,   349,   350,     0,   351,   352,   353,   354,
     355,     0,   357,   358,   359,   360,     0,   361,   362,   363,
     364,   365,   366,   367,     0,   368,     0,   370,   371,   372,
     373,   374,   375,   376,     0,   377,     0,   378,     0,     0,
     381,     0,   383,   384,   385,   386,   387,     0,     0,   388,
     389,     0,   391,     0,     0,   393,   394,   395,     0,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   428,     0,   429,   430,   431,   432,   433,
     434,     0,   435,   436,     0,     0,   437,   438,   439,     0,
       0,   440,   441,   442,     0,   444,     0,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   456,
     457,   458,   459,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,     0,
     494,   495,   496,   497,   498,   499,   500,   501,  1995,   503,
     504,   505,   506,   507,   508,     0,   509,   510,   511,   512,
     513,     0,   514,   515,   516,   517,   518,     0,   520,   521,
     522,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,     0,   539,
     540,     0,   541,     0,   543,   544,   545,   546,   547,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,     0,
       0,   564,   565,   566,   567,   568,     0,     0,   569,   570,
     571,   572,   573,   574,   575,     0,   576,     0,   578,   579,
     580,   581,     0,     0,   582,     0,     0,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   610,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
       0,  2175,     0,   241,   242,     0,   243,   244,   245,     0,
     247,   248,   249,   250,   251,     0,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,     0,   261,   262,   263,
     264,   265,     0,   266,   267,   268,   269,   270,     0,     0,
       0,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,     0,   288,
     289,   290,     0,     0,     0,     0,     0,     0,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,     0,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,   314,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,     0,   333,
       0,   334,   335,   336,   337,     0,   338,     0,   339,     0,
       0,     0,   342,   343,   344,   345,     0,   346,   347,     0,
     348,   349,   350,     0,   351,   352,   353,   354,   355,     0,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,     0,   370,   371,   372,   373,   374,
     375,   376,     0,   377,     0,   378,     0,     0,   381,     0,
     383,   384,   385,   386,   387,     0,     0,   388,   389,     0,
     391,     0,     0,   393,   394,   395,     0,     0,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   428,     0,   429,   430,   431,   432,   433,   434,     0,
     435,   436,     0,     0,   437,   438,   439,     0,     0,   440,
     441,   442,     0,   444,     0,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,   458,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,     0,
       0,   515,   516,   517,   518,     0,   520,   521,   522,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,     0,   539,   540,     0,
     541,     0,   543,   544,   545,   546,   547,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,   561,   562,   563,     0,     0,   564,
     565,   566,   567,   568,     0,     0,   569,   570,   571,   572,
     573,   574,   575,     0,   576,     0,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   610,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   230,   231,   232,   233,   234,   235,   236,   237,
       0,   238,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,     0,   243,   244,   245,     0,   247,   248,
     249,   250,   251,     0,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,     0,   802,   262,   263,   264,   265,
       0,   266,   267,   268,   269,   270,     0,     0,     0,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0,     0,   288,   289,   290,
       0,     0,     0,     0,     0,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,   314,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,     0,   333,     0,   334,
     335,   336,   337,     0,   338,     0,   339,     0,     0,     0,
     342,   343,   344,   345,     0,   346,   347,     0,   348,   349,
     350,     0,   351,   352,   353,   354,   355,     0,   357,   358,
     359,   360,     0,   361,   362,   363,   364,   365,   366,   367,
       0,   368,     0,   370,   371,   372,   373,   374,   375,   376,
       0,   377,     0,   378,     0,     0,   381,     0,   383,   384,
     385,   386,   387,     0,     0,   388,   389,     0,   391,     0,
       0,   393,   394,   395,     0,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   805,   412,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   428,
       0,   429,   430,   431,   432,   433,   434,     0,   435,   436,
       0,     0,   437,   438,   439,     0,     0,   440,   441,   442,
       0,   444,     0,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,   458,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,     0,   806,   495,   496,   497,
     498,   499,   500,   501,   502,   807,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,  1340,     0,   514,   515,
     516,   517,   518,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,     0,   539,   540,     0,   541,     0,
    2210,   544,   545,   546,   547,     0,   548,   809,   550,     0,
       0,   810,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,   561,   562,   563,     0,     0,   564,   565,   566,
     567,   568,     0,     0,   569,   570,   571,   572,   573,   574,
     575,     0,   576,     0,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   811,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   610,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     230,   231,   232,   233,   234,   235,   236,   237,     0,   238,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,     0,   243,   244,   245,     0,   247,   248,   249,   250,
     251,     0,   253,   254,     0,   255,   256,   257,   258,   259,
     260,     0,     0,   802,   262,   263,   264,   265,     0,   266,
     267,   268,   269,   270,     0,     0,     0,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,     0,   288,   289,   290,     0,     0,
       0,     0,     0,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,     0,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,   314,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,     0,   333,     0,   334,   335,   336,
     337,     0,   338,     0,   339,     0,     0,     0,   342,   343,
     344,   345,     0,   346,   347,     0,   348,   349,   350,     0,
     351,   352,   353,   354,   355,     0,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
       0,   370,   371,   372,   373,   374,   375,   376,     0,   377,
       0,   378,     0,     0,   381,     0,   383,   384,   385,   386,
     387,     0,     0,   388,   389,     0,   391,     0,     0,   393,
     394,   395,     0,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   805,
     412,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   428,     0,   429,
     430,   431,   432,   433,   434,     0,   435,   436,     0,     0,
     437,   438,   439,     0,     0,   440,   441,   442,     0,   444,
       0,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,   458,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,     0,   806,   495,   496,   497,   498,   499,
     500,   501,   502,  2286,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,  2287,     0,   514,   515,   516,   517,
     518,     0,   520,   521,   522,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,     0,   539,   540,     0,   541,     0,   543,   544,
     545,   546,   547,     0,   548,   809,   550,     0,     0,  2288,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
     561,   562,   563,     0,     0,   564,   565,   566,   567,   568,
       0,     0,   569,   570,   571,   572,   573,   574,   575,     0,
     576,     0,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   811,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   610,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   236,   237,     0,   238,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,     0,
     243,   244,   245,     0,   247,   248,   249,   250,   251,     0,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   802,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,     0,     0,     0,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,   281,   282,   283,   284,   285,
     286,     0,     0,   288,   289,   290,     0,     0,     0,     0,
       0,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   309,   310,   311,     0,     0,   312,   313,
     314,   315,   316,     0,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,     0,   333,     0,   334,   335,   336,   337,     0,
     338,     0,   339,     0,     0,     0,   342,   343,   344,   345,
       0,   346,   347,     0,   348,   349,   350,     0,   351,   352,
     353,   354,   355,     0,   357,   358,   359,   360,     0,   361,
     362,   363,   364,   365,   366,   367,     0,   368,     0,   370,
     371,   372,   373,   374,   375,   376,     0,   377,     0,   378,
       0,     0,   381,     0,   383,   384,   385,   386,   387,     0,
       0,   388,   389,     0,   391,     0,     0,   393,   394,   395,
       0,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   805,   412,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   428,     0,   429,   430,   431,
     432,   433,   434,     0,   435,   436,     0,     0,   437,   438,
     439,     0,     0,   440,   441,   442,     0,   444,     0,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
       0,   456,   457,   458,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,     0,   806,   495,   496,   497,   498,   499,   500,   501,
     502,  2365,   504,   505,   506,   507,   508,     0,   509,   510,
     511,   512,  2287,     0,   514,   515,   516,   517,   518,     0,
     520,   521,   522,   523,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
       0,   539,   540,     0,   541,     0,   543,   544,   545,   546,
     547,     0,   548,   809,   550,     0,     0,  2288,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,   561,   562,
     563,     0,     0,   564,   565,   566,   567,   568,     0,     0,
     569,   570,   571,   572,   573,   574,   575,     0,   576,     0,
     578,   579,   580,   581,     0,     0,   582,     0,     0,   583,
     584,   585,   586,   587,   811,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   610,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   230,   231,   232,   233,
     234,   235,   236,   237,     0,   238,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,     0,   243,   244,
     245,     0,   247,   248,   249,   250,   251,     0,   253,   254,
       0,   255,   256,   257,   258,   259,   260,     0,     0,   802,
     262,   263,   264,   265,     0,   266,   267,   268,   269,   270,
       0,     0,     0,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,   281,   282,   283,   284,   285,   286,     0,
       0,   288,   289,   290,     0,     0,     0,     0,     0,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
       0,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,   313,   314,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
       0,   333,     0,   334,   335,   336,   337,     0,   338,     0,
     339,     0,     0,     0,   342,   343,   344,   345,     0,   346,
     347,     0,   348,   349,   350,     0,   351,   352,   353,   354,
     355,     0,   357,   358,   359,   360,     0,   361,   362,   363,
     364,   365,   366,   367,     0,   368,     0,   370,   371,   372,
     373,   374,   375,   376,     0,   377,     0,   378,     0,     0,
     381,     0,   383,   384,   385,   386,   387,     0,     0,   388,
     389,     0,   391,     0,     0,   393,   394,   395,     0,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   805,   412,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   428,     0,   429,   430,   431,   432,   433,
     434,     0,   435,   436,     0,     0,   437,   438,   439,     0,
       0,   440,   441,   442,     0,   444,     0,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   456,
     457,   458,   459,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,     0,
     806,   495,   496,   497,   498,   499,   500,   501,   502,  2382,
     504,   505,   506,   507,   508,     0,   509,   510,   511,   512,
    2287,     0,   514,   515,   516,   517,   518,     0,   520,   521,
     522,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,     0,   539,
     540,     0,   541,     0,   543,   544,   545,   546,   547,     0,
     548,   809,   550,     0,     0,  2288,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,     0,
       0,   564,   565,   566,   567,   568,     0,     0,   569,   570,
     571,   572,   573,   574,   575,     0,   576,     0,   578,   579,
     580,   581,     0,     0,   582,     0,     0,   583,   584,   585,
     586,   587,   811,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   610,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
       0,     0,     0,   241,   242,     0,   243,   244,   245,     0,
     247,   248,   249,   250,   251,     0,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,     0,   261,   262,   263,
     264,   265,     0,   266,   267,   268,   269,   270,     0,     0,
       0,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,     0,   288,
     289,   290,     0,     0,     0,     0,     0,     0,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,     0,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,   314,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,     0,   333,
       0,   334,   335,   336,   337,     0,   338,     0,   339,     0,
       0,     0,   342,   343,   344,   345,     0,   346,   347,     0,
     348,   349,   350,     0,   351,   352,   353,   354,  2586,     0,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,     0,   370,   371,   372,   373,   374,
     375,   376,     0,   377,     0,   378,     0,     0,   381,     0,
     383,   384,   385,   386,   387,     0,     0,   388,   389,     0,
     391,     0,     0,   393,   394,   395,     0,     0,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   428,     0,   429,   430,   431,   432,   433,   434,     0,
     435,   436,     0,     0,   437,   438,   439,     0,     0,   440,
     441,   442,     0,   444,     0,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,   458,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,     0,
     514,   515,   516,   517,   518,     0,   520,   521,   522,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,     0,   539,   540,     0,
     541,     0,   543,   544,   545,   546,   547,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,   561,   562,   563,     0,     0,   564,
     565,   566,   567,   568,     0,     0,   569,   570,   571,   572,
     573,   574,   575,     0,   576,     0,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   610,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   230,   231,   232,   233,   234,   235,   236,   237,
       0,   238,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,     0,   243,   244,   245,     0,   247,   248,
     249,   250,   251,     0,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,     0,   261,   262,   263,   264,   265,
       0,   266,   267,   268,   269,   270,     0,     0,     0,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0,     0,   288,   289,   290,
       0,     0,     0,     0,     0,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,   314,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,     0,   333,     0,   334,
     335,   336,   337,     0,   338,     0,   339,     0,     0,     0,
     342,   343,   344,   345,     0,   346,   347,     0,   348,   349,
     350,     0,   351,   352,   353,   354,  2590,     0,   357,   358,
     359,   360,     0,   361,   362,   363,   364,   365,   366,   367,
       0,   368,     0,   370,   371,   372,   373,   374,   375,   376,
       0,   377,     0,   378,     0,     0,   381,     0,   383,   384,
     385,   386,   387,     0,     0,   388,   389,     0,   391,     0,
       0,   393,   394,   395,     0,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   428,
       0,   429,   430,   431,   432,   433,   434,     0,   435,   436,
       0,     0,   437,   438,   439,     0,     0,   440,   441,   442,
       0,   444,     0,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,   458,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,   513,     0,   514,   515,
     516,   517,   518,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,     0,   539,   540,     0,   541,     0,
     543,   544,   545,   546,   547,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,   561,   562,   563,     0,     0,   564,   565,   566,
     567,   568,     0,     0,   569,   570,   571,   572,   573,   574,
     575,     0,   576,     0,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   610,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     230,   231,   232,   233,   234,   235,   236,   237,     0,   238,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,     0,   243,   244,   245,     0,   247,   248,   249,   250,
     251,     0,   253,   254,     0,   255,   256,   257,   258,   259,
     260,     0,     0,   261,   262,   263,   264,   265,     0,   266,
     267,   268,   269,   270,     0,     0,     0,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,     0,   288,   289,   290,     0,     0,
       0,     0,     0,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,     0,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,   314,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,     0,   333,     0,   334,   335,   336,
     337,     0,   338,     0,   339,     0,     0,     0,   342,   343,
     344,   345,     0,   346,   347,     0,   348,   349,   350,     0,
     351,   352,   353,   354,  2666,     0,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
       0,   370,   371,   372,   373,   374,   375,   376,     0,   377,
       0,   378,     0,     0,   381,     0,   383,   384,   385,   386,
     387,     0,     0,   388,   389,     0,   391,     0,     0,   393,
     394,   395,     0,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   428,     0,   429,
     430,   431,   432,   433,   434,     0,   435,   436,     0,     0,
     437,   438,   439,     0,     0,   440,   441,   442,     0,   444,
       0,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,   458,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,   513,     0,   514,   515,   516,   517,
     518,     0,   520,   521,   522,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,     0,   539,   540,     0,   541,     0,   543,   544,
     545,   546,   547,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
     561,   562,   563,     0,     0,   564,   565,   566,   567,   568,
       0,     0,   569,   570,   571,   572,   573,   574,   575,     0,
     576,     0,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   610,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   236,   237,     0,   238,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,     0,
     243,   244,   245,     0,   247,   248,   249,   250,   251,     0,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,     0,     0,     0,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,   281,   282,   283,   284,   285,
     286,     0,     0,   288,   289,   290,     0,     0,     0,     0,
       0,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   309,   310,   311,     0,     0,   312,   313,
     314,   315,   316,     0,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,     0,   333,     0,   334,   335,   336,   337,     0,
     338,     0,   339,     0,     0,     0,   342,   343,   344,   345,
       0,   346,   347,     0,   348,   349,   350,     0,   351,   352,
     353,   354,  3000,     0,   357,   358,   359,   360,     0,   361,
     362,   363,   364,   365,   366,   367,     0,   368,     0,   370,
     371,   372,   373,   374,   375,   376,     0,   377,     0,   378,
       0,     0,   381,     0,   383,   384,   385,   386,   387,     0,
       0,   388,   389,     0,   391,     0,     0,   393,   394,   395,
       0,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   428,     0,   429,   430,   431,
     432,   433,   434,     0,   435,   436,     0,     0,   437,   438,
     439,     0,     0,   440,   441,   442,     0,   444,     0,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
       0,   456,   457,   458,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,     0,   509,   510,
     511,   512,   513,     0,   514,   515,   516,   517,   518,     0,
     520,   521,   522,   523,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
       0,   539,   540,     0,   541,     0,   543,   544,   545,   546,
     547,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,   561,   562,
     563,     0,     0,   564,   565,   566,   567,   568,     0,     0,
     569,   570,   571,   572,   573,   574,   575,     0,   576,     0,
     578,   579,   580,   581,     0,     0,   582,     0,     0,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   610,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   230,   231,   232,   233,
     234,   235,   236,   237,     0,   238,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,     0,   243,   244,
     245,     0,   247,   248,   249,   250,   251,     0,   253,   254,
       0,   255,   256,   257,   258,   259,   260,     0,     0,   802,
     262,   263,   264,   265,     0,   266,   267,   268,   269,   270,
       0,     0,     0,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,   281,   282,   283,   284,   285,   286,     0,
       0,   288,   289,   290,     0,     0,     0,     0,     0,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
       0,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,   313,   314,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
       0,   333,     0,   334,   335,   336,   337,     0,   338,     0,
     339,     0,     0,     0,   342,   343,   344,   345,     0,   346,
     347,     0,   348,   349,   350,     0,   351,   352,   353,   354,
     355,     0,   357,   358,   359,   360,     0,   361,   362,   363,
     364,   365,   366,   367,     0,   368,     0,   370,   371,   372,
     373,   374,   375,   376,     0,   377,     0,   378,     0,     0,
     381,     0,   383,   384,   385,   386,   387,     0,     0,   388,
     389,     0,   391,     0,     0,   393,   394,   395,     0,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   805,   412,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   428,     0,   429,   430,   431,   432,   433,
     434,     0,   435,   436,     0,     0,   437,   438,   439,     0,
       0,   440,   441,   442,     0,   444,     0,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   456,
     457,   458,   459,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,     0,
     806,   495,   496,   497,   498,   499,   500,   501,   502,   807,
     504,   505,   506,   507,   508,     0,   509,   510,   511,   512,
    2287,     0,   514,   515,   516,   517,   518,     0,   520,   521,
     522,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,     0,   539,
     540,     0,   541,     0,   543,   544,   545,   546,   547,     0,
     548,   809,   550,     0,     0,  2288,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,     0,
       0,   564,   565,   566,   567,   568,     0,     0,   569,   570,
     571,   572,   573,   574,   575,     0,   576,     0,   578,   579,
     580,   581,     0,     0,   582,     0,     0,   583,   584,   585,
     586,   587,   811,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   610,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
       0,     0,     0,   241,   242,     0,   243,   244,   245,     0,
     247,   248,   249,   250,   251,     0,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,     0,   261,   262,   263,
     264,   265,     0,   266,   267,   268,   269,   270,     0,     0,
       0,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,     0,   288,
     289,   290,     0,     0,     0,     0,     0,     0,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,     0,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,   314,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,     0,   333,
       0,   334,   335,   336,   337,     0,   338,     0,   339,     0,
       0,     0,   342,   343,   344,   345,     0,   346,   347,     0,
     348,   349,   350,     0,   351,   352,   353,   354,  3069,     0,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,     0,   370,   371,   372,   373,   374,
     375,   376,     0,   377,     0,   378,     0,     0,   381,     0,
     383,   384,   385,   386,   387,     0,     0,   388,   389,     0,
     391,     0,     0,   393,   394,   395,     0,     0,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   428,     0,   429,   430,   431,   432,   433,   434,     0,
     435,   436,     0,     0,   437,   438,   439,     0,     0,   440,
     441,   442,     0,   444,     0,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,   458,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,     0,
     514,   515,   516,   517,   518,     0,   520,   521,   522,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,     0,   539,   540,     0,
     541,     0,   543,   544,   545,   546,   547,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,   561,   562,   563,     0,     0,   564,
     565,   566,   567,   568,     0,     0,   569,   570,   571,   572,
     573,   574,   575,     0,   576,     0,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   610,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   230,   231,   232,   233,   234,   235,   236,   237,
       0,   238,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,     0,   243,   244,   245,     0,   247,   248,
     249,   250,   251,     0,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,     0,   261,   262,   263,   264,   265,
       0,   266,   267,   268,   269,   270,     0,     0,     0,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0,     0,   288,   289,   290,
       0,     0,     0,     0,     0,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,   314,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,     0,   333,     0,   334,
     335,   336,   337,     0,   338,     0,   339,     0,     0,     0,
     342,   343,   344,   345,     0,   346,   347,     0,   348,   349,
     350,     0,   351,   352,   353,   354,  3083,     0,   357,   358,
     359,   360,     0,   361,   362,   363,   364,   365,   366,   367,
       0,   368,     0,   370,   371,   372,   373,   374,   375,   376,
       0,   377,     0,   378,     0,     0,   381,     0,   383,   384,
     385,   386,   387,     0,     0,   388,   389,     0,   391,     0,
       0,   393,   394,   395,     0,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   428,
       0,   429,   430,   431,   432,   433,   434,     0,   435,   436,
       0,     0,   437,   438,   439,     0,     0,   440,   441,   442,
       0,   444,     0,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,   458,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,   513,     0,   514,   515,
     516,   517,   518,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,     0,   539,   540,     0,   541,     0,
     543,   544,   545,   546,   547,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,   561,   562,   563,     0,     0,   564,   565,   566,
     567,   568,     0,     0,   569,   570,   571,   572,   573,   574,
     575,     0,   576,     0,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   610,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     230,   231,   232,   233,   234,   235,   236,   237,     0,   238,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,     0,   243,   244,   245,     0,   247,   248,   249,   250,
     251,     0,   253,   254,     0,   255,   256,   257,   258,   259,
     260,     0,     0,   261,   262,   263,   264,   265,     0,   266,
     267,   268,   269,   270,     0,     0,     0,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,     0,   288,   289,   290,     0,     0,
       0,     0,     0,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,     0,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,   314,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,     0,   333,     0,   334,   335,   336,
     337,     0,   338,     0,   339,     0,     0,     0,   342,   343,
     344,   345,     0,   346,   347,     0,   348,   349,   350,     0,
     351,   352,   353,   354,  3085,     0,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
       0,   370,   371,   372,   373,   374,   375,   376,     0,   377,
       0,   378,     0,     0,   381,     0,   383,   384,   385,   386,
     387,     0,     0,   388,   389,     0,   391,     0,     0,   393,
     394,   395,     0,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   428,     0,   429,
     430,   431,   432,   433,   434,     0,   435,   436,     0,     0,
     437,   438,   439,     0,     0,   440,   441,   442,     0,   444,
       0,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,   458,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,   513,     0,   514,   515,   516,   517,
     518,     0,   520,   521,   522,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,     0,   539,   540,     0,   541,     0,   543,   544,
     545,   546,   547,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
     561,   562,   563,     0,     0,   564,   565,   566,   567,   568,
       0,     0,   569,   570,   571,   572,   573,   574,   575,     0,
     576,     0,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   610,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   236,   237,     0,   238,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,     0,
     243,   244,   245,     0,   247,   248,   249,   250,   251,     0,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,     0,     0,     0,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,   281,   282,   283,   284,   285,
     286,     0,     0,   288,   289,   290,     0,     0,     0,     0,
       0,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   309,   310,   311,     0,     0,   312,   313,
     314,   315,   316,     0,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,     0,   333,     0,   334,   335,   336,   337,     0,
     338,     0,   339,     0,     0,     0,   342,   343,   344,   345,
       0,   346,   347,     0,   348,   349,   350,     0,   351,   352,
     353,   354,  3230,     0,   357,   358,   359,   360,     0,   361,
     362,   363,   364,   365,   366,   367,     0,   368,     0,   370,
     371,   372,   373,   374,   375,   376,     0,   377,     0,   378,
       0,     0,   381,     0,   383,   384,   385,   386,   387,     0,
       0,   388,   389,     0,   391,     0,     0,   393,   394,   395,
       0,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   428,     0,   429,   430,   431,
     432,   433,   434,     0,   435,   436,     0,     0,   437,   438,
     439,     0,     0,   440,   441,   442,     0,   444,     0,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
       0,   456,   457,   458,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,     0,   509,   510,
     511,   512,   513,     0,   514,   515,   516,   517,   518,     0,
     520,   521,   522,   523,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
       0,   539,   540,     0,   541,     0,   543,   544,   545,   546,
     547,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,   561,   562,
     563,     0,     0,   564,   565,   566,   567,   568,     0,     0,
     569,   570,   571,   572,   573,   574,   575,     0,   576,     0,
     578,   579,   580,   581,     0,     0,   582,     0,     0,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   610,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   230,   231,   232,   233,
     234,   235,   236,   237,     0,   238,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,     0,   243,   244,
     245,     0,   247,   248,   249,   250,   251,     0,   253,   254,
       0,   255,   256,   257,   258,   259,   260,     0,     0,   261,
     262,   263,   264,   265,     0,   266,   267,   268,   269,   270,
       0,     0,     0,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,   281,   282,   283,   284,   285,   286,     0,
       0,   288,   289,   290,     0,     0,     0,     0,     0,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
       0,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,  3268,   314,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
       0,   333,     0,   334,   335,   336,   337,     0,   338,     0,
     339,     0,     0,     0,   342,   343,   344,   345,     0,   346,
     347,     0,   348,   349,   350,     0,   351,   352,   353,   354,
     355,     0,   357,   358,   359,   360,     0,   361,   362,   363,
     364,   365,   366,   367,     0,   368,     0,   370,   371,   372,
     373,   374,   375,   376,     0,   377,     0,   378,     0,     0,
     381,     0,   383,   384,   385,   386,   387,     0,     0,   388,
     389,     0,   391,     0,     0,   393,   394,   395,     0,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   428,     0,   429,   430,   431,   432,   433,
     434,     0,   435,   436,     0,     0,   437,   438,   439,     0,
       0,   440,   441,   442,     0,   444,     0,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   456,
     457,   458,   459,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,     0,   509,   510,   511,   512,
     513,     0,   514,   515,   516,   517,   518,     0,   520,   521,
     522,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,     0,   539,
     540,     0,   541,     0,   543,   544,   545,   546,   547,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,     0,
       0,   564,   565,   566,   567,   568,     0,     0,   569,   570,
     571,   572,   573,   574,   575,     0,   576,     0,   578,   579,
     580,   581,     0,     0,   582,     0,     0,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   610,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
       0,     0,     0,   241,   242,     0,   243,   244,   245,     0,
     247,   248,   249,   250,   251,     0,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,     0,   261,   262,   263,
     264,   265,     0,   266,   267,   268,   269,   270,     0,     0,
       0,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,     0,   288,
     289,   290,     0,     0,     0,     0,     0,     0,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,     0,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,   314,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,     0,   333,
       0,   334,   335,   336,   337,     0,   338,     0,   339,     0,
       0,     0,   342,   343,   344,   345,     0,   346,   347,     0,
     348,   349,   350,     0,   351,   352,   353,   354,  4452,     0,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,     0,   370,   371,   372,   373,   374,
     375,   376,     0,   377,     0,   378,     0,     0,   381,     0,
     383,   384,   385,   386,   387,     0,     0,   388,   389,     0,
     391,     0,     0,   393,   394,   395,     0,     0,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   428,     0,   429,   430,   431,   432,   433,   434,     0,
     435,   436,     0,     0,   437,   438,   439,     0,     0,   440,
     441,   442,     0,   444,     0,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,   458,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,     0,
     514,   515,   516,   517,   518,     0,   520,   521,   522,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,     0,   539,   540,     0,
     541,     0,   543,   544,   545,   546,   547,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,   561,   562,   563,     0,     0,   564,
     565,   566,   567,   568,     0,     0,   569,   570,   571,   572,
     573,   574,   575,     0,   576,     0,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,  1073,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   230,   231,   232,   233,   234,   235,   236,   237,
       0,   238,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,     0,   243,   244,   245,   246,   247,   248,
     249,     0,  1074,   252,  1075,  1076,     0,   255,   256,   257,
     258,   259,   260,     0,     0,   261,   262,  1077,  1078,   265,
       0,   266,   267,   268,   269,     0,     0,   271,     0,   272,
     273,   274,   275,   276,   277,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0,   287,   288,   289,   290,
       0,     0,     0,   291,     0,     0,     0,   292,   293,   294,
     295,   296,   297,  1079,  1080,   300,     0,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,  1081,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
       0,   328,   329,   330,   331,     0,     0,   333,     0,   334,
     335,  1082,   337,     0,   338,     0,   339,   340,     0,   341,
     342,   343,   344,   345,     0,   346,     0,     0,     0,   349,
     350,     0,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,  2183,   361,   362,   363,   364,   365,   366,   367,
       0,   368,   369,  2184,   371,   372,   373,   374,  1084,  1085,
       0,  1086,     0,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,     0,     0,   388,     0,   390,   391,   392,
       0,   393,   394,   395,     0,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,  1087,   413,  1088,   415,   416,   417,   418,   419,
     420,   421,     0,     0,   424,     0,   425,   426,   427,   428,
       0,     0,   430,  1089,   432,   433,   434,     0,   435,   436,
       0,     0,   437,   438,   439,     0,     0,   440,   441,  2186,
     443,   444,   445,     0,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,     0,   459,     0,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,  1090,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,   494,   495,   496,   497,
     498,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,   513,     0,   514,   515,
    2187,   517,   518,   519,   520,   521,  1092,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,     0,   538,     0,   539,   540,     0,   541,   542,
     543,   544,   545,   546,   547,     0,   548,  1093,  1094,     0,
       0,   551,   552,     0,   554,     0,     0,   556,   557,   558,
     559,   560,   561,   562,   563,     0,     0,   564,   565,   566,
     567,   568,     0,     0,   569,   570,   571,   572,   573,     0,
    1095,  2188,   576,   577,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,   610,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     600,   601,   602,     0,     0,     0,   230,   231,   232,   233,
     234,   235,   236,   237,     0,   238,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,     0,   243,   244,
     245,     0,   247,   248,   249,   250,   251,     0,   253,   254,
       0,   255,   256,   257,   258,   259,   260,     0,     0,   261,
     262,   263,   264,   265,     0,   266,   267,   268,   269,   270,
       0,     0,     0,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,   281,   282,   283,   284,   285,   286,     0,
       0,   288,   289,   290,     0,     0,     0,     0,     0,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
       0,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,   313,   314,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
       0,   333,     0,   334,   335,   336,   337,     0,   338,     0,
     339,     0,     0,     0,   342,   343,   344,   345,     0,   346,
     347,     0,   348,     0,   350,     0,   351,   352,   353,   354,
     355,     0,   357,   358,   359,   360,     0,   361,   362,   363,
     364,   365,   366,   367,     0,   368,     0,   370,   371,   372,
     373,   374,   375,   376,     0,   377,     0,   378,     0,     0,
     381,     0,   383,   384,   385,   386,   387,     0,     0,   388,
     389,     0,   391,     0,     0,   393,   394,   395,     0,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   428,     0,   429,   430,   431,   432,   433,
     434,     0,   435,   436,     0,     0,   437,   438,   439,     0,
       0,   440,   441,   442,     0,   444,     0,   446,   447,   448,
     449,   450,   451,   452,     0,   454,   455,     0,     0,   456,
     457,   458,   459,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,   471,     0,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,     0,
     494,   495,   496,   497,   498,   499,     0,   501,   502,   503,
     504,   505,   506,   507,   508,     0,   509,   510,   511,   512,
     513,     0,   514,   515,   516,   517,   518,     0,   520,   521,
     522,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,     0,   539,
     540,     0,   541,     0,   543,   544,   545,   546,   547,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,     0,
       0,   564,   565,   566,   567,   568,     0,     0,   569,   570,
     571,   572,   573,   574,   575,     0,   576,     0,   578,   579,
     580,   581,     0,     0,   582,     0,     0,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,  1073,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
       0,     0,     0,   241,   242,     0,   243,   244,   245,   246,
     247,   248,   249,     0,  1074,   252,  1075,  1076,     0,   255,
     256,   257,   258,   259,   260,     0,     0,   261,   262,  1077,
    1078,   265,     0,   266,   267,   268,   269,     0,     0,   271,
       0,   272,   273,   274,   275,   276,   277,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,   287,   288,
     289,   290,     0,     0,     0,   291,     0,     0,     0,   292,
     293,   294,   295,   296,   297,  1079,  1080,   300,     0,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,  1081,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,     0,   328,   329,   330,   331,     0,     0,   333,
       0,   334,   335,  1082,   337,     0,   338,     0,   339,   340,
       0,   341,   342,   343,   344,   345,     0,   346,     0,     0,
       0,   349,   350,     0,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,   369,     0,   371,   372,   373,   374,
    1084,  1085,     0,  1086,     0,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,     0,     0,   388,     0,   390,
     391,   392,     0,   393,   394,   395,     0,     0,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,  1087,   413,  1088,   415,   416,   417,
     418,   419,   420,   421,     0,     0,   424,     0,   425,   426,
     427,   428,  2282,     0,   430,  1089,   432,   433,   434,     0,
     435,   436,     0,     0,   437,   438,   439,     0,     0,   440,
     441,     0,   443,   444,   445,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,     0,
     459,     0,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,  1090,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,     0,
     514,   515,  2187,   517,   518,   519,   520,   521,  1092,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,     0,   538,     0,   539,   540,  3996,
     541,   542,   543,   544,   545,   546,   547,     0,   548,  1093,
    1094,     0,     0,   551,   552,     0,   554,     0,     0,   556,
     557,   558,   559,   560,   561,   562,   563,     0,     0,   564,
     565,   566,   567,   568,     0,     0,   569,   570,   571,   572,
     573,     0,  1095,     0,   576,   577,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,  1073,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   600,   601,   602,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   236,   237,     0,   238,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,     0,
     243,   244,   245,   246,   247,   248,   249,     0,  1074,   252,
    1075,  1076,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,  1077,  1078,   265,     0,   266,   267,   268,
     269,     0,     0,   271,     0,   272,   273,   274,   275,   276,
     277,   278,   279,   280,     0,   281,   282,   283,   284,   285,
     286,     0,   287,   288,   289,   290,     0,     0,     0,   291,
       0,     0,     0,   292,   293,   294,   295,   296,   297,  1079,
    1080,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   309,   310,   311,     0,     0,   312,   313,
    1081,   315,   316,     0,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,     0,   328,   329,   330,
     331,     0,     0,   333,     0,   334,   335,  1082,   337,     0,
     338,     0,   339,   340,     0,   341,   342,   343,   344,   345,
       0,   346,     0,     0,     0,   349,   350,     0,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,     0,   361,
     362,   363,   364,   365,   366,   367,     0,   368,   369,     0,
     371,   372,   373,   374,  1084,  1085,     0,  1086,     0,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,     0,
       0,   388,     0,   390,   391,   392,     0,   393,   394,   395,
       0,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,  1087,   413,
    1088,   415,   416,   417,   418,   419,   420,   421,  2355,     0,
     424,     0,   425,   426,   427,   428,     0,     0,   430,  1089,
     432,   433,   434,     0,   435,   436,     0,     0,   437,   438,
     439,     0,     0,   440,   441,     0,   443,   444,   445,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
       0,   456,   457,     0,   459,     0,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
    1090,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,   494,   495,   496,   497,   498,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,     0,   509,   510,
     511,   512,   513,     0,   514,   515,  1091,   517,   518,   519,
     520,   521,  1092,   523,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,     0,   538,
       0,   539,   540,     0,   541,   542,   543,   544,   545,   546,
     547,     0,   548,  1093,  1094,     0,     0,   551,   552,     0,
     554,     0,     0,   556,   557,   558,   559,   560,   561,   562,
     563,     0,     0,   564,   565,   566,   567,   568,     0,     0,
     569,   570,   571,   572,   573,     0,  1095,     0,   576,   577,
     578,   579,   580,   581,     0,     0,   582,     0,     0,   583,
     584,   585,   586,   587,   588,  1073,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   600,   601,   602,     0,
       0,     0,   230,   231,   232,   233,   234,   235,   236,   237,
       0,   238,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,     0,   243,   244,   245,   246,   247,   248,
     249,     0,  1074,   252,  1075,  1076,     0,   255,   256,   257,
     258,   259,   260,     0,     0,   261,   262,  1077,  1078,   265,
       0,   266,   267,   268,   269,     0,     0,   271,     0,   272,
     273,   274,   275,   276,   277,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0,   287,   288,   289,   290,
       0,     0,     0,   291,     0,     0,     0,   292,   293,   294,
     295,   296,   297,  1079,  1080,   300,     0,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,  1081,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
       0,   328,   329,   330,   331,     0,     0,   333,     0,   334,
     335,  1082,   337,     0,   338,     0,   339,   340,     0,   341,
     342,   343,   344,   345,     0,   346,     0,     0,     0,   349,
     350,     0,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,     0,   361,   362,   363,   364,   365,   366,   367,
       0,   368,   369,     0,   371,   372,   373,   374,  1084,  1085,
       0,  1086,     0,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,     0,     0,   388,     0,   390,   391,   392,
       0,   393,   394,   395,     0,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,  1087,   413,  1088,   415,   416,   417,   418,   419,
     420,   421,  3800,     0,   424,     0,   425,   426,   427,   428,
       0,     0,   430,  1089,   432,   433,   434,     0,   435,   436,
       0,     0,   437,   438,   439,     0,     0,   440,   441,     0,
     443,   444,   445,     0,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,     0,   459,     0,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,  1090,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,   494,   495,   496,   497,
     498,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,   513,     0,   514,   515,
    1091,   517,   518,   519,   520,   521,  1092,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,     0,   538,     0,   539,   540,     0,   541,   542,
     543,   544,   545,   546,   547,     0,   548,  1093,  1094,     0,
       0,   551,   552,     0,   554,     0,     0,   556,   557,   558,
     559,   560,   561,   562,   563,     0,     0,   564,   565,   566,
     567,   568,     0,     0,   569,   570,   571,   572,   573,     0,
    1095,     0,   576,   577,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,  1073,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     600,   601,   602,     0,     0,     0,   230,   231,   232,   233,
     234,   235,   236,   237,     0,   238,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,     0,   243,   244,
     245,   246,   247,   248,   249,     0,  1074,   252,  1075,  1076,
       0,   255,   256,   257,   258,   259,   260,     0,     0,   261,
     262,  1077,  1078,   265,     0,   266,   267,   268,   269,     0,
       0,   271,     0,   272,   273,   274,   275,   276,   277,   278,
     279,   280,     0,   281,   282,   283,   284,   285,   286,     0,
     287,   288,   289,   290,     0,     0,     0,   291,     0,     0,
       0,   292,   293,   294,   295,   296,   297,  1079,  1080,   300,
       0,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,   313,  1081,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,     0,   328,   329,   330,   331,     0,
       0,   333,     0,   334,   335,  1082,   337,  5368,   338,     0,
     339,   340,     0,   341,   342,   343,   344,   345,     0,   346,
       0,     0,     0,   349,   350,     0,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,     0,   361,   362,   363,
     364,   365,   366,   367,     0,   368,   369,     0,   371,   372,
     373,   374,  1084,  1085,     0,  1086,     0,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,     0,     0,   388,
       0,   390,   391,   392,     0,   393,   394,   395,     0,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,  1087,   413,  1088,   415,
     416,   417,   418,   419,   420,   421,     0,     0,   424,     0,
     425,   426,   427,   428,     0,     0,   430,  1089,   432,   433,
     434,     0,   435,   436,     0,     0,   437,   438,   439,     0,
       0,   440,   441,     0,   443,   444,   445,     0,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   456,
     457,     0,   459,     0,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,  1090,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,   493,
     494,   495,   496,   497,   498,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,     0,   509,   510,   511,   512,
     513,     0,   514,   515,  1091,   517,   518,   519,   520,   521,
    1092,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,     0,   538,     0,   539,
     540,     0,   541,   542,   543,   544,   545,   546,   547,     0,
     548,  1093,  1094,     0,     0,   551,   552,     0,   554,     0,
       0,   556,   557,   558,   559,   560,   561,   562,   563,     0,
       0,   564,   565,   566,   567,   568,     0,     0,   569,   570,
     571,   572,   573,     0,  1095,     0,   576,   577,   578,   579,
     580,   581,     0,     0,   582,     0,     0,   583,   584,   585,
     586,   587,   588,  1073,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   600,   601,   602,     0,     0,     0,
     230,   231,   232,   233,   234,   235,   236,   237,     0,   238,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,     0,   243,   244,   245,   246,   247,   248,   249,     0,
    1074,   252,  1075,  1076,     0,   255,   256,   257,   258,   259,
     260,     0,     0,   261,   262,  1077,  1078,   265,     0,   266,
     267,   268,   269,     0,     0,   271,     0,   272,   273,   274,
     275,   276,   277,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,   287,   288,   289,   290,     0,     0,
       0,   291,     0,     0,     0,   292,   293,   294,   295,   296,
     297,  1079,  1080,   300,     0,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,  1081,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,     0,   328,
     329,   330,   331,     0,     0,   333,     0,   334,   335,  1082,
     337,     0,   338,     0,   339,   340,     0,   341,   342,   343,
     344,   345,     0,   346,     0,     0,     0,   349,   350,     0,
     351,   352,   353,   354,  1083,   356,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
     369,     0,   371,   372,   373,   374,  1084,  1085,     0,  1086,
       0,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,     0,     0,   388,     0,   390,   391,   392,     0,   393,
     394,   395,     0,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
    1087,   413,  1088,   415,   416,   417,   418,   419,   420,   421,
       0,     0,   424,     0,   425,   426,   427,   428,     0,     0,
     430,  1089,   432,   433,   434,     0,   435,   436,     0,     0,
     437,   438,   439,     0,     0,   440,   441,     0,   443,   444,
     445,     0,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,     0,   459,     0,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,  1090,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,   494,   495,   496,   497,   498,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,   513,     0,   514,   515,  1091,   517,
     518,   519,   520,   521,  1092,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
       0,   538,     0,   539,   540,     0,   541,   542,   543,   544,
     545,   546,   547,     0,   548,  1093,  1094,     0,     0,   551,
     552,     0,   554,     0,     0,   556,   557,   558,   559,   560,
     561,   562,   563,     0,     0,   564,   565,   566,   567,   568,
       0,     0,   569,   570,   571,   572,   573,     0,  1095,     0,
     576,   577,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   588,  1073,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   600,   601,
     602,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
       0,     0,     0,   241,   242,     0,   243,   244,   245,   246,
     247,   248,   249,     0,  1074,   252,  1075,  1076,     0,   255,
     256,   257,   258,   259,   260,     0,     0,   261,   262,  1077,
    1078,   265,     0,   266,   267,   268,   269,     0,     0,   271,
       0,   272,   273,   274,   275,   276,   277,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,   287,   288,
     289,   290,     0,     0,     0,   291,     0,     0,     0,   292,
     293,   294,   295,   296,   297,  1079,  1080,   300,     0,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,  1081,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,     0,   328,   329,   330,   331,     0,     0,   333,
       0,   334,   335,  1082,   337,     0,   338,     0,   339,   340,
       0,   341,   342,   343,   344,   345,     0,   346,     0,     0,
       0,   349,   350,     0,   351,   352,   353,   354,  1141,   356,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,   369,     0,   371,   372,   373,   374,
    1084,  1085,     0,  1086,     0,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,     0,     0,   388,     0,   390,
     391,   392,     0,   393,   394,   395,     0,     0,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,  1087,   413,  1088,   415,   416,   417,
     418,   419,   420,   421,     0,     0,   424,     0,   425,   426,
     427,   428,     0,     0,   430,  1089,   432,   433,   434,     0,
     435,   436,     0,     0,   437,   438,   439,     0,     0,   440,
     441,     0,   443,   444,   445,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,     0,
     459,     0,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,  1090,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,     0,
     514,   515,  1091,   517,   518,   519,   520,   521,  1092,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,     0,   538,     0,   539,   540,     0,
     541,   542,   543,   544,   545,   546,   547,     0,   548,  1093,
    1094,     0,     0,   551,   552,     0,   554,     0,     0,   556,
     557,   558,   559,   560,   561,   562,   563,     0,     0,   564,
     565,   566,   567,   568,     0,     0,   569,   570,   571,   572,
     573,     0,  1095,     0,   576,   577,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,  1073,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   600,   601,   602,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   236,   237,     0,   238,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,     0,
     243,   244,   245,   246,   247,   248,   249,     0,  1074,   252,
    1075,  1076,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,  1077,  1078,   265,     0,   266,   267,   268,
     269,     0,     0,   271,     0,   272,   273,   274,   275,   276,
     277,   278,   279,   280,     0,   281,   282,   283,   284,   285,
     286,     0,   287,   288,   289,   290,     0,     0,     0,   291,
       0,     0,     0,   292,   293,   294,   295,   296,   297,  1079,
    1080,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   309,   310,   311,     0,     0,   312,   313,
    1081,   315,   316,     0,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,     0,   328,   329,   330,
     331,     0,     0,   333,     0,   334,   335,  1082,   337,     0,
     338,     0,   339,   340,     0,   341,   342,   343,   344,   345,
       0,   346,     0,     0,     0,   349,   350,     0,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,     0,   361,
     362,   363,   364,   365,   366,   367,     0,   368,   369,     0,
     371,   372,   373,   374,  1084,  1085,     0,  1086,     0,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,     0,
       0,   388,     0,   390,   391,   392,     0,   393,   394,   395,
       0,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,  1087,   413,
    1088,   415,   416,   417,   418,   419,   420,   421,     0,     0,
     424,     0,   425,   426,   427,   428,     0,     0,   430,  1089,
     432,   433,   434,     0,   435,   436,     0,     0,   437,   438,
     439,     0,     0,   440,   441,     0,   443,   444,   445,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
       0,   456,   457,     0,   459,     0,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
    1090,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,   494,   495,   496,   497,   498,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,     0,   509,   510,
     511,   512,   513,     0,   514,   515,  1091,   517,   518,   519,
     520,   521,  1092,   523,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,     0,   538,
       0,   539,   540,     0,   541,   542,   543,   544,   545,   546,
     547,     0,   548,  1093,  1094,     0,     0,   551,   552,     0,
     554,     0,     0,   556,   557,   558,   559,   560,   561,   562,
     563,     0,     0,   564,   565,   566,   567,   568,     0,     0,
     569,   570,   571,   572,   573,     0,  1095,     0,   576,   577,
     578,   579,   580,   581,     0,     0,   582,     0,     0,   583,
     584,   585,   586,   587,   588,  1073,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   600,   601,   602,     0,
       0,     0,   230,   231,   232,   233,   234,   235,   236,   237,
       0,   238,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,     0,   243,   244,   245,   246,   247,   248,
     249,     0,  1074,   252,  1075,  1076,     0,   255,   256,   257,
     258,   259,   260,     0,     0,   261,   262,  1077,  1078,   265,
       0,   266,   267,   268,   269,     0,     0,   271,     0,   272,
     273,   274,   275,   276,   277,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0,   287,   288,   289,   290,
       0,     0,     0,   291,     0,     0,     0,   292,   293,   294,
     295,   296,   297,  1079,  1080,   300,     0,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,  1081,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
       0,   328,   329,   330,   331,     0,     0,   333,     0,   334,
     335,  1082,   337,     0,   338,     0,   339,   340,     0,   341,
     342,   343,   344,   345,     0,   346,     0,     0,     0,   349,
     350,     0,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,     0,   361,   362,   363,   364,   365,   366,   367,
       0,   368,   369,     0,   371,   372,   373,   374,  1084,  1085,
       0,  1086,     0,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,     0,     0,   388,     0,   390,   391,   392,
       0,   393,   394,   395,     0,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,  1087,   413,  1088,   415,   416,   417,   418,   419,
     420,   421,     0,     0,   424,     0,   425,   426,   427,   428,
       0,     0,   430,  1089,   432,   433,   434,     0,   435,   436,
       0,     0,   437,   438,   439,     0,     0,   440,   441,     0,
     443,   444,   445,     0,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,     0,   459,     0,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,  1090,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,   494,   495,   496,   497,
     498,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,   513,     0,   514,   515,
    2187,   517,   518,   519,   520,   521,  1092,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,     0,   538,     0,   539,   540,     0,   541,   542,
     543,   544,   545,   546,   547,     0,   548,  1093,  1094,     0,
       0,   551,   552,     0,   554,     0,     0,   556,   557,   558,
     559,   560,   561,   562,   563,     0,     0,   564,   565,   566,
     567,   568,     0,     0,   569,   570,   571,   572,   573,     0,
    1095,     0,   576,   577,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,  1073,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     600,   601,   602,     0,     0,     0,   230,   231,   232,   233,
     234,   235,   236,   237,     0,   238,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,     0,   243,   244,
     245,   246,   247,   248,   249,     0,  1074,   252,  1075,  1076,
       0,   255,   256,   257,   258,   259,   260,     0,     0,   261,
     262,  1077,  1078,   265,     0,   266,   267,   268,   269,     0,
       0,   271,     0,   272,   273,   274,   275,   276,   277,   278,
     279,   280,     0,   281,   282,   283,   284,   285,   286,     0,
     287,   288,   289,   290,     0,     0,     0,   291,     0,     0,
       0,   292,   293,   294,   295,   296,   297,  1079,  1080,   300,
       0,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,   313,  1081,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,     0,   328,   329,   330,   331,     0,
       0,   333,     0,   334,   335,  1082,   337,     0,   338,     0,
     339,   340,     0,   341,   342,   343,   344,   345,     0,   346,
       0,     0,     0,   349,   350,     0,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,     0,   361,   362,   363,
     364,   365,   366,   367,     0,   368,   369,     0,   371,   372,
     373,   374,  1084,  1085,     0,  1086,     0,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,     0,     0,   388,
       0,   390,   391,   392,     0,   393,   394,   395,     0,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,  1087,   413,  1088,   415,
     416,   417,   418,   419,   420,   421,     0,     0,   424,     0,
     425,   426,   427,   428,     0,     0,   430,  1089,   432,   433,
     434,     0,   435,   436,     0,     0,   437,   438,   439,     0,
       0,   440,   441,     0,   443,   444,   445,     0,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   456,
     457,     0,   459,     0,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,  1090,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,   493,
     494,   495,   496,   497,   498,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,     0,   509,   510,   511,   512,
     513,     0,   514,   515,     0,   517,   518,   519,   520,   521,
    1092,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,     0,   538,     0,   539,
     540,     0,   541,   542,   543,   544,   545,   546,   547,     0,
     548,  1093,  1094,     0,     0,   551,   552,     0,   554,     0,
       0,   556,   557,   558,   559,   560,   561,   562,   563,     0,
       0,   564,   565,   566,   567,   568,     0,     0,   569,   570,
     571,   572,   573,     0,  1095,     0,   576,   577,   578,   579,
     580,   581,     0,     0,   582,     0,     0,   583,   584,   585,
     586,   587,   588,  1073,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   600,   601,   602,     0,     0,     0,
     230,   231,   232,   233,   234,   235,   236,   237,     0,   238,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,     0,   243,   244,   245,   246,   247,   248,   249,     0,
       0,   252,     0,     0,     0,   255,   256,   257,   258,   259,
     260,     0,     0,   261,   262,     0,     0,   265,     0,   266,
     267,   268,   269,     0,     0,   271,     0,   272,   273,   274,
     275,   276,   277,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,   287,   288,   289,   290,     0,     0,
       0,   291,     0,     0,     0,   292,   293,   294,   295,   296,
     297,     0,     0,   300,     0,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,   314,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,     0,   328,
     329,   330,   331,     0,     0,   333,     0,   334,   335,     0,
     337,     0,   338,     0,   339,   340,     0,   341,   342,   343,
     344,   345,     0,   346,     0,     0,     0,   349,   350,     0,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
     369,     0,   371,   372,   373,   374,     0,     0,     0,     0,
       0,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,     0,     0,   388,     0,   390,   391,   392,     0,   393,
     394,   395,     0,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
       0,   413,     0,   415,   416,   417,   418,   419,   420,   421,
       0,     0,   424,     0,   425,   426,   427,   428,     0,     0,
     430,     0,   432,   433,   434,     0,   435,   436,     0,     0,
     437,   438,   439,     0,     0,   440,   441,     0,   443,   444,
     445,     0,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,     0,   459,     0,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,     0,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,   494,   495,   496,   497,   498,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,   513,     0,   514,   515,     0,   517,
     518,   519,   520,   521,     0,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
       0,   538,     0,   539,   540,     0,   541,   542,   543,   544,
     545,   546,   547,     0,   548,     0,     0,     0,     0,   551,
     552,     0,   554,     0,     0,   556,   557,   558,   559,   560,
     561,   562,   563,     0,     0,   564,   565,   566,   567,   568,
       0,     0,   569,   570,   571,   572,   573,     0,     0,     0,
     576,   577,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   588,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   600,   601,
     602
};

static const yytype_int16 yycheck[] =
{
       6,   206,    37,    52,    45,   638,     0,   922,  1164,     0,
    1572,   671,     0,   801,     0,   950,     0,    23,   803,    25,
     750,   751,   752,    29,   206,  1121,   756,    21,  1091,    35,
      36,    37,  1445,    39,   201,   184,    42,    43,  1186,    45,
    1507,    47,   209,   954,   852,   212,   863,  2725,   825,   939,
    1491,   948,   923,  1484,  2526,    13,   192,    22,   718,     6,
    2598,  1094,  1036,    28,    46,  1223,  1496,  1732,   211,  2191,
    2192,  3073,   826,  3046,  1811,  1079,  1080,   810,  1491,   629,
      23,  2354,   225,  2891,  1982,  1089,  3342,  2941,  1636,  3692,
    3646,    18,   779,     0,    37,  2001,  3361,   671,   875,  2539,
    3389,  2439,  1025,  3392,  3099,  2418,  3101,     0,   888,  2701,
    3590,  2950,   717,  3744,    21,  3968,  3296,  3688,  1041,  3929,
    1010,   171,  3626,   707,  1014,  3985,  2915,  3973,   952,  1019,
     680,  2090,  3692,   913,  4482,  4598,  1603,  1604,   918,  1029,
     692,  3779,  2817,   695,  3372,  4490,   806,   186,     0,  2046,
      51,     0,     0,  1043,     0,  3620,  1474,  2123,  1823,  2157,
     186,     0,  3972,     0,     0,     8,     0,  1597,  2134,   712,
     830,  1422,    15,  4433,    36,    42,  4237,  1914,   694,   220,
     957,    43,  1072,   843,     0,     0,   192,   193,   194,   195,
       0,   197,   708,  2155,  1624,   201,     0,   203,  2960,   873,
     206,  3668,  4760,   209,  2844,  3359,   212,   849,   849,   215,
    4614,   217,  4616,  1369,   220,  4813,  1534,  4672,   224,  3551,
     226,  4481,    11,     6,     0,     0,    51,  5036,     6,     0,
      74,    59,   806,  1551,  4801,     0,     6,     6,    89,   913,
      37,  3625,    28,  3627,   918,    15,    16,     6,     6,  1253,
    1254,  1284,  1077,  1078,    34,  2023,  2529,     6,     0,  4714,
       6,     0,    13,  1088,   114,     6,    15,    16,    24,    11,
    1274,     6,    11,  1003,    15,    16,     6,    11,   161,  2954,
      13,     5,  4110,     6,    28,  3307,    28,    11,  2485,    28,
    2487,    42,   121,  1110,  2491,   166,  2493,  2494,     6,     6,
    1634,  1635,    59,  4721,  4722,  2502,  2503,  2504,  4057,  4058,
      28,  4060,  4061,  4062,  4063,  4064,  1437,   173,   183,    59,
      13,   166,    41,    74,  5012,     3,     6,    28,    81,    76,
     114,  3048,     6,   210,    35,   167,   114,   178,    86,    86,
     166,     6,   116,    41,   146,   107,     6,   166,  3986,    42,
      59,     5,     3,     0,     5,     6,   146,    11,     6,   273,
      11,    79,   273,  1050,  4746,    28,   279,   168,  2641,    87,
    2643,  4913,    35,    59,    21,   119,   298,   133,    59,   284,
     298,    74,   278,   167,   298,   284,   177,   298,   166,   620,
     166,   166,    60,    72,   766,   166,   107,   115,   765,    44,
      68,   166,   116,  5212,   349,    52,   889,   353,    44,    40,
    5338,  5339,  1386,   922,   190,   190,   367,  1242,  1243,   190,
     140,   243,   931,    28,   166,   190,   166,   166,   325,   158,
      13,   168,   941,   143,   267,  2888,   114,   349,   395,    38,
     214,   118,    24,  2378,  1269,   117,   116,   407,   190,    93,
      59,   190,   170,  1364,  4802,  1352,   638,   431,   447,   114,
     204,   394,   166,   114,   441,   183,   162,   450,    31,   145,
    1789,  5038,   476,  4877,    76,  4930,     5,   195,   488,   280,
     264,   491,    11,   714,    86,   489,  1146,   338,  2941,   263,
     473,     6,    55,   636,  1813,  1558,    28,   430,  4754,   642,
     196,    59,   491,    35,  1164,    76,   161,   689,   119,    76,
     487,   339,   655,   487,   186,  5203,   192,   429,   228,    86,
    2455,    76,  1209,   128,   123,   254,    76,  1304,   172,   320,
     487,   491,  5341,    76,   211,   357,   487,   450,   294,   186,
     373,   487,   487,   280,   214,   166,   443,   321,   259,    59,
      76,   133,    76,  5481,   268,  1332,   928,   188,   209,   350,
     927,  1166,   166,   231,   795,   487,   166,   369,  1228,   487,
     218,  5113,  1146,   487,   487,  1486,   487,   333,   116,   369,
     231,   135,   339,   488,   385,   263,   491,    13,   407,  3306,
     268,   487,   491,   263,   435,  4977,    31,   276,  1422,  3779,
     320,   375,   431,   268,   487,  5414,   190,   147,   268,   395,
     366,   617,  1128,   353,   491,   359,    42,   623,  1541,   625,
     491,   627,   487,   629,  3804,   631,   476,   407,   622,   407,
     339,   622,   638,   395,   622,   491,   622,   643,   622,   645,
     491,   485,   487,  5201,  5211,   489,   652,   431,    74,  1770,
      28,   321,  4132,   339,  1228,   487,  4160,   440,   339,   407,
     407,  4917,   487,   491,   382,   491,  1589,   385,   421,   718,
     676,  5480,   722,   392,   680,   376,  1192,  1567,   434,   685,
    1570,  1164,  5030,   689,  3940,   429,   692,  1347,    13,   695,
     487,   618,  1208,  3695,   392,  1355,  1356,   486,   476,  1634,
    1635,  1636,   442,   852,   487,   711,  4171,  1578,  1224,  1369,
    4175,   489,  5521,   376,   490,   490,  3981,   487,   487,   490,
    2993,   762,  5410,   717,  5142,   490,  3982,   485,   487,   487,
     339,   489,   483,  4561,   491,  1632,   478,   479,   487,   478,
     479,   487,  1522,  4075,   478,   479,   487,  5345,   490,  4216,
     483,   490,   487,  2087,   478,   479,   762,   487,   716,   765,
     766,   767,  1404,  1404,   487,  5332,   731,   487,   733,   974,
     735,   407,   452,  1347,   780,  4159,   741,  4161,   452,   487,
     487,   339,   491,   487,   366,   826,  4535,   480,   481,   482,
     483,   436,   974,   473,   800,   801,   450,   803,   804,   473,
     436,   840,   808,   970,  1952,   491,  3986,   487,  1482,   976,
     491,   718,   979,   487,   840,   856,   822,  5272,   429,   473,
     826,   491,  1918,   959,   478,   479,   832,   478,   479,   339,
    5285,   872,    22,  1641,  1377,    36,   407,  5241,   844,    27,
     407,  2963,  2272,  2965,   376,  4906,  4477,   429,   842,  5416,
     856,   842,   407,   108,   842,  5111,   842,   407,   842,  5207,
    5116,  1535,  2303,  1959,   407,  5210,   872,  1350,   383,   384,
     491,    31,  1355,  1356,  1970,    83,  1880,  4031,  1552,  3519,
    3193,   407,   491,   407,   890,   202,  1369,   491,  3890,   895,
     896,   491,   446,  3333,   211,   433,  1529,   480,   481,   482,
     483,   336,   745,   765,   766,   767,   446,   491,   225,     6,
     107,     6,  5479,   114,    59,   194,  3889,   125,  3680,  2349,
     166,   927,   928,  2921,  5184,   303,  2474,   119,   284,     3,
     107,  5386,   833,   491,    26,   842,   264,   804,  2904,   194,
    3962,   808,   114,  1767,   950,   951,  5206,   166,   119,   842,
     107,  1460,  2203,   959,  5512,    47,   146,    83,  2920,   107,
     107,   293,     3,   349,   970,     6,  5420,  5421,   974,    49,
     976,   190,   865,   979,  2292,   622,   114,   441,   178,  1462,
     168,   491,  4792,   361,   326,  5333,  5449,   351,   994,  1472,
     842,  3666,  2951,   842,   842,   278,   842,  5342,  2895,   125,
    3273,  3274,    24,   842,   163,   842,   842,   452,   842,   395,
    1016,    85,   204,  1522,   166,  3804,  2578,  1023,  1024,  2787,
    2788,   399,     6,   401,  2792,    83,   842,   842,   473,   431,
    1855,  1856,   842,   204,   366,  4008,  4596,   313,   842,  1045,
    1046,  1047,   487,  1049,  4647,  1051,  1052,  1053,   412,   259,
     178,  4689,   478,   479,   480,   481,   482,   483,   114,   259,
    2216,  2829,  2830,    86,   138,   927,   928,   125,   109,  5523,
     717,   718,  4552,   279,  4634,  3272,  1559,  5422,   353,  1562,
    1563,  5426,   282,   284,   273,   487,    64,  4647,   296,  2000,
    1820,   114,   161,  3366,   436,  4599,   268,  3951,   353,    10,
      59,   429,    13,   168,   273,   185,    17,    18,    19,   298,
     190,   133,    10,   205,    68,  1121,   395,  1123,  1124,    17,
      18,    19,   196,   109,  2187,   263,   128,   315,   130,   298,
    1057,   259,  2043,  5478,   119,   491,    24,    24,  4603,   394,
     395,   182,    30,  4608,   143,   259,  4611,   227,    68,  4995,
    1156,   278,  2087,   478,   479,   480,   481,   482,   483,   349,
     114,   407,     3,   351,  3617,  2596,    86,  3620,   109,    29,
     296,   268,  1166,   268,  3296,  5028,   336,  5522,  2089,   369,
    1186,  1187,  1967,  1968,  4994,  1191,  5032,  1193,  5048,   349,
      97,   351,   400,   840,   339,   842,   182,  5542,   395,    24,
    5545,   395,   243,   108,    68,   246,   363,  4472,  1214,   208,
    4466,   487,   487,  4502,  1220,   353,   170,  1223,   395,   204,
    1226,  5031,   410,   415,   144,   279,   300,     5,   416,  4231,
    2054,   450,   487,    11,  1240,   435,   292,   429,   296,  3692,
     263,   182,   318,   163,    85,   133,   133,   395,   395,   455,
     315,  4479,   412,  4813,  1303,   407,  2191,   243,   429,   469,
     246,  1744,    83,  2040,  3386,  1271,   335,   216,   175,  1929,
    1854,   273,   294,    83,   400,   476,   160,    24,  4273,   190,
     144,   259,   293,    30,   485,   284,   487,   488,   489,   194,
     491,   371,  1842,  1299,  1300,  1301,   137,  1303,   487,   163,
     259,   212,   243,   359,   125,   246,   167,   435,   133,   263,
     259,   333,   175,   366,   268,   125,   357,  1323,   487,   636,
    5353,   435,  1372,  1928,   476,   642,  1169,  1911,  1171,   366,
    1173,  1883,  1175,  4904,  1177,  1178,  1179,   489,   655,   395,
     178,  1184,   400,   279,   366,   205,  1898,  1529,   422,  1901,
    1389,  1390,   259,  1392,   119,  1361,   430,   311,   485,   433,
    4840,   279,   489,  1389,  1390,  1406,  1392,   106,   133,   280,
    1886,   357,   321,   327,   359,  4214,   293,   117,  1921,  2203,
     339,   437,   280,  2168,  1900,  1391,   133,  4686,  2021,  1395,
    1396,   311,    28,   234,   450,   282,   450,  1913,   147,   366,
    1406,  1407,  1408,  5034,  1410,   344,   294,   366,  4873,  1961,
     118,   487,  1964,  1965,   171,  1958,   357,   473,  1535,  1962,
     369,   259,   306,  1966,   423,    85,  1969,   468,  1434,   167,
    4729,   487,   407,   240,    10,  1552,   297,    13,   491,    32,
      33,    17,    18,    19,   429,   333,   186,   311,   353,   366,
     337,   338,  4932,   294,   491,   333,   294,  4937,  4938,  3997,
    4052,    34,   200,  1469,  2124,  5498,   126,   293,  1474,   294,
     424,  1477,   409,  2388,   231,   296,   136,   215,   366,   366,
     429,   344,   468,   240,  1490,  1491,   296,   225,   158,   394,
     395,   430,   128,  1499,   294,   333,  1502,   404,  3951,    51,
      93,  5104,   241,   211,   424,   244,  4276,   126,   333,  4689,
    2334,   372,  2435,  4283,   450,  5075,   491,   136,   216,  1166,
     113,   310,   310,  1529,   491,  1531,  4791,   468,  1534,   407,
    1457,   171,   450,   333,   156,  2359,    24,   282,   431,  2474,
     366,   366,  2638,   308,  5104,  1551,   487,   294,  1554,   294,
     220,  1557,  1593,   105,   147,   182,  2216,   398,  5114,   400,
     424,   259,   171,   474,   475,   476,   366,   478,   479,   480,
     481,   482,   483,  1579,   147,  4803,   474,   475,   476,   400,
     478,   479,   480,   481,   482,   483,   333,  1593,   333,  1236,
     400,   231,   116,   168,   487,  3501,  2420,   435,    88,  1605,
    1606,  1607,  1608,  1609,  3917,   343,   228,   147,   294,  1256,
     359,   116,  2535,  3175,  2368,  2369,   243,  1623,  2372,   366,
     409,   409,   231,  3961,  2448,    24,   201,   217,  1634,  1635,
    1636,    30,  3063,   409,   294,  2558,  2559,  2560,  2561,  3952,
     130,  1288,   399,   156,   401,   133,   395,  2570,   487,  5209,
    1543,   203,   161,   275,   117,  1548,  1303,  3779,  2438,  2209,
    2468,  2469,  2470,   172,   453,   453,   128,   190,   130,   329,
     427,   369,  2595,   333,   198,   294,   237,   453,   259,  3876,
     366,   190,  3804,  3880,  3881,   335,  3883,   487,   437,   169,
    1895,   169,   338,   733,   734,   735,  2520,   442,   738,   739,
     740,   450,  1838,  3440,   280,  3253,   366,   259,   748,   214,
    5266,  3259,  1894,  1895,   333,   228,   325,  1884,  4171,  2609,
     366,   359,  4175,   186,   473,  1618,  1732,   292,  1734,  1622,
     357,   429,   263,   284,   133,   259,   329,   268,   487,   263,
    1746,  1747,  1389,  1390,  3642,  1392,  4748,     0,   156,  4022,
     294,  4024,   333,   161,   337,  5011,  4778,   395,   263,   399,
    1766,   401,  3530,  3531,  3532,  3533,   359,  3197,  3536,  3537,
    3538,  3539,  3540,  3541,  3542,  3543,  3544,  3545,   301,  1785,
    2534,  5046,   294,   366,  2300,  5345,    13,   427,   319,   333,
     399,   407,   401,  2302,   359,  1801,  1802,  1803,  1804,   437,
     450,   263,   395,   355,   301,   356,   490,     5,  1814,  5037,
     333,   273,  3242,    11,   337,  1821,   321,  1823,   427,   359,
     228,   333,  5425,   473,  2374,   337,   325,  3595,  3596,  1835,
     395,   349,  1838,   342,   443,   450,  1842,   398,   316,  2021,
     337,   491,  1848,   366,   437,   450,   450,    74,   441,   487,
    2998,  4529,  4825,    34,   366,   395,    22,   450,  2588,  5419,
     476,   360,    28,   381,  3986,  5425,   427,   275,   348,   366,
     348,    45,   437,   489,   354,   313,   491,  1883,  1884,  2388,
     473,   361,   349,   361,   351,   450,   491,   491,  1894,  1895,
     351,   452,  1898,    67,   487,  1901,   395,   437,   474,   475,
     476,  3368,   478,   479,   480,   481,   482,   483,   473,  2392,
     450,    13,  1918,  1919,  2423,   294,   396,  2400,   396,  1925,
    2403,  1927,   487,  5526,   491,   166,   487,   450,  4923,   264,
     265,   294,  5221,   473,  1928,   333,  1977,   114,   418,  5204,
      42,  2601,   333,   412,   443,   412,  1952,   487,  2457,   190,
     473,   412,   353,  1959,   333,  1961,   272,  1992,  1964,  1965,
    4432,  1967,  1968,  4641,  1970,  4643,  5526,  2971,   366,   161,
     333,  1977,    74,   150,  4646,   366,   356,  5205,  1984,  4252,
    4253,   382,  4654,   106,  2808,  1991,  1992,  5009,  1982,  1995,
    2814,  1982,   184,  1999,  1982,  2001,  1982,  2657,  1982,  4471,
    2006,  2007,   443,   366,  5026,   325,   183,  2013,  2014,  2015,
       6,  4451,  2018,  4821,  2020,  2021,  2022,  2023,  2024,  2025,
    2026,  2027,  1929,  2029,   359,  2031,  2032,  2601,   452,  2035,
     253,  3696,  2719,  2720,   399,   161,   401,   486,   294,   162,
     360,  5063,   491,   218,  2050,  2051,  2052,  2053,  1991,   473,
     487,  2057,  2058,  2258,   277,  3523,  2062,   450,   184,  2065,
     395,   294,  2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,
    2076,  1998,  2078,   196,   242,   395,  2258,   333,  2084,  2085,
     473,  2087,  2890,  2657,  3552,   487,   263,  5060,  2094,  2256,
     116,  5347,  2259,  2260,   487,  1938,   329,  1940,   294,  1942,
     333,  1944,   437,  1946,    94,    93,  5334,  1950,  4421,    76,
     366,   488,   294,  2249,   491,   450,  5118,  2123,   241,    86,
     399,   244,   401,   443,  2130,   113,   412,  1167,  2134,  2135,
    1170,   240,  1172,   366,  1174,   161,  1176,   333,   473,  2145,
    1180,  3909,    94,  4596,  2961,  2688,   412,   337,  2154,  2155,
    4603,   333,   487,   485,   263,  4608,  2299,   489,  4611,   147,
    2893,   321,  2168,  5017,  5186,    26,   335,  4975,   161,  2175,
     366,  2177,   198,   356,   334,   143,   366,   167,  3049,   240,
     370,  4634,  2173,  2218,   366,  2220,    47,  5415,   156,  3751,
     240,   184,    86,   161,  4647,  4392,   192,  4394,  4395,  3347,
     265,  4398,   362,  2209,  3075,   201,   156,   452,  2691,  3357,
     200,   161,  2218,   209,  2220,   167,   212,  4966,  2851,  4968,
      37,  2128,   917,  4972,  4973,   215,  3963,   487,   473,   489,
    2271,  2237,   450,   259,  2377,   225,  2896,   263,    90,    56,
     208,   936,   487,  2249,   939,  2251,  2252,   450,   200,   194,
    2256,  2216,  2258,  2259,  2260,   473,  2262,   242,  2264,  1543,
     228,   251,  2268,   215,  1548,  2271,   278,  5269,  5524,   184,
     473,   283,  5021,   225,   143,   486,   488,   171,   228,   491,
     491,  1928,  3749,   412,  3751,   913,  2292,   156,   491,   106,
     918,   485,   161,   487,   359,  5103,   143,  2303,  3728,   251,
     194,  3742,  1619,  5325,   443,  2311,  2312,   275,   278,   156,
     482,  2454,  2318,   283,   161,   487,   284,   489,  3253,  3984,
      82,  2327,     3,  3481,  3259,   275,   278,  2368,  2369,    55,
     395,  2372,   143,   488,  1618,  1982,   491,   231,  1622,   208,
     356,   329,  2348,  4656,   450,   156,   452,  2353,  2354,    10,
     161,   218,    13,   343,  3784,  3015,    17,    18,    19,   228,
    4813,   208,  2368,  2369,   488,  3339,  2372,   491,  2374,  2375,
    3293,   359,   437,    34,    65,    66,   193,   482,  5380,  3412,
    3413,   228,   487,   487,   489,   450,  5408,   488,     5,   283,
     491,   343,  2398,   488,    11,  2401,   491,   208,    11,   485,
     237,   487,    19,   489,    85,   487,   275,   395,   473,   353,
    3300,   488,  2059,  2896,   491,   284,   278,   228,  2424,  2425,
    4873,    38,   487,   488,   241,   490,    55,   244,   275,   255,
     256,   257,   258,  2439,   237,  2441,  2442,   284,    15,    16,
     237,  3015,   259,   491,  2800,  2988,  2802,  2803,   488,   437,
    2415,   491,  5474,    45,   488,   423,   137,   491,   488,   349,
     350,   491,   450,  5465,   275,   487,  2472,  2473,  2474,  2985,
    2986,  3295,  2478,   284,  1791,   441,   293,   488,  2484,   431,
     491,   488,  1799,   443,   491,   473,  2492,   488,   488,  2495,
     491,   491,    82,  2534,  1811,  2501,  4769,   470,  2033,   487,
     359,  2036,    32,    33,  2510,   399,  2512,   401,  3975,   488,
     214,   488,   491,  5051,   491,   489,   353,  3341,   412,   488,
    2526,   338,   491,  2529,   488,  2531,  2173,   491,  2534,   281,
     424,   488,  2538,   427,   491,  2541,   395,  4734,   450,   488,
     452,  3050,   491,   360,   278,  3693,  3694,  2553,  2554,   488,
     353,   212,   491,   234,   423,   488,   353,  3970,   491,  3990,
     487,   398,   489,   380,  5017,  2571,   161,  4689,  2735,  5377,
    1887,  2738,   349,   350,  2741,  2581,   423,  2583,   437,   281,
     488,     3,  2540,   491,   399,  5263,   401,   237,   278,  2580,
     427,   450,   470,  2729,  4907,   398,  3326,  1914,  2627,  2628,
    2629,   398,  4915,    25,   488,  2611,   488,   491,   488,   491,
     281,   491,   423,   294,   473,   452,  3125,    45,   237,   280,
     301,   450,  5075,   452,   427,   470,   237,  3143,   487,   214,
     427,   399,  2638,   401,  2640,  2641,  2642,  2643,   488,   480,
     488,   491,  3302,   491,  3304,   488,  3162,   165,   491,   452,
     487,  5104,   333,   491,   488,   452,   337,   491,   488,    10,
     490,  3572,    13,    85,   349,   350,    17,    18,    19,  2851,
     488,   488,  2678,  3677,   485,   237,   488,   488,   489,   491,
     676,   487,  5490,    34,   487,   366,   349,   350,   488,   685,
     487,   491,   488,  4815,   488,   491,   692,   491,   488,   695,
     490,    37,   488,   353,   488,   491,   846,   491,   848,   237,
     488,  3465,   488,   491,   832,   491,   138,   398,   488,   400,
      56,   491,  4176,  2729,  4178,  3385,    55,  4289,  3302,  2735,
    3304,   488,  2738,  2915,   353,  2741,  5236,  5237,   210,  3636,
    2789,  3565,   353,   488,  2750,   487,   491,  5555,   398,   166,
     488,   488,  2758,   491,   491,   488,  5209,  2763,   491,   488,
     488,   454,   491,   491,  3675,  5359,  5360,   487,   190,   450,
     106,   489,   488,   488,   196,   491,   491,   427,   487,   398,
    4548,  2787,  2788,  2789,  2833,   488,  2792,   398,   491,   488,
     488,   353,   491,   491,  2800,  2801,  2802,  2803,    51,   487,
     333,  3317,   452,  3319,   190,   148,   488,  2813,   427,   491,
    2816,  3385,  2818,   474,   475,   476,   427,   478,   479,   480,
     481,   482,   483,  2829,  2830,   353,   488,  2833,   488,   491,
    4271,   491,   488,   452,   170,   491,   398,   487,   487,   148,
     488,   452,    95,   491,   489,  2851,   278,  2853,   190,  2855,
     488,  2857,  5324,   491,  3631,   488,   333,   193,   491,   237,
    3750,   212,   148,  2180,   278,   427,   488,   120,   487,   491,
     398,  2877,   190,   148,   488,  2881,   487,   491,   300,   148,
     488,  2198,  2888,   491,   137,   278,   488,  2204,   141,   491,
     452,  2208,  5345,   161,   488,   333,  2945,   491,  2904,   427,
    2882,  2883,  2884,  3720,    10,   241,  2912,    13,   244,   162,
     488,  3454,   165,   491,   148,   488,   488,  2234,   491,   491,
     226,  2927,   344,   259,   452,   487,   116,   180,   488,   280,
     431,   491,   278,  2580,   488,  2941,    42,   491,   242,  2945,
       0,  2888,  2948,    49,  2950,   488,   488,   488,   491,   491,
     491,   272,   488,   487,  3778,   491,  3780,   293,   128,   487,
     130,   237,  2279,   959,  3480,   412,  5419,   488,    74,   443,
     491,   393,  5425,   488,   970,   353,   491,   356,   488,  3803,
     976,   491,  2299,   979,   154,  2991,   488,  2993,   161,   491,
     488,  3862,  2998,   491,  2941,   488,  3886,   218,   491,  3823,
     422,   488,   338,   488,   491,   488,   491,  3490,   430,   488,
     488,   433,   491,   491,  2331,   268,    68,   263,    37,  3025,
     398,  3027,  3028,  3029,   360,   488,   488,   488,   491,   491,
     491,   488,   263,    93,   491,   141,   488,   487,  1156,   491,
    2357,   454,   488,   278,   380,   491,  2363,   488,   488,   427,
     491,   491,   161,  2370,   263,  1051,  1052,  1053,    45,  4122,
    2377,     0,   488,  2380,  3872,   491,   319,   488,    45,  2386,
     491,  4839,   488,  5526,   452,   491,   263,   353,   488,   185,
     417,   491,   263,   143,   190,   255,   256,   257,   258,  2406,
      85,    24,   262,   263,   294,  2412,   156,    30,   268,   443,
    2417,   161,   443,   273,   161,   148,   166,   314,   148,   487,
     487,   148,   172,  2430,  3296,   175,   440,   487,   307,   179,
     487,   227,   398,   474,   475,   476,  2443,   478,   479,   480,
     481,   482,   483,   148,    36,  3141,   148,  2454,   487,    72,
     454,   148,  2789,    68,   491,   148,   148,   148,   208,    74,
     148,   427,   148,   161,    93,   148,   128,   148,   130,   148,
     148,    86,   148,   148,   278,   395,    37,   487,   228,   161,
     226,   161,   487,   278,   280,     6,   452,     6,   161,   487,
     487,     6,   154,     6,   487,  1303,  2833,   487,   487,   114,
     487,   116,   487,   126,   487,   487,   487,   487,   487,   487,
     133,     6,   487,   136,   143,   487,   487,   487,     6,  2856,
     487,   487,   451,   487,   487,   275,   487,   156,   278,   290,
     487,   487,   161,   487,   284,  2872,   487,   166,   487,   162,
     487,   487,   210,   172,    37,    97,   175,   491,    37,   491,
     179,  2888,   226,   491,   414,   170,   161,  3253,   275,   161,
     273,   366,    64,  3259,   407,   425,   407,   353,   407,    37,
     442,   407,  3268,   196,   353,   371,   489,  3273,  3274,   208,
     407,   407,   353,   198,   228,   407,   337,  4188,    56,   476,
     340,   407,   407,   255,   256,   257,   258,   353,   148,   228,
     262,    86,  1410,  4441,  2941,   358,   268,   278,  2945,  4210,
     223,   273,  3308,  3309,  3310,   407,   407,   268,   122,   407,
    5078,   430,   398,   278,   349,   273,   298,   407,   487,  3325,
     407,  3804,   183,   487,    86,   491,   259,   294,   106,   122,
     263,   190,   148,   407,  3375,   395,   275,   431,   263,   278,
     273,  3347,  3348,   268,   395,   284,   431,   122,   407,   282,
     395,  3357,  3358,  3359,   407,   108,   122,  3363,   407,   407,
    3366,   294,    55,   423,    55,   471,   407,   248,   407,  3375,
     318,   407,   478,   479,   480,   481,   482,   483,   407,   407,
    3371,   407,  2699,   407,  4797,   407,   311,   447,   282,   449,
     450,   407,   398,   407,   407,   298,   407,   298,   407,    44,
    2717,   340,   327,   336,   337,    44,   212,  3398,  2725,   491,
     407,   488,   492,   407,   278,   193,   212,  4205,  3934,  3935,
     454,   212,   212,   278,  3465,   485,   212,   407,   488,   489,
     490,   212,   278,   366,   278,   212,   212,   407,  3444,   212,
     487,   417,   414,    37,   148,  4912,    26,   148,   278,   114,
     263,   450,   431,   425,  3603,   234,   395,   278,   148,  3465,
     148,   148,   273,   241,    37,   161,   244,   442,    37,   263,
     487,   263,  3478,   218,   263,  3481,   355,   487,    36,   405,
     407,   259,   487,   487,   423,   405,   407,   487,   407,  4032,
    4033,  4034,  4035,  4036,   407,   148,   148,  3503,   148,   424,
     431,   434,   431,   272,   148,   148,  3512,   407,   447,   267,
     449,   450,  4402,   487,  3520,   293,  3522,   485,   166,  3525,
     248,   485,   446,   248,  3530,  3531,  3532,  3533,    13,   491,
    3536,  3537,  3538,  3539,  3540,  3541,  3542,  3543,  3544,  3545,
     405,   487,   487,  3549,  3550,   175,   485,   157,   166,   488,
     489,   490,  3601,  3559,   407,  4038,   491,  3563,   409,    10,
     338,  3567,    13,  4196,   183,   369,  4501,   183,   208,  3575,
     488,  3620,  3578,   279,  3580,   491,    37,   491,   216,   431,
     287,    55,   360,   488,   431,    10,  3592,   216,    13,  3595,
    3596,    42,   353,   216,  3600,  3601,   487,  3779,    49,  3605,
     268,  3607,   380,   487,   268,   407,   407,   407,  3614,  3615,
    3616,  3617,   356,   161,  3620,  3621,   242,    42,   218,  3625,
    3626,  3627,  3804,    74,    49,   412,  3632,  3609,  3610,  3611,
    3612,   268,   278,   443,    45,   375,   278,   226,   263,     0,
     226,   226,   278,   407,   349,   122,   398,   278,  3642,    74,
     491,  3642,  3658,   333,  3642,   366,  3642,   278,  3642,   184,
     363,   278,   321,    37,   407,   407,  3672,   212,  3674,   284,
    3617,   488,   431,  3620,   431,   218,   317,   148,   273,   476,
     161,    37,   396,   443,  5452,  5453,  3692,  3693,  3694,   273,
    3696,   163,  4422,   363,   318,  3012,   148,   273,   148,   487,
     148,   431,   487,   450,   263,    37,   263,  3713,  3714,  3715,
    3716,   278,   278,   218,   181,   181,   141,   161,    37,   162,
     488,   470,   485,   488,  3371,   357,   246,   218,   363,   470,
    1848,   161,    93,   488,   185,   263,  3742,   488,   488,   190,
     278,   190,   454,   190,  5306,  3692,    25,   173,   190,   190,
     190,  3398,  4268,   491,  3760,   491,   491,   166,   407,   245,
     185,   487,   278,    55,   450,   190,   272,   491,  4916,   443,
     488,   488,   218,   395,   166,   488,   227,   487,   412,   488,
     488,   290,   143,   166,   299,   470,   488,   262,   488,   488,
     289,   488,   487,   491,   488,   156,   488,    55,  4281,   407,
     161,   240,   227,   487,  3986,   166,  3123,  4963,   487,   487,
     487,   172,   487,   236,   175,   472,  4359,  4360,   179,  4362,
     447,   278,   429,   437,   278,   476,   281,   447,   194,   280,
     148,   487,   487,   278,  4350,   407,   407,   407,   202,  1835,
     268,   454,  1838,   151,   407,   263,  3811,   208,   148,   282,
     358,  3857,   366,   148,   148,   280,  4952,  3822,  4954,   226,
     358,   358,   151,   194,   278,   476,   407,   228,   151,   431,
     228,   300,   428,   300,   151,   407,   407,   407,   382,   491,
     407,  1999,   122,  2001,   238,   238,  3892,  1883,  1884,  2007,
     238,   353,   263,   353,   407,  2013,  2014,  2015,   366,  3905,
     407,  3907,  1898,  3909,   407,  1901,  2024,  2025,    44,   148,
    3916,  2029,   407,   407,   275,  4739,  3922,   278,   353,   407,
     371,   353,   486,   284,   407,   407,  3932,   407,   407,   178,
     212,  3248,   212,  4449,   488,   488,   488,   212,   212,   488,
     491,  3947,   488,     3,   417,  3951,   371,   161,    45,   335,
     107,   488,   491,   161,  3601,  3961,    37,   148,   487,   148,
     161,   178,   488,   487,  3970,  1961,   476,   486,  1964,  1965,
    3617,   407,   431,  3620,  3980,   486,   488,   148,  3984,   340,
     353,   353,  4767,   353,   353,  3991,  3992,    10,  3979,   491,
      13,   353,   146,   431,  5150,  3642,   281,   146,   363,   212,
     212,   212,   212,   212,  3951,   212,   212,   212,   139,   485,
    5158,  5159,    13,   166,  4196,  4648,  4022,   290,  4024,    42,
     471,   491,   161,   488,   488,  4031,    49,   478,   479,   480,
     481,   482,   483,   166,   395,   488,   442,   262,   166,   447,
     175,   404,   473,   340,    84,   436,   471,   161,    37,   417,
    4858,    74,   431,   478,   479,   480,   481,   482,   483,   218,
    4066,   407,   423,    55,   488,   487,   148,   488,  4701,   488,
     487,   491,  4078,   488,   487,   491,   431,   202,   398,   382,
     487,   170,   417,   407,    10,   151,   447,    13,   449,   450,
     358,    17,    18,    19,   407,   407,   353,   407,   407,   353,
     488,   488,  4108,   488,   333,  4111,   487,   450,    34,    55,
     398,   437,    10,  4119,  4120,    13,   161,  5052,   141,    74,
    4126,  4127,   278,  3440,   485,  4131,   148,   488,   489,   490,
     107,  4137,   212,   417,  4140,  4141,   488,   212,   212,  4145,
    4146,  3458,   212,   487,    42,  4151,  4152,  4153,  4154,  4155,
    5298,    49,   216,  4159,  4160,  4161,   197,  4163,  4164,   487,
     407,  4167,   185,   454,   491,  4171,  3483,   190,   278,  4175,
     328,   488,    37,   276,  4690,  4181,    74,   491,   298,   278,
       3,   487,   417,   407,   491,   487,   491,   488,   486,   363,
    4196,   172,   107,   166,  4229,   212,   166,    55,   488,  4205,
     448,   488,   488,  4209,   227,   448,   487,   290,  4214,   215,
     488,   288,   215,   397,   285,   491,  4207,  4208,   488,   488,
     487,   487,   487,  4229,  4171,    55,  4232,   179,  4175,   488,
     273,   404,   476,   166,   417,   407,    74,   191,  5394,   196,
     184,   184,   268,   141,   268,   476,  4252,  4253,   450,    55,
     398,    68,   407,  2249,  5169,   491,   407,   280,   491,   148,
    2256,  1096,   407,  2259,  2260,  4271,   151,   407,  1396,   488,
     212,   487,   121,   168,   166,   114,    37,   190,   273,   431,
    4286,  1116,    37,   487,   363,   431,   212,   185,   263,  4949,
     163,  1126,   190,   161,   363,  1130,    55,   273,    80,  1134,
     450,  1136,   398,  4963,  3951,    37,   450,  1142,     6,   166,
    4275,   278,   487,  1148,   161,   199,  1151,   281,   166,   210,
    4285,   487,   487,  4866,  5148,   436,   379,   488,   488,   227,
    4336,   449,  3979,   298,  4877,   215,    86,   129,   278,   327,
     487,    10,   407,    37,    13,   487,   487,   148,   371,   148,
     488,   488,   407,   487,   280,  4361,   161,   487,   487,    37,
     487,   487,   268,   487,   487,   239,   194,   488,   487,   363,
    4376,   487,   148,    42,   107,    37,   134,   282,   446,   488,
      49,   417,   280,   488,   377,  5115,   377,    55,    37,    77,
     491,   398,   487,   487,   487,   487,   487,   436,   183,   431,
     398,   161,   487,   259,  4410,    74,  3723,   278,   398,     6,
     488,   155,   454,  4956,   487,   487,   147,    68,   350,   350,
    4426,  5245,   281,    68,   129,   450,  4432,   435,   487,   450,
     487,   436,    37,   491,   324,  4441,  2554,   366,   166,   398,
     196,   268,   134,   278,   278,   363,    37,    37,   471,   487,
    4456,   191,   281,   487,   168,   478,   479,   480,   481,   482,
     483,   281,   168,  4469,   491,  4471,  4648,   447,   488,   487,
      55,   407,   141,   371,   488,   386,   119,  4468,   429,  5112,
    4963,     6,   349,   349,   488,   363,   144,   487,   285,   334,
    5150,   487,    23,  2611,   192,    34,  4701,   268,   407,  4505,
     487,   487,   166,   201,   202,   487,   491,  4689,   491,   147,
      77,   209,   349,   211,   212,   377,   185,   286,   487,  4701,
     450,   190,  3839,   377,  4171,  3842,   450,   225,  4175,   168,
    1621,   168,   881,  4700,  2538,  2896,  1356,  2423,   842,  3075,
    2342,  3778,  4548,  5086,  3753,  5289,  2449,  2508,   474,   475,
     476,  3287,   478,   479,   480,   481,   482,   483,   227,  4742,
    4207,  4208,  5148,  5394,  3932,  4797,  4766,  2992,  2678,  5268,
    4412,  4577,  4578,   471,  4647,  4581,  5383,  4744,  5178,  5177,
     478,   479,   480,   481,   482,   483,  5309,  5419,  3980,  2996,
    4596,  3965,  5122,  4599,  3923,  2523,  3100,  4603,  2523,  3773,
    3337,   923,  4608,  3948,  4773,  4611,  4612,  2517,  4614,  4782,
    4616,   280,  4618,  4619,  3349,  4450,  5559,  5396,  4759,  5541,
      24,  3295,  3988,  4703,  5322,  1780,    30,  3944,  4634,  5289,
    4636,  4935,  5131,    28,  4706,  4041,  4903,  5487,  1193,    43,
    1826,  4647,  4648,  4649,  2192,  4651,  3963,  3990,  2970,  4596,
    1824,  1835,  5052,  5477,  1894,   705,  4603,   672,  1985,  1985,
    3229,  4608,  3803,  1986,  4611,  2448,  3341,  3823,    72,  5350,
    5529,  2789,  4011,  4013,  1441,   843,  2124,  2135,   821,  1929,
    4630,  4209,  5262,  2801,  3672,  2171,  1333,  4634,  2912,  2927,
    2145,  3635,  5254,  1376,  4700,  4701,  5097,     3,  4193,  2170,
    4647,  3620,   371,  4160,    10,  4177,  4874,    13,  3617,  5075,
    1399,    17,    18,    19,  5074,  2833,  1398,  5541,  3673,  5535,
     124,  3617,   126,  5367,  4041,  1401,  5244,  5456,    34,   133,
    1859,    37,   136,  2729,  5394,  5559,    42,  1406,  4744,  2735,
    4842,  4747,  2738,    49,  3567,  2741,  4622,  5257,  2082,  2856,
    5258,  2759,  2085,  4759,  2478,  2854,  4762,    -1,   162,  2877,
      -1,  4767,    -1,  4769,    -1,    -1,    -1,    -1,    74,    -1,
    4776,  4812,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4771,    -1,    -1,    -1,  4627,    -1,    -1,  4793,    -1,    -1,
      -1,  4797,   196,    -1,  4800,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   471,    -1,    -1,  4811,  4812,  4813,    -1,   478,
     479,   480,   481,   482,   483,    -1,    -1,    -1,  4809,    -1,
      -1,  4468,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4839,  4883,    -1,  4842,    -1,  4844,    -1,
      -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,   259,    -1,  4863,    -1,   263,
      -1,    -1,    -1,  4869,    -1,    34,  4813,  4873,    -1,   273,
      -1,  4877,    -1,    42,    -1,    -1,    -1,  4883,   282,   185,
      49,    -1,    -1,    -1,   190,    -1,  4892,    -1,    -1,    -1,
     294,    -1,  2888,    -1,    -1,  2023,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2031,    -1,    74,   212,   213,  4914,    -1,
    4916,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   227,    -1,    -1,    -1,    -1,  4873,    -1,    -1,   333,
    5112,    -1,   336,   337,    -1,    -1,  4942,    -1,   636,    -1,
      -1,  4947,  4948,    -1,   642,  2941,  4952,  4953,  4954,  4955,
      -1,    -1,    -1,    -1,    -1,    -1,  4603,   655,    -1,    -1,
     266,  4608,   366,    -1,  4611,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   671,   280,    -1,    -1,   283,   676,  4985,
      -1,    -1,    -1,   681,    -1,    -1,  4992,   685,   686,    -1,
      -1,  4308,    -1,    -1,   692,    -1,   694,   695,    -1,    -1,
      -1,    -1,    -1,  4320,    -1,    -1,    -1,    -1,  5014,   707,
     708,  5017,    -1,    -1,    -1,    -1,   185,  2145,    -1,    -1,
     718,   190,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     434,    -1,    -1,    -1,    -1,    -1,  5027,    -1,    -1,    -1,
      -1,    -1,    -1,   212,   213,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    58,    -1,  1889,    -1,    -1,    -1,   227,    -1,
      -1,    -1,  1897,    -1,    -1,   371,  5072,    -1,    -1,  5075,
    5017,    -1,  5078,    -1,    -1,    -1,  5082,    -1,    -1,    -1,
      -1,    -1,  1917,  5089,    -1,    -1,    92,  5093,    -1,  5095,
      -1,  5097,    -1,    -1,    -1,    -1,    -1,   266,  5104,    -1,
      -1,    -1,   800,   801,    -1,    -1,  5112,    -1,   806,  5276,
    5101,   280,    -1,    -1,   283,    -1,    -1,  5123,    -1,    -1,
      -1,    -1,    -1,    -1,  4771,    -1,    -1,    -1,  5075,    -1,
      -1,    -1,   830,    -1,   832,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   843,   152,    10,    -1,    -1,
      13,    -1,  5158,  5159,    17,    18,    19,  5104,    -1,    -1,
      -1,    -1,  4809,    -1,    -1,   471,    -1,    -1,   474,   475,
     476,    34,   478,   479,   480,   481,   482,   483,    -1,    -1,
      -1,   187,    -1,  5189,  5351,  5352,    -1,    -1,    -1,    -1,
    5196,    -1,    -1,    -1,  5200,    -1,    -1,    10,    -1,    -1,
      13,    -1,   371,  5209,    17,    18,    19,    -1,    -1,    -1,
      -1,    10,  4529,    -1,    13,    -1,    -1,   223,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    -1,  4873,    -1,    -1,  5235,
    5236,  5237,    -1,    -1,    -1,  5241,  4883,    -1,  5244,    -1,
      -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,  5254,    -1,
      49,  5257,   950,   951,   952,    -1,  5262,   263,    -1,    -1,
      -1,   959,  5209,    -1,    -1,    -1,    -1,    -1,   966,    -1,
    5276,    -1,   970,    -1,    -1,    74,    -1,    -1,   976,    -1,
      -1,   979,    -1,    -1,    -1,  5291,    -1,  2122,    -1,   295,
      -1,    10,  5298,   991,    13,   301,    -1,    -1,    17,    18,
      19,    -1,   471,    -1,    -1,   474,   475,   476,  1006,   478,
     479,   480,   481,   482,   483,    -1,    -1,    -1,  5324,   488,
      -1,    -1,   491,  5329,  4641,    -1,  4643,    -1,    -1,  5335,
      -1,   337,  5323,   339,    -1,   341,    -1,    -1,    -1,  5345,
      -1,    -1,   141,    -1,   350,  5351,  5352,  5353,    -1,   212,
      -1,    -1,   358,  1051,  1052,  1053,  5350,  5363,    -1,  5350,
     366,  5367,  5350,    -1,  5350,    -1,  5350,    -1,    10,    -1,
    5017,    13,   378,    -1,    -1,    17,    18,    19,    -1,  5428,
    5027,   387,  5388,    -1,    -1,   391,   185,    -1,    -1,    -1,
      -1,   190,    -1,  1091,  5561,  5562,    -1,    -1,  5345,   212,
      -1,    -1,    -1,    -1,    -1,    22,    -1,  3525,    -1,    -1,
      -1,    28,    -1,  5419,  5420,  5421,    -1,   280,    -1,  5425,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   227,    -1,
    1128,    -1,    -1,    -1,  5428,    -1,    -1,  5428,    -1,   445,
    5428,  3559,  5428,    -1,  5428,    -1,  5452,  5453,  1146,    -1,
      -1,    -1,    -1,    -1,  5101,    -1,    -1,  5463,  1156,    -1,
      -1,    -1,  5468,    -1,    -1,    -1,  1164,   280,    -1,    -1,
      -1,    -1,  5419,    -1,    -1,    -1,    -1,    -1,  5425,    -1,
      -1,   280,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3607,
      -1,    -1,  5498,   212,  1192,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5508,    -1,    -1,    -1,    -1,    -1,  1206,    -1,
    1208,    -1,    -1,    -1,    -1,    -1,    -1,  5523,    -1,    -1,
    5526,    -1,    -1,    -1,    -1,    -1,  1224,    -1,    -1,  5535,
    1228,    -1,    -1,  5539,    -1,  5529,    -1,    -1,  5529,    -1,
      -1,  5529,  1240,  5529,    -1,  5529,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    13,    -1,  5561,  5562,    17,    18,    19,
      -1,   280,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     212,    -1,   371,  1271,    34,    -1,    -1,    -1,    -1,  5526,
      -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,    49,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1299,  1300,  1301,    -1,  1303,    -1,    -1,    -1,    -1,
      -1,   474,   475,   476,    74,   478,   479,   480,   481,   482,
     483,  3617,    -1,    -1,  3620,  1323,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   280,    24,
      -1,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,  1347,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1355,  1356,  2787,
    2788,   474,   475,   476,  2792,   478,   479,   480,   481,   482,
     483,  1369,   471,    -1,    -1,    -1,  5323,    -1,    -1,   478,
     479,   480,   481,   482,   483,    -1,    -1,    72,    -1,    -1,
      -1,    -1,    -1,  1391,    -1,    -1,  3692,  1395,  1396,    -1,
      -1,  2829,  2830,  5350,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1410,    -1,    -1,    -1,    -1,    -1,  1416,    -1,
      -1,    -1,    -1,    37,  1422,   185,    10,    -1,    -1,    13,
     190,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,   126,    56,    -1,    -1,    -1,    -1,    -1,   133,    -1,
      34,   136,   212,   213,    -1,   474,   475,   476,    42,   478,
     479,   480,   481,   482,   483,    49,    -1,   227,    -1,    -1,
      -1,  2606,    -1,    -1,    -1,    -1,    -1,   162,    -1,  2614,
      -1,  5428,    -1,    -1,    -1,    -1,  1484,    -1,    -1,    -1,
      74,    -1,   106,   107,    -1,    -1,    -1,    -1,    -1,  2634,
     114,    -1,    -1,    -1,    -1,    -1,   266,    -1,    -1,  2644,
      -1,   196,  2647,    -1,  2649,  2650,    -1,    -1,  2653,    -1,
     280,    -1,    -1,   283,  2659,    -1,  2661,  1525,    -1,  2664,
      -1,    -1,   474,   475,   476,    -1,   478,   479,   480,   481,
     482,   483,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   170,    -1,    -1,    -1,
    1558,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   259,    -1,    -1,    -1,   263,   193,
      -1,    -1,  5529,    -1,    -1,    -1,    -1,    -1,   273,    -1,
      -1,    -1,  2727,    -1,    -1,    -1,    -1,   282,    -1,    -1,
      -1,   185,    -1,    -1,    -1,    -1,   190,    -1,    -1,   294,
      -1,   371,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1619,    -1,    -1,    -1,    -1,    -1,   241,   212,   213,
     244,    -1,    -1,    -1,    -1,    24,  1634,  1635,  1636,    -1,
      -1,    30,    -1,   227,    -1,   259,  5263,    -1,   333,   263,
      -1,   336,   337,    -1,    43,  3951,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   293,
      -1,   366,   266,    72,    -1,    -1,    -1,    -1,    -1,    -1,
    4108,    -1,    -1,    -1,    -1,    -1,   280,    -1,    -1,   283,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   471,    -1,    -1,   474,   475,   476,    -1,   478,   479,
     480,   481,   482,   483,   338,    -1,    -1,    -1,    -1,    -1,
      -1,   491,    -1,    -1,    -1,   124,    -1,   126,    -1,  1737,
      -1,    -1,    -1,    -1,   133,    -1,   360,   136,    -1,   434,
      -1,    -1,    -1,    -1,    -1,    -1,  1754,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   380,    -1,   382,  1767,
      -1,   385,    -1,   162,  1772,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   371,    -1,    -1,
      -1,    -1,    -1,  1791,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1799,    -1,    -1,    -1,    -1,    -1,   196,    -1,    -1,
      -1,    -1,    -1,  1811,   731,    -1,   733,    -1,   735,    -1,
      -1,    -1,    -1,    -1,   741,   742,   743,    -1,    -1,    -1,
    1828,    -1,    -1,    -1,    -1,    -1,    -1,  1835,    -1,    -1,
    1838,    -1,    -1,  1841,    -1,    -1,    -1,    -1,    -1,    -1,
    1848,    -1,    -1,    -1,    -1,    -1,  1854,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3001,    -1,  1866,    -1,
     259,    -1,    -1,   487,   263,  4171,    -1,    -1,    -1,  4175,
      -1,    -1,    -1,    -1,   273,  1883,  1884,   471,  1886,  1887,
     474,   475,   476,   282,   478,   479,   480,   481,   482,   483,
    1898,    -1,  1900,  1901,    -1,   294,    -1,   491,    -1,    -1,
      -1,    -1,  1910,  1911,    -1,  1913,  1914,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,
      -1,  1929,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   333,    -1,    -1,   336,   337,  3084,
      -1,  3086,    -1,    -1,    -1,    -1,    -1,    -1,    42,    -1,
      -1,    -1,    -1,  1961,    -1,    49,  1964,  1965,    -1,    -1,
      -1,    -1,   889,    -1,    -1,    -1,    -1,   366,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      74,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1999,    -1,  2001,    -1,    -1,    -1,    -1,  2006,  2007,
      -1,    -1,    -1,    -1,    -1,  2013,  2014,  2015,    -1,    -1,
    2018,    -1,  2020,    -1,  2022,  2023,  2024,  2025,  2026,  2027,
      -1,  2029,    -1,  2031,  2032,    -1,    -1,  2035,  4456,    -1,
      -1,    -1,    -1,    -1,    -1,   434,    -1,    -1,    -1,    -1,
      -1,  2049,  2050,  2051,  2052,  2053,  2054,    -1,    -1,    -1,
    2058,    -1,    -1,    -1,  2062,    -1,    -1,  2065,    -1,    -1,
    2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,  2076,    -1,
    2078,    -1,    -1,    -1,    -1,    -1,    -1,  2085,    -1,  2087,
    3225,    -1,    -1,    -1,    -1,    -1,  3231,    -1,    -1,    -1,
      -1,   185,  3530,  3531,  3532,  3533,   190,    -1,  3536,  3537,
    3538,  3539,  3540,  3541,  3542,  3543,  3544,  3545,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2124,    -1,    -1,    -1,
    4426,    -1,  2130,    -1,    -1,  3563,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   227,    -1,    -1,    -1,  2145,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2154,  2155,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3595,  3596,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2180,    -1,    -1,    -1,    -1,    -1,    -1,  2187,
      -1,    -1,    -1,  2191,  2192,    -1,   280,    -1,    -1,    -1,
    2198,    -1,    -1,    -1,    -1,  2203,  2204,    -1,    -1,    -1,
    2208,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2216,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,  2234,    -1,    -1,  2237,
      27,    -1,    -1,    -1,    -1,    -1,    -1,  1164,    -1,    -1,
      -1,  2249,    -1,    -1,    -1,  2253,    -1,    -1,  2256,    -1,
      -1,  2259,  2260,    -1,    -1,    -1,    -1,    -1,    -1,  2267,
      -1,    -1,    -1,    -1,    -1,    62,    -1,    -1,    -1,    -1,
      -1,  2279,    -1,    -1,    -1,    -1,    -1,   371,    75,    -1,
      -1,    -1,    -1,  3428,    -1,  3430,    -1,  3432,    -1,    -1,
    4596,  2299,  2300,    90,    -1,    -1,  3441,  4603,    -1,    -1,
    2308,    -1,  4608,    -1,    37,  4611,  4612,    -1,    -1,    17,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    26,    -1,
      -1,    -1,  2330,  2331,    -1,    58,  2334,    -1,  4634,    -1,
      -1,    -1,    -1,    -1,   131,    -1,    -1,  3482,    -1,    -1,
      -1,  4647,    -1,    -1,    -1,   142,    -1,    -1,    -1,  2357,
      -1,  2359,    -1,    -1,    -1,  2363,    -1,    -1,    -1,    92,
      -1,    -1,  2370,    -1,    -1,    -1,   163,    10,    -1,  2377,
      13,   168,  2380,    -1,    17,    18,    19,   471,  2386,    -1,
     474,   475,   476,    -1,   478,   479,   480,   481,   482,   483,
      -1,    34,    -1,    -1,  4700,    -1,    -1,    -1,  2406,    42,
      -1,    -1,    -1,    -1,  2412,    -1,    49,    -1,    -1,  2417,
      -1,    -1,  2420,    -1,    -1,    -1,  4844,    -1,    -1,   152,
      -1,    -1,  2430,  1350,    -1,    -1,    -1,    -1,  1355,  1356,
      -1,    74,    -1,    -1,    -1,  2443,    -1,    -1,  4744,    -1,
    2448,    -1,  1369,   240,    -1,    -1,  2454,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   187,  4883,    27,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2472,  2473,  2474,    -1,    -1,    -1,
    2478,  3909,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   280,    -1,   218,    -1,    -1,    -1,    -1,
     223,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2510,  2511,    -1,    76,    -1,  4813,    -1,    -1,
      -1,    -1,  2520,    -1,    -1,    -1,    -1,   314,   315,  4947,
    4948,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     263,    -1,    -1,    -1,    -1,  1462,    -1,   108,    -1,    -1,
      -1,    -1,   185,    -1,    -1,  1472,  2554,   190,    -1,    -1,
     347,    -1,    -1,    -1,    -1,    -1,   353,    -1,    -1,    -1,
     131,    -1,   295,   360,    -1,    -1,   363,  4873,   301,   212,
     213,   142,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   227,  2593,    -1,    -1,  2596,  1516,
    1517,    -1,   163,  2601,    -1,    -1,    -1,   168,   395,    -1,
      -1,    -1,    -1,  2611,   337,   402,    -1,    -1,   341,    -1,
      -1,    -1,    -1,   410,    -1,    -1,    -1,   350,    -1,    -1,
     417,    -1,    -1,   266,    -1,   358,    -1,    -1,    -1,    -1,
      -1,    -1,  1559,   366,    -1,  1562,  1563,   280,    -1,    -1,
     283,    -1,    -1,    -1,  5072,   378,   443,    24,   219,  2657,
      -1,    -1,    -1,    30,   387,    -1,    -1,    -1,   391,    -1,
      -1,  5089,    -1,    -1,    -1,  5093,    43,  5095,    -1,   240,
      -1,    -1,    -1,  4111,    -1,    -1,    -1,   410,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4992,    -1,    -1,    -1,
      -1,  2699,    -1,    -1,    -1,    72,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2715,    -1,  2717,
      -1,  5017,   445,    -1,    -1,    -1,   449,  2725,    -1,    -1,
      -1,  2729,    -1,    -1,  2732,  4163,    -1,  2735,   371,    -1,
    2738,    -1,    -1,  2741,    -1,    -1,    -1,    -1,    -1,  2747,
      -1,    -1,    -1,   314,   315,    -1,    -1,   318,    -1,   126,
    2758,    -1,    -1,    -1,    -1,  2763,   133,    -1,    -1,   136,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5075,
      -1,    -1,    -1,   344,    -1,    -1,   347,    -1,    -1,  2787,
    2788,  2789,   353,    -1,  2792,   162,    -1,    -1,    -1,   360,
      -1,    -1,  2800,  2801,  2802,  2803,    -1,    -1,  5104,    -1,
    2808,    -1,    -1,    -1,    -1,  2813,  2814,    -1,  2816,    -1,
    2818,    -1,    -1,    -1,    -1,    -1,    -1,  1744,   389,   196,
      -1,  2829,  2830,    -1,   395,  2833,    -1,   398,   471,    -1,
      -1,   474,   475,   476,    -1,   478,   479,   480,   481,   482,
     483,    -1,    -1,   486,    -1,  2853,   417,  2855,    -1,  2857,
      -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2877,
      -1,    -1,   443,    -1,    -1,    34,    -1,    -1,    -1,    -1,
    2888,  4026,   259,    42,    -1,  4030,   263,    -1,  2896,    -1,
      49,    -1,    -1,    -1,    -1,    -1,   273,    -1,    -1,    -1,
      -1,    -1,    -1,  5209,  2912,   282,    -1,    -1,    -1,    -1,
      -1,   619,    -1,    -1,    -1,    74,    -1,   294,    -1,  2927,
      -1,    -1,    -1,    -1,    -1,  1852,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2941,    -1,  1862,    -1,  1864,    -1,    -1,
      -1,    -1,    -1,  1870,    -1,    -1,    -1,    -1,    -1,    -1,
    1877,    -1,  2960,    -1,    -1,  2963,   333,  2965,    -1,   336,
     337,    -1,  2970,   671,   672,    -1,    -1,    -1,    -1,    -1,
    5276,    -1,    -1,    -1,    -1,    -1,    -1,  2985,  2986,    -1,
      -1,    -1,    -1,  2991,    -1,    -1,    -1,    -1,    -1,   366,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3012,    -1,    -1,  3015,    -1,    -1,
      -1,  3019,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5329,    -1,    -1,   185,    -1,    -1,    -1,
    3038,   190,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5345,
    5468,    -1,    -1,    -1,    -1,  5351,  5352,    -1,    -1,    -1,
      -1,    -1,    -1,   212,   213,  3063,    -1,   434,    -1,    -1,
     768,    58,    -1,    -1,    -1,    -1,    -1,    -1,   227,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2009,  2010,    -1,    -1,   794,    -1,    -1,  2016,
    2017,  3099,  3100,  3101,   802,    92,    -1,   805,   806,   807,
      -1,    -1,    -1,  4248,    -1,    -1,    -1,   266,    -1,    -1,
    4548,    -1,    -1,  5419,    -1,  3123,    -1,    -1,  2045,  5425,
      -1,   280,    -1,    -1,   283,  3133,    -1,  3135,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3143,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4292,  4293,    -1,
      -1,    -1,    -1,    37,  3162,   152,    -1,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,
      -1,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,
     187,    -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,    -1,
      -1,    -1,   371,    -1,    -1,    -1,    -1,    -1,  3226,    -1,
    5526,    74,    -1,    -1,    -1,    -1,   223,  2154,  2155,    -1,
      -1,    -1,    -1,  5539,    -1,    -1,    -1,  4382,  4383,    -1,
    3248,    10,    -1,    -1,    13,  3253,    -1,    -1,    17,    18,
      19,  3259,    -1,    -1,    -1,  5561,  5562,    -1,    -1,  3267,
      -1,    -1,   259,    -1,    -1,    34,   263,    -1,   152,    -1,
      -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,
      49,    -1,    -1,    -1,    -1,    -1,    -1,  3295,  3296,  2216,
      -1,    -1,    -1,    -1,  3302,    -1,  3304,   294,   295,    -1,
      -1,    -1,    -1,   187,   301,    74,    -1,    -1,    -1,  3317,
      -1,  3319,   471,    -1,    -1,   474,   475,   476,    -1,   478,
     479,   480,   481,   482,   483,    -1,    -1,    -1,    -1,   488,
      -1,    -1,   185,  3341,   218,    -1,   333,   190,    -1,   223,
     337,    -1,    -1,    -1,   341,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   350,    -1,    -1,    -1,  3365,    -1,   212,
     213,   358,    -1,  4508,    -1,    -1,    -1,  4512,  4513,   366,
      -1,    -1,    -1,    -1,   227,    -1,    -1,  3385,  3386,   263,
      -1,   378,    -1,  4528,  2311,    -1,    -1,    -1,    -1,    -1,
     387,    -1,  3400,    -1,   391,    -1,    -1,    -1,    -1,    -1,
      -1,  4839,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   295,    -1,   266,    -1,    -1,   185,   301,    -1,    -1,
      -1,   190,    -1,    -1,    -1,  4863,    -1,   280,    -1,    -1,
     283,    -1,  3440,    -1,    -1,    -1,    -1,    -1,  1146,    -1,
      -1,    -1,    -1,   212,   213,    -1,    -1,    -1,   445,    -1,
    3458,    -1,    -1,   337,    -1,    -1,  1164,   341,   227,    -1,
      -1,    -1,    -1,    -1,    -1,  2392,   350,    -1,    -1,    -1,
      -1,    -1,  3480,  2400,   358,  3483,  2403,    -1,    -1,    -1,
      -1,    -1,   366,    -1,    -1,    -1,    -1,    -1,  2415,    -1,
    1198,    -1,    -1,    -1,   378,  3503,    24,   266,  3506,    -1,
      -1,    -1,    30,   387,  3512,    -1,    -1,   391,    -1,    -1,
      -1,   280,  3520,    -1,  3522,    -1,    -1,  3525,   371,    -1,
    1228,  3529,  3530,  3531,  3532,  3533,   410,    -1,  3536,  3537,
    3538,  3539,  3540,  3541,  3542,  3543,  3544,  3545,    -1,    -1,
      -1,  3549,  3550,    -1,    72,    -1,  3554,    -1,    -1,    -1,
      -1,  3559,    -1,    -1,    -1,  3563,    -1,  3565,    -1,  3567,
      -1,   445,    -1,    -1,    -1,   449,    -1,  3575,    -1,    -1,
    3578,    -1,  3580,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3590,    -1,  3592,    -1,    -1,  3595,  3596,    -1,
      -1,    -1,  3600,  3601,    -1,    -1,    -1,  1305,   126,  3607,
      -1,    -1,   371,    -1,    -1,   133,  1314,    -1,   136,  3617,
      -1,    -1,  3620,    -1,    -1,    -1,    -1,    -1,   471,    -1,
    1328,   474,   475,   476,  3632,   478,   479,   480,   481,   482,
     483,    -1,    -1,    -1,   162,   488,    -1,    -1,    -1,  1347,
    5078,    -1,  1350,  1351,    -1,    -1,    -1,  1355,  1356,    -1,
    3658,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1369,    -1,    -1,    -1,    -1,  3674,    -1,   196,    -1,
      -1,    -1,  3680,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3692,    -1,    -1,    -1,    -1,    -1,
    4835,    -1,    -1,    -1,    -1,    -1,    -1,  2624,  2625,    -1,
      -1,    -1,   471,  2630,    -1,   474,   475,   476,    -1,   478,
     479,   480,   481,   482,   483,  3723,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   259,    -1,    -1,    -1,   263,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   273,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   282,    -1,    -1,    -1,    -1,    -1,
    4905,    -1,    -1,    -1,  2691,  3773,   294,    -1,    -1,    -1,
    3778,  3779,  3780,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3803,  3804,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   333,  5244,    -1,   336,   337,
      -1,    -1,    -1,  4958,    -1,  3823,    -1,    -1,    -1,     0,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3839,    -1,    -1,  3842,    -1,    -1,    -1,   366,    20,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,
      -1,    32,    33,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,  1576,    -1,
      -1,    -1,    -1,    -1,    -1,  1583,    57,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,    -1,
      71,    72,    -1,    -1,    -1,    -1,    -1,    78,    -1,    80,
      -1,  3909,    -1,    -1,    -1,    -1,   434,    -1,    -1,    -1,
      91,    -1,    93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5363,  3934,  3935,    -1,   110,
    3938,    -1,   113,    -1,    -1,    -1,  3944,    -1,    -1,    -1,
      -1,    -1,    -1,  3951,    -1,    -1,   127,    -1,   129,    -1,
      -1,    -1,   133,    -1,    -1,  3963,    10,    -1,   139,    13,
      -1,    -1,    -1,    17,    18,    19,   147,  2894,   149,  2896,
      -1,    -1,    -1,    -1,    -1,   156,    -1,    -1,  3986,    -1,
      34,    -1,  3990,  3991,  3992,    -1,    -1,    -1,    42,    -1,
      -1,   172,  2919,  2920,    -1,    49,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   189,    -1,
      -1,    -1,    -1,    -1,  5452,  5453,    -1,    -1,    -1,    -1,
      74,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    24,  4041,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   229,   230,
      -1,    -1,    -1,    -1,   235,    -1,    -1,    -1,  4066,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   247,    -1,    -1,    -1,
    4078,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      72,    -1,    -1,    -1,   265,    -1,  1794,    -1,    -1,    -1,
    1798,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4108,    -1,    -1,  4111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4119,  4120,    -1,  4122,    -1,    -1,    -1,  4126,  4127,
     301,    -1,    -1,  4131,  4132,    -1,    -1,    -1,   309,  4137,
      -1,   185,  4140,  4141,   126,    -1,   190,  4145,    -1,    -1,
      -1,   133,   323,  4151,   136,    -1,    -1,    -1,   329,   330,
      -1,   332,    -1,    -1,    -1,  4163,   337,    -1,   212,   213,
      -1,   342,    -1,  4171,   345,    -1,    -1,  4175,    -1,    -1,
     162,   352,    -1,   227,    -1,    -1,    -1,   358,   359,    -1,
      -1,    -1,    -1,    -1,    -1,   366,    -1,    -1,    -1,   370,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4205,    -1,   380,
      -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   266,    -1,   395,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4232,    -1,   280,    -1,    -1,   283,
      -1,    -1,    -1,  5378,   415,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4250,    -1,    -1,   426,    -1,    -1,    -1,    -1,
      -1,   432,    -1,    -1,    -1,    10,   437,    -1,    13,    -1,
    4268,    -1,    17,    18,    19,  4273,    -1,   259,    -1,   450,
      -1,   263,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,
      -1,   273,    -1,  4291,    -1,    -1,    -1,    42,    -1,    -1,
     282,    -1,   473,    -1,    49,    -1,    -1,    -1,    -1,    -1,
    4308,    -1,   294,    -1,  2012,  4313,   487,    -1,    -1,   490,
      -1,    -1,  4320,    -1,    -1,    -1,    -1,   371,    -1,    74,
      -1,    -1,    58,    -1,    -1,    -1,    -1,    22,  4336,    -1,
      -1,    -1,    27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   333,  4350,    -1,   336,   337,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    13,    -1,    92,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    62,    -1,  3296,
      -1,    -1,    -1,  4381,   366,    34,    -1,    -1,    -1,    -1,
      75,    -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,
      49,    -1,    -1,  3320,    -1,    90,  2104,    -1,    -1,    -1,
      -1,    -1,  4410,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   108,    -1,    74,   152,   471,  4426,    -1,
     474,   475,   476,    -1,   478,   479,   480,   481,   482,   483,
     185,    -1,    -1,    -1,   488,   190,   131,    -1,    -1,    -1,
      -1,  4449,   434,    -1,    -1,    -1,    -1,   142,  4456,    -1,
      -1,   187,    -1,    -1,    -1,    -1,   151,   212,   213,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   163,    -1,
      -1,    -1,   227,   168,    -1,    -1,    -1,    -1,    -1,    -1,
     175,    -1,  3409,    -1,    -1,    -1,    -1,   223,    -1,    -1,
      -1,    -1,    -1,  4501,    -1,  4503,    -1,    -1,    -1,   194,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2216,    -1,
      -1,   266,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4529,    -1,   259,    -1,   280,   185,   263,   283,    -1,
      -1,   190,    24,    -1,    -1,    -1,    -1,    -1,    30,    -1,
    4548,    -1,    -1,    -1,  4552,   240,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   212,   213,    -1,    -1,    -1,   294,   295,
      -1,    -1,    -1,  3490,    -1,   301,    -1,    -1,   227,  4577,
    4578,    -1,    -1,  4581,    -1,    -1,    -1,    -1,  2286,    -1,
      72,    -1,    -1,    -1,    -1,   280,    -1,    -1,  4596,    -1,
      -1,    -1,    -1,    -1,    -1,  4603,    -1,   333,   293,    -1,
    4608,   337,    -1,  4611,  4612,   341,    -1,   266,    -1,   304,
    4618,  4619,    -1,    -1,   350,    -1,   371,    -1,    -1,   314,
     315,   280,   358,   318,   283,    -1,  4634,    -1,  4636,    -1,
     366,    -1,    -1,  4641,   126,  4643,    -1,    -1,    -1,  4647,
      -1,   133,   378,    -1,   136,    -1,    -1,    -1,    -1,   344,
      -1,   387,   347,    24,    -1,   391,   351,  2365,   353,    30,
      -1,    -1,    -1,    -1,    -1,   360,    -1,    -1,   363,    -1,
     162,    -1,    -1,    -1,  2382,    -1,    -1,    -1,    -1,    -1,
      -1,  4689,  4690,    -1,    -1,    -1,    -1,   382,    -1,    -1,
      -1,    -1,  4700,    -1,   389,    -1,    -1,    -1,    -1,    -1,
     395,    72,    -1,   398,   196,    -1,    -1,   402,    -1,   445,
      -1,    -1,   371,    -1,    -1,   410,   471,   412,    -1,   474,
     475,   476,   417,   478,   479,   480,   481,   482,   483,    -1,
      -1,  4739,    -1,   488,    10,   430,  4744,    13,  2446,    -1,
      -1,    17,    18,    19,    -1,    -1,    -1,    -1,   443,    -1,
      -1,    -1,    -1,    -1,    -1,   126,    -1,    -1,    34,    -1,
      -1,    -1,   133,    -1,    -1,   136,    42,   259,    -1,    -1,
      -1,   263,    -1,    49,  2482,    -1,    -1,  2485,    -1,  2487,
      -1,   273,    -1,  2491,    -1,  2493,  2494,    -1,    -1,    -1,
     282,   162,    -1,    -1,  2502,  2503,  2504,    -1,    74,    -1,
      -1,    -1,   294,    -1,    -1,  4813,    -1,  4815,    -1,    -1,
      -1,    -1,   471,    -1,    -1,   474,   475,   476,    -1,   478,
     479,   480,   481,   482,   483,   196,    -1,    -1,    -1,   488,
      10,  4839,  4840,    13,  4842,    -1,  4844,    17,    18,    19,
      -1,   333,    -1,    -1,   336,   337,    -1,    -1,    -1,  2557,
      -1,    -1,  3779,    -1,    34,  4863,    -1,    -1,    -1,    -1,
      -1,  4869,    42,    -1,    -1,  4873,    -1,    -1,    -1,    49,
      -1,  4879,    -1,    -1,   366,  4883,    -1,  3804,    -1,    -1,
      -1,  2589,    -1,    -1,  3811,    -1,    -1,    -1,   259,    -1,
      -1,    -1,   263,  2601,    74,  3822,    10,    -1,    -1,    13,
      -1,    -1,   273,    17,    18,    19,    -1,    -1,    -1,   185,
      -1,   282,    -1,    -1,   190,  4923,    -1,    -1,    -1,    -1,
      34,    -1,    -1,   294,  4932,    -1,    -1,    -1,    42,  4937,
    4938,    -1,    -1,    -1,  4942,    49,   212,   213,    -1,  4947,
    4948,  4949,   434,    -1,    -1,    -1,    -1,    -1,    -1,  2657,
      -1,   227,    -1,    -1,    -1,  4963,    -1,    -1,    -1,    -1,
      74,    -1,   333,    -1,    -1,   336,   337,    -1,    -1,    -1,
    3897,  3898,    -1,    -1,     8,    -1,    -1,  4985,    -1,    -1,
      14,    15,    -1,    -1,  4992,    -1,    20,    -1,    22,    -1,
     266,    -1,    -1,    -1,    28,   366,    -1,    31,    -1,    -1,
      24,    -1,    -1,    -1,   280,   185,    30,   283,    -1,  5017,
     190,    -1,    -1,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,   194,    -1,
      -1,   197,   212,   213,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5052,  5053,    -1,   227,    72,    -1,
      -1,   217,    -1,    -1,    -1,    -1,    -1,    -1,   224,  3986,
      -1,    -1,    -1,   434,  5072,    -1,    -1,  5075,    -1,    -1,
    5078,   185,    -1,    -1,    -1,    -1,   190,    -1,    -1,    -1,
      -1,  5089,    -1,    -1,    -1,  5093,   266,  5095,    -1,  5097,
      -1,    -1,    -1,    -1,    -1,   371,  5104,    -1,   212,   213,
     280,    -1,   126,   283,    -1,    -1,    -1,    -1,    -1,   133,
      -1,  4038,   136,   227,    -1,  5123,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   162,    -1,
    5148,    -1,  5150,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   266,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   199,   280,    -1,    -1,   283,
      -1,    -1,   196,   207,    -1,    -1,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,   218,    -1,    -1,   221,  2896,   223,
      -1,   371,  5200,    -1,    -1,   471,    -1,    -1,   474,   475,
     476,  5209,   478,   479,   480,   481,   482,   483,    -1,    -1,
      -1,    -1,   488,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5235,  5236,  5237,
      -1,    -1,    -1,    -1,    -1,   259,  5244,  5245,    -1,   263,
    5248,    -1,    -1,    -1,    -1,    -1,  5254,    -1,    -1,   273,
      -1,    -1,    -1,    -1,    -1,  5263,    -1,   371,   282,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5276,    -1,
     294,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   471,    -1,    -1,   474,   475,   476,    -1,   478,   479,
     480,   481,   482,   483,    -1,    -1,    -1,  3015,   488,   333,
      -1,    24,   336,   337,    -1,    -1,    -1,    30,    -1,    -1,
      -1,  5329,    -1,    -1,    -1,    -1,    -1,  5335,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5345,    -1,    -1,
      -1,    -1,   366,  5351,  5352,  5353,    -1,    -1,  4275,    -1,
      -1,    -1,    -1,    -1,  4281,  5363,    -1,   471,  4285,    72,
     474,   475,   476,    -1,   478,   479,   480,   481,   482,   483,
      -1,    -1,    -1,    -1,   488,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4311,  4312,  5394,    -1,    -1,  4316,
    4317,    -1,    -1,    -1,    -1,    -1,    -1,  3105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     434,  5419,    -1,   126,    -1,    -1,    -1,  5425,    -1,    -1,
     133,    -1,    -1,   136,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,  5452,  5453,    -1,    -1,    -1,   162,
      -1,    -1,  3160,    -1,    -1,  5463,    -1,    -1,    34,   625,
    5468,   627,    -1,    -1,    -1,   631,    42,    -1,    -1,  5477,
      -1,    -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,   645,
      -1,    -1,   681,   196,    -1,    -1,   652,    -1,    -1,    -1,
    5498,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    74,    -1,
    5508,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   707,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5526,    -1,
    3228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5539,    -1,  5541,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   259,    -1,    -1,    -1,
     263,  5559,    -1,  5561,  5562,    -1,    -1,    -1,    -1,    -1,
     273,    -1,    -1,    -1,  3272,    -1,    -1,    -1,    -1,   282,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3286,  3287,
      -1,   294,    -1,    -1,    -1,    -1,    -1,    -1,  3296,    -1,
      -1,    -1,    -1,    -1,  3302,    -1,  3304,    -1,    -1,   633,
      -1,    -1,    -1,    -1,    -1,    -1,   640,   641,    -1,   185,
     644,    -1,   646,   647,   190,    -1,    -1,   651,    -1,    -1,
     333,    -1,    -1,   336,   337,    -1,    -1,    -1,   662,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   212,   213,    -1,    -1,
      -1,    -1,  3350,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   227,    -1,   366,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   701,    -1,   703,
      -1,    -1,    -1,    -1,    -1,    -1,  3384,  3385,    -1,   713,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     266,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   280,    -1,    -1,   283,    -1,    -1,
      -1,   745,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   434,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   895,
     896,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,
      -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      34,    -1,  4689,    -1,    -1,    -1,    -1,   966,    42,    10,
      -1,    -1,    13,    -1,    -1,    49,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   991,    34,    -1,   371,    -1,    -1,    -1,   833,
      74,    42,    -1,    -1,    -1,    -1,    -1,  1006,    49,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,
      -1,    -1,    -1,    17,    18,    19,    -1,    -1,   994,    -1,
      -1,    -1,    -1,    74,    -1,   869,    -1,    -1,    -1,    -1,
      34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    -1,    49,    -1,  1023,  1024,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3574,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      74,    -1,    -1,  1049,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   471,    -1,    -1,   474,   475,
     476,    -1,   478,   479,   480,   481,   482,   483,   942,    -1,
      -1,   185,   488,    -1,    -1,    10,   190,    -1,    13,    -1,
      -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,   963,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   212,   213,
      -1,   975,    -1,    -1,   185,    -1,   980,    42,    -1,   190,
      -1,    -1,    -1,   227,    49,    -1,   990,  1123,  1124,    -1,
      -1,   995,    -1,    -1,    -1,    -1,   201,   202,    -1,    -1,
    1004,   212,   213,    -1,   209,  1009,   211,   212,  1012,    74,
      -1,    -1,    -1,    -1,    -1,    -1,   227,    -1,    -1,    -1,
     225,   185,   266,    -1,    -1,    -1,   190,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   280,  1206,    -1,   283,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   212,   213,
    1054,    -1,    -1,    -1,    -1,   266,    -1,    -1,    -1,    -1,
      -1,    58,    -1,   227,    -1,    -1,  4963,    -1,    -1,   280,
      -1,    -1,   283,    -1,    -1,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    92,    -1,    -1,    -1,    -1,
      -1,  3779,   266,    34,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    42,    -1,    -1,    -1,    -1,   280,    -1,    49,   283,
     185,    -1,    -1,    -1,    -1,   190,  3804,   371,    -1,    -1,
      -1,    -1,    -1,    -1,  3812,    -1,    -1,  3815,    -1,  3817,
      -1,    -1,    -1,    74,    -1,    -1,    -1,   212,   213,    -1,
      -1,    -1,    -1,    -1,    -1,   152,    -1,    -1,    -1,    -1,
     371,    -1,   227,    -1,    -1,  1169,    -1,  1171,    -1,  1173,
      -1,  1175,    -1,  1177,  1178,  1179,    -1,    -1,    -1,    -1,
    1184,    -1,  3860,    -1,    -1,    10,    -1,    -1,    13,    -1,
     187,  1195,    17,    18,    19,    -1,    -1,    -1,  3876,    -1,
      -1,   266,  3880,  3881,    -1,  3883,    -1,   371,    -1,    34,
      -1,  1215,    -1,    -1,    -1,   280,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    -1,    49,    -1,   223,   471,    -1,    -1,
     474,   475,   476,    -1,   478,   479,   480,   481,   482,   483,
      -1,    -1,    -1,  5140,   488,    -1,    -1,    -1,    -1,    74,
      -1,    -1,    -1,    -1,   185,    -1,    -1,    -1,    -1,   190,
     471,    -1,   259,   474,   475,   476,   263,   478,   479,   480,
     481,   482,   483,    -1,    -1,    -1,    -1,   488,    -1,    -1,
      -1,   212,   213,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   227,   294,   295,    -1,
      -1,    -1,    -1,    -1,   301,  3983,   371,   471,  3986,    -1,
     474,   475,   476,    -1,   478,   479,   480,   481,   482,   483,
      -1,    -1,    -1,    -1,   488,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   266,   333,    -1,    -1,    -1,
     337,  1477,    -1,    -1,   341,    -1,    -1,    -1,    -1,   280,
      -1,    -1,   283,   350,    -1,    -1,  1525,    -1,    -1,    -1,
     185,   358,    -1,    -1,    -1,   190,  1502,    -1,    -1,   366,
      -1,    -1,  1376,    -1,    -1,    -1,    -1,    -1,  4056,  4057,
    4058,   378,  4060,  4061,  4062,  4063,  4064,   212,   213,    -1,
     387,    -1,    -1,    -1,   391,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   227,    -1,    -1,    -1,   471,    -1,    -1,   474,
     475,   476,    -1,   478,   479,   480,   481,   482,   483,    -1,
      10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
      -1,   636,    -1,    -1,    -1,    -1,    -1,   642,    -1,    -1,
     371,   266,    -1,  1579,    34,    -1,    -1,    -1,   445,    -1,
     655,    -1,    42,    -1,  1458,   280,    -1,    -1,   283,    49,
      -1,    -1,    -1,    -1,    -1,    -1,   671,    -1,    -1,  1605,
    1606,  1607,  1608,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     685,   686,    -1,    -1,    74,    -1,    -1,   692,    -1,   694,
     695,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   708,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   718,  4192,    -1,  4194,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1530,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     471,    -1,    -1,   474,   475,   476,   371,   478,   479,   480,
     481,   482,   483,    -1,    -1,    -1,    -1,   488,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1737,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5477,    -1,    -1,    -1,    -1,  1754,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   185,    -1,    -1,    -1,    -1,
     190,   806,    -1,  1772,    -1,    -1,    -1,    -1,    -1,    -1,
    1746,  1747,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   212,   213,    -1,   830,    -1,    -1,    -1,    -1,
    1766,    -1,    -1,    -1,    -1,    -1,    -1,   227,   843,    -1,
      -1,    -1,    -1,    -1,  5541,    -1,   471,    -1,    -1,   474,
     475,   476,    -1,   478,   479,   480,   481,   482,   483,  1828,
      -1,    -1,  5559,   488,    -1,  1801,  1802,  1803,  1804,    -1,
      -1,    -1,  1841,    -1,    -1,    -1,   266,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1854,    -1,    -1,    -1,    -1,
     280,    -1,    -1,   283,    -1,    -1,    -1,  1866,    -1,    -1,
      -1,  4379,  4380,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4392,    -1,  4394,  4395,    -1,    -1,
    4398,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,
      18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1910,  1911,    -1,    -1,    -1,    34,   952,    -1,    -1,
      -1,    -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      -1,    49,    -1,    -1,    -1,   970,    -1,    -1,    -1,    -1,
      -1,   976,  1776,    -1,   979,    -1,    -1,    -1,    -1,    -1,
      -1,   371,    -1,  1919,  4462,    -1,    74,    -1,    -1,  1925,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    24,    -1,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    -1,  4500,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    72,    -1,    -1,    -1,  4535,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2049,   471,    -1,    -1,   474,   475,   476,   106,   478,   479,
     480,   481,   482,   483,    -1,    -1,    -1,   185,   488,  1903,
      -1,  1905,   190,    -1,    -1,    -1,    -1,   126,    -1,    -1,
      -1,    -1,    -1,    -1,   133,    -1,    -1,   136,  1922,    -1,
    1924,  2057,    -1,  1128,   212,   213,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1938,    -1,  1940,    -1,  1942,   227,
    1944,  1146,  1946,   162,    -1,    -1,  1950,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1164,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   193,    -1,    -1,   196,   266,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1192,    -1,    -1,
      -1,    -1,   280,    -1,    -1,   283,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1208,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4689,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1224,
      -1,    -1,   241,  1228,    -1,   244,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     259,    -1,    -1,    -1,   263,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   273,    -1,  4734,    -1,    -1,    -1,
      -1,    -1,    -1,   282,    -1,  4743,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    13,   293,   294,    -1,    17,    18,    19,
      -1,    -1,    -1,   371,  2253,    -1,    -1,    -1,    10,    -1,
      -1,    13,    -1,    -1,    34,    17,    18,    19,  2267,    -1,
      -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,    49,
      -1,    -1,    -1,    -1,   333,  2251,  2252,   336,   337,   338,
      42,    -1,    -1,    -1,    -1,    -1,  2262,    49,  2264,    -1,
      -1,    -1,  2268,    -1,    74,    -1,    -1,    -1,    -1,  2308,
      -1,   360,  1347,    -1,    -1,    -1,    -1,   366,    -1,    -1,
    1355,  1356,    74,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   380,    -1,    -1,  1369,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2181,  2182,    -1,
      -1,    -1,    -1,   471,    -1,    -1,   474,   475,   476,    -1,
     478,   479,   480,   481,   482,   483,  2200,  2201,    -1,    -1,
     488,  2205,  2206,    -1,    -1,    -1,  2210,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   434,    -1,  1422,    -1,    -1,
    2224,    -1,    -1,    -1,    -1,    -1,    -1,  2231,    -1,    -1,
      -1,  2235,  2236,    -1,    -1,  2239,  2240,    -1,    -1,    -1,
      -1,    -1,  2246,    -1,    -1,   185,    -1,    -1,    -1,    -1,
     190,    -1,    -1,    -1,    -1,    -1,    -1,  2261,    -1,  2263,
      -1,    -1,  2398,   185,    -1,  2401,    -1,    -1,   190,    -1,
      -1,    -1,   212,   213,    -1,    -1,    -1,  2281,    -1,    -1,
      -1,    -1,  2286,    -1,    -1,  4963,    -1,   227,    -1,  4967,
     212,   213,    -1,    -1,    -1,    -1,    -1,  2301,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   227,  2310,    -1,    -1,  2313,
      -1,  2315,  2316,  2317,    -1,    -1,    -1,    -1,  2322,  2323,
      -1,    -1,    -1,    -1,    -1,    -1,   266,    -1,  2332,    -1,
      -1,    -1,    -1,  2337,    -1,    -1,    -1,  2341,    -1,    -1,
     280,    -1,  2511,   283,   266,    -1,    -1,    -1,  2484,    -1,
      -1,    -1,    -1,    -1,  2358,    -1,  2492,    -1,   280,  2495,
    2364,  2365,    -1,    -1,    -1,  2501,    -1,  2371,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2512,  2381,  2382,    -1,
      -1,    -1,    -1,  2387,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2399,    -1,    -1,  2402,    -1,
      -1,    -1,    -1,  2407,    -1,    -1,    -1,    -1,    -1,  2413,
    2414,    -1,    -1,    -1,  1619,  2419,    -1,  2553,  2422,    -1,
      -1,    -1,  2426,  2427,  2428,  2429,    -1,  2431,    -1,    -1,
      -1,   371,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2444,  2445,    -1,  2447,    -1,  2581,   203,    -1,    -1,   371,
      -1,    -1,    -1,    -1,  2458,  2459,  2460,    10,   215,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,   226,
      -1,    -1,  5150,    -1,    -1,    -1,  5154,    -1,  5156,    -1,
      -1,    34,  5160,  5161,    -1,    -1,    -1,    -1,    -1,    42,
      -1,    -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2640,    -1,  2642,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2521,    -1,    -1,
      -1,    74,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   471,    -1,    -1,   474,   475,   476,    -1,   478,   479,
     480,   481,   482,   483,    -1,  2549,  2715,    -1,   488,   471,
      -1,    -1,   474,   475,   476,    -1,   478,   479,   480,   481,
     482,   483,  1767,  2732,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2747,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1791,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1799,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1811,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2750,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   185,    -1,    -1,    -1,    -1,   190,    -1,    -1,
      -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   212,
     213,    -1,    -1,    -1,    -1,    34,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    42,   227,    -1,    -1,    -1,  1883,  1884,
      49,  1886,  1887,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1898,    -1,  1900,  1901,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    74,    -1,    -1,  1913,  1914,
      -1,    -1,    -1,   266,    -1,    -1,  5394,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1929,    -1,    -1,   280,    -1,    -1,
     283,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2751,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1961,    -1,    -1,  1964,
    1965,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5477,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   185,    -1,   371,    -1,
      -1,   190,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   212,   213,    -1,    -1,    -1,    -1,  2054,
    3019,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   227,    -1,
     617,    -1,    -1,  5541,    -1,    -1,   623,    -1,    -1,  3038,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5559,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3025,
      -1,  3027,  3028,  3029,    -1,    -1,    -1,   266,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   280,    -1,    -1,   283,    -1,    -1,    -1,   471,  2124,
      -1,   474,   475,   476,    -1,   478,   479,   480,   481,   482,
     483,    -1,    -1,    -1,    -1,   488,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3133,    -1,  3135,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2180,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2198,    -1,    -1,    -1,    -1,  2203,  2204,
      -1,    -1,   371,  2208,    -1,    -1,    -1,    -1,    -1,  3013,
      -1,  2216,    -1,  3017,    -1,    -1,    -1,    -1,    -1,  3023,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2234,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3041,  3042,    -1,
      -1,    -1,  3046,    -1,    -1,    -1,   803,  3051,  3052,  3053,
      -1,  2256,    -1,    -1,  2259,  2260,    -1,  3226,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   822,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2279,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3087,  3088,  3089,  3090,   844,    -1,    -1,
      -1,    -1,    -1,    -1,  2299,  2300,    -1,    -1,  3267,    -1,
      -1,    -1,   471,    -1,    -1,   474,   475,   476,    -1,   478,
     479,   480,   481,   482,   483,    -1,    -1,    -1,    -1,   488,
    3124,    -1,  3126,  3127,  3128,  2330,  2331,    10,    -1,  2334,
      13,    -1,  3268,   890,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    34,  2357,    -1,  2359,    -1,    -1,    -1,  2363,    42,
      -1,    -1,    -1,    -1,    -1,  2370,    49,    -1,    -1,    -1,
      10,    -1,  2377,    13,    -1,  2380,    -1,    17,    18,    19,
      -1,  2386,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      10,    74,    -1,    13,    34,    -1,  3365,    17,    18,    19,
      -1,  2406,    42,    -1,    -1,    -1,    -1,  2412,    -1,    49,
      -1,    -1,  2417,    -1,    34,  2420,    -1,    -1,    38,    -1,
      -1,    -1,    42,    -1,    -1,  2430,    -1,    -1,    -1,    49,
      -1,  3400,    -1,    -1,    74,    -1,  3240,    -1,  2443,    -1,
      -1,    -1,    -1,  2448,    -1,  3249,    -1,    -1,    -1,  2454,
      -1,    -1,    -1,    -1,    74,    -1,    -1,    -1,    -1,  1016,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3280,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1045,  1046,
    1047,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3303,
      -1,    -1,   185,   123,    -1,    -1,    -1,   190,  3444,    -1,
      -1,    -1,    -1,    -1,    -1,  2520,    -1,    -1,    -1,    -1,
      -1,   161,    -1,    -1,    -1,    -1,   166,    -1,    -1,   212,
     213,    -1,    -1,    -1,    -1,    -1,    -1,  3506,    -1,    -1,
      -1,    -1,    -1,    -1,   227,   185,    -1,    -1,    -1,    -1,
     190,  3355,    -1,    -1,    -1,    -1,  3360,    -1,    -1,    -1,
    3529,    -1,    -1,    -1,    -1,   185,    -1,    -1,    -1,    -1,
     190,    -1,   212,   213,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   266,    -1,  3554,    -1,   227,    -1,    -1,
    3394,    -1,   212,   213,    -1,    -1,  2601,   280,    -1,    -1,
     283,    -1,    -1,    -1,    -1,    -1,    -1,   227,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3590,    -1,    -1,    -1,    -1,   266,    -1,    -1,    -1,
      -1,    -1,    -1,  3437,  1191,  3439,    -1,    -1,    -1,    -1,
     280,    -1,    -1,   283,    -1,    -1,   266,    -1,    -1,    -1,
     202,    -1,  2657,    -1,    -1,    -1,    -1,  1214,    -1,   211,
     280,    -1,    -1,   283,    -1,    -1,  1223,    -1,    -1,    -1,
      -1,    -1,    -1,   225,    -1,  3479,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   371,    -1,
      -1,    -1,    -1,    -1,  2699,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2717,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2725,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2735,   371,    -1,  2738,    -1,    -1,  2741,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   371,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3713,  3714,  3715,
    3716,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   471,    -1,
      -1,   474,   475,   476,    -1,   478,   479,   480,   481,   482,
     483,    -1,    -1,  2808,  1361,   488,    -1,    -1,    -1,  2814,
      -1,   431,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   471,    -1,    -1,   474,   475,   476,    -1,   478,   479,
     480,   481,   482,   483,    -1,    -1,    -1,    -1,    -1,    -1,
    1407,   471,    -1,    -1,   474,   475,   476,    -1,   478,   479,
     480,   481,   482,   483,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2896,    -1,    -1,    -1,  3699,    -1,  3701,    -1,    -1,
      -1,    -1,    -1,    -1,  3708,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3724,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3736,  1490,    -1,    -1,  3740,    -1,    -1,    -1,
      -1,    -1,  1499,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3758,    -1,  3892,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3938,
      -1,  3907,  3776,    -1,  1531,    -1,    -1,  3781,    -1,    -1,
    2985,  2986,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1554,    -1,    -1,
    1557,    -1,  3806,    -1,    -1,    -1,  3810,  3012,    -1,    -1,
    3015,    -1,    -1,    -1,  3818,  3819,  3820,  3821,    -1,    -1,
      -1,    -1,    -1,  3827,  3828,  3829,  3830,    -1,    -1,    -1,
    3834,  3835,    -1,    -1,    -1,    -1,  3840,  3841,    -1,  3843,
    3844,  3845,  3846,  3847,  3848,  3849,    -1,    -1,    -1,    -1,
      -1,    -1,  1609,    -1,    -1,  3859,    -1,    -1,    -1,  3863,
    3864,  3865,  3866,    -1,    -1,    -1,  1623,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   636,  3889,    -1,    -1,    -1,    -1,
     642,    -1,    -1,    -1,  3099,  3100,  3101,    -1,    -1,    -1,
      -1,    -1,    -1,   655,  3908,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3123,   671,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   686,    -1,    10,    -1,  3143,    13,
      -1,    -1,   694,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   708,  3162,    -1,    -1,
      34,    -1,    -1,  4132,    -1,    -1,   718,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    -1,    49,    -1,  1734,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      74,    -1,    -1,    -1,  4008,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,  1785,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,    -1,    -1,
      -1,  4045,    -1,  3248,    -1,    42,    -1,    -1,    -1,    -1,
      -1,    -1,    49,    -1,   806,    -1,    -1,  1814,    -1,    -1,
      -1,    -1,    -1,    -1,  1821,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    74,   830,    -1,
      -1,  4250,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3295,   843,    -1,    -1,    -1,    -1,    -1,  3302,    -1,  3304,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   185,  3317,    -1,  3319,    -1,   190,    -1,    -1,    -1,
      -1,    -1,  4291,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3341,    -1,   212,   213,
      -1,    -1,    -1,    -1,  4313,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   227,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   160,    -1,    -1,    -1,    -1,    -1,    -1,
    1927,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3385,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   185,    -1,
      -1,    -1,   266,   190,    -1,    -1,    -1,    -1,    -1,    -1,
     952,    -1,    -1,    -1,    -1,    -1,   280,    -1,    -1,   283,
    1967,  1968,  4381,    -1,    -1,   212,   213,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4361,    -1,  1984,    -1,    -1,
     227,    -1,    -1,    -1,   308,  3440,    -1,    -1,    -1,    -1,
    4376,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3458,  4258,    -1,    -1,    -1,  4262,  4263,
    4264,  4265,    -1,    -1,    -1,  4269,    -1,    -1,    -1,   266,
      -1,    -1,    -1,    -1,    -1,  3480,    -1,    -1,  3483,    -1,
      -1,    -1,    -1,   280,    -1,    -1,   283,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   371,    -1,  4303,
    4304,  4305,  4306,  4307,    -1,  4309,  4310,    -1,    -1,   306,
      -1,    -1,    -1,    -1,   388,    -1,    -1,  4321,  4322,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2084,    -1,    -1,
      -1,    -1,    -1,  4469,  4503,    -1,    -1,  2094,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4351,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3565,    -1,    -1,    -1,    -1,    -1,  2123,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   371,    -1,  1128,  2134,  2135,    -1,
      -1,    -1,    -1,  4552,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1146,    -1,    -1,   471,    -1,    -1,
     474,   475,   476,    -1,   478,   479,   480,   481,   482,   483,
      -1,  2168,  1164,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1192,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4455,    -1,    -1,    -1,    -1,  1208,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1224,    -1,   471,    -1,  1228,   474,   475,   476,
      -1,   478,   479,   480,   481,   482,   483,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,    -1,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    -1,    -1,    -1,    -1,
      37,  4515,    -1,  4649,    -1,  4651,    -1,    -1,  3723,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    72,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2312,    -1,    -1,    10,    -1,
      -1,    13,    -1,    -1,    -1,    17,    18,    19,  3773,    -1,
    2327,    -1,    -1,  3778,    -1,  3780,    -1,    -1,    -1,   106,
      -1,    -1,    34,    -1,    -1,    37,    -1,    -1,    -1,    -1,
      42,  2348,    -1,    -1,    -1,  1347,    -1,    49,  3803,   126,
      -1,    -1,    -1,  1355,  1356,    -1,   133,    -1,    -1,   136,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1369,  3823,    -1,
      -1,    -1,    74,  4627,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3839,   162,    -1,  3842,    -1,    -1,
      10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     681,    -1,    -1,    -1,    34,    -1,   193,  2424,  2425,   196,
    1422,  4840,    42,    -1,    -1,  4811,    -1,    -1,    -1,    49,
      -1,    -1,    -1,    -1,    -1,    -1,   707,  4691,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    74,    -1,  4710,    -1,    -1,    -1,
    4879,  4715,  4716,    -1,   241,    -1,    -1,   244,    -1,    -1,
      -1,  4725,    -1,    -1,    -1,    -1,    -1,    -1,  4732,  3934,
    3935,    -1,   259,   185,    -1,    -1,   263,    -1,   190,  3944,
      -1,    -1,    -1,    -1,    -1,    -1,   273,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   282,    -1,    -1,  3963,    -1,
     212,   213,    -1,  4932,  4768,    -1,   293,   294,  4937,  4938,
      -1,    -1,    -1,    -1,  2531,   227,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4788,    -1,  4790,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4805,    -1,    -1,    -1,    -1,   333,    -1,    -1,   336,
     337,   338,    -1,    -1,   266,   185,    -1,  4953,    -1,  4955,
     190,  4825,    -1,    -1,    -1,    -1,    -1,    -1,   280,  4833,
      -1,   283,    -1,   360,    -1,    -1,  4041,    -1,    -1,   366,
      -1,    -1,   212,   213,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   380,   800,   801,    -1,   227,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1619,    -1,    10,
      -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,  5053,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    34,  4898,    -1,   266,    -1,    -1,    -1,
      -1,    42,    -1,    -1,    -1,    -1,    -1,   434,    49,    -1,
     280,    -1,    -1,   283,    -1,  4919,    -1,    -1,    -1,   371,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4931,    -1,   950,
      -1,    -1,   302,    74,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   966,    -1,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     991,    34,    -1,    -1,    37,    -1,    -1,    -1,    -1,    42,
      -1,    -1,    -1,    -1,    -1,  1006,    49,    -1,    -1,    -1,
      -1,    -1,  4996,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   371,    -1,    -1,   950,   951,    -1,    -1,    -1,    -1,
      -1,    74,    -1,    -1,    -1,  1767,    -1,    -1,    -1,   471,
      -1,    -1,   474,   475,   476,   166,   478,   479,   480,   481,
     482,   483,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1791,
      -1,    -1,    -1,    -1,   185,    -1,    -1,  1799,    -1,   190,
      -1,    -1,    -1,  5189,    -1,    -1,  5060,    -1,    -1,  1811,
      -1,    -1,    -1,  4268,    -1,    -1,    -1,    -1,  4273,    -1,
    1091,   212,   213,    -1,    -1,    -1,    -1,    -1,    -1,  5248,
      -1,    -1,    -1,    -1,    -1,    -1,   227,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   471,    -1,  4308,   474,   475,   476,    -1,   478,   479,
     480,   481,   482,   483,    -1,  4320,  5120,    -1,    -1,    -1,
      -1,    -1,   185,    -1,  2881,   266,    -1,   190,    -1,    -1,
      -1,  5135,    -1,    -1,  1886,  1887,    -1,    -1,    -1,   280,
      -1,    -1,   283,    -1,    -1,  4350,    -1,  2904,  1900,   212,
     213,    -1,    -1,    -1,    -1,  5291,    -1,    -1,    -1,    -1,
      -1,  1913,  1914,    -1,   227,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5179,    -1,  1929,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1206,    -1,    -1,    -1,    -1,
    5194,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   266,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   280,    -1,    -1,
     283,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     371,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4449,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5388,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5420,  5421,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1240,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2054,    -1,    -1,    -1,    -1,    -1,   371,    -1,
      -1,    -1,    -1,    -1,    -1,  5319,    -1,    -1,    -1,    10,
      -1,    -1,    13,    -1,  4529,  1271,    17,    18,    19,    -1,
     471,    -1,    -1,   474,   475,   476,    -1,   478,   479,   480,
     481,   482,   483,    34,    -1,    -1,    37,    -1,    -1,    -1,
      -1,    42,    -1,  1299,  1300,  1301,    -1,  1303,    49,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2124,    -1,    -1,    -1,    -1,  1323,    -1,    -1,
      -1,    -1,    -1,    74,  3141,    -1,    -1,  5523,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1416,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5407,    -1,    -1,    -1,    -1,   471,    -1,
      -1,   474,   475,   476,    -1,   478,   479,   480,   481,   482,
     483,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2180,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4641,    -1,  4643,    -1,
      -1,    -1,    -1,    -1,    -1,  1391,  2198,    -1,    -1,  1395,
    1396,  2203,  2204,    -1,    -1,    -1,  2208,    -1,    -1,    -1,
      -1,    -1,    -1,  1484,  2216,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2234,    -1,    -1,  4690,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   185,  4700,    -1,    -1,    -1,   190,
      -1,    -1,    -1,    -1,  1525,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   212,   213,    -1,    -1,    -1,    -1,  2279,    -1,   681,
      -1,    -1,    -1,    -1,  4739,    -1,   227,  1558,    -1,  4744,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2299,  2300,    -1,
      -1,  3308,  3309,  3310,    -1,   707,    -1,   681,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3325,    -1,
      -1,    -1,    -1,    -1,    -1,   266,    -1,    -1,  2330,  2331,
      -1,    -1,  2334,   707,    -1,    -1,    -1,    -1,    -1,   280,
      -1,  3348,   283,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3358,  3359,    -1,    -1,  2357,  3363,  2359,    -1,    -1,
      -1,  2363,    -1,  1634,  1635,  1636,    -1,    -1,  2370,    -1,
      -1,    -1,    -1,    -1,    -1,  2377,    -1,    -1,  2380,    -1,
      -1,    -1,    -1,    -1,  2386,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2406,    -1,    -1,    -1,    -1,    -1,
    2412,    -1,    -1,    -1,    -1,  2417,    -1,    -1,  2420,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2430,    -1,
     371,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1634,  1635,
    1636,  2443,    -1,    -1,    -1,    -1,  2448,    -1,    -1,    -1,
      -1,    -1,  2454,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1737,    -1,  4923,    -1,
      -1,  3478,    -1,    -1,  3481,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1754,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4949,    -1,    -1,    -1,    -1,    -1,
      -1,  1772,    -1,    -1,    -1,    -1,    -1,    -1,  4963,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2520,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     471,    -1,    -1,   474,   475,   476,    -1,   478,   479,   480,
     481,   482,   483,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1828,    -1,    -1,
      -1,    -1,    -1,    -1,   966,    -1,    -1,    -1,    -1,    -1,
    1841,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1854,    -1,    -1,    -1,    -1,    -1,   991,
      -1,    -1,   966,    -1,    10,  1866,    -1,    13,    -1,  2601,
      -1,    17,    18,    19,  1006,    -1,    -1,  3614,  3615,  3616,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   991,    34,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,    -1,
      -1,    -1,  1006,    49,    -1,    -1,    -1,    -1,    -1,  1910,
    1911,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2657,    -1,    -1,    74,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1091,
      -1,    -1,    -1,  5148,    -1,  5150,    -1,  2699,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2717,    -1,  1091,    -1,    -1,
      -1,    -1,    -1,  2725,    10,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    37,    -1,    -1,    -1,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,   185,
      -1,    -1,    -1,    -1,   190,    -1,    -1,    -1,  2049,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    74,    -1,
    5245,    -1,    -1,    -1,    -1,    -1,   212,   213,    -1,    -1,
      -1,    -1,    -1,    -1,  1206,    -1,  2808,    -1,  5263,    -1,
    2006,   227,  2814,    -1,    -1,    -1,  2087,    -1,    -1,    -1,
      -1,  5276,  2018,    -1,  2020,    -1,  2022,    -1,    -1,  2025,
    2026,  2027,  1206,    -1,  5289,    -1,  2032,    -1,    -1,  2035,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     266,    -1,    -1,    -1,  2050,  2051,  2052,  2053,    -1,    -1,
      -1,    -1,  2058,    -1,   280,    -1,  2062,   283,    -1,  2065,
      -1,    -1,  2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,
    2076,    -1,  2078,    -1,    -1,    -1,    -1,    -1,    -1,  2085,
      -1,  2087,    -1,    -1,  2896,    -1,  5351,  5352,  3905,   185,
      -1,    -1,    -1,    -1,   190,    -1,    -1,    -1,    -1,  3916,
      -1,    -1,    -1,    -1,    -1,    -1,  2187,    -1,    -1,    -1,
    2191,  2192,    -1,    -1,    -1,    -1,   212,   213,    -1,    -1,
      -1,    -1,    -1,    -1,  2130,    -1,    -1,    -1,    -1,  5394,
    3947,   227,    -1,    -1,    -1,    -1,    -1,    -1,  1350,    -1,
      -1,    -1,    -1,    -1,    -1,   371,    -1,    -1,  2154,  2155,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3980,    -1,    -1,    -1,    -1,    -1,    -1,
     266,    -1,  2253,  2985,  2986,    -1,    -1,   403,    -1,    -1,
      -1,    -1,    -1,    -1,   280,    -1,  2267,   283,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3012,    -1,    -1,  3015,  1416,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5477,    -1,  4031,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2308,    -1,    -1,
      -1,  2237,  1416,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   471,    -1,    -1,   474,   475,
     476,    -1,   478,   479,   480,   481,   482,   483,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1484,    -1,    -1,   371,  5541,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3099,  3100,  3101,
      -1,    -1,    -1,    -1,  5559,    -1,  5561,  5562,    -1,   681,
    1484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3123,    -1,  1525,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   707,    -1,    -1,    -1,    -1,
      -1,  3143,    -1,    -1,    -1,  4152,  4153,  4154,  4155,    -1,
      -1,  1525,    -1,    -1,    -1,    -1,  1558,    -1,    -1,    -1,
    3162,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1558,   471,    -1,    -1,   474,   475,
     476,    -1,   478,   479,   480,   481,   482,   483,    -1,    10,
      -1,    -1,    13,  2474,    -1,    -1,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    34,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,    49,    -1,
    2511,    -1,    -1,    -1,    -1,    -1,  3248,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    74,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2472,  2473,  2474,    -1,
      -1,    -1,  2478,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3295,    -1,    -1,    -1,    -1,    -1,    -1,
    3302,    -1,  3304,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2510,  3317,    -1,  3319,    -1,    -1,
      -1,    -1,  2593,    -1,    -1,  2596,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1737,    -1,    -1,    -1,  3341,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1754,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1737,    -1,    -1,    -1,    -1,    -1,    -1,
    1772,    -1,    -1,    -1,   185,    -1,    -1,    -1,    -1,   190,
    1754,    -1,    -1,  3385,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   966,    -1,    -1,    -1,  1772,    -1,
      -1,   212,   213,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   227,    -1,    -1,   991,
      -1,    -1,    -1,    -1,    -1,    -1,  1828,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1006,    -1,    -1,    -1,  3440,  1841,
      -1,    -1,    -1,    -1,  2715,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1854,    -1,  1828,   266,  3458,    -1,    -1,    -1,
      -1,  2732,    -1,    -1,  1866,    -1,    -1,  1841,    -1,   280,
      -1,    -1,   283,    -1,    -1,    -1,  2747,    -1,  3480,    -1,
    1854,  3483,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1866,    -1,    -1,    -1,    -1,    -1,  4505,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1910,  1911,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1091,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1910,  1911,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     371,    -1,  2758,  3565,    -1,    -1,    -1,  2763,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2789,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2800,    -1,  2802,  2803,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2813,    -1,    -1,
    2816,    -1,  2818,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1206,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2049,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2853,    -1,  2855,
     471,  2857,    -1,   474,   475,   476,    -1,   478,   479,   480,
     481,   482,   483,    -1,    -1,  2049,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2960,
      -1,    -1,  2963,    -1,  2965,    -1,    -1,    -1,    -1,  2970,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2912,    -1,    -1,    -1,
      -1,  3723,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2927,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4747,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3019,    -1,
      -1,    -1,    -1,    -1,    -1,  4762,    -1,    -1,    -1,    -1,
    4767,    -1,    -1,    -1,    -1,    -1,    -1,  3038,    -1,    -1,
      -1,  3773,    -1,    -1,    -1,    -1,  3778,    -1,  3780,    -1,
      -1,    -1,    22,    -1,    -1,  2187,  4793,    -1,    -1,  2191,
    2192,    -1,  3063,    -1,    -1,  2991,    -1,    -1,    -1,    39,
      -1,  3803,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2187,    -1,    -1,    -1,  2191,  2192,    -1,
      -1,  3823,    62,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    75,    -1,  3839,    -1,    -1,
    3842,    -1,    -1,    -1,  1416,    -1,    86,    -1,    -1,    -1,
      90,  2253,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3133,    -1,  3135,  2267,    -1,    -1,   108,    -1,
      -1,    -1,    -1,    -1,   114,    -1,    -1,    -1,    -1,  2253,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   131,    -1,  2267,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   142,    -1,    -1,    -1,  2308,  4914,    -1,    -1,
      -1,   151,  1484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   171,  3934,  3935,  2308,   175,    -1,    -1,    -1,    -1,
     681,    -1,  3944,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1525,   194,  3226,    -1,    -1,    -1,    -1,
      -1,  3963,    -1,    -1,    -1,    -1,   707,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3253,    -1,    -1,    -1,  1558,    -1,  3259,    -1,
      -1,   231,    -1,    -1,    -1,    -1,  3267,    -1,    -1,    -1,
     240,    -1,    -1,    -1,    -1,    -1,    -1,  5014,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3296,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4041,
     280,    -1,    -1,   283,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3253,    -1,    -1,
      -1,    -1,    -1,  3259,   304,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   318,    -1,
      -1,    -1,    -1,    -1,    -1,   325,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3365,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   344,    -1,    -1,    -1,    -1,  2511,
      -1,    -1,    -1,   353,    -1,  3386,    -1,    -1,    -1,    -1,
     360,    -1,    -1,   363,    -1,    -1,    -1,    -1,    -1,  3400,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2511,    -1,    -1,
      -1,    -1,   382,    -1,    -1,    -1,    -1,    -1,    -1,   389,
      -1,    -1,    -1,    -1,    -1,   395,    -1,    -1,   398,   399,
      -1,   401,   402,    -1,    -1,  1737,    -1,    -1,    -1,    -1,
      -1,    -1,   412,    -1,    -1,    -1,    -1,   417,    -1,    -1,
      -1,    -1,  1754,    -1,   424,    -1,    -1,   427,    -1,    -1,
     430,  2593,    -1,    -1,  2596,    -1,    -1,    -1,    -1,    -1,
    1772,    -1,    -1,   443,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2593,
      -1,    -1,  2596,    -1,    -1,   966,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3506,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     991,    -1,    -1,    -1,    -1,    -1,  1828,    -1,  3529,    -1,
      -1,    -1,    -1,    -1,    -1,  1006,  4268,    -1,    -1,  1841,
      -1,  4273,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1854,  3554,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1866,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4308,  3503,    -1,    -1,
      -1,    -1,    -1,  2715,    -1,    -1,  3512,    -1,  4320,  3590,
      -1,    -1,    -1,    -1,  3520,    -1,  3522,    -1,    -1,    -1,
    2732,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1910,  1911,
      -1,  2715,    -1,    -1,    -1,  2747,    -1,    -1,  4350,    -1,
    1091,    -1,    -1,  3549,  3550,    -1,    -1,    -1,  2732,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3567,    -1,  2747,    -1,    -1,    -1,    -1,    -1,  3575,
      22,    -1,  3578,    -1,  3580,    27,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3592,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3600,  3601,    -1,    -1,    -1,  3680,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      62,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    75,    76,    -1,  3632,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    86,    -1,    -1,  4449,    90,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3658,    -1,    -1,  1206,   108,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2049,  3674,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   131,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     142,    27,    -1,    -1,    -1,    -1,    -1,    -1,  3779,   151,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   163,    -1,    -1,    -1,    -1,   168,  4529,    -1,    -1,
      -1,    -1,    -1,  3804,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    75,
     681,    -1,   194,    -1,    -1,    -1,    -1,    -1,  2960,    -1,
      -1,  2963,    -1,  2965,    90,    -1,    -1,    -1,  2970,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   707,   219,    -1,    -1,
      -1,    -1,   108,    -1,    -1,    -1,  2960,    -1,   114,  2963,
      -1,  2965,    -1,    -1,    -1,    -1,  2970,    -1,   240,    -1,
      -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2187,   142,  3019,    -1,  2191,
    2192,    -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3038,   163,   280,  4641,
      -1,  4643,   168,    -1,    -1,  3019,    -1,    -1,    -1,   175,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3063,   304,    -1,  3038,    -1,    -1,  3938,   194,    -1,
      -1,    -1,   314,   315,    -1,  1416,   318,    -1,    -1,    -1,
      -1,  2253,    -1,    -1,    -1,    -1,    -1,    -1,  4690,  3063,
      -1,    -1,    -1,   219,    -1,  2267,    -1,    -1,    -1,    -1,
      -1,    -1,   344,    -1,    -1,   347,    -1,    -1,    -1,   351,
      -1,   353,    -1,    -1,   240,  3986,    -1,    -1,   360,  3990,
      -1,   363,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3133,    -1,  3135,    -1,    -1,  2308,  4739,    -1,    -1,
     382,    -1,    -1,  1484,    -1,    -1,    -1,   389,    -1,    -1,
      -1,    -1,    -1,   395,   280,    -1,   398,    -1,    -1,  3133,
     402,  3135,    -1,    -1,    -1,    -1,    -1,    -1,   410,    -1,
     412,    -1,    -1,    -1,    -1,   417,    -1,    -1,   304,    -1,
      -1,    -1,    -1,    -1,  1525,    -1,    -1,    -1,   314,   315,
      -1,    -1,   318,    -1,    -1,  3991,  3992,    -1,    -1,    -1,
      -1,   443,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1558,   344,    -1,
      -1,   347,    -1,    -1,  3226,   351,    -1,   353,    -1,    -1,
      -1,    -1,    -1,    -1,   360,   966,    -1,   363,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4122,  3226,    -1,    -1,    -1,   382,    -1,    -1,    -1,
     991,  4132,    -1,   389,    -1,  3267,    -1,    -1,   394,   395,
    4066,    -1,   398,    -1,    -1,  1006,   402,    -1,    -1,    -1,
      -1,    -1,  4078,    -1,    -1,    -1,   412,    -1,    -1,    -1,
      -1,   417,    -1,  3267,  3296,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   430,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   443,    -1,    -1,
      -1,  4923,  3296,  4119,  4120,    -1,    -1,    -1,    -1,    -1,
    4126,  4127,    -1,    -1,    -1,  4131,    -1,    -1,    -1,  2511,
      -1,  4137,   681,    -1,  4140,  4141,    -1,  4949,    -1,  4145,
      -1,    -1,    -1,    -1,    -1,  4151,    -1,    -1,    -1,    -1,
    1091,  4963,    -1,  3365,    -1,    -1,    -1,    -1,   707,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4250,
      -1,    -1,    -1,    -1,  3386,    -1,    -1,    -1,    -1,    -1,
      -1,  3365,    -1,    -1,    -1,    -1,  1737,    -1,  3400,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4205,
      -1,    -1,  3386,  1754,    -1,    -1,    -1,    -1,    -1,    -1,
    4291,  2593,    -1,    -1,  2596,    -1,  3400,    -1,    -1,    -1,
      -1,  1772,    -1,    -1,    -1,    -1,  4232,    -1,    -1,    -1,
      -1,    -1,  4313,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1206,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1828,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1841,    -1,    -1,    -1,  3506,    -1,    -1,    -1,    -1,    -1,
    4381,    -1,    -1,  1854,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1866,    -1,  3529,    -1,    -1,
      -1,    -1,  3506,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4336,    -1,    -1,  2715,    -1,    -1,  5148,    -1,  5150,    -1,
      -1,    -1,  3554,    -1,    -1,  3529,    -1,    -1,    -1,    -1,
    2732,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1910,
    1911,    -1,    -1,    -1,    -1,  2747,    -1,    -1,    -1,    -1,
    3554,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3590,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4410,    -1,  3590,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   966,    -1,    -1,
    4501,    -1,  4503,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5245,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   991,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5263,    -1,    -1,    -1,    -1,    -1,  1006,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3680,    -1,
      -1,  4552,    -1,    -1,    -1,  1416,    -1,  5289,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3680,    -1,  2049,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1091,  1484,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3779,    -1,    -1,
      -1,  4577,  4578,    -1,    -1,  4581,    -1,    -1,  2960,    -1,
      -1,  2963,  5394,  2965,  1525,    -1,    -1,    -1,  2970,    -1,
      -1,    -1,  3804,    -1,    -1,  3779,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4689,    -1,
      -1,    -1,  4618,  4619,    -1,    -1,    -1,  1558,    -1,    -1,
    3804,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4636,    -1,    -1,    -1,    -1,    -1,  2187,  3019,    -1,    -1,
    2191,  2192,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3038,  1206,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5477,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3063,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2253,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2267,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3938,    -1,    -1,  5541,
     681,    -1,    -1,    -1,  4815,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5559,    -1,    -1,
      -1,  3133,    -1,  3135,  3938,    -1,   707,  2308,    -1,  4840,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3986,    -1,    -1,    -1,  3990,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1737,    -1,  4879,    -1,
      -1,    -1,  3986,    -1,    -1,    -1,  3990,    -1,    -1,    -1,
      -1,    -1,    -1,  1754,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1772,    -1,    -1,    -1,    -1,  4842,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3226,    -1,    -1,    -1,    -1,    -1,
      -1,  4932,    -1,    -1,    -1,    -1,  4937,  4938,    -1,    -1,
      -1,    -1,    -1,  4869,    -1,    -1,    -1,  1416,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4883,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3267,    -1,  1828,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1841,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4122,    -1,    -1,  1854,  3296,    -1,    -1,    -1,    -1,    -1,
    4132,    -1,    -1,    -1,    -1,  1866,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1484,  4942,    -1,  4122,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4132,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2511,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1910,
    1911,  5052,  5053,    -1,    -1,    -1,  1525,    -1,    -1,  4985,
      -1,    -1,    -1,  3365,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3386,    -1,    -1,    -1,    -1,  1558,
      -1,    -1,    -1,    -1,    -1,   966,    -1,    -1,  3400,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4250,    -1,
     991,    -1,  2593,    -1,    -1,  2596,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1006,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4250,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4291,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5097,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4313,    -1,    -1,    -1,    -1,    -1,  4291,  2049,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5123,    -1,    -1,
      -1,    -1,    -1,    -1,  3506,    -1,    -1,    -1,    -1,  4313,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1091,    -1,    -1,    -1,    -1,    -1,    -1,  3529,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2715,    -1,    -1,  5248,    -1,  4381,
      -1,    -1,  3554,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2732,    -1,    -1,    -1,    -1,    -1,    -1,  1737,    -1,
      -1,    -1,    -1,    -1,  5200,    -1,  2747,  4381,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1754,    -1,    -1,  3590,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1772,    -1,    -1,    -1,    -1,    -1,  5235,
    5236,  5237,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2187,    -1,  5254,    -1,
    2191,  2192,    -1,    -1,    -1,  1206,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1828,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4503,  1841,    -1,    -1,    -1,    -1,    -1,  3680,    -1,
      -1,    -1,    -1,    -1,    -1,  1854,    -1,    -1,    -1,    -1,
      -1,    -1,  2253,    -1,    -1,    -1,    -1,  1866,    -1,  4503,
      -1,    -1,    -1,    -1,    -1,    -1,  2267,    -1,    -1,  5335,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4552,    -1,    -1,    -1,    -1,    -1,    -1,  5353,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1910,  1911,    -1,    -1,    -1,    -1,  2308,  4552,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3779,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2960,
      -1,    -1,  2963,    -1,  2965,    -1,    -1,    -1,    -1,  2970,
      -1,    -1,  3804,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5463,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1416,    -1,    -1,  3019,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4689,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3038,    -1,    -1,
      -1,    -1,  5498,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2049,    -1,  5508,    -1,    -1,  4689,    -1,    -1,    -1,    -1,
      -1,    -1,  3063,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1484,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3938,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2511,    -1,    -1,    -1,  1525,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3133,    -1,  3135,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4815,  3986,    -1,    -1,  1558,  3990,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4840,    -1,
      -1,  4815,    -1,    -1,    -1,    -1,    -1,    -1,  2187,    -1,
      -1,    -1,  2191,  2192,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2593,    -1,    -1,  2596,  4840,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4879,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3226,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4879,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2253,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3267,    -1,  2267,    -1,
    4932,    -1,    -1,    -1,    -1,  4937,  4938,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4122,    -1,    -1,    -1,    -1,  3296,    -1,    -1,  4932,    -1,
    4132,    -1,    -1,  4937,  4938,    -1,    -1,    -1,    -1,  2308,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2715,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1737,    -1,    -1,    -1,
      -1,  2732,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1754,    -1,    -1,  2747,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3365,    -1,    -1,    -1,    -1,    -1,
      -1,  1772,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3386,    -1,    -1,    -1,    -1,
      -1,  5053,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3400,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4250,  5053,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1828,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1841,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1854,    -1,    -1,    -1,    -1,    -1,  4291,
      -1,    -1,    -1,    -1,    -1,  1866,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4313,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3506,    -1,    -1,    -1,  1910,
    1911,    -1,  2511,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3529,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1315,  4381,
      -1,    -1,    -1,  3554,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2960,
      -1,    -1,  2963,    -1,  2965,    -1,    -1,    -1,    -1,  2970,
      -1,    -1,    -1,    -1,    -1,    -1,  5248,    -1,    -1,  3590,
      -1,    -1,    -1,    -1,  2593,    -1,    -1,  2596,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1373,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5248,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3019,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3038,  2049,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4503,  3063,    -1,    -1,    -1,    -1,    -1,    -1,  3680,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2715,    -1,    -1,    -1,
    4552,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2732,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3133,    -1,  3135,    -1,    -1,    -1,  2747,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3779,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2187,    -1,    -1,    -1,
    2191,  2192,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3804,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3226,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2253,    -1,    -1,    -1,    -1,  4689,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2267,    -1,    -1,    -1,
      -1,    -1,    -1,  1640,    -1,    -1,  3267,  1644,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3296,    -1,  2308,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3938,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2960,    -1,    -1,  2963,    -1,  2965,    -1,    -1,    -1,
      -1,  2970,    -1,    -1,  3365,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4815,    -1,  3986,    -1,    -1,    -1,  3990,
      -1,    -1,    -1,    -1,    -1,  3386,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4840,  3400,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3019,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3038,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4879,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3063,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4932,    -1,    -1,    -1,    -1,  4937,  4938,    -1,    -1,    -1,
    2511,    -1,    -1,    -1,    -1,  3506,    -1,    -1,    -1,    -1,
      -1,  4122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4132,    -1,    -1,  3133,    -1,  3135,    -1,  3529,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3554,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2593,    -1,    -1,  2596,    -1,    -1,    -1,  3590,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5053,    -1,    -1,    -1,    -1,    -1,  3226,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2004,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4250,
      -1,    -1,  2019,    -1,    -1,    -1,  2023,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3267,    -1,
    2037,  2038,  2039,    -1,  2041,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3680,
    4291,    -1,    -1,    -1,    -1,    -1,    -1,  3296,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4313,    -1,  2715,    -1,  2083,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2732,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2747,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3365,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2141,    -1,    -1,    -1,    -1,    -1,
    4381,    -1,    -1,    -1,    -1,    -1,  2153,  3386,  3779,    -1,
      -1,  2158,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3400,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3804,    -1,    -1,  5248,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4503,    -1,    -1,    -1,    -1,  3506,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3529,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3938,    -1,    -1,
      -1,  4552,    -1,    -1,    -1,  3554,    -1,    -1,    -1,  2960,
      -1,    -1,  2963,    -1,  2965,    -1,    -1,    -1,    -1,  2970,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3590,    -1,    -1,    -1,  3986,    -1,    -1,    -1,  3990,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3019,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3038,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3063,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3680,    -1,    -1,    -1,    -1,    -1,    -1,  4689,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4122,  3133,    -1,  3135,    -1,    -1,    -1,    -1,    -1,
      -1,  4132,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3779,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3804,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4815,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3226,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4840,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4250,
      -1,    -1,    -1,    -1,    -1,    -1,  3267,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4879,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3296,    -1,    -1,    -1,    -1,
    4291,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4313,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4932,    -1,    -1,    -1,    -1,  4937,  4938,    -1,  3938,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3365,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3386,    -1,  3986,    -1,    -1,
    4381,  3990,    -1,    -1,  2761,    -1,    -1,    -1,    -1,  3400,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2781,  2782,    -1,  2784,    -1,    -1,
    2787,  2788,    -1,  2790,    -1,  2792,    -1,    -1,    -1,  2796,
      -1,    -1,  2799,    -1,    -1,    -1,    -1,  2804,    -1,    -1,
      -1,    -1,    -1,  2810,    -1,    -1,    -1,    -1,  2815,    -1,
      -1,    -1,  5053,    -1,    -1,  2822,  2823,  2824,  2825,    -1,
      -1,    -1,  2829,  2830,    -1,  2832,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2850,    -1,  2852,    -1,    -1,    -1,    -1,
      -1,    -1,  2859,  2860,  2861,  2862,  2863,  2864,  2865,  2866,
    2867,  2868,    -1,    -1,    -1,  3506,    -1,    -1,    -1,    -1,
      -1,    -1,  4503,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4122,    -1,    -1,    -1,    -1,  3529,    -1,
      -1,    -1,    -1,  4132,    -1,    -1,    -1,    -1,  2905,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3554,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4552,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3590,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3006,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5248,    -1,    -1,
      -1,  4250,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3680,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4291,    -1,    -1,    -1,    -1,    -1,  4689,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4313,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3779,    -1,
      -1,    -1,  4381,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3804,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4815,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4840,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4879,    -1,
    3257,  3258,    -1,    -1,    -1,  3262,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4503,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3291,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3938,    -1,    -1,
      -1,  4932,    -1,    -1,    -1,    -1,  4937,  4938,    -1,    -1,
      -1,    -1,    -1,  4552,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3986,    -1,    -1,    -1,  3990,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5053,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4689,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4132,    -1,    -1,    -1,  3502,    -1,    -1,    -1,    -1,
      -1,  3508,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3526,
    3527,    -1,    -1,  3530,  3531,  3532,  3533,    -1,    -1,  3536,
    3537,  3538,  3539,  3540,  3541,  3542,  3543,  3544,  3545,  3546,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3568,    -1,    -1,  3571,    -1,  3573,    -1,    -1,  3576,
    3577,    -1,    -1,    -1,    -1,    -1,  4815,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3594,  3595,  3596,
    3597,    -1,  3599,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4840,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4250,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5248,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4879,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4291,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4313,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3689,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4932,    -1,    -1,    -1,    -1,  4937,  4938,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4381,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5053,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4503,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3909,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4552,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5248,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4689,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4067,    -1,    -1,    -1,  4071,    -1,  4073,  4074,    -1,    -1,
      -1,    -1,    -1,  4080,  4081,  4082,  4083,    -1,    -1,    -1,
      -1,  4088,  4089,  4090,  4091,  4092,  4093,  4094,  4095,  4096,
    4097,  4098,  4099,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4125,    -1,
      -1,  4128,    -1,  4130,    -1,    -1,    -1,    -1,  4135,    -1,
      -1,  4138,  4139,    -1,    -1,  4142,  4143,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4815,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4189,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4204,    -1,  4840,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4217,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4879,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4932,    -1,    -1,    -1,    -1,  4937,  4938,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4413,    -1,    -1,    -1,
      -1,    -1,  5053,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4498,  4499,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4541,    -1,    -1,    -1,    -1,    -1,
    4547,  4548,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4565,    -1,
    4567,    -1,    -1,    -1,  4571,  4572,  4573,    -1,    -1,  4576,
      -1,    -1,  4579,  4580,    -1,    -1,    -1,  4584,    -1,    -1,
      -1,  4588,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5248,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4645,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4711,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4838,  4839,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4853,  4854,  4855,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4863,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4890,  4891,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4902,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5065,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5078,    -1,    -1,  5081,    -1,    -1,    -1,  5085,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5134,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5171,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5242,    -1,  5244,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5274,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5328,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5356,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5417,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5452,  5453,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5504,  5505,    -1,
      -1,    -1,  5509,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,     5,     6,    -1,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,  5536,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    73,    -1,    75,    -1,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,   174,    -1,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,    -1,    -1,   223,   224,   225,   226,   227,    -1,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,    -1,   276,   277,    -1,    -1,
     280,   281,   282,    -1,    -1,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,    -1,    -1,    -1,    -1,    -1,    -1,   478,   479,
     480,    -1,    -1,    -1,    -1,    -1,    -1,   487,   488,     3,
      -1,     5,     6,    -1,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    36,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    -1,    69,    70,    71,    72,    73,
      -1,    75,    -1,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,    -1,   157,   158,   159,   160,    -1,   162,    -1,
     164,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
     174,    -1,   176,   177,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,    -1,    -1,   223,
     224,   225,   226,   227,    -1,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,    -1,   440,   441,   442,   443,
     444,   445,    -1,    -1,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,    -1,   473,
      -1,    -1,    -1,    -1,   478,   479,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   487,   488,     3,    -1,     5,     6,    -1,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,
      -1,    39,    40,    -1,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    73,    -1,    75,    -1,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,   174,    -1,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,    -1,    -1,   223,   224,   225,   226,   227,
      -1,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,   427,
     428,   429,   430,    -1,   432,   433,   434,   435,   436,   437,
     438,    -1,   440,   441,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,    -1,    -1,    -1,    -1,    -1,    -1,
     478,   479,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   487,
     488,     3,    -1,     5,     6,    -1,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,    -1,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    -1,    69,    70,    71,
      72,    73,    -1,    75,    -1,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,    -1,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,   140,   141,
     142,    -1,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,    -1,   157,   158,   159,   160,    -1,
     162,    -1,   164,   165,    -1,   167,   168,   169,   170,   171,
      -1,   173,   174,    -1,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,    -1,
      -1,   223,   224,   225,   226,   227,    -1,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,    -1,   276,   277,    -1,    -1,   280,   281,
     282,    -1,    -1,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,   427,   428,   429,   430,    -1,
     432,   433,   434,   435,   436,   437,   438,    -1,   440,   441,
     442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
      -1,    -1,    -1,    -1,    -1,    -1,   478,   479,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   487,   488,     3,    -1,     5,
       6,    -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    75,
      -1,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,   441,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,     3,    -1,    -1,    -1,
      -1,    -1,   478,   479,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   487,   488,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      37,    -1,    39,    40,    -1,    42,    43,    44,    -1,    46,
      47,    48,    49,    50,    -1,    52,    53,    -1,    55,    56,
      57,    58,    59,    60,    -1,    -1,    63,    64,    65,    66,
      67,    -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,
      77,    78,    79,    80,    81,    -1,    83,    84,    85,    -1,
      87,    88,    89,    90,    91,    92,    -1,    94,    95,    96,
      97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,    -1,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,    -1,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,   140,   141,   142,    -1,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,
     167,   168,   169,   170,   171,    -1,   173,   174,    -1,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,    -1,   211,    -1,    -1,   214,   215,   216,
     217,   218,   219,   220,    -1,    -1,   223,   224,   225,   226,
      -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
     267,    -1,   269,   270,   271,   272,   273,   274,    -1,   276,
     277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,
     287,    -1,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
      -1,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
      -1,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,   420,   421,   422,    -1,    -1,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
     437,   438,    -1,   440,    -1,   442,   443,   444,   445,    -1,
      -1,   448,    -1,    -1,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   488,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    -1,    42,    43,    44,    45,    46,    47,
      48,    -1,    50,    51,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    -1,    -1,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    -1,    -1,    75,    -1,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    94,    95,    96,    97,
      -1,    -1,    -1,   101,    -1,    -1,    -1,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
      -1,   149,   150,   151,   152,    -1,    -1,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,    -1,    -1,    -1,   177,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,    -1,    -1,   223,    -1,   225,   226,   227,
      -1,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,    -1,    -1,   262,    -1,   264,   265,   266,   267,
      -1,    -1,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,    -1,   306,    -1,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,    -1,   391,    -1,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,    -1,   412,    -1,    -1,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,    -1,
     438,   439,   440,   441,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     468,   469,   470,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
     488,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    45,    46,    47,    48,    -1,    50,    51,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    -1,    63,
      64,    65,    66,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    75,    -1,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    -1,
      94,    95,    96,    97,    -1,    -1,    -1,   101,    -1,    -1,
      -1,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,    -1,   149,   150,   151,   152,    -1,
      -1,   155,    -1,   157,   158,   159,   160,    -1,   162,    -1,
     164,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
      -1,    -1,    -1,   177,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,    -1,    -1,   223,
      -1,   225,   226,   227,    -1,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,    -1,    -1,   262,    -1,
     264,   265,   266,   267,    -1,    -1,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,   287,   288,   289,   290,    -1,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,    -1,   303,
     304,    -1,   306,    -1,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,    -1,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,    -1,   412,    -1,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
      -1,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,    -1,   438,   439,   440,   441,   442,   443,
     444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,     3,    -1,     5,     6,    -1,     8,     9,
      10,    11,    12,    -1,   468,   469,   470,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,   488,    -1,    36,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    73,    -1,    75,    -1,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,   174,    -1,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,    -1,    -1,   223,   224,   225,   226,   227,    -1,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,    -1,   276,   277,    -1,    -1,
     280,   281,   282,    -1,    -1,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,    -1,
     440,   441,   442,   443,   444,   445,    -1,    -1,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,    -1,   473,    -1,    -1,    -1,    -1,   478,   479,
      -1,    -1,    -1,     3,    -1,     5,     6,   487,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    73,    -1,    75,    -1,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,   169,
     170,   171,    -1,   173,   174,    -1,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,    -1,   222,   223,   224,   225,   226,   227,    -1,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,    -1,   276,   277,    -1,    -1,
     280,   281,   282,    -1,    -1,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,    -1,
     440,   441,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,    -1,    -1,    -1,    -1,    -1,    -1,   478,   479,
      -1,    -1,    -1,     3,    -1,     5,     6,   487,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    73,    -1,    75,    -1,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,   174,    -1,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,    -1,    -1,   223,   224,   225,   226,   227,    -1,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,    -1,   276,   277,    -1,    -1,
     280,   281,   282,    -1,    -1,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,    -1,
     440,   441,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,    -1,    -1,    -1,    -1,    -1,    -1,   478,   479,
      -1,    -1,    -1,    -1,    -1,   485,   486,   487,     3,    -1,
       5,     6,    -1,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,    -1,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,   441,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,    -1,    -1,    -1,
      -1,    -1,    -1,   478,   479,   480,    -1,    -1,     3,    -1,
       5,     6,   487,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,    -1,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,   441,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,    -1,    -1,    -1,
      -1,    -1,    -1,   478,   479,    -1,    -1,    -1,     3,    -1,
       5,     6,   487,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,    -1,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,    -1,    -1,    -1,
      -1,    -1,    -1,   478,   479,    -1,    -1,    -1,     3,    -1,
       5,     6,   487,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,    -1,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,   441,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,    -1,    -1,    -1,
      -1,    -1,    -1,   478,   479,    -1,    -1,    -1,     3,    -1,
       5,     6,   487,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,    -1,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,   441,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,    -1,    -1,    -1,
      -1,    -1,    -1,   478,   479,    -1,    -1,    -1,     3,    -1,
       5,     6,   487,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,    -1,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,   441,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,    -1,    -1,    -1,
      -1,    -1,    -1,   478,   479,    -1,    -1,    -1,     3,    -1,
       5,     6,   487,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,    -1,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,   441,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,    -1,    -1,    -1,
      -1,    -1,    -1,   478,   479,    -1,    -1,    -1,     3,    -1,
       5,     6,   487,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,    -1,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,   441,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,    -1,    -1,    -1,
      -1,    -1,    -1,   478,   479,    -1,    -1,    -1,     3,    -1,
       5,     6,   487,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,    -1,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,   441,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,    -1,    -1,    -1,
      -1,    -1,    -1,   478,   479,    -1,    -1,    -1,     3,    -1,
       5,     6,   487,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,    -1,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,   441,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,    -1,    -1,    -1,
      -1,    -1,    -1,   478,   479,    -1,    -1,    -1,     3,    -1,
       5,     6,   487,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,    -1,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,   441,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,    -1,    -1,    -1,
      -1,    -1,    -1,   478,   479,    -1,    -1,    -1,     3,    -1,
       5,     6,   487,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,    -1,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,   441,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,    -1,    -1,    -1,
      -1,    -1,    -1,   478,   479,    -1,    -1,    -1,     3,    -1,
       5,     6,   487,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,    -1,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,   441,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,    -1,    -1,    -1,
      -1,    -1,    -1,   478,   479,    -1,    -1,    -1,     3,    -1,
       5,     6,   487,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,    -1,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,    -1,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,   441,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   478,   479,    -1,    -1,    -1,     3,    -1,
       5,     6,   487,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,
     215,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,    -1,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,   441,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,    -1,    -1,    -1,
      -1,    -1,    -1,   478,   479,    -1,    -1,    -1,     3,    -1,
       5,     6,   487,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,    -1,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,    -1,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,   441,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   478,   479,     3,    -1,     5,     6,    -1,
       8,     9,   487,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,
      -1,    39,    40,    -1,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    73,    -1,    75,    -1,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,   174,    -1,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,    -1,    -1,   223,   224,   225,   226,   227,
      -1,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,   426,   427,
     428,   429,   430,    -1,   432,   433,   434,   435,   436,   437,
     438,    -1,   440,   441,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     478,   479,    -1,    -1,    -1,     3,    -1,     5,     6,   487,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,
      -1,    39,    40,    -1,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    73,    -1,    75,    -1,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,   174,    -1,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,    -1,    -1,   223,   224,   225,   226,   227,
      -1,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,   426,   427,
     428,   429,   430,    -1,   432,   433,   434,   435,   436,   437,
     438,    -1,   440,   441,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     478,   479,     3,    -1,     5,     6,    -1,     8,     9,   487,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    73,    -1,    75,    -1,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,   174,    -1,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
      -1,    -1,   223,   224,   225,   226,   227,    -1,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,    -1,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,    -1,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,   434,   435,   436,   437,   438,    -1,   440,
     441,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       3,    -1,     5,     6,    -1,     8,     9,    -1,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,   487,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    39,    40,    -1,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    -1,    69,    70,    71,    72,
      73,    -1,    75,    -1,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    -1,    87,    88,    89,    90,    91,    92,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,    -1,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
      -1,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,   165,    -1,   167,   168,   169,   170,   171,    -1,
     173,   174,    -1,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,    -1,    -1,
     223,   224,   225,   226,   227,    -1,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,    -1,   276,   277,    -1,    -1,   280,   281,   282,
      -1,    -1,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,    -1,    -1,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,    -1,   425,   426,   427,   428,   429,   430,    -1,   432,
     433,   434,   435,   436,   437,   438,    -1,   440,   441,   442,
     443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     3,    -1,
       5,     6,    -1,     8,     9,    -1,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,   487,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,    -1,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,    -1,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,   441,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     3,    -1,     5,     6,
      -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,   487,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,
      -1,    -1,    39,    40,    -1,    42,    43,    44,    45,    46,
      47,    48,    -1,    50,    51,    52,    53,    -1,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    -1,    69,    70,    71,    72,    73,    -1,    75,    -1,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    -1,
      87,    88,    89,    90,    91,    92,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,    -1,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,    -1,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,   140,    -1,   142,    -1,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,   165,    -1,
     167,   168,   169,   170,   171,    -1,   173,   174,    -1,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,    -1,   211,    -1,    -1,   214,   215,   216,
     217,   218,   219,   220,    -1,    -1,   223,   224,   225,   226,
      -1,    -1,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,    -1,   276,
     277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
      -1,    -1,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,    -1,   424,   425,   426,
     427,   428,   429,   430,    -1,   432,   433,   434,   435,   436,
     437,   438,    -1,   440,   441,   442,   443,   444,   445,    -1,
      -1,   448,    -1,    -1,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,
      -1,   478,   479,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     487,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    -1,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    73,    -1,    75,    -1,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,   174,    -1,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,   226,   227,    -1,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,    -1,   276,   277,    -1,
     279,   280,   281,   282,    -1,    -1,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,    -1,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,   434,   435,   436,   437,   438,
      -1,   440,   441,   442,   443,   444,   445,    -1,    -1,   448,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     3,    -1,   473,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   487,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    73,    -1,    75,    -1,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,   174,    -1,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,    -1,   223,   224,   225,   226,   227,    -1,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,   279,   280,
     281,   282,    -1,    -1,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,    -1,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,   434,   435,   436,   437,   438,    -1,   440,
     441,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   487,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    67,    -1,    69,    70,    71,    72,
      73,    -1,    75,    -1,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    -1,    87,    88,    89,    90,    91,    92,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,    -1,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
      -1,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,   165,    -1,   167,   168,   169,   170,   171,    -1,
     173,   174,    -1,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,    -1,    -1,
     223,   224,   225,   226,   227,    -1,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,    -1,   276,   277,    -1,    -1,   280,   281,   282,
      -1,    -1,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,    -1,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,    -1,   425,   426,   427,   428,   429,   430,    -1,   432,
     433,   434,   435,   436,   437,   438,    -1,   440,   441,   442,
     443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   487,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,    -1,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,    -1,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,   441,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   487,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    -1,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    -1,    55,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      67,    -1,    69,    70,    71,    72,    73,    -1,    75,    -1,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    -1,
      87,    88,    89,    90,    91,    92,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,    -1,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,    -1,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,   140,   141,   142,    -1,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,   165,    -1,
     167,   168,   169,   170,   171,    -1,   173,   174,    -1,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,    -1,    -1,   223,   224,   225,   226,
     227,    -1,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,    -1,   276,
     277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
      -1,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,   420,   421,   422,    -1,    -1,   425,   426,
     427,   428,   429,   430,    -1,   432,   433,   434,   435,   436,
     437,   438,    -1,   440,   441,   442,   443,   444,   445,    -1,
      -1,   448,    -1,    -1,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     3,    -1,     5,     6,    -1,    -1,
      -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     487,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    -1,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    -1,    -1,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    73,    -1,    75,    -1,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    -1,    94,    95,    96,    97,    -1,
      -1,    -1,   101,    -1,    -1,    -1,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,   174,    -1,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,    -1,    -1,   223,   224,   225,   226,   227,    -1,
     229,   230,   231,    -1,    -1,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,    -1,   276,   277,   278,
      -1,   280,   281,   282,    -1,    -1,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,    -1,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,   437,   438,
      -1,   440,   441,   442,   443,   444,   445,    -1,    -1,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,   478,
     479,   480,    -1,    -1,    -1,    -1,    -1,    -1,   487,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    32,    33,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    73,    -1,    75,    -1,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    94,    95,    96,    97,    -1,    -1,    -1,
     101,    -1,    -1,    -1,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,   174,    -1,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
      -1,    -1,   223,   224,   225,   226,   227,    -1,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,    -1,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,    -1,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,   437,   438,    -1,   440,
     441,   442,   443,   444,   445,    -1,    -1,   448,    -1,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       3,    -1,   473,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   487,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    -1,    -1,
      63,    64,    65,    66,    67,    -1,    69,    70,    71,    72,
      73,    -1,    75,    -1,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    -1,    87,    88,    89,    90,    91,    92,
      -1,    94,    95,    96,    97,    -1,    -1,    -1,   101,    -1,
      -1,    -1,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,    -1,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
      -1,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,   165,    -1,   167,   168,   169,   170,   171,    -1,
     173,   174,    -1,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,    -1,    -1,
     223,   224,   225,   226,   227,    -1,   229,   230,   231,    -1,
      -1,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,    -1,   276,   277,    -1,    -1,   280,   281,   282,
      -1,    -1,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,    -1,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,   437,   438,    -1,   440,   441,   442,
     443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   487,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      -1,    46,    47,    48,    49,    50,    -1,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    -1,    -1,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      -1,    -1,    77,    78,    79,    80,    81,    -1,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    -1,
      95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
      -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,
      -1,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
      -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,    -1,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,   267,    -1,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,    -1,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,    -1,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,    -1,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,    -1,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,    -1,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,    -1,   442,   443,   444,
     445,    -1,    -1,   448,    -1,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     3,    -1,   473,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   487,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,    46,
      47,    48,    49,    50,    -1,    52,    53,    -1,    55,    56,
      57,    58,    59,    60,    -1,    -1,    63,    64,    65,    66,
      67,    -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,
      77,    78,    79,    80,    81,    -1,    83,    84,    85,    -1,
      87,    88,    89,    90,    91,    92,    -1,    -1,    95,    96,
      97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,    -1,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,    -1,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,   140,   141,   142,    -1,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,
      -1,   168,   169,   170,   171,    -1,   173,   174,    -1,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,
     217,   218,   219,   220,    -1,    -1,   223,   224,    -1,   226,
      -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
     267,    -1,   269,   270,   271,   272,   273,   274,    -1,   276,
     277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,
     287,    -1,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,    -1,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
      -1,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
      -1,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,   420,   421,   422,    -1,    -1,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
     437,   438,    -1,   440,    -1,   442,   443,   444,   445,    -1,
      -1,   448,    -1,    -1,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     487,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    -1,    42,    43,    44,    -1,    46,    47,    48,
      49,    50,    -1,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    -1,    -1,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    73,    -1,    -1,    -1,    77,    78,
      79,    80,    81,    -1,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    -1,    -1,    95,    96,    97,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,
     169,   170,   171,    -1,   173,   174,    -1,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,
     219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,
     229,   230,   231,    -1,    -1,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,    -1,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,   267,    -1,
     269,   270,   271,   272,   273,   274,    -1,   276,   277,    -1,
      -1,   280,   281,   282,    -1,    -1,   285,   286,   287,    -1,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,    -1,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,    -1,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,    -1,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,   437,   438,
      -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   487,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    -1,    46,    47,    48,    49,    50,
      -1,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    73,    -1,    -1,    -1,    77,    78,    79,    80,
      81,    -1,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,
     171,    -1,   173,   174,    -1,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,    -1,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,    -1,    -1,   214,    -1,   216,   217,   218,   219,   220,
      -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
      -1,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,   267,    -1,   269,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,    -1,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
      -1,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,    -1,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,    -1,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,   437,   438,    -1,   440,
      -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   487,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,
      43,    44,    -1,    46,    47,    48,    49,    50,    -1,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    -1,    -1,
      63,    64,    65,    66,    67,    -1,    69,    70,    71,    72,
      73,    -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,
      83,    84,    85,    -1,    87,    88,    89,    90,    91,    92,
      -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,    -1,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
      -1,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,
     173,   174,    -1,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,    -1,   211,    -1,
      -1,   214,    -1,   216,   217,   218,   219,   220,    -1,    -1,
     223,   224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,
      -1,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,   267,    -1,   269,   270,   271,   272,
     273,   274,    -1,   276,   277,    -1,    -1,   280,   281,   282,
      -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,    -1,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,    -1,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,   437,   438,    -1,   440,    -1,   442,
     443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,    -1,    -1,
      -1,     3,    -1,     5,     6,    -1,    -1,    -1,    10,    11,
      -1,    -1,    -1,    -1,   487,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    -1,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    -1,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,    -1,   149,   150,   151,
     152,    -1,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,    -1,   175,    -1,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,    -1,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,    -1,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,    -1,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,    -1,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   468,   469,   470,    -1,
      -1,    -1,   474,   475,   476,    -1,   478,   479,   480,   481,
     482,   483,     3,    -1,     5,     6,    -1,    -1,    -1,    10,
      11,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    -1,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,    -1,   149,   150,
     151,   152,    -1,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,    -1,   175,    -1,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,    -1,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,   288,   289,   290,
      -1,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,   304,    -1,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,    -1,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
      -1,   412,    -1,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,    -1,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   468,   469,   470,
      -1,    -1,    -1,   474,   475,   476,     3,   478,   479,   480,
     481,   482,   483,    10,    -1,    -1,    -1,    -1,    -1,    -1,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,    46,
      47,    48,    49,    50,    -1,    52,    53,    -1,    55,    56,
      57,    58,    59,    60,    -1,    -1,    63,    64,    65,    66,
      67,    -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,
      77,    78,    79,    80,    81,    -1,    83,    84,    85,    -1,
      87,    88,    89,    90,    91,    92,    -1,    -1,    95,    96,
      97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,    -1,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,    -1,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,   140,   141,   142,    -1,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,
      -1,   168,   169,   170,   171,    -1,   173,   174,    -1,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,
     217,   218,   219,   220,    -1,    -1,   223,   224,    -1,   226,
      -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
     267,    -1,   269,   270,   271,   272,   273,   274,    -1,   276,
     277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,
     287,    -1,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,    -1,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
      -1,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
      -1,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,   420,   421,   422,    -1,    -1,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
     437,   438,    -1,   440,    -1,   442,   443,   444,   445,    -1,
      -1,   448,    -1,    -1,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,    -1,    -1,    -1,   474,   475,   476,
       3,   478,   479,   480,   481,   482,   483,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,
      43,    44,    -1,    46,    47,    48,    49,    50,    -1,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    -1,    -1,
      63,    64,    65,    66,    67,    -1,    69,    70,    71,    72,
      73,    -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,
      83,    84,    85,    -1,    87,    88,    89,    90,    91,    92,
      -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,    -1,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
      -1,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,
     173,   174,    -1,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,    -1,   211,    -1,
      -1,   214,    -1,   216,   217,   218,   219,   220,    -1,    -1,
     223,   224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,
      -1,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,   267,    -1,   269,   270,   271,   272,
     273,   274,    -1,   276,   277,    -1,    -1,   280,   281,   282,
      -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,    -1,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,    -1,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,   437,   438,    -1,   440,    -1,   442,
     443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,    -1,    -1,
      -1,   474,   475,   476,     3,   478,   479,   480,   481,   482,
     483,    10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    -1,    42,    43,    44,    -1,    46,    47,    48,
      49,    50,    -1,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    -1,    -1,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    73,    -1,    -1,    -1,    77,    78,
      79,    80,    81,    -1,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    -1,    -1,    95,    96,    97,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,
     169,   170,   171,    -1,   173,   174,    -1,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,
     219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,
     229,   230,   231,    -1,    -1,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,    -1,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,   267,    -1,
     269,   270,   271,   272,   273,   274,    -1,   276,   277,    -1,
      -1,   280,   281,   282,    -1,    -1,   285,   286,   287,    -1,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,    -1,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,    -1,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,    -1,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,   437,   438,
      -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,    -1,    -1,    -1,   474,   475,   476,     3,   478,
     479,   480,   481,   482,   483,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      -1,    46,    47,    48,    49,    50,    -1,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    -1,    -1,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      -1,    -1,    77,    78,    79,    80,    81,    -1,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    -1,
      95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
      -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,
      -1,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
      -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,    -1,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,   267,    -1,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,    -1,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,    -1,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,    -1,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,    -1,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,    -1,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,    -1,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,    -1,    -1,    -1,   474,
     475,   476,     3,   478,   479,   480,   481,   482,   483,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    -1,    46,    47,    48,    49,    50,
      -1,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    73,    -1,    -1,    -1,    77,    78,    79,    80,
      81,    -1,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,
     171,    -1,   173,   174,    -1,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,    -1,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,    -1,    -1,   214,    -1,   216,   217,   218,   219,   220,
      -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
      -1,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,   267,    -1,   269,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,    -1,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
      -1,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,    -1,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,    -1,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,   437,   438,    -1,   440,
      -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
      -1,    -1,    -1,   474,   475,   476,     3,   478,   479,   480,
     481,   482,   483,    10,    -1,    -1,    -1,    -1,    -1,    -1,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,    46,
      47,    48,    49,    50,    -1,    52,    53,    -1,    55,    56,
      57,    58,    59,    60,    -1,    -1,    63,    64,    65,    66,
      67,    -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,
      77,    78,    79,    80,    81,    -1,    83,    84,    85,    -1,
      87,    88,    89,    90,    91,    92,    -1,    -1,    95,    96,
      97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,    -1,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,    -1,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,   140,   141,   142,    -1,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,
      -1,   168,   169,   170,   171,    -1,   173,   174,    -1,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,
     217,   218,   219,   220,    -1,    -1,   223,   224,    -1,   226,
      -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
     267,    -1,   269,   270,   271,   272,   273,   274,    -1,   276,
     277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,
     287,    -1,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,    -1,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
      -1,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
      -1,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,   420,   421,   422,    -1,    -1,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
     437,   438,    -1,   440,    -1,   442,   443,   444,   445,    -1,
      -1,   448,    -1,    -1,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,    -1,    -1,    -1,   474,   475,   476,
       3,   478,   479,   480,   481,   482,   483,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,
      43,    44,    -1,    46,    47,    48,    49,    50,    -1,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    -1,    -1,
      63,    64,    65,    66,    67,    -1,    69,    70,    71,    72,
      73,    -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,
      83,    84,    85,    -1,    87,    88,    89,    90,    91,    92,
      -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,    -1,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
      -1,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,
     173,   174,    -1,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,    -1,   211,    -1,
      -1,   214,    -1,   216,   217,   218,   219,   220,    -1,    -1,
     223,   224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,
      -1,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,   267,    -1,   269,   270,   271,   272,
     273,   274,    -1,   276,   277,    -1,    -1,   280,   281,   282,
      -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,    -1,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,    -1,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,   437,   438,    -1,   440,    -1,   442,
     443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     3,    -1,
      -1,   474,   475,   476,    -1,   478,   479,   480,   481,   482,
     483,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   480,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,    46,
      47,    48,    49,    50,    -1,    52,    53,    -1,    55,    56,
      57,    58,    59,    60,    -1,    -1,    63,    64,    65,    66,
      67,    -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,
      77,    78,    79,    80,    81,    -1,    83,    84,    85,    -1,
      87,    88,    89,    90,    91,    92,    -1,    -1,    95,    96,
      97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,    -1,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,    -1,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,   140,   141,   142,    -1,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,
      -1,   168,   169,   170,   171,    -1,   173,   174,    -1,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,
     217,   218,   219,   220,    -1,    -1,   223,   224,    -1,   226,
      -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
     267,    -1,   269,   270,   271,   272,   273,   274,    -1,   276,
     277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,
     287,    -1,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,    -1,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
      -1,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
      -1,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,   420,   421,   422,    -1,    -1,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
     437,   438,    -1,   440,    -1,   442,   443,   444,   445,    -1,
      -1,   448,    -1,    -1,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   480,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    -1,    42,    43,    44,    -1,    46,    47,    48,
      49,    50,    -1,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    -1,    -1,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    73,    -1,    -1,    -1,    77,    78,
      79,    80,    81,    -1,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    -1,    -1,    95,    96,    97,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,
     169,   170,   171,    -1,   173,   174,    -1,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,
     219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,
     229,   230,   231,    -1,    -1,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,    -1,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,   267,    -1,
     269,   270,   271,   272,   273,   274,    -1,   276,   277,    -1,
      -1,   280,   281,   282,    -1,    -1,   285,   286,   287,    -1,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,    -1,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,    -1,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,    -1,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,   437,   438,
      -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   480,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    45,    46,    47,    48,    -1,    50,
      51,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    -1,    -1,    75,    -1,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    94,    95,    96,    97,    -1,    -1,    -1,
     101,    -1,    -1,    -1,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,    -1,   149,   150,
     151,   152,    -1,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,    -1,    -1,    -1,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
      -1,    -1,   223,    -1,   225,   226,   227,    -1,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,    -1,
      -1,   262,    -1,   264,   265,   266,   267,    -1,    -1,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,   284,   285,   286,   287,   288,   289,   290,
      -1,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,    -1,   306,    -1,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,    -1,
     391,    -1,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
      -1,   412,    -1,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,    -1,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,   438,   439,   440,
     441,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,   468,   469,   470,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   480,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    45,    46,    47,    48,    -1,
      50,    51,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    -1,    -1,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    -1,    -1,    75,    -1,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    94,    95,    96,    97,    -1,    -1,
      -1,   101,    -1,    -1,    -1,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,    -1,   149,
     150,   151,   152,    -1,    -1,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,    -1,    -1,    -1,   177,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,    -1,    -1,   223,    -1,   225,   226,   227,    -1,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
      -1,    -1,   262,    -1,   264,   265,   266,   267,    -1,    -1,
     270,   271,   272,   273,   274,    -1,   276,   277,    -1,    -1,
     280,   281,   282,    -1,   284,   285,   286,   287,   288,   289,
     290,    -1,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,    -1,   306,    -1,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,    -1,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,    -1,   412,    -1,    -1,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,    -1,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,   438,   439,
     440,   441,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,     5,     6,   468,   469,
     470,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     480,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    -1,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    -1,    -1,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    73,    -1,    75,    -1,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    -1,    94,    95,    96,    97,    -1,
      -1,    -1,   101,    -1,    -1,    -1,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,   174,    -1,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,    -1,    -1,   223,   224,   225,   226,   227,    -1,
     229,   230,   231,    -1,    -1,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,    -1,   276,   277,   278,
      -1,   280,   281,   282,    -1,    -1,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,    -1,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,   437,   438,
      -1,   440,   441,   442,   443,   444,   445,    -1,    -1,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,    -1,     3,    -1,     5,     6,    -1,    -1,   478,
     479,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    -1,    -1,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    73,    -1,    75,    -1,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    94,    95,    96,    97,    -1,    -1,
      -1,   101,    -1,    -1,    -1,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,   174,    -1,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,    -1,    -1,   223,   224,   225,   226,   227,    -1,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,    -1,   276,   277,   278,    -1,
     280,   281,   282,    -1,    -1,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,    -1,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,   437,   438,    -1,
     440,   441,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,    -1,     3,    -1,     5,     6,    -1,    -1,   478,   479,
      11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    73,    -1,    75,    -1,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    94,    95,    96,    97,    -1,    -1,    -1,
     101,    -1,    -1,    -1,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,   174,    -1,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
      -1,    -1,   223,   224,   225,   226,   227,    -1,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,    -1,   276,   277,   278,    -1,   280,
     281,   282,    -1,    -1,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,    -1,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,   437,   438,    -1,   440,
     441,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
      -1,     3,    -1,    -1,     6,    -1,    -1,   478,   479,    11,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    64,    65,    66,    67,    -1,    69,    70,    71,
      72,    73,    -1,    75,    -1,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    -1,    94,    95,    96,    97,    -1,    -1,    -1,   101,
      -1,    -1,    -1,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,    -1,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,   140,   141,
     142,    -1,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,    -1,   157,   158,   159,   160,    -1,
     162,    -1,   164,   165,    -1,   167,   168,   169,   170,   171,
      -1,   173,   174,    -1,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,    -1,
      -1,   223,   224,   225,   226,   227,    -1,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,    -1,   276,   277,   278,    -1,   280,   281,
     282,    -1,    -1,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,   437,   438,    -1,   440,   441,
     442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,    -1,
       3,    -1,    -1,    -1,    -1,    -1,   478,   479,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,
      43,    44,    -1,    46,    47,    48,    49,    50,    -1,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    -1,    -1,
      63,    64,    65,    66,    67,    -1,    69,    70,    71,    72,
      73,    -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,
      83,    84,    85,    -1,    87,    88,    89,    90,    91,    92,
      -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,    -1,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
      -1,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,    -1,   166,    -1,   168,   169,   170,   171,    -1,
     173,   174,    -1,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,    -1,   211,    -1,
      -1,   214,    -1,   216,   217,   218,   219,   220,    -1,    -1,
     223,   224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,
      -1,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,   267,    -1,   269,   270,   271,   272,
     273,   274,    -1,   276,   277,    -1,    -1,   280,   281,   282,
      -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,    -1,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,    -1,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,   437,   438,    -1,   440,    -1,   442,
     443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,    -1,     3,
      -1,     5,     6,    -1,    -1,   478,   479,    11,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    73,    -1,    75,    -1,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,   174,    -1,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,    -1,    -1,   223,   224,   225,   226,   227,    -1,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,    -1,   276,   277,    -1,    -1,
     280,   281,   282,    -1,    -1,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,    -1,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,    -1,
     440,   441,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     3,    -1,    -1,     6,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    64,    65,    66,    67,    -1,    69,    70,    71,
      72,    73,    -1,    75,    -1,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    -1,    94,    95,    96,    97,    -1,    -1,    -1,   101,
      -1,    -1,    -1,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,   140,   141,
     142,    -1,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,    -1,   157,   158,   159,   160,    -1,
     162,    -1,   164,   165,    -1,   167,   168,   169,   170,   171,
      -1,   173,   174,    -1,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,    -1,
      -1,   223,   224,   225,   226,   227,    -1,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,    -1,   276,   277,   278,    -1,   280,   281,
     282,    -1,    -1,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,   437,   438,    -1,   440,   441,
     442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    -1,    63,
      64,    65,    66,    67,    -1,    69,    70,    71,    72,    73,
      -1,    75,    -1,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    -1,
      94,    95,    96,    97,    -1,    -1,    -1,   101,    -1,    -1,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,   159,   160,    -1,   162,    -1,
     164,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
     174,    -1,   176,   177,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,    -1,    -1,   223,
     224,   225,   226,   227,    -1,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
      -1,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,   437,   438,    -1,   440,   441,   442,   443,
     444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    -1,    -1,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    75,
      -1,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    94,    95,
      96,    97,    -1,    -1,    -1,   101,    -1,    -1,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,    -1,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,   441,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    -1,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    -1,    -1,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    73,    -1,    75,    -1,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    94,    95,    96,    97,
      -1,    -1,    -1,   101,    -1,    -1,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,   174,    -1,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,    -1,    -1,   223,   224,   225,   226,   227,
      -1,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,   426,   427,
     428,   429,   430,    -1,   432,   433,   434,   435,   436,   437,
     438,    -1,   440,   441,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    -1,    -1,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    73,    -1,    75,    -1,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    94,    95,    96,    97,    -1,    -1,
      -1,   101,    -1,    -1,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,   174,   175,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,    -1,    -1,   223,   224,   225,   226,   227,    -1,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,    -1,   276,   277,    -1,    -1,
     280,   281,   282,    -1,    -1,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,    -1,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,   437,   438,    -1,
     440,   441,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    64,    65,    66,    67,    -1,    69,    70,    71,
      72,    73,    -1,    75,    -1,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    -1,    94,    95,    96,    97,    -1,    -1,    -1,   101,
      -1,    -1,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,   140,   141,
     142,    -1,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,   159,   160,    -1,
     162,    -1,   164,   165,    -1,   167,   168,   169,   170,   171,
      -1,   173,   174,    -1,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,    -1,
      -1,   223,   224,   225,   226,   227,    -1,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,    -1,   276,   277,    -1,    -1,   280,   281,
     282,    -1,    -1,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,   437,   438,    -1,   440,   441,
     442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    -1,    63,
      64,    65,    66,    67,    -1,    69,    70,    71,    72,    73,
      -1,    75,    -1,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    -1,
      94,    95,    96,    97,    -1,    -1,    -1,   101,    -1,    -1,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,   159,   160,    -1,   162,    -1,
     164,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
     174,    -1,   176,   177,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,    -1,    -1,   223,
     224,   225,   226,   227,    -1,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
      -1,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,   437,   438,    -1,   440,   441,   442,   443,
     444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    -1,    -1,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    75,
      -1,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    94,    95,
      96,    97,    -1,    -1,    -1,   101,    -1,    -1,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,    -1,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,   441,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    -1,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    -1,    -1,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    73,    -1,    75,    -1,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    94,    95,    96,    97,
      -1,    -1,    -1,   101,    -1,    -1,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,   174,    -1,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,    -1,    -1,   223,   224,   225,   226,   227,
      -1,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,   437,
     438,    -1,   440,   441,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    -1,    -1,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    73,    -1,    75,    -1,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    94,    95,    96,    97,    -1,    -1,
      -1,   101,    -1,    -1,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,   174,    -1,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,    -1,    -1,   223,   224,   225,   226,   227,    -1,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,    -1,   276,   277,    -1,    -1,
     280,   281,   282,    -1,    -1,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,    -1,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,   437,   438,    -1,
     440,   441,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      32,    33,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    64,    65,    66,    67,    -1,    69,    70,    71,
      72,    73,    -1,    75,    -1,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    -1,    94,    95,    96,    97,    -1,    -1,    -1,   101,
      -1,    -1,    -1,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,   140,   141,
     142,    -1,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,   159,   160,    -1,
     162,    -1,   164,   165,    -1,   167,   168,   169,   170,   171,
      -1,   173,   174,    -1,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,    -1,
      -1,   223,   224,   225,   226,   227,    -1,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,    -1,   276,   277,    -1,    -1,   280,   281,
     282,    -1,    -1,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,   437,   438,    -1,   440,   441,
     442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,     3,
      -1,    -1,     6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    -1,    63,
      64,    65,    66,    67,    -1,    69,    70,    71,    72,    73,
      -1,    75,    -1,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    -1,
      94,    95,    96,    97,    -1,    -1,    -1,   101,    -1,    -1,
      -1,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,   159,   160,    -1,   162,    -1,
     164,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
     174,    -1,   176,   177,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,    -1,    -1,   223,
     224,   225,   226,   227,    -1,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
      -1,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,   437,   438,    -1,   440,   441,   442,   443,
     444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     3,    -1,    -1,
       6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    -1,    -1,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    75,
      -1,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    94,    95,
      96,    97,    -1,    -1,    -1,   101,    -1,    -1,    -1,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,    -1,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,   441,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     3,    -1,    -1,     6,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    -1,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    -1,    -1,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    73,    -1,    75,    -1,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    94,    95,    96,    97,
      -1,    -1,    -1,   101,    -1,    -1,    -1,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,   174,    -1,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,    -1,    -1,   223,   224,   225,   226,   227,
      -1,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,   437,
     438,    -1,   440,   441,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    -1,    -1,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    73,    -1,    75,    -1,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    94,    95,    96,    97,    -1,    -1,
      -1,   101,    -1,    -1,    -1,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,   174,    -1,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,    -1,    -1,   223,   224,   225,   226,   227,    -1,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,    -1,   276,   277,    -1,    -1,
     280,   281,   282,    -1,    -1,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,    -1,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,   437,   438,    -1,
     440,   441,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    64,    65,    66,    67,    -1,    69,    70,    71,
      72,    73,    -1,    75,    -1,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    -1,    94,    95,    96,    97,    -1,    -1,    -1,   101,
      -1,    -1,    -1,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,   140,   141,
     142,    -1,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,   159,   160,    -1,
     162,    -1,   164,   165,    -1,   167,   168,   169,   170,   171,
      -1,   173,   174,    -1,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,    -1,
      -1,   223,   224,   225,   226,   227,    -1,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,    -1,   276,   277,    -1,    -1,   280,   281,
     282,    -1,    -1,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,   437,   438,    -1,   440,   441,
     442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    -1,    63,
      64,    65,    66,    67,    -1,    69,    70,    71,    72,    73,
      -1,    75,    -1,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    -1,
      94,    95,    96,    97,    -1,    -1,    -1,   101,    -1,    -1,
      -1,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,   159,   160,    -1,   162,    -1,
     164,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
     174,    -1,   176,   177,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,    -1,    -1,   223,
     224,   225,   226,   227,    -1,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
      -1,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,   437,   438,    -1,   440,   441,   442,   443,
     444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    -1,    -1,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    75,
      -1,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    94,    95,
      96,    97,    -1,    -1,    -1,   101,    -1,    -1,    -1,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,    -1,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,   441,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    -1,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    -1,    -1,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    73,    -1,    75,    -1,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    94,    95,    96,    97,
      -1,    -1,    -1,   101,    -1,    -1,    -1,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,   174,    -1,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,    -1,    -1,   223,   224,   225,   226,   227,
      -1,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,   437,
     438,    -1,   440,   441,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    -1,    -1,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    73,    -1,    75,    -1,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    94,    95,    96,    97,    -1,    -1,
      -1,   101,    -1,    -1,    -1,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,   174,    -1,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,    -1,    -1,   223,   224,   225,   226,   227,    -1,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,    -1,   276,   277,    -1,    -1,
     280,   281,   282,    -1,    -1,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,    -1,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,   437,   438,    -1,
     440,   441,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,
      42,    43,    44,    -1,    46,    47,    48,    49,    50,    -1,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    -1,    -1,    76,    77,    78,    79,    80,    81,
      -1,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,   140,   141,
     142,    -1,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,   159,   160,    -1,
     162,   163,   164,    -1,    -1,    -1,   168,   169,   170,   171,
      -1,   173,   174,    -1,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,    -1,   211,
      -1,    -1,   214,    -1,   216,   217,   218,   219,   220,    -1,
      -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,    -1,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,   267,    -1,   269,   270,   271,
     272,   273,   274,    -1,   276,   277,    -1,    -1,   280,   281,
     282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,    -1,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,   437,   438,    -1,   440,    -1,
     442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    -1,    46,    47,    48,    49,    50,    -1,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    -1,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    -1,
      -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,   159,   160,    -1,   162,   163,
     164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,
     174,    -1,   176,   177,   178,    -1,   180,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,
     214,    -1,   216,   217,   218,   219,   220,    -1,    -1,   223,
     224,    -1,   226,   227,    -1,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,   267,    -1,   269,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,   287,    -1,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,    -1,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,   437,   438,    -1,   440,    -1,   442,   443,
     444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,
      46,    47,    48,    49,    50,    -1,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    -1,    -1,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    -1,
      -1,    77,    78,    79,    80,    81,    -1,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    93,    -1,    95,
      96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,    -1,
      -1,    -1,   168,   169,   170,   171,   172,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,    -1,
     226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,   267,    -1,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,    -1,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,    -1,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,    -1,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,    -1,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    -1,    42,    43,    44,    -1,    46,    47,
      48,    49,    50,    -1,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    -1,    -1,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,    77,
      78,    79,    80,    81,    -1,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    93,    -1,    95,    96,    97,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,
     168,   169,   170,   171,   172,   173,   174,    -1,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,
     218,   219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,
      -1,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,   267,
      -1,   269,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,   287,
      -1,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,    -1,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,   437,
     438,    -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    -1,    46,    47,    48,    49,
      50,    -1,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    -1,    -1,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    -1,    -1,    -1,    77,    78,    79,
      80,    81,    -1,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,   159,
     160,    -1,   162,   163,   164,    -1,    -1,    -1,   168,   169,
     170,   171,    -1,   173,   174,    -1,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,   219,
     220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,   267,    -1,   269,
     270,   271,   272,   273,   274,    -1,   276,   277,    -1,    -1,
     280,   281,   282,    -1,    -1,   285,   286,   287,    -1,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,    -1,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,   437,   438,    -1,
     440,    -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,
      42,    43,    44,    -1,    46,    47,    48,    49,    50,    -1,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    64,    65,    66,    67,    -1,    69,    70,    71,
      72,    73,    -1,    -1,    -1,    77,    78,    79,    80,    81,
      -1,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    93,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,   140,   141,
     142,    -1,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,   159,   160,    -1,
     162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,
      -1,   173,   174,    -1,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,    -1,   211,
      -1,    -1,   214,    -1,   216,   217,   218,   219,   220,    -1,
      -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,    -1,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,   267,    -1,   269,   270,   271,
     272,   273,   274,    -1,   276,   277,    -1,    -1,   280,   281,
     282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,    -1,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,   437,   438,    -1,   440,    -1,
     442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    -1,    46,    47,    48,    49,    50,    -1,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    -1,    63,
      64,    65,    66,    67,    -1,    69,    70,    71,    72,    73,
      -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    -1,
      -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,   159,   160,    -1,   162,   163,
     164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,
     174,    -1,   176,   177,   178,    -1,   180,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,
     214,    -1,   216,   217,   218,   219,   220,    -1,    -1,   223,
     224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,   267,    -1,   269,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,   287,    -1,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,    -1,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
      -1,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,   437,   438,    -1,   440,    -1,   442,   443,
     444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,
      46,    47,    48,    49,    50,    -1,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    -1,    -1,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    -1,
      -1,    77,    78,    79,    80,    81,    -1,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    93,    -1,    95,
      96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,    -1,
      -1,    -1,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,    -1,
     226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,   267,    -1,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,    -1,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,    -1,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,    -1,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,    -1,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    -1,    42,    43,    44,    -1,    46,    47,
      48,    49,    50,    -1,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    -1,    -1,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,    77,
      78,    79,    80,    81,    -1,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    -1,    95,    96,    97,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,
     168,   169,   170,   171,    -1,   173,   174,    -1,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,
     218,   219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,
      -1,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,   267,
      -1,   269,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,   279,   280,   281,   282,    -1,    -1,   285,   286,   287,
      -1,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,    -1,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,   437,
     438,    -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    -1,    46,    47,    48,    49,
      50,    -1,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    -1,    -1,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    73,    -1,    -1,    -1,    77,    78,    79,
      80,    81,    -1,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,
     170,   171,    -1,   173,   174,    -1,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,   219,
     220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,   267,    -1,   269,
     270,   271,   272,   273,   274,    -1,   276,   277,    -1,    -1,
     280,   281,   282,    -1,    -1,   285,   286,   287,    -1,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,    -1,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,    -1,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,    -1,
     440,    -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,
      42,    43,    44,    -1,    46,    47,    48,    49,    50,    -1,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    64,    65,    66,    67,    -1,    69,    70,    71,
      72,    73,    -1,    -1,    -1,    77,    78,    79,    80,    81,
      -1,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,   140,   141,
     142,    -1,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,   159,   160,    -1,
     162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,
      -1,   173,   174,    -1,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,    -1,   211,
      -1,    -1,   214,    -1,   216,   217,   218,   219,   220,    -1,
      -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,    -1,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,   267,    -1,   269,   270,   271,
     272,   273,   274,    -1,   276,   277,    -1,    -1,   280,   281,
     282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,    -1,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,    -1,   425,   426,   427,   428,   429,   430,    -1,
     432,   433,   434,   435,   436,   437,   438,    -1,   440,    -1,
     442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    -1,    46,    47,    48,    49,    50,    -1,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    -1,    63,
      64,    65,    66,    67,    -1,    69,    70,    71,    72,    73,
      -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    -1,
      -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,   159,   160,    -1,   162,    -1,
     164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,
     174,    -1,   176,   177,   178,    -1,   180,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,
     214,    -1,   216,   217,   218,   219,   220,    -1,    -1,   223,
     224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,   267,    -1,   269,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,   287,    -1,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,    -1,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
      -1,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,   437,   438,    -1,   440,    -1,   442,   443,
     444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,
      46,    47,    48,    49,    50,    -1,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    -1,    -1,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    -1,
      -1,    77,    78,    79,    80,    81,    -1,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    -1,    95,
      96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,    -1,
      -1,    -1,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,    -1,
     226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,   267,    -1,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,    -1,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,    -1,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,    -1,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,    -1,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    -1,    42,    43,    44,    -1,    46,    47,
      48,    49,    50,    -1,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    -1,    -1,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,    77,
      78,    79,    80,    81,    -1,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    -1,    95,    96,    97,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,
     168,   169,   170,   171,    -1,   173,   174,    -1,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,
     218,   219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,
      -1,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,   267,
      -1,   269,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,   287,
      -1,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,    -1,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,   437,
     438,    -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    -1,    46,    47,    48,    49,
      50,    -1,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    -1,    -1,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    73,    -1,    -1,    -1,    77,    78,    79,
      80,    81,    -1,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,
     170,   171,    -1,   173,   174,    -1,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,   219,
     220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,   267,    -1,   269,
     270,   271,   272,   273,   274,    -1,   276,   277,    -1,    -1,
     280,   281,   282,    -1,    -1,   285,   286,   287,    -1,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,    -1,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,    -1,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,   437,   438,    -1,
     440,    -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,
      42,    43,    44,    -1,    46,    47,    48,    49,    50,    -1,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    64,    65,    66,    67,    -1,    69,    70,    71,
      72,    73,    -1,    -1,    -1,    77,    78,    79,    80,    81,
      -1,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,   140,   141,
     142,    -1,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,   159,   160,    -1,
     162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,
      -1,   173,   174,    -1,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,    -1,   211,
      -1,    -1,   214,    -1,   216,   217,   218,   219,   220,    -1,
      -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,    -1,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,   267,    -1,   269,   270,   271,
     272,   273,   274,    -1,   276,   277,    -1,   279,   280,   281,
     282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,    -1,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,   437,   438,    -1,   440,    -1,
     442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    -1,    46,    47,    48,    49,    50,    -1,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    -1,    63,
      64,    65,    66,    67,    -1,    69,    70,    71,    72,    73,
      -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    -1,
      -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,   159,   160,    -1,   162,    -1,
     164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,
     174,    -1,   176,   177,   178,    -1,   180,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,
     214,    -1,   216,   217,   218,   219,   220,    -1,    -1,   223,
     224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,   267,    -1,   269,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,   287,    -1,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,    -1,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
      -1,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,   437,   438,    -1,   440,    -1,   442,   443,
     444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,
      46,    47,    48,    49,    50,    -1,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    -1,    -1,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    -1,
      -1,    77,    78,    79,    80,    81,    -1,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    -1,    95,
      96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,    -1,
      -1,    -1,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,    -1,
     226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,   267,    -1,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,    -1,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,    -1,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,    -1,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,    -1,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    -1,    42,    43,    44,    -1,    46,    47,
      48,    49,    50,    -1,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    -1,    -1,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,    77,
      78,    79,    80,    81,    -1,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    -1,    95,    96,    97,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,
     168,   169,   170,   171,    -1,   173,   174,    -1,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,
     218,   219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,
      -1,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,   267,
      -1,   269,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,   287,
      -1,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,    -1,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,   437,
     438,    -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    -1,    46,    47,    48,    49,
      50,    -1,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    -1,    -1,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    73,    -1,    -1,    -1,    77,    78,    79,
      80,    81,    -1,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,
     170,   171,    -1,   173,   174,    -1,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,   219,
     220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,   267,    -1,   269,
     270,   271,   272,   273,   274,    -1,   276,   277,    -1,    -1,
     280,   281,   282,    -1,    -1,   285,   286,   287,    -1,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,    -1,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,    -1,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,   437,   438,    -1,
     440,    -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,
      42,    43,    44,    -1,    46,    47,    48,    49,    50,    -1,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    64,    65,    66,    67,    -1,    69,    70,    71,
      72,    73,    -1,    -1,    -1,    77,    78,    79,    80,    81,
      -1,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,   140,   141,
     142,    -1,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,   159,   160,    -1,
     162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,
      -1,   173,   174,    -1,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,    -1,   211,
      -1,    -1,   214,    -1,   216,   217,   218,   219,   220,    -1,
      -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,    -1,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,   267,    -1,   269,   270,   271,
     272,   273,   274,    -1,   276,   277,    -1,    -1,   280,   281,
     282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,    -1,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,   437,   438,    -1,   440,    -1,
     442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    -1,    63,
      64,    65,    66,    67,    -1,    69,    70,    71,    72,    73,
      -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    -1,
      -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,   159,   160,    -1,   162,    -1,
     164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,
     174,    -1,   176,   177,   178,    -1,   180,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,
     214,    -1,   216,   217,   218,   219,   220,    -1,    -1,   223,
     224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,   267,    -1,   269,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,   287,    -1,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,    -1,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
      -1,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,   437,   438,    -1,   440,    -1,   442,   443,
     444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,
      46,    47,    48,    49,    50,    -1,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    -1,    -1,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    -1,
      -1,    77,    78,    79,    80,    81,    -1,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    -1,    95,
      96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,    -1,
      -1,    -1,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,    -1,
     226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,   267,    -1,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,   279,   280,   281,   282,    -1,    -1,   285,
     286,   287,    -1,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,    -1,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,    -1,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,    -1,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    -1,    42,    43,    44,    -1,    46,    47,
      48,    49,    50,    -1,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    -1,    -1,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,    77,
      78,    79,    80,    81,    -1,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    -1,    95,    96,    97,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,
     168,   169,   170,   171,    -1,   173,   174,    -1,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,
     218,   219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,
      -1,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,   267,
      -1,   269,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,   287,
      -1,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,    -1,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,   437,
     438,    -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    -1,    46,    47,    48,    49,
      50,    -1,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    -1,    -1,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    73,    -1,    -1,    -1,    77,    78,    79,
      80,    81,    -1,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,
     170,   171,    -1,   173,   174,    -1,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,   219,
     220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,   267,    -1,   269,
     270,   271,   272,   273,   274,    -1,   276,   277,    -1,    -1,
     280,   281,   282,    -1,    -1,   285,   286,   287,    -1,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,    -1,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,   437,   438,    -1,
     440,    -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     3,    -1,    -1,     6,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,
      42,    43,    44,    -1,    46,    47,    48,    49,    50,    -1,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    64,    65,    66,    67,    -1,    69,    70,    71,
      72,    73,    -1,    -1,    -1,    77,    78,    79,    80,    81,
      -1,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,   140,   141,
     142,    -1,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,   159,   160,    -1,
     162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,
      -1,   173,   174,    -1,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,    -1,   211,
      -1,    -1,   214,    -1,   216,   217,   218,   219,   220,    -1,
      -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,    -1,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,   267,    -1,   269,   270,   271,
     272,   273,   274,    -1,   276,   277,    -1,    -1,   280,   281,
     282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,    -1,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,   437,   438,    -1,   440,    -1,
     442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    11,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    -1,    46,    47,    48,    49,    50,    -1,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    -1,    63,
      64,    65,    66,    67,    -1,    69,    70,    71,    72,    73,
      -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    -1,
      -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,   159,   160,    -1,   162,    -1,
     164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,
     174,    -1,   176,   177,   178,    -1,   180,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,
     214,    -1,   216,   217,   218,   219,   220,    -1,    -1,   223,
     224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,   267,    -1,   269,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,   287,    -1,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,    -1,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
      -1,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,   437,   438,    -1,   440,    -1,   442,   443,
     444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    37,    -1,    39,    40,    -1,    42,    43,    44,    -1,
      46,    47,    48,    49,    50,    -1,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    -1,    -1,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    -1,
      -1,    77,    78,    79,    80,    81,    -1,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    -1,    95,
      96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,    -1,
      -1,    -1,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,    -1,
     226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,   267,    -1,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,    -1,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,    -1,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,    -1,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,    -1,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    37,
      -1,    39,    40,    -1,    42,    43,    44,    -1,    46,    47,
      48,    49,    50,    -1,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    -1,    -1,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,    77,
      78,    79,    80,    81,    -1,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    -1,    95,    96,    97,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,
     168,   169,   170,   171,    -1,   173,   174,    -1,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,
     218,   219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,
      -1,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,   267,
      -1,   269,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,   287,
      -1,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,    -1,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,   437,
     438,    -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    -1,    46,    47,    48,    49,
      50,    -1,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    -1,    -1,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    73,    -1,    -1,    -1,    77,    78,    79,
      80,    81,    -1,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,
     170,   171,    -1,   173,   174,    -1,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,   219,
     220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,   267,    -1,   269,
     270,   271,   272,   273,   274,    -1,   276,   277,    -1,    -1,
     280,   281,   282,    -1,    -1,   285,   286,   287,    -1,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,    -1,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,    -1,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,   437,   438,    -1,
     440,    -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,
      42,    43,    44,    -1,    46,    47,    48,    49,    50,    -1,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    64,    65,    66,    67,    -1,    69,    70,    71,
      72,    73,    -1,    -1,    -1,    77,    78,    79,    80,    81,
      -1,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,   140,   141,
     142,    -1,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,   159,   160,    -1,
     162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,
      -1,   173,   174,    -1,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,    -1,   211,
      -1,    -1,   214,    -1,   216,   217,   218,   219,   220,    -1,
      -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,    -1,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,   267,    -1,   269,   270,   271,
     272,   273,   274,    -1,   276,   277,    -1,    -1,   280,   281,
     282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,    -1,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,   437,   438,    -1,   440,    -1,
     442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    -1,    46,    47,    48,    49,    50,    -1,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    -1,    63,
      64,    65,    66,    67,    -1,    69,    70,    71,    72,    73,
      -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    -1,
      -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,   159,   160,    -1,   162,    -1,
     164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,
     174,    -1,   176,   177,   178,    -1,   180,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,
     214,    -1,   216,   217,   218,   219,   220,    -1,    -1,   223,
     224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,   267,    -1,   269,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,   287,    -1,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,    -1,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
      -1,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,   437,   438,    -1,   440,    -1,   442,   443,
     444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,
      46,    47,    48,    49,    50,    -1,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    -1,    -1,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    -1,
      -1,    77,    78,    79,    80,    81,    -1,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    -1,    95,
      96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,    -1,
      -1,    -1,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,    -1,
     226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,   267,    -1,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,    -1,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,    -1,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,    -1,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,    -1,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    -1,    42,    43,    44,    -1,    46,    47,
      48,    49,    50,    -1,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    -1,    -1,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,    77,
      78,    79,    80,    81,    -1,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    -1,    95,    96,    97,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,
     168,   169,   170,   171,    -1,   173,   174,    -1,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,
     218,   219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,
      -1,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,   267,
      -1,   269,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,   287,
      -1,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,    -1,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,   437,
     438,    -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    -1,    46,    47,    48,    49,
      50,    -1,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    -1,    -1,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    73,    -1,    -1,    -1,    77,    78,    79,
      80,    81,    -1,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,
     170,   171,    -1,   173,   174,    -1,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,   219,
     220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,   267,    -1,   269,
     270,   271,   272,   273,   274,    -1,   276,   277,    -1,    -1,
     280,   281,   282,    -1,    -1,   285,   286,   287,    -1,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,    -1,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,    -1,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,   437,   438,    -1,
     440,    -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,
      42,    43,    44,    -1,    46,    47,    48,    49,    50,    -1,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    64,    65,    66,    67,    -1,    69,    70,    71,
      72,    73,    -1,    -1,    -1,    77,    78,    79,    80,    81,
      -1,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,   140,   141,
     142,    -1,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,   159,   160,    -1,
     162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,
      -1,   173,   174,    -1,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,    -1,   211,
      -1,    -1,   214,    -1,   216,   217,   218,   219,   220,    -1,
      -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,    -1,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,   267,    -1,   269,   270,   271,
     272,   273,   274,    -1,   276,   277,    -1,    -1,   280,   281,
     282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,    -1,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,   437,   438,    -1,   440,    -1,
     442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    -1,    46,    47,    48,    49,    50,    -1,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    -1,    63,
      64,    65,    66,    67,    -1,    69,    70,    71,    72,    73,
      -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    -1,
      -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,   159,   160,    -1,   162,    -1,
     164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,
     174,    -1,   176,   177,   178,    -1,   180,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,
     214,    -1,   216,   217,   218,   219,   220,    -1,    -1,   223,
     224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,   267,    -1,   269,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,   287,    -1,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,    -1,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
      -1,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,   437,   438,    -1,   440,    -1,   442,   443,
     444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,
      46,    47,    48,    49,    50,    -1,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    -1,    -1,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    -1,
      -1,    77,    78,    79,    80,    81,    -1,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    -1,    95,
      96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,    -1,
      -1,    -1,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,    -1,
     226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,   267,    -1,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,    -1,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,    -1,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,    -1,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,    -1,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    -1,    42,    43,    44,    -1,    46,    47,
      48,    49,    50,    -1,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    -1,    -1,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,    77,
      78,    79,    80,    81,    -1,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    -1,    95,    96,    97,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,
     168,   169,   170,   171,    -1,   173,   174,    -1,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,
     218,   219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,
      -1,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,   267,
      -1,   269,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,   287,
      -1,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,    -1,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,   437,
     438,    -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    -1,    46,    47,    48,    49,
      50,    -1,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    -1,    -1,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    73,    -1,    -1,    -1,    77,    78,    79,
      80,    81,    -1,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,
     170,   171,    -1,   173,   174,    -1,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,   219,
     220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,   267,    -1,   269,
     270,   271,   272,   273,   274,    -1,   276,   277,    -1,    -1,
     280,   281,   282,    -1,    -1,   285,   286,   287,    -1,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,    -1,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,    -1,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,   437,   438,    -1,
     440,    -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,
      42,    43,    44,    -1,    46,    47,    48,    49,    50,    -1,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    64,    65,    66,    67,    -1,    69,    70,    71,
      72,    73,    -1,    -1,    -1,    77,    78,    79,    80,    81,
      -1,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,   140,   141,
     142,    -1,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,   159,   160,    -1,
     162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,
      -1,   173,   174,    -1,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,    -1,   211,
      -1,    -1,   214,    -1,   216,   217,   218,   219,   220,    -1,
      -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,    -1,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,   267,    -1,   269,   270,   271,
     272,   273,   274,    -1,   276,   277,    -1,    -1,   280,   281,
     282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,    -1,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,   437,   438,    -1,   440,    -1,
     442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    -1,    46,    47,    48,    49,    50,    -1,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    -1,    63,
      64,    65,    66,    67,    -1,    69,    70,    71,    72,    73,
      -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    -1,
      -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,   159,   160,    -1,   162,    -1,
     164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,
     174,    -1,   176,   177,   178,    -1,   180,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,
     214,    -1,   216,   217,   218,   219,   220,    -1,    -1,   223,
     224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,   267,    -1,   269,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,   287,    -1,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,    -1,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
      -1,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,   437,   438,    -1,   440,    -1,   442,   443,
     444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,
      46,    47,    48,    49,    50,    -1,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    -1,    -1,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    -1,
      -1,    77,    78,    79,    80,    81,    -1,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    -1,    95,
      96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,    -1,
      -1,    -1,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,    -1,
     226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,   267,    -1,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,    -1,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,    -1,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,    -1,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,    -1,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    -1,    42,    43,    44,    -1,    46,    47,
      48,    49,    50,    -1,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    -1,    -1,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,    77,
      78,    79,    80,    81,    -1,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    -1,    95,    96,    97,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,
     168,   169,   170,   171,    -1,   173,   174,    -1,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,
     218,   219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,
      -1,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,   267,
      -1,   269,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,   287,
      -1,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,    -1,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,   437,
     438,    -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    -1,    46,    47,    48,    49,
      50,    -1,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    -1,    -1,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    73,    -1,    -1,    -1,    77,    78,    79,
      80,    81,    -1,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,
     170,   171,    -1,   173,   174,    -1,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,   219,
     220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,   267,    -1,   269,
     270,   271,   272,   273,   274,    -1,   276,   277,    -1,    -1,
     280,   281,   282,    -1,    -1,   285,   286,   287,    -1,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,    -1,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,    -1,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,   437,   438,    -1,
     440,    -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,
      42,    43,    44,    -1,    46,    47,    48,    49,    50,    -1,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    64,    65,    66,    67,    -1,    69,    70,    71,
      72,    73,    -1,    -1,    -1,    77,    78,    79,    80,    81,
      -1,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,   140,   141,
     142,    -1,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,   159,   160,    -1,
     162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,
      -1,   173,   174,    -1,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,    -1,   211,
      -1,    -1,   214,    -1,   216,   217,   218,   219,   220,    -1,
      -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,    -1,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,   267,    -1,   269,   270,   271,
     272,   273,   274,    -1,   276,   277,    -1,    -1,   280,   281,
     282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,    -1,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,   437,   438,    -1,   440,    -1,
     442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    -1,    46,    47,    48,    49,    50,    -1,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    -1,    63,
      64,    65,    66,    67,    -1,    69,    70,    71,    72,    73,
      -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    -1,
      -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,   159,   160,    -1,   162,    -1,
     164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,
     174,    -1,   176,   177,   178,    -1,   180,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,
     214,    -1,   216,   217,   218,   219,   220,    -1,    -1,   223,
     224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,   267,    -1,   269,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,   287,    -1,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,    -1,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
      -1,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,   437,   438,    -1,   440,    -1,   442,   443,
     444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,
      46,    47,    48,    49,    50,    -1,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    -1,    -1,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    -1,
      -1,    77,    78,    79,    80,    81,    -1,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    -1,    95,
      96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,    -1,
      -1,    -1,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,    -1,
     226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,   267,    -1,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,    -1,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,    -1,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,    -1,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,    -1,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    -1,    42,    43,    44,    -1,    46,    47,
      48,    49,    50,    -1,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    -1,    -1,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,    77,
      78,    79,    80,    81,    -1,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    -1,    95,    96,    97,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,
     168,   169,   170,   171,    -1,   173,   174,    -1,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,
     218,   219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,
      -1,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,   267,
      -1,   269,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,   287,
      -1,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,    -1,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,   437,
     438,    -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    -1,    46,    47,    48,    49,
      50,    -1,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    -1,    -1,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    73,    -1,    -1,    -1,    77,    78,    79,
      80,    81,    -1,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,
     170,   171,    -1,   173,   174,    -1,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,   219,
     220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,   267,    -1,   269,
     270,   271,   272,   273,   274,    -1,   276,   277,    -1,    -1,
     280,   281,   282,    -1,    -1,   285,   286,   287,    -1,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,    -1,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,    -1,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,   437,   438,    -1,
     440,    -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,
      42,    43,    44,    -1,    46,    47,    48,    49,    50,    -1,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    64,    65,    66,    67,    -1,    69,    70,    71,
      72,    73,    -1,    -1,    -1,    77,    78,    79,    80,    81,
      -1,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,   140,   141,
     142,    -1,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,   159,   160,    -1,
     162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,
      -1,   173,   174,    -1,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,    -1,   211,
      -1,    -1,   214,    -1,   216,   217,   218,   219,   220,    -1,
      -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,    -1,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,   267,    -1,   269,   270,   271,
     272,   273,   274,    -1,   276,   277,    -1,    -1,   280,   281,
     282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,    -1,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,   437,   438,    -1,   440,    -1,
     442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    -1,    46,    47,    48,    49,    50,    -1,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    -1,    63,
      64,    65,    66,    67,    -1,    69,    70,    71,    72,    73,
      -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    -1,
      -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,   159,   160,    -1,   162,    -1,
     164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,
     174,    -1,   176,   177,   178,    -1,   180,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,
     214,    -1,   216,   217,   218,   219,   220,    -1,    -1,   223,
     224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,   267,    -1,   269,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,   287,    -1,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,    -1,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
      -1,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,   437,   438,    -1,   440,    -1,   442,   443,
     444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,
      46,    47,    48,    49,    50,    -1,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    -1,    -1,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    -1,
      -1,    77,    78,    79,    80,    81,    -1,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    -1,    95,
      96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,    -1,
      -1,    -1,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,    -1,
     226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,   267,    -1,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,    -1,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,    -1,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,    -1,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,    -1,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    -1,    42,    43,    44,    -1,    46,    47,
      48,    49,    50,    -1,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    -1,    -1,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,    77,
      78,    79,    80,    81,    -1,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    -1,    95,    96,    97,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,
     168,   169,   170,   171,    -1,   173,   174,    -1,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,
     218,   219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,
      -1,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,   267,
      -1,   269,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,   287,
      -1,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,    -1,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,   437,
     438,    -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    -1,    46,    47,    48,    49,
      50,    -1,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    -1,    -1,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    73,    -1,    -1,    -1,    77,    78,    79,
      80,    81,    -1,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,
     170,   171,    -1,   173,   174,    -1,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,   219,
     220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,   267,    -1,   269,
     270,   271,   272,   273,   274,    -1,   276,   277,    -1,    -1,
     280,   281,   282,    -1,    -1,   285,   286,   287,    -1,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,    -1,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,    -1,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,   437,   438,    -1,
     440,    -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,
      42,    43,    44,    -1,    46,    47,    48,    49,    50,    -1,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    64,    65,    66,    67,    -1,    69,    70,    71,
      72,    73,    -1,    -1,    -1,    77,    78,    79,    80,    81,
      -1,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,   140,   141,
     142,    -1,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,   159,   160,    -1,
     162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,
      -1,   173,   174,    -1,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,    -1,   211,
      -1,    -1,   214,    -1,   216,   217,   218,   219,   220,    -1,
      -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,    -1,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,   267,    -1,   269,   270,   271,
     272,   273,   274,    -1,   276,   277,    -1,    -1,   280,   281,
     282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,    -1,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,   437,   438,    -1,   440,    -1,
     442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    -1,    46,    47,    48,    49,    50,    -1,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    -1,    63,
      64,    65,    66,    67,    -1,    69,    70,    71,    72,    73,
      -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    -1,
      -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,   159,   160,    -1,   162,    -1,
     164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,
     174,    -1,   176,   177,   178,    -1,   180,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,
     214,    -1,   216,   217,   218,   219,   220,    -1,    -1,   223,
     224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,   267,    -1,   269,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,   287,    -1,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,    -1,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
      -1,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,   437,   438,    -1,   440,    -1,   442,   443,
     444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    37,    -1,    39,    40,    -1,    42,    43,    44,    -1,
      46,    47,    48,    49,    50,    -1,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    -1,    -1,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    -1,
      -1,    77,    78,    79,    80,    81,    -1,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    -1,    95,
      96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,    -1,
      -1,    -1,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,    -1,
     226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,   267,    -1,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,    -1,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,    -1,
      -1,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,    -1,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,    -1,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,    -1,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    -1,    42,    43,    44,    -1,    46,    47,
      48,    49,    50,    -1,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    -1,    -1,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,    77,
      78,    79,    80,    81,    -1,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    -1,    95,    96,    97,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,
     168,   169,   170,   171,    -1,   173,   174,    -1,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,
     218,   219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,
      -1,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,   267,
      -1,   269,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,   287,
      -1,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,    -1,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,   437,
     438,    -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    -1,    46,    47,    48,    49,
      50,    -1,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    -1,    -1,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    73,    -1,    -1,    -1,    77,    78,    79,
      80,    81,    -1,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,
     170,   171,    -1,   173,   174,    -1,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,   219,
     220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,   267,    -1,   269,
     270,   271,   272,   273,   274,    -1,   276,   277,    -1,    -1,
     280,   281,   282,    -1,    -1,   285,   286,   287,    -1,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,    -1,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,    -1,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,   437,   438,    -1,
     440,    -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,
      42,    43,    44,    -1,    46,    47,    48,    49,    50,    -1,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    64,    65,    66,    67,    -1,    69,    70,    71,
      72,    73,    -1,    -1,    -1,    77,    78,    79,    80,    81,
      -1,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,   140,   141,
     142,    -1,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,   159,   160,    -1,
     162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,
      -1,   173,   174,    -1,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,    -1,   211,
      -1,    -1,   214,    -1,   216,   217,   218,   219,   220,    -1,
      -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,    -1,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,   267,    -1,   269,   270,   271,
     272,   273,   274,    -1,   276,   277,    -1,    -1,   280,   281,
     282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,    -1,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,   437,   438,    -1,   440,    -1,
     442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    -1,    46,    47,    48,    49,    50,    -1,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    -1,    63,
      64,    65,    66,    67,    -1,    69,    70,    71,    72,    73,
      -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    -1,
      -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,   159,   160,    -1,   162,    -1,
     164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,
     174,    -1,   176,   177,   178,    -1,   180,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,
     214,    -1,   216,   217,   218,   219,   220,    -1,    -1,   223,
     224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,   267,    -1,   269,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,   287,    -1,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,    -1,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
      -1,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,   437,   438,    -1,   440,    -1,   442,   443,
     444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,
      46,    47,    48,    49,    50,    -1,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    -1,    -1,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    -1,
      -1,    77,    78,    79,    80,    81,    -1,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    -1,    95,
      96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,    -1,
      -1,    -1,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,    -1,
     226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,   267,    -1,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,    -1,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,    -1,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,    -1,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,    -1,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    -1,    42,    43,    44,    -1,    46,    47,
      48,    49,    50,    -1,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    -1,    -1,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,    77,
      78,    79,    80,    81,    -1,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    -1,    95,    96,    97,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,
     168,   169,   170,   171,    -1,   173,   174,    -1,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,
     218,   219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,
      -1,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,   267,
      -1,   269,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,   287,
      -1,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,    -1,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,   437,
     438,    -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    -1,    46,    47,    48,    49,
      50,    -1,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    -1,    -1,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    73,    -1,    -1,    -1,    77,    78,    79,
      80,    81,    -1,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,
     170,   171,    -1,   173,   174,    -1,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,   219,
     220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,   267,    -1,   269,
     270,   271,   272,   273,   274,    -1,   276,   277,    -1,    -1,
     280,   281,   282,    -1,    -1,   285,   286,   287,    -1,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,    -1,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,    -1,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,   437,   438,    -1,
     440,    -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,
      42,    43,    44,    -1,    46,    47,    48,    49,    50,    -1,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    64,    65,    66,    67,    -1,    69,    70,    71,
      72,    73,    -1,    -1,    -1,    77,    78,    79,    80,    81,
      -1,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,   140,   141,
     142,    -1,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,   159,   160,    -1,
     162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,
      -1,   173,   174,    -1,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,    -1,   211,
      -1,    -1,   214,    -1,   216,   217,   218,   219,   220,    -1,
      -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,    -1,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,   267,    -1,   269,   270,   271,
     272,   273,   274,    -1,   276,   277,    -1,    -1,   280,   281,
     282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,    -1,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,   437,   438,    -1,   440,    -1,
     442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    -1,    46,    47,    48,    49,    50,    -1,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    -1,    63,
      64,    65,    66,    67,    -1,    69,    70,    71,    72,    73,
      -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    -1,
      -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,   159,   160,    -1,   162,    -1,
     164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,
     174,    -1,   176,   177,   178,    -1,   180,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,
     214,    -1,   216,   217,   218,   219,   220,    -1,    -1,   223,
     224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,   267,    -1,   269,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,   287,    -1,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,    -1,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
      -1,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,   437,   438,    -1,   440,    -1,   442,   443,
     444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,
      46,    47,    48,    49,    50,    -1,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    -1,    -1,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    -1,
      -1,    77,    78,    79,    80,    81,    -1,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    -1,    95,
      96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,    -1,
      -1,    -1,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,    -1,
     226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,   267,    -1,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,    -1,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,    -1,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,    -1,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,    -1,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    -1,    42,    43,    44,    -1,    46,    47,
      48,    49,    50,    -1,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    -1,    -1,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,    77,
      78,    79,    80,    81,    -1,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    -1,    95,    96,    97,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,
     168,   169,   170,   171,    -1,   173,   174,    -1,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,
     218,   219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,
      -1,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,   267,
      -1,   269,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,   287,
      -1,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,    -1,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,   437,
     438,    -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    -1,    46,    47,    48,    49,
      50,    -1,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    -1,    -1,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    73,    -1,    -1,    -1,    77,    78,    79,
      80,    81,    -1,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,
     170,   171,    -1,   173,   174,    -1,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,   219,
     220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,   267,    -1,   269,
     270,   271,   272,   273,   274,    -1,   276,   277,    -1,    -1,
     280,   281,   282,    -1,    -1,   285,   286,   287,    -1,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,    -1,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,    -1,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,   437,   438,    -1,
     440,    -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,
      42,    43,    44,    -1,    46,    47,    48,    49,    50,    -1,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    64,    65,    66,    67,    -1,    69,    70,    71,
      72,    73,    -1,    -1,    -1,    77,    78,    79,    80,    81,
      -1,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,   140,   141,
     142,    -1,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,   159,   160,    -1,
     162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,
      -1,   173,   174,    -1,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,    -1,   211,
      -1,    -1,   214,    -1,   216,   217,   218,   219,   220,    -1,
      -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,    -1,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,   267,    -1,   269,   270,   271,
     272,   273,   274,    -1,   276,   277,    -1,    -1,   280,   281,
     282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,    -1,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,   437,   438,    -1,   440,    -1,
     442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    -1,    46,    47,    48,    49,    50,    -1,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    -1,    63,
      64,    65,    66,    67,    -1,    69,    70,    71,    72,    73,
      -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    -1,
      -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,   159,   160,    -1,   162,    -1,
     164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,
     174,    -1,   176,   177,   178,    -1,   180,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,
     214,    -1,   216,   217,   218,   219,   220,    -1,    -1,   223,
     224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,   267,    -1,   269,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,   287,    -1,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,    -1,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
      -1,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,   437,   438,    -1,   440,    -1,   442,   443,
     444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,
      46,    47,    48,    49,    50,    -1,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    -1,    -1,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    -1,
      -1,    77,    78,    79,    80,    81,    -1,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    -1,    95,
      96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,    -1,
      -1,    -1,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,    -1,
     226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,   267,    -1,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,    -1,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,    -1,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,    -1,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,    -1,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    -1,    42,    43,    44,    45,    46,    47,
      48,    -1,    50,    51,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    -1,    -1,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    -1,    -1,    75,    -1,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    94,    95,    96,    97,
      -1,    -1,    -1,   101,    -1,    -1,    -1,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
      -1,   149,   150,   151,   152,    -1,    -1,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,    -1,    -1,    -1,   177,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,    -1,    -1,   223,    -1,   225,   226,   227,
      -1,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,    -1,    -1,   262,    -1,   264,   265,   266,   267,
      -1,    -1,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,    -1,   306,    -1,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,    -1,   391,    -1,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,    -1,   412,    -1,    -1,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,    -1,
     438,   439,   440,   441,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     468,   469,   470,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    -1,    46,    47,    48,    49,    50,    -1,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    -1,    63,
      64,    65,    66,    67,    -1,    69,    70,    71,    72,    73,
      -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    -1,
      -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,   159,   160,    -1,   162,    -1,
     164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,
     174,    -1,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,
     214,    -1,   216,   217,   218,   219,   220,    -1,    -1,   223,
     224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,   267,    -1,   269,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,   287,    -1,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,    -1,   299,   300,    -1,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,    -1,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
      -1,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,   437,   438,    -1,   440,    -1,   442,   443,
     444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    48,    -1,    50,    51,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    -1,    -1,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    -1,    -1,    75,
      -1,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    94,    95,
      96,    97,    -1,    -1,    -1,   101,    -1,    -1,    -1,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,    -1,   149,   150,   151,   152,    -1,    -1,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,    -1,    -1,
      -1,   177,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,    -1,   223,    -1,   225,
     226,   227,    -1,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,    -1,    -1,   262,    -1,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,    -1,   288,   289,   290,    -1,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,    -1,
     306,    -1,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,    -1,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,    -1,   412,    -1,    -1,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,    -1,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,   438,    -1,   440,   441,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   468,   469,   470,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,
      42,    43,    44,    45,    46,    47,    48,    -1,    50,    51,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    64,    65,    66,    67,    -1,    69,    70,    71,
      72,    -1,    -1,    75,    -1,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    -1,    94,    95,    96,    97,    -1,    -1,    -1,   101,
      -1,    -1,    -1,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,   140,   141,
     142,    -1,   144,   145,   146,   147,    -1,   149,   150,   151,
     152,    -1,    -1,   155,    -1,   157,   158,   159,   160,    -1,
     162,    -1,   164,   165,    -1,   167,   168,   169,   170,   171,
      -1,   173,    -1,    -1,    -1,   177,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,    -1,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,    -1,
      -1,   223,    -1,   225,   226,   227,    -1,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,    -1,
     262,    -1,   264,   265,   266,   267,    -1,    -1,   270,   271,
     272,   273,   274,    -1,   276,   277,    -1,    -1,   280,   281,
     282,    -1,    -1,   285,   286,    -1,   288,   289,   290,    -1,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
      -1,   303,   304,    -1,   306,    -1,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
      -1,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,    -1,    -1,   409,   410,    -1,
     412,    -1,    -1,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,    -1,   438,    -1,   440,   441,
     442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   468,   469,   470,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    -1,    42,    43,    44,    45,    46,    47,
      48,    -1,    50,    51,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    -1,    -1,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    -1,    -1,    75,    -1,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    94,    95,    96,    97,
      -1,    -1,    -1,   101,    -1,    -1,    -1,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
      -1,   149,   150,   151,   152,    -1,    -1,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,    -1,    -1,    -1,   177,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,    -1,    -1,   223,    -1,   225,   226,   227,
      -1,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,    -1,   262,    -1,   264,   265,   266,   267,
      -1,    -1,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,    -1,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,    -1,   306,    -1,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,    -1,   391,    -1,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,    -1,   412,    -1,    -1,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,    -1,
     438,    -1,   440,   441,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     468,   469,   470,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    45,    46,    47,    48,    -1,    50,    51,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    -1,    63,
      64,    65,    66,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    75,    -1,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    -1,
      94,    95,    96,    97,    -1,    -1,    -1,   101,    -1,    -1,
      -1,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,    -1,   149,   150,   151,   152,    -1,
      -1,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
     164,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
      -1,    -1,    -1,   177,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,    -1,    -1,   223,
      -1,   225,   226,   227,    -1,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,    -1,    -1,   262,    -1,
     264,   265,   266,   267,    -1,    -1,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,    -1,   288,   289,   290,    -1,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,    -1,   303,
     304,    -1,   306,    -1,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,    -1,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,    -1,   412,    -1,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
      -1,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,    -1,   438,    -1,   440,   441,   442,   443,
     444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   468,   469,   470,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    45,    46,    47,    48,    -1,
      50,    51,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    -1,    -1,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    -1,    -1,    75,    -1,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    94,    95,    96,    97,    -1,    -1,
      -1,   101,    -1,    -1,    -1,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,    -1,   149,
     150,   151,   152,    -1,    -1,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,    -1,    -1,    -1,   177,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,    -1,    -1,   223,    -1,   225,   226,   227,    -1,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
      -1,    -1,   262,    -1,   264,   265,   266,   267,    -1,    -1,
     270,   271,   272,   273,   274,    -1,   276,   277,    -1,    -1,
     280,   281,   282,    -1,    -1,   285,   286,    -1,   288,   289,
     290,    -1,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,    -1,   306,    -1,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,    -1,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,    -1,   412,    -1,    -1,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,    -1,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,   438,    -1,
     440,   441,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   468,   469,
     470,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    48,    -1,    50,    51,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    -1,    -1,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    -1,    -1,    75,
      -1,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    94,    95,
      96,    97,    -1,    -1,    -1,   101,    -1,    -1,    -1,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,    -1,   149,   150,   151,   152,    -1,    -1,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,    -1,    -1,
      -1,   177,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,    -1,   223,    -1,   225,
     226,   227,    -1,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,    -1,    -1,   262,    -1,   264,   265,
     266,   267,    -1,    -1,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,    -1,   288,   289,   290,    -1,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,    -1,
     306,    -1,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,    -1,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,    -1,   412,    -1,    -1,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,    -1,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,   438,    -1,   440,   441,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   468,   469,   470,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,
      42,    43,    44,    45,    46,    47,    48,    -1,    50,    51,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    64,    65,    66,    67,    -1,    69,    70,    71,
      72,    -1,    -1,    75,    -1,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    -1,    94,    95,    96,    97,    -1,    -1,    -1,   101,
      -1,    -1,    -1,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,   140,   141,
     142,    -1,   144,   145,   146,   147,    -1,   149,   150,   151,
     152,    -1,    -1,   155,    -1,   157,   158,   159,   160,    -1,
     162,    -1,   164,   165,    -1,   167,   168,   169,   170,   171,
      -1,   173,    -1,    -1,    -1,   177,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,    -1,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,    -1,
      -1,   223,    -1,   225,   226,   227,    -1,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,    -1,    -1,
     262,    -1,   264,   265,   266,   267,    -1,    -1,   270,   271,
     272,   273,   274,    -1,   276,   277,    -1,    -1,   280,   281,
     282,    -1,    -1,   285,   286,    -1,   288,   289,   290,    -1,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
      -1,   303,   304,    -1,   306,    -1,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
      -1,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,    -1,    -1,   409,   410,    -1,
     412,    -1,    -1,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,    -1,   438,    -1,   440,   441,
     442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   468,   469,   470,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    -1,    42,    43,    44,    45,    46,    47,
      48,    -1,    50,    51,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    -1,    -1,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    -1,    -1,    75,    -1,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    94,    95,    96,    97,
      -1,    -1,    -1,   101,    -1,    -1,    -1,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
      -1,   149,   150,   151,   152,    -1,    -1,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,    -1,    -1,    -1,   177,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,    -1,    -1,   223,    -1,   225,   226,   227,
      -1,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,    -1,    -1,   262,    -1,   264,   265,   266,   267,
      -1,    -1,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,    -1,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,    -1,   306,    -1,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,    -1,   391,    -1,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,    -1,   412,    -1,    -1,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,    -1,
     438,    -1,   440,   441,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     468,   469,   470,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    45,    46,    47,    48,    -1,    50,    51,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    -1,    63,
      64,    65,    66,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    75,    -1,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    -1,
      94,    95,    96,    97,    -1,    -1,    -1,   101,    -1,    -1,
      -1,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,    -1,   149,   150,   151,   152,    -1,
      -1,   155,    -1,   157,   158,   159,   160,    -1,   162,    -1,
     164,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
      -1,    -1,    -1,   177,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,    -1,    -1,   223,
      -1,   225,   226,   227,    -1,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,    -1,    -1,   262,    -1,
     264,   265,   266,   267,    -1,    -1,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,    -1,   288,   289,   290,    -1,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,    -1,   303,
     304,    -1,   306,    -1,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,    -1,   366,   367,    -1,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,    -1,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,    -1,   412,    -1,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
      -1,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,    -1,   438,    -1,   440,   441,   442,   443,
     444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   468,   469,   470,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    45,    46,    47,    48,    -1,
      -1,    51,    -1,    -1,    -1,    55,    56,    57,    58,    59,
      60,    -1,    -1,    63,    64,    -1,    -1,    67,    -1,    69,
      70,    71,    72,    -1,    -1,    75,    -1,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    94,    95,    96,    97,    -1,    -1,
      -1,   101,    -1,    -1,    -1,   105,   106,   107,   108,   109,
     110,    -1,    -1,   113,    -1,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,    -1,   149,
     150,   151,   152,    -1,    -1,   155,    -1,   157,   158,    -1,
     160,    -1,   162,    -1,   164,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,    -1,    -1,    -1,   177,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,    -1,   202,   203,   204,   205,    -1,    -1,    -1,    -1,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,    -1,    -1,   223,    -1,   225,   226,   227,    -1,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
      -1,   251,    -1,   253,   254,   255,   256,   257,   258,   259,
      -1,    -1,   262,    -1,   264,   265,   266,   267,    -1,    -1,
     270,    -1,   272,   273,   274,    -1,   276,   277,    -1,    -1,
     280,   281,   282,    -1,    -1,   285,   286,    -1,   288,   289,
     290,    -1,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,    -1,   306,    -1,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,    -1,   366,   367,    -1,   369,
     370,   371,   372,   373,    -1,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,    -1,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,    -1,    -1,    -1,    -1,   409,
     410,    -1,   412,    -1,    -1,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,    -1,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,    -1,
     440,   441,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   468,   469,
     470
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    20,    30,    32,    33,    48,    57,    69,    71,    72,
      78,    80,    91,    93,   110,   113,   127,   129,   133,   139,
     147,   149,   156,   172,   189,   229,   230,   235,   247,   265,
     301,   309,   323,   329,   330,   332,   337,   342,   345,   352,
     358,   359,   366,   370,   380,   395,   415,   426,   432,   437,
     450,   473,   487,   494,   495,   496,   497,   498,   504,   505,
     507,   508,   509,   510,   512,   516,   528,   533,   534,   537,
     538,   539,   558,   561,   562,   577,   621,   622,   623,   626,
     629,   630,   631,   639,   645,   647,   649,   650,   653,   656,
     657,   661,   670,   674,   675,   676,   677,   680,   682,   683,
     684,   685,   693,   695,   715,   719,   721,   722,   732,   734,
     741,   742,   745,   746,   747,   748,   749,   757,   759,   763,
     768,   772,   773,   781,   782,   785,   790,   804,   831,   834,
     835,   836,   841,   844,   846,   848,   850,   851,   856,   857,
     860,   862,   863,   867,   868,   869,   872,   873,   876,   877,
     878,   885,   887,   888,   889,   895,   897,   898,   904,   905,
     906,   909,   910,   911,   912,   914,   915,   917,   918,   920,
     921,   923,   935,   941,   944,   946,   947,   956,   958,   963,
     968,   972,   973,   974,   975,   976,   977,   981,  1016,   409,
     453,   890,    27,    75,    90,   108,   114,   131,   142,   151,
     163,   168,   175,   194,   219,   240,   280,   304,   314,   315,
     318,   344,   347,   351,   353,   360,   363,   382,   389,   394,
     395,   398,   402,   412,   417,   430,   443,   646,   890,     3,
      20,    21,    22,    23,    24,    25,    26,    27,    29,    30,
      31,    39,    40,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    55,    56,    57,    58,    59,
      60,    63,    64,    65,    66,    67,    69,    70,    71,    72,
      73,    75,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    87,    88,    89,    90,    91,    92,    94,    95,    96,
      97,   101,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   115,   117,   118,   119,   120,   121,   122,   124,   125,
     126,   127,   130,   131,   132,   133,   134,   136,   137,   138,
     140,   141,   142,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   155,   157,   158,   159,   160,   162,   164,
     165,   167,   168,   169,   170,   171,   173,   174,   176,   177,
     178,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   191,   192,   193,   194,   195,   196,   197,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   209,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   223,   224,
     225,   226,   227,   229,   230,   231,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   264,   265,   266,   267,   269,
     270,   271,   272,   273,   274,   276,   277,   280,   281,   282,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   303,   304,   305,   306,
     307,   308,   309,   310,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   360,
     361,   362,   363,   364,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   393,
     394,   396,   397,   398,   399,   400,   401,   402,   404,   405,
     406,   409,   410,   411,   412,   413,   415,   416,   417,   418,
     419,   420,   421,   422,   425,   426,   427,   428,   429,   432,
     433,   434,   435,   436,   437,   438,   440,   441,   442,   443,
     444,   445,   448,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,  1075,  1150,  1158,  1159,  1162,  1163,  1164,
       3,    28,   969,  1144,  1158,  1162,   441,   928,   278,   310,
     890,    51,   487,   569,    22,    39,    62,    75,    86,   108,
     114,   131,   142,   151,   163,   171,   175,   231,   280,   283,
     304,   318,   344,   353,   363,   382,   389,   398,   399,   401,
     402,   412,   417,   424,   427,   430,   578,   628,   737,   791,
     805,    28,   309,  1144,   969,    28,   303,   361,   399,   401,
       6,   218,   842,   843,  1153,    22,    27,    62,    75,    90,
     108,   131,   142,   151,   163,   168,   175,   194,   240,   280,
     293,   304,   315,   318,   344,   347,   351,   353,   360,   363,
     382,   389,   395,   398,   402,   410,   412,   417,   430,   443,
     646,   750,   751,   752,   890,  1144,    93,   441,   487,   623,
     626,   629,   923,   936,   944,   947,   956,   963,   968,   972,
      11,    21,    28,    46,   158,   164,   166,   190,   220,   254,
     312,   331,   478,   479,   769,   770,   969,  1152,  1154,    28,
      93,   327,   359,   774,   775,   776,  1158,   163,  1158,  1149,
    1153,   395,   984,   769,  1158,   337,   366,   370,   409,  1144,
     293,   240,   108,   194,   353,   394,   395,   487,   852,   853,
     352,  1158,    28,   364,   405,   409,   520,   529,   530,  1158,
      25,   172,   774,   775,   310,   890,  1158,   217,    28,   128,
     986,   987,    63,    87,   231,   249,   344,   353,   364,   405,
     409,   456,   517,   518,   519,   520,    28,   364,   405,   409,
     520,   409,   279,  1027,  1142,  1158,   984,   480,  1158,   167,
     487,   929,   487,   325,   978,   979,  1144,   978,   973,   974,
     977,     0,   490,   487,   928,   143,   208,   284,   423,   988,
     989,   973,   975,   976,   119,   204,   429,   491,    34,   894,
     821,  1150,   754,  1158,   754,  1145,  1158,   313,   754,   412,
    1144,   107,   395,   809,  1150,  1158,  1164,     3,   104,   365,
    1155,  1156,  1160,  1162,  1163,  1164,    28,   184,  1142,   272,
     443,    10,    17,    18,    19,    70,   155,   474,   475,   476,
     478,   479,   480,   481,   482,   483,   838,   840,  1105,  1106,
    1158,   184,  1144,   809,  1144,    28,  1155,  1156,   809,  1144,
    1144,   184,  1142,  1144,   184,   754,  1144,   337,   366,    28,
     184,  1027,  1144,   356,  1144,   754,    28,   238,  1155,  1156,
     184,  1142,   218,   116,   214,   263,   321,   891,   892,   893,
     487,   485,   489,  1133,  1135,  1142,  1148,  1158,    22,    27,
      62,    75,    76,    86,    90,   108,   131,   142,   151,   163,
     168,   194,   219,   240,   280,   304,   315,   318,   344,   347,
     351,   353,   360,   363,   382,   389,   395,   398,   402,   410,
     412,   417,   443,   646,   760,   761,  1153,   894,   943,   947,
     956,   963,   972,  1142,   242,   754,   487,   184,   754,   412,
    1145,   754,   412,   184,  1144,   107,   395,   399,   401,  1155,
    1156,   399,   401,    70,   155,   838,   335,  1144,  1144,  1155,
     184,   513,  1158,   184,  1144,   184,   754,  1144,  1144,   356,
    1144,   754,   238,  1155,   325,   360,   395,   443,   240,    90,
     194,    27,   168,   315,   351,   410,   416,   640,    28,  1144,
     970,   527,  1153,  1160,   843,   242,   184,   821,   822,   184,
     847,   184,  1145,     3,    50,    52,    53,    65,    66,   111,
     112,   132,   159,   184,   206,   207,   209,   250,   252,   271,
     322,   368,   374,   405,   406,   438,   756,  1049,  1051,  1053,
    1055,  1057,  1059,  1060,  1061,  1063,  1064,  1065,  1067,  1068,
    1159,  1162,   412,   107,   395,   184,   808,   809,   184,  1156,
    1157,    82,   443,    70,   155,   184,   839,   840,    55,   184,
     808,   184,  1157,   184,   808,   184,  1144,   184,  1144,   356,
     847,   184,   756,   184,   238,  1157,   218,   184,   753,   754,
     184,  1143,  1144,   184,  1144,   894,   487,   945,   578,   936,
     437,   923,   937,   938,   939,  1160,   928,  1154,   770,   771,
      28,   771,  1154,   771,    28,   771,  1154,   771,   771,   771,
    1154,  1152,  1152,   969,   771,   313,   487,   487,   598,   598,
     598,   278,   407,   491,   598,   353,  1027,  1028,   491,   886,
     530,   518,   520,    28,   520,  1153,   487,   942,    55,   443,
     441,   854,   855,    82,   792,   792,  1158,    45,   470,   214,
     489,   281,   281,   278,   166,  1153,   407,   894,   161,   764,
     278,     5,     8,     9,    10,    12,    36,    50,    52,    53,
      61,    62,    65,    66,    73,    75,    98,    99,   100,   101,
     102,   103,   104,   111,   112,   114,   148,   153,   154,   159,
     174,   176,   206,   207,   209,   224,   232,   233,   250,   252,
     261,   263,   268,   269,   271,   280,   291,   305,   322,   349,
     365,   374,   390,   405,   406,   411,   413,   414,   424,   430,
     438,   458,   459,   460,   461,   463,   464,   465,   466,   471,
     478,   479,   480,   487,   973,  1052,  1055,  1058,  1059,  1060,
    1062,  1063,  1064,  1067,  1068,  1072,  1074,  1075,  1076,  1078,
    1101,  1102,  1103,  1107,  1127,  1132,  1139,  1140,  1150,  1151,
    1152,  1153,  1158,  1138,  1139,  1153,    28,   535,  1141,  1142,
     364,   517,   114,   526,  1153,   527,  1153,    45,    67,   517,
     470,   375,   892,   281,   166,   407,   476,    45,   470,   214,
     893,   487,  1142,   480,  1135,  1028,   922,   923,   924,   925,
    1160,   165,   930,  1072,  1110,   978,   491,   487,   931,   488,
     488,   496,   922,   932,   933,   934,  1142,    28,   128,   985,
     985,    55,   985,   156,   161,   228,   275,   992,   994,   995,
    1010,  1012,  1013,  1014,   988,   989,   166,   210,  1027,  1029,
     487,    64,   259,   294,   333,   366,   487,   819,   294,   329,
     333,   366,   489,   755,   294,   333,   366,     3,    85,   137,
     234,   294,   301,   333,   366,   398,   400,   450,   528,   531,
     899,   900,   901,   902,   786,    24,   133,   294,   333,   366,
     434,   544,  1144,    24,   133,   366,   429,   511,   454,   184,
    1027,    58,    92,   152,   187,   223,   259,   263,   294,   295,
     333,   341,   350,   358,   366,   378,   387,   391,   445,   528,
     532,   824,   832,   861,   487,   806,  1135,   333,   511,   190,
     148,    24,    30,    43,    72,   126,   133,   136,   162,   196,
     259,   263,   273,   282,   294,   333,   336,   337,   366,   434,
     540,   542,   543,   664,   861,     5,   478,   479,   637,  1154,
      28,   184,  1142,   754,   754,   487,   837,   294,   366,   489,
     148,   278,   294,   333,   366,   832,   861,    24,   133,   294,
     333,   366,   190,   506,   333,   450,   473,   499,   506,   294,
     333,   366,   832,   861,   278,   294,   333,   148,    37,    56,
     106,   193,   241,   244,   259,   293,   333,   338,   360,   366,
     380,   540,   634,   635,   294,   333,   442,   664,   672,   148,
     294,   333,   366,    85,   126,   136,   294,   329,   333,   366,
     530,   518,   190,   148,    43,   124,   259,   333,   366,   540,
     541,   294,   333,   337,   366,    83,   125,   296,   400,   278,
      24,    30,   133,   294,   333,   366,   559,   560,   506,   161,
     333,   499,   506,   148,   333,   366,   540,  1144,   226,   116,
     279,   455,   491,   891,    28,   128,   439,   480,   488,   814,
    1072,  1111,  1112,  1159,  1072,  1134,     3,    28,    32,    33,
      34,    35,    36,    37,    38,    41,    54,    61,    62,    68,
      74,    76,    86,    93,    98,    99,   100,   102,   103,   104,
     114,   116,   123,   128,   129,   135,   139,   143,   154,   156,
     161,   163,   166,   172,   175,   179,   190,   198,   208,   210,
     221,   222,   228,   232,   233,   263,   268,   275,   278,   279,
     283,   284,   302,   311,   327,   340,   359,   365,   376,   392,
     395,   403,   407,   408,   414,   423,   424,   430,   431,   439,
     446,   447,   449,   450,   480,  1147,  1161,  1162,  1163,  1164,
    1165,  1133,   431,   919,   278,   242,   821,   487,  1144,  1049,
     412,   107,   395,   809,   272,   443,    70,   155,   840,  1144,
     809,   809,  1144,   356,   161,  1144,  1049,   218,   754,  1144,
     488,   598,  1144,    68,  1049,   263,   166,   487,   723,  1144,
     499,    37,   913,  1144,   263,   499,   454,   184,  1142,   499,
     754,   754,   723,   427,   578,   278,   161,   870,   871,   499,
     263,    45,   514,   263,   417,   671,   263,   931,    85,   294,
     648,    83,   125,   296,   400,    26,    47,   205,   696,    37,
     723,   161,   184,   499,   443,   184,  1142,   184,   624,  1142,
    1142,   443,   754,   792,  1150,  1150,  1150,  1144,   161,   646,
      51,   105,   203,   259,   355,   148,    59,   339,   491,   545,
     148,   487,   148,   499,   440,  1066,  1066,  1066,   487,  1054,
    1054,   307,   487,  1056,   148,    65,    66,  1066,  1054,  1051,
     452,   473,   487,  1069,   487,  1069,   491,   545,    36,  1050,
     487,   109,   182,   243,   246,   357,   468,   487,  1070,  1071,
     755,  1054,   454,   148,   491,   545,   148,   491,   184,   753,
     184,   754,   184,   754,   148,   491,   545,  1157,   148,   545,
     148,   148,   545,   148,   545,   148,    83,   125,   296,   400,
     161,   148,   545,   148,   161,   184,   184,   527,   148,   491,
     545,   148,   491,   545,   148,   278,  1110,   395,   488,   491,
     154,   278,   414,   524,   527,   637,   940,   936,   771,   969,
     771,   969,   771,   969,   771,   969,   771,   969,   969,   969,
     771,   969,   487,   599,   600,  1158,   599,    28,   108,   131,
     163,   168,   218,   219,   315,   347,   353,   360,   395,   398,
     417,   777,  1141,  1157,   776,  1144,   190,   491,   959,  1153,
    1049,  1113,    37,  1157,   792,   488,   491,  1142,  1144,   226,
    1158,   161,   161,   777,  1157,   352,  1158,   527,   278,   487,
    1136,   485,   973,  1114,  1072,  1131,   487,   487,   161,   487,
     487,   973,   487,   487,   487,   487,   487,   487,   487,  1072,
     487,   487,   487,   487,   487,   487,   487,   487,   973,   487,
     487,   487,   487,   487,   487,   487,   487,  1072,  1072,  1072,
     973,  1072,  1110,  1135,  1153,   487,  1153,     3,    10,    13,
      17,    18,    19,    34,    37,    42,    49,    74,   185,   190,
     212,   213,   227,   266,   280,   283,   371,   471,   474,   475,
     476,   478,   479,   480,   481,   482,   483,  1105,  1107,  1109,
     451,  1088,   290,  1072,   210,   491,   982,   487,  1153,  1135,
     982,   117,   186,   536,   491,    67,   114,   527,    37,     3,
     114,   231,   525,   637,  1068,  1153,  1153,    88,   130,  1084,
      97,   114,   521,   522,   524,   637,   114,   521,   226,  1142,
      89,   338,   758,   488,   491,   524,   637,   926,   928,   488,
     491,   979,  1143,    37,   488,   491,   931,   975,   975,   990,
     991,  1072,   975,   158,   254,  1001,   216,   259,   321,   369,
     429,    28,   996,  1072,   478,   479,   997,   998,  1072,  1074,
    1010,  1011,   995,   994,   992,   993,   161,  1013,   273,  1015,
     992,  1010,  1029,   948,  1142,    37,  1158,   366,  1110,    64,
     407,   407,   353,   190,   201,   284,   287,   368,   439,   480,
     812,   813,   814,   816,   818,   820,  1049,  1159,   407,   442,
     407,   353,  1147,   489,   407,   407,   353,   228,   407,   407,
     398,   517,   294,   899,   901,   476,   903,   161,   172,   190,
     342,   787,   788,    68,    86,   144,   163,   311,   424,   595,
     596,    86,   114,   263,   407,    86,   407,   114,   263,   353,
      86,   126,   136,   294,   333,   720,   353,   654,    22,    27,
      62,    75,    90,   131,   142,   163,   168,   240,   280,   315,
     347,   353,   360,   363,   395,   402,   410,   417,   443,   646,
    1144,   148,   333,   366,   540,   278,   637,   358,   223,   407,
    1158,   407,   268,   637,   118,   211,   353,   364,   409,   519,
     754,   339,   366,   824,   833,   122,   488,   807,   812,   407,
     430,   398,  1142,    76,   144,   184,   585,   595,  1158,    76,
      86,   858,   298,   278,   349,   351,   412,    86,   858,    31,
     336,   349,   351,   412,   349,  1142,   162,   196,   273,   754,
     487,   407,   407,   183,   487,   549,   237,   398,   427,   452,
     549,    86,   491,   122,     5,     5,   294,   190,   148,   333,
     366,   540,   861,   431,   431,   260,  1049,   407,   353,   487,
     838,  1144,  1142,   407,   407,   353,   833,   122,   395,   395,
     407,   407,   395,   723,   108,   366,   531,   407,   501,   531,
     407,   407,   353,   833,   122,  1142,   407,   407,  1142,  1051,
     637,    55,   636,   637,   637,   106,   241,   244,    55,   407,
     499,   248,   353,   499,   259,   635,   407,   407,   268,  1153,
     664,   754,   407,   407,   353,   382,  1153,   407,   318,   407,
     318,   723,   398,  1027,   298,   298,    86,   407,   858,   353,
     407,   407,   549,   549,   754,   754,   754,   754,  1142,    44,
     436,    44,    44,   407,    44,   407,   436,   353,   487,   491,
     531,   430,   681,  1156,   407,   501,   531,  1142,   407,   858,
     353,   294,   333,   321,   334,   362,   523,   891,  1111,  1111,
    1112,   488,    15,    16,   491,   988,   989,   486,   492,  1148,
    1158,  1142,   212,  1049,   278,   212,   454,   212,   637,   754,
     754,   212,   278,   212,   212,   278,    83,   125,   296,   400,
    1049,   278,   212,   212,   212,   407,   166,   407,   563,   417,
     487,    37,   148,   754,   724,   725,  1161,    26,   899,  1049,
     278,   148,   651,  1144,   263,   298,   487,   500,   737,   431,
     325,   443,  1142,    28,   395,   450,   828,   500,   148,  1156,
      93,   172,   515,   577,   630,   695,   772,   790,   895,   148,
    1153,   672,   673,   148,   278,  1153,  1156,   234,   754,   754,
     754,   754,   273,   119,   204,   415,   429,   697,   698,   140,
     320,   487,   681,   263,   500,  1142,   263,   632,   634,   263,
      37,   273,   298,   487,   598,   598,   184,   627,  1142,   161,
     184,   793,  1148,   487,   727,   819,   487,   810,   810,    37,
    1049,   218,   450,   452,   971,   355,   822,   821,  1049,  1145,
     487,   487,  1110,  1152,   756,  1066,  1066,    36,  1050,   405,
     405,  1152,  1152,  1049,   485,   485,  1152,   407,   407,   407,
     487,   407,  1152,  1054,   808,   809,  1157,  1156,   148,   545,
     148,   431,   148,   431,   839,   840,   545,   808,  1157,   808,
    1144,  1144,  1049,   756,  1157,   681,   148,   148,   545,   753,
     754,  1143,  1144,  1144,   754,   488,   184,  1142,   936,   938,
     969,   969,   969,   969,   969,   969,   599,   488,   491,   488,
     169,   316,   348,   361,   396,  1143,   753,   107,   363,   808,
    1143,   272,   808,   808,  1143,  1141,  1141,  1143,   753,   407,
     450,   783,   143,   228,   678,   679,    22,   146,   349,   369,
     960,  1027,   267,   961,   488,   491,   943,   407,  1142,   852,
     853,   855,   775,   774,   775,   166,   173,   784,  1158,    27,
      76,   108,   131,   142,   163,   168,   219,   240,   315,   318,
     344,   347,   353,   360,   389,   395,   398,   417,   443,   646,
     765,   766,  1110,  1133,   486,  1110,  1114,  1115,   446,  1128,
    1129,  1072,  1110,   487,  1152,  1152,     3,   109,   182,   243,
     246,   357,   468,  1116,  1117,  1153,  1110,  1110,  1110,  1152,
    1152,  1072,  1072,   838,  1072,  1119,   349,   478,   479,   487,
    1073,  1074,  1107,  1121,   488,  1110,  1072,  1110,  1122,  1072,
      54,   166,   222,   408,  1072,  1110,  1125,  1110,   248,  1074,
    1072,  1082,  1083,  1084,   248,  1072,  1084,   488,   491,  1152,
    1070,  1049,  1072,  1072,  1072,  1072,  1161,   405,    41,   392,
    1137,   754,  1072,   487,   973,  1126,   128,   130,   154,   255,
     256,   257,   258,   262,   263,   268,   273,   414,   425,  1118,
    1072,   487,  1072,   407,    49,   185,   190,   227,   371,  1072,
    1072,  1072,  1072,  1072,  1072,  1072,  1072,  1072,  1072,    28,
      35,   376,  1104,   175,   157,  1089,   349,   487,  1101,   171,
     231,   395,   399,   401,   427,   983,  1142,  1140,   166,  1017,
    1111,  1017,  1142,   409,   487,  1153,   491,   488,   183,   183,
     545,   934,   924,   923,   927,  1072,   488,   240,   263,   980,
     934,   932,   491,    38,   123,   431,   802,   349,   350,   478,
     479,   998,  1000,  1074,   369,   216,   279,   491,     5,   999,
    1152,   999,   349,   350,  1000,  1141,   267,   373,   962,  1011,
     993,   431,   957,   114,   292,   487,   949,   972,    37,  1158,
     487,   964,   965,   966,  1158,   488,  1156,  1144,  1144,   287,
      55,  1159,   488,   814,   816,   813,   816,  1159,   284,   488,
     491,   755,  1156,  1144,  1144,  1147,  1156,  1144,  1144,  1156,
    1145,  1144,   114,   524,  1154,   344,   430,   774,   353,   172,
     774,   487,  1144,   431,   794,   216,   216,   431,   487,   620,
     184,  1144,   268,  1156,  1144,  1144,  1072,   268,  1144,  1144,
      31,   336,   407,   407,  1144,   407,   655,   242,   821,   487,
     754,   754,  1049,   412,   107,   395,   809,   443,    70,   155,
     840,   809,   809,  1144,   754,  1144,   754,   356,   161,  1049,
     754,   218,   178,   259,   294,   333,   435,   658,   659,   660,
    1027,   407,   858,   353,   268,   118,   211,  1156,  1144,   278,
    1144,   278,   488,   491,  1155,  1157,  1144,   333,   540,   184,
     585,   263,  1049,  1144,  1152,  1158,  1142,  1144,   226,  1144,
      28,   430,  1144,   184,  1144,   184,  1158,   351,   412,   351,
     412,   226,  1144,    28,   430,  1144,   226,   349,  1142,    24,
     133,   366,   665,   666,   667,   668,  1161,  1156,  1144,   114,
     167,   264,   431,   548,   551,   552,  1161,  1144,    72,   276,
    1144,   543,   278,   407,   398,  1142,   407,   858,   353,   122,
    1146,  1158,  1146,   491,   488,   491,  1156,  1144,   864,   865,
    1161,   278,   333,   407,   689,  1156,  1144,  1144,   278,  1028,
    1028,  1156,  1144,  1028,  1145,  1155,     3,    85,   138,   196,
     300,   422,   430,   433,   502,  1156,  1144,  1144,   278,   333,
    1156,  1144,   333,   366,   540,   634,   637,   754,  1144,   637,
     754,  1144,   637,  1156,  1144,   366,  1156,  1144,  1144,  1154,
    1156,   828,  1144,   874,   875,  1161,  1144,   333,   366,   540,
     541,  1142,  1142,  1144,  1144,  1144,  1144,  1156,  1144,    24,
      30,   133,   294,   333,   366,   294,   333,   366,   723,   333,
     366,   333,   366,   333,   861,  1041,  1158,   184,   733,  1158,
     184,  1158,  1156,  1144,  1144,  1153,  1144,   864,    24,   560,
     363,  1155,   333,   366,   540,  1144,  1144,  1144,   407,   407,
      81,   421,   321,   491,   988,   988,   988,  1072,  1072,   439,
    1112,   488,  1072,  1134,   268,   762,  1153,    37,   131,   754,
     762,   762,   212,   431,   431,   762,   754,   762,   762,   754,
     218,   754,   762,   762,   762,   317,   564,   564,   194,   395,
     694,  1072,  1049,   754,   488,   491,   476,   697,   587,  1161,
    1144,    59,   166,   353,   442,   652,   659,   660,   148,   273,
     227,   579,   581,   583,   585,   592,   595,    25,   190,   344,
     393,   502,   503,   161,  1146,   443,  1142,    37,   690,   396,
    1028,   723,   513,  1158,   514,   283,   578,  1144,   163,   754,
    1110,   318,  1153,   723,   723,   723,   723,   273,   278,   283,
     487,   723,  1039,  1040,  1041,   363,   148,   487,   148,   148,
     147,   972,   754,   273,   579,  1158,   431,   615,   450,   550,
     263,    37,   598,  1153,   263,   278,     3,   728,   729,   723,
     488,   811,   812,   817,    37,   218,   341,   410,   449,   823,
     824,   825,   823,   278,   218,   527,   181,   181,   161,   545,
      37,   499,   162,   907,   908,  1110,   488,   488,   545,   485,
     470,   470,   488,   488,  1152,   486,  1152,   488,   182,   243,
    1071,   243,  1071,  1071,  1152,   246,   488,   545,   753,   754,
    1146,   754,  1146,   545,   545,   545,   545,   218,   545,   363,
     161,   527,   545,   545,   278,   545,   263,   488,   600,   190,
     190,   190,   190,   190,   454,  1143,   637,   638,   175,   778,
     779,  1156,    25,   784,   407,   487,   166,   146,   369,   146,
     369,   349,   429,   245,  1049,  1156,   450,   625,   792,   792,
     166,   278,   778,    55,   545,   821,  1049,   412,   395,   809,
     272,   443,   809,   809,  1049,   218,   754,  1144,   488,   486,
     486,   491,  1072,   135,  1129,  1130,    37,   488,  1072,   488,
     488,   488,   166,   488,   488,   488,   488,   488,   488,   491,
     491,   488,   302,  1120,   488,   487,  1073,  1073,  1110,    13,
      17,    18,    19,   190,   212,   280,   474,   475,   476,   478,
     479,   480,   481,   482,   483,  1107,  1073,   488,   488,   161,
     166,  1123,  1124,   488,    37,  1125,  1110,  1125,  1125,   166,
     488,   488,  1161,   299,  1086,    37,   488,   491,  1072,  1161,
     491,  1072,  1136,  1072,   488,   470,  1073,  1073,   141,  1110,
     166,   128,   130,   154,   262,   268,   273,   414,   425,  1118,
     487,   262,   141,   838,  1072,   392,  1137,  1072,  1126,  1072,
     407,   487,   973,   487,   487,   289,  1093,   487,  1110,   399,
     401,   399,   401,  1142,   984,   984,   984,   221,   350,   467,
     487,   973,  1018,  1019,  1020,  1027,  1032,  1042,  1075,  1077,
    1078,  1158,   447,  1037,   988,  1037,   892,  1152,  1070,   522,
     934,   240,   487,   991,   280,  1105,  1108,   472,   803,     5,
    1152,  1000,   279,   450,   429,   997,   236,  1018,   447,  1038,
     437,   394,   430,   950,   951,   952,  1158,   278,   953,  1158,
     966,   967,   491,  1017,   476,  1136,   820,   755,   816,   816,
      55,   818,   482,  1157,  1157,   278,  1143,   281,   278,  1072,
     596,  1146,   487,   487,   487,   620,   194,   599,   713,   148,
     545,   407,  1156,  1144,   527,  1144,  1049,  1144,   454,   754,
     754,   754,   754,    83,   125,   296,   400,  1049,  1144,   641,
    1144,   178,   435,   407,   407,   641,   658,   664,   333,   366,
     540,  1144,  1144,  1144,   202,   268,   151,   812,   293,   366,
     407,   263,   148,   282,   662,   713,   366,    24,   133,   337,
     338,   366,   544,   553,   554,   664,   859,   358,   148,   545,
     148,   545,  1144,  1144,  1144,  1144,   358,   358,   226,   667,
     668,   667,   488,   491,   669,  1153,   194,   488,   491,   476,
     489,   151,  1156,  1144,   333,   366,   540,  1144,  1144,  1144,
     278,   294,   333,   366,    24,   133,   294,   333,   366,  1049,
     260,  1049,   488,   491,   476,  1142,   407,  1157,   431,   686,
     151,   228,   300,   268,  1153,   300,  1157,   428,   151,   407,
     407,   353,   382,   491,   828,   293,   366,    86,   407,   858,
     353,   114,   161,   555,   407,   407,   238,   238,   238,   407,
     407,   353,   407,   407,   353,   407,   353,   407,   353,   407,
     122,   545,  1049,   263,  1153,   366,   859,   148,   545,   407,
     407,   488,  1144,   407,   858,   353,   407,  1156,  1144,   488,
     488,   488,  1112,   486,  1049,   754,   212,   762,  1146,  1146,
     212,   212,  1144,   212,   383,   384,   565,  1153,   565,   178,
     488,   488,   166,   723,   725,   260,   280,   478,   479,   637,
     726,   816,  1108,  1153,  1165,   278,    68,    74,    86,   114,
     116,   170,   198,   263,   268,   311,   327,   424,   588,   589,
     591,   147,   446,   499,   527,  1144,   527,   662,  1142,  1142,
    1142,   488,   491,  1157,   175,   344,  1157,  1152,   417,  1142,
     598,     3,   161,   691,    45,   514,   335,   395,   671,   107,
     931,   166,   874,   550,   599,  1142,   698,   730,   731,  1153,
     488,   491,  1144,   161,   599,  1142,   624,  1142,  1144,   625,
     487,   580,  1142,   488,  1146,   450,   452,   616,   549,    37,
     148,   972,   615,   407,   148,  1027,   476,   488,   491,   488,
     491,   114,   476,   826,  1153,   527,   395,   815,   816,   161,
     827,   825,   119,   204,   359,   429,   883,  1144,   178,   972,
    1049,   487,   488,   491,   488,  1152,  1069,  1069,   486,   486,
     488,   545,   431,   545,   431,   545,  1144,  1144,   681,   545,
     754,   148,   353,   353,   353,   353,   353,  1143,   491,  1156,
     450,   491,   780,   281,  1028,   363,   146,   146,   107,   259,
    1142,  1144,  1157,   777,   545,  1156,   212,   212,   212,   637,
     212,   212,   212,   212,   212,  1114,   403,  1072,   139,  1049,
     488,  1072,  1118,  1072,  1072,  1123,   488,  1110,   491,  1049,
    1073,  1073,  1073,  1073,   128,   130,   263,   273,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1072,  1072,
    1124,  1123,  1049,   488,   488,   488,  1110,   488,   491,    55,
    1074,  1087,   488,  1161,  1083,   308,   388,  1085,   488,   491,
     442,  1079,    37,   488,  1153,  1072,    34,    34,  1072,   488,
    1072,   166,   487,   262,  1113,  1072,   488,   141,  1073,  1073,
     141,   141,  1072,  1072,   989,   447,   487,  1094,  1158,   488,
    1110,   491,   984,   984,   984,   984,  1142,  1142,  1142,   973,
    1032,  1042,   166,   487,   973,  1019,  1020,    37,  1021,  1022,
    1158,   491,    94,   167,   200,   215,   225,   251,   343,  1024,
    1022,    37,  1021,  1023,  1158,  1022,   473,  1036,  1135,  1072,
     175,  1002,   488,  1002,   488,   943,   487,   803,   158,   220,
     279,   450,   404,    97,  1072,   340,   955,   436,   488,   491,
    1136,    84,   955,   488,   491,   965,  1038,  1072,   488,   482,
     820,   417,   169,   348,   354,   361,   396,   418,   789,   161,
     789,   488,   487,   603,   604,   797,  1077,  1158,   599,   599,
     713,  1148,   488,   116,   198,   259,   263,   714,  1144,  1144,
      37,  1144,   431,   431,   754,   754,   754,   754,   218,   755,
    1156,  1144,   407,   858,   353,   407,   202,  1144,    55,   398,
    1144,   148,   585,   487,   587,   382,   170,   150,   183,   263,
     549,   499,   107,   170,   263,   382,   385,   549,   635,   366,
     554,   417,  1144,  1158,   358,   666,  1144,   552,   726,  1161,
    1144,   293,   366,   407,   858,   353,   407,   151,   407,   407,
     353,   168,   280,   385,   735,   736,   168,   280,   743,   744,
     407,   407,   353,   488,   488,   488,   865,   260,   637,   816,
     866,  1108,  1153,  1165,   333,  1144,   487,   450,   687,  1144,
    1154,  1153,  1153,  1153,  1144,  1144,  1144,  1144,  1154,   875,
      55,   398,  1144,  1144,  1144,  1144,   437,  1144,  1144,   161,
     161,   335,   161,   184,  1156,  1144,  1144,  1156,  1144,  1144,
    1144,  1144,  1144,  1144,  1144,   278,    74,   546,   148,    26,
      47,   417,  1158,  1144,  1153,   664,  1144,  1144,  1144,  1144,
     988,   488,   212,   762,   212,   212,   762,   762,   212,   762,
     499,   431,   570,   571,   641,   713,   450,   452,   754,  1142,
     487,   754,  1144,  1073,    31,    55,   590,   117,   186,   116,
     268,   216,  1142,   828,   168,   315,   709,   716,   717,  1158,
     651,   298,   487,   580,   593,   197,   610,   583,  1157,  1157,
    1049,   487,   550,    28,   119,   204,   359,   429,   692,   407,
     688,  1156,   184,  1142,   673,   454,   278,  1018,   828,   328,
     699,   488,   491,  1041,   662,   681,   488,   632,    37,   273,
     298,   487,   945,   582,   584,   586,   595,  1158,   298,   611,
     612,   580,   610,   549,   276,   278,   617,   972,   627,   625,
     550,  1153,  1148,   794,   726,     3,   729,   817,  1072,  1072,
     491,   487,   823,   417,   491,   407,   487,   641,   488,   907,
     908,   486,  1146,  1146,   545,   363,   545,  1143,  1143,  1143,
    1143,  1143,   637,   172,   779,   488,  1144,   107,   784,   166,
     268,   767,  1153,   767,   767,   212,   767,   767,   767,   767,
     767,  1072,   488,   488,   488,  1124,   488,  1072,   166,   128,
     130,   273,   487,   488,   457,  1081,  1110,   326,   436,    55,
    1087,  1074,   448,   448,   488,  1072,   259,  1072,   491,  1080,
    1051,  1072,  1072,  1072,  1113,   488,  1072,    34,    34,  1072,
    1072,   141,   488,   488,  1072,  1095,  1158,   488,  1072,  1142,
    1142,  1142,  1142,  1022,  1023,  1022,   487,   462,  1074,   488,
    1158,   487,  1019,   215,   288,  1025,  1019,  1025,   215,  1024,
    1025,   215,   397,  1030,   487,  1158,   487,   285,    55,   179,
    1009,  1153,  1009,  1153,   488,   838,   404,   273,  1139,   972,
     292,   972,   952,   278,   487,   954,   476,   966,   955,   417,
     488,   407,   774,   166,   713,  1072,   488,   491,   450,    74,
     796,   800,   796,   488,   488,   191,   601,   117,   186,   196,
     116,   433,   545,  1049,  1146,  1146,  1144,  1144,  1144,  1144,
    1144,  1157,  1144,   585,   663,   667,  1154,   590,   184,   184,
     268,   637,   590,   268,  1154,  1158,  1049,   545,   545,   476,
      55,   398,  1144,  1144,  1144,  1144,  1144,  1156,  1144,  1144,
    1152,  1152,  1049,   491,  1152,  1152,   491,  1156,  1144,  1144,
     407,  1072,    68,  1157,  1144,   407,   407,   166,   190,   450,
    1143,  1143,   754,  1143,   148,   151,   754,  1153,  1153,  1049,
     545,   545,   407,   488,   212,   762,   762,   762,   762,   487,
     566,   567,   499,   121,   168,   201,   168,   166,   712,  1072,
     263,   589,   114,    37,   828,   598,   431,   619,  1150,    34,
     147,   190,   273,   579,   555,   145,   192,   487,   363,   431,
     599,    37,  1157,   686,   514,   263,   487,   163,  1144,  1110,
     253,   277,   700,   701,   702,   161,   705,  1153,   363,   550,
     147,   972,   754,   273,   579,   625,   488,   491,   450,   587,
      55,   615,   555,   611,    80,   398,   618,   450,   896,    37,
     618,   166,   278,   487,  1153,   814,   829,   830,  1159,  1049,
     161,  1142,   166,   407,   849,   199,   642,   545,   488,   545,
     545,  1144,   281,   210,   545,   778,   767,   488,  1073,   166,
     487,  1113,   487,   488,   491,   488,  1087,   488,   436,   379,
     488,   488,   488,  1072,  1072,  1072,   488,   298,  1096,   488,
    1033,  1034,  1077,   487,  1086,  1021,   487,  1143,  1019,   278,
     431,  1026,  1019,   215,  1019,  1150,  1040,   487,  1040,  1158,
      96,   176,   346,   487,  1003,  1004,  1005,  1006,  1007,  1008,
    1072,  1072,   449,  1090,  1090,   488,   969,   950,    86,   795,
     797,   129,  1072,   778,   278,   778,   488,   601,   604,   280,
     838,   754,   754,   801,   327,   601,   487,   828,   488,   407,
     366,   961,   488,   491,    37,   148,   148,   546,   726,  1157,
    1144,   407,   487,   809,   838,   840,   736,   487,   487,   744,
    1144,   488,   487,   366,   961,  1144,  1144,   487,   487,   487,
     450,   473,   916,   335,   916,   916,   161,  1144,   546,  1144,
     762,   572,   573,  1161,    51,    95,   120,   137,   141,   162,
     165,   180,   268,   319,   568,   566,  1153,   809,    37,   845,
     845,  1142,   713,   488,   183,   487,   619,   239,   602,   194,
     487,   717,   709,   487,  1142,   488,   363,    28,    79,    87,
     115,   170,   183,   195,   382,   385,   594,   594,  1141,  1144,
    1146,   488,   972,   687,   148,   107,   662,   166,   701,   349,
     395,   703,   134,   706,   446,   708,  1144,    37,  1144,   625,
     580,  1142,   488,   584,   282,  1158,   616,   611,   615,   119,
     133,   308,  1144,    60,    68,   231,   972,   754,  1027,   795,
     816,   488,   491,   417,  1037,   377,   377,   488,   641,   259,
     435,   643,   644,  1144,   545,  1073,  1113,   488,  1082,  1110,
     259,   469,    55,   988,   488,   491,    37,  1035,   114,  1047,
    1048,  1073,    77,  1143,   488,  1072,   487,  1019,  1026,   487,
     488,  1040,   488,   487,   367,   487,   488,   491,  1091,  1092,
    1158,   436,  1144,   488,   491,   264,   429,   780,   789,   545,
     796,   828,   487,   549,   802,  1142,   828,   599,   619,  1144,
     398,   667,   183,   431,   547,   366,   961,  1144,  1113,   161,
     739,   739,  1113,  1113,  1072,   398,  1110,  1110,   556,   557,
    1160,   753,   754,   753,   754,  1143,   545,   488,   491,   480,
     487,   524,   574,   637,   913,  1153,   913,   263,   268,   319,
     913,   913,  1037,   845,    40,   188,   161,   259,   597,   487,
     633,  1072,   167,   297,   372,   278,   606,   607,   608,   398,
     488,  1150,     6,   718,   580,   610,  1144,   488,   662,   155,
     738,   550,   896,  1142,   454,  1018,   913,   349,   381,   707,
     487,   147,   662,   972,   945,   611,   580,   610,   587,   487,
     617,   615,   616,   350,   350,    68,   281,    68,   625,   794,
     488,   823,   829,  1049,   129,   450,   450,   435,   641,   662,
     488,   488,   488,   436,  1110,   177,   320,   350,  1097,  1036,
    1033,   487,  1073,   488,   491,    37,  1043,  1044,  1158,   488,
    1143,  1110,   488,  1110,   487,  1110,  1004,   491,    37,   972,
    1037,   797,   366,   166,   619,   838,   802,   803,   598,   619,
     488,   713,  1144,   633,  1072,   398,   488,   284,   356,   324,
     740,   740,   488,   488,   488,  1144,   488,   488,   488,   491,
    1152,   916,   573,   524,   575,   576,  1153,  1153,   268,   599,
     480,   599,  1153,  1153,   134,   196,   634,   488,   119,   429,
     278,   608,   278,   607,  1144,   487,   488,   491,   555,   363,
     662,   754,    37,    37,   487,  1144,   704,  1158,  1072,   709,
     896,   625,   615,   555,   611,   487,   613,   614,  1077,  1158,
     618,   616,   617,   281,   281,   487,   191,   798,    29,   205,
     884,   168,   168,    49,    97,   420,  1072,  1098,  1099,  1098,
    1098,   488,  1040,   491,  1048,  1161,   488,   491,   161,  1049,
     488,   488,   488,  1003,   488,  1092,  1094,   964,   778,   447,
     605,   488,   803,   602,   713,   961,  1144,   809,    55,   961,
     407,   556,   754,   488,   491,   599,   349,   488,   386,    59,
     259,   339,   366,   609,   609,   488,     6,   363,  1144,   735,
     972,   662,   488,  1150,   616,   611,   615,  1072,   488,   491,
     800,   800,   617,   618,   795,   487,   550,   264,   487,   879,
     881,   885,   947,   956,   963,   972,   809,   809,  1099,   349,
     160,   306,   160,   306,   144,  1100,  1100,  1100,   488,  1074,
    1044,   285,     3,   114,   263,   268,  1045,  1046,   334,  1031,
     488,  1037,   545,   487,   713,   606,   961,   754,   487,   576,
     708,    23,   114,   268,  1144,   662,   896,   487,   617,   615,
     616,   488,   614,   754,   801,   801,   618,   488,   797,   799,
     618,   880,   881,   882,   973,   974,   491,   491,    34,    97,
     175,   259,   404,  1086,  1073,  1073,   268,  1046,   487,  1072,
     713,  1110,   147,   662,     5,   710,   711,  1152,  1153,  1161,
     618,   616,   617,   800,   798,   488,   491,  1037,   488,   490,
     407,   166,  1099,   349,   286,    77,  1072,   488,   488,   709,
     488,   491,   617,   618,   801,   550,   797,   882,   377,   377,
    1043,   488,  1150,   711,   618,   618,   450,   450,   488,   487,
    1037,   168,   168,   710,   809,   809,   488
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   493,   494,   495,   495,   496,   496,   496,   496,   496,
     496,   496,   496,   496,   496,   496,   496,   496,   496,   496,
     496,   496,   496,   496,   496,   496,   496,   496,   496,   496,
     496,   496,   496,   496,   496,   496,   496,   496,   496,   496,
     496,   496,   496,   496,   496,   496,   496,   496,   496,   496,
     496,   496,   496,   496,   496,   496,   496,   496,   496,   496,
     496,   496,   496,   496,   496,   496,   496,   496,   496,   496,
     496,   496,   496,   496,   496,   496,   496,   496,   496,   496,
     496,   496,   496,   496,   496,   496,   496,   496,   496,   496,
     496,   496,   496,   496,   496,   496,   496,   496,   496,   496,
     496,   496,   496,   496,   496,   496,   496,   496,   496,   496,
     496,   496,   496,   496,   496,   496,   496,   496,   496,   496,
     496,   496,   496,   496,   496,   496,   496,   496,   496,   496,
     496,   497,   498,   499,   499,   499,   500,   500,   501,   501,
     502,   502,   502,   502,   502,   502,   502,   502,   502,   503,
     503,   503,   503,   503,   503,   504,   505,   505,   506,   506,
     507,   507,   507,   507,   508,   508,   508,   508,   508,   508,
     509,   510,   511,   511,   512,   512,   512,   512,   513,   513,
     514,   514,   515,   515,   515,   515,   515,   515,   516,   516,
     516,   516,   517,   517,   517,   518,   518,   518,   518,   519,
     519,   519,   519,   519,   519,   519,   519,   519,   519,   519,
     520,   520,   521,   521,   522,   522,   523,   523,   523,   523,
     524,   524,   524,   524,   525,   525,   525,   525,   525,   525,
     525,   526,   526,   526,   527,   527,   528,   528,   529,   529,
     529,   529,   530,   530,   531,   531,   532,   532,   533,   533,
     533,   533,   533,   533,   533,   534,   535,   535,   536,   536,
     537,   538,   538,   538,   538,   538,   539,   539,   539,   539,
     539,   539,   539,   539,   539,   539,   539,   539,   539,   539,
     539,   539,   539,   539,   539,   540,   540,   541,   541,   542,
     543,   543,   543,   543,   543,   543,   543,   543,   543,   543,
     543,   543,   543,   543,   543,   543,   543,   543,   543,   543,
     543,   543,   543,   543,   543,   543,   543,   543,   543,   543,
     543,   543,   543,   543,   543,   543,   543,   543,   543,   543,
     543,   543,   543,   543,   543,   543,   543,   543,   543,   543,
     543,   543,   543,   543,   543,   543,   543,   543,   544,   544,
     545,   545,   545,   546,   546,   547,   547,   548,   548,   548,
     548,   549,   550,   550,   551,   551,   552,   552,   552,   552,
     553,   553,   554,   554,   554,   554,   555,   555,   555,   555,
     556,   557,   557,   558,   559,   559,   560,   560,   560,   560,
     561,   561,   562,   562,   563,   563,   564,   564,   565,   565,
     565,   566,   566,   567,   567,   568,   568,   568,   568,   568,
     568,   568,   568,   568,   568,   568,   568,   568,   569,   569,
     570,   570,   571,   571,   572,   572,   573,   574,   574,   574,
     574,   574,   575,   575,   576,   577,   577,   577,   577,   577,
     577,   578,   578,   578,   578,   578,   578,   578,   578,   579,
     579,   580,   580,   581,   581,   582,   582,   583,   583,   583,
     584,   584,   585,   586,   586,   587,   587,   588,   588,   588,
     588,   589,   589,   589,   589,   589,   589,   589,   589,   589,
     590,   590,   591,   591,   591,   591,   592,   593,   593,   593,
     594,   594,   594,   594,   594,   594,   594,   594,   594,   595,
     595,   596,   596,   596,   596,   596,   596,   596,   597,   597,
     598,   598,   599,   599,   600,   601,   601,   602,   602,   602,
     602,   603,   603,   604,   604,   605,   605,   606,   606,   606,
     606,   606,   607,   608,   609,   609,   609,   609,   609,   610,
     610,   611,   611,   612,   613,   613,   614,   614,   614,   615,
     615,   616,   616,   616,   617,   617,   617,   617,   618,   618,
     619,   619,   620,   621,   621,   622,   622,   623,   623,   624,
     625,   625,   625,   626,   626,   627,   628,   628,   629,   630,
     630,   631,   631,   632,   632,   633,   633,   634,   634,   635,
     635,   635,   635,   635,   635,   635,   635,   635,   635,   635,
     635,   635,   635,   636,   636,   637,   637,   637,   637,   638,
     638,   639,   639,   640,   640,   641,   641,   642,   642,   643,
     643,   644,   644,   645,   645,   646,   646,   647,   648,   648,
     649,   649,   650,   650,   651,   651,   652,   652,   652,   652,
     653,   654,   654,   655,   656,   656,   656,   656,   656,   656,
     656,   656,   656,   656,   656,   656,   656,   656,   656,   656,
     656,   656,   656,   656,   656,   656,   656,   656,   656,   656,
     656,   656,   657,   658,   658,   658,   658,   659,   659,   660,
     660,   661,   661,   662,   662,   663,   663,   664,   665,   665,
     666,   666,   666,   666,   667,   668,   669,   670,   670,   671,
     671,   672,   672,   673,   673,   674,   674,   674,   675,   675,
     675,   675,   676,   676,   677,   678,   678,   679,   679,   680,
     680,   681,   681,   682,   682,   683,   684,   685,   686,   686,
     687,   687,   688,   688,   689,   689,   690,   690,   691,   691,
     692,   692,   692,   692,   692,   693,   694,   694,   695,   695,
     696,   696,   696,   697,   697,   698,   698,   698,   698,   698,
     699,   699,   700,   700,   701,   702,   702,   703,   703,   704,
     705,   705,   706,   706,   707,   707,   708,   708,   709,   709,
     710,   710,   710,   711,   711,   711,   711,   712,   712,   713,
     713,   714,   714,   714,   714,   714,   714,   715,   715,   716,
     716,   717,   718,   718,   719,   720,   720,   720,   720,   721,
     722,   722,   722,   722,   722,   722,   722,   722,   722,   722,
     722,   722,   722,   722,   722,   722,   723,   724,   724,   725,
     725,   726,   726,   726,   726,   726,   726,   727,   728,   728,
     729,   730,   730,   731,   731,   732,   732,   732,   732,   733,
     733,   734,   735,   735,   736,   736,   736,   736,   736,   737,
     737,   738,   738,   739,   739,   739,   740,   740,   741,   742,
     742,   743,   743,   744,   744,   745,   745,   746,   746,   747,
     748,   749,   749,   749,   749,   749,   749,   749,   749,   749,
     749,   749,   749,   750,   750,   750,   750,   750,   750,   750,
     750,   750,   750,   750,   750,   750,   751,   751,   751,   751,
     751,   751,   751,   752,   752,   752,   753,   753,   754,   754,
     755,   755,   756,   756,   757,   758,   758,   758,   759,   759,
     759,   759,   759,   759,   759,   759,   759,   759,   759,   759,
     759,   759,   759,   759,   759,   759,   759,   760,   760,   760,
     760,   760,   760,   760,   760,   760,   760,   760,   760,   760,
     760,   761,   761,   761,   761,   761,   761,   761,   761,   761,
     761,   761,   761,   762,   762,   763,   763,   763,   763,   763,
     763,   763,   763,   763,   764,   764,   765,   765,   765,   765,
     765,   765,   766,   766,   766,   766,   766,   766,   766,   766,
     767,   767,   768,   768,   769,   769,   769,   769,   769,   769,
     769,   769,   769,   769,   769,   769,   769,   769,   769,   769,
     770,   770,   771,   771,   772,   773,   773,   774,   774,   774,
     774,   774,   775,   775,   776,   776,   776,   776,   777,   777,
     777,   777,   777,   777,   777,   777,   777,   777,   777,   777,
     777,   777,   777,   777,   777,   777,   777,   777,   778,   778,
     779,   779,   780,   780,   781,   782,   782,   783,   783,   784,
     784,   785,   786,   786,   787,   787,   787,   788,   788,   788,
     789,   789,   789,   789,   789,   789,   790,   790,   791,   791,
     792,   792,   793,   793,   794,   794,   795,   795,   796,   796,
     797,   797,   797,   798,   798,   799,   799,   800,   800,   801,
     801,   802,   802,   802,   803,   803,   803,   804,   804,   804,
     804,   805,   805,   806,   806,   807,   807,   808,   808,   809,
     809,   809,   809,   810,   810,   811,   811,   812,   812,   812,
     812,   812,   813,   813,   813,   813,   813,   814,   815,   816,
     816,   816,   817,   817,   817,   818,   819,   819,   819,   819,
     820,   820,   821,   822,   822,   823,   823,   824,   824,   824,
     824,   824,   824,   824,   824,   824,   824,   824,   824,   824,
     824,   824,   824,   824,   825,   825,   825,   825,   825,   826,
     826,   827,   827,   828,   828,   829,   830,   830,   831,   831,
     831,   832,   832,   833,   833,   834,   834,   834,   834,   834,
     834,   835,   835,   836,   836,   837,   837,   837,   837,   838,
     838,   839,   839,   840,   841,   842,   842,   843,   843,   844,
     844,   844,   845,   845,   845,   846,   847,   847,   848,   849,
     849,   849,   849,   850,   851,   851,   851,   851,   852,   852,
     853,   853,   853,   854,   854,   855,   856,   856,   857,   857,
     857,   857,   857,   857,   857,   857,   857,   857,   857,   857,
     857,   857,   857,   857,   857,   857,   857,   857,   857,   857,
     857,   857,   857,   857,   857,   857,   857,   857,   857,   857,
     857,   857,   857,   857,   857,   857,   857,   857,   857,   857,
     857,   857,   857,   857,   857,   857,   857,   857,   857,   857,
     857,   857,   857,   858,   858,   859,   859,   860,   860,   860,
     860,   860,   860,   861,   861,   862,   862,   862,   862,   862,
     862,   862,   862,   862,   862,   862,   862,   862,   862,   862,
     862,   862,   862,   862,   862,   862,   862,   862,   862,   862,
     862,   862,   863,   864,   864,   865,   865,   866,   866,   866,
     866,   866,   867,   868,   868,   868,   868,   868,   868,   868,
     868,   868,   868,   868,   868,   868,   868,   868,   868,   868,
     868,   868,   868,   868,   868,   868,   868,   869,   870,   870,
     871,   871,   872,   872,   872,   872,   873,   874,   874,   875,
     876,   876,   876,   876,   876,   876,   877,   877,   878,   879,
     879,   879,   880,   880,   881,   881,   881,   881,   881,   882,
     882,   883,   883,   883,   883,   884,   884,   884,   885,   886,
     886,   887,   888,   888,   889,   889,   889,   889,   889,   889,
     889,   889,   889,   889,   889,   889,   889,   889,   890,   890,
     890,   891,   891,   891,   891,   891,   892,   892,   892,   893,
     893,   894,   894,   894,   895,   895,   895,   895,   896,   896,
     896,   896,   897,   898,   899,   899,   900,   900,   901,   901,
     901,   902,   902,   902,   902,   902,   902,   902,   903,   903,
     904,   904,   904,   905,   906,   906,   906,   906,   907,   907,
     908,   909,   910,   910,   911,   912,   912,   912,   912,   912,
     912,   912,   913,   913,   914,   915,   915,   915,   915,   915,
     915,   916,   916,   917,   918,   918,   918,   919,   919,   920,
     920,   921,   921,   922,   922,   923,   923,   924,   925,   925,
     926,   926,   926,   927,   927,   928,   928,   929,   929,   930,
     930,   931,   931,   932,   933,   933,   934,   934,   935,   935,
     935,   935,   936,   936,   936,   936,   936,   936,   936,   936,
     936,   937,   937,   938,   939,   939,   940,   940,   940,   941,
     942,   942,   943,   943,   943,   943,   944,   944,   944,   945,
     945,   946,   946,   946,   946,   947,   948,   948,   949,   949,
     949,   949,   949,   950,   950,   951,   951,   952,   953,   953,
     953,   954,   954,   954,   955,   955,   956,   957,   957,   958,
     959,   959,   960,   960,   960,   960,   960,   960,   960,   960,
     961,   961,   962,   962,   962,   963,   964,   964,   965,   965,
     966,   967,   967,   968,   969,   970,   970,   970,   970,   970,
     971,   971,   971,   972,   972,   973,   973,   974,   974,   974,
     974,   974,   974,   974,   974,   975,   975,   976,   976,   976,
     976,   976,   976,   976,   977,   977,   977,   978,   978,   979,
     980,   980,   980,   981,   981,   982,   982,   983,   983,   983,
     983,   983,   983,   983,   983,   983,   984,   984,   985,   985,
     985,   986,   986,   987,   987,   988,   988,   989,   990,   990,
     991,   991,   992,   992,   992,   992,   993,   993,   994,   994,
     994,   994,   994,   994,   995,   995,   996,   996,   997,   998,
     998,   998,   999,   999,  1000,  1000,  1001,  1001,  1002,  1002,
    1003,  1003,  1004,  1004,  1004,  1004,  1004,  1005,  1006,  1007,
    1008,  1009,  1009,  1010,  1010,  1011,  1011,  1012,  1012,  1013,
    1014,  1014,  1014,  1014,  1015,  1015,  1016,  1016,  1017,  1017,
    1018,  1018,  1019,  1019,  1019,  1019,  1019,  1019,  1019,  1019,
    1019,  1019,  1020,  1020,  1020,  1020,  1020,  1020,  1021,  1021,
    1021,  1021,  1022,  1022,  1023,  1023,  1023,  1023,  1023,  1024,
    1024,  1024,  1024,  1025,  1025,  1026,  1026,  1027,  1027,  1027,
    1027,  1028,  1028,  1029,  1029,  1029,  1030,  1031,  1031,  1032,
    1032,  1033,  1034,  1034,  1035,  1035,  1036,  1036,  1037,  1037,
    1038,  1038,  1038,  1039,  1039,  1040,  1040,  1041,  1042,  1042,
    1043,  1043,  1044,  1044,  1044,  1045,  1045,  1046,  1046,  1046,
    1046,  1047,  1047,  1048,  1048,  1049,  1049,  1049,  1049,  1049,
    1049,  1050,  1050,  1050,  1051,  1051,  1051,  1051,  1051,  1051,
    1051,  1052,  1052,  1052,  1052,  1053,  1053,  1054,  1054,  1055,
    1055,  1055,  1055,  1055,  1055,  1055,  1055,  1055,  1055,  1055,
    1056,  1056,  1057,  1057,  1058,  1058,  1059,  1060,  1061,  1061,
    1062,  1062,  1063,  1064,  1065,  1065,  1065,  1065,  1065,  1065,
    1066,  1066,  1067,  1067,  1067,  1067,  1068,  1069,  1069,  1069,
    1070,  1070,  1070,  1070,  1070,  1070,  1070,  1070,  1070,  1070,
    1070,  1070,  1070,  1070,  1071,  1071,  1072,  1072,  1072,  1072,
    1072,  1072,  1072,  1072,  1072,  1072,  1072,  1072,  1072,  1072,
    1072,  1072,  1072,  1072,  1072,  1072,  1072,  1072,  1072,  1072,
    1072,  1072,  1072,  1072,  1072,  1072,  1072,  1072,  1072,  1072,
    1072,  1072,  1072,  1072,  1072,  1072,  1072,  1072,  1072,  1072,
    1072,  1072,  1072,  1072,  1072,  1072,  1072,  1072,  1072,  1072,
    1072,  1072,  1072,  1072,  1072,  1072,  1072,  1072,  1072,  1072,
    1072,  1072,  1072,  1072,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1075,  1075,  1075,  1075,  1075,  1075,  1075,
    1076,  1076,  1077,  1077,  1078,  1078,  1078,  1078,  1078,  1078,
    1078,  1078,  1078,  1078,  1078,  1078,  1078,  1078,  1078,  1078,
    1078,  1078,  1078,  1078,  1078,  1078,  1078,  1078,  1078,  1078,
    1078,  1078,  1078,  1078,  1078,  1078,  1078,  1078,  1078,  1078,
    1078,  1078,  1078,  1078,  1078,  1078,  1078,  1078,  1079,  1079,
    1080,  1080,  1080,  1080,  1081,  1082,  1082,  1083,  1083,  1084,
    1084,  1085,  1085,  1085,  1086,  1086,  1086,  1086,  1087,  1087,
    1088,  1088,  1089,  1089,  1090,  1090,  1091,  1091,  1092,  1093,
    1093,  1093,  1094,  1095,  1095,  1096,  1096,  1097,  1097,  1097,
    1097,  1098,  1098,  1099,  1099,  1099,  1099,  1099,  1100,  1100,
    1100,  1100,  1100,  1101,  1101,  1101,  1102,  1102,  1103,  1104,
    1104,  1104,  1105,  1105,  1106,  1106,  1106,  1106,  1106,  1106,
    1106,  1106,  1106,  1106,  1106,  1106,  1107,  1107,  1108,  1108,
    1109,  1109,  1109,  1109,  1109,  1109,  1110,  1110,  1111,  1111,
    1112,  1112,  1112,  1113,  1113,  1114,  1114,  1114,  1115,  1115,
    1116,  1116,  1117,  1117,  1117,  1117,  1117,  1117,  1117,  1117,
    1118,  1118,  1118,  1118,  1119,  1119,  1120,  1121,  1121,  1122,
    1122,  1122,  1122,  1122,  1122,  1123,  1124,  1125,  1125,  1125,
    1126,  1126,  1127,  1128,  1128,  1129,  1130,  1130,  1131,  1131,
    1132,  1132,  1133,  1133,  1133,  1133,  1134,  1134,  1135,  1135,
    1136,  1136,  1137,  1137,  1138,  1138,  1139,  1139,  1140,  1140,
    1140,  1140,  1141,  1141,  1142,  1142,  1143,  1143,  1144,  1145,
    1146,  1147,  1148,  1149,  1150,  1150,  1151,  1151,  1151,  1151,
    1151,  1151,  1151,  1151,  1151,  1151,  1151,  1151,  1151,  1152,
    1153,  1154,  1154,  1154,  1155,  1156,  1156,  1156,  1157,  1157,
    1158,  1158,  1158,  1159,  1159,  1159,  1160,  1160,  1160,  1160,
    1161,  1161,  1161,  1161,  1161,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1163,  1163,  1163,  1163,  1163,  1163,
    1163,  1163,  1163,  1163,  1163,  1163,  1163,  1163,  1163,  1163,
    1163,  1163,  1163,  1163,  1163,  1163,  1163,  1163,  1163,  1163,
    1163,  1163,  1163,  1163,  1163,  1163,  1163,  1163,  1163,  1163,
    1163,  1163,  1163,  1163,  1163,  1163,  1163,  1163,  1163,  1163,
    1163,  1163,  1163,  1163,  1163,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1165,  1165,
    1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,
    1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,
    1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,
    1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,
    1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,
    1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,
    1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,
    1165,  1165,  1165,  1165,  1165
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     2,     5,     1,     1,     0,     2,     0,     2,     0,
       2,     2,     3,     3,     1,     3,     3,     2,     1,     1,
       2,     2,     2,     3,     3,     5,     5,     5,     0,     3,
       5,     5,     5,     5,     3,     5,     3,     5,     3,     5,
       5,     6,     1,     1,     6,     4,     9,     7,     1,     0,
       2,     0,     1,     1,     1,     1,     1,     1,     3,     2,
       3,     3,     2,     5,     1,     3,     3,     3,     3,     1,
       3,     3,     2,     2,     2,     2,     3,     3,     3,     3,
       1,     3,     1,     3,     1,     1,     2,     2,     2,     1,
       1,     1,     1,     1,     1,     1,     3,     5,     1,     1,
       1,     1,     1,     0,     1,     1,     2,     3,     1,     2,
       3,     2,     1,     1,     2,     1,     2,     1,     3,     3,
       2,     3,     4,     3,     2,     4,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     2,     4,     6,     4,     6,
      10,    13,     4,     6,     4,    10,    13,     4,     6,     4,
       6,     5,     7,    11,    14,     1,     3,     4,     3,     3,
       2,     5,     3,     6,     4,     6,     6,     5,     7,     6,
       6,     5,     5,     6,     9,     4,     5,     7,     6,     4,
       8,     4,     2,     4,     3,     6,     4,     3,     3,     3,
       2,     2,     3,     4,     4,     3,     3,     3,     3,     3,
       3,     4,     4,     3,     2,     3,     2,     2,     3,     3,
       2,     2,     3,     4,     4,     4,     5,     1,     3,     2,
       1,     1,     0,     2,     0,     2,     0,     1,     1,     1,
       3,     3,     2,     0,     1,     3,     3,     1,     5,     3,
       1,     2,     1,     3,     2,     3,     6,     6,    10,     1,
       2,     1,     3,     4,     1,     3,     4,     6,     4,     8,
       2,     2,    11,     9,     1,     1,     1,     0,     1,     1,
       1,     1,     3,     2,     0,     1,     1,     3,     3,     1,
       1,     3,     3,     3,     3,     4,     3,     2,     1,     0,
       3,     0,     1,     0,     1,     3,     2,     1,     1,     1,
       3,     0,     1,     3,     1,    13,    16,    12,    15,    14,
      17,     1,     1,     2,     2,     2,     2,     1,     0,     1,
       0,     3,     0,     1,     3,     1,     3,     1,     1,     1,
       1,     1,     4,     2,     4,     2,     0,     3,     1,     1,
       2,     2,     1,     3,     4,     5,     2,     5,     7,     5,
       1,     2,     1,     2,     2,     2,     3,     3,     3,     0,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     5,     8,     3,     9,     4,    10,    11,     2,     0,
       3,     0,     1,     3,     1,     4,     0,     2,     2,     2,
       0,     1,     3,     3,     6,     4,     0,     1,     1,     2,
       2,     0,     3,     3,     2,     1,     1,     2,     2,     4,
       0,     1,     0,     6,     1,     3,     3,     3,     5,     2,
       0,     2,     2,     0,     3,     4,     4,     0,     2,     0,
       4,     0,     3,     8,    11,     6,     8,     7,    10,     6,
       2,     3,     0,     8,    11,     5,     1,     0,     6,     5,
       8,     4,     6,     1,     0,     3,     0,     1,     2,     2,
       2,     1,     2,     3,     2,     2,     2,     2,     3,     3,
       3,     1,     3,     1,     0,     1,     2,     2,     1,     1,
       3,     6,    10,     1,     0,     1,     2,     2,     0,     2,
       2,     1,     0,     5,     7,     1,     0,     7,     2,     0,
       3,     5,     5,     8,     2,     0,     2,     2,     2,     1,
       5,     2,     0,     2,     7,     6,    10,     6,     6,     6,
       6,     7,     6,     9,     9,     6,     6,     6,     7,     6,
       8,     8,     8,     8,     6,     6,     7,     7,     8,     6,
       9,     6,     7,     2,     2,     2,     2,     1,     2,     1,
       0,     7,     6,     4,     0,     1,     3,     4,     1,     3,
       1,     2,     2,     2,     2,     1,     1,    10,    13,     2,
       0,     2,     2,     1,     0,     5,     4,     4,    11,    14,
      12,    15,     5,     7,    11,     2,     1,     4,     0,     8,
      11,     1,     1,     7,     9,     8,    10,     8,     4,     0,
       5,     0,     2,     0,     2,     0,     2,     0,     2,     0,
       1,     1,     1,     1,     1,     8,     1,     1,    16,    20,
       1,     1,     2,     1,     3,     1,     1,     1,     3,     1,
       2,     0,     1,     2,     4,     1,     1,     1,     1,     1,
       3,     0,     1,     0,     1,     1,     4,     0,     1,     1,
       1,     3,     0,     1,     1,     1,     1,     2,     0,     0,
       2,     2,     1,     2,     2,     2,     2,    11,    13,     1,
       3,     5,     1,     3,     5,     1,     2,     2,     1,     8,
       6,     5,     4,     4,     3,     7,     8,     6,     6,     6,
       6,     6,     4,     7,     5,     8,     3,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     3,
       3,     1,     0,     1,     3,     7,     9,     9,     8,     3,
       0,    13,     1,     3,     5,     5,     3,     6,     2,     1,
       0,     2,     0,     2,     4,     0,     1,     0,     6,     8,
       8,     1,     3,     5,     5,     7,     9,     7,     9,     5,
       6,     6,     4,     6,     4,     6,     8,     4,     6,     4,
       6,     5,     7,     1,     1,     1,     2,     1,     2,     1,
       1,     1,     3,     3,     3,     3,     2,     2,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     2,
       2,     3,     1,     3,     5,     2,     2,     0,     6,     6,
       6,     6,     6,     6,     6,     8,     9,     8,     6,     6,
       8,     9,     8,     9,     9,     7,    10,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     2,     3,     3,     3,
       3,     2,     1,     2,     1,     3,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     8,     8,     8,     8,     8,
       8,     9,     8,     8,     2,     0,     1,     2,     1,     1,
       1,     2,     1,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     1,     2,     3,     3,     3,     3,
       4,     4,     3,     3,     3,     4,     4,     3,     4,     4,
       1,     1,     1,     0,     7,     7,    10,     1,     1,     2,
       4,     5,     1,     3,     2,     2,     2,     2,     1,     2,
       2,     4,     3,     2,     2,     2,     2,     2,     2,     3,
       2,     2,     2,     5,     5,     5,     5,     5,     1,     3,
       1,     2,     3,     0,     6,     6,     9,     3,     0,     3,
       0,     5,     2,     0,     3,     3,     3,     7,     7,    10,
       1,     1,     1,     1,     1,     1,    15,    18,     1,     0,
       1,     0,     1,     0,     2,     0,     1,     3,     4,     5,
       2,     2,     4,     4,     0,     1,     3,     2,     0,     1,
       0,     1,     1,     0,     2,     2,     0,     8,    11,     6,
       6,     2,     0,     3,     2,     1,     3,     1,     3,     2,
       1,     1,     2,     3,     2,     1,     3,     3,     3,     2,
       2,     1,     1,     1,     1,     2,     1,     1,     1,     1,
       4,     5,     1,     3,     3,     1,     3,     3,     5,     6,
       1,     3,     2,     1,     3,     1,     2,     4,     5,     1,
       1,     1,     1,     3,     3,     2,     2,     1,     2,     2,
       2,     2,     1,     2,     2,     2,     2,     1,     1,     1,
       3,     3,     5,     2,     0,     2,     1,     3,     5,     5,
       5,     1,     2,     1,     0,     4,     6,     4,     6,     4,
       6,     4,     6,     4,     6,     3,     5,     5,     5,     1,
       3,     1,     3,     2,     2,     1,     2,     1,     2,    11,
      10,    10,     2,     2,     0,     9,     2,     0,    10,    11,
      11,     5,     5,     8,     4,     4,     7,     7,     1,     1,
       1,     1,     1,     1,     3,     1,     5,     5,     6,     6,
       6,     6,     6,     8,     8,     6,     6,     7,     9,     9,
       8,    10,     6,     6,     6,     6,     6,     6,     6,     8,
       6,     8,     6,     8,     7,     9,     6,     8,     7,     9,
       8,    10,     8,    10,     9,    11,     8,    10,     9,    11,
       8,     8,     7,     6,     6,     6,     6,     8,     8,     8,
       8,     6,     9,     1,     0,     2,     0,     8,     8,     8,
      10,     9,     8,     1,     0,     6,     6,     6,     6,     6,
       6,     6,     9,     9,     6,     6,     6,     8,     6,     8,
       8,     8,     8,     6,     8,     6,     8,     7,     9,     7,
       9,     6,     7,     1,     3,     3,     3,     1,     1,     1,
       1,     1,     7,     6,     6,     6,     6,     6,     6,     7,
       7,     6,     9,     9,     6,     6,     6,     6,     6,     6,
       8,     8,     8,     6,     7,     6,     6,     5,     1,     0,
       3,     3,     5,     6,     6,     6,     8,     1,     3,     1,
       5,     5,     6,     7,     4,     4,     4,     6,    13,     1,
       1,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       0,     1,     1,     1,     1,     1,     1,     0,     3,     2,
       0,     2,     2,     2,     3,     3,     3,     3,     3,     3,
       2,     3,     2,     5,     4,     3,     3,     3,     1,     1,
       0,     3,     2,     2,     1,     2,     1,     3,     2,     1,
       0,     2,     3,     0,     9,    11,    12,    14,     3,     4,
       4,     0,     2,     5,     1,     0,     1,     2,     3,     3,
       3,     1,     2,     1,     1,     1,     1,     1,     1,     0,
       5,     4,     6,     4,     3,     5,     7,     9,     1,     3,
       1,     5,     4,     4,     6,     4,     6,     6,     5,     7,
       9,     6,     1,     0,     6,    11,    11,    11,    13,     9,
      11,     1,     1,    10,     4,     2,     5,     2,     0,     6,
       5,     3,     5,     1,     3,     1,     1,     2,     1,     1,
       1,     1,     0,     1,     0,     1,     0,     1,     0,     1,
       0,     3,     0,     2,     1,     3,     1,     0,     2,     4,
       3,     5,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     2,     1,     1,     1,     1,     0,     5,
       3,     0,     1,     1,     1,     1,     3,     9,    12,     3,
       0,     2,     3,     2,     3,     7,     1,     3,     1,     4,
       4,     7,     2,     1,     1,     1,     3,     2,     8,     5,
       0,     4,     3,     0,     2,     0,     7,     2,     0,     5,
       3,     0,     2,     2,     2,     3,     1,     3,     1,     2,
       1,     0,     1,     2,     0,     8,     1,     3,     3,     5,
       2,     1,     3,     7,     1,     0,     3,     2,     2,     2,
       0,     2,     2,     1,     1,     3,     3,     1,     2,     4,
       4,     2,     3,     5,     5,     1,     1,     9,     9,     1,
       2,     4,     4,     4,     2,     2,     3,     1,     3,     7,
       1,     2,     0,     1,     0,     2,     0,     3,     3,     4,
       4,     4,     4,     3,     2,     1,     1,     0,     1,     1,
       0,     1,     5,     1,     0,     1,     0,     3,     1,     3,
       4,     3,     2,     2,     1,     1,     1,     0,     2,     4,
       5,     6,     4,     5,     2,     3,     1,     1,     1,     1,
       2,     2,     1,     1,     1,     1,     1,     1,     3,     0,
       1,     3,     1,     1,     1,     1,     1,     2,     4,     4,
       5,     2,     0,     1,     3,     1,     0,     1,     2,     3,
       2,     4,     2,     3,     2,     0,     4,     5,     2,     0,
       1,     3,     2,     3,     2,     3,     2,     3,     2,     3,
       1,     4,     3,     4,     5,     4,     5,     4,     5,     2,
       4,     1,     1,     0,     1,     4,     5,     4,     0,     2,
       2,     2,     1,     1,     0,     4,     2,     1,     2,     2,
       4,     1,     3,     1,     2,     3,     6,     4,     0,     2,
       6,     2,     1,     3,     4,     0,     2,     0,     2,     0,
       2,     4,     0,     1,     0,     1,     3,     3,     7,    12,
       1,     3,     2,     3,     3,     1,     2,     2,     2,     2,
       1,     1,     3,     3,     2,     2,     3,     5,     6,     2,
       3,     3,     4,     0,     1,     1,     1,     1,     1,     2,
       4,     1,     1,     1,     1,     2,     3,     3,     0,     1,
       1,     1,     1,     1,     2,     2,     2,     2,     2,     1,
       3,     0,     1,     1,     1,     1,     5,     2,     1,     1,
       1,     1,     4,     1,     2,     2,     1,     3,     3,     2,
       1,     0,     5,     2,     5,     2,     1,     3,     3,     0,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       3,     3,     3,     0,     1,     4,     1,     3,     3,     5,
       2,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     2,     3,     3,     2,
       2,     3,     5,     4,     6,     3,     5,     4,     6,     4,
       6,     5,     7,     3,     2,     4,     2,     3,     3,     4,
       3,     4,     3,     4,     5,     6,     6,     7,     6,     7,
       6,     7,     3,     4,     4,     6,     2,     3,     4,     3,
       4,     4,     5,     1,     1,     3,     2,     2,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     2,     2,     5,     6,     6,     7,     3,     4,     1,
       1,     2,     4,     1,     1,     1,     2,     2,     2,     2,
       1,     1,     4,     3,     5,     6,     8,     6,     6,     4,
       4,     1,     1,     1,     5,     1,     1,     4,     1,     4,
       1,     4,     1,     4,     1,     1,     1,     1,     1,     1,
       6,     4,     4,     6,     4,     4,     4,     6,     5,     5,
       5,     4,     6,     4,     4,     4,     4,     5,     7,     7,
       9,     5,     4,     6,     5,     7,     7,     7,     2,     3,
       3,     3,     4,     0,     4,     1,     3,     3,     1,     1,
       1,     2,     2,     0,     2,     3,     3,     4,     2,     2,
       5,     0,     5,     0,     2,     0,     1,     3,     3,     2,
       2,     0,     6,     1,     0,     3,     0,     3,     3,     3,
       0,     1,     4,     2,     2,     2,     2,     2,     3,     2,
       2,     3,     0,     4,     3,     5,     4,     3,     5,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     4,     1,     4,
       1,     4,     1,     2,     1,     2,     1,     3,     1,     3,
       1,     3,     3,     1,     3,     3,     3,     2,     1,     3,
       3,     0,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     3,     2,     3,     0,     3,
       3,     2,     2,     1,     0,     2,     2,     3,     2,     1,
       1,     3,     5,     1,     2,     4,     2,     0,     1,     0,
       1,     2,     2,     2,     3,     5,     1,     0,     1,     2,
       0,     2,     1,     0,     1,     0,     1,     3,     3,     2,
       1,     1,     1,     3,     1,     2,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     2,     6,     2,     3,     5,     1,     1,     1,     1,
       1,     1,     2,     2,     1,     1,     1,     1,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, core_yyscan_t yyscanner)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, yyscanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (core_yyscan_t yyscanner)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, &yylloc, yyscanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 842 "gram.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[0].list);
			}
#line 26580 "gram.c" /* yacc.c:1646  */
    break;

  case 3:
#line 858 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-2].list) != NIL)
					{
						/* update length of previous stmt */
						updateRawStmtEnd(llast_node(RawStmt, (yyvsp[-2].list)), (yylsp[-1]));
					}
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), makeRawStmt((yyvsp[0].node), (yylsp[-1]) + 1));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 26596 "gram.c" /* yacc.c:1646  */
    break;

  case 4:
#line 870 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = list_make1(makeRawStmt((yyvsp[0].node), 0));
					else
						(yyval.list) = NIL;
				}
#line 26607 "gram.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1005 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 26613 "gram.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1015 "gram.y" /* yacc.c:1646  */
    {
					CallStmt *n = makeNode(CallStmt);
					n->funccall = castNode(FuncCall, (yyvsp[0].node));
					(yyval.node) = (Node *)n;
				}
#line 26623 "gram.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1030 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 26635 "gram.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1040 "gram.y" /* yacc.c:1646  */
    {}
#line 26641 "gram.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1041 "gram.y" /* yacc.c:1646  */
    {}
#line 26647 "gram.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1042 "gram.y" /* yacc.c:1646  */
    {}
#line 26653 "gram.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1051 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 26659 "gram.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1052 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26665 "gram.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1056 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 26671 "gram.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1057 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26677 "gram.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1062 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 26686 "gram.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1067 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password", NULL, (yylsp[-1]));
				}
#line 26694 "gram.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1071 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * These days, passwords are always stored in encrypted
					 * form, so there is no difference between PASSWORD and
					 * ENCRYPTED PASSWORD.
					 */
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 26708 "gram.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1081 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNENCRYPTED PASSWORD is no longer supported"),
							 errhint("Remove UNENCRYPTED to store the password in encrypted form instead."),
							 parser_errposition((yylsp[-2]))));
				}
#line 26720 "gram.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1089 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 26728 "gram.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1093 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 26736 "gram.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1097 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 26744 "gram.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1102 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 26752 "gram.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1106 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We handle identifiers that aren't parser keywords with
					 * the following special-case codes, to avoid bloating the
					 * size of the main parser.
					 */
					if (strcmp((yyvsp[0].str), "superuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nosuperuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createrole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreaterole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "replication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noreplication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createdb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreatedb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "login") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nologin") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "bypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *)makeInteger(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nobypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *)makeInteger(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noinherit") == 0)
					{
						/*
						 * Note that INHERIT is a keyword, so it's handled by main parser, but
						 * NOINHERIT is handled here.
						 */
						(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(false), (yylsp[0]));
					}
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized role option \"%s\"", (yyvsp[0].str)),
									 parser_errposition((yylsp[0]))));
				}
#line 26801 "gram.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1153 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = (yyvsp[0].defelt); }
#line 26807 "gram.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1156 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *)makeInteger((yyvsp[0].ival)), (yylsp[-1]));
				}
#line 26815 "gram.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1160 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 26823 "gram.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1164 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 26831 "gram.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1168 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 26839 "gram.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1172 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 26847 "gram.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1186 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 26859 "gram.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1204 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 26871 "gram.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1212 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 26883 "gram.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1222 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 26889 "gram.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1223 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 26895 "gram.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1228 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 26907 "gram.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1236 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 26919 "gram.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1244 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 26931 "gram.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1252 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 26943 "gram.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1273 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 26954 "gram.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1280 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = true;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 26965 "gram.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1287 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 26976 "gram.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1294 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->roles = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 26987 "gram.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1301 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 26998 "gram.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1308 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = true;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27009 "gram.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1325 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27021 "gram.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1343 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-3].rolespec);
					n->action = (yyvsp[-2].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *)(yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *)n;
				}
#line 27034 "gram.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1353 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = +1; }
#line 27040 "gram.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1354 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = -1; }
#line 27046 "gram.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1366 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 27060 "gram.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1376 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 27074 "gram.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1386 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* schema name can be omitted here, too */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 27093 "gram.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1401 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not here */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 27112 "gram.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1418 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27118 "gram.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1419 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 27124 "gram.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1424 "gram.y" /* yacc.c:1646  */
    {
					if ((yyloc) < 0)			/* see comments for YYLLOC_DEFAULT */
						(yyloc) = (yylsp[0]);
					(yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node));
				}
#line 27134 "gram.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1430 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27140 "gram.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1458 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->type = T_PgpoolVariableSetStmt; /* Hack to keep changes minumum */
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 27151 "gram.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1465 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 27161 "gram.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1471 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
#line 27171 "gram.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1477 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 27181 "gram.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1486 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 27193 "gram.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1494 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 27205 "gram.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1506 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 27217 "gram.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1514 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 27229 "gram.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1522 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 27240 "gram.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1529 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 27251 "gram.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1538 "gram.y" /* yacc.c:1646  */
    {(yyval.vsetstmt) = (yyvsp[0].vsetstmt);}
#line 27257 "gram.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1540 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 27268 "gram.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1548 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[0].node) != NULL)
						n->args = list_make1((yyvsp[0].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 27283 "gram.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1559 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[0]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				}
#line 27295 "gram.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1567 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 27307 "gram.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1575 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[0].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 27322 "gram.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1586 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 27334 "gram.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1594 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 27346 "gram.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1602 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 27357 "gram.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1609 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[0].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 27369 "gram.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1618 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION SNAPSHOT";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 27381 "gram.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1627 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27387 "gram.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1629 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str)); }
#line 27393 "gram.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1632 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 27399 "gram.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1633 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 27405 "gram.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1637 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0])); }
#line 27411 "gram.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1639 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].value), (yylsp[0])); }
#line 27417 "gram.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1642 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "read uncommitted"; }
#line 27423 "gram.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1643 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "read committed"; }
#line 27429 "gram.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1644 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "repeatable read"; }
#line 27435 "gram.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1645 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "serializable"; }
#line 27441 "gram.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1649 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "true"; }
#line 27447 "gram.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1650 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "false"; }
#line 27453 "gram.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1651 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "on"; }
#line 27459 "gram.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1657 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27465 "gram.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1670 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 27473 "gram.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1674 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 27481 "gram.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1678 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-2].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[0].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[0]))));
					}
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 27500 "gram.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1693 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-4].typnam);
					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 27511 "gram.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1699 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].value), (yylsp[0])); }
#line 27517 "gram.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1700 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 27523 "gram.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1701 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 27529 "gram.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1705 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27535 "gram.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1706 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 27541 "gram.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1707 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 27547 "gram.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1711 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27553 "gram.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1712 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27559 "gram.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1716 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].vsetstmt); }
#line 27565 "gram.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1718 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->type = T_PgpoolVariableSetStmt; /* Hack to keep the changes minumum */
					(yyval.node) = (Node *) n;
				}
#line 27575 "gram.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1726 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 27581 "gram.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1728 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.vsetstmt) = n;
				}
#line 27592 "gram.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1735 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.vsetstmt) = n;
				}
#line 27603 "gram.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1742 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 27614 "gram.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1752 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = (yyvsp[0].str);
					(yyval.vsetstmt) = n;
				}
#line 27625 "gram.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1759 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET_ALL;
					(yyval.vsetstmt) = n;
				}
#line 27635 "gram.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1768 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 27641 "gram.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1769 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 27647 "gram.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1774 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 27653 "gram.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1775 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 27659 "gram.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1782 "gram.y" /* yacc.c:1646  */
    {
				VariableShowStmt *n = (VariableShowStmt *)newNode(sizeof(VariableShowStmt),T_PgpoolVariableShowStmt);
				n->name = (yyvsp[0].str);
				(yyval.node) = (Node *) n;
			}
#line 27669 "gram.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1788 "gram.y" /* yacc.c:1646  */
    {
				VariableShowStmt *n = (VariableShowStmt *)newNode(sizeof(VariableShowStmt),T_PgpoolVariableShowStmt);
				n->name = "all";
				(yyval.node) = (Node *) n;
			}
#line 27679 "gram.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1794 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 27689 "gram.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1800 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
#line 27699 "gram.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1806 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
#line 27709 "gram.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1812 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
#line 27719 "gram.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1818 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "all";
					(yyval.node) = (Node *) n;
				}
#line 27729 "gram.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1828 "gram.y" /* yacc.c:1646  */
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);
					n->constraints = (yyvsp[-1].list);
					n->deferred = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 27740 "gram.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1837 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27746 "gram.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1838 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 27752 "gram.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1842 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 27758 "gram.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1843 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 27764 "gram.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1852 "gram.y" /* yacc.c:1646  */
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);
					(yyval.node) = (Node *)n;
				}
#line 27773 "gram.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1867 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
#line 27783 "gram.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1873 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 27793 "gram.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1879 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 27803 "gram.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1885 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
#line 27813 "gram.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1891 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_SEQUENCES;
					(yyval.node) = (Node *) n;
				}
#line 27823 "gram.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1910 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27836 "gram.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1919 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 27849 "gram.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1928 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->relkind = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27862 "gram.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1937 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->relkind = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 27875 "gram.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1946 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_TABLE;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 27890 "gram.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1957 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_TABLE;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 27905 "gram.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1968 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27918 "gram.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1977 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 27931 "gram.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1986 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->relkind = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27944 "gram.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1995 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_INDEX;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 27959 "gram.c" /* yacc.c:1646  */
    break;

  case 276:
#line 2006 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_INDEX;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 27974 "gram.c" /* yacc.c:1646  */
    break;

  case 277:
#line 2017 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27987 "gram.c" /* yacc.c:1646  */
    break;

  case 278:
#line 2026 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28000 "gram.c" /* yacc.c:1646  */
    break;

  case 279:
#line 2035 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28013 "gram.c" /* yacc.c:1646  */
    break;

  case 280:
#line 2044 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28026 "gram.c" /* yacc.c:1646  */
    break;

  case 281:
#line 2053 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_MATVIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28039 "gram.c" /* yacc.c:1646  */
    break;

  case 282:
#line 2062 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_MATVIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28052 "gram.c" /* yacc.c:1646  */
    break;

  case 283:
#line 2071 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 28067 "gram.c" /* yacc.c:1646  */
    break;

  case 284:
#line 2082 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 28082 "gram.c" /* yacc.c:1646  */
    break;

  case 285:
#line 2095 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 28088 "gram.c" /* yacc.c:1646  */
    break;

  case 286:
#line 2096 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 28094 "gram.c" /* yacc.c:1646  */
    break;

  case 287:
#line 2102 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_AttachPartition;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = (yyvsp[0].partboundspec);
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 28110 "gram.c" /* yacc.c:1646  */
    break;

  case 288:
#line 2115 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_DetachPartition;
					cmd->name = (yyvsp[0].range);
					cmd->bound = NULL;
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 28126 "gram.c" /* yacc.c:1646  */
    break;

  case 289:
#line 2131 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_AttachPartition;
					cmd->name = (yyvsp[0].range);
					cmd->bound = NULL;
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 28142 "gram.c" /* yacc.c:1646  */
    break;

  case 290:
#line 2147 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28154 "gram.c" /* yacc.c:1646  */
    break;

  case 291:
#line 2156 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28166 "gram.c" /* yacc.c:1646  */
    break;

  case 292:
#line 2165 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28178 "gram.c" /* yacc.c:1646  */
    break;

  case 293:
#line 2174 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28190 "gram.c" /* yacc.c:1646  */
    break;

  case 294:
#line 2183 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[-1].str);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 28202 "gram.c" /* yacc.c:1646  */
    break;

  case 295:
#line 2192 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *)n;
				}
#line 28213 "gram.c" /* yacc.c:1646  */
    break;

  case 296:
#line 2200 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *)n;
				}
#line 28224 "gram.c" /* yacc.c:1646  */
    break;

  case 297:
#line 2208 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropExpression;
					n->name = (yyvsp[-2].str);
					(yyval.node) = (Node *)n;
				}
#line 28235 "gram.c" /* yacc.c:1646  */
    break;

  case 298:
#line 2216 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropExpression;
					n->name = (yyvsp[-4].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28247 "gram.c" /* yacc.c:1646  */
    break;

  case 299:
#line 2225 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeInteger((yyvsp[0].ival));
					(yyval.node) = (Node *)n;
				}
#line 28259 "gram.c" /* yacc.c:1646  */
    break;

  case 300:
#line 2234 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					if ((yyvsp[-3].ival) <= 0 || (yyvsp[-3].ival) > PG_INT16_MAX)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("column number must be in range from 1 to %d", PG_INT16_MAX),
								 parser_errposition((yylsp[-3]))));

					n->subtype = AT_SetStatistics;
					n->num = (int16) (yyvsp[-3].ival);
					n->def = (Node *) makeInteger((yyvsp[0].ival));
					(yyval.node) = (Node *)n;
				}
#line 28278 "gram.c" /* yacc.c:1646  */
    break;

  case 301:
#line 2250 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28290 "gram.c" /* yacc.c:1646  */
    break;

  case 302:
#line 2259 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28302 "gram.c" /* yacc.c:1646  */
    break;

  case 303:
#line 2268 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStorage;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 28314 "gram.c" /* yacc.c:1646  */
    break;

  case 304:
#line 2277 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);

					c->contype = CONSTR_IDENTITY;
					c->generated_when = (yyvsp[-3].ival);
					c->options = (yyvsp[0].list);
					c->location = (yylsp[-4]);

					n->subtype = AT_AddIdentity;
					n->name = (yyvsp[-6].str);
					n->def = (Node *) c;

					(yyval.node) = (Node *)n;
				}
#line 28334 "gram.c" /* yacc.c:1646  */
    break;

  case 305:
#line 2294 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetIdentity;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28346 "gram.c" /* yacc.c:1646  */
    break;

  case 306:
#line 2303 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-2].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28358 "gram.c" /* yacc.c:1646  */
    break;

  case 307:
#line 2312 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-4].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28370 "gram.c" /* yacc.c:1646  */
    break;

  case 308:
#line 2321 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28383 "gram.c" /* yacc.c:1646  */
    break;

  case 309:
#line 2331 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28396 "gram.c" /* yacc.c:1646  */
    break;

  case 310:
#line 2344 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = (yyvsp[0].node);
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 28414 "gram.c" /* yacc.c:1646  */
    break;

  case 311:
#line 2359 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnGenericOptions;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28426 "gram.c" /* yacc.c:1646  */
    break;

  case 312:
#line 2368 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28438 "gram.c" /* yacc.c:1646  */
    break;

  case 313:
#line 2377 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);
					n->subtype = AT_AlterConstraint;
					n->def = (Node *) c;
					c->contype = CONSTR_FOREIGN; /* others not supported, yet */
					c->conname = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "ALTER CONSTRAINT statement",
									&c->deferrable,
									&c->initdeferred,
									NULL, NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 28456 "gram.c" /* yacc.c:1646  */
    break;

  case 314:
#line 2392 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ValidateConstraint;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28467 "gram.c" /* yacc.c:1646  */
    break;

  case 315:
#line 2400 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28480 "gram.c" /* yacc.c:1646  */
    break;

  case 316:
#line 2410 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28493 "gram.c" /* yacc.c:1646  */
    break;

  case 317:
#line 2420 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOids;
					(yyval.node) = (Node *)n;
				}
#line 28503 "gram.c" /* yacc.c:1646  */
    break;

  case 318:
#line 2427 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28514 "gram.c" /* yacc.c:1646  */
    break;

  case 319:
#line 2435 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
#line 28525 "gram.c" /* yacc.c:1646  */
    break;

  case 320:
#line 2443 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetLogged;
					(yyval.node) = (Node *)n;
				}
#line 28535 "gram.c" /* yacc.c:1646  */
    break;

  case 321:
#line 2450 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetUnLogged;
					(yyval.node) = (Node *)n;
				}
#line 28545 "gram.c" /* yacc.c:1646  */
    break;

  case 322:
#line 2457 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28556 "gram.c" /* yacc.c:1646  */
    break;

  case 323:
#line 2465 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28567 "gram.c" /* yacc.c:1646  */
    break;

  case 324:
#line 2473 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28578 "gram.c" /* yacc.c:1646  */
    break;

  case 325:
#line 2481 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *)n;
				}
#line 28588 "gram.c" /* yacc.c:1646  */
    break;

  case 326:
#line 2488 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *)n;
				}
#line 28598 "gram.c" /* yacc.c:1646  */
    break;

  case 327:
#line 2495 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28609 "gram.c" /* yacc.c:1646  */
    break;

  case 328:
#line 2503 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *)n;
				}
#line 28619 "gram.c" /* yacc.c:1646  */
    break;

  case 329:
#line 2510 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *)n;
				}
#line 28629 "gram.c" /* yacc.c:1646  */
    break;

  case 330:
#line 2517 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28640 "gram.c" /* yacc.c:1646  */
    break;

  case 331:
#line 2525 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28651 "gram.c" /* yacc.c:1646  */
    break;

  case 332:
#line 2533 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28662 "gram.c" /* yacc.c:1646  */
    break;

  case 333:
#line 2541 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28673 "gram.c" /* yacc.c:1646  */
    break;

  case 334:
#line 2549 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *)n;
				}
#line 28684 "gram.c" /* yacc.c:1646  */
    break;

  case 335:
#line 2557 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *)n;
				}
#line 28695 "gram.c" /* yacc.c:1646  */
    break;

  case 336:
#line 2565 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TypeName *def = makeTypeNameFromNameList((yyvsp[0].list));
					def->location = (yylsp[0]);
					n->subtype = AT_AddOf;
					n->def = (Node *) def;
					(yyval.node) = (Node *)n;
				}
#line 28708 "gram.c" /* yacc.c:1646  */
    break;

  case 337:
#line 2575 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOf;
					(yyval.node) = (Node *)n;
				}
#line 28718 "gram.c" /* yacc.c:1646  */
    break;

  case 338:
#line 2582 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ChangeOwner;
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 28729 "gram.c" /* yacc.c:1646  */
    break;

  case 339:
#line 2590 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28740 "gram.c" /* yacc.c:1646  */
    break;

  case 340:
#line 2598 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetRelOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28751 "gram.c" /* yacc.c:1646  */
    break;

  case 341:
#line 2606 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetRelOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28762 "gram.c" /* yacc.c:1646  */
    break;

  case 342:
#line 2614 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ReplicaIdentity;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 28773 "gram.c" /* yacc.c:1646  */
    break;

  case 343:
#line 2622 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 28783 "gram.c" /* yacc.c:1646  */
    break;

  case 344:
#line 2629 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 28793 "gram.c" /* yacc.c:1646  */
    break;

  case 345:
#line 2636 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ForceRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 28803 "gram.c" /* yacc.c:1646  */
    break;

  case 346:
#line 2643 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_NoForceRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 28813 "gram.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2649 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_GenericOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 28824 "gram.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2658 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 28830 "gram.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2659 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 28836 "gram.c" /* yacc.c:1646  */
    break;

  case 350:
#line 2663 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_CASCADE; }
#line 28842 "gram.c" /* yacc.c:1646  */
    break;

  case 351:
#line 2664 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; }
#line 28848 "gram.c" /* yacc.c:1646  */
    break;

  case 352:
#line 2665 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
#line 28854 "gram.c" /* yacc.c:1646  */
    break;

  case 353:
#line 2670 "gram.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 28866 "gram.c" /* yacc.c:1646  */
    break;

  case 354:
#line 2677 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 28872 "gram.c" /* yacc.c:1646  */
    break;

  case 355:
#line 2681 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 28878 "gram.c" /* yacc.c:1646  */
    break;

  case 356:
#line 2682 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 28884 "gram.c" /* yacc.c:1646  */
    break;

  case 357:
#line 2687 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_NOTHING;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 28895 "gram.c" /* yacc.c:1646  */
    break;

  case 358:
#line 2694 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_FULL;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 28906 "gram.c" /* yacc.c:1646  */
    break;

  case 359:
#line 2701 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_DEFAULT;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 28917 "gram.c" /* yacc.c:1646  */
    break;

  case 360:
#line 2708 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_INDEX;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 28928 "gram.c" /* yacc.c:1646  */
    break;

  case 361:
#line 2717 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 28934 "gram.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2720 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 28940 "gram.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2721 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28946 "gram.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2725 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 28952 "gram.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2726 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 28958 "gram.c" /* yacc.c:1646  */
    break;

  case 366:
#line 2732 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 28966 "gram.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2736 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 28974 "gram.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2740 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-4].str), (yyvsp[-2].str), (Node *) (yyvsp[0].node),
											 DEFELEM_UNSPEC, (yylsp[-4]));
				}
#line 28983 "gram.c" /* yacc.c:1646  */
    break;

  case 369:
#line 2745 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-2].str), (yyvsp[0].str), NULL, DEFELEM_UNSPEC, (yylsp[-2]));
				}
#line 28991 "gram.c" /* yacc.c:1646  */
    break;

  case 370:
#line 2752 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 28997 "gram.c" /* yacc.c:1646  */
    break;

  case 371:
#line 2754 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 29003 "gram.c" /* yacc.c:1646  */
    break;

  case 372:
#line 2759 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 29011 "gram.c" /* yacc.c:1646  */
    break;

  case 373:
#line 2763 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[0].value), (yylsp[-2]));
				}
#line 29019 "gram.c" /* yacc.c:1646  */
    break;

  case 374:
#line 2767 "gram.y" /* yacc.c:1646  */
    {
					if (strcmp((yyvsp[0].defelt)->defname, "as") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "restart") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "owned_by") == 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("sequence option \"%s\" not supported here", (yyvsp[0].defelt)->defname),
								 parser_errposition((yylsp[0]))));
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 29034 "gram.c" /* yacc.c:1646  */
    break;

  case 375:
#line 2778 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("generated", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 29042 "gram.c" /* yacc.c:1646  */
    break;

  case 376:
#line 2786 "gram.y" /* yacc.c:1646  */
    {
					ListCell   *lc;
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_HASH;
					n->modulus = n->remainder = -1;

					foreach (lc, (yyvsp[-1].list))
					{
						DefElem    *opt = lfirst_node(DefElem, lc);

						if (strcmp(opt->defname, "modulus") == 0)
						{
							if (n->modulus != -1)
								ereport(ERROR,
										(errcode(ERRCODE_DUPLICATE_OBJECT),
										 errmsg("modulus for hash partition provided more than once"),
										 parser_errposition(opt->location)));
							n->modulus = defGetInt32(opt);
						}
						else if (strcmp(opt->defname, "remainder") == 0)
						{
							if (n->remainder != -1)
								ereport(ERROR,
										(errcode(ERRCODE_DUPLICATE_OBJECT),
										 errmsg("remainder for hash partition provided more than once"),
										 parser_errposition(opt->location)));
							n->remainder = defGetInt32(opt);
						}
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized hash partition bound specification \"%s\"",
											opt->defname),
									 parser_errposition(opt->location)));
					}

					if (n->modulus == -1)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("modulus for hash partition must be specified")));
					if (n->remainder == -1)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("remainder for hash partition must be specified")));

					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 29097 "gram.c" /* yacc.c:1646  */
    break;

  case 377:
#line 2839 "gram.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_LIST;
					n->is_default = false;
					n->listdatums = (yyvsp[-1].list);
					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 29112 "gram.c" /* yacc.c:1646  */
    break;

  case 378:
#line 2852 "gram.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_RANGE;
					n->is_default = false;
					n->lowerdatums = (yyvsp[-5].list);
					n->upperdatums = (yyvsp[-1].list);
					n->location = (yylsp[-7]);

					(yyval.partboundspec) = n;
				}
#line 29128 "gram.c" /* yacc.c:1646  */
    break;

  case 379:
#line 2866 "gram.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->is_default = true;
					n->location = (yylsp[0]);

					(yyval.partboundspec) = n;
				}
#line 29141 "gram.c" /* yacc.c:1646  */
    break;

  case 380:
#line 2878 "gram.y" /* yacc.c:1646  */
    {
				(yyval.defelt) = makeDefElem((yyvsp[-1].str), (Node *)makeInteger((yyvsp[0].ival)), (yylsp[-1]));
			}
#line 29149 "gram.c" /* yacc.c:1646  */
    break;

  case 381:
#line 2885 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make1((yyvsp[0].defelt));
			}
#line 29157 "gram.c" /* yacc.c:1646  */
    break;

  case 382:
#line 2889 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
			}
#line 29165 "gram.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2903 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					/* can't use qualified_name, sigh */
					n->relation = makeRangeVarFromAnyName((yyvsp[-1].list), (yylsp[-1]), yyscanner);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TYPE;
					(yyval.node) = (Node *)n;
				}
#line 29179 "gram.c" /* yacc.c:1646  */
    break;

  case 384:
#line 2915 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 29185 "gram.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2916 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 29191 "gram.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2922 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[-1].node);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 29203 "gram.c" /* yacc.c:1646  */
    break;

  case 387:
#line 2931 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29216 "gram.c" /* yacc.c:1646  */
    break;

  case 388:
#line 2941 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29229 "gram.c" /* yacc.c:1646  */
    break;

  case 389:
#line 2951 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					n->behavior = (yyvsp[0].dbehavior);
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = NULL;
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 29248 "gram.c" /* yacc.c:1646  */
    break;

  case 390:
#line 2977 "gram.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29258 "gram.c" /* yacc.c:1646  */
    break;

  case 391:
#line 2983 "gram.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = NULL;
					(yyval.node) = (Node *)n;
				}
#line 29268 "gram.c" /* yacc.c:1646  */
    break;

  case 392:
#line 3018 "gram.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = (yyvsp[-8].range);
					n->query = NULL;
					n->attlist = (yyvsp[-7].list);
					n->is_from = (yyvsp[-6].boolean);
					n->is_program = (yyvsp[-5].boolean);
					n->filename = (yyvsp[-4].str);
					n->whereClause = (yyvsp[0].node);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-3]))));

					if (!n->is_from && n->whereClause != NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("WHERE clause not allowed with COPY TO"),
								 parser_errposition((yylsp[0]))));

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[-9].defelt))
						n->options = lappend(n->options, (yyvsp[-9].defelt));
					if ((yyvsp[-3].defelt))
						n->options = lappend(n->options, (yyvsp[-3].defelt));
					if ((yyvsp[-1].list))
						n->options = list_concat(n->options, (yyvsp[-1].list));
					(yyval.node) = (Node *)n;
				}
#line 29305 "gram.c" /* yacc.c:1646  */
    break;

  case 393:
#line 3051 "gram.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = NULL;
					n->query = (yyvsp[-6].node);
					n->attlist = NIL;
					n->is_from = false;
					n->is_program = (yyvsp[-3].boolean);
					n->filename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-4]))));

					(yyval.node) = (Node *)n;
				}
#line 29328 "gram.c" /* yacc.c:1646  */
    break;

  case 394:
#line 3072 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 29334 "gram.c" /* yacc.c:1646  */
    break;

  case 395:
#line 3073 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 29340 "gram.c" /* yacc.c:1646  */
    break;

  case 396:
#line 3077 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 29346 "gram.c" /* yacc.c:1646  */
    break;

  case 397:
#line 3078 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 29352 "gram.c" /* yacc.c:1646  */
    break;

  case 398:
#line 3087 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 29358 "gram.c" /* yacc.c:1646  */
    break;

  case 399:
#line 3088 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 29364 "gram.c" /* yacc.c:1646  */
    break;

  case 400:
#line 3089 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 29370 "gram.c" /* yacc.c:1646  */
    break;

  case 401:
#line 3092 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 29376 "gram.c" /* yacc.c:1646  */
    break;

  case 402:
#line 3093 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 29382 "gram.c" /* yacc.c:1646  */
    break;

  case 403:
#line 3098 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 29388 "gram.c" /* yacc.c:1646  */
    break;

  case 404:
#line 3099 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29394 "gram.c" /* yacc.c:1646  */
    break;

  case 405:
#line 3104 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"), (yylsp[0]));
				}
#line 29402 "gram.c" /* yacc.c:1646  */
    break;

  case 406:
#line 3108 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("freeze", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 29410 "gram.c" /* yacc.c:1646  */
    break;

  case 407:
#line 3112 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 29418 "gram.c" /* yacc.c:1646  */
    break;

  case 408:
#line 3116 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("null", (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 29426 "gram.c" /* yacc.c:1646  */
    break;

  case 409:
#line 3120 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("csv"), (yylsp[0]));
				}
#line 29434 "gram.c" /* yacc.c:1646  */
    break;

  case 410:
#line 3124 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("header", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 29442 "gram.c" /* yacc.c:1646  */
    break;

  case 411:
#line 3128 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("quote", (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 29450 "gram.c" /* yacc.c:1646  */
    break;

  case 412:
#line 3132 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("escape", (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 29458 "gram.c" /* yacc.c:1646  */
    break;

  case 413:
#line 3136 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 29466 "gram.c" /* yacc.c:1646  */
    break;

  case 414:
#line 3140 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)makeNode(A_Star), (yylsp[-2]));
				}
#line 29474 "gram.c" /* yacc.c:1646  */
    break;

  case 415:
#line 3144 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *)(yyvsp[0].list), (yylsp[-3]));
				}
#line 29482 "gram.c" /* yacc.c:1646  */
    break;

  case 416:
#line 3148 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_null", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 29490 "gram.c" /* yacc.c:1646  */
    break;

  case 417:
#line 3152 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 29498 "gram.c" /* yacc.c:1646  */
    break;

  case 418:
#line 3161 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"), (yylsp[0]));
				}
#line 29506 "gram.c" /* yacc.c:1646  */
    break;

  case 419:
#line 3164 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 29512 "gram.c" /* yacc.c:1646  */
    break;

  case 420:
#line 3169 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 29520 "gram.c" /* yacc.c:1646  */
    break;

  case 421:
#line 3172 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 29526 "gram.c" /* yacc.c:1646  */
    break;

  case 422:
#line 3176 "gram.y" /* yacc.c:1646  */
    {}
#line 29532 "gram.c" /* yacc.c:1646  */
    break;

  case 423:
#line 3177 "gram.y" /* yacc.c:1646  */
    {}
#line 29538 "gram.c" /* yacc.c:1646  */
    break;

  case 424:
#line 3183 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 29546 "gram.c" /* yacc.c:1646  */
    break;

  case 425:
#line 3187 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 29554 "gram.c" /* yacc.c:1646  */
    break;

  case 426:
#line 3194 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 29562 "gram.c" /* yacc.c:1646  */
    break;

  case 427:
#line 3200 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 29568 "gram.c" /* yacc.c:1646  */
    break;

  case 428:
#line 3201 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].value); }
#line 29574 "gram.c" /* yacc.c:1646  */
    break;

  case 429:
#line 3202 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeNode(A_Star); }
#line 29580 "gram.c" /* yacc.c:1646  */
    break;

  case 430:
#line 3203 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 29586 "gram.c" /* yacc.c:1646  */
    break;

  case 431:
#line 3204 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 29592 "gram.c" /* yacc.c:1646  */
    break;

  case 432:
#line 3209 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 29600 "gram.c" /* yacc.c:1646  */
    break;

  case 433:
#line 3213 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 29608 "gram.c" /* yacc.c:1646  */
    break;

  case 434:
#line 3220 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 29614 "gram.c" /* yacc.c:1646  */
    break;

  case 435:
#line 3234 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-9].range)->relpersistence = (yyvsp[-11].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-7].list);
					n->inhRelations = (yyvsp[-5].list);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 29635 "gram.c" /* yacc.c:1646  */
    break;

  case 436:
#line 3253 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-9].range)->relpersistence = (yyvsp[-14].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-7].list);
					n->inhRelations = (yyvsp[-5].list);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 29656 "gram.c" /* yacc.c:1646  */
    break;

  case 437:
#line 3272 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-8].range)->relpersistence = (yyvsp[-10].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-6].list));
					n->ofTypename->location = (yylsp[-6]);
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 29678 "gram.c" /* yacc.c:1646  */
    break;

  case 438:
#line 3292 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-8].range)->relpersistence = (yyvsp[-13].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-6].list));
					n->ofTypename->location = (yylsp[-6]);
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 29700 "gram.c" /* yacc.c:1646  */
    break;

  case 439:
#line 3312 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-10].range)->relpersistence = (yyvsp[-12].ival);
					n->relation = (yyvsp[-10].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = list_make1((yyvsp[-7].range));
					n->partbound = (yyvsp[-5].partboundspec);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 29722 "gram.c" /* yacc.c:1646  */
    break;

  case 440:
#line 3332 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-10].range)->relpersistence = (yyvsp[-15].ival);
					n->relation = (yyvsp[-10].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = list_make1((yyvsp[-7].range));
					n->partbound = (yyvsp[-5].partboundspec);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 29744 "gram.c" /* yacc.c:1646  */
    break;

  case 441:
#line 3362 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 29750 "gram.c" /* yacc.c:1646  */
    break;

  case 442:
#line 3363 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 29756 "gram.c" /* yacc.c:1646  */
    break;

  case 443:
#line 3364 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 29762 "gram.c" /* yacc.c:1646  */
    break;

  case 444:
#line 3365 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 29768 "gram.c" /* yacc.c:1646  */
    break;

  case 445:
#line 3367 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 29779 "gram.c" /* yacc.c:1646  */
    break;

  case 446:
#line 3374 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 29790 "gram.c" /* yacc.c:1646  */
    break;

  case 447:
#line 3380 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 29796 "gram.c" /* yacc.c:1646  */
    break;

  case 448:
#line 3381 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 29802 "gram.c" /* yacc.c:1646  */
    break;

  case 449:
#line 3385 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 29808 "gram.c" /* yacc.c:1646  */
    break;

  case 450:
#line 3386 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29814 "gram.c" /* yacc.c:1646  */
    break;

  case 451:
#line 3390 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 29820 "gram.c" /* yacc.c:1646  */
    break;

  case 452:
#line 3391 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29826 "gram.c" /* yacc.c:1646  */
    break;

  case 453:
#line 3396 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 29834 "gram.c" /* yacc.c:1646  */
    break;

  case 454:
#line 3400 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 29842 "gram.c" /* yacc.c:1646  */
    break;

  case 455:
#line 3407 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 29850 "gram.c" /* yacc.c:1646  */
    break;

  case 456:
#line 3411 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 29858 "gram.c" /* yacc.c:1646  */
    break;

  case 457:
#line 3417 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 29864 "gram.c" /* yacc.c:1646  */
    break;

  case 458:
#line 3418 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 29870 "gram.c" /* yacc.c:1646  */
    break;

  case 459:
#line 3419 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 29876 "gram.c" /* yacc.c:1646  */
    break;

  case 460:
#line 3423 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 29882 "gram.c" /* yacc.c:1646  */
    break;

  case 461:
#line 3424 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 29888 "gram.c" /* yacc.c:1646  */
    break;

  case 462:
#line 3428 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-3].str);
					n->typeName = (yyvsp[-2].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					n->fdwoptions = (yyvsp[-1].list);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 29911 "gram.c" /* yacc.c:1646  */
    break;

  case 463:
#line 3449 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-1].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 29933 "gram.c" /* yacc.c:1646  */
    break;

  case 464:
#line 3467 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-3].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 29955 "gram.c" /* yacc.c:1646  */
    break;

  case 465:
#line 3487 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 29961 "gram.c" /* yacc.c:1646  */
    break;

  case 466:
#line 3488 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29967 "gram.c" /* yacc.c:1646  */
    break;

  case 467:
#line 3493 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));
					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 29978 "gram.c" /* yacc.c:1646  */
    break;

  case 468:
#line 3499 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 29984 "gram.c" /* yacc.c:1646  */
    break;

  case 469:
#line 3500 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 29990 "gram.c" /* yacc.c:1646  */
    break;

  case 470:
#line 3502 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Note: the CollateClause is momentarily included in
					 * the list built by ColQualList, but we split it out
					 * again in SplitColQualList.
					 */
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 30007 "gram.c" /* yacc.c:1646  */
    break;

  case 471:
#line 3533 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 30018 "gram.c" /* yacc.c:1646  */
    break;

  case 472:
#line 3540 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 30029 "gram.c" /* yacc.c:1646  */
    break;

  case 473:
#line 3547 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30044 "gram.c" /* yacc.c:1646  */
    break;

  case 474:
#line 3558 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30059 "gram.c" /* yacc.c:1646  */
    break;

  case 475:
#line 3569 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->is_no_inherit = (yyvsp[0].boolean);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *)n;
				}
#line 30075 "gram.c" /* yacc.c:1646  */
    break;

  case 476:
#line 3581 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[-1]);
					n->raw_expr = (yyvsp[0].node);
					n->cooked_expr = NULL;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *)n;
				}
#line 30090 "gram.c" /* yacc.c:1646  */
    break;

  case 477:
#line 3592 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_IDENTITY;
					n->generated_when = (yyvsp[-3].ival);
					n->options = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *)n;
				}
#line 30103 "gram.c" /* yacc.c:1646  */
    break;

  case 478:
#line 3601 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_GENERATED;
					n->generated_when = (yyvsp[-5].ival);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->location = (yylsp[-6]);

					/*
					 * Can't do this in the grammar because of shift/reduce
					 * conflicts.  (IDENTITY allows both ALWAYS and BY
					 * DEFAULT, but generated columns only allow ALWAYS.)  We
					 * can also give a more useful error message and location.
					 */
					if ((yyvsp[-5].ival) != ATTRIBUTE_IDENTITY_ALWAYS)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("for a generated column, GENERATED ALWAYS must be specified"),
								 parser_errposition((yylsp[-5]))));

					(yyval.node) = (Node *)n;
				}
#line 30130 "gram.c" /* yacc.c:1646  */
    break;

  case 479:
#line 3624 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-4]);
					n->pktable			= (yyvsp[-3].range);
					n->fk_attrs			= NIL;
					n->pk_attrs			= (yyvsp[-2].list);
					n->fk_matchtype		= (yyvsp[-1].ival);
					n->fk_upd_action	= (char) ((yyvsp[0].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[0].ival) & 0xFF);
					n->skip_validation  = false;
					n->initially_valid  = true;
					(yyval.node) = (Node *)n;
				}
#line 30149 "gram.c" /* yacc.c:1646  */
    break;

  case 480:
#line 3641 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ATTRIBUTE_IDENTITY_ALWAYS; }
#line 30155 "gram.c" /* yacc.c:1646  */
    break;

  case 481:
#line 3642 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ATTRIBUTE_IDENTITY_BY_DEFAULT; }
#line 30161 "gram.c" /* yacc.c:1646  */
    break;

  case 482:
#line 3662 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 30172 "gram.c" /* yacc.c:1646  */
    break;

  case 483:
#line 3669 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 30183 "gram.c" /* yacc.c:1646  */
    break;

  case 484:
#line 3676 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 30194 "gram.c" /* yacc.c:1646  */
    break;

  case 485:
#line 3683 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 30205 "gram.c" /* yacc.c:1646  */
    break;

  case 486:
#line 3694 "gram.y" /* yacc.c:1646  */
    {
					TableLikeClause *n = makeNode(TableLikeClause);
					n->relation = (yyvsp[-1].range);
					n->options = (yyvsp[0].ival);
					(yyval.node) = (Node *)n;
				}
#line 30216 "gram.c" /* yacc.c:1646  */
    break;

  case 487:
#line 3703 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 30222 "gram.c" /* yacc.c:1646  */
    break;

  case 488:
#line 3704 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) & ~(yyvsp[0].ival); }
#line 30228 "gram.c" /* yacc.c:1646  */
    break;

  case 489:
#line 3705 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 30234 "gram.c" /* yacc.c:1646  */
    break;

  case 490:
#line 3709 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; }
#line 30240 "gram.c" /* yacc.c:1646  */
    break;

  case 491:
#line 3710 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; }
#line 30246 "gram.c" /* yacc.c:1646  */
    break;

  case 492:
#line 3711 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; }
#line 30252 "gram.c" /* yacc.c:1646  */
    break;

  case 493:
#line 3712 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_IDENTITY; }
#line 30258 "gram.c" /* yacc.c:1646  */
    break;

  case 494:
#line 3713 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_GENERATED; }
#line 30264 "gram.c" /* yacc.c:1646  */
    break;

  case 495:
#line 3714 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; }
#line 30270 "gram.c" /* yacc.c:1646  */
    break;

  case 496:
#line 3715 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_STATISTICS; }
#line 30276 "gram.c" /* yacc.c:1646  */
    break;

  case 497:
#line 3716 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; }
#line 30282 "gram.c" /* yacc.c:1646  */
    break;

  case 498:
#line 3717 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_ALL; }
#line 30288 "gram.c" /* yacc.c:1646  */
    break;

  case 499:
#line 3727 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));
					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 30299 "gram.c" /* yacc.c:1646  */
    break;

  case 500:
#line 3733 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 30305 "gram.c" /* yacc.c:1646  */
    break;

  case 501:
#line 3738 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
#line 30322 "gram.c" /* yacc.c:1646  */
    break;

  case 502:
#line 3752 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-7]);
					n->keys = (yyvsp[-5].list);
					n->including = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 30341 "gram.c" /* yacc.c:1646  */
    break;

  case 503:
#line 3767 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NIL;
					n->including = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 30360 "gram.c" /* yacc.c:1646  */
    break;

  case 504:
#line 3783 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-8]);
					n->keys = (yyvsp[-5].list);
					n->including = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 30379 "gram.c" /* yacc.c:1646  */
    break;

  case 505:
#line 3798 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NIL;
					n->including = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 30398 "gram.c" /* yacc.c:1646  */
    break;

  case 506:
#line 3815 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[-9]);
					n->access_method	= (yyvsp[-8].str);
					n->exclusions		= (yyvsp[-6].list);
					n->including		= (yyvsp[-4].list);
					n->options			= (yyvsp[-3].list);
					n->indexname		= NULL;
					n->indexspace		= (yyvsp[-2].str);
					n->where_clause		= (yyvsp[-1].node);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "EXCLUDE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 30419 "gram.c" /* yacc.c:1646  */
    break;

  case 507:
#line 3833 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-10]);
					n->pktable			= (yyvsp[-4].range);
					n->fk_attrs			= (yyvsp[-7].list);
					n->pk_attrs			= (yyvsp[-3].list);
					n->fk_matchtype		= (yyvsp[-2].ival);
					n->fk_upd_action	= (char) ((yyvsp[-1].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[-1].ival) & 0xFF);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "FOREIGN KEY",
								   &n->deferrable, &n->initdeferred,
								   &n->skip_validation, NULL,
								   yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
#line 30441 "gram.c" /* yacc.c:1646  */
    break;

  case 508:
#line 3852 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = true; }
#line 30447 "gram.c" /* yacc.c:1646  */
    break;

  case 509:
#line 3853 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = false; }
#line 30453 "gram.c" /* yacc.c:1646  */
    break;

  case 510:
#line 3857 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 30459 "gram.c" /* yacc.c:1646  */
    break;

  case 511:
#line 3858 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30465 "gram.c" /* yacc.c:1646  */
    break;

  case 512:
#line 3862 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 30471 "gram.c" /* yacc.c:1646  */
    break;

  case 513:
#line 3863 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 30477 "gram.c" /* yacc.c:1646  */
    break;

  case 514:
#line 3867 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 30485 "gram.c" /* yacc.c:1646  */
    break;

  case 515:
#line 3872 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 30491 "gram.c" /* yacc.c:1646  */
    break;

  case 516:
#line 3873 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30497 "gram.c" /* yacc.c:1646  */
    break;

  case 517:
#line 3877 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
#line 30505 "gram.c" /* yacc.c:1646  */
    break;

  case 518:
#line 3881 "gram.y" /* yacc.c:1646  */
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[-1]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
#line 30517 "gram.c" /* yacc.c:1646  */
    break;

  case 519:
#line 3889 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 30525 "gram.c" /* yacc.c:1646  */
    break;

  case 520:
#line 3893 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 30533 "gram.c" /* yacc.c:1646  */
    break;

  case 521:
#line 3899 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 30539 "gram.c" /* yacc.c:1646  */
    break;

  case 522:
#line 3901 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 30545 "gram.c" /* yacc.c:1646  */
    break;

  case 523:
#line 3905 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-2].ielem), (yyvsp[0].list));
			}
#line 30553 "gram.c" /* yacc.c:1646  */
    break;

  case 524:
#line 3910 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-5].ielem), (yyvsp[-1].list));
			}
#line 30561 "gram.c" /* yacc.c:1646  */
    break;

  case 525:
#line 3916 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 30567 "gram.c" /* yacc.c:1646  */
    break;

  case 526:
#line 3917 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 30573 "gram.c" /* yacc.c:1646  */
    break;

  case 527:
#line 3928 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[0].ival) << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
#line 30579 "gram.c" /* yacc.c:1646  */
    break;

  case 528:
#line 3930 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | ((yyvsp[0].ival) & 0xFF); }
#line 30585 "gram.c" /* yacc.c:1646  */
    break;

  case 529:
#line 3932 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[-1].ival) << 8) | ((yyvsp[0].ival) & 0xFF); }
#line 30591 "gram.c" /* yacc.c:1646  */
    break;

  case 530:
#line 3934 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[0].ival) << 8) | ((yyvsp[-1].ival) & 0xFF); }
#line 30597 "gram.c" /* yacc.c:1646  */
    break;

  case 531:
#line 3936 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
#line 30603 "gram.c" /* yacc.c:1646  */
    break;

  case 532:
#line 3939 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 30609 "gram.c" /* yacc.c:1646  */
    break;

  case 533:
#line 3942 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 30615 "gram.c" /* yacc.c:1646  */
    break;

  case 534:
#line 3946 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_NOACTION; }
#line 30621 "gram.c" /* yacc.c:1646  */
    break;

  case 535:
#line 3947 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_RESTRICT; }
#line 30627 "gram.c" /* yacc.c:1646  */
    break;

  case 536:
#line 3948 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_CASCADE; }
#line 30633 "gram.c" /* yacc.c:1646  */
    break;

  case 537:
#line 3949 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_SETNULL; }
#line 30639 "gram.c" /* yacc.c:1646  */
    break;

  case 538:
#line 3950 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_SETDEFAULT; }
#line 30645 "gram.c" /* yacc.c:1646  */
    break;

  case 539:
#line 3953 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 30651 "gram.c" /* yacc.c:1646  */
    break;

  case 540:
#line 3954 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30657 "gram.c" /* yacc.c:1646  */
    break;

  case 541:
#line 3958 "gram.y" /* yacc.c:1646  */
    { (yyval.partspec) = (yyvsp[0].partspec); }
#line 30663 "gram.c" /* yacc.c:1646  */
    break;

  case 542:
#line 3959 "gram.y" /* yacc.c:1646  */
    { (yyval.partspec) = NULL; }
#line 30669 "gram.c" /* yacc.c:1646  */
    break;

  case 543:
#line 3963 "gram.y" /* yacc.c:1646  */
    {
					PartitionSpec *n = makeNode(PartitionSpec);

					n->strategy = (yyvsp[-3].str);
					n->partParams = (yyvsp[-1].list);
					n->location = (yylsp[-5]);

					(yyval.partspec) = n;
				}
#line 30683 "gram.c" /* yacc.c:1646  */
    break;

  case 544:
#line 3974 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].partelem)); }
#line 30689 "gram.c" /* yacc.c:1646  */
    break;

  case 545:
#line 3975 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].partelem)); }
#line 30695 "gram.c" /* yacc.c:1646  */
    break;

  case 546:
#line 3979 "gram.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = (yyvsp[-2].str);
					n->expr = NULL;
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 30710 "gram.c" /* yacc.c:1646  */
    break;

  case 547:
#line 3990 "gram.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-2].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 30725 "gram.c" /* yacc.c:1646  */
    break;

  case 548:
#line 4001 "gram.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-3].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.partelem) = n;
				}
#line 30740 "gram.c" /* yacc.c:1646  */
    break;

  case 549:
#line 4014 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 30746 "gram.c" /* yacc.c:1646  */
    break;

  case 550:
#line 4015 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 30752 "gram.c" /* yacc.c:1646  */
    break;

  case 551:
#line 4020 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 30758 "gram.c" /* yacc.c:1646  */
    break;

  case 552:
#line 4021 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30764 "gram.c" /* yacc.c:1646  */
    break;

  case 553:
#line 4022 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30770 "gram.c" /* yacc.c:1646  */
    break;

  case 554:
#line 4025 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DROP; }
#line 30776 "gram.c" /* yacc.c:1646  */
    break;

  case 555:
#line 4026 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
#line 30782 "gram.c" /* yacc.c:1646  */
    break;

  case 556:
#line 4027 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
#line 30788 "gram.c" /* yacc.c:1646  */
    break;

  case 557:
#line 4028 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_NOOP; }
#line 30794 "gram.c" /* yacc.c:1646  */
    break;

  case 558:
#line 4031 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 30800 "gram.c" /* yacc.c:1646  */
    break;

  case 559:
#line 4032 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 30806 "gram.c" /* yacc.c:1646  */
    break;

  case 560:
#line 4035 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 30812 "gram.c" /* yacc.c:1646  */
    break;

  case 561:
#line 4036 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 30818 "gram.c" /* yacc.c:1646  */
    break;

  case 562:
#line 4039 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 30824 "gram.c" /* yacc.c:1646  */
    break;

  case 563:
#line 4059 "gram.y" /* yacc.c:1646  */
    {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);
					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->stxcomment = NULL;
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 30839 "gram.c" /* yacc.c:1646  */
    break;

  case 564:
#line 4071 "gram.y" /* yacc.c:1646  */
    {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);
					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->stxcomment = NULL;
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 30854 "gram.c" /* yacc.c:1646  */
    break;

  case 565:
#line 4094 "gram.y" /* yacc.c:1646  */
    {
					AlterStatsStmt *n = makeNode(AlterStatsStmt);
					n->defnames = (yyvsp[-3].list);
					n->missing_ok = false;
					n->stxstattarget = (yyvsp[0].ival);
					(yyval.node) = (Node *)n;
				}
#line 30866 "gram.c" /* yacc.c:1646  */
    break;

  case 566:
#line 4102 "gram.y" /* yacc.c:1646  */
    {
					AlterStatsStmt *n = makeNode(AlterStatsStmt);
					n->defnames = (yyvsp[-3].list);
					n->missing_ok = true;
					n->stxstattarget = (yyvsp[0].ival);
					(yyval.node) = (Node *)n;
				}
#line 30878 "gram.c" /* yacc.c:1646  */
    break;

  case 567:
#line 4123 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-5].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 30895 "gram.c" /* yacc.c:1646  */
    break;

  case 568:
#line 4136 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-8].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 30912 "gram.c" /* yacc.c:1646  */
    break;

  case 569:
#line 4153 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-5].range);
					(yyval.into)->colNames = (yyvsp[-4].list);
					(yyval.into)->accessMethod = (yyvsp[-3].str);
					(yyval.into)->options = (yyvsp[-2].list);
					(yyval.into)->onCommit = (yyvsp[-1].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 30928 "gram.c" /* yacc.c:1646  */
    break;

  case 570:
#line 4167 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 30934 "gram.c" /* yacc.c:1646  */
    break;

  case 571:
#line 4168 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 30940 "gram.c" /* yacc.c:1646  */
    break;

  case 572:
#line 4169 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 30946 "gram.c" /* yacc.c:1646  */
    break;

  case 573:
#line 4182 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->relkind = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-6].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 30963 "gram.c" /* yacc.c:1646  */
    break;

  case 574:
#line 4195 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->relkind = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-9].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 30980 "gram.c" /* yacc.c:1646  */
    break;

  case 575:
#line 4211 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-4].range);
					(yyval.into)->colNames = (yyvsp[-3].list);
					(yyval.into)->accessMethod = (yyvsp[-2].str);
					(yyval.into)->options = (yyvsp[-1].list);
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;		/* filled at analysis time */
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 30996 "gram.c" /* yacc.c:1646  */
    break;

  case 576:
#line 4224 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 31002 "gram.c" /* yacc.c:1646  */
    break;

  case 577:
#line 4225 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 31008 "gram.c" /* yacc.c:1646  */
    break;

  case 578:
#line 4238 "gram.y" /* yacc.c:1646  */
    {
					RefreshMatViewStmt *n = makeNode(RefreshMatViewStmt);
					n->concurrent = (yyvsp[-2].boolean);
					n->relation = (yyvsp[-1].range);
					n->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) n;
				}
#line 31020 "gram.c" /* yacc.c:1646  */
    break;

  case 579:
#line 4258 "gram.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[-1].range)->relpersistence = (yyvsp[-3].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 31034 "gram.c" /* yacc.c:1646  */
    break;

  case 580:
#line 4268 "gram.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[-1].range)->relpersistence = (yyvsp[-6].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 31048 "gram.c" /* yacc.c:1646  */
    break;

  case 581:
#line 4281 "gram.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 31060 "gram.c" /* yacc.c:1646  */
    break;

  case 582:
#line 4289 "gram.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 31072 "gram.c" /* yacc.c:1646  */
    break;

  case 583:
#line 4299 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31078 "gram.c" /* yacc.c:1646  */
    break;

  case 584:
#line 4300 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31084 "gram.c" /* yacc.c:1646  */
    break;

  case 585:
#line 4303 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31090 "gram.c" /* yacc.c:1646  */
    break;

  case 586:
#line 4304 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31096 "gram.c" /* yacc.c:1646  */
    break;

  case 587:
#line 4307 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 31102 "gram.c" /* yacc.c:1646  */
    break;

  case 588:
#line 4308 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 31108 "gram.c" /* yacc.c:1646  */
    break;

  case 589:
#line 4312 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[0].typnam), (yylsp[-1]));
				}
#line 31116 "gram.c" /* yacc.c:1646  */
    break;

  case 590:
#line 4316 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cache", (Node *)(yyvsp[0].value), (yylsp[-1]));
				}
#line 31124 "gram.c" /* yacc.c:1646  */
    break;

  case 591:
#line 4320 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 31132 "gram.c" /* yacc.c:1646  */
    break;

  case 592:
#line 4324 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(false), (yylsp[-1]));
				}
#line 31140 "gram.c" /* yacc.c:1646  */
    break;

  case 593:
#line 4328 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("increment", (Node *)(yyvsp[0].value), (yylsp[-2]));
				}
#line 31148 "gram.c" /* yacc.c:1646  */
    break;

  case 594:
#line 4332 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *)(yyvsp[0].value), (yylsp[-1]));
				}
#line 31156 "gram.c" /* yacc.c:1646  */
    break;

  case 595:
#line 4336 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *)(yyvsp[0].value), (yylsp[-1]));
				}
#line 31164 "gram.c" /* yacc.c:1646  */
    break;

  case 596:
#line 4340 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL, (yylsp[-1]));
				}
#line 31172 "gram.c" /* yacc.c:1646  */
    break;

  case 597:
#line 4344 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL, (yylsp[-1]));
				}
#line 31180 "gram.c" /* yacc.c:1646  */
    break;

  case 598:
#line 4348 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 31188 "gram.c" /* yacc.c:1646  */
    break;

  case 599:
#line 4352 "gram.y" /* yacc.c:1646  */
    {
					/* not documented, only used by pg_dump */
					(yyval.defelt) = makeDefElem("sequence_name", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 31197 "gram.c" /* yacc.c:1646  */
    break;

  case 600:
#line 4357 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("start", (Node *)(yyvsp[0].value), (yylsp[-2]));
				}
#line 31205 "gram.c" /* yacc.c:1646  */
    break;

  case 601:
#line 4361 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 31213 "gram.c" /* yacc.c:1646  */
    break;

  case 602:
#line 4365 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[0].value), (yylsp[-2]));
				}
#line 31221 "gram.c" /* yacc.c:1646  */
    break;

  case 603:
#line 4370 "gram.y" /* yacc.c:1646  */
    {}
#line 31227 "gram.c" /* yacc.c:1646  */
    break;

  case 604:
#line 4371 "gram.y" /* yacc.c:1646  */
    {}
#line 31233 "gram.c" /* yacc.c:1646  */
    break;

  case 605:
#line 4375 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeFloat((yyvsp[0].str)); }
#line 31239 "gram.c" /* yacc.c:1646  */
    break;

  case 606:
#line 4376 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeFloat((yyvsp[0].str)); }
#line 31245 "gram.c" /* yacc.c:1646  */
    break;

  case 607:
#line 4378 "gram.y" /* yacc.c:1646  */
    {
					(yyval.value) = makeFloat((yyvsp[0].str));
					doNegateFloat((yyval.value));
				}
#line 31254 "gram.c" /* yacc.c:1646  */
    break;

  case 608:
#line 4382 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeInteger((yyvsp[0].ival)); }
#line 31260 "gram.c" /* yacc.c:1646  */
    break;

  case 609:
#line 4385 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].value)); }
#line 31266 "gram.c" /* yacc.c:1646  */
    break;

  case 610:
#line 4386 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value)); }
#line 31272 "gram.c" /* yacc.c:1646  */
    break;

  case 611:
#line 4399 "gram.y" /* yacc.c:1646  */
    {
				/*
				 * We now interpret parameterless CREATE LANGUAGE as
				 * CREATE EXTENSION.  "OR REPLACE" is silently translated
				 * to "IF NOT EXISTS", which isn't quite the same, but
				 * seems more useful than throwing an error.  We just
				 * ignore TRUSTED, as the previous code would have too.
				 */
				CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
				n->if_not_exists = (yyvsp[-4].boolean);
				n->extname = (yyvsp[0].str);
				n->options = NIL;
				(yyval.node) = (Node *)n;
			}
#line 31291 "gram.c" /* yacc.c:1646  */
    break;

  case 612:
#line 4415 "gram.y" /* yacc.c:1646  */
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[-8].boolean);
				n->plname = (yyvsp[-4].str);
				n->plhandler = (yyvsp[-2].list);
				n->plinline = (yyvsp[-1].list);
				n->plvalidator = (yyvsp[0].list);
				n->pltrusted = (yyvsp[-7].boolean);
				(yyval.node) = (Node *)n;
			}
#line 31306 "gram.c" /* yacc.c:1646  */
    break;

  case 613:
#line 4428 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 31312 "gram.c" /* yacc.c:1646  */
    break;

  case 614:
#line 4429 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 31318 "gram.c" /* yacc.c:1646  */
    break;

  case 615:
#line 4437 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 31324 "gram.c" /* yacc.c:1646  */
    break;

  case 616:
#line 4438 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 31330 "gram.c" /* yacc.c:1646  */
    break;

  case 617:
#line 4442 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31336 "gram.c" /* yacc.c:1646  */
    break;

  case 618:
#line 4443 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31342 "gram.c" /* yacc.c:1646  */
    break;

  case 619:
#line 4447 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31348 "gram.c" /* yacc.c:1646  */
    break;

  case 620:
#line 4448 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31354 "gram.c" /* yacc.c:1646  */
    break;

  case 621:
#line 4452 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31360 "gram.c" /* yacc.c:1646  */
    break;

  case 622:
#line 4453 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31366 "gram.c" /* yacc.c:1646  */
    break;

  case 623:
#line 4458 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(makeString((yyvsp[-1].str)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 31380 "gram.c" /* yacc.c:1646  */
    break;

  case 624:
#line 4468 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(makeString((yyvsp[-1].str)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 31394 "gram.c" /* yacc.c:1646  */
    break;

  case 625:
#line 4480 "gram.y" /* yacc.c:1646  */
    {}
#line 31400 "gram.c" /* yacc.c:1646  */
    break;

  case 626:
#line 4481 "gram.y" /* yacc.c:1646  */
    {}
#line 31406 "gram.c" /* yacc.c:1646  */
    break;

  case 627:
#line 4492 "gram.y" /* yacc.c:1646  */
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);
					n->tablespacename = (yyvsp[-4].str);
					n->owner = (yyvsp[-3].rolespec);
					n->location = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31419 "gram.c" /* yacc.c:1646  */
    break;

  case 628:
#line 4502 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 31425 "gram.c" /* yacc.c:1646  */
    break;

  case 629:
#line 4503 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = NULL; }
#line 31431 "gram.c" /* yacc.c:1646  */
    break;

  case 630:
#line 4517 "gram.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31442 "gram.c" /* yacc.c:1646  */
    break;

  case 631:
#line 4524 "gram.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31453 "gram.c" /* yacc.c:1646  */
    break;

  case 632:
#line 4541 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = false;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31465 "gram.c" /* yacc.c:1646  */
    break;

  case 633:
#line 4549 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = true;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31477 "gram.c" /* yacc.c:1646  */
    break;

  case 634:
#line 4560 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 31483 "gram.c" /* yacc.c:1646  */
    break;

  case 635:
#line 4562 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31489 "gram.c" /* yacc.c:1646  */
    break;

  case 636:
#line 4567 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schema", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 31497 "gram.c" /* yacc.c:1646  */
    break;

  case 637:
#line 4571 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 31505 "gram.c" /* yacc.c:1646  */
    break;

  case 638:
#line 4575 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE EXTENSION ... FROM is no longer supported"),
							 parser_errposition((yylsp[-1]))));
				}
#line 31516 "gram.c" /* yacc.c:1646  */
    break;

  case 639:
#line 4582 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cascade", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 31524 "gram.c" /* yacc.c:1646  */
    break;

  case 640:
#line 4594 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionStmt *n = makeNode(AlterExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31535 "gram.c" /* yacc.c:1646  */
    break;

  case 641:
#line 4604 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 31541 "gram.c" /* yacc.c:1646  */
    break;

  case 642:
#line 4606 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31547 "gram.c" /* yacc.c:1646  */
    break;

  case 643:
#line 4611 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 31555 "gram.c" /* yacc.c:1646  */
    break;

  case 644:
#line 4624 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_ACCESS_METHOD;
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 31568 "gram.c" /* yacc.c:1646  */
    break;

  case 645:
#line 4633 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *)n;
				}
#line 31581 "gram.c" /* yacc.c:1646  */
    break;

  case 646:
#line 4642 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-7].str);
					n->action = (yyvsp[-6].ival);
					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam));
					(yyval.node) = (Node *) n;
				}
#line 31594 "gram.c" /* yacc.c:1646  */
    break;

  case 647:
#line 4651 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31607 "gram.c" /* yacc.c:1646  */
    break;

  case 648:
#line 4660 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31620 "gram.c" /* yacc.c:1646  */
    break;

  case 649:
#line 4669 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *)n;
				}
#line 31633 "gram.c" /* yacc.c:1646  */
    break;

  case 650:
#line 4678 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *)n;
				}
#line 31646 "gram.c" /* yacc.c:1646  */
    break;

  case 651:
#line 4687 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 31659 "gram.c" /* yacc.c:1646  */
    break;

  case 652:
#line 4696 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *)n;
				}
#line 31672 "gram.c" /* yacc.c:1646  */
    break;

  case 653:
#line 4705 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *)n;
				}
#line 31685 "gram.c" /* yacc.c:1646  */
    break;

  case 654:
#line 4714 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *)n;
				}
#line 31698 "gram.c" /* yacc.c:1646  */
    break;

  case 655:
#line 4723 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *)n;
				}
#line 31711 "gram.c" /* yacc.c:1646  */
    break;

  case 656:
#line 4732 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *)n;
				}
#line 31724 "gram.c" /* yacc.c:1646  */
    break;

  case 657:
#line 4741 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_SCHEMA;
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 31737 "gram.c" /* yacc.c:1646  */
    break;

  case 658:
#line 4750 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 31750 "gram.c" /* yacc.c:1646  */
    break;

  case 659:
#line 4759 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TABLE;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31763 "gram.c" /* yacc.c:1646  */
    break;

  case 660:
#line 4768 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31776 "gram.c" /* yacc.c:1646  */
    break;

  case 661:
#line 4777 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31789 "gram.c" /* yacc.c:1646  */
    break;

  case 662:
#line 4786 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31802 "gram.c" /* yacc.c:1646  */
    break;

  case 663:
#line 4795 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31815 "gram.c" /* yacc.c:1646  */
    break;

  case 664:
#line 4804 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_SEQUENCE;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31828 "gram.c" /* yacc.c:1646  */
    break;

  case 665:
#line 4813 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_VIEW;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31841 "gram.c" /* yacc.c:1646  */
    break;

  case 666:
#line 4822 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_MATVIEW;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31854 "gram.c" /* yacc.c:1646  */
    break;

  case 667:
#line 4831 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31867 "gram.c" /* yacc.c:1646  */
    break;

  case 668:
#line 4840 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 31880 "gram.c" /* yacc.c:1646  */
    break;

  case 669:
#line 4849 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 31893 "gram.c" /* yacc.c:1646  */
    break;

  case 670:
#line 4858 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-2].typnam), makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 31906 "gram.c" /* yacc.c:1646  */
    break;

  case 671:
#line 4867 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *)n;
				}
#line 31919 "gram.c" /* yacc.c:1646  */
    break;

  case 672:
#line 4885 "gram.y" /* yacc.c:1646  */
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);
					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31931 "gram.c" /* yacc.c:1646  */
    break;

  case 673:
#line 4895 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", (Node *)(yyvsp[0].list), (yylsp[-1])); }
#line 31937 "gram.c" /* yacc.c:1646  */
    break;

  case 674:
#line 4896 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", NULL, (yylsp[-1])); }
#line 31943 "gram.c" /* yacc.c:1646  */
    break;

  case 675:
#line 4897 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", (Node *)(yyvsp[0].list), (yylsp[-1])); }
#line 31949 "gram.c" /* yacc.c:1646  */
    break;

  case 676:
#line 4898 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", NULL, (yylsp[-1])); }
#line 31955 "gram.c" /* yacc.c:1646  */
    break;

  case 677:
#line 4902 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 31961 "gram.c" /* yacc.c:1646  */
    break;

  case 678:
#line 4903 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 31967 "gram.c" /* yacc.c:1646  */
    break;

  case 679:
#line 4907 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31973 "gram.c" /* yacc.c:1646  */
    break;

  case 680:
#line 4908 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31979 "gram.c" /* yacc.c:1646  */
    break;

  case 681:
#line 4919 "gram.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31991 "gram.c" /* yacc.c:1646  */
    break;

  case 682:
#line 4927 "gram.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[-1].str);
					n->func_options = (yyvsp[0].list);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 32003 "gram.c" /* yacc.c:1646  */
    break;

  case 683:
#line 4938 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 32009 "gram.c" /* yacc.c:1646  */
    break;

  case 684:
#line 4939 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32015 "gram.c" /* yacc.c:1646  */
    break;

  case 685:
#line 4944 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 32023 "gram.c" /* yacc.c:1646  */
    break;

  case 686:
#line 4948 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 32031 "gram.c" /* yacc.c:1646  */
    break;

  case 687:
#line 4955 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 32037 "gram.c" /* yacc.c:1646  */
    break;

  case 688:
#line 4960 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 32045 "gram.c" /* yacc.c:1646  */
    break;

  case 689:
#line 4964 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 32053 "gram.c" /* yacc.c:1646  */
    break;

  case 690:
#line 4971 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 32061 "gram.c" /* yacc.c:1646  */
    break;

  case 691:
#line 4975 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				}
#line 32070 "gram.c" /* yacc.c:1646  */
    break;

  case 692:
#line 4980 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				}
#line 32079 "gram.c" /* yacc.c:1646  */
    break;

  case 693:
#line 4985 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[0].str), NULL, DEFELEM_DROP, (yylsp[0]));
				}
#line 32087 "gram.c" /* yacc.c:1646  */
    break;

  case 694:
#line 4992 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 32095 "gram.c" /* yacc.c:1646  */
    break;

  case 695:
#line 4998 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32101 "gram.c" /* yacc.c:1646  */
    break;

  case 696:
#line 5003 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 32107 "gram.c" /* yacc.c:1646  */
    break;

  case 697:
#line 5015 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 32122 "gram.c" /* yacc.c:1646  */
    break;

  case 698:
#line 5027 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 32137 "gram.c" /* yacc.c:1646  */
    break;

  case 699:
#line 5040 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32143 "gram.c" /* yacc.c:1646  */
    break;

  case 700:
#line 5041 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 32149 "gram.c" /* yacc.c:1646  */
    break;

  case 701:
#line 5046 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32155 "gram.c" /* yacc.c:1646  */
    break;

  case 702:
#line 5047 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 32161 "gram.c" /* yacc.c:1646  */
    break;

  case 703:
#line 5051 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32167 "gram.c" /* yacc.c:1646  */
    break;

  case 704:
#line 5052 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 32173 "gram.c" /* yacc.c:1646  */
    break;

  case 705:
#line 5063 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-2].str);
					n->version = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 32186 "gram.c" /* yacc.c:1646  */
    break;

  case 706:
#line 5072 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-1].str);
					n->version = (yyvsp[0].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 32198 "gram.c" /* yacc.c:1646  */
    break;

  case 707:
#line 5080 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32209 "gram.c" /* yacc.c:1646  */
    break;

  case 708:
#line 5099 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32231 "gram.c" /* yacc.c:1646  */
    break;

  case 709:
#line 5119 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32253 "gram.c" /* yacc.c:1646  */
    break;

  case 710:
#line 5139 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32276 "gram.c" /* yacc.c:1646  */
    break;

  case 711:
#line 5160 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32299 "gram.c" /* yacc.c:1646  */
    break;

  case 712:
#line 5189 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32312 "gram.c" /* yacc.c:1646  */
    break;

  case 713:
#line 5198 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 32325 "gram.c" /* yacc.c:1646  */
    break;

  case 714:
#line 5220 "gram.y" /* yacc.c:1646  */
    {
				ImportForeignSchemaStmt *n = makeNode(ImportForeignSchemaStmt);
				n->server_name = (yyvsp[-3].str);
				n->remote_schema = (yyvsp[-7].str);
				n->local_schema = (yyvsp[-1].str);
				n->list_type = (yyvsp[-6].importqual)->type;
				n->table_list = (yyvsp[-6].importqual)->table_names;
				n->options = (yyvsp[0].list);
				(yyval.node) = (Node *) n;
			}
#line 32340 "gram.c" /* yacc.c:1646  */
    break;

  case 715:
#line 5233 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FDW_IMPORT_SCHEMA_LIMIT_TO; }
#line 32346 "gram.c" /* yacc.c:1646  */
    break;

  case 716:
#line 5234 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FDW_IMPORT_SCHEMA_EXCEPT; }
#line 32352 "gram.c" /* yacc.c:1646  */
    break;

  case 717:
#line 5239 "gram.y" /* yacc.c:1646  */
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));
				n->type = (yyvsp[-3].ival);
				n->table_names = (yyvsp[-1].list);
				(yyval.importqual) = n;
			}
#line 32363 "gram.c" /* yacc.c:1646  */
    break;

  case 718:
#line 5246 "gram.y" /* yacc.c:1646  */
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));
				n->type = FDW_IMPORT_SCHEMA_ALL;
				n->table_names = NIL;
				(yyval.importqual) = n;
			}
#line 32374 "gram.c" /* yacc.c:1646  */
    break;

  case 719:
#line 5262 "gram.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 32387 "gram.c" /* yacc.c:1646  */
    break;

  case 720:
#line 5271 "gram.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 32400 "gram.c" /* yacc.c:1646  */
    break;

  case 721:
#line 5282 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 32406 "gram.c" /* yacc.c:1646  */
    break;

  case 722:
#line 5283 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0])); }
#line 32412 "gram.c" /* yacc.c:1646  */
    break;

  case 723:
#line 5296 "gram.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32424 "gram.c" /* yacc.c:1646  */
    break;

  case 724:
#line 5304 "gram.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32436 "gram.c" /* yacc.c:1646  */
    break;

  case 725:
#line 5321 "gram.y" /* yacc.c:1646  */
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);
					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32448 "gram.c" /* yacc.c:1646  */
    break;

  case 726:
#line 5347 "gram.y" /* yacc.c:1646  */
    {
					CreatePolicyStmt *n = makeNode(CreatePolicyStmt);
					n->policy_name = (yyvsp[-7].str);
					n->table = (yyvsp[-5].range);
					n->permissive = (yyvsp[-4].boolean);
					n->cmd_name = (yyvsp[-3].str);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 32464 "gram.c" /* yacc.c:1646  */
    break;

  case 727:
#line 5363 "gram.y" /* yacc.c:1646  */
    {
					AlterPolicyStmt *n = makeNode(AlterPolicyStmt);
					n->policy_name = (yyvsp[-5].str);
					n->table = (yyvsp[-3].range);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 32478 "gram.c" /* yacc.c:1646  */
    break;

  case 728:
#line 5375 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 32484 "gram.c" /* yacc.c:1646  */
    break;

  case 729:
#line 5376 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 32490 "gram.c" /* yacc.c:1646  */
    break;

  case 730:
#line 5380 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 32496 "gram.c" /* yacc.c:1646  */
    break;

  case 731:
#line 5381 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 32502 "gram.c" /* yacc.c:1646  */
    break;

  case 732:
#line 5385 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32508 "gram.c" /* yacc.c:1646  */
    break;

  case 733:
#line 5386 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeRoleSpec(ROLESPEC_PUBLIC, -1)); }
#line 32514 "gram.c" /* yacc.c:1646  */
    break;

  case 734:
#line 5390 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32520 "gram.c" /* yacc.c:1646  */
    break;

  case 735:
#line 5391 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NULL; }
#line 32526 "gram.c" /* yacc.c:1646  */
    break;

  case 736:
#line 5396 "gram.y" /* yacc.c:1646  */
    {
					if (strcmp((yyvsp[0].str), "permissive") == 0)
						(yyval.boolean) = true;
					else if (strcmp((yyvsp[0].str), "restrictive") == 0)
						(yyval.boolean) = false;
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("unrecognized row security option \"%s\"", (yyvsp[0].str)),
								 errhint("Only PERMISSIVE or RESTRICTIVE policies are supported currently."),
									 parser_errposition((yylsp[0]))));

				}
#line 32544 "gram.c" /* yacc.c:1646  */
    break;

  case 737:
#line 5409 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 32550 "gram.c" /* yacc.c:1646  */
    break;

  case 738:
#line 5413 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32556 "gram.c" /* yacc.c:1646  */
    break;

  case 739:
#line 5414 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "all"; }
#line 32562 "gram.c" /* yacc.c:1646  */
    break;

  case 740:
#line 5418 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "all"; }
#line 32568 "gram.c" /* yacc.c:1646  */
    break;

  case 741:
#line 5419 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "select"; }
#line 32574 "gram.c" /* yacc.c:1646  */
    break;

  case 742:
#line 5420 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "insert"; }
#line 32580 "gram.c" /* yacc.c:1646  */
    break;

  case 743:
#line 5421 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "update"; }
#line 32586 "gram.c" /* yacc.c:1646  */
    break;

  case 744:
#line 5422 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "delete"; }
#line 32592 "gram.c" /* yacc.c:1646  */
    break;

  case 745:
#line 5433 "gram.y" /* yacc.c:1646  */
    {
					CreateAmStmt *n = makeNode(CreateAmStmt);
					n->amname = (yyvsp[-4].str);
					n->handler_name = (yyvsp[0].list);
					n->amtype = (yyvsp[-2].chr);
					(yyval.node) = (Node *) n;
				}
#line 32604 "gram.c" /* yacc.c:1646  */
    break;

  case 746:
#line 5443 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = AMTYPE_INDEX; }
#line 32610 "gram.c" /* yacc.c:1646  */
    break;

  case 747:
#line 5444 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = AMTYPE_TABLE; }
#line 32616 "gram.c" /* yacc.c:1646  */
    break;

  case 748:
#line 5458 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-13].str);
					n->relation = (yyvsp[-9].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = (yyvsp[-7].boolean);
					n->timing = (yyvsp[-12].ival);
					n->events = intVal(linitial((yyvsp[-11].list)));
					n->columns = (List *) lsecond((yyvsp[-11].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = (yyvsp[-8].list);
					n->isconstraint  = false;
					n->deferrable	 = false;
					n->initdeferred  = false;
					n->constrrel = NULL;
					(yyval.node) = (Node *)n;
				}
#line 32639 "gram.c" /* yacc.c:1646  */
    break;

  case 749:
#line 5480 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-16].str);
					n->relation = (yyvsp[-12].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = true;
					n->timing = TRIGGER_TYPE_AFTER;
					n->events = intVal(linitial((yyvsp[-14].list)));
					n->columns = (List *) lsecond((yyvsp[-14].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = NIL;
					n->isconstraint  = true;
					processCASbits((yyvsp[-10].ival), (yylsp[-10]), "TRIGGER",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					n->constrrel = (yyvsp[-11].range);
					(yyval.node) = (Node *)n;
				}
#line 32663 "gram.c" /* yacc.c:1646  */
    break;

  case 750:
#line 5502 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_BEFORE; }
#line 32669 "gram.c" /* yacc.c:1646  */
    break;

  case 751:
#line 5503 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_AFTER; }
#line 32675 "gram.c" /* yacc.c:1646  */
    break;

  case 752:
#line 5504 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_INSTEAD; }
#line 32681 "gram.c" /* yacc.c:1646  */
    break;

  case 753:
#line 5509 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32687 "gram.c" /* yacc.c:1646  */
    break;

  case 754:
#line 5511 "gram.y" /* yacc.c:1646  */
    {
					int		events1 = intVal(linitial((yyvsp[-2].list)));
					int		events2 = intVal(linitial((yyvsp[0].list)));
					List   *columns1 = (List *) lsecond((yyvsp[-2].list));
					List   *columns2 = (List *) lsecond((yyvsp[0].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				}
#line 32710 "gram.c" /* yacc.c:1646  */
    break;

  case 755:
#line 5533 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); }
#line 32716 "gram.c" /* yacc.c:1646  */
    break;

  case 756:
#line 5535 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); }
#line 32722 "gram.c" /* yacc.c:1646  */
    break;

  case 757:
#line 5537 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); }
#line 32728 "gram.c" /* yacc.c:1646  */
    break;

  case 758:
#line 5539 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[0].list)); }
#line 32734 "gram.c" /* yacc.c:1646  */
    break;

  case 759:
#line 5541 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); }
#line 32740 "gram.c" /* yacc.c:1646  */
    break;

  case 760:
#line 5545 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32746 "gram.c" /* yacc.c:1646  */
    break;

  case 761:
#line 5546 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32752 "gram.c" /* yacc.c:1646  */
    break;

  case 762:
#line 5550 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 32758 "gram.c" /* yacc.c:1646  */
    break;

  case 763:
#line 5551 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 32764 "gram.c" /* yacc.c:1646  */
    break;

  case 764:
#line 5556 "gram.y" /* yacc.c:1646  */
    {
					TriggerTransition *n = makeNode(TriggerTransition);
					n->name = (yyvsp[0].str);
					n->isNew = (yyvsp[-3].boolean);
					n->isTable = (yyvsp[-2].boolean);
					(yyval.node) = (Node *)n;
				}
#line 32776 "gram.c" /* yacc.c:1646  */
    break;

  case 765:
#line 5566 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 32782 "gram.c" /* yacc.c:1646  */
    break;

  case 766:
#line 5567 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 32788 "gram.c" /* yacc.c:1646  */
    break;

  case 767:
#line 5571 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 32794 "gram.c" /* yacc.c:1646  */
    break;

  case 768:
#line 5580 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 32800 "gram.c" /* yacc.c:1646  */
    break;

  case 769:
#line 5584 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32806 "gram.c" /* yacc.c:1646  */
    break;

  case 770:
#line 5589 "gram.y" /* yacc.c:1646  */
    {
					(yyval.boolean) = (yyvsp[0].boolean);
				}
#line 32814 "gram.c" /* yacc.c:1646  */
    break;

  case 771:
#line 5593 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = false;
				}
#line 32826 "gram.c" /* yacc.c:1646  */
    break;

  case 772:
#line 5603 "gram.y" /* yacc.c:1646  */
    {}
#line 32832 "gram.c" /* yacc.c:1646  */
    break;

  case 773:
#line 5604 "gram.y" /* yacc.c:1646  */
    {}
#line 32838 "gram.c" /* yacc.c:1646  */
    break;

  case 774:
#line 5608 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 32844 "gram.c" /* yacc.c:1646  */
    break;

  case 775:
#line 5609 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 32850 "gram.c" /* yacc.c:1646  */
    break;

  case 776:
#line 5613 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 32856 "gram.c" /* yacc.c:1646  */
    break;

  case 777:
#line 5614 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 32862 "gram.c" /* yacc.c:1646  */
    break;

  case 780:
#line 5623 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].value)); }
#line 32868 "gram.c" /* yacc.c:1646  */
    break;

  case 781:
#line 5624 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value)); }
#line 32874 "gram.c" /* yacc.c:1646  */
    break;

  case 782:
#line 5625 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32880 "gram.c" /* yacc.c:1646  */
    break;

  case 783:
#line 5630 "gram.y" /* yacc.c:1646  */
    {
					(yyval.value) = makeString(psprintf("%d", (yyvsp[0].ival)));
				}
#line 32888 "gram.c" /* yacc.c:1646  */
    break;

  case 784:
#line 5633 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 32894 "gram.c" /* yacc.c:1646  */
    break;

  case 785:
#line 5634 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 32900 "gram.c" /* yacc.c:1646  */
    break;

  case 786:
#line 5635 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 32906 "gram.c" /* yacc.c:1646  */
    break;

  case 787:
#line 5639 "gram.y" /* yacc.c:1646  */
    { (yyval.range) = (yyvsp[0].range); }
#line 32912 "gram.c" /* yacc.c:1646  */
    break;

  case 788:
#line 5640 "gram.y" /* yacc.c:1646  */
    { (yyval.range) = NULL; }
#line 32918 "gram.c" /* yacc.c:1646  */
    break;

  case 789:
#line 5645 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 32924 "gram.c" /* yacc.c:1646  */
    break;

  case 790:
#line 5647 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We must complain about conflicting options.
					 * We could, but choose not to, complain about redundant
					 * options (ie, where $2's bit is already set in $1).
					 */
					int		newspec = (yyvsp[-1].ival) | (yyvsp[0].ival);

					/* special message for this case */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED)) == (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[0]))));
					/* generic message for other conflicts */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE)) == (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE) ||
						(newspec & (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED)) == (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("conflicting constraint properties"),
								 parser_errposition((yylsp[0]))));
					(yyval.ival) = newspec;
				}
#line 32952 "gram.c" /* yacc.c:1646  */
    break;

  case 791:
#line 5673 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_DEFERRABLE; }
#line 32958 "gram.c" /* yacc.c:1646  */
    break;

  case 792:
#line 5674 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_DEFERRABLE; }
#line 32964 "gram.c" /* yacc.c:1646  */
    break;

  case 793:
#line 5675 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_IMMEDIATE; }
#line 32970 "gram.c" /* yacc.c:1646  */
    break;

  case 794:
#line 5676 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_DEFERRED; }
#line 32976 "gram.c" /* yacc.c:1646  */
    break;

  case 795:
#line 5677 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_VALID; }
#line 32982 "gram.c" /* yacc.c:1646  */
    break;

  case 796:
#line 5678 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NO_INHERIT; }
#line 32988 "gram.c" /* yacc.c:1646  */
    break;

  case 797:
#line 5693 "gram.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[-7].str);
					n->eventname = (yyvsp[-5].str);
					n->whenclause = NULL;
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *)n;
				}
#line 33001 "gram.c" /* yacc.c:1646  */
    break;

  case 798:
#line 5704 "gram.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[-9].str);
					n->eventname = (yyvsp[-7].str);
					n->whenclause = (yyvsp[-5].list);
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *)n;
				}
#line 33014 "gram.c" /* yacc.c:1646  */
    break;

  case 799:
#line 5716 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 33020 "gram.c" /* yacc.c:1646  */
    break;

  case 800:
#line 5718 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 33026 "gram.c" /* yacc.c:1646  */
    break;

  case 801:
#line 5723 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-4].str), (Node *) (yyvsp[-1].list), (yylsp[-4])); }
#line 33032 "gram.c" /* yacc.c:1646  */
    break;

  case 802:
#line 5728 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 33038 "gram.c" /* yacc.c:1646  */
    break;

  case 803:
#line 5730 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 33044 "gram.c" /* yacc.c:1646  */
    break;

  case 804:
#line 5735 "gram.y" /* yacc.c:1646  */
    {
					AlterEventTrigStmt *n = makeNode(AlterEventTrigStmt);
					n->trigname = (yyvsp[-1].str);
					n->tgenabled = (yyvsp[0].chr);
					(yyval.node) = (Node *) n;
				}
#line 33055 "gram.c" /* yacc.c:1646  */
    break;

  case 805:
#line 5744 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_ORIGIN; }
#line 33061 "gram.c" /* yacc.c:1646  */
    break;

  case 806:
#line 5745 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_REPLICA; }
#line 33067 "gram.c" /* yacc.c:1646  */
    break;

  case 807:
#line 5746 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ALWAYS; }
#line 33073 "gram.c" /* yacc.c:1646  */
    break;

  case 808:
#line 5747 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_DISABLED; }
#line 33079 "gram.c" /* yacc.c:1646  */
    break;

  case 809:
#line 5759 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = NULL;
				}
#line 33091 "gram.c" /* yacc.c:1646  */
    break;

  case 810:
#line 5778 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->replace = (yyvsp[-4].boolean);
					n->defnames = (yyvsp[-2].list);
					n->args = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33106 "gram.c" /* yacc.c:1646  */
    break;

  case 811:
#line 5789 "gram.y" /* yacc.c:1646  */
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->replace = (yyvsp[-3].boolean);
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33122 "gram.c" /* yacc.c:1646  */
    break;

  case 812:
#line 5801 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33136 "gram.c" /* yacc.c:1646  */
    break;

  case 813:
#line 5811 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33150 "gram.c" /* yacc.c:1646  */
    break;

  case 814:
#line 5821 "gram.y" /* yacc.c:1646  */
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[0].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *)n;
				}
#line 33165 "gram.c" /* yacc.c:1646  */
    break;

  case 815:
#line 5832 "gram.y" /* yacc.c:1646  */
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);

					/* can't use qualified_name, sigh */
					n->typevar = makeRangeVarFromAnyName((yyvsp[-4].list), (yylsp[-4]), yyscanner);
					n->coldeflist = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 33178 "gram.c" /* yacc.c:1646  */
    break;

  case 816:
#line 5841 "gram.y" /* yacc.c:1646  */
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);
					n->typeName = (yyvsp[-5].list);
					n->vals = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 33189 "gram.c" /* yacc.c:1646  */
    break;

  case 817:
#line 5848 "gram.y" /* yacc.c:1646  */
    {
					CreateRangeStmt *n = makeNode(CreateRangeStmt);
					n->typeName = (yyvsp[-3].list);
					n->params	= (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33200 "gram.c" /* yacc.c:1646  */
    break;

  case 818:
#line 5855 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33213 "gram.c" /* yacc.c:1646  */
    break;

  case 819:
#line 5864 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33226 "gram.c" /* yacc.c:1646  */
    break;

  case 820:
#line 5873 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33239 "gram.c" /* yacc.c:1646  */
    break;

  case 821:
#line 5882 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33252 "gram.c" /* yacc.c:1646  */
    break;

  case 822:
#line 5891 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33265 "gram.c" /* yacc.c:1646  */
    break;

  case 823:
#line 5900 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 33279 "gram.c" /* yacc.c:1646  */
    break;

  case 824:
#line 5910 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *)n;
				}
#line 33292 "gram.c" /* yacc.c:1646  */
    break;

  case 825:
#line 5919 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 33306 "gram.c" /* yacc.c:1646  */
    break;

  case 826:
#line 5930 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33312 "gram.c" /* yacc.c:1646  */
    break;

  case 827:
#line 5933 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 33318 "gram.c" /* yacc.c:1646  */
    break;

  case 828:
#line 5934 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 33324 "gram.c" /* yacc.c:1646  */
    break;

  case 829:
#line 5938 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 33332 "gram.c" /* yacc.c:1646  */
    break;

  case 830:
#line 5942 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 33340 "gram.c" /* yacc.c:1646  */
    break;

  case 831:
#line 5948 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].typnam); }
#line 33346 "gram.c" /* yacc.c:1646  */
    break;

  case 832:
#line 5949 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[0].keyword))); }
#line 33352 "gram.c" /* yacc.c:1646  */
    break;

  case 833:
#line 5950 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].list); }
#line 33358 "gram.c" /* yacc.c:1646  */
    break;

  case 834:
#line 5951 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].value); }
#line 33364 "gram.c" /* yacc.c:1646  */
    break;

  case 835:
#line 5952 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString((yyvsp[0].str)); }
#line 33370 "gram.c" /* yacc.c:1646  */
    break;

  case 836:
#line 5953 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[0].keyword))); }
#line 33376 "gram.c" /* yacc.c:1646  */
    break;

  case 837:
#line 5956 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33382 "gram.c" /* yacc.c:1646  */
    break;

  case 838:
#line 5959 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 33388 "gram.c" /* yacc.c:1646  */
    break;

  case 839:
#line 5960 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 33394 "gram.c" /* yacc.c:1646  */
    break;

  case 840:
#line 5969 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)(yyvsp[0].node), (yylsp[-2]));
				}
#line 33402 "gram.c" /* yacc.c:1646  */
    break;

  case 841:
#line 5975 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33408 "gram.c" /* yacc.c:1646  */
    break;

  case 842:
#line 5976 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33414 "gram.c" /* yacc.c:1646  */
    break;

  case 843:
#line 5980 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 33420 "gram.c" /* yacc.c:1646  */
    break;

  case 844:
#line 5982 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 33426 "gram.c" /* yacc.c:1646  */
    break;

  case 845:
#line 5993 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-4].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-1].boolean);
				(yyval.node) = (Node *) n;
			}
#line 33441 "gram.c" /* yacc.c:1646  */
    break;

  case 846:
#line 6004 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = false;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 33456 "gram.c" /* yacc.c:1646  */
    break;

  case 847:
#line 6015 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 33471 "gram.c" /* yacc.c:1646  */
    break;

  case 848:
#line 6026 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-5].list);
				n->oldVal = (yyvsp[-2].str);
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = false;
				n->skipIfNewValExists = false;
				(yyval.node) = (Node *) n;
			}
#line 33486 "gram.c" /* yacc.c:1646  */
    break;

  case 849:
#line 6038 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 33492 "gram.c" /* yacc.c:1646  */
    break;

  case 850:
#line 6039 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 33498 "gram.c" /* yacc.c:1646  */
    break;

  case 851:
#line 6057 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);
					n->opclassname = (yyvsp[-9].list);
					n->isDefault = (yyvsp[-8].boolean);
					n->datatype = (yyvsp[-5].typnam);
					n->amname = (yyvsp[-3].str);
					n->opfamilyname = (yyvsp[-2].list);
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33513 "gram.c" /* yacc.c:1646  */
    break;

  case 852:
#line 6070 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 33519 "gram.c" /* yacc.c:1646  */
    break;

  case 853:
#line 6071 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 33525 "gram.c" /* yacc.c:1646  */
    break;

  case 854:
#line 6076 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					ObjectWithArgs *owa = makeNode(ObjectWithArgs);
					owa->objname = (yyvsp[-2].list);
					owa->objargs = NIL;
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = owa;
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 33541 "gram.c" /* yacc.c:1646  */
    break;

  case 855:
#line 6089 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-2].objwithargs);
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 33554 "gram.c" /* yacc.c:1646  */
    break;

  case 856:
#line 6098 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-1].ival);
					(yyval.node) = (Node *) n;
				}
#line 33566 "gram.c" /* yacc.c:1646  */
    break;

  case 857:
#line 6106 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-4].ival);
					n->class_args = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 33579 "gram.c" /* yacc.c:1646  */
    break;

  case 858:
#line 6115 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 33590 "gram.c" /* yacc.c:1646  */
    break;

  case 859:
#line 6123 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 33596 "gram.c" /* yacc.c:1646  */
    break;

  case 860:
#line 6124 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 33602 "gram.c" /* yacc.c:1646  */
    break;

  case 861:
#line 6127 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33608 "gram.c" /* yacc.c:1646  */
    break;

  case 862:
#line 6128 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33614 "gram.c" /* yacc.c:1646  */
    break;

  case 863:
#line 6131 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33620 "gram.c" /* yacc.c:1646  */
    break;

  case 864:
#line 6132 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33626 "gram.c" /* yacc.c:1646  */
    break;

  case 865:
#line 6133 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33632 "gram.c" /* yacc.c:1646  */
    break;

  case 866:
#line 6137 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[0]))));
					(yyval.boolean) = true;
				}
#line 33650 "gram.c" /* yacc.c:1646  */
    break;

  case 867:
#line 6150 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 33656 "gram.c" /* yacc.c:1646  */
    break;

  case 868:
#line 6156 "gram.y" /* yacc.c:1646  */
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);
					n->opfamilyname = (yyvsp[-2].list);
					n->amname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33667 "gram.c" /* yacc.c:1646  */
    break;

  case 869:
#line 6166 "gram.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = false;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33680 "gram.c" /* yacc.c:1646  */
    break;

  case 870:
#line 6175 "gram.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = true;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33693 "gram.c" /* yacc.c:1646  */
    break;

  case 871:
#line 6186 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 33699 "gram.c" /* yacc.c:1646  */
    break;

  case 872:
#line 6187 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 33705 "gram.c" /* yacc.c:1646  */
    break;

  case 873:
#line 6192 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 33717 "gram.c" /* yacc.c:1646  */
    break;

  case 874:
#line 6200 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 33729 "gram.c" /* yacc.c:1646  */
    break;

  case 875:
#line 6212 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 33743 "gram.c" /* yacc.c:1646  */
    break;

  case 876:
#line 6222 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 33757 "gram.c" /* yacc.c:1646  */
    break;

  case 877:
#line 6235 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 33771 "gram.c" /* yacc.c:1646  */
    break;

  case 878:
#line 6245 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 33785 "gram.c" /* yacc.c:1646  */
    break;

  case 879:
#line 6267 "gram.y" /* yacc.c:1646  */
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);
					n->roles = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 33796 "gram.c" /* yacc.c:1646  */
    break;

  case 880:
#line 6277 "gram.y" /* yacc.c:1646  */
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);
					n->roles = (yyvsp[-2].list);
					n->newrole = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 33807 "gram.c" /* yacc.c:1646  */
    break;

  case 881:
#line 6295 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 33821 "gram.c" /* yacc.c:1646  */
    break;

  case 882:
#line 6305 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 33835 "gram.c" /* yacc.c:1646  */
    break;

  case 883:
#line 6315 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 33849 "gram.c" /* yacc.c:1646  */
    break;

  case 884:
#line 6325 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 33863 "gram.c" /* yacc.c:1646  */
    break;

  case 885:
#line 6335 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-4].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 33877 "gram.c" /* yacc.c:1646  */
    break;

  case 886:
#line 6345 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-6].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 33891 "gram.c" /* yacc.c:1646  */
    break;

  case 887:
#line 6355 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TYPE;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 33905 "gram.c" /* yacc.c:1646  */
    break;

  case 888:
#line 6365 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TYPE;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 33919 "gram.c" /* yacc.c:1646  */
    break;

  case 889:
#line 6375 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 33933 "gram.c" /* yacc.c:1646  */
    break;

  case 890:
#line 6385 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 33947 "gram.c" /* yacc.c:1646  */
    break;

  case 891:
#line 6395 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
#line 33961 "gram.c" /* yacc.c:1646  */
    break;

  case 892:
#line 6405 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
#line 33975 "gram.c" /* yacc.c:1646  */
    break;

  case 893:
#line 6418 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 33981 "gram.c" /* yacc.c:1646  */
    break;

  case 894:
#line 6419 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 33987 "gram.c" /* yacc.c:1646  */
    break;

  case 895:
#line 6420 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 33993 "gram.c" /* yacc.c:1646  */
    break;

  case 896:
#line 6421 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 33999 "gram.c" /* yacc.c:1646  */
    break;

  case 897:
#line 6422 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 34005 "gram.c" /* yacc.c:1646  */
    break;

  case 898:
#line 6423 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 34011 "gram.c" /* yacc.c:1646  */
    break;

  case 899:
#line 6424 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLLATION; }
#line 34017 "gram.c" /* yacc.c:1646  */
    break;

  case 900:
#line 6425 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_CONVERSION; }
#line 34023 "gram.c" /* yacc.c:1646  */
    break;

  case 901:
#line 6426 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_STATISTIC_EXT; }
#line 34029 "gram.c" /* yacc.c:1646  */
    break;

  case 902:
#line 6427 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSPARSER; }
#line 34035 "gram.c" /* yacc.c:1646  */
    break;

  case 903:
#line 6428 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 34041 "gram.c" /* yacc.c:1646  */
    break;

  case 904:
#line 6429 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 34047 "gram.c" /* yacc.c:1646  */
    break;

  case 905:
#line 6430 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 34053 "gram.c" /* yacc.c:1646  */
    break;

  case 906:
#line 6435 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ACCESS_METHOD; }
#line 34059 "gram.c" /* yacc.c:1646  */
    break;

  case 907:
#line 6436 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 34065 "gram.c" /* yacc.c:1646  */
    break;

  case 908:
#line 6437 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EXTENSION; }
#line 34071 "gram.c" /* yacc.c:1646  */
    break;

  case 909:
#line 6438 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FDW; }
#line 34077 "gram.c" /* yacc.c:1646  */
    break;

  case 910:
#line 6439 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_PUBLICATION; }
#line 34083 "gram.c" /* yacc.c:1646  */
    break;

  case 911:
#line 6440 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 34089 "gram.c" /* yacc.c:1646  */
    break;

  case 912:
#line 6441 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
#line 34095 "gram.c" /* yacc.c:1646  */
    break;

  case 913:
#line 6446 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_POLICY; }
#line 34101 "gram.c" /* yacc.c:1646  */
    break;

  case 914:
#line 6447 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_RULE; }
#line 34107 "gram.c" /* yacc.c:1646  */
    break;

  case 915:
#line 6448 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TRIGGER; }
#line 34113 "gram.c" /* yacc.c:1646  */
    break;

  case 916:
#line 6452 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 34119 "gram.c" /* yacc.c:1646  */
    break;

  case 917:
#line 6453 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 34125 "gram.c" /* yacc.c:1646  */
    break;

  case 918:
#line 6456 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 34131 "gram.c" /* yacc.c:1646  */
    break;

  case 919:
#line 6457 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 34137 "gram.c" /* yacc.c:1646  */
    break;

  case 920:
#line 6461 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 34143 "gram.c" /* yacc.c:1646  */
    break;

  case 921:
#line 6463 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 34149 "gram.c" /* yacc.c:1646  */
    break;

  case 922:
#line 6467 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 34155 "gram.c" /* yacc.c:1646  */
    break;

  case 923:
#line 6468 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 34161 "gram.c" /* yacc.c:1646  */
    break;

  case 924:
#line 6480 "gram.y" /* yacc.c:1646  */
    {
					TruncateStmt *n = makeNode(TruncateStmt);
					n->relations = (yyvsp[-2].list);
					n->restart_seqs = (yyvsp[-1].boolean);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 34173 "gram.c" /* yacc.c:1646  */
    break;

  case 925:
#line 6490 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 34179 "gram.c" /* yacc.c:1646  */
    break;

  case 926:
#line 6491 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 34185 "gram.c" /* yacc.c:1646  */
    break;

  case 927:
#line 6492 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 34191 "gram.c" /* yacc.c:1646  */
    break;

  case 928:
#line 6527 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34203 "gram.c" /* yacc.c:1646  */
    break;

  case 929:
#line 6535 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34215 "gram.c" /* yacc.c:1646  */
    break;

  case 930:
#line 6543 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34227 "gram.c" /* yacc.c:1646  */
    break;

  case 931:
#line 6551 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34239 "gram.c" /* yacc.c:1646  */
    break;

  case 932:
#line 6559 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34251 "gram.c" /* yacc.c:1646  */
    break;

  case 933:
#line 6567 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34263 "gram.c" /* yacc.c:1646  */
    break;

  case 934:
#line 6575 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34275 "gram.c" /* yacc.c:1646  */
    break;

  case 935:
#line 6583 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TABCONSTRAINT;
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34287 "gram.c" /* yacc.c:1646  */
    break;

  case 936:
#line 6591 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_DOMCONSTRAINT;
					/*
					 * should use Typename not any_name in the production, but
					 * there's a shift/reduce conflict if we do that, so fix it
					 * up here.
					 */
					n->object = (Node *) list_make2(makeTypeNameFromNameList((yyvsp[-2].list)), makeString((yyvsp[-5].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34304 "gram.c" /* yacc.c:1646  */
    break;

  case 937:
#line 6604 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_POLICY;
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34316 "gram.c" /* yacc.c:1646  */
    break;

  case 938:
#line 6612 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34328 "gram.c" /* yacc.c:1646  */
    break;

  case 939:
#line 6620 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34340 "gram.c" /* yacc.c:1646  */
    break;

  case 940:
#line 6628 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34352 "gram.c" /* yacc.c:1646  */
    break;

  case 941:
#line 6636 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-4].typnam), makeString((yyvsp[-2].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34364 "gram.c" /* yacc.c:1646  */
    break;

  case 942:
#line 6644 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRIGGER;
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34376 "gram.c" /* yacc.c:1646  */
    break;

  case 943:
#line 6652 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34388 "gram.c" /* yacc.c:1646  */
    break;

  case 944:
#line 6660 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34400 "gram.c" /* yacc.c:1646  */
    break;

  case 945:
#line 6668 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].value);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34412 "gram.c" /* yacc.c:1646  */
    break;

  case 946:
#line 6676 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-5].typnam), (yyvsp[-3].typnam));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34424 "gram.c" /* yacc.c:1646  */
    break;

  case 947:
#line 6687 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLUMN; }
#line 34430 "gram.c" /* yacc.c:1646  */
    break;

  case 948:
#line 6688 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 34436 "gram.c" /* yacc.c:1646  */
    break;

  case 949:
#line 6689 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 34442 "gram.c" /* yacc.c:1646  */
    break;

  case 950:
#line 6690 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_STATISTIC_EXT; }
#line 34448 "gram.c" /* yacc.c:1646  */
    break;

  case 951:
#line 6691 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 34454 "gram.c" /* yacc.c:1646  */
    break;

  case 952:
#line 6692 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 34460 "gram.c" /* yacc.c:1646  */
    break;

  case 953:
#line 6693 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 34466 "gram.c" /* yacc.c:1646  */
    break;

  case 954:
#line 6694 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLLATION; }
#line 34472 "gram.c" /* yacc.c:1646  */
    break;

  case 955:
#line 6695 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_CONVERSION; }
#line 34478 "gram.c" /* yacc.c:1646  */
    break;

  case 956:
#line 6696 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 34484 "gram.c" /* yacc.c:1646  */
    break;

  case 957:
#line 6697 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 34490 "gram.c" /* yacc.c:1646  */
    break;

  case 958:
#line 6698 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 34496 "gram.c" /* yacc.c:1646  */
    break;

  case 959:
#line 6699 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSPARSER; }
#line 34502 "gram.c" /* yacc.c:1646  */
    break;

  case 960:
#line 6700 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 34508 "gram.c" /* yacc.c:1646  */
    break;

  case 961:
#line 6705 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ACCESS_METHOD; }
#line 34514 "gram.c" /* yacc.c:1646  */
    break;

  case 962:
#line 6706 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DATABASE; }
#line 34520 "gram.c" /* yacc.c:1646  */
    break;

  case 963:
#line 6707 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 34526 "gram.c" /* yacc.c:1646  */
    break;

  case 964:
#line 6708 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EXTENSION; }
#line 34532 "gram.c" /* yacc.c:1646  */
    break;

  case 965:
#line 6709 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FDW; }
#line 34538 "gram.c" /* yacc.c:1646  */
    break;

  case 966:
#line 6710 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_LANGUAGE; }
#line 34544 "gram.c" /* yacc.c:1646  */
    break;

  case 967:
#line 6711 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_PUBLICATION; }
#line 34550 "gram.c" /* yacc.c:1646  */
    break;

  case 968:
#line 6712 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ROLE; }
#line 34556 "gram.c" /* yacc.c:1646  */
    break;

  case 969:
#line 6713 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 34562 "gram.c" /* yacc.c:1646  */
    break;

  case 970:
#line 6714 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
#line 34568 "gram.c" /* yacc.c:1646  */
    break;

  case 971:
#line 6715 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SUBSCRIPTION; }
#line 34574 "gram.c" /* yacc.c:1646  */
    break;

  case 972:
#line 6716 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 34580 "gram.c" /* yacc.c:1646  */
    break;

  case 973:
#line 6720 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34586 "gram.c" /* yacc.c:1646  */
    break;

  case 974:
#line 6721 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 34592 "gram.c" /* yacc.c:1646  */
    break;

  case 975:
#line 6737 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34605 "gram.c" /* yacc.c:1646  */
    break;

  case 976:
#line 6747 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34618 "gram.c" /* yacc.c:1646  */
    break;

  case 977:
#line 6757 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34631 "gram.c" /* yacc.c:1646  */
    break;

  case 978:
#line 6767 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34644 "gram.c" /* yacc.c:1646  */
    break;

  case 979:
#line 6777 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34657 "gram.c" /* yacc.c:1646  */
    break;

  case 980:
#line 6787 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34670 "gram.c" /* yacc.c:1646  */
    break;

  case 981:
#line 6797 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].value);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34683 "gram.c" /* yacc.c:1646  */
    break;

  case 982:
#line 6807 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34696 "gram.c" /* yacc.c:1646  */
    break;

  case 983:
#line 6817 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34709 "gram.c" /* yacc.c:1646  */
    break;

  case 984:
#line 6827 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34715 "gram.c" /* yacc.c:1646  */
    break;

  case 985:
#line 6828 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 34721 "gram.c" /* yacc.c:1646  */
    break;

  case 986:
#line 6833 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLUMN; }
#line 34727 "gram.c" /* yacc.c:1646  */
    break;

  case 987:
#line 6834 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 34733 "gram.c" /* yacc.c:1646  */
    break;

  case 988:
#line 6835 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 34739 "gram.c" /* yacc.c:1646  */
    break;

  case 989:
#line 6836 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 34745 "gram.c" /* yacc.c:1646  */
    break;

  case 990:
#line 6837 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 34751 "gram.c" /* yacc.c:1646  */
    break;

  case 991:
#line 6838 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 34757 "gram.c" /* yacc.c:1646  */
    break;

  case 992:
#line 6843 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DATABASE; }
#line 34763 "gram.c" /* yacc.c:1646  */
    break;

  case 993:
#line 6844 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 34769 "gram.c" /* yacc.c:1646  */
    break;

  case 994:
#line 6845 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_LANGUAGE; }
#line 34775 "gram.c" /* yacc.c:1646  */
    break;

  case 995:
#line 6846 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_PUBLICATION; }
#line 34781 "gram.c" /* yacc.c:1646  */
    break;

  case 996:
#line 6847 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ROLE; }
#line 34787 "gram.c" /* yacc.c:1646  */
    break;

  case 997:
#line 6848 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 34793 "gram.c" /* yacc.c:1646  */
    break;

  case 998:
#line 6849 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SUBSCRIPTION; }
#line 34799 "gram.c" /* yacc.c:1646  */
    break;

  case 999:
#line 6850 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 34805 "gram.c" /* yacc.c:1646  */
    break;

  case 1000:
#line 6853 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34811 "gram.c" /* yacc.c:1646  */
    break;

  case 1001:
#line 6854 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 34817 "gram.c" /* yacc.c:1646  */
    break;

  case 1002:
#line 6865 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);
					n->ismove = false;
					(yyval.node) = (Node *)n;
				}
#line 34827 "gram.c" /* yacc.c:1646  */
    break;

  case 1003:
#line 6871 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);
					n->ismove = true;
					(yyval.node) = (Node *)n;
				}
#line 34837 "gram.c" /* yacc.c:1646  */
    break;

  case 1004:
#line 6879 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 34849 "gram.c" /* yacc.c:1646  */
    break;

  case 1005:
#line 6887 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 34861 "gram.c" /* yacc.c:1646  */
    break;

  case 1006:
#line 6895 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 34873 "gram.c" /* yacc.c:1646  */
    break;

  case 1007:
#line 6903 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 34885 "gram.c" /* yacc.c:1646  */
    break;

  case 1008:
#line 6911 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 34897 "gram.c" /* yacc.c:1646  */
    break;

  case 1009:
#line 6919 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *)n;
				}
#line 34909 "gram.c" /* yacc.c:1646  */
    break;

  case 1010:
#line 6927 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 34921 "gram.c" /* yacc.c:1646  */
    break;

  case 1011:
#line 6935 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 34933 "gram.c" /* yacc.c:1646  */
    break;

  case 1012:
#line 6943 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 34945 "gram.c" /* yacc.c:1646  */
    break;

  case 1013:
#line 6951 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 34957 "gram.c" /* yacc.c:1646  */
    break;

  case 1014:
#line 6959 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 34969 "gram.c" /* yacc.c:1646  */
    break;

  case 1015:
#line 6967 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 34981 "gram.c" /* yacc.c:1646  */
    break;

  case 1016:
#line 6975 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 34993 "gram.c" /* yacc.c:1646  */
    break;

  case 1017:
#line 6983 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 35005 "gram.c" /* yacc.c:1646  */
    break;

  case 1018:
#line 6991 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 35017 "gram.c" /* yacc.c:1646  */
    break;

  case 1019:
#line 6999 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 35029 "gram.c" /* yacc.c:1646  */
    break;

  case 1020:
#line 7008 "gram.y" /* yacc.c:1646  */
    {}
#line 35035 "gram.c" /* yacc.c:1646  */
    break;

  case 1021:
#line 7009 "gram.y" /* yacc.c:1646  */
    {}
#line 35041 "gram.c" /* yacc.c:1646  */
    break;

  case 1022:
#line 7012 "gram.y" /* yacc.c:1646  */
    {}
#line 35047 "gram.c" /* yacc.c:1646  */
    break;

  case 1023:
#line 7013 "gram.y" /* yacc.c:1646  */
    {}
#line 35053 "gram.c" /* yacc.c:1646  */
    break;

  case 1024:
#line 7025 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 35069 "gram.c" /* yacc.c:1646  */
    break;

  case 1025:
#line 7041 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 35086 "gram.c" /* yacc.c:1646  */
    break;

  case 1026:
#line 7055 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 35103 "gram.c" /* yacc.c:1646  */
    break;

  case 1027:
#line 7080 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35109 "gram.c" /* yacc.c:1646  */
    break;

  case 1028:
#line 7082 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35115 "gram.c" /* yacc.c:1646  */
    break;

  case 1029:
#line 7084 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35121 "gram.c" /* yacc.c:1646  */
    break;

  case 1030:
#line 7086 "gram.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 35132 "gram.c" /* yacc.c:1646  */
    break;

  case 1031:
#line 7093 "gram.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 35143 "gram.c" /* yacc.c:1646  */
    break;

  case 1032:
#line 7101 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].accesspriv)); }
#line 35149 "gram.c" /* yacc.c:1646  */
    break;

  case 1033:
#line 7102 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].accesspriv)); }
#line 35155 "gram.c" /* yacc.c:1646  */
    break;

  case 1034:
#line 7106 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 35166 "gram.c" /* yacc.c:1646  */
    break;

  case 1035:
#line 7113 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 35177 "gram.c" /* yacc.c:1646  */
    break;

  case 1036:
#line 7120 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 35188 "gram.c" /* yacc.c:1646  */
    break;

  case 1037:
#line 7127 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = (yyvsp[-1].str);
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 35199 "gram.c" /* yacc.c:1646  */
    break;

  case 1038:
#line 7141 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35211 "gram.c" /* yacc.c:1646  */
    break;

  case 1039:
#line 7149 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35223 "gram.c" /* yacc.c:1646  */
    break;

  case 1040:
#line 7157 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35235 "gram.c" /* yacc.c:1646  */
    break;

  case 1041:
#line 7165 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FDW;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35247 "gram.c" /* yacc.c:1646  */
    break;

  case 1042:
#line 7173 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35259 "gram.c" /* yacc.c:1646  */
    break;

  case 1043:
#line 7181 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35271 "gram.c" /* yacc.c:1646  */
    break;

  case 1044:
#line 7189 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_PROCEDURE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35283 "gram.c" /* yacc.c:1646  */
    break;

  case 1045:
#line 7197 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_ROUTINE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35295 "gram.c" /* yacc.c:1646  */
    break;

  case 1046:
#line 7205 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_DATABASE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35307 "gram.c" /* yacc.c:1646  */
    break;

  case 1047:
#line 7213 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_DOMAIN;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35319 "gram.c" /* yacc.c:1646  */
    break;

  case 1048:
#line 7221 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_LANGUAGE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35331 "gram.c" /* yacc.c:1646  */
    break;

  case 1049:
#line 7229 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35343 "gram.c" /* yacc.c:1646  */
    break;

  case 1050:
#line 7237 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_SCHEMA;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35355 "gram.c" /* yacc.c:1646  */
    break;

  case 1051:
#line 7245 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35367 "gram.c" /* yacc.c:1646  */
    break;

  case 1052:
#line 7253 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TYPE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35379 "gram.c" /* yacc.c:1646  */
    break;

  case 1053:
#line 7261 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35391 "gram.c" /* yacc.c:1646  */
    break;

  case 1054:
#line 7269 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35403 "gram.c" /* yacc.c:1646  */
    break;

  case 1055:
#line 7277 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35415 "gram.c" /* yacc.c:1646  */
    break;

  case 1056:
#line 7285 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_PROCEDURE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35427 "gram.c" /* yacc.c:1646  */
    break;

  case 1057:
#line 7293 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_ROUTINE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35439 "gram.c" /* yacc.c:1646  */
    break;

  case 1058:
#line 7304 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 35445 "gram.c" /* yacc.c:1646  */
    break;

  case 1059:
#line 7305 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 35451 "gram.c" /* yacc.c:1646  */
    break;

  case 1060:
#line 7309 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 35457 "gram.c" /* yacc.c:1646  */
    break;

  case 1061:
#line 7310 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 35463 "gram.c" /* yacc.c:1646  */
    break;

  case 1062:
#line 7315 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35469 "gram.c" /* yacc.c:1646  */
    break;

  case 1063:
#line 7316 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 35475 "gram.c" /* yacc.c:1646  */
    break;

  case 1064:
#line 7327 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->admin_opt = (yyvsp[-1].boolean);
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node*)n;
				}
#line 35489 "gram.c" /* yacc.c:1646  */
    break;

  case 1065:
#line 7340 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node*)n;
				}
#line 35503 "gram.c" /* yacc.c:1646  */
    break;

  case 1066:
#line 7350 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node*)n;
				}
#line 35517 "gram.c" /* yacc.c:1646  */
    break;

  case 1067:
#line 7361 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35523 "gram.c" /* yacc.c:1646  */
    break;

  case 1068:
#line 7362 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 35529 "gram.c" /* yacc.c:1646  */
    break;

  case 1069:
#line 7365 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 35535 "gram.c" /* yacc.c:1646  */
    break;

  case 1070:
#line 7366 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = NULL; }
#line 35541 "gram.c" /* yacc.c:1646  */
    break;

  case 1071:
#line 7377 "gram.y" /* yacc.c:1646  */
    {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);
					n->options = (yyvsp[-1].list);
					n->action = (GrantStmt *) (yyvsp[0].node);
					(yyval.node) = (Node*)n;
				}
#line 35552 "gram.c" /* yacc.c:1646  */
    break;

  case 1072:
#line 7386 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 35558 "gram.c" /* yacc.c:1646  */
    break;

  case 1073:
#line 7387 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35564 "gram.c" /* yacc.c:1646  */
    break;

  case 1074:
#line 7392 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schemas", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 35572 "gram.c" /* yacc.c:1646  */
    break;

  case 1075:
#line 7396 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 35580 "gram.c" /* yacc.c:1646  */
    break;

  case 1076:
#line 7400 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 35588 "gram.c" /* yacc.c:1646  */
    break;

  case 1077:
#line 7412 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 35604 "gram.c" /* yacc.c:1646  */
    break;

  case 1078:
#line 7425 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 35621 "gram.c" /* yacc.c:1646  */
    break;

  case 1079:
#line 7439 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 35638 "gram.c" /* yacc.c:1646  */
    break;

  case 1080:
#line 7454 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_TABLE; }
#line 35644 "gram.c" /* yacc.c:1646  */
    break;

  case 1081:
#line 7455 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_FUNCTION; }
#line 35650 "gram.c" /* yacc.c:1646  */
    break;

  case 1082:
#line 7456 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_FUNCTION; }
#line 35656 "gram.c" /* yacc.c:1646  */
    break;

  case 1083:
#line 7457 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_SEQUENCE; }
#line 35662 "gram.c" /* yacc.c:1646  */
    break;

  case 1084:
#line 7458 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_TYPE; }
#line 35668 "gram.c" /* yacc.c:1646  */
    break;

  case 1085:
#line 7459 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_SCHEMA; }
#line 35674 "gram.c" /* yacc.c:1646  */
    break;

  case 1086:
#line 7474 "gram.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[-13].boolean);
					n->concurrent = (yyvsp[-11].boolean);
					n->idxname = (yyvsp[-10].str);
					n->relation = (yyvsp[-8].range);
					n->accessMethod = (yyvsp[-7].str);
					n->indexParams = (yyvsp[-5].list);
					n->indexIncludingParams = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->oldCreateSubid = InvalidSubTransactionId;
					n->oldFirstRelfilenodeSubid = InvalidSubTransactionId;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = false;
					n->reset_default_tblspc = false;
					(yyval.node) = (Node *)n;
				}
#line 35706 "gram.c" /* yacc.c:1646  */
    break;

  case 1087:
#line 7504 "gram.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[-16].boolean);
					n->concurrent = (yyvsp[-14].boolean);
					n->idxname = (yyvsp[-10].str);
					n->relation = (yyvsp[-8].range);
					n->accessMethod = (yyvsp[-7].str);
					n->indexParams = (yyvsp[-5].list);
					n->indexIncludingParams = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->oldCreateSubid = InvalidSubTransactionId;
					n->oldFirstRelfilenodeSubid = InvalidSubTransactionId;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = true;
					n->reset_default_tblspc = false;
					(yyval.node) = (Node *)n;
				}
#line 35738 "gram.c" /* yacc.c:1646  */
    break;

  case 1088:
#line 7534 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35744 "gram.c" /* yacc.c:1646  */
    break;

  case 1089:
#line 7535 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 35750 "gram.c" /* yacc.c:1646  */
    break;

  case 1090:
#line 7539 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35756 "gram.c" /* yacc.c:1646  */
    break;

  case 1091:
#line 7540 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 35762 "gram.c" /* yacc.c:1646  */
    break;

  case 1092:
#line 7544 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35768 "gram.c" /* yacc.c:1646  */
    break;

  case 1093:
#line 7545 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 35774 "gram.c" /* yacc.c:1646  */
    break;

  case 1094:
#line 7549 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35780 "gram.c" /* yacc.c:1646  */
    break;

  case 1095:
#line 7550 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = DEFAULT_INDEX_TYPE; }
#line 35786 "gram.c" /* yacc.c:1646  */
    break;

  case 1096:
#line 7553 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 35792 "gram.c" /* yacc.c:1646  */
    break;

  case 1097:
#line 7554 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 35798 "gram.c" /* yacc.c:1646  */
    break;

  case 1098:
#line 7560 "gram.y" /* yacc.c:1646  */
    {
			(yyval.ielem) = makeNode(IndexElem);
			(yyval.ielem)->name = NULL;
			(yyval.ielem)->expr = NULL;
			(yyval.ielem)->indexcolname = NULL;
			(yyval.ielem)->collation = (yyvsp[-3].list);
			(yyval.ielem)->opclass = (yyvsp[-2].list);
			(yyval.ielem)->opclassopts = NIL;
			(yyval.ielem)->ordering = (yyvsp[-1].ival);
			(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
		}
#line 35814 "gram.c" /* yacc.c:1646  */
    break;

  case 1099:
#line 7572 "gram.y" /* yacc.c:1646  */
    {
			(yyval.ielem) = makeNode(IndexElem);
			(yyval.ielem)->name = NULL;
			(yyval.ielem)->expr = NULL;
			(yyval.ielem)->indexcolname = NULL;
			(yyval.ielem)->collation = (yyvsp[-4].list);
			(yyval.ielem)->opclass = (yyvsp[-3].list);
			(yyval.ielem)->opclassopts = (yyvsp[-2].list);
			(yyval.ielem)->ordering = (yyvsp[-1].ival);
			(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
		}
#line 35830 "gram.c" /* yacc.c:1646  */
    break;

  case 1100:
#line 7591 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->name = (yyvsp[-1].str);
				}
#line 35839 "gram.c" /* yacc.c:1646  */
    break;

  case 1101:
#line 7596 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->expr = (yyvsp[-1].node);
				}
#line 35848 "gram.c" /* yacc.c:1646  */
    break;

  case 1102:
#line 7601 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->expr = (yyvsp[-2].node);
				}
#line 35857 "gram.c" /* yacc.c:1646  */
    break;

  case 1103:
#line 7607 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35863 "gram.c" /* yacc.c:1646  */
    break;

  case 1104:
#line 7608 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35869 "gram.c" /* yacc.c:1646  */
    break;

  case 1105:
#line 7611 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 35875 "gram.c" /* yacc.c:1646  */
    break;

  case 1106:
#line 7612 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 35881 "gram.c" /* yacc.c:1646  */
    break;

  case 1107:
#line 7615 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35887 "gram.c" /* yacc.c:1646  */
    break;

  case 1108:
#line 7616 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35893 "gram.c" /* yacc.c:1646  */
    break;

  case 1109:
#line 7619 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35899 "gram.c" /* yacc.c:1646  */
    break;

  case 1110:
#line 7620 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35905 "gram.c" /* yacc.c:1646  */
    break;

  case 1111:
#line 7623 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_ASC; }
#line 35911 "gram.c" /* yacc.c:1646  */
    break;

  case 1112:
#line 7624 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DESC; }
#line 35917 "gram.c" /* yacc.c:1646  */
    break;

  case 1113:
#line 7625 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DEFAULT; }
#line 35923 "gram.c" /* yacc.c:1646  */
    break;

  case 1114:
#line 7628 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_FIRST; }
#line 35929 "gram.c" /* yacc.c:1646  */
    break;

  case 1115:
#line 7629 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_LAST; }
#line 35935 "gram.c" /* yacc.c:1646  */
    break;

  case 1116:
#line 7630 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
#line 35941 "gram.c" /* yacc.c:1646  */
    break;

  case 1117:
#line 7648 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->is_procedure = false;
					n->replace = (yyvsp[-6].boolean);
					n->funcname = (yyvsp[-4].list);
					n->parameters = (yyvsp[-3].list);
					n->returnType = (yyvsp[-1].typnam);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 35956 "gram.c" /* yacc.c:1646  */
    break;

  case 1118:
#line 7660 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->is_procedure = false;
					n->replace = (yyvsp[-9].boolean);
					n->funcname = (yyvsp[-7].list);
					n->parameters = mergeTableFuncParameters((yyvsp[-6].list), (yyvsp[-2].list));
					n->returnType = TableFuncTypeName((yyvsp[-2].list));
					n->returnType->location = (yylsp[-4]);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 35972 "gram.c" /* yacc.c:1646  */
    break;

  case 1119:
#line 7673 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->is_procedure = false;
					n->replace = (yyvsp[-4].boolean);
					n->funcname = (yyvsp[-2].list);
					n->parameters = (yyvsp[-1].list);
					n->returnType = NULL;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 35987 "gram.c" /* yacc.c:1646  */
    break;

  case 1120:
#line 7685 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->is_procedure = true;
					n->replace = (yyvsp[-4].boolean);
					n->funcname = (yyvsp[-2].list);
					n->parameters = (yyvsp[-1].list);
					n->returnType = NULL;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 36002 "gram.c" /* yacc.c:1646  */
    break;

  case 1121:
#line 7698 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 36008 "gram.c" /* yacc.c:1646  */
    break;

  case 1122:
#line 7699 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36014 "gram.c" /* yacc.c:1646  */
    break;

  case 1123:
#line 7702 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 36020 "gram.c" /* yacc.c:1646  */
    break;

  case 1124:
#line 7703 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36026 "gram.c" /* yacc.c:1646  */
    break;

  case 1125:
#line 7707 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 36032 "gram.c" /* yacc.c:1646  */
    break;

  case 1126:
#line 7708 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 36038 "gram.c" /* yacc.c:1646  */
    break;

  case 1127:
#line 7712 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 36044 "gram.c" /* yacc.c:1646  */
    break;

  case 1128:
#line 7714 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 36050 "gram.c" /* yacc.c:1646  */
    break;

  case 1129:
#line 7719 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = (yyvsp[-1].list);
					n->objargs = extractArgTypes((yyvsp[0].list));
					(yyval.objwithargs) = n;
				}
#line 36061 "gram.c" /* yacc.c:1646  */
    break;

  case 1130:
#line 7731 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = list_make1(makeString(pstrdup((yyvsp[0].keyword))));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 36072 "gram.c" /* yacc.c:1646  */
    break;

  case 1131:
#line 7738 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = list_make1(makeString((yyvsp[0].str)));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 36083 "gram.c" /* yacc.c:1646  */
    break;

  case 1132:
#line 7745 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
												  yyscanner);
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 36095 "gram.c" /* yacc.c:1646  */
    break;

  case 1133:
#line 7759 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 36101 "gram.c" /* yacc.c:1646  */
    break;

  case 1134:
#line 7760 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36107 "gram.c" /* yacc.c:1646  */
    break;

  case 1135:
#line 7764 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 36113 "gram.c" /* yacc.c:1646  */
    break;

  case 1136:
#line 7766 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 36119 "gram.c" /* yacc.c:1646  */
    break;

  case 1137:
#line 7781 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-2].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 36132 "gram.c" /* yacc.c:1646  */
    break;

  case 1138:
#line 7790 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-2].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 36145 "gram.c" /* yacc.c:1646  */
    break;

  case 1139:
#line 7799 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 36158 "gram.c" /* yacc.c:1646  */
    break;

  case 1140:
#line 7808 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 36171 "gram.c" /* yacc.c:1646  */
    break;

  case 1141:
#line 7817 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 36184 "gram.c" /* yacc.c:1646  */
    break;

  case 1142:
#line 7828 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
#line 36190 "gram.c" /* yacc.c:1646  */
    break;

  case 1143:
#line 7829 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
#line 36196 "gram.c" /* yacc.c:1646  */
    break;

  case 1144:
#line 7830 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 36202 "gram.c" /* yacc.c:1646  */
    break;

  case 1145:
#line 7831 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 36208 "gram.c" /* yacc.c:1646  */
    break;

  case 1146:
#line 7832 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; }
#line 36214 "gram.c" /* yacc.c:1646  */
    break;

  case 1148:
#line 7843 "gram.y" /* yacc.c:1646  */
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 36226 "gram.c" /* yacc.c:1646  */
    break;

  case 1149:
#line 7857 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 36232 "gram.c" /* yacc.c:1646  */
    break;

  case 1150:
#line 7859 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 36242 "gram.c" /* yacc.c:1646  */
    break;

  case 1151:
#line 7865 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 36253 "gram.c" /* yacc.c:1646  */
    break;

  case 1152:
#line 7875 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 36261 "gram.c" /* yacc.c:1646  */
    break;

  case 1153:
#line 7879 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 36270 "gram.c" /* yacc.c:1646  */
    break;

  case 1154:
#line 7884 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 36279 "gram.c" /* yacc.c:1646  */
    break;

  case 1155:
#line 7892 "gram.y" /* yacc.c:1646  */
    {
					if (!((yyvsp[0].fun_param)->mode == FUNC_PARAM_IN ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_VARIADIC))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("aggregates cannot have output arguments"),
								 parser_errposition((yylsp[0]))));
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 36293 "gram.c" /* yacc.c:1646  */
    break;

  case 1156:
#line 7933 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NIL, makeInteger(-1));
				}
#line 36301 "gram.c" /* yacc.c:1646  */
    break;

  case 1157:
#line 7937 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(-1));
				}
#line 36309 "gram.c" /* yacc.c:1646  */
    break;

  case 1158:
#line 7941 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(0));
				}
#line 36317 "gram.c" /* yacc.c:1646  */
    break;

  case 1159:
#line 7945 "gram.y" /* yacc.c:1646  */
    {
					/* this is the only case requiring consistency checking */
					(yyval.list) = makeOrderedSetArgs((yyvsp[-4].list), (yyvsp[-1].list), yyscanner);
				}
#line 36326 "gram.c" /* yacc.c:1646  */
    break;

  case 1160:
#line 7952 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 36332 "gram.c" /* yacc.c:1646  */
    break;

  case 1161:
#line 7953 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 36338 "gram.c" /* yacc.c:1646  */
    break;

  case 1162:
#line 7958 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = (yyvsp[-1].list);
					n->objargs = extractAggrArgTypes((yyvsp[0].list));
					(yyval.objwithargs) = n;
				}
#line 36349 "gram.c" /* yacc.c:1646  */
    break;

  case 1163:
#line 7967 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 36355 "gram.c" /* yacc.c:1646  */
    break;

  case 1164:
#line 7969 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 36361 "gram.c" /* yacc.c:1646  */
    break;

  case 1165:
#line 7974 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 36367 "gram.c" /* yacc.c:1646  */
    break;

  case 1166:
#line 7975 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 36373 "gram.c" /* yacc.c:1646  */
    break;

  case 1167:
#line 7983 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(false), (yylsp[-3]));
				}
#line 36381 "gram.c" /* yacc.c:1646  */
    break;

  case 1168:
#line 7987 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(true), (yylsp[-4]));
				}
#line 36389 "gram.c" /* yacc.c:1646  */
    break;

  case 1169:
#line 7991 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 36397 "gram.c" /* yacc.c:1646  */
    break;

  case 1170:
#line 7995 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("immutable"), (yylsp[0]));
				}
#line 36405 "gram.c" /* yacc.c:1646  */
    break;

  case 1171:
#line 7999 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("stable"), (yylsp[0]));
				}
#line 36413 "gram.c" /* yacc.c:1646  */
    break;

  case 1172:
#line 8003 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("volatile"), (yylsp[0]));
				}
#line 36421 "gram.c" /* yacc.c:1646  */
    break;

  case 1173:
#line 8007 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(true), (yylsp[-2]));
				}
#line 36429 "gram.c" /* yacc.c:1646  */
    break;

  case 1174:
#line 8011 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(false), (yylsp[-2]));
				}
#line 36437 "gram.c" /* yacc.c:1646  */
    break;

  case 1175:
#line 8015 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(true), (yylsp[-1]));
				}
#line 36445 "gram.c" /* yacc.c:1646  */
    break;

  case 1176:
#line 8019 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(false), (yylsp[-1]));
				}
#line 36453 "gram.c" /* yacc.c:1646  */
    break;

  case 1177:
#line 8023 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 36461 "gram.c" /* yacc.c:1646  */
    break;

  case 1178:
#line 8027 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(false), (yylsp[-1]));
				}
#line 36469 "gram.c" /* yacc.c:1646  */
    break;

  case 1179:
#line 8031 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cost", (Node *)(yyvsp[0].value), (yylsp[-1]));
				}
#line 36477 "gram.c" /* yacc.c:1646  */
    break;

  case 1180:
#line 8035 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rows", (Node *)(yyvsp[0].value), (yylsp[-1]));
				}
#line 36485 "gram.c" /* yacc.c:1646  */
    break;

  case 1181:
#line 8039 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("support", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 36493 "gram.c" /* yacc.c:1646  */
    break;

  case 1182:
#line 8043 "gram.y" /* yacc.c:1646  */
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *)(yyvsp[0].vsetstmt), (yylsp[0]));
				}
#line 36502 "gram.c" /* yacc.c:1646  */
    break;

  case 1183:
#line 8048 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("parallel", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 36510 "gram.c" /* yacc.c:1646  */
    break;

  case 1184:
#line 8055 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 36518 "gram.c" /* yacc.c:1646  */
    break;

  case 1185:
#line 8059 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 36526 "gram.c" /* yacc.c:1646  */
    break;

  case 1186:
#line 8063 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("transform", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 36534 "gram.c" /* yacc.c:1646  */
    break;

  case 1187:
#line 8067 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("window", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 36542 "gram.c" /* yacc.c:1646  */
    break;

  case 1188:
#line 8071 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 36550 "gram.c" /* yacc.c:1646  */
    break;

  case 1189:
#line 8076 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36556 "gram.c" /* yacc.c:1646  */
    break;

  case 1190:
#line 8078 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeString((yyvsp[-2].str)), makeString((yyvsp[0].str)));
				}
#line 36564 "gram.c" /* yacc.c:1646  */
    break;

  case 1191:
#line 8084 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 36570 "gram.c" /* yacc.c:1646  */
    break;

  case 1192:
#line 8085 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-4].list), (yyvsp[0].typnam)); }
#line 36576 "gram.c" /* yacc.c:1646  */
    break;

  case 1193:
#line 8089 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36582 "gram.c" /* yacc.c:1646  */
    break;

  case 1194:
#line 8090 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36588 "gram.c" /* yacc.c:1646  */
    break;

  case 1195:
#line 8094 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 36601 "gram.c" /* yacc.c:1646  */
    break;

  case 1196:
#line 8106 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].fun_param));
				}
#line 36609 "gram.c" /* yacc.c:1646  */
    break;

  case 1197:
#line 8110 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param));
				}
#line 36617 "gram.c" /* yacc.c:1646  */
    break;

  case 1198:
#line 8125 "gram.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->objtype = OBJECT_FUNCTION;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 36629 "gram.c" /* yacc.c:1646  */
    break;

  case 1199:
#line 8133 "gram.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->objtype = OBJECT_PROCEDURE;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 36641 "gram.c" /* yacc.c:1646  */
    break;

  case 1200:
#line 8141 "gram.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->objtype = OBJECT_ROUTINE;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 36653 "gram.c" /* yacc.c:1646  */
    break;

  case 1201:
#line 8152 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 36659 "gram.c" /* yacc.c:1646  */
    break;

  case 1202:
#line 8153 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 36665 "gram.c" /* yacc.c:1646  */
    break;

  case 1205:
#line 8177 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 36679 "gram.c" /* yacc.c:1646  */
    break;

  case 1206:
#line 8187 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 36693 "gram.c" /* yacc.c:1646  */
    break;

  case 1207:
#line 8197 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_PROCEDURE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 36707 "gram.c" /* yacc.c:1646  */
    break;

  case 1208:
#line 8207 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_PROCEDURE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 36721 "gram.c" /* yacc.c:1646  */
    break;

  case 1209:
#line 8217 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_ROUTINE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 36735 "gram.c" /* yacc.c:1646  */
    break;

  case 1210:
#line 8227 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_ROUTINE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 36749 "gram.c" /* yacc.c:1646  */
    break;

  case 1211:
#line 8240 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 36763 "gram.c" /* yacc.c:1646  */
    break;

  case 1212:
#line 8250 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 36777 "gram.c" /* yacc.c:1646  */
    break;

  case 1213:
#line 8263 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 36791 "gram.c" /* yacc.c:1646  */
    break;

  case 1214:
#line 8273 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 36805 "gram.c" /* yacc.c:1646  */
    break;

  case 1215:
#line 8286 "gram.y" /* yacc.c:1646  */
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[0]))));
				}
#line 36817 "gram.c" /* yacc.c:1646  */
    break;

  case 1216:
#line 8294 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam)); }
#line 36823 "gram.c" /* yacc.c:1646  */
    break;

  case 1217:
#line 8296 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, (yyvsp[-1].typnam)); }
#line 36829 "gram.c" /* yacc.c:1646  */
    break;

  case 1218:
#line 8298 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), NULL); }
#line 36835 "gram.c" /* yacc.c:1646  */
    break;

  case 1219:
#line 8303 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36841 "gram.c" /* yacc.c:1646  */
    break;

  case 1220:
#line 8305 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-2].str)), (yyvsp[0].list)); }
#line 36847 "gram.c" /* yacc.c:1646  */
    break;

  case 1221:
#line 8309 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 36853 "gram.c" /* yacc.c:1646  */
    break;

  case 1222:
#line 8311 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 36859 "gram.c" /* yacc.c:1646  */
    break;

  case 1223:
#line 8316 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = (yyvsp[-1].list);
					n->objargs = (yyvsp[0].list);
					(yyval.objwithargs) = n;
				}
#line 36870 "gram.c" /* yacc.c:1646  */
    break;

  case 1224:
#line 8334 "gram.y" /* yacc.c:1646  */
    {
					DoStmt *n = makeNode(DoStmt);
					n->args = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 36880 "gram.c" /* yacc.c:1646  */
    break;

  case 1225:
#line 8342 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 36886 "gram.c" /* yacc.c:1646  */
    break;

  case 1226:
#line 8343 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 36892 "gram.c" /* yacc.c:1646  */
    break;

  case 1227:
#line 8348 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *)makeString((yyvsp[0].str)), (yylsp[0]));
				}
#line 36900 "gram.c" /* yacc.c:1646  */
    break;

  case 1228:
#line 8352 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 36908 "gram.c" /* yacc.c:1646  */
    break;

  case 1229:
#line 8365 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-7].typnam);
					n->targettype = (yyvsp[-5].typnam);
					n->func = (yyvsp[-1].objwithargs);
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
#line 36922 "gram.c" /* yacc.c:1646  */
    break;

  case 1230:
#line 8376 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
#line 36936 "gram.c" /* yacc.c:1646  */
    break;

  case 1231:
#line 8387 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = true;
					(yyval.node) = (Node *)n;
				}
#line 36950 "gram.c" /* yacc.c:1646  */
    break;

  case 1232:
#line 8398 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_IMPLICIT; }
#line 36956 "gram.c" /* yacc.c:1646  */
    break;

  case 1233:
#line 8399 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_ASSIGNMENT; }
#line 36962 "gram.c" /* yacc.c:1646  */
    break;

  case 1234:
#line 8400 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_EXPLICIT; }
#line 36968 "gram.c" /* yacc.c:1646  */
    break;

  case 1235:
#line 8405 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_CAST;
					n->objects = list_make1(list_make2((yyvsp[-4].typnam), (yyvsp[-2].typnam)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-6].boolean);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 36982 "gram.c" /* yacc.c:1646  */
    break;

  case 1236:
#line 8416 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 36988 "gram.c" /* yacc.c:1646  */
    break;

  case 1237:
#line 8417 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36994 "gram.c" /* yacc.c:1646  */
    break;

  case 1238:
#line 8428 "gram.y" /* yacc.c:1646  */
    {
					CreateTransformStmt *n = makeNode(CreateTransformStmt);
					n->replace = (yyvsp[-8].boolean);
					n->type_name = (yyvsp[-5].typnam);
					n->lang = (yyvsp[-3].str);
					n->fromsql = linitial((yyvsp[-1].list));
					n->tosql = lsecond((yyvsp[-1].list));
					(yyval.node) = (Node *)n;
				}
#line 37008 "gram.c" /* yacc.c:1646  */
    break;

  case 1239:
#line 8440 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-6].objwithargs), (yyvsp[0].objwithargs));
				}
#line 37016 "gram.c" /* yacc.c:1646  */
    break;

  case 1240:
#line 8444 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), (yyvsp[-6].objwithargs));
				}
#line 37024 "gram.c" /* yacc.c:1646  */
    break;

  case 1241:
#line 8448 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), NULL);
				}
#line 37032 "gram.c" /* yacc.c:1646  */
    break;

  case 1242:
#line 8452 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[0].objwithargs));
				}
#line 37040 "gram.c" /* yacc.c:1646  */
    break;

  case 1243:
#line 8459 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRANSFORM;
					n->objects = list_make1(list_make2((yyvsp[-3].typnam), makeString((yyvsp[-1].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-5].boolean);
					(yyval.node) = (Node *)n;
				}
#line 37053 "gram.c" /* yacc.c:1646  */
    break;

  case 1244:
#line 8479 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-2].ival);
					n->concurrent = (yyvsp[-1].boolean);
					n->relation = (yyvsp[0].range);
					n->name = NULL;
					n->options = 0;
					(yyval.node) = (Node *)n;
				}
#line 37067 "gram.c" /* yacc.c:1646  */
    break;

  case 1245:
#line 8489 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-2].ival);
					n->concurrent = (yyvsp[-1].boolean);
					n->name = (yyvsp[0].str);
					n->relation = NULL;
					n->options = 0;
					(yyval.node) = (Node *)n;
				}
#line 37081 "gram.c" /* yacc.c:1646  */
    break;

  case 1246:
#line 8499 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-2].ival);
					n->concurrent = (yyvsp[-1].boolean);
					n->relation = (yyvsp[0].range);
					n->name = NULL;
					n->options = (yyvsp[-4].ival);
					(yyval.node) = (Node *)n;
				}
#line 37095 "gram.c" /* yacc.c:1646  */
    break;

  case 1247:
#line 8509 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-2].ival);
					n->concurrent = (yyvsp[-1].boolean);
					n->name = (yyvsp[0].str);
					n->relation = NULL;
					n->options = (yyvsp[-4].ival);
					(yyval.node) = (Node *)n;
				}
#line 37109 "gram.c" /* yacc.c:1646  */
    break;

  case 1248:
#line 8520 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_INDEX; }
#line 37115 "gram.c" /* yacc.c:1646  */
    break;

  case 1249:
#line 8521 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_TABLE; }
#line 37121 "gram.c" /* yacc.c:1646  */
    break;

  case 1250:
#line 8524 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_SCHEMA; }
#line 37127 "gram.c" /* yacc.c:1646  */
    break;

  case 1251:
#line 8525 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_SYSTEM; }
#line 37133 "gram.c" /* yacc.c:1646  */
    break;

  case 1252:
#line 8526 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_DATABASE; }
#line 37139 "gram.c" /* yacc.c:1646  */
    break;

  case 1253:
#line 8529 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 37145 "gram.c" /* yacc.c:1646  */
    break;

  case 1254:
#line 8530 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 37151 "gram.c" /* yacc.c:1646  */
    break;

  case 1255:
#line 8533 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEXOPT_VERBOSE; }
#line 37157 "gram.c" /* yacc.c:1646  */
    break;

  case 1256:
#line 8544 "gram.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = false;
					(yyval.node) = (Node *)n;
				}
#line 37170 "gram.c" /* yacc.c:1646  */
    break;

  case 1257:
#line 8553 "gram.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = true;
					(yyval.node) = (Node *)n;
				}
#line 37183 "gram.c" /* yacc.c:1646  */
    break;

  case 1258:
#line 8570 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37196 "gram.c" /* yacc.c:1646  */
    break;

  case 1259:
#line 8579 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37209 "gram.c" /* yacc.c:1646  */
    break;

  case 1260:
#line 8588 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37222 "gram.c" /* yacc.c:1646  */
    break;

  case 1261:
#line 8597 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37235 "gram.c" /* yacc.c:1646  */
    break;

  case 1262:
#line 8606 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37248 "gram.c" /* yacc.c:1646  */
    break;

  case 1263:
#line 8615 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DOMCONSTRAINT;
					n->object = (Node *) (yyvsp[-5].list);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 37261 "gram.c" /* yacc.c:1646  */
    break;

  case 1264:
#line 8624 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37274 "gram.c" /* yacc.c:1646  */
    break;

  case 1265:
#line 8633 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37287 "gram.c" /* yacc.c:1646  */
    break;

  case 1266:
#line 8642 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37300 "gram.c" /* yacc.c:1646  */
    break;

  case 1267:
#line 8651 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37313 "gram.c" /* yacc.c:1646  */
    break;

  case 1268:
#line 8660 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37326 "gram.c" /* yacc.c:1646  */
    break;

  case 1269:
#line 8669 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37339 "gram.c" /* yacc.c:1646  */
    break;

  case 1270:
#line 8678 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37353 "gram.c" /* yacc.c:1646  */
    break;

  case 1271:
#line 8688 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 37367 "gram.c" /* yacc.c:1646  */
    break;

  case 1272:
#line 8698 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37380 "gram.c" /* yacc.c:1646  */
    break;

  case 1273:
#line 8707 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37393 "gram.c" /* yacc.c:1646  */
    break;

  case 1274:
#line 8716 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37406 "gram.c" /* yacc.c:1646  */
    break;

  case 1275:
#line 8725 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37419 "gram.c" /* yacc.c:1646  */
    break;

  case 1276:
#line 8734 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37432 "gram.c" /* yacc.c:1646  */
    break;

  case 1277:
#line 8743 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37445 "gram.c" /* yacc.c:1646  */
    break;

  case 1278:
#line 8752 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37459 "gram.c" /* yacc.c:1646  */
    break;

  case 1279:
#line 8762 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 37473 "gram.c" /* yacc.c:1646  */
    break;

  case 1280:
#line 8772 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37487 "gram.c" /* yacc.c:1646  */
    break;

  case 1281:
#line 8782 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 37501 "gram.c" /* yacc.c:1646  */
    break;

  case 1282:
#line 8792 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37515 "gram.c" /* yacc.c:1646  */
    break;

  case 1283:
#line 8802 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 37529 "gram.c" /* yacc.c:1646  */
    break;

  case 1284:
#line 8812 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37543 "gram.c" /* yacc.c:1646  */
    break;

  case 1285:
#line 8822 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 37557 "gram.c" /* yacc.c:1646  */
    break;

  case 1286:
#line 8832 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37571 "gram.c" /* yacc.c:1646  */
    break;

  case 1287:
#line 8842 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 37585 "gram.c" /* yacc.c:1646  */
    break;

  case 1288:
#line 8852 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37599 "gram.c" /* yacc.c:1646  */
    break;

  case 1289:
#line 8862 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 37613 "gram.c" /* yacc.c:1646  */
    break;

  case 1290:
#line 8872 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37628 "gram.c" /* yacc.c:1646  */
    break;

  case 1291:
#line 8883 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 37643 "gram.c" /* yacc.c:1646  */
    break;

  case 1292:
#line 8894 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_VIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37658 "gram.c" /* yacc.c:1646  */
    break;

  case 1293:
#line 8905 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_VIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 37673 "gram.c" /* yacc.c:1646  */
    break;

  case 1294:
#line 8916 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37688 "gram.c" /* yacc.c:1646  */
    break;

  case 1295:
#line 8927 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 37703 "gram.c" /* yacc.c:1646  */
    break;

  case 1296:
#line 8938 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37717 "gram.c" /* yacc.c:1646  */
    break;

  case 1297:
#line 8948 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 37731 "gram.c" /* yacc.c:1646  */
    break;

  case 1298:
#line 8958 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37746 "gram.c" /* yacc.c:1646  */
    break;

  case 1299:
#line 8969 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 37761 "gram.c" /* yacc.c:1646  */
    break;

  case 1300:
#line 8980 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_RULE;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37775 "gram.c" /* yacc.c:1646  */
    break;

  case 1301:
#line 8990 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37789 "gram.c" /* yacc.c:1646  */
    break;

  case 1302:
#line 9000 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 37801 "gram.c" /* yacc.c:1646  */
    break;

  case 1303:
#line 9008 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37814 "gram.c" /* yacc.c:1646  */
    break;

  case 1304:
#line 9017 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37827 "gram.c" /* yacc.c:1646  */
    break;

  case 1305:
#line 9026 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37840 "gram.c" /* yacc.c:1646  */
    break;

  case 1306:
#line 9035 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37853 "gram.c" /* yacc.c:1646  */
    break;

  case 1307:
#line 9044 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37866 "gram.c" /* yacc.c:1646  */
    break;

  case 1308:
#line 9053 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37879 "gram.c" /* yacc.c:1646  */
    break;

  case 1309:
#line 9062 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37892 "gram.c" /* yacc.c:1646  */
    break;

  case 1310:
#line 9071 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37905 "gram.c" /* yacc.c:1646  */
    break;

  case 1311:
#line 9080 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37918 "gram.c" /* yacc.c:1646  */
    break;

  case 1312:
#line 9089 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ATTRIBUTE;
					n->relationType = OBJECT_TYPE;
					n->relation = makeRangeVarFromAnyName((yyvsp[-6].list), (yylsp[-6]), yyscanner);
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37934 "gram.c" /* yacc.c:1646  */
    break;

  case 1313:
#line 9102 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COLUMN; }
#line 37940 "gram.c" /* yacc.c:1646  */
    break;

  case 1314:
#line 9103 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 37946 "gram.c" /* yacc.c:1646  */
    break;

  case 1315:
#line 9106 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 1; }
#line 37952 "gram.c" /* yacc.c:1646  */
    break;

  case 1316:
#line 9107 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 37958 "gram.c" /* yacc.c:1646  */
    break;

  case 1317:
#line 9118 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *)n;
				}
#line 37971 "gram.c" /* yacc.c:1646  */
    break;

  case 1318:
#line 9127 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *)n;
				}
#line 37984 "gram.c" /* yacc.c:1646  */
    break;

  case 1319:
#line 9136 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *)n;
				}
#line 37997 "gram.c" /* yacc.c:1646  */
    break;

  case 1320:
#line 9145 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-5].range);
					n->object = (Node *) list_make1(makeString((yyvsp[-7].str)));
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *)n;
				}
#line 38011 "gram.c" /* yacc.c:1646  */
    break;

  case 1321:
#line 9155 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *)n;
				}
#line 38024 "gram.c" /* yacc.c:1646  */
    break;

  case 1322:
#line 9164 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_INDEX;
					n->relation = (yyvsp[-5].range);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *)n;
				}
#line 38037 "gram.c" /* yacc.c:1646  */
    break;

  case 1323:
#line 9174 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 38043 "gram.c" /* yacc.c:1646  */
    break;

  case 1324:
#line 9175 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false;	}
#line 38049 "gram.c" /* yacc.c:1646  */
    break;

  case 1325:
#line 9186 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38062 "gram.c" /* yacc.c:1646  */
    break;

  case 1326:
#line 9195 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38075 "gram.c" /* yacc.c:1646  */
    break;

  case 1327:
#line 9204 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38088 "gram.c" /* yacc.c:1646  */
    break;

  case 1328:
#line 9213 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38101 "gram.c" /* yacc.c:1646  */
    break;

  case 1329:
#line 9222 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_EXTENSION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38114 "gram.c" /* yacc.c:1646  */
    break;

  case 1330:
#line 9231 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38127 "gram.c" /* yacc.c:1646  */
    break;

  case 1331:
#line 9240 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38140 "gram.c" /* yacc.c:1646  */
    break;

  case 1332:
#line 9249 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38153 "gram.c" /* yacc.c:1646  */
    break;

  case 1333:
#line 9258 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38166 "gram.c" /* yacc.c:1646  */
    break;

  case 1334:
#line 9267 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38179 "gram.c" /* yacc.c:1646  */
    break;

  case 1335:
#line 9276 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38192 "gram.c" /* yacc.c:1646  */
    break;

  case 1336:
#line 9285 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38205 "gram.c" /* yacc.c:1646  */
    break;

  case 1337:
#line 9294 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38218 "gram.c" /* yacc.c:1646  */
    break;

  case 1338:
#line 9303 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38231 "gram.c" /* yacc.c:1646  */
    break;

  case 1339:
#line 9312 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38244 "gram.c" /* yacc.c:1646  */
    break;

  case 1340:
#line 9321 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38257 "gram.c" /* yacc.c:1646  */
    break;

  case 1341:
#line 9330 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38270 "gram.c" /* yacc.c:1646  */
    break;

  case 1342:
#line 9339 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38283 "gram.c" /* yacc.c:1646  */
    break;

  case 1343:
#line 9348 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38296 "gram.c" /* yacc.c:1646  */
    break;

  case 1344:
#line 9357 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38309 "gram.c" /* yacc.c:1646  */
    break;

  case 1345:
#line 9366 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38322 "gram.c" /* yacc.c:1646  */
    break;

  case 1346:
#line 9375 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38335 "gram.c" /* yacc.c:1646  */
    break;

  case 1347:
#line 9384 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38348 "gram.c" /* yacc.c:1646  */
    break;

  case 1348:
#line 9393 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38361 "gram.c" /* yacc.c:1646  */
    break;

  case 1349:
#line 9402 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38374 "gram.c" /* yacc.c:1646  */
    break;

  case 1350:
#line 9411 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38387 "gram.c" /* yacc.c:1646  */
    break;

  case 1351:
#line 9420 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38400 "gram.c" /* yacc.c:1646  */
    break;

  case 1352:
#line 9438 "gram.y" /* yacc.c:1646  */
    {
					AlterOperatorStmt *n = makeNode(AlterOperatorStmt);
					n->opername = (yyvsp[-4].objwithargs);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 38411 "gram.c" /* yacc.c:1646  */
    break;

  case 1353:
#line 9446 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 38417 "gram.c" /* yacc.c:1646  */
    break;

  case 1354:
#line 9447 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 38423 "gram.c" /* yacc.c:1646  */
    break;

  case 1355:
#line 9451 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2])); }
#line 38429 "gram.c" /* yacc.c:1646  */
    break;

  case 1356:
#line 9453 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2])); }
#line 38435 "gram.c" /* yacc.c:1646  */
    break;

  case 1357:
#line 9458 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].typnam); }
#line 38441 "gram.c" /* yacc.c:1646  */
    break;

  case 1358:
#line 9459 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[0].keyword))); }
#line 38447 "gram.c" /* yacc.c:1646  */
    break;

  case 1359:
#line 9460 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].list); }
#line 38453 "gram.c" /* yacc.c:1646  */
    break;

  case 1360:
#line 9461 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].value); }
#line 38459 "gram.c" /* yacc.c:1646  */
    break;

  case 1361:
#line 9462 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString((yyvsp[0].str)); }
#line 38465 "gram.c" /* yacc.c:1646  */
    break;

  case 1362:
#line 9475 "gram.y" /* yacc.c:1646  */
    {
					AlterTypeStmt *n = makeNode(AlterTypeStmt);
					n->typeName = (yyvsp[-4].list);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 38476 "gram.c" /* yacc.c:1646  */
    break;

  case 1363:
#line 9490 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38488 "gram.c" /* yacc.c:1646  */
    break;

  case 1364:
#line 9498 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38500 "gram.c" /* yacc.c:1646  */
    break;

  case 1365:
#line 9506 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38512 "gram.c" /* yacc.c:1646  */
    break;

  case 1366:
#line 9514 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38524 "gram.c" /* yacc.c:1646  */
    break;

  case 1367:
#line 9522 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38536 "gram.c" /* yacc.c:1646  */
    break;

  case 1368:
#line 9530 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38548 "gram.c" /* yacc.c:1646  */
    break;

  case 1369:
#line 9538 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38560 "gram.c" /* yacc.c:1646  */
    break;

  case 1370:
#line 9546 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-3].value);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38572 "gram.c" /* yacc.c:1646  */
    break;

  case 1371:
#line 9554 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38584 "gram.c" /* yacc.c:1646  */
    break;

  case 1372:
#line 9562 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38596 "gram.c" /* yacc.c:1646  */
    break;

  case 1373:
#line 9570 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38608 "gram.c" /* yacc.c:1646  */
    break;

  case 1374:
#line 9578 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38620 "gram.c" /* yacc.c:1646  */
    break;

  case 1375:
#line 9586 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38632 "gram.c" /* yacc.c:1646  */
    break;

  case 1376:
#line 9594 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38644 "gram.c" /* yacc.c:1646  */
    break;

  case 1377:
#line 9602 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38656 "gram.c" /* yacc.c:1646  */
    break;

  case 1378:
#line 9610 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TABLESPACE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38668 "gram.c" /* yacc.c:1646  */
    break;

  case 1379:
#line 9618 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38680 "gram.c" /* yacc.c:1646  */
    break;

  case 1380:
#line 9626 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38692 "gram.c" /* yacc.c:1646  */
    break;

  case 1381:
#line 9634 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38704 "gram.c" /* yacc.c:1646  */
    break;

  case 1382:
#line 9642 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38716 "gram.c" /* yacc.c:1646  */
    break;

  case 1383:
#line 9650 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38728 "gram.c" /* yacc.c:1646  */
    break;

  case 1384:
#line 9658 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38740 "gram.c" /* yacc.c:1646  */
    break;

  case 1385:
#line 9666 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38752 "gram.c" /* yacc.c:1646  */
    break;

  case 1386:
#line 9674 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38764 "gram.c" /* yacc.c:1646  */
    break;

  case 1387:
#line 9692 "gram.y" /* yacc.c:1646  */
    {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);
					n->pubname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					if ((yyvsp[-1].node) != NULL)
					{
						/* FOR TABLE */
						if (IsA((yyvsp[-1].node), List))
							n->tables = (List *)(yyvsp[-1].node);
						/* FOR ALL TABLES */
						else
							n->for_all_tables = true;
					}
					(yyval.node) = (Node *)n;
				}
#line 38784 "gram.c" /* yacc.c:1646  */
    break;

  case 1388:
#line 9710 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 38790 "gram.c" /* yacc.c:1646  */
    break;

  case 1389:
#line 9711 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 38796 "gram.c" /* yacc.c:1646  */
    break;

  case 1390:
#line 9716 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) (yyvsp[0].list);
				}
#line 38804 "gram.c" /* yacc.c:1646  */
    break;

  case 1391:
#line 9720 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeInteger(true);
				}
#line 38812 "gram.c" /* yacc.c:1646  */
    break;

  case 1392:
#line 9740 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);
					n->pubname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 38823 "gram.c" /* yacc.c:1646  */
    break;

  case 1393:
#line 9747 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);
					n->pubname = (yyvsp[-3].str);
					n->tables = (yyvsp[0].list);
					n->tableAction = DEFELEM_ADD;
					(yyval.node) = (Node *)n;
				}
#line 38835 "gram.c" /* yacc.c:1646  */
    break;

  case 1394:
#line 9755 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);
					n->pubname = (yyvsp[-3].str);
					n->tables = (yyvsp[0].list);
					n->tableAction = DEFELEM_SET;
					(yyval.node) = (Node *)n;
				}
#line 38847 "gram.c" /* yacc.c:1646  */
    break;

  case 1395:
#line 9763 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);
					n->pubname = (yyvsp[-3].str);
					n->tables = (yyvsp[0].list);
					n->tableAction = DEFELEM_DROP;
					(yyval.node) = (Node *)n;
				}
#line 38859 "gram.c" /* yacc.c:1646  */
    break;

  case 1396:
#line 9780 "gram.y" /* yacc.c:1646  */
    {
					CreateSubscriptionStmt *n =
						makeNode(CreateSubscriptionStmt);
					n->subname = (yyvsp[-5].str);
					n->conninfo = (yyvsp[-3].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 38873 "gram.c" /* yacc.c:1646  */
    break;

  case 1397:
#line 9793 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].value));
				}
#line 38881 "gram.c" /* yacc.c:1646  */
    break;

  case 1398:
#line 9797 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value));
				}
#line 38889 "gram.c" /* yacc.c:1646  */
    break;

  case 1399:
#line 9803 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 38895 "gram.c" /* yacc.c:1646  */
    break;

  case 1400:
#line 9813 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_OPTIONS;
					n->subname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 38908 "gram.c" /* yacc.c:1646  */
    break;

  case 1401:
#line 9822 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_CONNECTION;
					n->subname = (yyvsp[-2].str);
					n->conninfo = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 38921 "gram.c" /* yacc.c:1646  */
    break;

  case 1402:
#line 9831 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_REFRESH;
					n->subname = (yyvsp[-3].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 38934 "gram.c" /* yacc.c:1646  */
    break;

  case 1403:
#line 9840 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 38948 "gram.c" /* yacc.c:1646  */
    break;

  case 1404:
#line 9850 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *)makeInteger(true), (yylsp[-3])));
					(yyval.node) = (Node *)n;
				}
#line 38962 "gram.c" /* yacc.c:1646  */
    break;

  case 1405:
#line 9860 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *)makeInteger(false), (yylsp[-3])));
					(yyval.node) = (Node *)n;
				}
#line 38976 "gram.c" /* yacc.c:1646  */
    break;

  case 1406:
#line 9878 "gram.y" /* yacc.c:1646  */
    {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);
					n->subname = (yyvsp[-1].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 38988 "gram.c" /* yacc.c:1646  */
    break;

  case 1407:
#line 9886 "gram.y" /* yacc.c:1646  */
    {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);
					n->subname = (yyvsp[-1].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 39000 "gram.c" /* yacc.c:1646  */
    break;

  case 1408:
#line 9904 "gram.y" /* yacc.c:1646  */
    {
					RuleStmt *n = makeNode(RuleStmt);
					n->replace = (yyvsp[-11].boolean);
					n->relation = (yyvsp[-4].range);
					n->rulename = (yyvsp[-9].str);
					n->whereClause = (yyvsp[-3].node);
					n->event = (yyvsp[-6].ival);
					n->instead = (yyvsp[-1].boolean);
					n->actions = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 39016 "gram.c" /* yacc.c:1646  */
    break;

  case 1409:
#line 9918 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 39022 "gram.c" /* yacc.c:1646  */
    break;

  case 1410:
#line 9919 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 39028 "gram.c" /* yacc.c:1646  */
    break;

  case 1411:
#line 9920 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 39034 "gram.c" /* yacc.c:1646  */
    break;

  case 1412:
#line 9926 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				  else
					(yyval.list) = (yyvsp[-2].list);
				}
#line 39044 "gram.c" /* yacc.c:1646  */
    break;

  case 1413:
#line 9932 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = list_make1((yyvsp[0].node));
				  else
					(yyval.list) = NIL;
				}
#line 39054 "gram.c" /* yacc.c:1646  */
    break;

  case 1419:
#line 9948 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 39060 "gram.c" /* yacc.c:1646  */
    break;

  case 1420:
#line 9949 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 39066 "gram.c" /* yacc.c:1646  */
    break;

  case 1421:
#line 9952 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_SELECT; }
#line 39072 "gram.c" /* yacc.c:1646  */
    break;

  case 1422:
#line 9953 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_UPDATE; }
#line 39078 "gram.c" /* yacc.c:1646  */
    break;

  case 1423:
#line 9954 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_DELETE; }
#line 39084 "gram.c" /* yacc.c:1646  */
    break;

  case 1424:
#line 9955 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_INSERT; }
#line 39090 "gram.c" /* yacc.c:1646  */
    break;

  case 1425:
#line 9959 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 39096 "gram.c" /* yacc.c:1646  */
    break;

  case 1426:
#line 9960 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 39102 "gram.c" /* yacc.c:1646  */
    break;

  case 1427:
#line 9961 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 39108 "gram.c" /* yacc.c:1646  */
    break;

  case 1428:
#line 9974 "gram.y" /* yacc.c:1646  */
    {
					NotifyStmt *n = makeNode(NotifyStmt);
					n->conditionname = (yyvsp[-1].str);
					n->payload = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39119 "gram.c" /* yacc.c:1646  */
    break;

  case 1429:
#line 9983 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 39125 "gram.c" /* yacc.c:1646  */
    break;

  case 1430:
#line 9984 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 39131 "gram.c" /* yacc.c:1646  */
    break;

  case 1431:
#line 9988 "gram.y" /* yacc.c:1646  */
    {
					ListenStmt *n = makeNode(ListenStmt);
					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39141 "gram.c" /* yacc.c:1646  */
    break;

  case 1432:
#line 9997 "gram.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39151 "gram.c" /* yacc.c:1646  */
    break;

  case 1433:
#line 10003 "gram.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = NULL;
					(yyval.node) = (Node *)n;
				}
#line 39161 "gram.c" /* yacc.c:1646  */
    break;

  case 1434:
#line 10022 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 39173 "gram.c" /* yacc.c:1646  */
    break;

  case 1435:
#line 10030 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 39184 "gram.c" /* yacc.c:1646  */
    break;

  case 1436:
#line 10037 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 39195 "gram.c" /* yacc.c:1646  */
    break;

  case 1437:
#line 10044 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 39207 "gram.c" /* yacc.c:1646  */
    break;

  case 1438:
#line 10052 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 39219 "gram.c" /* yacc.c:1646  */
    break;

  case 1439:
#line 10060 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 39231 "gram.c" /* yacc.c:1646  */
    break;

  case 1440:
#line 10068 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_SAVEPOINT;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39242 "gram.c" /* yacc.c:1646  */
    break;

  case 1441:
#line 10075 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39253 "gram.c" /* yacc.c:1646  */
    break;

  case 1442:
#line 10082 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39264 "gram.c" /* yacc.c:1646  */
    break;

  case 1443:
#line 10089 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39275 "gram.c" /* yacc.c:1646  */
    break;

  case 1444:
#line 10096 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39286 "gram.c" /* yacc.c:1646  */
    break;

  case 1445:
#line 10103 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39297 "gram.c" /* yacc.c:1646  */
    break;

  case 1446:
#line 10110 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39308 "gram.c" /* yacc.c:1646  */
    break;

  case 1447:
#line 10117 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39319 "gram.c" /* yacc.c:1646  */
    break;

  case 1448:
#line 10125 "gram.y" /* yacc.c:1646  */
    {}
#line 39325 "gram.c" /* yacc.c:1646  */
    break;

  case 1449:
#line 10126 "gram.y" /* yacc.c:1646  */
    {}
#line 39331 "gram.c" /* yacc.c:1646  */
    break;

  case 1450:
#line 10127 "gram.y" /* yacc.c:1646  */
    {}
#line 39337 "gram.c" /* yacc.c:1646  */
    break;

  case 1451:
#line 10132 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[0].str), (yylsp[0])), (yylsp[-2])); }
#line 39344 "gram.c" /* yacc.c:1646  */
    break;

  case 1452:
#line 10135 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(true, (yylsp[-1])), (yylsp[-1])); }
#line 39351 "gram.c" /* yacc.c:1646  */
    break;

  case 1453:
#line 10138 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(false, (yylsp[-1])), (yylsp[-1])); }
#line 39358 "gram.c" /* yacc.c:1646  */
    break;

  case 1454:
#line 10141 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(true, (yylsp[0])), (yylsp[0])); }
#line 39365 "gram.c" /* yacc.c:1646  */
    break;

  case 1455:
#line 10144 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(false, (yylsp[-1])), (yylsp[-1])); }
#line 39372 "gram.c" /* yacc.c:1646  */
    break;

  case 1456:
#line 10151 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 39378 "gram.c" /* yacc.c:1646  */
    break;

  case 1457:
#line 10153 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 39384 "gram.c" /* yacc.c:1646  */
    break;

  case 1458:
#line 10155 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 39390 "gram.c" /* yacc.c:1646  */
    break;

  case 1460:
#line 10161 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 39396 "gram.c" /* yacc.c:1646  */
    break;

  case 1461:
#line 10165 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 39402 "gram.c" /* yacc.c:1646  */
    break;

  case 1462:
#line 10166 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 39408 "gram.c" /* yacc.c:1646  */
    break;

  case 1463:
#line 10167 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 39414 "gram.c" /* yacc.c:1646  */
    break;

  case 1464:
#line 10181 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 39430 "gram.c" /* yacc.c:1646  */
    break;

  case 1465:
#line 10194 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 39446 "gram.c" /* yacc.c:1646  */
    break;

  case 1466:
#line 10207 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 39467 "gram.c" /* yacc.c:1646  */
    break;

  case 1467:
#line 10225 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 39488 "gram.c" /* yacc.c:1646  */
    break;

  case 1468:
#line 10244 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 39494 "gram.c" /* yacc.c:1646  */
    break;

  case 1469:
#line 10245 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 39500 "gram.c" /* yacc.c:1646  */
    break;

  case 1470:
#line 10246 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LOCAL_CHECK_OPTION; }
#line 39506 "gram.c" /* yacc.c:1646  */
    break;

  case 1471:
#line 10247 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = NO_CHECK_OPTION; }
#line 39512 "gram.c" /* yacc.c:1646  */
    break;

  case 1472:
#line 10258 "gram.y" /* yacc.c:1646  */
    {
					LoadStmt *n = makeNode(LoadStmt);
					n->filename = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39522 "gram.c" /* yacc.c:1646  */
    break;

  case 1473:
#line 10274 "gram.y" /* yacc.c:1646  */
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);
					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 39533 "gram.c" /* yacc.c:1646  */
    break;

  case 1474:
#line 10283 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 39539 "gram.c" /* yacc.c:1646  */
    break;

  case 1475:
#line 10284 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 39545 "gram.c" /* yacc.c:1646  */
    break;

  case 1476:
#line 10288 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 39551 "gram.c" /* yacc.c:1646  */
    break;

  case 1477:
#line 10289 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 39557 "gram.c" /* yacc.c:1646  */
    break;

  case 1478:
#line 10294 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 39565 "gram.c" /* yacc.c:1646  */
    break;

  case 1479:
#line 10298 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 39573 "gram.c" /* yacc.c:1646  */
    break;

  case 1480:
#line 10302 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2]));
				}
#line 39581 "gram.c" /* yacc.c:1646  */
    break;

  case 1481:
#line 10319 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 39587 "gram.c" /* yacc.c:1646  */
    break;

  case 1482:
#line 10320 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup("connection_limit"); }
#line 39593 "gram.c" /* yacc.c:1646  */
    break;

  case 1483:
#line 10321 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 39599 "gram.c" /* yacc.c:1646  */
    break;

  case 1484:
#line 10322 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 39605 "gram.c" /* yacc.c:1646  */
    break;

  case 1485:
#line 10323 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 39611 "gram.c" /* yacc.c:1646  */
    break;

  case 1486:
#line 10324 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 39617 "gram.c" /* yacc.c:1646  */
    break;

  case 1487:
#line 10325 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 39623 "gram.c" /* yacc.c:1646  */
    break;

  case 1488:
#line 10332 "gram.y" /* yacc.c:1646  */
    {}
#line 39629 "gram.c" /* yacc.c:1646  */
    break;

  case 1489:
#line 10333 "gram.y" /* yacc.c:1646  */
    {}
#line 39635 "gram.c" /* yacc.c:1646  */
    break;

  case 1490:
#line 10345 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 39646 "gram.c" /* yacc.c:1646  */
    break;

  case 1491:
#line 10352 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 39657 "gram.c" /* yacc.c:1646  */
    break;

  case 1492:
#line 10359 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-3].str);
					n->options = list_make1(makeDefElem("tablespace",
														(Node *)makeString((yyvsp[0].str)), (yylsp[0])));
					(yyval.node) = (Node *)n;
				 }
#line 39669 "gram.c" /* yacc.c:1646  */
    break;

  case 1493:
#line 10370 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);
					n->dbname = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 39680 "gram.c" /* yacc.c:1646  */
    break;

  case 1494:
#line 10387 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[0].str);
					n->missing_ok = false;
					n->options = NULL;
					(yyval.node) = (Node *)n;
				}
#line 39692 "gram.c" /* yacc.c:1646  */
    break;

  case 1495:
#line 10395 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[0].str);
					n->missing_ok = true;
					n->options = NULL;
					(yyval.node) = (Node *)n;
				}
#line 39704 "gram.c" /* yacc.c:1646  */
    break;

  case 1496:
#line 10403 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[-4].str);
					n->missing_ok = false;
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 39716 "gram.c" /* yacc.c:1646  */
    break;

  case 1497:
#line 10411 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[-4].str);
					n->missing_ok = true;
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 39728 "gram.c" /* yacc.c:1646  */
    break;

  case 1498:
#line 10422 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((Node *) (yyvsp[0].defelt));
				}
#line 39736 "gram.c" /* yacc.c:1646  */
    break;

  case 1499:
#line 10426 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (Node *) (yyvsp[0].defelt));
				}
#line 39744 "gram.c" /* yacc.c:1646  */
    break;

  case 1500:
#line 10437 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force", NULL, (yylsp[0]));
				}
#line 39752 "gram.c" /* yacc.c:1646  */
    break;

  case 1501:
#line 10449 "gram.y" /* yacc.c:1646  */
    {
					AlterCollationStmt *n = makeNode(AlterCollationStmt);
					n->collname = (yyvsp[-2].list);
					(yyval.node) = (Node *)n;
				}
#line 39762 "gram.c" /* yacc.c:1646  */
    break;

  case 1502:
#line 10466 "gram.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 39772 "gram.c" /* yacc.c:1646  */
    break;

  case 1503:
#line 10472 "gram.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 39782 "gram.c" /* yacc.c:1646  */
    break;

  case 1504:
#line 10488 "gram.y" /* yacc.c:1646  */
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);
					n->domainname = (yyvsp[-3].list);
					n->typeName = (yyvsp[-1].typnam);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 39795 "gram.c" /* yacc.c:1646  */
    break;

  case 1505:
#line 10501 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'T';
					n->typeName = (yyvsp[-1].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 39807 "gram.c" /* yacc.c:1646  */
    break;

  case 1506:
#line 10510 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'N';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *)n;
				}
#line 39818 "gram.c" /* yacc.c:1646  */
    break;

  case 1507:
#line 10518 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'O';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *)n;
				}
#line 39829 "gram.c" /* yacc.c:1646  */
    break;

  case 1508:
#line 10526 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'C';
					n->typeName = (yyvsp[-2].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 39841 "gram.c" /* yacc.c:1646  */
    break;

  case 1509:
#line 10535 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[-4].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39855 "gram.c" /* yacc.c:1646  */
    break;

  case 1510:
#line 10546 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[-6].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 39869 "gram.c" /* yacc.c:1646  */
    break;

  case 1511:
#line 10557 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'V';
					n->typeName = (yyvsp[-3].list);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39881 "gram.c" /* yacc.c:1646  */
    break;

  case 1512:
#line 10566 "gram.y" /* yacc.c:1646  */
    {}
#line 39887 "gram.c" /* yacc.c:1646  */
    break;

  case 1513:
#line 10567 "gram.y" /* yacc.c:1646  */
    {}
#line 39893 "gram.c" /* yacc.c:1646  */
    break;

  case 1514:
#line 10579 "gram.y" /* yacc.c:1646  */
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);
					n->dictname = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 39904 "gram.c" /* yacc.c:1646  */
    break;

  case 1515:
#line 10589 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_ADD_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
#line 39919 "gram.c" /* yacc.c:1646  */
    break;

  case 1516:
#line 10600 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_ALTER_MAPPING_FOR_TOKEN;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
#line 39934 "gram.c" /* yacc.c:1646  */
    break;

  case 1517:
#line 10611 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_REPLACE_DICT;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
#line 39949 "gram.c" /* yacc.c:1646  */
    break;

  case 1518:
#line 10622 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_REPLACE_DICT_FOR_TOKEN;
					n->cfgname = (yyvsp[-8].list);
					n->tokentype = (yyvsp[-4].list);
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
#line 39964 "gram.c" /* yacc.c:1646  */
    break;

  case 1519:
#line 10633 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-4].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node*)n;
				}
#line 39977 "gram.c" /* yacc.c:1646  */
    break;

  case 1520:
#line 10642 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node*)n;
				}
#line 39990 "gram.c" /* yacc.c:1646  */
    break;

  case 1521:
#line 10653 "gram.y" /* yacc.c:1646  */
    {}
#line 39996 "gram.c" /* yacc.c:1646  */
    break;

  case 1522:
#line 10654 "gram.y" /* yacc.c:1646  */
    {}
#line 40002 "gram.c" /* yacc.c:1646  */
    break;

  case 1523:
#line 10670 "gram.y" /* yacc.c:1646  */
    {
				CreateConversionStmt *n = makeNode(CreateConversionStmt);
				n->conversion_name = (yyvsp[-6].list);
				n->for_encoding_name = (yyvsp[-4].str);
				n->to_encoding_name = (yyvsp[-2].str);
				n->func_name = (yyvsp[0].list);
				n->def = (yyvsp[-8].boolean);
				(yyval.node) = (Node *)n;
			}
#line 40016 "gram.c" /* yacc.c:1646  */
    break;

  case 1524:
#line 10692 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->options = 0;
					if ((yyvsp[-2].boolean))
						n->options |= CLUOPT_VERBOSE;
					(yyval.node) = (Node*)n;
				}
#line 40030 "gram.c" /* yacc.c:1646  */
    break;

  case 1525:
#line 10702 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = NULL;
					n->indexname = NULL;
					n->options = 0;
					if ((yyvsp[0].boolean))
						n->options |= CLUOPT_VERBOSE;
					(yyval.node) = (Node*)n;
				}
#line 40044 "gram.c" /* yacc.c:1646  */
    break;

  case 1526:
#line 10713 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[0].range);
					n->indexname = (yyvsp[-2].str);
					n->options = 0;
					if ((yyvsp[-3].boolean))
						n->options |= CLUOPT_VERBOSE;
					(yyval.node) = (Node*)n;
				}
#line 40058 "gram.c" /* yacc.c:1646  */
    break;

  case 1527:
#line 10725 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40064 "gram.c" /* yacc.c:1646  */
    break;

  case 1528:
#line 10726 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 40070 "gram.c" /* yacc.c:1646  */
    break;

  case 1529:
#line 10739 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = NIL;
					if ((yyvsp[-4].boolean))
						n->options = lappend(n->options,
											 makeDefElem("full", NULL, (yylsp[-4])));
					if ((yyvsp[-3].boolean))
						n->options = lappend(n->options,
											 makeDefElem("freeze", NULL, (yylsp[-3])));
					if ((yyvsp[-2].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-2])));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("analyze", NULL, (yylsp[-1])));
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = true;
					(yyval.node) = (Node *)n;
				}
#line 40094 "gram.c" /* yacc.c:1646  */
    break;

  case 1530:
#line 10759 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = (yyvsp[-2].list);
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = true;
					(yyval.node) = (Node *) n;
				}
#line 40106 "gram.c" /* yacc.c:1646  */
    break;

  case 1531:
#line 10769 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = NIL;
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-1])));
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = false;
					(yyval.node) = (Node *)n;
				}
#line 40121 "gram.c" /* yacc.c:1646  */
    break;

  case 1532:
#line 10780 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = (yyvsp[-2].list);
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = false;
					(yyval.node) = (Node *) n;
				}
#line 40133 "gram.c" /* yacc.c:1646  */
    break;

  case 1533:
#line 10791 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 40141 "gram.c" /* yacc.c:1646  */
    break;

  case 1534:
#line 10795 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 40149 "gram.c" /* yacc.c:1646  */
    break;

  case 1535:
#line 10801 "gram.y" /* yacc.c:1646  */
    {}
#line 40155 "gram.c" /* yacc.c:1646  */
    break;

  case 1536:
#line 10802 "gram.y" /* yacc.c:1646  */
    {}
#line 40161 "gram.c" /* yacc.c:1646  */
    break;

  case 1537:
#line 10807 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 40169 "gram.c" /* yacc.c:1646  */
    break;

  case 1538:
#line 10813 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40175 "gram.c" /* yacc.c:1646  */
    break;

  case 1539:
#line 10814 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "analyze"; }
#line 40181 "gram.c" /* yacc.c:1646  */
    break;

  case 1540:
#line 10818 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 40187 "gram.c" /* yacc.c:1646  */
    break;

  case 1541:
#line 10819 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].value); }
#line 40193 "gram.c" /* yacc.c:1646  */
    break;

  case 1542:
#line 10820 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 40199 "gram.c" /* yacc.c:1646  */
    break;

  case 1543:
#line 10824 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 40205 "gram.c" /* yacc.c:1646  */
    break;

  case 1544:
#line 10825 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 40211 "gram.c" /* yacc.c:1646  */
    break;

  case 1545:
#line 10829 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 40217 "gram.c" /* yacc.c:1646  */
    break;

  case 1546:
#line 10830 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 40223 "gram.c" /* yacc.c:1646  */
    break;

  case 1547:
#line 10833 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 40229 "gram.c" /* yacc.c:1646  */
    break;

  case 1548:
#line 10834 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 40235 "gram.c" /* yacc.c:1646  */
    break;

  case 1549:
#line 10837 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 40241 "gram.c" /* yacc.c:1646  */
    break;

  case 1550:
#line 10838 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 40247 "gram.c" /* yacc.c:1646  */
    break;

  case 1551:
#line 10842 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 40253 "gram.c" /* yacc.c:1646  */
    break;

  case 1552:
#line 10843 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40259 "gram.c" /* yacc.c:1646  */
    break;

  case 1553:
#line 10848 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeVacuumRelation((yyvsp[-1].range), InvalidOid, (yyvsp[0].list));
				}
#line 40267 "gram.c" /* yacc.c:1646  */
    break;

  case 1554:
#line 10855 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 40273 "gram.c" /* yacc.c:1646  */
    break;

  case 1555:
#line 10857 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 40279 "gram.c" /* yacc.c:1646  */
    break;

  case 1556:
#line 10861 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 40285 "gram.c" /* yacc.c:1646  */
    break;

  case 1557:
#line 10862 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40291 "gram.c" /* yacc.c:1646  */
    break;

  case 1558:
#line 10876 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 40302 "gram.c" /* yacc.c:1646  */
    break;

  case 1559:
#line 10883 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("analyze", NULL, (yylsp[-2])));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 40316 "gram.c" /* yacc.c:1646  */
    break;

  case 1560:
#line 10893 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 40327 "gram.c" /* yacc.c:1646  */
    break;

  case 1561:
#line 10900 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 40338 "gram.c" /* yacc.c:1646  */
    break;

  case 1571:
#line 10922 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 40346 "gram.c" /* yacc.c:1646  */
    break;

  case 1572:
#line 10926 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 40354 "gram.c" /* yacc.c:1646  */
    break;

  case 1573:
#line 10933 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 40362 "gram.c" /* yacc.c:1646  */
    break;

  case 1574:
#line 10939 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40368 "gram.c" /* yacc.c:1646  */
    break;

  case 1575:
#line 10940 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "analyze"; }
#line 40374 "gram.c" /* yacc.c:1646  */
    break;

  case 1576:
#line 10944 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 40380 "gram.c" /* yacc.c:1646  */
    break;

  case 1577:
#line 10945 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].value); }
#line 40386 "gram.c" /* yacc.c:1646  */
    break;

  case 1578:
#line 10946 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 40392 "gram.c" /* yacc.c:1646  */
    break;

  case 1579:
#line 10957 "gram.y" /* yacc.c:1646  */
    {
					PrepareStmt *n = makeNode(PrepareStmt);
					n->name = (yyvsp[-3].str);
					n->argtypes = (yyvsp[-2].list);
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 40404 "gram.c" /* yacc.c:1646  */
    break;

  case 1580:
#line 10966 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 40410 "gram.c" /* yacc.c:1646  */
    break;

  case 1581:
#line 10967 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40416 "gram.c" /* yacc.c:1646  */
    break;

  case 1586:
#line 10985 "gram.y" /* yacc.c:1646  */
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-1].str);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 40427 "gram.c" /* yacc.c:1646  */
    break;

  case 1587:
#line 10993 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-7].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 40447 "gram.c" /* yacc.c:1646  */
    break;

  case 1588:
#line 11010 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-10].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 40467 "gram.c" /* yacc.c:1646  */
    break;

  case 1589:
#line 11027 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 40473 "gram.c" /* yacc.c:1646  */
    break;

  case 1590:
#line 11028 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40479 "gram.c" /* yacc.c:1646  */
    break;

  case 1591:
#line 11039 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 40489 "gram.c" /* yacc.c:1646  */
    break;

  case 1592:
#line 11045 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 40499 "gram.c" /* yacc.c:1646  */
    break;

  case 1593:
#line 11051 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 40509 "gram.c" /* yacc.c:1646  */
    break;

  case 1594:
#line 11057 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 40519 "gram.c" /* yacc.c:1646  */
    break;

  case 1595:
#line 11074 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].istmt)->relation = (yyvsp[-3].range);
					(yyvsp[-2].istmt)->onConflictClause = (yyvsp[-1].onconflict);
					(yyvsp[-2].istmt)->returningList = (yyvsp[0].list);
					(yyvsp[-2].istmt)->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *) (yyvsp[-2].istmt);
				}
#line 40531 "gram.c" /* yacc.c:1646  */
    break;

  case 1596:
#line 11091 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 40539 "gram.c" /* yacc.c:1646  */
    break;

  case 1597:
#line 11095 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].range)->alias = makeAlias((yyvsp[0].str), NIL);
					(yyval.range) = (yyvsp[-2].range);
				}
#line 40548 "gram.c" /* yacc.c:1646  */
    break;

  case 1598:
#line 11103 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 40558 "gram.c" /* yacc.c:1646  */
    break;

  case 1599:
#line 11109 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 40569 "gram.c" /* yacc.c:1646  */
    break;

  case 1600:
#line 11116 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-2].list);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 40579 "gram.c" /* yacc.c:1646  */
    break;

  case 1601:
#line 11122 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-5].list);
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 40590 "gram.c" /* yacc.c:1646  */
    break;

  case 1602:
#line 11129 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
#line 40600 "gram.c" /* yacc.c:1646  */
    break;

  case 1603:
#line 11137 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OVERRIDING_USER_VALUE; }
#line 40606 "gram.c" /* yacc.c:1646  */
    break;

  case 1604:
#line 11138 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OVERRIDING_SYSTEM_VALUE; }
#line 40612 "gram.c" /* yacc.c:1646  */
    break;

  case 1605:
#line 11143 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 40618 "gram.c" /* yacc.c:1646  */
    break;

  case 1606:
#line 11145 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 40624 "gram.c" /* yacc.c:1646  */
    break;

  case 1607:
#line 11150 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[-1]);
				}
#line 40636 "gram.c" /* yacc.c:1646  */
    break;

  case 1608:
#line 11161 "gram.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_UPDATE;
					(yyval.onconflict)->infer = (yyvsp[-5].infer);
					(yyval.onconflict)->targetList = (yyvsp[-1].list);
					(yyval.onconflict)->whereClause = (yyvsp[0].node);
					(yyval.onconflict)->location = (yylsp[-7]);
				}
#line 40649 "gram.c" /* yacc.c:1646  */
    break;

  case 1609:
#line 11171 "gram.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_NOTHING;
					(yyval.onconflict)->infer = (yyvsp[-2].infer);
					(yyval.onconflict)->targetList = NIL;
					(yyval.onconflict)->whereClause = NULL;
					(yyval.onconflict)->location = (yylsp[-4]);
				}
#line 40662 "gram.c" /* yacc.c:1646  */
    break;

  case 1610:
#line 11180 "gram.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = NULL;
				}
#line 40670 "gram.c" /* yacc.c:1646  */
    break;

  case 1611:
#line 11187 "gram.y" /* yacc.c:1646  */
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = (yyvsp[-2].list);
					(yyval.infer)->whereClause = (yyvsp[0].node);
					(yyval.infer)->conname = NULL;
					(yyval.infer)->location = (yylsp[-3]);
				}
#line 40682 "gram.c" /* yacc.c:1646  */
    break;

  case 1612:
#line 11196 "gram.y" /* yacc.c:1646  */
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = NIL;
					(yyval.infer)->whereClause = NULL;
					(yyval.infer)->conname = (yyvsp[0].str);
					(yyval.infer)->location = (yylsp[-2]);
				}
#line 40694 "gram.c" /* yacc.c:1646  */
    break;

  case 1613:
#line 11204 "gram.y" /* yacc.c:1646  */
    {
					(yyval.infer) = NULL;
				}
#line 40702 "gram.c" /* yacc.c:1646  */
    break;

  case 1614:
#line 11210 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 40708 "gram.c" /* yacc.c:1646  */
    break;

  case 1615:
#line 11211 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40714 "gram.c" /* yacc.c:1646  */
    break;

  case 1616:
#line 11224 "gram.y" /* yacc.c:1646  */
    {
					DeleteStmt *n = makeNode(DeleteStmt);
					n->relation = (yyvsp[-3].range);
					n->usingClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *)n;
				}
#line 40728 "gram.c" /* yacc.c:1646  */
    break;

  case 1617:
#line 11236 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 40734 "gram.c" /* yacc.c:1646  */
    break;

  case 1618:
#line 11237 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40740 "gram.c" /* yacc.c:1646  */
    break;

  case 1619:
#line 11249 "gram.y" /* yacc.c:1646  */
    {
					LockStmt *n = makeNode(LockStmt);

					n->relations = (yyvsp[-2].list);
					n->mode = (yyvsp[-1].ival);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 40753 "gram.c" /* yacc.c:1646  */
    break;

  case 1620:
#line 11259 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival); }
#line 40759 "gram.c" /* yacc.c:1646  */
    break;

  case 1621:
#line 11260 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 40765 "gram.c" /* yacc.c:1646  */
    break;

  case 1622:
#line 11263 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessShareLock; }
#line 40771 "gram.c" /* yacc.c:1646  */
    break;

  case 1623:
#line 11264 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RowShareLock; }
#line 40777 "gram.c" /* yacc.c:1646  */
    break;

  case 1624:
#line 11265 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RowExclusiveLock; }
#line 40783 "gram.c" /* yacc.c:1646  */
    break;

  case 1625:
#line 11266 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareUpdateExclusiveLock; }
#line 40789 "gram.c" /* yacc.c:1646  */
    break;

  case 1626:
#line 11267 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareLock; }
#line 40795 "gram.c" /* yacc.c:1646  */
    break;

  case 1627:
#line 11268 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareRowExclusiveLock; }
#line 40801 "gram.c" /* yacc.c:1646  */
    break;

  case 1628:
#line 11269 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ExclusiveLock; }
#line 40807 "gram.c" /* yacc.c:1646  */
    break;

  case 1629:
#line 11270 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 40813 "gram.c" /* yacc.c:1646  */
    break;

  case 1630:
#line 11273 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 40819 "gram.c" /* yacc.c:1646  */
    break;

  case 1631:
#line 11274 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 40825 "gram.c" /* yacc.c:1646  */
    break;

  case 1632:
#line 11278 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitError; }
#line 40831 "gram.c" /* yacc.c:1646  */
    break;

  case 1633:
#line 11279 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitSkip; }
#line 40837 "gram.c" /* yacc.c:1646  */
    break;

  case 1634:
#line 11280 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitBlock; }
#line 40843 "gram.c" /* yacc.c:1646  */
    break;

  case 1635:
#line 11296 "gram.y" /* yacc.c:1646  */
    {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[-5].range);
					n->targetList = (yyvsp[-3].list);
					n->fromClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-7].with);
					(yyval.node) = (Node *)n;
				}
#line 40858 "gram.c" /* yacc.c:1646  */
    break;

  case 1636:
#line 11308 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 40864 "gram.c" /* yacc.c:1646  */
    break;

  case 1637:
#line 11309 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_concat((yyvsp[-2].list),(yyvsp[0].list)); }
#line 40870 "gram.c" /* yacc.c:1646  */
    break;

  case 1638:
#line 11314 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].target)->val = (Node *) (yyvsp[0].node);
					(yyval.list) = list_make1((yyvsp[-2].target));
				}
#line 40879 "gram.c" /* yacc.c:1646  */
    break;

  case 1639:
#line 11319 "gram.y" /* yacc.c:1646  */
    {
					int ncolumns = list_length((yyvsp[-3].list));
					int i = 1;
					ListCell *col_cell;

					/* Create a MultiAssignRef source for each target */
					foreach(col_cell, (yyvsp[-3].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						MultiAssignRef *r = makeNode(MultiAssignRef);

						r->source = (Node *) (yyvsp[0].node);
						r->colno = i;
						r->ncolumns = ncolumns;
						res_col->val = (Node *) r;
						i++;
					}

					(yyval.list) = (yyvsp[-3].list);
				}
#line 40904 "gram.c" /* yacc.c:1646  */
    break;

  case 1640:
#line 11343 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[-1]);
				}
#line 40916 "gram.c" /* yacc.c:1646  */
    break;

  case 1641:
#line 11353 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 40922 "gram.c" /* yacc.c:1646  */
    break;

  case 1642:
#line 11354 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].target)); }
#line 40928 "gram.c" /* yacc.c:1646  */
    break;

  case 1643:
#line 11365 "gram.y" /* yacc.c:1646  */
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);
					n->portalname = (yyvsp[-5].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[-4].ival) | (yyvsp[-2].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 40941 "gram.c" /* yacc.c:1646  */
    break;

  case 1644:
#line 11375 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40947 "gram.c" /* yacc.c:1646  */
    break;

  case 1645:
#line 11378 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 40953 "gram.c" /* yacc.c:1646  */
    break;

  case 1646:
#line 11379 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | CURSOR_OPT_NO_SCROLL; }
#line 40959 "gram.c" /* yacc.c:1646  */
    break;

  case 1647:
#line 11380 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_SCROLL; }
#line 40965 "gram.c" /* yacc.c:1646  */
    break;

  case 1648:
#line 11381 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_BINARY; }
#line 40971 "gram.c" /* yacc.c:1646  */
    break;

  case 1649:
#line 11382 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_INSENSITIVE; }
#line 40977 "gram.c" /* yacc.c:1646  */
    break;

  case 1650:
#line 11385 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 40983 "gram.c" /* yacc.c:1646  */
    break;

  case 1651:
#line 11386 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CURSOR_OPT_HOLD; }
#line 40989 "gram.c" /* yacc.c:1646  */
    break;

  case 1652:
#line 11387 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 40995 "gram.c" /* yacc.c:1646  */
    break;

  case 1655:
#line 11440 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 41001 "gram.c" /* yacc.c:1646  */
    break;

  case 1656:
#line 11441 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 41007 "gram.c" /* yacc.c:1646  */
    break;

  case 1657:
#line 11456 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41013 "gram.c" /* yacc.c:1646  */
    break;

  case 1658:
#line 11458 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 41024 "gram.c" /* yacc.c:1646  */
    break;

  case 1659:
#line 11465 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										(yyvsp[0].selectlimit),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 41036 "gram.c" /* yacc.c:1646  */
    break;

  case 1660:
#line 11473 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										(yyvsp[-1].selectlimit),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 41048 "gram.c" /* yacc.c:1646  */
    break;

  case 1661:
#line 11481 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[0].node), NULL, NIL,
										NULL,
										(yyvsp[-1].with),
										yyscanner);
					(yyval.node) = (yyvsp[0].node);
				}
#line 41060 "gram.c" /* yacc.c:1646  */
    break;

  case 1662:
#line 11489 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL,
										(yyvsp[-2].with),
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 41072 "gram.c" /* yacc.c:1646  */
    break;

  case 1663:
#line 11497 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										(yyvsp[0].selectlimit),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 41084 "gram.c" /* yacc.c:1646  */
    break;

  case 1664:
#line 11505 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										(yyvsp[-1].selectlimit),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 41096 "gram.c" /* yacc.c:1646  */
    break;

  case 1665:
#line 11515 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41102 "gram.c" /* yacc.c:1646  */
    break;

  case 1666:
#line 11516 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41108 "gram.c" /* yacc.c:1646  */
    break;

  case 1667:
#line 11546 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = (yyvsp[-2].list);
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 41124 "gram.c" /* yacc.c:1646  */
    break;

  case 1668:
#line 11560 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->distinctClause = (yyvsp[-7].list);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = (yyvsp[-2].list);
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 41141 "gram.c" /* yacc.c:1646  */
    break;

  case 1669:
#line 11572 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41147 "gram.c" /* yacc.c:1646  */
    break;

  case 1670:
#line 11574 "gram.y" /* yacc.c:1646  */
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef *cr = makeNode(ColumnRef);
					ResTarget *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *)cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[0].range));
					(yyval.node) = (Node *)n;
				}
#line 41170 "gram.c" /* yacc.c:1646  */
    break;

  case 1671:
#line 11593 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 41178 "gram.c" /* yacc.c:1646  */
    break;

  case 1672:
#line 11597 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 41186 "gram.c" /* yacc.c:1646  */
    break;

  case 1673:
#line 11601 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 41194 "gram.c" /* yacc.c:1646  */
    break;

  case 1674:
#line 11618 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 41205 "gram.c" /* yacc.c:1646  */
    break;

  case 1675:
#line 11625 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 41216 "gram.c" /* yacc.c:1646  */
    break;

  case 1676:
#line 11632 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[-2]);
			}
#line 41227 "gram.c" /* yacc.c:1646  */
    break;

  case 1677:
#line 11641 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 41233 "gram.c" /* yacc.c:1646  */
    break;

  case 1678:
#line 11642 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 41239 "gram.c" /* yacc.c:1646  */
    break;

  case 1679:
#line 11646 "gram.y" /* yacc.c:1646  */
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);
				n->ctename = (yyvsp[-6].str);
				n->aliascolnames = (yyvsp[-5].list);
				n->ctematerialized = (yyvsp[-3].ival);
				n->ctequery = (yyvsp[-1].node);
				n->location = (yylsp[-6]);
				(yyval.node) = (Node *) n;
			}
#line 41253 "gram.c" /* yacc.c:1646  */
    break;

  case 1680:
#line 11658 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeAlways; }
#line 41259 "gram.c" /* yacc.c:1646  */
    break;

  case 1681:
#line 11659 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeNever; }
#line 41265 "gram.c" /* yacc.c:1646  */
    break;

  case 1682:
#line 11660 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeDefault; }
#line 41271 "gram.c" /* yacc.c:1646  */
    break;

  case 1683:
#line 11664 "gram.y" /* yacc.c:1646  */
    { (yyval.with) = (yyvsp[0].with); }
#line 41277 "gram.c" /* yacc.c:1646  */
    break;

  case 1684:
#line 11665 "gram.y" /* yacc.c:1646  */
    { (yyval.with) = NULL; }
#line 41283 "gram.c" /* yacc.c:1646  */
    break;

  case 1685:
#line 11670 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[0].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;
				}
#line 41298 "gram.c" /* yacc.c:1646  */
    break;

  case 1686:
#line 11681 "gram.y" /* yacc.c:1646  */
    { (yyval.into) = NULL; }
#line 41304 "gram.c" /* yacc.c:1646  */
    break;

  case 1687:
#line 11690 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 41313 "gram.c" /* yacc.c:1646  */
    break;

  case 1688:
#line 11695 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 41322 "gram.c" /* yacc.c:1646  */
    break;

  case 1689:
#line 11700 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 41331 "gram.c" /* yacc.c:1646  */
    break;

  case 1690:
#line 11705 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 41340 "gram.c" /* yacc.c:1646  */
    break;

  case 1691:
#line 11710 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 41352 "gram.c" /* yacc.c:1646  */
    break;

  case 1692:
#line 11718 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 41364 "gram.c" /* yacc.c:1646  */
    break;

  case 1693:
#line 11726 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_UNLOGGED;
				}
#line 41373 "gram.c" /* yacc.c:1646  */
    break;

  case 1694:
#line 11731 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 41382 "gram.c" /* yacc.c:1646  */
    break;

  case 1695:
#line 11736 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 41391 "gram.c" /* yacc.c:1646  */
    break;

  case 1696:
#line 11742 "gram.y" /* yacc.c:1646  */
    {}
#line 41397 "gram.c" /* yacc.c:1646  */
    break;

  case 1697:
#line 11743 "gram.y" /* yacc.c:1646  */
    {}
#line 41403 "gram.c" /* yacc.c:1646  */
    break;

  case 1698:
#line 11747 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 41409 "gram.c" /* yacc.c:1646  */
    break;

  case 1699:
#line 11748 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 41415 "gram.c" /* yacc.c:1646  */
    break;

  case 1700:
#line 11749 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 41421 "gram.c" /* yacc.c:1646  */
    break;

  case 1701:
#line 11756 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(NIL); }
#line 41427 "gram.c" /* yacc.c:1646  */
    break;

  case 1702:
#line 11757 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 41433 "gram.c" /* yacc.c:1646  */
    break;

  case 1703:
#line 11761 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL;}
#line 41439 "gram.c" /* yacc.c:1646  */
    break;

  case 1704:
#line 11762 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41445 "gram.c" /* yacc.c:1646  */
    break;

  case 1705:
#line 11766 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list);}
#line 41451 "gram.c" /* yacc.c:1646  */
    break;

  case 1706:
#line 11767 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41457 "gram.c" /* yacc.c:1646  */
    break;

  case 1707:
#line 11771 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 41463 "gram.c" /* yacc.c:1646  */
    break;

  case 1708:
#line 11775 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].sortby)); }
#line 41469 "gram.c" /* yacc.c:1646  */
    break;

  case 1709:
#line 11776 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].sortby)); }
#line 41475 "gram.c" /* yacc.c:1646  */
    break;

  case 1710:
#line 11780 "gram.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-3].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = (yyvsp[-1].list);
					(yyval.sortby)->location = (yylsp[-1]);
				}
#line 41488 "gram.c" /* yacc.c:1646  */
    break;

  case 1711:
#line 11789 "gram.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-2].node);
					(yyval.sortby)->sortby_dir = (yyvsp[-1].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				}
#line 41501 "gram.c" /* yacc.c:1646  */
    break;

  case 1712:
#line 11802 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[-1].selectlimit);
					((yyval.selectlimit))->limitOffset = (yyvsp[0].node);
				}
#line 41510 "gram.c" /* yacc.c:1646  */
    break;

  case 1713:
#line 11807 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[0].selectlimit);
					((yyval.selectlimit))->limitOffset = (yyvsp[-1].node);
				}
#line 41519 "gram.c" /* yacc.c:1646  */
    break;

  case 1714:
#line 11812 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[0].selectlimit);
				}
#line 41527 "gram.c" /* yacc.c:1646  */
    break;

  case 1715:
#line 11816 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));
					n->limitOffset = (yyvsp[0].node);
					n->limitCount = NULL;
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 41539 "gram.c" /* yacc.c:1646  */
    break;

  case 1716:
#line 11826 "gram.y" /* yacc.c:1646  */
    { (yyval.selectlimit) = (yyvsp[0].selectlimit); }
#line 41545 "gram.c" /* yacc.c:1646  */
    break;

  case 1717:
#line 11827 "gram.y" /* yacc.c:1646  */
    { (yyval.selectlimit) = NULL; }
#line 41551 "gram.c" /* yacc.c:1646  */
    break;

  case 1718:
#line 11832 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));
					n->limitOffset = NULL;
					n->limitCount = (yyvsp[0].node);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 41563 "gram.c" /* yacc.c:1646  */
    break;

  case 1719:
#line 11840 "gram.y" /* yacc.c:1646  */
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[-3]))));
				}
#line 41576 "gram.c" /* yacc.c:1646  */
    break;

  case 1720:
#line 11856 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));
					n->limitOffset = NULL;
					n->limitCount = (yyvsp[-2].node);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 41588 "gram.c" /* yacc.c:1646  */
    break;

  case 1721:
#line 11864 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));
					n->limitOffset = NULL;
					n->limitCount = (yyvsp[-3].node);
					n->limitOption = LIMIT_OPTION_WITH_TIES;
					(yyval.selectlimit) = n;
				}
#line 41600 "gram.c" /* yacc.c:1646  */
    break;

  case 1722:
#line 11872 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));
					n->limitOffset = NULL;
					n->limitCount = makeIntConst(1, -1);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 41612 "gram.c" /* yacc.c:1646  */
    break;

  case 1723:
#line 11880 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));
					n->limitOffset = NULL;
					n->limitCount = makeIntConst(1, -1);
					n->limitOption = LIMIT_OPTION_WITH_TIES;
					(yyval.selectlimit) = n;
				}
#line 41624 "gram.c" /* yacc.c:1646  */
    break;

  case 1724:
#line 11891 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41630 "gram.c" /* yacc.c:1646  */
    break;

  case 1725:
#line 11894 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 41636 "gram.c" /* yacc.c:1646  */
    break;

  case 1726:
#line 11898 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41642 "gram.c" /* yacc.c:1646  */
    break;

  case 1727:
#line 11900 "gram.y" /* yacc.c:1646  */
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 41651 "gram.c" /* yacc.c:1646  */
    break;

  case 1728:
#line 11907 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41657 "gram.c" /* yacc.c:1646  */
    break;

  case 1729:
#line 11927 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41663 "gram.c" /* yacc.c:1646  */
    break;

  case 1730:
#line 11929 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 41669 "gram.c" /* yacc.c:1646  */
    break;

  case 1731:
#line 11931 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 41675 "gram.c" /* yacc.c:1646  */
    break;

  case 1732:
#line 11935 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst((yyvsp[0].ival),(yylsp[0])); }
#line 41681 "gram.c" /* yacc.c:1646  */
    break;

  case 1733:
#line 11936 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeFloatConst((yyvsp[0].str),(yylsp[0])); }
#line 41687 "gram.c" /* yacc.c:1646  */
    break;

  case 1734:
#line 11940 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 41693 "gram.c" /* yacc.c:1646  */
    break;

  case 1735:
#line 11941 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 41699 "gram.c" /* yacc.c:1646  */
    break;

  case 1736:
#line 11944 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 41705 "gram.c" /* yacc.c:1646  */
    break;

  case 1737:
#line 11945 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 41711 "gram.c" /* yacc.c:1646  */
    break;

  case 1738:
#line 11970 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 41717 "gram.c" /* yacc.c:1646  */
    break;

  case 1739:
#line 11971 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41723 "gram.c" /* yacc.c:1646  */
    break;

  case 1740:
#line 11975 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 41729 "gram.c" /* yacc.c:1646  */
    break;

  case 1741:
#line 11976 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].node)); }
#line 41735 "gram.c" /* yacc.c:1646  */
    break;

  case 1742:
#line 11980 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41741 "gram.c" /* yacc.c:1646  */
    break;

  case 1743:
#line 11981 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41747 "gram.c" /* yacc.c:1646  */
    break;

  case 1744:
#line 11982 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41753 "gram.c" /* yacc.c:1646  */
    break;

  case 1745:
#line 11983 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41759 "gram.c" /* yacc.c:1646  */
    break;

  case 1746:
#line 11984 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41765 "gram.c" /* yacc.c:1646  */
    break;

  case 1747:
#line 11989 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_EMPTY, NIL, (yylsp[-1]));
				}
#line 41773 "gram.c" /* yacc.c:1646  */
    break;

  case 1748:
#line 12002 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_ROLLUP, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 41781 "gram.c" /* yacc.c:1646  */
    break;

  case 1749:
#line 12009 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_CUBE, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 41789 "gram.c" /* yacc.c:1646  */
    break;

  case 1750:
#line 12016 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_SETS, (yyvsp[-1].list), (yylsp[-4]));
				}
#line 41797 "gram.c" /* yacc.c:1646  */
    break;

  case 1751:
#line 12022 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41803 "gram.c" /* yacc.c:1646  */
    break;

  case 1752:
#line 12023 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 41809 "gram.c" /* yacc.c:1646  */
    break;

  case 1753:
#line 12027 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 41815 "gram.c" /* yacc.c:1646  */
    break;

  case 1754:
#line 12028 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41821 "gram.c" /* yacc.c:1646  */
    break;

  case 1755:
#line 12032 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 41827 "gram.c" /* yacc.c:1646  */
    break;

  case 1756:
#line 12033 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41833 "gram.c" /* yacc.c:1646  */
    break;

  case 1757:
#line 12037 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 41839 "gram.c" /* yacc.c:1646  */
    break;

  case 1758:
#line 12038 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 41845 "gram.c" /* yacc.c:1646  */
    break;

  case 1759:
#line 12043 "gram.y" /* yacc.c:1646  */
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[-1].list);
					n->strength = (yyvsp[-2].ival);
					n->waitPolicy = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 41857 "gram.c" /* yacc.c:1646  */
    break;

  case 1760:
#line 12053 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORUPDATE; }
#line 41863 "gram.c" /* yacc.c:1646  */
    break;

  case 1761:
#line 12054 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORNOKEYUPDATE; }
#line 41869 "gram.c" /* yacc.c:1646  */
    break;

  case 1762:
#line 12055 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORSHARE; }
#line 41875 "gram.c" /* yacc.c:1646  */
    break;

  case 1763:
#line 12056 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORKEYSHARE; }
#line 41881 "gram.c" /* yacc.c:1646  */
    break;

  case 1764:
#line 12060 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 41887 "gram.c" /* yacc.c:1646  */
    break;

  case 1765:
#line 12061 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41893 "gram.c" /* yacc.c:1646  */
    break;

  case 1766:
#line 12072 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->valuesLists = list_make1((yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 41903 "gram.c" /* yacc.c:1646  */
    break;

  case 1767:
#line 12078 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[-4].node);
					n->valuesLists = lappend(n->valuesLists, (yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 41913 "gram.c" /* yacc.c:1646  */
    break;

  case 1768:
#line 12095 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 41919 "gram.c" /* yacc.c:1646  */
    break;

  case 1769:
#line 12096 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41925 "gram.c" /* yacc.c:1646  */
    break;

  case 1770:
#line 12100 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 41931 "gram.c" /* yacc.c:1646  */
    break;

  case 1771:
#line 12101 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 41937 "gram.c" /* yacc.c:1646  */
    break;

  case 1772:
#line 12108 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-1].range)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-1].range);
				}
#line 41946 "gram.c" /* yacc.c:1646  */
    break;

  case 1773:
#line 12113 "gram.y" /* yacc.c:1646  */
    {
					RangeTableSample *n = (RangeTableSample *) (yyvsp[0].node);
					(yyvsp[-2].range)->alias = (yyvsp[-1].alias);
					/* relation_expr goes inside the RangeTableSample node */
					n->relation = (Node *) (yyvsp[-2].range);
					(yyval.node) = (Node *) n;
				}
#line 41958 "gram.c" /* yacc.c:1646  */
    break;

  case 1774:
#line 12121 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 41969 "gram.c" /* yacc.c:1646  */
    break;

  case 1775:
#line 12128 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);
					n->lateral = true;
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 41981 "gram.c" /* yacc.c:1646  */
    break;

  case 1776:
#line 12136 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 41991 "gram.c" /* yacc.c:1646  */
    break;

  case 1777:
#line 12142 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);
					n->lateral = true;
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 42002 "gram.c" /* yacc.c:1646  */
    break;

  case 1778:
#line 12149 "gram.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = false;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
					if ((yyvsp[0].alias) == NULL)
					{
						if (IsA((yyvsp[-1].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[-1].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
					}
					(yyval.node) = (Node *) n;
				}
#line 42041 "gram.c" /* yacc.c:1646  */
    break;

  case 1779:
#line 12184 "gram.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = true;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					/* same comment as above */
					if ((yyvsp[0].alias) == NULL)
					{
						if (IsA((yyvsp[-1].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[-1].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
					}
					(yyval.node) = (Node *) n;
				}
#line 42070 "gram.c" /* yacc.c:1646  */
    break;

  case 1780:
#line 12209 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) (yyvsp[0].jexpr);
				}
#line 42078 "gram.c" /* yacc.c:1646  */
    break;

  case 1781:
#line 12213 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].jexpr)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-2].jexpr);
				}
#line 42087 "gram.c" /* yacc.c:1646  */
    break;

  case 1782:
#line 12239 "gram.y" /* yacc.c:1646  */
    {
					(yyval.jexpr) = (yyvsp[-1].jexpr);
				}
#line 42095 "gram.c" /* yacc.c:1646  */
    break;

  case 1783:
#line 12243 "gram.y" /* yacc.c:1646  */
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = false;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
#line 42111 "gram.c" /* yacc.c:1646  */
    break;

  case 1784:
#line 12255 "gram.y" /* yacc.c:1646  */
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[-3].jtype);
					n->isNatural = false;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
						n->usingClause = (List *) (yyvsp[0].node); /* USING clause */
					else
						n->quals = (yyvsp[0].node); /* ON clause */
					(yyval.jexpr) = n;
				}
#line 42128 "gram.c" /* yacc.c:1646  */
    break;

  case 1785:
#line 12268 "gram.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = false;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
						n->usingClause = (List *) (yyvsp[0].node); /* USING clause */
					else
						n->quals = (yyvsp[0].node); /* ON clause */
					(yyval.jexpr) = n;
				}
#line 42146 "gram.c" /* yacc.c:1646  */
    break;

  case 1786:
#line 12282 "gram.y" /* yacc.c:1646  */
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[-2].jtype);
					n->isNatural = true;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 42161 "gram.c" /* yacc.c:1646  */
    break;

  case 1787:
#line 12293 "gram.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = true;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 42177 "gram.c" /* yacc.c:1646  */
    break;

  case 1788:
#line 12308 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 42187 "gram.c" /* yacc.c:1646  */
    break;

  case 1789:
#line 12314 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 42196 "gram.c" /* yacc.c:1646  */
    break;

  case 1790:
#line 12319 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 42206 "gram.c" /* yacc.c:1646  */
    break;

  case 1791:
#line 12325 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 42215 "gram.c" /* yacc.c:1646  */
    break;

  case 1792:
#line 12331 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = (yyvsp[0].alias); }
#line 42221 "gram.c" /* yacc.c:1646  */
    break;

  case 1793:
#line 12332 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = NULL; }
#line 42227 "gram.c" /* yacc.c:1646  */
    break;

  case 1794:
#line 12341 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].alias), NIL);
				}
#line 42235 "gram.c" /* yacc.c:1646  */
    break;

  case 1795:
#line 12345 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[-1].list));
				}
#line 42243 "gram.c" /* yacc.c:1646  */
    break;

  case 1796:
#line 12349 "gram.y" /* yacc.c:1646  */
    {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 42253 "gram.c" /* yacc.c:1646  */
    break;

  case 1797:
#line 12355 "gram.y" /* yacc.c:1646  */
    {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 42263 "gram.c" /* yacc.c:1646  */
    break;

  case 1798:
#line 12361 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, NIL);
				}
#line 42271 "gram.c" /* yacc.c:1646  */
    break;

  case 1799:
#line 12366 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_FULL; }
#line 42277 "gram.c" /* yacc.c:1646  */
    break;

  case 1800:
#line 12367 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_LEFT; }
#line 42283 "gram.c" /* yacc.c:1646  */
    break;

  case 1801:
#line 12368 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_RIGHT; }
#line 42289 "gram.c" /* yacc.c:1646  */
    break;

  case 1802:
#line 12369 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_INNER; }
#line 42295 "gram.c" /* yacc.c:1646  */
    break;

  case 1803:
#line 12373 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 42301 "gram.c" /* yacc.c:1646  */
    break;

  case 1804:
#line 12374 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 42307 "gram.c" /* yacc.c:1646  */
    break;

  case 1805:
#line 12386 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 42313 "gram.c" /* yacc.c:1646  */
    break;

  case 1806:
#line 12387 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 42319 "gram.c" /* yacc.c:1646  */
    break;

  case 1807:
#line 12393 "gram.y" /* yacc.c:1646  */
    {
					/* inheritance query, implicitly */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;
				}
#line 42330 "gram.c" /* yacc.c:1646  */
    break;

  case 1808:
#line 12400 "gram.y" /* yacc.c:1646  */
    {
					/* inheritance query, explicitly */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;
				}
#line 42341 "gram.c" /* yacc.c:1646  */
    break;

  case 1809:
#line 12407 "gram.y" /* yacc.c:1646  */
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
				}
#line 42352 "gram.c" /* yacc.c:1646  */
    break;

  case 1810:
#line 12414 "gram.y" /* yacc.c:1646  */
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
				}
#line 42363 "gram.c" /* yacc.c:1646  */
    break;

  case 1811:
#line 12424 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 42369 "gram.c" /* yacc.c:1646  */
    break;

  case 1812:
#line 12425 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 42375 "gram.c" /* yacc.c:1646  */
    break;

  case 1813:
#line 12439 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 42383 "gram.c" /* yacc.c:1646  */
    break;

  case 1814:
#line 12443 "gram.y" /* yacc.c:1646  */
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-1].range)->alias = alias;
					(yyval.range) = (yyvsp[-1].range);
				}
#line 42394 "gram.c" /* yacc.c:1646  */
    break;

  case 1815:
#line 12450 "gram.y" /* yacc.c:1646  */
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-2].range)->alias = alias;
					(yyval.range) = (yyvsp[-2].range);
				}
#line 42405 "gram.c" /* yacc.c:1646  */
    break;

  case 1816:
#line 12463 "gram.y" /* yacc.c:1646  */
    {
					RangeTableSample *n = makeNode(RangeTableSample);
					/* n->relation will be filled in later */
					n->method = (yyvsp[-4].list);
					n->args = (yyvsp[-2].list);
					n->repeatable = (yyvsp[0].node);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 42419 "gram.c" /* yacc.c:1646  */
    break;

  case 1817:
#line 12475 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].node); }
#line 42425 "gram.c" /* yacc.c:1646  */
    break;

  case 1818:
#line 12476 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 42431 "gram.c" /* yacc.c:1646  */
    break;

  case 1819:
#line 12492 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = false;
					n->functions = list_make1(list_make2((yyvsp[-1].node), NIL));
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 42445 "gram.c" /* yacc.c:1646  */
    break;

  case 1820:
#line 12502 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = true;
					n->functions = (yyvsp[-2].list);
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 42459 "gram.c" /* yacc.c:1646  */
    break;

  case 1821:
#line 12514 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].list)); }
#line 42465 "gram.c" /* yacc.c:1646  */
    break;

  case 1822:
#line 12518 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 42471 "gram.c" /* yacc.c:1646  */
    break;

  case 1823:
#line 12519 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 42477 "gram.c" /* yacc.c:1646  */
    break;

  case 1824:
#line 12522 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 42483 "gram.c" /* yacc.c:1646  */
    break;

  case 1825:
#line 12523 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42489 "gram.c" /* yacc.c:1646  */
    break;

  case 1826:
#line 12526 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 42495 "gram.c" /* yacc.c:1646  */
    break;

  case 1827:
#line 12527 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 42501 "gram.c" /* yacc.c:1646  */
    break;

  case 1828:
#line 12532 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 42507 "gram.c" /* yacc.c:1646  */
    break;

  case 1829:
#line 12533 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 42513 "gram.c" /* yacc.c:1646  */
    break;

  case 1830:
#line 12538 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 42519 "gram.c" /* yacc.c:1646  */
    break;

  case 1831:
#line 12540 "gram.y" /* yacc.c:1646  */
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);
					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[0].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
#line 42531 "gram.c" /* yacc.c:1646  */
    break;

  case 1832:
#line 12547 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 42537 "gram.c" /* yacc.c:1646  */
    break;

  case 1833:
#line 12552 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 42543 "gram.c" /* yacc.c:1646  */
    break;

  case 1834:
#line 12553 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42549 "gram.c" /* yacc.c:1646  */
    break;

  case 1835:
#line 12558 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 42557 "gram.c" /* yacc.c:1646  */
    break;

  case 1836:
#line 12562 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 42565 "gram.c" /* yacc.c:1646  */
    break;

  case 1837:
#line 12568 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-2].str);
					n->typeName = (yyvsp[-1].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = (CollateClause *) (yyvsp[0].node);
					n->collOid = InvalidOid;
					n->constraints = NIL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 42587 "gram.c" /* yacc.c:1646  */
    break;

  case 1838:
#line 12592 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = makeNode(RangeTableFunc);
					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = NIL;
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *)n;
				}
#line 42601 "gram.c" /* yacc.c:1646  */
    break;

  case 1839:
#line 12603 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = makeNode(RangeTableFunc);
					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = (yyvsp[-7].list);
					n->location = (yylsp[-11]);
					(yyval.node) = (Node *)n;
				}
#line 42615 "gram.c" /* yacc.c:1646  */
    break;

  case 1840:
#line 12614 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 42621 "gram.c" /* yacc.c:1646  */
    break;

  case 1841:
#line 12615 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 42627 "gram.c" /* yacc.c:1646  */
    break;

  case 1842:
#line 12620 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol	   *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-1].str);
					fc->for_ordinality = false;
					fc->typeName = (yyvsp[0].typnam);
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-1]);

					(yyval.node) = (Node *) fc;
				}
#line 42645 "gram.c" /* yacc.c:1646  */
    break;

  case 1843:
#line 12634 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol	   *fc = makeNode(RangeTableFuncCol);
					ListCell		   *option;
					bool				nullability_seen = false;

					fc->colname = (yyvsp[-2].str);
					fc->typeName = (yyvsp[-1].typnam);
					fc->for_ordinality = false;
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-2]);

					foreach(option, (yyvsp[0].list))
					{
						DefElem   *defel = (DefElem *) lfirst(option);

						if (strcmp(defel->defname, "default") == 0)
						{
							if (fc->coldefexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one DEFAULT value is allowed"),
										 parser_errposition(defel->location)));
							fc->coldefexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "path") == 0)
						{
							if (fc->colexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one PATH value per column is allowed"),
										 parser_errposition(defel->location)));
							fc->colexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "is_not_null") == 0)
						{
							if (nullability_seen)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("conflicting or redundant NULL / NOT NULL declarations for column \"%s\"", fc->colname),
										 parser_errposition(defel->location)));
							fc->is_not_null = intVal(defel->arg);
							nullability_seen = true;
						}
						else
						{
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized column option \"%s\"",
											defel->defname),
									 parser_errposition(defel->location)));
						}
					}
					(yyval.node) = (Node *) fc;
				}
#line 42706 "gram.c" /* yacc.c:1646  */
    break;

  case 1844:
#line 12691 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol	   *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-2].str);
					fc->for_ordinality = true;
					/* other fields are ignored, initialized by makeNode */
					fc->location = (yylsp[-2]);

					(yyval.node) = (Node *) fc;
				}
#line 42721 "gram.c" /* yacc.c:1646  */
    break;

  case 1845:
#line 12705 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 42727 "gram.c" /* yacc.c:1646  */
    break;

  case 1846:
#line 12707 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 42733 "gram.c" /* yacc.c:1646  */
    break;

  case 1847:
#line 12712 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1])); }
#line 42739 "gram.c" /* yacc.c:1646  */
    break;

  case 1848:
#line 12714 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("default", (yyvsp[0].node), (yylsp[-1])); }
#line 42745 "gram.c" /* yacc.c:1646  */
    break;

  case 1849:
#line 12716 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeInteger(true), (yylsp[-1])); }
#line 42751 "gram.c" /* yacc.c:1646  */
    break;

  case 1850:
#line 12718 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeInteger(false), (yylsp[0])); }
#line 42757 "gram.c" /* yacc.c:1646  */
    break;

  case 1851:
#line 12723 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 42763 "gram.c" /* yacc.c:1646  */
    break;

  case 1852:
#line 12725 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 42769 "gram.c" /* yacc.c:1646  */
    break;

  case 1853:
#line 12730 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 42781 "gram.c" /* yacc.c:1646  */
    break;

  case 1854:
#line 12738 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[0].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 42793 "gram.c" /* yacc.c:1646  */
    break;

  case 1855:
#line 12758 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
				}
#line 42802 "gram.c" /* yacc.c:1646  */
    break;

  case 1856:
#line 12763 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
					(yyval.typnam)->setof = true;
				}
#line 42812 "gram.c" /* yacc.c:1646  */
    break;

  case 1857:
#line 12770 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
				}
#line 42821 "gram.c" /* yacc.c:1646  */
    break;

  case 1858:
#line 12775 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
					(yyval.typnam)->setof = true;
				}
#line 42831 "gram.c" /* yacc.c:1646  */
    break;

  case 1859:
#line 12781 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				}
#line 42840 "gram.c" /* yacc.c:1646  */
    break;

  case 1860:
#line 12786 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = true;
				}
#line 42850 "gram.c" /* yacc.c:1646  */
    break;

  case 1861:
#line 12795 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-2].list), makeInteger(-1)); }
#line 42856 "gram.c" /* yacc.c:1646  */
    break;

  case 1862:
#line 12797 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-3].list), makeInteger((yyvsp[-1].ival))); }
#line 42862 "gram.c" /* yacc.c:1646  */
    break;

  case 1863:
#line 12799 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = NIL; }
#line 42868 "gram.c" /* yacc.c:1646  */
    break;

  case 1864:
#line 12803 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 42874 "gram.c" /* yacc.c:1646  */
    break;

  case 1865:
#line 12804 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 42880 "gram.c" /* yacc.c:1646  */
    break;

  case 1866:
#line 12805 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 42886 "gram.c" /* yacc.c:1646  */
    break;

  case 1867:
#line 12806 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 42892 "gram.c" /* yacc.c:1646  */
    break;

  case 1868:
#line 12807 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 42898 "gram.c" /* yacc.c:1646  */
    break;

  case 1869:
#line 12809 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->typmods = (yyvsp[0].list);
				}
#line 42907 "gram.c" /* yacc.c:1646  */
    break;

  case 1870:
#line 12814 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-3].typnam);
					(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											 makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 42917 "gram.c" /* yacc.c:1646  */
    break;

  case 1871:
#line 12833 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 42923 "gram.c" /* yacc.c:1646  */
    break;

  case 1872:
#line 12834 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 42929 "gram.c" /* yacc.c:1646  */
    break;

  case 1873:
#line 12835 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 42935 "gram.c" /* yacc.c:1646  */
    break;

  case 1874:
#line 12836 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 42941 "gram.c" /* yacc.c:1646  */
    break;

  case 1875:
#line 12848 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeName((yyvsp[-1].str));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 42951 "gram.c" /* yacc.c:1646  */
    break;

  case 1876:
#line 12854 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-2].str)), (yyvsp[-1].list)));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-2]);
				}
#line 42961 "gram.c" /* yacc.c:1646  */
    break;

  case 1877:
#line 12861 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 42967 "gram.c" /* yacc.c:1646  */
    break;

  case 1878:
#line 12862 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42973 "gram.c" /* yacc.c:1646  */
    break;

  case 1879:
#line 12869 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 42982 "gram.c" /* yacc.c:1646  */
    break;

  case 1880:
#line 12874 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 42991 "gram.c" /* yacc.c:1646  */
    break;

  case 1881:
#line 12879 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 43000 "gram.c" /* yacc.c:1646  */
    break;

  case 1882:
#line 12884 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 43009 "gram.c" /* yacc.c:1646  */
    break;

  case 1883:
#line 12889 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 43018 "gram.c" /* yacc.c:1646  */
    break;

  case 1884:
#line 12894 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43027 "gram.c" /* yacc.c:1646  */
    break;

  case 1885:
#line 12899 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43036 "gram.c" /* yacc.c:1646  */
    break;

  case 1886:
#line 12904 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43046 "gram.c" /* yacc.c:1646  */
    break;

  case 1887:
#line 12910 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43056 "gram.c" /* yacc.c:1646  */
    break;

  case 1888:
#line 12916 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43066 "gram.c" /* yacc.c:1646  */
    break;

  case 1889:
#line 12922 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 43075 "gram.c" /* yacc.c:1646  */
    break;

  case 1890:
#line 12929 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[-1].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[-1]))));
					else if ((yyvsp[-1].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[-1].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[-1]))));
				}
#line 43100 "gram.c" /* yacc.c:1646  */
    break;

  case 1891:
#line 12950 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
				}
#line 43108 "gram.c" /* yacc.c:1646  */
    break;

  case 1892:
#line 12960 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 43116 "gram.c" /* yacc.c:1646  */
    break;

  case 1893:
#line 12964 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 43124 "gram.c" /* yacc.c:1646  */
    break;

  case 1894:
#line 12972 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 43132 "gram.c" /* yacc.c:1646  */
    break;

  case 1895:
#line 12976 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 43141 "gram.c" /* yacc.c:1646  */
    break;

  case 1896:
#line 12984 "gram.y" /* yacc.c:1646  */
    {
					char *typname;

					typname = (yyvsp[-3].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[-1].list);
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 43154 "gram.c" /* yacc.c:1646  */
    break;

  case 1897:
#line 12996 "gram.y" /* yacc.c:1646  */
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[0].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43172 "gram.c" /* yacc.c:1646  */
    break;

  case 1898:
#line 13017 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 43180 "gram.c" /* yacc.c:1646  */
    break;

  case 1899:
#line 13021 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 43188 "gram.c" /* yacc.c:1646  */
    break;

  case 1900:
#line 13027 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 43196 "gram.c" /* yacc.c:1646  */
    break;

  case 1901:
#line 13031 "gram.y" /* yacc.c:1646  */
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 43211 "gram.c" /* yacc.c:1646  */
    break;

  case 1902:
#line 13044 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName((yyvsp[-3].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 43221 "gram.c" /* yacc.c:1646  */
    break;

  case 1903:
#line 13052 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName((yyvsp[0].str));
					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[0].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 43233 "gram.c" /* yacc.c:1646  */
    break;

  case 1904:
#line 13062 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 43239 "gram.c" /* yacc.c:1646  */
    break;

  case 1905:
#line 13064 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 43245 "gram.c" /* yacc.c:1646  */
    break;

  case 1906:
#line 13066 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "varchar"; }
#line 43251 "gram.c" /* yacc.c:1646  */
    break;

  case 1907:
#line 13068 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 43257 "gram.c" /* yacc.c:1646  */
    break;

  case 1908:
#line 13070 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 43263 "gram.c" /* yacc.c:1646  */
    break;

  case 1909:
#line 13072 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 43269 "gram.c" /* yacc.c:1646  */
    break;

  case 1910:
#line 13076 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 43275 "gram.c" /* yacc.c:1646  */
    break;

  case 1911:
#line 13077 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 43281 "gram.c" /* yacc.c:1646  */
    break;

  case 1912:
#line 13085 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 43294 "gram.c" /* yacc.c:1646  */
    break;

  case 1913:
#line 13094 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43306 "gram.c" /* yacc.c:1646  */
    break;

  case 1914:
#line 13102 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 43319 "gram.c" /* yacc.c:1646  */
    break;

  case 1915:
#line 13111 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43331 "gram.c" /* yacc.c:1646  */
    break;

  case 1916:
#line 13122 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 43340 "gram.c" /* yacc.c:1646  */
    break;

  case 1917:
#line 13129 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 43346 "gram.c" /* yacc.c:1646  */
    break;

  case 1918:
#line 13130 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 43352 "gram.c" /* yacc.c:1646  */
    break;

  case 1919:
#line 13131 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 43358 "gram.c" /* yacc.c:1646  */
    break;

  case 1920:
#line 13136 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[0]))); }
#line 43364 "gram.c" /* yacc.c:1646  */
    break;

  case 1921:
#line 13138 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[0]))); }
#line 43370 "gram.c" /* yacc.c:1646  */
    break;

  case 1922:
#line 13140 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[0]))); }
#line 43376 "gram.c" /* yacc.c:1646  */
    break;

  case 1923:
#line 13142 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[0]))); }
#line 43382 "gram.c" /* yacc.c:1646  */
    break;

  case 1924:
#line 13144 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[0]))); }
#line 43388 "gram.c" /* yacc.c:1646  */
    break;

  case 1925:
#line 13146 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 43394 "gram.c" /* yacc.c:1646  */
    break;

  case 1926:
#line 13148 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[-2])));
				}
#line 43403 "gram.c" /* yacc.c:1646  */
    break;

  case 1927:
#line 13153 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[-2])));
				}
#line 43412 "gram.c" /* yacc.c:1646  */
    break;

  case 1928:
#line 13158 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 43422 "gram.c" /* yacc.c:1646  */
    break;

  case 1929:
#line 13164 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 43434 "gram.c" /* yacc.c:1646  */
    break;

  case 1930:
#line 13172 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 43443 "gram.c" /* yacc.c:1646  */
    break;

  case 1931:
#line 13177 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 43454 "gram.c" /* yacc.c:1646  */
    break;

  case 1932:
#line 13184 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 43464 "gram.c" /* yacc.c:1646  */
    break;

  case 1933:
#line 13190 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 43470 "gram.c" /* yacc.c:1646  */
    break;

  case 1934:
#line 13195 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[0])));
				}
#line 43478 "gram.c" /* yacc.c:1646  */
    break;

  case 1935:
#line 13199 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[-3])),
									makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 43487 "gram.c" /* yacc.c:1646  */
    break;

  case 1936:
#line 13234 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 43493 "gram.c" /* yacc.c:1646  */
    break;

  case 1937:
#line 13236 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 43499 "gram.c" /* yacc.c:1646  */
    break;

  case 1938:
#line 13238 "gram.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = (yyvsp[-2].node);
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 43511 "gram.c" /* yacc.c:1646  */
    break;

  case 1939:
#line 13246 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("timezone"),
											   list_make2((yyvsp[0].node), (yyvsp[-4].node)),
											   (yylsp[-3]));
				}
#line 43521 "gram.c" /* yacc.c:1646  */
    break;

  case 1940:
#line 13261 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 43527 "gram.c" /* yacc.c:1646  */
    break;

  case 1941:
#line 13263 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 43533 "gram.c" /* yacc.c:1646  */
    break;

  case 1942:
#line 13265 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43539 "gram.c" /* yacc.c:1646  */
    break;

  case 1943:
#line 13267 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43545 "gram.c" /* yacc.c:1646  */
    break;

  case 1944:
#line 13269 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43551 "gram.c" /* yacc.c:1646  */
    break;

  case 1945:
#line 13271 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43557 "gram.c" /* yacc.c:1646  */
    break;

  case 1946:
#line 13273 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43563 "gram.c" /* yacc.c:1646  */
    break;

  case 1947:
#line 13275 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43569 "gram.c" /* yacc.c:1646  */
    break;

  case 1948:
#line 13277 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43575 "gram.c" /* yacc.c:1646  */
    break;

  case 1949:
#line 13279 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43581 "gram.c" /* yacc.c:1646  */
    break;

  case 1950:
#line 13281 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43587 "gram.c" /* yacc.c:1646  */
    break;

  case 1951:
#line 13283 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43593 "gram.c" /* yacc.c:1646  */
    break;

  case 1952:
#line 13285 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43599 "gram.c" /* yacc.c:1646  */
    break;

  case 1953:
#line 13287 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43605 "gram.c" /* yacc.c:1646  */
    break;

  case 1954:
#line 13290 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43611 "gram.c" /* yacc.c:1646  */
    break;

  case 1955:
#line 13292 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 43617 "gram.c" /* yacc.c:1646  */
    break;

  case 1956:
#line 13294 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[0].list), (yyvsp[-1].node), NULL, (yylsp[0])); }
#line 43623 "gram.c" /* yacc.c:1646  */
    break;

  case 1957:
#line 13297 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAndExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43629 "gram.c" /* yacc.c:1646  */
    break;

  case 1958:
#line 13299 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeOrExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43635 "gram.c" /* yacc.c:1646  */
    break;

  case 1959:
#line 13301 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 43641 "gram.c" /* yacc.c:1646  */
    break;

  case 1960:
#line 13303 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 43647 "gram.c" /* yacc.c:1646  */
    break;

  case 1961:
#line 13306 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 43656 "gram.c" /* yacc.c:1646  */
    break;

  case 1962:
#line 13311 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 43668 "gram.c" /* yacc.c:1646  */
    break;

  case 1963:
#line 13319 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 43677 "gram.c" /* yacc.c:1646  */
    break;

  case 1964:
#line 13324 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 43689 "gram.c" /* yacc.c:1646  */
    break;

  case 1965:
#line 13332 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 43698 "gram.c" /* yacc.c:1646  */
    break;

  case 1966:
#line 13337 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 43710 "gram.c" /* yacc.c:1646  */
    break;

  case 1967:
#line 13345 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 43719 "gram.c" /* yacc.c:1646  */
    break;

  case 1968:
#line 13350 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 43731 "gram.c" /* yacc.c:1646  */
    break;

  case 1969:
#line 13359 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_to_escape"),
											   list_make1((yyvsp[0].node)),
											   (yylsp[-2]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-3].node), (Node *) n, (yylsp[-2]));
				}
#line 43743 "gram.c" /* yacc.c:1646  */
    break;

  case 1970:
#line 13367 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_to_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 43755 "gram.c" /* yacc.c:1646  */
    break;

  case 1971:
#line 13375 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_to_escape"),
											   list_make1((yyvsp[0].node)),
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 43767 "gram.c" /* yacc.c:1646  */
    break;

  case 1972:
#line 13383 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_to_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-5]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-6].node), (Node *) n, (yylsp[-5]));
				}
#line 43779 "gram.c" /* yacc.c:1646  */
    break;

  case 1973:
#line 13401 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-2].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 43791 "gram.c" /* yacc.c:1646  */
    break;

  case 1974:
#line 13409 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 43803 "gram.c" /* yacc.c:1646  */
    break;

  case 1975:
#line 13417 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-3].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 43815 "gram.c" /* yacc.c:1646  */
    break;

  case 1976:
#line 13425 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 43827 "gram.c" /* yacc.c:1646  */
    break;

  case 1977:
#line 13433 "gram.y" /* yacc.c:1646  */
    {
					if (list_length((yyvsp[-2].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
								 parser_errposition((yylsp[-2]))));
					if (list_length((yyvsp[0].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlaps"),
											   list_concat((yyvsp[-2].list), (yyvsp[0].list)),
											   (yylsp[-1]));
				}
#line 43847 "gram.c" /* yacc.c:1646  */
    break;

  case 1978:
#line 13449 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_TRUE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *)b;
				}
#line 43859 "gram.c" /* yacc.c:1646  */
    break;

  case 1979:
#line 13457 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_TRUE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *)b;
				}
#line 43871 "gram.c" /* yacc.c:1646  */
    break;

  case 1980:
#line 13465 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_FALSE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *)b;
				}
#line 43883 "gram.c" /* yacc.c:1646  */
    break;

  case 1981:
#line 13473 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_FALSE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *)b;
				}
#line 43895 "gram.c" /* yacc.c:1646  */
    break;

  case 1982:
#line 13481 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_UNKNOWN;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *)b;
				}
#line 43907 "gram.c" /* yacc.c:1646  */
    break;

  case 1983:
#line 13489 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *)b;
				}
#line 43919 "gram.c" /* yacc.c:1646  */
    break;

  case 1984:
#line 13497 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 43927 "gram.c" /* yacc.c:1646  */
    break;

  case 1985:
#line 13501 "gram.y" /* yacc.c:1646  */
    {
                    (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 43935 "gram.c" /* yacc.c:1646  */
    break;

  case 1986:
#line 13505 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[-5].node), (Node *) (yyvsp[-1].list), (yylsp[-4]));
				}
#line 43943 "gram.c" /* yacc.c:1646  */
    break;

  case 1987:
#line 13509 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[-6].node), (Node *) (yyvsp[-1].list), (yylsp[-5]));
				}
#line 43951 "gram.c" /* yacc.c:1646  */
    break;

  case 1988:
#line 13513 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN,
												   "BETWEEN",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 43963 "gram.c" /* yacc.c:1646  */
    break;

  case 1989:
#line 13521 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN,
												   "NOT BETWEEN",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 43975 "gram.c" /* yacc.c:1646  */
    break;

  case 1990:
#line 13529 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN_SYM,
												   "BETWEEN SYMMETRIC",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 43987 "gram.c" /* yacc.c:1646  */
    break;

  case 1991:
#line 13537 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN_SYM,
												   "NOT BETWEEN SYMMETRIC",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 43999 "gram.c" /* yacc.c:1646  */
    break;

  case 1992:
#line 13545 "gram.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink *n = (SubLink *) (yyvsp[0].node);
						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-2].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-1]);
						(yyval.node) = (Node *)n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
					}
				}
#line 44023 "gram.c" /* yacc.c:1646  */
    break;

  case 1993:
#line 13565 "gram.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink *n = (SubLink *) (yyvsp[0].node);
						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-3].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-2]);
						/* Stick a NOT on top; must have same parse location */
						(yyval.node) = makeNotExpr((Node *) n, (yylsp[-2]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
					}
				}
#line 44049 "gram.c" /* yacc.c:1646  */
    break;

  case 1994:
#line 13587 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = (yyvsp[-1].ival);
					n->subLinkId = 0;
					n->testexpr = (yyvsp[-3].node);
					n->operName = (yyvsp[-2].list);
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 44064 "gram.c" /* yacc.c:1646  */
    break;

  case 1995:
#line 13598 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-3].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
				}
#line 44075 "gram.c" /* yacc.c:1646  */
    break;

  case 1996:
#line 13605 "gram.y" /* yacc.c:1646  */
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[-1]))));
				}
#line 44095 "gram.c" /* yacc.c:1646  */
    break;

  case 1997:
#line 13621 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 44104 "gram.c" /* yacc.c:1646  */
    break;

  case 1998:
#line 13626 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 44114 "gram.c" /* yacc.c:1646  */
    break;

  case 1999:
#line 13632 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("is_normalized"), list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 44122 "gram.c" /* yacc.c:1646  */
    break;

  case 2000:
#line 13636 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("is_normalized"), list_make2((yyvsp[-3].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))), (yylsp[-2]));
				}
#line 44130 "gram.c" /* yacc.c:1646  */
    break;

  case 2001:
#line 13640 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr((Node *) makeFuncCall(SystemFuncName("is_normalized"), list_make1((yyvsp[-3].node)), (yylsp[-2])), (yylsp[-2]));
				}
#line 44138 "gram.c" /* yacc.c:1646  */
    break;

  case 2002:
#line 13644 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr((Node *) makeFuncCall(SystemFuncName("is_normalized"), list_make2((yyvsp[-4].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))), (yylsp[-3])), (yylsp[-3]));
				}
#line 44146 "gram.c" /* yacc.c:1646  */
    break;

  case 2003:
#line 13648 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * The SQL spec only allows DEFAULT in "contextually typed
					 * expressions", but for us, it's easier to allow it in
					 * any a_expr and then throw error during parse analysis
					 * if it's in an inappropriate context.  This way also
					 * lets us say something smarter than "syntax error".
					 */
					SetToDefault *n = makeNode(SetToDefault);
					/* parse analysis will fill in the rest */
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 44164 "gram.c" /* yacc.c:1646  */
    break;

  case 2004:
#line 13673 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44170 "gram.c" /* yacc.c:1646  */
    break;

  case 2005:
#line 13675 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 44176 "gram.c" /* yacc.c:1646  */
    break;

  case 2006:
#line 13677 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 44182 "gram.c" /* yacc.c:1646  */
    break;

  case 2007:
#line 13679 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 44188 "gram.c" /* yacc.c:1646  */
    break;

  case 2008:
#line 13681 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44194 "gram.c" /* yacc.c:1646  */
    break;

  case 2009:
#line 13683 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44200 "gram.c" /* yacc.c:1646  */
    break;

  case 2010:
#line 13685 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44206 "gram.c" /* yacc.c:1646  */
    break;

  case 2011:
#line 13687 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44212 "gram.c" /* yacc.c:1646  */
    break;

  case 2012:
#line 13689 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44218 "gram.c" /* yacc.c:1646  */
    break;

  case 2013:
#line 13691 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44224 "gram.c" /* yacc.c:1646  */
    break;

  case 2014:
#line 13693 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44230 "gram.c" /* yacc.c:1646  */
    break;

  case 2015:
#line 13695 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44236 "gram.c" /* yacc.c:1646  */
    break;

  case 2016:
#line 13697 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44242 "gram.c" /* yacc.c:1646  */
    break;

  case 2017:
#line 13699 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44248 "gram.c" /* yacc.c:1646  */
    break;

  case 2018:
#line 13701 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44254 "gram.c" /* yacc.c:1646  */
    break;

  case 2019:
#line 13703 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44260 "gram.c" /* yacc.c:1646  */
    break;

  case 2020:
#line 13705 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44266 "gram.c" /* yacc.c:1646  */
    break;

  case 2021:
#line 13707 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 44272 "gram.c" /* yacc.c:1646  */
    break;

  case 2022:
#line 13709 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[0].list), (yyvsp[-1].node), NULL, (yylsp[0])); }
#line 44278 "gram.c" /* yacc.c:1646  */
    break;

  case 2023:
#line 13711 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 44286 "gram.c" /* yacc.c:1646  */
    break;

  case 2024:
#line 13715 "gram.y" /* yacc.c:1646  */
    {
                    (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 44294 "gram.c" /* yacc.c:1646  */
    break;

  case 2025:
#line 13719 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[-5].node), (Node *) (yyvsp[-1].list), (yylsp[-4]));
				}
#line 44302 "gram.c" /* yacc.c:1646  */
    break;

  case 2026:
#line 13723 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[-6].node), (Node *) (yyvsp[-1].list), (yylsp[-5]));
				}
#line 44310 "gram.c" /* yacc.c:1646  */
    break;

  case 2027:
#line 13727 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 44319 "gram.c" /* yacc.c:1646  */
    break;

  case 2028:
#line 13732 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 44329 "gram.c" /* yacc.c:1646  */
    break;

  case 2029:
#line 13747 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44335 "gram.c" /* yacc.c:1646  */
    break;

  case 2030:
#line 13748 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44341 "gram.c" /* yacc.c:1646  */
    break;

  case 2031:
#line 13750 "gram.y" /* yacc.c:1646  */
    {
					ParamRef *p = makeNode(ParamRef);
					p->number = (yyvsp[-1].ival);
					p->location = (yylsp[-1]);
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
#line 44360 "gram.c" /* yacc.c:1646  */
    break;

  case 2032:
#line 13765 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (yyvsp[-2].node);
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *)n;
					}
					else if (operator_precedence_warning)
					{
						/*
						 * If precedence warnings are enabled, insert
						 * AEXPR_PAREN nodes wrapping all explicitly
						 * parenthesized subexpressions; this prevents bogus
						 * warnings from being issued when the ordering has
						 * been forced by parentheses.  Take care that an
						 * AEXPR_PAREN node has the same exprLocation as its
						 * child, so as not to cause surprising changes in
						 * error cursor positioning.
						 *
						 * In principle we should not be relying on a GUC to
						 * decide whether to insert AEXPR_PAREN nodes.
						 * However, since they have no effect except to
						 * suppress warnings, it's probably safe enough; and
						 * we'd just as soon not waste cycles on dummy parse
						 * nodes if we don't have to.
						 */
						(yyval.node) = (Node *) makeA_Expr(AEXPR_PAREN, NIL, (yyvsp[-2].node), NULL,
												 exprLocation((yyvsp[-2].node)));
					}
					else
						(yyval.node) = (yyvsp[-2].node);
				}
#line 44398 "gram.c" /* yacc.c:1646  */
    break;

  case 2033:
#line 13799 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44404 "gram.c" /* yacc.c:1646  */
    break;

  case 2034:
#line 13801 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44410 "gram.c" /* yacc.c:1646  */
    break;

  case 2035:
#line 13803 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 44425 "gram.c" /* yacc.c:1646  */
    break;

  case 2036:
#line 13814 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);
					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[-1].node);
					n->location = (yylsp[-1]);
					a->arg = (Node *)n;
					a->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.node) = (Node *)a;
				}
#line 44453 "gram.c" /* yacc.c:1646  */
    break;

  case 2037:
#line 13838 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXISTS_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 44468 "gram.c" /* yacc.c:1646  */
    break;

  case 2038:
#line 13849 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = ARRAY_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 44483 "gram.c" /* yacc.c:1646  */
    break;

  case 2039:
#line 13860 "gram.y" /* yacc.c:1646  */
    {
					A_ArrayExpr *n = castNode(A_ArrayExpr, (yyvsp[0].node));
					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 44494 "gram.c" /* yacc.c:1646  */
    break;

  case 2040:
#line 13867 "gram.y" /* yacc.c:1646  */
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_EXPLICIT_CALL; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *)r;
				}
#line 44508 "gram.c" /* yacc.c:1646  */
    break;

  case 2041:
#line 13877 "gram.y" /* yacc.c:1646  */
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_IMPLICIT_CAST; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *)r;
				}
#line 44522 "gram.c" /* yacc.c:1646  */
    break;

  case 2042:
#line 13887 "gram.y" /* yacc.c:1646  */
    {
				  GroupingFunc *g = makeNode(GroupingFunc);
				  g->args = (yyvsp[-1].list);
				  g->location = (yylsp[-3]);
				  (yyval.node) = (Node *)g;
			  }
#line 44533 "gram.c" /* yacc.c:1646  */
    break;

  case 2043:
#line 13896 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall((yyvsp[-2].list), NIL, (yylsp[-2]));
				}
#line 44541 "gram.c" /* yacc.c:1646  */
    break;

  case 2044:
#line 13900 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-4].list), (yyvsp[-2].list), (yylsp[-4]));
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 44551 "gram.c" /* yacc.c:1646  */
    break;

  case 2045:
#line 13906 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), list_make1((yyvsp[-2].node)), (yylsp[-5]));
					n->func_variadic = true;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 44562 "gram.c" /* yacc.c:1646  */
    break;

  case 2046:
#line 13913 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-7].list), lappend((yyvsp[-5].list), (yyvsp[-2].node)), (yylsp[-7]));
					n->func_variadic = true;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 44573 "gram.c" /* yacc.c:1646  */
    break;

  case 2047:
#line 13920 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list), (yylsp[-5]));
					n->agg_order = (yyvsp[-1].list);
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					(yyval.node) = (Node *)n;
				}
#line 44587 "gram.c" /* yacc.c:1646  */
    break;

  case 2048:
#line 13930 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list), (yylsp[-5]));
					n->agg_order = (yyvsp[-1].list);
					n->agg_distinct = true;
					(yyval.node) = (Node *)n;
				}
#line 44598 "gram.c" /* yacc.c:1646  */
    break;

  case 2049:
#line 13937 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall *n = makeFuncCall((yyvsp[-3].list), NIL, (yylsp[-3]));
					n->agg_star = true;
					(yyval.node) = (Node *)n;
				}
#line 44618 "gram.c" /* yacc.c:1646  */
    break;

  case 2050:
#line 13965 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = (FuncCall *) (yyvsp[-3].node);
					/*
					 * The order clause for WITHIN GROUP and the one for
					 * plain-aggregate ORDER BY share a field, so we have to
					 * check here that at most one is present.  We also check
					 * for DISTINCT and VARIADIC here to give a better error
					 * location.  Other consistency checks are deferred to
					 * parse analysis.
					 */
					if ((yyvsp[-2].list) != NIL)
					{
						if (n->agg_order != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use multiple ORDER BY clauses with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->agg_distinct)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use DISTINCT with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->func_variadic)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use VARIADIC with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						n->agg_order = (yyvsp[-2].list);
						n->agg_within_group = true;
					}
					n->agg_filter = (yyvsp[-1].node);
					n->over = (yyvsp[0].windef);
					(yyval.node) = (Node *) n;
				}
#line 44657 "gram.c" /* yacc.c:1646  */
    break;

  case 2051:
#line 14000 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44663 "gram.c" /* yacc.c:1646  */
    break;

  case 2052:
#line 14010 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44669 "gram.c" /* yacc.c:1646  */
    break;

  case 2053:
#line 14011 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44675 "gram.c" /* yacc.c:1646  */
    break;

  case 2054:
#line 14019 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("pg_collation_for"),
											   list_make1((yyvsp[-1].node)),
											   (yylsp[-4]));
				}
#line 44685 "gram.c" /* yacc.c:1646  */
    break;

  case 2055:
#line 14025 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_DATE, -1, (yylsp[0]));
				}
#line 44693 "gram.c" /* yacc.c:1646  */
    break;

  case 2056:
#line 14029 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME, -1, (yylsp[0]));
				}
#line 44701 "gram.c" /* yacc.c:1646  */
    break;

  case 2057:
#line 14033 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 44709 "gram.c" /* yacc.c:1646  */
    break;

  case 2058:
#line 14037 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP, -1, (yylsp[0]));
				}
#line 44717 "gram.c" /* yacc.c:1646  */
    break;

  case 2059:
#line 14041 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 44725 "gram.c" /* yacc.c:1646  */
    break;

  case 2060:
#line 14045 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME, -1, (yylsp[0]));
				}
#line 44733 "gram.c" /* yacc.c:1646  */
    break;

  case 2061:
#line 14049 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 44741 "gram.c" /* yacc.c:1646  */
    break;

  case 2062:
#line 14053 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP, -1, (yylsp[0]));
				}
#line 44749 "gram.c" /* yacc.c:1646  */
    break;

  case 2063:
#line 14057 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 44757 "gram.c" /* yacc.c:1646  */
    break;

  case 2064:
#line 14061 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_ROLE, -1, (yylsp[0]));
				}
#line 44765 "gram.c" /* yacc.c:1646  */
    break;

  case 2065:
#line 14065 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_USER, -1, (yylsp[0]));
				}
#line 44773 "gram.c" /* yacc.c:1646  */
    break;

  case 2066:
#line 14069 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_SESSION_USER, -1, (yylsp[0]));
				}
#line 44781 "gram.c" /* yacc.c:1646  */
    break;

  case 2067:
#line 14073 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_USER, -1, (yylsp[0]));
				}
#line 44789 "gram.c" /* yacc.c:1646  */
    break;

  case 2068:
#line 14077 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_CATALOG, -1, (yylsp[0]));
				}
#line 44797 "gram.c" /* yacc.c:1646  */
    break;

  case 2069:
#line 14081 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_SCHEMA, -1, (yylsp[0]));
				}
#line 44805 "gram.c" /* yacc.c:1646  */
    break;

  case 2070:
#line 14085 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-3].node), (yyvsp[-1].typnam), (yylsp[-5])); }
#line 44811 "gram.c" /* yacc.c:1646  */
    break;

  case 2071:
#line 14087 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("date_part"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 44819 "gram.c" /* yacc.c:1646  */
    break;

  case 2072:
#line 14091 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("normalize"), list_make1((yyvsp[-1].node)), (yylsp[-3]));
				}
#line 44827 "gram.c" /* yacc.c:1646  */
    break;

  case 2073:
#line 14095 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("normalize"), list_make2((yyvsp[-3].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))), (yylsp[-5]));
				}
#line 44835 "gram.c" /* yacc.c:1646  */
    break;

  case 2074:
#line 14099 "gram.y" /* yacc.c:1646  */
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to
					 * overlay(A, B, C, D)
					 * overlay(A PLACING B FROM C) is converted to
					 * overlay(A, B, C)
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlay"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 44848 "gram.c" /* yacc.c:1646  */
    break;

  case 2075:
#line 14108 "gram.y" /* yacc.c:1646  */
    {
					/* position(A in B) is converted to position(B, A) */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("position"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 44857 "gram.c" /* yacc.c:1646  */
    break;

  case 2076:
#line 14113 "gram.y" /* yacc.c:1646  */
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("substring"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 44868 "gram.c" /* yacc.c:1646  */
    break;

  case 2077:
#line 14120 "gram.y" /* yacc.c:1646  */
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 *
					 * Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName(((Value *)llast((yyvsp[-1].typnam)->names))->val.str),
												list_make1((yyvsp[-3].node)),
												(yylsp[-5]));
				}
#line 44887 "gram.c" /* yacc.c:1646  */
    break;

  case 2078:
#line 14135 "gram.y" /* yacc.c:1646  */
    {
					/* various trim expressions are defined in SQL
					 * - thomas 1997-07-19
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"), (yyvsp[-1].list), (yylsp[-4]));
				}
#line 44898 "gram.c" /* yacc.c:1646  */
    break;

  case 2079:
#line 14142 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("ltrim"), (yyvsp[-1].list), (yylsp[-4]));
				}
#line 44906 "gram.c" /* yacc.c:1646  */
    break;

  case 2080:
#line 14146 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("rtrim"), (yyvsp[-1].list), (yylsp[-4]));
				}
#line 44914 "gram.c" /* yacc.c:1646  */
    break;

  case 2081:
#line 14150 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 44922 "gram.c" /* yacc.c:1646  */
    break;

  case 2082:
#line 14154 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[-3].node), (yyvsp[-1].node), (yylsp[-5]));
				}
#line 44930 "gram.c" /* yacc.c:1646  */
    break;

  case 2083:
#line 14158 "gram.y" /* yacc.c:1646  */
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);
					c->args = (yyvsp[-1].list);
					c->location = (yylsp[-3]);
					(yyval.node) = (Node *)c;
				}
#line 44941 "gram.c" /* yacc.c:1646  */
    break;

  case 2084:
#line 14165 "gram.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[-1].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *)v;
				}
#line 44953 "gram.c" /* yacc.c:1646  */
    break;

  case 2085:
#line 14173 "gram.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[-1].list);
					v->op = IS_LEAST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *)v;
				}
#line 44965 "gram.c" /* yacc.c:1646  */
    break;

  case 2086:
#line 14181 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 44973 "gram.c" /* yacc.c:1646  */
    break;

  case 2087:
#line 14185 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-1].str), NIL, NIL, (yylsp[-4]));
				}
#line 44981 "gram.c" /* yacc.c:1646  */
    break;

  case 2088:
#line 14189 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), (yyvsp[-1].list), NIL, (yylsp[-6]));
				}
#line 44989 "gram.c" /* yacc.c:1646  */
    break;

  case 2089:
#line 14193 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), NIL, (yyvsp[-1].list), (yylsp[-6]));
				}
#line 44997 "gram.c" /* yacc.c:1646  */
    break;

  case 2090:
#line 14197 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-5].str), (yyvsp[-3].list), (yyvsp[-1].list), (yylsp[-8]));
				}
#line 45005 "gram.c" /* yacc.c:1646  */
    break;

  case 2091:
#line 14201 "gram.y" /* yacc.c:1646  */
    {
					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
					 * converted to xmlexists(A, B)*/
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("xmlexists"), list_make2((yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-4]));
				}
#line 45015 "gram.c" /* yacc.c:1646  */
    break;

  case 2092:
#line 14207 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[-1].list), NIL, (yylsp[-3]));
				}
#line 45023 "gram.c" /* yacc.c:1646  */
    break;

  case 2093:
#line 14211 "gram.y" /* yacc.c:1646  */
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[-2].node), makeBoolAConst((yyvsp[-1].boolean), -1)),
									(yylsp[-5]));
					x->xmloption = (yyvsp[-3].ival);
					(yyval.node) = (Node *)x;
				}
#line 45036 "gram.c" /* yacc.c:1646  */
    break;

  case 2094:
#line 14220 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-1].str), NULL, NIL, (yylsp[-4]));
				}
#line 45044 "gram.c" /* yacc.c:1646  */
    break;

  case 2095:
#line 14224 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-3].str), NULL, list_make1((yyvsp[-1].node)), (yylsp[-6]));
				}
#line 45052 "gram.c" /* yacc.c:1646  */
    break;

  case 2096:
#line 14228 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-6]));
				}
#line 45061 "gram.c" /* yacc.c:1646  */
    break;

  case 2097:
#line 14233 "gram.y" /* yacc.c:1646  */
    {
					XmlSerialize *n = makeNode(XmlSerialize);
					n->xmloption = (yyvsp[-4].ival);
					n->expr = (yyvsp[-3].node);
					n->typeName = (yyvsp[-1].typnam);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *)n;
				}
#line 45074 "gram.c" /* yacc.c:1646  */
    break;

  case 2098:
#line 14247 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45080 "gram.c" /* yacc.c:1646  */
    break;

  case 2099:
#line 14249 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNullAConst(-1); }
#line 45086 "gram.c" /* yacc.c:1646  */
    break;

  case 2100:
#line 14253 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); }
#line 45092 "gram.c" /* yacc.c:1646  */
    break;

  case 2101:
#line 14255 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); }
#line 45098 "gram.c" /* yacc.c:1646  */
    break;

  case 2102:
#line 14257 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
#line 45104 "gram.c" /* yacc.c:1646  */
    break;

  case 2103:
#line 14259 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); }
#line 45110 "gram.c" /* yacc.c:1646  */
    break;

  case 2104:
#line 14262 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 45116 "gram.c" /* yacc.c:1646  */
    break;

  case 2105:
#line 14265 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 45122 "gram.c" /* yacc.c:1646  */
    break;

  case 2106:
#line 14266 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 45128 "gram.c" /* yacc.c:1646  */
    break;

  case 2107:
#line 14270 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 45140 "gram.c" /* yacc.c:1646  */
    break;

  case 2108:
#line 14278 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 45152 "gram.c" /* yacc.c:1646  */
    break;

  case 2109:
#line 14287 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_DOCUMENT; }
#line 45158 "gram.c" /* yacc.c:1646  */
    break;

  case 2110:
#line 14288 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_CONTENT; }
#line 45164 "gram.c" /* yacc.c:1646  */
    break;

  case 2111:
#line 14291 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 45170 "gram.c" /* yacc.c:1646  */
    break;

  case 2112:
#line 14292 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 45176 "gram.c" /* yacc.c:1646  */
    break;

  case 2113:
#line 14293 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 45182 "gram.c" /* yacc.c:1646  */
    break;

  case 2114:
#line 14299 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 45190 "gram.c" /* yacc.c:1646  */
    break;

  case 2115:
#line 14303 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-1].node);
				}
#line 45198 "gram.c" /* yacc.c:1646  */
    break;

  case 2116:
#line 14307 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 45206 "gram.c" /* yacc.c:1646  */
    break;

  case 2117:
#line 14311 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-1].node);
				}
#line 45214 "gram.c" /* yacc.c:1646  */
    break;

  case 2120:
#line 14326 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 45220 "gram.c" /* yacc.c:1646  */
    break;

  case 2121:
#line 14327 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45226 "gram.c" /* yacc.c:1646  */
    break;

  case 2122:
#line 14331 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 45232 "gram.c" /* yacc.c:1646  */
    break;

  case 2123:
#line 14332 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 45238 "gram.c" /* yacc.c:1646  */
    break;

  case 2124:
#line 14340 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45244 "gram.c" /* yacc.c:1646  */
    break;

  case 2125:
#line 14341 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45250 "gram.c" /* yacc.c:1646  */
    break;

  case 2126:
#line 14345 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].windef)); }
#line 45256 "gram.c" /* yacc.c:1646  */
    break;

  case 2127:
#line 14347 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].windef)); }
#line 45262 "gram.c" /* yacc.c:1646  */
    break;

  case 2128:
#line 14352 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					n->name = (yyvsp[-2].str);
					(yyval.windef) = n;
				}
#line 45272 "gram.c" /* yacc.c:1646  */
    break;

  case 2129:
#line 14360 "gram.y" /* yacc.c:1646  */
    { (yyval.windef) = (yyvsp[0].windef); }
#line 45278 "gram.c" /* yacc.c:1646  */
    break;

  case 2130:
#line 14362 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = (yyvsp[0].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[0]);
					(yyval.windef) = n;
				}
#line 45295 "gram.c" /* yacc.c:1646  */
    break;

  case 2131:
#line 14375 "gram.y" /* yacc.c:1646  */
    { (yyval.windef) = NULL; }
#line 45301 "gram.c" /* yacc.c:1646  */
    break;

  case 2132:
#line 14380 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = NULL;
					n->refname = (yyvsp[-4].str);
					n->partitionClause = (yyvsp[-3].list);
					n->orderClause = (yyvsp[-2].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[-1].windef)->frameOptions;
					n->startOffset = (yyvsp[-1].windef)->startOffset;
					n->endOffset = (yyvsp[-1].windef)->endOffset;
					n->location = (yylsp[-5]);
					(yyval.windef) = n;
				}
#line 45319 "gram.c" /* yacc.c:1646  */
    break;

  case 2133:
#line 14405 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 45325 "gram.c" /* yacc.c:1646  */
    break;

  case 2134:
#line 14406 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 45331 "gram.c" /* yacc.c:1646  */
    break;

  case 2135:
#line 14409 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45337 "gram.c" /* yacc.c:1646  */
    break;

  case 2136:
#line 14410 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45343 "gram.c" /* yacc.c:1646  */
    break;

  case 2137:
#line 14419 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[-1].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 45354 "gram.c" /* yacc.c:1646  */
    break;

  case 2138:
#line 14426 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[-1].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 45365 "gram.c" /* yacc.c:1646  */
    break;

  case 2139:
#line 14433 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[-1].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_GROUPS;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 45376 "gram.c" /* yacc.c:1646  */
    break;

  case 2140:
#line 14440 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 45388 "gram.c" /* yacc.c:1646  */
    break;

  case 2141:
#line 14450 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[0]))));
					if (n->frameOptions & FRAMEOPTION_START_OFFSET_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[0]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				}
#line 45409 "gram.c" /* yacc.c:1646  */
    break;

  case 2142:
#line 14467 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n1 = (yyvsp[-2].windef);
					WindowDef *n2 = (yyvsp[0].windef);
					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[-2]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_OFFSET_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_OFFSET_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_OFFSET_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				}
#line 45450 "gram.c" /* yacc.c:1646  */
    break;

  case 2143:
#line 14512 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 45462 "gram.c" /* yacc.c:1646  */
    break;

  case 2144:
#line 14520 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 45474 "gram.c" /* yacc.c:1646  */
    break;

  case 2145:
#line 14528 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 45486 "gram.c" /* yacc.c:1646  */
    break;

  case 2146:
#line 14536 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_OFFSET_PRECEDING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 45498 "gram.c" /* yacc.c:1646  */
    break;

  case 2147:
#line 14544 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_OFFSET_FOLLOWING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 45510 "gram.c" /* yacc.c:1646  */
    break;

  case 2148:
#line 14554 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_CURRENT_ROW; }
#line 45516 "gram.c" /* yacc.c:1646  */
    break;

  case 2149:
#line 14555 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_GROUP; }
#line 45522 "gram.c" /* yacc.c:1646  */
    break;

  case 2150:
#line 14556 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_TIES; }
#line 45528 "gram.c" /* yacc.c:1646  */
    break;

  case 2151:
#line 14557 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 45534 "gram.c" /* yacc.c:1646  */
    break;

  case 2152:
#line 14558 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 45540 "gram.c" /* yacc.c:1646  */
    break;

  case 2153:
#line 14572 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 45546 "gram.c" /* yacc.c:1646  */
    break;

  case 2154:
#line 14573 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45552 "gram.c" /* yacc.c:1646  */
    break;

  case 2155:
#line 14574 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 45558 "gram.c" /* yacc.c:1646  */
    break;

  case 2156:
#line 14577 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 45564 "gram.c" /* yacc.c:1646  */
    break;

  case 2157:
#line 14578 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45570 "gram.c" /* yacc.c:1646  */
    break;

  case 2158:
#line 14581 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 45576 "gram.c" /* yacc.c:1646  */
    break;

  case 2159:
#line 14584 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 45582 "gram.c" /* yacc.c:1646  */
    break;

  case 2160:
#line 14585 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 45588 "gram.c" /* yacc.c:1646  */
    break;

  case 2161:
#line 14586 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ALL_SUBLINK; }
#line 45594 "gram.c" /* yacc.c:1646  */
    break;

  case 2162:
#line 14589 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 45600 "gram.c" /* yacc.c:1646  */
    break;

  case 2163:
#line 14590 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 45606 "gram.c" /* yacc.c:1646  */
    break;

  case 2164:
#line 14593 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "+"; }
#line 45612 "gram.c" /* yacc.c:1646  */
    break;

  case 2165:
#line 14594 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "-"; }
#line 45618 "gram.c" /* yacc.c:1646  */
    break;

  case 2166:
#line 14595 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "*"; }
#line 45624 "gram.c" /* yacc.c:1646  */
    break;

  case 2167:
#line 14596 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "/"; }
#line 45630 "gram.c" /* yacc.c:1646  */
    break;

  case 2168:
#line 14597 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "%"; }
#line 45636 "gram.c" /* yacc.c:1646  */
    break;

  case 2169:
#line 14598 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "^"; }
#line 45642 "gram.c" /* yacc.c:1646  */
    break;

  case 2170:
#line 14599 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<"; }
#line 45648 "gram.c" /* yacc.c:1646  */
    break;

  case 2171:
#line 14600 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = ">"; }
#line 45654 "gram.c" /* yacc.c:1646  */
    break;

  case 2172:
#line 14601 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "="; }
#line 45660 "gram.c" /* yacc.c:1646  */
    break;

  case 2173:
#line 14602 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<="; }
#line 45666 "gram.c" /* yacc.c:1646  */
    break;

  case 2174:
#line 14603 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = ">="; }
#line 45672 "gram.c" /* yacc.c:1646  */
    break;

  case 2175:
#line 14604 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<>"; }
#line 45678 "gram.c" /* yacc.c:1646  */
    break;

  case 2176:
#line 14608 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 45684 "gram.c" /* yacc.c:1646  */
    break;

  case 2177:
#line 14610 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 45690 "gram.c" /* yacc.c:1646  */
    break;

  case 2178:
#line 14615 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 45696 "gram.c" /* yacc.c:1646  */
    break;

  case 2179:
#line 14617 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 45702 "gram.c" /* yacc.c:1646  */
    break;

  case 2180:
#line 14622 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 45708 "gram.c" /* yacc.c:1646  */
    break;

  case 2181:
#line 14624 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 45714 "gram.c" /* yacc.c:1646  */
    break;

  case 2182:
#line 14626 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~")); }
#line 45720 "gram.c" /* yacc.c:1646  */
    break;

  case 2183:
#line 14628 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~")); }
#line 45726 "gram.c" /* yacc.c:1646  */
    break;

  case 2184:
#line 14630 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~*")); }
#line 45732 "gram.c" /* yacc.c:1646  */
    break;

  case 2185:
#line 14632 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~*")); }
#line 45738 "gram.c" /* yacc.c:1646  */
    break;

  case 2186:
#line 14644 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 45746 "gram.c" /* yacc.c:1646  */
    break;

  case 2187:
#line 14648 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 45754 "gram.c" /* yacc.c:1646  */
    break;

  case 2188:
#line 14655 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 45762 "gram.c" /* yacc.c:1646  */
    break;

  case 2189:
#line 14659 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 45770 "gram.c" /* yacc.c:1646  */
    break;

  case 2190:
#line 14665 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 45778 "gram.c" /* yacc.c:1646  */
    break;

  case 2191:
#line 14669 "gram.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 45791 "gram.c" /* yacc.c:1646  */
    break;

  case 2192:
#line 14678 "gram.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 45804 "gram.c" /* yacc.c:1646  */
    break;

  case 2193:
#line 14688 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 45810 "gram.c" /* yacc.c:1646  */
    break;

  case 2194:
#line 14689 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 45816 "gram.c" /* yacc.c:1646  */
    break;

  case 2195:
#line 14693 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 45824 "gram.c" /* yacc.c:1646  */
    break;

  case 2196:
#line 14697 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 45832 "gram.c" /* yacc.c:1646  */
    break;

  case 2197:
#line 14701 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[-1]));
				}
#line 45840 "gram.c" /* yacc.c:1646  */
    break;

  case 2198:
#line 14706 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 45846 "gram.c" /* yacc.c:1646  */
    break;

  case 2199:
#line 14707 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 45852 "gram.c" /* yacc.c:1646  */
    break;

  case 2200:
#line 14713 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[-2].str), (yylsp[-2])), (yyvsp[0].node));
				}
#line 45860 "gram.c" /* yacc.c:1646  */
    break;

  case 2201:
#line 14716 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45866 "gram.c" /* yacc.c:1646  */
    break;

  case 2202:
#line 14723 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 45872 "gram.c" /* yacc.c:1646  */
    break;

  case 2203:
#line 14724 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "year"; }
#line 45878 "gram.c" /* yacc.c:1646  */
    break;

  case 2204:
#line 14725 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "month"; }
#line 45884 "gram.c" /* yacc.c:1646  */
    break;

  case 2205:
#line 14726 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "day"; }
#line 45890 "gram.c" /* yacc.c:1646  */
    break;

  case 2206:
#line 14727 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "hour"; }
#line 45896 "gram.c" /* yacc.c:1646  */
    break;

  case 2207:
#line 14728 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "minute"; }
#line 45902 "gram.c" /* yacc.c:1646  */
    break;

  case 2208:
#line 14729 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "second"; }
#line 45908 "gram.c" /* yacc.c:1646  */
    break;

  case 2209:
#line 14730 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 45914 "gram.c" /* yacc.c:1646  */
    break;

  case 2210:
#line 14734 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "nfc"; }
#line 45920 "gram.c" /* yacc.c:1646  */
    break;

  case 2211:
#line 14735 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "nfd"; }
#line 45926 "gram.c" /* yacc.c:1646  */
    break;

  case 2212:
#line 14736 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "nfkc"; }
#line 45932 "gram.c" /* yacc.c:1646  */
    break;

  case 2213:
#line 14737 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "nfkd"; }
#line 45938 "gram.c" /* yacc.c:1646  */
    break;

  case 2214:
#line 14748 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make4((yyvsp[-3].node), (yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 45946 "gram.c" /* yacc.c:1646  */
    break;

  case 2215:
#line 14752 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 45954 "gram.c" /* yacc.c:1646  */
    break;

  case 2216:
#line 14759 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45960 "gram.c" /* yacc.c:1646  */
    break;

  case 2217:
#line 14765 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-2].node)); }
#line 45966 "gram.c" /* yacc.c:1646  */
    break;

  case 2218:
#line 14766 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45972 "gram.c" /* yacc.c:1646  */
    break;

  case 2219:
#line 14783 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 45980 "gram.c" /* yacc.c:1646  */
    break;

  case 2220:
#line 14787 "gram.y" /* yacc.c:1646  */
    {
					/* not legal per SQL99, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[0].node), (yyvsp[-1].node));
				}
#line 45989 "gram.c" /* yacc.c:1646  */
    break;

  case 2221:
#line 14792 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].node));
				}
#line 45997 "gram.c" /* yacc.c:1646  */
    break;

  case 2222:
#line 14796 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[-1].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[0].node),
												 SystemTypeName("int4"), -1));
				}
#line 46016 "gram.c" /* yacc.c:1646  */
    break;

  case 2223:
#line 14811 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
				}
#line 46024 "gram.c" /* yacc.c:1646  */
    break;

  case 2224:
#line 14815 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46030 "gram.c" /* yacc.c:1646  */
    break;

  case 2225:
#line 14819 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46036 "gram.c" /* yacc.c:1646  */
    break;

  case 2226:
#line 14822 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46042 "gram.c" /* yacc.c:1646  */
    break;

  case 2227:
#line 14825 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[0].list), (yyvsp[-2].node)); }
#line 46048 "gram.c" /* yacc.c:1646  */
    break;

  case 2228:
#line 14826 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46054 "gram.c" /* yacc.c:1646  */
    break;

  case 2229:
#line 14827 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46060 "gram.c" /* yacc.c:1646  */
    break;

  case 2230:
#line 14831 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subselect = (yyvsp[0].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *)n;
				}
#line 46071 "gram.c" /* yacc.c:1646  */
    break;

  case 2231:
#line 14837 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[-1].list); }
#line 46077 "gram.c" /* yacc.c:1646  */
    break;

  case 2232:
#line 14848 "gram.y" /* yacc.c:1646  */
    {
					CaseExpr *c = makeNode(CaseExpr);
					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[-3].node);
					c->args = (yyvsp[-2].list);
					c->defresult = (Expr *) (yyvsp[-1].node);
					c->location = (yylsp[-4]);
					(yyval.node) = (Node *)c;
				}
#line 46091 "gram.c" /* yacc.c:1646  */
    break;

  case 2233:
#line 14861 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 46097 "gram.c" /* yacc.c:1646  */
    break;

  case 2234:
#line 14862 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 46103 "gram.c" /* yacc.c:1646  */
    break;

  case 2235:
#line 14867 "gram.y" /* yacc.c:1646  */
    {
					CaseWhen *w = makeNode(CaseWhen);
					w->expr = (Expr *) (yyvsp[-2].node);
					w->result = (Expr *) (yyvsp[0].node);
					w->location = (yylsp[-3]);
					(yyval.node) = (Node *)w;
				}
#line 46115 "gram.c" /* yacc.c:1646  */
    break;

  case 2236:
#line 14877 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46121 "gram.c" /* yacc.c:1646  */
    break;

  case 2237:
#line 14878 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 46127 "gram.c" /* yacc.c:1646  */
    break;

  case 2238:
#line 14881 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46133 "gram.c" /* yacc.c:1646  */
    break;

  case 2239:
#line 14882 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 46139 "gram.c" /* yacc.c:1646  */
    break;

  case 2240:
#line 14886 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[0].str), NIL, (yylsp[0]), yyscanner);
				}
#line 46147 "gram.c" /* yacc.c:1646  */
    break;

  case 2241:
#line 14890 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 46155 "gram.c" /* yacc.c:1646  */
    break;

  case 2242:
#line 14897 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 46163 "gram.c" /* yacc.c:1646  */
    break;

  case 2243:
#line 14901 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				}
#line 46171 "gram.c" /* yacc.c:1646  */
    break;

  case 2244:
#line 14905 "gram.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->is_slice = false;
					ai->lidx = NULL;
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 46183 "gram.c" /* yacc.c:1646  */
    break;

  case 2245:
#line 14913 "gram.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->is_slice = true;
					ai->lidx = (yyvsp[-3].node);
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 46195 "gram.c" /* yacc.c:1646  */
    break;

  case 2246:
#line 14923 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46201 "gram.c" /* yacc.c:1646  */
    break;

  case 2247:
#line 14924 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 46207 "gram.c" /* yacc.c:1646  */
    break;

  case 2248:
#line 14928 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 46213 "gram.c" /* yacc.c:1646  */
    break;

  case 2249:
#line 14929 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 46219 "gram.c" /* yacc.c:1646  */
    break;

  case 2250:
#line 14933 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46225 "gram.c" /* yacc.c:1646  */
    break;

  case 2251:
#line 14934 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 46231 "gram.c" /* yacc.c:1646  */
    break;

  case 2254:
#line 14948 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46237 "gram.c" /* yacc.c:1646  */
    break;

  case 2255:
#line 14949 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46243 "gram.c" /* yacc.c:1646  */
    break;

  case 2256:
#line 14953 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 46249 "gram.c" /* yacc.c:1646  */
    break;

  case 2257:
#line 14954 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 46255 "gram.c" /* yacc.c:1646  */
    break;

  case 2258:
#line 14958 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 46267 "gram.c" /* yacc.c:1646  */
    break;

  case 2259:
#line 14974 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[-1].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 46279 "gram.c" /* yacc.c:1646  */
    break;

  case 2260:
#line 14982 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 46291 "gram.c" /* yacc.c:1646  */
    break;

  case 2261:
#line 14990 "gram.y" /* yacc.c:1646  */
    {
					ColumnRef *n = makeNode(ColumnRef);
					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[0]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)n;
					(yyval.target)->location = (yylsp[0]);
				}
#line 46307 "gram.c" /* yacc.c:1646  */
    break;

  case 2262:
#line 15011 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 46313 "gram.c" /* yacc.c:1646  */
    break;

  case 2263:
#line 15012 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 46319 "gram.c" /* yacc.c:1646  */
    break;

  case 2264:
#line 15024 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = makeRangeVar(NULL, (yyvsp[0].str), (yylsp[0]));
				}
#line 46327 "gram.c" /* yacc.c:1646  */
    break;

  case 2265:
#line 15028 "gram.y" /* yacc.c:1646  */
    {
					check_qualified_name((yyvsp[0].list), yyscanner);
					(yyval.range) = makeRangeVar(NULL, NULL, (yylsp[-1]));
					switch (list_length((yyvsp[0].list)))
					{
						case 1:
							(yyval.range)->catalogname = NULL;
							(yyval.range)->schemaname = (yyvsp[-1].str);
							(yyval.range)->relname = strVal(linitial((yyvsp[0].list)));
							break;
						case 2:
							(yyval.range)->catalogname = (yyvsp[-1].str);
							(yyval.range)->schemaname = strVal(linitial((yyvsp[0].list)));
							(yyval.range)->relname = strVal(lsecond((yyvsp[0].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)))),
									 parser_errposition((yylsp[-1]))));
							break;
					}
				}
#line 46356 "gram.c" /* yacc.c:1646  */
    break;

  case 2266:
#line 15055 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 46362 "gram.c" /* yacc.c:1646  */
    break;

  case 2267:
#line 15057 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 46368 "gram.c" /* yacc.c:1646  */
    break;

  case 2268:
#line 15061 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46374 "gram.c" /* yacc.c:1646  */
    break;

  case 2269:
#line 15064 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46380 "gram.c" /* yacc.c:1646  */
    break;

  case 2270:
#line 15067 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46386 "gram.c" /* yacc.c:1646  */
    break;

  case 2271:
#line 15069 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46392 "gram.c" /* yacc.c:1646  */
    break;

  case 2272:
#line 15071 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46398 "gram.c" /* yacc.c:1646  */
    break;

  case 2273:
#line 15073 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46404 "gram.c" /* yacc.c:1646  */
    break;

  case 2274:
#line 15084 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 46410 "gram.c" /* yacc.c:1646  */
    break;

  case 2275:
#line 15086 "gram.y" /* yacc.c:1646  */
    {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
											 yyscanner);
					}
#line 46419 "gram.c" /* yacc.c:1646  */
    break;

  case 2276:
#line 15097 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0]));
				}
#line 46427 "gram.c" /* yacc.c:1646  */
    break;

  case 2277:
#line 15101 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeFloatConst((yyvsp[0].str), (yylsp[0]));
				}
#line 46435 "gram.c" /* yacc.c:1646  */
    break;

  case 2278:
#line 15105 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 46443 "gram.c" /* yacc.c:1646  */
    break;

  case 2279:
#line 15109 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 46451 "gram.c" /* yacc.c:1646  */
    break;

  case 2280:
#line 15113 "gram.y" /* yacc.c:1646  */
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 46464 "gram.c" /* yacc.c:1646  */
    break;

  case 2281:
#line 15122 "gram.y" /* yacc.c:1646  */
    {
					/* generic type 'literal' syntax */
					TypeName *t = makeTypeNameFromNameList((yyvsp[-1].list));
					t->location = (yylsp[-1]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 46475 "gram.c" /* yacc.c:1646  */
    break;

  case 2282:
#line 15129 "gram.y" /* yacc.c:1646  */
    {
					/* generic syntax with a type modifier */
					TypeName *t = makeTypeNameFromNameList((yyvsp[-5].list));
					ListCell *lc;

					/*
					 * We must use func_arg_list and opt_sort_clause in the
					 * production to avoid reduce/reduce conflicts, but we
					 * don't actually wish to allow NamedArgExpr in this
					 * context, nor ORDER BY.
					 */
					foreach(lc, (yyvsp[-3].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have parameter name"),
									 parser_errposition(arg->location)));
					}
					if ((yyvsp[-2].list) != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have ORDER BY"),
									 parser_errposition((yylsp[-2]))));

					t->typmods = (yyvsp[-3].list);
					t->location = (yylsp[-5]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 46511 "gram.c" /* yacc.c:1646  */
    break;

  case 2283:
#line 15161 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), (yyvsp[-1].typnam));
				}
#line 46519 "gram.c" /* yacc.c:1646  */
    break;

  case 2284:
#line 15165 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-2].typnam);
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 46529 "gram.c" /* yacc.c:1646  */
    break;

  case 2285:
#line 15171 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-4].typnam);
					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 46540 "gram.c" /* yacc.c:1646  */
    break;

  case 2286:
#line 15178 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(true, (yylsp[0]));
				}
#line 46548 "gram.c" /* yacc.c:1646  */
    break;

  case 2287:
#line 15182 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(false, (yylsp[0]));
				}
#line 46556 "gram.c" /* yacc.c:1646  */
    break;

  case 2288:
#line 15186 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 46564 "gram.c" /* yacc.c:1646  */
    break;

  case 2289:
#line 15191 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 46570 "gram.c" /* yacc.c:1646  */
    break;

  case 2290:
#line 15192 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46576 "gram.c" /* yacc.c:1646  */
    break;

  case 2291:
#line 15194 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 46582 "gram.c" /* yacc.c:1646  */
    break;

  case 2292:
#line 15195 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = + (yyvsp[0].ival); }
#line 46588 "gram.c" /* yacc.c:1646  */
    break;

  case 2293:
#line 15196 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = - (yyvsp[0].ival); }
#line 46594 "gram.c" /* yacc.c:1646  */
    break;

  case 2294:
#line 15201 "gram.y" /* yacc.c:1646  */
    {
					RoleSpec *spc = (RoleSpec *) (yyvsp[0].rolespec);
					switch (spc->roletype)
					{
						case ROLESPEC_CSTRING:
							(yyval.str) = spc->rolename;
							break;
						case ROLESPEC_PUBLIC:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("role name \"%s\" is reserved",
											"public"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_SESSION_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"SESSION_USER"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_CURRENT_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_USER"),
									 parser_errposition((yylsp[0]))));
							break;
					}
				}
#line 46629 "gram.c" /* yacc.c:1646  */
    break;

  case 2295:
#line 15234 "gram.y" /* yacc.c:1646  */
    {
						/*
						 * "public" and "none" are not keywords, but they must
						 * be treated specially here.
						 */
						RoleSpec *n;
						if (strcmp((yyvsp[0].str), "public") == 0)
						{
							n = (RoleSpec *) makeRoleSpec(ROLESPEC_PUBLIC, (yylsp[0]));
							n->roletype = ROLESPEC_PUBLIC;
						}
						else if (strcmp((yyvsp[0].str), "none") == 0)
						{
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("role name \"%s\" is reserved",
											"none"),
									 parser_errposition((yylsp[0]))));
						}
						else
						{
							n = makeRoleSpec(ROLESPEC_CSTRING, (yylsp[0]));
							n->rolename = pstrdup((yyvsp[0].str));
						}
						(yyval.rolespec) = n;
					}
#line 46660 "gram.c" /* yacc.c:1646  */
    break;

  case 2296:
#line 15261 "gram.y" /* yacc.c:1646  */
    {
						(yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0]));
					}
#line 46668 "gram.c" /* yacc.c:1646  */
    break;

  case 2297:
#line 15265 "gram.y" /* yacc.c:1646  */
    {
						(yyval.rolespec) = makeRoleSpec(ROLESPEC_SESSION_USER, (yylsp[0]));
					}
#line 46676 "gram.c" /* yacc.c:1646  */
    break;

  case 2298:
#line 15271 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 46682 "gram.c" /* yacc.c:1646  */
    break;

  case 2299:
#line 15273 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 46688 "gram.c" /* yacc.c:1646  */
    break;

  case 2300:
#line 15289 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46694 "gram.c" /* yacc.c:1646  */
    break;

  case 2301:
#line 15290 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 46700 "gram.c" /* yacc.c:1646  */
    break;

  case 2302:
#line 15291 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 46706 "gram.c" /* yacc.c:1646  */
    break;

  case 2303:
#line 15296 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46712 "gram.c" /* yacc.c:1646  */
    break;

  case 2304:
#line 15297 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 46718 "gram.c" /* yacc.c:1646  */
    break;

  case 2305:
#line 15298 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 46724 "gram.c" /* yacc.c:1646  */
    break;

  case 2306:
#line 15303 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46730 "gram.c" /* yacc.c:1646  */
    break;

  case 2307:
#line 15304 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 46736 "gram.c" /* yacc.c:1646  */
    break;

  case 2308:
#line 15305 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 46742 "gram.c" /* yacc.c:1646  */
    break;

  case 2309:
#line 15306 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 46748 "gram.c" /* yacc.c:1646  */
    break;

  case 2310:
#line 15312 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46754 "gram.c" /* yacc.c:1646  */
    break;

  case 2311:
#line 15313 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 46760 "gram.c" /* yacc.c:1646  */
    break;

  case 2312:
#line 15314 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 46766 "gram.c" /* yacc.c:1646  */
    break;

  case 2313:
#line 15315 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 46772 "gram.c" /* yacc.c:1646  */
    break;

  case 2314:
#line 15316 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 46778 "gram.c" /* yacc.c:1646  */
    break;


#line 46782 "gram.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, yyscanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, yyscanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 15823 "gram.y" /* yacc.c:1906  */


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static RawStmt *
makeRawStmt(Node *stmt, int stmt_location)
{
	RawStmt    *rs = makeNode(RawStmt);

	rs->stmt = stmt;
	rs->stmt_location = stmt_location;
	rs->stmt_len = 0;			/* might get changed later */
	return rs;
}

/* Adjust a RawStmt to reflect that it doesn't run to the end of the string */
static void
updateRawStmtEnd(RawStmt *rs, int end_location)
{
	/*
	 * If we already set the length, don't change it.  This is for situations
	 * like "select foo ;; select bar" where the same statement will be last
	 * in the string for more than one semicolon.
	 */
	if (rs->stmt_len > 0)
		return;

	/* OK, update length of RawStmt */
	rs->stmt_len = end_location - rs->stmt_location;
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int		nfields = 0;
	ListCell *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(indirection, l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast *n = makeNode(TypeCast);
	n->arg = arg;
	n->typeName = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

Node *
makeIntConst(int val, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Integer;
	n->val.val.ival = val;
	n->location = location;

	return (Node *)n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Float;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_BitString;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Null;
	n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Value *v, int location)
{
	Node *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(v->val.str, location);
			break;

		case T_Integer:
			n = makeIntConst(v->val.ival, location);
			break;

		case T_String:
		default:
			n = makeStringConst(v->val.str, location);
			break;
	}

	return n;
}

/* makeBoolAConst()
 * Create an A_Const string node and put it inside a boolean cast.
 */
static Node *
makeBoolAConst(bool state, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = (state ? "t" : "f");
	n->location = location;

	return makeTypeCast((Node *)n, SystemTypeName("bool"), -1);
}

/* makeRoleSpec
 * Create a RoleSpec with the given type
 */
static RoleSpec *
makeRoleSpec(RoleSpecType type, int location)
{
	RoleSpec *spec = makeNode(RoleSpec);

	spec->roletype = type;
	spec->location = location;

	return spec;
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(indirection, l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* extractAggrArgTypes()
 * As above, but work from the output of the aggr_args production.
 */
static List *
extractAggrArgTypes(List *aggrargs)
{
	Assert(list_length(aggrargs) == 2);
	return extractArgTypes((List *) linitial(aggrargs));
}

/* makeOrderedSetArgs()
 * Build the result of the aggr_args production (which see the comments for).
 * This handles only the case where both given lists are nonempty, so that
 * we have to deal with multiple VARIADIC arguments.
 */
static List *
makeOrderedSetArgs(List *directargs, List *orderedargs,
				   core_yyscan_t yyscanner)
{
	FunctionParameter *lastd = (FunctionParameter *) llast(directargs);
	int			ndirectargs;

	/* No restriction unless last direct arg is VARIADIC */
	if (lastd->mode == FUNC_PARAM_VARIADIC)
	{
		FunctionParameter *firsto = (FunctionParameter *) linitial(orderedargs);

		/*
		 * We ignore the names, though the aggr_arg production allows them;
		 * it doesn't allow default values, so those need not be checked.
		 */
		if (list_length(orderedargs) != 1 ||
			firsto->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 errmsg("an ordered-set aggregate with a VARIADIC direct argument must have one VARIADIC aggregated argument of the same data type"),
					 parser_errposition(exprLocation((Node *) firsto))));

		/* OK, drop the duplicate VARIADIC argument from the internal form */
		orderedargs = NIL;
	}

	/* don't merge into the next line, as list_concat changes directargs */
	ndirectargs = list_length(directargs);

	return list_make2(list_concat(directargs, orderedargs),
					  makeInteger(ndirectargs));
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					SelectLimit *limitClause,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitClause && limitClause->limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitClause->limitOffset))));
		stmt->limitOffset = limitClause->limitOffset;
	}
	if (limitClause && limitClause->limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitClause->limitCount))));
		stmt->limitCount = limitClause->limitCount;
	}
	if (limitClause && limitClause->limitOption != LIMIT_OPTION_DEFAULT)
	{
		if (stmt->limitOption)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple limit options not allowed")));
		if (!stmt->sortClause && limitClause->limitOption == LIMIT_OPTION_WITH_TIES)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("WITH TIES options can not be specified without ORDER BY clause")));
		stmt->limitOption = limitClause->limitOption;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}
/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const *con = (A_Const *)n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (con->val.type == T_Integer)
		{
			con->val.val.ival = -con->val.val.ival;
			return n;
		}
		if (con->val.type == T_Float)
		{
			doNegateFloat(&con->val);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Value *v)
{
	char   *oldval = v->val.str;

	Assert(IsA(v, Float));
	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->val.str = oldval+1;	/* just strip the '-' */
	else
		v->val.str = psprintf("-%s", oldval);
}

static Node *
makeAndExpr(Node *lexpr, Node *rexpr, int location)
{
	Node	   *lexp = lexpr;

	/* Look through AEXPR_PAREN nodes so they don't affect flattening */
	while (IsA(lexp, A_Expr) &&
		   ((A_Expr *) lexp)->kind == AEXPR_PAREN)
		lexp = ((A_Expr *) lexp)->lexpr;
	/* Flatten "a AND b AND c ..." to a single BoolExpr on sight */
	if (IsA(lexp, BoolExpr))
	{
		BoolExpr *blexpr = (BoolExpr *) lexp;

		if (blexpr->boolop == AND_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(AND_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeOrExpr(Node *lexpr, Node *rexpr, int location)
{
	Node	   *lexp = lexpr;

	/* Look through AEXPR_PAREN nodes so they don't affect flattening */
	while (IsA(lexp, A_Expr) &&
		   ((A_Expr *) lexp)->kind == AEXPR_PAREN)
		lexp = ((A_Expr *) lexp)->lexpr;
	/* Flatten "a OR b OR c ..." to a single BoolExpr on sight */
	if (IsA(lexp, BoolExpr))
	{
		BoolExpr *blexpr = (BoolExpr *) lexp;

		if (blexpr->boolop == OR_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(OR_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeNotExpr(Node *expr, int location)
{
	return (Node *) makeBoolExpr(NOT_EXPR, list_make1(expr), location);
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod, int location)
{
	SQLValueFunction *svf = makeNode(SQLValueFunction);

	svf->op = op;
	/* svf->type will be filled during parse analysis */
	svf->typmod = typmod;
	svf->location = location;
	return (Node *) svf;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr		*x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_IN && p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Convert a list of (dotted) names to a RangeVar (like
 * makeRangeVarFromNameList, but with position support).  The
 * "AnyName" refers to the any_name production in the grammar.
 */
static RangeVar *
makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner)
{
	RangeVar *r = makeNode(RangeVar);

	switch (list_length(names))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = NULL;
			r->relname = strVal(linitial(names));
			break;
		case 2:
			r->catalogname = NULL;
			r->schemaname = strVal(linitial(names));
			r->relname = strVal(lsecond(names));
			break;
		case 3:
			r->catalogname = strVal(linitial(names));
			r->schemaname = strVal(lsecond(names));
			r->relname = strVal(lthird(names));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
							NameListToString(names)),
					 parser_errposition(position)));
			break;
	}

	r->relpersistence = RELPERSISTENCE_PERMANENT;
	r->location = position;

	return r;
}

/* Separate Constraint nodes from COLLATE clauses in a ColQualList */
static void
SplitColQualList(List *qualList,
				 List **constraintList, CollateClause **collClause,
				 core_yyscan_t yyscanner)
{
	ListCell   *cell;

	*collClause = NULL;
	foreach(cell, qualList)
	{
		Node   *n = (Node *) lfirst(cell);

		if (IsA(n, Constraint))
		{
			/* keep it in list */
			continue;
		}
		if (IsA(n, CollateClause))
		{
			CollateClause *c = (CollateClause *) n;

			if (*collClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("multiple COLLATE clauses not allowed"),
						 parser_errposition(c->location)));
			*collClause = c;
		}
		else
			elog(ERROR, "unexpected node type %d", (int) n->type);
		/* remove non-Constraint nodes from qualList */
		qualList = foreach_delete_current(qualList, cell);
	}
	*constraintList = qualList;
}

/*
 * Process result of ConstraintAttributeSpec, and set appropriate bool flags
 * in the output command node.  Pass NULL for any flags the particular
 * command doesn't support.
 */
static void
processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner)
{
	/* defaults */
	if (deferrable)
		*deferrable = false;
	if (initdeferred)
		*initdeferred = false;
	if (not_valid)
		*not_valid = false;

	if (cas_bits & (CAS_DEFERRABLE | CAS_INITIALLY_DEFERRED))
	{
		if (deferrable)
			*deferrable = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_INITIALLY_DEFERRED)
	{
		if (initdeferred)
			*initdeferred = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_VALID)
	{
		if (not_valid)
			*not_valid = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT VALID",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NO_INHERIT)
	{
		if (no_inherit)
			*no_inherit = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NO INHERIT",
							constrType),
					 parser_errposition(location)));
	}
}

/*----------
 * Recursive view transformation
 *
 * Convert
 *
 *     CREATE RECURSIVE VIEW relname (aliases) AS query
 *
 * to
 *
 *     CREATE VIEW relname (aliases) AS
 *         WITH RECURSIVE relname (aliases) AS (query)
 *         SELECT aliases FROM relname
 *
 * Actually, just the WITH ... part, which is then inserted into the original
 * view definition as the query.
 * ----------
 */
static Node *
makeRecursiveViewSelect(char *relname, List *aliases, Node *query)
{
	SelectStmt *s = makeNode(SelectStmt);
	WithClause *w = makeNode(WithClause);
	CommonTableExpr *cte = makeNode(CommonTableExpr);
	List	   *tl = NIL;
	ListCell   *lc;

	/* create common table expression */
	cte->ctename = relname;
	cte->aliascolnames = aliases;
	cte->ctematerialized = CTEMaterializeDefault;
	cte->ctequery = query;
	cte->location = -1;

	/* create WITH clause and attach CTE */
	w->recursive = true;
	w->ctes = list_make1(cte);
	w->location = -1;

	/* create target list for the new SELECT from the alias list of the
	 * recursive view specification */
	foreach (lc, aliases)
	{
		ResTarget *rt = makeNode(ResTarget);

		rt->name = NULL;
		rt->indirection = NIL;
		rt->val = makeColumnRef(strVal(lfirst(lc)), NIL, -1, 0);
		rt->location = -1;

		tl = lappend(tl, rt);
	}

	/* create new SELECT combining WITH clause, target list, and fake FROM
	 * clause */
	s->withClause = w;
	s->targetList = tl;
	s->fromClause = list_make1(makeRangeVar(NULL, relname, -1));

	return (Node *) s;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}

