/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         minimal_base_yyparse
#define yylex           minimal_base_yylex
#define yyerror         minimal_base_yyerror
#define yydebug         minimal_base_yydebug
#define yynerrs         minimal_base_yynerrs


/* Copy the first part of user declarations.  */
#line 1 "gram_minimal.y" /* yacc.c:339  */


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 2003-2020, PgPool Global Development Group
 * Portions Copyright (c) 1996-2020, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  src/backend/parser/gram.y
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET constraint_exclusion TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */

#include "pool_parser.h"
#include "utils/elog.h"
#include "utils/palloc.h"
#include <ctype.h>
#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "nodes.h"
#include "keywords.h"
#include "gramparse.h"
#include "makefuncs.h"
#include "pool_string.h"
#include "parser.h"
#include "pg_class.h"
#include "pg_trigger.h"

/* This is a configuration parameter since PostgreSQL 9.5.
 * We set this false in pgpool-II. This is default in PostgreSQL.
 */
static bool operator_precedence_warning = false;

/*
 * Definition taken from
 * postgreSQL source code file: src/include/commands/trigger.h
 */
#define TRIGGER_FIRES_ON_ORIGIN                         'O'
#define TRIGGER_FIRES_ALWAYS                            'A'
#define TRIGGER_FIRES_ON_REPLICA                        'R'
#define TRIGGER_DISABLED                                'D'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/catalog/pg_class.h
 */

#define           REPLICA_IDENTITY_DEFAULT      'd'
#define           REPLICA_IDENTITY_NOTHING      'n'
#define           REPLICA_IDENTITY_FULL         'f'
#define           REPLICA_IDENTITY_INDEX        'i'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/catalog/pg_attribute.h
 */
#define		  ATTRIBUTE_IDENTITY_ALWAYS	'a'
#define		  ATTRIBUTE_IDENTITY_BY_DEFAULT 'd'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/utils/xml.h
 */
typedef enum
{
	XML_STANDALONE_YES,
	XML_STANDALONE_NO,
	XML_STANDALONE_NO_VALUE,
	XML_STANDALONE_OMITTED
} XmlStandaloneType;

/*
 * Location tracking support --- simpler than bison's default, since we only
 * want to track the start position not the end position of each nonterminal.
 */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if ((N) > 0) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (-1); \
	} while (0)

/*
 * The above macro assigns -1 (unknown) as the parse location of any
 * nonterminal that was reduced from an empty rule, or whose leftmost
 * component was reduced from an empty rule.  This is problematic
 * for nonterminals defined like
 *		OptFooList: / * EMPTY * / { ... } | OptFooList Foo { ... } ;
 * because we'll set -1 as the location during the first reduction and then
 * copy it during each subsequent reduction, leaving us with -1 for the
 * location even when the list is not empty.  To fix that, do this in the
 * action for the nonempty rule(s):
 *		if (@$ < 0) @$ = @2;
 * (Although we have many nonterminals that follow this pattern, we only
 * bother with fixing @$ like this when the nonterminal's parse location
 * is actually referenced in some rule.)
 *
 * A cleaner answer would be to make YYLLOC_DEFAULT scan all the Rhs
 * locations until it's found one that's not -1.  Then we'd get a correct
 * location for any nonterminal that isn't entirely empty.  But this way
 * would add overhead to every rule reduction, and so far there's not been
 * a compelling reason to pay that overhead.
 */

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	ObjectType	objtype;
	List	   *objs;
} PrivTarget;

/* Private struct for the result of import_qualification production */
typedef struct ImportQual
{
	ImportForeignSchemaType type;
	List	   *table_names;
} ImportQual;

/* Private struct for the result of opt_select_limit production */
typedef struct SelectLimit
{
	Node *limitOffset;
	Node *limitCount;
	LimitOption limitOption;
} SelectLimit;

/* ConstraintAttributeSpec yields an integer bitmask of these flags: */
#define CAS_NOT_DEFERRABLE			0x01
#define CAS_DEFERRABLE				0x02
#define CAS_INITIALLY_IMMEDIATE		0x04
#define CAS_INITIALLY_DEFERRED		0x08
#define CAS_NOT_VALID				0x10
#define CAS_NO_INHERIT				0x20


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void minimal_base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static RawStmt *makeRawStmt(Node *stmt, int stmt_location);
static void updateRawStmtEnd(RawStmt *rs, int end_location);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeStringConst(char *str, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Value *v, int location);
static Node *makeBoolAConst(bool state, int location);
static RoleSpec *makeRoleSpec(RoleSpecType type, int location);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static List *extractAggrArgTypes(List *aggrargs);
static List *makeOrderedSetArgs(List *directargs, List *orderedargs,
								core_yyscan_t yyscanner);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								SelectLimit *limitClause,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Value *v);
static Node *makeAndExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeOrExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeNotExpr(Node *expr, int location);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod,
								  int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);
static RangeVar *makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner);
static void SplitColQualList(List *qualList,
							 List **constraintList, CollateClause **collClause,
							 core_yyscan_t yyscanner);
static void processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner);
static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);


#line 309 "gram_minimal.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_MINIMAL_BASE_YY_Y_TAB_H_INCLUDED
# define YY_MINIMAL_BASE_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int minimal_base_yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    IDENT = 258,
    UIDENT = 259,
    FCONST = 260,
    SCONST = 261,
    USCONST = 262,
    BCONST = 263,
    XCONST = 264,
    Op = 265,
    ICONST = 266,
    PARAM = 267,
    TYPECAST = 268,
    DOT_DOT = 269,
    COLON_EQUALS = 270,
    EQUALS_GREATER = 271,
    LESS_EQUALS = 272,
    GREATER_EQUALS = 273,
    NOT_EQUALS = 274,
    ABORT_P = 275,
    ABSOLUTE_P = 276,
    ACCESS = 277,
    ACTION = 278,
    ADD_P = 279,
    ADMIN = 280,
    AFTER = 281,
    AGGREGATE = 282,
    ALL = 283,
    ALSO = 284,
    ALTER = 285,
    ALWAYS = 286,
    ANALYSE = 287,
    ANALYZE = 288,
    AND = 289,
    ANY = 290,
    ARRAY = 291,
    AS = 292,
    ASC = 293,
    ASSERTION = 294,
    ASSIGNMENT = 295,
    ASYMMETRIC = 296,
    AT = 297,
    ATTACH = 298,
    ATTRIBUTE = 299,
    AUTHORIZATION = 300,
    BACKWARD = 301,
    BEFORE = 302,
    BEGIN_P = 303,
    BETWEEN = 304,
    BIGINT = 305,
    BINARY = 306,
    BIT = 307,
    BOOLEAN_P = 308,
    BOTH = 309,
    BY = 310,
    CACHE = 311,
    CALL = 312,
    CALLED = 313,
    CASCADE = 314,
    CASCADED = 315,
    CASE = 316,
    CAST = 317,
    CATALOG_P = 318,
    CHAIN = 319,
    CHAR_P = 320,
    CHARACTER = 321,
    CHARACTERISTICS = 322,
    CHECK = 323,
    CHECKPOINT = 324,
    CLASS = 325,
    CLOSE = 326,
    CLUSTER = 327,
    COALESCE = 328,
    COLLATE = 329,
    COLLATION = 330,
    COLUMN = 331,
    COLUMNS = 332,
    COMMENT = 333,
    COMMENTS = 334,
    COMMIT = 335,
    COMMITTED = 336,
    CONCURRENTLY = 337,
    CONFIGURATION = 338,
    CONFLICT = 339,
    CONNECTION = 340,
    CONSTRAINT = 341,
    CONSTRAINTS = 342,
    CONTENT_P = 343,
    CONTINUE_P = 344,
    CONVERSION_P = 345,
    COPY = 346,
    COST = 347,
    CREATE = 348,
    CROSS = 349,
    CSV = 350,
    CUBE = 351,
    CURRENT_P = 352,
    CURRENT_CATALOG = 353,
    CURRENT_DATE = 354,
    CURRENT_ROLE = 355,
    CURRENT_SCHEMA = 356,
    CURRENT_TIME = 357,
    CURRENT_TIMESTAMP = 358,
    CURRENT_USER = 359,
    CURSOR = 360,
    CYCLE = 361,
    DATA_P = 362,
    DATABASE = 363,
    DAY_P = 364,
    DEALLOCATE = 365,
    DEC = 366,
    DECIMAL_P = 367,
    DECLARE = 368,
    DEFAULT = 369,
    DEFAULTS = 370,
    DEFERRABLE = 371,
    DEFERRED = 372,
    DEFINER = 373,
    DELETE_P = 374,
    DELIMITER = 375,
    DELIMITERS = 376,
    DEPENDS = 377,
    DESC = 378,
    DETACH = 379,
    DICTIONARY = 380,
    DISABLE_P = 381,
    DISCARD = 382,
    DISTINCT = 383,
    DO = 384,
    DOCUMENT_P = 385,
    DOMAIN_P = 386,
    DOUBLE_P = 387,
    DROP = 388,
    EACH = 389,
    ELSE = 390,
    ENABLE_P = 391,
    ENCODING = 392,
    ENCRYPTED = 393,
    END_P = 394,
    ENUM_P = 395,
    ESCAPE = 396,
    EVENT = 397,
    EXCEPT = 398,
    EXCLUDE = 399,
    EXCLUDING = 400,
    EXCLUSIVE = 401,
    EXECUTE = 402,
    EXISTS = 403,
    EXPLAIN = 404,
    EXPRESSION = 405,
    EXTENSION = 406,
    EXTERNAL = 407,
    EXTRACT = 408,
    FALSE_P = 409,
    FAMILY = 410,
    FETCH = 411,
    FILTER = 412,
    FIRST_P = 413,
    FLOAT_P = 414,
    FOLLOWING = 415,
    FOR = 416,
    FORCE = 417,
    FOREIGN = 418,
    FORWARD = 419,
    FREEZE = 420,
    FROM = 421,
    FULL = 422,
    FUNCTION = 423,
    FUNCTIONS = 424,
    GENERATED = 425,
    GLOBAL = 426,
    GRANT = 427,
    GRANTED = 428,
    GREATEST = 429,
    GROUP_P = 430,
    GROUPING = 431,
    GROUPS = 432,
    HANDLER = 433,
    HAVING = 434,
    HEADER_P = 435,
    HOLD = 436,
    HOUR_P = 437,
    IDENTITY_P = 438,
    IF_P = 439,
    ILIKE = 440,
    IMMEDIATE = 441,
    IMMUTABLE = 442,
    IMPLICIT_P = 443,
    IMPORT_P = 444,
    IN_P = 445,
    INCLUDE = 446,
    INCLUDING = 447,
    INCREMENT = 448,
    INDEX = 449,
    INDEXES = 450,
    INHERIT = 451,
    INHERITS = 452,
    INITIALLY = 453,
    INLINE_P = 454,
    INNER_P = 455,
    INOUT = 456,
    INPUT_P = 457,
    INSENSITIVE = 458,
    INSERT = 459,
    INSTEAD = 460,
    INT_P = 461,
    INTEGER = 462,
    INTERSECT = 463,
    INTERVAL = 464,
    INTO = 465,
    INVOKER = 466,
    IS = 467,
    ISNULL = 468,
    ISOLATION = 469,
    JOIN = 470,
    KEY = 471,
    LABEL = 472,
    LANGUAGE = 473,
    LARGE_P = 474,
    LAST_P = 475,
    LATERAL_P = 476,
    LEADING = 477,
    LEAKPROOF = 478,
    LEAST = 479,
    LEFT = 480,
    LEVEL = 481,
    LIKE = 482,
    LIMIT = 483,
    LISTEN = 484,
    LOAD = 485,
    LOCAL = 486,
    LOCALTIME = 487,
    LOCALTIMESTAMP = 488,
    LOCATION = 489,
    LOCK_P = 490,
    LOCKED = 491,
    LOGGED = 492,
    MAPPING = 493,
    MATCH = 494,
    MATERIALIZED = 495,
    MAXVALUE = 496,
    METHOD = 497,
    MINUTE_P = 498,
    MINVALUE = 499,
    MODE = 500,
    MONTH_P = 501,
    MOVE = 502,
    NAME_P = 503,
    NAMES = 504,
    NATIONAL = 505,
    NATURAL = 506,
    NCHAR = 507,
    NEW = 508,
    NEXT = 509,
    NFC = 510,
    NFD = 511,
    NFKC = 512,
    NFKD = 513,
    NO = 514,
    NONE = 515,
    NORMALIZE = 516,
    NORMALIZED = 517,
    NOT = 518,
    NOTHING = 519,
    NOTIFY = 520,
    NOTNULL = 521,
    NOWAIT = 522,
    NULL_P = 523,
    NULLIF = 524,
    NULLS_P = 525,
    NUMERIC = 526,
    OBJECT_P = 527,
    OF = 528,
    OFF = 529,
    OFFSET = 530,
    OIDS = 531,
    OLD = 532,
    ON = 533,
    ONLY = 534,
    OPERATOR = 535,
    OPTION = 536,
    OPTIONS = 537,
    OR = 538,
    ORDER = 539,
    ORDINALITY = 540,
    OTHERS = 541,
    OUT_P = 542,
    OUTER_P = 543,
    OVER = 544,
    OVERLAPS = 545,
    OVERLAY = 546,
    OVERRIDING = 547,
    OWNED = 548,
    OWNER = 549,
    PARALLEL = 550,
    PARSER = 551,
    PARTIAL = 552,
    PARTITION = 553,
    PASSING = 554,
    PASSWORD = 555,
    PGPOOL = 556,
    PLACING = 557,
    PLANS = 558,
    POLICY = 559,
    POSITION = 560,
    PRECEDING = 561,
    PRECISION = 562,
    PRESERVE = 563,
    PREPARE = 564,
    PREPARED = 565,
    PRIMARY = 566,
    PRIOR = 567,
    PRIVILEGES = 568,
    PROCEDURAL = 569,
    PROCEDURE = 570,
    PROCEDURES = 571,
    PROGRAM = 572,
    PUBLICATION = 573,
    QUOTE = 574,
    RANGE = 575,
    READ = 576,
    REAL = 577,
    REASSIGN = 578,
    RECHECK = 579,
    RECURSIVE = 580,
    REF = 581,
    REFERENCES = 582,
    REFERENCING = 583,
    REFRESH = 584,
    REINDEX = 585,
    RELATIVE_P = 586,
    RELEASE = 587,
    RENAME = 588,
    REPEATABLE = 589,
    REPLACE = 590,
    REPLICA = 591,
    RESET = 592,
    RESTART = 593,
    RESTRICT = 594,
    RETURNING = 595,
    RETURNS = 596,
    REVOKE = 597,
    RIGHT = 598,
    ROLE = 599,
    ROLLBACK = 600,
    ROLLUP = 601,
    ROUTINE = 602,
    ROUTINES = 603,
    ROW = 604,
    ROWS = 605,
    RULE = 606,
    SAVEPOINT = 607,
    SCHEMA = 608,
    SCHEMAS = 609,
    SCROLL = 610,
    SEARCH = 611,
    SECOND_P = 612,
    SECURITY = 613,
    SELECT = 614,
    SEQUENCE = 615,
    SEQUENCES = 616,
    SERIALIZABLE = 617,
    SERVER = 618,
    SESSION = 619,
    SESSION_USER = 620,
    SET = 621,
    SETS = 622,
    SETOF = 623,
    SHARE = 624,
    SHOW = 625,
    SIMILAR = 626,
    SIMPLE = 627,
    SKIP = 628,
    SMALLINT = 629,
    SNAPSHOT = 630,
    SOME = 631,
    SQL_P = 632,
    STABLE = 633,
    STANDALONE_P = 634,
    START = 635,
    STATEMENT = 636,
    STATISTICS = 637,
    STDIN = 638,
    STDOUT = 639,
    STORAGE = 640,
    STORED = 641,
    STRICT_P = 642,
    STRIP_P = 643,
    SUBSCRIPTION = 644,
    SUBSTRING = 645,
    SUPPORT = 646,
    SYMMETRIC = 647,
    SYSID = 648,
    SYSTEM_P = 649,
    TABLE = 650,
    TABLES = 651,
    TABLESAMPLE = 652,
    TABLESPACE = 653,
    TEMP = 654,
    TEMPLATE = 655,
    TEMPORARY = 656,
    TEXT_P = 657,
    THEN = 658,
    TIES = 659,
    TIME = 660,
    TIMESTAMP = 661,
    TO = 662,
    TRAILING = 663,
    TRANSACTION = 664,
    TRANSFORM = 665,
    TREAT = 666,
    TRIGGER = 667,
    TRIM = 668,
    TRUE_P = 669,
    TRUNCATE = 670,
    TRUSTED = 671,
    TYPE_P = 672,
    TYPES_P = 673,
    UESCAPE = 674,
    UNBOUNDED = 675,
    UNCOMMITTED = 676,
    UNENCRYPTED = 677,
    UNION = 678,
    UNIQUE = 679,
    UNKNOWN = 680,
    UNLISTEN = 681,
    UNLOGGED = 682,
    UNTIL = 683,
    UPDATE = 684,
    USER = 685,
    USING = 686,
    VACUUM = 687,
    VALID = 688,
    VALIDATE = 689,
    VALIDATOR = 690,
    VALUE_P = 691,
    VALUES = 692,
    VARCHAR = 693,
    VARIADIC = 694,
    VARYING = 695,
    VERBOSE = 696,
    VERSION_P = 697,
    VIEW = 698,
    VIEWS = 699,
    VOLATILE = 700,
    WHEN = 701,
    WHERE = 702,
    WHITESPACE_P = 703,
    WINDOW = 704,
    WITH = 705,
    WITHIN = 706,
    WITHOUT = 707,
    WORK = 708,
    WRAPPER = 709,
    WRITE = 710,
    XML_P = 711,
    XMLATTRIBUTES = 712,
    XMLCONCAT = 713,
    XMLELEMENT = 714,
    XMLEXISTS = 715,
    XMLFOREST = 716,
    XMLNAMESPACES = 717,
    XMLPARSE = 718,
    XMLPI = 719,
    XMLROOT = 720,
    XMLSERIALIZE = 721,
    XMLTABLE = 722,
    YEAR_P = 723,
    YES_P = 724,
    ZONE = 725,
    NOT_LA = 726,
    NULLS_LA = 727,
    WITH_LA = 728,
    POSTFIXOP = 729,
    UMINUS = 730
  };
#endif
/* Tokens.  */
#define IDENT 258
#define UIDENT 259
#define FCONST 260
#define SCONST 261
#define USCONST 262
#define BCONST 263
#define XCONST 264
#define Op 265
#define ICONST 266
#define PARAM 267
#define TYPECAST 268
#define DOT_DOT 269
#define COLON_EQUALS 270
#define EQUALS_GREATER 271
#define LESS_EQUALS 272
#define GREATER_EQUALS 273
#define NOT_EQUALS 274
#define ABORT_P 275
#define ABSOLUTE_P 276
#define ACCESS 277
#define ACTION 278
#define ADD_P 279
#define ADMIN 280
#define AFTER 281
#define AGGREGATE 282
#define ALL 283
#define ALSO 284
#define ALTER 285
#define ALWAYS 286
#define ANALYSE 287
#define ANALYZE 288
#define AND 289
#define ANY 290
#define ARRAY 291
#define AS 292
#define ASC 293
#define ASSERTION 294
#define ASSIGNMENT 295
#define ASYMMETRIC 296
#define AT 297
#define ATTACH 298
#define ATTRIBUTE 299
#define AUTHORIZATION 300
#define BACKWARD 301
#define BEFORE 302
#define BEGIN_P 303
#define BETWEEN 304
#define BIGINT 305
#define BINARY 306
#define BIT 307
#define BOOLEAN_P 308
#define BOTH 309
#define BY 310
#define CACHE 311
#define CALL 312
#define CALLED 313
#define CASCADE 314
#define CASCADED 315
#define CASE 316
#define CAST 317
#define CATALOG_P 318
#define CHAIN 319
#define CHAR_P 320
#define CHARACTER 321
#define CHARACTERISTICS 322
#define CHECK 323
#define CHECKPOINT 324
#define CLASS 325
#define CLOSE 326
#define CLUSTER 327
#define COALESCE 328
#define COLLATE 329
#define COLLATION 330
#define COLUMN 331
#define COLUMNS 332
#define COMMENT 333
#define COMMENTS 334
#define COMMIT 335
#define COMMITTED 336
#define CONCURRENTLY 337
#define CONFIGURATION 338
#define CONFLICT 339
#define CONNECTION 340
#define CONSTRAINT 341
#define CONSTRAINTS 342
#define CONTENT_P 343
#define CONTINUE_P 344
#define CONVERSION_P 345
#define COPY 346
#define COST 347
#define CREATE 348
#define CROSS 349
#define CSV 350
#define CUBE 351
#define CURRENT_P 352
#define CURRENT_CATALOG 353
#define CURRENT_DATE 354
#define CURRENT_ROLE 355
#define CURRENT_SCHEMA 356
#define CURRENT_TIME 357
#define CURRENT_TIMESTAMP 358
#define CURRENT_USER 359
#define CURSOR 360
#define CYCLE 361
#define DATA_P 362
#define DATABASE 363
#define DAY_P 364
#define DEALLOCATE 365
#define DEC 366
#define DECIMAL_P 367
#define DECLARE 368
#define DEFAULT 369
#define DEFAULTS 370
#define DEFERRABLE 371
#define DEFERRED 372
#define DEFINER 373
#define DELETE_P 374
#define DELIMITER 375
#define DELIMITERS 376
#define DEPENDS 377
#define DESC 378
#define DETACH 379
#define DICTIONARY 380
#define DISABLE_P 381
#define DISCARD 382
#define DISTINCT 383
#define DO 384
#define DOCUMENT_P 385
#define DOMAIN_P 386
#define DOUBLE_P 387
#define DROP 388
#define EACH 389
#define ELSE 390
#define ENABLE_P 391
#define ENCODING 392
#define ENCRYPTED 393
#define END_P 394
#define ENUM_P 395
#define ESCAPE 396
#define EVENT 397
#define EXCEPT 398
#define EXCLUDE 399
#define EXCLUDING 400
#define EXCLUSIVE 401
#define EXECUTE 402
#define EXISTS 403
#define EXPLAIN 404
#define EXPRESSION 405
#define EXTENSION 406
#define EXTERNAL 407
#define EXTRACT 408
#define FALSE_P 409
#define FAMILY 410
#define FETCH 411
#define FILTER 412
#define FIRST_P 413
#define FLOAT_P 414
#define FOLLOWING 415
#define FOR 416
#define FORCE 417
#define FOREIGN 418
#define FORWARD 419
#define FREEZE 420
#define FROM 421
#define FULL 422
#define FUNCTION 423
#define FUNCTIONS 424
#define GENERATED 425
#define GLOBAL 426
#define GRANT 427
#define GRANTED 428
#define GREATEST 429
#define GROUP_P 430
#define GROUPING 431
#define GROUPS 432
#define HANDLER 433
#define HAVING 434
#define HEADER_P 435
#define HOLD 436
#define HOUR_P 437
#define IDENTITY_P 438
#define IF_P 439
#define ILIKE 440
#define IMMEDIATE 441
#define IMMUTABLE 442
#define IMPLICIT_P 443
#define IMPORT_P 444
#define IN_P 445
#define INCLUDE 446
#define INCLUDING 447
#define INCREMENT 448
#define INDEX 449
#define INDEXES 450
#define INHERIT 451
#define INHERITS 452
#define INITIALLY 453
#define INLINE_P 454
#define INNER_P 455
#define INOUT 456
#define INPUT_P 457
#define INSENSITIVE 458
#define INSERT 459
#define INSTEAD 460
#define INT_P 461
#define INTEGER 462
#define INTERSECT 463
#define INTERVAL 464
#define INTO 465
#define INVOKER 466
#define IS 467
#define ISNULL 468
#define ISOLATION 469
#define JOIN 470
#define KEY 471
#define LABEL 472
#define LANGUAGE 473
#define LARGE_P 474
#define LAST_P 475
#define LATERAL_P 476
#define LEADING 477
#define LEAKPROOF 478
#define LEAST 479
#define LEFT 480
#define LEVEL 481
#define LIKE 482
#define LIMIT 483
#define LISTEN 484
#define LOAD 485
#define LOCAL 486
#define LOCALTIME 487
#define LOCALTIMESTAMP 488
#define LOCATION 489
#define LOCK_P 490
#define LOCKED 491
#define LOGGED 492
#define MAPPING 493
#define MATCH 494
#define MATERIALIZED 495
#define MAXVALUE 496
#define METHOD 497
#define MINUTE_P 498
#define MINVALUE 499
#define MODE 500
#define MONTH_P 501
#define MOVE 502
#define NAME_P 503
#define NAMES 504
#define NATIONAL 505
#define NATURAL 506
#define NCHAR 507
#define NEW 508
#define NEXT 509
#define NFC 510
#define NFD 511
#define NFKC 512
#define NFKD 513
#define NO 514
#define NONE 515
#define NORMALIZE 516
#define NORMALIZED 517
#define NOT 518
#define NOTHING 519
#define NOTIFY 520
#define NOTNULL 521
#define NOWAIT 522
#define NULL_P 523
#define NULLIF 524
#define NULLS_P 525
#define NUMERIC 526
#define OBJECT_P 527
#define OF 528
#define OFF 529
#define OFFSET 530
#define OIDS 531
#define OLD 532
#define ON 533
#define ONLY 534
#define OPERATOR 535
#define OPTION 536
#define OPTIONS 537
#define OR 538
#define ORDER 539
#define ORDINALITY 540
#define OTHERS 541
#define OUT_P 542
#define OUTER_P 543
#define OVER 544
#define OVERLAPS 545
#define OVERLAY 546
#define OVERRIDING 547
#define OWNED 548
#define OWNER 549
#define PARALLEL 550
#define PARSER 551
#define PARTIAL 552
#define PARTITION 553
#define PASSING 554
#define PASSWORD 555
#define PGPOOL 556
#define PLACING 557
#define PLANS 558
#define POLICY 559
#define POSITION 560
#define PRECEDING 561
#define PRECISION 562
#define PRESERVE 563
#define PREPARE 564
#define PREPARED 565
#define PRIMARY 566
#define PRIOR 567
#define PRIVILEGES 568
#define PROCEDURAL 569
#define PROCEDURE 570
#define PROCEDURES 571
#define PROGRAM 572
#define PUBLICATION 573
#define QUOTE 574
#define RANGE 575
#define READ 576
#define REAL 577
#define REASSIGN 578
#define RECHECK 579
#define RECURSIVE 580
#define REF 581
#define REFERENCES 582
#define REFERENCING 583
#define REFRESH 584
#define REINDEX 585
#define RELATIVE_P 586
#define RELEASE 587
#define RENAME 588
#define REPEATABLE 589
#define REPLACE 590
#define REPLICA 591
#define RESET 592
#define RESTART 593
#define RESTRICT 594
#define RETURNING 595
#define RETURNS 596
#define REVOKE 597
#define RIGHT 598
#define ROLE 599
#define ROLLBACK 600
#define ROLLUP 601
#define ROUTINE 602
#define ROUTINES 603
#define ROW 604
#define ROWS 605
#define RULE 606
#define SAVEPOINT 607
#define SCHEMA 608
#define SCHEMAS 609
#define SCROLL 610
#define SEARCH 611
#define SECOND_P 612
#define SECURITY 613
#define SELECT 614
#define SEQUENCE 615
#define SEQUENCES 616
#define SERIALIZABLE 617
#define SERVER 618
#define SESSION 619
#define SESSION_USER 620
#define SET 621
#define SETS 622
#define SETOF 623
#define SHARE 624
#define SHOW 625
#define SIMILAR 626
#define SIMPLE 627
#define SKIP 628
#define SMALLINT 629
#define SNAPSHOT 630
#define SOME 631
#define SQL_P 632
#define STABLE 633
#define STANDALONE_P 634
#define START 635
#define STATEMENT 636
#define STATISTICS 637
#define STDIN 638
#define STDOUT 639
#define STORAGE 640
#define STORED 641
#define STRICT_P 642
#define STRIP_P 643
#define SUBSCRIPTION 644
#define SUBSTRING 645
#define SUPPORT 646
#define SYMMETRIC 647
#define SYSID 648
#define SYSTEM_P 649
#define TABLE 650
#define TABLES 651
#define TABLESAMPLE 652
#define TABLESPACE 653
#define TEMP 654
#define TEMPLATE 655
#define TEMPORARY 656
#define TEXT_P 657
#define THEN 658
#define TIES 659
#define TIME 660
#define TIMESTAMP 661
#define TO 662
#define TRAILING 663
#define TRANSACTION 664
#define TRANSFORM 665
#define TREAT 666
#define TRIGGER 667
#define TRIM 668
#define TRUE_P 669
#define TRUNCATE 670
#define TRUSTED 671
#define TYPE_P 672
#define TYPES_P 673
#define UESCAPE 674
#define UNBOUNDED 675
#define UNCOMMITTED 676
#define UNENCRYPTED 677
#define UNION 678
#define UNIQUE 679
#define UNKNOWN 680
#define UNLISTEN 681
#define UNLOGGED 682
#define UNTIL 683
#define UPDATE 684
#define USER 685
#define USING 686
#define VACUUM 687
#define VALID 688
#define VALIDATE 689
#define VALIDATOR 690
#define VALUE_P 691
#define VALUES 692
#define VARCHAR 693
#define VARIADIC 694
#define VARYING 695
#define VERBOSE 696
#define VERSION_P 697
#define VIEW 698
#define VIEWS 699
#define VOLATILE 700
#define WHEN 701
#define WHERE 702
#define WHITESPACE_P 703
#define WINDOW 704
#define WITH 705
#define WITHIN 706
#define WITHOUT 707
#define WORK 708
#define WRAPPER 709
#define WRITE 710
#define XML_P 711
#define XMLATTRIBUTES 712
#define XMLCONCAT 713
#define XMLELEMENT 714
#define XMLEXISTS 715
#define XMLFOREST 716
#define XMLNAMESPACES 717
#define XMLPARSE 718
#define XMLPI 719
#define XMLROOT 720
#define XMLSERIALIZE 721
#define XMLTABLE 722
#define YEAR_P 723
#define YES_P 724
#define ZONE 725
#define NOT_LA 726
#define NULLS_LA 727
#define WITH_LA 728
#define POSTFIXOP 729
#define UMINUS 730

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 247 "gram_minimal.y" /* yacc.c:355  */

	core_YYSTYPE		core_yystype;
	/* these fields must match core_YYSTYPE: */
	int					ival;
	char				*str;
	const char			*keyword;

	char				chr;
	bool				boolean;
	JoinType			jtype;
	DropBehavior		dbehavior;
	OnCommitAction		oncommit;
	List				*list;
	Node				*node;
	Value				*value;
	ObjectType			objtype;
	TypeName			*typnam;
	FunctionParameter   *fun_param;
	FunctionParameterMode fun_param_mode;
	ObjectWithArgs		*objwithargs;
	DefElem				*defelt;
	SortBy				*sortby;
	WindowDef			*windef;
	JoinExpr			*jexpr;
	IndexElem			*ielem;
	Alias				*alias;
	RangeVar			*range;
	IntoClause			*into;
	WithClause			*with;
	InferClause			*infer;
	OnConflictClause	*onconflict;
	A_Indices			*aind;
	ResTarget			*target;
	struct PrivTarget	*privtarget;
	AccessPriv			*accesspriv;
	struct ImportQual	*importqual;
	InsertStmt			*istmt;
	VariableSetStmt		*vsetstmt;
	PartitionElem		*partelem;
	PartitionSpec		*partspec;
	PartitionBoundSpec	*partboundspec;
	RoleSpec			*rolespec;
	struct SelectLimit	*selectlimit;

#line 1344 "gram_minimal.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int minimal_base_yyparse (core_yyscan_t yyscanner);

#endif /* !YY_MINIMAL_BASE_YY_Y_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 1374 "gram_minimal.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  842
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   104109

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  493
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  675
/* YYNRULES -- Number of rules.  */
#define YYNRULES  2766
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  5573

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   730

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   482,     2,     2,
     487,   488,   480,   478,   491,   479,   489,   481,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   492,   490,
     474,   476,   475,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   485,     2,   486,   483,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   477,
     484
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   843,   843,   859,   871,   881,   882,   883,   884,   885,
     886,   887,   888,   889,   890,   891,   892,   893,   894,   895,
     896,   897,   898,   899,   900,   901,   902,   903,   904,   905,
     906,   907,   908,   909,   910,   911,   912,   913,   914,   915,
     916,   917,   918,   919,   920,   921,   922,   923,   924,   925,
     926,   927,   928,   929,   930,   931,   932,   933,   934,   935,
     936,   937,   938,   939,   940,   941,   942,   943,   944,   945,
     946,   947,   948,   949,   950,   951,   952,   953,   954,   955,
     956,   957,   958,   959,   960,   961,   962,   963,   964,   965,
     966,   967,   968,   969,   970,   971,   972,   973,   974,   975,
     976,   977,   978,   979,   980,   981,   982,   983,   984,   985,
     986,   987,   988,   989,   990,   991,   992,   993,   994,   995,
     996,   997,   998,   999,  1000,  1001,  1002,  1003,  1004,  1005,
    1007,  1016,  1031,  1042,  1043,  1044,  1053,  1054,  1058,  1059,
    1063,  1068,  1072,  1082,  1090,  1094,  1098,  1103,  1107,  1155,
    1157,  1161,  1165,  1169,  1173,  1187,  1205,  1213,  1224,  1225,
    1229,  1237,  1245,  1253,  1274,  1281,  1288,  1295,  1302,  1309,
    1326,  1344,  1355,  1356,  1367,  1377,  1387,  1402,  1420,  1421,
    1425,  1432,  1440,  1441,  1442,  1443,  1444,  1445,  1459,  1466,
    1472,  1478,  1487,  1495,  1503,  1507,  1515,  1523,  1530,  1540,
    1541,  1549,  1560,  1568,  1576,  1587,  1595,  1603,  1610,  1619,
    1629,  1630,  1634,  1635,  1638,  1640,  1644,  1645,  1646,  1647,
    1651,  1652,  1653,  1659,  1671,  1675,  1679,  1694,  1701,  1702,
    1703,  1707,  1708,  1709,  1713,  1714,  1718,  1719,  1728,  1729,
    1736,  1743,  1753,  1760,  1770,  1771,  1776,  1777,  1783,  1789,
    1795,  1801,  1807,  1813,  1819,  1829,  1839,  1840,  1844,  1845,
    1853,  1868,  1874,  1880,  1886,  1892,  1911,  1920,  1929,  1938,
    1947,  1958,  1969,  1978,  1987,  1996,  2007,  2018,  2027,  2036,
    2045,  2054,  2063,  2072,  2083,  2097,  2098,  2103,  2116,  2132,
    2148,  2157,  2166,  2175,  2184,  2193,  2201,  2209,  2217,  2226,
    2235,  2251,  2260,  2269,  2278,  2295,  2304,  2313,  2322,  2332,
    2345,  2360,  2369,  2378,  2393,  2401,  2411,  2421,  2428,  2436,
    2444,  2451,  2458,  2466,  2474,  2482,  2489,  2496,  2504,  2511,
    2518,  2526,  2534,  2542,  2550,  2558,  2566,  2576,  2583,  2591,
    2599,  2607,  2615,  2623,  2630,  2637,  2644,  2650,  2660,  2661,
    2665,  2666,  2667,  2671,  2679,  2683,  2684,  2688,  2695,  2702,
    2709,  2719,  2722,  2723,  2727,  2728,  2733,  2737,  2741,  2746,
    2753,  2755,  2760,  2764,  2768,  2779,  2787,  2840,  2853,  2867,
    2879,  2886,  2890,  2904,  2917,  2918,  2923,  2932,  2942,  2952,
    2978,  2984,  3017,  3052,  3074,  3075,  3079,  3080,  3089,  3090,
    3091,  3094,  3095,  3100,  3101,  3105,  3109,  3113,  3117,  3121,
    3125,  3129,  3133,  3137,  3141,  3145,  3149,  3153,  3162,  3166,
    3170,  3174,  3178,  3179,  3184,  3188,  3195,  3202,  3203,  3204,
    3205,  3206,  3210,  3214,  3222,  3233,  3252,  3271,  3291,  3311,
    3331,  3364,  3365,  3366,  3367,  3368,  3375,  3382,  3383,  3387,
    3388,  3392,  3393,  3397,  3401,  3408,  3412,  3419,  3420,  3421,
    3425,  3426,  3429,  3450,  3468,  3489,  3490,  3494,  3501,  3502,
    3503,  3534,  3541,  3548,  3559,  3570,  3582,  3593,  3602,  3625,
    3643,  3644,  3663,  3670,  3677,  3684,  3695,  3705,  3706,  3707,
    3711,  3712,  3713,  3714,  3715,  3716,  3717,  3718,  3719,  3728,
    3735,  3739,  3752,  3768,  3783,  3799,  3814,  3833,  3854,  3855,
    3859,  3860,  3864,  3865,  3868,  3874,  3875,  3878,  3882,  3890,
    3895,  3901,  3902,  3906,  3911,  3918,  3919,  3929,  3931,  3933,
    3935,  3938,  3941,  3944,  3948,  3949,  3950,  3951,  3952,  3955,
    3956,  3960,  3961,  3964,  3976,  3977,  3980,  3991,  4002,  4016,
    4017,  4022,  4023,  4024,  4027,  4028,  4029,  4030,  4033,  4034,
    4037,  4038,  4041,  4059,  4071,  4095,  4103,  4124,  4137,  4153,
    4169,  4170,  4171,  4183,  4196,  4212,  4226,  4227,  4239,  4259,
    4269,  4282,  4290,  4301,  4302,  4305,  4306,  4309,  4310,  4313,
    4317,  4321,  4325,  4329,  4333,  4337,  4341,  4345,  4349,  4353,
    4358,  4362,  4366,  4372,  4373,  4377,  4378,  4379,  4384,  4387,
    4388,  4400,  4415,  4430,  4431,  4439,  4440,  4444,  4445,  4449,
    4450,  4454,  4455,  4459,  4469,  4482,  4483,  4493,  4504,  4505,
    4518,  4525,  4542,  4550,  4561,  4564,  4568,  4572,  4576,  4583,
    4595,  4605,  4608,  4612,  4625,  4634,  4643,  4652,  4661,  4670,
    4679,  4688,  4697,  4706,  4715,  4724,  4733,  4742,  4751,  4760,
    4769,  4778,  4787,  4796,  4805,  4814,  4823,  4832,  4841,  4850,
    4859,  4868,  4886,  4897,  4898,  4899,  4900,  4904,  4905,  4909,
    4910,  4920,  4928,  4940,  4941,  4945,  4949,  4957,  4961,  4965,
    4972,  4976,  4981,  4986,  4993,  5000,  5005,  5015,  5027,  5042,
    5043,  5048,  5049,  5053,  5054,  5064,  5073,  5081,  5098,  5118,
    5138,  5159,  5190,  5199,  5220,  5235,  5236,  5240,  5248,  5263,
    5272,  5284,  5285,  5297,  5305,  5322,  5346,  5363,  5377,  5378,
    5382,  5383,  5387,  5388,  5392,  5393,  5397,  5411,  5415,  5416,
    5420,  5421,  5422,  5423,  5424,  5434,  5445,  5446,  5457,  5478,
    5504,  5505,  5506,  5510,  5512,  5534,  5536,  5538,  5540,  5542,
    5547,  5548,  5552,  5553,  5557,  5568,  5569,  5573,  5582,  5586,
    5590,  5595,  5605,  5606,  5610,  5611,  5615,  5616,  5620,  5621,
    5625,  5626,  5627,  5631,  5635,  5636,  5637,  5641,  5642,  5647,
    5648,  5675,  5676,  5677,  5678,  5679,  5680,  5693,  5703,  5717,
    5719,  5724,  5729,  5731,  5736,  5746,  5747,  5748,  5749,  5760,
    5779,  5790,  5802,  5812,  5822,  5833,  5842,  5849,  5856,  5865,
    5874,  5883,  5892,  5901,  5911,  5920,  5932,  5935,  5936,  5939,
    5943,  5950,  5951,  5952,  5953,  5954,  5955,  5958,  5961,  5962,
    5970,  5977,  5978,  5981,  5983,  5994,  6005,  6016,  6027,  6040,
    6041,  6057,  6072,  6073,  6077,  6089,  6099,  6107,  6116,  6125,
    6126,  6129,  6130,  6133,  6134,  6135,  6138,  6152,  6157,  6167,
    6176,  6188,  6189,  6193,  6201,  6213,  6223,  6236,  6246,  6268,
    6278,  6296,  6306,  6316,  6326,  6336,  6346,  6356,  6366,  6376,
    6386,  6396,  6406,  6420,  6421,  6422,  6423,  6424,  6425,  6426,
    6427,  6428,  6429,  6430,  6431,  6432,  6437,  6438,  6439,  6440,
    6441,  6442,  6443,  6448,  6449,  6450,  6454,  6455,  6458,  6459,
    6462,  6464,  6469,  6470,  6481,  6492,  6493,  6494,  6528,  6536,
    6544,  6552,  6560,  6568,  6576,  6584,  6592,  6605,  6613,  6621,
    6629,  6637,  6645,  6653,  6661,  6669,  6677,  6689,  6690,  6691,
    6692,  6693,  6694,  6695,  6696,  6697,  6698,  6699,  6700,  6701,
    6702,  6707,  6708,  6709,  6710,  6711,  6712,  6713,  6714,  6715,
    6716,  6717,  6718,  6722,  6723,  6737,  6747,  6757,  6767,  6777,
    6787,  6797,  6807,  6817,  6829,  6830,  6835,  6836,  6837,  6838,
    6839,  6840,  6845,  6846,  6847,  6848,  6849,  6850,  6851,  6852,
    6855,  6856,  6866,  6872,  6880,  6888,  6896,  6904,  6912,  6920,
    6928,  6936,  6944,  6952,  6960,  6968,  6976,  6984,  6992,  7000,
    7010,  7011,  7014,  7015,  7025,  7041,  7055,  7081,  7083,  7085,
    7087,  7094,  7103,  7104,  7107,  7114,  7121,  7128,  7142,  7150,
    7158,  7166,  7174,  7182,  7190,  7198,  7206,  7214,  7222,  7230,
    7238,  7246,  7254,  7262,  7270,  7278,  7286,  7294,  7306,  7307,
    7311,  7312,  7317,  7318,  7328,  7341,  7351,  7363,  7364,  7367,
    7368,  7378,  7388,  7389,  7393,  7397,  7401,  7412,  7425,  7439,
    7456,  7457,  7458,  7459,  7460,  7461,  7473,  7503,  7536,  7537,
    7541,  7542,  7546,  7547,  7551,  7552,  7555,  7556,  7561,  7573,
    7592,  7597,  7602,  7609,  7610,  7613,  7614,  7617,  7618,  7621,
    7622,  7625,  7626,  7627,  7630,  7631,  7632,  7648,  7660,  7673,
    7685,  7700,  7701,  7704,  7705,  7709,  7710,  7714,  7715,  7720,
    7732,  7739,  7746,  7761,  7762,  7766,  7767,  7782,  7791,  7800,
    7809,  7818,  7830,  7831,  7832,  7833,  7834,  7840,  7844,  7859,
    7860,  7866,  7876,  7880,  7885,  7893,  7934,  7938,  7942,  7946,
    7954,  7955,  7959,  7969,  7970,  7976,  7977,  7984,  7988,  7992,
    7996,  8000,  8004,  8008,  8012,  8016,  8020,  8024,  8028,  8032,
    8036,  8040,  8044,  8049,  8056,  8060,  8064,  8068,  8072,  8078,
    8079,  8086,  8087,  8091,  8092,  8095,  8107,  8111,  8126,  8134,
    8142,  8154,  8155,  8160,  8161,  8178,  8188,  8198,  8208,  8218,
    8228,  8241,  8251,  8264,  8274,  8287,  8295,  8297,  8299,  8304,
    8306,  8311,  8312,  8317,  8335,  8344,  8345,  8349,  8353,  8365,
    8376,  8387,  8400,  8401,  8402,  8406,  8418,  8419,  8429,  8441,
    8445,  8449,  8453,  8460,  8480,  8490,  8500,  8510,  8522,  8523,
    8526,  8527,  8528,  8531,  8532,  8535,  8545,  8554,  8571,  8580,
    8589,  8598,  8607,  8616,  8625,  8634,  8643,  8652,  8661,  8670,
    8679,  8689,  8699,  8708,  8717,  8726,  8735,  8744,  8753,  8763,
    8773,  8783,  8793,  8803,  8813,  8823,  8833,  8843,  8853,  8863,
    8873,  8884,  8895,  8906,  8917,  8928,  8939,  8949,  8959,  8970,
    8981,  8991,  9001,  9009,  9018,  9027,  9036,  9045,  9054,  9063,
    9072,  9081,  9090,  9104,  9105,  9108,  9109,  9119,  9128,  9137,
    9146,  9156,  9165,  9176,  9177,  9187,  9196,  9205,  9214,  9223,
    9232,  9241,  9250,  9259,  9268,  9277,  9286,  9295,  9304,  9313,
    9322,  9331,  9340,  9349,  9358,  9367,  9376,  9385,  9394,  9403,
    9412,  9421,  9439,  9448,  9449,  9452,  9454,  9460,  9461,  9462,
    9463,  9464,  9476,  9491,  9499,  9507,  9515,  9523,  9531,  9539,
    9547,  9555,  9563,  9571,  9579,  9587,  9595,  9603,  9611,  9619,
    9627,  9635,  9643,  9651,  9659,  9667,  9675,  9693,  9712,  9713,
    9717,  9721,  9741,  9748,  9756,  9764,  9781,  9794,  9798,  9805,
    9814,  9823,  9832,  9841,  9851,  9861,  9879,  9887,  9903,  9920,
    9921,  9922,  9927,  9933,  9942,  9943,  9944,  9945,  9946,  9950,
    9951,  9954,  9955,  9956,  9957,  9961,  9962,  9963,  9975,  9985,
    9986,  9989,  9998, 10004, 10023, 10031, 10038, 10045, 10053, 10061,
   10069, 10076, 10083, 10090, 10097, 10104, 10111, 10118, 10127, 10128,
   10129, 10133, 10136, 10139, 10142, 10145, 10152, 10154, 10156, 10161,
   10163, 10167, 10168, 10169, 10181, 10194, 10207, 10225, 10246, 10247,
   10248, 10249, 10259, 10275, 10285, 10286, 10290, 10291, 10295, 10299,
   10303, 10321, 10322, 10323, 10324, 10325, 10326, 10327, 10334, 10335,
   10346, 10353, 10360, 10371, 10388, 10396, 10404, 10412, 10423, 10427,
   10438, 10450, 10467, 10473, 10489, 10502, 10511, 10519, 10527, 10536,
   10547, 10558, 10568, 10569, 10580, 10590, 10601, 10612, 10623, 10634,
   10643, 10655, 10656, 10670, 10693, 10703, 10714, 10727, 10728, 10740,
   10760, 10770, 10781, 10792, 10796, 10803, 10804, 10808, 10815, 10816,
   10820, 10821, 10822, 10826, 10827, 10831, 10832, 10835, 10836, 10839,
   10840, 10844, 10845, 10849, 10856, 10858, 10863, 10864, 10877, 10884,
   10894, 10901, 10911, 10912, 10913, 10914, 10915, 10916, 10917, 10918,
   10919, 10923, 10927, 10934, 10941, 10942, 10946, 10947, 10948, 10958,
   10968, 10969, 10973, 10974, 10975, 10976, 10986, 10993, 11010, 11029,
   11030, 11040, 11046, 11052, 11058, 11074, 11085, 11106, 11110, 11118,
   11124, 11131, 11137, 11144, 11153, 11154, 11158, 11160, 11165, 11176,
   11186, 11196, 11202, 11211, 11220, 11226, 11227, 11238, 11252, 11253,
   11264, 11275, 11276, 11279, 11280, 11281, 11282, 11283, 11284, 11285,
   11286, 11289, 11290, 11294, 11295, 11296, 11307, 11323, 11338, 11339,
   11343, 11348, 11372, 11383, 11384, 11394, 11405, 11408, 11409, 11410,
   11411, 11412, 11415, 11416, 11417, 11465, 11466, 11470, 11471, 11486,
   11487, 11494, 11502, 11510, 11518, 11526, 11534, 11545, 11546, 11573,
   11587, 11602, 11603, 11622, 11626, 11630, 11647, 11654, 11661, 11671,
   11672, 11675, 11688, 11689, 11690, 11694, 11695, 11699, 11711, 11719,
   11724, 11729, 11734, 11739, 11747, 11755, 11760, 11765, 11772, 11773,
   11777, 11778, 11779, 11786, 11787, 11791, 11792, 11796, 11797, 11801,
   11805, 11806, 11809, 11818, 11831, 11836, 11841, 11845, 11856, 11857,
   11861, 11869, 11885, 11893, 11901, 11909, 11920, 11923, 11928, 11929,
   11937, 11957, 11958, 11960, 11965, 11966, 11970, 11971, 11974, 11975,
   12000, 12001, 12005, 12006, 12010, 12011, 12012, 12013, 12014, 12018,
   12031, 12038, 12045, 12052, 12053, 12057, 12058, 12062, 12063, 12067,
   12068, 12072, 12083, 12084, 12085, 12086, 12090, 12091, 12101, 12107,
   12125, 12126, 12130, 12131, 12137, 12142, 12150, 12157, 12165, 12171,
   12178, 12213, 12238, 12242, 12268, 12272, 12284, 12297, 12311, 12322,
   12337, 12343, 12348, 12354, 12361, 12362, 12370, 12374, 12378, 12384,
   12391, 12396, 12397, 12398, 12399, 12403, 12404, 12416, 12417, 12422,
   12429, 12436, 12443, 12454, 12455, 12468, 12472, 12479, 12492, 12505,
   12506, 12521, 12531, 12543, 12548, 12549, 12552, 12553, 12556, 12557,
   12562, 12563, 12568, 12569, 12577, 12582, 12583, 12587, 12591, 12597,
   12621, 12631, 12644, 12645, 12649, 12663, 12720, 12734, 12736, 12741,
   12743, 12745, 12747, 12752, 12754, 12759, 12767, 12787, 12792, 12799,
   12804, 12810, 12815, 12824, 12826, 12829, 12833, 12834, 12835, 12836,
   12837, 12838, 12843, 12863, 12864, 12865, 12866, 12877, 12883, 12891,
   12892, 12898, 12903, 12908, 12913, 12918, 12923, 12928, 12933, 12939,
   12945, 12951, 12958, 12980, 12989, 12993, 13001, 13005, 13013, 13025,
   13046, 13050, 13056, 13060, 13073, 13081, 13091, 13093, 13095, 13097,
   13099, 13101, 13106, 13107, 13114, 13123, 13131, 13140, 13151, 13159,
   13160, 13161, 13165, 13167, 13169, 13171, 13173, 13175, 13177, 13182,
   13187, 13193, 13201, 13206, 13213, 13220, 13224, 13228, 13264, 13265,
   13267, 13275, 13290, 13292, 13294, 13296, 13298, 13300, 13302, 13304,
   13306, 13308, 13310, 13312, 13314, 13316, 13319, 13321, 13323, 13326,
   13328, 13330, 13332, 13335, 13340, 13348, 13353, 13361, 13366, 13374,
   13379, 13388, 13396, 13404, 13412, 13430, 13438, 13446, 13454, 13462,
   13478, 13486, 13494, 13502, 13510, 13518, 13526, 13530, 13534, 13538,
   13542, 13550, 13558, 13566, 13574, 13594, 13616, 13627, 13634, 13650,
   13655, 13661, 13665, 13669, 13673, 13677, 13702, 13704, 13706, 13708,
   13710, 13712, 13714, 13716, 13718, 13720, 13722, 13724, 13726, 13728,
   13730, 13732, 13734, 13736, 13738, 13740, 13744, 13748, 13752, 13756,
   13761, 13777, 13778, 13779, 13794, 13828, 13830, 13832, 13843, 13867,
   13878, 13889, 13896, 13906, 13916, 13925, 13929, 13935, 13942, 13949,
   13959, 13966, 13994, 14029, 14040, 14041, 14048, 14054, 14058, 14062,
   14066, 14070, 14074, 14078, 14082, 14086, 14090, 14094, 14098, 14102,
   14106, 14110, 14114, 14116, 14120, 14124, 14128, 14137, 14142, 14149,
   14164, 14171, 14175, 14179, 14183, 14187, 14194, 14202, 14210, 14214,
   14218, 14222, 14226, 14230, 14236, 14240, 14249, 14253, 14257, 14262,
   14276, 14278, 14282, 14284, 14286, 14289, 14292, 14295, 14296, 14299,
   14307, 14317, 14318, 14321, 14322, 14323, 14328, 14332, 14336, 14340,
   14347, 14348, 14356, 14357, 14361, 14362, 14370, 14371, 14375, 14376,
   14381, 14389, 14391, 14405, 14408, 14435, 14436, 14439, 14440, 14448,
   14455, 14462, 14470, 14479, 14496, 14541, 14549, 14557, 14565, 14573,
   14584, 14585, 14586, 14587, 14588, 14602, 14603, 14604, 14607, 14608,
   14611, 14614, 14615, 14616, 14619, 14620, 14623, 14624, 14625, 14626,
   14627, 14628, 14629, 14630, 14631, 14632, 14633, 14634, 14637, 14639,
   14644, 14646, 14651, 14653, 14655, 14657, 14659, 14661, 14673, 14677,
   14684, 14688, 14694, 14698, 14707, 14718, 14719, 14722, 14726, 14730,
   14736, 14737, 14742, 14746, 14753, 14754, 14755, 14756, 14757, 14758,
   14759, 14760, 14764, 14765, 14766, 14767, 14777, 14781, 14788, 14795,
   14796, 14812, 14816, 14821, 14825, 14840, 14845, 14849, 14852, 14855,
   14856, 14857, 14860, 14867, 14877, 14891, 14892, 14896, 14907, 14908,
   14911, 14912, 14915, 14919, 14926, 14930, 14934, 14942, 14953, 14954,
   14958, 14959, 14963, 14964, 14967, 14968, 14978, 14979, 14983, 14984,
   14987, 15003, 15011, 15019, 15041, 15042, 15053, 15057, 15084, 15086,
   15091, 15094, 15097, 15099, 15101, 15103, 15113, 15115, 15126, 15130,
   15134, 15138, 15142, 15151, 15158, 15190, 15194, 15200, 15207, 15211,
   15215, 15221, 15222, 15224, 15225, 15226, 15230, 15263, 15290, 15294,
   15300, 15302, 15319, 15320, 15321, 15326, 15327, 15328, 15333, 15334,
   15335, 15336, 15342, 15343, 15344, 15345, 15346, 15366, 15367, 15368,
   15369, 15370, 15371, 15372, 15373, 15374, 15375, 15376, 15377, 15378,
   15379, 15380, 15381, 15382, 15383, 15384, 15385, 15386, 15387, 15388,
   15389, 15390, 15391, 15392, 15393, 15394, 15395, 15396, 15397, 15398,
   15399, 15400, 15401, 15402, 15403, 15404, 15405, 15406, 15407, 15408,
   15409, 15410, 15411, 15412, 15413, 15414, 15415, 15416, 15417, 15418,
   15419, 15420, 15421, 15422, 15423, 15424, 15425, 15426, 15427, 15428,
   15429, 15430, 15431, 15432, 15433, 15434, 15435, 15436, 15437, 15438,
   15439, 15440, 15441, 15442, 15443, 15444, 15445, 15446, 15447, 15448,
   15449, 15450, 15451, 15452, 15453, 15454, 15455, 15456, 15457, 15458,
   15459, 15460, 15461, 15462, 15463, 15464, 15465, 15466, 15467, 15468,
   15469, 15470, 15471, 15472, 15473, 15474, 15475, 15476, 15477, 15478,
   15479, 15480, 15481, 15482, 15483, 15484, 15485, 15486, 15487, 15488,
   15489, 15490, 15491, 15492, 15493, 15494, 15495, 15496, 15497, 15498,
   15499, 15500, 15501, 15502, 15503, 15504, 15505, 15506, 15507, 15508,
   15509, 15510, 15511, 15512, 15513, 15514, 15515, 15516, 15517, 15518,
   15519, 15520, 15521, 15522, 15523, 15524, 15525, 15526, 15527, 15528,
   15529, 15530, 15531, 15532, 15533, 15534, 15535, 15536, 15537, 15538,
   15539, 15540, 15541, 15542, 15543, 15544, 15545, 15546, 15547, 15548,
   15549, 15550, 15551, 15552, 15553, 15554, 15555, 15556, 15557, 15558,
   15559, 15560, 15561, 15562, 15563, 15564, 15565, 15566, 15567, 15568,
   15569, 15570, 15571, 15572, 15573, 15574, 15575, 15576, 15577, 15578,
   15579, 15580, 15581, 15582, 15583, 15584, 15585, 15586, 15587, 15588,
   15589, 15590, 15591, 15592, 15593, 15594, 15595, 15596, 15597, 15598,
   15599, 15600, 15601, 15602, 15603, 15604, 15605, 15606, 15607, 15608,
   15609, 15610, 15611, 15612, 15613, 15614, 15615, 15616, 15617, 15618,
   15619, 15620, 15621, 15622, 15623, 15624, 15625, 15626, 15627, 15628,
   15629, 15630, 15631, 15632, 15633, 15634, 15635, 15636, 15637, 15638,
   15639, 15640, 15641, 15642, 15643, 15644, 15645, 15646, 15647, 15648,
   15649, 15650, 15651, 15652, 15653, 15654, 15655, 15656, 15657, 15658,
   15659, 15660, 15661, 15662, 15663, 15664, 15678, 15679, 15680, 15681,
   15682, 15683, 15684, 15685, 15686, 15687, 15688, 15689, 15690, 15691,
   15692, 15693, 15694, 15695, 15696, 15697, 15698, 15699, 15700, 15701,
   15702, 15703, 15704, 15705, 15706, 15707, 15708, 15709, 15710, 15711,
   15712, 15713, 15714, 15715, 15716, 15717, 15718, 15719, 15720, 15721,
   15722, 15723, 15724, 15725, 15726, 15727, 15728, 15742, 15743, 15744,
   15745, 15746, 15747, 15748, 15749, 15750, 15751, 15752, 15753, 15754,
   15755, 15756, 15757, 15758, 15759, 15760, 15761, 15762, 15763, 15764,
   15774, 15775, 15776, 15777, 15778, 15779, 15780, 15781, 15782, 15783,
   15784, 15785, 15786, 15787, 15788, 15789, 15790, 15791, 15792, 15793,
   15794, 15795, 15796, 15797, 15798, 15799, 15800, 15801, 15802, 15803,
   15804, 15805, 15806, 15807, 15808, 15809, 15810, 15811, 15812, 15813,
   15814, 15815, 15816, 15817, 15818, 15819, 15820, 15821, 15822, 15823,
   15824, 15825, 15826, 15827, 15828, 15829, 15830, 15831, 15832, 15833,
   15834, 15835, 15836, 15837, 15838, 15839, 15840, 15841, 15842, 15843,
   15844, 15845, 15846, 15847, 15848, 15849, 15850
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "UIDENT", "FCONST", "SCONST",
  "USCONST", "BCONST", "XCONST", "Op", "ICONST", "PARAM", "TYPECAST",
  "DOT_DOT", "COLON_EQUALS", "EQUALS_GREATER", "LESS_EQUALS",
  "GREATER_EQUALS", "NOT_EQUALS", "ABORT_P", "ABSOLUTE_P", "ACCESS",
  "ACTION", "ADD_P", "ADMIN", "AFTER", "AGGREGATE", "ALL", "ALSO", "ALTER",
  "ALWAYS", "ANALYSE", "ANALYZE", "AND", "ANY", "ARRAY", "AS", "ASC",
  "ASSERTION", "ASSIGNMENT", "ASYMMETRIC", "AT", "ATTACH", "ATTRIBUTE",
  "AUTHORIZATION", "BACKWARD", "BEFORE", "BEGIN_P", "BETWEEN", "BIGINT",
  "BINARY", "BIT", "BOOLEAN_P", "BOTH", "BY", "CACHE", "CALL", "CALLED",
  "CASCADE", "CASCADED", "CASE", "CAST", "CATALOG_P", "CHAIN", "CHAR_P",
  "CHARACTER", "CHARACTERISTICS", "CHECK", "CHECKPOINT", "CLASS", "CLOSE",
  "CLUSTER", "COALESCE", "COLLATE", "COLLATION", "COLUMN", "COLUMNS",
  "COMMENT", "COMMENTS", "COMMIT", "COMMITTED", "CONCURRENTLY",
  "CONFIGURATION", "CONFLICT", "CONNECTION", "CONSTRAINT", "CONSTRAINTS",
  "CONTENT_P", "CONTINUE_P", "CONVERSION_P", "COPY", "COST", "CREATE",
  "CROSS", "CSV", "CUBE", "CURRENT_P", "CURRENT_CATALOG", "CURRENT_DATE",
  "CURRENT_ROLE", "CURRENT_SCHEMA", "CURRENT_TIME", "CURRENT_TIMESTAMP",
  "CURRENT_USER", "CURSOR", "CYCLE", "DATA_P", "DATABASE", "DAY_P",
  "DEALLOCATE", "DEC", "DECIMAL_P", "DECLARE", "DEFAULT", "DEFAULTS",
  "DEFERRABLE", "DEFERRED", "DEFINER", "DELETE_P", "DELIMITER",
  "DELIMITERS", "DEPENDS", "DESC", "DETACH", "DICTIONARY", "DISABLE_P",
  "DISCARD", "DISTINCT", "DO", "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P",
  "DROP", "EACH", "ELSE", "ENABLE_P", "ENCODING", "ENCRYPTED", "END_P",
  "ENUM_P", "ESCAPE", "EVENT", "EXCEPT", "EXCLUDE", "EXCLUDING",
  "EXCLUSIVE", "EXECUTE", "EXISTS", "EXPLAIN", "EXPRESSION", "EXTENSION",
  "EXTERNAL", "EXTRACT", "FALSE_P", "FAMILY", "FETCH", "FILTER", "FIRST_P",
  "FLOAT_P", "FOLLOWING", "FOR", "FORCE", "FOREIGN", "FORWARD", "FREEZE",
  "FROM", "FULL", "FUNCTION", "FUNCTIONS", "GENERATED", "GLOBAL", "GRANT",
  "GRANTED", "GREATEST", "GROUP_P", "GROUPING", "GROUPS", "HANDLER",
  "HAVING", "HEADER_P", "HOLD", "HOUR_P", "IDENTITY_P", "IF_P", "ILIKE",
  "IMMEDIATE", "IMMUTABLE", "IMPLICIT_P", "IMPORT_P", "IN_P", "INCLUDE",
  "INCLUDING", "INCREMENT", "INDEX", "INDEXES", "INHERIT", "INHERITS",
  "INITIALLY", "INLINE_P", "INNER_P", "INOUT", "INPUT_P", "INSENSITIVE",
  "INSERT", "INSTEAD", "INT_P", "INTEGER", "INTERSECT", "INTERVAL", "INTO",
  "INVOKER", "IS", "ISNULL", "ISOLATION", "JOIN", "KEY", "LABEL",
  "LANGUAGE", "LARGE_P", "LAST_P", "LATERAL_P", "LEADING", "LEAKPROOF",
  "LEAST", "LEFT", "LEVEL", "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL",
  "LOCALTIME", "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "LOCKED", "LOGGED",
  "MAPPING", "MATCH", "MATERIALIZED", "MAXVALUE", "METHOD", "MINUTE_P",
  "MINVALUE", "MODE", "MONTH_P", "MOVE", "NAME_P", "NAMES", "NATIONAL",
  "NATURAL", "NCHAR", "NEW", "NEXT", "NFC", "NFD", "NFKC", "NFKD", "NO",
  "NONE", "NORMALIZE", "NORMALIZED", "NOT", "NOTHING", "NOTIFY", "NOTNULL",
  "NOWAIT", "NULL_P", "NULLIF", "NULLS_P", "NUMERIC", "OBJECT_P", "OF",
  "OFF", "OFFSET", "OIDS", "OLD", "ON", "ONLY", "OPERATOR", "OPTION",
  "OPTIONS", "OR", "ORDER", "ORDINALITY", "OTHERS", "OUT_P", "OUTER_P",
  "OVER", "OVERLAPS", "OVERLAY", "OVERRIDING", "OWNED", "OWNER",
  "PARALLEL", "PARSER", "PARTIAL", "PARTITION", "PASSING", "PASSWORD",
  "PGPOOL", "PLACING", "PLANS", "POLICY", "POSITION", "PRECEDING",
  "PRECISION", "PRESERVE", "PREPARE", "PREPARED", "PRIMARY", "PRIOR",
  "PRIVILEGES", "PROCEDURAL", "PROCEDURE", "PROCEDURES", "PROGRAM",
  "PUBLICATION", "QUOTE", "RANGE", "READ", "REAL", "REASSIGN", "RECHECK",
  "RECURSIVE", "REF", "REFERENCES", "REFERENCING", "REFRESH", "REINDEX",
  "RELATIVE_P", "RELEASE", "RENAME", "REPEATABLE", "REPLACE", "REPLICA",
  "RESET", "RESTART", "RESTRICT", "RETURNING", "RETURNS", "REVOKE",
  "RIGHT", "ROLE", "ROLLBACK", "ROLLUP", "ROUTINE", "ROUTINES", "ROW",
  "ROWS", "RULE", "SAVEPOINT", "SCHEMA", "SCHEMAS", "SCROLL", "SEARCH",
  "SECOND_P", "SECURITY", "SELECT", "SEQUENCE", "SEQUENCES",
  "SERIALIZABLE", "SERVER", "SESSION", "SESSION_USER", "SET", "SETS",
  "SETOF", "SHARE", "SHOW", "SIMILAR", "SIMPLE", "SKIP", "SMALLINT",
  "SNAPSHOT", "SOME", "SQL_P", "STABLE", "STANDALONE_P", "START",
  "STATEMENT", "STATISTICS", "STDIN", "STDOUT", "STORAGE", "STORED",
  "STRICT_P", "STRIP_P", "SUBSCRIPTION", "SUBSTRING", "SUPPORT",
  "SYMMETRIC", "SYSID", "SYSTEM_P", "TABLE", "TABLES", "TABLESAMPLE",
  "TABLESPACE", "TEMP", "TEMPLATE", "TEMPORARY", "TEXT_P", "THEN", "TIES",
  "TIME", "TIMESTAMP", "TO", "TRAILING", "TRANSACTION", "TRANSFORM",
  "TREAT", "TRIGGER", "TRIM", "TRUE_P", "TRUNCATE", "TRUSTED", "TYPE_P",
  "TYPES_P", "UESCAPE", "UNBOUNDED", "UNCOMMITTED", "UNENCRYPTED", "UNION",
  "UNIQUE", "UNKNOWN", "UNLISTEN", "UNLOGGED", "UNTIL", "UPDATE", "USER",
  "USING", "VACUUM", "VALID", "VALIDATE", "VALIDATOR", "VALUE_P", "VALUES",
  "VARCHAR", "VARIADIC", "VARYING", "VERBOSE", "VERSION_P", "VIEW",
  "VIEWS", "VOLATILE", "WHEN", "WHERE", "WHITESPACE_P", "WINDOW", "WITH",
  "WITHIN", "WITHOUT", "WORK", "WRAPPER", "WRITE", "XML_P",
  "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT", "XMLEXISTS", "XMLFOREST",
  "XMLNAMESPACES", "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE",
  "XMLTABLE", "YEAR_P", "YES_P", "ZONE", "NOT_LA", "NULLS_LA", "WITH_LA",
  "'<'", "'>'", "'='", "POSTFIXOP", "'+'", "'-'", "'*'", "'/'", "'%'",
  "'^'", "UMINUS", "'['", "']'", "'('", "')'", "'.'", "';'", "','", "':'",
  "$accept", "stmtblock", "stmtmulti", "stmt", "CallStmt",
  "CreateRoleStmt", "opt_with", "OptRoleList", "AlterOptRoleList",
  "AlterOptRoleElem", "CreateOptRoleElem", "CreateUserStmt",
  "AlterRoleStmt", "opt_in_database", "AlterRoleSetStmt", "DropRoleStmt",
  "CreateGroupStmt", "AlterGroupStmt", "add_drop", "CreateSchemaStmt",
  "OptSchemaName", "OptSchemaEltList", "schema_stmt", "VariableSetStmt",
  "set_rest", "generic_set", "set_rest_more", "var_name", "var_list",
  "var_value", "iso_level", "opt_boolean_or_string", "zone_value",
  "opt_encoding", "NonReservedWord_or_Sconst", "VariableResetStmt",
  "reset_rest", "generic_reset", "SetResetClause",
  "FunctionSetResetClause", "VariableShowStmt", "ConstraintsSetStmt",
  "constraints_set_list", "constraints_set_mode", "CheckPointStmt",
  "DiscardStmt", "AlterTableStmt", "alter_table_cmds", "partition_cmd",
  "index_partition_cmd", "alter_table_cmd", "alter_column_default",
  "opt_drop_behavior", "opt_collate_clause", "alter_using",
  "replica_identity", "reloptions", "opt_reloptions", "reloption_list",
  "reloption_elem", "alter_identity_column_option_list",
  "alter_identity_column_option", "PartitionBoundSpec",
  "hash_partbound_elem", "hash_partbound", "AlterCompositeTypeStmt",
  "alter_type_cmds", "alter_type_cmd", "ClosePortalStmt", "CopyStmt",
  "copy_from", "opt_program", "copy_file_name", "copy_options",
  "copy_opt_list", "copy_opt_item", "opt_binary", "copy_delimiter",
  "opt_using", "copy_generic_opt_list", "copy_generic_opt_elem",
  "copy_generic_opt_arg", "copy_generic_opt_arg_list",
  "copy_generic_opt_arg_list_item", "CreateStmt", "OptTemp",
  "OptTableElementList", "OptTypedTableElementList", "TableElementList",
  "TypedTableElementList", "TableElement", "TypedTableElement",
  "columnDef", "columnOptions", "ColQualList", "ColConstraint",
  "ColConstraintElem", "generated_when", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "opt_no_inherit", "opt_column_list",
  "columnList", "columnElem", "opt_c_include", "key_match",
  "ExclusionConstraintList", "ExclusionConstraintElem",
  "ExclusionWhereClause", "key_actions", "key_update", "key_delete",
  "key_action", "OptInherit", "OptPartitionSpec", "PartitionSpec",
  "part_params", "part_elem", "table_access_method_clause", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptConsTableSpace", "ExistingIndex",
  "CreateStatsStmt", "AlterStatsStmt", "CreateAsStmt", "create_as_target",
  "opt_with_data", "CreateMatViewStmt", "create_mv_target", "OptNoLog",
  "RefreshMatViewStmt", "CreateSeqStmt", "AlterSeqStmt", "OptSeqOptList",
  "OptParenthesizedSeqOptList", "SeqOptList", "SeqOptElem", "opt_by",
  "NumericOnly", "NumericOnly_list", "CreatePLangStmt", "opt_trusted",
  "handler_name", "opt_inline_handler", "validator_clause",
  "opt_validator", "DropPLangStmt", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "AlterForeignServerStmt",
  "CreateForeignTableStmt", "AlterForeignTableStmt",
  "ImportForeignSchemaStmt", "import_qualification_type",
  "import_qualification", "CreateUserMappingStmt", "auth_ident",
  "DropUserMappingStmt", "AlterUserMappingStmt", "CreatePolicyStmt",
  "AlterPolicyStmt", "RowSecurityOptionalExpr",
  "RowSecurityOptionalWithCheck", "RowSecurityDefaultToRole",
  "RowSecurityOptionalToRole", "RowSecurityDefaultPermissive",
  "RowSecurityDefaultForCmd", "row_security_cmd", "CreateAmStmt",
  "am_type", "CreateTrigStmt", "TriggerActionTime", "TriggerEvents",
  "TriggerOneEvent", "TriggerReferencing", "TriggerTransitions",
  "TriggerTransition", "TransitionOldOrNew", "TransitionRowOrTable",
  "TransitionRelName", "TriggerForSpec", "TriggerForOptEach",
  "TriggerForType", "TriggerWhen", "FUNCTION_or_PROCEDURE",
  "TriggerFuncArgs", "TriggerFuncArg", "OptConstrFromTable",
  "ConstraintAttributeSpec", "ConstraintAttributeElem",
  "CreateEventTrigStmt", "event_trigger_when_list",
  "event_trigger_when_item", "event_trigger_value_list",
  "AlterEventTrigStmt", "enable_trigger", "CreateAssertionStmt",
  "DefineStmt", "definition", "def_list", "def_elem", "def_arg",
  "old_aggr_definition", "old_aggr_list", "old_aggr_elem",
  "opt_enum_val_list", "enum_val_list", "AlterEnumStmt",
  "opt_if_not_exists", "CreateOpClassStmt", "opclass_item_list",
  "opclass_item", "opt_default", "opt_opfamily", "opclass_purpose",
  "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "drop_type_any_name", "drop_type_name", "drop_type_name_on_any_name",
  "any_name_list", "any_name", "attrs", "type_name_list", "TruncateStmt",
  "opt_restart_seqs", "CommentStmt", "comment_type_any_name",
  "comment_type_name", "comment_text", "SecLabelStmt", "opt_provider",
  "security_label_type_any_name", "security_label_type_name",
  "security_label", "FetchStmt", "fetch_args", "from_in", "opt_from_in",
  "GrantStmt", "RevokeStmt", "privileges", "privilege_list", "privilege",
  "privilege_target", "grantee_list", "grantee", "opt_grant_grant_option",
  "GrantRoleStmt", "RevokeRoleStmt", "opt_grant_admin_option",
  "opt_granted_by", "AlterDefaultPrivilegesStmt", "DefACLOptionList",
  "DefACLOption", "DefACLAction", "defacl_privilege_target", "IndexStmt",
  "opt_unique", "opt_concurrently", "opt_index_name",
  "access_method_clause", "index_params", "index_elem_options",
  "index_elem", "opt_include", "index_including_params", "opt_collate",
  "opt_class", "opt_asc_desc", "opt_nulls_order", "CreateFunctionStmt",
  "opt_or_replace", "func_args", "func_args_list",
  "function_with_argtypes_list", "function_with_argtypes",
  "func_args_with_defaults", "func_args_with_defaults_list", "func_arg",
  "arg_class", "param_name", "func_return", "func_type",
  "func_arg_with_default", "aggr_arg", "aggr_args", "aggr_args_list",
  "aggregate_with_argtypes", "aggregate_with_argtypes_list",
  "createfunc_opt_list", "common_func_opt_item", "createfunc_opt_item",
  "func_as", "transform_type_list", "opt_definition", "table_func_column",
  "table_func_column_list", "AlterFunctionStmt", "alterfunc_opt_list",
  "opt_restrict", "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt",
  "oper_argtypes", "any_operator", "operator_with_argtypes_list",
  "operator_with_argtypes", "DoStmt", "dostmt_opt_list", "dostmt_opt_item",
  "CreateCastStmt", "cast_context", "DropCastStmt", "opt_if_exists",
  "CreateTransformStmt", "transform_element_list", "DropTransformStmt",
  "ReindexStmt", "reindex_target_type", "reindex_target_multitable",
  "reindex_option_list", "reindex_option_elem", "AlterTblSpcStmt",
  "RenameStmt", "opt_column", "opt_set_data", "AlterObjectDependsStmt",
  "opt_no", "AlterObjectSchemaStmt", "AlterOperatorStmt",
  "operator_def_list", "operator_def_elem", "operator_def_arg",
  "AlterTypeStmt", "AlterOwnerStmt", "CreatePublicationStmt",
  "opt_publication_for_tables", "publication_for_tables",
  "AlterPublicationStmt", "CreateSubscriptionStmt",
  "publication_name_list", "publication_name_item",
  "AlterSubscriptionStmt", "DropSubscriptionStmt", "RuleStmt",
  "RuleActionList", "RuleActionMulti", "RuleActionStmt",
  "RuleActionStmtOrEmpty", "event", "opt_instead", "NotifyStmt",
  "notify_payload", "ListenStmt", "UnlistenStmt", "TransactionStmt",
  "opt_transaction", "transaction_mode_item", "transaction_mode_list",
  "transaction_mode_list_or_empty", "opt_transaction_chain", "ViewStmt",
  "opt_check_option", "LoadStmt", "CreatedbStmt", "createdb_opt_list",
  "createdb_opt_items", "createdb_opt_item", "createdb_opt_name",
  "opt_equal", "AlterDatabaseStmt", "AlterDatabaseSetStmt", "DropdbStmt",
  "drop_option_list", "drop_option", "AlterCollationStmt",
  "AlterSystemStmt", "CreateDomainStmt", "AlterDomainStmt", "opt_as",
  "AlterTSDictionaryStmt", "AlterTSConfigurationStmt", "any_with",
  "CreateConversionStmt", "ClusterStmt", "cluster_index_specification",
  "VacuumStmt", "AnalyzeStmt", "vac_analyze_option_list",
  "analyze_keyword", "vac_analyze_option_elem", "vac_analyze_option_name",
  "vac_analyze_option_arg", "opt_analyze", "opt_verbose", "opt_full",
  "opt_freeze", "opt_name_list", "vacuum_relation", "vacuum_relation_list",
  "opt_vacuum_relation_list", "ExplainStmt", "ExplainableStmt",
  "explain_option_list", "explain_option_elem", "explain_option_name",
  "explain_option_arg", "PrepareStmt", "prep_type_clause",
  "PreparableStmt", "ExecuteStmt", "execute_param_clause",
  "DeallocateStmt", "InsertStmt", "InsertStmtShort", "insert_target",
  "insert_rest", "override_kind", "insert_column_list",
  "insert_column_item", "opt_on_conflict", "opt_conf_expr",
  "returning_clause", "DeleteStmt", "using_clause", "LockStmt", "opt_lock",
  "lock_type", "opt_nowait", "opt_nowait_or_skip", "UpdateStmt",
  "UpdateStmtShort", "set_clause_list", "set_clause", "set_target",
  "set_target_list", "DeclareCursorStmt", "cursor_name", "cursor_options",
  "opt_hold", "SelectStmt", "select_with_parens", "select_no_parens",
  "select_clause", "simple_select", "with_clause", "cte_list",
  "common_table_expr", "opt_materialized", "opt_with_clause",
  "into_clause", "OptTempTableName", "opt_table", "all_or_distinct",
  "distinct_clause", "opt_all_clause", "opt_sort_clause", "sort_clause",
  "sortby_list", "sortby", "select_limit", "opt_select_limit",
  "limit_clause", "offset_clause", "select_limit_value",
  "select_offset_value", "select_fetch_first_value", "I_or_F_const",
  "row_or_rows", "first_or_next", "group_clause", "group_by_list",
  "group_by_item", "empty_grouping_set", "rollup_clause", "cube_clause",
  "grouping_sets_clause", "having_clause", "for_locking_clause",
  "opt_for_locking_clause", "for_locking_items", "for_locking_item",
  "for_locking_strength", "locked_rels_list", "values_clause",
  "from_clause", "from_list", "table_ref", "joined_table", "alias_clause",
  "opt_alias_clause", "func_alias_clause", "join_type", "join_outer",
  "join_qual", "relation_expr", "relation_expr_list",
  "relation_expr_opt_alias", "tablesample_clause", "opt_repeatable_clause",
  "func_table", "rowsfrom_item", "rowsfrom_list", "opt_col_def_list",
  "opt_ordinality", "where_clause", "where_or_current_clause",
  "OptTableFuncElementList", "TableFuncElementList", "TableFuncElement",
  "xmltable", "xmltable_column_list", "xmltable_column_el",
  "xmltable_column_option_list", "xmltable_column_option_el",
  "xml_namespace_list", "xml_namespace_el", "Typename", "opt_array_bounds",
  "SimpleTypename", "ConstTypename", "GenericType", "opt_type_modifiers",
  "Numeric", "opt_float", "Bit", "ConstBit", "BitWithLength",
  "BitWithoutLength", "Character", "ConstCharacter", "CharacterWithLength",
  "CharacterWithoutLength", "character", "opt_varying", "ConstDatetime",
  "ConstInterval", "opt_timezone", "opt_interval", "interval_second",
  "a_expr", "b_expr", "c_expr", "func_application", "func_expr",
  "func_expr_windowless", "func_expr_common_subexpr", "xml_root_version",
  "opt_xml_root_standalone", "xml_attributes", "xml_attribute_list",
  "xml_attribute_el", "document_or_content", "xml_whitespace_option",
  "xmlexists_argument", "xml_passing_mech", "within_group_clause",
  "filter_clause", "window_clause", "window_definition_list",
  "window_definition", "over_clause", "window_specification",
  "opt_existing_window_name", "opt_partition_clause", "opt_frame_clause",
  "frame_extent", "frame_bound", "opt_window_exclusion_clause", "row",
  "explicit_row", "implicit_row", "sub_type", "all_Op", "MathOp",
  "qual_Op", "qual_all_Op", "subquery_Op", "expr_list", "func_arg_list",
  "func_arg_expr", "type_list", "array_expr", "array_expr_list",
  "extract_list", "extract_arg", "unicode_normal_form", "overlay_list",
  "overlay_placing", "position_list", "substr_list", "substr_from",
  "substr_for", "trim_list", "in_expr", "case_expr", "when_clause_list",
  "when_clause", "case_default", "case_arg", "columnref", "indirection_el",
  "opt_slice_bound", "indirection", "opt_indirection", "opt_asymmetric",
  "opt_target_list", "target_list", "target_el", "qualified_name_list",
  "qualified_name", "name_list", "name", "database_name", "access_method",
  "attr_name", "index_name", "file_name", "func_name", "AexprConst",
  "Iconst", "Sconst", "SignedIconst", "RoleId", "RoleSpec", "role_list",
  "ColId", "type_function_name", "NonReservedWord", "ColLabel",
  "unreserved_keyword", "col_name_keyword", "type_func_name_keyword",
  "reserved_keyword", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,    60,    62,    61,   729,    43,    45,
      42,    47,    37,    94,   730,    91,    93,    40,    41,    46,
      59,    44,    58
};
# endif

#define YYPACT_NINF -4944

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-4944)))

#define YYTABLE_NINF -2673

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-2673)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const int yypact[] =
{
   10182,   678, 18667, -4944, -4944,   678, 61659, -4944, 69615,    14,
     188,  1120,   170, 18321, 70083, 78039,   710,   352,  9722,   678,
   78039,  1066, 52766, 66807,   984, 78039,  1126,  1062, 52766, 78039,
    1765, 78507,  1190,  1285,   791, 78975, 70551, 65403,  1220, 78039,
    1417,  1415, 79443, 71019,  1214, 71487,  1062, 49032,   139,  1210,
   79911, 78039,  1528,  1767,  1394, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944,     1, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944,  1984, -4944,   894,  2020,  1419,   933,  1452, -4944,
   -4944,  1927, 61659, 78039, 78039, 78039,  1703, 78039,  1650, 78039,
     235, 61659, 57447, 71955,  1887,  1745, 45252, 80379, -4944, 61659,
   78039, 55575, 61659, 78039, 78039, 80847, 78039, 81315, 78039,   758,
   68211, 78039,  1919, 78039, 78039, 56043, 81783,  2075,  1375,   256,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944,  1812,  1757, -4944,   262, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, 78039, 17624,  1126,
    1927, -4944,  1528, 78039,  2063, 78039,  1833, 82251,  1915, 78039,
   -4944, 78039,  1918, 82719,   708,  1513, 57447,  1603, 45726,  2007,
   78039, 78039, 57447, 83187, 83655, 84123, 78039, 78039, -4944, -4944,
    1992, 78039, 78039, -4944,  2123, 57915,    75,  2143,  2301,  2222,
     814, -4944, 72423, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, 60723,   352, -4944, -4944,  2178, 62127,  2248, -4944, -4944,
   84591,101369,  2035, -4944,   863, 62595, 58383,  2373,  2026, 46200,
    2424, -4944, 63063, -4944, 58851, 63531, -4944, -4944, -4944, -4944,
   -4944, 85059, -4944, 85527,  2129,  2248, -4944,101823, 59319, -4944,
    2274, 85995, 86463, 86931,  1927,  2009,  1293,  2561, 41018, -4944,
   -4944, -4944,    14, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
    1023, -4944,   341,  1951,   273,   223,   286, -4944, -4944,   230,
     241,   243,   341,  2489,  2489, -4944, 78039, -4944, -4944,  1951,
     815,  2048,  2048,  2048,  2270,   969, -4944,  2048,  2213, -4944,
   -4944, -4944, -4944, 71487, -4944,  2091, 72891, 78039, 73359,  1126,
    2097,  2536,  2154, -4944, -4944, -4944, -4944, -4944,  2164,  2539,
    2539, 78039, -4944, -4944,  2592,  2181,  2442,  2155, -4944, -4944,
   -4944,  2380,  2382,  2390,   382,  1126,   319, -4944,  2519, -4944,
    2407, 27704, 27704,  1126, 73827, 87399,   302, 60723,  1126, 74295,
    2219,  1226,  2433, -4944, -4944, -4944,   755, -4944,  2648,  2264,
    2491,  2155,  1375, 42422, -4944,  2238,  1757, 71487, -4944, -4944,
   -4944, 59787,  2583, 29624, 78039,  2289, -4944,  2297,  2289,  2316,
    2317,  1419, -4944, 10182, 59787, 78039,  1416,  1416,  2730,  1416,
    1614,  1801, -4944,  2080, -4944,  2640,  2605, 71487,  2334,  1018,
   -4944,  1749,  2336,  1542,  2349,  1771,  2412, -4944, -4944,   920,
   78039,   236,  2395, 74763,  6746,  2363,  1757,  2371, -4944, -4944,
   -4944,  2511,   391, -4944, -4944, -4944, -4944,  2669,  2713,  5133,
     330, 75231, -4944, -4944, -4944, -4944, 78039, 78039, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944,  2384,   140, -4944,
   -4944,  2378,  2727,  2601,  7295,  1015,  2690,  2554,  1759, 10593,
    2619,  1516,  2750,  6734,  1284,  2755,  1785,  1531, 72891, 78039,
    2715,  2761,  6542,  1443,   874,  2633,  1347,  2690,  2756,  2590,
    1759,  2780,  7214, 78039, -4944,  2714,  2819,   123, -4944,   239,
   -4944, 22469, 29624, 48564, -4944,  1757,  2514,  2672,    82,  2720,
   61659,  2470, -4944, -4944, 78039, -4944, -4944,102277,  2559, -4944,
     866, 61659, -4944,  2694,  2524, 46674, 78039, 61659, -4944, -4944,
   61659, 78039, -4944, -4944, -4944, -4944, -4944, -4944, -4944,  2616,
    2816, 78039,102277, -4944,  2760, 78039, 78039, -4944, -4944,  2506,
   -4944, -4944, -4944, -4944,  2048, 78039,  2927,102277,  2733,   128,
   78039,     4,  2963, 78039,  2738,     4,  2548, 87867, -4944, -4944,
       4, -4944, -4944, -4944, 78039, 78039,  2529,  1554,  2746,  2847,
       4,  2768,  2991,  2993,  2787,  2644,  2804,  2297,  2986,  2778,
     904,  1065,   189,  1930,     4,  2634, 88335, 88803, 78039,  2660,
   78039,  2539, 61659, 61659, 61659, 78039,  2922, -4944,  2783, -4944,
   -4944,  1213, -4944, -4944, -4944, -4944, -4944,  2959, -4944,   226,
    2964,  2630,  2970,  1639, -4944, -4944,  2698, -4944,  2698,  2698,
    2653,  2653,  2842,  2673,  3008, -4944, -4944, -4944,  2376,  2698,
    2653, -4944,103185, -4944,  1633,  1800, -4944,   306, -4944,  3126,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,  2681, -4944,
     219,  1719, -4944, -4944,  2712, -4944,  3024,   313, -4944,  3025,
   -4944,  2683, 89271, -4944, 89739, 90207,  3031,   321, -4944, 57447,
    3038,   313,  3040,  2683,  3054,   313,  3055,   921,  3056, -4944,
     926,  3048,  3072,   306,  3073,  1978,  2683, 61191,  3074,   349,
   -4944,  3079,   414, -4944,  3080,  2951, -4944, 29624, -4944,  2836,
   -4944,  1210, -4944,  1776, -4944, 51828, -4944,  2561,  3022, 71487,
    1951, -4944, 78039,  1951, 78039,  1951, 78039,  1951, 78039,  1951,
   78039, 78039, 78039,  1951, -4944, -4944, -4944, 78039,  2747, 78039,
   78039, -4944, -4944, -4944, 67275, 57447, 67743, -4944, 78039, -4944,
     798,  1126, -4944, -4944, -4944,  1314, -4944,  2155, -4944,102277,
    3196, 57447,  2539, -4944,  1826, -4944, -4944, 78039, 78039, -4944,
   -4944, -4944,  3010, 78039,  3077,  3078, 67275, 57447, -4944, 90675,
   -4944, 60723,  2966,  2754, -4944, -4944, -4944, -4944, -4944,  1616,
    3239,   204,  3242, 29624,  2764,   204,   204,  2765,  3092, -4944,
   -4944, -4944,   283,  2769,  2770, -4944,   232,   232, -4944,  2772,
    2774, -4944,   238,  2775,  2781,  3249,  3259,   281,  2782,  2786,
    2788,  2376,   204,  2789, 29624, -4944,  2792,   232,  2795,  2796,
    2797,  3261,  2798, -4944,  3264,  2799,   314,   327,  2805,  2817,
   -4944,  2772, -4944,   287,  2818,  2820,  2821,  2823,  2824,  2826,
    2830,  2835, 29624, 29624, 29624, -4944, 26259,  1757,  1126, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944,   296,  7247, -4944,
    2855, -4944, -4944,  2984, -4944, -4944, 29624, -4944, -4944,   144,
   -4944,   297, -4944, -4944, -4944,  1757,  3108,  2832, -4944, -4944,
     324,  2833, -4944,  2052, -4944, -4944, -4944, -4944, -4944, -4944,
   60255,  3289, -4944,   277,  1126,   239,   370,  3230, 50890, 51359,
   -4944, -4944,  3102, -4944, 78039, -4944, -4944,  1757,   175,  1852,
   -4944, -4944, 51828, -4944, -4944,    14, 17405,  1856,  2289, 78039,
   78039,  3293, -4944, -4944, -4944,  1883, -4944,  2841, -4944,  2297,
   -4944, -4944,  1419,  1419, 29624,  1419,   267,  1666, 28184, 30104,
    3172,  3060,  1577,  1506,  3175, -4944,  3082,  1614,  1801, 71487,
   78039, 91143, -4944, 29624, -4944,  3281,  2939,  2943,  2998, 49968,
   -4944,  2945,  2917,  2957,  3013, 53703,  2885,  2968,  2969,  3027,
   -4944,  3150, -4944, -4944,  2974,  3045,  2976, 91611, -4944, -4944,
     799, -4944, -4944, -4944,   799, -4944,  2908,  1398,   447,  1237,
    2978,   517,   880,  3300, -4944,  1116, -4944, -4944,  3034, -4944,
    5909, 78039,  3240,  7416,  3111,   330,  3032, -4944, -4944, -4944,
    3168,  2985, 78039,  2987,  3125,   330,   312, 92079, -4944, -4944,
   78039, -4944, -4944, -4944, -4944,  6904,  3275, 25351, -4944,  1643,
    2992,  2971,  3000, 78039, 64467,   395,  3105,  3127,  1499,  1823,
     269,  3062, 78039,  1732,  3131, 78039,  2931,  3012,  3014,  3243,
    2938,  1406,  3336,  2936, -4944, -4944, -4944,  3306, -4944,  2161,
    2186,  3135, -4944,  3245,  3282,  7545,  3001,  3002,100007, -4944,
    3033,   975, 47148, 78039, 78039,  3037,  3039, 92547,  6904,  3316,
    3050,  3052,  3041,  3042,   654,  3342,  1539,  3046, -4944, -4944,
   -4944,  1539,  3047,  3049, 93015,  6904,  3330, 78039,  3051,  3053,
   78039,103185,   330, -4944,  3400,   330,   330,   284,  3402,  3057,
     332,  3211,  1426,     4,  2936,  3806, -4944,  3059,  3063,   333,
   -4944,  3179, 78039,  3065,  3067,  1409,  1126, -4944, -4944,  3068,
    3144,  3069,   742, -4944, -4944,  3081, 71487,  3165,  3169,  1732,
     248,  1758,  2936, -4944,  3070,  3075,  2938,  2938, 78039, 78039,
   78039, 78039, 78039,   214,  3436,  3439,  3084,   180,  1007,  2994,
   -4944,  1539, 56511,  3085, -4944,  1539, 78039,   453,  1941,  2936,
    1651,  1540, -4944, -4944, -4944,  1375, -4944, 29624, 29624, 29624,
    2996, -4944,  1592, 17405,    65, -4944,   298, 13883,  2995, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, 78039, -4944, 78039, -4944,  3276,
  102277,  3215,  3277, -4944,  3043, -4944,  3286,   330, -4944, 78039,
   78039,  3287,  3222,  3290,  3292,  3223,   945,102277,  3227,  3294,
   -4944,  3295,  3298,  3104,   191,  3096,  3028,  3479,  3369, 78039,
   53703, -4944,  3492,   799, -4944,102277,  3241,  3373, -4944, 78039,
    3265,    63, -4944,  3413,  3098, -4944, -4944,  1058, 78039,   253,
    3097, -4944, -4944,  3386, 57447,  1537,  3387,  1126,  3106,  3398,
    3273,  1126, 57447,  3318, 78039, 78039, 78039, 78039, -4944, -4944,
    3280,   970,   358, -4944, 56511,  3291, -4944, 78039,  3299,  3806,
    3305,  3518,    90,  2048, 93483,  3396, 93951,  3083,  3086,  3086,
    3532,102277,  3354, -4944,  1909, -4944,  3219, -4944, 61659, -4944,
   -4944, 61659, -4944, -4944,102277, 78039,  3089, -4944,  3094, -4944,
   -4944, 29624, -4944, -4944, -4944,  2489, -4944,102277,  2698,  2698,
   -4944, -4944,  3546,  3180,  3181,  2489, -4944,  2489, -4944,102277,
   -4944,  3099,  3109,  2489,  3182,  3183,  3184, -4944,  3110,  3186,
    2489, -4944, -4944,  1728, -4944, -4944, 61659, 61659, -4944, 57447,
   57447,  3454,   349,  3455,  3173,  3458,  3178, 47148, 47148, -4944,
     490, 61659, -4944, 57447, 61659, -4944, 78039, -4944, 78039, -4944,
   -4944, -4944, -4944,102277,102277, -4944, 57447, 56511,  3462,  3463,
     921, 78039, 78039, -4944, 78039, 78039, -4944, 78039, 78039,  1891,
   94419,  2561, 59787, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, 78039,  3246, 78039, -4944, 78039, -4944, 78039, -4944, 78039,
   -4944, 78039, -4944, -4944, -4944, 78039, -4944, 78039,  1914, -4944,
   -4944,  1920,  1085, 78039, 78039,   231, 61659, 78039,  3346, 61659,
   61659, 78039, 78039, 78039, 78039, 78039,  3212,  2833,  1435, -4944,
     289,   886, 71487,  3355, -4944, -4944,  1921,  1528,  1041, 78039,
    1312,  2164, -4944, -4944, -4944, -4944, 67743, 66807,  3457,   436,
   78039, -4944, -4944,  4283, 29624,  1757, 27219, -4944, -4944, 17405,
    3191, 29624, 29624,  3141,  2489,  2489, -4944,   721, 29624, 29624,
   29624,  2489,  2489, 29624,  9713, 29624, 47148, 29624, 34904, 23441,
   29624, 29624, 26739, -4944, 29624,  3381, 36338, 29624,   370,  3382,
   29624,   370,  9713,  3625,  3625,  2935,  7389,  3148,  1757, -4944,
    2489,   823, -4944,   466,102277, 29624, 29624, 29624, 29624, 53703,
    3235,   250, 78039, 29624,  3154,  2579, -4944, 29624, -4944,  3155,
   29624,  3236,   930, 29624, 29624, 29624, 29624, 29624, 29624, 29624,
   29624, 29624, -4944, 37742,   477,  3469,  3488,  1035,   437, 75699,
   27704,  3480, 22469, -4944,   261,  3480, -4944, -4944, -4944, 78039,
    3289, -4944, -4944,  3238, -4944, -4944, -4944, -4944, -4944,   299,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944,  3157, -4944, -4944,
   -4944, -4944,  3157, -4944,  3161,  3467,  3468,   921, 78039, 59787,
   -4944, -4944, -4944,  2321, -4944, 29624, -4944,  1926,  1924, 78039,
   78039, -4944,  3444, -4944,  3164, -4944, 14015,  3444, -4944, -4944,
   35381,  3296,  3445,  3393, -4944, -4944, -4944,  3185, 17405, 30584,
   30584, -4944,  2223, 17405,  2261, -4944, -4944, -4944, -4944, -4944,
   -4944,   168, -4944, 78039,   157,  3172,  1506,  3244, -4944,  3636,
   78039, -4944,  1933, -4944, 57447, 78039, 78039,  3395, -4944,  3619,
   -4944,103185, -4944,  3192, -4944,102731, 98631, -4944, -4944,    78,
   -4944,   950, 57447, -4944, 78039, 78039, -4944, 53703, 57447, 78039,
   78039, -4944, 57447, 78039, 78039, -4944, -4944, -4944, -4944, -4944,
   52297,   715, 66807,  3331, 65871, -4944, -4944,  3198, 78039,  3252,
    3470,  3471,  1296, -4944, -4944, 94887, -4944,  3420, 57447, 78039,
   78039, 29624,  3421, 78039, 78039, -4944,   305,  3283,  3284, -4944,
   78039,  3285,  3451, 61659,  3207, 78039, 78039,102277,  3297,   927,
   61659,  3253, 47622, 61659, 61659, 78039, 78039, 78039, 78039,  3339,
    3536,102277, 78039,  3484,  1568, 71487,   462,  2060,  2936,  3437,
   -4944,  1350, -4944, 57447, -4944, 78039,  3426, -4944, -4944, -4944,
   76167,  3661,  3332, -4944, -4944, -4944, 95355, -4944, -4944,  3432,
   -4944,  1966, -4944, 57447, 57447, 78039,  7900, 95823,  1385,  3448,
   -4944, -4944,102277, -4944, 78039, 76635, 78039, 78039,  3486, 78039,
   68679, 96291, 96759,  1043,  1410,  3489, 78039, 69147,  3490, -4944,
    3365, 78039, -4944, -4944, 54171, 57447, 78039,   816, 53703, -4944,
   -4944, 78039, -4944,   905, -4944, 78039,  6198,  3440, -4944, -4944,
    3310,  3321, 78039,   470,  2190,  2936,  3598, 78039, 78039,  3247,
    1971, 57447, 78039, 53703, -4944,  3443,   753, 57447, 78039, 76167,
   -4944,  3461, 71487, 71487, 57447, 78039, 71487, -4944, 78039, 87399,
   -4944, 57447,  1236, -4944, 57447, 78039, 76167, -4944,  3464,  3408,
   57447, 78039, 14275, -4944, -4944, -4944,   330, -4944, -4944, -4944,
   -4944, -4944, 78039, 78039,   330, 78039, 78039,   330,  1553, -4944,
   57447, 78039, -4944, -4944, -4944,  3360, 57447, 78039, 78039,   341,
   -4944, 57447,  3097, 78039, 53703, -4944, 78039,  7898, 78039, 78039,
   78039, 78039, 78039, 78039, 57447, 78039, -4944, -4944,  1493,    72,
     127,  1675,   833, 78039,  3563, 78039, 97227, 57447, 78039, 78039,
    1126, 78039, 53703,  1698, -4944, -4944,  3388, -4944, 57447,  1236,
   -4944,  9225, 78039, 78039, 78039,  3343,  3356,   228,  3428, -4944,
   -4944, -4944,    92,    92,  3478, -4944, 29624, 29624, 28664,  3279,
   -4944, -4944, 29624, -4944, -4944, -4944,   344,  3727, 97695,   344,
   -4944,   344,  3553,  3335,  3338,   344, 78039,   344,   344, 78039,
   -4944, -4944, -4944, -4944,  3552, 78039,   344,   344,   344,  3456,
   -4944, -4944,  3456,   769, 29624,102277, 78039, -4944,  1973, -4944,
    3301,   970, -4944, -4944, 53703, 78039,   220,   151,  3623,  3501,
   64935,  2145,  3614, 78039,  3333, 78039,  3741,  3385, 71487,  2529,
   -4944,  2145, 78039, -4944,  2370, 66807, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, 78039, -4944, -4944,  3620, 78039, 29624,  3466,
   -4944,  1126,  2529,  2529,  2529,  2529, -4944, -4944, -4944, -4944,
    3509,  1294, -4944,  3303,  2529, 78039,  3422,  3643,  2145,  3309,
    3645, -4944,  3806,  3649,  1187, 78039,  3525, 64935,  3368,  3350,
    3538,  3768,  2048,  1126,  3543,  3529, -4944, 50429, -4944,  2529,
   25805,  5712,  6209,  3531,  3592, 60723,  3634,  3640,  3656, -4944,
     226, -4944,  3791,  1639,  3667, 29624,  1975,  3345,   306, -4944,
   -4944,  3347,  3109,  3361,  3364,  3348,  3349, -4944,  2489,   206,
    3351,  1207,  1136,  3473,  2489,  3589,  3352, -4944,   313, -4944,
    2683, -4944, 78039, -4944, 78039, 78039, 78039, 78039,   321, -4944,
   -4944,   313,  2683,   313,   921, -4944,  3626,   306,  2683,  3475,
    3680, 60723, -4944,   349, -4944,   414, -4944,  3569,   921, -4944,
    3585,  2048, -4944, -4944,  1032, 42890, -4944, -4944, -4944, -4944,
   -4944, -4944,  1977, -4944, 78039, -4944,  3660,  3662,  3663,  3664,
    3665,  3366,  3370,  3397, 78039,  3374,  3366,   330,  3374,  3374,
    3366,  2833,  2833,  3366,  3370, 56979,  3831,  3686, -4944,  3453,
    3380,  3702,   199, -4944,   213,   725,  3624, -4944, -4944, -4944,
   -4944,102277, -4944, 57447,  3424,  2539,  2539, -4944,   406,  3594,
    3384, 56979,  3821,   921, -4944, 61659, -4944, -4944,102277,  3472,
    3485, 61659,  3607,  3446, 61659, -4944, -4944, 61659, -4944, -4944,
   -4944, -4944, -4944,102277, -4944,  3668, 78039, 78039,  1986, -4944,
   -4944,  1820, -4944,  1832, 29624,   192, -4944, 15777,  1993, 29624,
    3394,  3399, -4944, -4944, -4944, -4944, -4944, -4944, -4944,  3403,
    3731, -4944,  1995,  2003,  2027,  3405,  3410,  5265,  6208,  3411,
   14806,  3412,  3409, 34904, 34904, 26259,  1117, -4944, 34904,  3415,
    3615,  2037, 15177,  3418,  3416, 15849, 29144, 29624, 29144, 29144,
   15931,  3418,  3425,  2043, 53703,  3617, 16259,  2062, -4944, 29624,
   53703,  6738, 29624, -4944, 29624,  3430, -4944, -4944,  4516,  4516,
    4516,  9713, -4944,  3449, -4944, 34904, 34904, -4944,  2642, 26259,
   -4944, -4944,  3740, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
    2627, -4944,  3427, -4944, -4944,  3659,  2889, 47148,  8426, 29624,
     362, 29624,  3154, 29624,  3516,  4516,  4516,  4516,   430,   430,
     309,   309,   309,  2024,   437, -4944, -4944, -4944,  3438,  3441,
    3442,  3635,  3447, 29624, -4944,  1988,  2105, 78039,  2831,  4866,
    5717, -4944, -4944, -4944, 38678,  3491,    65,  3491, -4944,  1375,
    2489,   823, 51828, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   78039, 17405, -4944, -4944,  3691,  3450, -4944, -4944, 29624, -4944,
   -4944,  2606,  3476,   928,   102,  2267,  2267,  2223,   778, -4944,
   -4944,  3497, -4944, 29624,  2281, -4944,  2393, -4944, -4944, -4944,
   -4944,  2833, -4944,  3697, -4944, -4944, -4944, 38678,  3494, 78039,
   -4944, -4944, -4944, -4944, -4944, -4944, 98631,  1719, -4944,102731,
   -4944,102731, -4944,  1719,  3880, -4944, 98631,  1566, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, 57447, 57447,  3666, 78039,  3658,  3671, 29624,   795, 78039,
    3465,  3474,  1487,  3748, 78039, -4944,  3795,   921, -4944, -4944,
    3544, -4944, 17405, -4944, -4944, -4944, -4944, -4944, 57447, 78039,
   -4944, 60723, -4944, 78039, -4944,102277, -4944, -4944, -4944, 78039,
    3496, 78039, -4944, 78039, 78039, 78039, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944,   952,102277, -4944, -4944, 78039, 78039,   860,
    3549,  3551, 78039, -4944,  1105,  3179, 10024, 78039, 78039, 78039,
    3751, -4944, -4944, -4944, -4944,  3692, -4944,  3808, -4944, 98631,
   -4944,  2683,  1143,  3555,  2936,  3703, -4944,  3819,  3696, -4944,
    3613,   993, -4944, -4944,  3610, -4944, -4944, -4944, -4944,  3832,
     921,  3833,   921, 78039, 78039, 78039, 78039,  3627, -4944, -4944,
   -4944, -4944,  3630,  3757, -4944, 53703, 53703, 53703,  2066, -4944,
   -4944,  1126, -4944, -4944, -4944, -4944, -4944, -4944,  3790, -4944,
    2068, -4944,   618, -4944, -4944, -4944, -4944, -4944,  3838, 57447,
   78039, 10368, 78039, 78039, 78039,  3712,  1816, -4944,  1076,102277,
   -4944,100461, -4944, -4944,  2074, -4944,  3515, 78039,  3588, 57447,
    3561, -4944, -4944, -4944,  3846,  3507,  3507, -4944, -4944,  3507,
   -4944, -4944, -4944,  3772,  3701, -4944,   978,  3704, 57447,  3574,
   -4944, -4944, -4944, -4944,  3854,  3599, -4944, -4944,  3605,  2230,
    2936,  3806, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944,  3631, -4944, -4944, -4944, -4944, -4944, -4944, -4944,  1438,
   -4944, -4944,  1215,   254,  2339,  2936, -4944,   326, -4944,  3611,
   -4944,  3612, -4944, -4944, -4944,  3779,  3784,  3785,  3618,  3622,
    3674,  3629,  3633,  3678, -4944,  3637,  3679,  3641,  3684,  3642,
    3902,   921,102277,  3770,  1126,  3675,  3894,   921, -4944,  3644,
   -4944,  3646, -4944,  2086,  4008, -4944, 78039, -4944,   479,  2503,
    2936, -4944,  3648, -4944, 57447, 78039, -4944, -4944, -4944, 29624,
    3568,  3570,  3571, 17405, 17405, 29624, -4944, -4944, 17405,  3576,
   -4944, -4944, -4944,102277, 78039,  3845, -4944, -4944,   344, 78039,
   78039, -4944,  3848, -4944, -4944,  3852, 78039,  3855, -4944, -4944,
   -4944, -4944,   463,   463, -4944, -4944,  3890,  7941,  3581,   441,
   -4944, 53703, 44297,  2046,  2332,   821,     4, -4944, 60723, 78039,
   60723, -4944,   151,  3696, 78039, 78039, 78039,  3582,  3580, -4944,
   -4944, -4944, -4944, 57447,   946, 57447,  2489, -4944, -4944,  3655,
   -4944, 78039,  2048,  4070,  3913, -4944,  3507, -4944,  4030,  2993,
    1537,  3742,  1505,  2644,  3969,  2297,   423, 53703,  3350, -4944,
   -4944, -4944, -4944, 78039, 78039,   970,  1126, -4944,  3591,  3590,
   -4944, 78039,  3921, 78039, 78039, 78039, 78039,  3424,  3597, 78039,
    3601,102277, 78039,  2023,  2938,  4048,  3939,  1528,  3368,  3685,
    3943, 71487,  3621,  2102, -4944, -4944, -4944,  2111,   193, -4944,
    1126, 60723, 99553,  3932, -4944,  6209, -4944, -4944,  6209,   957,
   78039,  3917, -4944, -4944,  1528, -4944,102277,  3609, -4944,  2116,
   -4944,  2127, -4944, -4944, -4944,  2489, -4944, -4944,  1361,  1361,
    3616, -4944,  3628, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
    3647, -4944, -4944, -4944,   349,  3672,   921,  3676,   921, -4944,
   -4944, -4944, -4944, 78039, -4944, 78039, 56511,   921, -4944, -4944,
   78039, -4944,  3950,  3669,    53, 41954,  3835, -4944, 78039,   434,
   -4944,  3639, -4944, -4944, -4944,  3756,  3765,  3769,  3771,  3775,
   78039,  3366, -4944,  3632, 57447,  1482, -4944, -4944,  3829, -4944,
   -4944, 71487,  3758, -4944, -4944, -4944, -4944,  3983,  3984, -4944,
   -4944, -4944,   280, -4944, 78039, 78039, 57447, 67275,   499, 57447,
   -4944,  3922,  3924, -4944, -4944,  3926,   330, -4944,  3927,  3930,
    3931, -4944,  3935,  3936, -4944, -4944, -4944,  3673, 16324, 29624,
   -4944,  4010,102277, -4944,  8101, -4944, -4944, -4944, 29624, -4944,
   -4944, -4944, -4944, -4944, -4944,  2195, 29624, -4944, 29624,  3990,
   -4944, 23927,  4137,  4137,  3677,102277, 34904, 34904, 34904, 34904,
    1523,  2795, 34904, 34904, 34904, 34904, 34904, 34904, 34904, 34904,
   34904, 35861,   469, -4944,  3867, 29624, 29624,  4001,  3990, -4944,
  102277,  3681,  3418,  3682,  3689, 29624, -4944, -4944,  2131, 36806,
    3694, 53703, -4944, 29624, 15627,  2138,  3723, 17186,  1757,  8511,
    1126, 29624,  2221,  2654, 29624,  2144, 29624,  4006, -4944, -4944,
   -4944, -4944,  3693, -4944, -4944,  3911,102277, -4944, 29624,  3695,
    3730, 34904, 34904,  3853, -4944,  3898, 29624, 26259, -4944,  3478,
    3732, 43358, -4944, 24413,  3699,  1062,  1062,  1062,  1062, -4944,
   78039, 78039, 78039, 39146,  4018,  3700, 38210, 77103,  3706,  2875,
   -4944, 77103, 77571, 77103, -4944,  3715, -4944,  1757, 29624,  4016,
    3705,  4016,   239,  3710, -4944, -4944, -4944, -4944,  1528, -4944,
    3707, -4944,  3476,   279, -4944, -4944, -4944,  1026, -4944,  3788,
   -4944, -4944, -4944,  3706, 31064,  3859, -4944,  2157,  1839, -4944,
   -4944, 98631, -4944,  3783,  2683,  2683,  2008,  3366,  4041,  2008,
    8608, -4944, -4944, 39614, 78039, 78039, -4944, 78039,  2174,  1386,
   78039, -4944, 78039, -4944, -4944, -4944, -4944,  4166, -4944, 78039,
   -4944, -4944,  3773,  3786, 78039, 78039, 78039, 78039,  3988, -4944,
   -4944,  2349, -4944, -4944, 57447, 78039, -4944, -4944, -4944,   481,
    2562,  2936, -4944,  3807, -4944, -4944,  4013, 78039, -4944,  4161,
    3822, 78039,  4071, 78039,  3735, -4944,  1386,  3841,  4055,   278,
    2938,   332,  2949, -4944,  1109, -4944, -4944,  3809, -4944, 78039,
   -4944, 78039, -4944, -4944, -4944, -4944, -4944, -4944, -4944,  3869,
   -4944, -4944, -4944, -4944, 54171, -4944, -4944, 78039, -4944, 53703,
   44297, 53703, 78039, -4944,  1259,   485,  2700,  2936, -4944,  3824,
   -4944,  4077,  3825,  3826,  3876,   205,   246,  3830,  3839,  3883,
    3750,  3755,  3759, -4944, 53703, 44778,  3906, 78039,  2683,  3753,
    3798, 78039,   341,  1126, -4944, -4944,  1126,  2683,  1126, 78039,
   78039, 78039, 78039,   341, 53703, -4944,  4190,  3851, 78039, 78039,
   78039, 78039, -4944,  3814, -4944, 78039, 78039,  4092,   977,  2018,
   57447, 78039, 78039, 57447, 78039, 78039, 78039, 78039, 78039, 78039,
   78039,  3976, -4944,  4181,  4108,  2149,  4150,  3842, 78039, -4944,
   78039,  1126, -4944,  3179, 78039, 78039, 78039, 78039, -4944, -4944,
   -4944, -4944, -4944,  3478, -4944,  3774,  4051,   344, -4944,  4052,
    4053,   344,   344,  4054,   344, -4944, -4944,     4, -4944,   512,
   78039, -4944,  2061, 78039, -4944, -4944, -4944,  3707,  2161,  2186,
   -4944, -4944, -4944, -4944, -4944, -4944, 78039,  3780, 78039, 78039,
   34904, -4944,  1786,  1401,  1042, -4944,  4056, 78039,  3097, -4944,
   -4944, -4944,   225, 78039, -4944, -4944, -4944, -4944, -4944,   819,
    3597, -4944,  4074, 64935,  2683, 57447, 57447,  2683, -4944,102277,
    3781,  3350, -4944,   879,  3866, 57447,  1537,   981, 98163,  3106,
    3820,  3998, 38678,  1438, -4944,  3793,  3949, -4944,  3794,  3797,
   -4944, -4944, 78039,  3696, 56511,  2188,  3806,  4242,   101,  2009,
   -4944, 66339,  3987,  3597,  4074, -4944,  2938,  4005,  4011, -4944,
    1528, 78039,  3424,  3350,  1126, 78039,  3252, 44297, -4944,  4287,
   -4944, 98631, 29624, 29624, -4944,  3800, -4944,  3799,  6209, -4944,
    3878,  3802, -4944, -4944, -4944, -4944, -4944,  3889,  3812, 78039,
   -4944,  3813,  3667, -4944,  3667, -4944,  3816, -4944, -4944, -4944,
   -4944, -4944, -4944, 78039, -4944, 78039, -4944,   921, -4944,  3937,
   -4944,   921, 78039, -4944, -4944, -4944,  3868,  2199, -4944, -4944,
    4221,  3859, -4944,  2235, 42890,  3494, 29624,  1757, 78039, 78039,
   78039, 78039, 78039,  3366,   330, -4944,  4134, 56979, -4944, -4944,
    2240, 78039, -4944, -4944, -4944,  4201, -4944, -4944,   436,  4143,
   -4944, -4944,   994,   994,   994,  4099,   994,   994,   994,   994,
     994, -4944, 29624, 17405, -4944,  3834, -4944, 17405,  3840,  9101,
   17405,  4001, -4944,  2256, 29624, -4944,  1275,  1275,  1275,  3278,
    4147, -4944,  1584,  3843,  1275,  1275,  1275,   354,   354,   257,
     257,   257,  4137,   469, 17405, 17405, -4944, -4944,  3849, -4944,
   -4944, -4944,  3418, -4944, 31544,  1208,  4266, 36338, -4944, -4944,
   -4944,  3875,  3879,  3850, -4944, 29624, 32024,  3856,103185,  4036,
   -4944,  1059, 29624, 29624,  3836, -4944, 11563, 29624,102277, -4944,
    2273,  3836,   492, 29624,  2702,  2934, 29624, 29624,  5203,  9163,
    3858, 29624, 99085, -4944, -4944, -4944,  2277, 29624, 78039, 78039,
   78039, 78039, -4944, -4944, -4944, 77103, 77571, 77103,  3857, 37274,
   24882,  2875,  3860, 78039, -4944, -4944,  3862, 38678,  4114,  4063,
   -4944, 38678,  4063,   211,  4063,  4124,  3946, 43826, -4944, -4944,
    3865, -4944,  4068, -4944,  1643, 17405,  4285,  4175,  1126,  4175,
    1126,  3870, 47148, -4944, -4944, -4944, -4944,  3952, -4944,  4084,
   17405, 27704, -4944, -4944,  3944,  2279, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944,  3953, 66807,  4196, -4944, 29624,  2284, -4944,
    3914,  4289,   178,  2286,  2288,  1386, -4944,  4176, -4944,  1622,
    4170,   207, -4944,   921, -4944,102277, -4944, 78039, 78039, -4944,
   -4944, -4944, -4944, 78039,  2885, -4944, -4944, 78039, 78039, 78039,
   78039, -4944, -4944, 57447, 78039, -4944, 78039, -4944, 53703,  2332,
     341,  1786,  4184,  4186,  4103, -4944,   330, -4944,  1786,  4104,
     341, 78039, -4944, -4944,  3752, -4944,102277,   921,   921, -4944,
   -4944, -4944, -4944, -4944,  3897, -4944,  4319,  3977, 78039, 78039,
   78039, 78039, 78039, 57447, 78039, 78039,  2489,  2489,102277,  3891,
   -4944,  2489,  2489,  3892, -4944, 57447, 78039, 78039, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,  3978,
   -4944, 29624,  4316, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, 57447, 78039,  3979, -4944,  3980,
   -4944,   918, -4944, -4944, 78039, 78039, 78039, 78039,  4240, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
    4238, 78039, -4944, -4944,  1126,  1126,102277,   921,   921, -4944,
   -4944, -4944,  3985, -4944, -4944,  3905,  4178,   344, -4944,   344,
     344, -4944, -4944,   344, -4944,  3908, -4944,     4,  4275, -4944,
    1386,  1843,  4229, -4944,  4234, 29624, -4944,  1247,  3278, -4944,
    4288,  4364, -4944, -4944, -4944, -4944,  3097,  2048,  3972, -4944,
   -4944, 61659,  1339, -4944,  4215,   220,  4135, 64935,   326,   303,
    3920,  4046, -4944,  2683,  2683,  3981, 78039,  4373, -4944, -4944,
   -4944, -4944, -4944, -4944, 57447,  3561, -4944,  4148,   106,  4250,
   78039, 29624,  3706, -4944,  1870,  4255, -4944,  1126, -4944, -4944,
    4057,  3350, -4944,  1365, 78039,  4145, 64935,  3424,  2302, -4944,
   -4944, -4944,  3973,  4367,  3368, -4944,   326,  3987, -4944, -4944,
    4339,  4028,  3982,  4390, -4944,  4028,  4263,  4153,  3947, -4944,
    3621, -4944, -4944, 17405, 17405,  1126,103639,  6209,102277,  4276,
   78039,   825,  4237,   921,  2307, -4944, -4944,   921,   921, -4944,
   78039, -4944,  1528,  2852, 78039,  1757,   749, -4944,  3963, 78039,
   -4944,  3859, 17405,  3366,  3366,  3366,  3366,  3366, -4944,  4159,
   -4944, -4944,  4231, -4944,   921, 56979, -4944, -4944, -4944, -4944,
   -4944,   994, -4944, -4944, -4944, -4944, -4944, 17405, -4944, -4944,
   -4944, -4944, -4944,  9463, 34904,  4278, -4944,  3955,102277, -4944,
    3962,  2323,  2329, -4944, -4944,  1208, -4944,  4266, -4944, -4944,
   -4944,  9525,  4014, 17405,  4073,  3965,  3967,  3836,  3836, 11563,
    2331, -4944,  3836, 29624, 29624,  3836,  3836, 29624, -4944, -4944,
   10359,  4163, -4944, -4944, 10397, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944, 54639,  3986,  3617, 77103,  3991, 78039,  2875, 38678,
   -4944, -4944,  2355, -4944, 38678,  4244, -4944, 38678, 61659, -4944,
   78039,  3992, 78039, -4944, 32504, 29624,  4015, -4944,  4015, -4944,
   -4944,  3975, -4944, 78039,  2832, -4944, -4944, 56979,  4187, 56979,
    1386, 10723,  4176, 39614, 48096, 78039, -4944, 78039, -4944,  4139,
    4176,  3994,  3097, -4944, -4944, -4944, -4944, -4944, -4944,  3989,
   -4944, -4944, -4944, -4944,  4060, -4944, -4944,    28,  3355, -4944,
    2337, -4944, -4944,  4431,  4323,  4326, -4944, -4944, -4944, -4944,
   -4944, -4944,  4181, -4944, -4944, 44297, 57447, 78039, -4944,  4075,
   -4944, -4944, -4944, -4944, -4944, -4944, 41486, 47148, -4944,   205,
    3996,  3997,   246, -4944, -4944, -4944, 78039, 11116,  3999,    40,
    3355, 78039, 78039,  4000,  4003,  4004,  1446,  1413,  1740,  3366,
    4324, 78039, -4944, -4944, -4944,  4181, -4944, -4944, 78039, -4944,
     344, -4944, -4944, -4944, -4944, 53703, -4944,  1400,  3908,  1126,
   61659,  4451,  4451, 78039, -4944, 11418,  4224, -4944, -4944,   149,
    3972,  4257,  4303, -4944,  4017, 78039,   225,  4019, 78039,  4012,
    4138,  1535,  1535, 78039, 78039, 78039,  2352,  1528,  2683,  3798,
    1537,  4350, 64935,  4398,  3696,   438, -4944, -4944,  1870, -4944,
      96,  4375,  4061, -4944, 78039,  4473, 78039,  3424,  3597, 78039,
    4023, -4944, -4944, 66339,  4230,  2332, 78039,  2023,  3987,  3368,
     935, 78039, -4944,   361, -4944,  1528, -4944, 78039, 71487, 39614,
   -4944,102731, -4944,  2357, -4944, -4944,  4097,  3491,  4140,  4141,
    4031, 78039,   890, -4944, -4944, -4944, -4944, -4944, -4944,    53,
   -4944, -4944,  4434, 39614,  4392, 29624, -4944, -4944, -4944, 78039,
   -4944,   499, -4944, -4944,  3344, 34904,102277,  2372, 29624, -4944,
   29624, -4944, -4944, -4944, -4944,   116, -4944, -4944, -4944,  3836,
    3836,  3836, -4944,  4467,  3478, -4944, -4944,  2385,  4490, 33944,
    4453, -4944, 78039,  2403, -4944, 29624,  4044, -4944, -4944, 38678,
    2355,  4045,  2405, 78039,  2422,102277,  4049,   990,  4050, 22955,
    4037, -4944, -4944, -4944, -4944, -4944, 17405, 17405, 78039, -4944,
   -4944, -4944, -4944,  1482,  2008,   499,  4289,  3097, -4944,  4058,
   -4944, -4944,  2938,   413, 78039,  3097, 78039,  3972, -4944, 78039,
    4142, -4944, -4944, 53703,  4355, -4944, -4944,  4111, -4944,   999,
    3355, 78039,102277, -4944,   160,  4378, -4944,102277,102277, -4944,
   -4944, -4944, 29624,  4146, -4944, -4944, -4944, 29624, 29624, 63999,
   -4944, -4944, 78039, 78039, 78039, 78039, 78039, -4944,   921, -4944,
   -4944,  2428, -4944, 40550, -4944, -4944,  2963,  1126,  2963,  1717,
   -4944, -4944,  2963,  2963, -4944,  3491, -4944,  4451,  1003, -4944,
   -4944, -4944,  1668,  4284,  4059, 29624, -4944,  1132,  4269,  4151,
    4062, -4944, 61659,  4545,  3597,  4074, 78039, -4944, -4944, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,  2430,  3696,
    4397,  3350,  3982, -4944, 78039,  4100, -4944, 38678, -4944, -4944,
   -4944,  2963, -4944,   741,  4066,  4408,  3696,  1528,  2009, -4944,
    3987,  3597,  4074, -4944, -4944,  4069,  4011,  3368,  2023,  4207,
   -4944,  4209, -4944,  4492,  4280,  4498,  3424, -4944,  3252,  2441,
   -4944, -4944,  6209,103639,102277,  4438,  4121,  4122, -4944, -4944,
    4149, 78039, -4944, -4944,  4144, 78039,  2445,   113, 17405,  3696,
   -4944,  3344,  2451, -4944,  2458,  2473,  4152, -4944, 29624,  1134,
    3715, 54639,  4087, -4944, 34904,  2521, -4944,  3188, 78039,  2532,
   -4944, 17405, 78039, -4944, -4944, 29624, -4944,  2537, -4944, 29624,
    4088, 29624, -4944, 32504,  4085, -4944,  4546, -4944,  4420, -4944,
   -4944,  3972, 47148,   413,  3476,  2048,  3972,  2538, -4944, -4944,
   78039, -4944,  4059, 29624, -4944,  4189, -4944, -4944,  2544,  1463,
    4265,  4265,  2555,  2556, 11504, 78039,  2563,  2569, -4944,  2574,
    2489,  3370,  1740,  3370, -4944,  3366, -4944, -4944, 53703, -4944,
   55107, -4944, -4944, -4944,  1126, -4944,  1126,  4332, 78039, 49500,
    1126,  1126, -4944, -4944, -4944, -4944,  4457,  4396, -4944,  3806,
   -4944, 12189, -4944, -4944, -4944,   837, -4944,  4327,  4329, 78039,
   -4944,  4107, -4944,  2578,   326,  4239,  3696, -4944, -4944, 78039,
    4567,  4572, -4944,   723, 78039,  3706, 78039, -4944, -4944, -4944,
   29624,   225, -4944,  3982,  3424,  3368,   326,  3987,  2332, 40082,
    4028,  2023,  4011, -4944, -4944,  4334, -4944,  4336, -4944,  4123,
    4422, 39614,  6209, -4944, -4944,  1258,  4452,  4454, -4944, -4944,
    1528, -4944,  3491, -4944,  4258, -4944, -4944, -4944, -4944, -4944,
    3418, 32984, 32984, 32984,  4133, -4944, -4944, 78039,  3278,  4132,
   33944, 53703,  2582, -4944,100915, -4944,  2604,  2611, -4944,  2613,
   32504,  2617, -4944, 78039,  4155, 56979,  4179,  4156,  3476, -4944,
    4257, -4944, -4944,  1386,  3355, -4944, 17405, 78039, 61659,  4570,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944,  3355,  4222, -4944,
   -4944, 63999, -4944, 78039, -4944, -4944,  2623, -4944, -4944, -4944,
   78039,  3793, -4944,  3793, -4944, -4944,  4282, -4944,  1530,  4247,
     997,   997,  4515, -4944,  4206, -4944, -4944,  4157, -4944,  4640,
    4286, 78039, -4944, -4944,   205,  1528, 64935,  3696, -4944, -4944,
   12517, 61659, -4944, -4944,  2023,  3987,  3368, 29624,  2657, -4944,
    4289,   178, -4944,  4011,  4028, -4944, -4944, 39614,  4160,  3350,
   -4944, -4944, -4944,  2121, 61659, 61659, -4944, -4944, 42890, 34424,
    4299,  1159, 14878,  4506, -4944,  4506,  4506, -4944,  2659, 36338,
   -4944, -4944, -4944, 78039,  4366,   345, -4944,  4318, -4944,  2666,
   -4944, -4944, -4944,   499,  4171, -4944, -4944, -4944,  4269,  1386,
   -4944,  3355, -4944, 78039, -4944,  4172, -4944, -4944, -4944, 55107,
    3793,  4061, -4944, -4944, -4944,  4630, -4944,  1101, -4944, -4944,
   -4944, -4944, 78039,  3696,  3891,  3982, -4944, -4944,  4173,  4011,
    3368,  2023, 12537, -4944, 40082, 78039, 78039,  4028, -4944,  2670,
   39614,  4028, -4944,  3036, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944,  4174,  4177,   649,  4623, -4944, -4944, -4944, -4944, -4944,
    1152, -4944, -4944, -4944, -4944,  3617, -4944, -4944, 34904, 34904,
    4393, -4944,   345, -4944,  4180, -4944, -4944, -4944, 29624,  1386,
   -4944, -4944, -4944, 29624, -4944,  4517, -4944, -4944, -4944,  3696,
   -4944, -4944, 53235,  4028,  2023,  4011,  4289, -4944, -4944, -4944,
   -4944, -4944,  4422, -4944,  2679,  3491,  2029, -4944, -4944,  2033,
    2317,  4256,  4496, -4944, 33464,  4317, -4944,  4383, -4944,  4593,
    3278,  3278, -4944, -4944, 29624, 12555,  1386,  2704,   225, -4944,
   -4944,  2708, -4944, -4944, -4944, -4944, -4944,  4011,  4028, 78039,
    3350, -4944, 39614, -4944, -4944,  3036,  4294,  4296, -4944, -4944,
   -4944, 78039, 12902, -4944, -4944, 61659, -4944, 53235,  4028, -4944,
   -4944,  4028, -4944, -4944,  4225,  4226,  2709, -4944,  4192, -4944,
   -4944,  3491,  4509,  4512, -4944, 53235, -4944, 61659, 61659,  2725,
   -4944, -4944, -4944
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
    1686,  1450,   626,  1536,  1535,  1450,     0,   260,     0,  1546,
       0,  1450,   419,  1122,     0,     0,     0,     0,   626,  1450,
       0,  1686,     0,     0,     0,     0,     0,  1699,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1450,     0,
       0,  1706,     0,     0,     0,     0,  1699,     0,  1548,     0,
       0,     0,     0,     0,     2,     4,    39,    74,    75,    32,
      31,    93,    57,    18,    65,   127,   126,   128,    44,    40,
      82,    27,    29,    41,    45,    67,    69,    34,    47,    58,
     105,    66,    25,    64,    88,    70,    91,    52,    12,    13,
      53,    14,    54,    15,    55,    16,   101,    76,    94,    37,
      63,    24,    46,    72,    73,     5,    48,    80,    11,    59,
      60,    62,    85,    86,    87,   110,    89,   122,    43,   119,
      98,    99,   116,   100,   117,     9,   102,    56,    17,   113,
     112,   114,    83,    49,    84,    71,    92,   111,    28,   115,
      19,    20,    22,    23,    21,    61,    30,    68,    33,    90,
     118,   108,   104,   123,   121,   129,   106,    77,     7,     8,
      95,     6,    26,    51,    10,    36,    35,    50,    42,   125,
      38,  1546,    97,   109,    96,    78,   103,    81,   107,   124,
      79,   120,  1656,  1655,  1708,  1659,  1685,     0,  1671,  1449,
    1448,  1463,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   625,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1460,  2302,
    2317,  2318,  2319,  2320,  2321,  2322,  2323,  2324,  2325,  2326,
    2327,  2328,  2329,  2330,  2331,  2332,  2667,  2333,  2334,  2335,
    2616,  2617,  2668,  2618,  2619,  2336,  2337,  2338,  2339,  2340,
    2341,  2342,  2343,  2620,  2621,  2344,  2345,  2346,  2347,  2348,
    2622,  2669,  2349,  2350,  2351,  2352,  2353,  2670,  2354,  2355,
    2356,  2357,  2358,  2359,  2360,  2361,  2362,  2671,  2363,  2364,
    2365,  2672,  2366,  2367,  2368,  2369,  2370,  2371,  2623,  2624,
    2372,  2373,  2374,  2375,  2376,  2377,  2378,  2379,  2380,  2381,
    2382,  2383,  2384,  2385,  2386,  2387,  2388,  2389,  2390,  2391,
    2392,  2393,  2394,  2395,  2396,  2397,  2398,  2625,  2399,  2400,
    2401,  2402,  2626,  2403,  2404,  2405,  2627,  2406,  2407,  2408,
    2673,  2674,  2409,  2410,  2411,  2412,  2413,  2628,  2629,  2414,
    2415,  2416,  2417,  2418,  2419,  2420,  2675,  2421,  2422,  2423,
    2424,  2425,  2426,  2427,  2428,  2429,  2430,  2431,  2432,  2676,
    2630,  2433,  2434,  2435,  2436,  2631,  2632,  2633,  2437,  2677,
    2678,  2438,  2679,  2439,  2440,  2441,  2442,  2443,  2444,  2634,
    2680,  2445,  2681,  2446,  2447,  2448,  2449,  2450,  2451,  2452,
    2453,  2454,  2455,  2456,  2457,  2458,  2459,  2460,  2461,  2462,
    2463,  2464,  2635,  2682,  2636,  2465,  2466,  2467,  2468,  2469,
    2470,  2471,  2637,  2638,  2472,  2473,  2474,  2683,  2475,  2639,
    2476,  2640,  2477,  2478,  2479,  2480,  2481,  2482,  2483,  2484,
    2485,  2486,  2641,  2684,  2487,  2685,  2642,  2488,  2489,  2490,
    2491,  2492,  2493,  2494,  2495,  2496,  2497,  2498,  2643,  2499,
    2644,  2502,  2500,  2501,  2503,  2504,  2505,  2506,  2507,  2508,
    2509,  2510,  2511,  2512,  2645,  2513,  2514,  2515,  2516,  2517,
    2518,  2519,  2520,  2521,  2522,  2523,  2524,  2525,  2526,  2527,
    2528,  2529,  2530,  2686,  2531,  2532,  2533,  2534,  2535,  2646,
    2536,  2537,  2538,  2539,  2540,  2541,  2542,  2543,  2544,  2545,
    2546,  2547,  2548,  2549,  2550,  2551,  2647,  2552,  2553,  2687,
    2554,  2555,  2648,  2556,  2557,  2558,  2559,  2560,  2561,  2562,
    2563,  2564,  2565,  2566,  2567,  2568,  2569,  2649,  2570,  2571,
    2572,  2573,  2688,  2574,  2575,  2576,  2577,  2578,  2579,  2650,
    2651,  2580,  2581,  2652,  2582,  2653,  2583,  2584,  2585,  2586,
    2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,  2595,  2596,
    2597,  2598,  2599,  2600,  2654,  2655,  2601,  2689,  2602,  2603,
    2604,  2605,  2606,  2607,  2608,  2609,  2610,  2611,  2612,  2656,
    2657,  2658,  2659,  2660,  2661,  2662,  2663,  2664,  2665,  2666,
    2613,  2614,  2615,   131,     0,     0,  2276,  2303,  2304,  2307,
    2302,   391,   390,  1646,  2270,  2303,  1545,  1525,   626,     0,
    1463,   418,  1686,     0,     0,     0,     0,     0,     0,     0,
     859,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   179,     0,     0,     0,     0,   442,   441,
       0,     0,     0,  1088,   447,     0,     0,     0,     0,     0,
     614,  1593,  2500,  1591,  1647,   261,   264,   265,   262,   263,
    2292,     0,  1224,  1225,  1227,     0,     0,  1237,   899,   900,
       0,     0,     0,   908,     0,     0,     0,   897,     0,     0,
       0,   913,     0,   910,     0,     0,   914,   911,   894,   912,
     901,     0,   893,     0,     0,  1237,   915,     0,     0,   895,
       0,     0,     0,     0,  1463,  1590,   448,  1686,     0,  1567,
    1568,  1569,  1546,  1558,  1570,  1563,  1565,  1564,  1566,  1562,
       0,  2291,  2318,  1023,  1023,  1023,  1023,  1020,  1021,  1023,
    1023,  1023,  2520,     0,     0,  1002,     0,  1004,  2293,  1023,
    1028,   511,   511,   511,     0,  1027,  1032,   511,     0,  1431,
    1472,  2275,  1698,     0,  1003,  1430,     0,     0,     0,  2580,
    1581,     0,     0,  1252,  1248,  1250,  1251,  1249,     0,  1091,
    1091,  2538,  1442,   243,  2549,  2650,  2580,   242,   236,   238,
     210,  2322,     0,     0,  1027,     0,  1463,  1440,   985,  1705,
    1703,     0,  2257,  2342,  2357,  2448,   233,  2531,  2539,  2549,
    2650,  2580,  2612,   189,   199,   194,     0,   254,  2549,  2650,
    2580,   250,  1460,     0,  1672,  1809,  2266,     0,  1433,  1432,
    1547,     0,  1550,     0,  2515,  1676,  1679,  1552,  1677,  1668,
       0,     0,     1,  1686,     0,  1557,  1702,  1702,     0,  1702,
       0,  1660,  1668,  1663,  1667,     0,     0,     0,     0,     0,
    1434,     0,     0,     0,   918,     0,  1475,  2271,  1073,     0,
       0,     0,     0,     0,  1324,     0,  1131,  1130,  2308,  2298,
    2299,     0,  2296,  2297,  2309,  2310,  2311,     0,  2420,  1324,
       0,     0,  2164,  2175,  2176,  2177,  2346,  2403,  2172,  2173,
    2174,  2166,  2167,  2168,  2169,  2170,  2171,     0,     0,  1219,
    2165,     0,  2420,     0,  1324,     0,   158,     0,   135,  1324,
       0,     0,  2420,     0,     0,  2420,     0,     0,     0,     0,
       0,  2420,     0,     0,     0,     0,     0,   158,  2453,     0,
     135,  2420,     0,     0,  1454,     0,     0,     0,  1456,  1459,
    1435,     0,  2249,     0,  2250,  2277,  1528,     0,  2266,     0,
       0,     0,   954,   947,     0,   955,   962,     0,     0,   964,
       0,     0,   948,     0,     0,     0,     0,     0,   967,   968,
       0,     0,   969,   949,   970,   950,   971,   951,   972,     0,
       0,     0,     0,   952,     0,     0,     0,  1446,  1437,     0,
    1583,  1585,  1584,  1582,   511,     0,     0,     0,  2420,     0,
       0,   135,  1513,     0,  2420,   135,     0,     0,   446,   445,
     135,  2296,   444,   443,  2346,  2403,     0,  1121,     0,  1389,
     135,  2420,     0,   181,  2420,   700,  2420,  1552,     0,   629,
       0,     0,   814,  2453,   135,     0,     0,     0,     0,     0,
       0,  1091,     0,     0,     0,     0,     0,   613,   626,  1594,
    1592,     0,  1228,   235,   234,  1226,   906,  2420,  1163,   352,
       0,     0,  2420,  1494,  2305,  1884,  1913,  1891,  1913,  1913,
    1880,  1880,  2386,  1893,  2420,  1881,  1882,  1918,     0,  1913,
    1880,  1885,     0,  1883,  1921,  1921,  1908,   352,   922,  1865,
    1866,  1867,  1868,  1894,  1895,  1869,  1900,  1901,  1905,  1870,
    1935,  1880,  2306,   907,     0,   898,  2420,   352,  1127,  2420,
    2300,   168,     0,   896,  2346,  2403,  2420,   352,  1221,     0,
    2420,   352,  2420,   164,  2420,   352,  2420,   352,  2420,   630,
       0,     0,  2420,   352,  2420,  2453,   166,     0,  2420,   352,
     916,  2420,   352,  2268,  2420,     0,  1438,     0,  1586,     0,
    1560,  2654,  1575,     0,  1571,  1578,  1574,  1686,     0,     0,
    1023,  1022,     0,  1023,     0,  1023,     0,  1023,     0,  1023,
       0,     0,     0,  1023,  2294,  2295,  1005,     0,  1029,     0,
       0,  1036,  1035,  1034,     0,     0,     0,  1037,     0,  1813,
    1622,     0,  1428,   237,   188,     0,   249,   248,  1445,     0,
       0,     0,  1091,  1255,     0,  1253,  1090,     0,     0,  1441,
     241,   239,     0,     0,     0,     0,     0,     0,  1447,     0,
    1439,     0,     0,     0,  2279,  2281,  2282,  2178,  2252,     0,
    2617,  2618,  2619,  2241,     0,  2620,  2621,  2622,  2669,  2070,
    2057,  2066,  2071,  2058,  2060,  2067,  2623,  2624,  2005,  2625,
    2626,  2289,  2627,  2628,  2629,  2631,  2632,  2633,  2634,  2062,
    2064,  2635,  2636,  2638,     0,  2290,  2639,  2640,  2482,  2642,
    2643,  2645,  2646,  2068,  2648,  2649,  2650,  2651,  2652,  2653,
    2288,     0,  2069,  2655,  2657,  2658,  2659,  2660,  2662,  2663,
    2664,  2665,     0,     0,     0,  2263,     0,  2037,     0,  1873,
    1874,  1896,  1897,  1875,  1902,  1903,  1876,     0,  2262,  1938,
    2123,  2036,  2053,     0,  2042,  2043,     0,  2035,  2031,  1688,
    2258,     0,  2032,  2278,  2280,  2242,  1688,  2256,   202,   256,
       0,   257,  2264,  2549,   190,   232,   204,   231,   205,   203,
       0,  2344,   191,     0,     0,   192,     0,     0,     0,     0,
     253,   251,     0,  1436,     0,  1811,  1810,  2267,   927,     0,
    1539,  1533,  1542,  1538,  1549,  1546,  2188,     0,  1678,     0,
       0,     0,  1658,  1657,     3,     0,  1554,  1556,  1531,  1552,
    1700,  1701,     0,     0,     0,     0,     0,     0,     0,     0,
    1758,  1716,  1717,  1719,  1755,  1759,  1767,     0,  1664,     0,
       0,  1815,  1637,     0,  1461,     0,     0,     0,     0,     0,
    1162,     0,     0,     0,     0,     0,   919,     0,     0,     0,
    1481,     0,  1483,  1484,  1485,     0,     0,     0,  1486,  1487,
    1475,   245,  1493,  1491,  1474,  1476,  1489,     0,     0,     0,
       0,     0,     0,     0,  1505,     0,   172,   173,     0,   642,
     626,     0,  2420,     0,     0,     0,     0,  1170,  1177,  1323,
       0,     0,     0,     0,     0,     0,     0,     0,  1171,  1169,
       0,  1172,   247,  1182,  1201,  1204,     0,     0,  1129,  1132,
       0,     0,     0,     0,     0,  1314,     0,     0,     0,  1314,
       0,     0,     0,  1323,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   272,   274,   285,   347,     0,   605,     0,
       0,     0,   608,     0,  2420,  1324,     0,     0,     0,  1223,
       0,     0,     0,     0,     0,     0,     0,     0,  1204,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   133,   134,
     139,     0,     0,     0,     0,  1204,     0,     0,     0,     0,
       0,     0,     0,   591,   604,     0,     0,     0,     0,     0,
     601,     0,     0,   135,   277,   581,   587,     0,     0,     0,
     707,   706,     0,     0,     0,     0,     0,  1405,  1404,     0,
       0,     0,     0,  1503,  1502,     0,     0,     0,     0,     0,
    1314,     0,   266,   268,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   383,
     384,     0,     0,     0,   139,     0,     0,  1314,     0,   279,
       0,     0,  1455,  1452,  1453,     0,  1458,     0,     0,     0,
       0,  2045,     0,  2192,  1708,  2190,  1147,  2248,     0,  2312,
    2690,  2691,  2692,  2693,  2694,  2695,  2696,  2697,  2698,  2699,
    2700,  2701,  2702,  2703,  2704,  2705,  2706,  2707,  2708,  2709,
    2710,  2711,  2712,  2713,  2714,  2715,  2716,  2717,  2718,  2719,
    2720,  2721,  2722,  2723,  2724,  2725,  2726,  2727,  2728,  2729,
    2730,  2731,  2732,  2733,  2734,  2735,  2736,  2737,  2738,  2739,
    2740,  2741,  2742,  2743,  2744,  2745,  2746,  2747,  2748,  2749,
    2750,  2751,  2752,  2753,  2754,  2755,  2756,  2757,  2758,  2759,
    2760,  2761,  2762,  2763,  2764,  2765,  2766,  2245,  2244,  2273,
    2313,  2314,  2315,  2316,  2251,     0,  1524,     0,   961,     0,
       0,     0,     0,   963,     0,   956,     0,     0,   953,  2346,
    2403,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     966,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   822,     0,  1475,  1512,     0,     0,     0,   635,     0,
    2420,     0,   137,   860,     0,   812,   447,     0,     0,     0,
    1194,  1388,   137,     0,     0,   175,     0,     0,   704,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   751,   750,
       0,     0,     0,   813,     0,     0,   137,     0,  2420,   584,
    2420,     0,   511,   511,     0,     0,  1093,     0,     0,     0,
       0,     0,     0,  1650,  1652,  1651,     0,  1649,     0,   350,
     351,     0,  1211,  1236,     0,     0,     0,  1912,  1899,  1907,
    1906,     0,  1889,  1888,  1887,     0,  1886,     0,  1913,  1913,
    1911,  1890,  1865,     0,     0,     0,  1917,     0,  1915,     0,
     889,  1861,  1857,     0,  1924,  1925,  1926,  1923,  1936,  1922,
       0,  1871,  1927,  1880,  1877,   909,     0,     0,  1205,     0,
       0,  2420,   352,  2420,     0,  2420,     0,     0,     0,  1213,
     352,     0,  1207,     0,     0,  1209,     0,  1406,     0,   905,
     903,   902,   904,     0,     0,   887,     0,     0,     0,  2420,
     352,     0,     0,   882,     0,     0,   884,     0,     0,     0,
       0,  1686,     0,   221,   222,   220,  1576,   223,  1577,  1573,
    1559,     0,     0,     0,  1013,     0,  1017,     0,  1008,     0,
    1014,     0,  1009,  1006,  1007,     0,  1012,     0,     0,   512,
     514,     0,     0,  2369,  2385,     0,  2409,  2441,  2442,  2506,
    2534,  2539,  2545,     0,  2574,  2585,     0,  1038,  1068,  1033,
     718,     0,     0,  1632,  1429,  2195,     0,  1686,     0,     0,
       0,     0,  1244,  1245,   240,   211,     0,     0,     0,  1070,
    2538,  1444,   984,   626,     0,  2033,     0,  2040,  2041,  2240,
       0,     0,     0,     0,     0,     0,  2039,  2203,     0,     0,
       0,     0,     0,     0,  1961,     0,     0,     0,  2220,     0,
    2226,     0,     0,  1998,     0,     0,     0,     0,     0,     0,
       0,     0,  1962,  1942,  1943,  2037,  2188,     0,  2038,  2285,
       0,  1935,  2261,  2178,     0,  2175,  2176,  2177,     0,     0,
       0,  2255,     0,  2186,     0,     0,  1976,  2184,  1978,     0,
       0,     0,     0,  2172,  2173,  2174,  2166,  2167,  2168,  2169,
    2170,  2171,  2182,  1958,     0,     0,  2125,     0,  1957,     0,
       0,  1771,     0,  2283,  2243,  1771,   258,   259,   255,     0,
       0,   207,   206,     0,   225,   229,   230,   201,   228,     0,
     224,   209,  2112,  2111,   208,   200,   197,   195,   212,   214,
     215,   198,   196,   252,     0,     0,     0,   352,  1557,     0,
    1540,  1541,  1537,  1544,  1768,     0,  1680,     0,  1684,  1557,
       0,  1553,  1675,  1674,  1709,  1710,  1113,  1673,  1738,  1739,
       0,     0,     0,     0,  1764,  1762,  1729,  1720,  1728,     0,
       0,  1726,     0,  1730,  1938,  1757,  1662,  1714,  1715,  1718,
    1661,     0,  1760,     0,  1635,  1758,  1719,  1619,  1596,  1597,
       0,  1816,     0,  1462,     0,     0,     0,  1142,  1144,     0,
    1143,     0,  1146,     0,  1155,     0,     0,  1141,  1160,     0,
    1149,  1147,     0,  1501,     0,     0,   920,     0,     0,     0,
       0,  1482,     0,     0,  2574,   244,  1485,  1490,  1477,  1488,
       0,     0,     0,     0,     0,  1072,  1071,     0,     0,  1095,
       0,     0,     0,  1508,   500,     0,   349,     0,     0,     0,
       0,     0,     0,     0,     0,   808,   805,     0,     0,   804,
       0,   640,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   680,     0,  1314,     0,   712,     0,
    1179,     0,  1178,     0,  1183,     0,     0,  1180,  1175,  1176,
    2539,  2549,  2580,   246,  1181,  1203,     0,  1202,  1198,     0,
    1124,     0,  1125,     0,     0,     0,     0,     0,  2395,  2420,
     290,   312,     0,  1313,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   334,
       0,     0,   337,   336,     0,     0,     0,     0,     0,   341,
     320,     0,   321,     0,   340,     0,     0,     0,   606,   607,
       0,     0,     0,  1314,     0,   281,     0,     0,     0,     0,
       0,     0,     0,     0,  1220,     0,   735,     0,     0,  2539,
    1199,     0,     0,     0,     0,     0,     0,  1392,     0,     0,
     161,     0,   156,   160,     0,     0,  2539,  1200,     0,     0,
       0,     0,     0,   589,   590,   603,     0,   594,   595,   592,
     596,   597,     0,     0,     0,     0,     0,     0,     0,   588,
       0,     0,   702,   701,   705,     0,     0,     0,     0,     0,
    1401,     0,  1194,     0,     0,  1400,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1257,  1256,     0,     0,
       0,     0,  1324,     0,   850,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   163,   722,     0,   721,     0,   157,
     162,     0,     0,     0,     0,     0,     0,     0,     0,   219,
    1451,  1457,  1708,  1708,  1708,  2051,     0,     0,     0,     0,
    1707,  2246,  2249,  1527,  2274,  1526,     0,     0,     0,     0,
     965,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     957,   958,   959,   960,     0,     0,     0,     0,     0,   397,
     394,   395,   397,     0,     0,     0,     0,   824,     0,   827,
     830,     0,  1473,   466,     0,     0,   632,   680,     0,     0,
     450,   170,     0,     0,     0,     0,   737,     0,     0,     0,
    1387,   132,   179,   181,   448,     0,   180,   182,   184,   185,
     186,   183,   187,     0,   699,   703,     0,     0,     0,     0,
     628,     0,     0,     0,     0,     0,   752,   756,   755,   759,
     757,     0,   753,     0,     0,  1836,     0,     0,   155,     0,
       0,   579,   583,     0,     0,     0,     0,   450,   550,   363,
    2420,     0,   511,     0,  2420,     0,  1092,     0,   811,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1648,
     352,  1164,     0,  1495,     0,     0,     0,     0,   352,  1910,
    1909,  1862,  1858,     0,     0,     0,     0,   923,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1878,   352,  1128,
     169,  2301,     0,   891,     0,     0,     0,     0,   352,  1222,
     879,   352,   165,   352,   352,   631,     0,   352,   167,     0,
       0,     0,   623,   352,   917,   352,  2269,     0,   352,  1589,
    2420,   511,  1561,  1572,     0,     0,  1010,  1019,  1018,  1016,
    1015,  1011,     0,  1030,     0,   510,     0,     0,     0,     0,
       0,  1046,  1047,     0,     0,  1043,  1048,     0,  1044,  1045,
    1050,  1040,  1039,  1051,  1052,     0,     0,  1070,   716,     0,
       0,     0,     0,  1629,     0,  1627,     0,  1814,  1631,  1620,
    1580,     0,  1579,     0,   572,  1091,  1091,  1254,     0,     0,
    1027,     0,     0,   352,  1443,     0,   986,   992,     0,     0,
       0,     0,     0,     0,     0,   995,   996,     0,   997,   988,
     998,   989,   999,     0,   990,     0,     0,     0,     0,  2253,
    2199,     0,  2200,     0,     0,  2239,  2235,     0,     0,     0,
       0,     0,  2204,  2207,  2208,  2209,  2206,  2210,  2205,     0,
       0,  2211,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2646,     0,     0,     0,     0,  2006,     0,     0,
    2159,     0,  2188,  2225,     0,     0,     0,     0,     0,     0,
    2188,  2231,     0,     0,     0,     0,  2110,     0,  2107,     0,
       0,     0,     0,  2252,     0,     0,  2286,  1939,  1953,  1954,
    1955,  1959,  2260,     0,  2254,     0,     0,  1940,  1967,     0,
    2232,  1994,     0,  1999,  1982,  2212,  2213,  2214,  2215,  2001,
       0,  1975,     0,  1980,  1984,     0,  1963,     0,  1960,     0,
    2255,  2187,     0,  2185,     0,  1950,  1951,  1952,  1944,  1945,
    1946,  1947,  1948,  1949,  1956,  2163,  2161,  2162,     0,     0,
       0,  2133,     0,     0,  1979,  2412,  2448,     0,  1699,  1699,
    1699,  1687,  1697,  2259,     0,  1831,  1708,  1831,  2265,     0,
       0,  1935,     0,  1812,   925,   926,   924,  1530,  1534,  1543,
    1557,  2189,  1551,  1682,     0,     0,  1532,  1555,     0,  1111,
    1112,     0,  1116,  2646,  2536,     0,     0,     0,     0,  1731,
    1765,     0,  1756,     0,  2279,  1732,  2278,  1733,  1736,  1737,
    1727,  1766,  1633,     0,  1761,  1666,  1665,     0,  1834,     0,
    1817,  1769,  1363,  1258,  1325,  1145,     0,  1880,  1156,     0,
    1140,     0,  1139,  1880,     0,  1157,     0,  1880,  1364,  1259,
    1326,   921,  1365,  1260,  1327,  1366,  1261,  1492,  1480,  1479,
    1478,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   789,  2420,   352,  1506,  1367,
       0,  1262,   348,  1507,  1328,  1511,   807,   806,     0,     0,
    1329,     0,   641,     0,   645,     0,   647,   648,   649,     0,
       0,     0,   650,     0,  2346,  2403,   652,   655,   656,   657,
     664,   669,   659,     0,     0,   671,   665,     0,     0,     0,
       0,     0,     0,   677,   682,     0,     0,     0,     0,     0,
       0,  1173,  1174,  1368,  1265,     0,  1330,     0,  1123,     0,
    1266,   171,     0,     0,   273,  2420,   292,     0,   684,   789,
       0,  1316,   289,   318,     0,   333,   328,   329,   327,  2420,
     352,  2420,   352,     0,     0,     0,     0,     0,   330,   325,
     326,   322,     0,     0,   335,  2321,  2387,  2550,     0,   688,
     690,     0,   695,   338,  1286,   359,   358,   357,     0,   342,
       0,   364,   367,   339,   319,   317,   314,   286,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2272,     0,     0,
    1215,     0,  1371,  1331,     0,  1353,     0,     0,     0,     0,
     729,  1374,  1272,  1334,     0,  1393,  1395,  1385,  1273,  1394,
     159,  1303,   148,     0,     0,   144,     0,     0,     0,     0,
     138,  1375,  1274,  1335,     0,     0,  1376,  1275,     0,     0,
     278,   582,   593,   598,  1280,   602,   599,  1343,   600,  1383,
    1276,     0,  1379,  1306,  1338,   565,  1386,  1402,  1277,  1194,
    1397,  1399,     0,  1314,     0,   267,   269,     0,   288,     0,
    1278,     0,  1336,  1378,  1305,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1514,     0,     0,     0,     0,     0,
       0,   352,     0,     0,     0,  1316,  2420,   352,  1377,     0,
    1311,     0,  1351,     0,     0,   385,     0,  1304,  1314,     0,
     280,  1282,     0,  1345,     0,     0,   217,   216,   218,     0,
       0,     0,     0,  2193,  2194,     0,  2191,  2046,  2248,     0,
     974,   932,   973,     0,  2385,     0,   931,   933,     0,     0,
       0,   934,     0,   938,   939,     0,     0,     0,   930,   928,
     929,   396,     0,     0,   746,   747,     0,     0,     0,     0,
     826,     0,     0,     0,  1504,     0,   135,   639,     0,     0,
       0,   634,   679,   684,     0,     0,     0,     0,   449,   453,
     457,   458,   459,     0,     0,     0,     0,   149,   136,     0,
     868,     0,   511,     0,   739,  1391,  1390,  1193,     0,   181,
     174,     0,     0,   700,     0,  1552,     0,     0,   363,   821,
     819,   818,   820,     0,     0,     0,   842,   817,     0,  1835,
    1837,     0,     0,     0,     0,     0,     0,   572,   452,     0,
       0,   514,     0,   553,     0,     0,     0,     0,   550,     0,
       0,     0,  2305,     0,   838,   810,  1134,     0,  1152,  1135,
       0,     0,     0,     0,  1187,  1119,  1188,  1165,  1120,     0,
       0,   611,  1653,  1654,     0,  1212,     0,     0,  1500,     0,
    1498,     0,  1879,  1892,   890,     0,  1920,  1919,  1921,  1921,
       0,  1863,     0,  1904,  1929,  1930,  1931,  1932,  1933,  1934,
       0,  1928,  1872,  1206,   352,     0,   352,     0,   352,  1214,
    1208,  1210,  1407,     0,   888,     0,     0,   352,   881,   883,
       0,   885,     0,     0,     0,     0,  1611,  1599,     0,  1771,
    1638,     0,  2252,  1031,   513,     0,     0,     0,     0,     0,
       0,  1042,   609,  1049,     0,  1063,  1058,  1060,     0,  1064,
     715,     0,     0,  1630,  1623,  1625,  1624,     0,     0,  1621,
    2196,   880,     0,   578,     0,     0,     0,     0,   352,     0,
    1065,     0,     0,   993,   987,     0,     0,   991,     0,     0,
       0,   994,     0,     0,  1704,  2197,  2198,     0,     0,     0,
    2236,     0,     0,  2085,     0,  2059,  2061,  2073,     0,  2086,
    2044,  2087,  2063,  2065,  2074,     0,     0,  2179,     0,     0,
    2076,     0,  2008,  2009,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2024,  2023,  2077,  2158,     0,     0,  2223,  2224,  2078,
       0,     0,  2230,     0,     0,     0,  2083,  2088,     0,     0,
       0,     0,  2094,     0,  2115,     0,     0,     0,  2034,  2189,
       0,     0,     0,     0,     0,     0,     0,     0,  2000,  1983,
    2003,  1977,     0,  1981,  1985,     0,     0,  2002,     0,     0,
    1971,     0,     0,  1969,  1995,  1965,     0,     0,  1996,     0,
       0,     0,  2052,     0,     0,  1699,  1699,  1699,  1699,  1696,
       0,     0,     0,     0,  2536,  2666,     0,  1795,  1770,  1772,
    1782,  1795,  1800,  1795,  2054,  1829,  2055,  2266,     0,  1741,
       0,  1741,   193,     0,   226,   213,  1529,  1683,  1686,  1711,
       0,  2180,  1116,     0,  1713,  1735,  1734,     0,  1724,     0,
    1763,  1721,  1634,  1618,     0,  1616,  1598,     0,  1880,  1137,
    1138,     0,  1161,     0,  1075,  1076,     0,  1074,     0,     0,
       0,   499,  1094,     0,     0,     0,   789,     0,     0,   503,
       0,  1509,     0,  1384,  1302,   643,   644,     0,   658,     0,
     667,   666,     0,     0,     0,     0,     0,     0,     0,   651,
     673,   615,   674,   676,     0,     0,   675,   678,   681,  1314,
       0,   713,  1288,     0,  1349,  1167,     0,     0,  1126,     0,
       0,     0,     0,     0,     0,   466,   313,     0,     0,     0,
       0,   372,     0,   294,   305,   370,   311,     0,   344,     0,
     316,     0,   309,   331,   323,   332,   324,   343,   345,     0,
     692,   693,   691,   687,     0,   694,   696,     0,   361,     0,
       0,     0,     0,  1370,     0,  1314,     0,   282,  1284,     0,
    1347,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1352,     0,     0,     0,     0,   734,     0,
     731,     0,     0,     0,   141,   140,     0,   147,     0,     0,
       0,     0,     0,     0,     0,  1403,     0,     0,     0,     0,
       0,     0,   379,     0,   287,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   386,   354,     0,   845,     0,     0,     0,   388,
       0,     0,  1362,     0,     0,     0,     0,     0,  1369,  1267,
    2049,  2050,  2047,  1708,  2247,     0,     0,     0,   945,     0,
       0,     0,     0,     0,     0,   399,   400,   135,   398,   421,
       0,   789,     0,     0,   823,   828,   836,  2482,  2166,  2167,
     834,   829,   831,   833,   835,   832,     0,     0,     0,     0,
       0,   482,     0,     0,     0,   472,     0,     0,  1194,   465,
     468,   469,     0,     0,   635,   638,   636,   637,   672,     0,
     452,   489,   540,     0,   151,     0,     0,   152,   150,     0,
       0,   363,   736,     0,   733,     0,   177,   448,     0,   704,
       0,     0,     0,  1194,   627,   758,   761,   754,     0,   841,
     843,   815,     0,   684,     0,     0,   584,     0,   511,  1590,
     567,     0,   542,   452,   540,   549,     0,     0,   557,   362,
       0,     0,   572,   363,     0,     0,  1095,     0,   837,     0,
    1133,     0,     0,     0,  1184,  1189,  1185,     0,     0,  1148,
       0,  1186,  1166,  1423,  1424,  1421,  1422,     0,     0,     0,
    1645,     0,     0,  1496,     0,  1898,     0,  1916,  1914,  1859,
    1864,  1937,   892,     0,   875,     0,   877,   352,   723,     0,
     624,   352,     0,  1603,  1605,  1604,     0,     0,  1606,  2252,
       0,  1616,  1643,     0,     0,  1834,     0,  1642,     0,     0,
       0,     0,     0,  1041,     0,  1061,     0,     0,  1024,  1067,
       0,     0,  1628,  1626,   570,     0,  1246,  1247,  1070,     0,
    1025,  1069,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2201,     0,  2238,  2234,     0,  2056,  2202,     0,     0,
    2218,  2217,  2159,     0,     0,  2007,  2019,  2020,  2021,  2219,
       0,  2029,     0,     0,  2016,  2017,  2018,  2010,  2011,  2012,
    2013,  2014,  2015,  2022,  2228,  2227,  2221,  2222,     0,  2080,
    2081,  2082,  2229,  2089,     0,  2336,  2116,     0,  2093,  2109,
    2108,     0,     0,     0,  2096,     0,     0,  2105,     0,  2160,
    2287,  1941,     0,     0,  1968,  2233,  1986,     0,     0,  2004,
       0,  1964,  2179,     0,     0,     0,     0,     0,  1973,     0,
       0,     0,  2136,  2131,  2132,  2156,     0,     0,     0,     0,
       0,     0,  1690,  1689,  1695,  1795,  1800,  1795,     0,     0,
    1668,     0,  1782,     0,  1794,  1780,  1793,     0,     0,  1806,
    1804,     0,  1806,     0,  1806,     0,  1774,     0,  1796,  1776,
    1793,  1778,     0,  1821,  2267,  1830,     0,  1754,  2046,  1754,
       0,     0,     0,  1712,  1114,  1115,  1722,     0,  1725,  2365,
    1832,     0,  1617,  1158,     0,     0,  1150,  1081,  1082,  1085,
    1083,  1080,  1084,     0,     0,     0,   789,     0,     0,   521,
       0,  1108,  1108,     0,     0,   505,   562,   516,   792,     0,
       0,     0,   790,   352,  1263,     0,   668,     0,     0,   663,
     661,   660,   662,     0,   616,  1382,  1264,     0,     0,     0,
       0,  1168,  1317,     0,     0,  1287,     0,   291,     0,   462,
       0,     0,   297,   306,     0,   302,     0,  1315,     0,     0,
       0,     0,   301,   374,     0,   371,     0,   352,   352,   346,
     689,   360,   365,   366,   369,  1322,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   869,
     852,     0,     0,   870,   871,     0,     0,     0,  1217,  1218,
    1216,  1354,  1355,  1360,  1357,  1356,  1359,  1361,  1358,     0,
    1270,     0,     0,   727,  1318,   145,   142,   143,   146,  1319,
    1300,  1281,  1344,   566,  1398,     0,     0,     0,  1279,     0,
    1337,     0,  1296,  1290,     0,     0,     0,     0,     0,  1381,
    1310,  1342,  1380,  1308,  1340,  1307,  1339,  1309,  1341,  1301,
       0,     0,  1839,   849,     0,     0,     0,   352,   352,   848,
     725,  1283,     0,  1346,  1292,     0,     0,     0,   935,     0,
       0,   937,   940,     0,   942,   404,   422,   135,     0,   745,
     809,     0,     0,   825,   788,     0,   470,     0,   476,   480,
       0,     0,   484,   485,   483,   471,  1194,   511,   561,   778,
     779,     0,     0,   799,     0,   633,     0,   450,     0,   486,
       0,     0,   454,   154,   153,     0,     0,     0,   740,   744,
     742,   741,   743,   738,     0,   729,   181,  2420,     0,     0,
       0,     0,   563,  1396,     0,   771,   816,     0,  1838,   719,
       0,   363,   580,     0,     0,     0,   450,   572,     0,   455,
     460,   461,   466,     0,   550,   541,     0,   542,   551,   552,
       0,   559,  1471,     0,   573,   559,     0,     0,     0,   840,
       0,   839,  1136,  1153,  1154,     0,     0,  1117,     0,     0,
       0,     0,   618,   352,     0,  1499,  1860,   352,   352,  1243,
       0,   886,     0,     0,     0,  1608,  1614,  1595,     0,     0,
    1639,  1616,  1640,  1055,  1056,  1057,  1054,  1053,   610,     0,
    1059,   717,     0,   571,   352,     0,  1001,   979,  1000,   978,
     980,     0,   982,   983,   977,   975,   976,  2237,  2072,  2075,
    2084,  2216,  2158,  2189,     0,     0,  2030,     0,     0,  2079,
    2656,     0,     0,  2120,  2121,     0,  2117,  2118,  2113,  2114,
    2095,     0,  2471,  2100,     0,     0,     0,  1992,  1990,  1987,
       0,  1988,  1972,     0,     0,  1970,  1966,     0,  1997,  2122,
       0,  2138,  2135,  2155,  2189,  1694,  1693,  1692,  1691,  1781,
    1777,  1779,     0,  2661,     0,  1784,  1791,     0,  1773,     0,
    1805,  1801,     0,  1802,     0,     0,  1803,     0,     0,  1775,
       0,  1791,     0,  1828,     0,     0,  2127,  2284,  2127,   227,
    1681,     0,  1723,     0,  1615,  1151,  1159,     0,     0,     0,
     501,     0,   516,     0,     0,     0,  1101,  1110,  1100,     0,
     516,     0,  1194,   794,   793,   796,   791,   795,  1510,     0,
     653,   654,   670,  1289,     0,  1350,  1298,     0,  1632,   293,
       0,   685,   300,     0,     0,     0,   295,   373,   375,   296,
     299,   303,   354,   315,   308,     0,     0,     0,  1285,     0,
    1348,  1294,  1321,  1372,  1268,  1332,     0,     0,   858,     0,
       0,     0,     0,  1373,  1269,  1333,     0,     0,     0,     0,
    1632,     0,     0,     0,     0,     0,     0,     0,     0,  1519,
       0,     0,   353,   847,   846,   354,   387,  1312,     0,  2048,
       0,   936,   943,   944,   941,     0,   393,   401,   404,     0,
       0,  1234,  1234,     0,   789,     0,     0,   467,   481,     0,
     561,   520,     0,   473,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   732,   731,
     176,     0,   450,     0,   684,     0,   765,   766,   760,   762,
       0,   773,   777,   844,     0,     0,     0,   572,   452,     0,
       0,  1587,   451,     0,     0,   463,     0,   553,   542,   550,
       0,     0,   569,     0,  1464,     0,   575,     0,     0,     0,
    1190,     0,  1196,     0,  1147,  1191,     0,  1831,     0,     0,
       0,     0,   622,  1235,  1497,   876,   878,   724,  1600,     0,
    1601,  1607,     0,     0,     0,     0,  1644,  1636,  1062,     0,
    1066,   352,   981,  2160,  2025,     0,     0,     0,     0,  2090,
       0,  2091,  2119,  2097,  2101,     0,  2098,  2099,  1989,  1993,
    1991,  1974,  2124,     0,  1708,  2157,  1824,     0,  1827,     0,
       0,  1783,     0,     0,  1785,     0,     0,  1787,  1789,     0,
       0,     0,     0,     0,     0,  2270,  2364,  2629,  2533,     0,
    1740,  1742,  1745,  1747,  1746,  1748,  1744,  1753,     0,  1670,
    1669,  2181,  1833,  1063,     0,   352,  1108,  1194,   522,  2482,
     523,  1107,  1109,  1113,     0,  1194,     0,   561,   646,     0,
       0,   275,   683,     0,     0,   298,   307,   356,   368,     0,
    1632,     0,     0,   856,   865,   865,   853,     0,     0,   872,
    1271,   728,     0,     0,   270,  1297,  1291,     0,     0,     0,
    1521,  1522,     0,     0,     0,     0,     0,  1320,   352,  1293,
     946,     0,   424,   431,   405,   409,  1513,     0,  1513,     0,
     406,   410,  1513,  1513,   403,  1831,   420,  1234,     0,  1231,
    1230,   787,     0,   509,   586,     0,   474,     0,   531,     0,
       0,   800,     0,     0,   452,   540,     0,   498,   490,   491,
     492,   494,   493,   495,   496,   497,   488,   487,     0,   684,
     862,   363,  1471,   726,     0,     0,   697,     0,   763,   768,
     767,  1513,   772,     0,     0,     0,   684,     0,  1590,   568,
     542,   452,   540,   456,   466,     0,   557,   550,   553,     0,
     554,     0,   558,     0,     0,     0,   572,  1523,  1095,     0,
    1096,  1195,     0,     0,     0,     0,     0,     0,  1238,   617,
       0,     0,   621,   612,     0,     0,     0,     0,  1641,   684,
    1026,  2026,     0,  2027,     0,     0,  2103,  2102,     0,  2142,
    1829,     0,     0,  1823,     0,     0,  1853,     0,     0,     0,
    1792,  1808,     0,  1788,  1786,     0,  1797,     0,  1799,     0,
       0,     0,  1749,     0,  2126,  2128,     0,  1077,     0,  1078,
    1102,   561,     0,  1113,  1116,   511,   561,     0,   789,  1299,
       0,   686,   586,     0,   310,     0,   283,  1295,     0,     0,
     867,   867,     0,     0,     0,     0,     0,     0,   381,     0,
       0,  1515,     0,  1516,  1517,  1520,   389,   402,     0,   429,
       0,   427,   426,   428,     0,   417,     0,     0,     0,     0,
       0,     0,   392,  1229,  1233,  1232,     0,     0,   475,     0,
     477,     0,   517,   518,   519,     0,   479,   527,   528,     0,
     797,     0,   802,     0,     0,     0,   684,   539,   708,     0,
       0,     0,  1465,     0,     0,   564,     0,   774,   775,   770,
       0,     0,   720,  1471,   572,   550,     0,   542,   464,     0,
     559,   553,   557,   555,   556,     0,  1468,     0,   574,     0,
    1104,     0,  1118,  1197,  1192,  1427,     0,     0,   620,   619,
       0,  1613,  1831,  1610,     0,   714,  2028,  2106,  2092,  2104,
    2137,     0,     0,     0,     0,  1822,  1825,     0,  1856,     0,
       0,     0,     0,  1842,     0,  1790,     0,     0,  1798,     0,
       0,     0,  1743,     0,     0,     0,   526,     0,  1116,  1098,
     520,   789,   515,   502,  1632,   304,   355,     0,     0,     0,
     863,   866,   854,   855,   874,   873,   730,  1632,     0,   377,
     376,     0,   380,     0,   425,   434,     0,   432,   407,   412,
       0,   416,   414,   413,   408,   411,     0,   508,     0,     0,
       0,     0,     0,   529,     0,   530,   560,     0,   801,     0,
       0,     0,   710,   861,     0,     0,   450,   684,   764,   769,
       0,     0,  1466,  1588,   553,   542,   550,     0,     0,   544,
    1108,  1108,   437,   557,   559,  1469,  1470,     0,     0,   363,
    1097,  1426,  1425,  1686,     0,     0,  1602,  1612,     0,  2616,
    2365,  2588,     0,  2154,  2143,  2154,  2154,  2134,     0,     0,
    1854,  1855,  1840,     0,     0,  1844,  1807,  1820,  1751,     0,
    1750,  2129,  2130,   352,     0,   789,   524,  1099,   531,   504,
     276,  1632,   857,     0,   271,     0,   382,  1518,   430,     0,
     415,   777,   585,   478,   536,     0,   535,     0,   533,   532,
     798,   803,     0,   684,   851,  1471,   698,   776,     0,   557,
     550,   553,     0,   543,     0,  1110,  1110,   559,   435,     0,
       0,   559,  1409,  1686,  1408,  1410,  1418,  1415,  1417,  1416,
    1414,  1241,  1242,  1831,     0,  2147,  2146,  2145,  2149,  2148,
       0,  2141,  2139,  2140,  1826,     0,  1843,  1846,     0,     0,
       0,  1852,  1845,  1847,     0,  1818,  1752,  1079,     0,   506,
     789,   284,   864,     0,   433,     0,   534,   538,   537,   684,
     709,  1467,   782,   559,   553,   557,  1108,   545,  1109,   547,
     546,   439,  1104,  1105,     0,  1831,     0,  1419,  1413,  1668,
    1655,     0,     0,  1609,     0,     0,  2151,     0,  2152,     0,
    1849,  1850,  1851,  1848,     0,     0,   507,     0,     0,   711,
     784,     0,   780,   783,   785,   786,   438,   557,   559,  1110,
     363,  1103,     0,  1086,  1411,  1686,     0,     0,  2144,  2150,
    2153,     0,     0,   525,   378,     0,   748,     0,   559,   436,
     548,   559,  1106,  1412,     0,     0,     0,  1819,     0,   781,
     440,  1831,     0,     0,  1841,   782,  1087,     0,     0,     0,
    1239,  1240,   749
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -4944, -4944, -4944,  3844, -4944, -4944,  -902,   368,  3058,  -980,
   -4944, -4944, -4944,  1345, -4944, -4944, -4944, -4944,  3792, -4944,
    2141, -2457, -4944, -4944,   150,  -385, -1318,   134,  3325,  1790,
   -4944, -1147, -4944, -4944,  -573,   222, -4944,  -381,   548, -4944,
   -4944, -4944, -4944, -4944, -4944, -4944, -4944,  -809,  2266, -4944,
    2342,  1623,  -273, -2918, -4944, -4944, -1461, -3259, -4944,   929,
   -4944,   951, -4244,  -595, -4944, -4944, -4944,  2244, -4944, -4944,
   -4944,  2187,  1420,   -36, -4944, -4944, -4944, -4944, -4944, -4944,
    -444, -4944, -4944,  -694,   152,    43, -2480, -3791, -4944, -4944,
     784,   -85, -1442, -4944, -3615, -4944,   304, -2224, -4944, -4944,
   -4944,   -53, -1416,  1722, -4944,  -709, -1124,  2028, -4175,  -554,
   -4944,    74, -4944,  -670,  -459,  -457,  -590, -3827, -4320, -4944,
   -4944,  -701, -3249, -4589, -4790, -4330, -4460,  1733, -4944, -4944,
     158, -3179, -3274,   161,   756, -4944,   163,   164, -4944,   768,
    -394,  -919, -1562, -4944,  -869, -4944, -4944, -4944, -2954, -4944,
   -4944, -4944, -4944,    97, -4944, -4944, -4944, -4944,   817, -4944,
   -4944, -4944, -4944, -4944, -4944, -2688,  2203,  2208, -4944, -3214,
   -4944,  -877, -4944,   972, -2989,  1645, -4944, -4944,  1411,  3823,
     806, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -1743, -4944,
   -4944, -4944, -4944,   308,   -19, -4944, -4944, -4944, -4944, -4944,
   -4944, -4944,   165, -4944,  2234,  1418, -4944, -4944,   -27, -4944,
   -4944, -4944, -4944, -4944, -4944,  -645, -4558,  -807,  -787, -4944,
   -2975, -4944, -4944, -4944,     7, -4944, -4944, -4944, -4944, -4944,
    -864, -4944,  1470, -3630, -4944, -4944,   785, -4944, -4944, -4944,
   -4944, -4944,  -559,    69,  2988, -4944,  -165,  -359, -4944, -4944,
   -4944,    71, -4944, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -1071,  9954,  -819,  -577, -4944, -4944, -4944, -4944, -4944, -2232,
   -4944, -4944, -4944, -4944, -3751, -4944,  4747,  2252,  1695,   167,
   -4944,   -29,    62,  3578, -1165, -2662,   729,  -126, -4944, -4944,
   -4944, -2591, -4944, -4944, -4944, -4944, -3555,   169, -4944,  -680,
   -4944, -3844, -4629, -4025, -3593,  -714, -4944, -4943, -3660, -4549,
   -3565, -4944, -4944, -4944, -4944,  -548,  -155,  2952, -4944, -1413,
    2584,  -936, -4944, -2100,   801,  1818,  2958, -2762,  -137,  2948,
   -2543,  -672, -3281, -4944, -4944, -2295,  -265, -4944, -4944,  1388,
     648, -4944, -4944, -4944, -4944,  -636,  2892,  -181, -4944, -4944,
    4120, -4944, -4396, -4944,  4089, -4944, -4944, -4944, -4944,  2803,
    2807, -4944,  2808, -4944, -4944, -1387,  1570, -4944,  -778, -4944,
   -4944,  2348,  1010, -4944, -4944, -4944, -4944, -4944, -4944, -4944,
   -4944,  1468,   992, -4944, -4944, -4944, -4944, -4944,  -546,  -727,
   -4944, -4944,   173, -4944, -4944, -4944, -4944,  2265,  -891,  -734,
    4002,   865,   179, -4784, -4944, -4944, -1109, -4944,  3367, -4944,
   -4944, -4944, -4944, -4944,   807,   809, -4944, -4944, -4944, -4944,
   -2768, -4944, -4944, -4407, -4944, -4944, -4944, -4944, -4944,  3993,
     110,  2691, -4944, -4944, -4944,   -28, -4944, -4944,  -977,  2682,
   -4944, -1938, -4944,  -592, -4944,  2887, -4944, -4944, -4944, -4944,
   -1903,   181, -3820, -4944,  -621, -4944,  2880, -4944,    -4, -4944,
     316, -4944, -4944, -3798,     6, -4944, -4944, -4944, -4944, -4456,
   -4944,  -615, -4944,  -535,   792, -3313, -4944,   182,    -5, -4944,
   -4944,    12,  4746,   -43,   -60,   -52,     5,   103,  3452, -4944,
     183,  3498, -4944,    18,  1693, -4944, -4944,  -818,  -168, -4944,
    1910,  -635,  2656,  3433,  3435, -4944,  1905,  2693, -1985, -1966,
   -4944,  1199,  -419,  -258, -4944, -4944, -4944, -4944,   651,  -634,
    2676, -4944,  3477, -4944, -4944, -4944, -1993, -2867, -3504,  1221,
   -3482, -3396,   686,   670, -1638,   -25,    25,  -761,  -825, -4944,
   -4944,  1234,  -223, -4944, -4944,  -221, -2829,   827, -4944, -4391,
   -2342,  1242,  -681,  -505, -4944,  -591, -4944,  -380,  5927,  3016,
   -1052, -4944, -4944, -1008, 13625, -4944, -4944, -4944, 14302, 14996,
   -4944, -4944, 15670, 15916, -4944,  -828, 16287, 13713, -1032, -1898,
    -406, 12947, -1860,   186,   247, -4944, -3288, -1644, -4944, -4944,
   -4944,    24,  1301,   251, -4944, -4453, -3877, -4944, -4944,   252,
   -4944,  -388, -4944,  -382, -4944, -4944, -4944, -2489, -4158, -2606,
    2801, -4944, -4944, -4944,  -182, -4944, 16946, -2772, -4944,  -606,
   -1312, -1547, -3479, -1913, -4944, -4944, -4944, -2651, -4944, -4944,
   -4944, -4944, -1737, -3352,  -475,  2014, -4944, -4944,  2114, -4944,
   -4944, -4944,  -944,  2402,  -773, -2685,  2025, -4944,  -768,  2806,
    -777, 11908,  -698,  9047,  -532, -2277, -1265, -1660, -4944,  3602,
   -4944,  5642,  5594,     0,  -120,   856,  -632,    -6, 12648,  -651,
    -300,  3762, 11283,  9952, -3171
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    53,    54,    55,    56,    57,  1550,  2531,  2382,  3317,
    3318,    58,    59,  1546,    60,    61,    62,    63,  1460,    64,
    1032,  1795,  2546,    65,  2215,   814,   815,   816,  2117,  2118,
    2470,  2119,  2107,  1346,  1937,  1482,   788,   789,  1442,  1483,
      67,    68,  1340,  2098,    69,    70,    71,  1513,  1603,  1514,
    1515,  1454,  1842,  4372,  5124,  3109,  2344,  3365,  3110,  3111,
    3744,  3745,  3824,  5138,  5139,    72,  1619,  1620,    73,    74,
    2512,  3282,  3877,  4736,  4737,  4974,   623,  4397,  4398,  4961,
    4962,  5152,  5296,  5297,  2547,  1787,  3360,  3962,  3308,  4468,
    3309,  4469,  3310,  4470,  3294,  3909,  3910,  4411,  3911,  3311,
    4429,  5006,  3312,  2234,  5168,  2588,  1961,  1959,  4652,  4988,
    4228,  4229,  5385,  5176,  5177,  5178,  5408,  4431,  4474,  4475,
    5338,  5339,  3363,  3968,  4481,  4802,  4753,  2995,    76,    77,
     719,  1821,  3483,   720,  2591,   657,   721,  2548,    82,  2581,
    5170,  2582,  1576,  2396,  3890,  3463,    83,  1058,  3710,  4822,
    5062,  5063,    84,   227,    85,  1803,    86,    87,  2526,  3301,
      88,  2251,  3012,    89,    90,  3043,  3044,  3045,    91,  3735,
    4670,  1516,  3098,  3099,  3100,  3101,  3765,    92,  1798,  2555,
    2556,    93,    94,    95,    96,  2710,  2711,    97,  2456,    98,
      99,   100,   101,  3800,  4333,  4445,  3140,  3324,  3934,  4443,
     102,  3286,  2549,  1811,  2571,  2572,  4455,  4778,  4779,  4780,
    5021,  5328,  4782,  5023,  5199,  5025,  4421,  5521,  5522,  4744,
    3689,  4242,   104,  4422,  4423,  5183,   105,  2249,   106,   107,
    1771,  2518,  2519,  3891,  2598,  3373,  3374,  3948,  3949,   108,
    3224,   109,  4309,  4310,   658,  5190,  5130,  5282,   110,   111,
    4313,  4314,   112,   113,   114,   115,   116,   711,   712,   713,
    1149,  1150,  2967,  1097,   117,  2127,   118,   995,   996,  3261,
     119,  1232,  2756,  2757,  4537,   120,   745,  1171,  1172,  2550,
     122,   754,  2730,   756,  1976,  3465,  3466,  4048,   123,   124,
    2707,  2733,   125,  1447,  2225,  2226,  4223,  2551,   659,  1217,
    2595,  2990,  5049,  4646,  5050,  5349,  5494,  4647,  4913,  2922,
    3654,   127,   660,  1488,  2301,  1117,  1118,  2601,  3377,  2194,
    2195,  2196,  3988,  2197,  3379,  2198,  1420,  2199,  1068,  1069,
    3385,  3386,  3387,  3984,  3991,  2540,  4812,  4813,   128,  1485,
    2298,   129,   130,   131,  1529,   907,  1127,  1128,   132,   672,
     673,   133,  4979,   134,  1071,   135,  4820,   136,   137,   779,
     780,  1214,  1215,   138,   139,  2315,  3747,   140,  1486,   141,
     142,  3134,  3135,  4325,   143,   144,   145,  1790,  1791,   146,
     147,  3189,  3190,   148,   149,   150,  5434,  5496,  5497,  5498,
    3997,  5353,  5436,  1202,   152,   153,   154,   191,   948,   949,
     950,   860,  2552,  4804,   156,   157,  1443,  1444,  1445,  1446,
    2220,   158,   159,   160,  3399,  3400,   161,   162,   163,   164,
    1775,   165,   166,  4952,   167,   168,  1736,   169,   170,  1369,
    1370,  1371,  1372,  2132,  2910,   617,   832,  1375,  1381,  1386,
    1387,  1388,   172,   723,  1163,  1164,  1165,  1939,   173,  1210,
     999,   724,  1158,   175,   725,   176,  2178,  3446,  4026,  4027,
    4028,  4031,  4834,  4212,   726,  2948,   178,  1983,  2716,  2719,
    2944,   727,   179,  3449,  3450,  3451,  4033,   728,   747,  1061,
    2608,   729,  1307,   183,   184,   185,   841,   835,   836,  2915,
     730,  2091,  2891,   763,  1392,   801,   802,   850,  2480,  2144,
    2145,  2169,  2170,  1401,  1402,  2157,  2161,  2162,  2935,  2928,
    2150,  4197,  4890,  4891,  4892,  4893,  4894,  4895,  4626,  2165,
    2166,  1404,  1405,  1406,  2174,   188,  2895,  3628,  3629,  3630,
    4174,  4175,  4189,  4185,  4611,  4877,  3631,  1200,  1412,  4619,
    5465,  3632,  4866,  4867,  5083,  4193,  3639,  3665,  3348,  3349,
    3350,  3633,  5252,  5253,  5462,  5463,  5085,  5086,  2200,  1872,
    1099,  1308,  1100,  1884,  1309,  1856,  1102,  1310,  1311,  1312,
    1105,  1313,  1314,  1315,  1108,  1848,  1316,  1317,  1866,  1881,
    1882,  1376,  5087,  1319,  1320,  1321,  3635,  1322,  4127,  4575,
    4561,  2817,  2818,  2114,  4123,  3570,  4117,  2086,  2881,  4899,
    5104,  5105,  3612,  4153,  4591,  4864,  5244,  5363,  5364,  5451,
    1323,  1324,  1325,  2878,  2082,   910,  1326,  3893,  2084,  2811,
    1644,  1645,  1986,  2008,  2763,  2779,  2780,  2855,  2791,  3529,
    2799,  2804,  3557,  3558,  2812,  2841,  1327,  2765,  2766,  3511,
    2010,  1328,   954,  1648,   955,  2005,  2836,  1336,  1329,  1330,
    1977,   825,  4873,  1153,   866,  3126,  1728,   957,   760,  1331,
    1332,  1333,  1334,  1522,   881,  1120,  1121,   614,   606,   883,
    3102,   615,   608,   609,  1733
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     605,  1000,  1026,   612,  1575,   186,   177,  1002,   793,   840,
     664,  1734,   181,  2409,  1152,  1642,   851,   757,  1936,   759,
    1064,  1521,   749,   765,   909,   908,   186,  1341,   749,   782,
     790,   757,  2233,   797,  1337,  1407,   790,   790,  1624,   826,
    1862,   829,  1191,  1192,  1193,  1426,   874,  1580,  1197,  2339,
    3307,  1892,  2310,  1367,   914,   861,   656,   919,  1636,  3388,
    1800,  1998,  1133,  1868,   827,  1958,  1368,  1166,  3641,  3488,
     824,  2576,  1852,  1853,  2302,  2483,  1146,  1355,  2311,  3944,
    3663,  3128,  1861,  3960,  2722,   755,  3330,  4203,  3716,  3918,
    4230,   917,  2474,  2762,  3736,  2960,  2962,  1011,  1062,   794,
    1218,  3221,  2897,  1489,  3992,   939,  3760,  3992,  3762,  1773,
     171,  1517,  2322,  1778,  1574,   710,  3469,  4140,  1782,  3973,
    4269,  3895,  4171,  1602,  4225,  1160,   853,  3187,  1792,  4428,
    1143,   722,  4488,  1629,   854,  4032,  1539,  4477,  3578,  4467,
    4293,  1556,  1816,   845,  1131,  2436,  2437,  1135,  1073,  3652,
    4188,  4870,    75,  2826,   838,  4806,  1064,  4799,    78,  2293,
    2206,    79,  1785,    80,    81,   103,  2596,   121,  2796,   126,
     787,  1846,  4476,   151,  2659,  2937,  3957,   821,  1813,   155,
    1373,   174,   180,   187,  4760,  1367,   605,   864,   864,   867,
    2907,   864,   813,  1373,  3667,   876,  2940,   826,  4992,  3595,
     911,  2916,  1484,   876,  5066,  4106,   876,  4648,  5036,   826,
   -1913,   864,  4921,  2432,   826,  1400,  1403,   731,   864,  2293,
     826,   621,    66, -2405,  2448,  2130,  1812,  1377,  5192,  4882,
   -2443,  4884,  4798,  4517,  1348,  4186,  2293,  4191, -1880,  4566,
    2463, -2466,  1484, -2503, -1893,   932,  5210,  1484,  1852,  1853,
    1849,  1850,  4645,   603,  4944,  1868,  3320,  3266,  2443,  3267,
    1456,  1860, -2305,  3271,  2125,  3273,  3274, -2277, -2306,  1861,
    3535, -2305, -2305, -2333,  3278,  3279,  3280, -2306, -2306,  3297,
    2104,  2537,  1518,   670,   731,  1839, -2408, -1918,   731, -2672,
    4986,  2834,  1883, -1908,  1769,  1764,  1938,   731, -2672, -2672,
    2323,  1173,   670,   670, -2276,   670,   830,  3982,   670,  3246,
    4954,  4955,  4539,  4540,  1177,  4542,  4543,  4544,  4545,  4546,
   -1921,  5129,  2054,  4656,  2313,  2472,  2473,  3509,  1874,  3038,
    2313,  2217,  4984, -1921,  2430,  1518,  3006,  -135,  2693,   670,
    3818,   731,   872,  -135,  1942,  3473,  4980,  4489,  5458,   848,
     670,  2060,   731,   859,  2089,   944,  3717,  2510,   670,  3475,
   -2274,  2529,  2964,  2585,  5114,  1839,  3211,  3535,  3426,  1457,
    3428,  1826,  1839,  4306,  4464,  5076,   848,  5233,  4179,  2585,
    1839, -1737,  1204,  2062,  2151,  1203,  3298,  4054,  2586,   737,
    2399,  2105,  2236,  4419,  4920,  4231,   737,  5425,  5426,  4465,
    1045,  1875,  1633,  2834,  2586,  3212,  4943,   737,  1839,   737,
    3039,  4180,  2141,   738,  4311,  1456,  1345,  1849,  1850,  5332,
     738,  5043,  5344,  1734,  2942,  2148,  4614,  2152,  4272,  5044,
    2288,   738,  2708,   738,  1530,  1046,  4182,  4204,  3213,   737,
    3822,  2096,   616,  2054,  1860,  5019,  2330,  4024,  4761,  5212,
    2054,  2919,   737,   945,  1548,   616,   909,  5118,  2112,  5459,
    3215,  4273,  1876,   738,  1636,  1877,   618,  4907, -2464,   670,
    1047,  2313,  2060,  1839,  5126,  4915,   738,  1549,  5037,  2060,
    2331,  2314,  3535,  4025,  2108,  4307,  1087,  3823,   844,  2120,
    2120,  5020,  5097,  3216, -2164,  4762,  1064,  1900,  2573,  4205,
    2113, -2164,   946,  2131,  2062,  2875,  1531,   909,  2106,  2393,
    2097,  2062,  2876,  2126,  1064,  2227,  1020,  2709,  1048,  1890,
   -2183,  2149,  1030,  2289,  1457,  2400,  4312, -2183,  2401,  2313,
    2943,  1890,  1989,  2228,  2048,  1044,  2920,  2154,  2313,  4055,
    4420,  4274,  5234,  5529,  1594,  1734,  2313,  1593,  1227,  1839,
    2530,  1929, -1737,  5427,  4184,  2313,  2478,  2313,  1839,  1770,
     947,  2313,  2094,  1978,  5268,  1840,  2965,   952,  3474,  2966,
     671,   953,  3486,  3299,  1920,  1940,  1878,  2587,  1634,  1988,
    1064,  5163,  3476,  3249,  2177,  5077,  3042,  2449,  4466,  3942,
    4308,  2229,  5045,  4772,  2694,  1999,  2280,  2155,  2511,  3895,
    2894,  2412,  1458,  2239,  5017,  2324,  2287,  3883,  5460,  2732,
    2230,   958,  3260,  5461,  3717,  1770,  2450,   826,  2325,   864,
    2326,   864,  5343,   867,  4328,   864,   831,   186,  1001,  5483,
     873,  5481,   911,  -423,  1003,  2090,  4985,  1033,  2764,   864,
    4657,  3007,  2835,  5331,  1847,  1840,   864,  1528,  2538,  3247,
    2444,  5266,  1840,  1729,  2278,  2431,  5271,   622,  2002,  4580,
    1840,  3819,  3300,   952,  2522,  1459,  1982,   953,  2404,  3983,
     605,  2407,  4437,  4608,   867,   840,  1770,  4612,  2574,   876,
    2377,  2327,  2137,   911,  4188,  1408,   876,  1879,  1840,   876,
    4852, -1913,  3411,  2394,  1167,  5528,  2397,  2398,  4484,  1064,
    2047,  1642,  1642,  1642,  2414,   864,  1880,  1064,  1064, -2464,
    5205,  4235,  3682, -2405,  4485,   994,  2355,  1841,  5429,  1851,
   -2443,  1064,   186,  4837,  2772,  1855,  1229,   670,  2425,  4551,
    1635, -2466,  1170, -2503,  1175,  5293,  1179,  5548,   665,  4459,
    3550,  1186,  1183, -2305,  2471,  5419,   952,  2356, -2277, -2306,
     953,   743,   744,  1840,  3601,  1519,  1520,   826,  2231,  1159,
     790,   790,   790, -2333,   743,   744,  1863,  4037, -1918,  4599,
   -2672,  4601,  2175,  2176, -1908,  1219, -2408,  2102, -2464,  1863,
    2896,   853,  1548,  2050,  2092, -2276,  2900,  1864,  1199,   854,
    4842, -2464,  2081,   909,  1751,  1335,  1335,  1869,   826,   790,
    1864,  1865,  1430,   790,  1887,  1549,  3895,  2182,  1519,  1520,
    -135,  -135,  1898,  2297,  1867,  1016,  1746,   826,  5390,   743,
     744,   826,  1753,  1739,  1870,  1754,  2479,  1335,  1162,  1840,
    2773,  5394,  5485,  2682,  3547,  3548,  3549,  3550,  1840,   826,
    1922,  1052, -2164,  3957,  1888,  2575,  3875,  3876,   186,   177,
    2663,   826,  1199,  2877,  1899,   181,  5368,  4795,  1902,  3669,
    2462,  3670,  1905,  2227,  1907,  3066,  2297,   826, -2183,  3047,
    1915,  2232,  3936,  1196,  4078,  2637,  1923,  3122,  2492,  1926,
    5342,  5110,  1411,  2297,  1431,   826,  3854,  5336,  4257,  3048,
     864,   864,  4298,  2692,  3815,  5527,  2364,  1196,  1463,   773,
     787,  1205,  1207,  2774,  2704,  1925,  4400,  4438,  2712,  4215,
    2078,  2079,  2080,  2081,  2135,  2076,  2077,  2078,  2079,  2080,
    2081,  1357,   790,   790,  2240,  4034,  4399,  1890,  1770,  2135,
    3105,  3256,  1874,  3532,  3533,  5471,  1432,  1378,  3552,  2229,
    5320,  2937,  2971,  4396,  1448,  1335,  1335,  3545,  3546,  3547,
    3548,  3549,  3550,   171,   605,  1344,  5310,  1608,  2230,  1352,
    5545,  3657,  5335,  3284,  2775,   876,  3123,  2776,  3912,   911,
    1114,   876,  3646,  1744,   876,  3582,  3583,  3114,  2293,  2860,
    1839,  1890,  1053,  3106,   670,   774, -1880,  1804,  1981,   864,
    4047,  4818,  3869,  3870,  2241,    75,  4464,  5030,  4439,  1609,
     670,    78,  5509,  3644,    79,  1875,    80,    81,   103,  1909,
     121,   826,   126,   666,  5428,  5420,   151,  3738,   864,   864,
    2409,  4465,   155,  4326,   174,   180,   187,  4832,  2500,  1805,
    2619,  2620,  2713,  1433,  3020,  3704,  3868,   846,  3712,  1540,
     826,   826,   826,  5164,   864,  4502,   605,   605,   605,  2376,
    4230,  1910,   855,  1449,  5039,  4928,  5404,  3658,   882,  2981,
    2424,  2759,   787,  1205, -1880,    66,  1876,   918,  5040,  1877,
    2501,   667,  2054,  2979,  3477,  4452,  3993,  3705,  2777,  4847,
    3107,   940,  1414,  4440,  4713,  3965,  3138,   189,  1441,  2567,
    5197,  1808,  1469,  2216,  3770,   928,  3638,  5491,     3,     4,
    3785,  5495,   847,  1017,  1734,  4874,  2231,  3771,  4714,   668,
    4878,   669,  1809,  4880,  2589,  2861,   864,  4426,   864,   864,
    2862,  3925,  5198,  4871,   929,  1729,  3739,  1237,  1188,  1054,
    3535,   190,   670,  2062,  3536,  3537,  3538,   856,  4355,  1862,
    4034,  1770,   855,  2242,   775,  2982,  3443,   758,  1541,  5060,
    1734,  1335,   635,  5526,  3478,  1832,  1642,  2863,  4414,   716,
    3139,  3994,  1358,   826,  3285,  1055,  3219,  1944,  5185,  1946,
    1610,  1948,   186,  1950,  2568,  1952,  1953,  1954,   848,    15,
    1878,  3115,  1956,  1960,  1960,   776,   777,  3378,   826,  2778,
     757,  5165,  3892,  4791,  1411,  2701,  2702,  1438,  5549,  1439,
    1806,  5444,  4785,  5184,  5219,  5207,  4836, -1736,  5204,  3786,
    5326,   826,   637,    20,  1450,  5477,  3992,  1995,  5560,  2232,
     826,  5561,  1911,  2001,  1056,  4797,  2665,  1168,  3659,  1770,
    1057,  1359,  4819,  2243, -1880,  2714,  4833,  1335,  4441,  3152,
    5206,  2502,  2245,  5041,  1223,  2616,  3804,  3108,  3706,  5505,
    3636,  4640,  2246,  1451,  2686,  2715,  5405,  2640,  1115,  2959,
    1840,  1745,  4536,   840,  1833,  2691,  5311,  3913,  1335,  2696,
    1810,  2652,  2048,  2700,  1611,  1506,  2703,  1415,   778,  4671,
    2618,  1166,  3989,  3038,  2658,  1237,  1452,  5351,  3535,  1982,
    3926,  1879, -2673, -2673, -2673,  3713,  1335,  1335,  1335,  5172,
    1335,  2864,  1189,  3636,  1807,  4206,  4427,  3539,  4442,  1542,
    4415,  5241,  4356,  2613,  4868,  3897,  3995,   849,  1834,  5446,
    1335,  3153,  3021,  2235,  3444,  5061,  1912,  5506,  2362,  3540,
    3740,  3741,  2142,  2143,  3356,  2147,  5406,  2657,  2638,  2672,
     854,   854,   944,   854,  4515,  2503,  5538,  2133,  1543,  5108,
     909,  2236,  3707,  2651,  1453,  4231,  2653,  5100,   826,  3742,
    2451,  3900,   857,  5407,  3039,  5125,  1000,  5072,  4715,  5478,
    3787,  1613,  1002,  4755,  3154,  5093,  1195,  1614, -1736,  3417,
     648,  1544,   649,  2534,  2882,  2569,  3996,  -679,  1335,  3414,
    2789,    41,  1335,  1335,  3083,    33,  2941,  3541,  2758,  2570,
    2761,  2687,  3160,   826,   826,  2181,  2768,  1335,  1786,  3788,
    2247,  5507,  2782,  2783,  2784,  3531,  1835,  3902,  2695,  5208,
     773,  2698,  2699,  2801,  2803,    41, -1880,    45,  2813,  5173,
     619,   790,  3155,  2688,  1411, -1880,  3729,  1851, -1880,  1425,
     945, -1880,  3789,   799,  1390,  4497,  2689,  3741,  2723,  2248,
    3415,  4964,  1169,  5128,  5242,  3084,  4035,   762,  5132,  5133,
    1196,    45,  2363,  5352,   635,  5447,  2284,  4534,  3051,    49,
    2520,   790,  1836,  3171,   864,  4284,  4207,  2019,  1373,  3160,
    1615,  2690,    50,   771,  5243,   998,  4756,   826,  2312,   946,
    1890,   944,  1021,  1878,  2452,  4965,   826,  3064,  1021,   864,
    2237,  2535,  4238,    49,  5174,    51,   774,   717,  3816,  3730,
    4746,  1021,  4786,  5029,  3895,  3905,    50,  3205,  4412,  3445,
    4966,  4231,  2883,  3206,   637,   772,   911,  3172,   826,   189,
     795,   790,  1890,  -577,  4563,  3175,  3156,  4967,  3178,    51,
    3042,  4968,  1642,   800,  1391,  4231,    41,   947,   790,  5269,
    5038,   826,  4296,   718,   826,  3541,  5508,  2273,  3906,  2221,
    5016,  3052,  4969,  4997,  1878,  4970,  1506,  1561,  1837,  1064,
    2222,  3424,  3344,   190,  3907,  3214,   864,  3345,  1577,  1156,
    4971,  3817,    45,  3170,  4239,  2164,  1562,  4413,  2223,   945,
     826,  3542,  3543,  3544,  4071,  3545,  3546,  3547,  3548,  3549,
    3550,  1354,   864,   864,   864,   864,   826,  2476,  2477,  2409,
    4458,  3145,  3146,  4418,  4998,  3149,  1586,  1578,  3195,  2643,
     826,  2427,  4999,   822,    49,  4297,  3207,  2650,  5350,   189,
    2544,  1335,  1335,  1335,   798,  4388,  1563,    50,   946,  4391,
    4392,  1616,  4394,  2340,  4564,  4240,  3728,  2662,  4453,  4241,
    5000,  4090,  3240,  4091,  3250,  3251,  3252,  1587,  3157,  2399,
      51,  1230,  1396,  2340,  3220,   775,  3158,  1588,  4972,  3159,
    3892,  3908,  3061,   190,    52,  3327,  4086,  4087,  4088,  4089,
    1617,  2976,  4094,  4095,  4096,  4097,  4098,  4099,  4100,  4101,
    4102,  4103,   648,  4019,   649,  4324,   947,   833,  3339,  3340,
    3341,  3342,  3256,  5387,  2611,  5001,   776,   777,  3863,  2545,
    3347,  3397,  4555,  1618,  4556,   909,   909,  2649,  5002,  4973,
     654,  1358,  3234,  1564,    41,   635,  1579,  2993,  1614,  2484,
    5003,   826,  2639,  1396,  1398,  3375,  4507,  1604,  4508,  4653,
    2224,  4144,  4145,   864,   864,  4201,  3038,  5279,  4953, -2673,
   -2673, -2673,  5191,  3545,  3546,  3547,  3548,  3549,  3550,  2832,
      45,  3085,  2418,   864,  4927,  5489,  5490,   842,  1441,  4982,
    1396,  1565,  5218,  1441,  1566,  1397,  1605,  3326,    41,  2406,
    1606,  1399,   826,  2994,  4238,   637,  4092,  3208,  5211,  2408,
    1359,  2419,  4081,  4868,  2400,  5188,  4093,  2401,   864,   864,
     864,   864,    49,  1223,  2341,  1398,  3820,  4958,  4654,  1607,
    1558,   826,  5202,  1863,    45,    50,  2989,  4409,   826,  5280,
    2484,  4107,  3086,  1568,  2341,  1589,  3209,  3039,  3462,  5166,
    1045,  1615,   605,  2342,  1864,   605,  1421,  5493,    51,   867,
    1435,  4410,  1398,  1441,   909,  1335,  3150,  1441,  2318,  1559,
    2319,  3855,    52,  2342,  2906,  5235,    49,  4557,  2343,  3210,
    1590,  2467,  3040,  4950,  1591,  1046,  4239,  5059,  1570,  5550,
    3688,  1422, -1095,  4841,  2468,  1423,    36,  3892,  2343,  -448,
     876,   876,  2151,  3368,   843,  2706,  4951,    41,  2539,  1399,
    1571,   911,   911,  2338,  2330,   876,  4950,  1592,   876,  2313,
    3938,  3041,  2469,  3969,  1925,  2379,    52,  1729,  1424,  2321,
    1573,  2320,  1018,  2338,  1019,   864,   864,  5004,  2993,  4951,
    5005,  5340,   864,    45,   826,  2152,  1890,  4240,  2331,  3814,
    5333,  4241,  4046,  4231,  5121,   826,   186,  1925,  2676,  5552,
    2677,  3992,  2678,   858,  2679,  2465,  2680,  4759,  1048,  1545,
    2681,  1960,  3336,   648,  1064,   649,  5334, -1707,   864,  2637,
     876,   859, -1707,   876,   876,    49,   826,   826,  2729,   864,
    4660,  4661,  5322,  4047,  3685,  4903,   826,  4905,    50,  3636,
    5157,  1786,  3636,   826,  2466,  5158,  4790,  2153,  5055,  4770,
     757,   757,   186,  1001,  2734,  2340,  3461,  -448,  1335,  1003,
    1335,    51,  1022,  3042,  1023,  1335,  1335,  2717,  3217,  3401,
    1064,  4740,  1335,  1335,  1335,    52,   868,  1335,  5402,  1335,
     911,  1335,  1335,  1335,  1335,  1335,  1335,  4236,  1335, -1707,
    1335,  1335,  3391,  2120,  1335,  2154,  5159,  2054,  3112,  3636,
    4408,  3218,  1162,  1416,  4741,  3484,  3485,  4673,  3673,  1335,
    1335,  1335,  1335,  1851,  4678,  2207,   864,  1335,  2728,  4231,
    -158,  1335,   870,  3136,  1335,  1427,  2060,  1335,  1335,  1335,
    1335,  1335,  1335,  1335,  1335,  1335, -1707,  1335,  3640,  1583,
     909,  3026,  1417,   826,  1335,  1863,  1335,  5421,  3437,  1548,
    5431,  1814, -2296,   826,  2380,  2155,  -158,  1350,  2062,  2383,
    2755,  2006,   766,    52,  1428,  3022,  1864,  5229,  3027,  3028,
    3782,  2433,  1549,  5416,  1815,  1418,  3014,   737,  1584,  2100,
    1865,  4750,   826,  4776,  3191,  -158,  -135, -1668,   952,  1335,
   -2277,   767,   953,   826,   826,   768,  5340,  1429,  3668,  1917,
   -1668,   738,  4231,  5273,  1335, -1668,  5162,  4777,  3152,  3783,
    5195,  1585,  3136,  1335,  1335,  4731,  2341,  4732,  4733,   890,
    2541,  4734,  1918, -1667,  2913,  3642,  2348,   826,  3718,  2454,
    3313,  5484,   731,  2460,  2950,  4374, -1667,  4217,  2340,  4357,
    4283, -1667,  3784,  3060,  2578,  2342,  2370,  2914,   891,  3534,
    4950,  2349, -1668,  2983,  3746,  2986,  4375,   731,  5154,  5480,
    5156,  3562,  4358,  2387,  5160,  5161,  1851,   867,  1425,  1548,
    2343,  4460, -1668,  4951,  2797,  1851,   757,  2207,   757,  3945,
    2980,  3599,  2815,   846,  3295,  3416,  3418,  3419, -1667,  3955,
    3153,  1237,  1549,  3585,  3535,  1335, -1708,  3721,  3536,  3537,
    3538, -1708,   952,  2909,  4231,  2338,   953,   605, -1667,   864,
     864,  1064,  1863,  5196,   876,  4132,   911,   876,   876, -1668,
     864,  3151,   864,  1551,  1931,  5519,   864,  1932, -1668,   826,
     228,  5551,  3655,  1864,   746,   934,   620,  3614,   731,  4275,
     746,  4282,  1621,  3154,   714,  1625,  3677,  1867,   847,  2819,
     790,  4267,  2822,   943,  2464, -1667,  5389,  2340,  3636,   951,
    3046,  2312,  1538,   796, -1667,  1005,  3505,  1555, -1708,  3071,
     826,  2135,  3777,  1642,  1990,  4487,  3082,  1991,  3506,  1642,
    1007,  4214,  4059,  3507,  3896,   826,  1851,  1010,  2207,  3345,
    1013,  3561,  4258,  3563,  3564,  3314,  2929,  3395,  3237,  2341,
    2128,  3155,  1027,  2129,  2134,  3404,   826,  2135,  1040,  3674,
    3675,  3127,  3127,     3,     4, -1708,  4218,  4917,  3941,  2606,
    1064,  2607,  4219,  -576,   848,  3423,   826,   826,  2342,  4220,
     826,  2139,   867,   790,  2129,  3429,  4007,  4008,  3430,  2669,
    3431,  3432,  2135,  1049,  3434,  5432,    29,  3615,  4299,  3616,
    3438,  1050,  3439,  2343,  3914,  3441,   864,  1199,  1199,   864,
    3897,  1199,  2683,  5357,  4221,  2684,  3898, -1668,  2685,  2720,
    5469,  2684,  2721,  3049,  2912,  1430,  1051,  1925,  3899,  3185,
    1066,  2951,   826,   826,  2135,  3884,  4222,  2340,  2338,  1174,
    1176,  1178,  1070,  3540,  1180,  1181,  1182,  3222,  3695,  3225,
    3227,  1858,  1859, -1667,  1187,  3156,  3900,  1113,  3901,  4178,
    2845,  2846,  2847,  2848,  3058,  1122,   628,  3059,  2341,  3130,
    3490,  3290,  3131,  3402,  3291,  3453,  2135,  2340,  2684,  1123,
    1335,  1335,  1335,  3966,  3504,  3967,  1335,  2135,  2457,  1129,
      41,  3513,   864,  3519,  2135,  1140,  2135,  2342,  5010,  3315,
     864,  3520,  1147,   864,  2135,  5516,  1157,  1431,  4960,   864,
     731,  3541,  3902,   849,  3617,  4478,  3618,  3798,  1335,  5222,
     864,  4401,  2343,  4402,  3568,  3521,    45,  5534,  2135,  5535,
    3575,  1382,  4179, -1656,  2312,  3554,  3807,  3127,  2135,   826,
    3903,  3567,   826,  3636,  2135,  1190,  3329,  3636,  3316,   757,
    1393,   635,  1395,  3124,  4613,  4471,  4616,  2338,  1194,  1432,
    3572,   864,  1335,  3573,  3763,  4180,  3768,  3764,    49,  3769,
    4233,  4234,  3793,  1199, -1089,  3794,  1198,  3157,  3378,  3222,
    4181,    50,  2938,  2939,  3852,  3158,  2340,  3794,  3159,   864,
    4182,  3361,  1201,  3812,  1209,  3892,  3495,  3332,  2341,  3498,
    3978,  1211,  3499,  3979,    51,  3904,  3357,  1212,  3491,  3980,
    3905,   637,  3981,  5383,  4003,  1213,  4183,  4004,  5433,  1335,
   -1731, -1731,  5111,  3931,  5503,  4005,   892,  2342,  2135,  4113,
    5116,  1216,  4114,   893,   894,   895,  4124,  4065,  2341,  4125,
   -1735, -1735,  4135,  4875,  2759,  2135,   864,  1220,   864,  3127,
     864,  3127,  2343,  3906,  1223,  4213,  1433,  1064,  2966,  1064,
    2543,  1221,  2053,  3331,   716,  2054,  1222,  2342,  2560,  3907,
    2637,  1224,  4237,  1225,  1237,  2684,  5533,  3535,  1226,  3452,
    2457,  3536,  3537,  3538,    15,   909,  4461,  2338,  1960,  2684,
    1231,  3924,  2343,  3927,  2060,  1233,  3447,  4513,  4133,  1353,
    4514, -2673,  3821,  1360,  4844,  3542,  3543,  3544,  4184,  3545,
    3546,  3547,  3548,  3549,  3550,  1362,  1434,  2842,    20,  2843,
    4050,  5051,  1237,  1435,  1356,  3535,  2062,  2338,  1366,  3536,
    3537,  3538,  4283,  4518,  3691,  3915,  4519,  3917,  4531,   605,
    1064,  1982,  5566,  2844,  1361,   876,  4583,  2341,   876,  3651,
    2340,   876, -1734, -1734,  4552,  1436,  2641,  2135,  1374,    36,
     864,  1636,   840,  5365,  5366,  3587,  3908,  3588,  1335,  5452,
    5453,  4581,  4043,  1335,  2721,  4593,  2342,  4636,  2135,   648,
    2966,   649,  4642,  2457,  4649,  4643,  4650,  2684,  1437,  2684,
    1379,  3589,   651,  3584,  1380,  1394,  4876,  1335,  1335,  1335,
    4792,  2343,  1335,  4793,   653,  4824,   840,  1786,  4004,  2340,
    1335,  1335,  1335,  1335,  1382,  1383,  1409,  3750,  3986,  3752,
    1438,  4849,  1439,  1335,  4850,  1410,  1335,  4851,  1335,  4858,
    2135,  1413,  2721,  1419,  4669,  4922,  2338, -2673,  4923,  1335,
    1335, -2575, -2673,  1335,  2845,  2846,  2847,  2848,  1425,  4276,
    5011,  2849,  2850,  2684,  1490,  5052,  4790,  2851,  5053,  1461,
    1487,   911,  2852,  1335,  4058,  1335,  3856,  1335, -2307,  1492,
    5073,  1493,  1440,  2721,  4194,  1943,  3540,  1532,  1945, -2673,
    1947,  1528,  1949,  5080,  1951,  1533,  5081,  1335,  1955,  1534,
    1545,   826,  2845,  2846,  2847,  2848,  3650,  1547,  3637,  3590,
      33,  5090,  4254,  5096,  1925,  3591,  3952,  1557,  1560,  2053,
    3592,  2341,  2054,  1582,   826,  1595,  3620,  3621,  3622,  1596,
    5098,  1612,  1335,  3952,  3540,  4259,  5147,  1622,  5187,  5148,
      41,  2099,  2069,  1623, -2575,  4083,  4323,  1335,  1626,  5220,
    2342,  2060,  5221,  5232,  3541,  1632,  5221,  2340, -2673,  5236,
    1631,  3637,  2721,  3666,  1237,  1735,  5237,  3535,  3842,  3573,
    1737,  3536,  3537,  3538,  3849,  2343,    45,  1740,  3636,  4112,
    2341,  5238,  1738,  2062,  2135,  3636,  1747,  1748,  4584,  4178,
    3636,  1743,  1756,  3636, -2575,  4395,  4380,  1757,  1760,  2797,
    2797,  1335,  3541,  3127,  2797,  5071,  1561, -2575,  1960,  2342,
    2338,  2520, -2575,  2853,  1763,  1766,  1768, -2575,    49,  3636,
    1774,  1777,  1779, -2575,  2854,  1562, -2575,  4156,  1789,  5249,
   -2575,    50,  5250, -2673,  2343,   864,  1770,   864,   864,   864,
    5255,  2797,  2797,  1925,  1788,  5258,  5272,  1000,  3952,  2684,
    3598,  1793,  5278,  1002,    51,  2721,  1794,  3191,  -178, -2575,
    2952,  3593,  4179,  5284,  5285,  4385,  2721,  2721,    52,  2338,
    1796,  5288,  3594,  4300,  2135,  1563,  4277,  5289,  2968, -2575,
    2135,  1797,  5290,  2241,  2972,  5291,  5318,  1799,  2975,  5319,
    5372,  1801,  1802,  5373, -2673,  4180,  4576,  1817, -1668, -2673,
     898,   899,   900,  1831,   901,   902,   903,   904,   905,   906,
    4181, -1668,  5376,  2759,  2999,  1925, -1668,   208,  2341,  5377,
    4182,  5378,  2135,  1824,  2135,  5380, -2575,  1838,  2135, -2575,
    3651,  5398,  1843, -2673,  5399, -2575, -2673,  1844,  1845,  4278,
    2076,  2077,  2078,  2079,  2080,  2081,  4183,  2342,  3542,  3543,
    3544,   826,  3545,  3546,  3547,  3548,  3549,  3550,  1847,  3053,
    1851,  3634,  1564, -1668,  4829,  5423,  3540,  5454,  5424,  1854,
    3952,  4012,  2343,  4014,  5466,  4016,  1857,  5103,  5492,  1021,
    1855,  5221,  1871, -1668,  4020,  3636,  1885,  5531,  1873,  2069,
    5532, -2575,  1886,  1889,  1890,  4528,  3542,  3543,  3544,  1897,
    3545,  3546,  3547,  3548,  3549,  3550,  1901,  2338,  1903,  3636,
    1565,  3103,  5544,  1566,  3634,  2135,  5546,  5564,  1237,  5547,
    5373,  3535,  1904,  1906,  1908,  3536,  3537,  3538,  2408,  1913,
   -1668,    41,  4279,  5572,  3541,  4060,  5547,  3132,  4184, -1668,
    1914,  1916,  1921,  3141,  5248,  5251,   762,  1924,  1927,  1928,
    3147,  1930,  1941,  1987,  1957,  3636,  1994,  1021,  1996,  1997,
    3161,  2004,  1568,  1335,  2003, -1884,  3166,    45, -1891,  1335,
    1734,  2011,  2012,  2013, -2575, -1881,  2014,  2015,   864,    52,
   -2673,  2017,  2018,  3127,  3127, -1882,  3179, -1885,  2019,  2020,
   -1883,  4119,  3182,  2021,  2087,  2022,  2023,  3186, -2575,  2025,
   -2575, -2575,  2026,  2027,  2028,  2029,  2030,  1570,  1237,    49,
    3203,  3535,  2031,  4433,  4434,  3536,  3537,  3538,   826,   826,
     826,    29,    50,  3228,  2032,  2034,  2085,  2035,  2036,  1571,
    2037,  2038,  4766,  2039,  1021,   826, -2575,  2040,  2089, -2575,
   -2575, -2575,  2041,  2090,  2099,    51,  2103,  2115,  2123,  1573,
    2138,  4280,  2140,  1397,  4281,  1399,  2171,  1960,   826,    52,
    4523,  4524,  4525,  4526,  4527,  2183,  2184,  1960,   826,   826,
    2185,  2186,  2202,   826,  1237,  2173,  3127,  3535, -1668,  2203,
   -2673,  3536,  3537,  3538,  2204,   826,  2205,  2076,  2077,  2078,
    2079,  2080,  2081,  3636,  2207,  2208,  2209,  4471,  2211,  3972,
    2210,  2212,   766,  2213,  2219,  2238,  2244,  2250,  2275,  2279,
    2281,  2282,  2283,  2286,  2285,    41,  3976,  2299,  2305,  2303,
    3540,  2304,   840,  2316,  2332,  2317,  4000,  4677,  3542,  3543,
    3544,  2328,  3545,  3546,  3547,  3548,  3549,  3550,  2334,  2335,
     952,  2336,  2345,  1382,   953,  2338,  2337,  2346,  2347,  2350,
    2352,    45,  2357,  2358,   864,  2351,  2338,  3636,  2371,  4029,
    2361,  4150,  3452,  4634,  2367,  2372,  2368,  2373,  2374,  2375,
    2378,  5113,  2388,  2381,  2384,  2395,  2385,  2402,  2390,  2405,
    2391,  1506,  2422,  2428,  2403,   826,  2410,  2429,  3541,  3112,
    2411,  4294,  2416,    49,  2417,  2421,  2423,  2434,   826,  2426,
    2445,   826,  2435,  2446,  2475,  2453,    50,  2482,  2486,  2489,
    3540,  2447,  2458,  2488,  3136,  4738,  1199,  2490,  2491,  2495,
    2496,  2499,  2497,  1335,  2498,  2505,  2506,  2507,  4562,    51,
    2508,  2509,  1335,  2513,  3191,  2514,  2515,  2516,  2521,  2524,
    1335,  2525,  1335,    52, -1420,  1335, -1420,   630,  2528,  2533,
    1335,  1335,  1335,  1335,  2542,  2553,  1335,  1335,  1335,  1335,
    1335,  1335,  1335,  1335,  1335,  1335,  2557,  2539,  1579,  1335,
    1335,  2558,  2561,  2566,  2577,  2584, -2673,  2593,  3541,  1335,
    4811,  3467,  2580,  1335,   840,  3636,  4631,  1335,  2583,  2603,
    2597,  2759,  2605,  2600,  2609,  1335,  2614,  3636,  1335,  3481,
    1335,  2615,  2621,   840,  2628,  2623,  2624,  3467,  3651,  2631,
    2632,  2633,  1335,  2635,  2629,  1335,  1335,  2634,  5510,  5511,
    1335,  1335,  2642,  2644,  2645,  4154,  2646,  1335,   604,  2647,
    2660,  2661,  2675,  3651,   826,   826,   826,   605,  2697,  2705,
    3637,  4176,  2718,  2731,  3541,  4176,  4190,  4176,  2769,  2814,
    2820,  4667,  1335,  4158,  4159,  4160,  4161,  2764,  2054,  2824,
    2833,  2839,  2857,  2859,  2879,  2880,  2894,  2899,  2902,  2903,
    2904,  2905,   847,   186,  1001,  2918,  4716,  4717,  1335,  4719,
    1003,  2931,  3542,  3543,  3544,  2930,  3545,  3546,  3547,  3548,
    3549,  3550,  2932,  2949,  2956,  2947,  2933,  4232,  1960,  1960,
    2958,  2484,  2955,  2989,  2984,  2987,  2991,  2992,  2998,  3003,
    3008,  3009,  3011,  3013,  3015,  3033,  3023,  3034,   864,   864,
     864,   864,  3037,  3636,  3055,  3050,  1350,  1354,  4751,  3019,
    3057,  3067,  3074,  4709,  3093,  3087,  3092,  3119,  3118,  3120,
    3125,  3137,  2797,  2797,  2797,  2797,  3181,  2312,  2797,  2797,
    2797,  2797,  2797,  2797,  2797,  2797,  2797,  2797,  3129,  3144,
    2053,  3165,  3164,  2054,  4509,  4288,  2409,  3223,  4511,  3248,
    3244,  3236,  3542,  3543,  3544,  4116,  3545,  3546,  3547,  3548,
    3549,  3550,   848,  3245,  3263,  3268,  3269,  3257,   607,  3270,
    3276,  3304,  2060,  3281,  3305,  3319,  3321,  3292,  3323, -2673,
    3636,  3325,  3343,  3334,  3337,  3351,  3636,  2797,  2797,  1561,
    3346,  3352,  5117,  3354,   862,  3651,  3353,  3355,  3359,  3362,
    3364,  3366,  4335,   875,  2062,  3367,  3370,  3371,  1562,  3389,
    3390,   875,  4768,  4343,   875,  3392,  5151,  3394,  3542,  3543,
    3544,  3393,  3545,  3546,  3547,  3548,  3549,  3550,  3396,  3398,
    1878,  3406,  3405,  3403,  3407,  3421,  3408,  3409,  3435,  3413,
    3422,  3436,  4377,  1561,  3433,  4775,  2053,  3440,  3442,  2054,
    3455,  3460,  3456,  3457,  3458,  3459,  3468,  1925,  1563,  2732,
    3470,  1922,  1562,  2053,  3693,  1887,  2054,  3471,  3472,  3479,
    3634,  4143,  3487,  3634,  3482,  1196,  3489,   864,  2060,  3496,
    3494,  5141,  3515,  5143,  3493, -2673,  3501,  3516,  3636,  3497,
     826,  3517,   864,  3522,  1335,  2060,  3531,  3518,  3523,  3527,
    3530,   826, -2673,  3553,  3559, -2156,  3586,  4424,  2053,  2135,
    2062,  2054,  1563,  3566,  3596, -2673,  3569,  2312,  3580,  3581,
   -2673,  3597,  4278,  3606,  3611,  3607,  3660,  2062,  3609,  3610,
    3634,  3647,   826,  3662,  3613,  3671,  3637,  3648,  3638,  3678,
    2060,  3664,  3687,  3690,  3676,  1564,  3222, -2673,  3653,  3679,
    3699,  3692,  3683,  3725,   607,  4472,  3714, -2673,  3715,  3727,
    3726,  3684,  3731,   607,   884,   826,  3732,  3733,  3748,  2484,
    4658,   607,  2062,   884,   607,  3773,  1335,  1335,  3734,  3737,
    3749,  3751,  4482,  3759,  3767,  3757,  5008,   884,  3758,  3772,
    3781,  3795,  3799,  1565,  4146,  3797,  1566,  3801,  1982,  1564,
    3802,  3803,  3808,  5295,  3806,  3809,  3810,  3127,  4910,  3127,
    2069,  2408,  3811,  3813,  4683,  4684,   826,  3827,  3825,  3826,
     909, -2673,  3828,  3829,  3841,  3830, -2673,  3832,  3452,  3831,
    1335,  3835,  3837,  3844,  5301,  5303,  3833,  3839, -2673,  4147,
    3834,  3846,  3848, -2673,  3836,  1568,  5079,  1565,  3838,  3840,
    1566,  3850,  2443,  3851,  4929,  3857,  3860,  3867,  3861,  3862,
    3871,  4934,  3864, -2673,  3872,  2408,  1335,  3874,  3880,  3882,
    3922,  3923,  3929,  3932,  3933,  3935,  3940,  3937,  1335,  3951,
   -2673,  3952,  3954, -2673,  3961,  3970,  2797,  3971, -2673,  3964,
    1570,  3975,  3974,  3990,  5153,  3999,  4002,  3977,  4022,  1568,
    3858, -2673,  4009,  4013,  4726,  4727,  4023,  4015,  1335,  4038,
    4049,  1335,  1571,  4030,  4010,  4036,  2069,  4811,  4039,  1335,
    1335,  4051,  4040,  4044,  4041, -2673,  1335,  1335,  4042,  4052,
    4053,  1335,  1573,  2069,  4062,  4011,  4063,  1335,  4064,  4066,
    1335,  1335,  4067,  4068,  1570,  1335,  4592,  4069,  4070,  4074,
    3535,  1335,   826,   826,   826,   826,  3556, -2155,  2006,  4176,
    4190,  4176,  3555,  1335,  4176,  4126,  1571,  4606,  4084,  4109,
    4110,  3637,  4137,  4139,  5089,  3637,  5400,  4111,  2069,  4151,
    4138,  4621,  4118,  4142,  4168,  5089,  1573,  4169,  4192,  3634,
    4157,  4196,  4208,  4198,  4202,  4638,   911,  4177,  4200,  4211,
    4216, -2673,  4224,  4245,  4247,  1335,  4253, -2673,  2076,  2077,
    2078,  2079,  2080,  2081,  4260,  4261,  4263,  4248,   757,  4266,
    4264,  1335,  4268,  4270, -2673,  4271,  4286,  4289,  4302,  4305,
    4823,  4301,  4303,  4304,  4825,  4826,  4317,  4315,  4318,  4329,
    4331,  3127,  3127,  4319,  5075,  4345,  4316,  4320,  4332,  4346,
    5308,  4351,  5295,  4354,  4370,  4371,  4373,  4277,  5145,  4376,
    2312,  4840,  4386,  4387,  4389,  4390,  4393,  4405,  4436, -2673,
    4672,  4430,  4416,  4444,  4450,  4681,  4451,  4454,   862,  4463,
    4680,  4479,  4456,  2047,  2684,  4473,  4496,   875,  4457,  4480,
    4490,  4495,  2457,  4499,   875,  4498,  4500,   875,  5140,  4501,
    4510,  4503,  4506,  4567,  4512,  4516,  4529, -2673,  4533,  4535,
    2735,  4541,  1064,  4554,  2076,  2077,  2078,  2079,  2080,  2081,
    4045,  4565,  4548,  4568, -2673,  1335, -2157,  4569,  4549,  4609,
    4558,  2076,  2077,  2078,  2079,  2080,  2081,  4559,  4570,  4617,
    4624,  5136,  5137,  4618,  4602,  4061,  4589,  4574,  4605,  4607,
     864,  4610,  4622,  4623,  4625,  4604,  4632,  4633,  4630,  2736,
    4637,  4635,  4639,  4645,  4644,   864,  4655,  4651,  4674, -2673,
    4675,  4676,  4679,  4685,  4686,  4687,  2076,  2077,  2078,  2079,
    2080,  2081,  4699,  4702,  4708,  4706,  4711,  4712,  4720,  4721,
    4730,  2737,  4728,  4729,  5256,  4735,  4739,  4742,   884,  1335,
    4743,  4749,  4748,  4752,   884,  4757,  5270,  4763,  4758,  4764,
    4767,  4771,  4765,  4773,  2738,   605,  4781,   884,  4789,  4800,
    4784,  2312,  4796,  4794,  3634,  2739,  4801,  4805,  3634,  4807,
    1960,  4808,  4803,   884,  4809,  4963,  4821,  4816,   607,  4835,
    4838,  4839,  4846,  1112,  4845,  1335,  2740,   607,   884,  4848,
    4854,  2741,  4855,  4856,   607,  4857,   884,   607,   864,  4879,
    3361,  4863,   909,  4901,  4898,  4904,  4914,  4919,  4924,  1112,
     884,  4925,  5240,  4869,  4926,  4787,  5267,  4918,  4872,  4883,
     884,  4916,  4931,  4937,  4938,  4956,  4942,  4947,  4978,  5257,
    4948,  4949,  4415,  5259,   826,  5261,  4987,  4989,  5014,  1064,
    4995,  4996,  2742,  3651,  4990,  5015,  4993,  5024,  4029,  5022,
    5027,  5032,  5034,  3452,  5054,   909,  4935,  5056,  5057,  5058,
    5065,  5067,  5078,  2743,  4828,  4830,  2053,  5082,  5103,  2054,
    5088,  5092,  5095, -2673, -2673, -2673,  5099,  5101,  5122,  5129,
    5120,  4933,  5123,  5167,  5135,  5112,  5169,  5175,  1335,  5179,
    5180,  5182,  5189,  5200,  5194,  5201,  5209,  5213,  2060,  5214,
    5215,  5216,   862,   607,   607,  2061,  5217,  5225,  5070,   884,
    4255,  5226,  5227,   875,  5247,  5260,  5263,  1335,  1335,   875,
    5230,  1335,   875,  5264,  5228,  4977,  5265,  5277,  5239,  5281,
    2062,  5306,  5307,   884,  5317,   607,   605,   208,  2744,  4176,
    5300,  2745,  5321,  3637,  5324,  5312,   884,  5314,  3637,  5325,
    5347,  3637,   605,  5348,  3222,  5345,  4885,  5346,  1335,  1335,
    5354,  5367,  5355,  5369,  5358,  5393,  5384,  2746,  4902,  5395,
    2747,  5401,  5109,  5403,  5310,  5311,  2748,  4232,   911,   864,
    5140,   864,  4152,  2749,  5386,  5410,  5411,  5430,  5445,  5412,
    5450,  5457,  5464,  5476,  1827,  1828,  1829,  5504,  5468,  5473,
    5482,  5512,  5537,  5536,  5518,  5501,  5539,  5514,  5502,  5540,
    5541,  5554,  2750,  5555,  1491,  5562,  5563,  5567,  2751,  5565,
    5568,  2752,  2459,  3328,  2122,  5146,  4359,  1384,  3117,  4362,
     876,   911,  3645,  3196,  3743,  4285,  5396,  3235,  4292,  3283,
    2753,  2063,  4975,  3879,  5294,  5474,  2064,  4432,  5033,  5007,
    3681,  4747,  3454,   607,   607,  1730,  5388,  4908,  5470,  5315,
    5313,  5409,   607,  5487,  4462,  3686,  2754,  4483,  5275,  1112,
    3302,  4425,  5437,   607,   876,  3303,  4290,   826,  5439,   607,
    2797,  3761,   607,  2067,  3939,  4449,   182,  1581,  1064,  4424,
    5013,  5018,   826,  4769,  1112,  3293,  5475,   826,  5569,  3127,
    5559,  3885,  4991,  3947,  4491,  5414,  2312,   182,  4936,  1112,
    5131,  2532,  5283,  4939,  1979,   764,  4530,  5107,  5530,  5012,
    2961,  2602,  4492,   826,  3672,  2599,  2610,  4472,  5223,  2648,
    5035,  4446,  1065,  2725,  1141,  3847,  2069,  2726,   839,  2727,
    3233,   864,   826,  4232,  4321,  3943,  4344,  5435,  5553,  4504,
    2457,  2218,  5437,  4505,   607,   607,   607,  5046,  5439,  2673,
    2908,  2674,  2917,  5443,  1363,  5064,  4520,  4232,  3649,  1335,
    4831,  2136,  2946,  5048,  2095,  2168,  2167,  1385,  3661,  1335,
    4199,  5379,  1335,  2927,  1335,  5262,   840,  4172,  4963,  3634,
    4628,  2945,  4600,  4615,  1112,  5094,  3634,  4166,  5246,  5245,
    5556,  3634,  4521,  1335,  3634,  4167, -2577,  5517,  5456,  1335,
    5370,  5513,  5074,  3637,  4120,  5381,  3604,  4885,  2622,  3510,
    4900,  2172,  5382,  1335,  3259,  3602,     0,  2071,  2884,     0,
    3634,   884,  5106,     0,     0,     0,  2893,     0,     0,     0,
       0,     0,     0,  3467,     0,     0,     0,     0,   826,   884,
    1960,     0,     0,     0,  5437,     0,     0,     0,     0,   607,
    5439,     0,     0,     0,     0,     0,     0,   884,     0,     0,
     909,     0,   852,     0,     0,     0,  1335,     0,     0,     0,
       0,  1335,  1335,     0,     0,     0,   864,   864,   864,   864,
       0,  5371,     0,     0,     0,     0,     0,   884,     0, -2577,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1112,     0,   884,     0,     0,     0,     0,     0,  1335,
       0,     0,     0,     0,     0,     0,   605,  2072,     0,   884,
   -2673, -2673, -2673,   884,  2076,  2077,  2078,  2079,  2080,  2081,
       0,     0,     0,     0,     0,   607,     0,     0,   826, -2577,
       0,  3637,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0, -2577,     0,     0,     0,     0, -2577,     0,     0,
       0,  2797, -2577,     0,     0,     0,   607,     0, -2577,  5203,
       0, -2577,     0,     0,     0, -2577,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2797,  3634,     0,     0,     0,
       0,     0,     0,     0,   607,   607,   607,     0,   607,     0,
       0,     0,  1335,     0, -2577,   605,     0,     0,  1335,     0,
    3634,     0,  5254,     0,     0,     0,     0,     0,   607,  1335,
       0,     0,     0,  1335, -2577,  1335,     0,  1335,     0,     0,
       0,     0,     0,     0,     0,     0,   911,     0,     0,     0,
    5467,     0,   884,     0,     0,     0,     0,  1335,     0,     0,
     884,   884,     0,  5392,     0,     0,  3634,     0,     0,     0,
       0,     0,     0,     0,   884,     0,     0,     0,     0,     0,
       0, -2577,     0,     0, -2577,     0,     0,     0,     0,     0,
   -2577,     0,  1960,  1960,     0,     0,   607,  1494,     0,  4693,
     607,   607,     0,  1495,     0,     0,     0,     0,     0,     0,
       0,  4703,     0,     0,     0,   607,  1496,     0,     0,     0,
       0,  1112,  5525,   864,     0,     0,     0,  1730,     0,     0,
    5329,     0,     0,     0,  1335,     0,     0,     0,     0,  5441,
    5442,     0,     0,  5341,     0,  1497, -2577,     0,     0,     0,
       0,     0,     0,  2053,     0,  4232,  2054,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1335,  1335,  1335,     0,     0,
       0,  3222,  5356,     0,  1335,  2060,     0,  5525,     0,  1112,
       0,     0, -2673,     0,  1335,     0,     0,  5106,     0,  1498,
       0,   762,     0,     0,  3634,  5525,  1499,     0,     0,  1500,
    2797,     0,   876,     0,     0,  2053,     0,  2062,  2054,     0,
       0,     0,  2055,  2056,  2057,     0,     0,   864,     0, -2577,
    1112,     0,     0,     0,  1960,  1501,     0,     0,     0,  2058,
       0,     0,     0,     0,     0,     0,     0,  2060,     0,     0,
       0,     0,     0, -2577,  2061, -2577, -2577,     0,     0,     0,
    2312,     0,     0,  1112,     0,   605,     0,     0,  3634,  1502,
       0,  1335,     0,     0,     0,     0,     0,  5415,     0,  2062,
       0,  4232,     0,     0,  4587,     0,     0,     0,   876,   876,
       0, -2577,  3452,  1335, -2577, -2577, -2577,     0,   186,  5438,
       0,     0,     0,  1335,     0,  5440,     0,  5254,   182,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   884,     0,     0,   864, -2673,     0,
    5500,  3467,  1503, -2673,     0,     0,  1504,     0,     0,   607,
     607,   607,     0,     0,     0,     0,  1505,     0,     0,     0,
       0,     0,  5570,  5571,     0,  1506,     0,     0,  5341,   864,
     864,     0,     0,     0,  4232,     0,     0,  1507,     0,     0,
   -2673,     0,     0,     0,     0,     0,  2797,     0,   186,  5438,
     862,     0,     0,   862,     0,  5440,     0,     0,     0,     0,
    2063,     0,  1335,  1335,     0,  2064,  3634,     0,     0,     0,
       0,     0,  1335,   182,   839,     0,  1508,  1335,  3634,  1509,
    1510,     0,     0,     0,     0,     0,     0,  2065,  2066,     0,
       0,     0,     0,  2069,     0,     0,     0,     0,   875,   875,
       0,     0,  2067,  3467,     0,  3467,     0,     0,  1335,  1511,
       0,     0,  1112,   875,     0,     0,   875,     0,  1335,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1112,
       0,     0,     0,   864,     0,     0,  4232,     0,     0,     0,
       0,  2068,  1730,     0,     0,  5254,     0,  1112,     0,   605,
     186,  5438,     0,     0,     0,  2069,     0,  5440,  2070,     0,
       0,     0,     0,     0,     0,  5455,   884,     0,     0,     0,
       0,   876,   876,     0,   884,     0,     0,  1512,   875,     0,
       0,   875,   875,     0, -2673,     0,   884,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   852,     0,   182,
       0,     0,     0,  1112,  3634,     0,     0,     0,     0,     0,
     607,     0,     0,   607,     0,     0,  1112,     0,     0,     0,
       0,   674,     0,   607,     0,     0,     0,     0,     0,  1112,
     761,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1112,     0,     0,     0,     0,  2071,     0,     0,     0,
       0,     0,     0,     0,  2797,  2797,     0,     0,   607,   607,
       0,   884,   884,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   607,   748,   884,   607,     0,     0,     0,
     748,  3634,     0,     0, -2673,  1112,  1112,  3634,   884,   884,
       0,  2076,  2077,  2078,  2079,  2080,  2081,     0,     0,     0,
       0,     0,     0,     0,   884,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0, -2593,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   607,     0,
       0,   607,   607,     0,     0,     0,  2072,     0,     0,  2073,
    2074,  2075,     0,  2076,  2077,  2078,  2079,  2080,  2081,  3380,
       0,     0,     0,  3524,     0,     0,  3525,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   607,     0,   607,     0,
    1464,     0,     0,   607,   607,     0,     0,     0,     0,  3634,
     607,   607,   607,     0,     0,   607,     0,   607,     0,   607,
     607,   607,   607,   607,   607,     0,   607,     0,   607,   607,
       0,     0,   607,     0,  1465,     0,     0,     0,     0,     0,
   -2593,     0,     0,     0,     0,     0,  1112,   607,   607,   607,
     607,  1730,     0,     0,     0,   607,     0,     0,     0,   607,
       0,     0,   607,     0,     0,   607,   607,   607,   607,   607,
     607,   607,   607,   607,     0,   607,     0,     0,     0,     0,
       0,     0,   607,     0,   607,   862,     0,     0,     0,     0,
   -2593,     0,   875,     0,  1466,   875,   875,     0,     0,     0,
       0,     0,     0, -2593,     0,     0,     0,     0, -2593,     0,
       0,     0,     0, -2593,     0,     0,     0,     0,     0, -2593,
       0,   884, -2593,     0,     0,     0, -2593,   607,     0,  1467,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   607,   182,     0,     0,     0,     0,     0,     0,
       0,   607,   607,     0,     0, -2593,     0,     0,     0,     0,
    3381,  2252,     0,     0,     0,  1468,  2253,     0,     0,     0,
       0,     0,     0,     0,     0, -2593,   884,     0,     0,     0,
       0,     0,     0,  1112,     0,     0,     0,  1112,  1112,     0,
       0,     0,     0,     0,   884,     0,     0,     0,     0,  1730,
     884,  2254,     0,     0,   884,  1470,     0,     0,     0,     0,
       0,     0,   884,     0,  2255,  2007,     0,     0,     0,     0,
       0,     0, -2593,     0,     0, -2593,     0,     0,     0,  2256,
     884, -2593,     0,   607,     0,  2016,     0,  1472,     0,     0,
       0,     0,     0,  1435,     0,   607,     0,     0,     0,  1112,
       0,     0,   607,     0,     0,   607,   607,     0,     0,     0,
       0,     0,     0,  1112,     0,     0,     0,  2033,     0,     0,
    2257,     0,     0,     0,     0,   884,     0,     0,     0,    36,
       0,  2258,  2045,  3382,     0,     0,     0, -2593,     0,     0,
       0,     0,  1475,     0,     0,   884,   884,     0,     0,     0,
    1476,     0,  2259,     0,  1112,     0,     0,  2260,  2296,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1478,     0,     0,     0,     0,     0,  1730,   884,     0,  1479,
    1730,     0,     0,  1480,     0,     0,     0,     0,     0,     0,
       0,     0,   762,     0,     0,     0,     0,     0,     0,     0,
       0,  3467,  3383,   884,     0,  1730,     0,     0,     0,   884,
       0,     0,     0,     0,     0,     0,   884,     0,   852,   852,
   -2593,   852,     0,   884,     0,     0,   884,     0,     0,  2261,
       0,     0,   884,     0,     0,     0,     0,  1481,     0,     0,
       0,  3384,     0,     0, -2593,     0, -2593, -2593,     0,     0,
       0,     0,   884,     0,     0,     0,     0,     0,   884,     0,
       0,     0,     0,   884,     0,     0,  1730,     0,     0,  2262,
       0,     0,     0,     0,     0,     0,   884,     0,     0,     0,
       0,     0, -2593,     0,     0, -2593, -2593, -2593,     0,   884,
       0,     0,     0,   997,  1730,     0,     0,     0,  2053,     0,
     884,  2054,  1494,   208,  2263,  2055,  2056,  2057,  1495,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   607,   607,
     607,     0,  2058,     0,   607,     0,  3380,     0,     0,     0,
    2060,     0,     0,     0,     0,     0,  2264,  2061,     0,     0,
       0,     0,  2265,     0,     0,  1063,   674,  1464,     0,  2266,
    1497,     0,  2267,     0,     0,     0,   607,  1112,     0,     0,
       0,     0,  2062,     0,     0,     0,  1730,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1465,     0,     0,  2268,     0,     0,     0,     0,     0,
       0,  2269,     0,     0,     0,     0,     0,     0,     0,  2270,
     607,     0,     0,     0,  1498,     0,  2271,     0,     0,     0,
       0,  1499,     0,     0,  1500,     0,     0,   862,     0,     0,
       0,     0,     0,   875,     0,     0,   875,     0,     0,   875,
       0,     0,  2272,     0,     0,     0,     0,     0,     0,  1112,
    1501,  1466,  1112,  1208,     0,     0,     0,   884,     0,     0,
       0,     0,     0,     0,   748,     0,   748,   607,   748,     0,
       0,     0,     0,     0,   748,  1184,  1185,     0,     0,  1228,
       0,     0,     0,  2063,  1502,     0,  1467,  1338,  2064,     0,
    1347,  1063,  1349,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2065,  2066,     0,   884,     0,     0,     0,  3381,     0,     0,
       0,     0,  1468,     0,     0,  2067,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1599,     0,     0,
       0,  1504,     0,     0,     0,     0,     0,   884,     0,     0,
       0,  1505,  1470,     0,  2068,     0,     0,     0,     0,     0,
    1506,     0,     0,  1112,     0,   884,     0,     0,  2069,     0,
       0,  2070,  1507,   884,     0,     0,   604,   607,     0,     0,
    1112,     0,     0,   607,  1472,     0,   607,     0,     0,   607,
    1435,     0,     0,     0,     0,  1112,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   607,     0,     0,     0,
       0,   607,   748,     0,  1509,  1510,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    36,     0,     0,   604,
    1474,     0,     0,     0,     0,   607,   607,   607,     0,  1475,
     607,     0,     0,     0,  1511,     0,  1494,  1476,   607,   607,
     607,   607,  1495,     0,     0,  2296,  1730,     0,     0,  2071,
       0,   607,  1730,     0,   607,  1597,   607,  1478,     0,     0,
       0,     0,     0,     0,     0,     0,  1479,   607,   607,     0,
    1480,   607,     0,     0,     0,     0,     0,     0,  1098,     0,
       0,     0,     0,     0,  1497,     0,     0,     0,     0,  3383,
       0,   607,     0,   607,     0,   607,     0,     0,     0,     0,
       0,     0,  1512,     0,  1098,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   607,     0,     0,     0,     0,
       0,     0,     0,     0,  1481,     0,   607,     0,  3384,     0,
       0,     0,     0,     0,   884,     0,  1598,     0,  1498,     0,
       0,     0,     0,     0,     0,  1499,     0,   182,  1500,  2072,
     607,     0,  2073,  2074,  2075,     0,  2076,  2077,  2078,  2079,
    2080,  2081,     0,     0,     0,   607,     0,     0,     0,  3526,
       0,     0,     0,     0,  1501,     0,     0,     0,     0,   607,
       0,     0,     0,     0,     0,     0,     0,     0,  1112,     0,
       0,  1112,     0,  1112,     0,     0,     0,     0,  1112,     0,
       0,     0,     0,   182,     0,     0,     0,     0,  1502,     0,
       0,  1063,     0,   884,   884,     0,     0,     0,  2053,   607,
       0,  2054,     0,     0,     0,  2055,  2056,  2057,  1494,  1063,
       0,     0,     0,     0,  1495,     0,     0,     0,     0,     0,
     884,  1561,  2058,   884,     0,     0,     0,  1112,     0,     0,
    2060,     0,     0,     0,     0,     0,     0,  2061,     0,     0,
    1562,     0,     0,     0,     0,  1984,  1112,     0,     0,     0,
       0,  1599,     0,     0,  1464,  1504,  1497,   748,     0,     0,
    2840,     0,  2062,     0,     0,  1505,     0,     0,     0,     0,
       0,  1112,     0,     0,  1506,  1063,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1507,     0,  1465,     0,
    1563,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1730,  1730,  1730,
    1498,     0,     0,     0,     0,     0,     0,  1499,     0,     0,
    1500,     0,     0,     0,     0,  1600,     0,     0,  1509,  1510,
       0,   884,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1112,     0,  1112,  1742,     0,  1501,     0,  1466,     0,
       0,   884,  2049,     0,     0,     0,     0,     0,  1601,     0,
       0,  2051,     0,     0,     0,     0,     0,     0,     0,  1759,
     884,     0,     0,  2063,     0,  2093,     0,  1564,  2064,     0,
    1502,     0,     0,  1467,  1767,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1063,     0,     0,  2110,  2111,     0,
    2065,  2066,  1063,  1063,     0,     0,     0,     0,     0,     0,
       0,     0,  1464,     0,     0,  2067,  1063,     0,     0,  1468,
       0,     0,     0,     0,     0,  1565,  1512,     0,  1566,     0,
       0,     0,     0,     0,  1112,     0,     0,     0,     0,     0,
       0,     0,     0,  1567,     0,   748,  1465,  1504,     0,     0,
     748,   748,     0,     0,  2068,  1469,   884,  1505,     0,  1470,
       0,   607,     0,     0,   748,     0,  1506,   607,  2069,     0,
       0,  2070,     0,     0,     0,  1112,     0,  1568,  1507,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1471,  1472,     0,     0,     0,     0,     0,  1435,     0,     0,
       0,     0,     0,  1730,  1112,     0,  1466,     0,     0,     0,
     884,     0,   884,     0,     0,     0,     0,  1569,     0,     0,
    1509,  1510,  1570,     0,     0,   884,     0,   884,     0,  1473,
       0,     0,     0,    36,     0,     0,     0,  1474,     0,     0,
       0,  1467,     0,     0,  1571,     0,  1475,     0,     0,  1730,
    1572,     0,     0,     0,  1476,     0,     0,   748,     0,  2071,
       0,     0,  1477,     0,  1573,     0,     0,   748,     0,     0,
       0,     0,     0,  1112,  1478,     0,     0,  1468,     0,     0,
       0,     0,     0,  1479,     0,     0,  1985,  1480,     0,     0,
       0,     0,     0,   884,  1112,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1112,     0,
       0,  1184,  1185,     0,     0,     0,     0,  1470,  1512,     0,
       0,     0,     0,  2413,     0,     0,     0,     0,     0,     0,
    2420,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1481,     0,     0,     0,     0,     0,     0,   884,  1472,
       0,     0,     0,     0,   748,  1435,     0,   748,   748,  2072,
       0,     0,  2073,  2074,  2075,     0,  2076,  2077,  2078,  2079,
    2080,  2081,     0,     0,     0,   604,   884,     0,   604,  3576,
       0,     0,     0,     0,     0,     0,     0,     0,  1494,     0,
       0,    36,     0,  2295,  1495,  1474,     0,     0,   884,     0,
    2052,   884,     0,     0,  1475,     0,     0,  2053,     0,     0,
    2054,     0,  1476,     0,  2055,  2056,  2057,     0,     0,     0,
    2296,   607,     0,     0,  1112,     0,     0,     0,     0,     0,
     607,  2058,  1478,     0,  2059,   604,  1497,     0,   607,  2060,
     607,  1479,     0,   607,     0,  1480,  2061,  1112,   607,   607,
     607,   607,     0,     0,   607,   607,   607,   607,   607,   607,
     607,   607,   607,   607,     0,     0,     0,   607,   607,     0,
       0,  2062,  1112,     0,     0,     0,     0,   607,     0,     0,
     182,   607,     0,  1730,     0,   607,     0,     0,     0,     0,
    1498,     0,     0,   607,     0,     0,   607,  1499,   607,  1481,
    1500,     0,     0,  1464,     0,     0,     0,     0,  1112,     0,
     607,     0,     0,   607,   607,     0,     0,     0,   607,   607,
       0,     0,     0,     0,     0,   607,  1501,     0,     0,     0,
       0,     0,     0,     0,     0,   607,     0,  1465,   607,   748,
       0,  2554,     0,     0,     0,  2559,     0,     0,     0,  2053,
     607,     0,  2054,     0,     0,     0,  2055,  2056,  2057,     0,
    1502,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     182,     0,     0,  2058,     0,     0,   607,     0,     0,     0,
       0,  2060,  2063,  1112,     0,     0,     0,  2064,  2061,     0,
    1494,     0,     0,     0,     0,   607,  1495,  1466,     0,     0,
       0,     0,     0,     0,     0,  2360,     0,     0,     0,  2065,
    2066,     0,     0,  2062,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1599,  2067,     0,   884,  1504,     0,     0,
       0,     0,  1467,     0,     0,     0,     0,  1505,  1497,     0,
       0,     0,     0,     0,     0,     0,  1506,  2617,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2625,  1507,  2626,
       0,     0,     0,  2068,     0,  2630,     0,     0,  1468,     0,
       0,     0,  2636,     0,     0,     0,  1730,  2069,     0,     0,
    2070,  1730,  1112,  1730,     0,     0,     0,     0,     0,     0,
       0,  2045,  1498,     0,   604,     0,     0,  1627,     0,  1499,
    1509,  1510,  1500,     0,  1469,     0,  1730,  1112,  1470,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1494,
       0,     0,     0,     0,  2063,  1495,  1730,     0,  1501,  2064,
    1628,     0,     0,     0,     0,  2045,     0,     0,     0,  1535,
    1472,     0,   884,     0,     0,   884,  1435,     0,     0,     0,
       0,  2065,  2066,     0,     0,     0,     0,     0,  2840,     0,
       0,  2781,  1502,     0,     0,     0,  2067,  1497,  2071,     0,
       0,     0,     0,     0,  3608,     0,     0,     0,  1536,     0,
       0,     0,    36,     0,     0,     0,  1474,     0,     0,     0,
    3627,     0,     0,     0,     0,  1475,     0,     0,  1512,     0,
       0,     0,     0,  1476,     0,  2068,  2770,  2771,     0,     0,
       0,  1537,   607,  2785,  2786,     0,     0,  2487,     0,  2069,
       0,  1498,  2070,  1478,     0,  1599,     0,     0,  1499,  1504,
       0,  1500,  1479,     0,  2504,     0,  1480,   884,   884,  1505,
       0,  1112,  2825,  3627,     0,     0,     0,   884,  1506,     0,
       0,     0,  2523,  2901,   607,     0,     0,  1501,     0,     0,
    1507,     0,     0,     0,     0,     0,   884,     0,  2072,     0,
       0,  2073,  2074,  2075,     0,  2076,  2077,  2078,  2079,  2080,
    2081,     0,     0,     0,     0,     0,     0,     0,     0,  1112,
    1481,  1502,     0,  1112,   607,   607,     0,     0,     0,  2276,
       0,     0,  1509,  1510,     0,     0,     0,     0,  2604,     0,
    2071,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2612,     0,     0,     0,     0,     0,     0,     0,   604,
       0,     0,  2277,   604,  1098,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2627,     0,   607,     0,
       0,  2936,  2936,     0,  1503,     0,     0,     0,  1504,   884,
       0,     0,     0,     0,  1063,     0,     0,     0,  1505,     0,
       0,     0,     0,     0,     0,     0,     0,  1506,     0,     0,
       0,     0,     0,     0,   607,     0,     0,     0,     0,  1507,
    2656,  1098,     0,     0,     0,     0,   607,     0,     0,     0,
    1512,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2072,     0,   748,  2073,  2074,  2075,     0,  2076,  2077,  2078,
    2079,  2080,  2081,     0,     0,     0,   607,  2823,  2353,   607,
       0,  1509,  1510,     0,  1349,     0,     0,   607,   607,     0,
    1112,     0,     0,     0,   607,   607,     0,     0,     0,   607,
    1112,     0,     0,     0,     0,   607,     0,     0,   607,   607,
       0,  2354,     0,   607,     0,     0,     0,     0,     0,   607,
       0,     0,  1494,     0,  1494,     0,     0,     0,  1495,     0,
    1495,   607,     0,     0,     0,     0,     0,     0,     0,   607,
       0,  1597,     0,   607,     0,     0,     0,     0,     0,     0,
       0,  2053,     0,     0,  2054,     0,     0,  3070,  2055,  2056,
    2057,     0,     0,  1349,     0,     0,     0,     0,     0,     0,
    1497,     0,  1497,   607,     0,  2058,     0,     0,     0,  1512,
    1349,  2827,     0,  2060,     0,     0,     0,     0,     0,   607,
    2061,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1112,     0,     0,
       0,     0,     0,     0,     0,  2062,     0,     0,     0,     0,
       0,     0,  1598,  4754,  1498,   884,  1498,     0,     0,     0,
    1730,  1499,     0,  1499,  1500,     0,  1500,     0,   748,     0,
       0,     0,     0,     0,  3231,     0,   748,     0,  1112,   748,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1501,   748,  1501,     0,     0,   884,     0,     0,     0,     0,
    1112,     0,     0,     0,     0,     0,     0,   884,     0,     0,
    3262,     0,     0,  3262,     0,  3262,     0,     0,     0,  3262,
       0,  3262,  3262,   607,  1502,     0,  1502,     0,     0,     0,
    3262,  3262,  3262,     0,     0,     0,     0,   884,     0,     0,
       0,  2053,     0,   182,  2054,     0,     0,     0,  2055,  2056,
    2057,     0,     0,     0,     0,     0,  2063,     0,     0,     0,
       0,  2064,     0,     0,     0,  2058,     0,     0,  1112,     0,
     182,     0,     0,  2060,     0,     0,     0,     0,     0,     0,
    2061,     0,     0,  2065,  2066,  3338,     0,  1599,     0,  1599,
       0,  1504,     0,  1504,     0,     0,     0,   607,  2067,     0,
       0,  1505,     0,  1505,     0,  2062,     0,     0,     0,     0,
    1506,     0,  1506,   607,  3018,     0,     0,  3369,     0,     0,
       0,   839,  1507,     0,  1507,     0,     0,     0,  3035,  1063,
       0,     0,     0,     0,   604,     0,   884,  2068,     0,     0,
       0,   604,     0,   607,     0,     0,   604,     0,     0,   604,
    4881,  2069,     0,     0,  2070,     0,     0,     0,     0,     0,
       0,  3193,     0,  3063,  1509,  1510,  1509,  1510,     0,  3068,
       0,     0,     0,     0,     0,   604,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1063,     0,     0,  1112,     0,
    1112,     0,     0,     0,  3194,     0,  1511,     0,     0,     0,
    3410,  3412,     0,     0,     0,     0,  3420,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2063,     0,     0,     0,
       0,  2064,     0,     0,     0,     0,     0,   884,   875,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2071,  2065,  2066,     0,   607,     0,     0,     0,
    1112,     0,     0,     0,     0,     0,     0,     0,  2067,     0,
       0,     0,  1512,     0,  1512,     0,     0,     0,     0,   748,
       0,     0,   875,     0,     0,   607,   607,     0,     0,   607,
       0,     0,     0,  2045,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   607,     0,     0,  2068,     0,  4165,
       0,   607,  4170,     0,     0,     0,   607,     0,     0,   607,
     607,  2069,     0,     0,  2070,     0,   607,   607,     0,     0,
       0,     0,     0,     0,   182,     0,     0,     0,     0,   884,
       0,   884,     0,     0,     0,   607,     0,     0,     0,     0,
       0,   604,  2072,     0,     0,  2073,  2074,  2075,     0,  2076,
    2077,  2078,  2079,  2080,  2081,     0,     0,     0,     0,  3881,
       0,     0,     0,     0,     0,   604,  2053,     0,     0,  2054,
       0,     0,  3288,  2055,  2056,  2057,     0,  1112,   884,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   607,     0,
    2058,     0,     0,     0,     0,     0,     0,     0,  2060,     0,
       0,     0,  2071,     0,     0,  2061,     0,     0,     0,     0,
       0,   604,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1063,  1730,     0,     0,
    2062,     0,   607,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2053,     0,     0,  2054,     0,     0,     0,  2055,  2056,
    2057,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3643,     0,   748,  2058,     0,     0,     0,     0,
       0,     0,     0,  2060,     0,     0,     0,     0,     0,     0,
    2061,     0,     0,     0,     0,     0,     0,  3656,  3656,     0,
       0,   607,  2072,  1112,     0,  2073,  2074,  2075,     0,  2076,
    2077,  2078,  2079,  2080,  2081,  2062,     0,     0,     0,  4076,
       0,     0,     0,     0,  5181,   607,     0,   607,     0,     0,
       0,     0,     0,     0,     0,  1063,     0,   607,  1112,     0,
     607,  2063,   607,     0,     0,     0,  2064,     0,  2053,   604,
       0,  2054,     0,     0,     0,  2055,  2056,  2057,     0,     0,
       0,   607,     0,     0,     0,     0,     0,   607,  2065,  2066,
       0,   607,  2058,     0,     0,     0,     0,  1112,  3480,     0,
    2060,   607,     0,  2067,     0,     0,     0,  2061,     0,     0,
       0,     0,     0,     0,     0,  3492,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3500,     0,  2062,   604,     0,  1730,     0,     0,  3627,     0,
       0,     0,  2068,     0,  1112,  3766,  2063,     0,     0,  1112,
    1112,  2064,     0,     0,   607,     0,  2069,     0,     0,   607,
     607,   884,     0,     0,     0,     0,   182,     0,     0,     0,
       0,     0,     0,  2065,  2066,   884,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2067,     0,
       0,     0,     0,     0,     0,     0,     0,   607,     0,     0,
    3805,     0,     0,     0,   607,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2068,     0,   607,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2069,     0,  2063,  2070,     0,     0,  2071,  2064,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   604,     0,     0,     0,  1112,  1112,     0,  3845,     0,
    2065,  2066,     0,   604,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2067,     0,     0,     0,     0,
     607,     0,     0,   607,     0,     0,   607,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   607,     0,     0,
       0,   607,  3262,   607,     0,   607,     0,     0,     0,     0,
       0,     0,     0,     0,  2068,     0,  3878,  3878,     0,     0,
     875,     0,  2071,     0,     0,   607,  3894,     0,  2069,     0,
       0,  2070,  1063,     0,  1063,     0,     0,  2072,     0,     0,
    2073,  2074,  2075,     0,  2076,  2077,  2078,  2079,  2080,  2081,
    1730,     0,   884,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3627,     0,     0,     0,  3627,     0,     0,
       0,     0,     0,  5418,   748,     0,     0,     0,     0,     0,
    3950,     0,  3697,     0,     0,     0,     0,     0,     0,   604,
       0,     0,     0,     0,     0,     0,   875,   875,  3928,     0,
       0,  3708,   607,     0,     0,     0,     0,     0,     0,     0,
       0,   607,     0,     0,  3985,  1063,     0,     0,     0,  2071,
       0,     0,  2072,   607,     0,  2073,  2074,  2075,     0,  2076,
    2077,  2078,  2079,  2080,  2081,     0,     0,     0,     0,  4129,
       0,     0,     0,   607,   607,   607,     0,     0,     0,     0,
       0,     0,   607,  1730,     0,     0,  1112,     0,     0,     0,
       0,     0,   607,     0,     0,     0,   604,   884,     0,     0,
       0,     0,   604,     0,     0,     0,     0,     0,     0,     0,
     607,     0,     0,     0,     0,     0,     0,  4006,     0,     0,
       0,     0,     0,   884,     0,   613,  3790,     0,  3792,     0,
       0,   663,   613,     0,     0,     0,     0,   715,     0,   613,
       0,     0,     0,     0,     0,   613,     0,     0,   770,  2072,
       0,     0,  2073,  2074,  2075,     0,  2076,  2077,  2078,  2079,
    2080,  2081,     0,   607,     0,     0,  4226,   837,   837,   607,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   607,
       0,  2053,     0,     0,  2054,     0,   607,   607,  2055,  2056,
    2057,   607,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   607,     0,     0,   604,  2058,     0,     0,   748,     0,
       0,     0,     0,  2060,     0,     0,     0,  5558,     0,  3843,
    2061,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   884,     0,     0,     0,     0,     0,     0,     0,   875,
     875,     0,     0,  2053,  4130,  2062,  2054,     0,     0,     0,
    2055,  2056,  2057,     0,     0,     0,   607,     0,     0,     0,
    3865,     0,   607,     0,     0,     0,     0,  2058,     0,     0,
       0,     0,     0,     0,     0,  2060,     0,     0,     0,   182,
       0,     0,  2061,     0,     0,     0,     0,     0,     0,     0,
     607,   607,     0,     0,     0,     0,     0,     0,     0,     0,
     607,     0,     0,     0,     0,   607,     0,  2062,     0,     0,
       0,     0,     0,     0,  1730,     0,   871,     0,     0,  1494,
       0,     0,     0,     0,   913,  1495,     0,   915,   182,   182,
     920,   921,     0,   924,     0,   927,   607,     0,   933,     0,
     935,     0,     0,     0,     0,     0,   607,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2063,     0,  3068,     0,
       0,  2064,     0,     0,   607,     0,     0,  1497,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   607,     0,  1730,
       0,     0,     0,  2065,  2066,     0,     0,     0,     0,     0,
       0,     0,     0,  4001,     0,     0,     0,  1730,  2067,   607,
     607,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2063,     0,
       0,  1498,     0,  2064,     0,  3627,     0,     0,  1499,     0,
    3627,  1500,     0,  3627,  3894,     0,     0,  2068,     0,     0,
       0,     0,     0,     0,     0,  2065,  2066,     0,     0,     0,
       0,  2069,     0,     0,  2070,     0,     0,  1501,     0,  4327,
    2067,     0,     0,     0,     0,     0,     0,  4336,     0,     0,
    4337,     0,  4338,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   748,     0,     0,     0,     0,     0,     0,     0,
       0,  1502,     0,     0,     0,     0,     0,     0,     0,  2068,
       0,     0,     0,     0,     0,     0,     0,   748,     0,  4075,
       0,     0,     0,  2069,   748,  4379,  2070,     0,     0,     0,
       0,     0,     0,     0,     0,   748,     0,     0,     0,     0,
       0,  3262,  4085,     0,     0,  3262,  3262,     0,  3262,     0,
       0,     0,  2071,  2053,     0,     0,  2054,     0,     0,     0,
    2055,  2056,  2057,     0,  1599,     0,     0,  4108,  1504,     0,
       0,     0,     0,     0,     0,     0,     0,  2058,  1505,     0,
       0,     0,     0,     0,     0,  2060,     0,  1506,     0,     0,
       0,     0,  2061,   182,     0,     0,     0,     0,     0,  1507,
       0,     0,     0,  1985,     0,     0,     0,     0,     0,     0,
    1184,  1185,     0,     0,  2071,  2053,     0,  2062,  2054,     0,
       0,     0,  2055,  2056,  2057,     0,     0,     0,     0,     0,
       0,   182,     0,     0,     0,     0,     0,     0,  3238,  2058,
       0,  1509,  1510,     0,     0,     0,     0,  2060,  4486,     0,
       0,  3894,  2072,     0,  2061,  2073,  2074,  2075,     0,  2076,
    2077,  2078,  2079,  2080,  2081,     0,     0,     0,     0,  4550,
       0,  3239,     0,     0,     0,     0,     0,     0,     0,  2062,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   748,
       0,     0,     0,     0,     0,  3627,     0,     0,     0,     0,
       0,     0,     0,     0,  2072,  2045,     0,  2073,  2074,  2075,
       0,  2076,  2077,  2078,  2079,  2080,  2081,     0,  2063,     0,
       0,  4588,     0,  2064,     0,     0,  4538,  4538,  4538,  1512,
    4538,  4538,  4538,  4538,  4538,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2065,  2066,     0,     0,     0,
    1015,     0,     0,     0,     0,     0,   748,  1028,  1029,     0,
    2067,  1035,     0,  1038,  1039,     0,     0,     0,  1041,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1060,
    2063,     0,     0,     0,     0,  2064,     0,     0,     0,     0,
       0,     0,     0,  2053,     0,     0,  2054,     0,     0,  2068,
    2055,  2056,  2057,     0,     0,     0,     0,  2065,  2066,     0,
       0,     0,     0,  2069,   675,     0,  2070,     0,  1137,   676,
    1139,     0,  2067,     0,     0,  2060,     0,     0,     0,     0,
    1155,     0,  2061,  3627,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   182,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   677,     0,     0,  2062,     0,     0,
       0,  2068,  4627,   613,  4629,     0,     0,   678,     0,     0,
       0,     0,     0,     0,     0,  2069,     0,     0,  2070,     0,
       0,     0,   679,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     680,     0,     0,     0,  2071,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   681,     0,     0,  4435,     0,     0,     0,
       0,     0,     0,     0,   682,     0,     0,     0,     0,     0,
       0,     0,     0,   683,     0,     0,     0,     0,     0,     0,
       0,   837,     0,     0,     0,   684,     0,     0,     0,     0,
     685,     0,     0,     0,     0,     0,  2071,   686,  2063,     0,
       0,     0,     0,  2064,     0,     0,     0,     0,     0,     0,
       0,     0,   748,     0,     0,     0,   687,  1455,   748,     0,
       0,     0,   748,     0,     0,  2065,  2066,     0,     0,     0,
       0,     0,     0,     0,  2072,     0,     0,  2073,  2074,  2075,
    2067,  2076,  2077,  2078,  2079,  2080,  2081,     0,  4696,  4697,
       0,  4843,     0,  4700,  4701,     0,     0,     0,     0,     0,
       0,     0,   688,     0,     0,     0,     0,     0,  4723,  4724,
       0,     0,     0,     0,     0,     0,   182,     0,     0,  2068,
       0,  3262,     0,  3262,  3262,     0,     0,  3262,     0,     0,
    1630,     0,     0,  2069,     0,     0,  2072,     0,     0,  2073,
    2074,  2075,   689,  2076,  2077,  2078,  2079,  2080,  2081,     0,
       0,  1741,     0,  4853,     0,   690,     0,     0,     0,     0,
       0,     0,     0,  1752,     0,     0,   691,     0,  1755,     0,
       0,     0,     0,     0,     0,     0,   208,   692,  1758,     0,
     693,     0,     0,  1762,     0,     0,     0,     0,  1494,     0,
       0,  4783,  1765,     0,  1495,     0,     0,  1772,     0,     0,
    1776,     0,     0,     0,     0,  1985,   694,     0,     0,   695,
       0,   182,     0,   696,     0,   697,     0,     0,     0,     0,
       0,     0,   698,     0,  2071,   699,     0,     0,     0,  4810,
       0,     0,     0,     0,     0,     0,  1497,     0,     0,   182,
       0,     0,  1830,     0,   700,     0,     0,     0,     0,     0,
       0,   701,     0,     0,     0,     0,     0,   702,     0,     0,
     703,     0,     0,     0,   704,     0,     0,     0,     0,     0,
       0,     0,   705,     0,   706,  4538,     0,     0,     0,   707,
       0,     0,     0,     0,     0,     0,     0,   863,   865,     0,
    1498,   869,   708,   877,   886,     0,     0,  1499,     0,     0,
    1500,   877,     0,   886,   877,   709,     0,     0,     0,     0,
       0,   926,  4659,     0,     0,     0,     0,   886,   936,  5499,
       0,     0,  -130,     0,  2072,     0,  1501,  2073,  2074,  2075,
       0,  2076,  2077,  2078,  2079,  2080,  2081,     0,     0,     0,
       0,     0,     1,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     2,  4682,     3,     4,     0,     0,     0,   613,
    1502,   613,     0,   613,     0,   613,     0,   613,   613,   613,
       5,     0,     0,     0,   613,  4698,     0,     0,     0,     6,
       0,     0,     0,     0,     0,  1980,     0,     0,     0,     0,
       0,     7,     0,     8,     9,     0,     0,     0,     0,     0,
      10,     0,    11,     0,     0,  1993,     0,     0,     0,     0,
       0,     0,     0,    12,     0,    13,     0,     0,     0,  3894,
       0,   182,     0,  1599,     0,     0,     0,  1504,     0,     0,
       0,     0,    14,     0,     0,    15,     0,  1505,     0,     0,
       0,     0,     0,  4725,     0,     0,  1506,     0,     0,    16,
       0,    17,     0,     0,     0,    18,     0,     0,  1507,     0,
       0,    19,     0,     0,  3262,     0,     0,   748,     0,    20,
       0,    21,     0,  4976,     0,     0,     0,     0,    22,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    23,     0,     0,  3719,     0,     0,
    1509,  1510,     0,     0,     0,     0,     0,     0,     0,  2053,
       0,    24,  2054,     0,     0,     0,  2055,  2056,  2057,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3720,     0,  1494,  2058,     0,     0,     0,     0,  1495,     0,
       0,  2060,     0,     0,     0,     0,     0,  2053,  2061,     0,
    2054,    25,    26,     0,  2055,  2056,  2057,    27,     0,     0,
       0,     0,     0,     0,     0,  4815,   837,     0,     0,    28,
       0,  2058,     0,  2062,     0,     0,     0,     0,     0,  2060,
    1497,     0,     0,     0,     0,     0,  2061,    29,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1512,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2062,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    30,     0,  1985,     0,     0,     0,     0,
       0,    31,     0,     0,  1498,     0,     0,     0,     0,     0,
       0,  1499,     0,     0,  1500,    32,     0,     0,  2274,     0,
       0,    33,    34,     0,    35,     0,     0,     0,     0,    36,
       0,     0,     0,     0,    37,     0,     0,    38,     0,     0,
    1501,     0,     0,     0,    39,     0,     0,     0,     0,     0,
      40,    41,     0,     0,  2063,     0,     0,     0,    42,  2064,
       0,     0,    43,     0,     0,     0,     0,  1063,     0,     0,
       0,  5155,    44,     0,  1502,     0,     0,     0,     0,     0,
       0,  2065,  2066,     0,     0,     0,     0,    45,     0,  1006,
    2365,  1009,  2063,     0,     0,  1012,  2067,  2064,   886,     0,
       0,     0,     0,     0,   886,     0,     0,    46,     0,  1037,
       0,     0,     0,     0,     0,   748,  1042,   886,    47,  2065,
    2066,     0,     0,     0,    48,     0,     0,     0,     0,    49,
       0,     0,     0,   886,  2067,  2068,     0,  1599,     0,     0,
       0,  1504,    50,     0,     0,     0,     0,   877,   886,  2069,
       0,  1505,  2070,     0,   877,     0,   886,   877,     0,     0,
    1506,  1464,     0,     0,     0,    51,     0,     0,     0,     0,
     886,     0,  1507,  2068,     0,     0,     0,     0,     0,    52,
     886,     0,  -130,     0,     0,     0,     0,  2069,     0,     0,
    2070,     0,     0,     0,     0,  1465,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3775,     0,     0,  1509,  1510,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2071,     0,     0,  2053,  3776,     0,  2054,     0,     0,     0,
    2055,  2056,  2057,     0,  1063,  1466,     0,     0,  5298,     0,
    5299,     0,     0,     0,  5304,  5305,     0,  2058,     0,   886,
       0,     0,     0,     0,     0,  2060,     0,     0,  2071,     0,
       0,     0,  2061,  1985,     0,     0,     0,     0,     0,     0,
    1467,     0,  5292,   886,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   886,  2062,     0,     0,
       0,     0,  1512,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3843,     0,     0,     0,  1468,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2527,     0,     0,     0,
    2072,     0,     0,  2073,  2074,  2075,     0,  2076,  2077,  2078,
    2079,  2080,  2081,     0,     0,     0,     0,  4862,     0,     0,
    1526,  1527,  1469,     0,     0,     0,  1470,     0,     0,  1985,
       0,     0,     0,     0,  1985,  1985,     0,     0,  2072,     0,
       0,  2073,  2074,  2075,     0,  2076,  2077,  2078,  2079,  2080,
    2081,     0,     0,     0,     0,  4865,     0,  1552,  1472,     0,
       0,     0,     0,     0,  1435,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1732,     0,     0,  2063,     0,
       0,     0,     0,  2064,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   877,     0,     0,  1553,     0,     0,   877,
      36,     0,   877,     0,  1474,  2065,  2066,     0,     0,     0,
       0,     0,     0,  1475,     0,     0,     0,     0,     0,  1761,
    2067,  1476,     0,  2654,     0,  2655,     0,     0,     0,  1554,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1478,  2666,     0,  2667,     0,     0,     0,  1783,  1784,
    1479,  5224,     0,     0,  1480,     0,     0,     0,     0,  2068,
     613,     0,   613,  1063,   613,     0,   613,     0,   613,     0,
       0,     0,   613,  2069,  1825,     0,  2070,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1481,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5524,     0,  1894,  1896,
       0,   886,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2071,     0,     0,     0,     0,   886,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   886,     0,     0,
       0,     0,     0,     0,  5523,     0,  2053,     0,     0,  2054,
       0,     0,     0,  2055,  2056,  2057,     0,     0,     0,     0,
       0,  5524,     0,     0,     0,     0,     0,   886,     0,     0,
    2058,     0,     0,     0,     0,     0,     0,     0,  2060,  5524,
       0,     0,     0,   886,     0,  2061,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   886,
       0,  5375,     0,   886,     0,     0,     0,     0,     0,  5523,
    2062,     0,     0,     0,  2072,     0,     0,  2073,  2074,  2075,
       0,  2076,  2077,  2078,  2079,  2080,  2081,  5523,     0,     0,
       0,  4906,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2953,  2954,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2969,  2970,     0,     0,     0,  2973,  2974,     0,     0,
       0,  2977,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2988,     0,     0,     0,     0,
       0,     0,  2997,     0,     0,     0,  3000,  3001,     0,     0,
    3004,  3005,     0,     0,     0,     0,     0,  3010,     0,     0,
       0,  2063,   886,     0,     0,     0,  2064,     0,     0,     0,
     886,   886,  3029,     0,  3031,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   886,     0,     0,     0,  2065,  2066,
       0,     0,  3054,     0,     0,     0,     0,  3056,     0,     0,
       0,     0,     0,  2067,     0,     0,     0,     0,     0,     0,
       0,     0,  3062,     0,     0,     0,     0,     0,     0,     0,
       0,  3069,     0,     0,  3073,     0,  3075,  3078,  3080,     0,
       0,     0,     0,  3088,  3091,     0,     0,  1732,     0,     0,
       0,     0,  2068,  3104,     0,     0,     0,     0,  3113,     0,
       0,     0,  3116,     0,     0,     0,  2069,     0,     0,  2070,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3133,
       0,     0,     0,     0,     0,  3142,  3143,     0,     0,     0,
       0,     0,  3148,     0,     0,     0,     0,     0,  2053,     0,
       0,  2054,  3162,  3163,  2294,  2055,  2056,  2057,  3167,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3174,     0,  2058,  3177,     0,     0,     0,     0,  3180,  2333,
    2060,     0,     0,     0,  3183,  3184,     0,  2061,     0,     0,
    3188,     0,     0,  3192,     0,     0,     0,  3199,  3200,  3201,
    3202,     0,  3204,     0,     0,   885,     0,  2071,     0,     0,
       0,     0,  2062,     0,   885,  3229,  3230,     0,  3232,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   885,  3241,
    3242,  3243,     0,     0,  2053,     0,     0,  2054,     0,     0,
       0,  2055,  2056,  2057,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2415,     0,  2058,     0,
       0,     0,     0,     0,     0,     0,  2060,     0,     0,     0,
       0,     0,     0,  2061,     0,     0,     0,     0,     0,     0,
       0,     0,  2438,  2439,  2440,  2441,     0,     0,     0,     0,
       0,     0,  3296,  2053,   886,     0,  2054,     0,  2062,     0,
    2055,  2056,  2057,     0,     0,     0,     0,  2072,     0,     0,
    2073,  2074,  2075,     0,  2076,  2077,  2078,  2079,  2080,  2081,
    3333,     0,     0,  2063,  4941,  2060,     0,     0,  2064,     0,
       0,     0,  2061,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2065,  2066,     0,     0,     0,     0,     0,  2062,     0,     0,
       0,     0,     0,     0,     0,  2067,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2068,     0,     0,     0,     0,  2063,
       0,     0,     0,     0,  2064,     0,     0,     0,  2069,     0,
       0,  2070,     0,  2493,  2494,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2065,  2066,     0,     0,
       0,     0,  1732,  2517,     0,     0,     0,     0,     0,     0,
       0,  2067,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   886,     0,  2063,     0,
       0,     0,     0,  2064,   886,     0,     0,     0,  2562,  2563,
    2564,  2565,     0,     0,     0,     0,   886,     0,     0,     0,
    2068,     0,     0,     0,     0, -2673, -2673,     0,     0,     0,
       0,     0,     0,     0,  2069,     0,     0,  2070,     0,  2071,
    2067,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3503,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0, -2673,
       0,     0,     0,     0,     0,     0,     0,     0,   877,   877,
       0,   886,   886,  2069,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   877,     0,   886,   877,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   886,   886,
       0,     0,     0,     0,     0,  2071,  2664,     0,     0,     0,
       0,     0,  2668,     0,   886,     0,     0,     0,     0,  2072,
       0,     0,  2073,  2074,  2075,     0,  2076,  2077,  2078,  2079,
    2080,  2081,     0,     0,     0,     0,  4983,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   877,   885,
       0,   877,   877,     0,     0,   885,     0,     0,     0,     0,
       0,     0,     0,     0,  2071,     0,     0,     0,   885,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   885,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   885,
       0,     0,     0,     0,     0,  2072,     0,   885,  2073,  2074,
    2075,     0,  2076,  2077,  2078,  2079,  2080,  2081,     0,     0,
       0,   885,  5286,     0,     0,     0,     0,     0,     0,     0,
       0,   885,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1732,     0,     0,     0,     0,  2837,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2072,     0,     0,  2073,  2074,  2075,
       0,  2076,  2077,  2078,  2079,  2080,  2081,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3694,     0,     0,     0,
    3696,     0,     0,     0,     0,     0,  3698,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   886,     0,     0,  3709,  3711,     0,     0,     0,  3711,
     885,     0,     0,     0,  3722,  3723,  3724,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   889,     0,     0,   885,     0,     0,     0,     0,     0,
       0,     0,     0,   923,     0,     0,     0,   885,     0,     0,
    3753,  3754,  3755,  3756,   942,     0,   886,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   886,     0,     0,     0,     0,  1732,
     886,     0,     0,     0,   886,     0,     0,  3774,     0,  3778,
    3779,  3780,   886,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     886,     0,     0,     0,     0,     0,     0,     0,     0,  2053,
       0,     0,  2054,     0,     0,     0,  2055,  2056,  2057,  3016,
    3017,     0,   877,     0,     0,   877,   877,     0,     0,     0,
    3030,     0,  3032,  2058,     0,     0,  3036,     0,     0,     0,
       0,  2060,     0,     0,     0,   886,  1731,     0,  2061,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   886,   886,     0,     0,     0,
       0,     0,     0,  2062,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3853,     0,     0,  1732,   886,     0,     0,
    1732,     0,  3859,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   886,     0,  1732,     0,     0,     0,   886,
       0,     0,     0,  3873,     0,     0,   886,     0,     0,     0,
       0,     0,     0,   886,     0,     0,   886,     0,     0,     0,
       0,     0,   886,     0,     0,     0,  3916,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3173,     0,     0,  3176,
       0,     0,   886,     0,     0,     0,     0,     0,   886,     0,
       0,     0,     0,   886,  2063,     0,  1732,     0,     0,  2064,
       0,     0,     0,     0,     0,     0,   886,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3953,   886,
       0,  2065,  2066,  3959,  1732,     0,     0,     0,     0,     0,
     886,     0,   885,     0,     0,     0,  2067,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     885,     0,     0,     0,     0,     0,     0,  3998,     0,     0,
       0,     0,  3265,     0,     0,     0,     0,     0,   885,     0,
    3272,     0,     0,  3275,     0,  2068,     0,     0,     0,  3277,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2069,
    3289,     0,  2070,     0,     0,     0,  1732,     0,   885,     0,
    4017,     0,  4018,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   885,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     885,  3335,     0,     0,   885,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   956,     0,  2053,     0,     0,
    2054,  1004,  4057,     0,  2055,  2056,  2057,     0,     0,  3358,
       0,     0,     0,     0,     0,     0,     0,  2053,     0,     0,
    2054,  2058,     0,     0,  2055,  2056,  2057,   886,     0,  2060,
    2071,     0,     0,     0,     0,  2053,  2061,     0,  2054,     0,
       0,  2058,  2055,  2056,  2057,     0,     0,     0,     0,  2060,
       0,     0,     0,     0,     0,     0,  2061,     0,     0,  2058,
       0,  2062,     0,     0,     0,     0,     0,  2060,  3425,     0,
    3427,     0,     0,     0,  2061,     0,     0,     0,     0,     0,
       0,  2062,     0,   886,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2062,
       0,     0,     0,   885,     0,     0,     0,     0,     0,     0,
       0,   885,   885,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   885,     0,   886,     0,     0,
    2072,     0,     0,  2073,  2074,  2075,     0,  2076,  2077,  2078,
    2079,  2080,  2081,     0,     0,   886,     0,  5309,     0,     0,
       0,     0,     0,   886,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   877,     0,     0,   877,     0,     0,   877,
       0,     0,  2063,     0,     0,     0,     0,  2064,  1731,     0,
    3502,     0,  1342,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2063,     0,     0,     0,     0,  2064,     0,  2065,
    2066,  1365,     0,     0,     0,     0,     0,  4243,     0,  4244,
    2063,     0,     0,     0,  2067,  2064,  4246,     0,     0,  2065,
    2066,     0,     0,  1389,     0,     0,     0,     0,     0,     0,
       0,     0,  4256,     0,  2067,     0,  1732,  2065,  2066,     0,
       0,     0,  1732,     0,  4262,     0,     0,     0,  4265,     0,
       0,     0,  2067,  2068,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4287,  2069,     0,  1525,
    2070,     0,     0,  2068,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4291,     0,     0,  2069,     0,  4295,
    2070,  2068,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2069,     0,     0,  2070,     0,
       0,     0,     0,     0,  4330,     0,     0,     0,  4334,     0,
       0,     0,     0,     0,   886,     0,  4339,  4340,  4341,  4342,
       0,     0,     0,     0,     0,  4347,  4348,  4349,  4350,     0,
       0,     0,  4352,  4353,     0,     0,     0,     0,  4360,  4361,
       0,  4363,  4364,  4365,  4366,  4367,  4368,  4369,  2071,     0,
       0,     0,     0,     0,     0,     0,     0,  4378,     0,     0,
       0,  4381,  4382,  4383,  4384,   885,     0,     0,  2071,     0,
       0,     0,  2053,     0,     0,  2054,     0,     0,     0,  2055,
    2056,  2057,     0,     0,     0,  1781,  2071,  3711,     0,     0,
       0,     0,     0,   886,   886,     0,  2058,     0,     0,     0,
       0,     0,     0,     0,  2060,     0,  4407,     0,     0,     0,
       0,  2061,     0,     0,  1819,  1822,  1823,     0,     0,     0,
     886,     0,     0,   886,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3700,  2062,  3701,  3702,  3703,
       0,     0,     0,     0,     0,     0,     0,     0,  2072,     0,
       0,  2073,  2074,  2075,     0,  2076,  2077,  2078,  2079,  2080,
    2081,     0,     0,     0,     0,  5417,     0,     0,  2072,     0,
       0,  2073,  2074,  2075,     0,  2076,  2077,  2078,  2079,  2080,
    2081,     0,     0,     0,     0,  5486,  2072,     0,     0,  2073,
    2074,  2075,     0,  2076,  2077,  2078,  2079,  2080,  2081,     0,
       0,     0,     0,  5543,     0,     0,  3711,  1732,  1732,  1732,
       0,     0,     0,  1731,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   886,     0,     0,     0,     0,     0,   885,     0,     0,
       0,     0,     0,     0,     0,   885,     0,  2063,     0,     0,
       0,   886,  2064,     0,     0,     0,     0,   885,  4532,     0,
       0,     0,  1342,     0,     0,     0,     0,     0,     0,     0,
     886,     0,     0,     0,  2065,  2066,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1992,     0,     0,     0,  2067,
       0,     0,     0,     0,  1342,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2068,     0,
       0,     0,   885,   885,     0,     0,     0,     0,     0,     0,
       0,     0,  2069,     0,     0,  2070,   885,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   886,     0,     0,   885,
     885,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   885,     0,     0,  3866,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1732,     0,     0,     0,     0,     0,     0,
     886,     0,   886,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   886,     0,   886,     0,     0,
       0,     0,  2124,  2071,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1732,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4662,     0,     0,     0,  4663,  4664,  4665,  4666,     0,     0,
       0,  4668,     0,     0,     0,     0,     0,     0,  2179,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1111,
       0,     0,     0,   886,     0,     0,     0,     0,     0,     0,
       0,     0,  1731,     0,     0,  4688,  4689,  4690,  4691,  4692,
       0,  4694,  4695,     0,     0,  1111,     0,     0,     0,     0,
       0,     0,     0,  4704,  4705,     0,     0,     0,     0,     0,
       0,     0,     0,  2072,     0,     0,  2073,  2074,  2075,     0,
    2076,  2077,  2078,  2079,  2080,  2081,     0,     0,   886,     0,
    5557,     0,     0,  4710,  4021,     0,     0,     0,     0,     0,
       0,  2306,     0,     0,     0,     0,     0,     0,     0,     0,
    2329,     0,   885,     0,     0,     0,   886,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   886,     0,
       0,   886,  2366,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2389,     0,   885,  2392,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   885,     0,     0,     0,     0,
    1731,   885,     0,     0,     0,   885,     0,  4774,     0,     0,
       0,     0,     0,   885,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2442,   885,     0,  1732,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2461,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4827,     0,     0,
       0,     0,     0,     0,     0,     0,   885,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   885,   885,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1646,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1111,     0,  1731,   885,     0,
       0,  1731,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1111,     0,     0,     0,   885,  2485,  1731,     0,     0,     0,
     885,     0,     0,     0,     0,  1111,     0,   885,  4249,  4250,
    4251,  4252,     0,     0,   885,     0,   886,   885,     0,     0,
       0,     0,     0,   885,     0,     0,     0,     0,     0,     0,
     613,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   885,     0,     0,  2536,     0,     0,   885,
       0,     0,     0,     0,   885,     0,     0,  1731,     0,     0,
       0,     0,     0,     0,     0,     0,  1732,   885,     0,     0,
       0,  1732,     0,  1732,     0,  2579,     0,     0,     0,     0,
     885,     0,  2592,     0,  4930,  1731,     0,     0,     0,     0,
    1111,   885,     0,     0,     0,     0,  1732,     0,  1318,  1318,
       0,     0,     0,  4940,     0,     0,     0,     0,  4945,  4946,
       0,     0,     0,     0,     0,     0,  1732,     0,  4957,     0,
       0,     0,     0,     0,     0,  4959,     0,     0,     0,     0,
       0,     0,   886,     0,     0,   886,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1731,     0,     0,
       0,  5009,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5026,     0,  5028,     0,     0,     0,  4403,  2671,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5042,  2179,
       0,     0,  4406,     0,     0,     0,     0,  1111,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3711,     0,
       0,     0,     0,     0,     0,     0,     0,   886,   886,     0,
    1342,  1342,     0,     0,     0,     0,  5069,   886,   885,     0,
       0,     0,     0,  2053,     0,     0,  2054,  2724,  1643,  1647,
    2055,  2056,  2057,     0,     0,     0,   886,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2058,     0,     0,
       0,     0,     0,     0,     0,  2060,     0,     0,     0,     0,
       0,     0,  2061,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   885,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2062,     0,     0,
       0,     0,     0,     0,     0,     0,  5119,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5127,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   885,     0,
       0,     0,     0,     0,     0,     0,     0,  2892,     0,   886,
       0,     0,     0,     0,     0,     0,   885,  2898,     0,     0,
       0,     0,     0,     0,   885,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2053,     0,     0,  2054,     0,
       0,     0,  2055,  2056,  2057,     0,  1389,     0,     0,     0,
       0,     0,     0,  5186,     0,     0,     0,  1389,  1389,  2058,
       0,     0,     0,  2919,     0,     0,     0,  2060,     0,     0,
       0,     0,     0,     0,  2061,     0,     0,  2201,  2063,     0,
       0,     0,     0,  2064,     0,     0,     0,     0,     0,     0,
       0,  1342,     0,     0,     0,     0,     0,     0,     0,  2062,
       0,     0,     0,     0,     0,  2065,  2066,  1731,     0,     0,
       0,     0,     0,  1731,     0,     0,     0,     0,  3711,     0,
    2067,     0,  5231,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2201,     0,     0,  2920,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2068,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2069,     0,     0,  2070,  5274,     0,     0,
       0,     0,     0,     0,     0,     0,  1111,     0,     0,     0,
       0,     0,  5287,     0,     0,   885,     0,     0,     0,     0,
    2009,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2063,     0,     0,     0,     0,  2064,     0,     0,     0,  1111,
       0,     0,     0,     0,     0,   886,     0,     0,     0,     0,
    1732,  2024,     0,     0,  3072,     0,  5316,  2065,  2066,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3094,
       0,  5327,  2067,     0,     0,     0,     0,     0,     0,  2042,
    2043,  2044,     0,  2046,  2071,   886,     0,     0,     0,     0,
    3121,     0,     0,     0,   885,   885,     0,   886,     0,     0,
       0,     0,     0,  2088,     0,     0,     0,     0,     0,     0,
       0,  2068,     0,     0,     0,  1646,  1646,  1646,     0,     0,
       0,   885,     0,     0,   885,  2069,     0,   886,  2070,  1494,
       0,     0,     0,     0,     0,  1495,  1101,     0,     0,     0,
    4718,     0,  1561,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5391,  4722,     0,     0,     0,     0,
       0,  1562,  1101,     0,     0,     0,  3197,  3198,     0,     0,
       0,  2146,     0,     0,     0,  2158,  2163,  1497,     0,     0,
       0,     0,     0,     0,  2072,     0,     0,  2073,  2074,  2075,
       0,  2076,  2077,  2078,  2079,  2080,  2081,     0,  5413,  2481,
       0,     0,     0,     0,     0,     0,     0,     0,  1731,  1731,
    1731,  1563,     0,     0,     0,     0,  2071,     0,  1111,     0,
       0,     0,     0,     0,  1110,     0,   886,     0,     0,     0,
       0,  1498,   885,     0,     0,  1111,     0,     0,  1499,     0,
       0,  1500,     0,     0,     0,     0,     0,     0,  4788,     0,
    1110,     0,   885,  1111,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1501,     0,     0,
       0,   885,     0,  3322,     0,     0,  2921,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5479,
       0,     0,     0,     0,     0,     0,     0,     0,  1564,     0,
       0,  1502,     0,     0,     0,     0,     0,     0,     0,  1111,
       0,     0,     0,     0,     0,     0,  2072,   886,     0,  2073,
    2074,  2075,  1111,  2076,  2077,  2078,  2079,  2080,  2081,     0,
       0,     0,     0,     0,     0,  1111,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1565,  1111,     0,  1566,
       0,     0,     0,     0,     0,     0,     0,   885,     0,     0,
       0,     0,     0,     0,  1567,     0,     0,     0,  1504,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1505,     0,
       0,     0,     0,     0,     0,     0,     0,  1506,     0,     0,
       0,  1111,  1111,     0,     0,     0,     0,     0,  1568,  1507,
       0,     0,     0,     0,  1731,     0,     0,     0,     0,     0,
       0,   885,     0,   885,  1643,  1643,  1643,     0,     0,   886,
       0,   886,  1101,     0,     0,     0,   885,     0,   885,  4911,
       0,  4912,     0,     0,     0,     0,     0,     0,  3168,     0,
       0,  1509,  1510,  1570,     0,     0,     0,  1101,     0,     0,
    1731,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1101,     0,     0,  1571,     0,     0,   886,     0,
       0,  3169,     0,     0,     0,     0,     0,     0,   877,     0,
       0,     0,     0,     0,     0,  1573,     0,     0,     0,     0,
       0,     0,     0,     0,   885,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1110,     0,     0,     0,     0,     0,     0,  1732,     0,     0,
       0,     0,   877,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1111,     0,     0,  1110,     0,     0,     0,  1512,
       0,     0,     0,     0,     0,     0,     0,  1101,     0,   885,
    1110,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1646,     0,     0,     0,     0,     0,     0,   885,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5047,     0,     0,     0,     0,     0,     0,     0,   885,
       0,     0,   885,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3619,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1110,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2053,     0,  1389,  2054,
       0,     0,     0,  2055,  2056,  2057,     0,     0,     0,     0,
       0,     0,     0,     0,  1101,     0,     0,     0,     0,  2957,
    2058,     0,     0,  2201,  2963,     0,     0,     0,  2060,     0,
       0,     0,     0,     0,  1731,  2061,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1732,     0,     0,     0,     0,
    2062,     0,     0,     0,     0,     0,     0,     0,  2053,     0,
       0,  2054,     0,     0,     0,  2055,  2056,  2057,     0,     0,
       0,   886,     0,     0,     0,  1111,     0,  5142,     0,  5144,
       0,     0,  2058,     0,     0,   886,     0,     0,     0,  1111,
    2060,     0,  1110,     0,     0,     0,     0,  2061,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2062,     0,     0,     0,     0,     0,  2767,     0,
    1111,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2787,     0,  2788,     0,  2790,     0,     0,  2802,  2805,  2810,
       0,     0,     0,  1103,  2816,     0,     0,  2821,     0,     0,
       0,  2063,     0,     0,     0,     0,  2064,   885,     0,     0,
       0,     0,  2828,  2829,  2830,  2831,     0,     0,     0,  1103,
    2838,     0,     0,     0,  2856,     0,     0,  2858,  2065,  2066,
    2865,  2866,  2867,  2868,  2869,  2870,  2871,  2872,  2873,     0,
    2874,     0,     0,  2067,     0,     0,     0,  1318,  5448,  1643,
       0,     0,     0,     0,  1101,  3796,     0,  1731,     0,     0,
       0,     0,  1731,     0,  1731,     0,     0,     0,     0,     0,
       0,     0,     0,  2063,     0,     0,  2109,     0,  2064,     0,
       0,     0,  2068,     0,     0,     0,     0,  1731,     0,     0,
       0,     0,  2911,     0,     0,     0,  2069,     0,     0,  2070,
    2065,  2066,     0,     0,     0,     0,     0,  1731,     0,     0,
    1732,     0,   886,     0,     0,  2067,  2043,  2044,  3528,     0,
       0,     0,  1101,   885,     0,     0,   885,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1646,     0,     0,     0,
       0,     0,  1110,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5323,  2068,     0,     0,     0,     0,     0,
       0,     0,     0,  1101,     0,     0,     0,     0,  2069,     0,
       0,  2070,     0,  1111,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2071,     0,     0,
       0,     0,     0,     0,  5449,     0,  1101,  2053,  3002,     0,
    2054,     0,     0,     0,  2055,  2056,  2057,     0,     0,     0,
    1110,     0,     0,  1732,     0,     0,     0,     0,   885,   885,
       0,  2058,  3919,  3920,  3921,     0,     0,   886,   885,  2060,
       0,     0,     0,     0,     0,     0,  2061,     0,     0,  3930,
     877,     0,     0,     0,     0,     0,     0,   885,     0,     0,
       0,  1110,     0,   886,     0,  2201,     0,  5397,  2201,  2071,
       0,  2062,  3946,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3956,  3958,     0,     0,     0,  3963,     0,  1103,
       0,     0,     0,     0,  1110,     0,     0,  2072,     0,     0,
    2073,  2074,  2075,     0,  2076,  2077,  2078,  2079,  2080,  2081,
       0,     0,     0,     0,  1103,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   877,   877,     0,  1103,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     885,     0,     0,     0,     0,     0,     0,     0,  3555,     0,
       0,     0,     0,  3556,     0,     0,     0,  5472,     0,  2072,
       0,   886,  2073,  2074,  2075,     0,  2076,  2077,  2078,  2079,
    2080,  2081,  2063,     0,     0,  1101,     0,  2064,     0,  1111,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5488,
    5488,     0,  1101,     0,     0,     0,  1111,     0,     0,  2065,
    2066,     0,  4056,     0,  1103,  1342,     0,     0,     0,     0,
    1101,  1111,     0,     0,  2067,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3253,  3254,  1643,     0,     0,     0,  3258,
       0,     0,     0,     0,  1732,     0,     0,     0,     0,     0,
       0,     0,     0,  2068,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1110,     0,     0,  1101,  2069,     0,     0,
    2070,  3287,     0,     0,     0,     0,     0,     0,     0,  1101,
    1110,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1101,  5488,     0,     0,     0,     0,  1110,     0,
       0,     0,     0,     0,  1101,     0,     0,     0,     0,  1732,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1103,     0,     0,     0,     0,     0,  1732,     0,   877,
     877,     0,     0,     0,     0,     0,     0,     0,  4162,  4163,
    4164,     0,     0,     0,     0,     0,     0,     0,  1101,  1101,
       0,     0,     0,     0,  1110,     0,   885,     0,  2071,     0,
       0,  1731,     0,     0,     0,     0,     0,  1110,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1110,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1110,     0,     0,     0,   885,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   885,     0,
       0,     0,     0,     0,  2201,     0,     0,  2963,     0,  2963,
       0,     0,     0,     0,  2201,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1110,  1110,   885,     0,
       0,     0,     0,     0,     0,     0,     0,  2053,     0,     0,
    2054,     0,     0,     0,  2055,  2056,  2057,     0,  2072,     0,
       0,  2073,  2074,  2075,     0,  2076,  2077,  2078,  2079,  2080,
    2081,  2058,     0,  1111,     0,     0,     0,     0,     0,  2060,
       0,     0,     0,     0,     0,     0,  2061,  1104,     0,  1101,
       0,     0,  1111,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2062,     0,  1104,     0,     0,     0,  2201,     0,     0,
       0,  3508,     0,     0,     0,     0,  3514,     0,     0,     0,
       0,  1103,     0,     0,     0,     0,     0,   885,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2046,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2810,     0,  2810,  2810,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3574,  1110,     0,  3577,
       0,  3579,     0,     0,     0,     0,     0,  1111,     0,  1111,
       0,     0,     0,     0,     0,     0,     0,  2053,     0,  1103,
    2054,     0,     0,     0,  2055,  2056,  2057,     0,     0,     0,
       0,     0,     0,     0,  4404,     0,  3600,     0,  3603,     0,
    3605,  2058,  2063,     0,  3512,  4417,  1101,  2064,   885,  2060,
    1101,  1101,     0,     0,     0,     0,  2061,     0,     0,     0,
    1103,     0,     0,     0,     0,     0,     0,     0,     0,  2065,
    2066,     0,     0,     0,     0,     0,  4448,     0,     0,     0,
       0,  2062,     0,     0,  2067,     0,     0,     0,     0,  2053,
       0,     0,  2054,  1103,     0,  2146,  2055,  2056,  2057,     0,
    1111,     0,     0,     0,     0,     0,     0,     0,     0,  2592,
    2163,     0,  1101,  2058,     0,     0,  3560,     0,     0,     0,
       0,  2060,     0,  2068,     0,     0,  1101,  1646,  2061,     0,
       0,     0,     0,  1646,  1110,     0,     0,  2069,  1110,  1110,
    2070,  1111,     0,     0,     0,     0,     0,     0,     0,     0,
     885,     0,   885,  2062,     0,     0,     0,     0,     0,     0,
    2671,     0,     0,     0,  3680,  4121,     0,  1101,     0,     0,
    2963,  2053,     0,     0,  2054,     0,     0,     0,  2055,  2056,
    2057,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2063,  1104,     0,  2058,     0,  2064,     0,   885,
    1110,     0,     0,  2060,     0,     0,     0,     0,     0,     0,
    2061,     0,     0,     0,  1110,     0,     0,     0,  1104,  2065,
    2066,     0,     0,     0,     0,     0,     0,     0,  2071,     0,
       0,     0,     0,  1104,  2067,  2062,     0,     0,     0,  1111,
       0,     0,     0,     0,     0,  4122,     0,     0,  1731,     0,
       0,     0,     0,     0,     0,  1110,     0,     0,     0,     0,
    2963,     0,     0,     0,  2063,     0,     0,     0,     0,  2064,
       0,     0,  1103,  2068,  1111,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2069,     0,  1103,
    2070,  2065,  2066,     0,     0,     0,  4595,  4596,  4597,  4598,
       0,     0,     0,     0,     0,     0,  2067,  1103,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1104,     0,
       0,     0,     0,     0,     0,     0,     0,  3565,  2072,     0,
       0,  2073,  2074,  2075,     0,  2076,  2077,  2078,  2079,  2080,
    2081,     0,     0,     0,     0,  2068,  2063,     0,     0,     0,
       0,  2064,     0,     0,     0,     0,     0,     0,     0,  2069,
       0,     0,  2070,  1103,     0,     0,     0,     0,     0,     0,
    1101,     0,     0,  2065,  2066,     0,  1103,     0,  2071,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2067,  1103,
    1111,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1103,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1111,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1643,  2068,     0,     0,
       0,     0,  1643,     0,     0,  1104,  1731,     0,  1111,     0,
       0,  2069,     0,     0,  2070,  1103,  1103,     0,     0,     0,
    2071,     0,  1101,     0,     0,  1101,     0,     0,  1110,     0,
       0,     0,   885,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1111,     0,   885,     0,  2072,     0,
       0,  2073,  2074,  2075,     0,  2076,  2077,  2078,  2079,  2080,
    2081,     0,     0,     0,     0,     0,     0,     0,     0,  2053,
       0,     0,  2054,     0,     0,     0,  2055,  2056,  2057,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2058,     0,     0,  3571,     0,     0,     0,
       0,  2060,  2071,     0,     0,     0,     0,     0,  2061,     0,
    1110,     0,     0,  1110,     0,     0,     0,     0,     0,  2201,
    2072,     0,     0,  2073,  2074,  2075,     0,  2076,  2077,  2078,
    2079,  2080,  2081,  2062,  2053,     0,     0,  2054,     0,     0,
       0,  2055,  2056,  2057,     0,     0,  1101,     0,     0,     0,
       0,  1106,     0,     0,     0,     0,  1103,     0,  2058,     0,
       0,     0,     0,  1101,     0,     0,  2060,     0,     0,     0,
       0,     0,     0,  2061,     0,     0,     0,  1106,  1101,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2062,     0,
       0,     0,  2072,     0,     0,  2073,  2074,  2075,  4817,  2076,
    2077,  2078,  2079,  2080,  2081,  1104,     0,     0,  2963,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1731,     0,   885,  1110,     0,     0,     0,     0,     0,
       0,     0,     0,  2963,  2063,     0,     0,     0,     0,  2064,
       0,  1110,     0,     0,     0,     0,  4073,     0,     0,     0,
       0,     0,     0,     0,     0,  4077,  1110,     0,     0,     0,
       0,  2065,  2066,  4079,     0,  4080,     0,     0,     0,     0,
       0,     0,     0,  1104,     0,     0,  2067,     0,     0,     0,
       0,     0,     0,  1103,     0,     0,     0,  1103,  1103,     0,
       0,     0,  4104,  4105,     0,     0,     0,     0,     0,  2063,
       0,     0,     0,     0,  2064,     0,     0,     0,     0,     0,
    2816,     0,     0,     0,  1104,  2068,     0,     0,  4131,     0,
       0,  4134,     0,  4136,  1731,     0,  2065,  2066,     0,  2069,
       0,     0,  2070,     0,     0,  4141,     0,     0,   885,     0,
       0,  2067,     0,  4148,  4149,     0,     0,  1104,     0,  1103,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1103,   885,     0,     0,  1111,     0,     0,
       0,  1101,     0,     0,  1101,  4195,  1101,     0,     0,     0,
    2068,  1101,     0,     0,     0,     0,     0,  1107,     0,     0,
       0,     0,     0,     0,  2069,     0,     0,  2070,     0,     0,
       0,  4210,     0,     0,  1103,     0,     0,     0,     0,     0,
       0,     0,     0,  1107,     0,  2963,     0,     0,     0,  2201,
    2071,     0,     0,     0,     0,     0,     0,  1106,     0,     0,
    1101,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4981,     0,     0,     0,     0,     0,     0,     0,  1101,
       0,     0,  1106,     0,     0,     0,  4994,     0,     0,  1110,
       0,  1342,  1110,     0,  1110,     0,     0,  1106,     0,  1110,
       0,     0,   885,     0,  1101,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2071,     0,  5031,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4072,  1110,     0,
    2072,     0,     0,  2073,  2074,  2075,  1104,  2076,  2077,  2078,
    2079,  2080,  2081,     0,     0,     0,     0,  1110,     0,     0,
       0,     0,     0,  1104,  1101,     0,  1101,     0,     0,     0,
       0,     0,  1106,     0,     0,  1731,     0,     0,     0,     0,
       0,  1104,  1110,     0,     0,     0,  1111,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1111,     0,     0,     0,
       0,     0,     0,     0,     0,  2072,     0,     0,  2073,  2074,
    2075,     0,  2076,  2077,  2078,  2079,  2080,  2081,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1103,     0,     0,
       0,     0,  5115,     0,     0,     0,     0,  1104,     0,     0,
    1731,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1104,     0,  1110,     0,  1110,     0,     0,  1101,  1731,     0,
       0,     0,     0,  1104,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1104,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1106,
       0,     0,     0,  1107,     0,     0,     0,     0,  1101,     0,
       0,     0,     0,  1111,     0,     0,     0,     0,     0,  1103,
       0,     0,  1103,     0,     0,     0,     0,     0,  1107,  1104,
    1104,     0,     0,     0,     0,     0,     0,  1101,     0,     0,
       0,     0,  5193,  1107,     0,     0,     0,     0,     0,  4493,
    4494,     0,     0,     0,  1111,  1110,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1111,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1109,     0,
       0,     0,     0,     0,     0,     0,  1110,     0,     0,     0,
       0,     0,     0,  4522,     0,     0,  1101,     0,     0,     0,
       0,     0,     0,     0,  1109,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1110,     0,  1101,  1107,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4547,
       0,  1101,     0,  1103,  1111,     0,     0,     0,     0,     0,
       0,  4553,     0,     0,     0,     0,     0,     0,     0,     0,
    1103,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1104,     0,     0,     0,     0,  1103,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4571,  4573,  1110,     0,     0,     0,     0,  4577,
    4578,     0,     0,     0,  4579,     0,     0,     0,     0,  1106,
    4582,     0,     0,  4585,  4586,  1110,     0,     0,  4590,     0,
       0,     0,     0,     0,  4594,     0,     0,     0,     0,  1110,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1107,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1101,     0,     0,
       0,     0,     0,     0,  4814,     0,  1111,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1106,  1318,     0,
    1101,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4641,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1101,     0,  1104,     0,     0,
       0,  1104,  1104,     0,     0,     0,  2053,     0,  1106,  2054,
       0,     0,     0,  2055,  2056,  2057,  1111,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2058,  1101,     0,  4128,     0,  1110,     0,     0,  2060,     0,
       0,  1106,     0,     0,     0,  2061,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1110,     0,
       0,     0,     0,  1104,  1109,     0,     0,     0,  1103,     0,
    2062,  1103,     0,  1103,     0,     0,     0,  1104,  1103,     0,
       0,     0,     0,  1110,     0,     0,     0,     0,  4707,  1109,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1109,     0,  1101,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1104,  1110,
       0,     0,     0,     0,     0,     0,     0,  1103,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2963,     0,  1107,  1103,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4745,     0,     0,     0,     0,     0,     0,     0,
       0,  1103,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2063,     0,     0,     0,     0,  2064,     0,     0,  1109,
       0,     0,     0,     0,  1110,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1101,     0,     0,  2065,  2066,
       0,     0,     0,  1107,     0,     0,     0,     0,     0,     0,
    1106,     0,     0,  2067,     0,  2053,     0,     0,  2054,     0,
    1101,     0,  2055,  2056,  2057,     0,     0,  1106,     0,     0,
       0,  1103,     0,  1103,     0,     0,     0,     0,     0,  2058,
       0,     0,     0,     0,  1107,  1106,     0,  2060,     0,     0,
       0,     0,  2068,     0,  2061,     0,     0,     0,     0,  2963,
       0,     0,     0,     0,     0,     0,  2069,     0,     0,  2070,
       0,     0,     0,     0,     0,     0,     0,  1107,     0,  2062,
       0,     0,     0,  1110,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1111,     0,  1109,     0,     0,     0,
       0,  1106,     0,     0,     0,     0,     0,     0,  1110,     0,
       0,  1104,     0,     0,  1106,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1103,     0,     0,  1106,     0,     0,
    4859,  4860,     0,  1111,  4861,     0,     0,     0,     0,  1106,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1101,     0,     0,  2071,     0,     0,
       0,     0,     0,     0,     0,  1103,     0,     0,     0,     0,
       0,  4896,  4897,     0,     0,     0,     0,     0,     0,     0,
    1111,     0,     0,  1106,  1106,  1111,  1111,     0,     0,     0,
    2063,     0,     0,  1104,  1103,  2064,  1104,     0,     0,     0,
       0,     0,  1101,     0,     0,     0,  1101,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2065,  2066,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2067,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1110,     0,     0,     0,   959,     0,     0,     0,
       0,   960,     0,     0,     0,     0,  1107,  2072,     0,     0,
    2073,  2074,  2075,  1103,  2076,  2077,  2078,  2079,  2080,  2081,
       0,  2068,     0,  1107,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1103,  2069,   961,     0,  2070,     0,
    1110,  1107,     0,     0,  1110,     0,     0,     0,  1103,   962,
     963,  4814,  1111,     0,     0,     0,  1109,     0,     0,     0,
     964,     0,     0,     0,   965,     0,     0,  1104,     0,     0,
       0,     0,     0,     0,  1106,     0,     0,     0,     0,     0,
       0,     0,   966,     0,  1104,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1107,     0,  1104,
       0,     0,     0,  1101,     0,   967,     0,     0,     0,     0,
    1107,     0,     0,  1101,     0,     0,   968,     0,     0,     0,
       0,     0,     0,  1107,  1109,   969,  2071,     0,     0,     0,
       0,     0,  5068,     0,     0,  1107,     0,   970,     0,     0,
       0,     0,   971,     0,     0,  2816,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1103,  1109,     0,     0,   972,     0,
       0,     0,  5091,     0,     0,     0,     0,     0,     0,  1107,
    1107,     0,     0,     0,     0,     0,  2046,  1103,     0,     0,
       0,  1110,     0,   973,     0,     0,     0,     0,  1109,     0,
       0,  1110,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1106,  1103,     0,   974,  1106,  1106,     0,     0,     0,
    1101,     0,     0,     0,     0,     0,  2072,     0,     0,  2073,
    2074,  2075,     0,  2076,  2077,  2078,  2079,  2080,  2081,  5134,
       0,     0,     0,     0,     0,     0,     0,     0,  1103,     0,
       0,     0,  1111,     0,   975,     0,     0,     0,     0,     0,
       0,  1101,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1106,   976,     0,
       0,     0,  5171,  1101,     0,     0,     0,     0,   208,   977,
       0,  1106,   978,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1104,     0,     0,  1104,     0,  1104,  1110,     0,
       0,     0,  1104,     0,     0,     0,     0,     0,   979,     0,
    1107,   980,     0,  1103,     0,   981,     0,   982,     0,     0,
       0,     0,  1106,     0,   983,     0,     0,   984,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1110,
       0,  1101,     0,     0,     0,     0,   985,     0,     0,     0,
       0,  1104,     0,   986,     0,     0,     0,     0,     0,   987,
       0,  1110,   988,     0,     0,     0,   989,  1109,     0,     0,
    1104,     0,     0,     0,   990,     0,   991,     0,     0,     0,
       0,   992,     0,     0,  1109,     0,     0,     0,     0,     0,
    4896,     0,     0,     0,     0,  1104,     0,     0,     0,     0,
       0,     0,  1109,     0,     0,     0,     0,   993,     0,     0,
    5276,     0,  1103,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1110,
       0,     0,     0,     0,     0,     0,     0,  1103,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1107,     0,     0,
       0,  1107,  1107,     0,     0,     0,     0,     0,  1109,     0,
       0,     0,     0,  1101,     0,  1104,     0,  1104,     0,     0,
       0,  1109,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1109,     0,     0,  5330,     0,     0,
       0,     0,     0,     0,     0,     0,  1109,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1107,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1101,     0,  1106,     0,  1107,  5362,  5362,
    5362,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1109,  1109,     0,     0,     0,     0,     0,  4896,     0,     0,
       0,  1110,     0,     0,     0,     0,     0,     0,  1104,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1107,     0,
       0,  1103,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1104,
       0,     0,     0,     0,  2083,     0,     0,  1106,     0,     0,
    1106,  1110,     0,     0,     0,     0,     0,     0,     0,  1103,
       0,     0,     0,  1103,  5422,     0,     0,     0,  1104,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5362,     0,     0,     0,
    1101,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2083,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1109,     0,   624,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1104,     0,     0,
     625,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1104,     0,
       0,     0,     0,   626,     0,     0,     0,     0,     0,     0,
       0,  1106,  1104,     0,     0,     0,   627,     0,  1110,     0,
       0,     0,     0,     0,     0,     0,     0,   628,  1106,     0,
       0,  -860,     0,     0,     0,  5515,     0,     0,     0,     0,
       0,     0,     0,  1106,     0,     0,     0,     0,     0,   629,
    1103,  1107,     0,     0,     0,   630,  1101,     0,     0,     0,
    1103,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5362,   631,     0,     0,     0,     0,     0,     0,     0,
       0,  5542,     0,   632,     0,     0,     0,     0,     0,     0,
       0,  1101,   633,     0,     0,     0,     0,     0,  1109,     0,
       0,     0,  1109,  1109,   634,     0,     0,     0,     0,     0,
       0,     0,   635,     0,     0,     0,   636,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1104,     0,
    1101,     0,     0,  1107,     0, -1089,  1107,     0,     0,     0,
       0,     0,     0,     0,  1110,     0,     0,     0,     0,     0,
       0,  1104,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1109,     0,     0,  1103,     0,     0,
       0,     0,   637,     0,     0,     0,  1104,  1101,  1109,  1110,
       0,  -577,  1101,  1101,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1103,  2083,
       0,     0,  1104,  2083,     0,     0,     0,     0,  1110,  1109,
       0,   638,     0,     0,   639,     0,     0,     0,     0,     0,
    1103,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   640,  1106,     0,     0,  1106,
       0,  1106,     0,     0,     0,     0,  1106,  1107,     0,   641,
       0,     0,     0,     0,     0,  1110,  -448,     0,     0,     0,
    1110,  1110,     0,     0,  1107,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   642,     0,  1104,     0,  1107,
       0,     0,     0,     0,   643,     0,     0,     0,  1103,  1101,
       0,  -448,     0,     0,   644,  1106,     0,     0,     0,     0,
       0,     0,     0,     0,   192,     0,     0,     0,     0,     0,
       0,     0,     0,   645,  1106,     0,     0,     0,     0,     0,
     646,     0,     0,     0,     0,     0,  -448,     0,     0,   647,
     648,     0,   649,   650,     0,     0,     0,     0,     0,  1106,
       0,     0,     0,   651,     0,     0,     0,     0,   652,     0,
       0,     0,   193,     0,     0,   653,     0,     0,   654,     0,
       0,   655,     0,     0,     0,     0,     0,   194,     0,     0,
       0,     0,     0,     0,  -448,     0,  1104,  1110,     0,     0,
       0,     0,     0,     0,     0,   195,     0,     0,     0,     0,
       0,   196,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1104,     0,     0,     0,     0,     0,     0,   197,  1106,
    1103,  1106,  1109,     0,     0,     0,     0,     0,     0,   198,
       0,     0,     0,     0,     0,     0,     0,     0,   199,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     200,     0,     0,     0,     0,   201,     0,     0,     0,     0,
       0,     0,   202,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1103,   203,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1107,     0,     0,  1107,     0,  1107,     0,  1101,
       0,     0,  1107,     0,  1109,     0,   204,  1109,     0,     0,
       0,     0,  1106,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   205,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1104,     0,     0,     0,     0,
       0,  1107,     0,  1106,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   206,     0,     0,
    1107,     0,     0,     0,     0,  2083,     0,     0,     0,     0,
       0,     0,  1106,     0,     0,     0,     0,  1110,     0,     0,
    2083,   207,     0,  1104,  2798,  1107,     0,  1104,     0,     0,
       0,   208,   209,     0,     0,   210,     0,  1103,  2083,  2083,
    2083,     0,  2083,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1109,     0,
       0,   211,     0,     0,   212,     0,     0,     0,   213,     0,
     214,     0,     0,     0,     0,  1109,     0,   215,     0,     0,
     216,  1106,     0,     0,  2083,     0,     0,     0,     0,     0,
    1109,     0,     0,     0,     0,  1107,     0,  1107,     0,   217,
       0,     0,  1106,     0,     0,     0,   218,     0,     0,     0,
       0,   219,   220,     0,     0,   221,  1106,     0,     0,   222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   223,
       0,     0,     0,     0,   224,     0,     0,     0,     0,     0,
       0,     0,  2083,     0,     0,     0,     0,   225,     0,     0,
       0,     0,     0,     0,  2083,     0,     0,     0,     0,  2083,
     226,     0,     0,  1103,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1104,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1104,     0,     0,     0,  1107,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1103,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1107,
       0,     0,  1106,     0,     0,     0,     0,  1103,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1106,     0,     0,  1107,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1106,     0,     0,     0,  1103,     0,     0,     0,     0,  1103,
    1103,  1104,     0,  1109,     0,     0,  1109,     0,  1109,     0,
       0,     0,     0,  1109,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1106,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1107,     0,     0,
       0,     0,  1104,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1107,     0,
       0,     0,  1109,     0,  1104,     0,     0,     0,     0,     0,
       0,     0,  1107,     0,     0,     0,     0,     0,     0,     0,
       0,  1109,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1106,     0,     0,     0,     0,  1109,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1103,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1104,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1109,     0,  1109,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1107,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1106,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1107,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1106,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1107,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1104,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1109,
       0,     0,  1107,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1109,     0,     0,     0,  1104,     0,  1103,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1109,
       0,     0,     0,     0,     0,     0,     0,  1107,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1106,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1106,  1109,     0,
       0,  1106,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1109,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1104,     0,  1109,     0,     0,  1107,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1107,     0,  2083,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2083,  2083,     0,  2083,     0,     0,  2798,
    2798,     0,  3551,     0,  2798,     0,     0,     0,  2083,     0,
       0,  2083,     0,     0,     0,     0,  2083,     0,     0,     0,
       0,     0,  2083,     0,     0,     0,     0,  2083,     0,     0,
       0,     0,     0,     0,  2083,  2083,  2083,  2083,     0,     0,
       0,  2798,  2798,     0,  2083,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1106,  1109,
       0,     0,  2083,     0,  2083,     0,     0,  1104,  1106,     0,
       0,  2083,  2083,  2083,  2083,  2083,  2083,  2083,  2083,  2083,
    2083,     0,  1109,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1104,     0,     0,  1107,     0,  1109,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2083,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1104,     0,  1109,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1107,     0,     0,     0,  1107,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1106,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1104,     0,
       0,     0,     0,  1104,  1104,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2083,     0,
       0,     0,     0,     0,     0,     0,  1106,     0,  1109,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1106,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1107,     0,  1106,     0,     0,     0,
    1104,     0,     0,     0,  1107,     0,     0,  1109,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1109,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1107,     0,     0,     0,     0,     0,     0,  1106,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2083,
    2083,     0,  1107,     0,  2083,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1109,     0,     0,     0,
       0,     0,     0,     0,  1107,     0,     0,     0,  1106,     0,
       0,     0,     0,  2083,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1104,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1109,     0,     0,     0,  1109,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1107,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1106,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1107,  1109,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1109,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2083,     0,     0,     0,     0,     0,
    2083,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1107,     0,     0,     0,  3551,  3551,
       0,  1106,  2798,  2798,  2798,  2798,     0,     0,  2798,  2798,
    2798,  2798,  2798,  2798,  2798,  2798,  2798,  2798,  3551,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1106,     0,     0,     0,
    2083,     0,     0,  2083,     0,  2083,     0,     0,  3551,  3551,
       0,     0,  1109,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2083,  2798,  2798,  2083,
       0,  2083,     0,     0,     0,  1106,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1109,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1109,     0,     0,     0,     0,
       0,  1107,  1106,     0,     0,     0,     0,  1106,  1106,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2083,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1109,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1106,     0,     0,  1107,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1107,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1109,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1107,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1109,  2798,     0,  1107,     0,
       0,     0,     0,  1107,  1107,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1106,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1107,     0,  1109,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2083,
       0,     0,     0,  2083,     0,  2083,  2083,     0,     0,     0,
       0,     0,  3551,  3551,  3551,  3551,     0,     0,     0,     0,
    3551,  3551,  3551,  3551,  3551,  3551,  3551,  3551,  3551,  3551,
    2083,  2083,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2083,     0,     0,
    2083,     0,  2083,     0,     0,     0,     0,  2083,     0,     0,
    3551,  3551,     0,     0,  2083,  2083,     0,     0,  1109,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1109,     0,     0,     0,     0,     0,     0,
       0,  2083,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2083,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1107,     0,  1109,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1109,
       0,     0,     0,     0,  1109,  1109,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1109,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3551,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2083,
    2083,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2083,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2083,     0,     0,     0,     0,     0,  2083,
    2798,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2083,     0,  2083,
       0,     0,     0,  2083,  2083,  2083,     0,     0,  2083,     0,
       0,  2083,  2083,     0,     0,     0,  2083,     0,     0,     0,
    2083,  1109,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2083,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2083,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2083,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3551,  2798,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2083,  2083,  2083,     0,     0,
       0,     0,     0,     0,     0,  2798,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2083,  2083,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2083,     0,     0,  3551,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2798,     0,     0,  3551,     0,     0,     0,  2083,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2083,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2083,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3551,     0,  2798,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2083,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2083,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2083,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2083,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2798,  2798,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3551,  3551,     0,     0,
       0,  2083,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   229,     0,  1234,   670,     0,  1235,  1236,  1237,
     731,  1238,     0,     0,     0,     0,     0,     0,  2083,   230,
     231,   232,   233,   234,   235,   236,   237,  1637,   238,   239,
     240,     0,     0,     0,     0,  1239,     0,     0,   241,   242,
       0,   243,   244,   245,   246,   247,   248,   249,   250,  1240,
     252,  1241,  1242,     0,   255,   256,   257,   258,   259,   260,
    1243,  1244,   261,   262,  1245,  1246,   265,     0,   266,   267,
     268,   269,  1247,     0,  1248,     0,   272,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,   287,   288,   289,   290,  1249,  1250,  1251,
    1252,  1253,  1254,  1255,   292,   293,   294,   295,   296,   297,
    1256,  1257,   300,  1258,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,  1638,     0,   312,
     313,  1082,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,  1259,   328,   329,
     330,   331,  1260,  1261,   333,     0,   334,   335,  1262,   337,
       0,   338,     0,   339,   340,     0,   341,   342,   343,   344,
     345,     0,   346,  1263,     0,  1264,   349,   350,     0,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,  1265,  1266,     0,  1267,     0,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
       0,     0,   388,  1268,   390,   391,   392,     0,   393,   394,
     395,  1269,  1270,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,  1271,
     413,  1272,   415,   416,   417,   418,   419,   420,   421,   422,
    1273,   424,  1274,   425,   426,   427,   428,  1275,  1276,   430,
    1277,   432,   433,   434,     0,   435,   436,     0,     0,  1278,
     438,   439,     0,     0,   440,   441,   442,   443,   444,   445,
    1279,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,  1280,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,  1281,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,   494,   495,   496,   497,   498,  1282,   500,
     501,   502,   503,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,   513,  1283,   514,   515,   516,   517,   518,
     519,   520,   521,  1284,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,  1285,
     538,     0,   539,   540,     0,   541,   542,   543,   544,   545,
     546,   547,     0,   548,  1286,  1287,     0,     0,   551,   552,
    1288,   554,  1289,  1290,   556,   557,   558,   559,   560,   561,
     562,   563,     0,  1291,   564,   565,   566,   567,   568,  1292,
       0,   569,   570,   571,   572,   573,   574,  1293,  1639,   576,
     577,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   588,   589,  1294,  1295,  1296,
    1297,   594,  1298,  1299,  1300,  1301,   599,   600,   601,   602,
    1302,     0,     0,     0,     0,     0,     0,  1303,  1304,  1640,
       0,     0,     0,     0,     0,     0,  1306,  1641,   229,     0,
    1234,   670,     0,  1235,  1236,  1237,   731,  1238,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,  1239,     0,     0,   241,   242,     0,   243,   244,   245,
     246,   247,   248,   249,   250,  1240,   252,  1241,  1242,     0,
     255,   256,   257,   258,   259,   260,  1243,  1244,   261,   262,
    1245,  1246,   265,     0,   266,   267,   268,   269,  1247,     0,
    1248,     0,   272,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,   287,
     288,   289,   290,  1249,  1250,  1251,  1252,  1253,  1254,  1255,
     292,   293,   294,   295,   296,   297,  1256,  1257,   300,  1258,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,  1082,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,  1259,   328,   329,   330,   331,  1260,  1261,
     333,     0,   334,   335,  1262,   337,     0,   338,     0,   339,
     340,     0,   341,   342,   343,   344,   345,     0,   346,  1263,
       0,  1264,   349,   350,     0,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,  1265,  1266,     0,  1267,     0,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,     0,     0,   388,  1268,
     390,   391,   392,     0,   393,   394,   395,  1269,  1270,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,  1271,   413,  1272,   415,   416,
     417,   418,   419,   420,   421,   422,  1273,   424,  1274,   425,
     426,   427,   428,  1275,  1276,   430,  1277,   432,   433,   434,
       0,   435,   436,     0,     0,  1278,   438,   439,     0,     0,
     440,   441,   442,   443,   444,   445,  1279,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
    1280,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,  1281,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,  1282,   500,   501,   502,   503,   504,
     505,   506,   507,   508,    41,   509,   510,   511,   512,   513,
    1283,   514,   515,   516,   517,   518,   519,   520,   521,  1284,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,  1285,   538,     0,   539,   540,
      45,   541,   542,   543,   544,   545,   546,   547,     0,   548,
    1286,  1287,     0,     0,   551,   552,  1288,   554,  1289,  1290,
     556,   557,   558,   559,   560,   561,   562,   563,     0,  1291,
     564,   565,   566,   567,   568,  1292,     0,   569,   570,   571,
     572,   573,  1161,  1293,     0,   576,   577,   578,   579,   580,
     581,     0,     0,   582,     0,    50,   583,   584,   585,   586,
     587,   588,   589,  1294,  1295,  1296,  1297,   594,  1298,  1299,
    1300,  1301,   599,   600,   601,   602,  1302,     0,    51,     0,
       0,     0,     0,  1303,  1304,     0,     0,     0,     0,     0,
       0,     0,  1306,  5102,   229,     0,  1234,   670,     0,  1235,
    1236,  1237,   731,  1238,     0,     0,     0,     0,     0,     0,
       0,   230,   231,   232,   233,   234,   235,   236,   237,     0,
     238,   239,   240,     0,     0,     0,     0,  1239,     0,     0,
     241,   242,     0,   243,   244,   245,   246,   247,   248,   249,
     250,  1240,   252,  1241,  1242,     0,   255,   256,   257,   258,
     259,   260,  1243,  1244,   261,   262,  1245,  1246,   265,     0,
     266,   267,   268,   269,  1247,     0,  1248,     0,   272,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,     0,   287,   288,   289,   290,  1249,
    1250,  1251,  1252,  1253,  1254,  1255,   292,   293,   294,   295,
     296,   297,  1256,  1257,   300,  1258,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,  1082,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,  1259,
     328,   329,   330,   331,  1260,  1261,   333,     0,   334,   335,
    1262,   337,     0,   338,     0,   339,   340,     0,   341,   342,
     343,   344,   345,     0,   346,  1263,     0,  1264,   349,   350,
       0,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,     0,   361,   362,   363,   364,   365,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,  1265,  1266,     0,
    1267,     0,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,     0,     0,   388,  1268,   390,   391,   392,     0,
     393,   394,   395,  1269,  1270,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,  1271,   413,  1272,   415,   416,   417,   418,   419,   420,
     421,   422,  1273,   424,  1274,   425,   426,   427,   428,  1275,
    1276,   430,  1277,   432,   433,   434,     0,   435,   436,     0,
       0,  1278,   438,   439,     0,     0,   440,   441,   442,   443,
     444,   445,  1279,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,  1280,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,  1281,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,   494,   495,   496,   497,   498,
    1282,   500,   501,   502,   503,   504,   505,   506,   507,   508,
       0,   509,   510,   511,   512,   513,  1283,   514,   515,   516,
     517,   518,   519,   520,   521,  1284,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,  1285,   538,     0,   539,   540,     0,   541,   542,   543,
     544,   545,   546,   547,     0,   548,  1286,  1287,     0,     0,
     551,   552,  1288,   554,  1289,  1290,   556,   557,   558,   559,
     560,   561,   562,   563,     0,  1291,   564,   565,   566,   567,
     568,  1292,     0,   569,   570,   571,   572,   573,   574,  1293,
       0,   576,   577,   578,   579,   580,   581,     0,     0,   582,
       0,     0,   583,   584,   585,   586,   587,   588,   589,  1294,
    1295,  1296,  1297,   594,  1298,  1299,  1300,  1301,   599,   600,
     601,   602,  1302,     0,     0,     0,     0,     0,     0,  1303,
    1304,     0,     0,     0,     0,     0,     0,     0,  1306,  2800,
     229,     0,  1234,   670,     0,  1235,  1236,  1237,   731,  1238,
       0,     0,     0,     0,     0,     0,     0,   230,   231,   232,
     233,   234,   235,   236,   237,     0,   238,   239,   240,     0,
       0,     0,     0,  1239,     0,     0,   241,   242,     0,   243,
     244,   245,   246,   247,   248,   249,   250,  1240,   252,  1241,
    1242,     0,   255,   256,   257,   258,   259,   260,  1243,  1244,
     261,   262,  1245,  1246,   265,     0,   266,   267,   268,   269,
    1247,     0,  1248,     0,   272,   273,   274,   275,   276,   277,
     278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
       0,   287,   288,   289,   290,  1249,  1250,  1251,  1252,  1253,
    1254,  1255,   292,   293,   294,   295,   296,   297,  1256,  1257,
     300,  1258,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   309,   310,   311,     0,     0,   312,   313,  1082,
     315,   316,     0,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,  1259,   328,   329,   330,   331,
    1260,  1261,   333,     0,   334,   335,  1262,   337,     0,   338,
       0,   339,   340,     0,   341,   342,   343,   344,   345,     0,
     346,  1263,     0,  1264,   349,   350,     0,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,     0,   361,   362,
     363,   364,   365,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,  1265,  1266,     0,  1267,     0,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,     0,     0,
     388,  1268,   390,   391,   392,     0,   393,   394,   395,  1269,
    1270,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,  1271,   413,  1272,
     415,   416,   417,   418,   419,   420,   421,   422,  1273,   424,
    1274,   425,   426,   427,   428,  1275,  1276,   430,  1277,   432,
     433,   434,     0,   435,   436,     0,     0,  1278,   438,   439,
       0,     0,   440,   441,   442,   443,   444,   445,  1279,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     456,   457,  1280,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,  1281,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
     493,   494,   495,   496,   497,   498,  1282,   500,   501,   502,
     503,   504,   505,   506,   507,   508,     0,   509,   510,   511,
     512,   513,  1283,   514,   515,   516,   517,   518,   519,   520,
     521,  1284,   523,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,  1285,   538,     0,
     539,   540,     0,   541,   542,   543,   544,   545,   546,   547,
       0,   548,  1286,  1287,     0,     0,   551,   552,  1288,   554,
    1289,  1290,   556,   557,   558,   559,   560,   561,   562,   563,
       0,  1291,   564,   565,   566,   567,   568,  1292,     0,   569,
     570,   571,   572,   573,   574,  1293,     0,   576,   577,   578,
     579,   580,   581,     0,     0,   582,     0,     0,   583,   584,
     585,   586,   587,   588,   589,  1294,  1295,  1296,  1297,   594,
    1298,  1299,  1300,  1301,   599,   600,   601,   602,  1302,     0,
       0,     0,     0,     0,     0,  1303,  1304,     0,     0,     0,
       0,     0,     0,     0,  1306,  4082,   229,     0,  1234,   670,
       0,  1235,  1236,  1237,   731,  1238,     0,     0,     0,     0,
       0,     0,     0,   230,   231,   232,   233,   234,   235,   236,
     237,     0,   238,   239,   240,     0,     0,     0,     0,  1239,
       0,     0,   241,   242,     0,   243,   244,   245,   246,   247,
     248,   249,   250,  1240,   252,  1241,  1242,     0,   255,   256,
     257,   258,   259,   260,  1243,  1244,   261,   262,  1245,  1246,
     265,     0,   266,   267,   268,   269,  1247,     0,  1248,     0,
     272,   273,   274,   275,   276,   277,   278,   279,   280,     0,
     281,   282,   283,   284,   285,   286,     0,   287,   288,   289,
     290,  1249,  1250,  1251,  1252,  1253,  1254,  1255,   292,   293,
     294,   295,   296,   297,  1256,  1257,   300,  1258,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   309,   310,
     311,     0,     0,   312,   313,  1082,   315,   316,     0,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,  1259,   328,   329,   330,   331,  1260,  1261,   333,     0,
     334,   335,  1262,   337,     0,   338,     0,   339,   340,     0,
     341,   342,   343,   344,   345,     0,   346,  1263,     0,  1264,
     349,   350,     0,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,     0,   361,   362,   363,   364,   365,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,  1265,
    1266,     0,  1267,     0,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,     0,     0,   388,  1268,   390,   391,
     392,     0,   393,   394,   395,  1269,  1270,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,  1271,   413,  1272,   415,   416,   417,   418,
     419,   420,   421,   422,  1273,   424,  1274,   425,   426,   427,
     428,  1275,  1276,   430,  1277,   432,   433,   434,     0,   435,
     436,     0,     0,  1278,   438,   439,     0,     0,   440,   441,
     442,   443,   444,   445,  1279,   447,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   456,   457,  1280,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,  1281,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,   493,   494,   495,   496,
     497,   498,  1282,   500,   501,   502,   503,   504,   505,   506,
     507,   508,     0,   509,   510,   511,   512,   513,  1283,   514,
     515,   516,   517,   518,   519,   520,   521,  1284,   523,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,  1285,   538,     0,   539,   540,     0,   541,
     542,   543,   544,   545,   546,   547,     0,   548,  1286,  1287,
       0,     0,   551,   552,  1288,   554,  1289,  1290,   556,   557,
     558,   559,   560,   561,   562,   563,     0,  1291,   564,   565,
     566,   567,   568,  1292,     0,   569,   570,   571,   572,   573,
     574,  1293,     0,   576,   577,   578,   579,   580,   581,     0,
       0,   582,     0,     0,   583,   584,   585,   586,   587,   588,
     589,  1294,  1295,  1296,  1297,   594,  1298,  1299,  1300,  1301,
     599,   600,   601,   602,  1302,   610,     0,     0,     0,     0,
       0,  1303,  1304,     0,     0,     0,     0,     0,     0,     0,
    1306,  4155,   230,   231,   232,   233,   234,   235,   236,   237,
       0,   238,   239,   240,     0,     0,     0,     0,     0,  4173,
       0,   241,   242,     0,   243,   244,   245,     0,   247,   248,
     249,   250,   251,     0,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,     0,   261,   262,   263,   264,   265,
       0,   266,   267,   268,   269,   270,     0,     0,     0,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0, -1795,   288,   289,   290,
       0,     0,     0,     0,     0,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,   314,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,     0,   333,     0,   334,
     335,   336,   337,     0,   338,     0,   339,     0,     0, -1795,
     342,   343,   344,   345,     0,   346,   347,     0,   348,   349,
     350,     0,   351,   352,   353,   354,   355,     0,   357,   358,
     359,   360,     0,   361,   362,   363,   364,   365,   366,   367,
       0,   368, -1795,   370,   371,   372,   373,   374,   375,   376,
       0,   377,     0,   378,     0,     0,   381, -1795,   383,   384,
     385,   386,   387,     0,     0,   388,   389, -1795,   391,     0,
       0,   393,   394,   395,     0,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412, -1795,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   428,
       0,   429,   430,   431,   432,   433,   434,     0,   435,   436,
       0,     0,   437,   438,   439,     0,     0,   440,   441,   442,
       0,   444,     0,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,   458,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492, -1795,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,   513,     0,   514,   515,
     516,   517,   518,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,     0,   539,   540,     0,   541,     0,
     543,   544,   545,   546,   547,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,   561,   562,   563,     0,     0,   564,   565,   566,
     567,   568,     0,     0,   569,   570,   571,   572,   573,   574,
     575,     0,   576,     0,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,  1074,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1382,   230,   231,   232,   233,   234,   235,   236,   237,     0,
     238,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,     0,   243,   244,   245,   246,   247,   248,   249,
       0,  1075,   252,  1076,  1077,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,  1078,  1079,   265,     0,
     266,   267,   268,   269,     0,     0,   271,     0,   272,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,     0,   287,   288,   289,   290,     0,
       0,     0,   291,     0,     0,     0,   292,   293,   294,   295,
     296,   297,  1080,  1081,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,  1082,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,     0,
     328,   329,   330,   331,     0,     0,   333,     0,   334,   335,
    1083,   337,     0,   338,     0,   339,   340,     0,   341,   342,
     343,   344,   345,     0,   346,     0,     0,     0,   349,   350,
       0,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,  2187,   361,   362,   363,   364,   365,   366,   367,     0,
     368,   369,  2188,   371,   372,   373,   374,  1085,  1086,     0,
    1087,     0,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,     0,     0,   388,     0,   390,   391,   392,     0,
     393,   394,   395,     0,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,  1088,   413,  1089,   415,   416,   417,   418,   419,   420,
     421,     0,     0,   424,     0,   425,   426,   427,   428,     0,
       0,   430,  1090,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,     0,     0,   440,   441,  2190,   443,
     444,   445,     0,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,     0,   459,     0,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,  1091,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,   494,   495,   496,   497,   498,
       0,   500,   501,   502,   503,   504,   505,   506,   507,   508,
       0,   509,   510,   511,   512,   513,     0,   514,   515,  2191,
     517,   518,   519,   520,   521,  1093,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,     0,   538,     0,   539,   540,     0,   541,   542,   543,
     544,   545,   546,   547,     0,   548,  1094,  1095,     0,     0,
     551,   552,     0,   554,     0,     0,   556,   557,   558,   559,
     560,   561,   562,   563,     0,     0,   564,   565,   566,   567,
     568,     0,     0,   569,   570,   571,   572,   573,     0,  1096,
    2192,   576,   577,   578,   579,   580,   581,     0,     0,   582,
       0,     0,   583,   584,   585,   586,   587,   588,  1074,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   600,
     601,   602,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,  2300,
       0,     0,     0,     0,   241,   242,     0,   243,   244,   245,
     246,   247,   248,   249,     0,  1075,   252,  1076,  1077,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
    1078,  1079,   265,     0,   266,   267,   268,   269,     0,     0,
     271,     0,   272,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,   287,
     288,   289,   290,     0,     0,     0,   291,     0,     0,     0,
     292,   293,   294,   295,   296,   297,  1080,  1081,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,  1082,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,     0,   328,   329,   330,   331,     0,     0,
     333,     0,   334,   335,  1083,   337,     0,   338,     0,   339,
     340,     0,   341,   342,   343,   344,   345,     0,   346,     0,
       0,     0,   349,   350,     0,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,  2187,   361,   362,   363,   364,
     365,   366,   367,     0,   368,   369,  2188,   371,   372,   373,
     374,  1085,  1086,     0,  1087,     0,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,     0,     0,   388,     0,
     390,   391,   392,     0,   393,   394,   395,     0,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,  1088,   413,  1089,   415,   416,
     417,   418,   419,   420,   421,     0,     0,   424,     0,   425,
     426,   427,   428,     0,     0,   430,  1090,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,     0,     0,
     440,   441,  2190,   443,   444,   445,     0,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
       0,   459,     0,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,  1091,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,     0,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
       0,   514,   515,  2191,   517,   518,   519,   520,   521,  1093,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,     0,   538,     0,   539,   540,
       0,   541,   542,   543,   544,   545,   546,   547,     0,   548,
    1094,  1095,     0,     0,   551,   552,     0,   554,     0,     0,
     556,   557,   558,   559,   560,   561,   562,   563,     0,     0,
     564,   565,   566,   567,   568,     0,     0,   569,   570,   571,
     572,   573,     0,  1096,  2192,   576,   577,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   229,     0,  1234,   670,     0,  1235,  1236,  1237,
     731,  1238,     0,   600,   601,   602,     0,     0,     0,   230,
     231,   232,   233,   234,   235,   236,   237,     0,   238,   239,
     240,     0,     0,  3376,     0,  1239,     0,     0,   241,   242,
       0,   243,   244,   245,   246,   247,   248,   249,   250,  1240,
     252,  1241,  1242,     0,   255,   256,   257,   258,   259,   260,
    1243,  1244,   261,   262,  1245,  1246,   265,     0,   266,   267,
     268,   269,  1247,     0,  1248,     0,   272,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,   287,   288,   289,   290,  1249,  1250,  1251,
    1252,  1253,  1254,  1255,   292,   293,   294,   295,   296,   297,
    1256,  1257,   300,  1258,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,  1082,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,  1259,   328,   329,
     330,   331,  1260,  1261,   333,     0,   334,   335,  1262,   337,
       0,   338,     0,   339,   340,     0,   341,   342,   343,   344,
     345,     0,   346,  1263,     0,  1264,   349,   350,     0,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,  1265,  1266,     0,  1267,     0,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
       0,     0,   388,  1268,   390,   391,   392,     0,   393,   394,
     395,  1269,  1270,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,  1271,
     413,  1272,   415,   416,   417,   418,   419,   420,   421,   422,
    1273,   424,  1274,   425,   426,   427,   428,  1275,  1276,   430,
    1277,   432,   433,   434,     0,   435,   436,     0,     0,  1278,
     438,   439,     0,     0,   440,   441,   442,   443,   444,   445,
    1279,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,  1280,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,  1281,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,   494,   495,   496,   497,   498,  1282,   500,
     501,   502,   503,   504,   505,   506,   507,   508,    41,   509,
     510,   511,   512,   513,  1283,   514,   515,   516,   517,   518,
     519,   520,   521,  1284,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,  1285,
     538,     0,   539,   540,    45,   541,   542,   543,   544,   545,
     546,   547,     0,   548,  1286,  1287,     0,     0,   551,   552,
    1288,   554,  1289,  1290,   556,   557,   558,   559,   560,   561,
     562,   563,     0,  1291,   564,   565,   566,   567,   568,  1292,
       0,   569,   570,   571,   572,   573,  1161,  1293,     0,   576,
     577,   578,   579,   580,   581,     0,     0,   582,     0,    50,
     583,   584,   585,   586,   587,   588,   589,  1294,  1295,  1296,
    1297,   594,  1298,  1299,  1300,  1301,   599,   600,   601,   602,
    1302,     0,    51,     0,     0,     0,     0,  1303,  1304,     0,
       0,     0,   229,     0,  1234,   670,  1306,  1235,  1236,  1237,
     731,  1238,     0,     0,     0,     0,     0,     0,     0,   230,
     231,   232,   233,   234,   235,   236,   237,     0,   238,   239,
     240,     0,     0,     0,     0,  1239,     0,     0,   241,   242,
       0,   243,   244,   245,   246,   247,   248,   249,   250,  1240,
     252,  1241,  1242,  2806,   255,   256,   257,   258,   259,   260,
    1243,  1244,   261,   262,  1245,  1246,   265,     0,   266,   267,
     268,   269,  1247,     0,  1248,     0,   272,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,   287,   288,   289,   290,  1249,  1250,  1251,
    1252,  1253,  1254,  1255,   292,   293,   294,   295,   296,   297,
    1256,  1257,   300,  1258,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,  1082,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,  1259,   328,   329,
     330,   331,  1260,  1261,   333,     0,   334,   335,  1262,   337,
       0,   338,     0,   339,   340,  2807,   341,   342,   343,   344,
     345,     0,   346,  1263,     0,  1264,   349,   350,     0,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,  1265,  1266,     0,  1267,     0,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
       0,  2808,   388,  1268,   390,   391,   392,     0,   393,   394,
     395,  1269,  1270,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,  1271,
     413,  1272,   415,   416,   417,   418,   419,   420,   421,   422,
    1273,   424,  1274,   425,   426,   427,   428,  1275,  1276,   430,
    1277,   432,   433,   434,     0,   435,   436,     0,     0,  1278,
     438,   439,     0,     0,   440,   441,   442,   443,   444,   445,
    1279,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,  1280,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,  1281,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,   494,   495,   496,   497,   498,  1282,   500,
     501,   502,   503,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,   513,  1283,   514,   515,   516,   517,   518,
     519,   520,   521,  1284,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,  1285,
     538,     0,   539,   540,     0,   541,   542,   543,   544,   545,
     546,   547,     0,   548,  1286,  1287,     0,  2809,   551,   552,
    1288,   554,  1289,  1290,   556,   557,   558,   559,   560,   561,
     562,   563,     0,  1291,   564,   565,   566,   567,   568,  1292,
       0,   569,   570,   571,   572,   573,   574,  1293,     0,   576,
     577,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   588,   589,  1294,  1295,  1296,
    1297,   594,  1298,  1299,  1300,  1301,   599,   600,   601,   602,
    1302,     0,     0,     0,     0,     0,     0,  1303,  1304,     0,
       0,     0,   229,     0,  1234,   670,  1306,  1235,  1236,  1237,
     731,  1238,     0,     0,     0,     0,     0,     0,     0,   230,
     231,   232,   233,   234,   235,   236,   237,     0,   238,   239,
     240,     0,     0,     0,     0,  1239,     0,     0,   241,   242,
       0,   243,   244,   245,   246,   247,   248,   249,   250,  1240,
     252,  1241,  1242,     0,   255,   256,   257,   258,   259,   260,
    1243,  1244,   261,   262,  1245,  1246,   265,     0,   266,   267,
     268,   269,  1247,     0,  1248,     0,   272,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,   287,   288,   289,   290,  1249,  1250,  1251,
    1252,  1253,  1254,  1255,   292,   293,   294,   295,   296,   297,
    1256,  1257,   300,  1258,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,  1082,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,  1259,   328,   329,
     330,   331,  1260,  1261,   333,     0,   334,   335,  1262,   337,
       0,   338,     0,   339,   340,     0,   341,   342,   343,   344,
     345,     0,   346,  1263,     0,  1264,   349,   350,     0,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,  1265,  1266,     0,  1267,     0,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
       0,     0,   388,  1268,   390,   391,   392,     0,   393,   394,
     395,  1269,  1270,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,  1271,
     413,  1272,   415,   416,   417,   418,   419,   420,   421,   422,
    1273,   424,  1274,   425,   426,   427,   428,  1275,  1276,   430,
    1277,   432,   433,   434,     0,   435,   436,     0,     0,  1278,
     438,   439,     0,     0,   440,   441,   442,   443,   444,   445,
    1279,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,  1280,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,  1281,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,   494,   495,   496,   497,   498,  1282,   500,
     501,   502,   503,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,   513,  1283,   514,   515,   516,   517,   518,
     519,   520,   521,  1284,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,  1285,
     538,     0,   539,   540,     0,   541,   542,   543,   544,   545,
     546,   547,     0,   548,  1286,  1287,     0,     0,   551,   552,
    1288,   554,  1289,  1290,   556,   557,   558,   559,   560,   561,
     562,   563,     0,  1291,   564,   565,   566,   567,   568,  1292,
       0,   569,   570,   571,   572,   573,   574,  1293,     0,   576,
     577,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   588,   589,  1294,  1295,  1296,
    1297,   594,  1298,  1299,  1300,  1301,   599,   600,   601,   602,
    1302,     0,     0,     0,     0,     0,     0,  1303,  1304,     0,
       0,     0,     0,     0,  2006,  2760,  1306,   229,     0,  1234,
     670,     0,  1235,  1236,  1237,   731,  1238,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
    1239,     0,     0,   241,   242,     0,   243,   244,   245,   246,
     247,   248,   249,   250,  1240,   252,  1241,  1242,     0,   255,
     256,   257,   258,   259,   260,  1243,  1244,   261,   262,  1245,
    1246,   265,     0,   266,   267,   268,   269,  1247,     0,  1248,
       0,   272,   273,   274,   275,   276,   277,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,   287,   288,
     289,   290,  1249,  1250,  1251,  1252,  1253,  1254,  1255,   292,
     293,   294,   295,   296,   297,  1256,  1257,   300,  1258,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,  1082,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,  1259,   328,   329,   330,   331,  1260,  1261,   333,
       0,   334,   335,  1262,   337,     0,   338,     0,   339,   340,
       0,   341,   342,   343,   344,   345,     0,   346,  1263,     0,
    1264,   349,   350,     0,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
    1265,  1266,     0,  1267,     0,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,     0,     0,   388,  1268,   390,
     391,   392,     0,   393,   394,   395,  1269,  1270,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,  1271,   413,  1272,   415,   416,   417,
     418,   419,   420,   421,   422,  1273,   424,  1274,   425,   426,
     427,   428,  1275,  1276,   430,  1277,   432,   433,   434,     0,
     435,   436,     0,     0,  1278,   438,   439,     0,     0,   440,
     441,   442,   443,   444,   445,  1279,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,  1280,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,  1281,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,  1282,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,  1283,
     514,   515,   516,   517,   518,   519,   520,   521,  1284,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,  1285,   538,     0,   539,   540,     0,
     541,   542,   543,   544,   545,   546,   547,     0,   548,  1286,
    1287,     0,     0,   551,   552,  1288,   554,  1289,  1290,   556,
     557,   558,   559,   560,   561,   562,   563,     0,  1291,   564,
     565,   566,   567,   568,  1292,     0,   569,   570,   571,   572,
     573,   574,  1293,     0,   576,   577,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,  1294,  1295,  1296,  1297,   594,  1298,  1299,  1300,
    1301,   599,   600,   601,   602,  1302,     0,     0,     0,     0,
       0,     0,  1303,  1304,  1305,     0,     0,   229,     0,  1234,
     670,  1306,  1235,  1236,  1237,   731,  1238,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,  2156,   238,   239,   240,     0,     0,     0,     0,
    1239,     0,     0,   241,   242,     0,   243,   244,   245,   246,
     247,   248,   249,   250,  1240,   252,  1241,  1242,     0,   255,
     256,   257,   258,   259,   260,  1243,  1244,   261,   262,  1245,
    1246,   265,     0,   266,   267,   268,   269,  1247,     0,  1248,
       0,   272,   273,   274,   275,   276,   277,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,   287,   288,
     289,   290,  1249,  1250,  1251,  1252,  1253,  1254,  1255,   292,
     293,   294,   295,   296,   297,  1256,  1257,   300,  1258,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,  1082,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,  1259,   328,   329,   330,   331,  1260,  1261,   333,
       0,   334,   335,  1262,   337,     0,   338,     0,   339,   340,
       0,   341,   342,   343,   344,   345,     0,   346,  1263,     0,
    1264,   349,   350,     0,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
    1265,  1266,     0,  1267,     0,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,     0,     0,   388,  1268,   390,
     391,   392,     0,   393,   394,   395,  1269,  1270,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,  1271,   413,  1272,   415,   416,   417,
     418,   419,   420,   421,   422,  1273,   424,  1274,   425,   426,
     427,   428,  1275,  1276,   430,  1277,   432,   433,   434,     0,
     435,   436,     0,     0,  1278,   438,   439,     0,     0,   440,
     441,   442,   443,   444,   445,  1279,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,  1280,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,  1281,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,  1282,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,  1283,
     514,   515,   516,   517,   518,   519,   520,   521,  1284,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,  1285,   538,     0,   539,   540,     0,
     541,   542,   543,   544,   545,   546,   547,     0,   548,  1286,
    1287,     0,     0,   551,   552,  1288,   554,  1289,  1290,   556,
     557,   558,   559,   560,   561,   562,   563,     0,  1291,   564,
     565,   566,   567,   568,  1292,     0,   569,   570,   571,   572,
     573,   574,  1293,     0,   576,   577,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,  1294,  1295,  1296,  1297,   594,  1298,  1299,  1300,
    1301,   599,   600,   601,   602,  1302,     0,     0,     0,     0,
       0,     0,  1303,  1304,     0,     0,     0,   229,     0,  1234,
     670,  1306,  1235,  1236,  1237,   731,  1238,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
    1239,     0,     0,   241,   242,     0,   243,   244,   245,   246,
     247,   248,   249,   250,  1240,   252,  1241,  1242,     0,   255,
     256,   257,   258,   259,   260,  1243,  1244,   261,   262,  1245,
    1246,   265,     0,   266,   267,   268,   269,  1247,     0,  1248,
       0,   272,   273,   274,   275,   276,   277,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,   287,   288,
     289,   290,  1249,  1250,  1251,  1252,  1253,  1254,  1255,   292,
     293,   294,   295,   296,   297,  1256,  1257,   300,  1258,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,  1082,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,  1259,   328,   329,   330,   331,  1260,  1261,   333,
       0,   334,   335,  1262,   337,     0,   338,     0,   339,   340,
       0,   341,   342,   343,   344,   345,     0,   346,  1263,     0,
    1264,   349,   350,     0,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
    1265,  1266,     0,  1267,     0,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,     0,     0,   388,  1268,   390,
     391,   392,     0,   393,   394,   395,  1269,  1270,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,  1271,   413,  1272,   415,   416,   417,
     418,   419,   420,   421,   422,  1273,   424,  1274,   425,   426,
     427,   428,  1275,  1276,   430,  1277,   432,   433,   434,     0,
     435,   436,     0,     0,  1278,   438,   439,     0,     0,   440,
     441,   442,   443,   444,   445,  1279,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,  1280,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,  1281,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,  1282,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,  1283,
     514,   515,   516,   517,   518,   519,   520,   521,  1284,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,  1285,   538,     0,   539,   540,     0,
     541,   542,   543,   544,   545,   546,   547,     0,   548,  1286,
    1287,     0,     0,   551,   552,  1288,   554,  1289,  1290,   556,
     557,   558,   559,   560,   561,   562,   563,     0,  1291,   564,
     565,   566,   567,   568,  1292,     0,   569,   570,   571,   572,
     573,   574,  1293,  3255,   576,   577,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,  1294,  1295,  1296,  1297,   594,  1298,  1299,  1300,
    1301,   599,   600,   601,   602,  1302,     0,     0,     0,     0,
       0,     0,  1303,  1304,     0,     0,     0,   229,     0,  1234,
     670,  1306,  1235,  1236,  1237,   731,  1238,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
    1239,     0,     0,   241,   242,     0,   243,   244,   245,   246,
     247,   248,   249,   250,  1240,   252,  1241,  1242,     0,   255,
     256,   257,   258,   259,   260,  1243,  1244,   261,   262,  1245,
    1246,   265,     0,   266,   267,   268,   269,  1247,     0,  1248,
       0,   272,   273,   274,   275,   276,   277,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,   287,   288,
     289,   290,  1249,  1250,  1251,  1252,  1253,  1254,  1255,   292,
     293,   294,   295,   296,   297,  1256,  1257,   300,  1258,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,  1082,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,  1259,   328,   329,   330,   331,  1260,  1261,   333,
       0,   334,   335,  1262,   337,     0,   338,     0,   339,   340,
    2807,   341,   342,   343,   344,   345,     0,   346,  1263,     0,
    1264,   349,   350,     0,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
    1265,  1266,     0,  1267,     0,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,     0,     0,   388,  1268,   390,
     391,   392,     0,   393,   394,   395,  1269,  1270,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,  1271,   413,  1272,   415,   416,   417,
     418,   419,   420,   421,   422,  1273,   424,  1274,   425,   426,
     427,   428,  1275,  1276,   430,  1277,   432,   433,   434,     0,
     435,   436,     0,     0,  1278,   438,   439,     0,     0,   440,
     441,   442,   443,   444,   445,  1279,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,  1280,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,  1281,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,  1282,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,  1283,
     514,   515,   516,   517,   518,   519,   520,   521,  1284,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,  1285,   538,     0,   539,   540,     0,
     541,   542,   543,   544,   545,   546,   547,     0,   548,  1286,
    1287,     0,     0,   551,   552,  1288,   554,  1289,  1290,   556,
     557,   558,   559,   560,   561,   562,   563,     0,  1291,   564,
     565,   566,   567,   568,  1292,     0,   569,   570,   571,   572,
     573,   574,  1293,     0,   576,   577,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,  1294,  1295,  1296,  1297,   594,  1298,  1299,  1300,
    1301,   599,   600,   601,   602,  1302,     0,     0,     0,     0,
       0,     0,  1303,  1304,     0,     0,     0,   229,     0,  1234,
     670,  1306,  1235,  1236,  1237,   731,  1238,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
    1239,     0,     0,   241,   242,     0,   243,   244,   245,   246,
     247,   248,   249,   250,  1240,   252,  1241,  1242,     0,   255,
     256,   257,   258,   259,   260,  1243,  1244,   261,   262,  1245,
    1246,   265,     0,   266,   267,   268,   269,  1247,     0,  1248,
       0,   272,   273,   274,   275,   276,   277,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,   287,   288,
     289,   290,  1249,  1250,  1251,  1252,  1253,  1254,  1255,   292,
     293,   294,   295,   296,   297,  1256,  1257,   300,  1258,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,  1082,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,  1259,   328,   329,   330,   331,  1260,  1261,   333,
       0,   334,   335,  1262,   337,     0,   338,     0,   339,   340,
       0,   341,   342,   343,   344,   345,     0,   346,  1263,     0,
    1264,   349,   350,     0,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
    1265,  1266,     0,  1267,     0,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,     0,     0,   388,  1268,   390,
     391,   392,     0,   393,   394,   395,  1269,  1270,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,  1271,   413,  1272,   415,   416,   417,
     418,   419,   420,   421,   422,  1273,   424,  1274,   425,   426,
     427,   428,  1275,  1276,   430,  1277,   432,   433,   434,     0,
     435,   436,     0,     0,  1278,   438,   439,     0,     0,   440,
     441,   442,   443,   444,   445,  1279,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,  1280,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,  1281,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,  1282,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,  1283,
     514,   515,   516,   517,   518,   519,   520,   521,  1284,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,  1285,   538,     0,   539,   540,     0,
     541,   542,   543,   544,   545,   546,   547,     0,   548,  1286,
    1287,     0,     0,   551,   552,  1288,   554,  1289,  1290,   556,
     557,   558,   559,   560,   561,   562,   563,     0,  1291,   564,
     565,   566,   567,   568,  1292,     0,   569,   570,   571,   572,
     573,   574,  1293,     0,   576,   577,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,  1294,  1295,  1296,  1297,   594,  1298,  1299,  1300,
    1301,   599,   600,   601,   602,  1302,     0,     0,     0,     0,
       0,     0,  1303,  1304,     0,     0,     0,   229,     0,  1234,
     670,  1306,  1235,  1236,  1237,   731,  1238,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
    1239,     0,     0,   241,   242,     0,   243,   244,   245,   246,
     247,   248,   249,   250,  1240,   252,  1241,  1242,     0,   255,
     256,   257,   258,   259,   260,  1243,  1244,   261,   262,  1245,
    1246,   265,     0,   266,   267,   268,   269,  1247,     0,  1248,
       0,   272,   273,   274,   275,   276,   277,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,   287,   288,
     289,   290,  1249,  1250,  1251,  1252,  1253,  1254,  1255,   292,
     293,   294,   295,   296,   297,  1256,  1257,   300,  1258,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,  1082,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,  1259,   328,   329,   330,   331,  1260,  1261,   333,
       0,   334,   335,  1262,   337,     0,   338,     0,   339,   340,
       0,   341,   342,   343,   344,   345,     0,   346,  1263,     0,
    1264,   349,   350,     0,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
    1265,  1266,     0,  1267,     0,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,     0,     0,   388,  1268,   390,
     391,   392,     0,   393,   394,   395,  1269,  1270,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,  1271,   413,  1272,   415,   416,   417,
     418,   419,   420,   421,   422,  1273,   424,  1274,   425,   426,
     427,   428,  1275,  1276,   430,  1277,   432,   433,   434,     0,
     435,   436,     0,     0,  1278,   438,   439,     0,     0,   440,
     441,   442,   443,   444,   445,  1279,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,  1280,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,  1281,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,  1282,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,  1283,
     514,   515,   516,   517,   518,   519,   520,   521,  1284,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,  1285,   538,     0,   539,   540,     0,
     541,   542,   543,   544,   545,   546,   547,     0,   548,  1286,
    1287,     0,     0,   551,   552,  1288,   554,  1289,  1290,   556,
     557,   558,   559,   560,   561,   562,   563,     0,  1291,   564,
     565,   566,   567,   568,  1292,     0,   569,   570,   571,   572,
     573,   574,  1293,     0,   576,   577,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,  1294,  1295,  1296,  1297,   594,  1298,  1299,  1300,
    1301,   599,   600,   601,   602,  1302,     0,     0,     0,     0,
       0,     0,  2159,  2160,     0,     0,     0,   229,     0,  2934,
     670,  1306,  1235,  1236,  1237,   731,  1238,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
    1239,     0,     0,   241,   242,     0,   243,   244,   245,   246,
     247,   248,   249,   250,  1240,   252,  1241,  1242,     0,   255,
     256,   257,   258,   259,   260,  1243,  1244,   261,   262,  1245,
    1246,   265,     0,   266,   267,   268,   269,  1247,     0,  1248,
       0,   272,   273,   274,   275,   276,   277,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,   287,   288,
     289,   290,  1249,  1250,  1251,  1252,  1253,  1254,  1255,   292,
     293,   294,   295,   296,   297,  1256,  1257,   300,  1258,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,  1082,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,  1259,   328,   329,   330,   331,  1260,  1261,   333,
       0,   334,   335,  1262,   337,     0,   338,     0,   339,   340,
       0,   341,   342,   343,   344,   345,     0,   346,  1263,     0,
    1264,   349,   350,     0,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
    1265,  1266,     0,  1267,     0,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,     0,     0,   388,  1268,   390,
     391,   392,     0,   393,   394,   395,  1269,  1270,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,  1271,   413,  1272,   415,   416,   417,
     418,   419,   420,   421,   422,  1273,   424,  1274,   425,   426,
     427,   428,  1275,  1276,   430,  1277,   432,   433,   434,     0,
     435,   436,     0,     0,  1278,   438,   439,     0,     0,   440,
     441,   442,   443,   444,   445,  1279,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,  1280,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,  1281,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,  1282,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,  1283,
     514,   515,   516,   517,   518,   519,   520,   521,  1284,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,  1285,   538,     0,   539,   540,     0,
     541,   542,   543,   544,   545,   546,   547,     0,   548,  1286,
    1287,     0,     0,   551,   552,  1288,   554,  1289,  1290,   556,
     557,   558,   559,   560,   561,   562,   563,     0,  1291,   564,
     565,   566,   567,   568,  1292,     0,   569,   570,   571,   572,
     573,   574,  1293,     0,   576,   577,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,  1294,  1295,  1296,  1297,   594,  1298,  1299,  1300,
    1301,   599,   600,   601,   602,  1302,     0,     0,     0,     0,
       0,     0,  1303,  1304,     0,     0,     0,   229,     0,  1234,
     670,  1306,  1235,  1236,  1237,   731,  1238,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
    1239,     0,     0,   241,   242,     0,   243,   244,   245,   246,
     247,   248,   249,   250,  1240,   252,  1241,  1242,     0,   255,
     256,   257,   258,   259,   260,  1243,  1244,   261,   262,  1245,
    1246,   265,     0,   266,   267,   268,   269,  1247,     0,  1248,
       0,   272,   273,   274,   275,   276,   277,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,   287,   288,
     289,  4209,  1249,  1250,  1251,  1252,  1253,  1254,  1255,   292,
     293,   294,   295,   296,   297,  1256,  1257,   300,  1258,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,  1082,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,  1259,   328,   329,   330,   331,  1260,  1261,   333,
       0,   334,   335,  1262,   337,     0,   338,     0,   339,   340,
       0,   341,   342,   343,   344,   345,     0,   346,  1263,     0,
    1264,   349,   350,     0,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
    1265,  1266,     0,  1267,     0,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,     0,     0,   388,  1268,   390,
     391,   392,     0,   393,   394,   395,  1269,  1270,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,  1271,   413,  1272,   415,   416,   417,
     418,   419,   420,   421,   422,  1273,   424,  1274,   425,   426,
     427,   428,  1275,  1276,   430,  1277,   432,   433,   434,     0,
     435,   436,     0,     0,  1278,   438,   439,     0,     0,   440,
     441,   442,   443,   444,   445,  1279,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,  1280,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,  1281,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,  1282,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,  1283,
     514,   515,   516,   517,   518,   519,   520,   521,  1284,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,  1285,   538,     0,   539,   540,     0,
     541,   542,   543,   544,   545,   546,   547,     0,   548,  1286,
    1287,     0,     0,   551,   552,  1288,   554,  1289,  1290,   556,
     557,   558,   559,   560,   561,   562,   563,     0,  1291,   564,
     565,   566,   567,   568,  1292,     0,   569,   570,   571,   572,
     573,   574,  1293,     0,   576,   577,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,  1294,  1295,  1296,  1297,   594,  1298,  1299,  1300,
    1301,   599,   600,   601,   602,  1302,     0,     0,     0,     0,
       0,     0,  1303,  1304,     0,     0,     0,   229,     0,  1234,
     670,  1306,  1235,  1236,  1237,   731,  1238,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
    1239,     0,     0,   241,   242,     0,   243,   244,   245,   246,
     247,   248,   249,   250,  1240,   252,  1241,  1242,     0,   255,
     256,   257,   258,   259,   260,  1243,  1244,   261,   262,  1245,
    1246,   265,     0,   266,   267,   268,   269,  1247,     0,  1248,
       0,   272,   273,   274,   275,   276,   277,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,   287,   288,
     289,   290,  1249,  1250,  1251,  1252,  1253,  1254,  1255,   292,
     293,   294,   295,   296,   297,  1256,  1257,   300,  1258,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,  1082,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,  1259,   328,   329,   330,   331,  1260,  1261,   333,
       0,   334,   335,  1262,   337,     0,   338,     0,   339,   340,
       0,   341,   342,   343,   344,   345,     0,   346,  1263,     0,
    1264,   349,   350,     0,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
    1265,  1266,     0,  1267,     0,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,     0,     0,   388,  1268,   390,
     391,   392,     0,   393,   394,   395,  1269,  1270,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,  1271,   413,  1272,   415,   416,   417,
     418,   419,   420,   421,   422,  1273,   424,  1274,   425,   426,
     427,   428,  1275,  1276,   430,  1277,   432,   433,   434,     0,
     435,   436,     0,     0,  1278,   438,   439,     0,     0,   440,
     441,   442,   443,   444,   445,  1279,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,  1280,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,  1281,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,  1282,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,  1283,
     514,   515,   516,   517,   518,   519,   520,   521,  1284,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,  1285,   538,     0,   539,   540,     0,
     541,   542,   543,   544,   545,   546,   547,     0,   548,  1286,
    1287,     0,     0,   551,   552,  1288,   554,  1289,  1290,   556,
     557,   558,   559,   560,   561,   562,   563,     0,  1291,   564,
     565,   566,   567,   568,  1292,     0,   569,   570,   571,   572,
     573,   574,  1293,     0,   576,   577,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,  4560,  1294,  1295,  1296,  1297,   594,  1298,  1299,  1300,
    1301,   599,   600,   601,   602,  1302,     0,     0,     0,     0,
       0,     0,  1303,  1304,     0,     0,     0,   229,     0,  1234,
     670,  1306,  1235,  1236,  1237,   731,  1238,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
    1239,     0,     0,   241,   242,     0,   243,   244,   245,   246,
     247,   248,   249,   250,  1240,   252,  1241,  1242,     0,   255,
     256,   257,   258,   259,   260,  1243,  1244,   261,   262,  1245,
    1246,   265,     0,   266,   267,   268,   269,  1247,     0,  1248,
       0,   272,   273,   274,   275,   276,   277,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,   287,   288,
     289,   290,  1249,  1250,  1251,  1252,  1253,  1254,  1255,   292,
     293,   294,   295,   296,   297,  1256,  1257,   300,  1258,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,  1082,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,  1259,   328,   329,   330,   331,  1260,  1261,   333,
       0,   334,   335,  1262,   337,     0,   338,     0,   339,   340,
       0,   341,   342,   343,   344,   345,     0,   346,  1263,     0,
    1264,   349,   350,     0,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
    1265,  1266,     0,  1267,     0,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,     0,     0,   388,  1268,   390,
     391,   392,     0,   393,   394,   395,  1269,  1270,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,  1271,   413,  1272,   415,   416,   417,
     418,   419,   420,  4572,   422,  1273,   424,  1274,   425,   426,
     427,   428,  1275,  1276,   430,  1277,   432,   433,   434,     0,
     435,   436,     0,     0,  1278,   438,   439,     0,     0,   440,
     441,   442,   443,   444,   445,  1279,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,  1280,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,  1281,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,  1282,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,  1283,
     514,   515,   516,   517,   518,   519,   520,   521,  1284,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,  1285,   538,     0,   539,   540,     0,
     541,   542,   543,   544,   545,   546,   547,     0,   548,  1286,
    1287,     0,     0,   551,   552,  1288,   554,  1289,  1290,   556,
     557,   558,   559,   560,   561,   562,   563,     0,  1291,   564,
     565,   566,   567,   568,  1292,     0,   569,   570,   571,   572,
     573,   574,  1293,     0,   576,   577,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,  1294,  1295,  1296,  1297,   594,  1298,  1299,  1300,
    1301,   599,   600,   601,   602,  1302,     0,     0,     0,     0,
       0,     0,  1303,  1304,     0,     0,     0,   229,     0,  1234,
     670,  1306,  1235,  1236,  1237,   731,  1238,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
    1239,     0,     0,   241,   242,     0,   243,   244,   245,   246,
     247,   248,   249,   250,  1240,   252,  1241,  1242,     0,   255,
     256,   257,   258,   259,   260,  1243,  1244,   261,   262,  1245,
    1246,   265,     0,   266,   267,   268,   269,  1247,     0,  1248,
       0,   272,   273,   274,   275,   276,   277,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,   287,   288,
    4886,   290,  1249,  1250,  1251,  1252,  1253,  1254,  1255,   292,
     293,   294,   295,   296,   297,  1256,  1257,   300,  1258,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,  1082,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,  1259,   328,   329,   330,   331,  1260,  1261,   333,
       0,   334,   335,  1262,   337,     0,   338,     0,   339,   340,
       0,   341,   342,   343,   344,   345,     0,   346,  1263,     0,
    4887,   349,   350,     0,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
    1265,  1266,     0,  1267,     0,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,     0,     0,   388,  1268,   390,
     391,   392,     0,   393,   394,   395,  1269,  1270,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,  1271,   413,  1272,   415,   416,   417,
     418,   419,   420,   421,   422,  1273,   424,  1274,   425,   426,
     427,   428,  1275,  1276,   430,  1277,   432,   433,   434,     0,
     435,   436,     0,     0,  1278,   438,   439,     0,     0,   440,
     441,   442,   443,   444,   445,  1279,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,  1280,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,  1281,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
    4888,   497,   498,  1282,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,  1283,
     514,   515,   516,   517,   518,   519,   520,   521,  1284,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,  1285,   538,     0,   539,   540,     0,
     541,   542,   543,   544,   545,   546,   547,     0,   548,  1286,
    1287,     0,     0,   551,   552,  1288,   554,  1289,  1290,   556,
     557,   558,   559,   560,   561,   562,   563,     0,  1291,   564,
     565,   566,   567,   568,  1292,     0,   569,   570,   571,   572,
     573,   574,  1293,     0,   576,   577,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,  1294,  1295,  1296,  1297,   594,  1298,  1299,  1300,
    1301,   599,   600,   601,   602,  1302,     0,     0,     0,     0,
       0,     0,  1303,  1304,     0,     0,     0,   229,     0,  1234,
     670,  4889,  1235,  1236,  1237,   731,  1238,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
    1239,     0,     0,   241,   242,     0,   243,   244,   245,   246,
     247,   248,   249,  5359,  1240,   252,  1241,  1242,     0,   255,
     256,   257,   258,   259,   260,  1243,  1244,   261,   262,  1245,
    1246,   265,     0,   266,   267,   268,   269,  1247,     0,  1248,
       0,   272,   273,   274,   275,   276,   277,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,   287,   288,
     289,  5360,  1249,  1250,  1251,  1252,  1253,  1254,  1255,   292,
     293,   294,   295,   296,   297,  1256,  1257,   300,  1258,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,  1082,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,  1259,   328,   329,   330,   331,  1260,  1261,   333,
       0,   334,   335,  1262,   337,     0,   338,     0,   339,   340,
       0,   341,   342,   343,   344,   345,     0,   346,  1263,     0,
    1264,   349,   350,     0,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
    1265,  1266,     0,  1267,     0,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,     0,     0,   388,  1268,   390,
     391,   392,     0,   393,   394,   395,  1269,  1270,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,  1271,   413,  1272,   415,   416,   417,
     418,   419,   420,   421,   422,  1273,   424,  1274,   425,   426,
     427,   428,  1275,  1276,   430,  1277,   432,   433,   434,     0,
     435,   436,     0,     0,  1278,   438,   439,     0,     0,   440,
     441,   442,   443,   444,   445,  1279,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,  1280,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,  1281,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,  1282,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,  1283,
     514,   515,   516,   517,   518,   519,   520,   521,  1284,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,  1285,   538,     0,   539,   540,     0,
     541,   542,   543,   544,   545,   546,   547,     0,   548,  1286,
    1287,     0,     0,   551,   552,  1288,   554,  1289,  1290,   556,
     557,   558,   559,   560,  5361,   562,   563,     0,  1291,   564,
     565,   566,   567,   568,  1292,     0,   569,   570,   571,   572,
     573,   574,  1293,     0,   576,   577,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,  1294,  1295,  1296,  1297,   594,  1298,  1299,  1300,
    1301,   599,   600,   601,   602,  1302,     0,     0,     0,     0,
       0,     0,  1303,  1304,     0,     0,     0,   229,     0,  1234,
     670,  1306,  1235,  1236,  1237,   731,  1238,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
    1239,     0,     0,   241,   242,     0,   243,   244,   245,   246,
     247,   248,   249,   250,  1240,   252,  1241,  1242,     0,   255,
     256,   257,   258,   259,   260,  1243,  1244,   261,   262,  1245,
    1246,   265,     0,   266,   267,   268,   269,  1247,     0,  1248,
       0,   272,   273,   274,   275,   276,   277,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,   287,   288,
     289,  5360,  1249,  1250,  1251,  1252,  1253,  1254,  1255,   292,
     293,   294,   295,   296,   297,  1256,  1257,   300,  1258,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,  1082,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,  1259,   328,   329,   330,   331,  1260,  1261,   333,
       0,   334,   335,  1262,   337,     0,   338,     0,   339,   340,
       0,   341,   342,   343,   344,   345,     0,   346,  1263,     0,
    1264,   349,   350,     0,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
    1265,  1266,     0,  1267,     0,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,     0,     0,   388,  1268,   390,
     391,   392,     0,   393,   394,   395,  1269,  1270,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,  1271,   413,  1272,   415,   416,   417,
     418,   419,   420,   421,   422,  1273,   424,  1274,   425,   426,
     427,   428,  1275,  1276,   430,  1277,   432,   433,   434,     0,
     435,   436,     0,     0,  1278,   438,   439,     0,     0,   440,
     441,   442,   443,   444,   445,  1279,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,  1280,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,  1281,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,  1282,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,  1283,
     514,   515,   516,   517,   518,   519,   520,   521,  1284,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,  1285,   538,     0,   539,   540,     0,
     541,   542,   543,   544,   545,   546,   547,     0,   548,  1286,
    1287,     0,     0,   551,   552,  1288,   554,  1289,  1290,   556,
     557,   558,   559,   560,  5361,   562,   563,     0,  1291,   564,
     565,   566,   567,   568,  1292,     0,   569,   570,   571,   572,
     573,   574,  1293,     0,   576,   577,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,  1294,  1295,  1296,  1297,   594,  1298,  1299,  1300,
    1301,   599,   600,   601,   602,  1302,     0,     0,     0,     0,
       0,     0,  1303,  1304,     0,     0,     0,   229,     0,  1234,
     670,  1306,  1235,  1236,  1237,   731,  1238,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
    1239,     0,     0,   241,   242,     0,   243,   244,   245,   246,
     247,   248,   249,   250,  1240,   252,  1241,  1242,     0,   255,
     256,   257,   258,   259,   260,  1243,  1244,   261,   262,  1245,
    1246,   265,     0,   266,   267,   268,   269,  1247,     0,  1248,
       0,   272,   273,   274,   275,   276,   277,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,   287,   288,
     289,   290,  1249,  1250,  1251,  1252,  1253,  1254,  1255,   292,
     293,   294,   295,   296,   297,  1256,  1257,   300,  5084,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,  1082,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,  1259,   328,   329,   330,   331,  1260,  1261,   333,
       0,   334,   335,  1262,   337,     0,   338,     0,   339,   340,
       0,   341,   342,   343,   344,   345,     0,   346,  1263,     0,
    1264,   349,   350,     0,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
    1265,  1266,     0,  1267,     0,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,     0,     0,   388,  1268,   390,
     391,   392,     0,   393,   394,   395,  1269,  1270,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,  1271,   413,  1272,   415,   416,   417,
     418,   419,   420,   421,   422,  1273,   424,     0,   425,   426,
     427,   428,  1275,  1276,   430,  1277,   432,   433,   434,     0,
     435,   436,     0,     0,  1278,   438,   439,     0,     0,   440,
     441,   442,   443,   444,   445,  1279,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,  1280,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,  1281,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,  2792,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,  1283,
     514,   515,   516,   517,   518,   519,   520,   521,  1284,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,  1285,   538,     0,   539,   540,     0,
     541,   542,   543,   544,   545,   546,   547,     0,   548,  1286,
    1287,     0,     0,   551,   552,  1288,   554,  1289,  1290,   556,
     557,   558,   559,   560,   561,   562,   563,     0,     0,   564,
     565,   566,   567,   568,  1292,     0,   569,   570,   571,   572,
     573,   574,  1293,     0,   576,   577,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,  1294,  1295,  1296,  1297,   594,  1298,  1299,  1300,
    1301,   599,   600,   601,   602,     0,     0,     0,     0,     0,
       0,     0,  2793,  2794,     0,     0,     0,   229,     0,  1234,
     670,  2795,  1235,  1236,  1237,   731,  1238,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
    1239,     0,     0,   241,   242,     0,   243,   244,   245,   246,
     247,   248,   249, -2673,  1240,   252,  1241,  1242,     0,   255,
     256,   257,   258,   259,   260,  1243,  1244,   261,   262,  1245,
    1246,   265,     0,   266,   267,   268,   269,  1247,     0,  1248,
       0,   272,   273,   274,   275,   276,   277,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,   287,   288,
     289,  5360,  1249,  1250,  1251,  1252,  1253,  1254,  1255,   292,
     293,   294,   295,   296,   297,  1256,  1257,   300,  1258,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,  1082,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,  1259,   328,   329,   330,   331,  1260,  1261,   333,
       0,   334,   335,  1262,   337,     0,   338,     0,   339,   340,
       0,   341,   342,   343,   344,   345,     0,   346,  1263,     0,
    1264,   349,   350,     0,   351,   352,   353,   354,   355, -2673,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
    1265,  1266,     0,  1267,     0,   378,     0,     0,   381,   382,
     383,   384,   385,   386,   387,     0,     0,   388,  1268,   390,
     391, -2673,     0,   393,   394,   395,  1269,  1270,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,  1271,   413,  1272,   415,   416,   417,
     418,   419,   420,   421,   422,  1273,   424,  1274,   425,   426,
       0,   428,  1275,  1276,   430,  1277,   432,   433,   434,     0,
     435,   436,     0,     0,  1278,   438,   439,     0,     0,   440,
     441,   442,   443,   444,   445,  1279,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,  1280,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,  1281,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,  1282,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,  1283,
     514,   515,   516,   517,   518, -2673,   520,   521,  1284,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,  1285,   538,     0,   539,   540,     0,
     541,   542,   543,   544,   545,   546,   547,     0,   548,  1286,
    1287,     0,     0,   551,   552,  1288,   554,  1289,  1290,   556,
     557,   558,   559,   560,  5361,   562,   563,     0,  1291,   564,
     565,   566,   567,   568,  1292,     0,   569,   570,   571,   572,
     573,   574,  1293,     0,   576,   577,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,  1294,  1295,  1296,  1297,   594,  1298,  1299,  1300,
    1301,   599,   600,   601,   602, -2673,     0,     0,     0,     0,
       0,     0,  1303,  1304,     0,     0,     0,   229,     0,  1234,
     670,  1306,  1235,  1236,  1237,   731,  1238,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
    1239,     0,     0,   241,   242,     0,   243,   244,   245,   246,
     247,   248,   249,   250,  1240,   252,  1241,  1242,     0,   255,
     256,   257,   258,   259,   260,  1243,  1244,   261,   262,  1245,
    1246,   265,     0,   266,   267,   268,   269,  1247,     0,  1248,
       0,   272,   273,   274,   275,   276,   277,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,   287,   288,
     289,   290,  1249,  1250,  1251,  1252,  1253,  1254,  1255,   292,
     293,   294,   295,   296,   297,  1256,  1257,   300,     0,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,  1082,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,  1259,   328,   329,   330,   331,  1260,  1261,   333,
       0,   334,   335,  1262,   337,     0,   338,     0,   339,   340,
       0,   341,   342,   343,   344,   345,     0,   346,  1263,     0,
    1264,   349,   350,     0,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
    1265,  1266,     0,  1267,     0,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,     0,     0,   388,  1268,   390,
     391,   392,     0,   393,   394,   395,  1269,  1270,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,  1271,   413,  1272,   415,   416,   417,
     418,   419,   420,   421,   422,  1273,   424,     0,   425,   426,
     427,   428,  1275,  1276,   430,  1277,   432,   433,   434,     0,
     435,   436,     0,     0,  1278,   438,   439,     0,     0,   440,
     441,   442,   443,   444,   445,  1279,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,  1280,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,  1281,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,  2792,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,  1283,
     514,   515,   516,   517,   518,   519,   520,   521,  1284,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,  1285,   538,     0,   539,   540,     0,
     541,   542,   543,   544,   545,   546,   547,     0,   548,  1286,
    1287,     0,     0,   551,   552,  1288,   554,  1289,  1290,   556,
     557,   558,   559,   560,   561,   562,   563,     0,     0,   564,
     565,   566,   567,   568,  1292,     0,   569,   570,   571,   572,
     573,   574,  1293,     0,   576,   577,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,  1294,  1295,  1296,  1297,   594,  1298,  1299,  1300,
    1301,   599,   600,   601,   602,     0,     0,     0,     0,     0,
       0,     0,  2793,  2794,   229,     0,  1234,   670,     0,  1235,
    1236,  2795,   731,  1238,     0,     0,     0,     0,     0,     0,
       0,   230,   231,   232,   233,   234,   235,   236,   237,     0,
     238,   239,   240,     0,     0,     0,     0,  1239,     0,     0,
     241,   242,     0,   243,   244,   245,   246,   247,   248,   249,
     250,  1240,   252,  1241,  1242,     0,   255,   256,   257,   258,
     259,   260,  1243,  1244,   261,   262,  1245,  1246,   265,     0,
     266,   267,   268,   269,  1247,     0,  1248,     0,   272,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,     0,   287,   288,   289,   290,  1249,
    1250,  1251,  1252,  1253,  1254,  1255,   292,   293,   294,   295,
     296,   297,  1256,  1257,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,  1082,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,  1259,
     328,   329,   330,   331,  1260,  1261,   333,     0,   334,   335,
    1262,   337,     0,   338,     0,   339,   340,     0,   341,   342,
     343,   344,   345,     0,   346,  1263,     0,  1264,   349,   350,
       0,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,     0,   361,   362,   363,   364,   365,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,  1265,  1266,     0,
    1267,     0,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,     0,     0,   388,  1268,   390,   391,   392,     0,
     393,   394,   395,  1269,  1270,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,  1271,   413,  1272,   415,   416,   417,   418,   419,   420,
     421,   422,  1273,   424,     0,   425,   426,   427,   428,  1275,
    1276,   430,  1277,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,     0,     0,   440,   441,   442,   443,
     444,   445,  1279,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,  1280,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,  1281,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,   494,   495,   496,   497,   498,
    2923,  2924,   501,   502,   503,   504,   505,   506,   507,   508,
       0,   509,   510,   511,   512,   513,  1283,   514,   515,   516,
     517,   518,   519,   520,   521,  1284,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,  1285,   538,     0,   539,   540,     0,   541,   542,   543,
     544,   545,   546,   547,     0,   548,  1286,  1287,     0,     0,
     551,   552,  1288,   554,  1289,  1290,   556,   557,   558,   559,
     560,   561,   562,   563,     0,     0,   564,   565,   566,   567,
     568,  1292,     0,   569,   570,   571,   572,   573,   574,  1293,
       0,   576,   577,   578,   579,   580,   581,     0,     0,   582,
       0,     0,   583,   584,   585,   586,   587,   588,   589,  1294,
    1295,  1296,  1297,   594,  1298,  1299,  1300,  1301,   599,   600,
     601,   602,     0,     0,     0,     0,     0,     0,     0,  2925,
    2926,     0,     0,     0,   229,     0,  1234,   670,  2795,  1235,
    1236,  1237,   731,  1238,     0,     0,     0,     0,     0,     0,
       0,   230,   231,   232,   233,   234,   235,   236,   237,     0,
     238,   239,   240,     0,     0,     0,     0,  1239,     0,     0,
     241,   242,     0,   243,   244,   245,   246,   247,   248,   249,
     250,  1240,   252,  1241,  1242,     0,   255,   256,   257,   258,
     259,   260,  1243,  1244,   261,   262,  1245,  1246,   265,     0,
     266,   267,   268,   269,  1247,     0,  1248,     0,   272,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,     0,   287,   288,   289,   290,  1249,
    1250,  1251,  1252,  1253,  1254,  1255,   292,   293,   294,   295,
     296,   297,  1256,  1257,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,  1082,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,  1259,
     328,   329,   330,   331,  1260,  1261,   333,     0,   334,   335,
    1262,   337,     0,   338,     0,   339,   340,     0,   341,   342,
     343,   344,   345,     0,   346,  1263,     0,  1264,   349,   350,
       0,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,     0,   361,   362,   363,   364,   365,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,  1265,  1266,     0,
    1267,     0,   378,     0,   380,   381,   382,   383,   384,   385,
     386,   387,     0,     0,   388,  1268,   390,   391,   392,     0,
     393,   394,   395,  1269,  1270,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,  1271,   413,  1272,   415,   416,   417,   418,   419,   420,
     421,   422,  1273,   424,     0,   425,   426,   427,   428,  1275,
    1276,   430,  1277,   432,   433,   434,     0,   435,   436,     0,
       0,  1278,   438,   439,     0,     0,   440,   441,   442,   443,
     444,   445,  1279,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,  1280,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,  1281,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,   494,   495,   496,   497,   498,
    2792,   500,   501,   502,   503,   504,   505,   506,   507,   508,
       0,   509,   510,   511,   512,   513,  1283,   514,   515,   516,
     517,   518,   519,   520,   521,  1284,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,  1285,   538,     0,   539,   540,     0,   541,   542,   543,
     544,   545,   546,   547,     0,   548,  1286,  1287,     0,     0,
     551,   552,  1288,   554,  1289,  1290,   556,   557,   558,   559,
     560,   561,   562,   563,     0,     0,   564,   565,   566,   567,
     568,  1292,     0,   569,   570,   571,   572,   573,   574,  1293,
       0,   576,   577,   578,   579,   580,   581,     0,     0,   582,
       0,     0,   583,   584,   585,   586,   587,   588,   589,  1294,
    1295,  1296,  1297,   594,  1298,  1299,  1300,  1301,   599,   600,
     601,   602,     0,     0,     0,     0,     0,     0,     0,  2793,
    2794,   229,     0,  1234,   670,     0,  1235,  1236,  2795,   731,
    1238,     0,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   236,   237,     0,   238,   239,   240,
       0,     0,     0,     0,  1239,     0,     0,   241,   242,     0,
     243,   244,   245,   246,   247,   248,   249,   250,  1240,   252,
    1241,  1242,     0,   255,   256,   257,   258,   259,   260,  1243,
    1244,   261,   262,  1245,  1246,   265,     0,   266,   267,   268,
     269,  1247,     0,  1248,     0,   272,   273,   274,   275,   276,
     277,   278,   279,   280,     0,   281,   282,   283,   284,   285,
     286,     0,   287,   288,   289,   290,  1249,  1250,  1251,  1252,
    1253,  1254,  1255,   292,   293,   294,   295,   296,   297,  1256,
    1257,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   309,   310,   311,     0,     0,   312,   313,
    1082,   315,   316,     0,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,  1259,   328,   329,   330,
     331,  1260,  1261,   333,     0,   334,   335,  1262,   337,     0,
     338,     0,   339,   340,     0,   341,   342,   343,   344,   345,
       0,   346,  1263,     0,  1264,   349,   350,     0,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,     0,   361,
     362,   363,   364,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,  1265,  1266,     0,  1267,     0,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,     0,
       0,   388,  1268,   390,   391,   392,     0,   393,   394,   395,
    1269,  1270,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,  1271,   413,
    1272,   415,   416,   417,   418,   419,   420,   421,   422,  1273,
     424,     0,   425,   426,   427,   428,  1275,  1276,   430,  1277,
     432,   433,   434,     0,   435,   436,     0,     0,   437,   438,
     439,     0,     0,   440,   441,   442,   443,   444,   445,  1279,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
       0,   456,   457,  1280,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
    1281,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,   494,   495,   496,   497,   498,  2792,   500,   501,
     502,   503,   504,   505,   506,   507,   508,     0,   509,   510,
     511,   512,   513,  1283,   514,   515,   516,   517,   518,   519,
     520,   521,  1284,   523,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,  1285,   538,
       0,   539,   540,     0,   541,   542,   543,   544,   545,   546,
     547,     0,   548,  1286,  1287,     0,     0,   551,   552,  1288,
     554,  1289,  1290,   556,   557,   558,   559,   560,   561,   562,
     563,     0,     0,   564,   565,   566,   567,   568,  1292,     0,
     569,   570,   571,   572,   573,   574,  1293,     0,   576,   577,
     578,   579,   580,   581,     0,     0,   582,     0,     0,   583,
     584,   585,   586,   587,   588,   589,  1294,  1295,  1296,  1297,
     594,  1298,  1299,  1300,  1301,   599,   600,   601,   602,   229,
       0,  1234,   670,     0,  1235,  1236,     0,   731,  1238,     0,
       0,     0,     0,     0,     0,  2795,   230,   231,   232,   233,
     234,   235,   236,   237,     0,   238,   239,   240,     0,     0,
       0,     0,  1239,     0,     0,   241,   242,     0,   243,   244,
     245,   246,   247,   248,   249,   250,  1240,   252,  1241,  1242,
       0,  4115,   256,   257,   258,   259,   260,  1243,  1244,   261,
     262,  1245,  1246,   265,     0,   266,   267,   268,   269,  1247,
       0,  1248,     0,   272,   273,   274,   275,   276,   277,   278,
     279,   280,     0,   281,   282,   283,   284,   285,   286,     0,
     287,   288,   289,   290,  1249,  1250,  1251,  1252,  1253,  1254,
    1255,   292,   293,   294,   295,   296,   297,  1256,  1257,   300,
       0,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,   313,  1082,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,  1259,   328,   329,   330,   331,  1260,
    1261,   333,     0,   334,   335,  1262,   337,     0,   338,     0,
     339,   340,     0,   341,   342,   343,   344,   345,     0,   346,
    1263,     0,  1264,   349,   350,     0,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,     0,   361,   362,   363,
     364,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,  1265,  1266,     0,  1267,     0,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,     0,     0,   388,
    1268,   390,   391,   392,     0,   393,   394,   395,  1269,  1270,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,  1271,   413,  1272,   415,
     416,   417,   418,   419,   420,   421,   422,  1273,   424,     0,
     425,   426,   427,   428,  1275,  1276,   430,  1277,   432,   433,
     434,     0,   435,   436,     0,     0,   437,   438,   439,     0,
       0,   440,   441,   442,   443,   444,   445,  1279,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   456,
     457,  1280,   459,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,  1281,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,   493,
     494,   495,   496,   497,   498,  2792,   500,   501,   502,   503,
     504,   505,   506,   507,   508,     0,   509,   510,   511,   512,
     513,  1283,   514,   515,   516,   517,   518,   519,   520,   521,
    1284,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,  1285,   538,     0,   539,
     540,     0,   541,   542,   543,   544,   545,   546,   547,     0,
     548,  1286,  1287,     0,     0,   551,   552,  1288,   554,  1289,
    1290,   556,   557,   558,   559,   560,   561,   562,   563,     0,
       0,   564,   565,   566,   567,   568,  1292,     0,   569,   570,
     571,   572,   573,   574,  1293,     0,   576,   577,   578,   579,
     580,   581,     0,     0,   582,     0,     0,   583,   584,   585,
     586,   587,   588,   589,  1294,  1295,  1296,  1297,   594,  1298,
    1299,  1300,  1301,   599,   600,   601,   602,   229,     0,  1234,
     670,     0,  1235,  1236,     0,   731,  1238,     0,     0,     0,
       0,     0,     0,  2795,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
    1239,     0,     0,   241,   242,     0,   243,   244,   245,   246,
     247,   248,   249,   250,  1240,   252,  1241,  1242,     0,   255,
     256,   257,   258,   259,   260,  1243,  1244,   261,   262,  1245,
    1246,   265,     0,   266,   267,   268,   269,  1247,     0,  1248,
       0,   272,   273,   274,   275,   276,   277,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,   287,   288,
     289,   290,  1249,  1250,  1251,  1252,  1253,  1254,  1255,   292,
     293,   294,   295,   296,   297,  1256,  1257,   300,     0,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,  1082,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,  1259,   328,   329,   330,   331,  1260,  1261,   333,
       0,   334,   335,  1262,   337,     0,   338,     0,   339,   340,
       0,   341,   342,   343,   344,   345,     0,   346,  1263,     0,
    1264,   349,   350,     0,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
    1265,  1266,     0,  1267,     0,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,     0,     0,   388,  1268,   390,
     391,   392,     0,   393,   394,   395,  1269,  1270,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,  1271,   413,  1272,   415,   416,   417,
     418,   419,   420,   421,   422,  1273,   424,     0,   425,   426,
     427,   428,  1275,  1276,   430,  1277,   432,   433,   434,     0,
     435,   436,     0,     0,   437,   438,   439,     0,     0,   440,
     441,   442,   443,   444,   445,  1279,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,  1280,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,  1281,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,  2792,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,  1283,
     514,   515,   516,   517,   518,   519,   520,   521,  1284,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,  1285,   538,     0,   539,   540,     0,
     541,   542,   543,   544,   545,   546,   547,     0,   548,  1286,
    1287,     0,     0,   551,   552,  1288,   554,  1289,  1290,   556,
     557,   558,   559,   560,   561,   562,   563,     0,     0,   564,
     565,   566,   567,   568,  1292,     0,   569,   570,   571,   572,
     573,   574,  1293,     0,   576,   577,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,  1294,  1295,  1296,  1297,  4603,  1298,  1299,  1300,
    1301,   599,   600,   601,   602,   229,     0,  1234,   670,     0,
    1235,  1236,  1237,   731,  1238,     0,     0,     0,     0,     0,
       0,  2795,   230,   231,   232,   233,   234,   235,   236,   237,
       0,   238,   239,   240,     0,     0,     0,     0,  1239,     0,
       0,   241,   242,     0,   243,   244,   245,   246,   247,   248,
     249,     0,  1240,   252,  1241,  1242,     0,   255,   256,   257,
     258,   259,   260,  1243,  1244,   261,   262,  1245,  1246,   265,
       0,   266,   267,   268,   269,  1247,     0,  1248,     0,   272,
     273,   274,   275,   276,   277,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0,   287,   288,   289,   290,
    1249,  1250,  1251,  1252,  1253,  1254,  1255,   292,   293,   294,
     295,   296,   297,  1256,  1257,   300,  1258,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,  1082,   315,   316,     0,   317,   318,
     319,     0,   320,     0,   322,     0,   323,   324,   325,   326,
    1259,   328,   329,   330,   331,  1260,  1261,   333,     0,   334,
     335,  1262,   337,     0,   338,     0,   339,   340,     0,   341,
     342,   343,   344,   345,     0,   346,  1263,     0,  1264,   349,
     350,     0,   351,   352,   353,   354,   355,     0,   357,   358,
     359,   360,     0,   361,   362,   363,   364,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,  1265,  1266,
       0,  1267,     0,   378,     0,     0,   381,   382,   383,   384,
     385,   386,   387,     0,     0,   388,  1268,   390,   391,     0,
       0,   393,   394,   395,  1269,  1270,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,  1271,   413,  1272,   415,   416,   417,   418,   419,
     420,   421,   422,  1273,   424,  1274,   425,   426,     0,   428,
    1275,  1276,   430,  1277,   432,   433,   434,     0,   435,   436,
       0,     0,  1278,   438,   439,     0,     0,   440,   441,   442,
     443,   444,   445,  1279,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,  1280,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,  1281,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,   494,   495,   496,   497,
     498,  1282,   500,   501,   502,   503,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,   513,  1283,   514,   515,
     516,   517,   518,     0,   520,   521,  1284,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,  1285,   538,     0,   539,   540,     0,   541,   542,
     543,   544,   545,   546,   547,     0,   548,  1286,  1287,     0,
       0,   551,   552,  1288,   554,  1289,  1290,   556,   557,   558,
     559,   560,   561,   562,   563,     0,  1291,   564,   565,   566,
     567,   568,  1292,     0,   569,   570,   571,   572,   573,   574,
    1293,     0,   576,   577,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,   589,
    1294,  1295,  1296,  1297,   594,  1298,  1299,  1300,  1301,   599,
     600,   601,   602,   229,     0,     0,     0,     0,     0,     0,
    1303,  1304,     0,     0,     0,     0,     0,     0,     0,  1306,
     230,   231,   232,   233,   234,   235,   236,   237,     0,   238,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,     0,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,   256,   257,   258,   259,
     260,     0,  1244,   261,   262,   263,   264,   265,     0,   266,
     267,   268,   269,  1247,     0,  1248,     0,   272,   273,   274,
     275,   276,   277,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,   287,   288,   289,   290,  1249,  1250,
    1251,  1252,  1253,  1254,  1255,   292,   293,   294,   295,   296,
     297,   298,   299,   300,     0,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,   314,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,  1260,     0,   333,     0,   334,   335,   336,
     337,     0,   338,     0,   339,   340,     0,   341,   342,   343,
     344,   345,     0,   346,  1263,     0,   348,   349,   350,     0,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,     0,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,  3623,     0,   388,  1268,   390,   391,   392,     0,   393,
     394,   395,  1269,  1270,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,  1273,   424,     0,   425,   426,   427,   428,     0,  1276,
     430,   431,   432,   433,   434,     0,   435,   436,     0,   823,
     437,   438,   439,     0,     0,   440,   441,   442,   443,   444,
     445,  1279,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,  1280,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,   494,   495,   496,   497,   498,   499,
    3624,   501,   502,   503,   504,   505,   506,   507,   508,    41,
     509,   510,   511,   512,   513,  1283,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
    1285,   538,     0,   539,   540,    45,   541,   542,   543,   544,
     545,   546,   547,     0,   548,   549,   550,     0,     0,   551,
     552,  1288,   554,  1289,     0,   556,   557,   558,   559,   560,
     561,   562,   563,     0,     0,   564,   565,   566,   567,   568,
    1292,     0,   569,   570,   571,   572,   573,  1161,   575,     0,
     576,   577,   578,   579,   580,   581,     0,     0,   582,     0,
      50,   583,   584,   585,   586,   587,   588,   589,  1294,  1295,
    1296,  1297,   594,  1298,  1299,  1300,  1301,  3625,   600,   601,
     602,   229,     0,    51,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3626,   230,   231,
     232,   233,   234,   235,   236,   237,     0,   238,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,     0,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
    1244,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,  1247,     0,  1248,     0,   272,   273,   274,   275,   276,
     277,   278,   279,   280,     0,   281,   282,   283,   284,   285,
     286,     0,   287,   288,   289,   290,  1249,  1250,  1251,  1252,
    1253,  1254,  1255,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   309,   310,   311,     0,     0,   312,   313,
     314,   315,   316,     0,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,  1260,     0,   333,     0,   334,   335,   336,   337,     0,
     338,     0,   339,   340,     0,   341,   342,   343,   344,   345,
       0,   346,  1263,     0,   348,   349,   350,     0,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,     0,   361,
     362,   363,   364,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,     0,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,  3623,
       0,   388,  1268,   390,   391,   392,     0,   393,   394,   395,
    1269,  1270,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,  1273,
     424,     0,   425,   426,   427,   428,     0,  1276,   430,   431,
     432,   433,   434,     0,   435,   436,     0,   823,   437,   438,
     439,     0,     0,   440,   441,   442,   443,   444,   445,  1279,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
       0,   456,   457,  1280,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,   494,   495,   496,   497,   498,   499,  3624,   501,
     502,   503,   504,   505,   506,   507,   508,     0,   509,   510,
     511,   512,   513,  1283,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,  1285,   538,
       0,   539,   540,     0,   541,   542,   543,   544,   545,   546,
     547,     0,   548,   549,   550,     0,     0,   551,   552,  1288,
     554,  1289,     0,   556,   557,   558,   559,   560,   561,   562,
     563,     0,     0,   564,   565,   566,   567,   568,  1292,     0,
     569,   570,   571,   572,   573,   574,   575,     0,   576,   577,
     578,   579,   580,   581,     0,     0,   582,     0,     0,   583,
     584,   585,   586,   587,   588,   589,  1294,  1295,  1296,  1297,
     594,  1298,  1299,  1300,  1301,  3625,   600,   601,   602,   229,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3626,   230,   231,   232,   233,
     234,   235,   236,   237,     0,   238,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,     0,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,   256,   257,   258,   259,   260,     0,  1244,   261,
     262,   263,   264,   265,     0,   266,   267,   268,   269,  1247,
       0,  1248,     0,   272,   273,   274,   275,   276,   277,   278,
     279,   280,     0,   281,   282,   283,   284,   285,   286,     0,
     287,   288,   289,   290,  1249,  1250,  1251,  1252,  1253,  1254,
    1255,   292,   293,   294,   295,   296,   297,   298,   299,   300,
       0,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,   313,   314,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,  1260,
       0,   333,     0,   334,   335,   336,   337,     0,   338,     0,
     339,   340,     0,   341,   342,   343,   344,   345,     0,   346,
    1263,     0,   348,   349,   350,     0,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,     0,   361,   362,   363,
     364,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,     0,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,     0,     0,   388,
    1268,   390,   391,   392,     0,   393,   394,   395,  1269,  1270,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,  1273,   424,     0,
     425,   426,   427,   428,     0,  1276,   430,   431,   432,   433,
     434,     0,   435,   436,     0,     0,   437,   438,   439,     0,
       0,   440,   441,   442,   443,   444,   445,  1279,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   456,
     457,  1280,   459,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,   493,
     494,   495,   496,   497,   498,   499,  3624,   501,   502,   503,
     504,   505,   506,   507,   508,     0,   509,   510,   511,   512,
     513,  1283,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,  1285,   538,     0,   539,
     540,     0,   541,   542,   543,   544,   545,   546,   547,     0,
     548,   549,   550,     0,     0,   551,   552,  1288,   554,  1289,
       0,   556,   557,   558,   559,   560,   561,   562,   563,     0,
       0,   564,   565,   566,   567,   568,  1292,     0,   569,   570,
     571,   572,   573,   574,   575,     0,   576,   577,   578,   579,
     580,   581,     0,     0,   582,     0,     0,   583,   584,   585,
     586,   587,   588,   589,  1294,  1295,  1296,  1297,   594,  1298,
    1299,  1300,  1301,  3625,   600,   601,   602,   229,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    52,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
       0,     0,     0,   241,   242,     0,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,  1244,   261,   262,   263,
     264,   265,     0,   266,   267,   268,   269,  1247,     0,  1248,
       0,   272,   273,   274,   275,   276,   277,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,   287,   288,
     289,   290,  1249,  1250,  1251,  1252,  1253,  1254,  1255,   292,
     293,   294,   295,   296,   297,   298,   299,   300,     0,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,   314,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,  1260,     0,   333,
       0,   334,   335,   336,   337,     0,   338,     0,   339,   340,
       0,   341,   342,   343,   344,   345,     0,   346,  1263,     0,
     348,   349,   350,     0,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,     0,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,     0,     0,   388,  1268,   390,
     391,   392,     0,   393,   394,   395,  1269,  1270,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,  1273,   424,     0,   425,   426,
     427,   428,     0,  1276,   430,   431,   432,   433,   434,     0,
     435,   436,     0,     0,   437,   438,   439,     0,     0,   440,
     441,   442,   443,   444,   445,  1279,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,  1280,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,  1283,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,  1285,   538,     0,   539,   540,     0,
     541,   542,   543,   544,   545,   546,   547,     0,   548,   549,
     550,     0,     0,   551,   552,  1288,   554,  1289,     0,   556,
     557,   558,   559,   560,   561,   562,   563,     0,     0,   564,
     565,   566,   567,   568,  1292,     0,   569,   570,   571,   572,
     573,   574,   575,     0,   576,   577,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,  1294,  1295,  1296,  1297,   594,  1298,  1299,  1300,
    1301,   599,   600,   601,   602,   229,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4227,   230,   231,   232,   233,   234,   235,   236,   237,
       0,   238,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,     0,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,  1244,   261,   262,   263,   264,   265,
       0,   266,   267,   268,   269,  1247,     0,  1248,     0,   272,
     273,   274,   275,   276,   277,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0,   287,   288,   289,   290,
    1249,  1250,  1251,  1252,  1253,  1254,  1255,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,   314,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,  1260,     0,   333,     0,   334,
     335,   336,   337,     0,   338,     0,   339,   340,     0,   341,
     342,   343,   344,   345,     0,   346,  1263,     0,   348,   349,
     350,     0,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,     0,   361,   362,   363,   364,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,     0,     0,   388,  1268,   390,   391,   392,
       0,   393,   394,   395,  1269,  1270,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,  1273,   424,     0,   425,   426,   427,   428,
       0,  1276,   430,   431,   432,   433,   434,     0,   435,   436,
       0,     0,   437,   438,   439,     0,     0,   440,   441,   442,
     443,   444,   445,  1279,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,  1280,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,   513,  1283,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,  1285,   538,     0,   539,   540,     0,   541,   542,
     543,   544,   545,   546,   547,     0,   548,   549,   550,     0,
       0,   551,   552,  1288,   554,  1289,     0,   556,   557,   558,
     559,   560,   561,   562,   563,     0,     0,   564,   565,   566,
     567,   568,  1292,     0,   569,   570,   571,   572,   573,   574,
     575,     0,   576,   577,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,   589,
    1294,  1295,  1296,  1297,   594,  1298,  1299,  1300,  1301,   599,
     600,   601,   602,   878,     0,  1518,   670,     0,     0,     0,
       0,   731,     0,     0,     0,     0,     0,     0,     0,  5337,
     230,   231,   232,   233,   234,   235,   236,   237,     0,   238,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,     0,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,   256,   257,   258,   259,
     260,     0,     0,   261,   262,   263,   264,   265,     0,   266,
     267,   268,   269,   270,     0,   271,     0,   272,   273,   274,
     275,   276,   277,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,   287,   288,   289,   290,     0,     0,
       0,   291,     0,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,     0,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,   314,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,  1933,   333,     0,   334,   335,   336,
     337,     0,   338,     0,   339,   340,     0,   341,   342,   343,
     344,   345,     0,   346,   347,     0,   348,   349,   350,     0,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,     0,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,     0,     0,   388,   389,   390,   391,   392,     0,   393,
     394,   395,     0,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   427,   428,     0,   429,
     430,   431,   432,   433,   434,     0,   435,   436,  1934,     0,
     437,   438,   439,     0,     0,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,   458,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,   513,     0,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,     0,   539,   540,     0,   541,   542,   543,   544,
     545,   546,   547,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,  1935,   556,   557,   558,   559,   560,
     561,   562,   563,     0,     0,   564,   565,   566,   567,   568,
       0,     0,   569,   570,   571,   572,   573,   574,   575,     0,
     576,   577,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   878,     0,     0,     0,     0,     0,     0,  1519,  1520,
    5149,     0,     0,     0,     0,     0,     0,  5150,   230,   231,
     232,   233,   234,   235,   236,   237,     0,   238,   239,   240,
       3,     4,     0,     0,     0,     0,     0,   241,   242,     0,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,     0,   271,     0,   272,   273,   274,   275,   276,
     277,   278,   279,   280,     0,   281,   282,   283,   284,   285,
     286,     0,   287,   288,   289,   290,     0,     0,     0,   291,
       0,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   309,   310,   311,     0,     0,   312,   313,
     314,   315,   316,     0,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,     0,   333,     0,   334,   335,   336,   337,     0,
     338,     0,   339,   340,     0,   341,   342,   343,   344,   345,
       0,   346,   347,     0,   348,   349,   350,     0,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,     0,   361,
     362,   363,   364,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,     0,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,     0,
       0,   388,   389,   390,   391,   392,     0,   393,   394,   395,
       0,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   427,   428,     0,   429,   430,   431,
     432,   433,   434,     0,   435,   436,     0,     0,   437,   438,
     439,     0,     0,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
       0,   456,   457,   458,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,    41,   509,   510,
     511,   512,   513,     0,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
       0,   539,   540,    45,   541,   542,   543,   544,   545,   546,
     547,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,   561,   562,
     563,     0,     0,   564,   565,   566,   567,   568,     0,     0,
     569,   570,   571,   572,   573,  1161,   575,     0,   576,   577,
     578,   579,   580,   581,     0,     0,   582,     0,    50,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   229,
       0,    51,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    52,   230,   231,   232,   233,
     234,   235,   236,   237,     0,   238,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,     0,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,   256,   257,   258,   259,   260,     0,     0,   261,
     262,   263,   264,   265,     0,   266,   267,   268,   269,   270,
       0,   271,     0,   272,   273,   274,   275,   276,   277,   278,
     279,   280,     0,   281,   282,   283,   284,   285,   286,     0,
     287,   288,   289,   290,     0,     0,     0,   291,     0,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
       0,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,   313,   314,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
       0,   333,     0,   334,   335,   336,   337,     0,   338,     0,
     339,   340,     0,   341,   342,   343,   344,   345,     0,   346,
     347,     0,   348,   349,   350,     0,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,     0,   361,   362,   363,
     364,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,     0,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,     0,     0,   388,
     389,   390,   391,   392,     0,   393,   394,   395,     0,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   427,   428,     0,   429,   430,   431,   432,   433,
     434,     0,   435,   436,     0,     0,   437,   438,   439,     0,
       0,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   456,
     457,   458,   459,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,     0,   509,   510,   511,   512,
     513,     0,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,     0,   539,
     540,     0,   541,   542,   543,   544,   545,   546,   547,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,     0,
       0,   564,   565,   566,   567,   568,     0,     0,   569,   570,
     571,   572,   573,   574,   575,     0,   576,   577,   578,   579,
     580,   581,     0,     0,   582,     0,     0,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   610,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4932,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
       0,     0,     0,   241,   242,     0,   243,   244,   245,     0,
     247,   248,   249,   250,   251,     0,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,     0,   261,   262,   263,
     264,   265,     0,   266,   267,   268,   269,   270,     0,     0,
       0,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,     0,   288,
     289,   290,     0,     0,     0,     0,     0,     0,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,     0,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,   314,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,     0,   333,
       0,   334,   335,   336,   337,     0,   338,     0,   339,     0,
       0,     0,   342,   343,   344,   345,     0,   346,   347,     0,
     348,   349,   350,     0,   351,   352,   353,   354,   355,     0,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,     0,   370,   371,   372,   373,   374,
     375,   376,     0,   377,     0,   378,     0,     0,   381,     0,
     383,   384,   385,   386,   387,     0,     0,   388,   389,     0,
     391,     0,     0,   393,   394,   395,     0,     0,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   428,     0,   429,   430,   431,   432,   433,   434,     0,
     435,   436,     0,     0,   437,   438,   439,     0,     0,   440,
     441,   442,     0,   444,     0,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,   458,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,    41,   509,   510,   511,   512,   513,     0,
     514,   515,   516,   517,   518,     0,   520,   521,   522,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,     0,   539,   540,    45,
     541,     0,   543,   544,   545,   546,   547,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,   561,   562,   563,     0,     0,   564,
     565,   566,   567,   568,     0,     0,   569,   570,   571,   572,
     573,  1161,   575,     0,   576,     0,   578,   579,   580,   581,
       0,     0,   582,     0,    50,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   610,     0,    51,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    52,   230,   231,   232,   233,   234,   235,   236,   237,
       0,   238,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,     0,   243,   244,   245,     0,   247,   248,
     249,   250,   251,     0,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,     0,   261,   262,   263,   264,   265,
       0,   266,   267,   268,   269,   270,     0,     0,     0,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0,     0,   288,   289,   290,
       0,     0,     0,     0,     0,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,   314,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,     0,   333,     0,   334,
     335,   336,   337,     0,   338,     0,   339,     0,     0,     0,
     342,   343,   344,   345,     0,   346,   347,     0,   348,   349,
     350,     0,   351,   352,   353,   354,   355,     0,   357,   358,
     359,   360,     0,   361,   362,   363,   364,   365,   366,   367,
       0,   368,     0,   370,   371,   372,   373,   374,   375,   376,
       0,   377,     0,   378,     0,     0,   381,     0,   383,   384,
     385,   386,   387,     0,     0,   388,   389,     0,   391,     0,
       0,   393,   394,   395,     0,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   428,
       0,   429,   430,   431,   432,   433,   434,     0,   435,   436,
       0,     0,   437,   438,   439,     0,     0,   440,   441,   442,
       0,   444,     0,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,   458,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,   513,     0,   514,   515,
     516,   517,   518,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,     0,   539,   540,     0,   541,     0,
     543,   544,   545,   546,   547,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,   561,   562,   563,     0,     0,   564,   565,   566,
     567,   568,     0,     0,   569,   570,   571,   572,   573,   574,
     575,     0,   576,     0,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   610,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1364,
     230,   231,   232,   233,   234,   235,   236,   237,     0,   238,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,     0,   243,   244,   245,     0,   247,   248,   249,   250,
     251,     0,   253,   254,     0,   255,   256,   257,   258,   259,
     260,     0,     0,   261,   262,   263,   264,   265,     0,   266,
     267,   268,   269,   270,     0,     0,     0,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,     0,   288,   289,   290,     0,     0,
       0,     0,     0,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,     0,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,   314,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,     0,   333,     0,   334,   335,   336,
     337,     0,   338,     0,   339,     0,     0,     0,   342,   343,
     344,   345,     0,   346,   347,     0,   348,   349,   350,     0,
     351,   352,   353,   354,   355,     0,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
       0,   370,   371,   372,   373,   374,   375,   376,     0,   377,
       0,   378,     0,     0,   381,     0,   383,   384,   385,   386,
     387,     0,     0,   388,   389,     0,   391,     0,     0,   393,
     394,   395,     0,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   428,     0,   429,
     430,   431,   432,   433,   434,     0,   435,   436,     0,     0,
     437,   438,   439,     0,     0,   440,   441,   442,     0,   444,
       0,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,   458,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,   513,     0,   514,   515,   516,   517,
     518,     0,   520,   521,   522,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,     0,   539,   540,     0,   541,     0,   543,   544,
     545,   546,   547,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
     561,   562,   563,     0,     0,   564,   565,   566,   567,   568,
       0,     0,   569,   570,   571,   572,   573,   574,   575,     0,
     576,     0,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   610,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3448,   230,   231,
     232,   233,   234,   235,   236,   237,     0,   238,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,     0,
     243,   244,   245,     0,   247,   248,   249,   250,   251,     0,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,     0,     0,     0,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,   281,   282,   283,   284,   285,
     286,     0,     0,   288,   289,   290,     0,     0,     0,     0,
       0,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   309,   310,   311,     0,     0,   312,   313,
     314,   315,   316,     0,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,     0,   333,     0,   334,   335,   336,   337,     0,
     338,     0,   339,     0,     0,     0,   342,   343,   344,   345,
       0,   346,   347,     0,   348,   349,   350,     0,   351,   352,
     353,   354,   355,     0,   357,   358,   359,   360,     0,   361,
     362,   363,   364,   365,   366,   367,     0,   368,     0,   370,
     371,   372,   373,   374,   375,   376,     0,   377,     0,   378,
       0,     0,   381,     0,   383,   384,   385,   386,   387,     0,
       0,   388,   389,     0,   391,     0,     0,   393,   394,   395,
       0,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   428,     0,   429,   430,   431,
     432,   433,   434,     0,   435,   436,     0,     0,   437,   438,
     439,     0,     0,   440,   441,   442,     0,   444,     0,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
       0,   456,   457,   458,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,     0,   509,   510,
     511,   512,   513,     0,   514,   515,   516,   517,   518,     0,
     520,   521,   522,   523,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
       0,   539,   540,     0,   541,     0,   543,   544,   545,   546,
     547,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,   561,   562,
     563,     0,     0,   564,   565,   566,   567,   568,     0,     0,
     569,   570,   571,   572,   573,   574,   575,     0,   576,     0,
     578,   579,   580,   581,     0,     0,   582,     0,     0,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   610,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4152,   230,   231,   232,   233,
     234,   235,   236,   237,     0,   238,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,     0,   243,   244,
     245,     0,   247,   248,   249,   250,   251,     0,   253,   254,
       0,   255,   256,   257,   258,   259,   260,     0,     0,   261,
     262,   263,   264,   265,     0,   266,   267,   268,   269,   270,
       0,     0,     0,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,   281,   282,   283,   284,   285,   286,     0,
       0,   288,   289,   290,     0,     0,     0,     0,     0,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
       0,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,   313,   314,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
       0,   333,     0,   334,   335,   336,   337,     0,   338,     0,
     339,     0,     0,     0,   342,   343,   344,   345,     0,   346,
     347,     0,   348,   349,   350,     0,   351,   352,   353,   354,
     355,     0,   357,   358,   359,   360,     0,   361,   362,   363,
     364,   365,   366,   367,     0,   368,     0,   370,   371,   372,
     373,   374,   375,   376,     0,   377,     0,   378,     0,     0,
     381,     0,   383,   384,   385,   386,   387,     0,     0,   388,
     389,     0,   391,     0,     0,   393,   394,   395,     0,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   428,     0,   429,   430,   431,   432,   433,
     434,     0,   435,   436,     0,     0,   437,   438,   439,     0,
       0,   440,   441,   442,     0,   444,     0,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   456,
     457,   458,   459,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,     0,   509,   510,   511,   512,
     513,     0,   514,   515,   516,   517,   518,     0,   520,   521,
     522,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,     0,   539,
     540,     0,   541,     0,   543,   544,   545,   546,   547,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,     0,
       0,   564,   565,   566,   567,   568,     0,     0,   569,   570,
     571,   572,   573,   574,   575,     0,   576,     0,   578,   579,
     580,   581,     0,     0,   582,     0,     0,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,     0,     0,
    1074,     0,  1518,   670,     0,     0,     0,   892,   731,     0,
       0,     0,     0,  4620,   893,   894,   895,   230,   231,   232,
     233,   234,   235,   236,   237,  1650,   238,   239,   240,  1651,
    1652,  1653,  1654,  1655,  1656,  1657,   241,   242,  1658,   243,
     244,   245,   246,   247,   248,   249,     0,  1075,   252,  1076,
    1077,  1659,   255,   256,   257,   258,   259,   260,  1660,  1661,
     261,   262,  1078,  1079,   265,  1662,   266,   267,   268,   269,
       0,  1663,   271,  1664,   272,   273,   274,   275,   276,   277,
     278,   279,   280,  1665,   281,   282,   283,   284,   285,   286,
    1666,   287,   288,   289,   290,  1667,  1668,  1669,   291,  1670,
    1671,  1672,   292,   293,   294,   295,   296,   297,  1080,  1081,
     300,  1673,   301,  1674,   302,   303,   304,   305,   306,   307,
    1675,   308,   309,   310,   311,  1676,  1677,   312,   313,  1082,
     315,   316,  1678,   317,   318,   319,  1679,   320,   321,   322,
    1680,   323,   324,   325,   326,     0,   328,   329,   330,   331,
       0,  1681,   333,  1682,   334,   335,  1083,   337,  1683,   338,
    1684,   339,   340,  1685,   341,   342,   343,   344,   345,  1686,
     346,     0,  1687,     0,   349,   350,  1688,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,  1689,   361,   362,
     363,   364,   365,   366,   367,  1690,   368,   369,     0,   371,
     372,   373,   374,  1085,  1086,  1691,  1087,  1692,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,  1693,  1694,
     388,     0,   390,   391,   392,  1695,   393,   394,   395,  1696,
    1697,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,  1088,   413,  1089,
     415,   416,   417,   418,   419,   420,   421,  3886,     0,   424,
    1698,   425,   426,   427,   428,  1699,     0,   430,  1090,   432,
     433,   434,  1700,   435,   436,  1701,  1702,  3887,   438,   439,
    1703,  1704,   440,   441,     0,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,  1705,
     456,   457,     0,   459,     0,   461,   462,   463,  1706,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,  1091,
     475,   476,   477,   478,  1707,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,  1708,   491,   492,
     493,   494,   495,   496,   497,   498,     0,   500,   501,   502,
     503,   504,   505,   506,   507,   508,  1709,   509,   510,   511,
     512,   513,  1710,   514,   515,  2191,   517,   518,   519,   520,
     521,  1093,   523,  1711,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,     0,   538,  1712,
     539,   540,  1713,   541,   542,   543,   544,   545,   546,   547,
    1714,   548,  1094,  1095,  1715,  1716,   551,   552,     0,   554,
       0,  1717,   556,   557,   558,   559,   560,   561,   562,   563,
    1718,  1719,   564,   565,   566,   567,   568,  1720,  1721,   569,
     570,   571,   572,   573,     0,  1096,  1722,   576,   577,   578,
     579,   580,   581,  1723,  1724,   582,  1725,  1726,   583,   584,
     585,   586,   587,   588,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   600,   601,   602,     0,     0,
       0,   898,   899,   900,     0,  3888,  3889,   903,   904,   905,
     906,  1074,     0,  1518,   670,     0,     0,     0,   892,   731,
       0,     0,     0,     0,     0,   893,   894,   895,   230,   231,
     232,   233,   234,   235,   236,   237,  1650,   238,   239,   240,
    1651,  1652,  1653,  1654,  1655,  1656,  1657,   241,   242,  1658,
     243,   244,   245,   246,   247,   248,   249,     0,  1075,   252,
    1076,  1077,  1659,   255,   256,   257,   258,   259,   260,  1660,
    1661,   261,   262,  1078,  1079,   265,  1662,   266,   267,   268,
     269,     0,  1663,   271,  1664,   272,   273,   274,   275,   276,
     277,   278,   279,   280,  1665,   281,   282,   283,   284,   285,
     286,  1666,   287,   288,   289,   290,  1667,  1668,  1669,   291,
    1670,  1671,  1672,   292,   293,   294,   295,   296,   297,  1080,
    1081,   300,  1673,   301,  1674,   302,   303,   304,   305,   306,
     307,  1675,   308,   309,   310,   311,  1676,  1677,   312,   313,
    1082,   315,   316,  1678,   317,   318,   319,  1679,   320,   321,
     322,  1680,   323,   324,   325,   326,     0,   328,   329,   330,
     331,     0,  1681,   333,  1682,   334,   335,  1083,   337,  1683,
     338,  1684,   339,   340,  1685,   341,   342,   343,   344,   345,
    1686,   346,     0,  1687,     0,   349,   350,  1688,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,  1689,   361,
     362,   363,   364,   365,   366,   367,  1690,   368,   369,     0,
     371,   372,   373,   374,  1085,  1086,  1691,  1087,  1692,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,  1693,
    1694,   388,     0,   390,   391,   392,  1695,   393,   394,   395,
    1696,  1697,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,  1088,   413,
    1089,   415,   416,   417,   418,   419,   420,   421,  4322,     0,
     424,  1698,   425,   426,   427,   428,  1699,     0,   430,  1090,
     432,   433,   434,  1700,   435,   436,  1701,  1702,  3887,   438,
     439,  1703,  1704,   440,   441,     0,   443,   444,   445,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
    1705,   456,   457,     0,   459,     0,   461,   462,   463,  1706,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
    1091,   475,   476,   477,   478,  1707,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,  1708,   491,
     492,   493,   494,   495,   496,   497,   498,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,  1709,   509,   510,
     511,   512,   513,  1710,   514,   515,  2191,   517,   518,   519,
     520,   521,  1093,   523,  1711,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,     0,   538,
    1712,   539,   540,  1713,   541,   542,   543,   544,   545,   546,
     547,  1714,   548,  1094,  1095,  1715,  1716,   551,   552,     0,
     554,     0,  1717,   556,   557,   558,   559,   560,   561,   562,
     563,  1718,  1719,   564,   565,   566,   567,   568,  1720,  1721,
     569,   570,   571,   572,   573,     0,  1096,  1722,   576,   577,
     578,   579,   580,   581,  1723,  1724,   582,  1725,  1726,   583,
     584,   585,   586,   587,   588,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   600,   601,   602,     0,
       0,     0,   898,   899,   900,   610,  3888,  3889,   903,   904,
     905,   906,   892,     0,     0,     0,     0,     0,     0,   893,
     894,   895,   230,   231,   232,   233,   234,   235,   236,   237,
       0,   238,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,     0,   243,   244,   245,     0,   247,   248,
     249,   250,   251,     0,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,     0,   261,   262,   263,   264,   265,
       0,   266,   896,   268,   269,   270,     0,     0,     0,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0,     0,   288,   289,   290,
       0,     0,     0,     0,     0,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,   314,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,     0,   897,     0,   334,
     335,   336,   337,     0,   338,     0,   339,     0,     0,     0,
     342,   343,   344,   345,     0,   346,   347,     0,   348,   349,
     350,     0,   351,   352,   353,   354,   355,     0,   357,   358,
     359,   360,     0,   361,   362,   363,   364,   365,   366,   367,
       0,   368,     0,   370,   371,   372,   373,   374,   375,   376,
       0,   377,     0,   378,     0,     0,   381,     0,   383,   384,
     385,   386,   387,     0,     0,   388,   389,     0,   391,     0,
       0,   393,   394,   395,     0,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   428,
       0,   429,   430,   431,   432,   433,   434,     0,   435,   436,
       0,     0,   437,   438,   439,     0,     0,   440,   441,   442,
       0,   444,     0,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,   458,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,   513,     0,   514,   515,
     516,   517,   518,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,     0,   539,   540,     0,   541,     0,
     543,   544,   545,   546,   547,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,   561,   562,   563,     0,     0,   564,   565,   566,
     567,   568,     0,     0,   569,   570,   571,   572,   573,   574,
     575,     0,   576,     0,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,     0,     0,   898,   899,   900,   610,
     901,   902,   903,   904,   905,   906,   892,     0,     0,     0,
       0,     0,     0,   893,   894,   895,   230,   231,   232,   233,
     234,   235,   236,   237,     0,   238,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,     0,   243,   244,
     245,     0,   247,   248,   249,   250,   251,     0,   253,   254,
       0,   255,   256,   257,   258,   259,   260,     0,     0,   261,
     262,   263,   264,   265,     0,   266,  1024,   268,   269,   270,
       0,     0,     0,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,   281,   282,   283,   284,   285,   286,     0,
       0,   288,   289,   290,     0,     0,     0,     0,     0,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
       0,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,   313,   314,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
       0,  1025,     0,   334,   335,   336,   337,     0,   338,     0,
     339,     0,     0,     0,   342,   343,   344,   345,     0,   346,
     347,     0,   348,   349,   350,     0,   351,   352,   353,   354,
     355,     0,   357,   358,   359,   360,     0,   361,   362,   363,
     364,   365,   366,   367,     0,   368,     0,   370,   371,   372,
     373,   374,   375,   376,     0,   377,     0,   378,     0,     0,
     381,     0,   383,   384,   385,   386,   387,     0,     0,   388,
     389,     0,   391,     0,     0,   393,   394,   395,     0,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   428,     0,   429,   430,   431,   432,   433,
     434,     0,   435,   436,     0,     0,   437,   438,   439,     0,
       0,   440,   441,   442,     0,   444,     0,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   456,
     457,   458,   459,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,     0,   509,   510,   511,   512,
     513,     0,   514,   515,   516,   517,   518,     0,   520,   521,
     522,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,     0,   539,
     540,     0,   541,     0,   543,   544,   545,   546,   547,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,     0,
       0,   564,   565,   566,   567,   568,     0,     0,   569,   570,
     571,   572,   573,   574,   575,     0,   576,     0,   578,   579,
     580,   581,     0,     0,   582,     0,     0,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,     0,     0,
     898,   899,   900,   610,   901,   902,   903,   904,   905,   906,
     892,     0,     0,     0,     0,     0,     0,   893,   894,   895,
     230,   231,   232,   233,   234,   235,   236,   237,     0,   238,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,     0,   243,   244,   245,     0,   247,   248,   249,   250,
     251,     0,   253,   254,     0,   255,   256,   257,   258,   259,
     260,     0,     0,   261,   262,   263,   264,   265,     0,   266,
    1124,   268,   269,   270,     0,     0,     0,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,     0,   288,   289,   290,     0,     0,
       0,     0,     0,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,     0,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,   314,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,     0,  1125,     0,   334,   335,   336,
     337,     0,   338,     0,   339,     0,     0,     0,   342,   343,
     344,   345,     0,   346,   347,     0,   348,   349,   350,     0,
     351,   352,   353,   354,  1126,     0,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
       0,   370,   371,   372,   373,   374,   375,   376,     0,   377,
       0,   378,     0,     0,   381,     0,   383,   384,   385,   386,
     387,     0,     0,   388,   389,     0,   391,     0,     0,   393,
     394,   395,     0,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   428,     0,   429,
     430,   431,   432,   433,   434,     0,   435,   436,     0,     0,
     437,   438,   439,     0,     0,   440,   441,   442,     0,   444,
       0,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,   458,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,   513,     0,   514,   515,   516,   517,
     518,     0,   520,   521,   522,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,     0,   539,   540,     0,   541,     0,   543,   544,
     545,   546,   547,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
     561,   562,   563,     0,     0,   564,   565,   566,   567,   568,
       0,     0,   569,   570,   571,   572,   573,   574,   575,     0,
     576,     0,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,     0,     0,   898,   899,   900,   610,   901,   902,
     903,   904,   905,   906,   892,     0,     0,     0,     0,     0,
       0,   893,   894,   895,   230,   231,   232,   233,   234,   235,
     236,   237,     0,   238,   239,   240,     0,     0,     0,     0,
       0,     0,     0,   241,   242,     0,   243,   244,   245,     0,
     247,   248,   249,   250,   251,     0,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,     0,   261,   262,   263,
     264,   265,     0,   266,  1749,   268,   269,   270,     0,     0,
       0,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,   281,   282,   283,   284,   285,   286,     0,     0,   288,
     289,   290,     0,     0,     0,     0,     0,     0,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,     0,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   309,
     310,   311,     0,     0,   312,   313,   314,   315,   316,     0,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,     0,  1750,
       0,   334,   335,   336,   337,     0,   338,     0,   339,     0,
       0,     0,   342,   343,   344,   345,     0,   346,   347,     0,
     348,   349,   350,     0,   351,   352,   353,   354,   355,     0,
     357,   358,   359,   360,     0,   361,   362,   363,   364,   365,
     366,   367,     0,   368,     0,   370,   371,   372,   373,   374,
     375,   376,     0,   377,     0,   378,     0,     0,   381,     0,
     383,   384,   385,   386,   387,     0,     0,   388,   389,     0,
     391,     0,     0,   393,   394,   395,     0,     0,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   428,     0,   429,   430,   431,   432,   433,   434,     0,
     435,   436,     0,     0,   437,   438,   439,     0,     0,   440,
     441,   442,     0,   444,     0,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,     0,   456,   457,   458,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   509,   510,   511,   512,   513,     0,
     514,   515,   516,   517,   518,     0,   520,   521,   522,   523,
       0,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,     0,   539,   540,     0,
     541,     0,   543,   544,   545,   546,   547,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,   561,   562,   563,     0,     0,   564,
     565,   566,   567,   568,     0,     0,   569,   570,   571,   572,
     573,   574,   575,     0,   576,     0,   578,   579,   580,   581,
       0,     0,   582,     0,     0,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,     0,     0,     0,   898,   899,
     900,   610,   901,   902,   903,   904,   905,   906,   892,     0,
       0,     0,     0,     0,     0,   893,   894,   895,   230,   231,
     232,   233,   234,   235,   236,   237,     0,   238,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,     0,
     243,   244,   245,     0,   247,   248,   249,   250,   251,     0,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,     0,     0,     0,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,   281,   282,   283,   284,   285,
     286,     0,     0,   288,   289,   290,     0,     0,     0,     0,
       0,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   309,   310,   311,     0,     0,   312,   313,
     314,   315,   316,     0,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,     0,   333,     0,   334,   335,   336,   337,     0,
     338,     0,   339,     0,     0,     0,   342,   343,   344,   345,
       0,   346,   347,     0,   348,   349,   350,     0,   351,   352,
     353,   354,   355,     0,   357,   358,   359,   360,     0,   361,
     362,   363,   364,   365,   366,   367,     0,   368,     0,   370,
     371,   372,   373,   374,   375,   376,     0,   377,     0,   378,
       0,     0,   381,     0,   383,   384,   385,   386,   387,     0,
       0,   388,   389,     0,   391,     0,     0,   393,   394,   395,
       0,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   428,     0,   429,   430,   431,
     432,   433,   434,     0,   435,   436,     0,     0,   437,   438,
     439,     0,     0,   440,   441,   442,     0,   444,     0,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
       0,   456,   457,   458,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,     0,   509,   510,
     511,   512,   513,     0,   514,   515,   516,   517,   518,     0,
     520,   521,   522,   523,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
       0,   539,   540,     0,   541,     0,   543,   544,   545,   546,
     547,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,   561,   562,
     563,     0,     0,   564,   565,   566,   567,   568,     0,     0,
     569,   570,   571,   572,   573,   574,   575,     0,   576,     0,
     578,   579,   580,   581,     0,     0,   582,     0,     0,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
       0,     0,   898,   899,   900,   610,   901,   902,   903,   904,
     905,   906,   892,     0,     0,     0,     0,     0,     0,   893,
     894,   895,   230,   231,   232,   233,   234,   235,   236,   237,
       0,   238,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,     0,   243,   244,   245,     0,   247,   248,
     249,   250,   251,     0,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,     0,   261,   262,   263,   264,   265,
       0,   266,  3024,   268,   269,   270,     0,     0,     0,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0,     0,   288,   289,   290,
       0,     0,     0,     0,     0,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,   314,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,     0,  3025,     0,   334,
     335,   336,   337,     0,   338,     0,   339,     0,     0,     0,
     342,   343,   344,   345,     0,   346,   347,     0,   348,   349,
     350,     0,   351,   352,   353,   354,   355,     0,   357,   358,
     359,   360,     0,   361,   362,   363,   364,   365,   366,   367,
       0,   368,     0,   370,   371,   372,   373,   374,   375,   376,
       0,   377,     0,   378,     0,     0,   381,     0,   383,   384,
     385,   386,   387,     0,     0,   388,   389,     0,   391,     0,
       0,   393,   394,   395,     0,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   428,
       0,   429,   430,   431,   432,   433,   434,     0,   435,   436,
       0,     0,   437,   438,   439,     0,     0,   440,   441,   442,
       0,   444,     0,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,   458,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,   513,     0,   514,   515,
     516,   517,   518,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,     0,   539,   540,     0,   541,     0,
     543,   544,   545,   546,   547,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,   561,   562,   563,     0,     0,   564,   565,   566,
     567,   568,     0,     0,   569,   570,   571,   572,   573,   574,
     575,     0,   576,     0,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,     0,     0,   898,   899,   900,   610,
     901,   902,   903,   904,   905,   906,   892,     0,     0,     0,
       0,     0,     0,   893,   894,   895,   230,   231,   232,   233,
     234,   235,   236,   237,     0,   238,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,     0,   243,   244,
     245,     0,   247,   248,   249,   250,   251,     0,   253,   254,
       0,   255,   256,   257,   258,   259,   260,     0,     0,   261,
     262,   263,   264,   265,     0,   266,   267,   268,   269,   270,
       0,     0,     0,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,   281,   282,   283,   284,   285,   286,     0,
       0,   288,   289,   290,     0,     0,     0,     0,     0,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
       0,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,   313,   314,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
       0,   333,     0,   334,   335,   336,   337,     0,   338,     0,
     339,     0,     0,     0,   342,   343,   344,   345,     0,   346,
     347,     0,   348,   349,   350,     0,   351,   352,   353,   354,
     355,     0,   357,   358,   359,   360,     0,   361,   362,   363,
     364,   365,   366,   367,     0,   368,     0,   370,   371,   372,
     373,   374,   375,   376,     0,   377,     0,   378,     0,     0,
     381,     0,   383,   384,   385,   386,   387,     0,     0,   388,
     389,     0,   391,     0,     0,   393,   394,   395,     0,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   428,     0,   429,   430,   431,   432,   433,
     434,     0,   435,   436,     0,     0,  4909,   438,   439,     0,
       0,   440,   441,   442,     0,   444,     0,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   456,
     457,   458,   459,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,     0,   509,   510,   511,   512,
     513,     0,   514,   515,   516,   517,   518,     0,   520,   521,
     522,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,     0,   539,
     540,     0,   541,     0,   543,   544,   545,   546,   547,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,     0,
       0,   564,   565,   566,   567,   568,     0,     0,   569,   570,
     571,   572,   573,   574,   575,     0,   576,     0,   578,   579,
     580,   581,     0,     0,   582,     0,     0,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,  1649,     0,     0,
     898,   899,   900,     0,   901,   902,   903,   904,   905,   906,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     236,   237,  1650,   238,   239,   240,  1651,  1652,  1653,  1654,
    1655,  1656,  1657,   241,   242,  1658,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,  1659,   255,
     256,   257,   258,   259,   260,  1660,  1661,   261,   262,   263,
     264,   265,  1662,   266,   267,   268,   269,   270,  1663,   271,
    1664,   272,   273,   274,   275,   276,   277,   278,   279,   280,
    1665,   281,   282,   283,   284,   285,   286,  1666,   287,   288,
     289,   290,  1667,  1668,  1669,   291,  1670,  1671,  1672,   292,
     293,   294,   295,   296,   297,   298,   299,   300,  1673,   301,
    1674,   302,   303,   304,   305,   306,   307,  1675,   308,   309,
     310,   311,  1676,  1677,   312,   313,   314,   315,   316,  1678,
     317,   318,   319,  1679,   320,   321,   322,  1680,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,  1681,   333,
    1682,   334,   335,   336,   337,  1683,   338,  1684,   339,   340,
    1685,   341,   342,   343,   344,   345,  1686,   346,   347,  1687,
     348,   349,   350,  1688,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,  1689,   361,   362,   363,   364,   365,
     366,   367,  1690,   368,   369,   370,   371,   372,   373,   374,
     375,   376,  1691,   377,  1692,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,  1693,  1694,   388,   389,   390,
     391,   392,  1695,   393,   394,   395,  1696,  1697,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,  1698,   425,   426,
     427,   428,  1699,   429,   430,   431,   432,   433,   434,  1700,
     435,   436,  1701,  1702,   437,   438,   439,  1703,  1704,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,     0,  1705,   456,   457,   458,
     459,   460,   461,   462,   463,  1706,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,  1707,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,  1708,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,  1709,   509,   510,   511,   512,   513,  1710,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
    1711,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,  1712,   539,   540,  1713,
     541,   542,   543,   544,   545,   546,   547,  1714,   548,   549,
     550,  1715,  1716,   551,   552,   553,   554,   555,  1717,   556,
     557,   558,   559,   560,   561,   562,   563,  1718,  1719,   564,
     565,   566,   567,   568,  1720,  1721,   569,   570,   571,   572,
     573,   574,   575,  1722,   576,   577,   578,   579,   580,   581,
    1723,  1724,   582,  1725,  1726,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   610,     0,     0,     0,     0,
       0,     0,     0,     0,  1727,     0,     0,     0,     0,     0,
       0,     0,   230,   231,   232,   233,   234,   235,   236,   237,
       0,   238,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,     0,   243,   244,   245,     0,   247,   248,
     249,   250,   251,     0,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,     0,   261,   262,   263,   264,   265,
       0,   266,   267,   268,   269,   270,     0,     0,     0,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,   281,
     282,   283,   284,   285,   286,     0,     0,   288,   289,   290,
       0,     0,     0,     0,     0,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,   309,   310,   311,
       0,     0,   312,   313,   314,   315,   316,     0,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,     0,   333,     0,   334,
     335,   336,   337,     0,   338,     0,   339,     0,     0,     0,
     342,   343,   344,   345,     0,   346,   347,     0,   348,   349,
     350,     0,   351,   352,   353,   354,   355,     0,   357,   358,
     359,   360,     0,   361,   362,   363,   364,   365,   366,   367,
       0,   368,     0,   370,   371,   372,   373,   374,   375,   376,
       0,   377,     0,   378,     0,     0,   381,     0,   383,   384,
     385,   386,   387,     0,     0,   388,   389,     0,   391,     0,
       0,   393,   394,   395,     0,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   428,
       0,   429,   430,   431,   432,   433,   434,     0,   435,   436,
       0,     0,   437,   438,   439,     0,     0,   440,   441,   442,
       0,   444,     0,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,     0,     0,   456,   457,   458,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,     0,   509,   510,   511,   512,   513,     0,   514,   515,
     516,   517,   518,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,     0,   539,   540,     0,   541,     0,
     543,   544,   545,   546,   547,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,   561,   562,   563,     0,     0,   564,   565,   566,
     567,   568,     0,     0,   569,   570,   571,   572,   573,   574,
     575,     0,   576,     0,   578,   579,   580,   581,     0,     0,
     582,     0,     0,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   610,     0,     0,     0,     0,     0,     0,
       0,     0,   828,     0,     0,     0,     0,     0,     0,     0,
     230,   231,   232,   233,   234,   235,   236,   237,     0,   238,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,     0,   243,   244,   245,     0,   247,   248,   249,   250,
     251,     0,   253,   254,     0,   255,   256,   257,   258,   259,
     260,     0,     0,   261,   262,   263,   264,   265,     0,   266,
     267,   268,   269,   270,     0,     0,     0,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,     0,   288,   289,   290,     0,     0,
       0,     0,     0,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,     0,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,   314,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,     0,   333,     0,   334,   335,   336,
     337,     0,   338,     0,   339,     0,     0,     0,   342,   343,
     344,   345,     0,   346,   347,     0,   348,   349,   350,     0,
     351,   352,   353,   354,   355,     0,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
       0,   370,   371,   372,   373,   374,   375,   376,     0,   377,
       0,   378,     0,     0,   381,     0,   383,   384,   385,   386,
     387,     0,     0,   388,   389,     0,   391,     0,     0,   393,
     394,   395,     0,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   428,     0,   429,
     430,   431,   432,   433,   434,     0,   435,   436,     0,     0,
     437,   438,   439,     0,     0,   440,   441,   442,     0,   444,
       0,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,   458,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,   513,     0,   514,   515,   516,   517,
     518,     0,   520,   521,   522,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,     0,   539,   540,     0,   541,     0,   543,   544,
     545,   546,   547,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
     561,   562,   563,     0,     0,   564,   565,   566,   567,   568,
       0,     0,   569,   570,   571,   572,   573,   574,   575,     0,
     576,     0,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,  1074,     0,     0,     0,     0,     0,     0,     0,     0,
    5302,     0,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   236,   237,     0,   238,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,     0,
     243,   244,   245,   246,   247,   248,   249,     0,  1075,   252,
    1076,  1077,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,  1078,  1079,   265,     0,   266,   267,   268,
     269,     0,     0,   271,     0,   272,   273,   274,   275,   276,
     277,   278,   279,   280,     0,   281,   282,   283,   284,   285,
     286,     0,   287,   288,   289,   290,     0,     0,     0,   291,
       0,     0,     0,   292,   293,   294,   295,   296,   297,  1080,
    1081,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   309,   310,   311,     0,     0,   312,   313,
    1082,   315,   316,     0,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,     0,   328,   329,   330,
     331,     0,     0,   333,     0,   334,   335,  1083,   337,     0,
     338,     0,   339,   340,     0,   341,   342,   343,   344,   345,
       0,   346,     0,     0,     0,   349,   350,     0,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,  2187,   361,
     362,   363,   364,   365,   366,   367,     0,   368,   369,  2188,
     371,   372,   373,   374,  1085,  1086,     0,  1087,     0,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,     0,
       0,   388,     0,   390,   391,   392,     0,   393,   394,   395,
       0,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,  1088,   413,
    1089,   415,   416,   417,   418,   419,   420,   421,     0,     0,
     424,     0,   425,   426,   427,   428,     0,     0,   430,  1090,
     432,   433,   434,     0,   435,   436,     0,     0,   437,   438,
     439,     0,  2189,   440,   441,  2190,   443,   444,   445,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
       0,   456,   457,     0,   459,     0,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
    1091,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,   494,   495,   496,   497,   498,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,     0,   509,   510,
     511,   512,   513,     0,   514,   515,  2191,   517,   518,   519,
     520,   521,  1093,   523,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,     0,   538,
       0,   539,   540,     0,   541,   542,   543,   544,   545,   546,
     547,     0,   548,  1094,  1095,     0,     0,   551,   552,     0,
     554,     0,     0,   556,   557,   558,   559,   560,   561,   562,
     563,     0,     0,   564,   565,   566,   567,   568,     0,     0,
     569,   570,   571,   572,   573,     0,  1096,  2192,   576,   577,
     578,   579,   580,   581,     0,     0,   582,     0,     0,   583,
     584,   585,   586,   587,   588,     0,     0,     0,     0,     0,
       0,     0,  3372,     0,     0,     0,   600,   601,   602,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2193,   230,
     231,   232,   233,   234,   235,   236,   237,     0,   238,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
       0,   243,   244,   245,   246,   247,   248,   249,     0,  1075,
     252,  1076,  1077,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,  1078,  1079,   265,     0,   266,   267,
     268,   269,     0,     0,   271,     0,   272,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,   287,   288,   289,   290,     0,     0,     0,
     291,     0,     0,     0,   292,   293,   294,   295,   296,   297,
    1080,  1081,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,  1082,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,     0,   328,   329,
     330,   331,     0,     0,   333,     0,   334,   335,  1083,   337,
       0,   338,     0,   339,   340,     0,   341,   342,   343,   344,
     345,     0,   346,     0,     0,     0,   349,   350,     0,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,  2187,
     361,   362,   363,   364,   365,   366,   367,     0,   368,   369,
    2188,   371,   372,   373,   374,  1085,  1086,     0,  1087,     0,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
       0,     0,   388,     0,   390,   391,   392,     0,   393,   394,
     395,     0,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,  1088,
     413,  1089,   415,   416,   417,   418,   419,   420,   421,     0,
       0,   424,     0,   425,   426,   427,   428,     0,     0,   430,
    1090,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,     0,  2189,   440,   441,  2190,   443,   444,   445,
       0,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,     0,   459,     0,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,  1091,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,   494,   495,   496,   497,   498,     0,   500,
     501,   502,   503,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,   513,     0,   514,   515,  2191,   517,   518,
     519,   520,   521,  1093,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,     0,
     538,     0,   539,   540,     0,   541,   542,   543,   544,   545,
     546,   547,     0,   548,  1094,  1095,     0,     0,   551,   552,
       0,   554,     0,     0,   556,   557,   558,   559,   560,   561,
     562,   563,     0,     0,   564,   565,   566,   567,   568,     0,
       0,   569,   570,   571,   572,   573,     0,  1096,  2192,   576,
     577,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   588,     0,     0,     0,     0,
       0,     0,     0,   878,     0,  1518,   670,   600,   601,   602,
       0,   731,     0,     0,     0,     0,     0,     0,     0,  2193,
     230,   231,   232,   233,   234,   235,   236,   237,     0,   238,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,     0,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,   256,   257,   258,   259,
     260,     0,     0,   261,   262,   263,   264,   265,     0,   266,
     267,   268,   269,   270,     0,   271,     0,   272,   273,   274,
     275,   276,   277,   278,   279,   280,     0,   281,   282,   283,
     284,   285,   286,     0,   287,   288,   289,   290,     0,     0,
       0,   291,     0,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,  2116,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   309,   310,   311,     0,     0,
     312,   313,   314,   315,   316,     0,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,  1933,   333,     0,   334,   335,   336,
     337,     0,   338,     0,   339,   340,     0,   341,   342,   343,
     344,   345,     0,   346,   347,     0,   348,   349,   350,     0,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
       0,   361,   362,   363,   364,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,     0,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,     0,     0,   388,   389,   390,   391,   392,     0,   393,
     394,   395,     0,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   427,   428,     0,   429,
     430,   431,   432,   433,   434,     0,   435,   436,  1934,     0,
     437,   438,   439,     0,     0,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   456,   457,   458,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,     0,
     509,   510,   511,   512,   513,     0,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,     0,   539,   540,     0,   541,   542,   543,   544,
     545,   546,   547,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,  1935,   556,   557,   558,   559,   560,
     561,   562,   563,     0,     0,   564,   565,   566,   567,   568,
       0,     0,   569,   570,   571,   572,   573,   574,   575,     0,
     576,   577,   578,   579,   580,   581,     0,     0,   582,     0,
       0,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   878,     0,  1518,   670,     0,     0,  1519,  1520,
     731,     0,     0,     0,     0,     0,     0,     0,     0,   230,
     231,   232,   233,   234,   235,   236,   237,     0,   238,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
       0,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,     0,   271,     0,   272,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,   287,   288,   289,   290,     0,     0,     0,
     291,     0,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,  2121,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,   314,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,  1933,   333,     0,   334,   335,   336,   337,
       0,   338,     0,   339,   340,     0,   341,   342,   343,   344,
     345,     0,   346,   347,     0,   348,   349,   350,     0,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,     0,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
       0,     0,   388,   389,   390,   391,   392,     0,   393,   394,
     395,     0,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,     0,   429,   430,
     431,   432,   433,   434,     0,   435,   436,  1934,     0,   437,
     438,   439,     0,     0,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   458,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,   513,     0,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,     0,   539,   540,     0,   541,   542,   543,   544,   545,
     546,   547,     0,   548,   549,   550,     0,     0,   551,   552,
     553,   554,   555,  1935,   556,   557,   558,   559,   560,   561,
     562,   563,     0,     0,   564,   565,   566,   567,   568,     0,
       0,   569,   570,   571,   572,   573,   574,   575,     0,   576,
     577,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
       0,   878,     0,  1518,   670,     0,     0,  1519,  1520,   731,
       0,     0,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   236,   237,     0,   238,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,     0,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,     0,   271,     0,   272,   273,   274,   275,   276,
     277,   278,   279,   280,     0,   281,   282,   283,   284,   285,
     286,     0,   287,   288,   289,   290,     0,     0,     0,   291,
       0,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   309,   310,   311,     0,     0,   312,   313,
     314,   315,   316,     0,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,  1933,   333,     0,   334,   335,   336,   337,     0,
     338,     0,   339,   340,     0,   341,   342,   343,   344,   345,
       0,   346,   347,     0,   348,   349,   350,     0,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,     0,   361,
     362,   363,   364,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,     0,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,     0,
       0,   388,   389,   390,   391,   392,     0,   393,   394,   395,
       0,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   427,   428,     0,   429,   430,   431,
     432,   433,   434,     0,   435,   436,  1934,     0,   437,   438,
     439,     0,     0,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,     0,
       0,   456,   457,   458,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,     0,   509,   510,
     511,   512,   513,     0,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
       0,   539,   540,     0,   541,   542,   543,   544,   545,   546,
     547,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,  1935,   556,   557,   558,   559,   560,   561,   562,
     563,     0,     0,   564,   565,   566,   567,   568,     0,     0,
     569,   570,   571,   572,   573,   574,   575,     0,   576,   577,
     578,   579,   580,   581,     0,     0,   582,     0,     0,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     878,     0,     0,   670,     0,     0,  1519,  1520,   731,     0,
       0,     0,     0,     0,     0,     0,     0,   230,   231,   232,
     233,   234,   235,   236,   237,     0,   238,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,     0,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,     0,   271,     0,   272,   273,   274,   275,   276,   277,
     278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
       0,   287,   288,   289,   290,     0,     0,     0,   291,     0,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,  2978,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   309,   310,   311,     0,     0,   312,   313,   314,
     315,   316,     0,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,  1933,   333,     0,   334,   335,   336,   337,     0,   338,
       0,   339,   340,     0,   341,   342,   343,   344,   345,     0,
     346,   347,     0,   348,   349,   350,     0,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,     0,   361,   362,
     363,   364,   365,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,     0,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,     0,     0,
     388,   389,   390,   391,   392,     0,   393,   394,   395,     0,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,     0,   429,   430,   431,   432,
     433,   434,     0,   435,   436,  1934,     0,   437,   438,   439,
       0,     0,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   458,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,     0,   509,   510,   511,
     512,   513,     0,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,     0,
     539,   540,     0,   541,   542,   543,   544,   545,   546,   547,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,  1935,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,   565,   566,   567,   568,     0,     0,   569,
     570,   571,   572,   573,   574,   575,     0,   576,   577,   578,
     579,   580,   581,     0,     0,   582,     0,     0,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,     0,   610,
       0,     0,     0,     0,     0,   743,   744,   731,     0,     0,
       0,     0,     0,     0,     0,     0,   230,   732,   232,   233,
     234,   235,   236,   237,   733,   238,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,     0,   243,   244,
     245,     0,   734,   248,   249,   250,   251,     0,   253,   254,
       0,   255,   256,   257,   258,   259,   260,     0,     0,   261,
     262,   263,   264,   265,     0,   266,   267,   268,   269,   270,
       0,     0,     0,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,   281,   282,   283,   284,   285,   286,     0,
       0,   288,   289,   290,     0,     0,     0,     0,     0,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
       0,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   309,   310,   311,     0,     0,   312,   313,   314,   315,
     316,     0,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
       0,   333,     0,   334,   735,   336,   337,     0,   338,     0,
     736,     0,   737,     0,   342,   343,   344,   345,     0,   346,
     347,     0,   348,   349,   350,     0,   351,   352,   353,   354,
     355,     0,   357,   358,   359,   360,   738,   361,   362,   363,
     364,   365,   366,   367,     0,   368,     0,   370,   371,   372,
     373,   374,   375,   376,     0,   377,     0,   378,     0,     0,
     381,     0,   383,   384,   385,   386,   739,     0,     0,   388,
     389,     0,   391,     0,     0,   393,   394,   395,     0,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   414,   415,
     740,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   428,     0,   429,   430,   431,   432,   433,
     434,     0,   435,   436,     0,     0,   437,   438,   439,     0,
       0,   440,   441,   442,     0,   444,     0,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   456,
     457,   458,   459,   460,   461,   462,   463,     0,   741,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   742,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,     0,   509,   510,   511,   512,
     513,     0,   514,   515,   516,   517,   518,     0,   520,   521,
     522,   523,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,     0,   539,
     540,     0,   541,     0,   543,   544,   545,   546,   547,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,     0,
       0,   564,   565,   566,   567,   568,     0,     0,   569,   570,
     571,   572,   573,   574,   575,     0,   576,     0,   578,   579,
     580,   581,     0,     0,   582,     0,     0,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,  1649,     0,
    5520,   670,     0,     0,   743,   744,   731,     0,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,  1650,   238,   239,   240,  1651,  1652,  1653,
    1654,  1655,  1656,  1657,   241,   242,  1658,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,  1659,
     255,   256,   257,   258,   259,   260,  1660,  1661,   261,   262,
     263,   264,   265,  1662,   266,   267,   268,   269,   270,  1663,
     271,  1664,   272,   273,   274,   275,   276,   277,   278,   279,
     280,  1665,   281,   282,   283,   284,   285,   286,  1666,   287,
     288,   289,   290,  1667,  1668,  1669,   291,  1670,  1671,  1672,
     292,   293,   294,   295,   296,   297,   298,   299,   300,  1673,
     301,  1674,   302,   303,   304,   305,   306,   307,  1675,   308,
     309,   310,   311,  1676,  1677,   312,   313,   314,   315,   316,
    1678,   317,   318,   319,  1679,   320,   321,   322,  1680,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,  1681,
     333,  1682,   334,   335,   336,   337,  1683,   338,  1684,   339,
     340,  1685,   341,   342,   343,   344,   345,  1686,   346,   347,
    1687,   348,   349,   350,  1688,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,  1689,   361,   362,   363,   364,
     365,   366,   367,  1690,   368,   369,   370,   371,   372,   373,
     374,   375,   376,  1691,   377,  1692,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,  1693,  1694,   388,   389,
     390,   391,   392,  1695,   393,   394,   395,  1696,  1697,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,  1698,   425,
     426,   427,   428,  1699,   429,   430,   431,   432,   433,   434,
    1700,   435,   436,  1701,  1702,   437,   438,   439,  1703,  1704,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,  1705,   456,   457,
     458,   459,   460,   461,   462,   463,  1706,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,  1707,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,  1708,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,  1709,   509,   510,   511,   512,   513,
    1710,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,  1711,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,  1712,   539,   540,
    1713,   541,   542,   543,   544,   545,   546,   547,  1714,   548,
     549,   550,  1715,  1716,   551,   552,   553,   554,   555,  1717,
     556,   557,   558,   559,   560,   561,   562,   563,  1718,  1719,
     564,   565,   566,   567,   568,  1720,  1721,   569,   570,   571,
     572,   573,   574,   575,  1722,   576,   577,   578,   579,   580,
     581,  1723,  1724,   582,  1725,  1726,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,  1649,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   230,   231,   232,   233,   234,   235,   236,
     237,  1650,   238,   239,   240,  1651,  1652,  1653,  1654,  1655,
    1656,  1657,   241,   242,  1658,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,  1659,   255,   256,
     257,   258,   259,   260,  1660,  1661,   261,   262,   263,   264,
     265,  1662,   266,   267,   268,   269,   270,  1663,   271,  1664,
     272,   273,   274,   275,   276,   277,   278,   279,   280,  1665,
     281,   282,   283,   284,   285,   286,  1666,   287,   288,   289,
     290,  1667,  1668,  1669,   291,  1670,  1671,  1672,   292,   293,
     294,   295,   296,   297,   298,   299,   300,  1673,   301,  1674,
     302,   303,   304,   305,   306,   307,  1675,   308,   309,   310,
     311,  1676,  1677,   312,   313,   314,   315,   316,  1678,   317,
     318,   319,  1679,   320,   321,   322,  1680,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,  1681,   333,  1682,
     334,   335,   336,   337,  1683,   338,  1684,   339,   340,  1685,
     341,   342,   343,   344,   345,  1686,   346,   347,  1687,   348,
     349,   350,  1688,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,  1689,   361,   362,   363,   364,   365,   366,
     367,  1690,   368,   369,   370,   371,   372,   373,   374,   375,
     376,  1691,   377,  1692,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,  1693,  1694,   388,   389,   390,   391,
     392,  1695,   393,   394,   395,  1696,  1697,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,  1698,   425,   426,   427,
     428,  1699,   429,   430,   431,   432,   433,   434,  1700,   435,
     436,  1701,  1702,   437,   438,   439,  1703,  1704,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,     0,  1705,   456,   457,   458,   459,
     460,   461,   462,   463,  1706,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
    1707,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,  1708,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,  1709,   509,   510,   511,   512,   513,  1710,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,  1711,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,  1712,   539,   540,  1713,   541,
     542,   543,   544,   545,   546,   547,  1714,   548,   549,   550,
    1715,  1716,   551,   552,   553,   554,   555,  1717,   556,   557,
     558,   559,   560,   561,   562,   563,  1718,  1719,   564,   565,
     566,   567,   568,  1720,  1721,   569,   570,   571,   572,   573,
     574,   575,  1722,   576,   577,   578,   579,   580,   581,  1723,
    1724,   582,  1725,  1726,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,  1649,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   230,   231,   232,   233,  3095,   235,   236,   237,  1650,
     238,   239,   240,  1651,  1652,  1653,  1654,  1655,  1656,  1657,
     241,   242,  1658,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,  1659,   255,   256,   257,   258,
     259,   260,  1660,  1661,   261,   262,   263,   264,   265,  1662,
     266,   267,   268,   269,   270,  1663,   271,  1664,   272,   273,
     274,   275,   276,   277,   278,   279,   280,  1665,   281,   282,
     283,   284,   285,   286,  1666,   287,   288,   289,   290,  1667,
    1668,  1669,   291,  1670,  1671,  1672,   292,   293,   294,   295,
     296,   297,   298,   299,   300,  1673,   301,  1674,   302,   303,
     304,   305,   306,   307,  1675,   308,   309,   310,   311,  1676,
    1677,   312,   313,   314,  3096,   316,  1678,   317,   318,   319,
    1679,   320,   321,   322,  1680,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,  1681,   333,  1682,   334,   335,
     336,   337,  1683,   338,  1684,   339,   340,  1685,   341,   342,
     343,   344,   345,  1686,   346,   347,  1687,   348,   349,   350,
    1688,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,  1689,   361,   362,   363,   364,   365,   366,   367,  1690,
     368,   369,   370,   371,   372,   373,   374,   375,   376,  1691,
     377,  1692,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,  1693,  1694,   388,   389,   390,   391,   392,  1695,
     393,   394,   395,  1696,  1697,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,  1698,   425,   426,   427,   428,  1699,
     429,   430,   431,   432,   433,   434,  1700,   435,   436,  1701,
    1702,   437,   438,   439,  1703,  1704,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,  1705,   456,   457,   458,   459,   460,   461,
     462,   463,  1706,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,  1707,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,  1708,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
    1709,   509,   510,   511,   512,   513,  1710,  3097,   515,   516,
     517,   518,   519,   520,   521,   522,   523,  1711,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,  1712,   539,   540,  1713,   541,   542,   543,
     544,   545,   546,   547,  1714,   548,   549,   550,  1715,  1716,
     551,   552,   553,   554,   555,  1717,   556,   557,   558,   559,
     560,   561,   562,   563,  1718,  1719,   564,   565,   566,   567,
     568,  1720,  1721,   569,   570,   571,   572,   573,   574,   575,
    1722,   576,   577,   578,   579,   580,   581,  1723,  1724,   582,
    1725,  1726,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   229,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   230,
     231,   232,   233,   234,   235,   236,   237,     0,   238,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
       0,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,  1244,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,  1247,     0,  1248,     0,   272,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,   287,   288,   289,   290,  1249,  1250,  1251,
    1252,  1253,  1254,  1255,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,   314,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,  1260,     0,   333,     0,   334,   335,   336,   337,
       0,   338,     0,   339,   340,     0,   341,   342,   343,   344,
     345,     0,   346,  1263,     0,   348,   349,   350,     0,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,     0,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
       0,     0,   388,  1268,   390,   391,   392,     0,   393,   394,
     395,  1269,  1270,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
    1273,   424,     0,   425,   426,   427,   428,     0,  1276,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,     0,     0,   440,   441,   442,   443,   444,   445,
    1279,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,  1280,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,   513,  1283,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,  1285,
     538,     0,   539,   540,     0,   541,   542,   543,   544,   545,
     546,   547,     0,   548,   549,   550,     0,     0,   551,   552,
    1288,   554,  1289,     0,   556,   557,   558,   559,   560,   561,
     562,   563,     0,     0,   564,   565,   566,   567,   568,  1292,
       0,   569,   570,   571,   572,   573,   574,   575,     0,   576,
     577,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   588,   589,  1294,  1295,  1296,
    1297,   594,  1298,  1299,  1300,  1301,   599,   600,   601,   602,
     878,     0,     0,   670,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   230,   231,   232,
     233,   234,   235,   236,   237,     0,   238,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,     0,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,     0,   271,     0,   272,   273,   274,   275,   276,   277,
     278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
       0,   287,   288,   289,   290,     0,     0,     0,   291,     0,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   309,   310,   311,     0,     0,   312,   313,   314,
     315,   316,     0,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,  1933,   333,     0,   334,   335,   336,   337,     0,   338,
       0,   339,   340,     0,   341,   342,   343,   344,   345,     0,
     346,   347,     0,   348,   349,   350,     0,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,     0,   361,   362,
     363,   364,   365,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,     0,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,     0,     0,
     388,   389,   390,   391,   392,     0,   393,   394,   395,     0,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,     0,   429,   430,   431,   432,
     433,   434,     0,   435,   436,  1934,     0,   437,   438,   439,
       0,     0,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   458,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,     0,   509,   510,   511,
     512,   513,     0,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,     0,
     539,   540,     0,   541,   542,   543,   544,   545,   546,   547,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,  1935,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,   565,   566,   567,   568,     0,     0,   569,
     570,   571,   572,   573,   574,   575,     0,   576,   577,   578,
     579,   580,   581,     0,     0,   582,     0,     0,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   878,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,   916,   238,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,     0,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,     0,
     271,     0,   272,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,   287,
     288,   289,   290,     0,     0,     0,   291,     0,     0,   879,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,   314,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,     0,
     333,     0,   334,   335,   336,   337,     0,   338,     0,   339,
     340,     0,   341,   342,   343,   344,   345,     0,   346,   347,
       0,   348,   349,   350,     0,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,     0,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,     0,     0,   388,   389,
     390,   391,   392,     0,   393,   394,   395,     0,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,     0,   429,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,     0,     0,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     458,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
     880,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,     0,   539,   540,
       0,   541,   542,   543,   544,   545,   546,   547,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,   561,   562,   563,     0,     0,
     564,   565,   566,   567,   568,     0,     0,   569,   570,   571,
     572,   573,   574,   575,     0,   576,   577,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   878,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   230,   231,   232,   233,   234,   235,   236,
     237,   937,   238,   239,   240,     0,     0,     0,     0,     0,
       0,     0,   241,   242,     0,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,     0,   271,     0,
     272,   273,   274,   275,   276,   277,   278,   279,   280,     0,
     281,   282,   283,   284,   285,   286,     0,   287,   288,   289,
     290,     0,     0,     0,   291,     0,     0,   879,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   309,   310,
     311,     0,     0,   312,   313,   314,   315,   316,     0,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,     0,   333,     0,
     334,   335,   336,   337,     0,   338,     0,   339,   340,     0,
     341,   342,   343,   344,   345,     0,   346,   347,     0,   348,
     349,   350,     0,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,     0,   361,   362,   363,   364,   365,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,     0,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,     0,     0,   388,   389,   390,   391,
     392,     0,   393,   394,   395,     0,     0,   396,   397,   398,
     399,   938,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,     0,   429,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,     0,     0,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   458,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,     0,   509,   510,   511,   512,   513,   880,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,     0,   539,   540,     0,   541,
     542,   543,   544,   545,   546,   547,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,   561,   562,   563,     0,     0,   564,   565,
     566,   567,   568,     0,     0,   569,   570,   571,   572,   573,
     574,   575,     0,   576,   577,   578,   579,   580,   581,     0,
       0,   582,     0,     0,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   878,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   230,   231,   232,   233,   234,   235,   236,   237,     0,
     238,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,     0,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,     0,   271,     0,   272,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,     0,   287,   288,   289,   290,     0,
       0,     0,   291,     0,     0,   879,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,   314,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,     0,   333,     0,   334,   335,
     336,   337,     0,   338,     0,   339,   340,     0,   341,   342,
     343,   344,   345,     0,   346,   347,     0,   348,   349,   350,
       0,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,     0,   361,   362,   363,   364,   365,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,     0,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,     0,     0,   388,   389,   390,   391,   392,     0,
     393,   394,   395,     0,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,     0,
     429,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,     0,     0,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   458,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
       0,   509,   510,   511,   512,   513,   880,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,     0,   539,   540,     0,   541,   542,   543,
     544,   545,   546,   547,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,   561,   562,   563,     0,     0,   564,   565,   566,   567,
     568,  2455,     0,   569,   570,   571,   572,   573,   574,   575,
       0,   576,   577,   578,   579,   580,   581,     0,     0,   582,
       0,     0,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   878,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   230,
     231,   232,   233,   234,   235,   236,   237,     0,   238,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
       0,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,     0,   271,     0,   272,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,   287,   288,   289,   290,     0,     0,     0,
     291,     0,     0,   879,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,   314,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,     0,   333,     0,   334,   335,   336,   337,
       0,   338,     0,   339,   340,     0,   341,   342,   343,   344,
     345,     0,   346,   347,  3464,   348,   349,   350,     0,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,     0,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
       0,     0,   388,   389,   390,   391,   392,     0,   393,   394,
     395,     0,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,     0,   429,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,     0,     0,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   458,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,   513,   880,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,     0,   539,   540,     0,   541,   542,   543,   544,   545,
     546,   547,     0,   548,   549,   550,     0,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,   561,
     562,   563,     0,     0,   564,   565,   566,   567,   568,     0,
       0,   569,   570,   571,   572,   573,   574,   575,     0,   576,
     577,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     878,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   230,   231,   232,
     233,   234,   235,   236,   237,     0,   238,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,     0,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,     0,   271,     0,   272,   273,   274,   275,   276,   277,
     278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
       0,   287,   288,   289,   290,     0,     0,     0,   291,     0,
       0,   879,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   309,   310,   311,     0,     0,   312,   313,   314,
     315,   316,     0,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,     0,   333,     0,   334,   335,   336,   337,     0,   338,
       0,   339,   340,     0,   341,   342,   343,   344,   345,     0,
     346,   347,     0,   348,   349,   350,     0,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,     0,   361,   362,
     363,   364,   365,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,     0,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,     0,     0,
     388,   389,   390,   391,   392,     0,   393,   394,   395,     0,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,     0,   429,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
       0,     0,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   458,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,     0,   509,   510,   511,
     512,   513,   880,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,     0,
     539,   540,     0,   541,   542,   543,   544,   545,   546,   547,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,   565,   566,   567,   568,     0,     0,   569,
     570,   571,   572,   573,   574,   575,     0,   576,   577,   578,
     579,   580,   581,     0,     0,   582,     0,     0,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   878,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,     0,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,     0,
     271,     0,   272,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,   287,
     288,   289,   290,     0,     0,     0,   291,     0,     0,   879,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,   314,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,     0,
     333,     0,   334,   335,   336,   337,     0,   338,     0,   339,
     340,     0,   341,   342,   343,   344,   345,     0,   346,   347,
       0,   348,   349,   350,     0,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,     0,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,     0,     0,   388,   389,
     390,   391,   392,     0,   393,   394,   395,     0,     0,   396,
     397,   398,   399,  1043,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,     0,   429,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,     0,     0,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     458,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
     880,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,     0,   539,   540,
       0,   541,   542,   543,   544,   545,   546,   547,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,   561,   562,   563,     0,     0,
     564,   565,   566,   567,   568,     0,     0,   569,   570,   571,
     572,   573,   574,   575,     0,   576,   577,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   878,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   230,   231,   232,   233,   234,   235,   236,
     237,     0,   238,   239,   240,     0,     0,     0,     0,     0,
       0,     0,   241,   242,     0,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,     0,   271,     0,
     272,   273,   274,   275,   276,   277,   278,   279,   280,     0,
     281,   282,   283,   284,   285,   286,     0,   287,   288,   289,
     290,     0,     0,     0,   291,     0,     0,   879,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   309,   310,
     311,     0,     0,   312,   313,   314,   315,   316,     0,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,     0,   333,     0,
     334,   335,   336,   337,     0,   338,     0,   339,   340,     0,
     341,   342,   343,   344,   345,     0,   346,   347,     0,   348,
     349,   350,     0,   351,   352,   353,   354,  1119,   356,   357,
     358,   359,   360,     0,   361,   362,   363,   364,   365,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,     0,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,     0,     0,   388,   389,   390,   391,
     392,     0,   393,   394,   395,     0,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,     0,   429,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,     0,     0,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   458,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,     0,   509,   510,   511,   512,   513,   880,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,     0,   539,   540,     0,   541,
     542,   543,   544,   545,   546,   547,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,   561,   562,   563,     0,     0,   564,   565,
     566,   567,   568,     0,     0,   569,   570,   571,   572,   573,
     574,   575,     0,   576,   577,   578,   579,   580,   581,     0,
       0,   582,     0,     0,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   878,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   230,   231,   232,   233,   234,   235,   236,   237,     0,
     238,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,     0,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,     0,   271,     0,   272,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,     0,   287,   288,   289,   290,     0,
       0,     0,   291,     0,     0,   879,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,   314,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,     0,   333,     0,   334,   335,
     336,   337,     0,   338,     0,   339,   340,     0,   341,   342,
     343,   344,   345,     0,   346,   347,     0,   348,   349,   350,
       0,   351,   352,   353,   354,  1132,   356,   357,   358,   359,
     360,     0,   361,   362,   363,   364,   365,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,     0,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,     0,     0,   388,   389,   390,   391,   392,     0,
     393,   394,   395,     0,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,     0,
     429,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,     0,     0,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   458,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
       0,   509,   510,   511,   512,   513,   880,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,     0,   539,   540,     0,   541,   542,   543,
     544,   545,   546,   547,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,   561,   562,   563,     0,     0,   564,   565,   566,   567,
     568,     0,     0,   569,   570,   571,   572,   573,   574,   575,
       0,   576,   577,   578,   579,   580,   581,     0,     0,   582,
       0,     0,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   878,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   230,
     231,   232,   233,   234,   235,   236,   237,     0,   238,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
       0,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,     0,   271,     0,   272,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,   287,   288,   289,   290,     0,     0,     0,
     291,     0,     0,   879,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,   314,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,     0,   333,     0,   334,   335,   336,   337,
       0,   338,     0,   339,   340,     0,   341,   342,   343,   344,
     345,     0,   346,   347,     0,   348,   349,   350,     0,   351,
     352,   353,   354,  1144,   356,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,     0,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
       0,     0,   388,   389,   390,   391,   392,     0,   393,   394,
     395,     0,     0,   396,   397,   398,   399,  1145,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,     0,   429,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,     0,     0,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   458,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,   513,   880,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,     0,   539,   540,     0,   541,   542,   543,   544,   545,
     546,   547,     0,   548,   549,   550,     0,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,   561,
     562,   563,     0,     0,   564,   565,   566,   567,   568,     0,
       0,   569,   570,   571,   572,   573,   574,   575,     0,   576,
     577,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     878,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   230,   231,   232,
     233,   234,   235,   236,   237,     0,   238,   239,   240,     3,
       4,     0,     0,     0,     0,     0,   241,   242,     0,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,     0,   271,     0,   272,   273,   274,   275,   276,   277,
     278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
       0,   287,   288,   289,   290,     0,     0,     0,   291,     0,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   309,   310,   311,     0,     0,   312,   313,   314,
     315,   316,     0,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,     0,   333,     0,   334,   335,   336,   337,     0,   338,
       0,   339,   340,     0,   341,   342,   343,   344,   345,     0,
     346,   347,     0,   348,   349,   350,     0,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,     0,   361,   362,
     363,   364,   365,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,     0,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,     0,     0,
     388,   389,   390,   391,   392,     0,   393,   394,   395,     0,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,     0,   429,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
       0,     0,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   458,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,     0,   509,   510,   511,
     512,   513,     0,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,     0,
     539,   540,     0,   541,   542,   543,   544,   545,   546,   547,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,   565,   566,   567,   568,     0,     0,   569,
     570,   571,   572,   573,   574,   575,     0,   576,   577,   578,
     579,   580,   581,     0,     0,   582,     0,     0,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   878,     0,
       0,   670,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,     0,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,     0,
     271,     0,   272,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,   287,
     288,   289,   290,     0,     0,     0,   291,     0,     0,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,  2101,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,   314,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,     0,
     333,     0,   334,   335,   336,   337,     0,   338,     0,   339,
     340,     0,   341,   342,   343,   344,   345,     0,   346,   347,
       0,   348,   349,   350,     0,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,     0,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,     0,     0,   388,   389,
     390,   391,   392,     0,   393,   394,   395,     0,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,     0,   429,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,     0,     0,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     458,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
       0,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,     0,   539,   540,
       0,   541,   542,   543,   544,   545,   546,   547,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,   561,   562,   563,     0,     0,
     564,   565,   566,   567,   568,     0,     0,   569,   570,   571,
     572,   573,   574,   575,     0,   576,   577,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   878,     0,     0,   670,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   230,   231,   232,   233,   234,   235,   236,
     237,     0,   238,   239,   240,     0,     0,     0,     0,     0,
       0,     0,   241,   242,     0,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,     0,   271,     0,
     272,   273,   274,   275,   276,   277,   278,   279,   280,     0,
     281,   282,   283,   284,   285,   286,     0,   287,   288,   289,
     290,     0,     0,     0,   291,     0,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   309,   310,
     311,     0,     0,   312,   313,   314,   315,   316,     0,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,     0,   333,     0,
     334,   335,   336,   337,     0,   338,     0,   339,   340,     0,
     341,   342,   343,   344,   345,     0,   346,   347,     0,   348,
     349,   350,     0,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,     0,   361,   362,   363,   364,   365,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,     0,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,     0,     0,   388,   389,   390,   391,
     392,     0,   393,   394,   395,     0,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,     0,   429,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,     0,     0,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   458,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,     0,   509,   510,   511,   512,   513,     0,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,     0,   539,   540,     0,   541,
     542,   543,   544,   545,   546,   547,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,   561,   562,   563,     0,     0,   564,   565,
     566,   567,   568,     0,     0,   569,   570,   571,   572,   573,
     574,   575,     0,   576,   577,   578,   579,   580,   581,     0,
       0,   582,     0,     0,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   878,     0,     0,   670,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   230,   231,   232,   233,   234,   235,   236,   237,     0,
     238,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,     0,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,     0,   271,     0,   272,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,     0,   287,   288,   289,   290,     0,
       0,     0,   291,     0,     0,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,   314,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,     0,   333,     0,   334,   335,
     336,   337,     0,   338,     0,   339,   340,     0,   341,   342,
     343,   344,   345,     0,   346,   347,     0,   348,   349,   350,
       0,   351,   352,   353,   354,  1919,   356,   357,   358,   359,
     360,     0,   361,   362,   363,   364,   365,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,     0,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,     0,     0,   388,   389,   390,   391,   392,     0,
     393,   394,   395,     0,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,     0,
     429,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,     0,     0,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   458,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
       0,   509,   510,   511,   512,   513,     0,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,     0,   539,   540,     0,   541,   542,   543,
     544,   545,   546,   547,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,   561,   562,   563,     0,     0,   564,   565,   566,   567,
     568,     0,     0,   569,   570,   571,   572,   573,   574,   575,
       0,   576,   577,   578,   579,   580,   581,     0,     0,   582,
       0,     0,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   229,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   230,
     231,   232,   233,   234,   235,   236,   237,     0,   238,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
       0,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,     0,   271,     0,   272,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,   287,   288,   289,   290,     0,     0,     0,
     291,     0,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,   314,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,     0,   333,     0,   334,   335,   336,   337,
       0,   338,     0,   339,   340,     0,   341,   342,   343,   344,
     345,     0,   346,   347,     0,   348,   349,   350,     0,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,     0,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
       0,     0,   388,   389,   390,   391,   392,     0,   393,   394,
     395,     0,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,     0,   429,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,     0,     0,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   458,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,   513,     0,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,     0,   539,   540,     0,   541,   542,   543,   544,   545,
     546,   547,     0,   548,   549,   550,     0,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,   561,
     562,   563,     0,     0,   564,   565,   566,   567,   568,     0,
       0,   569,   570,   571,   572,   573,   574,   575,     0,   576,
     577,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     229,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   230,   231,   232,
     233,   234,   235,   236,   237,     0,   238,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,     0,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,     0,   271,     0,   272,   273,   274,   275,   276,   277,
     278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
       0,   287,   288,   289,   290,     0,     0,     0,   291,     0,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   309,   310,   311,     0,     0,   312,   313,   314,
     315,   316,     0,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,     0,   333,     0,   334,   335,   336,   337,     0,   338,
       0,   339,   340,     0,   341,   342,   343,   344,   345,     0,
     346,   347,     0,   348,   349,   350,     0,   351,   352,   353,
     354,  1067,   356,   357,   358,   359,   360,     0,   361,   362,
     363,   364,   365,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,     0,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,     0,     0,
     388,   389,   390,   391,   392,     0,   393,   394,   395,     0,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,     0,   429,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
       0,     0,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   458,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,     0,   509,   510,   511,
     512,   513,     0,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,     0,
     539,   540,     0,   541,   542,   543,   544,   545,   546,   547,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,   565,   566,   567,   568,     0,     0,   569,
     570,   571,   572,   573,   574,   575,     0,   576,   577,   578,
     579,   580,   581,     0,     0,   582,     0,     0,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   229,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,     0,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,     0,
     271,     0,   272,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,   287,
     288,   289,   290,     0,     0,     0,   291,     0,     0,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,   314,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,     0,
     333,     0,   334,   335,   336,   337,     0,   338,     0,   339,
     340,     0,   341,   342,   343,   344,   345,     0,   346,   347,
       0,   348,   349,   350,     0,   351,   352,   353,   354,  1116,
     356,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,     0,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,     0,     0,   388,   389,
     390,   391,   392,     0,   393,   394,   395,     0,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,     0,   429,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,     0,     0,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     458,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
       0,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,     0,   539,   540,
       0,   541,   542,   543,   544,   545,   546,   547,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,   561,   562,   563,     0,     0,
     564,   565,   566,   567,   568,     0,     0,   569,   570,   571,
     572,   573,   574,   575,     0,   576,   577,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   229,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   230,   231,   232,   233,   234,   235,   236,
     237,     0,   238,   239,   240,     0,     0,     0,     0,     0,
       0,     0,   241,   242,     0,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,     0,   271,     0,
     272,   273,   274,   275,   276,   277,   278,   279,   280,     0,
     281,   282,   283,   284,   285,   286,     0,   287,   288,   289,
     290,     0,     0,     0,   291,     0,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   309,   310,
     311,     0,     0,   312,   313,   314,   315,   316,     0,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,     0,   333,     0,
     334,   335,   336,   337,     0,   338,     0,   339,   340,     0,
     341,   342,   343,   344,   345,     0,   346,   347,     0,   348,
     349,   350,     0,   351,   352,   353,   354,  1130,   356,   357,
     358,   359,   360,     0,   361,   362,   363,   364,   365,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,     0,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,     0,     0,   388,   389,   390,   391,
     392,     0,   393,   394,   395,     0,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,     0,   429,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,     0,     0,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   458,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,     0,   509,   510,   511,   512,   513,     0,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,     0,   539,   540,     0,   541,
     542,   543,   544,   545,   546,   547,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,   561,   562,   563,     0,     0,   564,   565,
     566,   567,   568,     0,     0,   569,   570,   571,   572,   573,
     574,   575,     0,   576,   577,   578,   579,   580,   581,     0,
       0,   582,     0,     0,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   229,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   230,   231,   232,   233,   234,   235,   236,   237,     0,
     238,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,     0,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,     0,   271,     0,   272,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,     0,   287,   288,   289,   290,     0,
       0,     0,   291,     0,     0,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,   314,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,     0,   333,     0,   334,   335,
     336,   337,     0,   338,     0,   339,   340,     0,   341,   342,
     343,   344,   345,     0,   346,   347,     0,   348,   349,   350,
       0,   351,   352,   353,   354,  1134,   356,   357,   358,   359,
     360,     0,   361,   362,   363,   364,   365,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,     0,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,     0,     0,   388,   389,   390,   391,   392,     0,
     393,   394,   395,     0,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,     0,
     429,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,     0,     0,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   458,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
       0,   509,   510,   511,   512,   513,     0,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,     0,   539,   540,     0,   541,   542,   543,
     544,   545,   546,   547,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,   561,   562,   563,     0,     0,   564,   565,   566,   567,
     568,     0,     0,   569,   570,   571,   572,   573,   574,   575,
       0,   576,   577,   578,   579,   580,   581,     0,     0,   582,
       0,     0,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   878,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   230,
     231,   232,   233,   234,   235,   236,   237,     0,   238,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
       0,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,     0,   271,     0,   272,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,   287,   288,   289,   290,     0,     0,     0,
     291,     0,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,   314,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,     0,   333,     0,   334,   335,   336,   337,
       0,   338,     0,   339,   340,     0,   341,   342,   343,   344,
     345,     0,   346,   347,     0,   348,   349,   350,     0,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,     0,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
       0,     0,   388,   389,   390,   391,   392,     0,   393,   394,
     395,     0,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,     0,   429,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,     0,     0,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   458,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,   513,     0,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,     0,   539,   540,     0,   541,   542,   543,   544,   545,
     546,   547,     0,   548,   549,   550,     0,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,   561,
     562,   563,     0,     0,   564,   565,   566,   567,   568,     0,
       0,   569,   570,   571,   572,   573,   574,   575,     0,   576,
     577,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     610,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   230,   231,   232,
     233,   234,   235,   236,   237,     0,   238,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,     0,   243,
     244,   245,     0,   247,   248,   249,   250,   251,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,   263,   264,   265,  2227,   266,   267,   268,   269,
     270,     0,     0,  2307,   272,   273,   274,   275,   276,     0,
     278,   279,   280,  2228,   281,   282,   283,   284,   285,   286,
       0,     0,   288,   289,   290,     0,     0,     0,     0,     0,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   309,   310,   311,     0,     0,   312,   313,   314,
     315,   316,     0,   317,   318,   319,     0,   320,   321,   322,
       0,  2308,   324,   325,   326,   327,   328,   329,   330,   331,
     332,     0,   333,     0,   334,   335,   336,   337,     0,   338,
    2230,   339,     0,     0,     0,   342,   343,   344,   345,     0,
     346,   347,     0,   348,   349,   350,     0,   351,   352,   353,
     354,  2309,     0,   357,   358,   359,   360,     0,   361,   362,
     363,   364,   365,   366,   367,     0,   368,     0,   370,   371,
     372,   373,   374,   375,   376,     0,   377,     0,   378,     0,
       0,   381,     0,   383,   384,   385,   386,   387,     0,     0,
     388,   389,     0,   391,     0,     0,   393,   394,   395,     0,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,     0,   428,     0,   429,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
       0,     0,   440,   441,   442,     0,   444,     0,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   458,   459,   460,   461,   462,   463,  2231,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,     0,   509,   510,   511,
     512,   513,     0,   514,   515,   516,   517,   518,     0,   520,
     521,   522,   523,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,     0,
     539,   540,     0,   541,     0,   543,   544,   545,   546,   547,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,   561,   562,   563,
       0,  2232,   564,   565,   566,   567,   568,     0,     0,   569,
     570,   571,   572,   573,   574,   575,     0,   576,     0,   578,
     579,   580,   581,     0,     0,   582,     0,     0,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   610,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,     0,   243,   244,   245,
       0,   247,   248,   249,   250,   251,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
     263,   264,   265,  2227,   266,   267,   268,   269,   270,     0,
       0,     0,   272,   273,   274,   275,   276,     0,   278,   279,
     280,  2228,   281,   282,   283,   284,   285,   286,     0,     0,
     288,   289,   290,     0,     0,     0,     0,     0,     0,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,   314,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,  2308,
     324,   325,   326,   327,   328,   329,   330,   331,   332,     0,
     333,     0,   334,   335,   336,   337,     0,   338,  2230,   339,
       0,     0,     0,   342,   343,   344,   345,     0,   346,   347,
       0,   348,   349,   350,     0,   351,   352,   353,   354,   355,
       0,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,     0,   370,   371,   372,   373,
     374,   375,   376,     0,   377,     0,   378,     0,     0,   381,
       0,   383,   384,   385,   386,   387,     0,     0,   388,   389,
       0,   391,  3306,     0,   393,   394,   395,     0,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,     0,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,     0,   428,     0,   429,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,     0,     0,
     440,   441,   442,     0,   444,     0,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     458,   459,   460,   461,   462,   463,  2231,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
       0,   514,   515,   516,   517,   518,     0,   520,   521,   522,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,     0,   539,   540,
       0,   541,     0,   543,   544,   545,   546,   547,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,   561,   562,   563,     0,  2232,
     564,   565,   566,   567,   568,     0,     0,   569,   570,   571,
     572,   573,   574,   575,     0,   576,     0,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   610,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   230,   231,   232,   233,   234,   791,   236,
     237,   750,   238,   239,   240,     0,     0,     0,     0,     0,
       0,     0,   241,   242,     0,   243,   244,   245,     0,   247,
     248,   249,   250,   251,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,     0,     0,     0,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
     281,   282,   283,   284,   285,   286,   751,     0,   288,   289,
     290,     0,     0,     0,     0,     0,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   309,   310,
     311,     0,     0,   312,   313,   314,   315,   316,     0,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,     0,   333,     0,
     334,   335,   336,   337,     0,   338,     0,   339,     0,     0,
       0,   342,   343,   344,   345,   792,   346,   347,     0,   348,
     349,   350,     0,   351,   352,   353,   354,   355,     0,   357,
     358,   359,   360,     0,   361,   362,   363,   364,   365,   366,
     367,     0,   368,     0,   370,   371,   372,   373,   374,   375,
     376,     0,   377,     0,   378,     0,     0,   381,     0,   383,
     384,   385,   386,   387,     0,     0,   388,   389,     0,   391,
       0,     0,   393,   394,   395,     0,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,     0,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,     0,
     428,     0,   429,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,     0,     0,   440,   441,
     442,     0,   444,     0,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   458,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     752,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   753,   509,   510,   511,   512,   513,     0,   514,
     515,   516,   517,   518,     0,   520,   521,   522,   523,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,     0,   539,   540,     0,   541,
       0,   543,   544,   545,   546,   547,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,   561,   562,   563,     0,     0,   564,   565,
     566,   567,   568,     0,     0,   569,   570,   571,   572,   573,
     574,   575,     0,   576,     0,   578,   579,   580,   581,     0,
       0,   582,     0,     0,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   610,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   230,   231,   232,   233,   234,   235,   236,   237,   750,
     238,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,     0,   243,   244,   245,     0,   247,   248,   249,
     250,   251,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,     0,     0,     0,   272,   273,
     274,   275,   276,     0,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,   751,     0,   288,   289,   290,     0,
       0,     0,     0,     0,     0,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,   314,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,     0,   333,     0,   334,   335,
     336,   337,     0,   338,     0,   339,     0,     0,     0,   342,
     343,   344,   345,  2985,   346,   347,     0,   348,   349,   350,
       0,   351,   352,   353,   354,   355,     0,   357,   358,   359,
     360,     0,   361,   362,   363,   364,   365,   366,   367,     0,
     368,     0,   370,   371,   372,   373,   374,   375,   376,     0,
     377,     0,   378,     0,     0,   381,     0,   383,   384,   385,
     386,   387,     0,     0,   388,   389,     0,   391,     0,     0,
     393,   394,   395,     0,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,     0,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,     0,   428,     0,
     429,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,     0,     0,   440,   441,   442,     0,
     444,     0,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   458,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   752,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     753,   509,   510,   511,   512,   513,     0,   514,   515,   516,
     517,   518,     0,   520,   521,   522,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,     0,   539,   540,     0,   541,     0,   543,
     544,   545,   546,   547,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,   561,   562,   563,     0,     0,   564,   565,   566,   567,
     568,     0,     0,   569,   570,   571,   572,   573,   574,   575,
       0,   576,     0,   578,   579,   580,   581,     0,     0,   582,
       0,     0,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   610,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   230,
     231,   232,   233,   234,   235,   236,   237,     0,   238,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
       0,   243,   244,   245,     0,   247,   248,   249,   250,   251,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,   263,   264,   265,  2227,   266,   267,
     268,   269,   270,     0,     0,     0,   272,   273,   274,   275,
     276,     0,   278,   279,   280,  2228,   281,   282,   283,   284,
     285,   286,     0,     0,   288,   289,   290,     0,     0,     0,
       0,     0,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,   314,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,  2308,   324,   325,   326,   327,   328,   329,
     330,   331,   332,     0,   333,     0,   334,   335,   336,   337,
       0,   338,  2230,   339,     0,     0,     0,   342,   343,   344,
     345,     0,   346,   347,     0,   348,   349,   350,     0,   351,
     352,   353,   354,   355,     0,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,     0,
     370,   371,   372,   373,   374,   375,   376,     0,   377,     0,
     378,     0,     0,   381,     0,   383,   384,   385,   386,   387,
       0,     0,   388,   389,     0,   391,     0,     0,   393,   394,
     395,     0,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
       0,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,     0,   428,     0,   429,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,     0,     0,   440,   441,   442,     0,   444,     0,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   458,   459,   460,   461,   462,   463,
    2231,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,   513,     0,   514,   515,   516,   517,   518,
       0,   520,   521,   522,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,     0,   539,   540,     0,   541,     0,   543,   544,   545,
     546,   547,     0,   548,   549,   550,     0,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,   561,
     562,   563,     0,  2232,   564,   565,   566,   567,   568,     0,
       0,   569,   570,   571,   572,   573,   574,   575,     0,   576,
       0,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     610,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   230,   231,   232,
     233,   234,   235,   236,   237,   750,   238,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,     0,   243,
     244,   245,     0,   247,   248,   249,   250,   251,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,     0,     0,     0,   272,   273,   274,   275,   276,     0,
     278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
     751,     0,   288,   289,   290,     0,     0,     0,     0,     0,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   309,   310,   311,     0,     0,   312,   313,   314,
     315,   316,     0,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,     0,   333,     0,   334,   335,   336,   337,     0,   338,
       0,   339,     0,     0,     0,   342,   343,   344,   345,     0,
     346,   347,     0,   348,   349,   350,     0,   351,   352,   353,
     354,   355,     0,   357,   358,   359,   360,     0,   361,   362,
     363,   364,   365,   366,   367,     0,   368,     0,   370,   371,
     372,   373,   374,   375,   376,     0,   377,     0,   378,     0,
       0,   381,     0,   383,   384,   385,   386,   387,     0,     0,
     388,   389,     0,   391,     0,     0,   393,   394,   395,     0,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,     0,   428,     0,   429,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
       0,     0,   440,   441,   442,     0,   444,     0,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   458,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   752,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   753,   509,   510,   511,
     512,   513,     0,   514,   515,   516,   517,   518,     0,   520,
     521,   522,   523,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,     0,
     539,   540,     0,   541,     0,   543,   544,   545,   546,   547,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,   565,   566,   567,   568,     0,     0,   569,
     570,   571,   572,   573,   574,   575,     0,   576,     0,   578,
     579,   580,   581,     0,     0,   582,     0,     0,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   610,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,  1962,   238,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,     0,   243,   244,   245,
       0,   247,   248,   249,   250,   251,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,     0,
       0,     0,   272,   273,   274,   275,   276,     0,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,     0,
     288,   289,   290,     0,     0,     0,     0,     0,     0,     0,
     292,   293,   294,  1963,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,  1964,   314,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,     0,
     333,     0,   334,   335,   336,   337,     0,   338,  1965,   339,
       0,     0,     0,  1966,   343,   344,   345,     0,   346,   347,
       0,   348,   349,   350,     0,   351,   352,   353,   354,   355,
       0,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,     0,   370,   371,   372,   373,
     374,   375,   376,     0,   377,     0,   378,     0,     0,   381,
       0,   383,   384,  1967,  1968,   387,     0,     0,   388,   389,
       0,   391,     0,     0,   393,   394,   395,     0,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,     0,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,     0,   428,     0,   429,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,     0,     0,
     440,   441,   442,     0,   444,     0,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     458,   459,   460,   461,   462,   463,     0,   464,   465,   466,
    1969,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,     0,   494,
     495,   496,  1970,   498,   499,   500,   501,   502,  1971,   504,
     505,   506,   507,   508,     0,  1972,   510,   511,   512,   513,
       0,   514,   515,   516,   517,   518,     0,   520,   521,   522,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,     0,   539,   540,
    1973,   541,     0,  1974,   544,   545,   546,   547,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,     0,
     556,   557,  1975,   559,   560,   561,   562,   563,     0,     0,
     564,   565,   566,   567,   568,     0,     0,   569,   570,   571,
     572,   573,   574,   575,     0,   576,     0,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   610,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   230,   231,   232,   233,   234,   235,   236,
     237,     0,   238,   239,   240,     0,     0,     0,     0,     0,
       0,     0,   241,   242,     0,   243,   244,   245,     0,   247,
     248,   249,   250,   251,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,     0,     0,     0,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
     281,   282,   283,   284,   285,   286,   751,     0,   288,   289,
     290,     0,     0,     0,     0,     0,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   309,   310,
     311,     0,     0,   312,   313,   314,   315,   316,     0,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,     0,   333,     0,
     334,   335,   336,   337,     0,   338,     0,   339,     0,     0,
       0,   342,   343,   344,   345,     0,   346,   347,     0,   348,
     349,   350,     0,   351,   352,   353,   354,   355,     0,   357,
     358,   359,   360,     0,   361,   362,   363,   364,   365,   366,
     367,     0,   368,     0,   370,   371,   372,   373,   374,   375,
     376,     0,   377,     0,   378,     0,     0,   381,     0,   383,
     384,   385,   386,   387,     0,     0,   388,   389,     0,   391,
       0,     0,   393,   394,   395,     0,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,     0,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,     0,
     428,     0,   429,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,     0,     0,   440,   441,
     442,     0,   444,     0,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   458,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     752,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   753,   509,   510,   511,   512,   513,     0,   514,
     515,   516,   517,   518,     0,   520,   521,   522,   523,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,     0,   539,   540,     0,   541,
       0,   543,   544,   545,   546,   547,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,   561,   562,   563,     0,     0,   564,   565,
     566,   567,   568,     0,     0,   569,   570,   571,   572,   573,
     574,   575,     0,   576,     0,   578,   579,   580,   581,     0,
       0,   582,     0,     0,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   610,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   230,   231,   232,   233,   234,   235,   236,   237,   930,
     238,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,     0,   243,   244,   245,     0,   247,   248,   249,
     250,   251,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,     0,     0,     0,   272,   273,
     274,   275,   276,     0,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,     0,     0,   288,   289,   290,     0,
       0,     0,     0,     0,     0,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,   314,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,     0,   333,     0,   334,   335,
     336,   337,     0,   338,     0,   339,     0,     0,     0,   342,
     343,   344,   345,     0,   346,   347,     0,   348,   349,   350,
       0,   351,   352,   353,   354,   931,     0,   357,   358,   359,
     360,     0,   361,   362,   363,   364,   365,   366,   367,     0,
     368,     0,   370,   371,   372,   373,   374,   375,   376,     0,
     377,     0,   378,     0,     0,   381,     0,   383,   384,   385,
     386,   387,     0,     0,   388,   389,     0,   391,     0,     0,
     393,   394,   395,     0,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,     0,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,     0,   428,     0,
     429,   430,   431,   432,   433,   434,     0,   435,   436,     0,
     823,   437,   438,   439,     0,     0,   440,   441,   442,     0,
     444,     0,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   458,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
       0,   509,   510,   511,   512,   513,     0,   514,   515,   516,
     517,   518,     0,   520,   521,   522,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,     0,   539,   540,     0,   541,     0,   543,
     544,   545,   546,   547,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,   561,   562,   563,     0,     0,   564,   565,   566,   567,
     568,     0,     0,   569,   570,   571,   572,   573,   574,   575,
       0,   576,     0,   578,   579,   580,   581,     0,     0,   582,
       0,     0,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   610,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   230,
     231,   232,   233,   234,   235,   236,   237,  3076,   238,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
       0,   243,   244,   245,     0,   247,   248,   249,   250,   251,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,     0,     0,     0,   272,   273,   274,   275,
     276,     0,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,     0,   288,   289,   290,     0,     0,     0,
       0,     0,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,   314,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,     0,   333,     0,   334,   335,   336,   337,
       0,   338,     0,   339,     0,     0,     0,   342,   343,   344,
     345,     0,   346,   347,     0,   348,   349,   350,     0,   351,
     352,   353,   354,   355,     0,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,     0,
     370,   371,   372,   373,   374,   375,   376,     0,   377,     0,
     378,     0,     0,   381,     0,   383,   384,   385,   386,   387,
       0,     0,   388,   389,     0,   391,     0,     0,   393,   394,
     395,     0,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
       0,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,     0,   428,     0,   429,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,     0,     0,   440,   441,   442,     0,   444,     0,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   458,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,   513,     0,   514,   515,   516,   517,   518,
       0,   520,   521,   522,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,     0,   539,   540,     0,   541,     0,   543,   544,   545,
     546,   547,     0,   548,   549,   550,     0,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,   561,
     562,   563,     0,     0,   564,   565,   566,   567,   568,  3077,
       0,   569,   570,   571,   572,   573,   574,   575,     0,   576,
       0,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     610,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   230,   231,   232,
     233,   234,   235,   236,   237,  3089,   238,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,     0,   243,
     244,   245,     0,   247,   248,   249,   250,   251,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,     0,     0,     0,   272,   273,   274,   275,   276,     0,
     278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
       0,     0,   288,   289,   290,     0,     0,     0,     0,     0,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   309,   310,   311,     0,     0,   312,   313,   314,
     315,   316,     0,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,     0,   333,     0,   334,   335,   336,   337,     0,   338,
       0,   339,     0,     0,     0,   342,   343,   344,   345,     0,
     346,   347,     0,   348,   349,   350,     0,   351,   352,   353,
     354,   355,     0,   357,   358,   359,   360,     0,   361,   362,
     363,   364,   365,   366,   367,     0,   368,     0,   370,   371,
     372,   373,   374,   375,   376,     0,   377,     0,   378,     0,
       0,   381,     0,   383,   384,   385,   386,   387,     0,     0,
     388,   389,     0,   391,     0,     0,   393,   394,   395,     0,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,     0,   428,     0,   429,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
       0,     0,   440,   441,   442,     0,   444,     0,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   458,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,     0,   509,   510,   511,
     512,   513,     0,   514,   515,   516,   517,   518,     0,   520,
     521,   522,   523,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,     0,
     539,   540,     0,   541,     0,   543,   544,   545,   546,   547,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,   565,   566,   567,   568,  3090,     0,   569,
     570,   571,   572,   573,   574,   575,     0,   576,     0,   578,
     579,   580,   581,     0,     0,   582,     0,     0,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   610,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,   611,   238,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,     0,   243,   244,   245,
       0,   247,   248,   249,   250,   251,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,     0,
       0,     0,   272,   273,   274,   275,   276,     0,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,     0,
     288,   289,   290,     0,     0,     0,     0,     0,     0,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,   314,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,     0,
     333,     0,   334,   335,   336,   337,     0,   338,     0,   339,
       0,     0,     0,   342,   343,   344,   345,     0,   346,   347,
       0,   348,   349,   350,     0,   351,   352,   353,   354,   355,
       0,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,     0,   370,   371,   372,   373,
     374,   375,   376,     0,   377,     0,   378,     0,     0,   381,
       0,   383,   384,   385,   386,   387,     0,     0,   388,   389,
       0,   391,     0,     0,   393,   394,   395,     0,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,     0,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,     0,   428,     0,   429,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,     0,     0,
     440,   441,   442,     0,   444,     0,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     458,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
       0,   514,   515,   516,   517,   518,     0,   520,   521,   522,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,     0,   539,   540,
       0,   541,     0,   543,   544,   545,   546,   547,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,   561,   562,   563,     0,     0,
     564,   565,   566,   567,   568,     0,     0,   569,   570,   571,
     572,   573,   574,   575,     0,   576,     0,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   610,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   230,   231,   232,   233,   234,   235,   236,
     237,   661,   238,   239,   240,     0,     0,     0,     0,     0,
       0,     0,   241,   242,     0,   243,   244,   245,     0,   247,
     248,   249,   250,   251,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,     0,     0,     0,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
     281,   282,   283,   284,   285,   286,     0,     0,   288,   289,
     290,     0,     0,     0,     0,     0,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   309,   310,
     311,     0,     0,   312,   313,   314,   315,   316,     0,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,     0,   333,     0,
     334,   335,   336,   337,     0,   338,     0,   339,     0,     0,
       0,   342,   343,   344,   345,     0,   346,   347,     0,   348,
     349,   350,     0,   351,   352,   353,   354,   355,     0,   357,
     358,   359,   360,     0,   361,   362,   363,   364,   365,   366,
     367,     0,   368,     0,   370,   371,   372,   373,   374,   375,
     376,     0,   377,     0,   378,     0,     0,   381,     0,   383,
     384,   385,   386,   387,     0,     0,   388,   389,     0,   391,
       0,     0,   393,   394,   395,     0,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,     0,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,     0,
     428,     0,   429,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,     0,     0,   440,   441,
     442,     0,   444,     0,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   458,   459,
     460,   461,   662,   463,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,     0,   509,   510,   511,   512,   513,     0,   514,
     515,   516,   517,   518,     0,   520,   521,   522,   523,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,     0,   539,   540,     0,   541,
       0,   543,   544,   545,   546,   547,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,   561,   562,   563,     0,     0,   564,   565,
     566,   567,   568,     0,     0,   569,   570,   571,   572,   573,
     574,   575,     0,   576,     0,   578,   579,   580,   581,     0,
       0,   582,     0,     0,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   610,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   230,   231,   232,   233,   234,   235,   236,   237,   783,
     238,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,     0,   243,   244,   245,     0,   247,   248,   249,
     250,   251,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,     0,     0,     0,   272,   273,
     274,   275,   276,     0,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,     0,     0,   288,   289,   290,     0,
       0,     0,     0,     0,     0,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,   314,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,     0,   333,     0,   334,   335,
     336,   337,     0,   338,     0,   339,     0,     0,     0,   342,
     343,   344,   345,     0,   346,   347,     0,   348,   349,   350,
       0,   351,   352,   353,   354,   355,     0,   357,   358,   359,
     360,     0,   361,   362,   363,   364,   365,   366,   367,     0,
     368,     0,   370,   371,   372,   373,   374,   375,   376,     0,
     377,     0,   378,     0,     0,   381,     0,   383,   384,   385,
     386,   387,     0,     0,   388,   389,     0,   391,     0,     0,
     393,   394,   395,     0,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,     0,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,     0,   428,     0,
     429,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,     0,     0,   440,   441,   442,     0,
     444,     0,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   458,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
       0,   509,   510,   511,   512,   784,     0,   514,   515,   516,
     517,   518,     0,   520,   521,   522,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,     0,   539,   540,     0,   541,     0,   543,
     544,   545,   546,   547,     0,   548,   785,   550,     0,     0,
     786,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,   561,   562,   563,     0,     0,   564,   565,   566,   567,
     568,     0,     0,   569,   570,   571,   572,   573,   574,   575,
       0,   576,     0,   578,   579,   580,   581,     0,     0,   582,
       0,     0,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   610,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   230,
     231,   232,   233,   234,   235,   236,   237,   817,   238,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
       0,   243,   244,   245,     0,   247,   248,   249,   250,   251,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,     0,     0,     0,   272,   273,   274,   275,
     276,     0,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,     0,   288,   289,   290,     0,     0,     0,
       0,     0,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,   314,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,     0,   333,     0,   334,   335,   336,   337,
       0,   338,     0,   339,     0,     0,     0,   342,   343,   344,
     345,     0,   346,   347,     0,   348,   349,   350,     0,   351,
     352,   353,   354,   355,     0,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,     0,
     370,   371,   372,   373,   374,   375,   376,     0,   377,     0,
     378,     0,     0,   381,     0,   383,   384,   385,   386,   387,
       0,     0,   388,   389,     0,   391,     0,     0,   393,   394,
     395,     0,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
       0,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,     0,   428,     0,   429,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,     0,     0,   440,   441,   442,     0,   444,     0,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   458,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,   818,     0,   514,   515,   516,   517,   518,
       0,   520,   521,   522,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,     0,   539,   540,     0,   541,     0,   543,   544,   545,
     546,   547,     0,   548,   819,   550,     0,     0,   820,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,   561,
     562,   563,     0,     0,   564,   565,   566,   567,   568,     0,
       0,   569,   570,   571,   572,   573,   574,   575,     0,   576,
       0,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     610,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   230,   231,   232,
     233,   234,   235,   236,   237,     0,   238,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,     0,   243,
     244,   245,     0,   247,   248,   249,   250,   251,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,     0,     0,     0,   272,   273,   274,   275,   276,     0,
     278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
       0,     0,   288,   289,   290,     0,     0,     0,     0,     0,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   309,   310,   311,     0,     0,   312,   313,   314,
     315,   316,     0,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,     0,   333,     0,   334,   335,   336,   337,     0,   338,
       0,   339,     0,     0,     0,   342,   343,   344,   345,     0,
     346,   347,     0,   348,   349,   350,     0,   351,   352,   353,
     354,   355,     0,   357,   358,   359,   360,     0,   361,   362,
     363,   364,   365,   366,   367,     0,   368,     0,   370,   371,
     372,   373,   374,   375,   376,     0,   377,     0,   378,     0,
       0,   381,     0,   383,   384,   385,   386,   387,     0,     0,
     388,   389,     0,   391,     0,     0,   393,   394,   395,     0,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,     0,   428,     0,   429,   430,   431,   432,
     433,   434,     0,   435,   436,     0,   823,   437,   438,   439,
       0,     0,   440,   441,   442,     0,   444,     0,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   458,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,     0,   509,   510,   511,
     512,   513,     0,   514,   515,   516,   517,   518,     0,   520,
     521,   522,   523,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,     0,
     539,   540,     0,   541,     0,   543,   544,   545,   546,   547,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,   565,   566,   567,   568,     0,     0,   569,
     570,   571,   572,   573,   574,   575,     0,   576,     0,   578,
     579,   580,   581,     0,     0,   582,     0,     0,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   610,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,   887,   238,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,     0,   243,   244,   245,
       0,   247,   248,   249,   250,   251,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,     0,
       0,     0,   272,   273,   274,   275,   276,     0,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,     0,
     288,   289,   290,     0,     0,     0,     0,     0,     0,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,   314,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,     0,
     333,     0,   334,   335,   336,   337,     0,   338,     0,   339,
       0,     0,     0,   342,   343,   344,   345,     0,   346,   347,
       0,   348,   349,   350,     0,   351,   352,   353,   354,   888,
       0,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,     0,   370,   371,   372,   373,
     374,   375,   376,     0,   377,     0,   378,     0,     0,   381,
       0,   383,   384,   385,   386,   387,     0,     0,   388,   389,
       0,   391,     0,     0,   393,   394,   395,     0,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,     0,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,     0,   428,     0,   429,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,     0,     0,
     440,   441,   442,     0,   444,     0,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     458,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
       0,   514,   515,   516,   517,   518,     0,   520,   521,   522,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,     0,   539,   540,
       0,   541,     0,   543,   544,   545,   546,   547,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,   561,   562,   563,     0,     0,
     564,   565,   566,   567,   568,     0,     0,   569,   570,   571,
     572,   573,   574,   575,     0,   576,     0,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   610,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   230,   231,   232,   233,   234,   235,   236,
     237,  1059,   238,   239,   240,     0,     0,     0,     0,     0,
       0,     0,   241,   242,     0,   243,   244,   245,     0,   247,
     248,   249,   250,   251,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,     0,     0,     0,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
     281,   282,   283,   284,   285,   286,     0,     0,   288,   289,
     290,     0,     0,     0,     0,     0,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   309,   310,
     311,     0,     0,   312,   313,   314,   315,   316,     0,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,     0,   333,     0,
     334,   335,   336,   337,     0,   338,     0,   339,     0,     0,
       0,   342,   343,   344,   345,     0,   346,   347,     0,   348,
     349,   350,     0,   351,   352,   353,   354,   355,     0,   357,
     358,   359,   360,     0,   361,   362,   363,   364,   365,   366,
     367,     0,   368,     0,   370,   371,   372,   373,   374,   375,
     376,     0,   377,     0,   378,     0,     0,   381,     0,   383,
     384,   385,   386,   387,     0,     0,   388,   389,     0,   391,
       0,     0,   393,   394,   395,     0,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,     0,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,     0,
     428,     0,   429,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,     0,     0,   440,   441,
     442,     0,   444,     0,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   458,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,     0,   509,   510,   511,   512,   513,     0,   514,
     515,   516,   517,   518,     0,   520,   521,   522,   523,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,     0,   539,   540,     0,   541,
       0,   543,   544,   545,   546,   547,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,   561,   562,   563,     0,     0,   564,   565,
     566,   567,   568,     0,     0,   569,   570,   571,   572,   573,
     574,   575,     0,   576,     0,   578,   579,   580,   581,     0,
       0,   582,     0,     0,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   610,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   230,   231,   232,   233,   234,   235,   236,   237,   783,
     238,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,     0,   243,   244,   245,     0,   247,   248,   249,
     250,   251,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,     0,     0,     0,   272,   273,
     274,   275,   276,     0,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,     0,     0,   288,   289,   290,     0,
       0,     0,     0,     0,     0,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,   314,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,     0,   333,     0,   334,   335,
     336,   337,     0,   338,     0,   339,     0,     0,     0,   342,
     343,   344,   345,     0,   346,   347,     0,   348,   349,   350,
       0,   351,   352,   353,   354,   355,     0,   357,   358,   359,
     360,     0,   361,   362,   363,   364,   365,   366,   367,     0,
     368,     0,   370,   371,   372,   373,   374,   375,   376,     0,
     377,     0,   378,     0,     0,   381,     0,   383,   384,   385,
     386,   387,     0,     0,   388,   389,     0,   391,     0,     0,
     393,   394,   395,     0,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,     0,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,     0,   428,     0,
     429,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,     0,     0,   440,   441,   442,     0,
     444,     0,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   458,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
       0,   509,   510,   511,   512,   513,     0,   514,   515,   516,
     517,   518,     0,   520,   521,   522,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,     0,   539,   540,     0,   541,     0,   543,
     544,   545,   546,   547,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,   561,   562,   563,     0,     0,   564,   565,   566,   567,
     568,     0,     0,   569,   570,   571,   572,   573,   574,   575,
       0,   576,     0,   578,   579,   580,   581,     0,     0,   582,
       0,     0,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   610,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   230,
     231,   232,   233,   234,   235,   236,   237,  1206,   238,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
       0,   243,   244,   245,     0,   247,   248,   249,   250,   251,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,     0,     0,     0,   272,   273,   274,   275,
     276,     0,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,     0,   288,   289,   290,     0,     0,     0,
       0,     0,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,   314,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,     0,   333,     0,   334,   335,   336,   337,
       0,   338,     0,   339,     0,     0,     0,   342,   343,   344,
     345,     0,   346,   347,     0,   348,   349,   350,     0,   351,
     352,   353,   354,   355,     0,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,     0,
     370,   371,   372,   373,   374,   375,   376,     0,   377,     0,
     378,     0,     0,   381,     0,   383,   384,   385,   386,   387,
       0,     0,   388,   389,     0,   391,     0,     0,   393,   394,
     395,     0,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
       0,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,     0,   428,     0,   429,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,     0,     0,   440,   441,   442,     0,   444,     0,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   458,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,   513,     0,   514,   515,   516,   517,   518,
       0,   520,   521,   522,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,     0,   539,   540,     0,   541,     0,   543,   544,   545,
     546,   547,     0,   548,   549,   550,     0,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,   561,
     562,   563,     0,     0,   564,   565,   566,   567,   568,     0,
       0,   569,   570,   571,   572,   573,   574,   575,     0,   576,
       0,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     610,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   230,   231,   232,
     233,   234,   235,   236,   237,  1339,   238,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,     0,   243,
     244,   245,     0,   247,   248,   249,   250,   251,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,     0,     0,     0,   272,   273,   274,   275,   276,     0,
     278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
       0,     0,   288,   289,   290,     0,     0,     0,     0,     0,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   309,   310,   311,     0,     0,   312,   313,   314,
     315,   316,     0,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,     0,   333,     0,   334,   335,   336,   337,     0,   338,
       0,   339,     0,     0,     0,   342,   343,   344,   345,     0,
     346,   347,     0,   348,   349,   350,     0,   351,   352,   353,
     354,   355,     0,   357,   358,   359,   360,     0,   361,   362,
     363,   364,   365,   366,   367,     0,   368,     0,   370,   371,
     372,   373,   374,   375,   376,     0,   377,     0,   378,     0,
       0,   381,     0,   383,   384,   385,   386,   387,     0,     0,
     388,   389,     0,   391,     0,     0,   393,   394,   395,     0,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,     0,   428,     0,   429,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
       0,     0,   440,   441,   442,     0,   444,     0,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   458,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,     0,   509,   510,   511,
     512,   513,     0,   514,   515,   516,   517,   518,     0,   520,
     521,   522,   523,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,     0,
     539,   540,     0,   541,     0,   543,   544,   545,   546,   547,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,   565,   566,   567,   568,     0,     0,   569,
     570,   571,   572,   573,   574,   575,     0,   576,     0,   578,
     579,   580,   581,     0,     0,   582,     0,     0,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   610,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,     0,   243,   244,   245,
    1350,   247,   248,   249,   250,   251,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   803,   262,
     263,   264,  1351,     0,   266,   267,   268,   269,   270,     0,
       0,     0,   272,   273,   274,   275,   276,     0,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,     0,
     288,   289,   290,     0,     0,     0,     0,     0,     0,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,   314,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,     0,
     333,     0,   334,   335,   336,   337,     0,   338,     0,   339,
       0,     0,     0,   342,   343,   344,   345,     0,   346,   347,
       0,   348,   349,   350,     0,   351,   352,   353,   354,   355,
       0,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,     0,   370,   371,   372,   373,
     374,   375,   376,     0,   377,     0,   378,     0,     0,   381,
       0,   383,   384,   385,   386,   387,     0,     0,   388,   389,
       0,   391,     0,     0,   393,   394,   395,     0,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   806,   412,     0,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,     0,   428,     0,   429,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,     0,     0,
     440,   441,   442,     0,   444,     0,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     458,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,     0,   807,
     495,   496,   497,   498,   499,   500,   501,   502,   808,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,  1343,
       0,   514,   515,   516,   517,   518,     0,   520,   521,   522,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,     0,   539,   540,
       0,   541,     0,   543,   544,   545,   546,   547,     0,   548,
     810,   550,     0,     0,   811,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,   561,   562,   563,     0,     0,
     564,   565,   566,   567,   568,     0,     0,   569,   570,   571,
     572,   573,   574,   575,     0,   576,     0,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   812,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   610,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   230,   231,   232,   233,   234,   235,   236,
     237,     0,   238,   239,   240,     0,     0,     0,     0,     0,
       0,     0,   241,   242,     0,   243,   244,   245,     0,   247,
     248,   249,   250,   251,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,     0,     0,     0,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
     281,   282,   283,   284,   285,   286,     0,     0,   288,   289,
     290,     0,     0,     0,     0,     0,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   309,   310,
     311,     0,     0,   312,   313,   314,   315,   316,     0,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,     0,   333,     0,
     334,   335,   336,   337,     0,   338,     0,   339,     0,     0,
       0,   342,   343,   344,   345,     0,   346,   347,     0,   348,
     349,   350,     0,   351,   352,   353,   354,  1462,     0,   357,
     358,   359,   360,     0,   361,   362,   363,   364,   365,   366,
     367,     0,   368,     0,   370,   371,   372,   373,   374,   375,
     376,     0,   377,     0,   378,     0,     0,   381,     0,   383,
     384,   385,   386,   387,     0,     0,   388,   389,     0,   391,
       0,     0,   393,   394,   395,     0,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,     0,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,     0,
     428,     0,   429,   430,   431,   432,   433,   434,     0,   435,
     436,     0,   823,   437,   438,   439,     0,     0,   440,   441,
     442,     0,   444,     0,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   458,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,     0,   509,   510,   511,   512,   513,     0,   514,
     515,   516,   517,   518,     0,   520,   521,   522,   523,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,     0,   539,   540,     0,   541,
       0,   543,   544,   545,   546,   547,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,   561,   562,   563,     0,     0,   564,   565,
     566,   567,   568,     0,     0,   569,   570,   571,   572,   573,
     574,   575,     0,   576,     0,   578,   579,   580,   581,     0,
       0,   582,     0,     0,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   610,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   230,   231,   232,   233,   234,   235,   236,   237,  1523,
     238,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,     0,   243,   244,   245,     0,   247,   248,   249,
     250,   251,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,     0,     0,     0,   272,   273,
     274,   275,   276,     0,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,     0,     0,   288,   289,   290,     0,
       0,     0,     0,     0,     0,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,   314,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,     0,   333,     0,   334,   335,
     336,   337,     0,   338,     0,   339,     0,     0,     0,   342,
     343,   344,   345,     0,   346,   347,     0,   348,   349,   350,
       0,   351,   352,   353,   354,  1524,     0,   357,   358,   359,
     360,     0,   361,   362,   363,   364,   365,   366,   367,     0,
     368,     0,   370,   371,   372,   373,   374,   375,   376,     0,
     377,     0,   378,     0,     0,   381,     0,   383,   384,   385,
     386,   387,     0,     0,   388,   389,     0,   391,     0,     0,
     393,   394,   395,     0,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,     0,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,     0,   428,     0,
     429,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,     0,     0,   440,   441,   442,     0,
     444,     0,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   458,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
       0,   509,   510,   511,   512,   513,     0,   514,   515,   516,
     517,   518,     0,   520,   521,   522,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,     0,   539,   540,     0,   541,     0,   543,
     544,   545,   546,   547,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,   561,   562,   563,     0,     0,   564,   565,   566,   567,
     568,     0,     0,   569,   570,   571,   572,   573,   574,   575,
       0,   576,     0,   578,   579,   580,   581,     0,     0,   582,
       0,     0,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   610,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   230,
     231,   232,   233,   234,   235,   236,   237,     0,   238,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
       0,   243,   244,   245,     0,   247,   248,   249,   250,   251,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,     0,     0,     0,   272,   273,   274,   275,
     276,     0,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,     0,   288,   289,   290,     0,     0,     0,
       0,     0,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,   314,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,     0,   333,     0,   334,   335,   336,   337,
       0,   338,     0,   339,     0,     0,     0,   342,   343,   344,
    2885,     0,   346,   347,     0,   348,   349,   350,     0,   351,
     352,   353,   354,   355,     0,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,     0,
     370,   371,   372,   373,   374,   375,   376,     0,   377,     0,
     378,     0,     0,   381,     0,   383,   384,   385,   386,   387,
       0,     0,   388,   389,     0,   391,     0,     0,   393,   394,
    2886,     0,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
       0,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,     0,   428,     0,   429,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,     0,     0,   440,   441,   442,     0,   444,     0,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   458,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,   513,     0,   514,   515,   516,   517,   518,
       0,   520,   521,   522,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,     0,   539,   540,  2887,   541,     0,   543,  2888,   545,
    2889,   547,     0,   548,   549,   550,     0,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,   561,
     562,   563,     0,     0,   564,   565,  2890,   567,   568,     0,
       0,   569,   570,   571,   572,   573,   574,   575,     0,   576,
       0,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     610,     0,     0,   670,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   230,   231,   232,
     233,   234,   235,   236,   237,     0,   238,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,     0,   243,
     244,   245,     0,   247,   248,   249,   250,   251,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,     0,     0,     0,   272,   273,   274,   275,   276,     0,
     278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
       0,     0,   288,   289,   290,     0,     0,     0,     0,     0,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   309,   310,   311,     0,     0,   312,   313,   314,
     315,   316,     0,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,     0,   333,     0,   334,   335,   336,   337,     0,   338,
       0,   339,     0,     0,     0,   342,   343,   344,   345,     0,
     346,   347,     0,   348,   349,   350,     0,   351,   352,   353,
     354,   355,     0,   357,   358,   359,   360,     0,   361,   362,
     363,   364,   365,   366,   367,     0,   368,     0,   370,   371,
     372,   373,   374,   375,   376,     0,   377,     0,   378,     0,
       0,   381,     0,   383,   384,   385,   386,   387,     0,     0,
     388,   389,     0,   391,     0,     0,   393,   394,   395,     0,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,     0,   428,     0,   429,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
       0,     0,   440,   441,   442,     0,   444,     0,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   458,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,     0,   509,   510,   511,
     512,   513,     0,   514,   515,   516,   517,   518,     0,   520,
     521,   522,   523,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,     0,
     539,   540,     0,   541,     0,   543,   544,   545,   546,   547,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,   565,   566,   567,   568,     0,     0,   569,
     570,   571,   572,   573,   574,   575,     0,   576,     0,   578,
     579,   580,   581,     0,     0,   582,     0,     0,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   610,     0,
       0,     0,     0,     0,     0,     0,   731,     0,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,     0,   243,   244,   245,
       0,   247,   248,   249,   250,   251,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,     0,
       0,     0,   272,   273,   274,   275,   276,     0,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,     0,
     288,   289,   290,     0,     0,     0,     0,     0,     0,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,   314,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,     0,
     333,     0,   334,   335,   336,   337,     0,   338,     0,   339,
       0,     0,     0,   342,   343,   344,   345,     0,   346,   347,
       0,   348,   349,   350,     0,   351,   352,   353,   354,   355,
       0,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,     0,   370,   371,   372,   373,
     374,   375,   376,     0,   377,     0,   378,     0,     0,   381,
       0,   383,   384,   385,   386,   387,     0,     0,   388,   389,
       0,   391,     0,     0,   393,   394,   395,     0,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,     0,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,     0,   428,     0,   429,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,     0,     0,
     440,   441,   442,     0,   444,     0,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     458,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
       0,   514,   515,   516,   517,   518,     0,   520,   521,   522,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,     0,   539,   540,
       0,   541,     0,   543,   544,   545,   546,   547,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,   561,   562,   563,     0,     0,
     564,   565,   566,   567,   568,     0,     0,   569,   570,   571,
     572,   573,   574,   575,     0,   576,     0,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   610,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   230,   231,   232,   233,   234,   235,   236,
     237,     0,   238,   239,   240,     0,     0,     0,     0,     0,
    4173,     0,   241,   242,     0,   243,   244,   245,     0,   247,
     248,   249,   250,   251,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,     0,     0,     0,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
     281,   282,   283,   284,   285,   286,     0,     0,   288,   289,
     290,     0,     0,     0,     0,     0,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   309,   310,
     311,     0,     0,   312,   313,   314,   315,   316,     0,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,     0,   333,     0,
     334,   335,   336,   337,     0,   338,     0,   339,     0,     0,
       0,   342,   343,   344,   345,     0,   346,   347,     0,   348,
     349,   350,     0,   351,   352,   353,   354,   355,     0,   357,
     358,   359,   360,     0,   361,   362,   363,   364,   365,   366,
     367,     0,   368,     0,   370,   371,   372,   373,   374,   375,
     376,     0,   377,     0,   378,     0,     0,   381,     0,   383,
     384,   385,   386,   387,     0,     0,   388,   389,     0,   391,
       0,     0,   393,   394,   395,     0,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,     0,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,     0,
     428,     0,   429,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,     0,     0,   440,   441,
     442,     0,   444,     0,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   458,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,     0,   509,   510,   511,   512,   513,     0,   514,
     515,   516,   517,   518,     0,   520,   521,   522,   523,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,     0,   539,   540,     0,   541,
       0,   543,   544,   545,   546,   547,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,   561,   562,   563,     0,     0,   564,   565,
     566,   567,   568,     0,     0,   569,   570,   571,   572,   573,
     574,   575,     0,   576,     0,   578,   579,   580,   581,     0,
       0,   582,     0,     0,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   610,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   230,   231,   232,   233,   234,   235,   236,   237,     0,
     238,   239,   240,     0,     0,     0,     0,     0,  4187,     0,
     241,   242,     0,   243,   244,   245,     0,   247,   248,   249,
     250,   251,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,     0,     0,     0,   272,   273,
     274,   275,   276,     0,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,     0,     0,   288,   289,   290,     0,
       0,     0,     0,     0,     0,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,   314,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,     0,   333,     0,   334,   335,
     336,   337,     0,   338,     0,   339,     0,     0,     0,   342,
     343,   344,   345,     0,   346,   347,     0,   348,   349,   350,
       0,   351,   352,   353,   354,   355,     0,   357,   358,   359,
     360,     0,   361,   362,   363,   364,   365,   366,   367,     0,
     368,     0,   370,   371,   372,   373,   374,   375,   376,     0,
     377,     0,   378,     0,     0,   381,     0,   383,   384,   385,
     386,   387,     0,     0,   388,   389,     0,   391,     0,     0,
     393,   394,   395,     0,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,     0,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,     0,   428,     0,
     429,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,     0,     0,   440,   441,   442,     0,
     444,     0,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   458,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
       0,   509,   510,   511,   512,   513,     0,   514,   515,   516,
     517,   518,     0,   520,   521,   522,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,     0,   539,   540,     0,   541,     0,   543,
     544,   545,   546,   547,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,   561,   562,   563,     0,     0,   564,   565,   566,   567,
     568,     0,     0,   569,   570,   571,   572,   573,   574,   575,
       0,   576,     0,   578,   579,   580,   581,     0,     0,   582,
       0,     0,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   610,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   230,
     231,   232,   233,   234,   235,   236,   237,     0,   238,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
       0,   243,   244,   245,     0,   247,   248,   249,   250,   251,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,     0,     0,     0,   272,   273,   274,   275,
     276,     0,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,     0,   288,   289,   290,     0,     0,     0,
       0,     0,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,   314,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,     0,   333,     0,   334,   335,   336,   337,
       0,   338,     0,   339,     0,     0,     0,   342,   343,   344,
     345,     0,   346,   347,     0,   348,   349,   350,     0,   351,
     352,   353,   354,   355,     0,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,     0,
     370,   371,   372,   373,   374,   375,   376,     0,   377,     0,
     378,     0,     0,   381,     0,   383,   384,   385,   386,   387,
       0,     0,   388,   389,     0,   391,     0,     0,   393,   394,
     395,     0,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
       0,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,     0,   428,     0,   429,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,     0,     0,   440,   441,   442,     0,   444,     0,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   458,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,   513,     0,   514,   515,   516,   517,   518,
       0,   520,   521,   522,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,     0,   539,   540,     0,   541,     0,   543,   544,   545,
     546,   547,     0,   548,   549,   550,     0,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,   561,
     562,   563,     0,     0,   564,   565,   566,   567,   568,     0,
       0,   569,   570,   571,   572,   573,   574,   575,     0,   576,
       0,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     610,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   230,   231,   232,
     233,   234,   235,   236,   237,     0,   238,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,     0,   243,
     244,   245,     0,   247,   248,   249,   250,   251,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,     0,     0,     0,   272,   273,   274,   275,   276,     0,
     278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
       0,     0,   288,   289,   290,     0,     0,     0,     0,     0,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   309,   310,   311,     0,     0,   312,   313,   314,
     315,   316,     0,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,     0,   333,     0,   334,   335,   336,   337,     0,   338,
       0,   339,     0,     0,     0,   342,   343,   344,   345,     0,
     346,   347,     0,   348,   349,   350,     0,   351,   352,   353,
     354,   355,     0,   357,   358,   359,   360,     0,   361,   362,
     363,   364,   365,   366,   367,     0,   368,     0,   370,   371,
     372,   373,   374,   375,   376,     0,   377,     0,   378,     0,
       0,   381,     0,   383,   384,   385,   386,   387,     0,     0,
     388,   389,     0,   391,     0,     0,   393,   394,   395,     0,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,     0,   428,     0,   429,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
       0,     0,   440,   441,   442,     0,   444,     0,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   458,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,     0,   509,   510,   511,
     512,   513,     0,   514,   515,   516,   517,   518,     0,   520,
     521,   522,   523,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,     0,
     539,   540,     0,   541,     0,   543,   544,   545,   546,   547,
       0,   548,   549,   550,     0,     0,   769,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,   565,   566,   567,   568,     0,     0,   569,
     570,   571,   572,   573,   574,   575,     0,   576,     0,   578,
     579,   580,   581,     0,     0,   582,     0,     0,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   610,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,     0,   243,   244,   245,
       0,   247,   248,   249,   250,   251,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,     0,
       0,     0,   272,   273,   274,   275,   276,     0,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,     0,
     288,   289,   290,     0,     0,     0,     0,     0,     0,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,   314,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,     0,
     333,     0,   334,   335,   336,   337,     0,   338,     0,   339,
       0,     0,     0,   342,   343,   344,   345,     0,   346,   347,
       0,   348,   349,   350,     0,   351,   352,   353,   354,   355,
       0,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,     0,   370,   371,   372,   373,
     374,   375,   376,     0,   377,     0,   378,     0,     0,   381,
       0,   383,   384,   385,   386,   387,     0,     0,   388,   389,
       0,   391,     0,     0,   393,   394,   395,     0,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,     0,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,     0,   428,     0,   429,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,     0,     0,
     440,   441,   442,     0,   444,     0,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     458,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   781,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
       0,   514,   515,   516,   517,   518,     0,   520,   521,   522,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,     0,   539,   540,
       0,   541,     0,   543,   544,   545,   546,   547,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,   561,   562,   563,     0,     0,
     564,   565,   566,   567,   568,     0,     0,   569,   570,   571,
     572,   573,   574,   575,     0,   576,     0,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   610,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   230,   231,   232,   233,   234,   235,   236,
     237,     0,   238,   239,   240,     0,     0,     0,     0,     0,
       0,     0,   241,   242,     0,   243,   244,   245,     0,   247,
     248,   249,   250,   251,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   803,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,     0,     0,     0,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
     804,   282,   283,   284,   285,   286,     0,     0,   288,   289,
     290,     0,     0,     0,     0,     0,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   309,   310,
     311,     0,     0,   312,   313,   314,   315,   316,     0,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,     0,   333,     0,
     334,   335,   336,   337,     0,   338,     0,   339,     0,     0,
       0,   342,   343,   344,   345,     0,   346,   347,     0,   348,
     349,   350,     0,   351,   352,   353,   354,   355,     0,   357,
     358,   359,   360,     0,   361,   362,   363,   364,   365,   366,
     367,     0,   368,     0,   370,   371,   372,   373,   374,   375,
     376,     0,   377,     0,   378,     0,     0,   381,     0,   383,
     384,   385,   386,   387,     0,     0,   388,   389,     0,   391,
       0,     0,   393,   394,   805,     0,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   806,   412,     0,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,     0,
     428,     0,   429,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,     0,     0,   440,   441,
     442,     0,   444,     0,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   458,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,     0,   807,   495,   496,
     497,   498,   499,   500,   501,   502,   808,   504,   505,   506,
     507,   508,     0,   509,   510,   511,   512,   809,     0,   514,
     515,   516,   517,   518,     0,   520,   521,   522,   523,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,     0,   539,   540,     0,   541,
       0,   543,   544,   545,   546,   547,     0,   548,   810,   550,
       0,     0,   811,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,   561,   562,   563,     0,     0,   564,   565,
     566,   567,   568,     0,     0,   569,   570,   571,   572,   573,
     574,   575,     0,   576,     0,   578,   579,   580,   581,     0,
       0,   582,     0,     0,   583,   584,   585,   586,   587,   812,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   610,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   230,   231,   232,   233,   234,   235,   236,   237,     0,
     238,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,     0,   243,   244,   245,     0,   247,   248,   249,
     250,   251,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,     0,     0,     0,   272,   273,
     274,   275,   276,     0,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,     0,     0,   288,   289,   290,     0,
       0,     0,     0,     0,     0,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,   314,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,     0,   333,     0,   334,   335,
     336,   337,     0,   338,     0,   339,     0,     0,     0,   342,
     343,   344,   345,     0,   346,   347,     0,   348,   349,   350,
       0,   351,   352,   353,   354,   355,     0,   357,   358,   359,
     360,     0,   361,   362,   363,   364,   365,   366,   367,     0,
     368,     0,   370,   371,   372,   373,   374,   375,   376,     0,
     377,     0,   378,     0,     0,   381,     0,   383,   384,   385,
     386,   387,     0,     0,   388,   389,     0,   391,     0,     0,
     393,   394,   395,     0,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,     0,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,     0,   428,     0,
     429,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,     0,     0,   440,   441,   442,     0,
     444,     0,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   458,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   834,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
       0,   509,   510,   511,   512,   513,     0,   514,   515,   516,
     517,   518,     0,   520,   521,   522,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,     0,   539,   540,     0,   541,     0,   543,
     544,   545,   546,   547,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,   561,   562,   563,     0,     0,   564,   565,   566,   567,
     568,     0,     0,   569,   570,   571,   572,   573,   574,   575,
       0,   576,     0,   578,   579,   580,   581,     0,     0,   582,
       0,     0,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   610,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   230,
     231,   232,   233,   234,   235,   236,   237,     0,   238,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
       0,   243,   244,   245,     0,   247,   248,   249,   250,   251,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,     0,     0,     0,   272,   273,   274,   275,
     276,     0,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,     0,   288,   289,   290,     0,     0,     0,
       0,     0,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,   314,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,     0,   333,     0,   334,   335,   336,   337,
       0,   338,     0,   339,     0,     0,     0,   342,   343,   344,
     345,     0,   346,   347,     0,   348,   349,   350,     0,   351,
     352,   353,   354,   912,     0,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,     0,
     370,   371,   372,   373,   374,   375,   376,     0,   377,     0,
     378,     0,     0,   381,     0,   383,   384,   385,   386,   387,
       0,     0,   388,   389,     0,   391,     0,     0,   393,   394,
     395,     0,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
       0,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,     0,   428,     0,   429,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,     0,     0,   440,   441,   442,     0,   444,     0,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   458,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,   513,     0,   514,   515,   516,   517,   518,
       0,   520,   521,   522,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,     0,   539,   540,     0,   541,     0,   543,   544,   545,
     546,   547,     0,   548,   549,   550,     0,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,   561,
     562,   563,     0,     0,   564,   565,   566,   567,   568,     0,
       0,   569,   570,   571,   572,   573,   574,   575,     0,   576,
       0,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     610,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   230,   231,   232,
     233,   234,   235,   236,   237,     0,   238,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,     0,   243,
     244,   245,     0,   247,   248,   249,   250,   251,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,     0,     0,     0,   272,   273,   274,   275,   276,     0,
     278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
       0,     0,   288,   289,   290,     0,     0,     0,     0,     0,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   309,   310,   311,     0,     0,   312,   313,   314,
     315,   316,     0,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,     0,   333,     0,   334,   335,   336,   337,     0,   338,
       0,   339,     0,     0,     0,   342,   343,   344,   345,     0,
     346,   347,     0,   348,   349,   350,     0,   351,   352,   353,
     354,   922,     0,   357,   358,   359,   360,     0,   361,   362,
     363,   364,   365,   366,   367,     0,   368,     0,   370,   371,
     372,   373,   374,   375,   376,     0,   377,     0,   378,     0,
       0,   381,     0,   383,   384,   385,   386,   387,     0,     0,
     388,   389,     0,   391,     0,     0,   393,   394,   395,     0,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,     0,   428,     0,   429,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
       0,     0,   440,   441,   442,     0,   444,     0,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   458,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,     0,   509,   510,   511,
     512,   513,     0,   514,   515,   516,   517,   518,     0,   520,
     521,   522,   523,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,     0,
     539,   540,     0,   541,     0,   543,   544,   545,   546,   547,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,   565,   566,   567,   568,     0,     0,   569,
     570,   571,   572,   573,   574,   575,     0,   576,     0,   578,
     579,   580,   581,     0,     0,   582,     0,     0,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   610,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,     0,   243,   244,   245,
       0,   247,   248,   249,   250,   251,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,     0,
       0,     0,   272,   273,   274,   275,   276,     0,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,     0,
     288,   289,   290,     0,     0,     0,     0,     0,     0,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,   314,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,     0,
     333,     0,   334,   335,   336,   337,     0,   338,     0,   339,
       0,     0,     0,   342,   343,   344,   345,     0,   346,   347,
       0,   348,   349,   350,     0,   351,   352,   353,   354,   925,
       0,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,     0,   370,   371,   372,   373,
     374,   375,   376,     0,   377,     0,   378,     0,     0,   381,
       0,   383,   384,   385,   386,   387,     0,     0,   388,   389,
       0,   391,     0,     0,   393,   394,   395,     0,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,     0,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,     0,   428,     0,   429,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,     0,     0,
     440,   441,   442,     0,   444,     0,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     458,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
       0,   514,   515,   516,   517,   518,     0,   520,   521,   522,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,     0,   539,   540,
       0,   541,     0,   543,   544,   545,   546,   547,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,   561,   562,   563,     0,     0,
     564,   565,   566,   567,   568,     0,     0,   569,   570,   571,
     572,   573,   574,   575,     0,   576,     0,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   610,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   230,   231,   232,   233,   234,   235,   236,
     237,     0,   238,   239,   240,     0,     0,     0,     0,     0,
       0,     0,   241,   242,     0,   243,   244,   245,     0,   247,
     248,   249,   250,   251,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,     0,     0,     0,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
     281,   282,   283,   284,   285,   286,     0,     0,   288,   289,
     290,     0,     0,     0,     0,     0,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   309,   310,
     311,     0,     0,   312,   313,   314,   315,   316,     0,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,     0,   333,     0,
     334,   335,   336,   337,     0,   338,     0,   339,     0,     0,
       0,   342,   343,   344,   345,     0,   346,   347,     0,   348,
     349,   350,     0,   351,   352,   353,   354,   941,     0,   357,
     358,   359,   360,     0,   361,   362,   363,   364,   365,   366,
     367,     0,   368,     0,   370,   371,   372,   373,   374,   375,
     376,     0,   377,     0,   378,     0,     0,   381,     0,   383,
     384,   385,   386,   387,     0,     0,   388,   389,     0,   391,
       0,     0,   393,   394,   395,     0,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,     0,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,     0,
     428,     0,   429,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,     0,     0,   440,   441,
     442,     0,   444,     0,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   458,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,     0,   509,   510,   511,   512,   513,     0,   514,
     515,   516,   517,   518,     0,   520,   521,   522,   523,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,     0,   539,   540,     0,   541,
       0,   543,   544,   545,   546,   547,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,   561,   562,   563,     0,     0,   564,   565,
     566,   567,   568,     0,     0,   569,   570,   571,   572,   573,
     574,   575,     0,   576,     0,   578,   579,   580,   581,     0,
       0,   582,     0,     0,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   610,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   230,   231,   232,   233,   234,   235,   236,   237,     0,
     238,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,     0,   243,   244,   245,     0,   247,   248,   249,
     250,   251,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,     0,     0,     0,   272,   273,
     274,   275,   276,     0,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,     0,     0,   288,   289,   290,     0,
       0,     0,     0,     0,     0,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,   314,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,     0,   333,     0,   334,   335,
     336,   337,     0,   338,     0,   339,     0,     0,     0,   342,
     343,   344,   345,     0,   346,   347,     0,   348,   349,   350,
       0,   351,   352,   353,   354,  1008,     0,   357,   358,   359,
     360,     0,   361,   362,   363,   364,   365,   366,   367,     0,
     368,     0,   370,   371,   372,   373,   374,   375,   376,     0,
     377,     0,   378,     0,     0,   381,     0,   383,   384,   385,
     386,   387,     0,     0,   388,   389,     0,   391,     0,     0,
     393,   394,   395,     0,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,     0,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,     0,   428,     0,
     429,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,     0,     0,   440,   441,   442,     0,
     444,     0,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   458,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
       0,   509,   510,   511,   512,   513,     0,   514,   515,   516,
     517,   518,     0,   520,   521,   522,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,     0,   539,   540,     0,   541,     0,   543,
     544,   545,   546,   547,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,   561,   562,   563,     0,     0,   564,   565,   566,   567,
     568,     0,     0,   569,   570,   571,   572,   573,   574,   575,
       0,   576,     0,   578,   579,   580,   581,     0,     0,   582,
       0,     0,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   610,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   230,
     231,   232,   233,   234,   235,   236,   237,     0,   238,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
       0,   243,   244,   245,     0,   247,   248,   249,   250,   251,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,     0,     0,     0,   272,   273,   274,   275,
     276,     0,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,     0,   288,   289,   290,     0,     0,     0,
       0,     0,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,   314,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,     0,   333,     0,   334,   335,   336,   337,
       0,   338,     0,   339,     0,     0,     0,   342,   343,   344,
     345,     0,   346,   347,     0,   348,   349,   350,     0,   351,
     352,   353,   354,  1014,     0,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,     0,
     370,   371,   372,   373,   374,   375,   376,     0,   377,     0,
     378,     0,     0,   381,     0,   383,   384,   385,   386,   387,
       0,     0,   388,   389,     0,   391,     0,     0,   393,   394,
     395,     0,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
       0,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,     0,   428,     0,   429,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,     0,     0,   440,   441,   442,     0,   444,     0,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   458,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,   513,     0,   514,   515,   516,   517,   518,
       0,   520,   521,   522,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,     0,   539,   540,     0,   541,     0,   543,   544,   545,
     546,   547,     0,   548,   549,   550,     0,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,   561,
     562,   563,     0,     0,   564,   565,   566,   567,   568,     0,
       0,   569,   570,   571,   572,   573,   574,   575,     0,   576,
       0,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     610,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   230,   231,   232,
     233,   234,   235,   236,   237,     0,   238,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,     0,   243,
     244,   245,     0,   247,   248,   249,   250,   251,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,     0,     0,     0,   272,   273,   274,   275,   276,     0,
     278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
       0,     0,   288,   289,   290,     0,     0,     0,     0,     0,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   309,   310,   311,     0,     0,   312,   313,   314,
     315,   316,     0,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,     0,   333,     0,   334,   335,   336,   337,     0,   338,
       0,   339,     0,     0,     0,   342,   343,   344,   345,     0,
     346,   347,     0,   348,   349,   350,     0,   351,   352,   353,
     354,  1031,     0,   357,   358,   359,   360,     0,   361,   362,
     363,   364,   365,   366,   367,     0,   368,     0,   370,   371,
     372,   373,   374,   375,   376,     0,   377,     0,   378,     0,
       0,   381,     0,   383,   384,   385,   386,   387,     0,     0,
     388,   389,     0,   391,     0,     0,   393,   394,   395,     0,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,     0,   428,     0,   429,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
       0,     0,   440,   441,   442,     0,   444,     0,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   458,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,     0,   509,   510,   511,
     512,   513,     0,   514,   515,   516,   517,   518,     0,   520,
     521,   522,   523,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,     0,
     539,   540,     0,   541,     0,   543,   544,   545,   546,   547,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,   565,   566,   567,   568,     0,     0,   569,
     570,   571,   572,   573,   574,   575,     0,   576,     0,   578,
     579,   580,   581,     0,     0,   582,     0,     0,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   610,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,     0,   243,   244,   245,
       0,   247,   248,   249,   250,   251,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,     0,
       0,     0,   272,   273,   274,   275,   276,     0,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,     0,
     288,   289,   290,     0,     0,     0,     0,     0,     0,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,   314,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,     0,
     333,     0,   334,   335,   336,   337,     0,   338,     0,   339,
       0,     0,     0,   342,   343,   344,   345,     0,   346,   347,
       0,   348,   349,   350,     0,   351,   352,   353,   354,  1034,
       0,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,     0,   370,   371,   372,   373,
     374,   375,   376,     0,   377,     0,   378,     0,     0,   381,
       0,   383,   384,   385,   386,   387,     0,     0,   388,   389,
       0,   391,     0,     0,   393,   394,   395,     0,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,     0,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,     0,   428,     0,   429,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,     0,     0,
     440,   441,   442,     0,   444,     0,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     458,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
       0,   514,   515,   516,   517,   518,     0,   520,   521,   522,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,     0,   539,   540,
       0,   541,     0,   543,   544,   545,   546,   547,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,   561,   562,   563,     0,     0,
     564,   565,   566,   567,   568,     0,     0,   569,   570,   571,
     572,   573,   574,   575,     0,   576,     0,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   610,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   230,   231,   232,   233,   234,   235,   236,
     237,     0,   238,   239,   240,     0,     0,     0,     0,     0,
       0,     0,   241,   242,     0,   243,   244,   245,     0,   247,
     248,   249,   250,   251,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,     0,     0,     0,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
     281,   282,   283,   284,   285,   286,     0,     0,   288,   289,
     290,     0,     0,     0,     0,     0,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   309,   310,
     311,     0,     0,   312,   313,   314,   315,   316,     0,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,     0,   333,     0,
     334,   335,   336,   337,     0,   338,     0,   339,     0,     0,
       0,   342,   343,   344,   345,     0,   346,   347,     0,   348,
     349,   350,     0,   351,   352,   353,   354,  1036,     0,   357,
     358,   359,   360,     0,   361,   362,   363,   364,   365,   366,
     367,     0,   368,     0,   370,   371,   372,   373,   374,   375,
     376,     0,   377,     0,   378,     0,     0,   381,     0,   383,
     384,   385,   386,   387,     0,     0,   388,   389,     0,   391,
       0,     0,   393,   394,   395,     0,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,     0,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,     0,
     428,     0,   429,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,     0,     0,   440,   441,
     442,     0,   444,     0,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   458,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,     0,   509,   510,   511,   512,   513,     0,   514,
     515,   516,   517,   518,     0,   520,   521,   522,   523,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,     0,   539,   540,     0,   541,
       0,   543,   544,   545,   546,   547,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,   561,   562,   563,     0,     0,   564,   565,
     566,   567,   568,     0,     0,   569,   570,   571,   572,   573,
     574,   575,     0,   576,     0,   578,   579,   580,   581,     0,
       0,   582,     0,     0,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   610,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   230,   231,   232,   233,   234,   235,   236,   237,     0,
     238,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,     0,   243,   244,   245,     0,   247,   248,   249,
     250,   251,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,     0,     0,     0,   272,   273,
     274,   275,   276,     0,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,     0,     0,   288,   289,   290,     0,
       0,     0,     0,     0,     0,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,   314,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,     0,   333,     0,   334,   335,
     336,   337,     0,   338,     0,   339,     0,     0,     0,   342,
     343,   344,   345,     0,   346,   347,     0,   348,   349,   350,
       0,   351,   352,   353,   354,  1072,     0,   357,   358,   359,
     360,     0,   361,   362,   363,   364,   365,   366,   367,     0,
     368,     0,   370,   371,   372,   373,   374,   375,   376,     0,
     377,     0,   378,     0,     0,   381,     0,   383,   384,   385,
     386,   387,     0,     0,   388,   389,     0,   391,     0,     0,
     393,   394,   395,     0,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,     0,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,     0,   428,     0,
     429,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,     0,     0,   440,   441,   442,     0,
     444,     0,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   458,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
       0,   509,   510,   511,   512,   513,     0,   514,   515,   516,
     517,   518,     0,   520,   521,   522,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,     0,   539,   540,     0,   541,     0,   543,
     544,   545,   546,   547,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,   561,   562,   563,     0,     0,   564,   565,   566,   567,
     568,     0,     0,   569,   570,   571,   572,   573,   574,   575,
       0,   576,     0,   578,   579,   580,   581,     0,     0,   582,
       0,     0,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   610,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   230,
     231,   232,   233,   234,   235,   236,   237,     0,   238,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
       0,   243,   244,   245,     0,   247,   248,   249,   250,   251,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,     0,     0,     0,   272,   273,   274,   275,
     276,     0,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,     0,   288,   289,   290,     0,     0,     0,
       0,     0,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,   314,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,     0,   333,     0,   334,   335,   336,   337,
       0,   338,     0,   339,     0,     0,     0,   342,   343,   344,
     345,     0,   346,   347,     0,   348,   349,   350,     0,   351,
     352,   353,   354,  1136,     0,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,     0,
     370,   371,   372,   373,   374,   375,   376,     0,   377,     0,
     378,     0,     0,   381,     0,   383,   384,   385,   386,   387,
       0,     0,   388,   389,     0,   391,     0,     0,   393,   394,
     395,     0,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
       0,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,     0,   428,     0,   429,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,     0,     0,   440,   441,   442,     0,   444,     0,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   458,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,   513,     0,   514,   515,   516,   517,   518,
       0,   520,   521,   522,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,     0,   539,   540,     0,   541,     0,   543,   544,   545,
     546,   547,     0,   548,   549,   550,     0,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,   561,
     562,   563,     0,     0,   564,   565,   566,   567,   568,     0,
       0,   569,   570,   571,   572,   573,   574,   575,     0,   576,
       0,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     610,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   230,   231,   232,
     233,   234,   235,   236,   237,     0,   238,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,     0,   243,
     244,   245,     0,   247,   248,   249,   250,   251,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,     0,     0,     0,   272,   273,   274,   275,   276,     0,
     278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
       0,     0,   288,   289,   290,     0,     0,     0,     0,     0,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   309,   310,   311,     0,     0,   312,   313,   314,
     315,   316,     0,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,     0,   333,     0,   334,   335,   336,   337,     0,   338,
       0,   339,     0,     0,     0,   342,   343,   344,   345,     0,
     346,   347,     0,   348,   349,   350,     0,   351,   352,   353,
     354,  1138,     0,   357,   358,   359,   360,     0,   361,   362,
     363,   364,   365,   366,   367,     0,   368,     0,   370,   371,
     372,   373,   374,   375,   376,     0,   377,     0,   378,     0,
       0,   381,     0,   383,   384,   385,   386,   387,     0,     0,
     388,   389,     0,   391,     0,     0,   393,   394,   395,     0,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,     0,   428,     0,   429,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
       0,     0,   440,   441,   442,     0,   444,     0,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   458,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,     0,   509,   510,   511,
     512,   513,     0,   514,   515,   516,   517,   518,     0,   520,
     521,   522,   523,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,     0,
     539,   540,     0,   541,     0,   543,   544,   545,   546,   547,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,   565,   566,   567,   568,     0,     0,   569,
     570,   571,   572,   573,   574,   575,     0,   576,     0,   578,
     579,   580,   581,     0,     0,   582,     0,     0,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   610,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,     0,   243,   244,   245,
       0,   247,   248,   249,   250,   251,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,     0,
       0,     0,   272,   273,   274,   275,   276,     0,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,     0,
     288,   289,   290,     0,     0,     0,     0,     0,     0,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,   314,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,     0,
     333,     0,   334,   335,   336,   337,     0,   338,     0,   339,
       0,     0,     0,   342,   343,   344,   345,     0,   346,   347,
       0,   348,   349,   350,     0,   351,   352,   353,   354,  1148,
       0,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,     0,   370,   371,   372,   373,
     374,   375,   376,     0,   377,     0,   378,     0,     0,   381,
       0,   383,   384,   385,   386,   387,     0,     0,   388,   389,
       0,   391,     0,     0,   393,   394,   395,     0,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,     0,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,     0,   428,     0,   429,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,     0,     0,
     440,   441,   442,     0,   444,     0,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     458,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
       0,   514,   515,   516,   517,   518,     0,   520,   521,   522,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,     0,   539,   540,
       0,   541,     0,   543,   544,   545,   546,   547,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,   561,   562,   563,     0,     0,
     564,   565,   566,   567,   568,     0,     0,   569,   570,   571,
     572,   573,   574,   575,     0,   576,     0,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   610,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   230,   231,   232,   233,   234,   235,   236,
     237,     0,   238,   239,   240,     0,     0,     0,     0,     0,
       0,     0,   241,   242,     0,   243,   244,   245,     0,   247,
     248,   249,   250,   251,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,     0,     0,     0,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
     281,   282,   283,   284,   285,   286,     0,     0,   288,   289,
     290,     0,     0,     0,     0,     0,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   309,   310,
     311,     0,     0,   312,   313,   314,   315,   316,     0,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,     0,   333,     0,
     334,   335,   336,   337,     0,   338,     0,   339,     0,     0,
       0,   342,   343,   344,   345,     0,   346,   347,     0,   348,
     349,   350,     0,   351,   352,   353,   354,  1151,     0,   357,
     358,   359,   360,     0,   361,   362,   363,   364,   365,   366,
     367,     0,   368,     0,   370,   371,   372,   373,   374,   375,
     376,     0,   377,     0,   378,     0,     0,   381,     0,   383,
     384,   385,   386,   387,     0,     0,   388,   389,     0,   391,
       0,     0,   393,   394,   395,     0,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,     0,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,     0,
     428,     0,   429,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,     0,     0,   440,   441,
     442,     0,   444,     0,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   458,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,     0,   509,   510,   511,   512,   513,     0,   514,
     515,   516,   517,   518,     0,   520,   521,   522,   523,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,     0,   539,   540,     0,   541,
       0,   543,   544,   545,   546,   547,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,   561,   562,   563,     0,     0,   564,   565,
     566,   567,   568,     0,     0,   569,   570,   571,   572,   573,
     574,   575,     0,   576,     0,   578,   579,   580,   581,     0,
       0,   582,     0,     0,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   610,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   230,   231,   232,   233,   234,   235,   236,   237,     0,
     238,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,     0,   243,   244,   245,     0,   247,   248,   249,
     250,   251,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,     0,     0,     0,   272,   273,
     274,   275,   276,     0,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,     0,     0,   288,   289,   290,     0,
       0,     0,     0,     0,     0,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,   314,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,     0,   333,     0,   334,   335,
     336,   337,     0,   338,     0,   339,     0,     0,     0,   342,
     343,   344,   345,     0,   346,   347,     0,   348,   349,   350,
       0,   351,   352,   353,   354,  1154,     0,   357,   358,   359,
     360,     0,   361,   362,   363,   364,   365,   366,   367,     0,
     368,     0,   370,   371,   372,   373,   374,   375,   376,     0,
     377,     0,   378,     0,     0,   381,     0,   383,   384,   385,
     386,   387,     0,     0,   388,   389,     0,   391,     0,     0,
     393,   394,   395,     0,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,     0,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,     0,   428,     0,
     429,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,     0,     0,   440,   441,   442,     0,
     444,     0,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   458,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
       0,   509,   510,   511,   512,   513,     0,   514,   515,   516,
     517,   518,     0,   520,   521,   522,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,     0,   539,   540,     0,   541,     0,   543,
     544,   545,   546,   547,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,   561,   562,   563,     0,     0,   564,   565,   566,   567,
     568,     0,     0,   569,   570,   571,   572,   573,   574,   575,
       0,   576,     0,   578,   579,   580,   581,     0,     0,   582,
       0,     0,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   610,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   230,
     231,   232,   233,   234,   235,   236,   237,     0,   238,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
       0,   243,   244,   245,     0,   247,   248,   249,   250,   251,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   803,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,     0,     0,     0,   272,   273,   274,   275,
     276,     0,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,     0,   288,   289,   290,     0,     0,     0,
       0,     0,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,   314,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,     0,   333,     0,   334,   335,   336,   337,
       0,   338,     0,   339,     0,     0,     0,   342,   343,   344,
     345,     0,   346,   347,     0,   348,   349,   350,     0,   351,
     352,   353,   354,   355,     0,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,     0,
     370,   371,   372,   373,   374,   375,   376,     0,   377,     0,
     378,     0,     0,   381,     0,   383,   384,   385,   386,   387,
       0,     0,   388,   389,     0,   391,     0,     0,   393,   394,
     395,     0,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   806,   412,
       0,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,     0,   428,     0,   429,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,     0,     0,   440,   441,   442,     0,   444,     0,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   458,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,     0,   807,   495,   496,   497,   498,   499,   500,
     501,   502,   808,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,  1343,     0,   514,   515,   516,   517,   518,
       0,   520,   521,   522,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,     0,   539,   540,     0,   541,     0,   543,   544,   545,
     546,   547,     0,   548,   810,   550,     0,     0,   811,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,   561,
     562,   563,     0,     0,   564,   565,   566,   567,   568,     0,
       0,   569,   570,   571,   572,   573,   574,   575,     0,   576,
       0,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   812,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     610,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   230,   231,   232,
     233,   234,   235,   236,   237,     0,   238,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,     0,   243,
     244,   245,     0,   247,   248,   249,   250,   251,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,     0,     0,     0,   272,   273,   274,   275,   276,     0,
     278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
       0,     0,   288,   289,   290,     0,     0,     0,     0,     0,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   309,   310,   311,     0,     0,   312,   313,   314,
     315,   316,     0,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,     0,   333,     0,   334,   335,   336,   337,     0,   338,
       0,   339,     0,     0,     0,   342,   343,   344,   345,     0,
     346,   347,     0,   348,   349,   350,     0,   351,   352,   353,
     354,  1780,     0,   357,   358,   359,   360,     0,   361,   362,
     363,   364,   365,   366,   367,     0,   368,     0,   370,   371,
     372,   373,   374,   375,   376,     0,   377,     0,   378,     0,
       0,   381,     0,   383,   384,   385,   386,   387,     0,     0,
     388,   389,     0,   391,     0,     0,   393,   394,   395,     0,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,     0,   428,     0,   429,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
       0,     0,   440,   441,   442,     0,   444,     0,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   458,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,     0,   509,   510,   511,
     512,   513,     0,   514,   515,   516,   517,   518,     0,   520,
     521,   522,   523,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,     0,
     539,   540,     0,   541,     0,   543,   544,   545,   546,   547,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,   565,   566,   567,   568,     0,     0,   569,
     570,   571,   572,   573,   574,   575,     0,   576,     0,   578,
     579,   580,   581,     0,     0,   582,     0,     0,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   610,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,     0,   243,   244,   245,
       0,   247,   248,   249,   250,   251,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,     0,
       0,     0,   272,   273,   274,   275,   276,     0,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,     0,
     288,   289,   290,     0,     0,     0,     0,     0,     0,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,   314,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,     0,
     333,     0,   334,   335,   336,   337,     0,   338,     0,   339,
       0,     0,     0,   342,   343,   344,   345,     0,   346,   347,
       0,   348,   349,   350,     0,   351,   352,   353,   354,  1818,
       0,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,     0,   370,   371,   372,   373,
     374,   375,   376,     0,   377,     0,   378,     0,     0,   381,
       0,   383,   384,   385,   386,   387,     0,     0,   388,   389,
       0,   391,     0,     0,   393,   394,   395,     0,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,     0,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,     0,   428,     0,   429,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,     0,     0,
     440,   441,   442,     0,   444,     0,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     458,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
       0,   514,   515,   516,   517,   518,     0,   520,   521,   522,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,     0,   539,   540,
       0,   541,     0,   543,   544,   545,   546,   547,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,   561,   562,   563,     0,     0,
     564,   565,   566,   567,   568,     0,     0,   569,   570,   571,
     572,   573,   574,   575,     0,   576,     0,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   610,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   230,   231,   232,   233,   234,   235,   236,
     237,     0,   238,   239,   240,     0,     0,     0,     0,     0,
       0,     0,   241,   242,     0,   243,   244,   245,     0,   247,
     248,   249,   250,   251,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,     0,     0,     0,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
     281,   282,   283,   284,   285,   286,     0,     0,   288,   289,
     290,     0,     0,     0,     0,     0,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   309,   310,
     311,     0,     0,   312,   313,   314,   315,   316,     0,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,     0,   333,     0,
     334,   335,   336,   337,     0,   338,     0,   339,     0,     0,
       0,   342,   343,   344,   345,     0,   346,   347,     0,   348,
     349,   350,     0,   351,   352,   353,   354,  1820,     0,   357,
     358,   359,   360,     0,   361,   362,   363,   364,   365,   366,
     367,     0,   368,     0,   370,   371,   372,   373,   374,   375,
     376,     0,   377,     0,   378,     0,     0,   381,     0,   383,
     384,   385,   386,   387,     0,     0,   388,   389,     0,   391,
       0,     0,   393,   394,   395,     0,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,     0,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,     0,
     428,     0,   429,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,     0,     0,   440,   441,
     442,     0,   444,     0,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   458,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,     0,   509,   510,   511,   512,   513,     0,   514,
     515,   516,   517,   518,     0,   520,   521,   522,   523,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,     0,   539,   540,     0,   541,
       0,   543,   544,   545,   546,   547,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,   561,   562,   563,     0,     0,   564,   565,
     566,   567,   568,     0,     0,   569,   570,   571,   572,   573,
     574,   575,     0,   576,     0,   578,   579,   580,   581,     0,
       0,   582,     0,     0,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   610,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   230,   231,   232,   233,   234,   235,   236,   237,     0,
     238,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,     0,   243,   244,   245,     0,   247,   248,   249,
     250,   251,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,     0,     0,     0,   272,   273,
     274,   275,   276,     0,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,     0,     0,   288,   289,   290,     0,
       0,     0,     0,     0,     0,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,   314,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,     0,   333,     0,   334,   335,
     336,   337,     0,   338,     0,   339,     0,     0,     0,   342,
     343,   344,   345,     0,   346,   347,     0,   348,   349,   350,
       0,   351,   352,   353,   354,  1891,     0,   357,   358,   359,
     360,     0,   361,   362,   363,   364,   365,   366,   367,     0,
     368,     0,   370,   371,   372,   373,   374,   375,   376,     0,
     377,     0,   378,     0,     0,   381,     0,   383,   384,   385,
     386,   387,     0,     0,   388,   389,     0,   391,     0,     0,
     393,   394,   395,     0,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,     0,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,     0,   428,     0,
     429,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,     0,     0,   440,   441,   442,     0,
     444,     0,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   458,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
       0,   509,   510,   511,   512,   513,     0,   514,   515,   516,
     517,   518,     0,   520,   521,   522,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,     0,   539,   540,     0,   541,     0,   543,
     544,   545,   546,   547,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,   561,   562,   563,     0,     0,   564,   565,   566,   567,
     568,     0,     0,   569,   570,   571,   572,   573,   574,   575,
       0,   576,     0,   578,   579,   580,   581,     0,     0,   582,
       0,     0,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   610,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   230,
     231,   232,   233,   234,   235,   236,   237,     0,   238,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
       0,   243,   244,   245,     0,   247,   248,   249,   250,   251,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,     0,     0,     0,   272,   273,   274,   275,
     276,     0,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,     0,   288,   289,   290,     0,     0,     0,
       0,     0,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,   314,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,     0,   333,     0,   334,   335,   336,   337,
       0,   338,     0,   339,     0,     0,     0,   342,   343,   344,
     345,     0,   346,   347,     0,   348,   349,   350,     0,   351,
     352,   353,   354,  1893,     0,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,     0,
     370,   371,   372,   373,   374,   375,   376,     0,   377,     0,
     378,     0,     0,   381,     0,   383,   384,   385,   386,   387,
       0,     0,   388,   389,     0,   391,     0,     0,   393,   394,
     395,     0,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
       0,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,     0,   428,     0,   429,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,     0,     0,   440,   441,   442,     0,   444,     0,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   458,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,   513,     0,   514,   515,   516,   517,   518,
       0,   520,   521,   522,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,     0,   539,   540,     0,   541,     0,   543,   544,   545,
     546,   547,     0,   548,   549,   550,     0,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,   561,
     562,   563,     0,     0,   564,   565,   566,   567,   568,     0,
       0,   569,   570,   571,   572,   573,   574,   575,     0,   576,
       0,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     610,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   230,   231,   232,
     233,   234,   235,   236,   237,     0,   238,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,     0,   243,
     244,   245,     0,   247,   248,   249,   250,   251,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,     0,     0,     0,   272,   273,   274,   275,   276,     0,
     278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
       0,     0,   288,   289,   290,     0,     0,     0,     0,     0,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   309,   310,   311,     0,     0,   312,   313,   314,
     315,   316,     0,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,     0,   333,     0,   334,   335,   336,   337,     0,   338,
       0,   339,     0,     0,     0,   342,   343,   344,   345,     0,
     346,   347,     0,   348,   349,   350,     0,   351,   352,   353,
     354,  1895,     0,   357,   358,   359,   360,     0,   361,   362,
     363,   364,   365,   366,   367,     0,   368,     0,   370,   371,
     372,   373,   374,   375,   376,     0,   377,     0,   378,     0,
       0,   381,     0,   383,   384,   385,   386,   387,     0,     0,
     388,   389,     0,   391,     0,     0,   393,   394,   395,     0,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,     0,   428,     0,   429,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
       0,     0,   440,   441,   442,     0,   444,     0,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   458,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,     0,   509,   510,   511,
     512,   513,     0,   514,   515,   516,   517,   518,     0,   520,
     521,   522,   523,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,     0,
     539,   540,     0,   541,     0,   543,   544,   545,   546,   547,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,   565,   566,   567,   568,     0,     0,   569,
     570,   571,   572,   573,   574,   575,     0,   576,     0,   578,
     579,   580,   581,     0,     0,   582,     0,     0,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   610,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,     0,   243,   244,   245,
       0,   247,   248,   249,   250,   251,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,     0,
       0,     0,   272,   273,   274,   275,   276,     0,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,     0,
     288,   289,   290,     0,     0,     0,     0,     0,     0,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,   314,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,     0,
     333,     0,   334,   335,   336,   337,     0,   338,     0,   339,
       0,     0,     0,   342,   343,   344,   345,     0,   346,   347,
       0,   348,   349,   350,     0,   351,   352,   353,   354,   355,
       0,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,     0,   370,   371,   372,   373,
     374,   375,   376,     0,   377,     0,   378,     0,     0,   381,
       0,   383,   384,   385,   386,   387,     0,     0,   388,   389,
       0,   391,     0,     0,   393,   394,   395,     0,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,     0,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,     0,   428,     0,   429,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,     0,     0,
     440,   441,   442,     0,   444,     0,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     458,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,     0,   494,
     495,   496,   497,   498,   499,   500,   501,  2000,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
       0,   514,   515,   516,   517,   518,     0,   520,   521,   522,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,     0,   539,   540,
       0,   541,     0,   543,   544,   545,   546,   547,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,   561,   562,   563,     0,     0,
     564,   565,   566,   567,   568,     0,     0,   569,   570,   571,
     572,   573,   574,   575,     0,   576,     0,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   610,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   230,   231,   232,   233,   234,   235,   236,
     237,     0,   238,   239,   240,     0,     0,     0,     0,     0,
    2180,     0,   241,   242,     0,   243,   244,   245,     0,   247,
     248,   249,   250,   251,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,     0,     0,     0,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
     281,   282,   283,   284,   285,   286,     0,     0,   288,   289,
     290,     0,     0,     0,     0,     0,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   309,   310,
     311,     0,     0,   312,   313,   314,   315,   316,     0,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,     0,   333,     0,
     334,   335,   336,   337,     0,   338,     0,   339,     0,     0,
       0,   342,   343,   344,   345,     0,   346,   347,     0,   348,
     349,   350,     0,   351,   352,   353,   354,   355,     0,   357,
     358,   359,   360,     0,   361,   362,   363,   364,   365,   366,
     367,     0,   368,     0,   370,   371,   372,   373,   374,   375,
     376,     0,   377,     0,   378,     0,     0,   381,     0,   383,
     384,   385,   386,   387,     0,     0,   388,   389,     0,   391,
       0,     0,   393,   394,   395,     0,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,     0,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,     0,
     428,     0,   429,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,     0,     0,   440,   441,
     442,     0,   444,     0,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   458,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,     0,   509,   510,   511,   512,   513,     0,     0,
     515,   516,   517,   518,     0,   520,   521,   522,   523,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,     0,   539,   540,     0,   541,
       0,   543,   544,   545,   546,   547,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,   561,   562,   563,     0,     0,   564,   565,
     566,   567,   568,     0,     0,   569,   570,   571,   572,   573,
     574,   575,     0,   576,     0,   578,   579,   580,   581,     0,
       0,   582,     0,     0,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   610,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   230,   231,   232,   233,   234,   235,   236,   237,     0,
     238,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,     0,   243,   244,   245,     0,   247,   248,   249,
     250,   251,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   803,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,     0,     0,     0,   272,   273,
     274,   275,   276,     0,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,     0,     0,   288,   289,   290,     0,
       0,     0,     0,     0,     0,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,   314,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,     0,   333,     0,   334,   335,
     336,   337,     0,   338,     0,   339,     0,     0,     0,   342,
     343,   344,   345,     0,   346,   347,     0,   348,   349,   350,
       0,   351,   352,   353,   354,   355,     0,   357,   358,   359,
     360,     0,   361,   362,   363,   364,   365,   366,   367,     0,
     368,     0,   370,   371,   372,   373,   374,   375,   376,     0,
     377,     0,   378,     0,     0,   381,     0,   383,   384,   385,
     386,   387,     0,     0,   388,   389,     0,   391,     0,     0,
     393,   394,   395,     0,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     806,   412,     0,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,     0,   428,     0,
     429,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,     0,     0,   440,   441,   442,     0,
     444,     0,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   458,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,     0,   807,   495,   496,   497,   498,
     499,   500,   501,   502,   808,   504,   505,   506,   507,   508,
       0,   509,   510,   511,   512,  1343,     0,   514,   515,   516,
     517,   518,     0,   520,   521,   522,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,     0,   539,   540,     0,   541,     0,  2214,
     544,   545,   546,   547,     0,   548,   810,   550,     0,     0,
     811,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,   561,   562,   563,     0,     0,   564,   565,   566,   567,
     568,     0,     0,   569,   570,   571,   572,   573,   574,   575,
       0,   576,     0,   578,   579,   580,   581,     0,     0,   582,
       0,     0,   583,   584,   585,   586,   587,   812,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   610,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   230,
     231,   232,   233,   234,   235,   236,   237,     0,   238,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
       0,   243,   244,   245,     0,   247,   248,   249,   250,   251,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   803,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,     0,     0,     0,   272,   273,   274,   275,
     276,     0,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,     0,   288,   289,   290,     0,     0,     0,
       0,     0,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,   314,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,     0,   333,     0,   334,   335,   336,   337,
       0,   338,     0,   339,     0,     0,     0,   342,   343,   344,
     345,     0,   346,   347,     0,   348,   349,   350,     0,   351,
     352,   353,   354,   355,     0,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,     0,
     370,   371,   372,   373,   374,   375,   376,     0,   377,     0,
     378,     0,     0,   381,     0,   383,   384,   385,   386,   387,
       0,     0,   388,   389,     0,   391,     0,     0,   393,   394,
     395,     0,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   806,   412,
       0,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,     0,   428,     0,   429,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,     0,     0,   440,   441,   442,     0,   444,     0,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   458,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,     0,   807,   495,   496,   497,   498,   499,   500,
     501,   502,  2290,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,  2291,     0,   514,   515,   516,   517,   518,
       0,   520,   521,   522,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,     0,   539,   540,     0,   541,     0,   543,   544,   545,
     546,   547,     0,   548,   810,   550,     0,     0,  2292,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,   561,
     562,   563,     0,     0,   564,   565,   566,   567,   568,     0,
       0,   569,   570,   571,   572,   573,   574,   575,     0,   576,
       0,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   812,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     610,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   230,   231,   232,
     233,   234,   235,   236,   237,     0,   238,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,     0,   243,
     244,   245,     0,   247,   248,   249,   250,   251,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     803,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,     0,     0,     0,   272,   273,   274,   275,   276,     0,
     278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
       0,     0,   288,   289,   290,     0,     0,     0,     0,     0,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   309,   310,   311,     0,     0,   312,   313,   314,
     315,   316,     0,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,     0,   333,     0,   334,   335,   336,   337,     0,   338,
       0,   339,     0,     0,     0,   342,   343,   344,   345,     0,
     346,   347,     0,   348,   349,   350,     0,   351,   352,   353,
     354,   355,     0,   357,   358,   359,   360,     0,   361,   362,
     363,   364,   365,   366,   367,     0,   368,     0,   370,   371,
     372,   373,   374,   375,   376,     0,   377,     0,   378,     0,
       0,   381,     0,   383,   384,   385,   386,   387,     0,     0,
     388,   389,     0,   391,     0,     0,   393,   394,   395,     0,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   806,   412,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,     0,   428,     0,   429,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
       0,     0,   440,   441,   442,     0,   444,     0,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   458,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
       0,   807,   495,   496,   497,   498,   499,   500,   501,   502,
    2369,   504,   505,   506,   507,   508,     0,   509,   510,   511,
     512,  2291,     0,   514,   515,   516,   517,   518,     0,   520,
     521,   522,   523,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,     0,
     539,   540,     0,   541,     0,   543,   544,   545,   546,   547,
       0,   548,   810,   550,     0,     0,  2292,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,   565,   566,   567,   568,     0,     0,   569,
     570,   571,   572,   573,   574,   575,     0,   576,     0,   578,
     579,   580,   581,     0,     0,   582,     0,     0,   583,   584,
     585,   586,   587,   812,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   610,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,     0,   243,   244,   245,
       0,   247,   248,   249,   250,   251,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   803,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,     0,
       0,     0,   272,   273,   274,   275,   276,     0,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,     0,
     288,   289,   290,     0,     0,     0,     0,     0,     0,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,   314,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,     0,
     333,     0,   334,   335,   336,   337,     0,   338,     0,   339,
       0,     0,     0,   342,   343,   344,   345,     0,   346,   347,
       0,   348,   349,   350,     0,   351,   352,   353,   354,   355,
       0,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,     0,   370,   371,   372,   373,
     374,   375,   376,     0,   377,     0,   378,     0,     0,   381,
       0,   383,   384,   385,   386,   387,     0,     0,   388,   389,
       0,   391,     0,     0,   393,   394,   395,     0,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   806,   412,     0,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,     0,   428,     0,   429,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,     0,     0,
     440,   441,   442,     0,   444,     0,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     458,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,     0,   807,
     495,   496,   497,   498,   499,   500,   501,   502,  2386,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,  2291,
       0,   514,   515,   516,   517,   518,     0,   520,   521,   522,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,     0,   539,   540,
       0,   541,     0,   543,   544,   545,   546,   547,     0,   548,
     810,   550,     0,     0,  2292,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,   561,   562,   563,     0,     0,
     564,   565,   566,   567,   568,     0,     0,   569,   570,   571,
     572,   573,   574,   575,     0,   576,     0,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   812,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   610,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   230,   231,   232,   233,   234,   235,   236,
     237,     0,   238,   239,   240,     0,     0,     0,     0,     0,
       0,     0,   241,   242,     0,   243,   244,   245,     0,   247,
     248,   249,   250,   251,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,     0,     0,     0,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
     281,   282,   283,   284,   285,   286,     0,     0,   288,   289,
     290,     0,     0,     0,     0,     0,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   309,   310,
     311,     0,     0,   312,   313,   314,   315,   316,     0,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,     0,   333,     0,
     334,   335,   336,   337,     0,   338,     0,   339,     0,     0,
       0,   342,   343,   344,   345,     0,   346,   347,     0,   348,
     349,   350,     0,   351,   352,   353,   354,  2590,     0,   357,
     358,   359,   360,     0,   361,   362,   363,   364,   365,   366,
     367,     0,   368,     0,   370,   371,   372,   373,   374,   375,
     376,     0,   377,     0,   378,     0,     0,   381,     0,   383,
     384,   385,   386,   387,     0,     0,   388,   389,     0,   391,
       0,     0,   393,   394,   395,     0,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,     0,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,     0,
     428,     0,   429,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,     0,     0,   440,   441,
     442,     0,   444,     0,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   458,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,     0,   509,   510,   511,   512,   513,     0,   514,
     515,   516,   517,   518,     0,   520,   521,   522,   523,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,     0,   539,   540,     0,   541,
       0,   543,   544,   545,   546,   547,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,   561,   562,   563,     0,     0,   564,   565,
     566,   567,   568,     0,     0,   569,   570,   571,   572,   573,
     574,   575,     0,   576,     0,   578,   579,   580,   581,     0,
       0,   582,     0,     0,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   610,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   230,   231,   232,   233,   234,   235,   236,   237,     0,
     238,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,     0,   243,   244,   245,     0,   247,   248,   249,
     250,   251,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,     0,     0,     0,   272,   273,
     274,   275,   276,     0,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,     0,     0,   288,   289,   290,     0,
       0,     0,     0,     0,     0,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,   314,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,     0,   333,     0,   334,   335,
     336,   337,     0,   338,     0,   339,     0,     0,     0,   342,
     343,   344,   345,     0,   346,   347,     0,   348,   349,   350,
       0,   351,   352,   353,   354,  2594,     0,   357,   358,   359,
     360,     0,   361,   362,   363,   364,   365,   366,   367,     0,
     368,     0,   370,   371,   372,   373,   374,   375,   376,     0,
     377,     0,   378,     0,     0,   381,     0,   383,   384,   385,
     386,   387,     0,     0,   388,   389,     0,   391,     0,     0,
     393,   394,   395,     0,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,     0,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,     0,   428,     0,
     429,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,     0,     0,   440,   441,   442,     0,
     444,     0,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   458,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
       0,   509,   510,   511,   512,   513,     0,   514,   515,   516,
     517,   518,     0,   520,   521,   522,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,     0,   539,   540,     0,   541,     0,   543,
     544,   545,   546,   547,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,   561,   562,   563,     0,     0,   564,   565,   566,   567,
     568,     0,     0,   569,   570,   571,   572,   573,   574,   575,
       0,   576,     0,   578,   579,   580,   581,     0,     0,   582,
       0,     0,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   610,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   230,
     231,   232,   233,   234,   235,   236,   237,     0,   238,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
       0,   243,   244,   245,     0,   247,   248,   249,   250,   251,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,     0,     0,     0,   272,   273,   274,   275,
     276,     0,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,     0,   288,   289,   290,     0,     0,     0,
       0,     0,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,   314,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,     0,   333,     0,   334,   335,   336,   337,
       0,   338,     0,   339,     0,     0,     0,   342,   343,   344,
     345,     0,   346,   347,     0,   348,   349,   350,     0,   351,
     352,   353,   354,  2670,     0,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,     0,
     370,   371,   372,   373,   374,   375,   376,     0,   377,     0,
     378,     0,     0,   381,     0,   383,   384,   385,   386,   387,
       0,     0,   388,   389,     0,   391,     0,     0,   393,   394,
     395,     0,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
       0,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,     0,   428,     0,   429,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,     0,     0,   440,   441,   442,     0,   444,     0,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   458,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,   513,     0,   514,   515,   516,   517,   518,
       0,   520,   521,   522,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,     0,   539,   540,     0,   541,     0,   543,   544,   545,
     546,   547,     0,   548,   549,   550,     0,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,   561,
     562,   563,     0,     0,   564,   565,   566,   567,   568,     0,
       0,   569,   570,   571,   572,   573,   574,   575,     0,   576,
       0,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     610,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   230,   231,   232,
     233,   234,   235,   236,   237,     0,   238,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,     0,   243,
     244,   245,     0,   247,   248,   249,   250,   251,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,     0,     0,     0,   272,   273,   274,   275,   276,     0,
     278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
       0,     0,   288,   289,   290,     0,     0,     0,     0,     0,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   309,   310,   311,     0,     0,   312,   313,   314,
     315,   316,     0,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,     0,   333,     0,   334,   335,   336,   337,     0,   338,
       0,   339,     0,     0,     0,   342,   343,   344,   345,     0,
     346,   347,     0,   348,   349,   350,     0,   351,   352,   353,
     354,  2996,     0,   357,   358,   359,   360,     0,   361,   362,
     363,   364,   365,   366,   367,     0,   368,     0,   370,   371,
     372,   373,   374,   375,   376,     0,   377,     0,   378,     0,
       0,   381,     0,   383,   384,   385,   386,   387,     0,     0,
     388,   389,     0,   391,     0,     0,   393,   394,   395,     0,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,     0,   428,     0,   429,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
       0,     0,   440,   441,   442,     0,   444,     0,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   458,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,     0,   509,   510,   511,
     512,   513,     0,   514,   515,   516,   517,   518,     0,   520,
     521,   522,   523,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,     0,
     539,   540,     0,   541,     0,   543,   544,   545,   546,   547,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,   565,   566,   567,   568,     0,     0,   569,
     570,   571,   572,   573,   574,   575,     0,   576,     0,   578,
     579,   580,   581,     0,     0,   582,     0,     0,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   610,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,     0,   243,   244,   245,
       0,   247,   248,   249,   250,   251,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   803,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,     0,
       0,     0,   272,   273,   274,   275,   276,     0,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,     0,
     288,   289,   290,     0,     0,     0,     0,     0,     0,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,   314,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,     0,
     333,     0,   334,   335,   336,   337,     0,   338,     0,   339,
       0,     0,     0,   342,   343,   344,   345,     0,   346,   347,
       0,   348,   349,   350,     0,   351,   352,   353,   354,   355,
       0,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,     0,   370,   371,   372,   373,
     374,   375,   376,     0,   377,     0,   378,     0,     0,   381,
       0,   383,   384,   385,   386,   387,     0,     0,   388,   389,
       0,   391,     0,     0,   393,   394,   395,     0,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   806,   412,     0,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,     0,   428,     0,   429,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,     0,     0,
     440,   441,   442,     0,   444,     0,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     458,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,     0,   807,
     495,   496,   497,   498,   499,   500,   501,   502,   808,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,  2291,
       0,   514,   515,   516,   517,   518,     0,   520,   521,   522,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,     0,   539,   540,
       0,   541,     0,   543,   544,   545,   546,   547,     0,   548,
     810,   550,     0,     0,  2292,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,   561,   562,   563,     0,     0,
     564,   565,   566,   567,   568,     0,     0,   569,   570,   571,
     572,   573,   574,   575,     0,   576,     0,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   812,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   610,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   230,   231,   232,   233,   234,   235,   236,
     237,     0,   238,   239,   240,     0,     0,     0,     0,     0,
       0,     0,   241,   242,     0,   243,   244,   245,     0,   247,
     248,   249,   250,   251,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,     0,     0,     0,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
     281,   282,   283,   284,   285,   286,     0,     0,   288,   289,
     290,     0,     0,     0,     0,     0,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   309,   310,
     311,     0,     0,   312,   313,   314,   315,   316,     0,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,     0,   333,     0,
     334,   335,   336,   337,     0,   338,     0,   339,     0,     0,
       0,   342,   343,   344,   345,     0,   346,   347,     0,   348,
     349,   350,     0,   351,   352,   353,   354,  3065,     0,   357,
     358,   359,   360,     0,   361,   362,   363,   364,   365,   366,
     367,     0,   368,     0,   370,   371,   372,   373,   374,   375,
     376,     0,   377,     0,   378,     0,     0,   381,     0,   383,
     384,   385,   386,   387,     0,     0,   388,   389,     0,   391,
       0,     0,   393,   394,   395,     0,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,     0,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,     0,
     428,     0,   429,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,     0,     0,   440,   441,
     442,     0,   444,     0,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   458,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,     0,   509,   510,   511,   512,   513,     0,   514,
     515,   516,   517,   518,     0,   520,   521,   522,   523,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,     0,   539,   540,     0,   541,
       0,   543,   544,   545,   546,   547,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,   561,   562,   563,     0,     0,   564,   565,
     566,   567,   568,     0,     0,   569,   570,   571,   572,   573,
     574,   575,     0,   576,     0,   578,   579,   580,   581,     0,
       0,   582,     0,     0,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   610,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   230,   231,   232,   233,   234,   235,   236,   237,     0,
     238,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,     0,   243,   244,   245,     0,   247,   248,   249,
     250,   251,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,     0,     0,     0,   272,   273,
     274,   275,   276,     0,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,     0,     0,   288,   289,   290,     0,
       0,     0,     0,     0,     0,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,   314,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,     0,   333,     0,   334,   335,
     336,   337,     0,   338,     0,   339,     0,     0,     0,   342,
     343,   344,   345,     0,   346,   347,     0,   348,   349,   350,
       0,   351,   352,   353,   354,  3079,     0,   357,   358,   359,
     360,     0,   361,   362,   363,   364,   365,   366,   367,     0,
     368,     0,   370,   371,   372,   373,   374,   375,   376,     0,
     377,     0,   378,     0,     0,   381,     0,   383,   384,   385,
     386,   387,     0,     0,   388,   389,     0,   391,     0,     0,
     393,   394,   395,     0,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,     0,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,     0,   428,     0,
     429,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,     0,     0,   440,   441,   442,     0,
     444,     0,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   458,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
       0,   509,   510,   511,   512,   513,     0,   514,   515,   516,
     517,   518,     0,   520,   521,   522,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,     0,   539,   540,     0,   541,     0,   543,
     544,   545,   546,   547,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,   561,   562,   563,     0,     0,   564,   565,   566,   567,
     568,     0,     0,   569,   570,   571,   572,   573,   574,   575,
       0,   576,     0,   578,   579,   580,   581,     0,     0,   582,
       0,     0,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   610,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   230,
     231,   232,   233,   234,   235,   236,   237,     0,   238,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
       0,   243,   244,   245,     0,   247,   248,   249,   250,   251,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,     0,     0,     0,   272,   273,   274,   275,
     276,     0,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,     0,   288,   289,   290,     0,     0,     0,
       0,     0,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,   314,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,     0,   333,     0,   334,   335,   336,   337,
       0,   338,     0,   339,     0,     0,     0,   342,   343,   344,
     345,     0,   346,   347,     0,   348,   349,   350,     0,   351,
     352,   353,   354,  3081,     0,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,     0,
     370,   371,   372,   373,   374,   375,   376,     0,   377,     0,
     378,     0,     0,   381,     0,   383,   384,   385,   386,   387,
       0,     0,   388,   389,     0,   391,     0,     0,   393,   394,
     395,     0,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
       0,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,     0,   428,     0,   429,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,     0,     0,   440,   441,   442,     0,   444,     0,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   458,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,   513,     0,   514,   515,   516,   517,   518,
       0,   520,   521,   522,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,     0,   539,   540,     0,   541,     0,   543,   544,   545,
     546,   547,     0,   548,   549,   550,     0,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,   561,
     562,   563,     0,     0,   564,   565,   566,   567,   568,     0,
       0,   569,   570,   571,   572,   573,   574,   575,     0,   576,
       0,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     610,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   230,   231,   232,
     233,   234,   235,   236,   237,     0,   238,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,     0,   243,
     244,   245,     0,   247,   248,   249,   250,   251,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,     0,     0,     0,   272,   273,   274,   275,   276,     0,
     278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
       0,     0,   288,   289,   290,     0,     0,     0,     0,     0,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   309,   310,   311,     0,     0,   312,   313,   314,
     315,   316,     0,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,     0,   333,     0,   334,   335,   336,   337,     0,   338,
       0,   339,     0,     0,     0,   342,   343,   344,   345,     0,
     346,   347,     0,   348,   349,   350,     0,   351,   352,   353,
     354,  3226,     0,   357,   358,   359,   360,     0,   361,   362,
     363,   364,   365,   366,   367,     0,   368,     0,   370,   371,
     372,   373,   374,   375,   376,     0,   377,     0,   378,     0,
       0,   381,     0,   383,   384,   385,   386,   387,     0,     0,
     388,   389,     0,   391,     0,     0,   393,   394,   395,     0,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,     0,   428,     0,   429,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
       0,     0,   440,   441,   442,     0,   444,     0,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   458,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,     0,   509,   510,   511,
     512,   513,     0,   514,   515,   516,   517,   518,     0,   520,
     521,   522,   523,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,     0,
     539,   540,     0,   541,     0,   543,   544,   545,   546,   547,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,   565,   566,   567,   568,     0,     0,   569,
     570,   571,   572,   573,   574,   575,     0,   576,     0,   578,
     579,   580,   581,     0,     0,   582,     0,     0,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   610,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,     0,   243,   244,   245,
       0,   247,   248,   249,   250,   251,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,     0,
       0,     0,   272,   273,   274,   275,   276,     0,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,     0,
     288,   289,   290,     0,     0,     0,     0,     0,     0,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,  3264,   314,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,     0,
     333,     0,   334,   335,   336,   337,     0,   338,     0,   339,
       0,     0,     0,   342,   343,   344,   345,     0,   346,   347,
       0,   348,   349,   350,     0,   351,   352,   353,   354,   355,
       0,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,     0,   370,   371,   372,   373,
     374,   375,   376,     0,   377,     0,   378,     0,     0,   381,
       0,   383,   384,   385,   386,   387,     0,     0,   388,   389,
       0,   391,     0,     0,   393,   394,   395,     0,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,     0,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,     0,   428,     0,   429,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,     0,     0,
     440,   441,   442,     0,   444,     0,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     458,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
       0,   514,   515,   516,   517,   518,     0,   520,   521,   522,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,     0,   539,   540,
       0,   541,     0,   543,   544,   545,   546,   547,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,   561,   562,   563,     0,     0,
     564,   565,   566,   567,   568,     0,     0,   569,   570,   571,
     572,   573,   574,   575,     0,   576,     0,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   610,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   230,   231,   232,   233,   234,   235,   236,
     237,     0,   238,   239,   240,     0,     0,     0,     0,     0,
       0,     0,   241,   242,     0,   243,   244,   245,     0,   247,
     248,   249,   250,   251,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,     0,     0,     0,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
     281,   282,   283,   284,   285,   286,     0,     0,   288,   289,
     290,     0,     0,     0,     0,     0,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   309,   310,
     311,     0,     0,   312,   313,   314,   315,   316,     0,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,     0,   333,     0,
     334,   335,   336,   337,     0,   338,     0,   339,     0,     0,
       0,   342,   343,   344,   345,     0,   346,   347,     0,   348,
     349,   350,     0,   351,   352,   353,   354,  4447,     0,   357,
     358,   359,   360,     0,   361,   362,   363,   364,   365,   366,
     367,     0,   368,     0,   370,   371,   372,   373,   374,   375,
     376,     0,   377,     0,   378,     0,     0,   381,     0,   383,
     384,   385,   386,   387,     0,     0,   388,   389,     0,   391,
       0,     0,   393,   394,   395,     0,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,     0,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,     0,
     428,     0,   429,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,     0,     0,   440,   441,
     442,     0,   444,     0,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   458,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,     0,   509,   510,   511,   512,   513,     0,   514,
     515,   516,   517,   518,     0,   520,   521,   522,   523,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,     0,   539,   540,     0,   541,
       0,   543,   544,   545,   546,   547,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,   561,   562,   563,     0,     0,   564,   565,
     566,   567,   568,     0,     0,   569,   570,   571,   572,   573,
     574,   575,     0,   576,     0,   578,   579,   580,   581,     0,
       0,   582,     0,     0,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,  1074,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   230,   231,   232,   233,   234,   235,   236,   237,     0,
     238,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,     0,   243,   244,   245,   246,   247,   248,   249,
       0,  1075,   252,  1076,  1077,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,  1078,  1079,   265,     0,
     266,   267,   268,   269,     0,     0,   271,     0,   272,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,     0,   287,   288,   289,   290,     0,
       0,     0,   291,     0,     0,     0,   292,   293,   294,   295,
     296,   297,  1080,  1081,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,  1082,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,     0,
     328,   329,   330,   331,     0,     0,   333,     0,   334,   335,
    1083,   337,     0,   338,     0,   339,   340,     0,   341,   342,
     343,   344,   345,     0,   346,     0,     0,     0,   349,   350,
       0,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,  2187,   361,   362,   363,   364,   365,   366,   367,     0,
     368,   369,  2188,   371,   372,   373,   374,  1085,  1086,     0,
    1087,     0,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,     0,     0,   388,     0,   390,   391,   392,     0,
     393,   394,   395,     0,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,  1088,   413,  1089,   415,   416,   417,   418,   419,   420,
     421,     0,     0,   424,     0,   425,   426,   427,   428,     0,
       0,   430,  1090,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,     0,     0,   440,   441,  2190,   443,
     444,   445,     0,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,     0,   459,     0,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,  1091,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,   494,   495,   496,   497,   498,
       0,   500,   501,   502,   503,   504,   505,   506,   507,   508,
       0,   509,   510,   511,   512,   513,     0,   514,   515,  2191,
     517,   518,   519,   520,   521,  1093,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,     0,   538,     0,   539,   540,     0,   541,   542,   543,
     544,   545,   546,   547,     0,   548,  1094,  1095,     0,     0,
     551,   552,     0,   554,     0,     0,   556,   557,   558,   559,
     560,   561,   562,   563,     0,     0,   564,   565,   566,   567,
     568,     0,     0,   569,   570,   571,   572,   573,     0,  1096,
    2192,   576,   577,   578,   579,   580,   581,     0,     0,   582,
       0,     0,   583,   584,   585,   586,   587,   588,   610,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   600,
     601,   602,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,     0,   243,   244,   245,
       0,   247,   248,   249,   250,   251,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,     0,
       0,     0,   272,   273,   274,   275,   276,     0,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,     0,
     288,   289,   290,     0,     0,     0,     0,     0,     0,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,   314,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,     0,
     333,     0,   334,   335,   336,   337,     0,   338,     0,   339,
       0,     0,     0,   342,   343,   344,   345,     0,   346,   347,
       0,   348,     0,   350,     0,   351,   352,   353,   354,   355,
       0,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,     0,   370,   371,   372,   373,
     374,   375,   376,     0,   377,     0,   378,     0,     0,   381,
       0,   383,   384,   385,   386,   387,     0,     0,   388,   389,
       0,   391,     0,     0,   393,   394,   395,     0,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,     0,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,     0,   428,     0,   429,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,     0,     0,
     440,   441,   442,     0,   444,     0,   446,   447,   448,   449,
     450,   451,   452,     0,   454,   455,     0,     0,   456,   457,
     458,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,     0,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,     0,   494,
     495,   496,   497,   498,   499,     0,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
       0,   514,   515,   516,   517,   518,     0,   520,   521,   522,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,     0,   539,   540,
       0,   541,     0,   543,   544,   545,   546,   547,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,   561,   562,   563,     0,     0,
     564,   565,   566,   567,   568,     0,     0,   569,   570,   571,
     572,   573,   574,   575,     0,   576,     0,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,  1074,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   230,   231,   232,   233,   234,   235,   236,
     237,     0,   238,   239,   240,     0,     0,     0,     0,     0,
       0,     0,   241,   242,     0,   243,   244,   245,   246,   247,
     248,   249,     0,  1075,   252,  1076,  1077,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,  1078,  1079,
     265,     0,   266,   267,   268,   269,     0,     0,   271,     0,
     272,   273,   274,   275,   276,   277,   278,   279,   280,     0,
     281,   282,   283,   284,   285,   286,     0,   287,   288,   289,
     290,     0,     0,     0,   291,     0,     0,     0,   292,   293,
     294,   295,   296,   297,  1080,  1081,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   309,   310,
     311,     0,     0,   312,   313,  1082,   315,   316,     0,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,     0,   328,   329,   330,   331,     0,     0,   333,     0,
     334,   335,  1083,   337,     0,   338,     0,   339,   340,     0,
     341,   342,   343,   344,   345,     0,   346,     0,     0,     0,
     349,   350,     0,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,     0,   361,   362,   363,   364,   365,   366,
     367,     0,   368,   369,     0,   371,   372,   373,   374,  1085,
    1086,     0,  1087,     0,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,     0,     0,   388,     0,   390,   391,
     392,     0,   393,   394,   395,     0,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,  1088,   413,  1089,   415,   416,   417,   418,
     419,   420,   421,     0,     0,   424,     0,   425,   426,   427,
     428,  2286,     0,   430,  1090,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,     0,     0,   440,   441,
       0,   443,   444,   445,     0,   447,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   456,   457,     0,   459,
       0,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,  1091,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,   493,   494,   495,   496,
     497,   498,     0,   500,   501,   502,   503,   504,   505,   506,
     507,   508,     0,   509,   510,   511,   512,   513,     0,   514,
     515,  2191,   517,   518,   519,   520,   521,  1093,   523,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,     0,   538,     0,   539,   540,  3987,   541,
     542,   543,   544,   545,   546,   547,     0,   548,  1094,  1095,
       0,     0,   551,   552,     0,   554,     0,     0,   556,   557,
     558,   559,   560,   561,   562,   563,     0,     0,   564,   565,
     566,   567,   568,     0,     0,   569,   570,   571,   572,   573,
       0,  1096,     0,   576,   577,   578,   579,   580,   581,     0,
       0,   582,     0,     0,   583,   584,   585,   586,   587,   588,
    1074,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   600,   601,   602,     0,     0,     0,   230,   231,   232,
     233,   234,   235,   236,   237,     0,   238,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,     0,   243,
     244,   245,   246,   247,   248,   249,     0,  1075,   252,  1076,
    1077,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,  1078,  1079,   265,     0,   266,   267,   268,   269,
       0,     0,   271,     0,   272,   273,   274,   275,   276,   277,
     278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
       0,   287,   288,   289,   290,     0,     0,     0,   291,     0,
       0,     0,   292,   293,   294,   295,   296,   297,  1080,  1081,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   309,   310,   311,     0,     0,   312,   313,  1082,
     315,   316,     0,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,     0,   328,   329,   330,   331,
       0,     0,   333,     0,   334,   335,  1083,   337,     0,   338,
       0,   339,   340,     0,   341,   342,   343,   344,   345,     0,
     346,     0,     0,     0,   349,   350,     0,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,     0,   361,   362,
     363,   364,   365,   366,   367,     0,   368,   369,     0,   371,
     372,   373,   374,  1085,  1086,     0,  1087,     0,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,     0,     0,
     388,     0,   390,   391,   392,     0,   393,   394,   395,     0,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,  1088,   413,  1089,
     415,   416,   417,   418,   419,   420,   421,  2359,     0,   424,
       0,   425,   426,   427,   428,     0,     0,   430,  1090,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
       0,     0,   440,   441,     0,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     456,   457,     0,   459,     0,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,  1091,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
     493,   494,   495,   496,   497,   498,     0,   500,   501,   502,
     503,   504,   505,   506,   507,   508,     0,   509,   510,   511,
     512,   513,     0,   514,   515,  1092,   517,   518,   519,   520,
     521,  1093,   523,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,     0,   538,     0,
     539,   540,     0,   541,   542,   543,   544,   545,   546,   547,
       0,   548,  1094,  1095,     0,     0,   551,   552,     0,   554,
       0,     0,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,   565,   566,   567,   568,     0,     0,   569,
     570,   571,   572,   573,     0,  1096,     0,   576,   577,   578,
     579,   580,   581,     0,     0,   582,     0,     0,   583,   584,
     585,   586,   587,   588,  1074,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   600,   601,   602,     0,     0,
       0,   230,   231,   232,   233,   234,   235,   236,   237,     0,
     238,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,     0,   243,   244,   245,   246,   247,   248,   249,
       0,  1075,   252,  1076,  1077,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,  1078,  1079,   265,     0,
     266,   267,   268,   269,     0,     0,   271,     0,   272,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,     0,   287,   288,   289,   290,     0,
       0,     0,   291,     0,     0,     0,   292,   293,   294,   295,
     296,   297,  1080,  1081,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,  1082,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,     0,
     328,   329,   330,   331,     0,     0,   333,     0,   334,   335,
    1083,   337,     0,   338,     0,   339,   340,     0,   341,   342,
     343,   344,   345,     0,   346,     0,     0,     0,   349,   350,
       0,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,     0,   361,   362,   363,   364,   365,   366,   367,     0,
     368,   369,     0,   371,   372,   373,   374,  1085,  1086,     0,
    1087,     0,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,     0,     0,   388,     0,   390,   391,   392,     0,
     393,   394,   395,     0,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,  1088,   413,  1089,   415,   416,   417,   418,   419,   420,
     421,  3791,     0,   424,     0,   425,   426,   427,   428,     0,
       0,   430,  1090,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,     0,     0,   440,   441,     0,   443,
     444,   445,     0,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,     0,   459,     0,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,  1091,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,   494,   495,   496,   497,   498,
       0,   500,   501,   502,   503,   504,   505,   506,   507,   508,
       0,   509,   510,   511,   512,   513,     0,   514,   515,  1092,
     517,   518,   519,   520,   521,  1093,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,     0,   538,     0,   539,   540,     0,   541,   542,   543,
     544,   545,   546,   547,     0,   548,  1094,  1095,     0,     0,
     551,   552,     0,   554,     0,     0,   556,   557,   558,   559,
     560,   561,   562,   563,     0,     0,   564,   565,   566,   567,
     568,     0,     0,   569,   570,   571,   572,   573,     0,  1096,
       0,   576,   577,   578,   579,   580,   581,     0,     0,   582,
       0,     0,   583,   584,   585,   586,   587,   588,  1074,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   600,
     601,   602,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,     0,   243,   244,   245,
     246,   247,   248,   249,     0,  1075,   252,  1076,  1077,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
    1078,  1079,   265,     0,   266,   267,   268,   269,     0,     0,
     271,     0,   272,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,   287,
     288,   289,   290,     0,     0,     0,   291,     0,     0,     0,
     292,   293,   294,   295,   296,   297,  1080,  1081,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,  1082,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,     0,   328,   329,   330,   331,     0,     0,
     333,     0,   334,   335,  1083,   337,  5374,   338,     0,   339,
     340,     0,   341,   342,   343,   344,   345,     0,   346,     0,
       0,     0,   349,   350,     0,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,   369,     0,   371,   372,   373,
     374,  1085,  1086,     0,  1087,     0,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,     0,     0,   388,     0,
     390,   391,   392,     0,   393,   394,   395,     0,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,  1088,   413,  1089,   415,   416,
     417,   418,   419,   420,   421,     0,     0,   424,     0,   425,
     426,   427,   428,     0,     0,   430,  1090,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,     0,     0,
     440,   441,     0,   443,   444,   445,     0,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
       0,   459,     0,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,  1091,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,     0,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
       0,   514,   515,  1092,   517,   518,   519,   520,   521,  1093,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,     0,   538,     0,   539,   540,
       0,   541,   542,   543,   544,   545,   546,   547,     0,   548,
    1094,  1095,     0,     0,   551,   552,     0,   554,     0,     0,
     556,   557,   558,   559,   560,   561,   562,   563,     0,     0,
     564,   565,   566,   567,   568,     0,     0,   569,   570,   571,
     572,   573,     0,  1096,     0,   576,   577,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,  1074,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   600,   601,   602,     0,     0,     0,   230,
     231,   232,   233,   234,   235,   236,   237,     0,   238,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
       0,   243,   244,   245,   246,   247,   248,   249,     0,  1075,
     252,  1076,  1077,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,  1078,  1079,   265,     0,   266,   267,
     268,   269,     0,     0,   271,     0,   272,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,   287,   288,   289,   290,     0,     0,     0,
     291,     0,     0,     0,   292,   293,   294,   295,   296,   297,
    1080,  1081,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,  1082,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,     0,   328,   329,
     330,   331,     0,     0,   333,     0,   334,   335,  1083,   337,
       0,   338,     0,   339,   340,     0,   341,   342,   343,   344,
     345,     0,   346,     0,     0,     0,   349,   350,     0,   351,
     352,   353,   354,  1084,   356,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,   369,
       0,   371,   372,   373,   374,  1085,  1086,     0,  1087,     0,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
       0,     0,   388,     0,   390,   391,   392,     0,   393,   394,
     395,     0,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,  1088,
     413,  1089,   415,   416,   417,   418,   419,   420,   421,     0,
       0,   424,     0,   425,   426,   427,   428,     0,     0,   430,
    1090,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,     0,     0,   440,   441,     0,   443,   444,   445,
       0,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,     0,   459,     0,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,  1091,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,   494,   495,   496,   497,   498,     0,   500,
     501,   502,   503,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,   513,     0,   514,   515,  1092,   517,   518,
     519,   520,   521,  1093,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,     0,
     538,     0,   539,   540,     0,   541,   542,   543,   544,   545,
     546,   547,     0,   548,  1094,  1095,     0,     0,   551,   552,
       0,   554,     0,     0,   556,   557,   558,   559,   560,   561,
     562,   563,     0,     0,   564,   565,   566,   567,   568,     0,
       0,   569,   570,   571,   572,   573,     0,  1096,     0,   576,
     577,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   588,  1074,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   600,   601,   602,
       0,     0,     0,   230,   231,   232,   233,   234,   235,   236,
     237,     0,   238,   239,   240,     0,     0,     0,     0,     0,
       0,     0,   241,   242,     0,   243,   244,   245,   246,   247,
     248,   249,     0,  1075,   252,  1076,  1077,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,  1078,  1079,
     265,     0,   266,   267,   268,   269,     0,     0,   271,     0,
     272,   273,   274,   275,   276,   277,   278,   279,   280,     0,
     281,   282,   283,   284,   285,   286,     0,   287,   288,   289,
     290,     0,     0,     0,   291,     0,     0,     0,   292,   293,
     294,   295,   296,   297,  1080,  1081,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   309,   310,
     311,     0,     0,   312,   313,  1082,   315,   316,     0,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,     0,   328,   329,   330,   331,     0,     0,   333,     0,
     334,   335,  1083,   337,     0,   338,     0,   339,   340,     0,
     341,   342,   343,   344,   345,     0,   346,     0,     0,     0,
     349,   350,     0,   351,   352,   353,   354,  1142,   356,   357,
     358,   359,   360,     0,   361,   362,   363,   364,   365,   366,
     367,     0,   368,   369,     0,   371,   372,   373,   374,  1085,
    1086,     0,  1087,     0,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,     0,     0,   388,     0,   390,   391,
     392,     0,   393,   394,   395,     0,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,  1088,   413,  1089,   415,   416,   417,   418,
     419,   420,   421,     0,     0,   424,     0,   425,   426,   427,
     428,     0,     0,   430,  1090,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,     0,     0,   440,   441,
       0,   443,   444,   445,     0,   447,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   456,   457,     0,   459,
       0,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,  1091,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,   493,   494,   495,   496,
     497,   498,     0,   500,   501,   502,   503,   504,   505,   506,
     507,   508,     0,   509,   510,   511,   512,   513,     0,   514,
     515,  1092,   517,   518,   519,   520,   521,  1093,   523,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,     0,   538,     0,   539,   540,     0,   541,
     542,   543,   544,   545,   546,   547,     0,   548,  1094,  1095,
       0,     0,   551,   552,     0,   554,     0,     0,   556,   557,
     558,   559,   560,   561,   562,   563,     0,     0,   564,   565,
     566,   567,   568,     0,     0,   569,   570,   571,   572,   573,
       0,  1096,     0,   576,   577,   578,   579,   580,   581,     0,
       0,   582,     0,     0,   583,   584,   585,   586,   587,   588,
    1074,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   600,   601,   602,     0,     0,     0,   230,   231,   232,
     233,   234,   235,   236,   237,     0,   238,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,     0,   243,
     244,   245,   246,   247,   248,   249,     0,  1075,   252,  1076,
    1077,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,  1078,  1079,   265,     0,   266,   267,   268,   269,
       0,     0,   271,     0,   272,   273,   274,   275,   276,   277,
     278,   279,   280,     0,   281,   282,   283,   284,   285,   286,
       0,   287,   288,   289,   290,     0,     0,     0,   291,     0,
       0,     0,   292,   293,   294,   295,   296,   297,  1080,  1081,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   309,   310,   311,     0,     0,   312,   313,  1082,
     315,   316,     0,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,     0,   328,   329,   330,   331,
       0,     0,   333,     0,   334,   335,  1083,   337,     0,   338,
       0,   339,   340,     0,   341,   342,   343,   344,   345,     0,
     346,     0,     0,     0,   349,   350,     0,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,     0,   361,   362,
     363,   364,   365,   366,   367,     0,   368,   369,     0,   371,
     372,   373,   374,  1085,  1086,     0,  1087,     0,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,     0,     0,
     388,     0,   390,   391,   392,     0,   393,   394,   395,     0,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,  1088,   413,  1089,
     415,   416,   417,   418,   419,   420,   421,     0,     0,   424,
       0,   425,   426,   427,   428,     0,     0,   430,  1090,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
       0,     0,   440,   441,     0,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     456,   457,     0,   459,     0,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,  1091,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
     493,   494,   495,   496,   497,   498,     0,   500,   501,   502,
     503,   504,   505,   506,   507,   508,     0,   509,   510,   511,
     512,   513,     0,   514,   515,  1092,   517,   518,   519,   520,
     521,  1093,   523,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,     0,   538,     0,
     539,   540,     0,   541,   542,   543,   544,   545,   546,   547,
       0,   548,  1094,  1095,     0,     0,   551,   552,     0,   554,
       0,     0,   556,   557,   558,   559,   560,   561,   562,   563,
       0,     0,   564,   565,   566,   567,   568,     0,     0,   569,
     570,   571,   572,   573,     0,  1096,     0,   576,   577,   578,
     579,   580,   581,     0,     0,   582,     0,     0,   583,   584,
     585,   586,   587,   588,  1074,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   600,   601,   602,     0,     0,
       0,   230,   231,   232,   233,   234,   235,   236,   237,     0,
     238,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,     0,   243,   244,   245,   246,   247,   248,   249,
       0,  1075,   252,  1076,  1077,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,  1078,  1079,   265,     0,
     266,   267,   268,   269,     0,     0,   271,     0,   272,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   281,   282,
     283,   284,   285,   286,     0,   287,   288,   289,   290,     0,
       0,     0,   291,     0,     0,     0,   292,   293,   294,   295,
     296,   297,  1080,  1081,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   309,   310,   311,     0,
       0,   312,   313,  1082,   315,   316,     0,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,     0,
     328,   329,   330,   331,     0,     0,   333,     0,   334,   335,
    1083,   337,     0,   338,     0,   339,   340,     0,   341,   342,
     343,   344,   345,     0,   346,     0,     0,     0,   349,   350,
       0,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,     0,   361,   362,   363,   364,   365,   366,   367,     0,
     368,   369,     0,   371,   372,   373,   374,  1085,  1086,     0,
    1087,     0,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,     0,     0,   388,     0,   390,   391,   392,     0,
     393,   394,   395,     0,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,  1088,   413,  1089,   415,   416,   417,   418,   419,   420,
     421,     0,     0,   424,     0,   425,   426,   427,   428,     0,
       0,   430,  1090,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,     0,     0,   440,   441,     0,   443,
     444,   445,     0,   447,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   456,   457,     0,   459,     0,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,  1091,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,   494,   495,   496,   497,   498,
       0,   500,   501,   502,   503,   504,   505,   506,   507,   508,
       0,   509,   510,   511,   512,   513,     0,   514,   515,  2191,
     517,   518,   519,   520,   521,  1093,   523,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,     0,   538,     0,   539,   540,     0,   541,   542,   543,
     544,   545,   546,   547,     0,   548,  1094,  1095,     0,     0,
     551,   552,     0,   554,     0,     0,   556,   557,   558,   559,
     560,   561,   562,   563,     0,     0,   564,   565,   566,   567,
     568,     0,     0,   569,   570,   571,   572,   573,     0,  1096,
       0,   576,   577,   578,   579,   580,   581,     0,     0,   582,
       0,     0,   583,   584,   585,   586,   587,   588,  1074,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   600,
     601,   602,     0,     0,     0,   230,   231,   232,   233,   234,
     235,   236,   237,     0,   238,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,     0,   243,   244,   245,
     246,   247,   248,   249,     0,  1075,   252,  1076,  1077,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
    1078,  1079,   265,     0,   266,   267,   268,   269,     0,     0,
     271,     0,   272,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,   282,   283,   284,   285,   286,     0,   287,
     288,   289,   290,     0,     0,     0,   291,     0,     0,     0,
     292,   293,   294,   295,   296,   297,  1080,  1081,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     309,   310,   311,     0,     0,   312,   313,  1082,   315,   316,
       0,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,     0,   328,   329,   330,   331,     0,     0,
     333,     0,   334,   335,  1083,   337,     0,   338,     0,   339,
     340,     0,   341,   342,   343,   344,   345,     0,   346,     0,
       0,     0,   349,   350,     0,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,     0,   361,   362,   363,   364,
     365,   366,   367,     0,   368,   369,     0,   371,   372,   373,
     374,  1085,  1086,     0,  1087,     0,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,     0,     0,   388,     0,
     390,   391,   392,     0,   393,   394,   395,     0,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,  1088,   413,  1089,   415,   416,
     417,   418,   419,   420,   421,     0,     0,   424,     0,   425,
     426,   427,   428,     0,     0,   430,  1090,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,     0,     0,
     440,   441,     0,   443,   444,   445,     0,   447,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   456,   457,
       0,   459,     0,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,  1091,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,     0,   500,   501,   502,   503,   504,
     505,   506,   507,   508,     0,   509,   510,   511,   512,   513,
       0,   514,   515,     0,   517,   518,   519,   520,   521,  1093,
     523,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,     0,   538,     0,   539,   540,
       0,   541,   542,   543,   544,   545,   546,   547,     0,   548,
    1094,  1095,     0,     0,   551,   552,     0,   554,     0,     0,
     556,   557,   558,   559,   560,   561,   562,   563,     0,     0,
     564,   565,   566,   567,   568,     0,     0,   569,   570,   571,
     572,   573,     0,  1096,     0,   576,   577,   578,   579,   580,
     581,     0,     0,   582,     0,     0,   583,   584,   585,   586,
     587,   588,  1074,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   600,   601,   602,     0,     0,     0,   230,
     231,   232,   233,   234,   235,   236,   237,     0,   238,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
       0,   243,   244,   245,   246,   247,   248,   249,     0,     0,
     252,     0,     0,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,     0,     0,   265,     0,   266,   267,
     268,   269,     0,     0,   271,     0,   272,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,   282,   283,   284,
     285,   286,     0,   287,   288,   289,   290,     0,     0,     0,
     291,     0,     0,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   309,   310,   311,     0,     0,   312,
     313,   314,   315,   316,     0,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,     0,   328,   329,
     330,   331,     0,     0,   333,     0,   334,   335,     0,   337,
       0,   338,     0,   339,   340,     0,   341,   342,   343,   344,
     345,     0,   346,     0,     0,     0,   349,   350,     0,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,     0,
     361,   362,   363,   364,   365,   366,   367,     0,   368,   369,
       0,   371,   372,   373,   374,     0,     0,     0,     0,     0,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
       0,     0,   388,     0,   390,   391,   392,     0,   393,   394,
     395,     0,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,     0,
     413,     0,   415,   416,   417,   418,   419,   420,   421,     0,
       0,   424,     0,   425,   426,   427,   428,     0,     0,   430,
       0,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,     0,     0,   440,   441,     0,   443,   444,   445,
       0,   447,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   456,   457,     0,   459,     0,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,     0,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,   494,   495,   496,   497,   498,     0,   500,
     501,   502,   503,   504,   505,   506,   507,   508,     0,   509,
     510,   511,   512,   513,     0,   514,   515,     0,   517,   518,
     519,   520,   521,     0,   523,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,     0,
     538,     0,   539,   540,     0,   541,   542,   543,   544,   545,
     546,   547,     0,   548,     0,     0,     0,     0,   551,   552,
       0,   554,     0,     0,   556,   557,   558,   559,   560,   561,
     562,   563,     0,     0,   564,   565,   566,   567,   568,     0,
       0,   569,   570,   571,   572,   573,     0,     0,     0,   576,
     577,   578,   579,   580,   581,     0,     0,   582,     0,     0,
     583,   584,   585,   586,   587,   588,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   600,   601,   602
};

static const yytype_int16 yycheck[] =
{
       6,   622,   638,     8,   923,     0,     0,   622,    37,    52,
      15,   955,     0,  1575,   712,   951,   184,    23,  1165,    25,
     671,   890,    22,    29,   206,   206,    21,   804,    28,    35,
      36,    37,  1448,    39,   802,   853,    42,    43,   940,    45,
    1092,    47,   751,   752,   753,   864,   201,   924,   757,  1510,
    2530,  1122,  1494,   826,   209,   192,    13,   212,   949,  2602,
    1037,  1226,   694,  1095,    46,  1189,   827,   718,  2897,  2731,
      45,  1814,  1080,  1081,  1487,  1735,   708,   811,  1494,  3338,
    2947,  2358,  1090,  3357,  1987,    23,  2543,  3652,  3042,  3303,
    3683,   211,  1639,  2006,  3069,  2195,  2196,   629,   671,    37,
     780,  2443,  2095,   876,  3385,   225,  3095,  3388,  3097,  1011,
       0,   889,  1499,  1015,   923,    18,  2707,  3596,  1020,  3368,
    3735,  3292,  3626,   932,  3679,   717,   186,  2422,  1030,  3920,
     707,    21,  3976,   942,   186,  3448,   914,  3964,  2823,  3959,
    3770,   919,  1044,   171,   692,  1606,  1607,   695,   680,  2921,
    3632,  4604,     0,  2051,    51,  4485,   807,  4477,     0,  1477,
    1425,     0,  1026,     0,     0,     0,  1826,     0,  2028,     0,
      36,  1073,  3963,     0,  1917,  2160,  3355,    43,  1042,     0,
     831,     0,     0,     0,  4428,   958,   192,   193,   194,   195,
    2128,   197,    42,   844,  2956,   201,  2162,   203,  4756,  2850,
     206,  2139,   874,   209,  4833,  3557,   212,  4232,  4797,   215,
       6,   217,  4668,  1600,   220,   850,   850,    11,   224,  1537,
     226,    51,     0,     0,    44,  1372,    37,   833,  5012,  4620,
       0,  4622,  4476,  4031,   807,  3631,  1554,  3633,     6,  4116,
    1627,     0,   914,     0,     6,   220,  5036,   919,  1256,  1257,
    1078,  1079,    74,     6,  4710,  1287,  2533,  2489,    44,  2491,
      24,  1089,     6,  2495,    89,  2497,  2498,     6,     6,  1277,
      13,    15,    16,     0,  2506,  2507,  2508,    15,    16,    59,
       3,    28,     5,     6,    11,    59,     0,     6,    11,     6,
    4750,    41,  1111,     6,   166,  1004,  1165,    11,    15,    16,
      31,    28,     6,     6,     6,     6,   167,   114,     6,    81,
    4717,  4718,  4063,  4064,    28,  4066,  4067,  4068,  4069,  4070,
       6,   161,    13,   116,    76,  1637,  1638,   135,   109,   178,
      76,  1440,   183,     6,    86,     5,    31,     5,   107,     6,
      86,    11,   107,    11,  1169,   146,  4742,  3977,     3,   284,
       6,    42,    11,    34,   210,   116,  3044,   166,     6,   146,
     278,   298,   284,   273,  4913,    59,   294,    13,  2645,   133,
    2647,  1051,    59,   168,   273,   259,   284,   264,   167,   273,
      59,   279,   767,    74,   216,   766,   166,   107,   298,   166,
     106,   114,   114,   168,   366,  3683,   166,  5340,  5341,   298,
     325,   182,   279,    41,   298,   333,   366,   166,    59,   166,
     259,   200,  1389,   190,   168,    24,   114,  1245,  1246,  5203,
     190,    60,  5212,  1367,   267,   158,   215,   259,   150,    68,
     118,   190,   143,   190,   294,   360,   225,   158,   366,   166,
     114,   117,   441,    13,  1272,   349,   162,   394,   145,  5038,
      13,    38,   166,   214,   450,   441,   638,  4917,    88,   114,
     333,   183,   243,   190,  1355,   246,   278,  4642,   166,     6,
     395,    76,    42,    59,  4930,  4650,   190,   473,  4798,    42,
     196,    86,    13,   430,  1353,   280,   209,   161,   487,  1358,
    1359,   395,  4883,   366,    28,   192,  1147,  1129,   140,   220,
     130,    35,   263,  1372,    74,    28,   366,   689,   231,  1561,
     186,    74,    35,   338,  1165,    68,   636,   228,   443,   491,
      28,   254,   642,   211,   133,   241,   280,    35,   244,    76,
     373,   491,  1212,    86,  1307,   655,   123,   369,    76,   259,
     315,   263,   429,  5486,   929,  1489,    76,   928,   166,    59,
     487,  1157,   450,  5343,   343,    76,   491,    76,    59,   487,
     321,    76,  1335,  1195,  5113,   339,   488,   485,   369,   491,
     218,   489,   166,   353,  1147,  1167,   357,   487,   455,  1211,
    1231,  4977,   369,   491,  1409,   469,   435,   407,   487,   166,
     385,   144,   231,   487,   363,  1227,  1465,   429,   407,  3770,
     166,   268,   366,    86,   166,   336,  1475,   166,   263,   173,
     163,   617,   268,   268,  3302,   487,   436,   623,   349,   625,
     351,   627,  5211,   629,  3795,   631,   487,   622,   622,  5419,
     395,  5415,   638,   121,   622,   491,   487,   643,   446,   645,
     433,   336,   392,  5201,   440,   339,   652,   487,   395,   421,
     436,  5111,   339,   953,  1463,   407,  5116,   487,  1231,  4138,
     339,   407,   442,   485,  1773,   429,   491,   489,  1570,   476,
     676,  1573,  3931,  4177,   680,   718,   487,  4181,   320,   685,
    1544,   412,  1380,   689,  4166,   853,   692,   468,   339,   695,
    4567,   487,   486,  1562,   722,  5485,  1565,  1566,  3972,  1350,
    1306,  1637,  1638,  1639,  1581,   711,   487,  1358,  1359,   407,
    5030,  3686,  2989,   490,  3973,   618,  1525,   491,  5347,   487,
     490,  1372,   717,  4521,     3,   487,   407,     6,  1592,  4081,
     491,   490,   732,   490,   734,  5142,   736,  5527,    28,  3953,
     483,   746,   742,   487,  1635,  5334,   485,  1525,   487,   487,
     489,   478,   479,   339,   392,   478,   479,   763,   311,   716,
     766,   767,   768,   490,   478,   479,   452,  3452,   487,  4165,
     487,  4167,  1407,  1407,   487,   781,   490,  1350,   476,   452,
    2092,   841,   450,   487,   487,   487,   487,   473,   763,   841,
    4541,   489,   483,   975,   975,   801,   802,   491,   804,   805,
     473,   487,     3,   809,   491,   473,  3977,  1413,   478,   479,
     478,   479,   491,  1485,   487,   107,   971,   823,  5274,   478,
     479,   827,   977,   960,  1097,   980,  1644,   833,   718,   339,
     109,  5287,  5421,  1957,   480,   481,   482,   483,   339,   845,
     491,    27,   376,  4022,  1117,   487,   383,   384,   843,   843,
    1921,   857,   827,   376,  1127,   843,  5247,  4472,  1131,  2959,
     407,  2961,  1135,    68,  1137,  2307,  1538,   873,   376,   407,
    1143,   424,  3329,   491,  3525,  1883,  1149,   407,  1747,  1152,
    5210,  4906,   857,  1555,    85,   891,   407,  5207,   407,  2276,
     896,   897,   407,  1964,  3189,  5484,  1532,   491,   873,   108,
     766,   767,   768,   182,  1975,   491,  3881,    28,    22,  3671,
     480,   481,   482,   483,   491,   478,   479,   480,   481,   482,
     483,   166,   928,   929,   407,   491,  3880,   491,   487,   491,
     114,  2478,   109,  2793,  2794,  5391,   137,   834,  2798,   144,
    5184,  2926,  2207,   431,    24,   951,   952,   478,   479,   480,
     481,   482,   483,   843,   960,   805,   119,    83,   163,   809,
    5518,  2927,  5206,   194,   243,   971,  2353,   246,   147,   975,
     107,   977,  2910,   107,   980,  2835,  2836,    72,  2296,    49,
      59,   491,   168,   167,     6,   194,    36,    83,   190,   995,
     491,   166,  3269,  3270,   114,   843,   273,  4788,   119,   125,
       6,   843,  5455,  2901,   843,   182,   843,   843,   843,    83,
     843,  1017,   843,   303,  5344,  5335,   843,    24,  1024,  1025,
    2582,   298,   843,  3795,   843,   843,   843,   278,    83,   125,
    1858,  1859,   146,   234,   107,    83,  3268,   143,   178,    24,
    1046,  1047,  1048,    40,  1050,  3999,  1052,  1053,  1054,   395,
    4643,   125,   119,   133,   119,  4685,    59,   279,   202,   344,
     318,  2005,   928,   929,   114,   843,   243,   211,   133,   246,
     125,   361,    13,  2220,   349,  3942,   119,   125,   357,  4558,
     264,   225,    64,   204,   166,  3362,   333,   409,   866,   119,
     349,    26,   259,   294,   476,   337,   447,  5427,    32,    33,
      24,  5431,   208,   395,  2048,  4609,   311,   489,   190,   399,
    4614,   401,    47,  4617,  1823,   185,  1122,   298,  1124,  1125,
     190,   175,   381,  4605,   366,  1425,   133,    10,   313,   315,
      13,   453,     6,    74,    17,    18,    19,   204,   161,  2191,
     491,   487,   119,   263,   353,   430,   114,   163,   133,   259,
    2094,  1157,   171,  5483,   429,  1058,  2092,   227,   116,    93,
     407,   204,   407,  1169,   395,   351,   333,  1172,  4995,  1174,
     296,  1176,  1167,  1178,   204,  1180,  1181,  1182,   284,   113,
     357,   276,  1187,  1189,  1190,   394,   395,  2600,  1194,   468,
    1196,   188,  3292,  4467,  1169,  1972,  1973,   398,  5528,   400,
     296,  5359,  4461,  4994,  5048,  5032,  4519,   279,  5028,   133,
     487,  1217,   231,   147,   294,   114,  4497,  1223,  5548,   424,
    1226,  5551,   296,  1229,   410,  4474,  1924,   204,   450,   487,
     416,   476,   407,   353,   284,   349,   487,  1243,   359,     3,
    5031,   296,   126,   308,   489,  1851,   268,   431,   296,    97,
    2894,  4226,   136,   333,   169,   369,   259,  1889,   395,  2195,
     339,   395,   268,  1306,    51,  1963,   429,   446,  1274,  1967,
     205,  1903,  2045,  1971,   400,   282,  1974,   259,   487,  4268,
    1857,  1932,  3382,   178,  1916,    10,   366,    29,    13,   491,
     344,   468,    17,    18,    19,   435,  1302,  1303,  1304,   167,
    1306,   371,   487,  2947,   400,   279,   487,   190,   429,   294,
     268,   177,   335,  1845,  4602,    68,   359,   423,   105,   160,
    1326,    85,   395,    86,   292,   435,   400,   175,   353,   212,
     337,   338,  1392,  1393,   147,  1395,   339,  1914,  1886,  1931,
    1392,  1393,   116,  1395,  4029,   400,  5504,  1375,   333,  4904,
    1532,   114,   400,  1901,   434,  4643,  1904,   367,  1364,   366,
     353,   114,   429,   366,   259,   366,  1987,  4846,   450,   268,
     294,    24,  1987,    34,   138,  4879,   407,    30,   450,   243,
     399,   366,   401,   325,   349,   415,   429,   282,  1394,   182,
    2026,   359,  1398,  1399,   351,   329,  2173,   280,  2004,   429,
    2006,   316,  2382,  1409,  1410,  1411,  2012,  1413,   427,   333,
     294,   259,  2018,  2019,  2020,   487,   203,   170,  1966,  5034,
     108,  1969,  1970,  2029,  2030,   359,   476,   395,  2034,   297,
     310,  1437,   196,   348,  1409,   485,   293,   487,   488,   489,
     214,   491,   366,    28,    28,  3988,   361,   338,   407,   333,
     243,    51,   429,  4932,   320,   412,  3449,   395,  4937,  4938,
     491,   395,   487,   205,   171,   306,  1472,  4058,   118,   437,
    1770,  1477,   259,  2392,  1480,   366,   450,   487,  2129,  2459,
     133,   396,   450,   293,   350,   620,   147,  1493,  1494,   263,
     491,   116,   636,   357,   487,    95,  1502,  2306,   642,  1505,
     263,   443,   116,   437,   372,   473,   194,   441,   293,   366,
     263,   655,   147,  4787,  4685,   268,   450,    24,   117,   487,
     120,  4809,   487,    30,   231,   240,  1532,  2396,  1534,   409,
     310,  1537,   491,   240,   326,  2404,   300,   137,  2407,   473,
     435,   141,  2478,   128,   128,  4833,   359,   321,  1554,  5114,
    4799,  1557,   293,   487,  1560,   280,   404,  1460,   311,   161,
    4774,   211,   162,    28,   357,   165,   282,    37,   355,  2220,
     172,  2642,   278,   453,   327,  2439,  1582,   283,   294,   714,
     180,   366,   395,  2392,   198,  1399,    56,   186,   190,   214,
    1596,   474,   475,   476,  3507,   478,   479,   480,   481,   482,
     483,   375,  1608,  1609,  1610,  1611,  1612,    15,    16,  3171,
    3952,  2372,  2373,  3908,    79,  2376,    85,   333,  2427,  1892,
    1626,  1596,    87,   409,   437,   366,   133,  1900,  5221,   409,
      93,  1637,  1638,  1639,   217,  3867,   106,   450,   263,  3871,
    3872,   294,  3874,   237,   436,   259,  3059,  1920,  3943,   263,
     115,   128,  2461,   130,  2472,  2473,  2474,   126,   422,   106,
     473,   796,   156,   237,  2442,   353,   430,   136,   268,   433,
    3770,   424,  2304,   453,   487,  2539,  3536,  3537,  3538,  3539,
     333,  2213,  3542,  3543,  3544,  3545,  3546,  3547,  3548,  3549,
    3550,  3551,   399,  3436,   401,  3795,   321,   487,  2562,  2563,
    2564,  2565,  3249,  5268,  1841,   170,   394,   395,  3255,   172,
    2574,  2613,   128,   366,   130,  1897,  1898,  1898,   183,   319,
     427,   407,    24,   193,   359,   171,   442,   431,    30,  1735,
     195,  1737,  1887,   156,   228,  2599,  4013,   294,  4015,   117,
     342,  3601,  3602,  1749,  1750,  3648,   178,   284,   335,   474,
     475,   476,  5011,   478,   479,   480,   481,   482,   483,  2059,
     395,   351,   353,  1769,  4682,  5425,  5426,     0,  1546,  4744,
     156,   241,  5046,  1551,   244,   161,   333,  2538,   359,   353,
     337,   275,  1788,   487,   116,   231,   263,   294,  5037,   259,
     476,   382,  3529,  5081,   241,  5009,   273,   244,  1804,  1805,
    1806,  1807,   437,   489,   398,   228,  3193,  4725,   186,   366,
     294,  1817,  5026,   452,   395,   450,   431,    31,  1824,   356,
    1826,  3558,   412,   293,   398,   294,   333,   259,  2697,   161,
     325,   133,  1838,   427,   473,  1841,   294,  5430,   473,  1845,
     301,    55,   228,  1621,  2026,  1851,  2378,  1625,   349,   333,
     351,  3238,   487,   427,  2127,  5069,   437,   273,   452,   366,
     329,   321,   294,   450,   333,   360,   198,  4821,   338,  5529,
    2994,   329,   487,  4535,   334,   333,   337,  3977,   452,   325,
    1886,  1887,   216,  2592,   490,   450,   473,   359,   450,   275,
     360,  1897,  1898,   487,   162,  1901,   450,   366,  1904,    76,
     395,   333,   362,  3364,   491,   366,   487,  2207,   366,    86,
     380,   412,   399,   487,   401,  1921,  1922,   382,   431,   473,
     385,  5209,  1928,   395,  1930,   259,   491,   259,   196,   491,
    5204,   263,   450,  5221,  4923,  1941,  1931,   491,  1943,  5532,
    1945,  5222,  1947,   491,  1949,   294,  1951,  4427,   443,   190,
    1955,  1957,  2558,   399,  2605,   401,  5205,   156,  1964,  2967,
    1966,    34,   161,  1969,  1970,   437,  1972,  1973,  1997,  1975,
    4247,  4248,  5186,   491,   487,  4637,  1982,  4639,   450,  3623,
     263,   427,  3626,  1989,   333,   268,  4466,   321,  4817,  4446,
    1996,  1997,  1987,  1987,  2000,   237,  2694,   443,  2004,  1987,
    2006,   473,   399,   435,   401,  2011,  2012,  1982,   333,  2615,
    2661,   168,  2018,  2019,  2020,   487,   313,  2023,   488,  2025,
    2026,  2027,  2028,  2029,  2030,  2031,  2032,  3687,  2034,   228,
    2036,  2037,  2605,  2902,  2040,   369,   319,    13,  2338,  3683,
    3900,   366,  1932,   294,   201,  2725,  2726,  4271,   482,  2055,
    2056,  2057,  2058,   487,  4278,   489,  2062,  2063,  1996,  5347,
     301,  2067,   412,  2363,  2070,   294,    42,  2073,  2074,  2075,
    2076,  2077,  2078,  2079,  2080,  2081,   275,  2083,  2896,   294,
    2262,  2262,   333,  2089,  2090,   452,  2092,  5336,  2661,   450,
    5349,   161,   333,  2099,  1546,   429,   337,    45,    74,  1551,
    2003,   485,   337,   487,   333,  2260,   473,  5061,  2263,  2264,
     294,   353,   473,  5327,   184,   366,  2253,   166,   333,    67,
     487,  4416,  2128,   253,  2424,   366,   487,   143,   485,  2135,
     487,   366,   489,  2139,  2140,   370,  5424,   366,  2957,   161,
     156,   190,  5430,  5118,  2150,   161,  4975,   277,     3,   333,
    5017,   366,  2452,  2159,  2160,  4387,   398,  4389,  4390,   272,
    1792,  4393,   184,   143,   240,  2899,     5,  2173,  3045,  1621,
      25,  5420,    11,  1625,  2180,    26,   156,   169,   237,   161,
    3742,   161,   366,  2303,  1816,   427,  1538,   263,   443,  2795,
     450,     5,   208,  2222,  3071,  2224,    47,    11,  4966,  5413,
    4968,  2807,   184,  1555,  4972,  4973,   487,  2213,   489,   450,
     452,  3954,   228,   473,  2028,   487,  2222,   489,  2224,  3343,
    2220,  2857,  2036,   143,  2524,  2631,  2632,  2633,   208,  3353,
      85,    10,   473,  2839,    13,  2241,   156,  3046,    17,    18,
      19,   161,   485,  2133,  5532,   487,   489,  2253,   228,  2255,
    2256,  2902,   452,  5021,  2260,    34,  2262,  2263,  2264,   275,
    2266,  2381,  2268,   918,   488,  5479,  2272,   491,   284,  2275,
       5,  5530,     5,   473,    22,   356,    11,  2883,    11,  3740,
      28,  3742,   937,   138,    19,   940,  2984,   487,   208,  2038,
    2296,  3733,  2041,   218,   353,   275,  5271,   237,  3942,   487,
    2275,  2307,   914,    38,   284,   242,   486,   919,   228,  2315,
    2316,   491,  3121,  3249,   488,  3975,  2322,   491,   486,  3255,
     487,   482,  3487,   491,   278,  2331,   487,   412,   489,   283,
     412,  2806,  3719,  2808,  2809,   190,  2150,  2610,  2458,   398,
     488,   196,   335,   491,   488,  2618,  2352,   491,   356,  2981,
    2982,  2357,  2358,    32,    33,   275,   348,  4652,  3335,   450,
    3011,   452,   354,   240,   284,  2638,  2372,  2373,   427,   361,
    2376,   488,  2378,  2379,   491,  2648,  3408,  3409,  2651,   488,
    2653,  2654,   491,   240,  2657,   264,   265,   399,  3775,   401,
    2663,    90,  2665,   452,  3296,  2668,  2402,  2372,  2373,  2405,
      68,  2376,   488,  5232,   396,   491,    74,   423,   488,   488,
    5385,   491,   491,   353,   488,     3,   194,   491,    86,  2419,
     242,   488,  2428,  2429,   491,  3289,   418,   237,   487,   734,
     735,   736,   184,   212,   739,   740,   741,  2443,  3011,  2445,
    2446,    65,    66,   423,   749,   300,   114,   412,   116,    94,
     255,   256,   257,   258,   488,    82,    86,   491,   398,   488,
    2733,   488,   491,   488,   491,   488,   491,   237,   491,   443,
    2476,  2477,  2478,   450,   488,   452,  2482,   491,  1622,    55,
     359,   488,  2488,   488,   491,   356,   491,   427,  4765,   344,
    2496,   488,   218,  2499,   491,  5470,   487,    85,  4730,  2505,
      11,   280,   170,   423,   399,  3966,   401,  3139,  2514,  5052,
    2516,   450,   452,   452,  2814,   488,   395,   488,   491,   490,
    2820,   488,   167,   490,  2530,   488,  3158,  2533,   491,  2535,
     198,   488,  2538,  4177,   491,   487,  2542,  4181,   393,  2545,
     847,   171,   849,   353,  4182,  3961,  4184,   487,   278,   137,
     488,  2557,  2558,   491,   488,   200,   488,   491,   437,   491,
    3684,  3685,   488,  2538,   194,   491,   353,   422,  3981,  2575,
     215,   450,   349,   350,   488,   430,   237,   491,   433,  2585,
     225,  2587,   491,   353,   487,  4685,  2741,  2544,   398,  2744,
     488,    55,  2747,   491,   473,   263,  2584,   443,  2735,   488,
     268,   231,   491,  5265,   488,   441,   251,   491,   487,  2615,
     349,   350,  4907,  3322,  5443,   488,    10,   427,   491,   488,
    4915,    82,   491,    17,    18,    19,   488,  3496,   398,   491,
     349,   350,   488,   278,  3578,   491,  2642,    45,  2644,  2645,
    2646,  2647,   452,   311,   489,   488,   234,  3298,   491,  3300,
    1794,   470,    10,   283,    93,    13,   214,   427,  1802,   327,
    3668,   281,   488,   281,    10,   491,  5495,    13,   278,  2675,
    1814,    17,    18,    19,   113,  2857,   488,   487,  2684,   491,
     161,  3313,   452,  3315,    42,   278,  2674,   488,    34,   470,
     491,    49,   353,    45,  4554,   474,   475,   476,   343,   478,
     479,   480,   481,   482,   483,   214,   294,   128,   147,   130,
    3471,  4811,    10,   301,   281,    13,    74,   487,   480,    17,
      18,    19,  4284,   488,  2997,  3298,   491,  3300,   488,  2735,
    3381,   491,  5561,   154,   470,  2741,    34,   398,  2744,  2921,
     237,  2747,   349,   350,   488,   333,  1890,   491,   165,   337,
    2756,  3642,  2795,  5242,  5243,   128,   424,   130,  2764,  5365,
    5366,   488,  3460,  2769,   491,   488,   427,   488,   491,   399,
     491,   401,   488,  1917,   488,   491,   488,   491,   366,   491,
     491,   154,   412,   141,   487,    55,   431,  2793,  2794,  2795,
     488,   452,  2798,   491,   424,   488,  2839,   427,   491,   237,
    2806,  2807,  2808,  2809,   488,   488,   166,  3080,  3381,  3082,
     398,   488,   400,  2819,   491,   210,  2822,   488,  2824,   488,
     491,   487,   491,   487,  4266,   488,   487,   185,   491,  2835,
    2836,     0,   190,  2839,   255,   256,   257,   258,   489,  3741,
     488,   262,   263,   491,   333,   488,  5326,   268,   491,   454,
     487,  2857,   273,  2859,  3486,  2861,   353,  2863,   487,   190,
     488,   148,   450,   491,  3637,  1170,   212,   489,  1173,   227,
    1175,   487,  1177,   488,  1179,   148,   491,  2883,  1183,   278,
     190,  2887,   255,   256,   257,   258,   280,   333,  2894,   262,
     329,   488,  3711,   488,   491,   268,   491,   278,   148,    10,
     273,   398,    13,   148,  2910,   190,  2888,  2889,  2890,   148,
     488,   278,  2918,   491,   212,   353,   488,   161,   488,   491,
     359,   491,   280,   333,    93,  3531,  3795,  2933,   148,   488,
     427,    42,   491,   488,   280,   116,   491,   237,    49,   488,
     226,  2947,   491,  2949,    10,   431,   488,    13,  3221,   491,
     278,    17,    18,    19,  3227,   452,   395,   487,  4602,  3565,
     398,   488,   242,    74,   491,  4609,   272,   443,    34,    94,
    4614,   412,   356,  4617,   143,  3877,  3853,   161,   218,  2793,
    2794,  2987,   280,  2989,  2798,  4845,    37,   156,  2994,   427,
     487,  3291,   161,   414,   488,    68,   263,   166,   437,  4643,
      37,   263,   454,   172,   425,    56,   175,  3613,   161,   488,
     179,   450,   491,   371,   452,  3021,   487,  3023,  3024,  3025,
     488,  2835,  2836,   491,   278,   488,   488,  3648,   491,   491,
     141,   263,   488,  3648,   473,   491,    45,  3337,    45,   208,
    2184,   414,   167,   488,   488,  3863,   491,   491,   487,   487,
     263,   488,   425,   353,   491,   106,   107,   488,  2202,   228,
     491,   417,   488,   114,  2208,   491,   488,   263,  2212,   491,
     488,    85,   294,   491,   185,   200,  4128,   443,   143,   190,
     474,   475,   476,   161,   478,   479,   480,   481,   482,   483,
     215,   156,   488,  4037,  2238,   491,   161,   314,   398,   488,
     225,   488,   491,   443,   491,   488,   275,   148,   491,   278,
    3292,   488,   148,   471,   491,   284,   227,   487,   148,   170,
     478,   479,   480,   481,   482,   483,   251,   427,   474,   475,
     476,  3137,   478,   479,   480,   481,   482,   483,   440,  2283,
     487,  2894,   193,   208,   292,   488,   212,   488,   491,   307,
     491,  3424,   452,  3426,   488,  3428,   148,   491,   488,  2303,
     487,   491,    36,   228,  3437,  4809,   454,   488,   487,   280,
     491,   340,   148,   148,   491,  4044,   474,   475,   476,   148,
     478,   479,   480,   481,   482,   483,   148,   487,   148,  4833,
     241,  2335,   488,   244,  2947,   491,   488,   488,    10,   491,
     491,    13,   148,   148,   148,    17,    18,    19,   259,   161,
     275,   359,   263,   488,   280,  3488,   491,  2361,   343,   284,
     148,   148,   148,  2367,  5084,    37,   395,   148,   148,   278,
    2374,   395,   210,    37,   487,  4879,   226,  2381,   161,   161,
    2384,   487,   293,  3249,   278,     6,  2390,   395,     6,  3255,
    4194,   487,   487,   161,   423,     6,   487,   487,  3264,   487,
     371,   487,   487,  3269,  3270,     6,  2410,     6,   487,   487,
       6,  3571,  2416,   487,   290,   487,   487,  2421,   447,   487,
     449,   450,   487,   487,   487,   487,   487,   338,    10,   437,
    2434,    13,   487,  3925,  3926,    17,    18,    19,  3304,  3305,
    3306,   265,   450,  2447,   487,   487,   451,   487,   487,   360,
     487,   487,  4436,   487,  2458,  3321,   485,   487,   210,   488,
     489,   490,   487,   491,   491,   473,    37,    97,   226,   380,
      37,   382,   491,   161,   385,   275,   161,  3343,  3344,   487,
    4038,  4039,  4040,  4041,  4042,    64,   407,  3353,  3354,  3355,
     407,   353,   407,  3359,    10,   273,  3362,    13,   423,   442,
     471,    17,    18,    19,   407,  3371,   353,   478,   479,   480,
     481,   482,   483,  5017,   489,   407,   407,  4793,   228,  3367,
     353,   407,   337,   407,   476,   407,    86,   353,   148,   278,
     358,   223,   407,   268,   407,   359,  3371,   122,   398,   407,
     212,   430,  3445,   298,   273,   278,  3394,  4276,   474,   475,
     476,   349,   478,   479,   480,   481,   482,   483,   487,   407,
     485,   407,    86,   488,   489,   487,   183,   491,   122,   294,
     148,   395,   431,   431,  3440,   190,   487,  5081,   122,  3445,
     407,  3609,  3448,  4211,   407,   395,   407,   395,   407,   407,
     108,  4912,   122,   407,   407,    55,   407,    55,   407,   248,
     407,   282,   318,   298,   407,  3471,   407,   298,   280,  3769,
     407,  3771,   407,   437,   407,   407,   407,   407,  3484,   398,
      44,  3487,   407,    44,   488,   491,   450,   492,   212,   212,
     212,   407,   407,   278,  3794,  4397,  3471,   454,   212,   212,
     278,   278,   212,  3509,   212,   278,   212,   212,  4114,   473,
     212,   407,  3518,   417,  3814,   487,    37,   148,    26,   278,
    3526,   148,  3528,   487,   488,  3531,   490,   114,   263,   431,
    3536,  3537,  3538,  3539,   148,   148,  3542,  3543,  3544,  3545,
    3546,  3547,  3548,  3549,  3550,  3551,   148,   450,   442,  3555,
    3556,   278,   234,   273,   263,    37,   212,   161,   280,  3565,
    4496,  2705,   263,  3569,  3607,  5209,  4202,  3573,   263,    37,
     487,  4515,   218,   487,   355,  3581,   487,  5221,  3584,  2723,
    3586,   487,    36,  3626,   485,   405,   405,  2731,  3770,   407,
     407,   407,  3598,   407,   485,  3601,  3602,   487,  5458,  5459,
    3606,  3607,   148,   148,   431,  3611,   148,  3613,     6,   431,
     148,   148,   366,  3795,  3620,  3621,  3622,  3623,   272,   407,
    3626,  3627,   267,   166,   280,  3631,  3632,  3633,   487,   248,
     248,  4263,  3638,  3615,  3616,  3617,  3618,   446,    13,   491,
     405,   487,   487,   407,   175,   157,   166,   409,   491,   488,
     183,   183,   208,  3648,  3648,   491,  4354,  4355,  3664,  4357,
    3648,   216,   474,   475,   476,   369,   478,   479,   480,   481,
     482,   483,   279,    37,    55,   431,   491,  3683,  3684,  3685,
     488,  3687,   287,   431,   353,   487,   216,   216,   268,   268,
     407,   407,   407,   242,   487,   356,   443,   161,  3704,  3705,
    3706,  3707,   218,  5347,   278,   268,    45,   375,  4417,   412,
     278,   263,   226,  4345,   349,   226,   226,   407,   278,   398,
     122,   278,  3536,  3537,  3538,  3539,   366,  3733,  3542,  3543,
    3544,  3545,  3546,  3547,  3548,  3549,  3550,  3551,   491,   278,
      10,   333,   278,    13,  4017,  3751,  5308,   184,  4021,   321,
     407,   363,   474,   475,   476,  3569,   478,   479,   480,   481,
     482,   483,   284,   407,    37,   212,   431,   488,     6,   431,
     218,   148,    42,   317,   273,   161,   443,   476,    37,    49,
    5424,   396,   273,   163,   318,   363,  5430,  3601,  3602,    37,
     487,   148,  4916,   148,   192,  3977,   487,   148,   273,   431,
     450,   263,  3802,   201,    74,    37,   263,   278,    56,   278,
     218,   209,  4444,  3813,   212,   181,  4963,   161,   474,   475,
     476,   181,   478,   479,   480,   481,   482,   483,    37,   162,
     357,   470,   485,   488,   470,   246,   488,   488,   363,   488,
     488,   161,  3848,    37,   218,  4451,    10,   278,   263,    13,
     190,   454,   190,   190,   190,   190,    25,   491,   106,   173,
     407,   491,    56,    10,  3008,   491,    13,   487,   166,   245,
    3623,   141,   278,  3626,   450,   491,    55,  3883,    42,   272,
     395,  4952,   488,  4954,   412,    49,   218,   488,  5532,   443,
    3896,   488,  3898,   488,  3900,    42,   487,   166,   488,   488,
     488,  3907,    49,   488,   488,   290,   166,  3913,    10,   491,
      74,    13,   106,   488,   487,   185,   299,  3923,   488,   470,
     190,   262,   170,   407,   289,   487,   429,    74,   487,   487,
    3683,   240,  3938,   236,   487,    55,  3942,   487,   447,   281,
      42,   447,   194,   148,   278,   193,  3952,    49,   472,   278,
     454,   407,   487,   202,   192,  3961,   407,   227,   407,   151,
     268,   487,   407,   201,   202,  3971,   263,   148,   358,  3975,
    4243,   209,    74,   211,   212,  3119,  3982,  3983,   282,   366,
     148,   148,  3970,   226,   194,   358,  4763,   225,   358,   151,
     278,   476,   431,   241,   141,   407,   244,   151,   491,   193,
     228,   300,   428,  5150,   300,   151,   407,  4013,  4644,  4015,
     280,   259,   407,   382,  4287,  4288,  4022,   238,   407,   407,
    4202,   185,   238,   238,   122,   407,   190,   353,  4034,   407,
    4036,   353,   353,   263,  5158,  5159,   407,   353,   185,   141,
     407,   366,   148,   190,   407,   293,  4864,   241,   407,   407,
     244,   407,    44,   407,  4686,   407,   488,   212,   488,   488,
     212,  4697,   486,   227,   212,   259,  4072,   212,   178,   488,
     488,   491,   417,     3,   161,    45,   107,   335,  4084,   488,
     227,   491,   161,   185,   487,    37,  3900,   148,   190,   488,
     338,   148,   407,   161,  4963,   178,   487,   476,   148,   293,
    3244,   371,   486,   431,  4377,  4378,   437,   431,  4114,   353,
     281,  4117,   360,   278,   486,   476,   280,  5053,   353,  4125,
    4126,   363,   353,   491,   353,   227,  4132,  4133,   353,   146,
     146,  4137,   380,   280,   212,   488,   212,  4143,   212,   212,
    4146,  4147,   212,   212,   338,  4151,  4152,   212,   212,   139,
      13,  4157,  4158,  4159,  4160,  4161,   166,   290,   485,  4165,
    4166,  4167,   161,  4169,  4170,   442,   360,  4173,   491,   488,
     488,  4177,   166,   262,  4872,  4181,  5300,   488,   280,   447,
     487,  4187,   488,   488,   166,  4883,   380,   487,   473,  3942,
     491,   175,   404,   488,   487,  4224,  4202,   491,   488,   340,
     417,   471,   161,    37,   431,  4211,   218,   371,   478,   479,
     480,   481,   482,   483,   407,   202,    55,   431,  4224,   148,
     398,  4227,   487,   382,   371,   170,   417,   358,   151,   353,
    4503,   407,   407,   407,  4507,  4508,   353,   407,   488,   333,
     487,  4247,  4248,   488,  4850,    55,   407,   488,   450,   398,
    5169,   437,  5399,   161,   278,    74,   148,   107,  4956,   417,
    4266,  4534,   488,   212,   212,   212,   212,   487,   487,   371,
    4270,   197,   216,   407,   454,  4281,   278,   328,   676,    37,
    4280,   276,   488,  4889,   491,   298,   487,   685,   491,   278,
       3,   491,  3436,   491,   692,   417,   407,   695,  4949,   487,
     363,   488,   486,  4117,   436,    84,   172,   471,   107,   166,
      27,   212,  4963,   166,   478,   479,   480,   481,   482,   483,
    3464,    55,   488,   448,   471,  4331,   290,   448,   488,   215,
     487,   478,   479,   480,   481,   482,   483,   488,   488,   215,
      55,  4947,  4948,   397,   487,  3489,   488,   491,   488,   487,
    4356,   288,   487,   285,   179,  4169,   404,   273,   488,    76,
     407,   417,   166,    74,   450,  4371,   196,   191,   184,   471,
     184,   268,   268,   476,    55,   398,   478,   479,   480,   481,
     482,   483,   491,   491,    68,   407,   407,   407,   148,   151,
     212,   108,   407,   488,  5092,   487,   121,   168,   636,  4405,
     166,    37,   114,   431,   642,   190,  5115,   487,   273,   363,
      37,   263,   431,   163,   131,  4421,   161,   655,   273,    80,
     363,  4427,    55,   450,  4177,   142,   398,    37,  4181,   166,
    4436,   278,   450,   671,   487,  4735,   199,   161,   676,   476,
     281,   210,   487,   681,   166,  4451,   163,   685,   686,   487,
     436,   168,   379,   488,   692,   488,   694,   695,  4464,   215,
    4466,   298,  4644,   488,   449,   278,   327,   407,    37,   707,
     708,   148,  5078,   487,   148,  4463,  5112,   488,   487,   487,
     718,   487,   407,   487,   487,   161,   487,   487,    37,  5095,
     487,   487,   268,  5099,  4500,  5101,   239,   194,   148,  5150,
     488,   363,   219,  4685,   487,   107,   487,   446,  4514,   134,
      37,   488,   282,  4519,   417,  4697,  4697,   377,   377,   488,
      86,   129,    55,   240,  4512,  4513,    10,    37,   491,    13,
      77,   487,   487,    17,    18,    19,   487,   487,   183,   161,
     398,  4696,   431,   259,   398,   487,   487,   278,  4554,   398,
     488,     6,   155,   487,   454,   147,   487,   350,    42,   350,
      68,   281,   960,   801,   802,    49,    68,   129,  4841,   807,
    3714,   450,   450,   971,   487,   487,   491,  4583,  4584,   977,
     436,  4587,   980,    37,   435,  4740,   166,   398,   436,   324,
      74,   134,   196,   831,   487,   833,  4602,   314,   315,  4605,
     268,   318,   363,  4609,    37,   278,   844,   278,  4614,    37,
     487,  4617,  4618,   191,  4620,   281,  4622,   281,  4624,  4625,
     168,   488,   168,   491,   366,    55,   447,   344,  4633,   407,
     347,   349,  4905,   386,   119,   429,   353,  4643,  4644,  4645,
    5291,  4647,   487,   360,   488,   488,     6,   487,   349,   363,
     144,   285,   334,    23,  1052,  1053,  1054,    34,   487,   487,
     487,   268,   166,   407,   147,   491,   349,   487,   491,   286,
      77,   377,   389,   377,   882,   450,   450,   168,   395,   487,
     168,   398,  1624,  2542,  1359,  4958,  3830,   843,  2346,  3833,
    4696,  4697,  2902,  2427,  3071,  3744,  5291,  2453,  3769,  2512,
     417,   185,  4738,  3283,  5148,  5399,   190,  3923,  4793,  4762,
    2988,  4407,  2684,   951,   952,   953,  5270,  4643,  5388,  5178,
    5177,  5311,   960,  5424,  3956,  2992,   443,  3971,  5122,   967,
    2527,  3914,  5353,   971,  4740,  2527,  3764,  4743,  5353,   977,
    4554,  3096,   980,   227,  3333,  3939,     0,   924,  5399,  4755,
    4769,  4778,  4758,  4445,   992,  2521,  5401,  4763,  5565,  4765,
    5547,  3291,  4755,  3345,  3979,  5324,  4772,    21,  4699,  1007,
    4935,  1783,  5131,  4702,  1196,    28,  4047,  4903,  5492,  4767,
    2196,  1829,  3981,  4789,  2966,  1827,  1838,  4793,  5053,  1897,
    4796,  3935,   672,  1990,   705,  3225,   280,  1990,    52,  1991,
    2452,  4807,  4808,  4809,  3794,  3337,  3814,  5353,  5535,  4002,
    3954,  1444,  5433,  4004,  1052,  1053,  1054,  4805,  5433,  1932,
    2129,  1941,  2140,  5358,   822,  4829,  4034,  4833,  2918,  4835,
    4514,  1379,  2176,  4808,  1336,  1402,  1401,   844,  2933,  4845,
    3641,  5260,  4848,  2150,  4850,  5103,  4889,  3626,  5148,  4602,
    4199,  2175,  4166,  4183,  1092,  4880,  4609,  3623,  5081,  5080,
    5541,  4614,  4035,  4869,  4617,  3623,     0,  5473,  5373,  4875,
    5250,  5462,  4848,  4879,  3573,  5263,  2862,  4883,  1862,  2765,
    4628,  1404,  5264,  4889,  2482,  2860,    -1,   371,  2087,    -1,
    4643,  1129,  4898,    -1,    -1,    -1,  2090,    -1,    -1,    -1,
      -1,    -1,    -1,  4047,    -1,    -1,    -1,    -1,  4914,  1147,
    4916,    -1,    -1,    -1,  5535,    -1,    -1,    -1,    -1,  1157,
    5535,    -1,    -1,    -1,    -1,    -1,    -1,  1165,    -1,    -1,
    5112,    -1,   186,    -1,    -1,    -1,  4942,    -1,    -1,    -1,
      -1,  4947,  4948,    -1,    -1,    -1,  4952,  4953,  4954,  4955,
      -1,  5251,    -1,    -1,    -1,    -1,    -1,  1195,    -1,    93,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1209,    -1,  1211,    -1,    -1,    -1,    -1,    -1,  4985,
      -1,    -1,    -1,    -1,    -1,    -1,  4992,   471,    -1,  1227,
     474,   475,   476,  1231,   478,   479,   480,   481,   482,   483,
      -1,    -1,    -1,    -1,    -1,  1243,    -1,    -1,  5014,   143,
      -1,  5017,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   156,    -1,    -1,    -1,    -1,   161,    -1,    -1,
      -1,  4845,   166,    -1,    -1,    -1,  1274,    -1,   172,  5027,
      -1,   175,    -1,    -1,    -1,   179,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4869,  4809,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1302,  1303,  1304,    -1,  1306,    -1,
      -1,    -1,  5078,    -1,   208,  5081,    -1,    -1,  5084,    -1,
    4833,    -1,  5088,    -1,    -1,    -1,    -1,    -1,  1326,  5095,
      -1,    -1,    -1,  5099,   228,  5101,    -1,  5103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5112,    -1,    -1,    -1,
    5383,    -1,  1350,    -1,    -1,    -1,    -1,  5123,    -1,    -1,
    1358,  1359,    -1,  5278,    -1,    -1,  4879,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1372,    -1,    -1,    -1,    -1,    -1,
      -1,   275,    -1,    -1,   278,    -1,    -1,    -1,    -1,    -1,
     284,    -1,  5158,  5159,    -1,    -1,  1394,    24,    -1,  4303,
    1398,  1399,    -1,    30,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4315,    -1,    -1,    -1,  1413,    43,    -1,    -1,    -1,
      -1,  1419,  5482,  5189,    -1,    -1,    -1,  1425,    -1,    -1,
    5196,    -1,    -1,    -1,  5200,    -1,    -1,    -1,    -1,  5354,
    5355,    -1,    -1,  5209,    -1,    72,   340,    -1,    -1,    -1,
      -1,    -1,    -1,    10,    -1,  5221,    13,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5241,  5242,  5243,    -1,    -1,
      -1,  5247,  5230,    -1,  5250,    42,    -1,  5547,    -1,  1487,
      -1,    -1,    49,    -1,  5260,    -1,    -1,  5263,    -1,   126,
      -1,   395,    -1,    -1,  5017,  5565,   133,    -1,    -1,   136,
    5084,    -1,  5278,    -1,    -1,    10,    -1,    74,    13,    -1,
      -1,    -1,    17,    18,    19,    -1,    -1,  5293,    -1,   423,
    1528,    -1,    -1,    -1,  5300,   162,    -1,    -1,    -1,    34,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,
      -1,    -1,    -1,   447,    49,   449,   450,    -1,    -1,    -1,
    5326,    -1,    -1,  1561,    -1,  5331,    -1,    -1,  5081,   196,
      -1,  5337,    -1,    -1,    -1,    -1,    -1,  5325,    -1,    74,
      -1,  5347,    -1,    -1,   141,    -1,    -1,    -1,  5354,  5355,
      -1,   485,  5358,  5359,   488,   489,   490,    -1,  5353,  5353,
      -1,    -1,    -1,  5369,    -1,  5353,    -1,  5373,   622,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1622,    -1,    -1,  5393,   185,    -1,
    5433,  4535,   259,   190,    -1,    -1,   263,    -1,    -1,  1637,
    1638,  1639,    -1,    -1,    -1,    -1,   273,    -1,    -1,    -1,
      -1,    -1,  5567,  5568,    -1,   282,    -1,    -1,  5424,  5425,
    5426,    -1,    -1,    -1,  5430,    -1,    -1,   294,    -1,    -1,
     227,    -1,    -1,    -1,    -1,    -1,  5250,    -1,  5433,  5433,
    1838,    -1,    -1,  1841,    -1,  5433,    -1,    -1,    -1,    -1,
     185,    -1,  5458,  5459,    -1,   190,  5209,    -1,    -1,    -1,
      -1,    -1,  5468,   717,   718,    -1,   333,  5473,  5221,   336,
     337,    -1,    -1,    -1,    -1,    -1,    -1,   212,   213,    -1,
      -1,    -1,    -1,   280,    -1,    -1,    -1,    -1,  1886,  1887,
      -1,    -1,   227,  4637,    -1,  4639,    -1,    -1,  5504,   366,
      -1,    -1,  1740,  1901,    -1,    -1,  1904,    -1,  5514,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1757,
      -1,    -1,    -1,  5529,    -1,    -1,  5532,    -1,    -1,    -1,
      -1,   266,  1770,    -1,    -1,  5541,    -1,  1775,    -1,  5545,
    5535,  5535,    -1,    -1,    -1,   280,    -1,  5535,   283,    -1,
      -1,    -1,    -1,    -1,    -1,  5369,  1794,    -1,    -1,    -1,
      -1,  5567,  5568,    -1,  1802,    -1,    -1,   434,  1966,    -1,
      -1,  1969,  1970,    -1,   371,    -1,  1814,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   841,    -1,   843,
      -1,    -1,    -1,  1831,  5347,    -1,    -1,    -1,    -1,    -1,
    1838,    -1,    -1,  1841,    -1,    -1,  1844,    -1,    -1,    -1,
      -1,    17,    -1,  1851,    -1,    -1,    -1,    -1,    -1,  1857,
      26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1869,    -1,    -1,    -1,    -1,   371,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5458,  5459,    -1,    -1,  1886,  1887,
      -1,  1889,  1890,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1901,    22,  1903,  1904,    -1,    -1,    -1,
      28,  5424,    -1,    -1,   471,  1913,  1914,  5430,  1916,  1917,
      -1,   478,   479,   480,   481,   482,   483,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1932,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     0,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1966,    -1,
      -1,  1969,  1970,    -1,    -1,    -1,   471,    -1,    -1,   474,
     475,   476,    -1,   478,   479,   480,   481,   482,   483,    37,
      -1,    -1,    -1,   488,    -1,    -1,   491,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2004,    -1,  2006,    -1,
      58,    -1,    -1,  2011,  2012,    -1,    -1,    -1,    -1,  5532,
    2018,  2019,  2020,    -1,    -1,  2023,    -1,  2025,    -1,  2027,
    2028,  2029,  2030,  2031,  2032,    -1,  2034,    -1,  2036,  2037,
      -1,    -1,  2040,    -1,    92,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    -1,    -1,  2054,  2055,  2056,  2057,
    2058,  2059,    -1,    -1,    -1,  2063,    -1,    -1,    -1,  2067,
      -1,    -1,  2070,    -1,    -1,  2073,  2074,  2075,  2076,  2077,
    2078,  2079,  2080,  2081,    -1,  2083,    -1,    -1,    -1,    -1,
      -1,    -1,  2090,    -1,  2092,  2253,    -1,    -1,    -1,    -1,
     143,    -1,  2260,    -1,   152,  2263,  2264,    -1,    -1,    -1,
      -1,    -1,    -1,   156,    -1,    -1,    -1,    -1,   161,    -1,
      -1,    -1,    -1,   166,    -1,    -1,    -1,    -1,    -1,   172,
      -1,  2129,   175,    -1,    -1,    -1,   179,  2135,    -1,   187,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2150,  1167,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2159,  2160,    -1,    -1,   208,    -1,    -1,    -1,    -1,
     218,    22,    -1,    -1,    -1,   223,    27,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   228,  2184,    -1,    -1,    -1,
      -1,    -1,    -1,  2191,    -1,    -1,    -1,  2195,  2196,    -1,
      -1,    -1,    -1,    -1,  2202,    -1,    -1,    -1,    -1,  2207,
    2208,    62,    -1,    -1,  2212,   263,    -1,    -1,    -1,    -1,
      -1,    -1,  2220,    -1,    75,  1239,    -1,    -1,    -1,    -1,
      -1,    -1,   275,    -1,    -1,   278,    -1,    -1,    -1,    90,
    2238,   284,    -1,  2241,    -1,  1259,    -1,   295,    -1,    -1,
      -1,    -1,    -1,   301,    -1,  2253,    -1,    -1,    -1,  2257,
      -1,    -1,  2260,    -1,    -1,  2263,  2264,    -1,    -1,    -1,
      -1,    -1,    -1,  2271,    -1,    -1,    -1,  1291,    -1,    -1,
     131,    -1,    -1,    -1,    -1,  2283,    -1,    -1,    -1,   337,
      -1,   142,  1306,   341,    -1,    -1,    -1,   340,    -1,    -1,
      -1,    -1,   350,    -1,    -1,  2303,  2304,    -1,    -1,    -1,
     358,    -1,   163,    -1,  2312,    -1,    -1,   168,   366,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,  2334,  2335,    -1,   387,
    2338,    -1,    -1,   391,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   395,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5265,   410,  2361,    -1,  2363,    -1,    -1,    -1,  2367,
      -1,    -1,    -1,    -1,    -1,    -1,  2374,    -1,  1392,  1393,
     423,  1395,    -1,  2381,    -1,    -1,  2384,    -1,    -1,   240,
      -1,    -1,  2390,    -1,    -1,    -1,    -1,   445,    -1,    -1,
      -1,   449,    -1,    -1,   447,    -1,   449,   450,    -1,    -1,
      -1,    -1,  2410,    -1,    -1,    -1,    -1,    -1,  2416,    -1,
      -1,    -1,    -1,  2421,    -1,    -1,  2424,    -1,    -1,   280,
      -1,    -1,    -1,    -1,    -1,    -1,  2434,    -1,    -1,    -1,
      -1,    -1,   485,    -1,    -1,   488,   489,   490,    -1,  2447,
      -1,    -1,    -1,   619,  2452,    -1,    -1,    -1,    10,    -1,
    2458,    13,    24,   314,   315,    17,    18,    19,    30,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2476,  2477,
    2478,    -1,    34,    -1,  2482,    -1,    37,    -1,    -1,    -1,
      42,    -1,    -1,    -1,    -1,    -1,   347,    49,    -1,    -1,
      -1,    -1,   353,    -1,    -1,   671,   672,    58,    -1,   360,
      72,    -1,   363,    -1,    -1,    -1,  2514,  2515,    -1,    -1,
      -1,    -1,    74,    -1,    -1,    -1,  2524,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    92,    -1,    -1,   395,    -1,    -1,    -1,    -1,    -1,
      -1,   402,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   410,
    2558,    -1,    -1,    -1,   126,    -1,   417,    -1,    -1,    -1,
      -1,   133,    -1,    -1,   136,    -1,    -1,  2735,    -1,    -1,
      -1,    -1,    -1,  2741,    -1,    -1,  2744,    -1,    -1,  2747,
      -1,    -1,   443,    -1,    -1,    -1,    -1,    -1,    -1,  2597,
     162,   152,  2600,   769,    -1,    -1,    -1,  2605,    -1,    -1,
      -1,    -1,    -1,    -1,   732,    -1,   734,  2615,   736,    -1,
      -1,    -1,    -1,    -1,   742,   743,   744,    -1,    -1,   795,
      -1,    -1,    -1,   185,   196,    -1,   187,   803,   190,    -1,
     806,   807,   808,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     212,   213,    -1,  2661,    -1,    -1,    -1,   218,    -1,    -1,
      -1,    -1,   223,    -1,    -1,   227,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   259,    -1,    -1,
      -1,   263,    -1,    -1,    -1,    -1,    -1,  2705,    -1,    -1,
      -1,   273,   263,    -1,   266,    -1,    -1,    -1,    -1,    -1,
     282,    -1,    -1,  2721,    -1,  2723,    -1,    -1,   280,    -1,
      -1,   283,   294,  2731,    -1,    -1,  2894,  2735,    -1,    -1,
    2738,    -1,    -1,  2741,   295,    -1,  2744,    -1,    -1,  2747,
     301,    -1,    -1,    -1,    -1,  2753,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2764,    -1,    -1,    -1,
      -1,  2769,   890,    -1,   336,   337,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   337,    -1,    -1,  2947,
     341,    -1,    -1,    -1,    -1,  2793,  2794,  2795,    -1,   350,
    2798,    -1,    -1,    -1,   366,    -1,    24,   358,  2806,  2807,
    2808,  2809,    30,    -1,    -1,   366,  2814,    -1,    -1,   371,
      -1,  2819,  2820,    -1,  2822,    43,  2824,   378,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   387,  2835,  2836,    -1,
     391,  2839,    -1,    -1,    -1,    -1,    -1,    -1,   681,    -1,
      -1,    -1,    -1,    -1,    72,    -1,    -1,    -1,    -1,   410,
      -1,  2859,    -1,  2861,    -1,  2863,    -1,    -1,    -1,    -1,
      -1,    -1,   434,    -1,   707,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2883,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   445,    -1,  2894,    -1,   449,    -1,
      -1,    -1,    -1,    -1,  2902,    -1,   124,    -1,   126,    -1,
      -1,    -1,    -1,    -1,    -1,   133,    -1,  1931,   136,   471,
    2918,    -1,   474,   475,   476,    -1,   478,   479,   480,   481,
     482,   483,    -1,    -1,    -1,  2933,    -1,    -1,    -1,   491,
      -1,    -1,    -1,    -1,   162,    -1,    -1,    -1,    -1,  2947,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2956,    -1,
      -1,  2959,    -1,  2961,    -1,    -1,    -1,    -1,  2966,    -1,
      -1,    -1,    -1,  1987,    -1,    -1,    -1,    -1,   196,    -1,
      -1,  1147,    -1,  2981,  2982,    -1,    -1,    -1,    10,  2987,
      -1,    13,    -1,    -1,    -1,    17,    18,    19,    24,  1165,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    -1,    -1,
    3008,    37,    34,  3011,    -1,    -1,    -1,  3015,    -1,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,
      56,    -1,    -1,    -1,    -1,  1201,  3034,    -1,    -1,    -1,
      -1,   259,    -1,    -1,    58,   263,    72,  1165,    -1,    -1,
    2064,    -1,    74,    -1,    -1,   273,    -1,    -1,    -1,    -1,
      -1,  3059,    -1,    -1,   282,  1231,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   294,    -1,    92,    -1,
     106,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3095,  3096,  3097,
     126,    -1,    -1,    -1,    -1,    -1,    -1,   133,    -1,    -1,
     136,    -1,    -1,    -1,    -1,   333,    -1,    -1,   336,   337,
      -1,  3119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3129,    -1,  3131,   967,    -1,   162,    -1,   152,    -1,
      -1,  3139,  1308,    -1,    -1,    -1,    -1,    -1,   366,    -1,
      -1,  1317,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   992,
    3158,    -1,    -1,   185,    -1,  1331,    -1,   193,   190,    -1,
     196,    -1,    -1,   187,  1007,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1350,    -1,    -1,  1353,  1354,    -1,
     212,   213,  1358,  1359,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    58,    -1,    -1,   227,  1372,    -1,    -1,   223,
      -1,    -1,    -1,    -1,    -1,   241,   434,    -1,   244,    -1,
      -1,    -1,    -1,    -1,  3222,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   259,    -1,  1353,    92,   263,    -1,    -1,
    1358,  1359,    -1,    -1,   266,   259,  3244,   273,    -1,   263,
      -1,  3249,    -1,    -1,  1372,    -1,   282,  3255,   280,    -1,
      -1,   283,    -1,    -1,    -1,  3263,    -1,   293,   294,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     294,   295,    -1,    -1,    -1,    -1,    -1,   301,    -1,    -1,
      -1,    -1,    -1,  3291,  3292,    -1,   152,    -1,    -1,    -1,
    3298,    -1,  3300,    -1,    -1,    -1,    -1,   333,    -1,    -1,
     336,   337,   338,    -1,    -1,  3313,    -1,  3315,    -1,   333,
      -1,    -1,    -1,   337,    -1,    -1,    -1,   341,    -1,    -1,
      -1,   187,    -1,    -1,   360,    -1,   350,    -1,    -1,  3337,
     366,    -1,    -1,    -1,   358,    -1,    -1,  1465,    -1,   371,
      -1,    -1,   366,    -1,   380,    -1,    -1,  1475,    -1,    -1,
      -1,    -1,    -1,  3361,   378,    -1,    -1,   223,    -1,    -1,
      -1,    -1,    -1,   387,    -1,    -1,  1209,   391,    -1,    -1,
      -1,    -1,    -1,  3381,  3382,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3396,    -1,
      -1,  1519,  1520,    -1,    -1,    -1,    -1,   263,   434,    -1,
      -1,    -1,    -1,  1579,    -1,    -1,    -1,    -1,    -1,    -1,
    1586,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   445,    -1,    -1,    -1,    -1,    -1,    -1,  3436,   295,
      -1,    -1,    -1,    -1,  1562,   301,    -1,  1565,  1566,   471,
      -1,    -1,   474,   475,   476,    -1,   478,   479,   480,   481,
     482,   483,    -1,    -1,    -1,  3623,  3464,    -1,  3626,   491,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,    -1,
      -1,   337,    -1,   339,    30,   341,    -1,    -1,  3486,    -1,
       3,  3489,    -1,    -1,   350,    -1,    -1,    10,    -1,    -1,
      13,    -1,   358,    -1,    17,    18,    19,    -1,    -1,    -1,
     366,  3509,    -1,    -1,  3512,    -1,    -1,    -1,    -1,    -1,
    3518,    34,   378,    -1,    37,  3683,    72,    -1,  3526,    42,
    3528,   387,    -1,  3531,    -1,   391,    49,  3535,  3536,  3537,
    3538,  3539,    -1,    -1,  3542,  3543,  3544,  3545,  3546,  3547,
    3548,  3549,  3550,  3551,    -1,    -1,    -1,  3555,  3556,    -1,
      -1,    74,  3560,    -1,    -1,    -1,    -1,  3565,    -1,    -1,
    2584,  3569,    -1,  3571,    -1,  3573,    -1,    -1,    -1,    -1,
     126,    -1,    -1,  3581,    -1,    -1,  3584,   133,  3586,   445,
     136,    -1,    -1,    58,    -1,    -1,    -1,    -1,  3596,    -1,
    3598,    -1,    -1,  3601,  3602,    -1,    -1,    -1,  3606,  3607,
      -1,    -1,    -1,    -1,    -1,  3613,   162,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3623,    -1,    92,  3626,  1747,
      -1,  1797,    -1,    -1,    -1,  1801,    -1,    -1,    -1,    10,
    3638,    -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,
     196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2674,    -1,    -1,    34,    -1,    -1,  3664,    -1,    -1,    -1,
      -1,    42,   185,  3671,    -1,    -1,    -1,   190,    49,    -1,
      24,    -1,    -1,    -1,    -1,  3683,    30,   152,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1528,    -1,    -1,    -1,   212,
     213,    -1,    -1,    74,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   259,   227,    -1,  3714,   263,    -1,    -1,
      -1,    -1,   187,    -1,    -1,    -1,    -1,   273,    72,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   282,  1855,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1865,   294,  1867,
      -1,    -1,    -1,   266,    -1,  1873,    -1,    -1,   223,    -1,
      -1,    -1,  1880,    -1,    -1,    -1,  3764,   280,    -1,    -1,
     283,  3769,  3770,  3771,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2795,   126,    -1,  3942,    -1,    -1,   333,    -1,   133,
     336,   337,   136,    -1,   259,    -1,  3794,  3795,   263,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,
      -1,    -1,    -1,    -1,   185,    30,  3814,    -1,   162,   190,
     366,    -1,    -1,    -1,    -1,  2839,    -1,    -1,    -1,   294,
     295,    -1,  3830,    -1,    -1,  3833,   301,    -1,    -1,    -1,
      -1,   212,   213,    -1,    -1,    -1,    -1,    -1,  2862,    -1,
      -1,  2017,   196,    -1,    -1,    -1,   227,    72,   371,    -1,
      -1,    -1,    -1,    -1,  2878,    -1,    -1,    -1,   333,    -1,
      -1,    -1,   337,    -1,    -1,    -1,   341,    -1,    -1,    -1,
    2894,    -1,    -1,    -1,    -1,   350,    -1,    -1,   434,    -1,
      -1,    -1,    -1,   358,    -1,   266,  2014,  2015,    -1,    -1,
      -1,   366,  3900,  2021,  2022,    -1,    -1,  1740,    -1,   280,
      -1,   126,   283,   378,    -1,   259,    -1,    -1,   133,   263,
      -1,   136,   387,    -1,  1757,    -1,   391,  3925,  3926,   273,
      -1,  3929,  2050,  2947,    -1,    -1,    -1,  3935,   282,    -1,
      -1,    -1,  1775,  2109,  3942,    -1,    -1,   162,    -1,    -1,
     294,    -1,    -1,    -1,    -1,    -1,  3954,    -1,   471,    -1,
      -1,   474,   475,   476,    -1,   478,   479,   480,   481,   482,
     483,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3977,
     445,   196,    -1,  3981,  3982,  3983,    -1,    -1,    -1,   333,
      -1,    -1,   336,   337,    -1,    -1,    -1,    -1,  1831,    -1,
     371,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1844,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4177,
      -1,    -1,   366,  4181,  1857,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1869,    -1,  4036,    -1,
      -1,  2159,  2160,    -1,   259,    -1,    -1,    -1,   263,  4047,
      -1,    -1,    -1,    -1,  2220,    -1,    -1,    -1,   273,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   282,    -1,    -1,
      -1,    -1,    -1,    -1,  4072,    -1,    -1,    -1,    -1,   294,
    1913,  1914,    -1,    -1,    -1,    -1,  4084,    -1,    -1,    -1,
     434,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     471,    -1,  2220,   474,   475,   476,    -1,   478,   479,   480,
     481,   482,   483,    -1,    -1,    -1,  4114,   488,   333,  4117,
      -1,   336,   337,    -1,  2290,    -1,    -1,  4125,  4126,    -1,
    4128,    -1,    -1,    -1,  4132,  4133,    -1,    -1,    -1,  4137,
    4138,    -1,    -1,    -1,    -1,  4143,    -1,    -1,  4146,  4147,
      -1,   366,    -1,  4151,    -1,    -1,    -1,    -1,    -1,  4157,
      -1,    -1,    24,    -1,    24,    -1,    -1,    -1,    30,    -1,
      30,  4169,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4177,
      -1,    43,    -1,  4181,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    13,    -1,    -1,  2315,    17,    18,
      19,    -1,    -1,  2369,    -1,    -1,    -1,    -1,    -1,    -1,
      72,    -1,    72,  4211,    -1,    34,    -1,    -1,    -1,   434,
    2386,  2054,    -1,    42,    -1,    -1,    -1,    -1,    -1,  4227,
      49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4245,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    74,    -1,    -1,    -1,    -1,
      -1,    -1,   124,  4421,   126,  4263,   126,    -1,    -1,    -1,
    4268,   133,    -1,   133,   136,    -1,   136,    -1,  2396,    -1,
      -1,    -1,    -1,    -1,  2450,    -1,  2404,    -1,  4286,  2407,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     162,  2419,   162,    -1,    -1,  4303,    -1,    -1,    -1,    -1,
    4308,    -1,    -1,    -1,    -1,    -1,    -1,  4315,    -1,    -1,
    2486,    -1,    -1,  2489,    -1,  2491,    -1,    -1,    -1,  2495,
      -1,  2497,  2498,  4331,   196,    -1,   196,    -1,    -1,    -1,
    2506,  2507,  2508,    -1,    -1,    -1,    -1,  4345,    -1,    -1,
      -1,    10,    -1,  3367,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,   185,    -1,    -1,    -1,
      -1,   190,    -1,    -1,    -1,    34,    -1,    -1,  4376,    -1,
    3394,    -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,
      49,    -1,    -1,   212,   213,  2561,    -1,   259,    -1,   259,
      -1,   263,    -1,   263,    -1,    -1,    -1,  4405,   227,    -1,
      -1,   273,    -1,   273,    -1,    74,    -1,    -1,    -1,    -1,
     282,    -1,   282,  4421,  2257,    -1,    -1,  2593,    -1,    -1,
      -1,  3445,   294,    -1,   294,    -1,    -1,    -1,  2271,  2605,
      -1,    -1,    -1,    -1,  4602,    -1,  4444,   266,    -1,    -1,
      -1,  4609,    -1,  4451,    -1,    -1,  4614,    -1,    -1,  4617,
    4618,   280,    -1,    -1,   283,    -1,    -1,    -1,    -1,    -1,
      -1,   333,    -1,   333,   336,   337,   336,   337,    -1,  2312,
      -1,    -1,    -1,    -1,    -1,  4643,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2661,    -1,    -1,  4496,    -1,
    4498,    -1,    -1,    -1,   366,    -1,   366,    -1,    -1,    -1,
    2628,  2629,    -1,    -1,    -1,    -1,  2634,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   185,    -1,    -1,    -1,
      -1,   190,    -1,    -1,    -1,    -1,    -1,  4535,  4696,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   371,   212,   213,    -1,  4554,    -1,    -1,    -1,
    4558,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   227,    -1,
      -1,    -1,   434,    -1,   434,    -1,    -1,    -1,    -1,  2697,
      -1,    -1,  4740,    -1,    -1,  4583,  4584,    -1,    -1,  4587,
      -1,    -1,    -1,  3607,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4602,    -1,    -1,   266,    -1,  3623,
      -1,  4609,  3626,    -1,    -1,    -1,  4614,    -1,    -1,  4617,
    4618,   280,    -1,    -1,   283,    -1,  4624,  4625,    -1,    -1,
      -1,    -1,    -1,    -1,  3648,    -1,    -1,    -1,    -1,  4637,
      -1,  4639,    -1,    -1,    -1,  4643,    -1,    -1,    -1,    -1,
      -1,  4809,   471,    -1,    -1,   474,   475,   476,    -1,   478,
     479,   480,   481,   482,   483,    -1,    -1,    -1,    -1,   488,
      -1,    -1,    -1,    -1,    -1,  4833,    10,    -1,    -1,    13,
      -1,    -1,  2515,    17,    18,    19,    -1,  4685,  4686,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4696,    -1,
      34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    -1,
      -1,    -1,   371,    -1,    -1,    49,    -1,    -1,    -1,    -1,
      -1,  4879,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2902,  4735,    -1,    -1,
      74,    -1,  4740,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2900,    -1,  2902,    34,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,
      49,    -1,    -1,    -1,    -1,    -1,    -1,  2925,  2926,    -1,
      -1,  4809,   471,  4811,    -1,   474,   475,   476,    -1,   478,
     479,   480,   481,   482,   483,    74,    -1,    -1,    -1,   488,
      -1,    -1,    -1,    -1,  4992,  4833,    -1,  4835,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3011,    -1,  4845,  4846,    -1,
    4848,   185,  4850,    -1,    -1,    -1,   190,    -1,    10,  5017,
      -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,
      -1,  4869,    -1,    -1,    -1,    -1,    -1,  4875,   212,   213,
      -1,  4879,    34,    -1,    -1,    -1,    -1,  4885,  2721,    -1,
      42,  4889,    -1,   227,    -1,    -1,    -1,    49,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2738,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2753,    -1,    74,  5081,    -1,  4923,    -1,    -1,  3942,    -1,
      -1,    -1,   266,    -1,  4932,  3101,   185,    -1,    -1,  4937,
    4938,   190,    -1,    -1,  4942,    -1,   280,    -1,    -1,  4947,
    4948,  4949,    -1,    -1,    -1,    -1,  3970,    -1,    -1,    -1,
      -1,    -1,    -1,   212,   213,  4963,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   227,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4985,    -1,    -1,
    3156,    -1,    -1,    -1,  4992,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   266,    -1,  5017,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   280,    -1,   185,   283,    -1,    -1,   371,   190,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5209,    -1,    -1,    -1,  5053,  5054,    -1,  3224,    -1,
     212,   213,    -1,  5221,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   227,    -1,    -1,    -1,    -1,
    5078,    -1,    -1,  5081,    -1,    -1,  5084,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5095,    -1,    -1,
      -1,  5099,  3268,  5101,    -1,  5103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   266,    -1,  3282,  3283,    -1,    -1,
    5278,    -1,   371,    -1,    -1,  5123,  3292,    -1,   280,    -1,
      -1,   283,  3298,    -1,  3300,    -1,    -1,   471,    -1,    -1,
     474,   475,   476,    -1,   478,   479,   480,   481,   482,   483,
    5148,    -1,  5150,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4177,    -1,    -1,    -1,  4181,    -1,    -1,
      -1,    -1,    -1,  5331,  3292,    -1,    -1,    -1,    -1,    -1,
    3346,    -1,  3015,    -1,    -1,    -1,    -1,    -1,    -1,  5347,
      -1,    -1,    -1,    -1,    -1,    -1,  5354,  5355,  3316,    -1,
      -1,  3034,  5200,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5209,    -1,    -1,  3380,  3381,    -1,    -1,    -1,   371,
      -1,    -1,   471,  5221,    -1,   474,   475,   476,    -1,   478,
     479,   480,   481,   482,   483,    -1,    -1,    -1,    -1,   488,
      -1,    -1,    -1,  5241,  5242,  5243,    -1,    -1,    -1,    -1,
      -1,    -1,  5250,  5251,    -1,    -1,  5254,    -1,    -1,    -1,
      -1,    -1,  5260,    -1,    -1,    -1,  5424,  5265,    -1,    -1,
      -1,    -1,  5430,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5278,    -1,    -1,    -1,    -1,    -1,    -1,  3405,    -1,    -1,
      -1,    -1,    -1,  5291,    -1,     8,  3129,    -1,  3131,    -1,
      -1,    14,    15,    -1,    -1,    -1,    -1,    20,    -1,    22,
      -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,    31,   471,
      -1,    -1,   474,   475,   476,    -1,   478,   479,   480,   481,
     482,   483,    -1,  5331,    -1,    -1,   488,    50,    51,  5337,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5347,
      -1,    10,    -1,    -1,    13,    -1,  5354,  5355,    17,    18,
      19,  5359,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5369,    -1,    -1,  5532,    34,    -1,    -1,  3496,    -1,
      -1,    -1,    -1,    42,    -1,    -1,    -1,  5545,    -1,  3222,
      49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5399,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5567,
    5568,    -1,    -1,    10,  3580,    74,    13,    -1,    -1,    -1,
      17,    18,    19,    -1,    -1,    -1,  5424,    -1,    -1,    -1,
    3263,    -1,  5430,    -1,    -1,    -1,    -1,    34,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,    -1,  4463,
      -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5458,  5459,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5468,    -1,    -1,    -1,    -1,  5473,    -1,    74,    -1,    -1,
      -1,    -1,    -1,    -1,  5482,    -1,   199,    -1,    -1,    24,
      -1,    -1,    -1,    -1,   207,    30,    -1,   210,  4512,  4513,
     213,   214,    -1,   216,    -1,   218,  5504,    -1,   221,    -1,
     223,    -1,    -1,    -1,    -1,    -1,  5514,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   185,    -1,  3361,    -1,
      -1,   190,    -1,    -1,  5532,    -1,    -1,    72,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5545,    -1,  5547,
      -1,    -1,    -1,   212,   213,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3396,    -1,    -1,    -1,  5565,   227,  5567,
    5568,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   185,    -1,
      -1,   126,    -1,   190,    -1,  4609,    -1,    -1,   133,    -1,
    4614,   136,    -1,  4617,  3770,    -1,    -1,   266,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   212,   213,    -1,    -1,    -1,
      -1,   280,    -1,    -1,   283,    -1,    -1,   162,    -1,  3795,
     227,    -1,    -1,    -1,    -1,    -1,    -1,  3803,    -1,    -1,
    3806,    -1,  3808,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3770,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   266,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3795,    -1,  3512,
      -1,    -1,    -1,   280,  3802,  3851,   283,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3813,    -1,    -1,    -1,    -1,
      -1,  3867,  3535,    -1,    -1,  3871,  3872,    -1,  3874,    -1,
      -1,    -1,   371,    10,    -1,    -1,    13,    -1,    -1,    -1,
      17,    18,    19,    -1,   259,    -1,    -1,  3560,   263,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,   273,    -1,
      -1,    -1,    -1,    -1,    -1,    42,    -1,   282,    -1,    -1,
      -1,    -1,    49,  4767,    -1,    -1,    -1,    -1,    -1,   294,
      -1,    -1,    -1,  3596,    -1,    -1,    -1,    -1,    -1,    -1,
    3888,  3889,    -1,    -1,   371,    10,    -1,    74,    13,    -1,
      -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,
      -1,  4805,    -1,    -1,    -1,    -1,    -1,    -1,   333,    34,
      -1,   336,   337,    -1,    -1,    -1,    -1,    42,  3974,    -1,
      -1,  3977,   471,    -1,    49,   474,   475,   476,    -1,   478,
     479,   480,   481,   482,   483,    -1,    -1,    -1,    -1,   488,
      -1,   366,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    74,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3977,
      -1,    -1,    -1,    -1,    -1,  4879,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   471,  4889,    -1,   474,   475,   476,
      -1,   478,   479,   480,   481,   482,   483,    -1,   185,    -1,
      -1,   488,    -1,   190,    -1,    -1,  4062,  4063,  4064,   434,
    4066,  4067,  4068,  4069,  4070,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   212,   213,    -1,    -1,    -1,
     633,    -1,    -1,    -1,    -1,    -1,  4044,   640,   641,    -1,
     227,   644,    -1,   646,   647,    -1,    -1,    -1,   651,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   662,
     185,    -1,    -1,    -1,    -1,   190,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,   266,
      17,    18,    19,    -1,    -1,    -1,    -1,   212,   213,    -1,
      -1,    -1,    -1,   280,    22,    -1,   283,    -1,   701,    27,
     703,    -1,   227,    -1,    -1,    42,    -1,    -1,    -1,    -1,
     713,    -1,    49,  5017,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5027,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    62,    -1,    -1,    74,    -1,    -1,
      -1,   266,  4198,   746,  4200,    -1,    -1,    75,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   280,    -1,    -1,   283,    -1,
      -1,    -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     108,    -1,    -1,    -1,   371,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   131,    -1,    -1,  3929,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   142,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   834,    -1,    -1,    -1,   163,    -1,    -1,    -1,    -1,
     168,    -1,    -1,    -1,    -1,    -1,   371,   175,   185,    -1,
      -1,    -1,    -1,   190,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4270,    -1,    -1,    -1,   194,   870,  4276,    -1,
      -1,    -1,  4280,    -1,    -1,   212,   213,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   471,    -1,    -1,   474,   475,   476,
     227,   478,   479,   480,   481,   482,   483,    -1,  4306,  4307,
      -1,   488,    -1,  4311,  4312,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   240,    -1,    -1,    -1,    -1,    -1,  4374,  4375,
      -1,    -1,    -1,    -1,    -1,    -1,  5230,    -1,    -1,   266,
      -1,  4387,    -1,  4389,  4390,    -1,    -1,  4393,    -1,    -1,
     943,    -1,    -1,   280,    -1,    -1,   471,    -1,    -1,   474,
     475,   476,   280,   478,   479,   480,   481,   482,   483,    -1,
      -1,   964,    -1,   488,    -1,   293,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   976,    -1,    -1,   304,    -1,   981,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   314,   315,   991,    -1,
     318,    -1,    -1,   996,    -1,    -1,    -1,    -1,    24,    -1,
      -1,  4457,  1005,    -1,    30,    -1,    -1,  1010,    -1,    -1,
    1013,    -1,    -1,    -1,    -1,  4138,   344,    -1,    -1,   347,
      -1,  5325,    -1,   351,    -1,   353,    -1,    -1,    -1,    -1,
      -1,    -1,   360,    -1,   371,   363,    -1,    -1,    -1,  4495,
      -1,    -1,    -1,    -1,    -1,    -1,    72,    -1,    -1,  5353,
      -1,    -1,  1055,    -1,   382,    -1,    -1,    -1,    -1,    -1,
      -1,   389,    -1,    -1,    -1,    -1,    -1,   395,    -1,    -1,
     398,    -1,    -1,    -1,   402,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   410,    -1,   412,  4541,    -1,    -1,    -1,   417,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,   194,    -1,
     126,   197,   430,   201,   202,    -1,    -1,   133,    -1,    -1,
     136,   209,    -1,   211,   212,   443,    -1,    -1,    -1,    -1,
      -1,   217,  4245,    -1,    -1,    -1,    -1,   225,   224,  5433,
      -1,    -1,     0,    -1,   471,    -1,   162,   474,   475,   476,
      -1,   478,   479,   480,   481,   482,   483,    -1,    -1,    -1,
      -1,    -1,    20,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    30,  4286,    32,    33,    -1,    -1,    -1,  1172,
     196,  1174,    -1,  1176,    -1,  1178,    -1,  1180,  1181,  1182,
      48,    -1,    -1,    -1,  1187,  4308,    -1,    -1,    -1,    57,
      -1,    -1,    -1,    -1,    -1,  1198,    -1,    -1,    -1,    -1,
      -1,    69,    -1,    71,    72,    -1,    -1,    -1,    -1,    -1,
      78,    -1,    80,    -1,    -1,  1218,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    -1,    93,    -1,    -1,    -1,  4685,
      -1,  5535,    -1,   259,    -1,    -1,    -1,   263,    -1,    -1,
      -1,    -1,   110,    -1,    -1,   113,    -1,   273,    -1,    -1,
      -1,    -1,    -1,  4376,    -1,    -1,   282,    -1,    -1,   127,
      -1,   129,    -1,    -1,    -1,   133,    -1,    -1,   294,    -1,
      -1,   139,    -1,    -1,  4730,    -1,    -1,  4685,    -1,   147,
      -1,   149,    -1,  4739,    -1,    -1,    -1,    -1,   156,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   172,    -1,    -1,   333,    -1,    -1,
     336,   337,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,
      -1,   189,    13,    -1,    -1,    -1,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     366,    -1,    24,    34,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    10,    49,    -1,
      13,   229,   230,    -1,    17,    18,    19,   235,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4498,  1379,    -1,    -1,   247,
      -1,    34,    -1,    74,    -1,    -1,    -1,    -1,    -1,    42,
      72,    -1,    -1,    -1,    -1,    -1,    49,   265,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   434,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    74,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   301,    -1,  4558,    -1,    -1,    -1,    -1,
      -1,   309,    -1,    -1,   126,    -1,    -1,    -1,    -1,    -1,
      -1,   133,    -1,    -1,   136,   323,    -1,    -1,  1461,    -1,
      -1,   329,   330,    -1,   332,    -1,    -1,    -1,    -1,   337,
      -1,    -1,    -1,    -1,   342,    -1,    -1,   345,    -1,    -1,
     162,    -1,    -1,    -1,   352,    -1,    -1,    -1,    -1,    -1,
     358,   359,    -1,    -1,   185,    -1,    -1,    -1,   366,   190,
      -1,    -1,   370,    -1,    -1,    -1,    -1,  4963,    -1,    -1,
      -1,  4967,   380,    -1,   196,    -1,    -1,    -1,    -1,    -1,
      -1,   212,   213,    -1,    -1,    -1,    -1,   395,    -1,   625,
    1533,   627,   185,    -1,    -1,   631,   227,   190,   636,    -1,
      -1,    -1,    -1,    -1,   642,    -1,    -1,   415,    -1,   645,
      -1,    -1,    -1,    -1,    -1,  4963,   652,   655,   426,   212,
     213,    -1,    -1,    -1,   432,    -1,    -1,    -1,    -1,   437,
      -1,    -1,    -1,   671,   227,   266,    -1,   259,    -1,    -1,
      -1,   263,   450,    -1,    -1,    -1,    -1,   685,   686,   280,
      -1,   273,   283,    -1,   692,    -1,   694,   695,    -1,    -1,
     282,    58,    -1,    -1,    -1,   473,    -1,    -1,    -1,    -1,
     708,    -1,   294,   266,    -1,    -1,    -1,    -1,    -1,   487,
     718,    -1,   490,    -1,    -1,    -1,    -1,   280,    -1,    -1,
     283,    -1,    -1,    -1,    -1,    92,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   333,    -1,    -1,   336,   337,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     371,    -1,    -1,    10,   366,    -1,    13,    -1,    -1,    -1,
      17,    18,    19,    -1,  5150,   152,    -1,    -1,  5154,    -1,
    5156,    -1,    -1,    -1,  5160,  5161,    -1,    34,    -1,   807,
      -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,   371,    -1,
      -1,    -1,    49,  4846,    -1,    -1,    -1,    -1,    -1,    -1,
     187,    -1,  5140,   831,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   844,    74,    -1,    -1,
      -1,    -1,   434,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4885,    -1,    -1,    -1,   223,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1779,    -1,    -1,    -1,
     471,    -1,    -1,   474,   475,   476,    -1,   478,   479,   480,
     481,   482,   483,    -1,    -1,    -1,    -1,   488,    -1,    -1,
     896,   897,   259,    -1,    -1,    -1,   263,    -1,    -1,  4932,
      -1,    -1,    -1,    -1,  4937,  4938,    -1,    -1,   471,    -1,
      -1,   474,   475,   476,    -1,   478,   479,   480,   481,   482,
     483,    -1,    -1,    -1,    -1,   488,    -1,   294,   295,    -1,
      -1,    -1,    -1,    -1,   301,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   953,    -1,    -1,   185,    -1,
      -1,    -1,    -1,   190,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   971,    -1,    -1,   333,    -1,    -1,   977,
     337,    -1,   980,    -1,   341,   212,   213,    -1,    -1,    -1,
      -1,    -1,    -1,   350,    -1,    -1,    -1,    -1,    -1,   995,
     227,   358,    -1,  1906,    -1,  1908,    -1,    -1,    -1,   366,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   378,  1925,    -1,  1927,    -1,    -1,    -1,  1024,  1025,
     387,  5054,    -1,    -1,   391,    -1,    -1,    -1,    -1,   266,
    1943,    -1,  1945,  5399,  1947,    -1,  1949,    -1,  1951,    -1,
      -1,    -1,  1955,   280,  1050,    -1,   283,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   445,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5482,    -1,  1124,  1125,
      -1,  1129,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   371,    -1,    -1,    -1,    -1,  1147,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1165,    -1,    -1,
      -1,    -1,    -1,    -1,  5482,    -1,    10,    -1,    -1,    13,
      -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,  5547,    -1,    -1,    -1,    -1,    -1,  1195,    -1,    -1,
      34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,  5565,
      -1,    -1,    -1,  1211,    -1,    49,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1227,
      -1,  5254,    -1,  1231,    -1,    -1,    -1,    -1,    -1,  5547,
      74,    -1,    -1,    -1,   471,    -1,    -1,   474,   475,   476,
      -1,   478,   479,   480,   481,   482,   483,  5565,    -1,    -1,
      -1,   488,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2185,  2186,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2204,  2205,    -1,    -1,    -1,  2209,  2210,    -1,    -1,
      -1,  2214,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2228,    -1,    -1,    -1,    -1,
      -1,    -1,  2235,    -1,    -1,    -1,  2239,  2240,    -1,    -1,
    2243,  2244,    -1,    -1,    -1,    -1,    -1,  2250,    -1,    -1,
      -1,   185,  1350,    -1,    -1,    -1,   190,    -1,    -1,    -1,
    1358,  1359,  2265,    -1,  2267,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1372,    -1,    -1,    -1,   212,   213,
      -1,    -1,  2285,    -1,    -1,    -1,    -1,  2290,    -1,    -1,
      -1,    -1,    -1,   227,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2305,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2314,    -1,    -1,  2317,    -1,  2319,  2320,  2321,    -1,
      -1,    -1,    -1,  2326,  2327,    -1,    -1,  1425,    -1,    -1,
      -1,    -1,   266,  2336,    -1,    -1,    -1,    -1,  2341,    -1,
      -1,    -1,  2345,    -1,    -1,    -1,   280,    -1,    -1,   283,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2362,
      -1,    -1,    -1,    -1,    -1,  2368,  2369,    -1,    -1,    -1,
      -1,    -1,  2375,    -1,    -1,    -1,    -1,    -1,    10,    -1,
      -1,    13,  2385,  2386,  1480,    17,    18,    19,  2391,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2403,    -1,    34,  2406,    -1,    -1,    -1,    -1,  2411,  1505,
      42,    -1,    -1,    -1,  2417,  2418,    -1,    49,    -1,    -1,
    2423,    -1,    -1,  2426,    -1,    -1,    -1,  2430,  2431,  2432,
    2433,    -1,  2435,    -1,    -1,   202,    -1,   371,    -1,    -1,
      -1,    -1,    74,    -1,   211,  2448,  2449,    -1,  2451,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   225,  2462,
    2463,  2464,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1582,    -1,    34,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1608,  1609,  1610,  1611,    -1,    -1,    -1,    -1,
      -1,    -1,  2525,    10,  1622,    -1,    13,    -1,    74,    -1,
      17,    18,    19,    -1,    -1,    -1,    -1,   471,    -1,    -1,
     474,   475,   476,    -1,   478,   479,   480,   481,   482,   483,
    2553,    -1,    -1,   185,   488,    42,    -1,    -1,   190,    -1,
      -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     212,   213,    -1,    -1,    -1,    -1,    -1,    74,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   227,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   266,    -1,    -1,    -1,    -1,   185,
      -1,    -1,    -1,    -1,   190,    -1,    -1,    -1,   280,    -1,
      -1,   283,    -1,  1749,  1750,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   212,   213,    -1,    -1,
      -1,    -1,  1770,  1769,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   227,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1794,    -1,   185,    -1,
      -1,    -1,    -1,   190,  1802,    -1,    -1,    -1,  1804,  1805,
    1806,  1807,    -1,    -1,    -1,    -1,  1814,    -1,    -1,    -1,
     266,    -1,    -1,    -1,    -1,   212,   213,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   280,    -1,    -1,   283,    -1,   371,
     227,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2757,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   266,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1886,  1887,
      -1,  1889,  1890,   280,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1901,    -1,  1903,  1904,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1916,  1917,
      -1,    -1,    -1,    -1,    -1,   371,  1922,    -1,    -1,    -1,
      -1,    -1,  1928,    -1,  1932,    -1,    -1,    -1,    -1,   471,
      -1,    -1,   474,   475,   476,    -1,   478,   479,   480,   481,
     482,   483,    -1,    -1,    -1,    -1,   488,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1966,   636,
      -1,  1969,  1970,    -1,    -1,   642,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   371,    -1,    -1,    -1,   655,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   671,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   686,
      -1,    -1,    -1,    -1,    -1,   471,    -1,   694,   474,   475,
     476,    -1,   478,   479,   480,   481,   482,   483,    -1,    -1,
      -1,   708,   488,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   718,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2059,    -1,    -1,    -1,    -1,  2062,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   471,    -1,    -1,   474,   475,   476,
      -1,   478,   479,   480,   481,   482,   483,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3009,    -1,    -1,    -1,
    3013,    -1,    -1,    -1,    -1,    -1,  3019,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2129,    -1,    -1,  3037,  3038,    -1,    -1,    -1,  3042,
     807,    -1,    -1,    -1,  3047,  3048,  3049,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   203,    -1,    -1,   831,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   215,    -1,    -1,    -1,   844,    -1,    -1,
    3083,  3084,  3085,  3086,   226,    -1,  2184,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2202,    -1,    -1,    -1,    -1,  2207,
    2208,    -1,    -1,    -1,  2212,    -1,    -1,  3120,    -1,  3122,
    3123,  3124,  2220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,  2255,
    2256,    -1,  2260,    -1,    -1,  2263,  2264,    -1,    -1,    -1,
    2266,    -1,  2268,    34,    -1,    -1,  2272,    -1,    -1,    -1,
      -1,    42,    -1,    -1,    -1,  2283,   953,    -1,    49,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2303,  2304,    -1,    -1,    -1,
      -1,    -1,    -1,    74,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3236,    -1,    -1,  2334,  2335,    -1,    -1,
    2338,    -1,  3245,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2361,    -1,  2363,    -1,    -1,    -1,  2367,
      -1,    -1,    -1,  3276,    -1,    -1,  2374,    -1,    -1,    -1,
      -1,    -1,    -1,  2381,    -1,    -1,  2384,    -1,    -1,    -1,
      -1,    -1,  2390,    -1,    -1,    -1,  3299,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2402,    -1,    -1,  2405,
      -1,    -1,  2410,    -1,    -1,    -1,    -1,    -1,  2416,    -1,
      -1,    -1,    -1,  2421,   185,    -1,  2424,    -1,    -1,   190,
      -1,    -1,    -1,    -1,    -1,    -1,  2434,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3351,  2447,
      -1,   212,   213,  3356,  2452,    -1,    -1,    -1,    -1,    -1,
    2458,    -1,  1129,    -1,    -1,    -1,   227,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1147,    -1,    -1,    -1,    -1,    -1,    -1,  3390,    -1,    -1,
      -1,    -1,  2488,    -1,    -1,    -1,    -1,    -1,  1165,    -1,
    2496,    -1,    -1,  2499,    -1,   266,    -1,    -1,    -1,  2505,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   280,
    2516,    -1,   283,    -1,    -1,    -1,  2524,    -1,  1195,    -1,
    3433,    -1,  3435,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1211,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1227,  2557,    -1,    -1,  1231,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   617,    -1,    10,    -1,    -1,
      13,   623,  3485,    -1,    17,    18,    19,    -1,    -1,  2585,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,
      13,    34,    -1,    -1,    17,    18,    19,  2605,    -1,    42,
     371,    -1,    -1,    -1,    -1,    10,    49,    -1,    13,    -1,
      -1,    34,    17,    18,    19,    -1,    -1,    -1,    -1,    42,
      -1,    -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,    34,
      -1,    74,    -1,    -1,    -1,    -1,    -1,    42,  2644,    -1,
    2646,    -1,    -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,
      -1,    74,    -1,  2661,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    74,
      -1,    -1,    -1,  1350,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1358,  1359,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1372,    -1,  2705,    -1,    -1,
     471,    -1,    -1,   474,   475,   476,    -1,   478,   479,   480,
     481,   482,   483,    -1,    -1,  2723,    -1,   488,    -1,    -1,
      -1,    -1,    -1,  2731,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2741,    -1,    -1,  2744,    -1,    -1,  2747,
      -1,    -1,   185,    -1,    -1,    -1,    -1,   190,  1425,    -1,
    2756,    -1,   804,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   185,    -1,    -1,    -1,    -1,   190,    -1,   212,
     213,   823,    -1,    -1,    -1,    -1,    -1,  3690,    -1,  3692,
     185,    -1,    -1,    -1,   227,   190,  3699,    -1,    -1,   212,
     213,    -1,    -1,   845,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3715,    -1,   227,    -1,  2814,   212,   213,    -1,
      -1,    -1,  2820,    -1,  3727,    -1,    -1,    -1,  3731,    -1,
      -1,    -1,   227,   266,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3749,   280,    -1,   891,
     283,    -1,    -1,   266,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3767,    -1,    -1,   280,    -1,  3772,
     283,   266,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   280,    -1,    -1,   283,    -1,
      -1,    -1,    -1,    -1,  3797,    -1,    -1,    -1,  3801,    -1,
      -1,    -1,    -1,    -1,  2902,    -1,  3809,  3810,  3811,  3812,
      -1,    -1,    -1,    -1,    -1,  3818,  3819,  3820,  3821,    -1,
      -1,    -1,  3825,  3826,    -1,    -1,    -1,    -1,  3831,  3832,
      -1,  3834,  3835,  3836,  3837,  3838,  3839,  3840,   371,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3850,    -1,    -1,
      -1,  3854,  3855,  3856,  3857,  1622,    -1,    -1,   371,    -1,
      -1,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,
      18,    19,    -1,    -1,    -1,  1017,   371,  3880,    -1,    -1,
      -1,    -1,    -1,  2981,  2982,    -1,    34,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    42,    -1,  3899,    -1,    -1,    -1,
      -1,    49,    -1,    -1,  1046,  1047,  1048,    -1,    -1,    -1,
    3008,    -1,    -1,  3011,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3021,    74,  3023,  3024,  3025,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   471,    -1,
      -1,   474,   475,   476,    -1,   478,   479,   480,   481,   482,
     483,    -1,    -1,    -1,    -1,   488,    -1,    -1,   471,    -1,
      -1,   474,   475,   476,    -1,   478,   479,   480,   481,   482,
     483,    -1,    -1,    -1,    -1,   488,   471,    -1,    -1,   474,
     475,   476,    -1,   478,   479,   480,   481,   482,   483,    -1,
      -1,    -1,    -1,   488,    -1,    -1,  3999,  3095,  3096,  3097,
      -1,    -1,    -1,  1770,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3119,    -1,    -1,    -1,    -1,    -1,  1794,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1802,    -1,   185,    -1,    -1,
      -1,  3139,   190,    -1,    -1,    -1,    -1,  1814,  4051,    -1,
      -1,    -1,  1194,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3158,    -1,    -1,    -1,   212,   213,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1217,    -1,    -1,    -1,   227,
      -1,    -1,    -1,    -1,  1226,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   266,    -1,
      -1,    -1,  1889,  1890,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   280,    -1,    -1,   283,  1903,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3244,    -1,    -1,  1916,
    1917,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1932,    -1,    -1,  3264,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3291,    -1,    -1,    -1,    -1,    -1,    -1,
    3298,    -1,  3300,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3313,    -1,  3315,    -1,    -1,
      -1,    -1,  1364,   371,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3337,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4253,    -1,    -1,    -1,  4257,  4258,  4259,  4260,    -1,    -1,
      -1,  4264,    -1,    -1,    -1,    -1,    -1,    -1,  1410,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   681,
      -1,    -1,    -1,  3381,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2059,    -1,    -1,  4298,  4299,  4300,  4301,  4302,
      -1,  4304,  4305,    -1,    -1,   707,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4316,  4317,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   471,    -1,    -1,   474,   475,   476,    -1,
     478,   479,   480,   481,   482,   483,    -1,    -1,  3436,    -1,
     488,    -1,    -1,  4346,  3440,    -1,    -1,    -1,    -1,    -1,
      -1,  1493,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1502,    -1,  2129,    -1,    -1,    -1,  3464,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3486,    -1,
      -1,  3489,  1534,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1557,    -1,  2184,  1560,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2202,    -1,    -1,    -1,    -1,
    2207,  2208,    -1,    -1,    -1,  2212,    -1,  4450,    -1,    -1,
      -1,    -1,    -1,  2220,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1612,  2238,    -1,  3571,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1626,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4510,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2283,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2303,  2304,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   951,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   967,    -1,  2334,  2335,    -1,
      -1,  2338,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     992,    -1,    -1,    -1,  2361,  1737,  2363,    -1,    -1,    -1,
    2367,    -1,    -1,    -1,    -1,  1007,    -1,  2374,  3704,  3705,
    3706,  3707,    -1,    -1,  2381,    -1,  3714,  2384,    -1,    -1,
      -1,    -1,    -1,  2390,    -1,    -1,    -1,    -1,    -1,    -1,
    4633,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2410,    -1,    -1,  1788,    -1,    -1,  2416,
      -1,    -1,    -1,    -1,  2421,    -1,    -1,  2424,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3764,  2434,    -1,    -1,
      -1,  3769,    -1,  3771,    -1,  1817,    -1,    -1,    -1,    -1,
    2447,    -1,  1824,    -1,  4687,  2452,    -1,    -1,    -1,    -1,
    1092,  2458,    -1,    -1,    -1,    -1,  3794,    -1,   801,   802,
      -1,    -1,    -1,  4706,    -1,    -1,    -1,    -1,  4711,  4712,
      -1,    -1,    -1,    -1,    -1,    -1,  3814,    -1,  4721,    -1,
      -1,    -1,    -1,    -1,    -1,  4728,    -1,    -1,    -1,    -1,
      -1,    -1,  3830,    -1,    -1,  3833,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2524,    -1,    -1,
      -1,  4764,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4784,    -1,  4786,    -1,    -1,    -1,  3883,  1930,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4801,  1941,
      -1,    -1,  3898,    -1,    -1,    -1,    -1,  1209,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4821,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3925,  3926,    -1,
    1972,  1973,    -1,    -1,    -1,    -1,  4839,  3935,  2605,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    13,  1989,   951,   952,
      17,    18,    19,    -1,    -1,    -1,  3954,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,
      -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2661,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    74,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4919,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4931,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2705,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2089,    -1,  4047,
      -1,    -1,    -1,    -1,    -1,    -1,  2723,  2099,    -1,    -1,
      -1,    -1,    -1,    -1,  2731,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,
      -1,    -1,    17,    18,    19,    -1,  2128,    -1,    -1,    -1,
      -1,    -1,    -1,  4996,    -1,    -1,    -1,  2139,  2140,    34,
      -1,    -1,    -1,    38,    -1,    -1,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    -1,    49,    -1,    -1,  1419,   185,    -1,
      -1,    -1,    -1,   190,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2173,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    74,
      -1,    -1,    -1,    -1,    -1,   212,   213,  2814,    -1,    -1,
      -1,    -1,    -1,  2820,    -1,    -1,    -1,    -1,  5061,    -1,
     227,    -1,  5065,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1487,    -1,    -1,   123,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   266,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   280,    -1,    -1,   283,  5120,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1528,    -1,    -1,    -1,
      -1,    -1,  5135,    -1,    -1,  2902,    -1,    -1,    -1,    -1,
    1243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     185,    -1,    -1,    -1,    -1,   190,    -1,    -1,    -1,  1561,
      -1,    -1,    -1,    -1,    -1,  4263,    -1,    -1,    -1,    -1,
    4268,  1274,    -1,    -1,  2316,    -1,  5179,   212,   213,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2331,
      -1,  5194,   227,    -1,    -1,    -1,    -1,    -1,    -1,  1302,
    1303,  1304,    -1,  1306,   371,  4303,    -1,    -1,    -1,    -1,
    2352,    -1,    -1,    -1,  2981,  2982,    -1,  4315,    -1,    -1,
      -1,    -1,    -1,  1326,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   266,    -1,    -1,    -1,  1637,  1638,  1639,    -1,    -1,
      -1,  3008,    -1,    -1,  3011,   280,    -1,  4345,   283,    24,
      -1,    -1,    -1,    -1,    -1,    30,   681,    -1,    -1,    -1,
    4356,    -1,    37,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5277,  4371,    -1,    -1,    -1,    -1,
      -1,    56,   707,    -1,    -1,    -1,  2428,  2429,    -1,    -1,
      -1,  1394,    -1,    -1,    -1,  1398,  1399,    72,    -1,    -1,
      -1,    -1,    -1,    -1,   471,    -1,    -1,   474,   475,   476,
      -1,   478,   479,   480,   481,   482,   483,    -1,  5321,   486,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3095,  3096,
    3097,   106,    -1,    -1,    -1,    -1,   371,    -1,  1740,    -1,
      -1,    -1,    -1,    -1,   681,    -1,  4444,    -1,    -1,    -1,
      -1,   126,  3119,    -1,    -1,  1757,    -1,    -1,   133,    -1,
      -1,   136,    -1,    -1,    -1,    -1,    -1,    -1,  4464,    -1,
     707,    -1,  3139,  1775,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   162,    -1,    -1,
      -1,  3158,    -1,  2535,    -1,    -1,   431,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5412,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,    -1,
      -1,   196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1831,
      -1,    -1,    -1,    -1,    -1,    -1,   471,  4535,    -1,   474,
     475,   476,  1844,   478,   479,   480,   481,   482,   483,    -1,
      -1,    -1,    -1,    -1,    -1,  1857,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   241,  1869,    -1,   244,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3244,    -1,    -1,
      -1,    -1,    -1,    -1,   259,    -1,    -1,    -1,   263,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   282,    -1,    -1,
      -1,  1913,  1914,    -1,    -1,    -1,    -1,    -1,   293,   294,
      -1,    -1,    -1,    -1,  3291,    -1,    -1,    -1,    -1,    -1,
      -1,  3298,    -1,  3300,  1637,  1638,  1639,    -1,    -1,  4637,
      -1,  4639,   967,    -1,    -1,    -1,  3313,    -1,  3315,  4645,
      -1,  4647,    -1,    -1,    -1,    -1,    -1,    -1,   333,    -1,
      -1,   336,   337,   338,    -1,    -1,    -1,   992,    -1,    -1,
    3337,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1007,    -1,    -1,   360,    -1,    -1,  4686,    -1,
      -1,   366,    -1,    -1,    -1,    -1,    -1,    -1,  4696,    -1,
      -1,    -1,    -1,    -1,    -1,   380,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3381,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     967,    -1,    -1,    -1,    -1,    -1,    -1,  4735,    -1,    -1,
      -1,    -1,  4740,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2054,    -1,    -1,   992,    -1,    -1,    -1,   434,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1092,    -1,  3436,
    1007,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2092,    -1,    -1,    -1,    -1,    -1,    -1,  3464,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4807,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3486,
      -1,    -1,  3489,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2887,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1092,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,  2910,    13,
      -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1209,    -1,    -1,    -1,    -1,  2191,
      34,    -1,    -1,  2195,  2196,    -1,    -1,    -1,    42,    -1,
      -1,    -1,    -1,    -1,  3571,    49,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4923,    -1,    -1,    -1,    -1,
      74,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,
      -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,
      -1,  4949,    -1,    -1,    -1,  2257,    -1,  4953,    -1,  4955,
      -1,    -1,    34,    -1,    -1,  4963,    -1,    -1,    -1,  2271,
      42,    -1,  1209,    -1,    -1,    -1,    -1,    49,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    74,    -1,    -1,    -1,    -1,    -1,  2011,    -1,
    2312,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2023,    -1,  2025,    -1,  2027,    -1,    -1,  2030,  2031,  2032,
      -1,    -1,    -1,   681,  2037,    -1,    -1,  2040,    -1,    -1,
      -1,   185,    -1,    -1,    -1,    -1,   190,  3714,    -1,    -1,
      -1,    -1,  2055,  2056,  2057,  2058,    -1,    -1,    -1,   707,
    2063,    -1,    -1,    -1,  2067,    -1,    -1,  2070,   212,   213,
    2073,  2074,  2075,  2076,  2077,  2078,  2079,  2080,  2081,    -1,
    2083,    -1,    -1,   227,    -1,    -1,    -1,  2090,   160,  2092,
      -1,    -1,    -1,    -1,  1419,  3137,    -1,  3764,    -1,    -1,
      -1,    -1,  3769,    -1,  3771,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   185,    -1,    -1,  1353,    -1,   190,    -1,
      -1,    -1,   266,    -1,    -1,    -1,    -1,  3794,    -1,    -1,
      -1,    -1,  2135,    -1,    -1,    -1,   280,    -1,    -1,   283,
     212,   213,    -1,    -1,    -1,    -1,    -1,  3814,    -1,    -1,
    5148,    -1,  5150,    -1,    -1,   227,  2159,  2160,   302,    -1,
      -1,    -1,  1487,  3830,    -1,    -1,  3833,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2478,    -1,    -1,    -1,
      -1,    -1,  1419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5189,   266,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1528,    -1,    -1,    -1,    -1,   280,    -1,
      -1,   283,    -1,  2515,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   371,    -1,    -1,
      -1,    -1,    -1,    -1,   306,    -1,  1561,    10,  2241,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,
    1487,    -1,    -1,  5251,    -1,    -1,    -1,    -1,  3925,  3926,
      -1,    34,  3304,  3305,  3306,    -1,    -1,  5265,  3935,    42,
      -1,    -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,  3321,
    5278,    -1,    -1,    -1,    -1,    -1,    -1,  3954,    -1,    -1,
      -1,  1528,    -1,  5291,    -1,  2597,    -1,  5293,  2600,   371,
      -1,    74,  3344,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3354,  3355,    -1,    -1,    -1,  3359,    -1,   967,
      -1,    -1,    -1,    -1,  1561,    -1,    -1,   471,    -1,    -1,
     474,   475,   476,    -1,   478,   479,   480,   481,   482,   483,
      -1,    -1,    -1,    -1,   992,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5354,  5355,    -1,  1007,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4047,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   161,    -1,
      -1,    -1,    -1,   166,    -1,    -1,    -1,  5393,    -1,   471,
      -1,  5399,   474,   475,   476,    -1,   478,   479,   480,   481,
     482,   483,   185,    -1,    -1,  1740,    -1,   190,    -1,  2721,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5425,
    5426,    -1,  1757,    -1,    -1,    -1,  2738,    -1,    -1,   212,
     213,    -1,  3484,    -1,  1092,  3487,    -1,    -1,    -1,    -1,
    1775,  2753,    -1,    -1,   227,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2476,  2477,  2478,    -1,    -1,    -1,  2482,
      -1,    -1,    -1,    -1,  5482,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   266,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1740,    -1,    -1,  1831,   280,    -1,    -1,
     283,  2514,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1844,
    1757,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1857,  5529,    -1,    -1,    -1,    -1,  1775,    -1,
      -1,    -1,    -1,    -1,  1869,    -1,    -1,    -1,    -1,  5547,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1209,    -1,    -1,    -1,    -1,    -1,  5565,    -1,  5567,
    5568,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3620,  3621,
    3622,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1913,  1914,
      -1,    -1,    -1,    -1,  1831,    -1,  4263,    -1,   371,    -1,
      -1,  4268,    -1,    -1,    -1,    -1,    -1,  1844,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1857,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1869,    -1,    -1,    -1,  4303,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4315,    -1,
      -1,    -1,    -1,    -1,  2956,    -1,    -1,  2959,    -1,  2961,
      -1,    -1,    -1,    -1,  2966,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1913,  1914,  4345,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,   471,    -1,
      -1,   474,   475,   476,    -1,   478,   479,   480,   481,   482,
     483,    34,    -1,  3015,    -1,    -1,    -1,    -1,    -1,    42,
      -1,    -1,    -1,    -1,    -1,    -1,    49,   681,    -1,  2054,
      -1,    -1,  3034,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    74,    -1,   707,    -1,    -1,    -1,  3059,    -1,    -1,
      -1,  2764,    -1,    -1,    -1,    -1,  2769,    -1,    -1,    -1,
      -1,  1419,    -1,    -1,    -1,    -1,    -1,  4444,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2795,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2806,    -1,  2808,  2809,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2819,  2054,    -1,  2822,
      -1,  2824,    -1,    -1,    -1,    -1,    -1,  3129,    -1,  3131,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,  1487,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3896,    -1,  2859,    -1,  2861,    -1,
    2863,    34,   185,    -1,    37,  3907,  2191,   190,  4535,    42,
    2195,  2196,    -1,    -1,    -1,    -1,    49,    -1,    -1,    -1,
    1528,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   212,
     213,    -1,    -1,    -1,    -1,    -1,  3938,    -1,    -1,    -1,
      -1,    74,    -1,    -1,   227,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    13,  1561,    -1,  2918,    17,    18,    19,    -1,
    3222,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3971,
    2933,    -1,  2257,    34,    -1,    -1,    37,    -1,    -1,    -1,
      -1,    42,    -1,   266,    -1,    -1,  2271,  3249,    49,    -1,
      -1,    -1,    -1,  3255,  2191,    -1,    -1,   280,  2195,  2196,
     283,  3263,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4637,    -1,  4639,    74,    -1,    -1,    -1,    -1,    -1,    -1,
    4022,    -1,    -1,    -1,  2987,   308,    -1,  2312,    -1,    -1,
    3292,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   185,   967,    -1,    34,    -1,   190,    -1,  4686,
    2257,    -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,
      49,    -1,    -1,    -1,  2271,    -1,    -1,    -1,   992,   212,
     213,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   371,    -1,
      -1,    -1,    -1,  1007,   227,    74,    -1,    -1,    -1,  3361,
      -1,    -1,    -1,    -1,    -1,   388,    -1,    -1,  4735,    -1,
      -1,    -1,    -1,    -1,    -1,  2312,    -1,    -1,    -1,    -1,
    3382,    -1,    -1,    -1,   185,    -1,    -1,    -1,    -1,   190,
      -1,    -1,  1740,   266,  3396,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   280,    -1,  1757,
     283,   212,   213,    -1,    -1,    -1,  4158,  4159,  4160,  4161,
      -1,    -1,    -1,    -1,    -1,    -1,   227,  1775,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1092,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   166,   471,    -1,
      -1,   474,   475,   476,    -1,   478,   479,   480,   481,   482,
     483,    -1,    -1,    -1,    -1,   266,   185,    -1,    -1,    -1,
      -1,   190,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   280,
      -1,    -1,   283,  1831,    -1,    -1,    -1,    -1,    -1,    -1,
    2515,    -1,    -1,   212,   213,    -1,  1844,    -1,   371,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   227,  1857,
    3512,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1869,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3535,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3249,   266,    -1,    -1,
      -1,    -1,  3255,    -1,    -1,  1209,  4923,    -1,  3560,    -1,
      -1,   280,    -1,    -1,   283,  1913,  1914,    -1,    -1,    -1,
     371,    -1,  2597,    -1,    -1,  2600,    -1,    -1,  2515,    -1,
      -1,    -1,  4949,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3596,    -1,  4963,    -1,   471,    -1,
      -1,   474,   475,   476,    -1,   478,   479,   480,   481,   482,
     483,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    34,    -1,    -1,    37,    -1,    -1,    -1,
      -1,    42,   371,    -1,    -1,    -1,    -1,    -1,    49,    -1,
    2597,    -1,    -1,  2600,    -1,    -1,    -1,    -1,    -1,  3671,
     471,    -1,    -1,   474,   475,   476,    -1,   478,   479,   480,
     481,   482,   483,    74,    10,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,    -1,    -1,  2721,    -1,    -1,    -1,
      -1,   681,    -1,    -1,    -1,    -1,  2054,    -1,    34,    -1,
      -1,    -1,    -1,  2738,    -1,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    -1,    49,    -1,    -1,    -1,   707,  2753,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    74,    -1,
      -1,    -1,   471,    -1,    -1,   474,   475,   476,  4500,   478,
     479,   480,   481,   482,   483,  1419,    -1,    -1,  3770,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5148,    -1,  5150,  2721,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3795,   185,    -1,    -1,    -1,    -1,   190,
      -1,  2738,    -1,    -1,    -1,    -1,  3509,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3518,  2753,    -1,    -1,    -1,
      -1,   212,   213,  3526,    -1,  3528,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1487,    -1,    -1,   227,    -1,    -1,    -1,
      -1,    -1,    -1,  2191,    -1,    -1,    -1,  2195,  2196,    -1,
      -1,    -1,  3555,  3556,    -1,    -1,    -1,    -1,    -1,   185,
      -1,    -1,    -1,    -1,   190,    -1,    -1,    -1,    -1,    -1,
    3573,    -1,    -1,    -1,  1528,   266,    -1,    -1,  3581,    -1,
      -1,  3584,    -1,  3586,  5251,    -1,   212,   213,    -1,   280,
      -1,    -1,   283,    -1,    -1,  3598,    -1,    -1,  5265,    -1,
      -1,   227,    -1,  3606,  3607,    -1,    -1,  1561,    -1,  2257,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2271,  5291,    -1,    -1,  3929,    -1,    -1,
      -1,  2956,    -1,    -1,  2959,  3638,  2961,    -1,    -1,    -1,
     266,  2966,    -1,    -1,    -1,    -1,    -1,   681,    -1,    -1,
      -1,    -1,    -1,    -1,   280,    -1,    -1,   283,    -1,    -1,
      -1,  3664,    -1,    -1,  2312,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   707,    -1,  3977,    -1,    -1,    -1,  3981,
     371,    -1,    -1,    -1,    -1,    -1,    -1,   967,    -1,    -1,
    3015,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4743,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3034,
      -1,    -1,   992,    -1,    -1,    -1,  4758,    -1,    -1,  2956,
      -1,  4763,  2959,    -1,  2961,    -1,    -1,  1007,    -1,  2966,
      -1,    -1,  5399,    -1,  3059,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   371,    -1,  4789,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   403,  3015,    -1,
     471,    -1,    -1,   474,   475,   476,  1740,   478,   479,   480,
     481,   482,   483,    -1,    -1,    -1,    -1,  3034,    -1,    -1,
      -1,    -1,    -1,  1757,  3129,    -1,  3131,    -1,    -1,    -1,
      -1,    -1,  1092,    -1,    -1,  5482,    -1,    -1,    -1,    -1,
      -1,  1775,  3059,    -1,    -1,    -1,  4128,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4138,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   471,    -1,    -1,   474,   475,
     476,    -1,   478,   479,   480,   481,   482,   483,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2515,    -1,    -1,
      -1,    -1,  4914,    -1,    -1,    -1,    -1,  1831,    -1,    -1,
    5547,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1844,    -1,  3129,    -1,  3131,    -1,    -1,  3222,  5565,    -1,
      -1,    -1,    -1,  1857,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1869,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1209,
      -1,    -1,    -1,   967,    -1,    -1,    -1,    -1,  3263,    -1,
      -1,    -1,    -1,  4245,    -1,    -1,    -1,    -1,    -1,  2597,
      -1,    -1,  2600,    -1,    -1,    -1,    -1,    -1,   992,  1913,
    1914,    -1,    -1,    -1,    -1,    -1,    -1,  3292,    -1,    -1,
      -1,    -1,  5014,  1007,    -1,    -1,    -1,    -1,    -1,  3982,
    3983,    -1,    -1,    -1,  4286,  3222,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4308,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   681,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3263,    -1,    -1,    -1,
      -1,    -1,    -1,  4036,    -1,    -1,  3361,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   707,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3292,    -1,  3382,  1092,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4072,
      -1,  3396,    -1,  2721,  4376,    -1,    -1,    -1,    -1,    -1,
      -1,  4084,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2738,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2054,    -1,    -1,    -1,    -1,  2753,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4125,  4126,  3361,    -1,    -1,    -1,    -1,  4132,
    4133,    -1,    -1,    -1,  4137,    -1,    -1,    -1,    -1,  1419,
    4143,    -1,    -1,  4146,  4147,  3382,    -1,    -1,  4151,    -1,
      -1,    -1,    -1,    -1,  4157,    -1,    -1,    -1,    -1,  3396,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1209,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3512,    -1,    -1,
      -1,    -1,    -1,    -1,  4496,    -1,  4498,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1487,  4211,    -1,
    3535,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4227,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3560,    -1,  2191,    -1,    -1,
      -1,  2195,  2196,    -1,    -1,    -1,    10,    -1,  1528,    13,
      -1,    -1,    -1,    17,    18,    19,  4558,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      34,  3596,    -1,    37,    -1,  3512,    -1,    -1,    42,    -1,
      -1,  1561,    -1,    -1,    -1,    49,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3535,    -1,
      -1,    -1,    -1,  2257,   967,    -1,    -1,    -1,  2956,    -1,
      74,  2959,    -1,  2961,    -1,    -1,    -1,  2271,  2966,    -1,
      -1,    -1,    -1,  3560,    -1,    -1,    -1,    -1,  4331,   992,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1007,    -1,  3671,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2312,  3596,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3015,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4685,    -1,  1419,  3034,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4405,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3059,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   185,    -1,    -1,    -1,    -1,   190,    -1,    -1,  1092,
      -1,    -1,    -1,    -1,  3671,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3770,    -1,    -1,   212,   213,
      -1,    -1,    -1,  1487,    -1,    -1,    -1,    -1,    -1,    -1,
    1740,    -1,    -1,   227,    -1,    10,    -1,    -1,    13,    -1,
    3795,    -1,    17,    18,    19,    -1,    -1,  1757,    -1,    -1,
      -1,  3129,    -1,  3131,    -1,    -1,    -1,    -1,    -1,    34,
      -1,    -1,    -1,    -1,  1528,  1775,    -1,    42,    -1,    -1,
      -1,    -1,   266,    -1,    49,    -1,    -1,    -1,    -1,  4811,
      -1,    -1,    -1,    -1,    -1,    -1,   280,    -1,    -1,   283,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1561,    -1,    74,
      -1,    -1,    -1,  3770,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4846,    -1,  1209,    -1,    -1,    -1,
      -1,  1831,    -1,    -1,    -1,    -1,    -1,    -1,  3795,    -1,
      -1,  2515,    -1,    -1,  1844,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3222,    -1,    -1,  1857,    -1,    -1,
    4583,  4584,    -1,  4885,  4587,    -1,    -1,    -1,    -1,  1869,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3929,    -1,    -1,   371,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3263,    -1,    -1,    -1,    -1,
      -1,  4624,  4625,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4932,    -1,    -1,  1913,  1914,  4937,  4938,    -1,    -1,    -1,
     185,    -1,    -1,  2597,  3292,   190,  2600,    -1,    -1,    -1,
      -1,    -1,  3977,    -1,    -1,    -1,  3981,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   212,   213,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   227,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3929,    -1,    -1,    -1,    22,    -1,    -1,    -1,
      -1,    27,    -1,    -1,    -1,    -1,  1740,   471,    -1,    -1,
     474,   475,   476,  3361,   478,   479,   480,   481,   482,   483,
      -1,   266,    -1,  1757,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3382,   280,    62,    -1,   283,    -1,
    3977,  1775,    -1,    -1,  3981,    -1,    -1,    -1,  3396,    75,
      76,  5053,  5054,    -1,    -1,    -1,  1419,    -1,    -1,    -1,
      86,    -1,    -1,    -1,    90,    -1,    -1,  2721,    -1,    -1,
      -1,    -1,    -1,    -1,  2054,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   108,    -1,  2738,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1831,    -1,  2753,
      -1,    -1,    -1,  4128,    -1,   131,    -1,    -1,    -1,    -1,
    1844,    -1,    -1,  4138,    -1,    -1,   142,    -1,    -1,    -1,
      -1,    -1,    -1,  1857,  1487,   151,   371,    -1,    -1,    -1,
      -1,    -1,  4835,    -1,    -1,  1869,    -1,   163,    -1,    -1,
      -1,    -1,   168,    -1,    -1,  4848,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3512,  1528,    -1,    -1,   194,    -1,
      -1,    -1,  4875,    -1,    -1,    -1,    -1,    -1,    -1,  1913,
    1914,    -1,    -1,    -1,    -1,    -1,  4889,  3535,    -1,    -1,
      -1,  4128,    -1,   219,    -1,    -1,    -1,    -1,  1561,    -1,
      -1,  4138,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2191,  3560,    -1,   240,  2195,  2196,    -1,    -1,    -1,
    4245,    -1,    -1,    -1,    -1,    -1,   471,    -1,    -1,   474,
     475,   476,    -1,   478,   479,   480,   481,   482,   483,  4942,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3596,    -1,
      -1,    -1,  5254,    -1,   280,    -1,    -1,    -1,    -1,    -1,
      -1,  4286,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2257,   304,    -1,
      -1,    -1,  4985,  4308,    -1,    -1,    -1,    -1,   314,   315,
      -1,  2271,   318,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2956,    -1,    -1,  2959,    -1,  2961,  4245,    -1,
      -1,    -1,  2966,    -1,    -1,    -1,    -1,    -1,   344,    -1,
    2054,   347,    -1,  3671,    -1,   351,    -1,   353,    -1,    -1,
      -1,    -1,  2312,    -1,   360,    -1,    -1,   363,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4286,
      -1,  4376,    -1,    -1,    -1,    -1,   382,    -1,    -1,    -1,
      -1,  3015,    -1,   389,    -1,    -1,    -1,    -1,    -1,   395,
      -1,  4308,   398,    -1,    -1,    -1,   402,  1740,    -1,    -1,
    3034,    -1,    -1,    -1,   410,    -1,   412,    -1,    -1,    -1,
      -1,   417,    -1,    -1,  1757,    -1,    -1,    -1,    -1,    -1,
    5103,    -1,    -1,    -1,    -1,  3059,    -1,    -1,    -1,    -1,
      -1,    -1,  1775,    -1,    -1,    -1,    -1,   443,    -1,    -1,
    5123,    -1,  3770,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4376,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3795,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2191,    -1,    -1,
      -1,  2195,  2196,    -1,    -1,    -1,    -1,    -1,  1831,    -1,
      -1,    -1,    -1,  4498,    -1,  3129,    -1,  3131,    -1,    -1,
      -1,  1844,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1857,    -1,    -1,  5200,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1869,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2257,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4558,    -1,  2515,    -1,  2271,  5241,  5242,
    5243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1913,  1914,    -1,    -1,    -1,    -1,    -1,  5260,    -1,    -1,
      -1,  4498,    -1,    -1,    -1,    -1,    -1,    -1,  3222,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2312,    -1,
      -1,  3929,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3263,
      -1,    -1,    -1,    -1,  1318,    -1,    -1,  2597,    -1,    -1,
    2600,  4558,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3977,
      -1,    -1,    -1,  3981,  5337,    -1,    -1,    -1,  3292,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5359,    -1,    -1,    -1,
    4685,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1376,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2054,    -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3361,    -1,    -1,
      39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3382,    -1,
      -1,    -1,    -1,    62,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2721,  3396,    -1,    -1,    -1,    75,    -1,  4685,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    86,  2738,    -1,
      -1,    90,    -1,    -1,    -1,  5468,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2753,    -1,    -1,    -1,    -1,    -1,   108,
    4128,  2515,    -1,    -1,    -1,   114,  4811,    -1,    -1,    -1,
    4138,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5504,   131,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5514,    -1,   142,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4846,   151,    -1,    -1,    -1,    -1,    -1,  2191,    -1,
      -1,    -1,  2195,  2196,   163,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   171,    -1,    -1,    -1,   175,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3512,    -1,
    4885,    -1,    -1,  2597,    -1,   194,  2600,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4811,    -1,    -1,    -1,    -1,    -1,
      -1,  3535,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2257,    -1,    -1,  4245,    -1,    -1,
      -1,    -1,   231,    -1,    -1,    -1,  3560,  4932,  2271,  4846,
      -1,   240,  4937,  4938,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4286,  1643,
      -1,    -1,  3596,  1647,    -1,    -1,    -1,    -1,  4885,  2312,
      -1,   280,    -1,    -1,   283,    -1,    -1,    -1,    -1,    -1,
    4308,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   304,  2956,    -1,    -1,  2959,
      -1,  2961,    -1,    -1,    -1,    -1,  2966,  2721,    -1,   318,
      -1,    -1,    -1,    -1,    -1,  4932,   325,    -1,    -1,    -1,
    4937,  4938,    -1,    -1,  2738,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   344,    -1,  3671,    -1,  2753,
      -1,    -1,    -1,    -1,   353,    -1,    -1,    -1,  4376,  5054,
      -1,   360,    -1,    -1,   363,  3015,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    27,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   382,  3034,    -1,    -1,    -1,    -1,    -1,
     389,    -1,    -1,    -1,    -1,    -1,   395,    -1,    -1,   398,
     399,    -1,   401,   402,    -1,    -1,    -1,    -1,    -1,  3059,
      -1,    -1,    -1,   412,    -1,    -1,    -1,    -1,   417,    -1,
      -1,    -1,    75,    -1,    -1,   424,    -1,    -1,   427,    -1,
      -1,   430,    -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    -1,    -1,    -1,   443,    -1,  3770,  5054,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   108,    -1,    -1,    -1,    -1,
      -1,   114,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3795,    -1,    -1,    -1,    -1,    -1,    -1,   131,  3129,
    4498,  3131,  2515,    -1,    -1,    -1,    -1,    -1,    -1,   142,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     163,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,    -1,
      -1,    -1,   175,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4558,   194,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2956,    -1,    -1,  2959,    -1,  2961,    -1,  5254,
      -1,    -1,  2966,    -1,  2597,    -1,   219,  2600,    -1,    -1,
      -1,    -1,  3222,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   240,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3929,    -1,    -1,    -1,    -1,
      -1,  3015,    -1,  3263,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   280,    -1,    -1,
    3034,    -1,    -1,    -1,    -1,  2009,    -1,    -1,    -1,    -1,
      -1,    -1,  3292,    -1,    -1,    -1,    -1,  5254,    -1,    -1,
    2024,   304,    -1,  3977,  2028,  3059,    -1,  3981,    -1,    -1,
      -1,   314,   315,    -1,    -1,   318,    -1,  4685,  2042,  2043,
    2044,    -1,  2046,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2721,    -1,
      -1,   344,    -1,    -1,   347,    -1,    -1,    -1,   351,    -1,
     353,    -1,    -1,    -1,    -1,  2738,    -1,   360,    -1,    -1,
     363,  3361,    -1,    -1,  2088,    -1,    -1,    -1,    -1,    -1,
    2753,    -1,    -1,    -1,    -1,  3129,    -1,  3131,    -1,   382,
      -1,    -1,  3382,    -1,    -1,    -1,   389,    -1,    -1,    -1,
      -1,   394,   395,    -1,    -1,   398,  3396,    -1,    -1,   402,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   412,
      -1,    -1,    -1,    -1,   417,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2146,    -1,    -1,    -1,    -1,   430,    -1,    -1,
      -1,    -1,    -1,    -1,  2158,    -1,    -1,    -1,    -1,  2163,
     443,    -1,    -1,  4811,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4128,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4138,    -1,    -1,    -1,  3222,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4846,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3263,
      -1,    -1,  3512,    -1,    -1,    -1,    -1,  4885,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3535,    -1,    -1,  3292,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3560,    -1,    -1,    -1,  4932,    -1,    -1,    -1,    -1,  4937,
    4938,  4245,    -1,  2956,    -1,    -1,  2959,    -1,  2961,    -1,
      -1,    -1,    -1,  2966,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3596,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3361,    -1,    -1,
      -1,    -1,  4286,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3382,    -1,
      -1,    -1,  3015,    -1,  4308,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3396,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3034,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3671,    -1,    -1,    -1,    -1,  3059,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5054,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4376,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3129,    -1,  3131,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3512,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3770,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3535,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3795,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3560,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4498,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3222,
      -1,    -1,  3596,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3263,    -1,    -1,    -1,  4558,    -1,  5254,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3292,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3671,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3929,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3977,  3361,    -1,
      -1,  3981,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3382,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4685,    -1,  3396,    -1,    -1,  3770,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3795,    -1,  2767,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2787,  2788,    -1,  2790,    -1,    -1,  2793,
    2794,    -1,  2796,    -1,  2798,    -1,    -1,    -1,  2802,    -1,
      -1,  2805,    -1,    -1,    -1,    -1,  2810,    -1,    -1,    -1,
      -1,    -1,  2816,    -1,    -1,    -1,    -1,  2821,    -1,    -1,
      -1,    -1,    -1,    -1,  2828,  2829,  2830,  2831,    -1,    -1,
      -1,  2835,  2836,    -1,  2838,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4128,  3512,
      -1,    -1,  2856,    -1,  2858,    -1,    -1,  4811,  4138,    -1,
      -1,  2865,  2866,  2867,  2868,  2869,  2870,  2871,  2872,  2873,
    2874,    -1,  3535,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4846,    -1,    -1,  3929,    -1,  3560,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2911,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4885,    -1,  3596,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3977,    -1,    -1,    -1,  3981,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4245,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4932,    -1,
      -1,    -1,    -1,  4937,  4938,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3002,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4286,    -1,  3671,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4308,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4128,    -1,  4376,    -1,    -1,    -1,
    5054,    -1,    -1,    -1,  4138,    -1,    -1,  3770,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3795,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4245,    -1,    -1,    -1,    -1,    -1,    -1,  4498,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3253,
    3254,    -1,  4286,    -1,  3258,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3929,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4308,    -1,    -1,    -1,  4558,    -1,
      -1,    -1,    -1,  3287,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5254,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3977,    -1,    -1,    -1,  3981,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4376,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4685,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4498,  4128,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4138,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3508,    -1,    -1,    -1,    -1,    -1,
    3514,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4558,    -1,    -1,    -1,  3532,  3533,
      -1,  4811,  3536,  3537,  3538,  3539,    -1,    -1,  3542,  3543,
    3544,  3545,  3546,  3547,  3548,  3549,  3550,  3551,  3552,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4846,    -1,    -1,    -1,
    3574,    -1,    -1,  3577,    -1,  3579,    -1,    -1,  3582,  3583,
      -1,    -1,  4245,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3600,  3601,  3602,  3603,
      -1,  3605,    -1,    -1,    -1,  4885,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4286,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4308,    -1,    -1,    -1,    -1,
      -1,  4685,  4932,    -1,    -1,    -1,    -1,  4937,  4938,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3680,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4376,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5054,    -1,    -1,  4811,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4846,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4498,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4885,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4558,  3900,    -1,  4932,    -1,
      -1,    -1,    -1,  4937,  4938,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5254,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5054,    -1,  4685,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4073,
      -1,    -1,    -1,  4077,    -1,  4079,  4080,    -1,    -1,    -1,
      -1,    -1,  4086,  4087,  4088,  4089,    -1,    -1,    -1,    -1,
    4094,  4095,  4096,  4097,  4098,  4099,  4100,  4101,  4102,  4103,
    4104,  4105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4131,    -1,    -1,
    4134,    -1,  4136,    -1,    -1,    -1,    -1,  4141,    -1,    -1,
    4144,  4145,    -1,    -1,  4148,  4149,    -1,    -1,  4811,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4846,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4195,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4210,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5254,    -1,  4885,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4932,
      -1,    -1,    -1,    -1,  4937,  4938,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5054,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4408,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4493,
    4494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4522,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4547,    -1,    -1,    -1,    -1,    -1,  4553,
    4554,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4571,    -1,  4573,
      -1,    -1,    -1,  4577,  4578,  4579,    -1,    -1,  4582,    -1,
      -1,  4585,  4586,    -1,    -1,    -1,  4590,    -1,    -1,    -1,
    4594,  5254,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4641,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4707,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4745,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4844,  4845,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4859,  4860,  4861,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4869,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4896,  4897,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5068,    -1,    -1,  5071,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5084,    -1,    -1,  5087,    -1,    -1,    -1,  5091,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5171,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5248,    -1,  5250,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5276,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5330,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5362,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5422,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5458,  5459,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5510,  5511,    -1,    -1,
      -1,  5515,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,    -1,     5,     6,    -1,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,  5542,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    73,    -1,    75,    -1,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,   174,    -1,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
      -1,    -1,   223,   224,   225,   226,   227,    -1,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,    -1,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,    -1,    -1,    -1,    -1,    -1,    -1,   478,   479,   480,
      -1,    -1,    -1,    -1,    -1,    -1,   487,   488,     3,    -1,
       5,     6,    -1,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,    -1,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,   441,   442,   443,   444,
     445,    -1,    -1,   448,    -1,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,    -1,   473,    -1,
      -1,    -1,    -1,   478,   479,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   487,   488,     3,    -1,     5,     6,    -1,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      39,    40,    -1,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    73,    -1,    75,    -1,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,   174,    -1,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,    -1,    -1,   223,   224,   225,   226,   227,    -1,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,    -1,   276,   277,    -1,
      -1,   280,   281,   282,    -1,    -1,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,   434,   435,   436,   437,   438,
      -1,   440,   441,   442,   443,   444,   445,    -1,    -1,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,    -1,    -1,    -1,    -1,    -1,    -1,   478,
     479,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   487,   488,
       3,    -1,     5,     6,    -1,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    39,    40,    -1,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    -1,    69,    70,    71,    72,
      73,    -1,    75,    -1,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    -1,    87,    88,    89,    90,    91,    92,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,    -1,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
      -1,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,   165,    -1,   167,   168,   169,   170,   171,    -1,
     173,   174,    -1,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,    -1,    -1,
     223,   224,   225,   226,   227,    -1,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,    -1,   276,   277,    -1,    -1,   280,   281,   282,
      -1,    -1,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,    -1,    -1,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,   424,   425,   426,   427,   428,   429,   430,    -1,   432,
     433,   434,   435,   436,   437,   438,    -1,   440,   441,   442,
     443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,    -1,
      -1,    -1,    -1,    -1,    -1,   478,   479,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   487,   488,     3,    -1,     5,     6,
      -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,
      -1,    -1,    39,    40,    -1,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    -1,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    -1,    69,    70,    71,    72,    73,    -1,    75,    -1,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    -1,
      87,    88,    89,    90,    91,    92,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,    -1,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,    -1,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,   140,   141,   142,    -1,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,   165,    -1,
     167,   168,   169,   170,   171,    -1,   173,   174,    -1,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,    -1,    -1,   223,   224,   225,   226,
     227,    -1,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,    -1,   276,
     277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
      -1,    -1,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,    -1,   424,   425,   426,
     427,   428,   429,   430,    -1,   432,   433,   434,   435,   436,
     437,   438,    -1,   440,   441,   442,   443,   444,   445,    -1,
      -1,   448,    -1,    -1,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,     3,    -1,    -1,    -1,    -1,
      -1,   478,   479,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     487,   488,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    37,
      -1,    39,    40,    -1,    42,    43,    44,    -1,    46,    47,
      48,    49,    50,    -1,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    -1,    -1,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,    77,
      78,    79,    80,    81,    -1,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    94,    95,    96,    97,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,   167,
     168,   169,   170,   171,    -1,   173,   174,    -1,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,    -1,    -1,   214,   215,   216,   217,
     218,   219,   220,    -1,    -1,   223,   224,   225,   226,    -1,
      -1,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,   267,
      -1,   269,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,   287,
      -1,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,    -1,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,   437,
     438,    -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     488,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    -1,    42,    43,    44,    45,    46,    47,    48,
      -1,    50,    51,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    -1,    -1,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    -1,    -1,    75,    -1,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    -1,    94,    95,    96,    97,    -1,
      -1,    -1,   101,    -1,    -1,    -1,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,    -1,
     149,   150,   151,   152,    -1,    -1,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,    -1,    -1,    -1,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,    -1,    -1,   223,    -1,   225,   226,   227,    -1,
     229,   230,   231,    -1,    -1,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,    -1,    -1,   262,    -1,   264,   265,   266,   267,    -1,
      -1,   270,   271,   272,   273,   274,    -1,   276,   277,    -1,
      -1,   280,   281,   282,    -1,    -1,   285,   286,   287,   288,
     289,   290,    -1,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,    -1,   306,    -1,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,    -1,   391,    -1,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,    -1,   412,    -1,    -1,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,    -1,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,    -1,   438,
     439,   440,   441,   442,   443,   444,   445,    -1,    -1,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   468,
     469,   470,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,   488,
      -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      45,    46,    47,    48,    -1,    50,    51,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    -1,    -1,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    -1,    -1,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    94,
      95,    96,    97,    -1,    -1,    -1,   101,    -1,    -1,    -1,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,    -1,   149,   150,   151,   152,    -1,    -1,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,    -1,
      -1,    -1,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,    -1,   223,    -1,
     225,   226,   227,    -1,   229,   230,   231,    -1,    -1,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,    -1,    -1,   262,    -1,   264,
     265,   266,   267,    -1,    -1,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,   288,   289,   290,    -1,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
      -1,   306,    -1,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,    -1,   412,    -1,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,    -1,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,   438,   439,   440,   441,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,     3,    -1,     5,     6,    -1,     8,     9,    10,
      11,    12,    -1,   468,   469,   470,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,   488,    -1,    36,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    73,    -1,    75,    -1,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,   174,    -1,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
      -1,    -1,   223,   224,   225,   226,   227,    -1,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,    -1,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,   434,   435,   436,   437,   438,    -1,   440,
     441,   442,   443,   444,   445,    -1,    -1,   448,    -1,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,    -1,   473,    -1,    -1,    -1,    -1,   478,   479,    -1,
      -1,    -1,     3,    -1,     5,     6,   487,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    73,    -1,    75,    -1,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,   165,   166,   167,   168,   169,   170,
     171,    -1,   173,   174,    -1,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
      -1,   222,   223,   224,   225,   226,   227,    -1,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,    -1,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,   434,   435,   436,   437,   438,    -1,   440,
     441,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,    -1,    -1,    -1,    -1,    -1,    -1,   478,   479,    -1,
      -1,    -1,     3,    -1,     5,     6,   487,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    73,    -1,    75,    -1,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,   174,    -1,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
      -1,    -1,   223,   224,   225,   226,   227,    -1,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,    -1,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,   434,   435,   436,   437,   438,    -1,   440,
     441,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,    -1,    -1,    -1,    -1,    -1,    -1,   478,   479,    -1,
      -1,    -1,    -1,    -1,   485,   486,   487,     3,    -1,     5,
       6,    -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    75,
      -1,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,   441,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,    -1,    -1,    -1,    -1,
      -1,    -1,   478,   479,   480,    -1,    -1,     3,    -1,     5,
       6,   487,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    75,
      -1,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,   441,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,    -1,    -1,    -1,    -1,
      -1,    -1,   478,   479,    -1,    -1,    -1,     3,    -1,     5,
       6,   487,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    75,
      -1,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,    -1,    -1,    -1,    -1,
      -1,    -1,   478,   479,    -1,    -1,    -1,     3,    -1,     5,
       6,   487,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    75,
      -1,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,   441,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,    -1,    -1,    -1,    -1,
      -1,    -1,   478,   479,    -1,    -1,    -1,     3,    -1,     5,
       6,   487,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    75,
      -1,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,   441,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,    -1,    -1,    -1,    -1,
      -1,    -1,   478,   479,    -1,    -1,    -1,     3,    -1,     5,
       6,   487,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    75,
      -1,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,   441,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,    -1,    -1,    -1,    -1,
      -1,    -1,   478,   479,    -1,    -1,    -1,     3,    -1,     5,
       6,   487,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    75,
      -1,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,   441,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,    -1,    -1,    -1,    -1,
      -1,    -1,   478,   479,    -1,    -1,    -1,     3,    -1,     5,
       6,   487,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    75,
      -1,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,   441,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,    -1,    -1,    -1,    -1,
      -1,    -1,   478,   479,    -1,    -1,    -1,     3,    -1,     5,
       6,   487,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    75,
      -1,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,   441,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,    -1,    -1,    -1,    -1,
      -1,    -1,   478,   479,    -1,    -1,    -1,     3,    -1,     5,
       6,   487,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    75,
      -1,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,   441,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,    -1,    -1,    -1,    -1,
      -1,    -1,   478,   479,    -1,    -1,    -1,     3,    -1,     5,
       6,   487,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    75,
      -1,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,   441,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,    -1,    -1,    -1,    -1,
      -1,    -1,   478,   479,    -1,    -1,    -1,     3,    -1,     5,
       6,   487,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    75,
      -1,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,   441,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,    -1,    -1,    -1,    -1,
      -1,    -1,   478,   479,    -1,    -1,    -1,     3,    -1,     5,
       6,   487,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    75,
      -1,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,   441,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,    -1,    -1,    -1,    -1,
      -1,    -1,   478,   479,    -1,    -1,    -1,     3,    -1,     5,
       6,   487,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    75,
      -1,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,    -1,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,   441,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   478,   479,    -1,    -1,    -1,     3,    -1,     5,
       6,   487,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    75,
      -1,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,   215,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,   441,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,    -1,    -1,    -1,    -1,
      -1,    -1,   478,   479,    -1,    -1,    -1,     3,    -1,     5,
       6,   487,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    75,
      -1,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,    -1,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,   441,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   478,   479,     3,    -1,     5,     6,    -1,     8,
       9,   487,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      39,    40,    -1,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    73,    -1,    75,    -1,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,   174,    -1,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,    -1,    -1,   223,   224,   225,   226,   227,    -1,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,    -1,   276,   277,    -1,
      -1,   280,   281,   282,    -1,    -1,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,    -1,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,   434,   435,   436,   437,   438,
      -1,   440,   441,   442,   443,   444,   445,    -1,    -1,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   478,
     479,    -1,    -1,    -1,     3,    -1,     5,     6,   487,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      39,    40,    -1,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    73,    -1,    75,    -1,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,   174,    -1,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,    -1,    -1,   223,   224,   225,   226,   227,    -1,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,    -1,   276,   277,    -1,
      -1,   280,   281,   282,    -1,    -1,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,    -1,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,   434,   435,   436,   437,   438,
      -1,   440,   441,   442,   443,   444,   445,    -1,    -1,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   478,
     479,     3,    -1,     5,     6,    -1,     8,     9,   487,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,    -1,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    -1,    69,    70,    71,
      72,    73,    -1,    75,    -1,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,   140,   141,
     142,    -1,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,    -1,   157,   158,   159,   160,    -1,
     162,    -1,   164,   165,    -1,   167,   168,   169,   170,   171,
      -1,   173,   174,    -1,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,    -1,
      -1,   223,   224,   225,   226,   227,    -1,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,    -1,   276,   277,    -1,    -1,   280,   281,
     282,    -1,    -1,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,    -1,   425,   426,   427,   428,   429,   430,    -1,
     432,   433,   434,   435,   436,   437,   438,    -1,   440,   441,
     442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,     3,
      -1,     5,     6,    -1,     8,     9,    -1,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,   487,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    36,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    -1,    69,    70,    71,    72,    73,
      -1,    75,    -1,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,    -1,   157,   158,   159,   160,    -1,   162,    -1,
     164,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
     174,    -1,   176,   177,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,    -1,    -1,   223,
     224,   225,   226,   227,    -1,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
      -1,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,    -1,   440,   441,   442,   443,
     444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     3,    -1,     5,
       6,    -1,     8,     9,    -1,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,   487,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    75,
      -1,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,    -1,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,   441,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     3,    -1,     5,     6,    -1,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,   487,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,
      -1,    39,    40,    -1,    42,    43,    44,    45,    46,    47,
      48,    -1,    50,    51,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    73,    -1,    75,    -1,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,    -1,   142,    -1,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,   174,    -1,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,    -1,    -1,   214,   215,   216,   217,
     218,   219,   220,    -1,    -1,   223,   224,   225,   226,    -1,
      -1,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,   427,
     428,   429,   430,    -1,   432,   433,   434,   435,   436,   437,
     438,    -1,   440,   441,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,
     478,   479,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   487,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    73,    -1,    75,    -1,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,   174,    -1,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,    -1,   223,   224,   225,   226,   227,    -1,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,    -1,   276,   277,    -1,   279,
     280,   281,   282,    -1,    -1,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,    -1,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,    -1,
     440,   441,   442,   443,   444,   445,    -1,    -1,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     3,    -1,   473,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   487,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    67,    -1,    69,    70,    71,
      72,    73,    -1,    75,    -1,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,   140,   141,
     142,    -1,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,   159,   160,    -1,
     162,    -1,   164,   165,    -1,   167,   168,   169,   170,   171,
      -1,   173,   174,    -1,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
      -1,   223,   224,   225,   226,   227,    -1,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,    -1,   276,   277,    -1,   279,   280,   281,
     282,    -1,    -1,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,    -1,   425,   426,   427,   428,   429,   430,    -1,
     432,   433,   434,   435,   436,   437,   438,    -1,   440,   441,
     442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   487,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    67,    -1,    69,    70,    71,    72,    73,
      -1,    75,    -1,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,   159,   160,    -1,   162,    -1,
     164,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
     174,    -1,   176,   177,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,    -1,    -1,   223,
     224,   225,   226,   227,    -1,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
      -1,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,    -1,   440,   441,   442,   443,
     444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   487,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    75,
      -1,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,   165,
      -1,   167,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,    -1,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,   441,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   487,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    -1,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    73,    -1,    75,    -1,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,   165,    -1,   167,
     168,   169,   170,   171,    -1,   173,   174,    -1,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,    -1,    -1,   223,   224,   225,   226,   227,
      -1,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,   426,   427,
     428,   429,   430,    -1,   432,   433,   434,   435,   436,   437,
     438,    -1,   440,   441,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,     3,    -1,     5,     6,    -1,    -1,    -1,
      -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   487,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    -1,    -1,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    73,    -1,    75,    -1,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    94,    95,    96,    97,    -1,    -1,
      -1,   101,    -1,    -1,    -1,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,   174,    -1,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,    -1,    -1,   223,   224,   225,   226,   227,    -1,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,    -1,   276,   277,   278,    -1,
     280,   281,   282,    -1,    -1,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,    -1,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,   437,   438,    -1,
     440,   441,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     3,    -1,    -1,    -1,    -1,    -1,    -1,   478,   479,
     480,    -1,    -1,    -1,    -1,    -1,    -1,   487,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      32,    33,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    64,    65,    66,    67,    -1,    69,    70,    71,
      72,    73,    -1,    75,    -1,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    -1,    94,    95,    96,    97,    -1,    -1,    -1,   101,
      -1,    -1,    -1,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,   140,   141,
     142,    -1,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,   159,   160,    -1,
     162,    -1,   164,   165,    -1,   167,   168,   169,   170,   171,
      -1,   173,   174,    -1,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,    -1,
      -1,   223,   224,   225,   226,   227,    -1,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,    -1,   276,   277,    -1,    -1,   280,   281,
     282,    -1,    -1,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,   437,   438,    -1,   440,   441,
     442,   443,   444,   445,    -1,    -1,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,     3,
      -1,   473,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   487,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    -1,    63,
      64,    65,    66,    67,    -1,    69,    70,    71,    72,    73,
      -1,    75,    -1,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    -1,
      94,    95,    96,    97,    -1,    -1,    -1,   101,    -1,    -1,
      -1,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,   159,   160,    -1,   162,    -1,
     164,   165,    -1,   167,   168,   169,   170,   171,    -1,   173,
     174,    -1,   176,   177,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,    -1,    -1,   223,
     224,   225,   226,   227,    -1,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
      -1,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,   437,   438,    -1,   440,   441,   442,   443,
     444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   487,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,
      46,    47,    48,    49,    50,    -1,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    -1,    -1,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    -1,
      -1,    77,    78,    79,    80,    81,    -1,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    -1,    95,
      96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,    -1,
      -1,    -1,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,    -1,
     226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,   267,    -1,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,    -1,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,    -1,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,    -1,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,    -1,   442,   443,   444,   445,
      -1,    -1,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     3,    -1,   473,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   487,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    -1,    42,    43,    44,    -1,    46,    47,
      48,    49,    50,    -1,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    -1,    -1,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,    77,
      78,    79,    80,    81,    -1,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    -1,    95,    96,    97,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,
     168,   169,   170,   171,    -1,   173,   174,    -1,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,
     218,   219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,
      -1,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,   267,
      -1,   269,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,   287,
      -1,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,    -1,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,   437,
     438,    -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   487,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    -1,    46,    47,    48,    49,
      50,    -1,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    -1,    -1,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    73,    -1,    -1,    -1,    77,    78,    79,
      80,    81,    -1,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,
     170,   171,    -1,   173,   174,    -1,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,   219,
     220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,   267,    -1,   269,
     270,   271,   272,   273,   274,    -1,   276,   277,    -1,    -1,
     280,   281,   282,    -1,    -1,   285,   286,   287,    -1,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,    -1,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,    -1,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,   437,   438,    -1,
     440,    -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   487,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,
      42,    43,    44,    -1,    46,    47,    48,    49,    50,    -1,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    64,    65,    66,    67,    -1,    69,    70,    71,
      72,    73,    -1,    -1,    -1,    77,    78,    79,    80,    81,
      -1,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,   140,   141,
     142,    -1,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,   159,   160,    -1,
     162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,
      -1,   173,   174,    -1,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,    -1,   211,
      -1,    -1,   214,    -1,   216,   217,   218,   219,   220,    -1,
      -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,    -1,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,   267,    -1,   269,   270,   271,
     272,   273,   274,    -1,   276,   277,    -1,    -1,   280,   281,
     282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,    -1,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,   437,   438,    -1,   440,    -1,
     442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   487,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    -1,    46,    47,    48,    49,    50,    -1,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    -1,    63,
      64,    65,    66,    67,    -1,    69,    70,    71,    72,    73,
      -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    -1,
      -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,   159,   160,    -1,   162,    -1,
     164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,
     174,    -1,   176,   177,   178,    -1,   180,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,
     214,    -1,   216,   217,   218,   219,   220,    -1,    -1,   223,
     224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,   267,    -1,   269,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,   287,    -1,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,    -1,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
      -1,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,   437,   438,    -1,   440,    -1,   442,   443,
     444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,    -1,    -1,    -1,
       3,    -1,     5,     6,    -1,    -1,    -1,    10,    11,    -1,
      -1,    -1,    -1,   487,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    -1,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      -1,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,    -1,   149,   150,   151,   152,
      -1,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,    -1,   175,    -1,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,    -1,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,    -1,   262,
     263,   264,   265,   266,   267,   268,    -1,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,   304,    -1,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,    -1,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,    -1,   412,
      -1,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   468,   469,   470,    -1,    -1,
      -1,   474,   475,   476,    -1,   478,   479,   480,   481,   482,
     483,     3,    -1,     5,     6,    -1,    -1,    -1,    10,    11,
      -1,    -1,    -1,    -1,    -1,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    -1,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    -1,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,    -1,   149,   150,   151,
     152,    -1,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,    -1,   175,    -1,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,    -1,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,    -1,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,    -1,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,    -1,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   468,   469,   470,    -1,
      -1,    -1,   474,   475,   476,     3,   478,   479,   480,   481,
     482,   483,    10,    -1,    -1,    -1,    -1,    -1,    -1,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    -1,    42,    43,    44,    -1,    46,    47,
      48,    49,    50,    -1,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    -1,    -1,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,    77,
      78,    79,    80,    81,    -1,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    -1,    95,    96,    97,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,
     168,   169,   170,   171,    -1,   173,   174,    -1,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,
     218,   219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,
      -1,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,   267,
      -1,   269,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,   287,
      -1,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,    -1,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,   437,
     438,    -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,    -1,    -1,    -1,   474,   475,   476,     3,
     478,   479,   480,   481,   482,   483,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    -1,    46,    47,    48,    49,    50,    -1,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    -1,    63,
      64,    65,    66,    67,    -1,    69,    70,    71,    72,    73,
      -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    -1,
      -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,   159,   160,    -1,   162,    -1,
     164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,
     174,    -1,   176,   177,   178,    -1,   180,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,
     214,    -1,   216,   217,   218,   219,   220,    -1,    -1,   223,
     224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,   267,    -1,   269,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,   287,    -1,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,    -1,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
      -1,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,   437,   438,    -1,   440,    -1,   442,   443,
     444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,    -1,    -1,    -1,
     474,   475,   476,     3,   478,   479,   480,   481,   482,   483,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    -1,    46,    47,    48,    49,
      50,    -1,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    -1,    -1,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    73,    -1,    -1,    -1,    77,    78,    79,
      80,    81,    -1,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,
     170,   171,    -1,   173,   174,    -1,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,   219,
     220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,   267,    -1,   269,
     270,   271,   272,   273,   274,    -1,   276,   277,    -1,    -1,
     280,   281,   282,    -1,    -1,   285,   286,   287,    -1,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,    -1,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,    -1,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,   437,   438,    -1,
     440,    -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,    -1,    -1,    -1,   474,   475,   476,     3,   478,   479,
     480,   481,   482,   483,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,
      46,    47,    48,    49,    50,    -1,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    -1,    -1,    63,    64,    65,
      66,    67,    -1,    69,    70,    71,    72,    73,    -1,    -1,
      -1,    77,    78,    79,    80,    81,    -1,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    -1,    -1,    95,
      96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
      -1,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,   140,   141,   142,    -1,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,   159,   160,    -1,   162,    -1,   164,    -1,
      -1,    -1,   168,   169,   170,   171,    -1,   173,   174,    -1,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,
     216,   217,   218,   219,   220,    -1,    -1,   223,   224,    -1,
     226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,   267,    -1,   269,   270,   271,   272,   273,   274,    -1,
     276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,
     286,   287,    -1,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,    -1,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,   420,   421,   422,    -1,    -1,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,    -1,   442,   443,   444,   445,
      -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,    -1,    -1,    -1,   474,   475,
     476,     3,   478,   479,   480,   481,   482,   483,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,
      42,    43,    44,    -1,    46,    47,    48,    49,    50,    -1,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    64,    65,    66,    67,    -1,    69,    70,    71,
      72,    73,    -1,    -1,    -1,    77,    78,    79,    80,    81,
      -1,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,   140,   141,
     142,    -1,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,   159,   160,    -1,
     162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,
      -1,   173,   174,    -1,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,    -1,   211,
      -1,    -1,   214,    -1,   216,   217,   218,   219,   220,    -1,
      -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,    -1,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,   267,    -1,   269,   270,   271,
     272,   273,   274,    -1,   276,   277,    -1,    -1,   280,   281,
     282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,    -1,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,   437,   438,    -1,   440,    -1,
     442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,    -1,
      -1,    -1,   474,   475,   476,     3,   478,   479,   480,   481,
     482,   483,    10,    -1,    -1,    -1,    -1,    -1,    -1,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    -1,    42,    43,    44,    -1,    46,    47,
      48,    49,    50,    -1,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    -1,    -1,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,    77,
      78,    79,    80,    81,    -1,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    -1,    95,    96,    97,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,
     168,   169,   170,   171,    -1,   173,   174,    -1,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,
     218,   219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,
      -1,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,   267,
      -1,   269,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,   287,
      -1,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,    -1,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,   437,
     438,    -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,    -1,    -1,    -1,   474,   475,   476,     3,
     478,   479,   480,   481,   482,   483,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    -1,    46,    47,    48,    49,    50,    -1,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    -1,    63,
      64,    65,    66,    67,    -1,    69,    70,    71,    72,    73,
      -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    -1,
      -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,   159,   160,    -1,   162,    -1,
     164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,
     174,    -1,   176,   177,   178,    -1,   180,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,
     214,    -1,   216,   217,   218,   219,   220,    -1,    -1,   223,
     224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,   267,    -1,   269,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,   287,    -1,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,    -1,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
      -1,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,   437,   438,    -1,   440,    -1,   442,   443,
     444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     3,    -1,    -1,
     474,   475,   476,    -1,   478,   479,   480,   481,   482,   483,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   480,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    -1,    42,    43,    44,    -1,    46,    47,
      48,    49,    50,    -1,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    -1,    -1,    63,    64,    65,    66,    67,
      -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,    77,
      78,    79,    80,    81,    -1,    83,    84,    85,    -1,    87,
      88,    89,    90,    91,    92,    -1,    -1,    95,    96,    97,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,    -1,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,   140,   141,   142,    -1,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,
     168,   169,   170,   171,    -1,   173,   174,    -1,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,
     218,   219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,
      -1,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,   267,
      -1,   269,   270,   271,   272,   273,   274,    -1,   276,   277,
      -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,   287,
      -1,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,    -1,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,    -1,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,    -1,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,   437,
     438,    -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   480,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    -1,    46,    47,    48,    49,
      50,    -1,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    -1,    -1,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    73,    -1,    -1,    -1,    77,    78,    79,
      80,    81,    -1,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,
     170,   171,    -1,   173,   174,    -1,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,   219,
     220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,   267,    -1,   269,
     270,   271,   272,   273,   274,    -1,   276,   277,    -1,    -1,
     280,   281,   282,    -1,    -1,   285,   286,   287,    -1,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,    -1,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,    -1,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,   437,   438,    -1,
     440,    -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     480,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,
      42,    43,    44,    45,    46,    47,    48,    -1,    50,    51,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    64,    65,    66,    67,    -1,    69,    70,    71,
      72,    -1,    -1,    75,    -1,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    -1,    94,    95,    96,    97,    -1,    -1,    -1,   101,
      -1,    -1,    -1,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,   140,   141,
     142,    -1,   144,   145,   146,   147,    -1,   149,   150,   151,
     152,    -1,    -1,   155,    -1,   157,   158,   159,   160,    -1,
     162,    -1,   164,   165,    -1,   167,   168,   169,   170,   171,
      -1,   173,    -1,    -1,    -1,   177,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,    -1,
      -1,   223,    -1,   225,   226,   227,    -1,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,    -1,    -1,
     262,    -1,   264,   265,   266,   267,    -1,    -1,   270,   271,
     272,   273,   274,    -1,   276,   277,    -1,    -1,   280,   281,
     282,    -1,   284,   285,   286,   287,   288,   289,   290,    -1,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
      -1,   303,   304,    -1,   306,    -1,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
      -1,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,    -1,    -1,   409,   410,    -1,
     412,    -1,    -1,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,    -1,   438,   439,   440,   441,
     442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,    -1,    -1,    -1,   468,   469,   470,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   480,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    45,    46,    47,    48,    -1,    50,
      51,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    -1,    -1,    75,    -1,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    94,    95,    96,    97,    -1,    -1,    -1,
     101,    -1,    -1,    -1,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,    -1,   149,   150,
     151,   152,    -1,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,    -1,    -1,    -1,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
      -1,    -1,   223,    -1,   225,   226,   227,    -1,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,    -1,
      -1,   262,    -1,   264,   265,   266,   267,    -1,    -1,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,   284,   285,   286,   287,   288,   289,   290,
      -1,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,    -1,   306,    -1,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,    -1,
     391,    -1,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
      -1,   412,    -1,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,    -1,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,   438,   439,   440,
     441,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,     5,     6,   468,   469,   470,
      -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   480,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    -1,    -1,    63,    64,    65,    66,    67,    -1,    69,
      70,    71,    72,    73,    -1,    75,    -1,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    -1,    94,    95,    96,    97,    -1,    -1,
      -1,   101,    -1,    -1,    -1,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,    -1,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,    -1,   157,   158,   159,
     160,    -1,   162,    -1,   164,   165,    -1,   167,   168,   169,
     170,   171,    -1,   173,   174,    -1,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,   207,    -1,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,    -1,    -1,   223,   224,   225,   226,   227,    -1,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,    -1,   276,   277,   278,    -1,
     280,   281,   282,    -1,    -1,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,    -1,    -1,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,    -1,    -1,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,   437,   438,    -1,
     440,   441,   442,   443,   444,   445,    -1,    -1,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,    -1,     3,    -1,     5,     6,    -1,    -1,   478,   479,
      11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    73,    -1,    75,    -1,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    94,    95,    96,    97,    -1,    -1,    -1,
     101,    -1,    -1,    -1,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,   174,    -1,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
      -1,    -1,   223,   224,   225,   226,   227,    -1,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,    -1,   276,   277,   278,    -1,   280,
     281,   282,    -1,    -1,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,    -1,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,   437,   438,    -1,   440,
     441,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
      -1,     3,    -1,     5,     6,    -1,    -1,   478,   479,    11,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    64,    65,    66,    67,    -1,    69,    70,    71,
      72,    73,    -1,    75,    -1,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    -1,    94,    95,    96,    97,    -1,    -1,    -1,   101,
      -1,    -1,    -1,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,   140,   141,
     142,    -1,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,    -1,   157,   158,   159,   160,    -1,
     162,    -1,   164,   165,    -1,   167,   168,   169,   170,   171,
      -1,   173,   174,    -1,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,   207,    -1,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,    -1,
      -1,   223,   224,   225,   226,   227,    -1,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,    -1,   276,   277,   278,    -1,   280,   281,
     282,    -1,    -1,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,   437,   438,    -1,   440,   441,
     442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,    -1,
       3,    -1,    -1,     6,    -1,    -1,   478,   479,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    -1,    -1,
      63,    64,    65,    66,    67,    -1,    69,    70,    71,    72,
      73,    -1,    75,    -1,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    -1,    87,    88,    89,    90,    91,    92,
      -1,    94,    95,    96,    97,    -1,    -1,    -1,   101,    -1,
      -1,    -1,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,    -1,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
      -1,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,   165,    -1,   167,   168,   169,   170,   171,    -1,
     173,   174,    -1,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,    -1,    -1,
     223,   224,   225,   226,   227,    -1,   229,   230,   231,    -1,
      -1,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,    -1,   276,   277,   278,    -1,   280,   281,   282,
      -1,    -1,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,    -1,    -1,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,   437,   438,    -1,   440,   441,   442,
     443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,    -1,     3,
      -1,    -1,    -1,    -1,    -1,   478,   479,    11,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,
      44,    -1,    46,    47,    48,    49,    50,    -1,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    -1,    63,
      64,    65,    66,    67,    -1,    69,    70,    71,    72,    73,
      -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    -1,
      -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,    -1,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,    -1,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,   159,   160,    -1,   162,    -1,
     164,    -1,   166,    -1,   168,   169,   170,   171,    -1,   173,
     174,    -1,   176,   177,   178,    -1,   180,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,
     214,    -1,   216,   217,   218,   219,   220,    -1,    -1,   223,
     224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,   267,    -1,   269,   270,   271,   272,   273,
     274,    -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,
      -1,   285,   286,   287,    -1,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,    -1,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,    -1,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
      -1,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,   437,   438,    -1,   440,    -1,   442,   443,
     444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,    -1,     3,    -1,
       5,     6,    -1,    -1,   478,   479,    11,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    73,    -1,    75,    -1,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,   174,    -1,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
      -1,    -1,   223,   224,   225,   226,   227,    -1,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,    -1,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,    -1,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,   434,   435,   436,   437,   438,    -1,   440,
     441,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       3,    -1,    -1,     6,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    -1,    -1,
      63,    64,    65,    66,    67,    -1,    69,    70,    71,    72,
      73,    -1,    75,    -1,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    -1,    87,    88,    89,    90,    91,    92,
      -1,    94,    95,    96,    97,    -1,    -1,    -1,   101,    -1,
      -1,    -1,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,    -1,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
      -1,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,   165,    -1,   167,   168,   169,   170,   171,    -1,
     173,   174,    -1,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,    -1,    -1,
     223,   224,   225,   226,   227,    -1,   229,   230,   231,    -1,
      -1,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,    -1,   276,   277,   278,    -1,   280,   281,   282,
      -1,    -1,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,    -1,    -1,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,   437,   438,    -1,   440,   441,   442,
     443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    -1,    -1,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    94,
      95,    96,    97,    -1,    -1,    -1,   101,    -1,    -1,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,    -1,   229,   230,   231,    -1,    -1,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,    -1,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,   441,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    -1,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    -1,    55,    56,
      57,    58,    59,    60,    -1,    -1,    63,    64,    65,    66,
      67,    -1,    69,    70,    71,    72,    73,    -1,    75,    -1,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    -1,
      87,    88,    89,    90,    91,    92,    -1,    94,    95,    96,
      97,    -1,    -1,    -1,   101,    -1,    -1,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,    -1,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,    -1,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,   140,   141,   142,    -1,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,   165,    -1,
     167,   168,   169,   170,   171,    -1,   173,   174,    -1,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,    -1,    -1,   223,   224,   225,   226,
     227,    -1,   229,   230,   231,    -1,    -1,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,    -1,   276,
     277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
      -1,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,   420,   421,   422,    -1,    -1,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
     437,   438,    -1,   440,   441,   442,   443,   444,   445,    -1,
      -1,   448,    -1,    -1,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    -1,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    -1,    -1,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    73,    -1,    75,    -1,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    -1,    94,    95,    96,    97,    -1,
      -1,    -1,   101,    -1,    -1,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,   174,    -1,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,    -1,    -1,   223,   224,   225,   226,   227,    -1,
     229,   230,   231,    -1,    -1,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,    -1,   276,   277,    -1,
      -1,   280,   281,   282,    -1,    -1,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,    -1,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,   434,   435,   436,   437,   438,
      -1,   440,   441,   442,   443,   444,   445,    -1,    -1,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    73,    -1,    75,    -1,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    94,    95,    96,    97,    -1,    -1,    -1,
     101,    -1,    -1,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
      -1,    -1,   223,   224,   225,   226,   227,    -1,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,    -1,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,    -1,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,   437,   438,    -1,   440,
     441,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    -1,    -1,
      63,    64,    65,    66,    67,    -1,    69,    70,    71,    72,
      73,    -1,    75,    -1,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    -1,    87,    88,    89,    90,    91,    92,
      -1,    94,    95,    96,    97,    -1,    -1,    -1,   101,    -1,
      -1,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,    -1,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
      -1,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,   165,    -1,   167,   168,   169,   170,   171,    -1,
     173,   174,    -1,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,    -1,    -1,
     223,   224,   225,   226,   227,    -1,   229,   230,   231,    -1,
      -1,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,    -1,   276,   277,    -1,    -1,   280,   281,   282,
      -1,    -1,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,    -1,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,   437,   438,    -1,   440,   441,   442,
     443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    -1,    -1,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    94,
      95,    96,    97,    -1,    -1,    -1,   101,    -1,    -1,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,    -1,   229,   230,   231,    -1,    -1,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,    -1,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,   441,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    -1,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    -1,    55,    56,
      57,    58,    59,    60,    -1,    -1,    63,    64,    65,    66,
      67,    -1,    69,    70,    71,    72,    73,    -1,    75,    -1,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    -1,
      87,    88,    89,    90,    91,    92,    -1,    94,    95,    96,
      97,    -1,    -1,    -1,   101,    -1,    -1,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,    -1,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,    -1,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,   140,   141,   142,    -1,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,   165,    -1,
     167,   168,   169,   170,   171,    -1,   173,   174,    -1,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,    -1,    -1,   223,   224,   225,   226,
     227,    -1,   229,   230,   231,    -1,    -1,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,    -1,   276,
     277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
      -1,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,   420,   421,   422,    -1,    -1,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
     437,   438,    -1,   440,   441,   442,   443,   444,   445,    -1,
      -1,   448,    -1,    -1,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    -1,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    -1,    -1,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    73,    -1,    75,    -1,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    -1,    94,    95,    96,    97,    -1,
      -1,    -1,   101,    -1,    -1,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,   174,    -1,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,    -1,    -1,   223,   224,   225,   226,   227,    -1,
     229,   230,   231,    -1,    -1,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,    -1,   276,   277,    -1,
      -1,   280,   281,   282,    -1,    -1,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,    -1,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,   437,   438,
      -1,   440,   441,   442,   443,   444,   445,    -1,    -1,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    73,    -1,    75,    -1,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    94,    95,    96,    97,    -1,    -1,    -1,
     101,    -1,    -1,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,   174,    -1,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
      -1,    -1,   223,   224,   225,   226,   227,    -1,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,    -1,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,    -1,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,   437,   438,    -1,   440,
     441,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    32,
      33,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    -1,    -1,
      63,    64,    65,    66,    67,    -1,    69,    70,    71,    72,
      73,    -1,    75,    -1,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    -1,    87,    88,    89,    90,    91,    92,
      -1,    94,    95,    96,    97,    -1,    -1,    -1,   101,    -1,
      -1,    -1,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,    -1,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
      -1,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,   165,    -1,   167,   168,   169,   170,   171,    -1,
     173,   174,    -1,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,    -1,    -1,
     223,   224,   225,   226,   227,    -1,   229,   230,   231,    -1,
      -1,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,    -1,   276,   277,    -1,    -1,   280,   281,   282,
      -1,    -1,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,    -1,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,   437,   438,    -1,   440,   441,   442,
     443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     3,    -1,
      -1,     6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    -1,    -1,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    94,
      95,    96,    97,    -1,    -1,    -1,   101,    -1,    -1,    -1,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,    -1,   229,   230,   231,    -1,    -1,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,    -1,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,   441,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     3,    -1,    -1,     6,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    -1,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    -1,    55,    56,
      57,    58,    59,    60,    -1,    -1,    63,    64,    65,    66,
      67,    -1,    69,    70,    71,    72,    73,    -1,    75,    -1,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    -1,
      87,    88,    89,    90,    91,    92,    -1,    94,    95,    96,
      97,    -1,    -1,    -1,   101,    -1,    -1,    -1,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,    -1,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,    -1,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,   140,   141,   142,    -1,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,   165,    -1,
     167,   168,   169,   170,   171,    -1,   173,   174,    -1,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,    -1,    -1,   223,   224,   225,   226,
     227,    -1,   229,   230,   231,    -1,    -1,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,    -1,   276,
     277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
      -1,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,   420,   421,   422,    -1,    -1,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
     437,   438,    -1,   440,   441,   442,   443,   444,   445,    -1,
      -1,   448,    -1,    -1,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     3,    -1,    -1,     6,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    -1,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    -1,    -1,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    73,    -1,    75,    -1,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    -1,    94,    95,    96,    97,    -1,
      -1,    -1,   101,    -1,    -1,    -1,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,   174,    -1,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,    -1,    -1,   223,   224,   225,   226,   227,    -1,
     229,   230,   231,    -1,    -1,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,    -1,   276,   277,    -1,
      -1,   280,   281,   282,    -1,    -1,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,    -1,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,   437,   438,
      -1,   440,   441,   442,   443,   444,   445,    -1,    -1,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    73,    -1,    75,    -1,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    94,    95,    96,    97,    -1,    -1,    -1,
     101,    -1,    -1,    -1,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,   174,    -1,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
      -1,    -1,   223,   224,   225,   226,   227,    -1,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,    -1,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,    -1,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,   437,   438,    -1,   440,
     441,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    -1,    -1,
      63,    64,    65,    66,    67,    -1,    69,    70,    71,    72,
      73,    -1,    75,    -1,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    -1,    87,    88,    89,    90,    91,    92,
      -1,    94,    95,    96,    97,    -1,    -1,    -1,   101,    -1,
      -1,    -1,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,    -1,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
      -1,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,   165,    -1,   167,   168,   169,   170,   171,    -1,
     173,   174,    -1,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,    -1,    -1,
     223,   224,   225,   226,   227,    -1,   229,   230,   231,    -1,
      -1,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,    -1,   276,   277,    -1,    -1,   280,   281,   282,
      -1,    -1,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,    -1,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,   437,   438,    -1,   440,   441,   442,
     443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    -1,    -1,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    94,
      95,    96,    97,    -1,    -1,    -1,   101,    -1,    -1,    -1,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,    -1,   229,   230,   231,    -1,    -1,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,    -1,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,   441,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    -1,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    -1,    55,    56,
      57,    58,    59,    60,    -1,    -1,    63,    64,    65,    66,
      67,    -1,    69,    70,    71,    72,    73,    -1,    75,    -1,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    -1,
      87,    88,    89,    90,    91,    92,    -1,    94,    95,    96,
      97,    -1,    -1,    -1,   101,    -1,    -1,    -1,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,    -1,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,    -1,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,   140,   141,   142,    -1,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,   165,    -1,
     167,   168,   169,   170,   171,    -1,   173,   174,    -1,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,    -1,    -1,   223,   224,   225,   226,
     227,    -1,   229,   230,   231,    -1,    -1,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,    -1,   276,
     277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
      -1,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,   420,   421,   422,    -1,    -1,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
     437,   438,    -1,   440,   441,   442,   443,   444,   445,    -1,
      -1,   448,    -1,    -1,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    -1,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    -1,    -1,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    73,    -1,    75,    -1,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    -1,    94,    95,    96,    97,    -1,
      -1,    -1,   101,    -1,    -1,    -1,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,   174,    -1,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,    -1,    -1,   223,   224,   225,   226,   227,    -1,
     229,   230,   231,    -1,    -1,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,    -1,   276,   277,    -1,
      -1,   280,   281,   282,    -1,    -1,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,    -1,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,   437,   438,
      -1,   440,   441,   442,   443,   444,   445,    -1,    -1,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    73,    -1,    75,    -1,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    94,    95,    96,    97,    -1,    -1,    -1,
     101,    -1,    -1,    -1,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,   174,    -1,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
      -1,    -1,   223,   224,   225,   226,   227,    -1,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,    -1,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,    -1,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,   437,   438,    -1,   440,
     441,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,
      43,    44,    -1,    46,    47,    48,    49,    50,    -1,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    -1,    -1,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    -1,    -1,    76,    77,    78,    79,    80,    81,    -1,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,    -1,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
      -1,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,   159,   160,    -1,   162,
     163,   164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,
     173,   174,    -1,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,    -1,   211,    -1,
      -1,   214,    -1,   216,   217,   218,   219,   220,    -1,    -1,
     223,   224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,
      -1,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,   267,    -1,   269,   270,   271,   272,
     273,   274,    -1,   276,   277,    -1,    -1,   280,   281,   282,
      -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,    -1,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,    -1,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,   424,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,   437,   438,    -1,   440,    -1,   442,
     443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      -1,    46,    47,    48,    49,    50,    -1,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    -1,    -1,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    -1,
      -1,    -1,    77,    78,    79,    80,    81,    -1,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    -1,    -1,
      95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,   159,   160,    -1,   162,   163,   164,
      -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,
      -1,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
      -1,   226,   227,    -1,   229,   230,   231,    -1,    -1,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,    -1,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,   267,    -1,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,    -1,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,    -1,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,    -1,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,    -1,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,    -1,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,    46,
      47,    48,    49,    50,    -1,    52,    53,    -1,    55,    56,
      57,    58,    59,    60,    -1,    -1,    63,    64,    65,    66,
      67,    -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,
      77,    78,    79,    80,    81,    -1,    83,    84,    85,    -1,
      87,    88,    89,    90,    91,    92,    93,    -1,    95,    96,
      97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,    -1,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,    -1,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,   140,   141,   142,    -1,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,
      -1,   168,   169,   170,   171,   172,   173,   174,    -1,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,
     217,   218,   219,   220,    -1,    -1,   223,   224,    -1,   226,
      -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
     267,    -1,   269,   270,   271,   272,   273,   274,    -1,   276,
     277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,
     287,    -1,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,    -1,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
      -1,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
      -1,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,   420,   421,   422,    -1,    -1,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
     437,   438,    -1,   440,    -1,   442,   443,   444,   445,    -1,
      -1,   448,    -1,    -1,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    -1,    42,    43,    44,    -1,    46,    47,    48,
      49,    50,    -1,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    -1,    -1,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    73,    -1,    -1,    -1,    77,    78,
      79,    80,    81,    -1,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    93,    -1,    95,    96,    97,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,
     169,   170,   171,   172,   173,   174,    -1,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,
     219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,
     229,   230,   231,    -1,    -1,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,    -1,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,   267,    -1,
     269,   270,   271,   272,   273,   274,    -1,   276,   277,    -1,
      -1,   280,   281,   282,    -1,    -1,   285,   286,   287,    -1,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,    -1,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,    -1,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,    -1,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,   437,   438,
      -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    -1,    46,    47,    48,    49,    50,
      -1,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    -1,    -1,    -1,    77,    78,    79,    80,
      81,    -1,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,   163,   164,    -1,    -1,    -1,   168,   169,   170,
     171,    -1,   173,   174,    -1,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,    -1,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,    -1,    -1,   214,    -1,   216,   217,   218,   219,   220,
      -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
      -1,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,   267,    -1,   269,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,    -1,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
      -1,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,    -1,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,   437,   438,    -1,   440,
      -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,
      43,    44,    -1,    46,    47,    48,    49,    50,    -1,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    -1,    -1,
      63,    64,    65,    66,    67,    -1,    69,    70,    71,    72,
      73,    -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,
      83,    84,    85,    -1,    87,    88,    89,    90,    91,    92,
      93,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,    -1,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
      -1,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,
     173,   174,    -1,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,    -1,   211,    -1,
      -1,   214,    -1,   216,   217,   218,   219,   220,    -1,    -1,
     223,   224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,
      -1,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,   267,    -1,   269,   270,   271,   272,
     273,   274,    -1,   276,   277,    -1,    -1,   280,   281,   282,
      -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,    -1,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,    -1,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,   437,   438,    -1,   440,    -1,   442,
     443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      -1,    46,    47,    48,    49,    50,    -1,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    -1,    -1,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      -1,    -1,    77,    78,    79,    80,    81,    -1,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    -1,
      95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,   159,   160,    -1,   162,   163,   164,
      -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,
      -1,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
      -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,    -1,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,   267,    -1,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,    -1,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,    -1,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,    -1,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,    -1,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,    -1,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,    -1,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,    46,
      47,    48,    49,    50,    -1,    52,    53,    -1,    55,    56,
      57,    58,    59,    60,    -1,    -1,    63,    64,    65,    66,
      67,    -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,
      77,    78,    79,    80,    81,    -1,    83,    84,    85,    -1,
      87,    88,    89,    90,    91,    92,    93,    -1,    95,    96,
      97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,    -1,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,    -1,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,   140,   141,   142,    -1,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,
      -1,   168,   169,   170,   171,    -1,   173,   174,    -1,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,
     217,   218,   219,   220,    -1,    -1,   223,   224,    -1,   226,
      -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
     267,    -1,   269,   270,   271,   272,   273,   274,    -1,   276,
     277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,
     287,    -1,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,    -1,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
      -1,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
      -1,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,   420,   421,   422,    -1,    -1,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
     437,   438,    -1,   440,    -1,   442,   443,   444,   445,    -1,
      -1,   448,    -1,    -1,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    -1,    42,    43,    44,    -1,    46,    47,    48,
      49,    50,    -1,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    -1,    -1,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    73,    -1,    -1,    -1,    77,    78,
      79,    80,    81,    -1,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    -1,    -1,    95,    96,    97,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,
     169,   170,   171,    -1,   173,   174,    -1,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,
     219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,
     229,   230,   231,    -1,    -1,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,    -1,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,   267,    -1,
     269,   270,   271,   272,   273,   274,    -1,   276,   277,    -1,
     279,   280,   281,   282,    -1,    -1,   285,   286,   287,    -1,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,    -1,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,    -1,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,    -1,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,   437,   438,
      -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    -1,    46,    47,    48,    49,    50,
      -1,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    73,    -1,    -1,    -1,    77,    78,    79,    80,
      81,    -1,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,
     171,    -1,   173,   174,    -1,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,    -1,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,    -1,    -1,   214,    -1,   216,   217,   218,   219,   220,
      -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
      -1,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,   267,    -1,   269,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,    -1,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
      -1,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,    -1,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,    -1,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,   434,   435,   436,   437,   438,    -1,   440,
      -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,
      43,    44,    -1,    46,    47,    48,    49,    50,    -1,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    -1,    -1,
      63,    64,    65,    66,    67,    -1,    69,    70,    71,    72,
      73,    -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,
      83,    84,    85,    -1,    87,    88,    89,    90,    91,    92,
      -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,    -1,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
      -1,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,
     173,   174,    -1,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,    -1,   211,    -1,
      -1,   214,    -1,   216,   217,   218,   219,   220,    -1,    -1,
     223,   224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,
      -1,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,   267,    -1,   269,   270,   271,   272,
     273,   274,    -1,   276,   277,    -1,    -1,   280,   281,   282,
      -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,    -1,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,    -1,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,    -1,   425,   426,   427,   428,   429,   430,    -1,   432,
     433,   434,   435,   436,   437,   438,    -1,   440,    -1,   442,
     443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      -1,    46,    47,    48,    49,    50,    -1,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    -1,    -1,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      -1,    -1,    77,    78,    79,    80,    81,    -1,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    -1,
      95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
      -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,
      -1,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
      -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,    -1,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,   267,    -1,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,    -1,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,    -1,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,    -1,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,    -1,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,    -1,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,    -1,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,    46,
      47,    48,    49,    50,    -1,    52,    53,    -1,    55,    56,
      57,    58,    59,    60,    -1,    -1,    63,    64,    65,    66,
      67,    -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,
      77,    78,    79,    80,    81,    -1,    83,    84,    85,    -1,
      87,    88,    89,    90,    91,    92,    -1,    -1,    95,    96,
      97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,    -1,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,    -1,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,   140,   141,   142,    -1,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,
      -1,   168,   169,   170,   171,    -1,   173,   174,    -1,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,
     217,   218,   219,   220,    -1,    -1,   223,   224,    -1,   226,
      -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
     267,    -1,   269,   270,   271,   272,   273,   274,    -1,   276,
     277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,
     287,    -1,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,    -1,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
      -1,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
      -1,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,   420,   421,   422,    -1,    -1,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
     437,   438,    -1,   440,    -1,   442,   443,   444,   445,    -1,
      -1,   448,    -1,    -1,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    -1,    42,    43,    44,    -1,    46,    47,    48,
      49,    50,    -1,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    -1,    -1,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    73,    -1,    -1,    -1,    77,    78,
      79,    80,    81,    -1,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    -1,    -1,    95,    96,    97,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,
     169,   170,   171,    -1,   173,   174,    -1,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,
     219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,
     229,   230,   231,    -1,    -1,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,    -1,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,   267,    -1,
     269,   270,   271,   272,   273,   274,    -1,   276,   277,    -1,
      -1,   280,   281,   282,    -1,    -1,   285,   286,   287,    -1,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,    -1,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,    -1,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,    -1,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,   437,   438,
      -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    -1,    46,    47,    48,    49,    50,
      -1,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    73,    -1,    -1,    -1,    77,    78,    79,    80,
      81,    -1,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,
     171,    -1,   173,   174,    -1,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,    -1,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,    -1,    -1,   214,    -1,   216,   217,   218,   219,   220,
      -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
      -1,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,   267,    -1,   269,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,    -1,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
      -1,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,    -1,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,    -1,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,   437,   438,    -1,   440,
      -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,
      43,    44,    -1,    46,    47,    48,    49,    50,    -1,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    -1,    -1,
      63,    64,    65,    66,    67,    -1,    69,    70,    71,    72,
      73,    -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,
      83,    84,    85,    -1,    87,    88,    89,    90,    91,    92,
      -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,    -1,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
      -1,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,
     173,   174,    -1,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,    -1,   211,    -1,
      -1,   214,    -1,   216,   217,   218,   219,   220,    -1,    -1,
     223,   224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,
      -1,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,   267,    -1,   269,   270,   271,   272,
     273,   274,    -1,   276,   277,    -1,   279,   280,   281,   282,
      -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,    -1,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,    -1,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,   437,   438,    -1,   440,    -1,   442,
     443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      -1,    46,    47,    48,    49,    50,    -1,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    -1,    -1,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      -1,    -1,    77,    78,    79,    80,    81,    -1,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    -1,
      95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
      -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,
      -1,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
      -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,    -1,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,   267,    -1,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,    -1,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,    -1,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,    -1,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,    -1,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,    -1,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,    -1,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,    46,
      47,    48,    49,    50,    -1,    52,    53,    -1,    55,    56,
      57,    58,    59,    60,    -1,    -1,    63,    64,    65,    66,
      67,    -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,
      77,    78,    79,    80,    81,    -1,    83,    84,    85,    -1,
      87,    88,    89,    90,    91,    92,    -1,    -1,    95,    96,
      97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,    -1,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,    -1,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,   140,   141,   142,    -1,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,
      -1,   168,   169,   170,   171,    -1,   173,   174,    -1,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,
     217,   218,   219,   220,    -1,    -1,   223,   224,    -1,   226,
      -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
     267,    -1,   269,   270,   271,   272,   273,   274,    -1,   276,
     277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,
     287,    -1,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,    -1,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
      -1,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
      -1,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,   420,   421,   422,    -1,    -1,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
     437,   438,    -1,   440,    -1,   442,   443,   444,   445,    -1,
      -1,   448,    -1,    -1,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    -1,    42,    43,    44,    -1,    46,    47,    48,
      49,    50,    -1,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    -1,    -1,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    73,    -1,    -1,    -1,    77,    78,
      79,    80,    81,    -1,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    -1,    -1,    95,    96,    97,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,
     169,   170,   171,    -1,   173,   174,    -1,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,
     219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,
     229,   230,   231,    -1,    -1,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,    -1,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,   267,    -1,
     269,   270,   271,   272,   273,   274,    -1,   276,   277,    -1,
      -1,   280,   281,   282,    -1,    -1,   285,   286,   287,    -1,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,    -1,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,    -1,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,    -1,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,   437,   438,
      -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    -1,    46,    47,    48,    49,    50,
      -1,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    73,    -1,    -1,    -1,    77,    78,    79,    80,
      81,    -1,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,
     171,    -1,   173,   174,    -1,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,    -1,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,    -1,    -1,   214,    -1,   216,   217,   218,   219,   220,
      -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
      -1,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,   267,    -1,   269,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,    -1,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
      -1,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,    -1,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,    -1,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,   437,   438,    -1,   440,
      -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,
      43,    44,    -1,    46,    47,    48,    49,    50,    -1,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    -1,    -1,
      63,    64,    65,    66,    67,    -1,    69,    70,    71,    72,
      73,    -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,
      83,    84,    85,    -1,    87,    88,    89,    90,    91,    92,
      -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,    -1,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
      -1,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,
     173,   174,    -1,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,    -1,   211,    -1,
      -1,   214,    -1,   216,   217,   218,   219,   220,    -1,    -1,
     223,   224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,
      -1,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,   267,    -1,   269,   270,   271,   272,
     273,   274,    -1,   276,   277,    -1,    -1,   280,   281,   282,
      -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,    -1,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,    -1,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,   437,   438,    -1,   440,    -1,   442,
     443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    -1,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    -1,    -1,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      -1,    -1,    77,    78,    79,    80,    81,    -1,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    -1,
      95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
      -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,
      -1,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
      -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,    -1,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,   267,    -1,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,    -1,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,    -1,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,    -1,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,    -1,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,    -1,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,    -1,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,    46,
      47,    48,    49,    50,    -1,    52,    53,    -1,    55,    56,
      57,    58,    59,    60,    -1,    -1,    63,    64,    65,    66,
      67,    -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,
      77,    78,    79,    80,    81,    -1,    83,    84,    85,    -1,
      87,    88,    89,    90,    91,    92,    -1,    -1,    95,    96,
      97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,    -1,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,    -1,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,   140,   141,   142,    -1,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,
      -1,   168,   169,   170,   171,    -1,   173,   174,    -1,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,
     217,   218,   219,   220,    -1,    -1,   223,   224,    -1,   226,
      -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
     267,    -1,   269,   270,   271,   272,   273,   274,    -1,   276,
     277,    -1,   279,   280,   281,   282,    -1,    -1,   285,   286,
     287,    -1,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,    -1,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
      -1,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
      -1,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,   420,   421,   422,    -1,    -1,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
     437,   438,    -1,   440,    -1,   442,   443,   444,   445,    -1,
      -1,   448,    -1,    -1,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    -1,    42,    43,    44,    -1,    46,    47,    48,
      49,    50,    -1,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    -1,    -1,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    73,    -1,    -1,    -1,    77,    78,
      79,    80,    81,    -1,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    -1,    -1,    95,    96,    97,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,
     169,   170,   171,    -1,   173,   174,    -1,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,
     219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,
     229,   230,   231,    -1,    -1,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,    -1,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,   267,    -1,
     269,   270,   271,   272,   273,   274,    -1,   276,   277,    -1,
      -1,   280,   281,   282,    -1,    -1,   285,   286,   287,    -1,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,    -1,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,    -1,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,    -1,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,   437,   438,
      -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    -1,    46,    47,    48,    49,    50,
      -1,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    73,    -1,    -1,    -1,    77,    78,    79,    80,
      81,    -1,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,
     171,    -1,   173,   174,    -1,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,    -1,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,    -1,    -1,   214,    -1,   216,   217,   218,   219,   220,
      -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
      -1,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,   267,    -1,   269,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,    -1,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
      -1,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,    -1,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,    -1,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,   437,   438,    -1,   440,
      -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       3,    -1,    -1,     6,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,
      43,    44,    -1,    46,    47,    48,    49,    50,    -1,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    -1,    -1,
      63,    64,    65,    66,    67,    -1,    69,    70,    71,    72,
      73,    -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,
      83,    84,    85,    -1,    87,    88,    89,    90,    91,    92,
      -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,    -1,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
      -1,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,
     173,   174,    -1,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,    -1,   211,    -1,
      -1,   214,    -1,   216,   217,   218,   219,   220,    -1,    -1,
     223,   224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,
      -1,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,   267,    -1,   269,   270,   271,   272,
     273,   274,    -1,   276,   277,    -1,    -1,   280,   281,   282,
      -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,    -1,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,    -1,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,   437,   438,    -1,   440,    -1,   442,
     443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    11,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      -1,    46,    47,    48,    49,    50,    -1,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    -1,    -1,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      -1,    -1,    77,    78,    79,    80,    81,    -1,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    -1,
      95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
      -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,
      -1,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
      -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,    -1,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,   267,    -1,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,    -1,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,    -1,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,    -1,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,    -1,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,    -1,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,    -1,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      37,    -1,    39,    40,    -1,    42,    43,    44,    -1,    46,
      47,    48,    49,    50,    -1,    52,    53,    -1,    55,    56,
      57,    58,    59,    60,    -1,    -1,    63,    64,    65,    66,
      67,    -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,
      77,    78,    79,    80,    81,    -1,    83,    84,    85,    -1,
      87,    88,    89,    90,    91,    92,    -1,    -1,    95,    96,
      97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,    -1,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,    -1,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,   140,   141,   142,    -1,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,
      -1,   168,   169,   170,   171,    -1,   173,   174,    -1,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,
     217,   218,   219,   220,    -1,    -1,   223,   224,    -1,   226,
      -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
     267,    -1,   269,   270,   271,   272,   273,   274,    -1,   276,
     277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,
     287,    -1,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,    -1,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
      -1,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
      -1,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,   420,   421,   422,    -1,    -1,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
     437,   438,    -1,   440,    -1,   442,   443,   444,   445,    -1,
      -1,   448,    -1,    -1,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    37,    -1,
      39,    40,    -1,    42,    43,    44,    -1,    46,    47,    48,
      49,    50,    -1,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    -1,    -1,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    73,    -1,    -1,    -1,    77,    78,
      79,    80,    81,    -1,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    -1,    -1,    95,    96,    97,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,
     169,   170,   171,    -1,   173,   174,    -1,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,
     219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,
     229,   230,   231,    -1,    -1,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,    -1,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,   267,    -1,
     269,   270,   271,   272,   273,   274,    -1,   276,   277,    -1,
      -1,   280,   281,   282,    -1,    -1,   285,   286,   287,    -1,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,    -1,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,    -1,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,    -1,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,   437,   438,
      -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    -1,    46,    47,    48,    49,    50,
      -1,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    73,    -1,    -1,    -1,    77,    78,    79,    80,
      81,    -1,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,
     171,    -1,   173,   174,    -1,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,    -1,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,    -1,    -1,   214,    -1,   216,   217,   218,   219,   220,
      -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
      -1,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,   267,    -1,   269,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,    -1,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
      -1,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,    -1,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,    -1,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,   437,   438,    -1,   440,
      -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,
      43,    44,    -1,    46,    47,    48,    49,    50,    -1,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    -1,    -1,
      63,    64,    65,    66,    67,    -1,    69,    70,    71,    72,
      73,    -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,
      83,    84,    85,    -1,    87,    88,    89,    90,    91,    92,
      -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,    -1,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
      -1,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,
     173,   174,    -1,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,    -1,   211,    -1,
      -1,   214,    -1,   216,   217,   218,   219,   220,    -1,    -1,
     223,   224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,
      -1,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,   267,    -1,   269,   270,   271,   272,
     273,   274,    -1,   276,   277,    -1,    -1,   280,   281,   282,
      -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,    -1,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,    -1,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,   437,   438,    -1,   440,    -1,   442,
     443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      -1,    46,    47,    48,    49,    50,    -1,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    -1,    -1,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      -1,    -1,    77,    78,    79,    80,    81,    -1,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    -1,
      95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
      -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,
      -1,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
      -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,    -1,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,   267,    -1,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,    -1,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,    -1,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,    -1,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,    -1,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,    -1,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,    -1,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,    46,
      47,    48,    49,    50,    -1,    52,    53,    -1,    55,    56,
      57,    58,    59,    60,    -1,    -1,    63,    64,    65,    66,
      67,    -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,
      77,    78,    79,    80,    81,    -1,    83,    84,    85,    -1,
      87,    88,    89,    90,    91,    92,    -1,    -1,    95,    96,
      97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,    -1,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,    -1,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,   140,   141,   142,    -1,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,
      -1,   168,   169,   170,   171,    -1,   173,   174,    -1,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,
     217,   218,   219,   220,    -1,    -1,   223,   224,    -1,   226,
      -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
     267,    -1,   269,   270,   271,   272,   273,   274,    -1,   276,
     277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,
     287,    -1,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,    -1,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
      -1,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
      -1,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,   420,   421,   422,    -1,    -1,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
     437,   438,    -1,   440,    -1,   442,   443,   444,   445,    -1,
      -1,   448,    -1,    -1,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    -1,    42,    43,    44,    -1,    46,    47,    48,
      49,    50,    -1,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    -1,    -1,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    73,    -1,    -1,    -1,    77,    78,
      79,    80,    81,    -1,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    -1,    -1,    95,    96,    97,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,
     169,   170,   171,    -1,   173,   174,    -1,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,
     219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,
     229,   230,   231,    -1,    -1,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,    -1,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,   267,    -1,
     269,   270,   271,   272,   273,   274,    -1,   276,   277,    -1,
      -1,   280,   281,   282,    -1,    -1,   285,   286,   287,    -1,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,    -1,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,    -1,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,    -1,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,   437,   438,
      -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    -1,    46,    47,    48,    49,    50,
      -1,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    73,    -1,    -1,    -1,    77,    78,    79,    80,
      81,    -1,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,
     171,    -1,   173,   174,    -1,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,    -1,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,    -1,    -1,   214,    -1,   216,   217,   218,   219,   220,
      -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
      -1,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,   267,    -1,   269,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,    -1,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
      -1,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,    -1,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,    -1,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,   437,   438,    -1,   440,
      -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,
      43,    44,    -1,    46,    47,    48,    49,    50,    -1,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    -1,    -1,
      63,    64,    65,    66,    67,    -1,    69,    70,    71,    72,
      73,    -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,
      83,    84,    85,    -1,    87,    88,    89,    90,    91,    92,
      -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,    -1,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
      -1,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,
     173,   174,    -1,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,    -1,   211,    -1,
      -1,   214,    -1,   216,   217,   218,   219,   220,    -1,    -1,
     223,   224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,
      -1,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,   267,    -1,   269,   270,   271,   272,
     273,   274,    -1,   276,   277,    -1,    -1,   280,   281,   282,
      -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,    -1,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,    -1,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,   437,   438,    -1,   440,    -1,   442,
     443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      -1,    46,    47,    48,    49,    50,    -1,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    -1,    -1,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      -1,    -1,    77,    78,    79,    80,    81,    -1,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    -1,
      95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
      -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,
      -1,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
      -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,    -1,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,   267,    -1,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,    -1,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,    -1,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,    -1,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,    -1,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,    -1,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,    -1,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,    46,
      47,    48,    49,    50,    -1,    52,    53,    -1,    55,    56,
      57,    58,    59,    60,    -1,    -1,    63,    64,    65,    66,
      67,    -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,
      77,    78,    79,    80,    81,    -1,    83,    84,    85,    -1,
      87,    88,    89,    90,    91,    92,    -1,    -1,    95,    96,
      97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,    -1,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,    -1,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,   140,   141,   142,    -1,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,
      -1,   168,   169,   170,   171,    -1,   173,   174,    -1,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,
     217,   218,   219,   220,    -1,    -1,   223,   224,    -1,   226,
      -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
     267,    -1,   269,   270,   271,   272,   273,   274,    -1,   276,
     277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,
     287,    -1,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,    -1,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
      -1,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
      -1,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,   420,   421,   422,    -1,    -1,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
     437,   438,    -1,   440,    -1,   442,   443,   444,   445,    -1,
      -1,   448,    -1,    -1,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    -1,    42,    43,    44,    -1,    46,    47,    48,
      49,    50,    -1,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    -1,    -1,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    73,    -1,    -1,    -1,    77,    78,
      79,    80,    81,    -1,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    -1,    -1,    95,    96,    97,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,
     169,   170,   171,    -1,   173,   174,    -1,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,
     219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,
     229,   230,   231,    -1,    -1,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,    -1,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,   267,    -1,
     269,   270,   271,   272,   273,   274,    -1,   276,   277,    -1,
      -1,   280,   281,   282,    -1,    -1,   285,   286,   287,    -1,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,    -1,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,    -1,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,    -1,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,   437,   438,
      -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    -1,    46,    47,    48,    49,    50,
      -1,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    73,    -1,    -1,    -1,    77,    78,    79,    80,
      81,    -1,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,
     171,    -1,   173,   174,    -1,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,    -1,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,    -1,    -1,   214,    -1,   216,   217,   218,   219,   220,
      -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
      -1,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,   267,    -1,   269,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,    -1,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
      -1,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,    -1,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,    -1,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,   437,   438,    -1,   440,
      -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,
      43,    44,    -1,    46,    47,    48,    49,    50,    -1,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    -1,    -1,
      63,    64,    65,    66,    67,    -1,    69,    70,    71,    72,
      73,    -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,
      83,    84,    85,    -1,    87,    88,    89,    90,    91,    92,
      -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,    -1,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
      -1,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,
     173,   174,    -1,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,    -1,   211,    -1,
      -1,   214,    -1,   216,   217,   218,   219,   220,    -1,    -1,
     223,   224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,
      -1,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,   267,    -1,   269,   270,   271,   272,
     273,   274,    -1,   276,   277,    -1,    -1,   280,   281,   282,
      -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,    -1,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,    -1,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,   437,   438,    -1,   440,    -1,   442,
     443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      -1,    46,    47,    48,    49,    50,    -1,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    -1,    -1,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      -1,    -1,    77,    78,    79,    80,    81,    -1,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    -1,
      95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
      -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,
      -1,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
      -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,    -1,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,   267,    -1,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,    -1,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,    -1,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,    -1,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,    -1,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,    -1,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,    -1,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,    46,
      47,    48,    49,    50,    -1,    52,    53,    -1,    55,    56,
      57,    58,    59,    60,    -1,    -1,    63,    64,    65,    66,
      67,    -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,
      77,    78,    79,    80,    81,    -1,    83,    84,    85,    -1,
      87,    88,    89,    90,    91,    92,    -1,    -1,    95,    96,
      97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,    -1,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,    -1,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,   140,   141,   142,    -1,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,
      -1,   168,   169,   170,   171,    -1,   173,   174,    -1,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,
     217,   218,   219,   220,    -1,    -1,   223,   224,    -1,   226,
      -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
     267,    -1,   269,   270,   271,   272,   273,   274,    -1,   276,
     277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,
     287,    -1,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,    -1,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
      -1,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
      -1,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,   420,   421,   422,    -1,    -1,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
     437,   438,    -1,   440,    -1,   442,   443,   444,   445,    -1,
      -1,   448,    -1,    -1,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    -1,    42,    43,    44,    -1,    46,    47,    48,
      49,    50,    -1,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    -1,    -1,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    73,    -1,    -1,    -1,    77,    78,
      79,    80,    81,    -1,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    -1,    -1,    95,    96,    97,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,
     169,   170,   171,    -1,   173,   174,    -1,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,
     219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,
     229,   230,   231,    -1,    -1,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,    -1,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,   267,    -1,
     269,   270,   271,   272,   273,   274,    -1,   276,   277,    -1,
      -1,   280,   281,   282,    -1,    -1,   285,   286,   287,    -1,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,    -1,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,    -1,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,    -1,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,   437,   438,
      -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    -1,    46,    47,    48,    49,    50,
      -1,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    73,    -1,    -1,    -1,    77,    78,    79,    80,
      81,    -1,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,
     171,    -1,   173,   174,    -1,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,    -1,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,    -1,    -1,   214,    -1,   216,   217,   218,   219,   220,
      -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
      -1,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,   267,    -1,   269,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,    -1,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
      -1,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,    -1,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,    -1,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,   437,   438,    -1,   440,
      -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,
      43,    44,    -1,    46,    47,    48,    49,    50,    -1,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    -1,    -1,
      63,    64,    65,    66,    67,    -1,    69,    70,    71,    72,
      73,    -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,
      83,    84,    85,    -1,    87,    88,    89,    90,    91,    92,
      -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,    -1,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
      -1,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,
     173,   174,    -1,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,    -1,   211,    -1,
      -1,   214,    -1,   216,   217,   218,   219,   220,    -1,    -1,
     223,   224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,
      -1,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,   267,    -1,   269,   270,   271,   272,
     273,   274,    -1,   276,   277,    -1,    -1,   280,   281,   282,
      -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,    -1,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,    -1,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,   437,   438,    -1,   440,    -1,   442,
     443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      -1,    46,    47,    48,    49,    50,    -1,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    -1,    -1,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      -1,    -1,    77,    78,    79,    80,    81,    -1,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    -1,
      95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
      -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,
      -1,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
      -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,    -1,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,   267,    -1,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,    -1,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,    -1,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,    -1,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,    -1,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,    -1,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,    -1,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,    46,
      47,    48,    49,    50,    -1,    52,    53,    -1,    55,    56,
      57,    58,    59,    60,    -1,    -1,    63,    64,    65,    66,
      67,    -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,
      77,    78,    79,    80,    81,    -1,    83,    84,    85,    -1,
      87,    88,    89,    90,    91,    92,    -1,    -1,    95,    96,
      97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,    -1,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,    -1,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,   140,   141,   142,    -1,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,
      -1,   168,   169,   170,   171,    -1,   173,   174,    -1,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,
     217,   218,   219,   220,    -1,    -1,   223,   224,    -1,   226,
      -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
     267,    -1,   269,   270,   271,   272,   273,   274,    -1,   276,
     277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,
     287,    -1,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,    -1,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
      -1,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
      -1,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,   420,   421,   422,    -1,    -1,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
     437,   438,    -1,   440,    -1,   442,   443,   444,   445,    -1,
      -1,   448,    -1,    -1,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    -1,    42,    43,    44,    -1,    46,    47,    48,
      49,    50,    -1,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    -1,    -1,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    73,    -1,    -1,    -1,    77,    78,
      79,    80,    81,    -1,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    -1,    -1,    95,    96,    97,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,
     169,   170,   171,    -1,   173,   174,    -1,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,
     219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,
     229,   230,   231,    -1,    -1,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,    -1,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,   267,    -1,
     269,   270,   271,   272,   273,   274,    -1,   276,   277,    -1,
      -1,   280,   281,   282,    -1,    -1,   285,   286,   287,    -1,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,    -1,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,    -1,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,    -1,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,   437,   438,
      -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    -1,    46,    47,    48,    49,    50,
      -1,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    73,    -1,    -1,    -1,    77,    78,    79,    80,
      81,    -1,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,
     171,    -1,   173,   174,    -1,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,    -1,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,    -1,    -1,   214,    -1,   216,   217,   218,   219,   220,
      -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
      -1,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,   267,    -1,   269,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,    -1,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
      -1,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,    -1,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,    -1,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,   437,   438,    -1,   440,
      -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,
      43,    44,    -1,    46,    47,    48,    49,    50,    -1,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    -1,    -1,
      63,    64,    65,    66,    67,    -1,    69,    70,    71,    72,
      73,    -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,
      83,    84,    85,    -1,    87,    88,    89,    90,    91,    92,
      -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,    -1,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
      -1,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,
     173,   174,    -1,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,    -1,   211,    -1,
      -1,   214,    -1,   216,   217,   218,   219,   220,    -1,    -1,
     223,   224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,
      -1,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,   267,    -1,   269,   270,   271,   272,
     273,   274,    -1,   276,   277,    -1,    -1,   280,   281,   282,
      -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,    -1,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,    -1,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,   437,   438,    -1,   440,    -1,   442,
     443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      -1,    46,    47,    48,    49,    50,    -1,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    -1,    -1,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      -1,    -1,    77,    78,    79,    80,    81,    -1,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    -1,
      95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
      -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,
      -1,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
      -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,    -1,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,   267,    -1,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,    -1,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,    -1,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,    -1,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,    -1,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,    -1,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,    -1,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,    46,
      47,    48,    49,    50,    -1,    52,    53,    -1,    55,    56,
      57,    58,    59,    60,    -1,    -1,    63,    64,    65,    66,
      67,    -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,
      77,    78,    79,    80,    81,    -1,    83,    84,    85,    -1,
      87,    88,    89,    90,    91,    92,    -1,    -1,    95,    96,
      97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,    -1,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,    -1,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,   140,   141,   142,    -1,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,
      -1,   168,   169,   170,   171,    -1,   173,   174,    -1,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,
     217,   218,   219,   220,    -1,    -1,   223,   224,    -1,   226,
      -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
     267,    -1,   269,   270,   271,   272,   273,   274,    -1,   276,
     277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,
     287,    -1,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,    -1,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
      -1,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
      -1,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,   420,   421,   422,    -1,    -1,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
     437,   438,    -1,   440,    -1,   442,   443,   444,   445,    -1,
      -1,   448,    -1,    -1,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    -1,    42,    43,    44,    -1,    46,    47,    48,
      49,    50,    -1,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    -1,    -1,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    73,    -1,    -1,    -1,    77,    78,
      79,    80,    81,    -1,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    -1,    -1,    95,    96,    97,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,
     169,   170,   171,    -1,   173,   174,    -1,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,
     219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,
     229,   230,   231,    -1,    -1,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,    -1,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,   267,    -1,
     269,   270,   271,   272,   273,   274,    -1,   276,   277,    -1,
      -1,   280,   281,   282,    -1,    -1,   285,   286,   287,    -1,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,    -1,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,    -1,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,    -1,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,   437,   438,
      -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    -1,    46,    47,    48,    49,    50,
      -1,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    73,    -1,    -1,    -1,    77,    78,    79,    80,
      81,    -1,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,
     171,    -1,   173,   174,    -1,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,    -1,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,    -1,    -1,   214,    -1,   216,   217,   218,   219,   220,
      -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
      -1,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,   267,    -1,   269,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,    -1,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
      -1,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,    -1,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,    -1,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,   437,   438,    -1,   440,
      -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,
      43,    44,    -1,    46,    47,    48,    49,    50,    -1,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    -1,    -1,
      63,    64,    65,    66,    67,    -1,    69,    70,    71,    72,
      73,    -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,
      83,    84,    85,    -1,    87,    88,    89,    90,    91,    92,
      -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,    -1,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
      -1,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,
     173,   174,    -1,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,    -1,   211,    -1,
      -1,   214,    -1,   216,   217,   218,   219,   220,    -1,    -1,
     223,   224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,
      -1,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,   267,    -1,   269,   270,   271,   272,
     273,   274,    -1,   276,   277,    -1,    -1,   280,   281,   282,
      -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,    -1,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,    -1,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,   437,   438,    -1,   440,    -1,   442,
     443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      -1,    46,    47,    48,    49,    50,    -1,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    -1,    -1,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      -1,    -1,    77,    78,    79,    80,    81,    -1,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    -1,
      95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
      -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,
      -1,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
      -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,    -1,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,   267,    -1,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,    -1,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,    -1,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,    -1,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,    -1,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,    -1,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,    -1,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      37,    -1,    39,    40,    -1,    42,    43,    44,    -1,    46,
      47,    48,    49,    50,    -1,    52,    53,    -1,    55,    56,
      57,    58,    59,    60,    -1,    -1,    63,    64,    65,    66,
      67,    -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,
      77,    78,    79,    80,    81,    -1,    83,    84,    85,    -1,
      87,    88,    89,    90,    91,    92,    -1,    -1,    95,    96,
      97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,    -1,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,    -1,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,   140,   141,   142,    -1,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,
      -1,   168,   169,   170,   171,    -1,   173,   174,    -1,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,
     217,   218,   219,   220,    -1,    -1,   223,   224,    -1,   226,
      -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
     267,    -1,   269,   270,   271,   272,   273,   274,    -1,   276,
     277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,
     287,    -1,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,    -1,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,    -1,    -1,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
      -1,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
      -1,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,   420,   421,   422,    -1,    -1,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
     437,   438,    -1,   440,    -1,   442,   443,   444,   445,    -1,
      -1,   448,    -1,    -1,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    -1,    42,    43,    44,    -1,    46,    47,    48,
      49,    50,    -1,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    -1,    -1,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    73,    -1,    -1,    -1,    77,    78,
      79,    80,    81,    -1,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    -1,    -1,    95,    96,    97,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,
     169,   170,   171,    -1,   173,   174,    -1,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,
     219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,
     229,   230,   231,    -1,    -1,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,    -1,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,   267,    -1,
     269,   270,   271,   272,   273,   274,    -1,   276,   277,    -1,
      -1,   280,   281,   282,    -1,    -1,   285,   286,   287,    -1,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,    -1,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,    -1,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,    -1,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,   437,   438,
      -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    -1,    46,    47,    48,    49,    50,
      -1,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    73,    -1,    -1,    -1,    77,    78,    79,    80,
      81,    -1,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,
     171,    -1,   173,   174,    -1,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,    -1,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,    -1,    -1,   214,    -1,   216,   217,   218,   219,   220,
      -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
      -1,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,   267,    -1,   269,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,    -1,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
      -1,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,    -1,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,    -1,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,   437,   438,    -1,   440,
      -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,
      43,    44,    -1,    46,    47,    48,    49,    50,    -1,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    -1,    -1,
      63,    64,    65,    66,    67,    -1,    69,    70,    71,    72,
      73,    -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,
      83,    84,    85,    -1,    87,    88,    89,    90,    91,    92,
      -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,    -1,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
      -1,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,
     173,   174,    -1,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,    -1,   211,    -1,
      -1,   214,    -1,   216,   217,   218,   219,   220,    -1,    -1,
     223,   224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,
      -1,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,   267,    -1,   269,   270,   271,   272,
     273,   274,    -1,   276,   277,    -1,    -1,   280,   281,   282,
      -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,    -1,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,    -1,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,   437,   438,    -1,   440,    -1,   442,
     443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      -1,    46,    47,    48,    49,    50,    -1,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    -1,    -1,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      -1,    -1,    77,    78,    79,    80,    81,    -1,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    -1,
      95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
      -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,
      -1,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
      -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,    -1,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,   267,    -1,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,    -1,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,    -1,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,    -1,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,    -1,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,    -1,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,    -1,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,    46,
      47,    48,    49,    50,    -1,    52,    53,    -1,    55,    56,
      57,    58,    59,    60,    -1,    -1,    63,    64,    65,    66,
      67,    -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,
      77,    78,    79,    80,    81,    -1,    83,    84,    85,    -1,
      87,    88,    89,    90,    91,    92,    -1,    -1,    95,    96,
      97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,    -1,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,    -1,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,   140,   141,   142,    -1,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,
      -1,   168,   169,   170,   171,    -1,   173,   174,    -1,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,
     217,   218,   219,   220,    -1,    -1,   223,   224,    -1,   226,
      -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
     267,    -1,   269,   270,   271,   272,   273,   274,    -1,   276,
     277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,
     287,    -1,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,    -1,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
      -1,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
      -1,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,   420,   421,   422,    -1,    -1,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
     437,   438,    -1,   440,    -1,   442,   443,   444,   445,    -1,
      -1,   448,    -1,    -1,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    -1,    42,    43,    44,    -1,    46,    47,    48,
      49,    50,    -1,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    -1,    -1,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    73,    -1,    -1,    -1,    77,    78,
      79,    80,    81,    -1,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    -1,    -1,    95,    96,    97,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,
     169,   170,   171,    -1,   173,   174,    -1,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,
     219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,
     229,   230,   231,    -1,    -1,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,    -1,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,   267,    -1,
     269,   270,   271,   272,   273,   274,    -1,   276,   277,    -1,
      -1,   280,   281,   282,    -1,    -1,   285,   286,   287,    -1,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,    -1,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,    -1,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,    -1,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,   437,   438,
      -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    -1,    46,    47,    48,    49,    50,
      -1,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    73,    -1,    -1,    -1,    77,    78,    79,    80,
      81,    -1,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,
     171,    -1,   173,   174,    -1,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,    -1,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,    -1,    -1,   214,    -1,   216,   217,   218,   219,   220,
      -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
      -1,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,   267,    -1,   269,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,    -1,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
      -1,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,    -1,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,    -1,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,   437,   438,    -1,   440,
      -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,
      43,    44,    -1,    46,    47,    48,    49,    50,    -1,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    -1,    -1,
      63,    64,    65,    66,    67,    -1,    69,    70,    71,    72,
      73,    -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,
      83,    84,    85,    -1,    87,    88,    89,    90,    91,    92,
      -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,    -1,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
      -1,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,
     173,   174,    -1,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,    -1,   211,    -1,
      -1,   214,    -1,   216,   217,   218,   219,   220,    -1,    -1,
     223,   224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,
      -1,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,   267,    -1,   269,   270,   271,   272,
     273,   274,    -1,   276,   277,    -1,    -1,   280,   281,   282,
      -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,    -1,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,    -1,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,   437,   438,    -1,   440,    -1,   442,
     443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      -1,    46,    47,    48,    49,    50,    -1,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    -1,    -1,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      -1,    -1,    77,    78,    79,    80,    81,    -1,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    -1,
      95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
      -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,
      -1,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
      -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,    -1,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,   267,    -1,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,    -1,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,    -1,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,    -1,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,    -1,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,    -1,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,    -1,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,    46,
      47,    48,    49,    50,    -1,    52,    53,    -1,    55,    56,
      57,    58,    59,    60,    -1,    -1,    63,    64,    65,    66,
      67,    -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,
      77,    78,    79,    80,    81,    -1,    83,    84,    85,    -1,
      87,    88,    89,    90,    91,    92,    -1,    -1,    95,    96,
      97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,    -1,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,    -1,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,   140,   141,   142,    -1,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,
      -1,   168,   169,   170,   171,    -1,   173,   174,    -1,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,
     217,   218,   219,   220,    -1,    -1,   223,   224,    -1,   226,
      -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
     267,    -1,   269,   270,   271,   272,   273,   274,    -1,   276,
     277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,
     287,    -1,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,    -1,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
      -1,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
      -1,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,   420,   421,   422,    -1,    -1,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
     437,   438,    -1,   440,    -1,   442,   443,   444,   445,    -1,
      -1,   448,    -1,    -1,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    -1,    42,    43,    44,    -1,    46,    47,    48,
      49,    50,    -1,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    -1,    -1,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    73,    -1,    -1,    -1,    77,    78,
      79,    80,    81,    -1,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    -1,    -1,    95,    96,    97,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,    -1,    -1,    -1,   168,
     169,   170,   171,    -1,   173,   174,    -1,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,    -1,    -1,   214,    -1,   216,   217,   218,
     219,   220,    -1,    -1,   223,   224,    -1,   226,    -1,    -1,
     229,   230,   231,    -1,    -1,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,    -1,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,   267,    -1,
     269,   270,   271,   272,   273,   274,    -1,   276,   277,    -1,
      -1,   280,   281,   282,    -1,    -1,   285,   286,   287,    -1,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,    -1,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,    -1,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,    -1,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,   437,   438,
      -1,   440,    -1,   442,   443,   444,   445,    -1,    -1,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    -1,    46,    47,    48,    49,    50,
      -1,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    73,    -1,    -1,    -1,    77,    78,    79,    80,
      81,    -1,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    -1,    95,    96,    97,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,    -1,    -1,    -1,   168,   169,   170,
     171,    -1,   173,   174,    -1,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,    -1,
     201,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,    -1,    -1,   214,    -1,   216,   217,   218,   219,   220,
      -1,    -1,   223,   224,    -1,   226,    -1,    -1,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
      -1,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,   267,    -1,   269,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,    -1,   285,   286,   287,    -1,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,    -1,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
      -1,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,    -1,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,    -1,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,   437,   438,    -1,   440,
      -1,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,
      43,    44,    -1,    46,    47,    48,    49,    50,    -1,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    -1,    -1,
      63,    64,    65,    66,    67,    -1,    69,    70,    71,    72,
      73,    -1,    -1,    -1,    77,    78,    79,    80,    81,    -1,
      83,    84,    85,    -1,    87,    88,    89,    90,    91,    92,
      -1,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,    -1,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
      -1,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,    -1,    -1,    -1,   168,   169,   170,   171,    -1,
     173,   174,    -1,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,    -1,   211,    -1,
      -1,   214,    -1,   216,   217,   218,   219,   220,    -1,    -1,
     223,   224,    -1,   226,    -1,    -1,   229,   230,   231,    -1,
      -1,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,   267,    -1,   269,   270,   271,   272,
     273,   274,    -1,   276,   277,    -1,    -1,   280,   281,   282,
      -1,    -1,   285,   286,   287,    -1,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,    -1,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,    -1,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,   437,   438,    -1,   440,    -1,   442,
     443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      -1,    46,    47,    48,    49,    50,    -1,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    -1,    -1,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      -1,    -1,    77,    78,    79,    80,    81,    -1,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    -1,
      95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
      -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,
      -1,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
      -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,    -1,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,   267,    -1,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,    -1,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,    -1,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,    -1,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,    -1,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,    -1,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,    -1,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    -1,    42,    43,    44,    -1,    46,
      47,    48,    49,    50,    -1,    52,    53,    -1,    55,    56,
      57,    58,    59,    60,    -1,    -1,    63,    64,    65,    66,
      67,    -1,    69,    70,    71,    72,    73,    -1,    -1,    -1,
      77,    78,    79,    80,    81,    -1,    83,    84,    85,    -1,
      87,    88,    89,    90,    91,    92,    -1,    -1,    95,    96,
      97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,    -1,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,    -1,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,   140,   141,   142,    -1,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,    -1,    -1,
      -1,   168,   169,   170,   171,    -1,   173,   174,    -1,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,    -1,   209,    -1,   211,    -1,    -1,   214,    -1,   216,
     217,   218,   219,   220,    -1,    -1,   223,   224,    -1,   226,
      -1,    -1,   229,   230,   231,    -1,    -1,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
     267,    -1,   269,   270,   271,   272,   273,   274,    -1,   276,
     277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,
     287,    -1,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,    -1,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
      -1,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
      -1,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,   420,   421,   422,    -1,    -1,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
     437,   438,    -1,   440,    -1,   442,   443,   444,   445,    -1,
      -1,   448,    -1,    -1,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    -1,    42,    43,    44,    45,    46,    47,    48,
      -1,    50,    51,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    -1,    -1,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    -1,    -1,    75,    -1,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    -1,    94,    95,    96,    97,    -1,
      -1,    -1,   101,    -1,    -1,    -1,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,    -1,
     149,   150,   151,   152,    -1,    -1,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,    -1,    -1,    -1,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,    -1,    -1,   223,    -1,   225,   226,   227,    -1,
     229,   230,   231,    -1,    -1,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,    -1,    -1,   262,    -1,   264,   265,   266,   267,    -1,
      -1,   270,   271,   272,   273,   274,    -1,   276,   277,    -1,
      -1,   280,   281,   282,    -1,    -1,   285,   286,   287,   288,
     289,   290,    -1,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,    -1,   306,    -1,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,    -1,   391,    -1,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,    -1,   412,    -1,    -1,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,    -1,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,    -1,   438,
     439,   440,   441,   442,   443,   444,   445,    -1,    -1,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   468,
     469,   470,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      -1,    46,    47,    48,    49,    50,    -1,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    -1,    -1,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    73,    -1,
      -1,    -1,    77,    78,    79,    80,    81,    -1,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    -1,
      95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
      -1,    -1,    -1,   168,   169,   170,   171,    -1,   173,   174,
      -1,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,    -1,    -1,   214,
      -1,   216,   217,   218,   219,   220,    -1,    -1,   223,   224,
      -1,   226,    -1,    -1,   229,   230,   231,    -1,    -1,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,    -1,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,   267,    -1,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,   287,    -1,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,    -1,   299,   300,    -1,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,    -1,   344,
     345,   346,   347,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,    -1,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,    -1,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,    -1,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,   437,   438,    -1,   440,    -1,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    -1,    42,    43,    44,    45,    46,
      47,    48,    -1,    50,    51,    52,    53,    -1,    55,    56,
      57,    58,    59,    60,    -1,    -1,    63,    64,    65,    66,
      67,    -1,    69,    70,    71,    72,    -1,    -1,    75,    -1,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    -1,
      87,    88,    89,    90,    91,    92,    -1,    94,    95,    96,
      97,    -1,    -1,    -1,   101,    -1,    -1,    -1,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,    -1,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,    -1,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,   140,   141,   142,    -1,   144,   145,   146,
     147,    -1,   149,   150,   151,   152,    -1,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,   165,    -1,
     167,   168,   169,   170,   171,    -1,   173,    -1,    -1,    -1,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,    -1,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,    -1,    -1,   223,    -1,   225,   226,
     227,    -1,   229,   230,   231,    -1,    -1,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,    -1,    -1,   262,    -1,   264,   265,   266,
     267,   268,    -1,   270,   271,   272,   273,   274,    -1,   276,
     277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,
      -1,   288,   289,   290,    -1,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,    -1,   303,   304,    -1,   306,
      -1,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,    -1,   391,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
      -1,    -1,   409,   410,    -1,   412,    -1,    -1,   415,   416,
     417,   418,   419,   420,   421,   422,    -1,    -1,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
      -1,   438,    -1,   440,   441,   442,   443,   444,   445,    -1,
      -1,   448,    -1,    -1,   451,   452,   453,   454,   455,   456,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   468,   469,   470,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,
      43,    44,    45,    46,    47,    48,    -1,    50,    51,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    -1,    -1,
      63,    64,    65,    66,    67,    -1,    69,    70,    71,    72,
      -1,    -1,    75,    -1,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    -1,    87,    88,    89,    90,    91,    92,
      -1,    94,    95,    96,    97,    -1,    -1,    -1,   101,    -1,
      -1,    -1,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,    -1,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
      -1,   144,   145,   146,   147,    -1,   149,   150,   151,   152,
      -1,    -1,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,   165,    -1,   167,   168,   169,   170,   171,    -1,
     173,    -1,    -1,    -1,   177,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,    -1,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,    -1,    -1,
     223,    -1,   225,   226,   227,    -1,   229,   230,   231,    -1,
      -1,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,    -1,   262,
      -1,   264,   265,   266,   267,    -1,    -1,   270,   271,   272,
     273,   274,    -1,   276,   277,    -1,    -1,   280,   281,   282,
      -1,    -1,   285,   286,    -1,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,    -1,
     303,   304,    -1,   306,    -1,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,    -1,   391,    -1,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,    -1,    -1,   409,   410,    -1,   412,
      -1,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,    -1,   438,    -1,   440,   441,   442,
     443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,
     453,   454,   455,   456,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   468,   469,   470,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    -1,    42,    43,    44,    45,    46,    47,    48,
      -1,    50,    51,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    -1,    -1,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    -1,    -1,    75,    -1,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    -1,    94,    95,    96,    97,    -1,
      -1,    -1,   101,    -1,    -1,    -1,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,    -1,
     149,   150,   151,   152,    -1,    -1,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,    -1,    -1,    -1,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,    -1,    -1,   223,    -1,   225,   226,   227,    -1,
     229,   230,   231,    -1,    -1,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,    -1,   262,    -1,   264,   265,   266,   267,    -1,
      -1,   270,   271,   272,   273,   274,    -1,   276,   277,    -1,
      -1,   280,   281,   282,    -1,    -1,   285,   286,    -1,   288,
     289,   290,    -1,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,    -1,   306,    -1,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,    -1,   391,    -1,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,    -1,   412,    -1,    -1,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,    -1,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,    -1,   438,
      -1,   440,   441,   442,   443,   444,   445,    -1,    -1,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   468,
     469,   470,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      45,    46,    47,    48,    -1,    50,    51,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    -1,    -1,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    -1,    -1,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    94,
      95,    96,    97,    -1,    -1,    -1,   101,    -1,    -1,    -1,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,    -1,   149,   150,   151,   152,    -1,    -1,
     155,    -1,   157,   158,   159,   160,   161,   162,    -1,   164,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,    -1,
      -1,    -1,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,    -1,   223,    -1,
     225,   226,   227,    -1,   229,   230,   231,    -1,    -1,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,    -1,    -1,   262,    -1,   264,
     265,   266,   267,    -1,    -1,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,    -1,   288,   289,   290,    -1,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
      -1,   306,    -1,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,    -1,   412,    -1,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,    -1,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,   438,    -1,   440,   441,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   468,   469,   470,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    45,    46,    47,    48,    -1,    50,
      51,    52,    53,    -1,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    -1,    -1,    75,    -1,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    94,    95,    96,    97,    -1,    -1,    -1,
     101,    -1,    -1,    -1,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,    -1,   149,   150,
     151,   152,    -1,    -1,   155,    -1,   157,   158,   159,   160,
      -1,   162,    -1,   164,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,    -1,    -1,    -1,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,    -1,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
      -1,    -1,   223,    -1,   225,   226,   227,    -1,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,    -1,
      -1,   262,    -1,   264,   265,   266,   267,    -1,    -1,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,    -1,   285,   286,    -1,   288,   289,   290,
      -1,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,    -1,   306,    -1,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,    -1,
     391,    -1,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,    -1,    -1,   409,   410,
      -1,   412,    -1,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,    -1,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,   438,    -1,   440,
     441,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   468,   469,   470,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    -1,    42,    43,    44,    45,    46,
      47,    48,    -1,    50,    51,    52,    53,    -1,    55,    56,
      57,    58,    59,    60,    -1,    -1,    63,    64,    65,    66,
      67,    -1,    69,    70,    71,    72,    -1,    -1,    75,    -1,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    -1,
      87,    88,    89,    90,    91,    92,    -1,    94,    95,    96,
      97,    -1,    -1,    -1,   101,    -1,    -1,    -1,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,    -1,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,    -1,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,   140,   141,   142,    -1,   144,   145,   146,
     147,    -1,   149,   150,   151,   152,    -1,    -1,   155,    -1,
     157,   158,   159,   160,    -1,   162,    -1,   164,   165,    -1,
     167,   168,   169,   170,   171,    -1,   173,    -1,    -1,    -1,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,    -1,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,    -1,    -1,   223,    -1,   225,   226,
     227,    -1,   229,   230,   231,    -1,    -1,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,    -1,    -1,   262,    -1,   264,   265,   266,
     267,    -1,    -1,   270,   271,   272,   273,   274,    -1,   276,
     277,    -1,    -1,   280,   281,   282,    -1,    -1,   285,   286,
      -1,   288,   289,   290,    -1,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,    -1,   303,   304,    -1,   306,
      -1,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,    -1,   391,    -1,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
      -1,    -1,   409,   410,    -1,   412,    -1,    -1,   415,   416,
     417,   418,   419,   420,   421,   422,    -1,    -1,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
      -1,   438,    -1,   440,   441,   442,   443,   444,   445,    -1,
      -1,   448,    -1,    -1,   451,   452,   453,   454,   455,   456,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   468,   469,   470,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,
      43,    44,    45,    46,    47,    48,    -1,    50,    51,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    -1,    -1,
      63,    64,    65,    66,    67,    -1,    69,    70,    71,    72,
      -1,    -1,    75,    -1,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    -1,    87,    88,    89,    90,    91,    92,
      -1,    94,    95,    96,    97,    -1,    -1,    -1,   101,    -1,
      -1,    -1,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,    -1,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
      -1,   144,   145,   146,   147,    -1,   149,   150,   151,   152,
      -1,    -1,   155,    -1,   157,   158,   159,   160,    -1,   162,
      -1,   164,   165,    -1,   167,   168,   169,   170,   171,    -1,
     173,    -1,    -1,    -1,   177,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,    -1,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,    -1,    -1,
     223,    -1,   225,   226,   227,    -1,   229,   230,   231,    -1,
      -1,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,    -1,    -1,   262,
      -1,   264,   265,   266,   267,    -1,    -1,   270,   271,   272,
     273,   274,    -1,   276,   277,    -1,    -1,   280,   281,   282,
      -1,    -1,   285,   286,    -1,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,    -1,
     303,   304,    -1,   306,    -1,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,    -1,   391,    -1,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,    -1,    -1,   409,   410,    -1,   412,
      -1,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,    -1,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,    -1,   438,    -1,   440,   441,   442,
     443,   444,   445,    -1,    -1,   448,    -1,    -1,   451,   452,
     453,   454,   455,   456,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   468,   469,   470,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    -1,    42,    43,    44,    45,    46,    47,    48,
      -1,    50,    51,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    -1,    -1,    63,    64,    65,    66,    67,    -1,
      69,    70,    71,    72,    -1,    -1,    75,    -1,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    -1,    87,    88,
      89,    90,    91,    92,    -1,    94,    95,    96,    97,    -1,
      -1,    -1,   101,    -1,    -1,    -1,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,    -1,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,   140,   141,   142,    -1,   144,   145,   146,   147,    -1,
     149,   150,   151,   152,    -1,    -1,   155,    -1,   157,   158,
     159,   160,    -1,   162,    -1,   164,   165,    -1,   167,   168,
     169,   170,   171,    -1,   173,    -1,    -1,    -1,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,    -1,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,    -1,    -1,   223,    -1,   225,   226,   227,    -1,
     229,   230,   231,    -1,    -1,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,    -1,    -1,   262,    -1,   264,   265,   266,   267,    -1,
      -1,   270,   271,   272,   273,   274,    -1,   276,   277,    -1,
      -1,   280,   281,   282,    -1,    -1,   285,   286,    -1,   288,
     289,   290,    -1,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,    -1,   303,   304,    -1,   306,    -1,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,    -1,   391,    -1,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,    -1,    -1,
     409,   410,    -1,   412,    -1,    -1,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,    -1,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,    -1,   438,
      -1,   440,   441,   442,   443,   444,   445,    -1,    -1,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   468,
     469,   470,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    -1,    42,    43,    44,
      45,    46,    47,    48,    -1,    50,    51,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    -1,    -1,    63,    64,
      65,    66,    67,    -1,    69,    70,    71,    72,    -1,    -1,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    -1,    94,
      95,    96,    97,    -1,    -1,    -1,   101,    -1,    -1,    -1,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,    -1,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,    -1,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,   140,   141,   142,    -1,   144,
     145,   146,   147,    -1,   149,   150,   151,   152,    -1,    -1,
     155,    -1,   157,   158,   159,   160,    -1,   162,    -1,   164,
     165,    -1,   167,   168,   169,   170,   171,    -1,   173,    -1,
      -1,    -1,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,    -1,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,    -1,    -1,   223,    -1,
     225,   226,   227,    -1,   229,   230,   231,    -1,    -1,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,    -1,    -1,   262,    -1,   264,
     265,   266,   267,    -1,    -1,   270,   271,   272,   273,   274,
      -1,   276,   277,    -1,    -1,   280,   281,   282,    -1,    -1,
     285,   286,    -1,   288,   289,   290,    -1,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,    -1,   303,   304,
      -1,   306,    -1,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
      -1,   366,   367,    -1,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,    -1,    -1,   409,   410,    -1,   412,    -1,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,    -1,    -1,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,   438,    -1,   440,   441,   442,   443,   444,
     445,    -1,    -1,   448,    -1,    -1,   451,   452,   453,   454,
     455,   456,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   468,   469,   470,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    43,    44,    45,    46,    47,    48,    -1,    -1,
      51,    -1,    -1,    -1,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    64,    -1,    -1,    67,    -1,    69,    70,
      71,    72,    -1,    -1,    75,    -1,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    -1,    94,    95,    96,    97,    -1,    -1,    -1,
     101,    -1,    -1,    -1,   105,   106,   107,   108,   109,   110,
      -1,    -1,   113,    -1,   115,    -1,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,    -1,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,   140,
     141,   142,    -1,   144,   145,   146,   147,    -1,   149,   150,
     151,   152,    -1,    -1,   155,    -1,   157,   158,    -1,   160,
      -1,   162,    -1,   164,   165,    -1,   167,   168,   169,   170,
     171,    -1,   173,    -1,    -1,    -1,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
      -1,   202,   203,   204,   205,    -1,    -1,    -1,    -1,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
      -1,    -1,   223,    -1,   225,   226,   227,    -1,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,    -1,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,    -1,
      -1,   262,    -1,   264,   265,   266,   267,    -1,    -1,   270,
      -1,   272,   273,   274,    -1,   276,   277,    -1,    -1,   280,
     281,   282,    -1,    -1,   285,   286,    -1,   288,   289,   290,
      -1,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,    -1,   303,   304,    -1,   306,    -1,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,    -1,   366,   367,    -1,   369,   370,
     371,   372,   373,    -1,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,    -1,
     391,    -1,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,    -1,    -1,    -1,    -1,   409,   410,
      -1,   412,    -1,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,    -1,    -1,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,    -1,   440,
     441,   442,   443,   444,   445,    -1,    -1,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   468,   469,   470
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    20,    30,    32,    33,    48,    57,    69,    71,    72,
      78,    80,    91,    93,   110,   113,   127,   129,   133,   139,
     147,   149,   156,   172,   189,   229,   230,   235,   247,   265,
     301,   309,   323,   329,   330,   332,   337,   342,   345,   352,
     358,   359,   366,   370,   380,   395,   415,   426,   432,   437,
     450,   473,   487,   494,   495,   496,   497,   498,   504,   505,
     507,   508,   509,   510,   512,   516,   528,   533,   534,   537,
     538,   539,   558,   561,   562,   577,   621,   622,   623,   626,
     629,   630,   631,   639,   645,   647,   649,   650,   653,   656,
     657,   661,   670,   674,   675,   676,   677,   680,   682,   683,
     684,   685,   693,   695,   715,   719,   721,   722,   732,   734,
     741,   742,   745,   746,   747,   748,   749,   757,   759,   763,
     768,   772,   773,   781,   782,   785,   790,   804,   831,   834,
     835,   836,   841,   844,   846,   848,   850,   851,   856,   857,
     860,   862,   863,   867,   868,   869,   872,   873,   876,   877,
     878,   885,   887,   888,   889,   895,   897,   898,   904,   905,
     906,   909,   910,   911,   912,   914,   915,   917,   918,   920,
     921,   923,   935,   941,   944,   946,   948,   957,   959,   965,
     970,   974,   975,   976,   977,   978,   979,   983,  1018,   409,
     453,   890,    27,    75,    90,   108,   114,   131,   142,   151,
     163,   168,   175,   194,   219,   240,   280,   304,   314,   315,
     318,   344,   347,   351,   353,   360,   363,   382,   389,   394,
     395,   398,   402,   412,   417,   430,   443,   646,   890,     3,
      20,    21,    22,    23,    24,    25,    26,    27,    29,    30,
      31,    39,    40,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    55,    56,    57,    58,    59,
      60,    63,    64,    65,    66,    67,    69,    70,    71,    72,
      73,    75,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    87,    88,    89,    90,    91,    92,    94,    95,    96,
      97,   101,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   115,   117,   118,   119,   120,   121,   122,   124,   125,
     126,   127,   130,   131,   132,   133,   134,   136,   137,   138,
     140,   141,   142,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   155,   157,   158,   159,   160,   162,   164,
     165,   167,   168,   169,   170,   171,   173,   174,   176,   177,
     178,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   191,   192,   193,   194,   195,   196,   197,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   209,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   223,   224,
     225,   226,   227,   229,   230,   231,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   264,   265,   266,   267,   269,
     270,   271,   272,   273,   274,   276,   277,   280,   281,   282,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   303,   304,   305,   306,
     307,   308,   309,   310,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   360,
     361,   362,   363,   364,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   393,
     394,   396,   397,   398,   399,   400,   401,   402,   404,   405,
     406,   409,   410,   411,   412,   413,   415,   416,   417,   418,
     419,   420,   421,   422,   425,   426,   427,   428,   429,   432,
     433,   434,   435,   436,   437,   438,   440,   441,   442,   443,
     444,   445,   448,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,  1077,  1152,  1160,  1161,  1164,  1165,  1166,
       3,    28,   971,  1146,  1160,  1164,   441,   928,   278,   310,
     890,    51,   487,   569,    22,    39,    62,    75,    86,   108,
     114,   131,   142,   151,   163,   171,   175,   231,   280,   283,
     304,   318,   344,   353,   363,   382,   389,   398,   399,   401,
     402,   412,   417,   424,   427,   430,   578,   628,   737,   791,
     805,    28,   309,  1146,   971,    28,   303,   361,   399,   401,
       6,   218,   842,   843,  1155,    22,    27,    62,    75,    90,
     108,   131,   142,   151,   163,   168,   175,   194,   240,   280,
     293,   304,   315,   318,   344,   347,   351,   353,   360,   363,
     382,   389,   395,   398,   402,   410,   412,   417,   430,   443,
     646,   750,   751,   752,   890,  1146,    93,   441,   487,   623,
     626,   629,   923,   936,   944,   947,   957,   964,   970,   974,
     983,    11,    21,    28,    46,   158,   164,   166,   190,   220,
     254,   312,   331,   478,   479,   769,   770,   971,  1154,  1156,
      28,    93,   327,   359,   774,   775,   776,  1160,   163,  1160,
    1151,  1155,   395,   986,   769,  1160,   337,   366,   370,   409,
    1146,   293,   240,   108,   194,   353,   394,   395,   487,   852,
     853,   352,  1160,    28,   364,   405,   409,   520,   529,   530,
    1160,    25,   172,   774,   775,   310,   890,  1160,   217,    28,
     128,   988,   989,    63,    87,   231,   249,   344,   353,   364,
     405,   409,   456,   517,   518,   519,   520,    28,   364,   405,
     409,   520,   409,   279,  1029,  1144,  1160,   986,   480,  1160,
     167,   487,   929,   487,   325,   980,   981,  1146,   980,   975,
     976,   979,     0,   490,   487,   928,   143,   208,   284,   423,
     990,   991,   975,   977,   978,   119,   204,   429,   491,    34,
     894,   821,  1152,   754,  1160,   754,  1147,  1160,   313,   754,
     412,  1146,   107,   395,   809,  1152,  1160,  1166,     3,   104,
     365,  1157,  1158,  1162,  1164,  1165,  1166,    28,   184,  1144,
     272,   443,    10,    17,    18,    19,    70,   155,   474,   475,
     476,   478,   479,   480,   481,   482,   483,   838,   840,  1107,
    1108,  1160,   184,  1146,   809,  1146,    28,  1157,  1158,   809,
    1146,  1146,   184,  1144,  1146,   184,   754,  1146,   337,   366,
      28,   184,  1029,  1146,   356,  1146,   754,    28,   238,  1157,
    1158,   184,  1144,   218,   116,   214,   263,   321,   891,   892,
     893,   487,   485,   489,  1135,  1137,  1144,  1150,  1160,    22,
      27,    62,    75,    76,    86,    90,   108,   131,   142,   151,
     163,   168,   194,   219,   240,   280,   304,   315,   318,   344,
     347,   351,   353,   360,   363,   382,   389,   395,   398,   402,
     410,   412,   417,   443,   646,   760,   761,  1155,   894,   943,
     947,   957,   964,   974,  1144,   242,   754,   487,   184,   754,
     412,  1147,   754,   412,   184,  1146,   107,   395,   399,   401,
    1157,  1158,   399,   401,    70,   155,   838,   335,  1146,  1146,
    1157,   184,   513,  1160,   184,  1146,   184,   754,  1146,  1146,
     356,  1146,   754,   238,  1157,   325,   360,   395,   443,   240,
      90,   194,    27,   168,   315,   351,   410,   416,   640,    28,
    1146,   972,   527,  1155,  1162,   843,   242,   184,   821,   822,
     184,   847,   184,  1147,     3,    50,    52,    53,    65,    66,
     111,   112,   132,   159,   184,   206,   207,   209,   250,   252,
     271,   322,   368,   374,   405,   406,   438,   756,  1051,  1053,
    1055,  1057,  1059,  1061,  1062,  1063,  1065,  1066,  1067,  1069,
    1070,  1161,  1164,   412,   107,   395,   184,   808,   809,   184,
    1158,  1159,    82,   443,    70,   155,   184,   839,   840,    55,
     184,   808,   184,  1159,   184,   808,   184,  1146,   184,  1146,
     356,   847,   184,   756,   184,   238,  1159,   218,   184,   753,
     754,   184,  1145,  1146,   184,  1146,   894,   487,   945,   578,
     936,   437,   923,   937,   938,   939,  1162,   928,   204,   429,
    1156,   770,   771,    28,   771,  1156,   771,    28,   771,  1156,
     771,   771,   771,  1156,  1154,  1154,   971,   771,   313,   487,
     487,   598,   598,   598,   278,   407,   491,   598,   353,  1029,
    1030,   491,   886,   530,   518,   520,    28,   520,  1155,   487,
     942,    55,   443,   441,   854,   855,    82,   792,   792,  1160,
      45,   470,   214,   489,   281,   281,   278,   166,  1155,   407,
     894,   161,   764,   278,     5,     8,     9,    10,    12,    36,
      50,    52,    53,    61,    62,    65,    66,    73,    75,    98,
      99,   100,   101,   102,   103,   104,   111,   112,   114,   148,
     153,   154,   159,   174,   176,   206,   207,   209,   224,   232,
     233,   250,   252,   261,   263,   268,   269,   271,   280,   291,
     305,   322,   349,   365,   374,   390,   405,   406,   411,   413,
     414,   424,   430,   438,   458,   459,   460,   461,   463,   464,
     465,   466,   471,   478,   479,   480,   487,   975,  1054,  1057,
    1060,  1061,  1062,  1064,  1065,  1066,  1069,  1070,  1074,  1076,
    1077,  1078,  1080,  1103,  1104,  1105,  1109,  1129,  1134,  1141,
    1142,  1152,  1153,  1154,  1155,  1160,  1140,  1141,  1155,    28,
     535,  1143,  1144,   364,   517,   114,   526,  1155,   527,  1155,
      45,    67,   517,   470,   375,   892,   281,   166,   407,   476,
      45,   470,   214,   893,   487,  1144,   480,  1137,  1030,   922,
     923,   924,   925,  1162,   165,   930,  1074,  1112,   980,   491,
     487,   931,   488,   488,   496,   922,   932,   933,   934,  1144,
      28,   128,   987,   987,    55,   987,   156,   161,   228,   275,
     994,   996,   997,  1012,  1014,  1015,  1016,   990,   991,   166,
     210,  1029,  1031,   487,    64,   259,   294,   333,   366,   487,
     819,   294,   329,   333,   366,   489,   755,   294,   333,   366,
       3,    85,   137,   234,   294,   301,   333,   366,   398,   400,
     450,   528,   531,   899,   900,   901,   902,   786,    24,   133,
     294,   333,   366,   434,   544,  1146,    24,   133,   366,   429,
     511,   454,   184,  1029,    58,    92,   152,   187,   223,   259,
     263,   294,   295,   333,   341,   350,   358,   366,   378,   387,
     391,   445,   528,   532,   824,   832,   861,   487,   806,  1137,
     333,   511,   190,   148,    24,    30,    43,    72,   126,   133,
     136,   162,   196,   259,   263,   273,   282,   294,   333,   336,
     337,   366,   434,   540,   542,   543,   664,   861,     5,   478,
     479,   637,  1156,    28,   184,  1144,   754,   754,   487,   837,
     294,   366,   489,   148,   278,   294,   333,   366,   832,   861,
      24,   133,   294,   333,   366,   190,   506,   333,   450,   473,
     499,   506,   294,   333,   366,   832,   861,   278,   294,   333,
     148,    37,    56,   106,   193,   241,   244,   259,   293,   333,
     338,   360,   366,   380,   540,   634,   635,   294,   333,   442,
     664,   672,   148,   294,   333,   366,    85,   126,   136,   294,
     329,   333,   366,   530,   518,   190,   148,    43,   124,   259,
     333,   366,   540,   541,   294,   333,   337,   366,    83,   125,
     296,   400,   278,    24,    30,   133,   294,   333,   366,   559,
     560,   506,   161,   333,   499,   506,   148,   333,   366,   540,
    1146,   226,   116,   279,   455,   491,   891,    28,   128,   439,
     480,   488,   814,  1074,  1113,  1114,  1161,  1074,  1136,     3,
      28,    32,    33,    34,    35,    36,    37,    38,    41,    54,
      61,    62,    68,    74,    76,    86,    93,    98,    99,   100,
     102,   103,   104,   114,   116,   123,   128,   129,   135,   139,
     143,   154,   156,   161,   163,   166,   172,   175,   179,   190,
     198,   208,   210,   221,   222,   228,   232,   233,   263,   268,
     275,   278,   279,   283,   284,   302,   311,   327,   340,   359,
     365,   376,   392,   395,   403,   407,   408,   414,   423,   424,
     430,   431,   439,   446,   447,   449,   450,   480,  1149,  1163,
    1164,  1165,  1166,  1167,  1135,   431,   919,   278,   242,   821,
     487,  1146,  1051,   412,   107,   395,   809,   272,   443,    70,
     155,   840,  1146,   809,   809,  1146,   356,   161,  1146,  1051,
     218,   754,  1146,   488,   598,  1146,    68,  1051,   263,   166,
     487,   723,  1146,   499,    37,   913,  1146,   263,   499,   454,
     184,  1144,   499,   754,   754,   723,   427,   578,   278,   161,
     870,   871,   499,   263,    45,   514,   263,   417,   671,   263,
     931,    85,   294,   648,    83,   125,   296,   400,    26,    47,
     205,   696,    37,   723,   161,   184,   499,   443,   184,  1144,
     184,   624,  1144,  1144,   443,   754,   792,  1152,  1152,  1152,
    1146,   161,   646,    51,   105,   203,   259,   355,   148,    59,
     339,   491,   545,   148,   487,   148,   499,   440,  1068,  1068,
    1068,   487,  1056,  1056,   307,   487,  1058,   148,    65,    66,
    1068,  1056,  1053,   452,   473,   487,  1071,   487,  1071,   491,
     545,    36,  1052,   487,   109,   182,   243,   246,   357,   468,
     487,  1072,  1073,   755,  1056,   454,   148,   491,   545,   148,
     491,   184,   753,   184,   754,   184,   754,   148,   491,   545,
    1159,   148,   545,   148,   148,   545,   148,   545,   148,    83,
     125,   296,   400,   161,   148,   545,   148,   161,   184,   184,
     527,   148,   491,   545,   148,   491,   545,   148,   278,  1112,
     395,   488,   491,   154,   278,   414,   524,   527,   637,   940,
     936,   210,  1031,   771,   971,   771,   971,   771,   971,   771,
     971,   771,   971,   971,   971,   771,   971,   487,   599,   600,
    1160,   599,    28,   108,   131,   163,   168,   218,   219,   315,
     347,   353,   360,   395,   398,   417,   777,  1143,  1159,   776,
    1146,   190,   491,   960,  1155,  1051,  1115,    37,  1159,   792,
     488,   491,  1144,  1146,   226,  1160,   161,   161,   777,  1159,
     352,  1160,   527,   278,   487,  1138,   485,   975,  1116,  1074,
    1133,   487,   487,   161,   487,   487,   975,   487,   487,   487,
     487,   487,   487,   487,  1074,   487,   487,   487,   487,   487,
     487,   487,   487,   975,   487,   487,   487,   487,   487,   487,
     487,   487,  1074,  1074,  1074,   975,  1074,  1112,  1137,  1155,
     487,  1155,     3,    10,    13,    17,    18,    19,    34,    37,
      42,    49,    74,   185,   190,   212,   213,   227,   266,   280,
     283,   371,   471,   474,   475,   476,   478,   479,   480,   481,
     482,   483,  1107,  1109,  1111,   451,  1090,   290,  1074,   210,
     491,   984,   487,  1155,  1137,   984,   117,   186,   536,   491,
      67,   114,   527,    37,     3,   114,   231,   525,   637,  1070,
    1155,  1155,    88,   130,  1086,    97,   114,   521,   522,   524,
     637,   114,   521,   226,  1144,    89,   338,   758,   488,   491,
     524,   637,   926,   928,   488,   491,   981,  1145,    37,   488,
     491,   931,   977,   977,   992,   993,  1074,   977,   158,   254,
    1003,   216,   259,   321,   369,   429,    28,   998,  1074,   478,
     479,   999,  1000,  1074,  1076,  1012,  1013,   997,   996,   994,
     995,   161,  1015,   273,  1017,   994,  1012,  1031,   949,  1144,
      37,  1160,  1112,    64,   407,   407,   353,   190,   201,   284,
     287,   368,   439,   480,   812,   813,   814,   816,   818,   820,
    1051,  1161,   407,   442,   407,   353,  1149,   489,   407,   407,
     353,   228,   407,   407,   398,   517,   294,   899,   901,   476,
     903,   161,   172,   190,   342,   787,   788,    68,    86,   144,
     163,   311,   424,   595,   596,    86,   114,   263,   407,    86,
     407,   114,   263,   353,    86,   126,   136,   294,   333,   720,
     353,   654,    22,    27,    62,    75,    90,   131,   142,   163,
     168,   240,   280,   315,   347,   353,   360,   363,   395,   402,
     410,   417,   443,   646,  1146,   148,   333,   366,   540,   278,
     637,   358,   223,   407,  1160,   407,   268,   637,   118,   211,
     353,   364,   409,   519,   754,   339,   366,   824,   833,   122,
     488,   807,   812,   407,   430,   398,  1144,    76,   144,   184,
     585,   595,  1160,    76,    86,   858,   298,   278,   349,   351,
     412,    86,   858,    31,   336,   349,   351,   412,   349,  1144,
     162,   196,   273,   754,   487,   407,   407,   183,   487,   549,
     237,   398,   427,   452,   549,    86,   491,   122,     5,     5,
     294,   190,   148,   333,   366,   540,   861,   431,   431,   260,
    1051,   407,   353,   487,   838,  1146,  1144,   407,   407,   353,
     833,   122,   395,   395,   407,   407,   395,   723,   108,   366,
     531,   407,   501,   531,   407,   407,   353,   833,   122,  1144,
     407,   407,  1144,  1053,   637,    55,   636,   637,   637,   106,
     241,   244,    55,   407,   499,   248,   353,   499,   259,   635,
     407,   407,   268,  1155,   664,   754,   407,   407,   353,   382,
    1155,   407,   318,   407,   318,   723,   398,  1029,   298,   298,
      86,   407,   858,   353,   407,   407,   549,   549,   754,   754,
     754,   754,  1144,    44,   436,    44,    44,   407,    44,   407,
     436,   353,   487,   491,   531,   430,   681,  1158,   407,   501,
     531,  1144,   407,   858,   353,   294,   333,   321,   334,   362,
     523,   891,  1113,  1113,  1114,   488,    15,    16,   491,   990,
     991,   486,   492,  1150,  1160,  1144,   212,  1051,   278,   212,
     454,   212,   637,   754,   754,   212,   278,   212,   212,   278,
      83,   125,   296,   400,  1051,   278,   212,   212,   212,   407,
     166,   407,   563,   417,   487,    37,   148,   754,   724,   725,
    1163,    26,   899,  1051,   278,   148,   651,  1146,   263,   298,
     487,   500,   737,   431,   325,   443,  1144,    28,   395,   450,
     828,   500,   148,  1158,    93,   172,   515,   577,   630,   695,
     772,   790,   895,   148,  1155,   672,   673,   148,   278,  1155,
    1158,   234,   754,   754,   754,   754,   273,   119,   204,   415,
     429,   697,   698,   140,   320,   487,   681,   263,   500,  1144,
     263,   632,   634,   263,    37,   273,   298,   487,   598,   598,
     184,   627,  1144,   161,   184,   793,  1150,   487,   727,   819,
     487,   810,   810,    37,  1051,   218,   450,   452,   973,   355,
     822,   821,  1051,  1147,   487,   487,  1112,  1154,   756,  1068,
    1068,    36,  1052,   405,   405,  1154,  1154,  1051,   485,   485,
    1154,   407,   407,   407,   487,   407,  1154,  1056,   808,   809,
    1159,  1158,   148,   545,   148,   431,   148,   431,   839,   840,
     545,   808,  1159,   808,  1146,  1146,  1051,   756,  1159,   681,
     148,   148,   545,   753,   754,  1145,  1146,  1146,   754,   488,
     184,  1144,   936,   938,   949,   366,   971,   971,   971,   971,
     971,   971,   599,   488,   491,   488,   169,   316,   348,   361,
     396,  1145,   753,   107,   363,   808,  1145,   272,   808,   808,
    1145,  1143,  1143,  1145,   753,   407,   450,   783,   143,   228,
     678,   679,    22,   146,   349,   369,   961,  1029,   267,   962,
     488,   491,   943,   407,  1144,   852,   853,   855,   775,   774,
     775,   166,   173,   784,  1160,    27,    76,   108,   131,   142,
     163,   168,   219,   240,   315,   318,   344,   347,   353,   360,
     389,   395,   398,   417,   443,   646,   765,   766,  1112,  1135,
     486,  1112,  1116,  1117,   446,  1130,  1131,  1074,  1112,   487,
    1154,  1154,     3,   109,   182,   243,   246,   357,   468,  1118,
    1119,  1155,  1112,  1112,  1112,  1154,  1154,  1074,  1074,   838,
    1074,  1121,   349,   478,   479,   487,  1075,  1076,  1109,  1123,
     488,  1112,  1074,  1112,  1124,  1074,    54,   166,   222,   408,
    1074,  1112,  1127,  1112,   248,  1076,  1074,  1084,  1085,  1086,
     248,  1074,  1086,   488,   491,  1154,  1072,  1051,  1074,  1074,
    1074,  1074,  1163,   405,    41,   392,  1139,   754,  1074,   487,
     975,  1128,   128,   130,   154,   255,   256,   257,   258,   262,
     263,   268,   273,   414,   425,  1120,  1074,   487,  1074,   407,
      49,   185,   190,   227,   371,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,    28,    35,   376,  1106,   175,
     157,  1091,   349,   487,  1103,   171,   231,   395,   399,   401,
     427,   985,  1144,  1142,   166,  1019,  1113,  1019,  1144,   409,
     487,  1155,   491,   488,   183,   183,   545,   934,   924,   923,
     927,  1074,   488,   240,   263,   982,   934,   932,   491,    38,
     123,   431,   802,   349,   350,   478,   479,  1000,  1002,  1076,
     369,   216,   279,   491,     5,  1001,  1154,  1001,   349,   350,
    1002,  1143,   267,   373,   963,  1013,   995,   431,   958,    37,
    1160,   488,  1158,  1146,  1146,   287,    55,  1161,   488,   814,
     816,   813,   816,  1161,   284,   488,   491,   755,  1158,  1146,
    1146,  1149,  1158,  1146,  1146,  1158,  1147,  1146,   114,   524,
    1156,   344,   430,   774,   353,   172,   774,   487,  1146,   431,
     794,   216,   216,   431,   487,   620,   184,  1146,   268,  1158,
    1146,  1146,  1074,   268,  1146,  1146,    31,   336,   407,   407,
    1146,   407,   655,   242,   821,   487,   754,   754,  1051,   412,
     107,   395,   809,   443,    70,   155,   840,   809,   809,  1146,
     754,  1146,   754,   356,   161,  1051,   754,   218,   178,   259,
     294,   333,   435,   658,   659,   660,  1029,   407,   858,   353,
     268,   118,   211,  1158,  1146,   278,  1146,   278,   488,   491,
    1157,  1159,  1146,   333,   540,   184,   585,   263,  1051,  1146,
    1154,  1160,  1144,  1146,   226,  1146,    28,   430,  1146,   184,
    1146,   184,  1160,   351,   412,   351,   412,   226,  1146,    28,
     430,  1146,   226,   349,  1144,    24,   133,   366,   665,   666,
     667,   668,  1163,  1158,  1146,   114,   167,   264,   431,   548,
     551,   552,  1163,  1146,    72,   276,  1146,   543,   278,   407,
     398,  1144,   407,   858,   353,   122,  1148,  1160,  1148,   491,
     488,   491,  1158,  1146,   864,   865,  1163,   278,   333,   407,
     689,  1158,  1146,  1146,   278,  1030,  1030,  1158,  1146,  1030,
    1147,  1157,     3,    85,   138,   196,   300,   422,   430,   433,
     502,  1158,  1146,  1146,   278,   333,  1158,  1146,   333,   366,
     540,   634,   637,   754,  1146,   637,   754,  1146,   637,  1158,
    1146,   366,  1158,  1146,  1146,  1156,  1158,   828,  1146,   874,
     875,  1163,  1146,   333,   366,   540,   541,  1144,  1144,  1146,
    1146,  1146,  1146,  1158,  1146,    24,    30,   133,   294,   333,
     366,   294,   333,   366,   723,   333,   366,   333,   366,   333,
     861,  1043,  1160,   184,   733,  1160,   184,  1160,  1158,  1146,
    1146,  1155,  1146,   864,    24,   560,   363,  1157,   333,   366,
     540,  1146,  1146,  1146,   407,   407,    81,   421,   321,   491,
     990,   990,   990,  1074,  1074,   439,  1114,   488,  1074,  1136,
     268,   762,  1155,    37,   131,   754,   762,   762,   212,   431,
     431,   762,   754,   762,   762,   754,   218,   754,   762,   762,
     762,   317,   564,   564,   194,   395,   694,  1074,  1051,   754,
     488,   491,   476,   697,   587,  1163,  1146,    59,   166,   353,
     442,   652,   659,   660,   148,   273,   227,   579,   581,   583,
     585,   592,   595,    25,   190,   344,   393,   502,   503,   161,
    1148,   443,  1144,    37,   690,   396,  1030,   723,   513,  1160,
     514,   283,   578,  1146,   163,   754,  1112,   318,  1155,   723,
     723,   723,   723,   273,   278,   283,   487,   723,  1041,  1042,
    1043,   363,   148,   487,   148,   148,   147,   974,   754,   273,
     579,  1160,   431,   615,   450,   550,   263,    37,   598,  1155,
     263,   278,     3,   728,   729,   723,   488,   811,   812,   817,
      37,   218,   341,   410,   449,   823,   824,   825,   823,   278,
     218,   527,   181,   181,   161,   545,    37,   499,   162,   907,
     908,  1112,   488,   488,   545,   485,   470,   470,   488,   488,
    1154,   486,  1154,   488,   182,   243,  1073,   243,  1073,  1073,
    1154,   246,   488,   545,   753,   754,  1148,   754,  1148,   545,
     545,   545,   545,   218,   545,   363,   161,   527,   545,   545,
     278,   545,   263,   114,   292,   487,   950,   974,   487,   966,
     967,   968,  1160,   488,   600,   190,   190,   190,   190,   190,
     454,  1145,   637,   638,   175,   778,   779,  1158,    25,   784,
     407,   487,   166,   146,   369,   146,   369,   349,   429,   245,
    1051,  1158,   450,   625,   792,   792,   166,   278,   778,    55,
     545,   821,  1051,   412,   395,   809,   272,   443,   809,   809,
    1051,   218,   754,  1146,   488,   486,   486,   491,  1074,   135,
    1131,  1132,    37,   488,  1074,   488,   488,   488,   166,   488,
     488,   488,   488,   488,   488,   491,   491,   488,   302,  1122,
     488,   487,  1075,  1075,  1112,    13,    17,    18,    19,   190,
     212,   280,   474,   475,   476,   478,   479,   480,   481,   482,
     483,  1109,  1075,   488,   488,   161,   166,  1125,  1126,   488,
      37,  1127,  1112,  1127,  1127,   166,   488,   488,  1163,   299,
    1088,    37,   488,   491,  1074,  1163,   491,  1074,  1138,  1074,
     488,   470,  1075,  1075,   141,  1112,   166,   128,   130,   154,
     262,   268,   273,   414,   425,  1120,   487,   262,   141,   838,
    1074,   392,  1139,  1074,  1128,  1074,   407,   487,   975,   487,
     487,   289,  1095,   487,  1112,   399,   401,   399,   401,  1144,
     986,   986,   986,   221,   350,   467,   487,   975,  1020,  1021,
    1022,  1029,  1034,  1044,  1077,  1079,  1080,  1160,   447,  1039,
     990,  1039,   892,  1154,  1072,   522,   934,   240,   487,   993,
     280,  1107,  1110,   472,   803,     5,  1154,  1002,   279,   450,
     429,   999,   236,  1020,   447,  1040,  1160,   820,   755,   816,
     816,    55,   818,   482,  1159,  1159,   278,  1145,   281,   278,
    1074,   596,  1148,   487,   487,   487,   620,   194,   599,   713,
     148,   545,   407,  1158,  1146,   527,  1146,  1051,  1146,   454,
     754,   754,   754,   754,    83,   125,   296,   400,  1051,  1146,
     641,  1146,   178,   435,   407,   407,   641,   658,   664,   333,
     366,   540,  1146,  1146,  1146,   202,   268,   151,   812,   293,
     366,   407,   263,   148,   282,   662,   713,   366,    24,   133,
     337,   338,   366,   544,   553,   554,   664,   859,   358,   148,
     545,   148,   545,  1146,  1146,  1146,  1146,   358,   358,   226,
     667,   668,   667,   488,   491,   669,  1155,   194,   488,   491,
     476,   489,   151,  1158,  1146,   333,   366,   540,  1146,  1146,
    1146,   278,   294,   333,   366,    24,   133,   294,   333,   366,
    1051,   260,  1051,   488,   491,   476,  1144,   407,  1159,   431,
     686,   151,   228,   300,   268,  1155,   300,  1159,   428,   151,
     407,   407,   353,   382,   491,   828,   293,   366,    86,   407,
     858,   353,   114,   161,   555,   407,   407,   238,   238,   238,
     407,   407,   353,   407,   407,   353,   407,   353,   407,   353,
     407,   122,   545,  1051,   263,  1155,   366,   859,   148,   545,
     407,   407,   488,  1146,   407,   858,   353,   407,  1158,  1146,
     488,   488,   488,  1114,   486,  1051,   754,   212,   762,  1148,
    1148,   212,   212,  1146,   212,   383,   384,   565,  1155,   565,
     178,   488,   488,   166,   723,   725,   260,   280,   478,   479,
     637,   726,   816,  1110,  1155,  1167,   278,    68,    74,    86,
     114,   116,   170,   198,   263,   268,   311,   327,   424,   588,
     589,   591,   147,   446,   499,   527,  1146,   527,   662,  1144,
    1144,  1144,   488,   491,  1159,   175,   344,  1159,  1154,   417,
    1144,   598,     3,   161,   691,    45,   514,   335,   395,   671,
     107,   931,   166,   874,   550,   599,  1144,   698,   730,   731,
    1155,   488,   491,  1146,   161,   599,  1144,   624,  1144,  1146,
     625,   487,   580,  1144,   488,  1148,   450,   452,   616,   549,
      37,   148,   974,   615,   407,   148,  1029,   476,   488,   491,
     488,   491,   114,   476,   826,  1155,   527,   395,   815,   816,
     161,   827,   825,   119,   204,   359,   429,   883,  1146,   178,
     974,  1051,   487,   488,   491,   488,  1154,  1071,  1071,   486,
     486,   488,   545,   431,   545,   431,   545,  1146,  1146,   681,
     545,   754,   148,   437,   394,   430,   951,   952,   953,  1160,
     278,   954,   968,   969,   491,  1019,   476,  1138,   353,   353,
     353,   353,   353,  1145,   491,  1158,   450,   491,   780,   281,
    1030,   363,   146,   146,   107,   259,  1144,  1146,  1159,   777,
     545,  1158,   212,   212,   212,   637,   212,   212,   212,   212,
     212,  1116,   403,  1074,   139,  1051,   488,  1074,  1120,  1074,
    1074,  1125,   488,  1112,   491,  1051,  1075,  1075,  1075,  1075,
     128,   130,   263,   273,  1075,  1075,  1075,  1075,  1075,  1075,
    1075,  1075,  1075,  1075,  1074,  1074,  1126,  1125,  1051,   488,
     488,   488,  1112,   488,   491,    55,  1076,  1089,   488,  1163,
    1085,   308,   388,  1087,   488,   491,   442,  1081,    37,   488,
    1155,  1074,    34,    34,  1074,   488,  1074,   166,   487,   262,
    1115,  1074,   488,   141,  1075,  1075,   141,   141,  1074,  1074,
     991,   447,   487,  1096,  1160,   488,  1112,   491,   986,   986,
     986,   986,  1144,  1144,  1144,   975,  1034,  1044,   166,   487,
     975,  1021,  1022,    37,  1023,  1024,  1160,   491,    94,   167,
     200,   215,   225,   251,   343,  1026,  1024,    37,  1023,  1025,
    1160,  1024,   473,  1038,  1137,  1074,   175,  1004,   488,  1004,
     488,   943,   487,   803,   158,   220,   279,   450,   404,    97,
    1074,   340,   956,   488,   482,   820,   417,   169,   348,   354,
     361,   396,   418,   789,   161,   789,   488,   487,   603,   604,
     797,  1079,  1160,   599,   599,   713,  1150,   488,   116,   198,
     259,   263,   714,  1146,  1146,    37,  1146,   431,   431,   754,
     754,   754,   754,   218,   755,  1158,  1146,   407,   858,   353,
     407,   202,  1146,    55,   398,  1146,   148,   585,   487,   587,
     382,   170,   150,   183,   263,   549,   499,   107,   170,   263,
     382,   385,   549,   635,   366,   554,   417,  1146,  1160,   358,
     666,  1146,   552,   726,  1163,  1146,   293,   366,   407,   858,
     353,   407,   151,   407,   407,   353,   168,   280,   385,   735,
     736,   168,   280,   743,   744,   407,   407,   353,   488,   488,
     488,   865,   260,   637,   816,   866,  1110,  1155,  1167,   333,
    1146,   487,   450,   687,  1146,  1156,  1155,  1155,  1155,  1146,
    1146,  1146,  1146,  1156,   875,    55,   398,  1146,  1146,  1146,
    1146,   437,  1146,  1146,   161,   161,   335,   161,   184,  1158,
    1146,  1146,  1158,  1146,  1146,  1146,  1146,  1146,  1146,  1146,
     278,    74,   546,   148,    26,    47,   417,  1160,  1146,  1155,
     664,  1146,  1146,  1146,  1146,   990,   488,   212,   762,   212,
     212,   762,   762,   212,   762,   499,   431,   570,   571,   641,
     713,   450,   452,   754,  1144,   487,   754,  1146,  1075,    31,
      55,   590,   117,   186,   116,   268,   216,  1144,   828,   168,
     315,   709,   716,   717,  1160,   651,   298,   487,   580,   593,
     197,   610,   583,  1159,  1159,  1051,   487,   550,    28,   119,
     204,   359,   429,   692,   407,   688,  1158,   184,  1144,   673,
     454,   278,  1020,   828,   328,   699,   488,   491,  1043,   662,
     681,   488,   632,    37,   273,   298,   487,   945,   582,   584,
     586,   595,  1160,   298,   611,   612,   580,   610,   549,   276,
     278,   617,   974,   627,   625,   550,  1155,  1150,   794,   726,
       3,   729,   817,  1074,  1074,   491,   487,   823,   417,   491,
     407,   487,   641,   488,   907,   908,   486,  1148,  1148,   545,
     363,   545,   436,   488,   491,  1138,    84,   956,   488,   491,
     967,  1040,  1074,  1145,  1145,  1145,  1145,  1145,   637,   172,
     779,   488,  1146,   107,   784,   166,   268,   767,  1155,   767,
     767,   212,   767,   767,   767,   767,   767,  1074,   488,   488,
     488,  1126,   488,  1074,   166,   128,   130,   273,   487,   488,
     457,  1083,  1112,   326,   436,    55,  1089,  1076,   448,   448,
     488,  1074,   259,  1074,   491,  1082,  1053,  1074,  1074,  1074,
    1115,   488,  1074,    34,    34,  1074,  1074,   141,   488,   488,
    1074,  1097,  1160,   488,  1074,  1144,  1144,  1144,  1144,  1024,
    1025,  1024,   487,   462,  1076,   488,  1160,   487,  1021,   215,
     288,  1027,  1021,  1027,   215,  1026,  1027,   215,   397,  1032,
     487,  1160,   487,   285,    55,   179,  1011,  1155,  1011,  1155,
     488,   838,   404,   273,  1141,   417,   488,   407,   774,   166,
     713,  1074,   488,   491,   450,    74,   796,   800,   796,   488,
     488,   191,   601,   117,   186,   196,   116,   433,   545,  1051,
    1148,  1148,  1146,  1146,  1146,  1146,  1146,  1159,  1146,   585,
     663,   667,  1156,   590,   184,   184,   268,   637,   590,   268,
    1156,  1160,  1051,   545,   545,   476,    55,   398,  1146,  1146,
    1146,  1146,  1146,  1158,  1146,  1146,  1154,  1154,  1051,   491,
    1154,  1154,   491,  1158,  1146,  1146,   407,  1074,    68,  1159,
    1146,   407,   407,   166,   190,   450,  1145,  1145,   754,  1145,
     148,   151,   754,  1155,  1155,  1051,   545,   545,   407,   488,
     212,   762,   762,   762,   762,   487,   566,   567,   499,   121,
     168,   201,   168,   166,   712,  1074,   263,   589,   114,    37,
     828,   598,   431,   619,  1152,    34,   147,   190,   273,   579,
     555,   145,   192,   487,   363,   431,   599,    37,  1159,   686,
     514,   263,   487,   163,  1146,  1112,   253,   277,   700,   701,
     702,   161,   705,  1155,   363,   550,   147,   974,   754,   273,
     579,   625,   488,   491,   450,   587,    55,   615,   555,   611,
      80,   398,   618,   450,   896,    37,   618,   166,   278,   487,
    1155,   814,   829,   830,  1161,  1051,   161,  1144,   166,   407,
     849,   199,   642,   545,   488,   545,   545,  1146,   974,   292,
     974,   953,   278,   487,   955,   476,   968,   956,   281,   210,
     545,   778,   767,   488,  1075,   166,   487,  1115,   487,   488,
     491,   488,  1089,   488,   436,   379,   488,   488,   488,  1074,
    1074,  1074,   488,   298,  1098,   488,  1035,  1036,  1079,   487,
    1088,  1023,   487,  1145,  1021,   278,   431,  1028,  1021,   215,
    1021,  1152,  1042,   487,  1042,  1160,    96,   176,   346,   487,
    1005,  1006,  1007,  1008,  1009,  1010,  1074,  1074,   449,  1092,
    1092,   488,   971,   778,   278,   778,   488,   601,   604,   280,
     838,   754,   754,   801,   327,   601,   487,   828,   488,   407,
     366,   962,   488,   491,    37,   148,   148,   546,   726,  1159,
    1146,   407,   487,   809,   838,   840,   736,   487,   487,   744,
    1146,   488,   487,   366,   962,  1146,  1146,   487,   487,   487,
     450,   473,   916,   335,   916,   916,   161,  1146,   546,  1146,
     762,   572,   573,  1163,    51,    95,   120,   137,   141,   162,
     165,   180,   268,   319,   568,   566,  1155,   809,    37,   845,
     845,  1144,   713,   488,   183,   487,   619,   239,   602,   194,
     487,   717,   709,   487,  1144,   488,   363,    28,    79,    87,
     115,   170,   183,   195,   382,   385,   594,   594,  1143,  1146,
    1148,   488,   974,   687,   148,   107,   662,   166,   701,   349,
     395,   703,   134,   706,   446,   708,  1146,    37,  1146,   625,
     580,  1144,   488,   584,   282,  1160,   616,   611,   615,   119,
     133,   308,  1146,    60,    68,   231,   974,   754,  1029,   795,
     797,   816,   488,   491,   417,  1039,   377,   377,   488,   641,
     259,   435,   643,   644,   951,    86,   795,   129,  1074,  1146,
     545,  1075,  1115,   488,  1084,  1112,   259,   469,    55,   990,
     488,   491,    37,  1037,   114,  1049,  1050,  1075,    77,  1145,
     488,  1074,   487,  1021,  1028,   487,   488,  1042,   488,   487,
     367,   487,   488,   491,  1093,  1094,  1160,   780,   789,   545,
     796,   828,   487,   549,   802,  1144,   828,   599,   619,  1146,
     398,   667,   183,   431,   547,   366,   962,  1146,  1115,   161,
     739,   739,  1115,  1115,  1074,   398,  1112,  1112,   556,   557,
    1162,   753,   754,   753,   754,  1145,   545,   488,   491,   480,
     487,   524,   574,   637,   913,  1155,   913,   263,   268,   319,
     913,   913,  1039,   845,    40,   188,   161,   259,   597,   487,
     633,  1074,   167,   297,   372,   278,   606,   607,   608,   398,
     488,  1152,     6,   718,   580,   610,  1146,   488,   662,   155,
     738,   550,   896,  1144,   454,  1020,   913,   349,   381,   707,
     487,   147,   662,   974,   945,   611,   580,   610,   587,   487,
     617,   615,   616,   350,   350,    68,   281,    68,   625,   794,
     488,   491,   823,   829,  1051,   129,   450,   450,   435,   641,
     436,  1146,   488,   264,   429,   662,   488,   488,   488,   436,
    1112,   177,   320,   350,  1099,  1038,  1035,   487,  1075,   488,
     491,    37,  1045,  1046,  1160,   488,  1145,  1112,   488,  1112,
     487,  1112,  1006,   491,    37,   166,   619,   838,   802,   803,
     598,   619,   488,   713,  1146,   633,  1074,   398,   488,   284,
     356,   324,   740,   740,   488,   488,   488,  1146,   488,   488,
     488,   491,  1154,   916,   573,   524,   575,   576,  1155,  1155,
     268,   599,   480,   599,  1155,  1155,   134,   196,   634,   488,
     119,   429,   278,   608,   278,   607,  1146,   487,   488,   491,
     555,   363,   662,   754,    37,    37,   487,  1146,   704,  1160,
    1074,   709,   896,   625,   615,   555,   611,   487,   613,   614,
    1079,  1160,   618,   616,   617,   281,   281,   487,   191,   798,
     797,    29,   205,   884,   168,   168,   974,  1039,   366,    49,
      97,   420,  1074,  1100,  1101,  1100,  1100,   488,  1042,   491,
    1050,  1163,   488,   491,   161,  1051,   488,   488,   488,  1005,
     488,  1094,  1096,   778,   447,   605,   488,   803,   602,   713,
     962,  1146,   809,    55,   962,   407,   556,   754,   488,   491,
     599,   349,   488,   386,    59,   259,   339,   366,   609,   609,
     488,     6,   363,  1146,   735,   974,   662,   488,  1152,   616,
     611,   615,  1074,   488,   491,   800,   800,   617,   618,   795,
     487,   550,   264,   487,   879,   881,   885,   947,   957,   964,
     974,   809,   809,   966,  1101,   349,   160,   306,   160,   306,
     144,  1102,  1102,  1102,   488,  1076,  1046,   285,     3,   114,
     263,   268,  1047,  1048,   334,  1033,   488,   545,   487,   713,
     606,   962,   754,   487,   576,   708,    23,   114,   268,  1146,
     662,   896,   487,   617,   615,   616,   488,   614,   754,   801,
     801,   618,   488,   797,   799,   618,   880,   881,   882,   975,
     976,   491,   491,  1039,    34,    97,   175,   259,   404,  1088,
    1075,  1075,   268,  1048,   487,  1074,   713,  1112,   147,   662,
       5,   710,   711,  1154,  1155,  1163,   618,   616,   617,   800,
     798,   488,   491,  1039,   488,   490,   407,   166,  1101,   349,
     286,    77,  1074,   488,   488,   709,   488,   491,   617,   618,
     801,   550,   797,   882,   377,   377,  1045,   488,  1152,   711,
     618,   618,   450,   450,   488,   487,  1039,   168,   168,   710,
     809,   809,   488
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   493,   494,   495,   495,   496,   496,   496,   496,   496,
     496,   496,   496,   496,   496,   496,   496,   496,   496,   496,
     496,   496,   496,   496,   496,   496,   496,   496,   496,   496,
     496,   496,   496,   496,   496,   496,   496,   496,   496,   496,
     496,   496,   496,   496,   496,   496,   496,   496,   496,   496,
     496,   496,   496,   496,   496,   496,   496,   496,   496,   496,
     496,   496,   496,   496,   496,   496,   496,   496,   496,   496,
     496,   496,   496,   496,   496,   496,   496,   496,   496,   496,
     496,   496,   496,   496,   496,   496,   496,   496,   496,   496,
     496,   496,   496,   496,   496,   496,   496,   496,   496,   496,
     496,   496,   496,   496,   496,   496,   496,   496,   496,   496,
     496,   496,   496,   496,   496,   496,   496,   496,   496,   496,
     496,   496,   496,   496,   496,   496,   496,   496,   496,   496,
     496,   497,   498,   499,   499,   499,   500,   500,   501,   501,
     502,   502,   502,   502,   502,   502,   502,   502,   502,   503,
     503,   503,   503,   503,   503,   504,   505,   505,   506,   506,
     507,   507,   507,   507,   508,   508,   508,   508,   508,   508,
     509,   510,   511,   511,   512,   512,   512,   512,   513,   513,
     514,   514,   515,   515,   515,   515,   515,   515,   516,   516,
     516,   516,   517,   517,   517,   518,   518,   518,   518,   519,
     519,   519,   519,   519,   519,   519,   519,   519,   519,   519,
     520,   520,   521,   521,   522,   522,   523,   523,   523,   523,
     524,   524,   524,   524,   525,   525,   525,   525,   525,   525,
     525,   526,   526,   526,   527,   527,   528,   528,   529,   529,
     529,   529,   530,   530,   531,   531,   532,   532,   533,   533,
     533,   533,   533,   533,   533,   534,   535,   535,   536,   536,
     537,   538,   538,   538,   538,   538,   539,   539,   539,   539,
     539,   539,   539,   539,   539,   539,   539,   539,   539,   539,
     539,   539,   539,   539,   539,   540,   540,   541,   541,   542,
     543,   543,   543,   543,   543,   543,   543,   543,   543,   543,
     543,   543,   543,   543,   543,   543,   543,   543,   543,   543,
     543,   543,   543,   543,   543,   543,   543,   543,   543,   543,
     543,   543,   543,   543,   543,   543,   543,   543,   543,   543,
     543,   543,   543,   543,   543,   543,   543,   543,   543,   543,
     543,   543,   543,   543,   543,   543,   543,   543,   544,   544,
     545,   545,   545,   546,   546,   547,   547,   548,   548,   548,
     548,   549,   550,   550,   551,   551,   552,   552,   552,   552,
     553,   553,   554,   554,   554,   554,   555,   555,   555,   555,
     556,   557,   557,   558,   559,   559,   560,   560,   560,   560,
     561,   561,   562,   562,   563,   563,   564,   564,   565,   565,
     565,   566,   566,   567,   567,   568,   568,   568,   568,   568,
     568,   568,   568,   568,   568,   568,   568,   568,   569,   569,
     570,   570,   571,   571,   572,   572,   573,   574,   574,   574,
     574,   574,   575,   575,   576,   577,   577,   577,   577,   577,
     577,   578,   578,   578,   578,   578,   578,   578,   578,   579,
     579,   580,   580,   581,   581,   582,   582,   583,   583,   583,
     584,   584,   585,   586,   586,   587,   587,   588,   588,   588,
     588,   589,   589,   589,   589,   589,   589,   589,   589,   589,
     590,   590,   591,   591,   591,   591,   592,   593,   593,   593,
     594,   594,   594,   594,   594,   594,   594,   594,   594,   595,
     595,   596,   596,   596,   596,   596,   596,   596,   597,   597,
     598,   598,   599,   599,   600,   601,   601,   602,   602,   602,
     602,   603,   603,   604,   604,   605,   605,   606,   606,   606,
     606,   606,   607,   608,   609,   609,   609,   609,   609,   610,
     610,   611,   611,   612,   613,   613,   614,   614,   614,   615,
     615,   616,   616,   616,   617,   617,   617,   617,   618,   618,
     619,   619,   620,   621,   621,   622,   622,   623,   623,   624,
     625,   625,   625,   626,   626,   627,   628,   628,   629,   630,
     630,   631,   631,   632,   632,   633,   633,   634,   634,   635,
     635,   635,   635,   635,   635,   635,   635,   635,   635,   635,
     635,   635,   635,   636,   636,   637,   637,   637,   637,   638,
     638,   639,   639,   640,   640,   641,   641,   642,   642,   643,
     643,   644,   644,   645,   645,   646,   646,   647,   648,   648,
     649,   649,   650,   650,   651,   651,   652,   652,   652,   652,
     653,   654,   654,   655,   656,   656,   656,   656,   656,   656,
     656,   656,   656,   656,   656,   656,   656,   656,   656,   656,
     656,   656,   656,   656,   656,   656,   656,   656,   656,   656,
     656,   656,   657,   658,   658,   658,   658,   659,   659,   660,
     660,   661,   661,   662,   662,   663,   663,   664,   665,   665,
     666,   666,   666,   666,   667,   668,   669,   670,   670,   671,
     671,   672,   672,   673,   673,   674,   674,   674,   675,   675,
     675,   675,   676,   676,   677,   678,   678,   679,   679,   680,
     680,   681,   681,   682,   682,   683,   684,   685,   686,   686,
     687,   687,   688,   688,   689,   689,   690,   690,   691,   691,
     692,   692,   692,   692,   692,   693,   694,   694,   695,   695,
     696,   696,   696,   697,   697,   698,   698,   698,   698,   698,
     699,   699,   700,   700,   701,   702,   702,   703,   703,   704,
     705,   705,   706,   706,   707,   707,   708,   708,   709,   709,
     710,   710,   710,   711,   711,   711,   711,   712,   712,   713,
     713,   714,   714,   714,   714,   714,   714,   715,   715,   716,
     716,   717,   718,   718,   719,   720,   720,   720,   720,   721,
     722,   722,   722,   722,   722,   722,   722,   722,   722,   722,
     722,   722,   722,   722,   722,   722,   723,   724,   724,   725,
     725,   726,   726,   726,   726,   726,   726,   727,   728,   728,
     729,   730,   730,   731,   731,   732,   732,   732,   732,   733,
     733,   734,   735,   735,   736,   736,   736,   736,   736,   737,
     737,   738,   738,   739,   739,   739,   740,   740,   741,   742,
     742,   743,   743,   744,   744,   745,   745,   746,   746,   747,
     748,   749,   749,   749,   749,   749,   749,   749,   749,   749,
     749,   749,   749,   750,   750,   750,   750,   750,   750,   750,
     750,   750,   750,   750,   750,   750,   751,   751,   751,   751,
     751,   751,   751,   752,   752,   752,   753,   753,   754,   754,
     755,   755,   756,   756,   757,   758,   758,   758,   759,   759,
     759,   759,   759,   759,   759,   759,   759,   759,   759,   759,
     759,   759,   759,   759,   759,   759,   759,   760,   760,   760,
     760,   760,   760,   760,   760,   760,   760,   760,   760,   760,
     760,   761,   761,   761,   761,   761,   761,   761,   761,   761,
     761,   761,   761,   762,   762,   763,   763,   763,   763,   763,
     763,   763,   763,   763,   764,   764,   765,   765,   765,   765,
     765,   765,   766,   766,   766,   766,   766,   766,   766,   766,
     767,   767,   768,   768,   769,   769,   769,   769,   769,   769,
     769,   769,   769,   769,   769,   769,   769,   769,   769,   769,
     770,   770,   771,   771,   772,   773,   773,   774,   774,   774,
     774,   774,   775,   775,   776,   776,   776,   776,   777,   777,
     777,   777,   777,   777,   777,   777,   777,   777,   777,   777,
     777,   777,   777,   777,   777,   777,   777,   777,   778,   778,
     779,   779,   780,   780,   781,   782,   782,   783,   783,   784,
     784,   785,   786,   786,   787,   787,   787,   788,   788,   788,
     789,   789,   789,   789,   789,   789,   790,   790,   791,   791,
     792,   792,   793,   793,   794,   794,   795,   795,   796,   796,
     797,   797,   797,   798,   798,   799,   799,   800,   800,   801,
     801,   802,   802,   802,   803,   803,   803,   804,   804,   804,
     804,   805,   805,   806,   806,   807,   807,   808,   808,   809,
     809,   809,   809,   810,   810,   811,   811,   812,   812,   812,
     812,   812,   813,   813,   813,   813,   813,   814,   815,   816,
     816,   816,   817,   817,   817,   818,   819,   819,   819,   819,
     820,   820,   821,   822,   822,   823,   823,   824,   824,   824,
     824,   824,   824,   824,   824,   824,   824,   824,   824,   824,
     824,   824,   824,   824,   825,   825,   825,   825,   825,   826,
     826,   827,   827,   828,   828,   829,   830,   830,   831,   831,
     831,   832,   832,   833,   833,   834,   834,   834,   834,   834,
     834,   835,   835,   836,   836,   837,   837,   837,   837,   838,
     838,   839,   839,   840,   841,   842,   842,   843,   843,   844,
     844,   844,   845,   845,   845,   846,   847,   847,   848,   849,
     849,   849,   849,   850,   851,   851,   851,   851,   852,   852,
     853,   853,   853,   854,   854,   855,   856,   856,   857,   857,
     857,   857,   857,   857,   857,   857,   857,   857,   857,   857,
     857,   857,   857,   857,   857,   857,   857,   857,   857,   857,
     857,   857,   857,   857,   857,   857,   857,   857,   857,   857,
     857,   857,   857,   857,   857,   857,   857,   857,   857,   857,
     857,   857,   857,   857,   857,   857,   857,   857,   857,   857,
     857,   857,   857,   858,   858,   859,   859,   860,   860,   860,
     860,   860,   860,   861,   861,   862,   862,   862,   862,   862,
     862,   862,   862,   862,   862,   862,   862,   862,   862,   862,
     862,   862,   862,   862,   862,   862,   862,   862,   862,   862,
     862,   862,   863,   864,   864,   865,   865,   866,   866,   866,
     866,   866,   867,   868,   868,   868,   868,   868,   868,   868,
     868,   868,   868,   868,   868,   868,   868,   868,   868,   868,
     868,   868,   868,   868,   868,   868,   868,   869,   870,   870,
     871,   871,   872,   872,   872,   872,   873,   874,   874,   875,
     876,   876,   876,   876,   876,   876,   877,   877,   878,   879,
     879,   879,   880,   880,   881,   881,   881,   881,   881,   882,
     882,   883,   883,   883,   883,   884,   884,   884,   885,   886,
     886,   887,   888,   888,   889,   889,   889,   889,   889,   889,
     889,   889,   889,   889,   889,   889,   889,   889,   890,   890,
     890,   891,   891,   891,   891,   891,   892,   892,   892,   893,
     893,   894,   894,   894,   895,   895,   895,   895,   896,   896,
     896,   896,   897,   898,   899,   899,   900,   900,   901,   901,
     901,   902,   902,   902,   902,   902,   902,   902,   903,   903,
     904,   904,   904,   905,   906,   906,   906,   906,   907,   907,
     908,   909,   910,   910,   911,   912,   912,   912,   912,   912,
     912,   912,   913,   913,   914,   915,   915,   915,   915,   915,
     915,   916,   916,   917,   918,   918,   918,   919,   919,   920,
     920,   921,   921,   922,   922,   923,   923,   924,   925,   925,
     926,   926,   926,   927,   927,   928,   928,   929,   929,   930,
     930,   931,   931,   932,   933,   933,   934,   934,   935,   935,
     935,   935,   936,   936,   936,   936,   936,   936,   936,   936,
     936,   937,   937,   938,   939,   939,   940,   940,   940,   941,
     942,   942,   943,   943,   943,   943,   944,   944,   944,   945,
     945,   946,   946,   946,   946,   947,   948,   949,   949,   950,
     950,   950,   950,   950,   951,   951,   952,   952,   953,   954,
     954,   954,   955,   955,   955,   956,   956,   957,   958,   958,
     959,   960,   960,   961,   961,   961,   961,   961,   961,   961,
     961,   962,   962,   963,   963,   963,   964,   965,   966,   966,
     967,   967,   968,   969,   969,   970,   971,   972,   972,   972,
     972,   972,   973,   973,   973,   974,   974,   975,   975,   976,
     976,   976,   976,   976,   976,   976,   976,   977,   977,   978,
     978,   978,   978,   978,   978,   978,   979,   979,   979,   980,
     980,   981,   982,   982,   982,   983,   983,   984,   984,   985,
     985,   985,   985,   985,   985,   985,   985,   985,   986,   986,
     987,   987,   987,   988,   988,   989,   989,   990,   990,   991,
     992,   992,   993,   993,   994,   994,   994,   994,   995,   995,
     996,   996,   996,   996,   996,   996,   997,   997,   998,   998,
     999,  1000,  1000,  1000,  1001,  1001,  1002,  1002,  1003,  1003,
    1004,  1004,  1005,  1005,  1006,  1006,  1006,  1006,  1006,  1007,
    1008,  1009,  1010,  1011,  1011,  1012,  1012,  1013,  1013,  1014,
    1014,  1015,  1016,  1016,  1016,  1016,  1017,  1017,  1018,  1018,
    1019,  1019,  1020,  1020,  1021,  1021,  1021,  1021,  1021,  1021,
    1021,  1021,  1021,  1021,  1022,  1022,  1022,  1022,  1022,  1022,
    1023,  1023,  1023,  1023,  1024,  1024,  1025,  1025,  1025,  1025,
    1025,  1026,  1026,  1026,  1026,  1027,  1027,  1028,  1028,  1029,
    1029,  1029,  1029,  1030,  1030,  1031,  1031,  1031,  1032,  1033,
    1033,  1034,  1034,  1035,  1036,  1036,  1037,  1037,  1038,  1038,
    1039,  1039,  1040,  1040,  1040,  1041,  1041,  1042,  1042,  1043,
    1044,  1044,  1045,  1045,  1046,  1046,  1046,  1047,  1047,  1048,
    1048,  1048,  1048,  1049,  1049,  1050,  1050,  1051,  1051,  1051,
    1051,  1051,  1051,  1052,  1052,  1052,  1053,  1053,  1053,  1053,
    1053,  1053,  1053,  1054,  1054,  1054,  1054,  1055,  1055,  1056,
    1056,  1057,  1057,  1057,  1057,  1057,  1057,  1057,  1057,  1057,
    1057,  1057,  1058,  1058,  1059,  1059,  1060,  1060,  1061,  1062,
    1063,  1063,  1064,  1064,  1065,  1066,  1067,  1067,  1067,  1067,
    1067,  1067,  1068,  1068,  1069,  1069,  1069,  1069,  1070,  1071,
    1071,  1071,  1072,  1072,  1072,  1072,  1072,  1072,  1072,  1072,
    1072,  1072,  1072,  1072,  1072,  1072,  1073,  1073,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1075,  1075,  1075,  1075,
    1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,
    1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,
    1075,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,
    1076,  1076,  1076,  1076,  1076,  1077,  1077,  1077,  1077,  1077,
    1077,  1077,  1078,  1078,  1079,  1079,  1080,  1080,  1080,  1080,
    1080,  1080,  1080,  1080,  1080,  1080,  1080,  1080,  1080,  1080,
    1080,  1080,  1080,  1080,  1080,  1080,  1080,  1080,  1080,  1080,
    1080,  1080,  1080,  1080,  1080,  1080,  1080,  1080,  1080,  1080,
    1080,  1080,  1080,  1080,  1080,  1080,  1080,  1080,  1080,  1080,
    1081,  1081,  1082,  1082,  1082,  1082,  1083,  1084,  1084,  1085,
    1085,  1086,  1086,  1087,  1087,  1087,  1088,  1088,  1088,  1088,
    1089,  1089,  1090,  1090,  1091,  1091,  1092,  1092,  1093,  1093,
    1094,  1095,  1095,  1095,  1096,  1097,  1097,  1098,  1098,  1099,
    1099,  1099,  1099,  1100,  1100,  1101,  1101,  1101,  1101,  1101,
    1102,  1102,  1102,  1102,  1102,  1103,  1103,  1103,  1104,  1104,
    1105,  1106,  1106,  1106,  1107,  1107,  1108,  1108,  1108,  1108,
    1108,  1108,  1108,  1108,  1108,  1108,  1108,  1108,  1109,  1109,
    1110,  1110,  1111,  1111,  1111,  1111,  1111,  1111,  1112,  1112,
    1113,  1113,  1114,  1114,  1114,  1115,  1115,  1116,  1116,  1116,
    1117,  1117,  1118,  1118,  1119,  1119,  1119,  1119,  1119,  1119,
    1119,  1119,  1120,  1120,  1120,  1120,  1121,  1121,  1122,  1123,
    1123,  1124,  1124,  1124,  1124,  1124,  1124,  1125,  1126,  1127,
    1127,  1127,  1128,  1128,  1129,  1130,  1130,  1131,  1132,  1132,
    1133,  1133,  1134,  1134,  1135,  1135,  1135,  1135,  1136,  1136,
    1137,  1137,  1138,  1138,  1139,  1139,  1140,  1140,  1141,  1141,
    1142,  1142,  1142,  1142,  1143,  1143,  1144,  1144,  1145,  1145,
    1146,  1147,  1148,  1149,  1150,  1151,  1152,  1152,  1153,  1153,
    1153,  1153,  1153,  1153,  1153,  1153,  1153,  1153,  1153,  1153,
    1153,  1154,  1155,  1156,  1156,  1156,  1157,  1158,  1158,  1158,
    1159,  1159,  1160,  1160,  1160,  1161,  1161,  1161,  1162,  1162,
    1162,  1162,  1163,  1163,  1163,  1163,  1163,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1165,  1165,  1165,  1165,
    1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,
    1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,
    1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,
    1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,  1165,
    1165,  1165,  1165,  1165,  1165,  1165,  1165,  1166,  1166,  1166,
    1166,  1166,  1166,  1166,  1166,  1166,  1166,  1166,  1166,  1166,
    1166,  1166,  1166,  1166,  1166,  1166,  1166,  1166,  1166,  1166,
    1167,  1167,  1167,  1167,  1167,  1167,  1167,  1167,  1167,  1167,
    1167,  1167,  1167,  1167,  1167,  1167,  1167,  1167,  1167,  1167,
    1167,  1167,  1167,  1167,  1167,  1167,  1167,  1167,  1167,  1167,
    1167,  1167,  1167,  1167,  1167,  1167,  1167,  1167,  1167,  1167,
    1167,  1167,  1167,  1167,  1167,  1167,  1167,  1167,  1167,  1167,
    1167,  1167,  1167,  1167,  1167,  1167,  1167,  1167,  1167,  1167,
    1167,  1167,  1167,  1167,  1167,  1167,  1167,  1167,  1167,  1167,
    1167,  1167,  1167,  1167,  1167,  1167,  1167
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     2,     5,     1,     1,     0,     2,     0,     2,     0,
       2,     2,     3,     3,     1,     3,     3,     2,     1,     1,
       2,     2,     2,     3,     3,     5,     5,     5,     0,     3,
       5,     5,     5,     5,     3,     5,     3,     5,     3,     5,
       5,     6,     1,     1,     6,     4,     9,     7,     1,     0,
       2,     0,     1,     1,     1,     1,     1,     1,     3,     2,
       3,     3,     2,     5,     1,     3,     3,     3,     3,     1,
       3,     3,     2,     2,     2,     2,     3,     3,     3,     3,
       1,     3,     1,     3,     1,     1,     2,     2,     2,     1,
       1,     1,     1,     1,     1,     1,     3,     5,     1,     1,
       1,     1,     1,     0,     1,     1,     2,     3,     1,     2,
       3,     2,     1,     1,     2,     1,     2,     1,     3,     3,
       2,     3,     4,     3,     2,     4,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     2,     4,     6,     4,     6,
      10,    13,     4,     6,     4,    10,    13,     4,     6,     4,
       6,     5,     7,    11,    14,     1,     3,     4,     3,     3,
       2,     5,     3,     6,     4,     6,     6,     5,     7,     6,
       6,     5,     5,     6,     9,     4,     5,     7,     6,     4,
       8,     4,     2,     4,     3,     6,     4,     3,     3,     3,
       2,     2,     3,     4,     4,     3,     3,     3,     3,     3,
       3,     4,     4,     3,     2,     3,     2,     2,     3,     3,
       2,     2,     3,     4,     4,     4,     5,     1,     3,     2,
       1,     1,     0,     2,     0,     2,     0,     1,     1,     1,
       3,     3,     2,     0,     1,     3,     3,     1,     5,     3,
       1,     2,     1,     3,     2,     3,     6,     6,    10,     1,
       2,     1,     3,     4,     1,     3,     4,     6,     4,     8,
       2,     2,    11,     9,     1,     1,     1,     0,     1,     1,
       1,     1,     3,     2,     0,     1,     1,     3,     3,     1,
       1,     3,     3,     3,     3,     4,     3,     2,     1,     0,
       3,     0,     1,     0,     1,     3,     2,     1,     1,     1,
       3,     0,     1,     3,     1,    13,    16,    12,    15,    14,
      17,     1,     1,     2,     2,     2,     2,     1,     0,     1,
       0,     3,     0,     1,     3,     1,     3,     1,     1,     1,
       1,     1,     4,     2,     4,     2,     0,     3,     1,     1,
       2,     2,     1,     3,     4,     5,     2,     5,     7,     5,
       1,     2,     1,     2,     2,     2,     3,     3,     3,     0,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     5,     8,     3,     9,     4,    10,    11,     2,     0,
       3,     0,     1,     3,     1,     4,     0,     2,     2,     2,
       0,     1,     3,     3,     6,     4,     0,     1,     1,     2,
       2,     0,     3,     3,     2,     1,     1,     2,     2,     4,
       0,     1,     0,     6,     1,     3,     3,     3,     5,     2,
       0,     2,     2,     0,     3,     4,     4,     0,     2,     0,
       4,     0,     3,     8,    11,     6,     8,     7,    10,     6,
       2,     3,     0,     8,    11,     5,     1,     0,     6,     5,
       8,     4,     6,     1,     0,     3,     0,     1,     2,     2,
       2,     1,     2,     3,     2,     2,     2,     2,     3,     3,
       3,     1,     3,     1,     0,     1,     2,     2,     1,     1,
       3,     6,    10,     1,     0,     1,     2,     2,     0,     2,
       2,     1,     0,     5,     7,     1,     0,     7,     2,     0,
       3,     5,     5,     8,     2,     0,     2,     2,     2,     1,
       5,     2,     0,     2,     7,     6,    10,     6,     6,     6,
       6,     7,     6,     9,     9,     6,     6,     6,     7,     6,
       8,     8,     8,     8,     6,     6,     7,     7,     8,     6,
       9,     6,     7,     2,     2,     2,     2,     1,     2,     1,
       0,     7,     6,     4,     0,     1,     3,     4,     1,     3,
       1,     2,     2,     2,     2,     1,     1,    10,    13,     2,
       0,     2,     2,     1,     0,     5,     4,     4,    11,    14,
      12,    15,     5,     7,    11,     2,     1,     4,     0,     8,
      11,     1,     1,     7,     9,     8,    10,     8,     4,     0,
       5,     0,     2,     0,     2,     0,     2,     0,     2,     0,
       1,     1,     1,     1,     1,     8,     1,     1,    16,    20,
       1,     1,     2,     1,     3,     1,     1,     1,     3,     1,
       2,     0,     1,     2,     4,     1,     1,     1,     1,     1,
       3,     0,     1,     0,     1,     1,     4,     0,     1,     1,
       1,     3,     0,     1,     1,     1,     1,     2,     0,     0,
       2,     2,     1,     2,     2,     2,     2,    11,    13,     1,
       3,     5,     1,     3,     5,     1,     2,     2,     1,     8,
       6,     5,     4,     4,     3,     7,     8,     6,     6,     6,
       6,     6,     4,     7,     5,     8,     3,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     3,
       3,     1,     0,     1,     3,     7,     9,     9,     8,     3,
       0,    13,     1,     3,     5,     5,     3,     6,     2,     1,
       0,     2,     0,     2,     4,     0,     1,     0,     6,     8,
       8,     1,     3,     5,     5,     7,     9,     7,     9,     5,
       6,     6,     4,     6,     4,     6,     8,     4,     6,     4,
       6,     5,     7,     1,     1,     1,     2,     1,     2,     1,
       1,     1,     3,     3,     3,     3,     2,     2,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     2,
       2,     3,     1,     3,     5,     2,     2,     0,     6,     6,
       6,     6,     6,     6,     6,     8,     9,     8,     6,     6,
       8,     9,     8,     9,     9,     7,    10,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     2,     3,     3,     3,
       3,     2,     1,     2,     1,     3,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     8,     8,     8,     8,     8,
       8,     9,     8,     8,     2,     0,     1,     2,     1,     1,
       1,     2,     1,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     1,     2,     3,     3,     3,     3,
       4,     4,     3,     3,     3,     4,     4,     3,     4,     4,
       1,     1,     1,     0,     7,     7,    10,     1,     1,     2,
       4,     5,     1,     3,     2,     2,     2,     2,     1,     2,
       2,     4,     3,     2,     2,     2,     2,     2,     2,     3,
       2,     2,     2,     5,     5,     5,     5,     5,     1,     3,
       1,     2,     3,     0,     6,     6,     9,     3,     0,     3,
       0,     5,     2,     0,     3,     3,     3,     7,     7,    10,
       1,     1,     1,     1,     1,     1,    15,    18,     1,     0,
       1,     0,     1,     0,     2,     0,     1,     3,     4,     5,
       2,     2,     4,     4,     0,     1,     3,     2,     0,     1,
       0,     1,     1,     0,     2,     2,     0,     8,    11,     6,
       6,     2,     0,     3,     2,     1,     3,     1,     3,     2,
       1,     1,     2,     3,     2,     1,     3,     3,     3,     2,
       2,     1,     1,     1,     1,     2,     1,     1,     1,     1,
       4,     5,     1,     3,     3,     1,     3,     3,     5,     6,
       1,     3,     2,     1,     3,     1,     2,     4,     5,     1,
       1,     1,     1,     3,     3,     2,     2,     1,     2,     2,
       2,     2,     1,     2,     2,     2,     2,     1,     1,     1,
       3,     3,     5,     2,     0,     2,     1,     3,     5,     5,
       5,     1,     2,     1,     0,     4,     6,     4,     6,     4,
       6,     4,     6,     4,     6,     3,     5,     5,     5,     1,
       3,     1,     3,     2,     2,     1,     2,     1,     2,    11,
      10,    10,     2,     2,     0,     9,     2,     0,    10,    11,
      11,     5,     5,     8,     4,     4,     7,     7,     1,     1,
       1,     1,     1,     1,     3,     1,     5,     5,     6,     6,
       6,     6,     6,     8,     8,     6,     6,     7,     9,     9,
       8,    10,     6,     6,     6,     6,     6,     6,     6,     8,
       6,     8,     6,     8,     7,     9,     6,     8,     7,     9,
       8,    10,     8,    10,     9,    11,     8,    10,     9,    11,
       8,     8,     7,     6,     6,     6,     6,     8,     8,     8,
       8,     6,     9,     1,     0,     2,     0,     8,     8,     8,
      10,     9,     8,     1,     0,     6,     6,     6,     6,     6,
       6,     6,     9,     9,     6,     6,     6,     8,     6,     8,
       8,     8,     8,     6,     8,     6,     8,     7,     9,     7,
       9,     6,     7,     1,     3,     3,     3,     1,     1,     1,
       1,     1,     7,     6,     6,     6,     6,     6,     6,     7,
       7,     6,     9,     9,     6,     6,     6,     6,     6,     6,
       8,     8,     8,     6,     7,     6,     6,     5,     1,     0,
       3,     3,     5,     6,     6,     6,     8,     1,     3,     1,
       5,     5,     6,     7,     4,     4,     4,     6,    13,     1,
       1,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       0,     1,     1,     1,     1,     1,     1,     0,     3,     2,
       0,     2,     2,     2,     3,     3,     3,     3,     3,     3,
       2,     3,     2,     5,     4,     3,     3,     3,     1,     1,
       0,     3,     2,     2,     1,     2,     1,     3,     2,     1,
       0,     2,     3,     0,     9,    11,    12,    14,     3,     4,
       4,     0,     2,     5,     1,     0,     1,     2,     3,     3,
       3,     1,     2,     1,     1,     1,     1,     1,     1,     0,
       5,     4,     6,     4,     3,     5,     7,     9,     1,     3,
       1,     5,     4,     4,     6,     4,     6,     6,     5,     7,
       9,     6,     1,     0,     6,    11,    11,    11,    13,     9,
      11,     1,     1,    10,     4,     2,     5,     2,     0,     6,
       5,     3,     5,     1,     3,     1,     1,     2,     1,     1,
       1,     1,     0,     1,     0,     1,     0,     1,     0,     1,
       0,     3,     0,     2,     1,     3,     1,     0,     2,     4,
       3,     5,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     2,     1,     1,     1,     1,     0,     5,
       3,     0,     1,     1,     1,     1,     3,     9,    12,     3,
       0,     2,     3,     2,     3,     7,     4,     1,     3,     1,
       4,     4,     7,     2,     1,     1,     1,     3,     2,     8,
       5,     0,     4,     3,     0,     2,     0,     7,     2,     0,
       5,     3,     0,     2,     2,     2,     3,     1,     3,     1,
       2,     1,     0,     1,     2,     0,     8,     3,     1,     3,
       3,     5,     2,     1,     3,     7,     1,     0,     3,     2,
       2,     2,     0,     2,     2,     1,     1,     3,     3,     1,
       2,     4,     4,     2,     3,     5,     5,     1,     1,     9,
       9,     1,     2,     4,     4,     4,     2,     2,     3,     1,
       3,     7,     1,     2,     0,     1,     0,     2,     0,     3,
       3,     4,     4,     4,     4,     3,     2,     1,     1,     0,
       1,     1,     0,     1,     5,     1,     0,     1,     0,     3,
       1,     3,     4,     3,     2,     2,     1,     1,     1,     0,
       2,     4,     5,     6,     4,     5,     2,     3,     1,     1,
       1,     1,     2,     2,     1,     1,     1,     1,     1,     1,
       3,     0,     1,     3,     1,     1,     1,     1,     1,     2,
       4,     4,     5,     2,     0,     1,     3,     1,     0,     1,
       2,     3,     2,     4,     2,     3,     2,     0,     4,     5,
       2,     0,     1,     3,     2,     3,     2,     3,     2,     3,
       2,     3,     1,     4,     3,     4,     5,     4,     5,     4,
       5,     2,     4,     1,     1,     0,     1,     4,     5,     4,
       0,     2,     2,     2,     1,     1,     0,     4,     2,     1,
       2,     2,     4,     1,     3,     1,     2,     3,     6,     4,
       0,     2,     6,     2,     1,     3,     4,     0,     2,     0,
       2,     0,     2,     4,     0,     1,     0,     1,     3,     3,
       7,    12,     1,     3,     2,     3,     3,     1,     2,     2,
       2,     2,     1,     1,     3,     3,     2,     2,     3,     5,
       6,     2,     3,     3,     4,     0,     1,     1,     1,     1,
       1,     2,     4,     1,     1,     1,     1,     2,     3,     3,
       0,     1,     1,     1,     1,     1,     2,     2,     2,     2,
       2,     1,     3,     0,     1,     1,     1,     1,     5,     2,
       1,     1,     1,     1,     4,     1,     2,     2,     1,     3,
       3,     2,     1,     0,     5,     2,     5,     2,     1,     3,
       3,     0,     1,     1,     1,     1,     1,     1,     3,     3,
       3,     3,     3,     3,     3,     0,     1,     4,     1,     3,
       3,     5,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     2,     3,
       3,     2,     2,     3,     5,     4,     6,     3,     5,     4,
       6,     4,     6,     5,     7,     3,     2,     4,     2,     3,
       3,     4,     3,     4,     3,     4,     5,     6,     6,     7,
       6,     7,     6,     7,     3,     4,     4,     6,     2,     3,
       4,     3,     4,     4,     5,     1,     1,     3,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     2,     5,     6,     6,     7,     3,
       4,     1,     1,     2,     4,     1,     1,     1,     2,     2,
       2,     2,     1,     1,     4,     3,     5,     6,     8,     6,
       6,     4,     4,     1,     1,     1,     5,     1,     1,     4,
       1,     4,     1,     4,     1,     4,     1,     1,     1,     1,
       1,     1,     6,     4,     4,     6,     4,     4,     4,     6,
       5,     5,     5,     4,     6,     4,     4,     4,     4,     5,
       7,     7,     9,     5,     4,     6,     5,     7,     7,     7,
       2,     3,     3,     3,     4,     0,     4,     1,     3,     3,
       1,     1,     1,     2,     2,     0,     2,     3,     3,     4,
       2,     2,     5,     0,     5,     0,     2,     0,     1,     3,
       3,     2,     2,     0,     6,     1,     0,     3,     0,     3,
       3,     3,     0,     1,     4,     2,     2,     2,     2,     2,
       3,     2,     2,     3,     0,     4,     3,     5,     4,     3,
       5,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     4,
       1,     4,     1,     4,     1,     2,     1,     2,     1,     3,
       1,     3,     1,     3,     3,     1,     3,     3,     3,     2,
       1,     3,     3,     0,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     4,     3,     2,     3,
       0,     3,     3,     2,     2,     1,     0,     2,     2,     3,
       2,     1,     1,     3,     5,     1,     2,     4,     2,     0,
       1,     0,     1,     2,     2,     2,     3,     5,     1,     0,
       1,     2,     0,     2,     1,     0,     1,     0,     1,     3,
       3,     2,     1,     1,     1,     3,     1,     2,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     2,     1,     1,
       1,     1,     1,     2,     6,     2,     3,     5,     1,     1,
       1,     1,     1,     1,     2,     2,     1,     1,     1,     1,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, core_yyscan_t yyscanner)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, yyscanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (core_yyscan_t yyscanner)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, &yylloc, yyscanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 844 "gram_minimal.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[0].list);
			}
#line 26368 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 3:
#line 860 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-2].list) != NIL)
					{
						/* update length of previous stmt */
						updateRawStmtEnd(llast_node(RawStmt, (yyvsp[-2].list)), (yylsp[-1]));
					}
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), makeRawStmt((yyvsp[0].node), (yylsp[-1]) + 1));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 26384 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 4:
#line 872 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = list_make1(makeRawStmt((yyvsp[0].node), 0));
					else
						(yyval.list) = NIL;
				}
#line 26395 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1007 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 26401 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1017 "gram_minimal.y" /* yacc.c:1646  */
    {
					CallStmt *n = makeNode(CallStmt);
					n->funccall = castNode(FuncCall, (yyvsp[0].node));
					(yyval.node) = (Node *)n;
				}
#line 26411 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1032 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 26423 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1042 "gram_minimal.y" /* yacc.c:1646  */
    {}
#line 26429 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1043 "gram_minimal.y" /* yacc.c:1646  */
    {}
#line 26435 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1044 "gram_minimal.y" /* yacc.c:1646  */
    {}
#line 26441 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1053 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 26447 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1054 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26453 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1058 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 26459 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1059 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26465 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1064 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 26474 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1069 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password", NULL, (yylsp[-1]));
				}
#line 26482 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1073 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * These days, passwords are always stored in encrypted
					 * form, so there is no difference between PASSWORD and
					 * ENCRYPTED PASSWORD.
					 */
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 26496 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1083 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNENCRYPTED PASSWORD is no longer supported"),
							 errhint("Remove UNENCRYPTED to store the password in encrypted form instead."),
							 parser_errposition((yylsp[-2]))));
				}
#line 26508 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1091 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 26516 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1095 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 26524 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1099 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 26532 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1104 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 26540 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1108 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * We handle identifiers that aren't parser keywords with
					 * the following special-case codes, to avoid bloating the
					 * size of the main parser.
					 */
					if (strcmp((yyvsp[0].str), "superuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nosuperuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createrole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreaterole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "replication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noreplication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createdb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreatedb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "login") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nologin") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "bypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *)makeInteger(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nobypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *)makeInteger(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noinherit") == 0)
					{
						/*
						 * Note that INHERIT is a keyword, so it's handled by main parser, but
						 * NOINHERIT is handled here.
						 */
						(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(false), (yylsp[0]));
					}
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized role option \"%s\"", (yyvsp[0].str)),
									 parser_errposition((yylsp[0]))));
				}
#line 26589 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1155 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = (yyvsp[0].defelt); }
#line 26595 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1158 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *)makeInteger((yyvsp[0].ival)), (yylsp[-1]));
				}
#line 26603 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1162 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 26611 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1166 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 26619 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1170 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 26627 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1174 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 26635 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1188 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 26647 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1206 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 26659 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1214 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 26671 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1224 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 26677 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1225 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 26683 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1230 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 26695 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1238 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 26707 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1246 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 26719 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1254 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 26731 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1275 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 26742 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1282 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = true;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 26753 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1289 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 26764 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1296 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->roles = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 26775 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1303 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 26786 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1310 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = true;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 26797 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1327 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 26809 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1345 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-3].rolespec);
					n->action = (yyvsp[-2].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *)(yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *)n;
				}
#line 26822 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1355 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = +1; }
#line 26828 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1356 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = -1; }
#line 26834 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1368 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 26848 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1378 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 26862 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1388 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* schema name can be omitted here, too */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 26881 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1403 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not here */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 26900 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1420 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 26906 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1421 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 26912 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1426 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyloc) < 0)			/* see comments for YYLLOC_DEFAULT */
						(yyloc) = (yylsp[0]);
					(yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node));
				}
#line 26922 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1432 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26928 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1460 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->type = T_PgpoolVariableSetStmt; /* Hack to keep changes minumum */
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 26939 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1467 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 26949 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1473 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
#line 26959 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1479 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 26969 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1488 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 26981 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1496 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 26993 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1508 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 27005 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1516 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 27017 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1524 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 27028 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1531 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 27039 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1540 "gram_minimal.y" /* yacc.c:1646  */
    {(yyval.vsetstmt) = (yyvsp[0].vsetstmt);}
#line 27045 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1542 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 27056 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1550 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[0].node) != NULL)
						n->args = list_make1((yyvsp[0].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 27071 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1561 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[0]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				}
#line 27083 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1569 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 27095 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1577 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[0].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 27110 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1588 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 27122 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1596 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 27134 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1604 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 27145 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1611 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[0].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 27157 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1620 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION SNAPSHOT";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 27169 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1629 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27175 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1631 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str)); }
#line 27181 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1634 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 27187 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1635 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 27193 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1639 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0])); }
#line 27199 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1641 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].value), (yylsp[0])); }
#line 27205 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1644 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "read uncommitted"; }
#line 27211 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1645 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "read committed"; }
#line 27217 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1646 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "repeatable read"; }
#line 27223 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1647 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "serializable"; }
#line 27229 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1651 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "true"; }
#line 27235 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1652 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "false"; }
#line 27241 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1653 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "on"; }
#line 27247 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1659 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27253 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1672 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 27261 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1676 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 27269 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1680 "gram_minimal.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-2].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[0].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[0]))));
					}
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 27288 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1695 "gram_minimal.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-4].typnam);
					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 27299 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1701 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].value), (yylsp[0])); }
#line 27305 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1702 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 27311 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1703 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 27317 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1707 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27323 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1708 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 27329 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1709 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 27335 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1713 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27341 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1714 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27347 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1718 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].vsetstmt); }
#line 27353 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1720 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->type = T_PgpoolVariableSetStmt; /* Hack to keep the changes minumum */
					(yyval.node) = (Node *) n;
				}
#line 27363 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1728 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 27369 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1730 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.vsetstmt) = n;
				}
#line 27380 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1737 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.vsetstmt) = n;
				}
#line 27391 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1744 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 27402 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1754 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = (yyvsp[0].str);
					(yyval.vsetstmt) = n;
				}
#line 27413 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1761 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET_ALL;
					(yyval.vsetstmt) = n;
				}
#line 27423 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1770 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 27429 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1771 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 27435 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1776 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 27441 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1777 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 27447 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1784 "gram_minimal.y" /* yacc.c:1646  */
    {
				VariableShowStmt *n = (VariableShowStmt *)newNode(sizeof(VariableShowStmt),T_PgpoolVariableShowStmt);
				n->name = (yyvsp[0].str);
				(yyval.node) = (Node *) n;
			}
#line 27457 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1790 "gram_minimal.y" /* yacc.c:1646  */
    {
				VariableShowStmt *n = (VariableShowStmt *)newNode(sizeof(VariableShowStmt),T_PgpoolVariableShowStmt);
				n->name = "all";
				(yyval.node) = (Node *) n;
			}
#line 27467 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1796 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 27477 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1802 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
#line 27487 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1808 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
#line 27497 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1814 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
#line 27507 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1820 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "all";
					(yyval.node) = (Node *) n;
				}
#line 27517 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1830 "gram_minimal.y" /* yacc.c:1646  */
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);
					n->constraints = (yyvsp[-1].list);
					n->deferred = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 27528 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1839 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27534 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1840 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 27540 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1844 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 27546 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1845 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 27552 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1854 "gram_minimal.y" /* yacc.c:1646  */
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);
					(yyval.node) = (Node *)n;
				}
#line 27561 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1869 "gram_minimal.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
#line 27571 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1875 "gram_minimal.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 27581 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1881 "gram_minimal.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 27591 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1887 "gram_minimal.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
#line 27601 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1893 "gram_minimal.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_SEQUENCES;
					(yyval.node) = (Node *) n;
				}
#line 27611 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1912 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27624 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1921 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 27637 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1930 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->relkind = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27650 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1939 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->relkind = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 27663 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1948 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_TABLE;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 27678 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1959 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_TABLE;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 27693 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1970 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27706 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1979 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 27719 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1988 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->relkind = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27732 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1997 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_INDEX;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 27747 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 276:
#line 2008 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_INDEX;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 27762 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 277:
#line 2019 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27775 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 278:
#line 2028 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 27788 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 279:
#line 2037 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27801 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 280:
#line 2046 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 27814 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 281:
#line 2055 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_MATVIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27827 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 282:
#line 2064 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_MATVIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 27840 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 283:
#line 2073 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 27855 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 284:
#line 2084 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 27870 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 285:
#line 2097 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 27876 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 286:
#line 2098 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 27882 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 287:
#line 2104 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_AttachPartition;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = (yyvsp[0].partboundspec);
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 27898 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 288:
#line 2117 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_DetachPartition;
					cmd->name = (yyvsp[0].range);
					cmd->bound = NULL;
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 27914 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 289:
#line 2133 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_AttachPartition;
					cmd->name = (yyvsp[0].range);
					cmd->bound = NULL;
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 27930 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 290:
#line 2149 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27942 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 291:
#line 2158 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 27954 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 292:
#line 2167 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27966 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 293:
#line 2176 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 27978 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 294:
#line 2185 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[-1].str);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 27990 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 295:
#line 2194 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *)n;
				}
#line 28001 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 296:
#line 2202 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *)n;
				}
#line 28012 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 297:
#line 2210 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropExpression;
					n->name = (yyvsp[-2].str);
					(yyval.node) = (Node *)n;
				}
#line 28023 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 298:
#line 2218 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropExpression;
					n->name = (yyvsp[-4].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28035 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 299:
#line 2227 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeInteger((yyvsp[0].ival));
					(yyval.node) = (Node *)n;
				}
#line 28047 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 300:
#line 2236 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					if ((yyvsp[-3].ival) <= 0 || (yyvsp[-3].ival) > PG_INT16_MAX)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("column number must be in range from 1 to %d", PG_INT16_MAX),
								 parser_errposition((yylsp[-3]))));

					n->subtype = AT_SetStatistics;
					n->num = (int16) (yyvsp[-3].ival);
					n->def = (Node *) makeInteger((yyvsp[0].ival));
					(yyval.node) = (Node *)n;
				}
#line 28066 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 301:
#line 2252 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28078 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 302:
#line 2261 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28090 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 303:
#line 2270 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStorage;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 28102 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 304:
#line 2279 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);

					c->contype = CONSTR_IDENTITY;
					c->generated_when = (yyvsp[-3].ival);
					c->options = (yyvsp[0].list);
					c->location = (yylsp[-4]);

					n->subtype = AT_AddIdentity;
					n->name = (yyvsp[-6].str);
					n->def = (Node *) c;

					(yyval.node) = (Node *)n;
				}
#line 28122 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 305:
#line 2296 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetIdentity;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28134 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 306:
#line 2305 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-2].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28146 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 307:
#line 2314 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-4].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28158 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 308:
#line 2323 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28171 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 309:
#line 2333 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28184 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 310:
#line 2346 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = (yyvsp[0].node);
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 28202 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 311:
#line 2361 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnGenericOptions;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28214 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 312:
#line 2370 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28226 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 313:
#line 2379 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);
					n->subtype = AT_AlterConstraint;
					n->def = (Node *) c;
					c->contype = CONSTR_FOREIGN; /* others not supported, yet */
					c->conname = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "ALTER CONSTRAINT statement",
									&c->deferrable,
									&c->initdeferred,
									NULL, NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 28244 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 314:
#line 2394 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ValidateConstraint;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28255 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 315:
#line 2402 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28268 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 316:
#line 2412 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28281 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 317:
#line 2422 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOids;
					(yyval.node) = (Node *)n;
				}
#line 28291 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 318:
#line 2429 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28302 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 319:
#line 2437 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
#line 28313 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 320:
#line 2445 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetLogged;
					(yyval.node) = (Node *)n;
				}
#line 28323 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 321:
#line 2452 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetUnLogged;
					(yyval.node) = (Node *)n;
				}
#line 28333 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 322:
#line 2459 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28344 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 323:
#line 2467 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28355 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 324:
#line 2475 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28366 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 325:
#line 2483 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *)n;
				}
#line 28376 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 326:
#line 2490 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *)n;
				}
#line 28386 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 327:
#line 2497 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28397 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 328:
#line 2505 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *)n;
				}
#line 28407 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 329:
#line 2512 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *)n;
				}
#line 28417 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 330:
#line 2519 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28428 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 331:
#line 2527 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28439 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 332:
#line 2535 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28450 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 333:
#line 2543 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28461 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 334:
#line 2551 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *)n;
				}
#line 28472 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 335:
#line 2559 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *)n;
				}
#line 28483 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 336:
#line 2567 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TypeName *def = makeTypeNameFromNameList((yyvsp[0].list));
					def->location = (yylsp[0]);
					n->subtype = AT_AddOf;
					n->def = (Node *) def;
					(yyval.node) = (Node *)n;
				}
#line 28496 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 337:
#line 2577 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOf;
					(yyval.node) = (Node *)n;
				}
#line 28506 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 338:
#line 2584 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ChangeOwner;
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 28517 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 339:
#line 2592 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28528 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 340:
#line 2600 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetRelOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28539 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 341:
#line 2608 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetRelOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28550 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 342:
#line 2616 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ReplicaIdentity;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 28561 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 343:
#line 2624 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 28571 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 344:
#line 2631 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 28581 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 345:
#line 2638 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ForceRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 28591 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 346:
#line 2645 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_NoForceRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 28601 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2651 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_GenericOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 28612 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2660 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 28618 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2661 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 28624 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 350:
#line 2665 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_CASCADE; }
#line 28630 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 351:
#line 2666 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; }
#line 28636 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 352:
#line 2667 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
#line 28642 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 353:
#line 2672 "gram_minimal.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 28654 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 354:
#line 2679 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 28660 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 355:
#line 2683 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 28666 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 356:
#line 2684 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 28672 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 357:
#line 2689 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_NOTHING;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 28683 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 358:
#line 2696 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_FULL;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 28694 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 359:
#line 2703 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_DEFAULT;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 28705 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 360:
#line 2710 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_INDEX;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 28716 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 361:
#line 2719 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 28722 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2722 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 28728 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2723 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28734 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2727 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 28740 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2728 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 28746 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 366:
#line 2734 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 28754 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2738 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 28762 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2742 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-4].str), (yyvsp[-2].str), (Node *) (yyvsp[0].node),
											 DEFELEM_UNSPEC, (yylsp[-4]));
				}
#line 28771 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 369:
#line 2747 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-2].str), (yyvsp[0].str), NULL, DEFELEM_UNSPEC, (yylsp[-2]));
				}
#line 28779 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 370:
#line 2754 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 28785 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 371:
#line 2756 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 28791 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 372:
#line 2761 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 28799 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 373:
#line 2765 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[0].value), (yylsp[-2]));
				}
#line 28807 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 374:
#line 2769 "gram_minimal.y" /* yacc.c:1646  */
    {
					if (strcmp((yyvsp[0].defelt)->defname, "as") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "restart") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "owned_by") == 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("sequence option \"%s\" not supported here", (yyvsp[0].defelt)->defname),
								 parser_errposition((yylsp[0]))));
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 28822 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 375:
#line 2780 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("generated", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 28830 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 376:
#line 2788 "gram_minimal.y" /* yacc.c:1646  */
    {
					ListCell   *lc;
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_HASH;
					n->modulus = n->remainder = -1;

					foreach (lc, (yyvsp[-1].list))
					{
						DefElem    *opt = lfirst_node(DefElem, lc);

						if (strcmp(opt->defname, "modulus") == 0)
						{
							if (n->modulus != -1)
								ereport(ERROR,
										(errcode(ERRCODE_DUPLICATE_OBJECT),
										 errmsg("modulus for hash partition provided more than once"),
										 parser_errposition(opt->location)));
							n->modulus = defGetInt32(opt);
						}
						else if (strcmp(opt->defname, "remainder") == 0)
						{
							if (n->remainder != -1)
								ereport(ERROR,
										(errcode(ERRCODE_DUPLICATE_OBJECT),
										 errmsg("remainder for hash partition provided more than once"),
										 parser_errposition(opt->location)));
							n->remainder = defGetInt32(opt);
						}
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized hash partition bound specification \"%s\"",
											opt->defname),
									 parser_errposition(opt->location)));
					}

					if (n->modulus == -1)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("modulus for hash partition must be specified")));
					if (n->remainder == -1)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("remainder for hash partition must be specified")));

					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 28885 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 377:
#line 2841 "gram_minimal.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_LIST;
					n->is_default = false;
					n->listdatums = (yyvsp[-1].list);
					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 28900 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 378:
#line 2854 "gram_minimal.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_RANGE;
					n->is_default = false;
					n->lowerdatums = (yyvsp[-5].list);
					n->upperdatums = (yyvsp[-1].list);
					n->location = (yylsp[-7]);

					(yyval.partboundspec) = n;
				}
#line 28916 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 379:
#line 2868 "gram_minimal.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->is_default = true;
					n->location = (yylsp[0]);

					(yyval.partboundspec) = n;
				}
#line 28929 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 380:
#line 2880 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.defelt) = makeDefElem((yyvsp[-1].str), (Node *)makeInteger((yyvsp[0].ival)), (yylsp[-1]));
			}
#line 28937 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 381:
#line 2887 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make1((yyvsp[0].defelt));
			}
#line 28945 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 382:
#line 2891 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
			}
#line 28953 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2905 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					/* can't use qualified_name, sigh */
					n->relation = makeRangeVarFromAnyName((yyvsp[-1].list), (yylsp[-1]), yyscanner);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TYPE;
					(yyval.node) = (Node *)n;
				}
#line 28967 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 384:
#line 2917 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 28973 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2918 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 28979 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2924 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[-1].node);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 28991 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 387:
#line 2933 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29004 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 388:
#line 2943 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29017 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 389:
#line 2953 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					n->behavior = (yyvsp[0].dbehavior);
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = NULL;
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 29036 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 390:
#line 2979 "gram_minimal.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29046 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 391:
#line 2985 "gram_minimal.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = NULL;
					(yyval.node) = (Node *)n;
				}
#line 29056 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 392:
#line 3020 "gram_minimal.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = (yyvsp[-8].range);
					n->query = NULL;
					n->attlist = (yyvsp[-7].list);
					n->is_from = (yyvsp[-6].boolean);
					n->is_program = (yyvsp[-5].boolean);
					n->filename = (yyvsp[-4].str);
					n->whereClause = (yyvsp[0].node);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-3]))));

					if (!n->is_from && n->whereClause != NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("WHERE clause not allowed with COPY TO"),
								 parser_errposition((yylsp[0]))));

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[-9].defelt))
						n->options = lappend(n->options, (yyvsp[-9].defelt));
					if ((yyvsp[-3].defelt))
						n->options = lappend(n->options, (yyvsp[-3].defelt));
					if ((yyvsp[-1].list))
						n->options = list_concat(n->options, (yyvsp[-1].list));
					(yyval.node) = (Node *)n;
				}
#line 29093 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 393:
#line 3053 "gram_minimal.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = NULL;
					n->query = (yyvsp[-6].node);
					n->attlist = NIL;
					n->is_from = false;
					n->is_program = (yyvsp[-3].boolean);
					n->filename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-4]))));

					(yyval.node) = (Node *)n;
				}
#line 29116 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 394:
#line 3074 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 29122 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 395:
#line 3075 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 29128 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 396:
#line 3079 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 29134 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 397:
#line 3080 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 29140 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 398:
#line 3089 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 29146 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 399:
#line 3090 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 29152 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 400:
#line 3091 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 29158 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 401:
#line 3094 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 29164 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 402:
#line 3095 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 29170 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 403:
#line 3100 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 29176 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 404:
#line 3101 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29182 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 405:
#line 3106 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"), (yylsp[0]));
				}
#line 29190 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 406:
#line 3110 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("freeze", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 29198 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 407:
#line 3114 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 29206 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 408:
#line 3118 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("null", (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 29214 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 409:
#line 3122 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("csv"), (yylsp[0]));
				}
#line 29222 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 410:
#line 3126 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("header", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 29230 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 411:
#line 3130 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("quote", (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 29238 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 412:
#line 3134 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("escape", (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 29246 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 413:
#line 3138 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 29254 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 414:
#line 3142 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)makeNode(A_Star), (yylsp[-2]));
				}
#line 29262 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 415:
#line 3146 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *)(yyvsp[0].list), (yylsp[-3]));
				}
#line 29270 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 416:
#line 3150 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_null", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 29278 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 417:
#line 3154 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 29286 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 418:
#line 3163 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"), (yylsp[0]));
				}
#line 29294 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 419:
#line 3166 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 29300 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 420:
#line 3171 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 29308 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 421:
#line 3174 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 29314 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 422:
#line 3178 "gram_minimal.y" /* yacc.c:1646  */
    {}
#line 29320 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 423:
#line 3179 "gram_minimal.y" /* yacc.c:1646  */
    {}
#line 29326 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 424:
#line 3185 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 29334 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 425:
#line 3189 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 29342 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 426:
#line 3196 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 29350 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 427:
#line 3202 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 29356 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 428:
#line 3203 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].value); }
#line 29362 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 429:
#line 3204 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeNode(A_Star); }
#line 29368 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 430:
#line 3205 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 29374 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 431:
#line 3206 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 29380 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 432:
#line 3211 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 29388 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 433:
#line 3215 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 29396 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 434:
#line 3222 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 29402 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 435:
#line 3236 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-9].range)->relpersistence = (yyvsp[-11].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-7].list);
					n->inhRelations = (yyvsp[-5].list);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 29423 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 436:
#line 3255 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-9].range)->relpersistence = (yyvsp[-14].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-7].list);
					n->inhRelations = (yyvsp[-5].list);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 29444 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 437:
#line 3274 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-8].range)->relpersistence = (yyvsp[-10].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-6].list));
					n->ofTypename->location = (yylsp[-6]);
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 29466 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 438:
#line 3294 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-8].range)->relpersistence = (yyvsp[-13].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-6].list));
					n->ofTypename->location = (yylsp[-6]);
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 29488 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 439:
#line 3314 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-10].range)->relpersistence = (yyvsp[-12].ival);
					n->relation = (yyvsp[-10].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = list_make1((yyvsp[-7].range));
					n->partbound = (yyvsp[-5].partboundspec);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 29510 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 440:
#line 3334 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-10].range)->relpersistence = (yyvsp[-15].ival);
					n->relation = (yyvsp[-10].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = list_make1((yyvsp[-7].range));
					n->partbound = (yyvsp[-5].partboundspec);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 29532 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 441:
#line 3364 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 29538 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 442:
#line 3365 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 29544 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 443:
#line 3366 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 29550 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 444:
#line 3367 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 29556 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 445:
#line 3369 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 29567 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 446:
#line 3376 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 29578 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 447:
#line 3382 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 29584 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 448:
#line 3383 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 29590 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 449:
#line 3387 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 29596 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 450:
#line 3388 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29602 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 451:
#line 3392 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 29608 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 452:
#line 3393 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29614 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 453:
#line 3398 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 29622 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 454:
#line 3402 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 29630 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 455:
#line 3409 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 29638 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 456:
#line 3413 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 29646 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 457:
#line 3419 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 29652 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 458:
#line 3420 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 29658 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 459:
#line 3421 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 29664 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 460:
#line 3425 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 29670 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 461:
#line 3426 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 29676 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 462:
#line 3430 "gram_minimal.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-3].str);
					n->typeName = (yyvsp[-2].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					n->fdwoptions = (yyvsp[-1].list);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 29699 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 463:
#line 3451 "gram_minimal.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-1].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 29721 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 464:
#line 3469 "gram_minimal.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-3].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 29743 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 465:
#line 3489 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 29749 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 466:
#line 3490 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29755 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 467:
#line 3495 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));
					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 29766 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 468:
#line 3501 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 29772 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 469:
#line 3502 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 29778 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 470:
#line 3504 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * Note: the CollateClause is momentarily included in
					 * the list built by ColQualList, but we split it out
					 * again in SplitColQualList.
					 */
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 29795 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 471:
#line 3535 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 29806 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 472:
#line 3542 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 29817 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 473:
#line 3549 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29832 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 474:
#line 3560 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29847 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 475:
#line 3571 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->is_no_inherit = (yyvsp[0].boolean);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *)n;
				}
#line 29863 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 476:
#line 3583 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[-1]);
					n->raw_expr = (yyvsp[0].node);
					n->cooked_expr = NULL;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *)n;
				}
#line 29878 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 477:
#line 3594 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_IDENTITY;
					n->generated_when = (yyvsp[-3].ival);
					n->options = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *)n;
				}
#line 29891 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 478:
#line 3603 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_GENERATED;
					n->generated_when = (yyvsp[-5].ival);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->location = (yylsp[-6]);

					/*
					 * Can't do this in the grammar because of shift/reduce
					 * conflicts.  (IDENTITY allows both ALWAYS and BY
					 * DEFAULT, but generated columns only allow ALWAYS.)  We
					 * can also give a more useful error message and location.
					 */
					if ((yyvsp[-5].ival) != ATTRIBUTE_IDENTITY_ALWAYS)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("for a generated column, GENERATED ALWAYS must be specified"),
								 parser_errposition((yylsp[-5]))));

					(yyval.node) = (Node *)n;
				}
#line 29918 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 479:
#line 3626 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-4]);
					n->pktable			= (yyvsp[-3].range);
					n->fk_attrs			= NIL;
					n->pk_attrs			= (yyvsp[-2].list);
					n->fk_matchtype		= (yyvsp[-1].ival);
					n->fk_upd_action	= (char) ((yyvsp[0].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[0].ival) & 0xFF);
					n->skip_validation  = false;
					n->initially_valid  = true;
					(yyval.node) = (Node *)n;
				}
#line 29937 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 480:
#line 3643 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ATTRIBUTE_IDENTITY_ALWAYS; }
#line 29943 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 481:
#line 3644 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ATTRIBUTE_IDENTITY_BY_DEFAULT; }
#line 29949 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 482:
#line 3664 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 29960 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 483:
#line 3671 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 29971 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 484:
#line 3678 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 29982 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 485:
#line 3685 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 29993 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 486:
#line 3696 "gram_minimal.y" /* yacc.c:1646  */
    {
					TableLikeClause *n = makeNode(TableLikeClause);
					n->relation = (yyvsp[-1].range);
					n->options = (yyvsp[0].ival);
					(yyval.node) = (Node *)n;
				}
#line 30004 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 487:
#line 3705 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 30010 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 488:
#line 3706 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) & ~(yyvsp[0].ival); }
#line 30016 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 489:
#line 3707 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 30022 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 490:
#line 3711 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; }
#line 30028 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 491:
#line 3712 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; }
#line 30034 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 492:
#line 3713 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; }
#line 30040 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 493:
#line 3714 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_IDENTITY; }
#line 30046 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 494:
#line 3715 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_GENERATED; }
#line 30052 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 495:
#line 3716 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; }
#line 30058 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 496:
#line 3717 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_STATISTICS; }
#line 30064 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 497:
#line 3718 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; }
#line 30070 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 498:
#line 3719 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_ALL; }
#line 30076 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 499:
#line 3729 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));
					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 30087 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 500:
#line 3735 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 30093 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 501:
#line 3740 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
#line 30110 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 502:
#line 3754 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-7]);
					n->keys = (yyvsp[-5].list);
					n->including = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 30129 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 503:
#line 3769 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NIL;
					n->including = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 30148 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 504:
#line 3785 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-8]);
					n->keys = (yyvsp[-5].list);
					n->including = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 30167 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 505:
#line 3800 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NIL;
					n->including = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 30186 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 506:
#line 3817 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[-9]);
					n->access_method	= (yyvsp[-8].str);
					n->exclusions		= (yyvsp[-6].list);
					n->including		= (yyvsp[-4].list);
					n->options			= (yyvsp[-3].list);
					n->indexname		= NULL;
					n->indexspace		= (yyvsp[-2].str);
					n->where_clause		= (yyvsp[-1].node);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "EXCLUDE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 30207 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 507:
#line 3835 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-10]);
					n->pktable			= (yyvsp[-4].range);
					n->fk_attrs			= (yyvsp[-7].list);
					n->pk_attrs			= (yyvsp[-3].list);
					n->fk_matchtype		= (yyvsp[-2].ival);
					n->fk_upd_action	= (char) ((yyvsp[-1].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[-1].ival) & 0xFF);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "FOREIGN KEY",
								   &n->deferrable, &n->initdeferred,
								   &n->skip_validation, NULL,
								   yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
#line 30229 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 508:
#line 3854 "gram_minimal.y" /* yacc.c:1646  */
    {  (yyval.boolean) = true; }
#line 30235 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 509:
#line 3855 "gram_minimal.y" /* yacc.c:1646  */
    {  (yyval.boolean) = false; }
#line 30241 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 510:
#line 3859 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 30247 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 511:
#line 3860 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30253 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 512:
#line 3864 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 30259 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 513:
#line 3865 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 30265 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 514:
#line 3869 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 30273 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 515:
#line 3874 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 30279 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 516:
#line 3875 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30285 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 517:
#line 3879 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
#line 30293 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 518:
#line 3883 "gram_minimal.y" /* yacc.c:1646  */
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[-1]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
#line 30305 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 519:
#line 3891 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 30313 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 520:
#line 3895 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 30321 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 521:
#line 3901 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 30327 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 522:
#line 3903 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 30333 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 523:
#line 3907 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-2].ielem), (yyvsp[0].list));
			}
#line 30341 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 524:
#line 3912 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-5].ielem), (yyvsp[-1].list));
			}
#line 30349 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 525:
#line 3918 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 30355 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 526:
#line 3919 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 30361 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 527:
#line 3930 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[0].ival) << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
#line 30367 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 528:
#line 3932 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | ((yyvsp[0].ival) & 0xFF); }
#line 30373 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 529:
#line 3934 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[-1].ival) << 8) | ((yyvsp[0].ival) & 0xFF); }
#line 30379 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 530:
#line 3936 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[0].ival) << 8) | ((yyvsp[-1].ival) & 0xFF); }
#line 30385 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 531:
#line 3938 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
#line 30391 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 532:
#line 3941 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 30397 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 533:
#line 3944 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 30403 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 534:
#line 3948 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_NOACTION; }
#line 30409 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 535:
#line 3949 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_RESTRICT; }
#line 30415 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 536:
#line 3950 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_CASCADE; }
#line 30421 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 537:
#line 3951 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_SETNULL; }
#line 30427 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 538:
#line 3952 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_SETDEFAULT; }
#line 30433 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 539:
#line 3955 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 30439 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 540:
#line 3956 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30445 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 541:
#line 3960 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.partspec) = (yyvsp[0].partspec); }
#line 30451 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 542:
#line 3961 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.partspec) = NULL; }
#line 30457 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 543:
#line 3965 "gram_minimal.y" /* yacc.c:1646  */
    {
					PartitionSpec *n = makeNode(PartitionSpec);

					n->strategy = (yyvsp[-3].str);
					n->partParams = (yyvsp[-1].list);
					n->location = (yylsp[-5]);

					(yyval.partspec) = n;
				}
#line 30471 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 544:
#line 3976 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].partelem)); }
#line 30477 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 545:
#line 3977 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].partelem)); }
#line 30483 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 546:
#line 3981 "gram_minimal.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = (yyvsp[-2].str);
					n->expr = NULL;
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 30498 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 547:
#line 3992 "gram_minimal.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-2].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 30513 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 548:
#line 4003 "gram_minimal.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-3].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.partelem) = n;
				}
#line 30528 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 549:
#line 4016 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 30534 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 550:
#line 4017 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 30540 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 551:
#line 4022 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 30546 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 552:
#line 4023 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30552 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 553:
#line 4024 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30558 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 554:
#line 4027 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DROP; }
#line 30564 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 555:
#line 4028 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
#line 30570 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 556:
#line 4029 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
#line 30576 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 557:
#line 4030 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_NOOP; }
#line 30582 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 558:
#line 4033 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 30588 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 559:
#line 4034 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 30594 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 560:
#line 4037 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 30600 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 561:
#line 4038 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 30606 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 562:
#line 4041 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 30612 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 563:
#line 4061 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);
					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->stxcomment = NULL;
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 30627 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 564:
#line 4073 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);
					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->stxcomment = NULL;
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 30642 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 565:
#line 4096 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterStatsStmt *n = makeNode(AlterStatsStmt);
					n->defnames = (yyvsp[-3].list);
					n->missing_ok = false;
					n->stxstattarget = (yyvsp[0].ival);
					(yyval.node) = (Node *)n;
				}
#line 30654 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 566:
#line 4104 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterStatsStmt *n = makeNode(AlterStatsStmt);
					n->defnames = (yyvsp[-3].list);
					n->missing_ok = true;
					n->stxstattarget = (yyvsp[0].ival);
					(yyval.node) = (Node *)n;
				}
#line 30666 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 567:
#line 4125 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-5].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 30683 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 568:
#line 4138 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-8].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 30700 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 569:
#line 4155 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-5].range);
					(yyval.into)->colNames = (yyvsp[-4].list);
					(yyval.into)->accessMethod = (yyvsp[-3].str);
					(yyval.into)->options = (yyvsp[-2].list);
					(yyval.into)->onCommit = (yyvsp[-1].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 30716 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 570:
#line 4169 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 30722 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 571:
#line 4170 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 30728 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 572:
#line 4171 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 30734 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 573:
#line 4184 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->relkind = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-6].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 30751 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 574:
#line 4197 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->relkind = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-9].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 30768 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 575:
#line 4213 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-4].range);
					(yyval.into)->colNames = (yyvsp[-3].list);
					(yyval.into)->accessMethod = (yyvsp[-2].str);
					(yyval.into)->options = (yyvsp[-1].list);
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;		/* filled at analysis time */
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 30784 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 576:
#line 4226 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 30790 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 577:
#line 4227 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 30796 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 578:
#line 4240 "gram_minimal.y" /* yacc.c:1646  */
    {
					RefreshMatViewStmt *n = makeNode(RefreshMatViewStmt);
					n->concurrent = (yyvsp[-2].boolean);
					n->relation = (yyvsp[-1].range);
					n->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) n;
				}
#line 30808 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 579:
#line 4260 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[-1].range)->relpersistence = (yyvsp[-3].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 30822 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 580:
#line 4270 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[-1].range)->relpersistence = (yyvsp[-6].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 30836 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 581:
#line 4283 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 30848 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 582:
#line 4291 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 30860 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 583:
#line 4301 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 30866 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 584:
#line 4302 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30872 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 585:
#line 4305 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 30878 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 586:
#line 4306 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30884 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 587:
#line 4309 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 30890 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 588:
#line 4310 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 30896 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 589:
#line 4314 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[0].typnam), (yylsp[-1]));
				}
#line 30904 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 590:
#line 4318 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cache", (Node *)(yyvsp[0].value), (yylsp[-1]));
				}
#line 30912 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 591:
#line 4322 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 30920 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 592:
#line 4326 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(false), (yylsp[-1]));
				}
#line 30928 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 593:
#line 4330 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("increment", (Node *)(yyvsp[0].value), (yylsp[-2]));
				}
#line 30936 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 594:
#line 4334 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *)(yyvsp[0].value), (yylsp[-1]));
				}
#line 30944 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 595:
#line 4338 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *)(yyvsp[0].value), (yylsp[-1]));
				}
#line 30952 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 596:
#line 4342 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL, (yylsp[-1]));
				}
#line 30960 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 597:
#line 4346 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL, (yylsp[-1]));
				}
#line 30968 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 598:
#line 4350 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 30976 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 599:
#line 4354 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* not documented, only used by pg_dump */
					(yyval.defelt) = makeDefElem("sequence_name", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 30985 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 600:
#line 4359 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("start", (Node *)(yyvsp[0].value), (yylsp[-2]));
				}
#line 30993 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 601:
#line 4363 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 31001 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 602:
#line 4367 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[0].value), (yylsp[-2]));
				}
#line 31009 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 603:
#line 4372 "gram_minimal.y" /* yacc.c:1646  */
    {}
#line 31015 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 604:
#line 4373 "gram_minimal.y" /* yacc.c:1646  */
    {}
#line 31021 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 605:
#line 4377 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.value) = makeFloat((yyvsp[0].str)); }
#line 31027 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 606:
#line 4378 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.value) = makeFloat((yyvsp[0].str)); }
#line 31033 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 607:
#line 4380 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.value) = makeFloat((yyvsp[0].str));
					doNegateFloat((yyval.value));
				}
#line 31042 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 608:
#line 4384 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.value) = makeInteger((yyvsp[0].ival)); }
#line 31048 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 609:
#line 4387 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].value)); }
#line 31054 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 610:
#line 4388 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value)); }
#line 31060 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 611:
#line 4401 "gram_minimal.y" /* yacc.c:1646  */
    {
				/*
				 * We now interpret parameterless CREATE LANGUAGE as
				 * CREATE EXTENSION.  "OR REPLACE" is silently translated
				 * to "IF NOT EXISTS", which isn't quite the same, but
				 * seems more useful than throwing an error.  We just
				 * ignore TRUSTED, as the previous code would have too.
				 */
				CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
				n->if_not_exists = (yyvsp[-4].boolean);
				n->extname = (yyvsp[0].str);
				n->options = NIL;
				(yyval.node) = (Node *)n;
			}
#line 31079 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 612:
#line 4417 "gram_minimal.y" /* yacc.c:1646  */
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[-8].boolean);
				n->plname = (yyvsp[-4].str);
				n->plhandler = (yyvsp[-2].list);
				n->plinline = (yyvsp[-1].list);
				n->plvalidator = (yyvsp[0].list);
				n->pltrusted = (yyvsp[-7].boolean);
				(yyval.node) = (Node *)n;
			}
#line 31094 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 613:
#line 4430 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 31100 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 614:
#line 4431 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 31106 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 615:
#line 4439 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 31112 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 616:
#line 4440 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 31118 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 617:
#line 4444 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31124 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 618:
#line 4445 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31130 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 619:
#line 4449 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31136 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 620:
#line 4450 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31142 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 621:
#line 4454 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31148 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 622:
#line 4455 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31154 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 623:
#line 4460 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(makeString((yyvsp[-1].str)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 31168 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 624:
#line 4470 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(makeString((yyvsp[-1].str)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 31182 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 625:
#line 4482 "gram_minimal.y" /* yacc.c:1646  */
    {}
#line 31188 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 626:
#line 4483 "gram_minimal.y" /* yacc.c:1646  */
    {}
#line 31194 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 627:
#line 4494 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);
					n->tablespacename = (yyvsp[-4].str);
					n->owner = (yyvsp[-3].rolespec);
					n->location = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31207 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 628:
#line 4504 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 31213 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 629:
#line 4505 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = NULL; }
#line 31219 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 630:
#line 4519 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31230 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 631:
#line 4526 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31241 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 632:
#line 4543 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = false;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31253 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 633:
#line 4551 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = true;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31265 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 634:
#line 4562 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 31271 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 635:
#line 4564 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31277 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 636:
#line 4569 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schema", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 31285 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 637:
#line 4573 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 31293 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 638:
#line 4577 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE EXTENSION ... FROM is no longer supported"),
							 parser_errposition((yylsp[-1]))));
				}
#line 31304 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 639:
#line 4584 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cascade", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 31312 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 640:
#line 4596 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionStmt *n = makeNode(AlterExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31323 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 641:
#line 4606 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 31329 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 642:
#line 4608 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31335 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 643:
#line 4613 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 31343 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 644:
#line 4626 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_ACCESS_METHOD;
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 31356 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 645:
#line 4635 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *)n;
				}
#line 31369 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 646:
#line 4644 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-7].str);
					n->action = (yyvsp[-6].ival);
					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam));
					(yyval.node) = (Node *) n;
				}
#line 31382 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 647:
#line 4653 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31395 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 648:
#line 4662 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31408 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 649:
#line 4671 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *)n;
				}
#line 31421 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 650:
#line 4680 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *)n;
				}
#line 31434 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 651:
#line 4689 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 31447 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 652:
#line 4698 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *)n;
				}
#line 31460 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 653:
#line 4707 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *)n;
				}
#line 31473 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 654:
#line 4716 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *)n;
				}
#line 31486 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 655:
#line 4725 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *)n;
				}
#line 31499 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 656:
#line 4734 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *)n;
				}
#line 31512 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 657:
#line 4743 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_SCHEMA;
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 31525 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 658:
#line 4752 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 31538 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 659:
#line 4761 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TABLE;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31551 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 660:
#line 4770 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31564 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 661:
#line 4779 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31577 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 662:
#line 4788 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31590 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 663:
#line 4797 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31603 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 664:
#line 4806 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_SEQUENCE;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31616 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 665:
#line 4815 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_VIEW;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31629 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 666:
#line 4824 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_MATVIEW;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31642 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 667:
#line 4833 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31655 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 668:
#line 4842 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 31668 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 669:
#line 4851 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 31681 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 670:
#line 4860 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-2].typnam), makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 31694 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 671:
#line 4869 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *)n;
				}
#line 31707 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 672:
#line 4887 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);
					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31719 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 673:
#line 4897 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", (Node *)(yyvsp[0].list), (yylsp[-1])); }
#line 31725 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 674:
#line 4898 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", NULL, (yylsp[-1])); }
#line 31731 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 675:
#line 4899 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", (Node *)(yyvsp[0].list), (yylsp[-1])); }
#line 31737 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 676:
#line 4900 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", NULL, (yylsp[-1])); }
#line 31743 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 677:
#line 4904 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 31749 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 678:
#line 4905 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 31755 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 679:
#line 4909 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31761 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 680:
#line 4910 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31767 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 681:
#line 4921 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31779 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 682:
#line 4929 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[-1].str);
					n->func_options = (yyvsp[0].list);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 31791 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 683:
#line 4940 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31797 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 684:
#line 4941 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31803 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 685:
#line 4946 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 31811 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 686:
#line 4950 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 31819 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 687:
#line 4957 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31825 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 688:
#line 4962 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 31833 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 689:
#line 4966 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 31841 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 690:
#line 4973 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 31849 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 691:
#line 4977 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				}
#line 31858 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 692:
#line 4982 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				}
#line 31867 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 693:
#line 4987 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[0].str), NULL, DEFELEM_DROP, (yylsp[0]));
				}
#line 31875 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 694:
#line 4994 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 31883 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 695:
#line 5000 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31889 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 696:
#line 5005 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 31895 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 697:
#line 5017 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 31910 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 698:
#line 5029 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 31925 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 699:
#line 5042 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31931 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 700:
#line 5043 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31937 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 701:
#line 5048 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31943 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 702:
#line 5049 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31949 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 703:
#line 5053 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31955 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 704:
#line 5054 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31961 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 705:
#line 5065 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-2].str);
					n->version = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 31974 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 706:
#line 5074 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-1].str);
					n->version = (yyvsp[0].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 31986 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 707:
#line 5082 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31997 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 708:
#line 5101 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32019 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 709:
#line 5121 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32041 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 710:
#line 5141 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32064 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 711:
#line 5162 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32087 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 712:
#line 5191 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32100 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 713:
#line 5200 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 32113 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 714:
#line 5222 "gram_minimal.y" /* yacc.c:1646  */
    {
				ImportForeignSchemaStmt *n = makeNode(ImportForeignSchemaStmt);
				n->server_name = (yyvsp[-3].str);
				n->remote_schema = (yyvsp[-7].str);
				n->local_schema = (yyvsp[-1].str);
				n->list_type = (yyvsp[-6].importqual)->type;
				n->table_list = (yyvsp[-6].importqual)->table_names;
				n->options = (yyvsp[0].list);
				(yyval.node) = (Node *) n;
			}
#line 32128 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 715:
#line 5235 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = FDW_IMPORT_SCHEMA_LIMIT_TO; }
#line 32134 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 716:
#line 5236 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = FDW_IMPORT_SCHEMA_EXCEPT; }
#line 32140 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 717:
#line 5241 "gram_minimal.y" /* yacc.c:1646  */
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));
				n->type = (yyvsp[-3].ival);
				n->table_names = (yyvsp[-1].list);
				(yyval.importqual) = n;
			}
#line 32151 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 718:
#line 5248 "gram_minimal.y" /* yacc.c:1646  */
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));
				n->type = FDW_IMPORT_SCHEMA_ALL;
				n->table_names = NIL;
				(yyval.importqual) = n;
			}
#line 32162 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 719:
#line 5264 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 32175 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 720:
#line 5273 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 32188 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 721:
#line 5284 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 32194 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 722:
#line 5285 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0])); }
#line 32200 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 723:
#line 5298 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32212 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 724:
#line 5306 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32224 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 725:
#line 5323 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);
					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32236 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 726:
#line 5349 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreatePolicyStmt *n = makeNode(CreatePolicyStmt);
					n->policy_name = (yyvsp[-7].str);
					n->table = (yyvsp[-5].range);
					n->permissive = (yyvsp[-4].boolean);
					n->cmd_name = (yyvsp[-3].str);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 32252 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 727:
#line 5365 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterPolicyStmt *n = makeNode(AlterPolicyStmt);
					n->policy_name = (yyvsp[-5].str);
					n->table = (yyvsp[-3].range);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 32266 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 728:
#line 5377 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 32272 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 729:
#line 5378 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 32278 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 730:
#line 5382 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 32284 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 731:
#line 5383 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 32290 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 732:
#line 5387 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32296 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 733:
#line 5388 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeRoleSpec(ROLESPEC_PUBLIC, -1)); }
#line 32302 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 734:
#line 5392 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32308 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 735:
#line 5393 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NULL; }
#line 32314 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 736:
#line 5398 "gram_minimal.y" /* yacc.c:1646  */
    {
					if (strcmp((yyvsp[0].str), "permissive") == 0)
						(yyval.boolean) = true;
					else if (strcmp((yyvsp[0].str), "restrictive") == 0)
						(yyval.boolean) = false;
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("unrecognized row security option \"%s\"", (yyvsp[0].str)),
								 errhint("Only PERMISSIVE or RESTRICTIVE policies are supported currently."),
									 parser_errposition((yylsp[0]))));

				}
#line 32332 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 737:
#line 5411 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 32338 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 738:
#line 5415 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32344 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 739:
#line 5416 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "all"; }
#line 32350 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 740:
#line 5420 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "all"; }
#line 32356 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 741:
#line 5421 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "select"; }
#line 32362 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 742:
#line 5422 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "insert"; }
#line 32368 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 743:
#line 5423 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "update"; }
#line 32374 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 744:
#line 5424 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "delete"; }
#line 32380 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 745:
#line 5435 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateAmStmt *n = makeNode(CreateAmStmt);
					n->amname = (yyvsp[-4].str);
					n->handler_name = (yyvsp[0].list);
					n->amtype = (yyvsp[-2].chr);
					(yyval.node) = (Node *) n;
				}
#line 32392 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 746:
#line 5445 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.chr) = AMTYPE_INDEX; }
#line 32398 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 747:
#line 5446 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.chr) = AMTYPE_TABLE; }
#line 32404 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 748:
#line 5460 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-13].str);
					n->relation = (yyvsp[-9].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = (yyvsp[-7].boolean);
					n->timing = (yyvsp[-12].ival);
					n->events = intVal(linitial((yyvsp[-11].list)));
					n->columns = (List *) lsecond((yyvsp[-11].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = (yyvsp[-8].list);
					n->isconstraint  = false;
					n->deferrable	 = false;
					n->initdeferred  = false;
					n->constrrel = NULL;
					(yyval.node) = (Node *)n;
				}
#line 32427 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 749:
#line 5482 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-16].str);
					n->relation = (yyvsp[-12].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = true;
					n->timing = TRIGGER_TYPE_AFTER;
					n->events = intVal(linitial((yyvsp[-14].list)));
					n->columns = (List *) lsecond((yyvsp[-14].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = NIL;
					n->isconstraint  = true;
					processCASbits((yyvsp[-10].ival), (yylsp[-10]), "TRIGGER",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					n->constrrel = (yyvsp[-11].range);
					(yyval.node) = (Node *)n;
				}
#line 32451 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 750:
#line 5504 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_BEFORE; }
#line 32457 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 751:
#line 5505 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_AFTER; }
#line 32463 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 752:
#line 5506 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_INSTEAD; }
#line 32469 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 753:
#line 5511 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32475 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 754:
#line 5513 "gram_minimal.y" /* yacc.c:1646  */
    {
					int		events1 = intVal(linitial((yyvsp[-2].list)));
					int		events2 = intVal(linitial((yyvsp[0].list)));
					List   *columns1 = (List *) lsecond((yyvsp[-2].list));
					List   *columns2 = (List *) lsecond((yyvsp[0].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				}
#line 32498 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 755:
#line 5535 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); }
#line 32504 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 756:
#line 5537 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); }
#line 32510 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 757:
#line 5539 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); }
#line 32516 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 758:
#line 5541 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[0].list)); }
#line 32522 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 759:
#line 5543 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); }
#line 32528 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 760:
#line 5547 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32534 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 761:
#line 5548 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32540 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 762:
#line 5552 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 32546 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 763:
#line 5553 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 32552 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 764:
#line 5558 "gram_minimal.y" /* yacc.c:1646  */
    {
					TriggerTransition *n = makeNode(TriggerTransition);
					n->name = (yyvsp[0].str);
					n->isNew = (yyvsp[-3].boolean);
					n->isTable = (yyvsp[-2].boolean);
					(yyval.node) = (Node *)n;
				}
#line 32564 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 765:
#line 5568 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 32570 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 766:
#line 5569 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 32576 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 767:
#line 5573 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 32582 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 768:
#line 5582 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 32588 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 769:
#line 5586 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32594 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 770:
#line 5591 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.boolean) = (yyvsp[0].boolean);
				}
#line 32602 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 771:
#line 5595 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = false;
				}
#line 32614 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 772:
#line 5605 "gram_minimal.y" /* yacc.c:1646  */
    {}
#line 32620 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 773:
#line 5606 "gram_minimal.y" /* yacc.c:1646  */
    {}
#line 32626 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 774:
#line 5610 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 32632 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 775:
#line 5611 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 32638 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 776:
#line 5615 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 32644 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 777:
#line 5616 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 32650 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 780:
#line 5625 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].value)); }
#line 32656 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 781:
#line 5626 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value)); }
#line 32662 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 782:
#line 5627 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32668 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 783:
#line 5632 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.value) = makeString(psprintf("%d", (yyvsp[0].ival)));
				}
#line 32676 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 784:
#line 5635 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 32682 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 785:
#line 5636 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 32688 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 786:
#line 5637 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 32694 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 787:
#line 5641 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.range) = (yyvsp[0].range); }
#line 32700 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 788:
#line 5642 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.range) = NULL; }
#line 32706 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 789:
#line 5647 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 32712 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 790:
#line 5649 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * We must complain about conflicting options.
					 * We could, but choose not to, complain about redundant
					 * options (ie, where $2's bit is already set in $1).
					 */
					int		newspec = (yyvsp[-1].ival) | (yyvsp[0].ival);

					/* special message for this case */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED)) == (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[0]))));
					/* generic message for other conflicts */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE)) == (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE) ||
						(newspec & (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED)) == (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("conflicting constraint properties"),
								 parser_errposition((yylsp[0]))));
					(yyval.ival) = newspec;
				}
#line 32740 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 791:
#line 5675 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_DEFERRABLE; }
#line 32746 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 792:
#line 5676 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_DEFERRABLE; }
#line 32752 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 793:
#line 5677 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_IMMEDIATE; }
#line 32758 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 794:
#line 5678 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_DEFERRED; }
#line 32764 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 795:
#line 5679 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_VALID; }
#line 32770 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 796:
#line 5680 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NO_INHERIT; }
#line 32776 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 797:
#line 5695 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[-7].str);
					n->eventname = (yyvsp[-5].str);
					n->whenclause = NULL;
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *)n;
				}
#line 32789 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 798:
#line 5706 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[-9].str);
					n->eventname = (yyvsp[-7].str);
					n->whenclause = (yyvsp[-5].list);
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *)n;
				}
#line 32802 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 799:
#line 5718 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 32808 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 800:
#line 5720 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 32814 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 801:
#line 5725 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-4].str), (Node *) (yyvsp[-1].list), (yylsp[-4])); }
#line 32820 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 802:
#line 5730 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 32826 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 803:
#line 5732 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 32832 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 804:
#line 5737 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterEventTrigStmt *n = makeNode(AlterEventTrigStmt);
					n->trigname = (yyvsp[-1].str);
					n->tgenabled = (yyvsp[0].chr);
					(yyval.node) = (Node *) n;
				}
#line 32843 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 805:
#line 5746 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_ORIGIN; }
#line 32849 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 806:
#line 5747 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_REPLICA; }
#line 32855 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 807:
#line 5748 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ALWAYS; }
#line 32861 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 808:
#line 5749 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_DISABLED; }
#line 32867 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 809:
#line 5761 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = NULL;
				}
#line 32879 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 810:
#line 5780 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->replace = (yyvsp[-4].boolean);
					n->defnames = (yyvsp[-2].list);
					n->args = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 32894 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 811:
#line 5791 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->replace = (yyvsp[-3].boolean);
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 32910 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 812:
#line 5803 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 32924 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 813:
#line 5813 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 32938 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 814:
#line 5823 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[0].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *)n;
				}
#line 32953 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 815:
#line 5834 "gram_minimal.y" /* yacc.c:1646  */
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);

					/* can't use qualified_name, sigh */
					n->typevar = makeRangeVarFromAnyName((yyvsp[-4].list), (yylsp[-4]), yyscanner);
					n->coldeflist = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 32966 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 816:
#line 5843 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);
					n->typeName = (yyvsp[-5].list);
					n->vals = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 32977 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 817:
#line 5850 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateRangeStmt *n = makeNode(CreateRangeStmt);
					n->typeName = (yyvsp[-3].list);
					n->params	= (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 32988 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 818:
#line 5857 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33001 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 819:
#line 5866 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33014 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 820:
#line 5875 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33027 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 821:
#line 5884 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33040 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 822:
#line 5893 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33053 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 823:
#line 5902 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 33067 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 824:
#line 5912 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *)n;
				}
#line 33080 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 825:
#line 5921 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 33094 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 826:
#line 5932 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33100 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 827:
#line 5935 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 33106 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 828:
#line 5936 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 33112 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 829:
#line 5940 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 33120 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 830:
#line 5944 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 33128 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 831:
#line 5950 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].typnam); }
#line 33134 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 832:
#line 5951 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[0].keyword))); }
#line 33140 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 833:
#line 5952 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].list); }
#line 33146 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 834:
#line 5953 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].value); }
#line 33152 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 835:
#line 5954 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString((yyvsp[0].str)); }
#line 33158 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 836:
#line 5955 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[0].keyword))); }
#line 33164 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 837:
#line 5958 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33170 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 838:
#line 5961 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 33176 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 839:
#line 5962 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 33182 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 840:
#line 5971 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)(yyvsp[0].node), (yylsp[-2]));
				}
#line 33190 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 841:
#line 5977 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33196 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 842:
#line 5978 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33202 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 843:
#line 5982 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 33208 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 844:
#line 5984 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 33214 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 845:
#line 5995 "gram_minimal.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-4].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-1].boolean);
				(yyval.node) = (Node *) n;
			}
#line 33229 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 846:
#line 6006 "gram_minimal.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = false;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 33244 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 847:
#line 6017 "gram_minimal.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 33259 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 848:
#line 6028 "gram_minimal.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-5].list);
				n->oldVal = (yyvsp[-2].str);
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = false;
				n->skipIfNewValExists = false;
				(yyval.node) = (Node *) n;
			}
#line 33274 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 849:
#line 6040 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 33280 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 850:
#line 6041 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 33286 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 851:
#line 6059 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);
					n->opclassname = (yyvsp[-9].list);
					n->isDefault = (yyvsp[-8].boolean);
					n->datatype = (yyvsp[-5].typnam);
					n->amname = (yyvsp[-3].str);
					n->opfamilyname = (yyvsp[-2].list);
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33301 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 852:
#line 6072 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 33307 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 853:
#line 6073 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 33313 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 854:
#line 6078 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					ObjectWithArgs *owa = makeNode(ObjectWithArgs);
					owa->objname = (yyvsp[-2].list);
					owa->objargs = NIL;
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = owa;
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 33329 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 855:
#line 6091 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-2].objwithargs);
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 33342 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 856:
#line 6100 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-1].ival);
					(yyval.node) = (Node *) n;
				}
#line 33354 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 857:
#line 6108 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-4].ival);
					n->class_args = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 33367 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 858:
#line 6117 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 33378 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 859:
#line 6125 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 33384 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 860:
#line 6126 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 33390 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 861:
#line 6129 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33396 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 862:
#line 6130 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33402 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 863:
#line 6133 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33408 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 864:
#line 6134 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33414 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 865:
#line 6135 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33420 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 866:
#line 6139 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[0]))));
					(yyval.boolean) = true;
				}
#line 33438 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 867:
#line 6152 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 33444 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 868:
#line 6158 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);
					n->opfamilyname = (yyvsp[-2].list);
					n->amname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33455 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 869:
#line 6168 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = false;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33468 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 870:
#line 6177 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = true;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33481 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 871:
#line 6188 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 33487 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 872:
#line 6189 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 33493 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 873:
#line 6194 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 33505 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 874:
#line 6202 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 33517 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 875:
#line 6214 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 33531 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 876:
#line 6224 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 33545 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 877:
#line 6237 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 33559 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 878:
#line 6247 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 33573 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 879:
#line 6269 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);
					n->roles = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 33584 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 880:
#line 6279 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);
					n->roles = (yyvsp[-2].list);
					n->newrole = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 33595 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 881:
#line 6297 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 33609 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 882:
#line 6307 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 33623 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 883:
#line 6317 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 33637 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 884:
#line 6327 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 33651 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 885:
#line 6337 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-4].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 33665 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 886:
#line 6347 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-6].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 33679 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 887:
#line 6357 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TYPE;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 33693 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 888:
#line 6367 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TYPE;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 33707 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 889:
#line 6377 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 33721 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 890:
#line 6387 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 33735 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 891:
#line 6397 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
#line 33749 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 892:
#line 6407 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
#line 33763 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 893:
#line 6420 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 33769 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 894:
#line 6421 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 33775 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 895:
#line 6422 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 33781 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 896:
#line 6423 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 33787 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 897:
#line 6424 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 33793 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 898:
#line 6425 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 33799 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 899:
#line 6426 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLLATION; }
#line 33805 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 900:
#line 6427 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_CONVERSION; }
#line 33811 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 901:
#line 6428 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_STATISTIC_EXT; }
#line 33817 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 902:
#line 6429 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSPARSER; }
#line 33823 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 903:
#line 6430 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 33829 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 904:
#line 6431 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 33835 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 905:
#line 6432 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 33841 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 906:
#line 6437 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ACCESS_METHOD; }
#line 33847 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 907:
#line 6438 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 33853 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 908:
#line 6439 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EXTENSION; }
#line 33859 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 909:
#line 6440 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FDW; }
#line 33865 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 910:
#line 6441 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_PUBLICATION; }
#line 33871 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 911:
#line 6442 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 33877 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 912:
#line 6443 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
#line 33883 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 913:
#line 6448 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_POLICY; }
#line 33889 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 914:
#line 6449 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_RULE; }
#line 33895 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 915:
#line 6450 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TRIGGER; }
#line 33901 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 916:
#line 6454 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 33907 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 917:
#line 6455 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 33913 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 918:
#line 6458 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 33919 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 919:
#line 6459 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 33925 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 920:
#line 6463 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 33931 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 921:
#line 6465 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 33937 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 922:
#line 6469 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 33943 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 923:
#line 6470 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 33949 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 924:
#line 6482 "gram_minimal.y" /* yacc.c:1646  */
    {
					TruncateStmt *n = makeNode(TruncateStmt);
					n->relations = (yyvsp[-2].list);
					n->restart_seqs = (yyvsp[-1].boolean);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 33961 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 925:
#line 6492 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 33967 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 926:
#line 6493 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 33973 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 927:
#line 6494 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 33979 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 928:
#line 6529 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33991 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 929:
#line 6537 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34003 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 930:
#line 6545 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34015 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 931:
#line 6553 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34027 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 932:
#line 6561 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34039 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 933:
#line 6569 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34051 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 934:
#line 6577 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34063 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 935:
#line 6585 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TABCONSTRAINT;
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34075 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 936:
#line 6593 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_DOMCONSTRAINT;
					/*
					 * should use Typename not any_name in the production, but
					 * there's a shift/reduce conflict if we do that, so fix it
					 * up here.
					 */
					n->object = (Node *) list_make2(makeTypeNameFromNameList((yyvsp[-2].list)), makeString((yyvsp[-5].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34092 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 937:
#line 6606 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_POLICY;
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34104 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 938:
#line 6614 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34116 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 939:
#line 6622 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34128 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 940:
#line 6630 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34140 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 941:
#line 6638 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-4].typnam), makeString((yyvsp[-2].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34152 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 942:
#line 6646 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRIGGER;
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34164 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 943:
#line 6654 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34176 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 944:
#line 6662 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34188 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 945:
#line 6670 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].value);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34200 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 946:
#line 6678 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-5].typnam), (yyvsp[-3].typnam));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34212 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 947:
#line 6689 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLUMN; }
#line 34218 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 948:
#line 6690 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 34224 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 949:
#line 6691 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 34230 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 950:
#line 6692 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_STATISTIC_EXT; }
#line 34236 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 951:
#line 6693 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 34242 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 952:
#line 6694 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 34248 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 953:
#line 6695 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 34254 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 954:
#line 6696 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLLATION; }
#line 34260 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 955:
#line 6697 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_CONVERSION; }
#line 34266 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 956:
#line 6698 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 34272 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 957:
#line 6699 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 34278 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 958:
#line 6700 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 34284 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 959:
#line 6701 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSPARSER; }
#line 34290 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 960:
#line 6702 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 34296 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 961:
#line 6707 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ACCESS_METHOD; }
#line 34302 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 962:
#line 6708 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DATABASE; }
#line 34308 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 963:
#line 6709 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 34314 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 964:
#line 6710 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EXTENSION; }
#line 34320 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 965:
#line 6711 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FDW; }
#line 34326 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 966:
#line 6712 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_LANGUAGE; }
#line 34332 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 967:
#line 6713 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_PUBLICATION; }
#line 34338 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 968:
#line 6714 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ROLE; }
#line 34344 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 969:
#line 6715 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 34350 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 970:
#line 6716 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
#line 34356 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 971:
#line 6717 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SUBSCRIPTION; }
#line 34362 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 972:
#line 6718 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 34368 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 973:
#line 6722 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34374 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 974:
#line 6723 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 34380 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 975:
#line 6739 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34393 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 976:
#line 6749 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34406 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 977:
#line 6759 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34419 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 978:
#line 6769 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34432 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 979:
#line 6779 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34445 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 980:
#line 6789 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34458 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 981:
#line 6799 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].value);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34471 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 982:
#line 6809 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34484 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 983:
#line 6819 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34497 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 984:
#line 6829 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34503 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 985:
#line 6830 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 34509 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 986:
#line 6835 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLUMN; }
#line 34515 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 987:
#line 6836 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 34521 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 988:
#line 6837 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 34527 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 989:
#line 6838 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 34533 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 990:
#line 6839 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 34539 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 991:
#line 6840 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 34545 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 992:
#line 6845 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DATABASE; }
#line 34551 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 993:
#line 6846 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 34557 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 994:
#line 6847 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_LANGUAGE; }
#line 34563 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 995:
#line 6848 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_PUBLICATION; }
#line 34569 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 996:
#line 6849 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ROLE; }
#line 34575 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 997:
#line 6850 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 34581 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 998:
#line 6851 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SUBSCRIPTION; }
#line 34587 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 999:
#line 6852 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 34593 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1000:
#line 6855 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34599 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1001:
#line 6856 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 34605 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1002:
#line 6867 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);
					n->ismove = false;
					(yyval.node) = (Node *)n;
				}
#line 34615 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1003:
#line 6873 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);
					n->ismove = true;
					(yyval.node) = (Node *)n;
				}
#line 34625 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1004:
#line 6881 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 34637 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1005:
#line 6889 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 34649 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1006:
#line 6897 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 34661 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1007:
#line 6905 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 34673 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1008:
#line 6913 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 34685 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1009:
#line 6921 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *)n;
				}
#line 34697 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1010:
#line 6929 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 34709 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1011:
#line 6937 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 34721 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1012:
#line 6945 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 34733 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1013:
#line 6953 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 34745 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1014:
#line 6961 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 34757 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1015:
#line 6969 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 34769 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1016:
#line 6977 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 34781 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1017:
#line 6985 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 34793 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1018:
#line 6993 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 34805 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1019:
#line 7001 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 34817 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1020:
#line 7010 "gram_minimal.y" /* yacc.c:1646  */
    {}
#line 34823 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1021:
#line 7011 "gram_minimal.y" /* yacc.c:1646  */
    {}
#line 34829 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1022:
#line 7014 "gram_minimal.y" /* yacc.c:1646  */
    {}
#line 34835 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1023:
#line 7015 "gram_minimal.y" /* yacc.c:1646  */
    {}
#line 34841 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1024:
#line 7027 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 34857 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1025:
#line 7043 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 34874 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1026:
#line 7057 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 34891 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1027:
#line 7082 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34897 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1028:
#line 7084 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34903 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1029:
#line 7086 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34909 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1030:
#line 7088 "gram_minimal.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 34920 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1031:
#line 7095 "gram_minimal.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 34931 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1032:
#line 7103 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].accesspriv)); }
#line 34937 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1033:
#line 7104 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].accesspriv)); }
#line 34943 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1034:
#line 7108 "gram_minimal.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 34954 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1035:
#line 7115 "gram_minimal.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 34965 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1036:
#line 7122 "gram_minimal.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 34976 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1037:
#line 7129 "gram_minimal.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = (yyvsp[-1].str);
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 34987 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1038:
#line 7143 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 34999 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1039:
#line 7151 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35011 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1040:
#line 7159 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35023 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1041:
#line 7167 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FDW;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35035 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1042:
#line 7175 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35047 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1043:
#line 7183 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35059 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1044:
#line 7191 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_PROCEDURE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35071 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1045:
#line 7199 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_ROUTINE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35083 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1046:
#line 7207 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_DATABASE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35095 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1047:
#line 7215 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_DOMAIN;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35107 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1048:
#line 7223 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_LANGUAGE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35119 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1049:
#line 7231 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35131 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1050:
#line 7239 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_SCHEMA;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35143 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1051:
#line 7247 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35155 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1052:
#line 7255 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TYPE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35167 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1053:
#line 7263 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35179 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1054:
#line 7271 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35191 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1055:
#line 7279 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35203 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1056:
#line 7287 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_PROCEDURE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35215 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1057:
#line 7295 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_ROUTINE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35227 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1058:
#line 7306 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 35233 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1059:
#line 7307 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 35239 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1060:
#line 7311 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 35245 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1061:
#line 7312 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 35251 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1062:
#line 7317 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35257 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1063:
#line 7318 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 35263 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1064:
#line 7329 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->admin_opt = (yyvsp[-1].boolean);
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node*)n;
				}
#line 35277 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1065:
#line 7342 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node*)n;
				}
#line 35291 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1066:
#line 7352 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node*)n;
				}
#line 35305 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1067:
#line 7363 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35311 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1068:
#line 7364 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 35317 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1069:
#line 7367 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 35323 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1070:
#line 7368 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = NULL; }
#line 35329 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1071:
#line 7379 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);
					n->options = (yyvsp[-1].list);
					n->action = (GrantStmt *) (yyvsp[0].node);
					(yyval.node) = (Node*)n;
				}
#line 35340 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1072:
#line 7388 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 35346 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1073:
#line 7389 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35352 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1074:
#line 7394 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schemas", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 35360 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1075:
#line 7398 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 35368 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1076:
#line 7402 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 35376 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1077:
#line 7414 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 35392 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1078:
#line 7427 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 35409 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1079:
#line 7441 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 35426 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1080:
#line 7456 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_TABLE; }
#line 35432 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1081:
#line 7457 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_FUNCTION; }
#line 35438 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1082:
#line 7458 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_FUNCTION; }
#line 35444 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1083:
#line 7459 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_SEQUENCE; }
#line 35450 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1084:
#line 7460 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_TYPE; }
#line 35456 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1085:
#line 7461 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_SCHEMA; }
#line 35462 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1086:
#line 7476 "gram_minimal.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[-13].boolean);
					n->concurrent = (yyvsp[-11].boolean);
					n->idxname = (yyvsp[-10].str);
					n->relation = (yyvsp[-8].range);
					n->accessMethod = (yyvsp[-7].str);
					n->indexParams = (yyvsp[-5].list);
					n->indexIncludingParams = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->oldCreateSubid = InvalidSubTransactionId;
					n->oldFirstRelfilenodeSubid = InvalidSubTransactionId;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = false;
					n->reset_default_tblspc = false;
					(yyval.node) = (Node *)n;
				}
#line 35494 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1087:
#line 7506 "gram_minimal.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[-16].boolean);
					n->concurrent = (yyvsp[-14].boolean);
					n->idxname = (yyvsp[-10].str);
					n->relation = (yyvsp[-8].range);
					n->accessMethod = (yyvsp[-7].str);
					n->indexParams = (yyvsp[-5].list);
					n->indexIncludingParams = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->oldCreateSubid = InvalidSubTransactionId;
					n->oldFirstRelfilenodeSubid = InvalidSubTransactionId;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = true;
					n->reset_default_tblspc = false;
					(yyval.node) = (Node *)n;
				}
#line 35526 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1088:
#line 7536 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35532 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1089:
#line 7537 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 35538 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1090:
#line 7541 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35544 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1091:
#line 7542 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 35550 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1092:
#line 7546 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35556 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1093:
#line 7547 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 35562 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1094:
#line 7551 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35568 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1095:
#line 7552 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = DEFAULT_INDEX_TYPE; }
#line 35574 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1096:
#line 7555 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 35580 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1097:
#line 7556 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 35586 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1098:
#line 7562 "gram_minimal.y" /* yacc.c:1646  */
    {
			(yyval.ielem) = makeNode(IndexElem);
			(yyval.ielem)->name = NULL;
			(yyval.ielem)->expr = NULL;
			(yyval.ielem)->indexcolname = NULL;
			(yyval.ielem)->collation = (yyvsp[-3].list);
			(yyval.ielem)->opclass = (yyvsp[-2].list);
			(yyval.ielem)->opclassopts = NIL;
			(yyval.ielem)->ordering = (yyvsp[-1].ival);
			(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
		}
#line 35602 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1099:
#line 7574 "gram_minimal.y" /* yacc.c:1646  */
    {
			(yyval.ielem) = makeNode(IndexElem);
			(yyval.ielem)->name = NULL;
			(yyval.ielem)->expr = NULL;
			(yyval.ielem)->indexcolname = NULL;
			(yyval.ielem)->collation = (yyvsp[-4].list);
			(yyval.ielem)->opclass = (yyvsp[-3].list);
			(yyval.ielem)->opclassopts = (yyvsp[-2].list);
			(yyval.ielem)->ordering = (yyvsp[-1].ival);
			(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
		}
#line 35618 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1100:
#line 7593 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->name = (yyvsp[-1].str);
				}
#line 35627 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1101:
#line 7598 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->expr = (yyvsp[-1].node);
				}
#line 35636 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1102:
#line 7603 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->expr = (yyvsp[-2].node);
				}
#line 35645 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1103:
#line 7609 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35651 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1104:
#line 7610 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35657 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1105:
#line 7613 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 35663 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1106:
#line 7614 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 35669 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1107:
#line 7617 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35675 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1108:
#line 7618 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35681 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1109:
#line 7621 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35687 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1110:
#line 7622 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35693 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1111:
#line 7625 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_ASC; }
#line 35699 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1112:
#line 7626 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DESC; }
#line 35705 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1113:
#line 7627 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DEFAULT; }
#line 35711 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1114:
#line 7630 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_FIRST; }
#line 35717 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1115:
#line 7631 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_LAST; }
#line 35723 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1116:
#line 7632 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
#line 35729 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1117:
#line 7650 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->is_procedure = false;
					n->replace = (yyvsp[-6].boolean);
					n->funcname = (yyvsp[-4].list);
					n->parameters = (yyvsp[-3].list);
					n->returnType = (yyvsp[-1].typnam);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 35744 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1118:
#line 7662 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->is_procedure = false;
					n->replace = (yyvsp[-9].boolean);
					n->funcname = (yyvsp[-7].list);
					n->parameters = mergeTableFuncParameters((yyvsp[-6].list), (yyvsp[-2].list));
					n->returnType = TableFuncTypeName((yyvsp[-2].list));
					n->returnType->location = (yylsp[-4]);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 35760 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1119:
#line 7675 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->is_procedure = false;
					n->replace = (yyvsp[-4].boolean);
					n->funcname = (yyvsp[-2].list);
					n->parameters = (yyvsp[-1].list);
					n->returnType = NULL;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 35775 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1120:
#line 7687 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->is_procedure = true;
					n->replace = (yyvsp[-4].boolean);
					n->funcname = (yyvsp[-2].list);
					n->parameters = (yyvsp[-1].list);
					n->returnType = NULL;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 35790 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1121:
#line 7700 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35796 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1122:
#line 7701 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 35802 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1123:
#line 7704 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35808 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1124:
#line 7705 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35814 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1125:
#line 7709 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 35820 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1126:
#line 7710 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 35826 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1127:
#line 7714 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 35832 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1128:
#line 7716 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 35838 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1129:
#line 7721 "gram_minimal.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = (yyvsp[-1].list);
					n->objargs = extractArgTypes((yyvsp[0].list));
					(yyval.objwithargs) = n;
				}
#line 35849 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1130:
#line 7733 "gram_minimal.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = list_make1(makeString(pstrdup((yyvsp[0].keyword))));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 35860 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1131:
#line 7740 "gram_minimal.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = list_make1(makeString((yyvsp[0].str)));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 35871 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1132:
#line 7747 "gram_minimal.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
												  yyscanner);
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 35883 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1133:
#line 7761 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35889 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1134:
#line 7762 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35895 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1135:
#line 7766 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 35901 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1136:
#line 7768 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 35907 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1137:
#line 7783 "gram_minimal.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-2].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 35920 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1138:
#line 7792 "gram_minimal.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-2].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 35933 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1139:
#line 7801 "gram_minimal.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 35946 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1140:
#line 7810 "gram_minimal.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 35959 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1141:
#line 7819 "gram_minimal.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 35972 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1142:
#line 7830 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
#line 35978 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1143:
#line 7831 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
#line 35984 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1144:
#line 7832 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 35990 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1145:
#line 7833 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 35996 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1146:
#line 7834 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; }
#line 36002 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1148:
#line 7845 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 36014 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1149:
#line 7859 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 36020 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1150:
#line 7861 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 36030 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1151:
#line 7867 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 36041 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1152:
#line 7877 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 36049 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1153:
#line 7881 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 36058 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1154:
#line 7886 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 36067 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1155:
#line 7894 "gram_minimal.y" /* yacc.c:1646  */
    {
					if (!((yyvsp[0].fun_param)->mode == FUNC_PARAM_IN ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_VARIADIC))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("aggregates cannot have output arguments"),
								 parser_errposition((yylsp[0]))));
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 36081 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1156:
#line 7935 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NIL, makeInteger(-1));
				}
#line 36089 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1157:
#line 7939 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(-1));
				}
#line 36097 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1158:
#line 7943 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(0));
				}
#line 36105 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1159:
#line 7947 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* this is the only case requiring consistency checking */
					(yyval.list) = makeOrderedSetArgs((yyvsp[-4].list), (yyvsp[-1].list), yyscanner);
				}
#line 36114 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1160:
#line 7954 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 36120 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1161:
#line 7955 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 36126 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1162:
#line 7960 "gram_minimal.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = (yyvsp[-1].list);
					n->objargs = extractAggrArgTypes((yyvsp[0].list));
					(yyval.objwithargs) = n;
				}
#line 36137 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1163:
#line 7969 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 36143 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1164:
#line 7971 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 36149 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1165:
#line 7976 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 36155 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1166:
#line 7977 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 36161 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1167:
#line 7985 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(false), (yylsp[-3]));
				}
#line 36169 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1168:
#line 7989 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(true), (yylsp[-4]));
				}
#line 36177 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1169:
#line 7993 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 36185 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1170:
#line 7997 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("immutable"), (yylsp[0]));
				}
#line 36193 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1171:
#line 8001 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("stable"), (yylsp[0]));
				}
#line 36201 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1172:
#line 8005 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("volatile"), (yylsp[0]));
				}
#line 36209 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1173:
#line 8009 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(true), (yylsp[-2]));
				}
#line 36217 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1174:
#line 8013 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(false), (yylsp[-2]));
				}
#line 36225 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1175:
#line 8017 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(true), (yylsp[-1]));
				}
#line 36233 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1176:
#line 8021 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(false), (yylsp[-1]));
				}
#line 36241 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1177:
#line 8025 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 36249 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1178:
#line 8029 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(false), (yylsp[-1]));
				}
#line 36257 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1179:
#line 8033 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cost", (Node *)(yyvsp[0].value), (yylsp[-1]));
				}
#line 36265 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1180:
#line 8037 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rows", (Node *)(yyvsp[0].value), (yylsp[-1]));
				}
#line 36273 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1181:
#line 8041 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("support", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 36281 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1182:
#line 8045 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *)(yyvsp[0].vsetstmt), (yylsp[0]));
				}
#line 36290 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1183:
#line 8050 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("parallel", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 36298 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1184:
#line 8057 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 36306 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1185:
#line 8061 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 36314 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1186:
#line 8065 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("transform", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 36322 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1187:
#line 8069 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("window", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 36330 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1188:
#line 8073 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 36338 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1189:
#line 8078 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36344 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1190:
#line 8080 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeString((yyvsp[-2].str)), makeString((yyvsp[0].str)));
				}
#line 36352 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1191:
#line 8086 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 36358 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1192:
#line 8087 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-4].list), (yyvsp[0].typnam)); }
#line 36364 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1193:
#line 8091 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36370 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1194:
#line 8092 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36376 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1195:
#line 8096 "gram_minimal.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 36389 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1196:
#line 8108 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].fun_param));
				}
#line 36397 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1197:
#line 8112 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param));
				}
#line 36405 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1198:
#line 8127 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->objtype = OBJECT_FUNCTION;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 36417 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1199:
#line 8135 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->objtype = OBJECT_PROCEDURE;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 36429 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1200:
#line 8143 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->objtype = OBJECT_ROUTINE;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 36441 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1201:
#line 8154 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 36447 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1202:
#line 8155 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 36453 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1205:
#line 8179 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 36467 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1206:
#line 8189 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 36481 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1207:
#line 8199 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_PROCEDURE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 36495 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1208:
#line 8209 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_PROCEDURE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 36509 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1209:
#line 8219 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_ROUTINE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 36523 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1210:
#line 8229 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_ROUTINE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 36537 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1211:
#line 8242 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 36551 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1212:
#line 8252 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 36565 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1213:
#line 8265 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 36579 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1214:
#line 8275 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 36593 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1215:
#line 8288 "gram_minimal.y" /* yacc.c:1646  */
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[0]))));
				}
#line 36605 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1216:
#line 8296 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam)); }
#line 36611 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1217:
#line 8298 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, (yyvsp[-1].typnam)); }
#line 36617 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1218:
#line 8300 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), NULL); }
#line 36623 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1219:
#line 8305 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36629 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1220:
#line 8307 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-2].str)), (yyvsp[0].list)); }
#line 36635 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1221:
#line 8311 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 36641 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1222:
#line 8313 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 36647 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1223:
#line 8318 "gram_minimal.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = (yyvsp[-1].list);
					n->objargs = (yyvsp[0].list);
					(yyval.objwithargs) = n;
				}
#line 36658 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1224:
#line 8336 "gram_minimal.y" /* yacc.c:1646  */
    {
					DoStmt *n = makeNode(DoStmt);
					n->args = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 36668 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1225:
#line 8344 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 36674 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1226:
#line 8345 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 36680 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1227:
#line 8350 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *)makeString((yyvsp[0].str)), (yylsp[0]));
				}
#line 36688 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1228:
#line 8354 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 36696 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1229:
#line 8367 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-7].typnam);
					n->targettype = (yyvsp[-5].typnam);
					n->func = (yyvsp[-1].objwithargs);
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
#line 36710 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1230:
#line 8378 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
#line 36724 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1231:
#line 8389 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = true;
					(yyval.node) = (Node *)n;
				}
#line 36738 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1232:
#line 8400 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_IMPLICIT; }
#line 36744 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1233:
#line 8401 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_ASSIGNMENT; }
#line 36750 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1234:
#line 8402 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_EXPLICIT; }
#line 36756 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1235:
#line 8407 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_CAST;
					n->objects = list_make1(list_make2((yyvsp[-4].typnam), (yyvsp[-2].typnam)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-6].boolean);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 36770 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1236:
#line 8418 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 36776 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1237:
#line 8419 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36782 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1238:
#line 8430 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTransformStmt *n = makeNode(CreateTransformStmt);
					n->replace = (yyvsp[-8].boolean);
					n->type_name = (yyvsp[-5].typnam);
					n->lang = (yyvsp[-3].str);
					n->fromsql = linitial((yyvsp[-1].list));
					n->tosql = lsecond((yyvsp[-1].list));
					(yyval.node) = (Node *)n;
				}
#line 36796 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1239:
#line 8442 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-6].objwithargs), (yyvsp[0].objwithargs));
				}
#line 36804 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1240:
#line 8446 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), (yyvsp[-6].objwithargs));
				}
#line 36812 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1241:
#line 8450 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), NULL);
				}
#line 36820 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1242:
#line 8454 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[0].objwithargs));
				}
#line 36828 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1243:
#line 8461 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRANSFORM;
					n->objects = list_make1(list_make2((yyvsp[-3].typnam), makeString((yyvsp[-1].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-5].boolean);
					(yyval.node) = (Node *)n;
				}
#line 36841 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1244:
#line 8481 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-2].ival);
					n->concurrent = (yyvsp[-1].boolean);
					n->relation = (yyvsp[0].range);
					n->name = NULL;
					n->options = 0;
					(yyval.node) = (Node *)n;
				}
#line 36855 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1245:
#line 8491 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-2].ival);
					n->concurrent = (yyvsp[-1].boolean);
					n->name = (yyvsp[0].str);
					n->relation = NULL;
					n->options = 0;
					(yyval.node) = (Node *)n;
				}
#line 36869 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1246:
#line 8501 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-2].ival);
					n->concurrent = (yyvsp[-1].boolean);
					n->relation = (yyvsp[0].range);
					n->name = NULL;
					n->options = (yyvsp[-4].ival);
					(yyval.node) = (Node *)n;
				}
#line 36883 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1247:
#line 8511 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-2].ival);
					n->concurrent = (yyvsp[-1].boolean);
					n->name = (yyvsp[0].str);
					n->relation = NULL;
					n->options = (yyvsp[-4].ival);
					(yyval.node) = (Node *)n;
				}
#line 36897 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1248:
#line 8522 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_INDEX; }
#line 36903 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1249:
#line 8523 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_TABLE; }
#line 36909 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1250:
#line 8526 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_SCHEMA; }
#line 36915 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1251:
#line 8527 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_SYSTEM; }
#line 36921 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1252:
#line 8528 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_DATABASE; }
#line 36927 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1253:
#line 8531 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 36933 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1254:
#line 8532 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 36939 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1255:
#line 8535 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEXOPT_VERBOSE; }
#line 36945 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1256:
#line 8546 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = false;
					(yyval.node) = (Node *)n;
				}
#line 36958 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1257:
#line 8555 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = true;
					(yyval.node) = (Node *)n;
				}
#line 36971 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1258:
#line 8572 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36984 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1259:
#line 8581 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36997 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1260:
#line 8590 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37010 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1261:
#line 8599 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37023 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1262:
#line 8608 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37036 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1263:
#line 8617 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DOMCONSTRAINT;
					n->object = (Node *) (yyvsp[-5].list);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 37049 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1264:
#line 8626 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37062 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1265:
#line 8635 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37075 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1266:
#line 8644 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37088 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1267:
#line 8653 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37101 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1268:
#line 8662 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37114 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1269:
#line 8671 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37127 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1270:
#line 8680 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37141 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1271:
#line 8690 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 37155 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1272:
#line 8700 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37168 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1273:
#line 8709 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37181 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1274:
#line 8718 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37194 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1275:
#line 8727 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37207 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1276:
#line 8736 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37220 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1277:
#line 8745 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37233 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1278:
#line 8754 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37247 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1279:
#line 8764 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 37261 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1280:
#line 8774 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37275 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1281:
#line 8784 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 37289 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1282:
#line 8794 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37303 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1283:
#line 8804 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 37317 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1284:
#line 8814 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37331 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1285:
#line 8824 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 37345 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1286:
#line 8834 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37359 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1287:
#line 8844 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 37373 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1288:
#line 8854 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37387 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1289:
#line 8864 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 37401 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1290:
#line 8874 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37416 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1291:
#line 8885 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 37431 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1292:
#line 8896 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_VIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37446 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1293:
#line 8907 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_VIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 37461 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1294:
#line 8918 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37476 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1295:
#line 8929 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 37491 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1296:
#line 8940 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37505 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1297:
#line 8950 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 37519 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1298:
#line 8960 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37534 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1299:
#line 8971 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 37549 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1300:
#line 8982 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_RULE;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37563 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1301:
#line 8992 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37577 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1302:
#line 9002 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 37589 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1303:
#line 9010 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37602 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1304:
#line 9019 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37615 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1305:
#line 9028 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37628 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1306:
#line 9037 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37641 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1307:
#line 9046 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37654 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1308:
#line 9055 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37667 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1309:
#line 9064 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37680 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1310:
#line 9073 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37693 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1311:
#line 9082 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37706 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1312:
#line 9091 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ATTRIBUTE;
					n->relationType = OBJECT_TYPE;
					n->relation = makeRangeVarFromAnyName((yyvsp[-6].list), (yylsp[-6]), yyscanner);
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37722 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1313:
#line 9104 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = COLUMN; }
#line 37728 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1314:
#line 9105 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 37734 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1315:
#line 9108 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 1; }
#line 37740 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1316:
#line 9109 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 37746 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1317:
#line 9120 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *)n;
				}
#line 37759 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1318:
#line 9129 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *)n;
				}
#line 37772 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1319:
#line 9138 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *)n;
				}
#line 37785 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1320:
#line 9147 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-5].range);
					n->object = (Node *) list_make1(makeString((yyvsp[-7].str)));
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *)n;
				}
#line 37799 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1321:
#line 9157 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *)n;
				}
#line 37812 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1322:
#line 9166 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_INDEX;
					n->relation = (yyvsp[-5].range);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *)n;
				}
#line 37825 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1323:
#line 9176 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 37831 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1324:
#line 9177 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false;	}
#line 37837 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1325:
#line 9188 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37850 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1326:
#line 9197 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37863 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1327:
#line 9206 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37876 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1328:
#line 9215 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37889 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1329:
#line 9224 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_EXTENSION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37902 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1330:
#line 9233 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37915 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1331:
#line 9242 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37928 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1332:
#line 9251 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37941 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1333:
#line 9260 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37954 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1334:
#line 9269 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37967 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1335:
#line 9278 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37980 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1336:
#line 9287 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37993 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1337:
#line 9296 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38006 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1338:
#line 9305 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38019 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1339:
#line 9314 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38032 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1340:
#line 9323 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38045 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1341:
#line 9332 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38058 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1342:
#line 9341 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38071 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1343:
#line 9350 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38084 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1344:
#line 9359 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38097 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1345:
#line 9368 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38110 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1346:
#line 9377 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38123 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1347:
#line 9386 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38136 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1348:
#line 9395 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38149 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1349:
#line 9404 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38162 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1350:
#line 9413 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38175 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1351:
#line 9422 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38188 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1352:
#line 9440 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOperatorStmt *n = makeNode(AlterOperatorStmt);
					n->opername = (yyvsp[-4].objwithargs);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 38199 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1353:
#line 9448 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 38205 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1354:
#line 9449 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 38211 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1355:
#line 9453 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2])); }
#line 38217 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1356:
#line 9455 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2])); }
#line 38223 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1357:
#line 9460 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].typnam); }
#line 38229 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1358:
#line 9461 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[0].keyword))); }
#line 38235 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1359:
#line 9462 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].list); }
#line 38241 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1360:
#line 9463 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].value); }
#line 38247 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1361:
#line 9464 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString((yyvsp[0].str)); }
#line 38253 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1362:
#line 9477 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTypeStmt *n = makeNode(AlterTypeStmt);
					n->typeName = (yyvsp[-4].list);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 38264 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1363:
#line 9492 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38276 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1364:
#line 9500 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38288 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1365:
#line 9508 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38300 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1366:
#line 9516 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38312 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1367:
#line 9524 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38324 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1368:
#line 9532 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38336 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1369:
#line 9540 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38348 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1370:
#line 9548 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-3].value);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38360 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1371:
#line 9556 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38372 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1372:
#line 9564 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38384 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1373:
#line 9572 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38396 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1374:
#line 9580 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38408 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1375:
#line 9588 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38420 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1376:
#line 9596 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38432 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1377:
#line 9604 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38444 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1378:
#line 9612 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TABLESPACE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38456 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1379:
#line 9620 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38468 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1380:
#line 9628 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38480 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1381:
#line 9636 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38492 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1382:
#line 9644 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38504 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1383:
#line 9652 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38516 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1384:
#line 9660 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38528 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1385:
#line 9668 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38540 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1386:
#line 9676 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 38552 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1387:
#line 9694 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);
					n->pubname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					if ((yyvsp[-1].node) != NULL)
					{
						/* FOR TABLE */
						if (IsA((yyvsp[-1].node), List))
							n->tables = (List *)(yyvsp[-1].node);
						/* FOR ALL TABLES */
						else
							n->for_all_tables = true;
					}
					(yyval.node) = (Node *)n;
				}
#line 38572 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1388:
#line 9712 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 38578 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1389:
#line 9713 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 38584 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1390:
#line 9718 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) (yyvsp[0].list);
				}
#line 38592 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1391:
#line 9722 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeInteger(true);
				}
#line 38600 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1392:
#line 9742 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);
					n->pubname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 38611 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1393:
#line 9749 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);
					n->pubname = (yyvsp[-3].str);
					n->tables = (yyvsp[0].list);
					n->tableAction = DEFELEM_ADD;
					(yyval.node) = (Node *)n;
				}
#line 38623 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1394:
#line 9757 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);
					n->pubname = (yyvsp[-3].str);
					n->tables = (yyvsp[0].list);
					n->tableAction = DEFELEM_SET;
					(yyval.node) = (Node *)n;
				}
#line 38635 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1395:
#line 9765 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);
					n->pubname = (yyvsp[-3].str);
					n->tables = (yyvsp[0].list);
					n->tableAction = DEFELEM_DROP;
					(yyval.node) = (Node *)n;
				}
#line 38647 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1396:
#line 9782 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateSubscriptionStmt *n =
						makeNode(CreateSubscriptionStmt);
					n->subname = (yyvsp[-5].str);
					n->conninfo = (yyvsp[-3].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 38661 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1397:
#line 9795 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].value));
				}
#line 38669 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1398:
#line 9799 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value));
				}
#line 38677 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1399:
#line 9805 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 38683 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1400:
#line 9815 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_OPTIONS;
					n->subname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 38696 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1401:
#line 9824 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_CONNECTION;
					n->subname = (yyvsp[-2].str);
					n->conninfo = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 38709 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1402:
#line 9833 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_REFRESH;
					n->subname = (yyvsp[-3].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 38722 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1403:
#line 9842 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 38736 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1404:
#line 9852 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *)makeInteger(true), (yylsp[-3])));
					(yyval.node) = (Node *)n;
				}
#line 38750 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1405:
#line 9862 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *)makeInteger(false), (yylsp[-3])));
					(yyval.node) = (Node *)n;
				}
#line 38764 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1406:
#line 9880 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);
					n->subname = (yyvsp[-1].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 38776 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1407:
#line 9888 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);
					n->subname = (yyvsp[-1].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 38788 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1408:
#line 9906 "gram_minimal.y" /* yacc.c:1646  */
    {
					RuleStmt *n = makeNode(RuleStmt);
					n->replace = (yyvsp[-11].boolean);
					n->relation = (yyvsp[-4].range);
					n->rulename = (yyvsp[-9].str);
					n->whereClause = (yyvsp[-3].node);
					n->event = (yyvsp[-6].ival);
					n->instead = (yyvsp[-1].boolean);
					n->actions = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 38804 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1409:
#line 9920 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 38810 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1410:
#line 9921 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 38816 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1411:
#line 9922 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 38822 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1412:
#line 9928 "gram_minimal.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				  else
					(yyval.list) = (yyvsp[-2].list);
				}
#line 38832 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1413:
#line 9934 "gram_minimal.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = list_make1((yyvsp[0].node));
				  else
					(yyval.list) = NIL;
				}
#line 38842 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1419:
#line 9950 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 38848 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1420:
#line 9951 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 38854 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1421:
#line 9954 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_SELECT; }
#line 38860 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1422:
#line 9955 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_UPDATE; }
#line 38866 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1423:
#line 9956 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_DELETE; }
#line 38872 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1424:
#line 9957 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_INSERT; }
#line 38878 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1425:
#line 9961 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 38884 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1426:
#line 9962 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 38890 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1427:
#line 9963 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 38896 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1428:
#line 9976 "gram_minimal.y" /* yacc.c:1646  */
    {
					NotifyStmt *n = makeNode(NotifyStmt);
					n->conditionname = (yyvsp[-1].str);
					n->payload = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 38907 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1429:
#line 9985 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 38913 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1430:
#line 9986 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 38919 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1431:
#line 9990 "gram_minimal.y" /* yacc.c:1646  */
    {
					ListenStmt *n = makeNode(ListenStmt);
					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 38929 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1432:
#line 9999 "gram_minimal.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 38939 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1433:
#line 10005 "gram_minimal.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = NULL;
					(yyval.node) = (Node *)n;
				}
#line 38949 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1434:
#line 10024 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 38961 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1435:
#line 10032 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 38972 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1436:
#line 10039 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 38983 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1437:
#line 10046 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 38995 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1438:
#line 10054 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 39007 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1439:
#line 10062 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 39019 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1440:
#line 10070 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_SAVEPOINT;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39030 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1441:
#line 10077 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39041 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1442:
#line 10084 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39052 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1443:
#line 10091 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39063 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1444:
#line 10098 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39074 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1445:
#line 10105 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39085 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1446:
#line 10112 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39096 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1447:
#line 10119 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39107 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1448:
#line 10127 "gram_minimal.y" /* yacc.c:1646  */
    {}
#line 39113 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1449:
#line 10128 "gram_minimal.y" /* yacc.c:1646  */
    {}
#line 39119 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1450:
#line 10129 "gram_minimal.y" /* yacc.c:1646  */
    {}
#line 39125 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1451:
#line 10134 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[0].str), (yylsp[0])), (yylsp[-2])); }
#line 39132 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1452:
#line 10137 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(true, (yylsp[-1])), (yylsp[-1])); }
#line 39139 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1453:
#line 10140 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(false, (yylsp[-1])), (yylsp[-1])); }
#line 39146 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1454:
#line 10143 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(true, (yylsp[0])), (yylsp[0])); }
#line 39153 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1455:
#line 10146 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(false, (yylsp[-1])), (yylsp[-1])); }
#line 39160 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1456:
#line 10153 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 39166 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1457:
#line 10155 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 39172 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1458:
#line 10157 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 39178 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1460:
#line 10163 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 39184 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1461:
#line 10167 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 39190 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1462:
#line 10168 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 39196 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1463:
#line 10169 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 39202 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1464:
#line 10183 "gram_minimal.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 39218 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1465:
#line 10196 "gram_minimal.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 39234 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1466:
#line 10209 "gram_minimal.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 39255 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1467:
#line 10227 "gram_minimal.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 39276 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1468:
#line 10246 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 39282 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1469:
#line 10247 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 39288 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1470:
#line 10248 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LOCAL_CHECK_OPTION; }
#line 39294 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1471:
#line 10249 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = NO_CHECK_OPTION; }
#line 39300 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1472:
#line 10260 "gram_minimal.y" /* yacc.c:1646  */
    {
					LoadStmt *n = makeNode(LoadStmt);
					n->filename = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39310 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1473:
#line 10276 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);
					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 39321 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1474:
#line 10285 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 39327 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1475:
#line 10286 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 39333 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1476:
#line 10290 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 39339 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1477:
#line 10291 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 39345 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1478:
#line 10296 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 39353 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1479:
#line 10300 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 39361 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1480:
#line 10304 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2]));
				}
#line 39369 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1481:
#line 10321 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 39375 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1482:
#line 10322 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup("connection_limit"); }
#line 39381 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1483:
#line 10323 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 39387 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1484:
#line 10324 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 39393 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1485:
#line 10325 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 39399 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1486:
#line 10326 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 39405 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1487:
#line 10327 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 39411 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1488:
#line 10334 "gram_minimal.y" /* yacc.c:1646  */
    {}
#line 39417 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1489:
#line 10335 "gram_minimal.y" /* yacc.c:1646  */
    {}
#line 39423 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1490:
#line 10347 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 39434 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1491:
#line 10354 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 39445 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1492:
#line 10361 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-3].str);
					n->options = list_make1(makeDefElem("tablespace",
														(Node *)makeString((yyvsp[0].str)), (yylsp[0])));
					(yyval.node) = (Node *)n;
				 }
#line 39457 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1493:
#line 10372 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);
					n->dbname = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 39468 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1494:
#line 10389 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[0].str);
					n->missing_ok = false;
					n->options = NULL;
					(yyval.node) = (Node *)n;
				}
#line 39480 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1495:
#line 10397 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[0].str);
					n->missing_ok = true;
					n->options = NULL;
					(yyval.node) = (Node *)n;
				}
#line 39492 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1496:
#line 10405 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[-4].str);
					n->missing_ok = false;
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 39504 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1497:
#line 10413 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[-4].str);
					n->missing_ok = true;
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 39516 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1498:
#line 10424 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((Node *) (yyvsp[0].defelt));
				}
#line 39524 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1499:
#line 10428 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (Node *) (yyvsp[0].defelt));
				}
#line 39532 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1500:
#line 10439 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force", NULL, (yylsp[0]));
				}
#line 39540 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1501:
#line 10451 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterCollationStmt *n = makeNode(AlterCollationStmt);
					n->collname = (yyvsp[-2].list);
					(yyval.node) = (Node *)n;
				}
#line 39550 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1502:
#line 10468 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 39560 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1503:
#line 10474 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 39570 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1504:
#line 10490 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);
					n->domainname = (yyvsp[-3].list);
					n->typeName = (yyvsp[-1].typnam);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 39583 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1505:
#line 10503 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'T';
					n->typeName = (yyvsp[-1].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 39595 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1506:
#line 10512 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'N';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *)n;
				}
#line 39606 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1507:
#line 10520 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'O';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *)n;
				}
#line 39617 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1508:
#line 10528 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'C';
					n->typeName = (yyvsp[-2].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 39629 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1509:
#line 10537 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[-4].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39643 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1510:
#line 10548 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[-6].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 39657 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1511:
#line 10559 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'V';
					n->typeName = (yyvsp[-3].list);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39669 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1512:
#line 10568 "gram_minimal.y" /* yacc.c:1646  */
    {}
#line 39675 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1513:
#line 10569 "gram_minimal.y" /* yacc.c:1646  */
    {}
#line 39681 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1514:
#line 10581 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);
					n->dictname = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 39692 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1515:
#line 10591 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_ADD_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
#line 39707 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1516:
#line 10602 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_ALTER_MAPPING_FOR_TOKEN;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
#line 39722 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1517:
#line 10613 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_REPLACE_DICT;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
#line 39737 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1518:
#line 10624 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_REPLACE_DICT_FOR_TOKEN;
					n->cfgname = (yyvsp[-8].list);
					n->tokentype = (yyvsp[-4].list);
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
#line 39752 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1519:
#line 10635 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-4].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node*)n;
				}
#line 39765 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1520:
#line 10644 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node*)n;
				}
#line 39778 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1521:
#line 10655 "gram_minimal.y" /* yacc.c:1646  */
    {}
#line 39784 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1522:
#line 10656 "gram_minimal.y" /* yacc.c:1646  */
    {}
#line 39790 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1523:
#line 10672 "gram_minimal.y" /* yacc.c:1646  */
    {
				CreateConversionStmt *n = makeNode(CreateConversionStmt);
				n->conversion_name = (yyvsp[-6].list);
				n->for_encoding_name = (yyvsp[-4].str);
				n->to_encoding_name = (yyvsp[-2].str);
				n->func_name = (yyvsp[0].list);
				n->def = (yyvsp[-8].boolean);
				(yyval.node) = (Node *)n;
			}
#line 39804 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1524:
#line 10694 "gram_minimal.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->options = 0;
					if ((yyvsp[-2].boolean))
						n->options |= CLUOPT_VERBOSE;
					(yyval.node) = (Node*)n;
				}
#line 39818 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1525:
#line 10704 "gram_minimal.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = NULL;
					n->indexname = NULL;
					n->options = 0;
					if ((yyvsp[0].boolean))
						n->options |= CLUOPT_VERBOSE;
					(yyval.node) = (Node*)n;
				}
#line 39832 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1526:
#line 10715 "gram_minimal.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[0].range);
					n->indexname = (yyvsp[-2].str);
					n->options = 0;
					if ((yyvsp[-3].boolean))
						n->options |= CLUOPT_VERBOSE;
					(yyval.node) = (Node*)n;
				}
#line 39846 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1527:
#line 10727 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 39852 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1528:
#line 10728 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 39858 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1529:
#line 10741 "gram_minimal.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = NIL;
					if ((yyvsp[-4].boolean))
						n->options = lappend(n->options,
											 makeDefElem("full", NULL, (yylsp[-4])));
					if ((yyvsp[-3].boolean))
						n->options = lappend(n->options,
											 makeDefElem("freeze", NULL, (yylsp[-3])));
					if ((yyvsp[-2].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-2])));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("analyze", NULL, (yylsp[-1])));
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = true;
					(yyval.node) = (Node *)n;
				}
#line 39882 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1530:
#line 10761 "gram_minimal.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = (yyvsp[-2].list);
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = true;
					(yyval.node) = (Node *) n;
				}
#line 39894 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1531:
#line 10771 "gram_minimal.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = NIL;
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-1])));
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = false;
					(yyval.node) = (Node *)n;
				}
#line 39909 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1532:
#line 10782 "gram_minimal.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = (yyvsp[-2].list);
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = false;
					(yyval.node) = (Node *) n;
				}
#line 39921 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1533:
#line 10793 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 39929 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1534:
#line 10797 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 39937 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1535:
#line 10803 "gram_minimal.y" /* yacc.c:1646  */
    {}
#line 39943 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1536:
#line 10804 "gram_minimal.y" /* yacc.c:1646  */
    {}
#line 39949 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1537:
#line 10809 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 39957 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1538:
#line 10815 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 39963 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1539:
#line 10816 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "analyze"; }
#line 39969 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1540:
#line 10820 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 39975 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1541:
#line 10821 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].value); }
#line 39981 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1542:
#line 10822 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 39987 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1543:
#line 10826 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 39993 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1544:
#line 10827 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 39999 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1545:
#line 10831 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 40005 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1546:
#line 10832 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 40011 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1547:
#line 10835 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 40017 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1548:
#line 10836 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 40023 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1549:
#line 10839 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 40029 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1550:
#line 10840 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 40035 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1551:
#line 10844 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 40041 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1552:
#line 10845 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40047 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1553:
#line 10850 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeVacuumRelation((yyvsp[-1].range), InvalidOid, (yyvsp[0].list));
				}
#line 40055 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1554:
#line 10857 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 40061 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1555:
#line 10859 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 40067 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1556:
#line 10863 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 40073 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1557:
#line 10864 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40079 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1558:
#line 10878 "gram_minimal.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 40090 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1559:
#line 10885 "gram_minimal.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("analyze", NULL, (yylsp[-2])));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 40104 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1560:
#line 10895 "gram_minimal.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 40115 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1561:
#line 10902 "gram_minimal.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 40126 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1571:
#line 10924 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 40134 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1572:
#line 10928 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 40142 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1573:
#line 10935 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 40150 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1574:
#line 10941 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40156 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1575:
#line 10942 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "analyze"; }
#line 40162 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1576:
#line 10946 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 40168 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1577:
#line 10947 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].value); }
#line 40174 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1578:
#line 10948 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 40180 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1579:
#line 10959 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrepareStmt *n = makeNode(PrepareStmt);
					n->name = (yyvsp[-3].str);
					n->argtypes = (yyvsp[-2].list);
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 40192 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1580:
#line 10968 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 40198 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1581:
#line 10969 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40204 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1586:
#line 10987 "gram_minimal.y" /* yacc.c:1646  */
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-1].str);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 40215 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1587:
#line 10995 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-7].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 40235 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1588:
#line 11012 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-10].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 40255 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1589:
#line 11029 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 40261 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1590:
#line 11030 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40267 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1591:
#line 11041 "gram_minimal.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 40277 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1592:
#line 11047 "gram_minimal.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 40287 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1593:
#line 11053 "gram_minimal.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 40297 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1594:
#line 11059 "gram_minimal.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 40307 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1595:
#line 11076 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].istmt)->relation = (yyvsp[-3].range);
					(yyvsp[-2].istmt)->onConflictClause = (yyvsp[-1].onconflict);
					(yyvsp[-2].istmt)->returningList = (yyvsp[0].list);
					(yyvsp[-2].istmt)->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *) (yyvsp[-2].istmt);
				}
#line 40319 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1596:
#line 11086 "gram_minimal.y" /* yacc.c:1646  */
    {
				InsertStmt *insert = makeNode(InsertStmt);
				insert->relation = (yyvsp[0].range);
				(yyval.node) = (Node *) insert;
				/*
				 * Assign the node directly to the parsetree and exit the scanner
				 * we don't want to keep parsing for information we don't need
				 */
				pg_yyget_extra(yyscanner)->parsetree = list_make1(makeRawStmt((yyval.node), 0));
				YYACCEPT;
			}
#line 40335 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1597:
#line 11107 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 40343 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1598:
#line 11111 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].range)->alias = makeAlias((yyvsp[0].str), NIL);
					(yyval.range) = (yyvsp[-2].range);
				}
#line 40352 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1599:
#line 11119 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 40362 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1600:
#line 11125 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 40373 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1601:
#line 11132 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-2].list);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 40383 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1602:
#line 11138 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-5].list);
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 40394 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1603:
#line 11145 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
#line 40404 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1604:
#line 11153 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OVERRIDING_USER_VALUE; }
#line 40410 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1605:
#line 11154 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OVERRIDING_SYSTEM_VALUE; }
#line 40416 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1606:
#line 11159 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 40422 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1607:
#line 11161 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 40428 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1608:
#line 11166 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[-1]);
				}
#line 40440 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1609:
#line 11177 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_UPDATE;
					(yyval.onconflict)->infer = (yyvsp[-5].infer);
					(yyval.onconflict)->targetList = (yyvsp[-1].list);
					(yyval.onconflict)->whereClause = (yyvsp[0].node);
					(yyval.onconflict)->location = (yylsp[-7]);
				}
#line 40453 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1610:
#line 11187 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_NOTHING;
					(yyval.onconflict)->infer = (yyvsp[-2].infer);
					(yyval.onconflict)->targetList = NIL;
					(yyval.onconflict)->whereClause = NULL;
					(yyval.onconflict)->location = (yylsp[-4]);
				}
#line 40466 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1611:
#line 11196 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = NULL;
				}
#line 40474 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1612:
#line 11203 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = (yyvsp[-2].list);
					(yyval.infer)->whereClause = (yyvsp[0].node);
					(yyval.infer)->conname = NULL;
					(yyval.infer)->location = (yylsp[-3]);
				}
#line 40486 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1613:
#line 11212 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = NIL;
					(yyval.infer)->whereClause = NULL;
					(yyval.infer)->conname = (yyvsp[0].str);
					(yyval.infer)->location = (yylsp[-2]);
				}
#line 40498 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1614:
#line 11220 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.infer) = NULL;
				}
#line 40506 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1615:
#line 11226 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 40512 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1616:
#line 11227 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40518 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1617:
#line 11240 "gram_minimal.y" /* yacc.c:1646  */
    {
					DeleteStmt *n = makeNode(DeleteStmt);
					n->relation = (yyvsp[-3].range);
					n->usingClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *)n;
				}
#line 40532 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1618:
#line 11252 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 40538 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1619:
#line 11253 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40544 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1620:
#line 11265 "gram_minimal.y" /* yacc.c:1646  */
    {
					LockStmt *n = makeNode(LockStmt);

					n->relations = (yyvsp[-2].list);
					n->mode = (yyvsp[-1].ival);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 40557 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1621:
#line 11275 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival); }
#line 40563 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1622:
#line 11276 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 40569 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1623:
#line 11279 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessShareLock; }
#line 40575 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1624:
#line 11280 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RowShareLock; }
#line 40581 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1625:
#line 11281 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RowExclusiveLock; }
#line 40587 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1626:
#line 11282 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareUpdateExclusiveLock; }
#line 40593 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1627:
#line 11283 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareLock; }
#line 40599 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1628:
#line 11284 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareRowExclusiveLock; }
#line 40605 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1629:
#line 11285 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ExclusiveLock; }
#line 40611 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1630:
#line 11286 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 40617 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1631:
#line 11289 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 40623 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1632:
#line 11290 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 40629 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1633:
#line 11294 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitError; }
#line 40635 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1634:
#line 11295 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitSkip; }
#line 40641 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1635:
#line 11296 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitBlock; }
#line 40647 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1636:
#line 11312 "gram_minimal.y" /* yacc.c:1646  */
    {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[-5].range);
					n->targetList = (yyvsp[-3].list);
					n->fromClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-7].with);
					(yyval.node) = (Node *)n;
				}
#line 40662 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1637:
#line 11324 "gram_minimal.y" /* yacc.c:1646  */
    {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[0].range);
					n->targetList = NULL;
					n->fromClause = NULL;
					n->whereClause = NULL;
					n->returningList = NULL;
					n->withClause = (yyvsp[-2].with);
					(yyval.node) = (Node *)n;
					pg_yyget_extra(yyscanner)->parsetree = list_make1(makeRawStmt((yyval.node), 0));
					YYACCEPT;
				}
#line 40679 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1638:
#line 11338 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 40685 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1639:
#line 11339 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_concat((yyvsp[-2].list),(yyvsp[0].list)); }
#line 40691 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1640:
#line 11344 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].target)->val = (Node *) (yyvsp[0].node);
					(yyval.list) = list_make1((yyvsp[-2].target));
				}
#line 40700 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1641:
#line 11349 "gram_minimal.y" /* yacc.c:1646  */
    {
					int ncolumns = list_length((yyvsp[-3].list));
					int i = 1;
					ListCell *col_cell;

					/* Create a MultiAssignRef source for each target */
					foreach(col_cell, (yyvsp[-3].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						MultiAssignRef *r = makeNode(MultiAssignRef);

						r->source = (Node *) (yyvsp[0].node);
						r->colno = i;
						r->ncolumns = ncolumns;
						res_col->val = (Node *) r;
						i++;
					}

					(yyval.list) = (yyvsp[-3].list);
				}
#line 40725 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1642:
#line 11373 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[-1]);
				}
#line 40737 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1643:
#line 11383 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 40743 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1644:
#line 11384 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].target)); }
#line 40749 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1645:
#line 11395 "gram_minimal.y" /* yacc.c:1646  */
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);
					n->portalname = (yyvsp[-5].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[-4].ival) | (yyvsp[-2].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 40762 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1646:
#line 11405 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40768 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1647:
#line 11408 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 40774 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1648:
#line 11409 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | CURSOR_OPT_NO_SCROLL; }
#line 40780 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1649:
#line 11410 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_SCROLL; }
#line 40786 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1650:
#line 11411 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_BINARY; }
#line 40792 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1651:
#line 11412 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_INSENSITIVE; }
#line 40798 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1652:
#line 11415 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 40804 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1653:
#line 11416 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CURSOR_OPT_HOLD; }
#line 40810 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1654:
#line 11417 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 40816 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1657:
#line 11470 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 40822 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1658:
#line 11471 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 40828 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1659:
#line 11486 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 40834 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1660:
#line 11488 "gram_minimal.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 40845 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1661:
#line 11495 "gram_minimal.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										(yyvsp[0].selectlimit),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 40857 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1662:
#line 11503 "gram_minimal.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										(yyvsp[-1].selectlimit),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 40869 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1663:
#line 11511 "gram_minimal.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[0].node), NULL, NIL,
										NULL,
										(yyvsp[-1].with),
										yyscanner);
					(yyval.node) = (yyvsp[0].node);
				}
#line 40881 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1664:
#line 11519 "gram_minimal.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL,
										(yyvsp[-2].with),
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 40893 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1665:
#line 11527 "gram_minimal.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										(yyvsp[0].selectlimit),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 40905 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1666:
#line 11535 "gram_minimal.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										(yyvsp[-1].selectlimit),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 40917 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1667:
#line 11545 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 40923 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1668:
#line 11546 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 40929 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1669:
#line 11576 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = (yyvsp[-2].list);
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 40945 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1670:
#line 11590 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->distinctClause = (yyvsp[-7].list);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = (yyvsp[-2].list);
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 40962 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1671:
#line 11602 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 40968 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1672:
#line 11604 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef *cr = makeNode(ColumnRef);
					ResTarget *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *)cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[0].range));
					(yyval.node) = (Node *)n;
				}
#line 40991 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1673:
#line 11623 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 40999 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1674:
#line 11627 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 41007 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1675:
#line 11631 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 41015 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1676:
#line 11648 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 41026 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1677:
#line 11655 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 41037 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1678:
#line 11662 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[-2]);
			}
#line 41048 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1679:
#line 11671 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 41054 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1680:
#line 11672 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 41060 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1681:
#line 11676 "gram_minimal.y" /* yacc.c:1646  */
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);
				n->ctename = (yyvsp[-6].str);
				n->aliascolnames = (yyvsp[-5].list);
				n->ctematerialized = (yyvsp[-3].ival);
				n->ctequery = (yyvsp[-1].node);
				n->location = (yylsp[-6]);
				(yyval.node) = (Node *) n;
			}
#line 41074 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1682:
#line 11688 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeAlways; }
#line 41080 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1683:
#line 11689 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeNever; }
#line 41086 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1684:
#line 11690 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeDefault; }
#line 41092 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1685:
#line 11694 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.with) = (yyvsp[0].with); }
#line 41098 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1686:
#line 11695 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.with) = NULL; }
#line 41104 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1687:
#line 11700 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[0].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;
				}
#line 41119 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1688:
#line 11711 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.into) = NULL; }
#line 41125 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1689:
#line 11720 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 41134 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1690:
#line 11725 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 41143 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1691:
#line 11730 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 41152 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1692:
#line 11735 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 41161 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1693:
#line 11740 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 41173 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1694:
#line 11748 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 41185 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1695:
#line 11756 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_UNLOGGED;
				}
#line 41194 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1696:
#line 11761 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 41203 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1697:
#line 11766 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 41212 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1698:
#line 11772 "gram_minimal.y" /* yacc.c:1646  */
    {}
#line 41218 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1699:
#line 11773 "gram_minimal.y" /* yacc.c:1646  */
    {}
#line 41224 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1700:
#line 11777 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 41230 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1701:
#line 11778 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 41236 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1702:
#line 11779 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 41242 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1703:
#line 11786 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(NIL); }
#line 41248 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1704:
#line 11787 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 41254 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1705:
#line 11791 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL;}
#line 41260 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1706:
#line 11792 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41266 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1707:
#line 11796 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list);}
#line 41272 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1708:
#line 11797 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41278 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1709:
#line 11801 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 41284 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1710:
#line 11805 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].sortby)); }
#line 41290 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1711:
#line 11806 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].sortby)); }
#line 41296 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1712:
#line 11810 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-3].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = (yyvsp[-1].list);
					(yyval.sortby)->location = (yylsp[-1]);
				}
#line 41309 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1713:
#line 11819 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-2].node);
					(yyval.sortby)->sortby_dir = (yyvsp[-1].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				}
#line 41322 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1714:
#line 11832 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[-1].selectlimit);
					((yyval.selectlimit))->limitOffset = (yyvsp[0].node);
				}
#line 41331 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1715:
#line 11837 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[0].selectlimit);
					((yyval.selectlimit))->limitOffset = (yyvsp[-1].node);
				}
#line 41340 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1716:
#line 11842 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[0].selectlimit);
				}
#line 41348 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1717:
#line 11846 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));
					n->limitOffset = (yyvsp[0].node);
					n->limitCount = NULL;
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 41360 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1718:
#line 11856 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.selectlimit) = (yyvsp[0].selectlimit); }
#line 41366 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1719:
#line 11857 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.selectlimit) = NULL; }
#line 41372 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1720:
#line 11862 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));
					n->limitOffset = NULL;
					n->limitCount = (yyvsp[0].node);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 41384 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1721:
#line 11870 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[-3]))));
				}
#line 41397 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1722:
#line 11886 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));
					n->limitOffset = NULL;
					n->limitCount = (yyvsp[-2].node);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 41409 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1723:
#line 11894 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));
					n->limitOffset = NULL;
					n->limitCount = (yyvsp[-3].node);
					n->limitOption = LIMIT_OPTION_WITH_TIES;
					(yyval.selectlimit) = n;
				}
#line 41421 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1724:
#line 11902 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));
					n->limitOffset = NULL;
					n->limitCount = makeIntConst(1, -1);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 41433 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1725:
#line 11910 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));
					n->limitOffset = NULL;
					n->limitCount = makeIntConst(1, -1);
					n->limitOption = LIMIT_OPTION_WITH_TIES;
					(yyval.selectlimit) = n;
				}
#line 41445 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1726:
#line 11921 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41451 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1727:
#line 11924 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 41457 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1728:
#line 11928 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41463 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1729:
#line 11930 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 41472 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1730:
#line 11937 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41478 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1731:
#line 11957 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41484 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1732:
#line 11959 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 41490 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1733:
#line 11961 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 41496 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1734:
#line 11965 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst((yyvsp[0].ival),(yylsp[0])); }
#line 41502 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1735:
#line 11966 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeFloatConst((yyvsp[0].str),(yylsp[0])); }
#line 41508 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1736:
#line 11970 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 41514 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1737:
#line 11971 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 41520 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1738:
#line 11974 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 41526 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1739:
#line 11975 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 41532 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1740:
#line 12000 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 41538 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1741:
#line 12001 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41544 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1742:
#line 12005 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 41550 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1743:
#line 12006 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].node)); }
#line 41556 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1744:
#line 12010 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41562 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1745:
#line 12011 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41568 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1746:
#line 12012 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41574 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1747:
#line 12013 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41580 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1748:
#line 12014 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41586 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1749:
#line 12019 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_EMPTY, NIL, (yylsp[-1]));
				}
#line 41594 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1750:
#line 12032 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_ROLLUP, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 41602 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1751:
#line 12039 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_CUBE, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 41610 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1752:
#line 12046 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_SETS, (yyvsp[-1].list), (yylsp[-4]));
				}
#line 41618 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1753:
#line 12052 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41624 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1754:
#line 12053 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 41630 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1755:
#line 12057 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 41636 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1756:
#line 12058 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41642 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1757:
#line 12062 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 41648 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1758:
#line 12063 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41654 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1759:
#line 12067 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 41660 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1760:
#line 12068 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 41666 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1761:
#line 12073 "gram_minimal.y" /* yacc.c:1646  */
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[-1].list);
					n->strength = (yyvsp[-2].ival);
					n->waitPolicy = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 41678 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1762:
#line 12083 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORUPDATE; }
#line 41684 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1763:
#line 12084 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORNOKEYUPDATE; }
#line 41690 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1764:
#line 12085 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORSHARE; }
#line 41696 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1765:
#line 12086 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORKEYSHARE; }
#line 41702 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1766:
#line 12090 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 41708 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1767:
#line 12091 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41714 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1768:
#line 12102 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->valuesLists = list_make1((yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 41724 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1769:
#line 12108 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[-4].node);
					n->valuesLists = lappend(n->valuesLists, (yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 41734 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1770:
#line 12125 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 41740 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1771:
#line 12126 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41746 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1772:
#line 12130 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 41752 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1773:
#line 12131 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 41758 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1774:
#line 12138 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyvsp[-1].range)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-1].range);
				}
#line 41767 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1775:
#line 12143 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableSample *n = (RangeTableSample *) (yyvsp[0].node);
					(yyvsp[-2].range)->alias = (yyvsp[-1].alias);
					/* relation_expr goes inside the RangeTableSample node */
					n->relation = (Node *) (yyvsp[-2].range);
					(yyval.node) = (Node *) n;
				}
#line 41779 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1776:
#line 12151 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 41790 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1777:
#line 12158 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);
					n->lateral = true;
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 41802 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1778:
#line 12166 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 41812 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1779:
#line 12172 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);
					n->lateral = true;
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 41823 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1780:
#line 12179 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = false;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
					if ((yyvsp[0].alias) == NULL)
					{
						if (IsA((yyvsp[-1].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[-1].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
					}
					(yyval.node) = (Node *) n;
				}
#line 41862 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1781:
#line 12214 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = true;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					/* same comment as above */
					if ((yyvsp[0].alias) == NULL)
					{
						if (IsA((yyvsp[-1].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[-1].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
					}
					(yyval.node) = (Node *) n;
				}
#line 41891 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1782:
#line 12239 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) (yyvsp[0].jexpr);
				}
#line 41899 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1783:
#line 12243 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].jexpr)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-2].jexpr);
				}
#line 41908 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1784:
#line 12269 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.jexpr) = (yyvsp[-1].jexpr);
				}
#line 41916 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1785:
#line 12273 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = false;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
#line 41932 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1786:
#line 12285 "gram_minimal.y" /* yacc.c:1646  */
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[-3].jtype);
					n->isNatural = false;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
						n->usingClause = (List *) (yyvsp[0].node); /* USING clause */
					else
						n->quals = (yyvsp[0].node); /* ON clause */
					(yyval.jexpr) = n;
				}
#line 41949 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1787:
#line 12298 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = false;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
						n->usingClause = (List *) (yyvsp[0].node); /* USING clause */
					else
						n->quals = (yyvsp[0].node); /* ON clause */
					(yyval.jexpr) = n;
				}
#line 41967 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1788:
#line 12312 "gram_minimal.y" /* yacc.c:1646  */
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[-2].jtype);
					n->isNatural = true;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 41982 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1789:
#line 12323 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = true;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 41998 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1790:
#line 12338 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 42008 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1791:
#line 12344 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 42017 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1792:
#line 12349 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 42027 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1793:
#line 12355 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 42036 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1794:
#line 12361 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.alias) = (yyvsp[0].alias); }
#line 42042 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1795:
#line 12362 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.alias) = NULL; }
#line 42048 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1796:
#line 12371 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].alias), NIL);
				}
#line 42056 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1797:
#line 12375 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[-1].list));
				}
#line 42064 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1798:
#line 12379 "gram_minimal.y" /* yacc.c:1646  */
    {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 42074 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1799:
#line 12385 "gram_minimal.y" /* yacc.c:1646  */
    {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 42084 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1800:
#line 12391 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, NIL);
				}
#line 42092 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1801:
#line 12396 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_FULL; }
#line 42098 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1802:
#line 12397 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_LEFT; }
#line 42104 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1803:
#line 12398 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_RIGHT; }
#line 42110 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1804:
#line 12399 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_INNER; }
#line 42116 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1805:
#line 12403 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 42122 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1806:
#line 12404 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 42128 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1807:
#line 12416 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 42134 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1808:
#line 12417 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 42140 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1809:
#line 12423 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* inheritance query, implicitly */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;
				}
#line 42151 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1810:
#line 12430 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* inheritance query, explicitly */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;
				}
#line 42162 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1811:
#line 12437 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
				}
#line 42173 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1812:
#line 12444 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
				}
#line 42184 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1813:
#line 12454 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 42190 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1814:
#line 12455 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 42196 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1815:
#line 12469 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 42204 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1816:
#line 12473 "gram_minimal.y" /* yacc.c:1646  */
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-1].range)->alias = alias;
					(yyval.range) = (yyvsp[-1].range);
				}
#line 42215 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1817:
#line 12480 "gram_minimal.y" /* yacc.c:1646  */
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-2].range)->alias = alias;
					(yyval.range) = (yyvsp[-2].range);
				}
#line 42226 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1818:
#line 12493 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableSample *n = makeNode(RangeTableSample);
					/* n->relation will be filled in later */
					n->method = (yyvsp[-4].list);
					n->args = (yyvsp[-2].list);
					n->repeatable = (yyvsp[0].node);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 42240 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1819:
#line 12505 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].node); }
#line 42246 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1820:
#line 12506 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 42252 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1821:
#line 12522 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = false;
					n->functions = list_make1(list_make2((yyvsp[-1].node), NIL));
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 42266 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1822:
#line 12532 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = true;
					n->functions = (yyvsp[-2].list);
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 42280 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1823:
#line 12544 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].list)); }
#line 42286 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1824:
#line 12548 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 42292 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1825:
#line 12549 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 42298 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1826:
#line 12552 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 42304 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1827:
#line 12553 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42310 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1828:
#line 12556 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 42316 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1829:
#line 12557 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 42322 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1830:
#line 12562 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 42328 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1831:
#line 12563 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 42334 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1832:
#line 12568 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 42340 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1833:
#line 12570 "gram_minimal.y" /* yacc.c:1646  */
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);
					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[0].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
#line 42352 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1834:
#line 12577 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 42358 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1835:
#line 12582 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 42364 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1836:
#line 12583 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42370 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1837:
#line 12588 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 42378 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1838:
#line 12592 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 42386 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1839:
#line 12598 "gram_minimal.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-2].str);
					n->typeName = (yyvsp[-1].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = (CollateClause *) (yyvsp[0].node);
					n->collOid = InvalidOid;
					n->constraints = NIL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 42408 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1840:
#line 12622 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = makeNode(RangeTableFunc);
					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = NIL;
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *)n;
				}
#line 42422 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1841:
#line 12633 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = makeNode(RangeTableFunc);
					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = (yyvsp[-7].list);
					n->location = (yylsp[-11]);
					(yyval.node) = (Node *)n;
				}
#line 42436 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1842:
#line 12644 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 42442 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1843:
#line 12645 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 42448 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1844:
#line 12650 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol	   *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-1].str);
					fc->for_ordinality = false;
					fc->typeName = (yyvsp[0].typnam);
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-1]);

					(yyval.node) = (Node *) fc;
				}
#line 42466 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1845:
#line 12664 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol	   *fc = makeNode(RangeTableFuncCol);
					ListCell		   *option;
					bool				nullability_seen = false;

					fc->colname = (yyvsp[-2].str);
					fc->typeName = (yyvsp[-1].typnam);
					fc->for_ordinality = false;
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-2]);

					foreach(option, (yyvsp[0].list))
					{
						DefElem   *defel = (DefElem *) lfirst(option);

						if (strcmp(defel->defname, "default") == 0)
						{
							if (fc->coldefexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one DEFAULT value is allowed"),
										 parser_errposition(defel->location)));
							fc->coldefexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "path") == 0)
						{
							if (fc->colexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one PATH value per column is allowed"),
										 parser_errposition(defel->location)));
							fc->colexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "is_not_null") == 0)
						{
							if (nullability_seen)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("conflicting or redundant NULL / NOT NULL declarations for column \"%s\"", fc->colname),
										 parser_errposition(defel->location)));
							fc->is_not_null = intVal(defel->arg);
							nullability_seen = true;
						}
						else
						{
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized column option \"%s\"",
											defel->defname),
									 parser_errposition(defel->location)));
						}
					}
					(yyval.node) = (Node *) fc;
				}
#line 42527 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1846:
#line 12721 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol	   *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-2].str);
					fc->for_ordinality = true;
					/* other fields are ignored, initialized by makeNode */
					fc->location = (yylsp[-2]);

					(yyval.node) = (Node *) fc;
				}
#line 42542 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1847:
#line 12735 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 42548 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1848:
#line 12737 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 42554 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1849:
#line 12742 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1])); }
#line 42560 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1850:
#line 12744 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("default", (yyvsp[0].node), (yylsp[-1])); }
#line 42566 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1851:
#line 12746 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeInteger(true), (yylsp[-1])); }
#line 42572 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1852:
#line 12748 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeInteger(false), (yylsp[0])); }
#line 42578 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1853:
#line 12753 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 42584 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1854:
#line 12755 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 42590 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1855:
#line 12760 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 42602 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1856:
#line 12768 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[0].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 42614 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1857:
#line 12788 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
				}
#line 42623 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1858:
#line 12793 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
					(yyval.typnam)->setof = true;
				}
#line 42633 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1859:
#line 12800 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
				}
#line 42642 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1860:
#line 12805 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
					(yyval.typnam)->setof = true;
				}
#line 42652 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1861:
#line 12811 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				}
#line 42661 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1862:
#line 12816 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = true;
				}
#line 42671 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1863:
#line 12825 "gram_minimal.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-2].list), makeInteger(-1)); }
#line 42677 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1864:
#line 12827 "gram_minimal.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-3].list), makeInteger((yyvsp[-1].ival))); }
#line 42683 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1865:
#line 12829 "gram_minimal.y" /* yacc.c:1646  */
    {  (yyval.list) = NIL; }
#line 42689 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1866:
#line 12833 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 42695 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1867:
#line 12834 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 42701 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1868:
#line 12835 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 42707 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1869:
#line 12836 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 42713 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1870:
#line 12837 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 42719 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1871:
#line 12839 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->typmods = (yyvsp[0].list);
				}
#line 42728 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1872:
#line 12844 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-3].typnam);
					(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											 makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 42738 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1873:
#line 12863 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 42744 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1874:
#line 12864 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 42750 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1875:
#line 12865 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 42756 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1876:
#line 12866 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 42762 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1877:
#line 12878 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeName((yyvsp[-1].str));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 42772 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1878:
#line 12884 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-2].str)), (yyvsp[-1].list)));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-2]);
				}
#line 42782 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1879:
#line 12891 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 42788 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1880:
#line 12892 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42794 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1881:
#line 12899 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 42803 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1882:
#line 12904 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 42812 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1883:
#line 12909 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 42821 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1884:
#line 12914 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 42830 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1885:
#line 12919 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 42839 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1886:
#line 12924 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 42848 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1887:
#line 12929 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 42857 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1888:
#line 12934 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 42867 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1889:
#line 12940 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 42877 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1890:
#line 12946 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 42887 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1891:
#line 12952 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 42896 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1892:
#line 12959 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[-1].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[-1]))));
					else if ((yyvsp[-1].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[-1].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[-1]))));
				}
#line 42921 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1893:
#line 12980 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
				}
#line 42929 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1894:
#line 12990 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 42937 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1895:
#line 12994 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 42945 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1896:
#line 13002 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 42953 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1897:
#line 13006 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 42962 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1898:
#line 13014 "gram_minimal.y" /* yacc.c:1646  */
    {
					char *typname;

					typname = (yyvsp[-3].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[-1].list);
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 42975 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1899:
#line 13026 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[0].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 42993 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1900:
#line 13047 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 43001 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1901:
#line 13051 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 43009 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1902:
#line 13057 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 43017 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1903:
#line 13061 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 43032 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1904:
#line 13074 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName((yyvsp[-3].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 43042 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1905:
#line 13082 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName((yyvsp[0].str));
					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[0].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 43054 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1906:
#line 13092 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 43060 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1907:
#line 13094 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 43066 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1908:
#line 13096 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "varchar"; }
#line 43072 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1909:
#line 13098 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 43078 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1910:
#line 13100 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 43084 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1911:
#line 13102 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 43090 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1912:
#line 13106 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 43096 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1913:
#line 13107 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 43102 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1914:
#line 13115 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 43115 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1915:
#line 13124 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43127 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1916:
#line 13132 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 43140 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1917:
#line 13141 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43152 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1918:
#line 13152 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 43161 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1919:
#line 13159 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 43167 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1920:
#line 13160 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 43173 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1921:
#line 13161 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 43179 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1922:
#line 13166 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[0]))); }
#line 43185 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1923:
#line 13168 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[0]))); }
#line 43191 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1924:
#line 13170 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[0]))); }
#line 43197 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1925:
#line 13172 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[0]))); }
#line 43203 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1926:
#line 13174 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[0]))); }
#line 43209 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1927:
#line 13176 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 43215 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1928:
#line 13178 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[-2])));
				}
#line 43224 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1929:
#line 13183 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[-2])));
				}
#line 43233 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1930:
#line 13188 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 43243 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1931:
#line 13194 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 43255 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1932:
#line 13202 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 43264 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1933:
#line 13207 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 43275 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1934:
#line 13214 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 43285 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1935:
#line 13220 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 43291 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1936:
#line 13225 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[0])));
				}
#line 43299 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1937:
#line 13229 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[-3])),
									makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 43308 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1938:
#line 13264 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 43314 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1939:
#line 13266 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 43320 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1940:
#line 13268 "gram_minimal.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = (yyvsp[-2].node);
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 43332 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1941:
#line 13276 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("timezone"),
											   list_make2((yyvsp[0].node), (yyvsp[-4].node)),
											   (yylsp[-3]));
				}
#line 43342 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1942:
#line 13291 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 43348 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1943:
#line 13293 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 43354 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1944:
#line 13295 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43360 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1945:
#line 13297 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43366 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1946:
#line 13299 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43372 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1947:
#line 13301 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43378 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1948:
#line 13303 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43384 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1949:
#line 13305 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43390 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1950:
#line 13307 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43396 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1951:
#line 13309 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43402 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1952:
#line 13311 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43408 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1953:
#line 13313 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43414 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1954:
#line 13315 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43420 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1955:
#line 13317 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43426 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1956:
#line 13320 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43432 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1957:
#line 13322 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 43438 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1958:
#line 13324 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[0].list), (yyvsp[-1].node), NULL, (yylsp[0])); }
#line 43444 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1959:
#line 13327 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeAndExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43450 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1960:
#line 13329 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeOrExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43456 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1961:
#line 13331 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 43462 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1962:
#line 13333 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 43468 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1963:
#line 13336 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 43477 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1964:
#line 13341 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 43489 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1965:
#line 13349 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 43498 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1966:
#line 13354 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 43510 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1967:
#line 13362 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 43519 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1968:
#line 13367 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 43531 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1969:
#line 13375 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 43540 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1970:
#line 13380 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 43552 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1971:
#line 13389 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_to_escape"),
											   list_make1((yyvsp[0].node)),
											   (yylsp[-2]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-3].node), (Node *) n, (yylsp[-2]));
				}
#line 43564 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1972:
#line 13397 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_to_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 43576 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1973:
#line 13405 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_to_escape"),
											   list_make1((yyvsp[0].node)),
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 43588 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1974:
#line 13413 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_to_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-5]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-6].node), (Node *) n, (yylsp[-5]));
				}
#line 43600 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1975:
#line 13431 "gram_minimal.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-2].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 43612 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1976:
#line 13439 "gram_minimal.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 43624 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1977:
#line 13447 "gram_minimal.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-3].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 43636 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1978:
#line 13455 "gram_minimal.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 43648 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1979:
#line 13463 "gram_minimal.y" /* yacc.c:1646  */
    {
					if (list_length((yyvsp[-2].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
								 parser_errposition((yylsp[-2]))));
					if (list_length((yyvsp[0].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlaps"),
											   list_concat((yyvsp[-2].list), (yyvsp[0].list)),
											   (yylsp[-1]));
				}
#line 43668 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1980:
#line 13479 "gram_minimal.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_TRUE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *)b;
				}
#line 43680 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1981:
#line 13487 "gram_minimal.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_TRUE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *)b;
				}
#line 43692 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1982:
#line 13495 "gram_minimal.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_FALSE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *)b;
				}
#line 43704 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1983:
#line 13503 "gram_minimal.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_FALSE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *)b;
				}
#line 43716 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1984:
#line 13511 "gram_minimal.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_UNKNOWN;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *)b;
				}
#line 43728 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1985:
#line 13519 "gram_minimal.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *)b;
				}
#line 43740 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1986:
#line 13527 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 43748 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1987:
#line 13531 "gram_minimal.y" /* yacc.c:1646  */
    {
                    (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 43756 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1988:
#line 13535 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[-5].node), (Node *) (yyvsp[-1].list), (yylsp[-4]));
				}
#line 43764 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1989:
#line 13539 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[-6].node), (Node *) (yyvsp[-1].list), (yylsp[-5]));
				}
#line 43772 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1990:
#line 13543 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN,
												   "BETWEEN",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 43784 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1991:
#line 13551 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN,
												   "NOT BETWEEN",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 43796 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1992:
#line 13559 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN_SYM,
												   "BETWEEN SYMMETRIC",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 43808 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1993:
#line 13567 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN_SYM,
												   "NOT BETWEEN SYMMETRIC",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 43820 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1994:
#line 13575 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink *n = (SubLink *) (yyvsp[0].node);
						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-2].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-1]);
						(yyval.node) = (Node *)n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
					}
				}
#line 43844 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1995:
#line 13595 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink *n = (SubLink *) (yyvsp[0].node);
						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-3].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-2]);
						/* Stick a NOT on top; must have same parse location */
						(yyval.node) = makeNotExpr((Node *) n, (yylsp[-2]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
					}
				}
#line 43870 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1996:
#line 13617 "gram_minimal.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = (yyvsp[-1].ival);
					n->subLinkId = 0;
					n->testexpr = (yyvsp[-3].node);
					n->operName = (yyvsp[-2].list);
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 43885 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1997:
#line 13628 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-3].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
				}
#line 43896 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1998:
#line 13635 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[-1]))));
				}
#line 43916 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1999:
#line 13651 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 43925 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2000:
#line 13656 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 43935 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2001:
#line 13662 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("is_normalized"), list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 43943 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2002:
#line 13666 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("is_normalized"), list_make2((yyvsp[-3].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))), (yylsp[-2]));
				}
#line 43951 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2003:
#line 13670 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr((Node *) makeFuncCall(SystemFuncName("is_normalized"), list_make1((yyvsp[-3].node)), (yylsp[-2])), (yylsp[-2]));
				}
#line 43959 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2004:
#line 13674 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr((Node *) makeFuncCall(SystemFuncName("is_normalized"), list_make2((yyvsp[-4].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))), (yylsp[-3])), (yylsp[-3]));
				}
#line 43967 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2005:
#line 13678 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * The SQL spec only allows DEFAULT in "contextually typed
					 * expressions", but for us, it's easier to allow it in
					 * any a_expr and then throw error during parse analysis
					 * if it's in an inappropriate context.  This way also
					 * lets us say something smarter than "syntax error".
					 */
					SetToDefault *n = makeNode(SetToDefault);
					/* parse analysis will fill in the rest */
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 43985 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2006:
#line 13703 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 43991 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2007:
#line 13705 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 43997 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2008:
#line 13707 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 44003 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2009:
#line 13709 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 44009 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2010:
#line 13711 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44015 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2011:
#line 13713 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44021 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2012:
#line 13715 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44027 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2013:
#line 13717 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44033 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2014:
#line 13719 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44039 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2015:
#line 13721 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44045 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2016:
#line 13723 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44051 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2017:
#line 13725 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44057 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2018:
#line 13727 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44063 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2019:
#line 13729 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44069 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2020:
#line 13731 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44075 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2021:
#line 13733 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44081 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2022:
#line 13735 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44087 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2023:
#line 13737 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 44093 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2024:
#line 13739 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[0].list), (yyvsp[-1].node), NULL, (yylsp[0])); }
#line 44099 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2025:
#line 13741 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 44107 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2026:
#line 13745 "gram_minimal.y" /* yacc.c:1646  */
    {
                    (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 44115 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2027:
#line 13749 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[-5].node), (Node *) (yyvsp[-1].list), (yylsp[-4]));
				}
#line 44123 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2028:
#line 13753 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[-6].node), (Node *) (yyvsp[-1].list), (yylsp[-5]));
				}
#line 44131 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2029:
#line 13757 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 44140 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2030:
#line 13762 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 44150 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2031:
#line 13777 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44156 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2032:
#line 13778 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44162 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2033:
#line 13780 "gram_minimal.y" /* yacc.c:1646  */
    {
					ParamRef *p = makeNode(ParamRef);
					p->number = (yyvsp[-1].ival);
					p->location = (yylsp[-1]);
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
#line 44181 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2034:
#line 13795 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (yyvsp[-2].node);
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *)n;
					}
					else if (operator_precedence_warning)
					{
						/*
						 * If precedence warnings are enabled, insert
						 * AEXPR_PAREN nodes wrapping all explicitly
						 * parenthesized subexpressions; this prevents bogus
						 * warnings from being issued when the ordering has
						 * been forced by parentheses.  Take care that an
						 * AEXPR_PAREN node has the same exprLocation as its
						 * child, so as not to cause surprising changes in
						 * error cursor positioning.
						 *
						 * In principle we should not be relying on a GUC to
						 * decide whether to insert AEXPR_PAREN nodes.
						 * However, since they have no effect except to
						 * suppress warnings, it's probably safe enough; and
						 * we'd just as soon not waste cycles on dummy parse
						 * nodes if we don't have to.
						 */
						(yyval.node) = (Node *) makeA_Expr(AEXPR_PAREN, NIL, (yyvsp[-2].node), NULL,
												 exprLocation((yyvsp[-2].node)));
					}
					else
						(yyval.node) = (yyvsp[-2].node);
				}
#line 44219 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2035:
#line 13829 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44225 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2036:
#line 13831 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44231 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2037:
#line 13833 "gram_minimal.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 44246 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2038:
#line 13844 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);
					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[-1].node);
					n->location = (yylsp[-1]);
					a->arg = (Node *)n;
					a->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.node) = (Node *)a;
				}
#line 44274 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2039:
#line 13868 "gram_minimal.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXISTS_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 44289 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2040:
#line 13879 "gram_minimal.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = ARRAY_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 44304 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2041:
#line 13890 "gram_minimal.y" /* yacc.c:1646  */
    {
					A_ArrayExpr *n = castNode(A_ArrayExpr, (yyvsp[0].node));
					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 44315 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2042:
#line 13897 "gram_minimal.y" /* yacc.c:1646  */
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_EXPLICIT_CALL; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *)r;
				}
#line 44329 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2043:
#line 13907 "gram_minimal.y" /* yacc.c:1646  */
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_IMPLICIT_CAST; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *)r;
				}
#line 44343 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2044:
#line 13917 "gram_minimal.y" /* yacc.c:1646  */
    {
				  GroupingFunc *g = makeNode(GroupingFunc);
				  g->args = (yyvsp[-1].list);
				  g->location = (yylsp[-3]);
				  (yyval.node) = (Node *)g;
			  }
#line 44354 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2045:
#line 13926 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall((yyvsp[-2].list), NIL, (yylsp[-2]));
				}
#line 44362 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2046:
#line 13930 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-4].list), (yyvsp[-2].list), (yylsp[-4]));
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 44372 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2047:
#line 13936 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), list_make1((yyvsp[-2].node)), (yylsp[-5]));
					n->func_variadic = true;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 44383 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2048:
#line 13943 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-7].list), lappend((yyvsp[-5].list), (yyvsp[-2].node)), (yylsp[-7]));
					n->func_variadic = true;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 44394 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2049:
#line 13950 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list), (yylsp[-5]));
					n->agg_order = (yyvsp[-1].list);
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					(yyval.node) = (Node *)n;
				}
#line 44408 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2050:
#line 13960 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list), (yylsp[-5]));
					n->agg_order = (yyvsp[-1].list);
					n->agg_distinct = true;
					(yyval.node) = (Node *)n;
				}
#line 44419 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2051:
#line 13967 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall *n = makeFuncCall((yyvsp[-3].list), NIL, (yylsp[-3]));
					n->agg_star = true;
					(yyval.node) = (Node *)n;
				}
#line 44439 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2052:
#line 13995 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall *n = (FuncCall *) (yyvsp[-3].node);
					/*
					 * The order clause for WITHIN GROUP and the one for
					 * plain-aggregate ORDER BY share a field, so we have to
					 * check here that at most one is present.  We also check
					 * for DISTINCT and VARIADIC here to give a better error
					 * location.  Other consistency checks are deferred to
					 * parse analysis.
					 */
					if ((yyvsp[-2].list) != NIL)
					{
						if (n->agg_order != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use multiple ORDER BY clauses with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->agg_distinct)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use DISTINCT with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->func_variadic)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use VARIADIC with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						n->agg_order = (yyvsp[-2].list);
						n->agg_within_group = true;
					}
					n->agg_filter = (yyvsp[-1].node);
					n->over = (yyvsp[0].windef);
					(yyval.node) = (Node *) n;
				}
#line 44478 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2053:
#line 14030 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44484 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2054:
#line 14040 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44490 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2055:
#line 14041 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44496 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2056:
#line 14049 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("pg_collation_for"),
											   list_make1((yyvsp[-1].node)),
											   (yylsp[-4]));
				}
#line 44506 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2057:
#line 14055 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_DATE, -1, (yylsp[0]));
				}
#line 44514 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2058:
#line 14059 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME, -1, (yylsp[0]));
				}
#line 44522 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2059:
#line 14063 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 44530 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2060:
#line 14067 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP, -1, (yylsp[0]));
				}
#line 44538 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2061:
#line 14071 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 44546 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2062:
#line 14075 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME, -1, (yylsp[0]));
				}
#line 44554 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2063:
#line 14079 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 44562 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2064:
#line 14083 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP, -1, (yylsp[0]));
				}
#line 44570 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2065:
#line 14087 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 44578 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2066:
#line 14091 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_ROLE, -1, (yylsp[0]));
				}
#line 44586 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2067:
#line 14095 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_USER, -1, (yylsp[0]));
				}
#line 44594 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2068:
#line 14099 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_SESSION_USER, -1, (yylsp[0]));
				}
#line 44602 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2069:
#line 14103 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_USER, -1, (yylsp[0]));
				}
#line 44610 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2070:
#line 14107 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_CATALOG, -1, (yylsp[0]));
				}
#line 44618 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2071:
#line 14111 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_SCHEMA, -1, (yylsp[0]));
				}
#line 44626 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2072:
#line 14115 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-3].node), (yyvsp[-1].typnam), (yylsp[-5])); }
#line 44632 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2073:
#line 14117 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("date_part"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 44640 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2074:
#line 14121 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("normalize"), list_make1((yyvsp[-1].node)), (yylsp[-3]));
				}
#line 44648 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2075:
#line 14125 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("normalize"), list_make2((yyvsp[-3].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))), (yylsp[-5]));
				}
#line 44656 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2076:
#line 14129 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to
					 * overlay(A, B, C, D)
					 * overlay(A PLACING B FROM C) is converted to
					 * overlay(A, B, C)
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlay"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 44669 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2077:
#line 14138 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* position(A in B) is converted to position(B, A) */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("position"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 44678 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2078:
#line 14143 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("substring"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 44689 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2079:
#line 14150 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 *
					 * Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName(((Value *)llast((yyvsp[-1].typnam)->names))->val.str),
												list_make1((yyvsp[-3].node)),
												(yylsp[-5]));
				}
#line 44708 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2080:
#line 14165 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* various trim expressions are defined in SQL
					 * - thomas 1997-07-19
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"), (yyvsp[-1].list), (yylsp[-4]));
				}
#line 44719 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2081:
#line 14172 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("ltrim"), (yyvsp[-1].list), (yylsp[-4]));
				}
#line 44727 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2082:
#line 14176 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("rtrim"), (yyvsp[-1].list), (yylsp[-4]));
				}
#line 44735 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2083:
#line 14180 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 44743 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2084:
#line 14184 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[-3].node), (yyvsp[-1].node), (yylsp[-5]));
				}
#line 44751 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2085:
#line 14188 "gram_minimal.y" /* yacc.c:1646  */
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);
					c->args = (yyvsp[-1].list);
					c->location = (yylsp[-3]);
					(yyval.node) = (Node *)c;
				}
#line 44762 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2086:
#line 14195 "gram_minimal.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[-1].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *)v;
				}
#line 44774 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2087:
#line 14203 "gram_minimal.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[-1].list);
					v->op = IS_LEAST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *)v;
				}
#line 44786 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2088:
#line 14211 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 44794 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2089:
#line 14215 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-1].str), NIL, NIL, (yylsp[-4]));
				}
#line 44802 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2090:
#line 14219 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), (yyvsp[-1].list), NIL, (yylsp[-6]));
				}
#line 44810 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2091:
#line 14223 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), NIL, (yyvsp[-1].list), (yylsp[-6]));
				}
#line 44818 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2092:
#line 14227 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-5].str), (yyvsp[-3].list), (yyvsp[-1].list), (yylsp[-8]));
				}
#line 44826 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2093:
#line 14231 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
					 * converted to xmlexists(A, B)*/
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("xmlexists"), list_make2((yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-4]));
				}
#line 44836 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2094:
#line 14237 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[-1].list), NIL, (yylsp[-3]));
				}
#line 44844 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2095:
#line 14241 "gram_minimal.y" /* yacc.c:1646  */
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[-2].node), makeBoolAConst((yyvsp[-1].boolean), -1)),
									(yylsp[-5]));
					x->xmloption = (yyvsp[-3].ival);
					(yyval.node) = (Node *)x;
				}
#line 44857 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2096:
#line 14250 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-1].str), NULL, NIL, (yylsp[-4]));
				}
#line 44865 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2097:
#line 14254 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-3].str), NULL, list_make1((yyvsp[-1].node)), (yylsp[-6]));
				}
#line 44873 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2098:
#line 14258 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-6]));
				}
#line 44882 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2099:
#line 14263 "gram_minimal.y" /* yacc.c:1646  */
    {
					XmlSerialize *n = makeNode(XmlSerialize);
					n->xmloption = (yyvsp[-4].ival);
					n->expr = (yyvsp[-3].node);
					n->typeName = (yyvsp[-1].typnam);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *)n;
				}
#line 44895 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2100:
#line 14277 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44901 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2101:
#line 14279 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeNullAConst(-1); }
#line 44907 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2102:
#line 14283 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); }
#line 44913 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2103:
#line 14285 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); }
#line 44919 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2104:
#line 14287 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
#line 44925 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2105:
#line 14289 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); }
#line 44931 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2106:
#line 14292 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 44937 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2107:
#line 14295 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 44943 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2108:
#line 14296 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 44949 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2109:
#line 14300 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 44961 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2110:
#line 14308 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 44973 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2111:
#line 14317 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_DOCUMENT; }
#line 44979 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2112:
#line 14318 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_CONTENT; }
#line 44985 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2113:
#line 14321 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 44991 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2114:
#line 14322 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 44997 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2115:
#line 14323 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 45003 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2116:
#line 14329 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 45011 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2117:
#line 14333 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-1].node);
				}
#line 45019 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2118:
#line 14337 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 45027 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2119:
#line 14341 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-1].node);
				}
#line 45035 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2122:
#line 14356 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 45041 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2123:
#line 14357 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45047 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2124:
#line 14361 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 45053 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2125:
#line 14362 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 45059 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2126:
#line 14370 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45065 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2127:
#line 14371 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45071 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2128:
#line 14375 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].windef)); }
#line 45077 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2129:
#line 14377 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].windef)); }
#line 45083 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2130:
#line 14382 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					n->name = (yyvsp[-2].str);
					(yyval.windef) = n;
				}
#line 45093 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2131:
#line 14390 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.windef) = (yyvsp[0].windef); }
#line 45099 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2132:
#line 14392 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = (yyvsp[0].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[0]);
					(yyval.windef) = n;
				}
#line 45116 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2133:
#line 14405 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.windef) = NULL; }
#line 45122 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2134:
#line 14410 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = NULL;
					n->refname = (yyvsp[-4].str);
					n->partitionClause = (yyvsp[-3].list);
					n->orderClause = (yyvsp[-2].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[-1].windef)->frameOptions;
					n->startOffset = (yyvsp[-1].windef)->startOffset;
					n->endOffset = (yyvsp[-1].windef)->endOffset;
					n->location = (yylsp[-5]);
					(yyval.windef) = n;
				}
#line 45140 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2135:
#line 14435 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 45146 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2136:
#line 14436 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 45152 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2137:
#line 14439 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45158 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2138:
#line 14440 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45164 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2139:
#line 14449 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[-1].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 45175 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2140:
#line 14456 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[-1].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 45186 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2141:
#line 14463 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[-1].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_GROUPS;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 45197 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2142:
#line 14470 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 45209 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2143:
#line 14480 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[0]))));
					if (n->frameOptions & FRAMEOPTION_START_OFFSET_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[0]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				}
#line 45230 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2144:
#line 14497 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef *n1 = (yyvsp[-2].windef);
					WindowDef *n2 = (yyvsp[0].windef);
					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[-2]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_OFFSET_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_OFFSET_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_OFFSET_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				}
#line 45271 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2145:
#line 14542 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 45283 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2146:
#line 14550 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 45295 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2147:
#line 14558 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 45307 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2148:
#line 14566 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_OFFSET_PRECEDING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 45319 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2149:
#line 14574 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_OFFSET_FOLLOWING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 45331 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2150:
#line 14584 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_CURRENT_ROW; }
#line 45337 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2151:
#line 14585 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_GROUP; }
#line 45343 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2152:
#line 14586 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_TIES; }
#line 45349 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2153:
#line 14587 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 45355 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2154:
#line 14588 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 45361 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2155:
#line 14602 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 45367 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2156:
#line 14603 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45373 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2157:
#line 14604 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 45379 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2158:
#line 14607 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 45385 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2159:
#line 14608 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45391 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2160:
#line 14611 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 45397 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2161:
#line 14614 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 45403 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2162:
#line 14615 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 45409 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2163:
#line 14616 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ALL_SUBLINK; }
#line 45415 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2164:
#line 14619 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 45421 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2165:
#line 14620 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 45427 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2166:
#line 14623 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "+"; }
#line 45433 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2167:
#line 14624 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "-"; }
#line 45439 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2168:
#line 14625 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "*"; }
#line 45445 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2169:
#line 14626 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "/"; }
#line 45451 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2170:
#line 14627 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "%"; }
#line 45457 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2171:
#line 14628 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "^"; }
#line 45463 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2172:
#line 14629 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "<"; }
#line 45469 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2173:
#line 14630 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = ">"; }
#line 45475 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2174:
#line 14631 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "="; }
#line 45481 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2175:
#line 14632 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "<="; }
#line 45487 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2176:
#line 14633 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = ">="; }
#line 45493 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2177:
#line 14634 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "<>"; }
#line 45499 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2178:
#line 14638 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 45505 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2179:
#line 14640 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 45511 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2180:
#line 14645 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 45517 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2181:
#line 14647 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 45523 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2182:
#line 14652 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 45529 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2183:
#line 14654 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 45535 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2184:
#line 14656 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~")); }
#line 45541 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2185:
#line 14658 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~")); }
#line 45547 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2186:
#line 14660 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~*")); }
#line 45553 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2187:
#line 14662 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~*")); }
#line 45559 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2188:
#line 14674 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 45567 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2189:
#line 14678 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 45575 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2190:
#line 14685 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 45583 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2191:
#line 14689 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 45591 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2192:
#line 14695 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 45599 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2193:
#line 14699 "gram_minimal.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 45612 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2194:
#line 14708 "gram_minimal.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 45625 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2195:
#line 14718 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 45631 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2196:
#line 14719 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 45637 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2197:
#line 14723 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 45645 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2198:
#line 14727 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 45653 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2199:
#line 14731 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[-1]));
				}
#line 45661 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2200:
#line 14736 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 45667 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2201:
#line 14737 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 45673 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2202:
#line 14743 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[-2].str), (yylsp[-2])), (yyvsp[0].node));
				}
#line 45681 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2203:
#line 14746 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45687 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2204:
#line 14753 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 45693 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2205:
#line 14754 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "year"; }
#line 45699 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2206:
#line 14755 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "month"; }
#line 45705 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2207:
#line 14756 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "day"; }
#line 45711 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2208:
#line 14757 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "hour"; }
#line 45717 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2209:
#line 14758 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "minute"; }
#line 45723 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2210:
#line 14759 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "second"; }
#line 45729 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2211:
#line 14760 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 45735 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2212:
#line 14764 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "nfc"; }
#line 45741 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2213:
#line 14765 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "nfd"; }
#line 45747 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2214:
#line 14766 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "nfkc"; }
#line 45753 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2215:
#line 14767 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "nfkd"; }
#line 45759 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2216:
#line 14778 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make4((yyvsp[-3].node), (yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 45767 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2217:
#line 14782 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 45775 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2218:
#line 14789 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45781 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2219:
#line 14795 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-2].node)); }
#line 45787 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2220:
#line 14796 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45793 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2221:
#line 14813 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 45801 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2222:
#line 14817 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* not legal per SQL99, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[0].node), (yyvsp[-1].node));
				}
#line 45810 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2223:
#line 14822 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].node));
				}
#line 45818 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2224:
#line 14826 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[-1].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[0].node),
												 SystemTypeName("int4"), -1));
				}
#line 45837 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2225:
#line 14841 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
				}
#line 45845 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2226:
#line 14845 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45851 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2227:
#line 14849 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45857 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2228:
#line 14852 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45863 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2229:
#line 14855 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[0].list), (yyvsp[-2].node)); }
#line 45869 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2230:
#line 14856 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45875 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2231:
#line 14857 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45881 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2232:
#line 14861 "gram_minimal.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subselect = (yyvsp[0].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *)n;
				}
#line 45892 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2233:
#line 14867 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[-1].list); }
#line 45898 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2234:
#line 14878 "gram_minimal.y" /* yacc.c:1646  */
    {
					CaseExpr *c = makeNode(CaseExpr);
					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[-3].node);
					c->args = (yyvsp[-2].list);
					c->defresult = (Expr *) (yyvsp[-1].node);
					c->location = (yylsp[-4]);
					(yyval.node) = (Node *)c;
				}
#line 45912 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2235:
#line 14891 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 45918 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2236:
#line 14892 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 45924 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2237:
#line 14897 "gram_minimal.y" /* yacc.c:1646  */
    {
					CaseWhen *w = makeNode(CaseWhen);
					w->expr = (Expr *) (yyvsp[-2].node);
					w->result = (Expr *) (yyvsp[0].node);
					w->location = (yylsp[-3]);
					(yyval.node) = (Node *)w;
				}
#line 45936 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2238:
#line 14907 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45942 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2239:
#line 14908 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 45948 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2240:
#line 14911 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45954 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2241:
#line 14912 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 45960 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2242:
#line 14916 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[0].str), NIL, (yylsp[0]), yyscanner);
				}
#line 45968 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2243:
#line 14920 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 45976 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2244:
#line 14927 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 45984 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2245:
#line 14931 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				}
#line 45992 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2246:
#line 14935 "gram_minimal.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->is_slice = false;
					ai->lidx = NULL;
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 46004 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2247:
#line 14943 "gram_minimal.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->is_slice = true;
					ai->lidx = (yyvsp[-3].node);
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 46016 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2248:
#line 14953 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46022 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2249:
#line 14954 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 46028 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2250:
#line 14958 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 46034 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2251:
#line 14959 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 46040 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2252:
#line 14963 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46046 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2253:
#line 14964 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 46052 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2256:
#line 14978 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46058 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2257:
#line 14979 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46064 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2258:
#line 14983 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 46070 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2259:
#line 14984 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 46076 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2260:
#line 14988 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 46088 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2261:
#line 15004 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[-1].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 46100 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2262:
#line 15012 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 46112 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2263:
#line 15020 "gram_minimal.y" /* yacc.c:1646  */
    {
					ColumnRef *n = makeNode(ColumnRef);
					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[0]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)n;
					(yyval.target)->location = (yylsp[0]);
				}
#line 46128 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2264:
#line 15041 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 46134 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2265:
#line 15042 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 46140 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2266:
#line 15054 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = makeRangeVar(NULL, (yyvsp[0].str), (yylsp[0]));
				}
#line 46148 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2267:
#line 15058 "gram_minimal.y" /* yacc.c:1646  */
    {
					check_qualified_name((yyvsp[0].list), yyscanner);
					(yyval.range) = makeRangeVar(NULL, NULL, (yylsp[-1]));
					switch (list_length((yyvsp[0].list)))
					{
						case 1:
							(yyval.range)->catalogname = NULL;
							(yyval.range)->schemaname = (yyvsp[-1].str);
							(yyval.range)->relname = strVal(linitial((yyvsp[0].list)));
							break;
						case 2:
							(yyval.range)->catalogname = (yyvsp[-1].str);
							(yyval.range)->schemaname = strVal(linitial((yyvsp[0].list)));
							(yyval.range)->relname = strVal(lsecond((yyvsp[0].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)))),
									 parser_errposition((yylsp[-1]))));
							break;
					}
				}
#line 46177 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2268:
#line 15085 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 46183 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2269:
#line 15087 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 46189 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2270:
#line 15091 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46195 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2271:
#line 15094 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46201 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2272:
#line 15097 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46207 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2273:
#line 15099 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46213 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2274:
#line 15101 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46219 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2275:
#line 15103 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46225 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2276:
#line 15114 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 46231 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2277:
#line 15116 "gram_minimal.y" /* yacc.c:1646  */
    {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
											 yyscanner);
					}
#line 46240 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2278:
#line 15127 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0]));
				}
#line 46248 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2279:
#line 15131 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeFloatConst((yyvsp[0].str), (yylsp[0]));
				}
#line 46256 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2280:
#line 15135 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 46264 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2281:
#line 15139 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 46272 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2282:
#line 15143 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 46285 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2283:
#line 15152 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* generic type 'literal' syntax */
					TypeName *t = makeTypeNameFromNameList((yyvsp[-1].list));
					t->location = (yylsp[-1]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 46296 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2284:
#line 15159 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* generic syntax with a type modifier */
					TypeName *t = makeTypeNameFromNameList((yyvsp[-5].list));
					ListCell *lc;

					/*
					 * We must use func_arg_list and opt_sort_clause in the
					 * production to avoid reduce/reduce conflicts, but we
					 * don't actually wish to allow NamedArgExpr in this
					 * context, nor ORDER BY.
					 */
					foreach(lc, (yyvsp[-3].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have parameter name"),
									 parser_errposition(arg->location)));
					}
					if ((yyvsp[-2].list) != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have ORDER BY"),
									 parser_errposition((yylsp[-2]))));

					t->typmods = (yyvsp[-3].list);
					t->location = (yylsp[-5]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 46332 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2285:
#line 15191 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), (yyvsp[-1].typnam));
				}
#line 46340 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2286:
#line 15195 "gram_minimal.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-2].typnam);
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 46350 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2287:
#line 15201 "gram_minimal.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-4].typnam);
					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 46361 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2288:
#line 15208 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(true, (yylsp[0]));
				}
#line 46369 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2289:
#line 15212 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(false, (yylsp[0]));
				}
#line 46377 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2290:
#line 15216 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 46385 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2291:
#line 15221 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 46391 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2292:
#line 15222 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46397 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2293:
#line 15224 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 46403 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2294:
#line 15225 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = + (yyvsp[0].ival); }
#line 46409 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2295:
#line 15226 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = - (yyvsp[0].ival); }
#line 46415 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2296:
#line 15231 "gram_minimal.y" /* yacc.c:1646  */
    {
					RoleSpec *spc = (RoleSpec *) (yyvsp[0].rolespec);
					switch (spc->roletype)
					{
						case ROLESPEC_CSTRING:
							(yyval.str) = spc->rolename;
							break;
						case ROLESPEC_PUBLIC:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("role name \"%s\" is reserved",
											"public"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_SESSION_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"SESSION_USER"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_CURRENT_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_USER"),
									 parser_errposition((yylsp[0]))));
							break;
					}
				}
#line 46450 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2297:
#line 15264 "gram_minimal.y" /* yacc.c:1646  */
    {
						/*
						 * "public" and "none" are not keywords, but they must
						 * be treated specially here.
						 */
						RoleSpec *n;
						if (strcmp((yyvsp[0].str), "public") == 0)
						{
							n = (RoleSpec *) makeRoleSpec(ROLESPEC_PUBLIC, (yylsp[0]));
							n->roletype = ROLESPEC_PUBLIC;
						}
						else if (strcmp((yyvsp[0].str), "none") == 0)
						{
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("role name \"%s\" is reserved",
											"none"),
									 parser_errposition((yylsp[0]))));
						}
						else
						{
							n = makeRoleSpec(ROLESPEC_CSTRING, (yylsp[0]));
							n->rolename = pstrdup((yyvsp[0].str));
						}
						(yyval.rolespec) = n;
					}
#line 46481 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2298:
#line 15291 "gram_minimal.y" /* yacc.c:1646  */
    {
						(yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0]));
					}
#line 46489 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2299:
#line 15295 "gram_minimal.y" /* yacc.c:1646  */
    {
						(yyval.rolespec) = makeRoleSpec(ROLESPEC_SESSION_USER, (yylsp[0]));
					}
#line 46497 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2300:
#line 15301 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 46503 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2301:
#line 15303 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 46509 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2302:
#line 15319 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46515 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2303:
#line 15320 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 46521 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2304:
#line 15321 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 46527 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2305:
#line 15326 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46533 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2306:
#line 15327 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 46539 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2307:
#line 15328 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 46545 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2308:
#line 15333 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46551 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2309:
#line 15334 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 46557 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2310:
#line 15335 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 46563 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2311:
#line 15336 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 46569 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2312:
#line 15342 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46575 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2313:
#line 15343 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 46581 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2314:
#line 15344 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 46587 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2315:
#line 15345 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 46593 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2316:
#line 15346 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 46599 "gram_minimal.c" /* yacc.c:1646  */
    break;


#line 46603 "gram_minimal.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, yyscanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, yyscanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 15853 "gram_minimal.y" /* yacc.c:1906  */


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
minimal_base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static RawStmt *
makeRawStmt(Node *stmt, int stmt_location)
{
	RawStmt    *rs = makeNode(RawStmt);

	rs->stmt = stmt;
	rs->stmt_location = stmt_location;
	rs->stmt_len = 0;			/* might get changed later */
	return rs;
}

/* Adjust a RawStmt to reflect that it doesn't run to the end of the string */
static void
updateRawStmtEnd(RawStmt *rs, int end_location)
{
	/*
	 * If we already set the length, don't change it.  This is for situations
	 * like "select foo ;; select bar" where the same statement will be last
	 * in the string for more than one semicolon.
	 */
	if (rs->stmt_len > 0)
		return;

	/* OK, update length of RawStmt */
	rs->stmt_len = end_location - rs->stmt_location;
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int		nfields = 0;
	ListCell *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(indirection, l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}


static Node *
makeStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}


static Node *
makeFloatConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Float;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_BitString;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Null;
	n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Value *v, int location)
{
	Node *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(v->val.str, location);
			break;

		case T_Integer:
			n = makeIntConst(v->val.ival, location);
			break;

		case T_String:
		default:
			n = makeStringConst(v->val.str, location);
			break;
	}

	return n;
}

/* makeBoolAConst()
 * Create an A_Const string node and put it inside a boolean cast.
 */
static Node *
makeBoolAConst(bool state, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = (state ? "t" : "f");
	n->location = location;

	return makeTypeCast((Node *)n, SystemTypeName("bool"), -1);
}

/* makeRoleSpec
 * Create a RoleSpec with the given type
 */
static RoleSpec *
makeRoleSpec(RoleSpecType type, int location)
{
	RoleSpec *spec = makeNode(RoleSpec);

	spec->roletype = type;
	spec->location = location;

	return spec;
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(indirection, l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* extractAggrArgTypes()
 * As above, but work from the output of the aggr_args production.
 */
static List *
extractAggrArgTypes(List *aggrargs)
{
	Assert(list_length(aggrargs) == 2);
	return extractArgTypes((List *) linitial(aggrargs));
}

/* makeOrderedSetArgs()
 * Build the result of the aggr_args production (which see the comments for).
 * This handles only the case where both given lists are nonempty, so that
 * we have to deal with multiple VARIADIC arguments.
 */
static List *
makeOrderedSetArgs(List *directargs, List *orderedargs,
				   core_yyscan_t yyscanner)
{
	FunctionParameter *lastd = (FunctionParameter *) llast(directargs);
	int			ndirectargs;

	/* No restriction unless last direct arg is VARIADIC */
	if (lastd->mode == FUNC_PARAM_VARIADIC)
	{
		FunctionParameter *firsto = (FunctionParameter *) linitial(orderedargs);

		/*
		 * We ignore the names, though the aggr_arg production allows them;
		 * it doesn't allow default values, so those need not be checked.
		 */
		if (list_length(orderedargs) != 1 ||
			firsto->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 errmsg("an ordered-set aggregate with a VARIADIC direct argument must have one VARIADIC aggregated argument of the same data type"),
					 parser_errposition(exprLocation((Node *) firsto))));

		/* OK, drop the duplicate VARIADIC argument from the internal form */
		orderedargs = NIL;
	}

	/* don't merge into the next line, as list_concat changes directargs */
	ndirectargs = list_length(directargs);

	return list_make2(list_concat(directargs, orderedargs),
					  makeInteger(ndirectargs));
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					SelectLimit *limitClause,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitClause && limitClause->limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitClause->limitOffset))));
		stmt->limitOffset = limitClause->limitOffset;
	}
	if (limitClause && limitClause->limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitClause->limitCount))));
		stmt->limitCount = limitClause->limitCount;
	}
	if (limitClause && limitClause->limitOption != LIMIT_OPTION_DEFAULT)
	{
		if (stmt->limitOption)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple limit options not allowed")));
		if (!stmt->sortClause && limitClause->limitOption == LIMIT_OPTION_WITH_TIES)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("WITH TIES options can not be specified without ORDER BY clause")));
		stmt->limitOption = limitClause->limitOption;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const *con = (A_Const *)n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (con->val.type == T_Integer)
		{
			con->val.val.ival = -con->val.val.ival;
			return n;
		}
		if (con->val.type == T_Float)
		{
			doNegateFloat(&con->val);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Value *v)
{
	char   *oldval = v->val.str;

	Assert(IsA(v, Float));
	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->val.str = oldval+1;	/* just strip the '-' */
	else
		v->val.str = psprintf("-%s", oldval);
}

static Node *
makeAndExpr(Node *lexpr, Node *rexpr, int location)
{
	Node	   *lexp = lexpr;

	/* Look through AEXPR_PAREN nodes so they don't affect flattening */
	while (IsA(lexp, A_Expr) &&
		   ((A_Expr *) lexp)->kind == AEXPR_PAREN)
		lexp = ((A_Expr *) lexp)->lexpr;
	/* Flatten "a AND b AND c ..." to a single BoolExpr on sight */
	if (IsA(lexp, BoolExpr))
	{
		BoolExpr *blexpr = (BoolExpr *) lexp;

		if (blexpr->boolop == AND_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(AND_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeOrExpr(Node *lexpr, Node *rexpr, int location)
{
	Node	   *lexp = lexpr;

	/* Look through AEXPR_PAREN nodes so they don't affect flattening */
	while (IsA(lexp, A_Expr) &&
		   ((A_Expr *) lexp)->kind == AEXPR_PAREN)
		lexp = ((A_Expr *) lexp)->lexpr;
	/* Flatten "a OR b OR c ..." to a single BoolExpr on sight */
	if (IsA(lexp, BoolExpr))
	{
		BoolExpr *blexpr = (BoolExpr *) lexp;

		if (blexpr->boolop == OR_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(OR_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeNotExpr(Node *expr, int location)
{
	return (Node *) makeBoolExpr(NOT_EXPR, list_make1(expr), location);
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod, int location)
{
	SQLValueFunction *svf = makeNode(SQLValueFunction);

	svf->op = op;
	/* svf->type will be filled during parse analysis */
	svf->typmod = typmod;
	svf->location = location;
	return (Node *) svf;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr		*x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_IN && p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Convert a list of (dotted) names to a RangeVar (like
 * makeRangeVarFromNameList, but with position support).  The
 * "AnyName" refers to the any_name production in the grammar.
 */
static RangeVar *
makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner)
{
	RangeVar *r = makeNode(RangeVar);

	switch (list_length(names))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = NULL;
			r->relname = strVal(linitial(names));
			break;
		case 2:
			r->catalogname = NULL;
			r->schemaname = strVal(linitial(names));
			r->relname = strVal(lsecond(names));
			break;
		case 3:
			r->catalogname = strVal(linitial(names));
			r->schemaname = strVal(lsecond(names));
			r->relname = strVal(lthird(names));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
							NameListToString(names)),
					 parser_errposition(position)));
			break;
	}

	r->relpersistence = RELPERSISTENCE_PERMANENT;
	r->location = position;

	return r;
}

/* Separate Constraint nodes from COLLATE clauses in a ColQualList */
static void
SplitColQualList(List *qualList,
				 List **constraintList, CollateClause **collClause,
				 core_yyscan_t yyscanner)
{
	ListCell   *cell;

	*collClause = NULL;
	foreach(cell, qualList)
	{
		Node   *n = (Node *) lfirst(cell);

		if (IsA(n, Constraint))
		{
			/* keep it in list */
			continue;
		}
		if (IsA(n, CollateClause))
		{
			CollateClause *c = (CollateClause *) n;

			if (*collClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("multiple COLLATE clauses not allowed"),
						 parser_errposition(c->location)));
			*collClause = c;
		}
		else
			elog(ERROR, "unexpected node type %d", (int) n->type);
		/* remove non-Constraint nodes from qualList */
		qualList = foreach_delete_current(qualList, cell);
	}
	*constraintList = qualList;
}

/*
 * Process result of ConstraintAttributeSpec, and set appropriate bool flags
 * in the output command node.  Pass NULL for any flags the particular
 * command doesn't support.
 */
static void
processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner)
{
	/* defaults */
	if (deferrable)
		*deferrable = false;
	if (initdeferred)
		*initdeferred = false;
	if (not_valid)
		*not_valid = false;

	if (cas_bits & (CAS_DEFERRABLE | CAS_INITIALLY_DEFERRED))
	{
		if (deferrable)
			*deferrable = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_INITIALLY_DEFERRED)
	{
		if (initdeferred)
			*initdeferred = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_VALID)
	{
		if (not_valid)
			*not_valid = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT VALID",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NO_INHERIT)
	{
		if (no_inherit)
			*no_inherit = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NO INHERIT",
							constrType),
					 parser_errposition(location)));
	}
}

/*----------
 * Recursive view transformation
 *
 * Convert
 *
 *     CREATE RECURSIVE VIEW relname (aliases) AS query
 *
 * to
 *
 *     CREATE VIEW relname (aliases) AS
 *         WITH RECURSIVE relname (aliases) AS (query)
 *         SELECT aliases FROM relname
 *
 * Actually, just the WITH ... part, which is then inserted into the original
 * view definition as the query.
 * ----------
 */
static Node *
makeRecursiveViewSelect(char *relname, List *aliases, Node *query)
{
	SelectStmt *s = makeNode(SelectStmt);
	WithClause *w = makeNode(WithClause);
	CommonTableExpr *cte = makeNode(CommonTableExpr);
	List	   *tl = NIL;
	ListCell   *lc;

	/* create common table expression */
	cte->ctename = relname;
	cte->aliascolnames = aliases;
	cte->ctematerialized = CTEMaterializeDefault;
	cte->ctequery = query;
	cte->location = -1;

	/* create WITH clause and attach CTE */
	w->recursive = true;
	w->ctes = list_make1(cte);
	w->location = -1;

	/* create target list for the new SELECT from the alias list of the
	 * recursive view specification */
	foreach (lc, aliases)
	{
		ResTarget *rt = makeNode(ResTarget);

		rt->name = NULL;
		rt->indirection = NIL;
		rt->val = makeColumnRef(strVal(lfirst(lc)), NIL, -1, 0);
		rt->location = -1;

		tl = lappend(tl, rt);
	}

	/* create new SELECT combining WITH clause, target list, and fake FROM
	 * clause */
	s->withClause = w;
	s->targetList = tl;
	s->fromClause = list_make1(makeRangeVar(NULL, relname, -1));

	return (Node *) s;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
minimal_parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}

